#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


map<array<char, 2>, int> ind;
map<char, int> to[4];

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) cin >> a[i][j];

    auto print = [&]() {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j];
            }
            cout << '\n';
        }
//        cout << endl;
    };

    auto toL = [&]() {
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][cur++]);
                }
            }
        }
    };

    auto toR = [&]() {
        for (int i = 0; i < n; i++) {
            int cur = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][cur--]);
                }
            }
        }
    };

    auto toU = [&]() {
        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[cur++][j]);
                }
            }
        }
    };

    auto toD = [&]() {
        for (int j = 0; j < m; j++) {
            int cur = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[cur--][j]);
                }
            }
        }
    };

    auto change = [&](char ch) {
        if (ch == 'U') toU();
        if (ch == 'D') toD();
        if (ch == 'R') toR();
        if (ch == 'L') toL();
    };

    string s;
    cin >> s;

    char lst = 'x';

    int id;
    for (id = 0; id < s.length(); id++) {
        if (lst == s[id]) continue;

        if (lst == 'L') {
            if (s[id] != 'R') {
                break;
            }
        }
        if (lst == 'R') {
            if (s[id] != 'L') {
                break;
            }
        }
        if (lst == 'U') {
            if (s[id] != 'D') {
                break;
            }
        }
        if (lst == 'D') {
            if (s[id] != 'U') {
                break;
            }
        }

        lst = s[id];
    }

    change(lst);
    if (id == s.length()) {
        print();
        return;
    }
    change(s[id]);

    array<char, 2> now = {lst, s[id]};
    sort(all(now));
    int corner = ind[now];

    for (id++; id < s.length(); id++) corner = to[corner][s[id]];

    if (corner == 0) change('U'), change('L');
    if (corner == 1) change('U'), change('R');
    if (corner == 2) change('D'), change('R');
    if (corner == 3) change('D'), change('L');

    print();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    array<char, 2> a = {'U', 'L'}, b = {'U', 'R'}, c = {'D', 'R'}, d = {'D', 'L'};
    sort(all(a));
    sort(all(b));
    sort(all(c));
    sort(all(d));
    ind[a] = 0;
    ind[b] = 1;
    ind[c] = 2;
    ind[d] = 3;

    to[0]['U'] = 0;
    to[0]['L'] = 0;
    to[0]['R'] = 1;
    to[0]['D'] = 3;

    to[1]['U'] = 1;
    to[1]['R'] = 1;
    to[1]['L'] = 0;
    to[1]['D'] = 2;

    to[2]['D'] = 2;
    to[2]['R'] = 2;
    to[2]['U'] = 1;
    to[2]['L'] = 3;

    to[3]['D'] = 3;
    to[3]['L'] = 3;
    to[3]['U'] = 0;
    to[3]['R'] = 2;

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
