#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

map<char, int> to[12];

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) cin >> a[i][j];

    auto toL = [&]() {
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][cur++]);
                }
            }
        }
    };

    auto toR = [&]() {
        for (int i = 0; i < n; i++) {
            int cur = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][cur--]);
                }
            }
        }
    };

    auto toU = [&]() {
        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[cur++][j]);
                }
            }
        }
    };

    auto toD = [&]() {
        for (int j = 0; j < m; j++) {
            int cur = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[cur--][j]);
                }
            }
        }
    };

    auto change = [&](char ch) {
        if (ch == 'U') toU();
        if (ch == 'D') toD();
        if (ch == 'R') toR();
        if (ch == 'L') toL();
    };

    auto print = [&]() {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j];
            }
            cout << '\n';
        }
//        cout << endl;
    };

    string s;
    cin >> s;

    int corner = 0;

    for (int id = 0; id < s.length(); id++) corner = to[corner][s[id]];

    for (int i = 0; i < corner; i++) {
        if (i % 4 == 0) change('U');
        if (i % 4 == 1) change('R');
        if (i % 4 == 2) change('D');
        if (i % 4 == 3) change('L');
    }

    print();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vector<vector<char>> a = {
            {'.', '.', '.'},
            {'c', '.', '.'},
            {'a', 'b', '.'},
    };

    auto toL = [&]() {
        for (int i = 0; i < 3; i++) {
            int cur = 0;
            for (int j = 0; j < 3; j++) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][cur++]);
                }
            }
        }
    };

    auto toR = [&]() {
        for (int i = 0; i < 3; i++) {
            int cur = 3 - 1;
            for (int j = 3 - 1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][cur--]);
                }
            }
        }
    };

    auto toU = [&]() {
        for (int j = 0; j < 3; j++) {
            int cur = 0;
            for (int i = 0; i < 3; i++) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[cur++][j]);
                }
            }
        }
    };

    auto toD = [&]() {
        for (int j = 0; j < 3; j++) {
            int cur = 3 - 1;
            for (int i = 3 - 1; i >= 0; i--) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[cur--][j]);
                }
            }
        }
    };

    auto change = [&](char ch) {
        if (ch == 'U') toU();
        if (ch == 'D') toD();
        if (ch == 'R') toR();
        if (ch == 'L') toL();
    };

    map<vector<vector<char>>, int> id;
    for (int i = 0; i < 12; i++) {
        id[a] = i;
        if (i % 4 == 0) change('U');
        if (i % 4 == 1) change('R');
        if (i % 4 == 2) change('D');
        if (i % 4 == 3) change('L');
    }

    for (int i = 0; i < 12; i++) {
        for (auto ch : {'U', 'D', 'L', 'R'}) {
            auto b = a;
            change(ch);
            to[i][ch] = id[a];
            a = b;
        }
        if (i % 4 == 0) change('U');
        if (i % 4 == 1) change('R');
        if (i % 4 == 2) change('D');
        if (i % 4 == 3) change('L');
    }

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
