#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

int n, m;

template<typename T>
void toL(vector<vector<T>>& a, const T& bad) {
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != bad) {
                swap(a[i][j], a[i][cur++]);
            }
        }
    }
}

template<typename T>
void toR(vector<vector<T>>& a, const T& bad) {
    for (int i = 0; i < n; i++) {
        int cur = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] != bad) {
                swap(a[i][j], a[i][cur--]);
            }
        }
    }
}

template<typename T>
void toU(vector<vector<T>>& a, const T& bad) {
    for (int j = 0; j < m; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != bad) {
                swap(a[i][j], a[cur++][j]);
            }
        }
    }
}

template<typename T>
void toD(vector<vector<T>>& a, const T& bad) {
    for (int j = 0; j < m; j++) {
        int cur = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] != bad) {
                swap(a[i][j], a[cur--][j]);
            }
        }
    }
}

template<typename T>
void change(char ch, vector<vector<T>>& a, const T& bad) {
    if (ch == 'U') toU(a, bad);
    if (ch == 'D') toD(a, bad);
    if (ch == 'R') toR(a, bad);
    if (ch == 'L') toL(a, bad);
}

void solve() {
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) cin >> a[i][j];

    auto print = [&]() {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j];
            }
            cout << '\n';
        }
//        cout << endl;
    };

    string s;
    cin >> s;

    int q = s.length() / 4 - 1;
    for (int i = 0; i < s.length(); i++) change(s[i], a, '.');

    vector<vector<array<int, 2>>> now(n, vector<array<int, 2>>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.') {
                now[i][j] = {-1, -1};
            } else {
                now[i][j] = {i, j};
            }
        }
    }

    change<array<int, 2>>('L', now, {-1, -1});
    change<array<int, 2>>('L', now, {-1, -1});
    change<array<int, 2>>('L', now, {-1, -1});
    change<array<int, 2>>('L', now, {-1, -1});

    array<int, 2> to[n][m];

    print();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
