#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

struct Fenwick {
    vector<int> t;
    int n;

    void init (int k) {
        n = k + 10;
        t.assign(n + 10, 0);
    }

    void add (int k, int x) {
        for (int i = k; i <= n; i += i & -i) {
            t[i] += x;
        }
    }

    int sum (int k) {
        int ans = 0;
        for (int i = k; i > 0; i -= i & -i) {
            ans += t[i];
        }

        return ans;
    }

    int sum (int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

void solve() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pair<int, int>> a(n + m);

    int s = 0;

    vector<int> pref(n + 1, 0);

    for (int i = 0; i < n + m; i++) {
        cin >> a[i].first >> a[i].second;
        pref[i + 1] = pref[i];
        if (a[i].first == 1) {
            pref[i + 1] += a[i].second;
        }
    }

    vector<int> dp(n, 0);

    for (int i = 0; i < n; i++) {
        dp[i] = dp[i - 1];
        if (a[i].first == 2) {
            dp[i] = max(dp[i], dp[i - 1] + p - a[i].second * c);

            for (int j = 0; j < i; j++) {
                if (a[j].first == 2) {
                    if (a[j].second - (pref[i] - pref[j]) >= 0) {
                        int t = max(0ll, (a[i].second - (a[j].second - (pref[i] - pref[j]))));
                        dp[i] = max(dp[i], dp[j] + p - t * c);
                    }
                }
            }
        }
    }

    cout << dp[n - 1] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}