#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

struct Fenwick {
    vector<int> t;
    int n;

    void init (int k) {
        n = k + 10;
        t.assign(1e6, 0);
    }

    void add (int k, int x) {
        for (int i = k; i <= n; i += i & -i) {
            t[i] += x;
        }
    }

    int sum (int k) {
        int ans = 0;
        for (int i = k; i > 0; i -= i & -i) {
            ans += t[i];
        }

        return ans;
    }

    int sum (int l, int r) {
        if (l > r) return 0;
        return sum(r) - sum(l - 1);
    }
};

void solve() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    n += m;

    vector<pair<int, int>> a(n);

    int s = 0;

    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].second += s;

        if (a[i].first == 1) {
            s = a[i].second;
        }
    }

    vector<int> right(n, -1);

    vector<int> stck;

    for (int i = n - 1; i >= 0; i--) {
        while (sz(stck) && a[i].second >= a[stck.back()].second) {
            stck.pop_back();
        }

        if (sz(stck) == 0) {
            right[i] = -1;
        } else {
            right[i] = stck.back();
        }

        if (a[i].first == 1) stck.push_back(i);
    }

    int ans = 0;

    vector<int> ind(n);
    iota(all(ind), 0ll);

    sort(all(ind), [&] (int i, int j) {
        if (a[i].second == a[j].second) return  i < j;
        return a[i].second < a[j].second;
    });

    Fenwick f, cnt;
    cnt.init(n + 10);
    f.init(n + 10);

    map<int, vector<int>> index;

    for (int i = 0; i < n; i++) {
        if (a[i].first == 2) {
            index[a[i].second].push_back(i);
        }
    }

    for (auto v : index) {
        for (auto j : v.second) {
            f.add(j + 1, 1);
        }

        for (auto j : v.second) {
            int r = right[j];
            if (r == -1) r = n;

            int t = f.sum(1, r);
            ans = max(ans, t * p - (a[j].second - 1) * c);

        }
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}