#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

void solve() {
    int m, n;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char ch;
            cin >> ch;
            a[i][j] = (ch == '.' ? -1 : ch - 'a');
        }
    }

    string s;
    cin >> s;

    int q = sz(s);

    auto print = [&]() {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < m; k++) {
                if (a[j][k] == -1) {
                    cout << ".";
                } else {
                    cout << char('a' + a[j][k]);
                }
            }
            cout << endl;
        }
//        cout << "________________" << endl;
    };

    char last_op = 'Z';

    auto do_something = [&] (char ch) {
        if (ch == 'L') {
            vector<vector<int>> b(n, vector<int>(m, -1));
            for (int j = 0; j < n; j++) {
                int pos = 0;
                for (int k = 0; k < m; k++) {
                    if (a[j][k] != -1) {
                        b[j][pos++] = a[j][k];
                    }
                }
            }
            a = b;
        } else if (ch == 'R') {
            vector<vector<int>> b(n, vector<int>(m, -1));
            for (int j = 0; j < n; j++) {
                int pos = m - 1;
                for (int k = m - 1; k >= 0; k--) {
                    if (a[j][k] != -1) {
                        b[j][pos--] = a[j][k];
                    }
                }
            }
            a = b;
        } else if (ch == 'U') {
            vector<vector<int>> b(n, vector<int>(m, -1));
            for (int j = 0; j < m; j++) {
                int pos = 0;
                for (int k = 0; k < n; k++) {
                    if (a[k][j] != -1) {
                        b[pos++][j] = a[k][j];
                    }
                }
            }
            a = b;
        } else {
            vector<vector<int>> b(n, vector<int>(m, -1));
            for (int j = 0; j < m; j++) {
                int pos = n - 1;
                for (int k = n - 1; k >= 0; k--) {
                    if (a[k][j] != -1) {
                        b[pos--][j] = a[k][j];
                    }
                }
            }
            a = b;
        }
    };

    int fi = n;

    for (int i = 0; i < q; i++) {
        if (s[i] == 'U' || s[i] == 'D') {
            fi = i;
            break;
        }
    }

    for (int i = 0; i < fi; i++) {
        if (s[i] == 'L' || s[i] == 'R') {
            last_op = s[i];
        }
    }

    if (last_op != 'Z') {
        do_something(last_op);
    }

    if (fi != n) {
        do_something(s[fi]);
    } else {
        // нету ни U, ни D
        print();
        return;
    }

    int se = n;
    last_op = 'Z';

    for (int j = fi + 1; j < q; j++) {
        if (s[j] == 'R' || s[j] == 'L') {
            se = j;
            break;
        }
    }

    for (int j = fi + 1; j < se; j++) {
        if (s[j] == 'U' || s[j] == 'D') {
            last_op = s[j];
        }
    }

    if (last_op != 'Z') {
        do_something(last_op);
    }

    if (se != n) {
        do_something(s[se]);
    } else {
        print();
        return;
    }

    vector<int> rows(n, 0);

    int dirX = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                rows[i]++;
            }
        }

        if (a[i][0] == -1) {
            dirX = 1; // R
        } else if (a[i][m - 1] == -1) {
            dirX = 0; // L
        }
    }

    int dirY = 0;

    if (rows[0] == 0) {
        dirY = 1; //D
    } else if (rows[n - 1] == 0) {
        dirY = 0; // U
    }

    for (int i = se + 1; i < q; i++) {
        if (s[i] == 'R' || s[i] == 'L') {
            if (s[i] == 'R') {
                dirX = 1;
            } else {
                dirX = 0;
            }
        } else {
            if (s[i] == 'U') {
                dirY = 0;
            } else {
                dirY = 1;
            }
        }
    }

    if (dirX == 0) {
        do_something('L');
    } else {
        do_something('R');
    }

    if (dirY == 0) {
        do_something('U');
    } else {
        do_something('D');
    }

    print();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}