#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vec vector
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)

inline bool isvert(char c) { return c == 'U' || c == 'D'; }
inline bool ishz(char c) { return c == 'L' || c == 'R'; }
int h, w;

void mv_vt(vec<vec<int>> &fld, bool down) {
  forn(i, w) {
    vec<int> chs;
    forn(j, h) {
      if (fld[j][i])
        chs.push_back(fld[j][i]);
      fld[j][i] = 0;
    }
    for(int orig_pos = down ? h - chs.size() : 0, j = 0; j < chs.size(); ++j, ++orig_pos)
      fld[orig_pos][i] = chs[j];
  }
}

void mv_hz(vec<vec<int>> &fld, bool right) {
  forn(i, h) {
    vec<int> chs;
    forn(j, w) {
      if (fld[i][j])
        chs.push_back(fld[i][j]);
      fld[i][j] = 0;
    }
    for(int orig_pos = right ? w - chs.size() : 0, j = 0; j < chs.size(); ++j, ++orig_pos)
      fld[i][orig_pos] = chs[j];
  }
}

void mv(vec<vec<int>> &fld, char cmd) {
  switch(cmd) {
    case 'L': mv_hz(fld, false); break;
    case 'R': mv_hz(fld, true); break;
    case 'U': mv_vt(fld, false); break;
    case 'D': mv_vt(fld, true); break;
    default: break;
  }
}

void solve () {
  cin >> h >> w;
  vec<vec<char>> fld(h);
  forn(i, h) {
    fld[i].resize(w);
    forn(j, w) cin >> fld[i][j];
  }
  string cmd; cin >> cmd;
  vec<char> stk, cv, ch;
  for (auto i : cmd) {
    if ((cv.size() && i == cv.back()) || (ch.size() && i == ch.back())) continue;
    while (stk.size()) {
      if (isvert(i) == isvert(stk.back())) {
        char c = stk.back();
        if (isvert(c))
          cv.pop_back();
        else
          ch.pop_back();
        stk.pop_back();
        if ((cv.size() && i == cv.back()) || (ch.size() && i == ch.back()))
          goto skip;
      } else break;
    }
    if (isvert(i)) cv.push_back(i);
    if (ishz(i)) ch.push_back(i);
    stk.push_back(i);
    skip: continue;
  }

  vec<vec<int>> rot(h);
  
  vec<char> chars;
  int clr = 1;
  forn(i, h) {
    rot[i].resize(w, 0);
    forn(j, w) {
      if (fld[i][j] == '.') continue;
      rot[i][j] = clr++;
      chars.push_back(fld[i][j]);
    }
  }
  
  for(int i = 0; i < min<int>(4, stk.size()); ++i)
    mv(rot, stk[i]);

  /*forn(i, h) {
    forn(j, w) {
      if (rot[i][j])
        cout << chars[rot[i][j]-1];
      else
        cout << '.';
    }
    cout << endl;
  }*/

  if (stk.size() >= 12) {
    vec<vec<int>> orig_rot = rot;
    vec<pair<int,int>> orig_pos(chars.size()); // x, y
    forn(i, h)
      forn(j, w)
        if (rot[i][j])
          orig_pos[rot[i][j]-1] = {j,i};

    for(int i = 4; i < 8; ++i)
      mv(rot, stk[i]);
    
    int steps = (stk.size() - 4 - 4) / 4;
    vec<vec<int>> moves(__lg(steps) + 1);
    for(auto &i : moves) i.resize(chars.size());
    forn(i, h)
      forn(j, w)
        if (rot[i][j])
          moves[0][rot[i][j]-1] = orig_rot[i][j]-1;
    forn(stp, __lg(steps))
      forn (i, chars.size())
        moves[stp+1][i] = moves[stp][moves[stp][i]];
    
    vec<vec<int>> res(h);
    forn(i, h) res[i].resize(w, 0);

    for(int i = 0; i < chars.size(); ++i) {
      int p = i;
      int cnt = steps;
      for(int l = __lg(steps); l >= 0; --l) {
        if ((1 << l) <= cnt) {
          cnt -= (1 << l);
          p = moves[l][p];
        }
      }
      auto now = orig_pos[p];
      res[now.second][now.first] = i+1;
    }
    for(int i = 4 + steps * 4; i < stk.size(); ++i)
      mv(res, stk[i]);
    
    /*for(auto [from, to] : moves[0]) {
      cout << from.first << " " << from.second << " -> " << to.first << " " << to.second << endl;
    }*/
    forn(i, h) {
      forn(j, w) {
        if (res[i][j])
          cout << chars[res[i][j]-1];
        else
          cout << '.';
      }
      cout << endl;
    }
  } else {
    for(int i = 4; i < stk.size(); ++i)
      mv(rot, stk[i]);
    forn(i, h) {
      forn(j, w) {
        if (rot[i][j])
          cout << chars[rot[i][j]-1];
        else
          cout << '.';
      }
      cout << endl;
    }
  }
  /*for(auto i : stk) cout << i;
  cout << endl;*/
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int c; cin >> c;
  forn(_, c)
    solve();
  return 0;
}