#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vec vector
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)

struct rect {
  int xl, yl, xr, yr;
};

struct evt {
  int y;
  bool operator<(evt e) {
    return y < e.y;
  }
  int xl, xr; int delta;
  int id;
};

umap<int, int> xcompress;
vec<int> xback;

void solve () {
  int n; cin >> n;
  vec<rect> rs(n);
  forn(i, n) {
    cin >> rs[i].xl >> rs[i].yl >> rs[i].xr >> rs[i].yr;
    ++rs[i].xr; ++rs[i].yr;
  }

  /*for (auto i : rs) xback.push_back(i.xl), xback.push_back(i.xr);
  sort(all(xback));
  xback.erase(unique(all(xback)), xback.end());
  forn(i, xback.size())
    xcompress[xback[i]] = i;*/
  
  vec<evt> evts;
  int id = 0;
  for(auto rct : rs) {
    evts.push_back({ rct.yl, rct.xl, rct.xr, +1, id });
    evts.push_back({ rct.yr, rct.xl, rct.xr, -1, id++ });
  }

  sort(all(evts));
  set<pair<int,int>> lbounds, rbounds;
  map<pair<int,int>, int> seg_cnt, seg_last, seg_ns, seg_ns_best;
  int py = -1;
  for (auto e : evts) {
    //cerr << e.y << " : " << e.delta << " " << e.xl << " " << e.xr << endl;
    if (py != e.y) {
      auto li = lbounds.begin(), ri = rbounds.begin();
      int cnt = 0, begin = -1;
      while (li != lbounds.end() || ri != rbounds.end()) {
        int cl = li == lbounds.end() ? INT_MAX : li->first;
        int cr = ri == rbounds.end() ? INT_MAX : ri->first;
        if (cl <= cr) {
          //cerr << " add " << cl << endl;
          if (cnt == 0) begin = cl;
          ++cnt;
          ++li;
        } else {
          //cerr << " del " << cr << endl;
          --cnt;
          if (cnt == 0) {
            pair<int,int> seg = {begin, cr};
            //cerr << "  - seg " << begin << " " << cr << endl;
            int h = e.y - py;
            seg_cnt[seg] += h;
            if (seg_last[seg] == py)
              seg_ns[seg] += h;
            else
              seg_ns[seg] = h;
            seg_ns_best[seg] = max(seg_ns_best[seg], seg_ns[seg]);
            seg_last[seg] = e.y;
          }
          ++ri;
        }
      }
      py = e.y;
    }
    if (e.delta == +1) {
      lbounds.insert({e.xl, e.id});
      rbounds.insert({e.xr, e.id});
    } else {
      lbounds.erase({e.xl, e.id});
      rbounds.erase({e.xr, e.id});
    }
  }
  cout << seg_cnt.size() << '\n';
  for (auto [seg, cnt] : seg_cnt) {
    cout << seg.first << " " << seg.second-1 << " " << cnt << " " << seg_ns_best[seg] << '\n';
  }
  //cout.flush();
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int c; cin >> c;
  forn(_, c)
    solve();

  return 0;
}