#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

ll n, m;
vector<string> a;

void up() {
    for (ll j = 0; j < m; j++) {
        vector<char> cur;
        for (ll i = 0; i < n; i++) {
            if (a[i][j] == '.') continue;
            cur.emplace_back(a[i][j]);
            a[i][j] = '.';
        }
        for (ll i = 0; i < cur.size(); i++) {
            a[i][j] = cur[i];
        }
    }
}

void down() {
    for (ll j = 0; j < m; j++) {
        vector<char> cur;
        for (ll i = n - 1; i >= 0; i--) {
            if (a[i][j] == '.') continue;
            cur.emplace_back(a[i][j]);
            a[i][j] = '.';
        }
        for (ll i = n - 1, k = 0; k < cur.size(); i--, k++) {
            a[i][j] = cur[k];
        }
    }
}

void left() {
    for (ll i = 0; i < n; i++) {
        vector<char> cur;
        for (ll j = 0; j < m; j++) {
            if (a[i][j] == '.') continue;
            cur.emplace_back(a[i][j]);
            a[i][j] = '.';
        }
        for (ll j = 0; j < cur.size(); j++) {
            a[i][j] = cur[j];
        }
    }
}

void right() {
    for (ll i = 0; i < n; i++) {
        vector<char> cur;
        for (ll j = m - 1; j >= 0; j--) {
            if (a[i][j] == '.') continue;
            cur.emplace_back(a[i][j]);
            a[i][j] = '.';
        }
        for (ll j = m - 1, k = 0; k < cur.size(); j--, k++) {
            a[i][j] = cur[k];
        }
    }
}

void move(char t) {
    if (t == 'U') up();
    if (t == 'D') down();
    if (t == 'L') left();
    if (t == 'R') right();
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    for (auto &s: a) cin >> s;
    string qs;
    cin >> qs;
    ll q = ll(qs.size());
    bool fl1 = false, fl2 = false;
    char pr1 = ' ', pr2 = ' ';
    for (auto &t: qs) {
        if (t == 'U' || t == 'D') {
            pr1 = t;
            fl1 = true;
            if (!fl2) continue;
            move(pr2);
            move(pr1);
            break;
        }
        if (t == 'R' || t == 'L') {
            pr2 = t;
            fl2 = true;
            if (!fl1) continue;
            move(pr1);
            move(pr2);
            break;
        }
    }
    reverse(qs.begin(), qs.end());
    fl1 = false;
    fl2 = false;
    for (auto &t: qs) {
        if (fl1 && fl2) break;
        if (t == 'U' && !fl1) {
            up();
            fl1 = true;
        }
        if (t == 'D' && !fl1) {
            down();
            fl1 = true;
        }
        if (t == 'L' && !fl2) {
            left();
            fl2 = true;
        }
        if (t == 'R' && !fl2) {
            right();
            fl2 = true;
        }
    }
    for (auto &s: a) {
        cout << s << '\n';
    }
    cout << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll testC;
#ifdef home
    freopen("input.txt", "r", stdin);
#endif
    cin >> testC;
    while (testC--) {
        solve();
    }
    return 0;
}
