#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long
#define endl "\n"
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int _TestNum; cin >> _TestNum;while(_TestNum--)

int tpc(char c) {
    return ((c == 'L') || (c == 'R'));
}

char prc(char c) {
    if (c == 'L') {
        return 'R';
    }
    if (c == 'R') {
        return 'L';
    }
    if (c == 'U') {
        return 'D';
    }
    if (c == 'D') {
        return 'U';
    }
}

string build_new_s(string s) {
    vector<char> stck;

    vector<vector<char>> lst = {{'.'},
                                {'.'}};

    for (int i = 0; i < s.size(); i++) {
        if (stck.size() == 0) {
            stck.push_back(s[i]);
            lst[tpc(s[i])].push_back(s[i]);
            continue;
        }
        if (tpc(stck.back()) == tpc(s[i])) {
            stck.pop_back();
            lst[tpc(s[i])].pop_back();
        }

        if (lst[tpc(s[i])].back() != s[i]) {
            stck.push_back(s[i]);
            lst[tpc(s[i])].push_back(s[i]);
        }
    }

    s = "";

    for (auto it: stck) {
        s += it;
    }
    return s;
}

int n, m;
vector<vector<int>> a;

int match(int i, int j) {
    return i * m + j;
}

pair<int, int> unmatch(int x) {
    return {x / m, x % m};
};

void move_l() {
    for (int i = 0; i < n; i++) {
        int pos = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                a[i][pos] = a[i][j];
                if (j != pos) {
                    a[i][j] = -1;
                }
                pos++;
            }
        }
    }
}

void move_r() {
    for (int i = 0; i < n; i++) {
        int pos = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] != -1) {
                a[i][pos] = a[i][j];
                if (j != pos) {
                    a[i][j] = -1;
                }
                pos--;
            }
        }
    }
}

void move_u() {
    for (int j = 0; j < m; j++) {
        int pos = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != -1) {
                a[pos][j] = a[i][j];
                if (i != pos) {
                    a[i][j] = -1;
                }
                pos++;
            }
        }
    }
}

void move_d() {
    for (int j = 0; j < m; j++) {
        int pos = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] != -1) {
                a[pos][j] = a[i][j];
                if (i != pos) {
                    a[i][j] = -1;
                }
                pos--;
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    MNOGO {

        cin >> n >> m;
        a = {};
        a.resize(n, vector<int>(m, 0));

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char x;
                cin >> x;
                if (x == '.') {
                    a[i][j] = -1;
                } else {
                    a[i][j] = (x - 'a');
                }
            }
        }

        string s;
        cin >> s;

        s = build_new_s(s);

        int q = s.size();

        int ind = 0;

        for (; ind < min(2ll, (int) s.size()); ind++) {
            char c = s[ind];
            if (c == 'L') {
                move_l();
            }
            if (c == 'R') {
                move_r();
            }
            if (c == 'U') {
                move_u();
            }
            if (c == 'D') {
                move_d();
            }
        }

        if (s.size() < 2) {
            for (auto it: a) {
                for (auto tt: it) {
                    char nw = char('a' + tt);
                    if (tt == -1) {
                        nw = '.';
                    }
                    cout << nw;
                }
                cout << endl;
            }
            continue;
        }

        int cycle_num = 0;

        while (ind + 4 <= s.size()) {
            ind += 4;
            cycle_num++;
        }

        auto b = a;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    a[i][j] = match(i, j);
                }
            }
        }


        string tobs = "";
        tobs += prc(s[0]);
        tobs += prc(s[1]);
        tobs += s[0];
        tobs += s[1];

        for (auto c: tobs) {
            if (c == 'L') {
                move_l();
            }
            if (c == 'R') {
                move_r();
            }
            if (c == 'U') {
                move_u();
            }
            if (c == 'D') {
                move_d();
            }
        }

        map<int, int> next;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    next[match(i, j)] = a[i][j];
                }
            }
        }

        set<int> used;

        vector<vector<int>> comp;

        map<int, int> cm, pos;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    int v = match(i, j);
                    if (!used.count(v)) {
                        comp.push_back({});
                        int c_num = comp.size() - 1;
                        int cnt = 0;
                        while (!used.count(v)) {
                            used.insert(v);
                            comp[c_num].push_back(v);
                            cm[v] = c_num;
                            pos[v] = cnt;
                            cnt++;
                            v = next[v];
                        }
                    }
                }
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int v = match(i, j);
                if (a[i][j] == -1) {
                    continue;
                }
                int nw = comp[cm[v]][(pos[v] + cycle_num) % (comp[cm[v]].size())];
                int ni = unmatch(nw).ff;
                int nj = unmatch(nw).ss;
                a[i][j] = b[ni][nj];
            }
        }

        for (; ind < (int) s.size(); ind++) {
            char c = s[ind];
            if (c == 'L') {
                move_l();
            }
            if (c == 'R') {
                move_r();
            }
            if (c == 'U') {
                move_u();
            }
            if (c == 'D') {
                move_d();
            }
        }

//        cout << s << endl;

        for (auto it: a) {
            for (auto tt: it) {
                char nw = char('a' + tt);
                if (tt == -1) {
                    nw = '.';
                }
                cout << nw;
            }
            cout << endl;
        }

    };

}
