#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void op(vector<vector<int>> &state, char code) {
    int n = state.size();
    int m = state[0].size();
    if (code == 'D') {
        for (int j = 0; j < m; ++j) {
            int lastdot = -1;
            for (int i = n - 1; i >= 0; --i) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = i;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[lastdot][j]);
                    while (state[lastdot][j] != '.') {
                        --lastdot;
                    }
                }
            }
        }
    } else if (code == 'U') {
        for (int j = 0; j < m; ++j) {
            int lastdot = -1;
            for (int i = 0; i < n; ++i) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = i;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[lastdot][j]);
                    while (state[lastdot][j] != '.') {
                        ++lastdot;
                    }
                }
            }
        }
    } else if (code == 'L') {
        for (int i = 0; i < n; ++i) {
            int lastdot = -1;
            for (int j = 0; j < m; ++j) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = j;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[i][lastdot]);
                    while (state[i][lastdot] != '.') {
                        ++lastdot;
                    }
                }
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            int lastdot = -1;
            for (int j = m - 1; j >= 0; --j) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = j;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[i][lastdot]);
                    while (state[i][lastdot] != '.') {
                        --lastdot;
                    }
                }
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> state(n);
    vector<char> unmap(n * m + 256);
    int last_id = '.' + 1;
    bool oa = true;
    for (vector<int> &st : state) {
        st.assign(m, '.');
        string now;
        cin >> now;
        for (int i = 0; i < m; ++i) {
            if (now[i] != '.') {
                unmap[last_id] = now[i];
                st[i] = last_id++;
            }
        }
    }
    string ask;
    cin >> ask;
    for (int i = 0; i < 4; ++i) {
        op(state, ask[i]);
    }
    if (ask.size() != 4) {
        int toop = ask.size() / 4 - 1;
        vector<vector<int>> ns = state;
        for (int i = 0; i < 4; ++i) {
            op(ns, ask[i]);
        }
        vector<int> perm(last_id + 1, -1);
        std::iota(perm.begin(), perm.end(), 0);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                perm[state[i][j]] = ns[i][j];
            }
        }
        vector<int> used(perm.size(), -1);
        vector<vector<int>> go(perm.size());
        vector<int> gp(perm.size());
        for (int i = 0; i < perm.size(); ++i) {
            if (used[i] == -1) {
                used[i] = i;
                int j = i;
                do {
                    gp[j] = go[i].size();
                    used[j] = i;
                    go[i].push_back(j);
                    j = perm[i];
                } while (j != i);
            }
        }
        vector<int> perm2(perm.size());
        for (int i = 0; i < perm2.size(); ++i) {
            perm2[i] = go[used[i]][(gp[i] + toop) % go[used[i]].size()];
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (state[i][j] != '.') {
                    state[i][j] = perm2[state[i][j]];
                }
            }
        }
    }
    for (vector<int> &now : state) {
        for (int j = 0; j < m; ++j) {
            if (now[j] == '.') {
                cout << '.';
            } else {
                cout << unmap[now[j]];
            }
        }
        cout << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    for (int qi = 0; qi < t; ++qi) {
        solve();
    }
    return 0;
}
