#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << (x) << '\n'

// template <typename T>
ostream& operator<<(ostream& out, vector <string> &a) {
    for (auto &i : a) cout << i << '\n';
    return out;
}

// template <typename T>
ostream& operator<<(ostream& out, vector <int> &a) {
    for (auto &i : a) cout << i << ' ';
    cout << '\n';
    return out;
}

ostream& operator<<(ostream& out, vector <vector <int> > &a) {
    for (auto &i : a) cout << i;
    cout << '\n';
    return out;
}

void down(vector <string> &a, int &n, int &m) {
    for (int j = 0; j < m; j++) {
        int cnt = n - 1;
        for (int i = n - 1; i > -1; i--) {
            if (a[i][j] != '.') a[cnt][j] = a[i][j], cnt--;
            if (cnt >= i) a[i][j] = '.';
        }
    }
}

void up(vector <string> &a, int &n, int &m) {
    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.') a[cnt][j] = a[i][j], cnt++;
            if (cnt <= i) a[i][j] = '.';
        }
    }
}

void right(vector <string> &a, int &n, int &m) {
    for (int i = 0; i < n; i++) {
        int cnt = m - 1;
        for (int j = m - 1; j > -1; j--) {
            if (a[i][j] != '.') a[i][cnt] = a[i][j], cnt--;
            if (cnt >= j) a[i][j] = '.';
        }
    }
}

void left(vector <string> &a, int &n, int &m) {
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') a[i][cnt] = a[i][j], cnt++;
            if (cnt <= j) a[i][j] = '.';
        }
    }
}

void down(vector <vector <int>> &a, int &n, int &m) {
    for (int j = 0; j < m; j++) {
        int cnt = n - 1;
        for (int i = n - 1; i > -1; i--) {
            if (a[i][j] != -1) a[cnt][j] = a[i][j], cnt--;
            if (cnt >= i) a[i][j] = -1;
        }
    }
}

void up(vector <vector <int>> &a, int &n, int &m) {
    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != -1) a[cnt][j] = a[i][j], cnt++;
            if (cnt <= i) a[i][j] = -1;
        }
    }
}

void right(vector <vector <int>> &a, int &n, int &m) {
    for (int i = 0; i < n; i++) {
        int cnt = m - 1;
        for (int j = m - 1; j > -1; j--) {
            if (a[i][j] != -1) a[i][cnt] = a[i][j], cnt--;
            if (cnt >= j) a[i][j] = -1;
        }
    }
}

void left(vector <vector <int>> &a, int &n, int &m) {
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) a[i][cnt] = a[i][j], cnt++;
            if (cnt <= j) a[i][j] = -1;
        }
    }
}

int dfs(int v, vector <int> &g, int &root) {
    if (g[v] != root) return 1 + dfs(g[v], g, root);
    return 1;
}

void dfs2(int v, vector <int> &g, int &res, queue <int> &q, vector <int> &ans) {
    if (ans[v] != -1) return;
    if (q.size() < res) q.push(v), dfs2(g[v], g, res, q, ans);
    else ans[v] = q.front(), q.pop(), q.push(v), dfs2(g[v], g, res, q, ans);
}

void dfs3(int v, vector <int> &g, vector <int> &ans, int &root) {
    ans[v] = v;
    if (g[v] != root) dfs3(g[v], g, ans, root);
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, n, m, q;
    cin >> t;
    string s0;
    while (t--) {
        cin >> n >> m;
        vector <string> a(n), res(n, string(m, '.'));
        vector < vector <int> > b(n, vector <int> (m, -1));
        for (int i = 0; i < n; i++) cin >> a[i];
        cin >> s0;
        string s;
        q = 1;
        s.push_back(s0[0]);
        for (char &c : s0) {
            if (c == 'L' || c == 'R') {
                if (s[q - 1] == 'L' || s[q - 1] == 'R') s.pop_back(), q--;
            } else {
                if (s[q - 1] == 'D' || s[q - 1] == 'U') s.pop_back(), q--;
            }
            if (q <= 1 || s[q - 2] != c) s.push_back(c), q++;
        }
        for (int i = 0; i < min(q, 2); i++) {
            if (s[i] == 'L') left(a, n, m);
            else if (s[i] == 'R') right(a, n, m);
            else if (s[i] == 'D') down(a, n, m);
            else up(a, n, m);
        }
        // debug(s);
        // debug(q);
        if (q > 5) {
            int op = (q - 2) / 4;
            if (q >= 6) {
                // for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) if (a[i][j] != '.') b[i][j] = i * n + j;
                // for (int i = 2; i < 6; i++) {
                //     if (s[i] == 'L') left(b, n, m);
                //     else if (s[i] == 'R') right(b, n, m);
                //     else if (s[i] == 'D') down(b, n, m);
                //     else up(b, n, m);
                // }
                // vector <int> g(n * m), ans(n * m, -1);
                // for (int i = 0; i < n; i++) {
                //     for (int j = 0; j < m; j++) {
                //         if (b[i][j] != -1) g[b[i][j]] = i * n + j;
                //     }
                // }
                // for (int i = 0; i < n; i++) {
                //     for (int j = 0; j < m; j++) {
                //         int v = i * n + j;
                //         if (b[i][j] != -1 && ans[v] == -1) {
                //             queue <int> q;
                //             int cnt = op % dfs(v, g, v);
                //             if (cnt != 0) dfs2(v, g, cnt, q, ans);
                //             else dfs3(v, g, ans, v);
                //         }
                //         if (b[i][j] != -1) res[i][j] = a[ans[v] / n][ans[v] % n];
                //     }
                // }
                // debug(g);
                // debug(cycle_len);
                // debug(ans);
                // debug(b);
                // debug(res);
                for (int i = 2 + op * 4; i < q; i++) {
                    if (s[i] == 'L') left(res, n, m);
                    else if (s[i] == 'R') right(res, n, m);
                    else if (s[i] == 'D') down(res, n, m);
                    else up(res, n, m);
                }
                cout << res;
            }
        } else {
            for (int i = 2; i < q; i++) {
                if (s[i] == 'L') left(a, n, m);
                else if (s[i] == 'R') right(a, n, m);
                else if (s[i] == 'D') down(a, n, m);
                else up(a, n, m);
            }
            cout << a;
        }
    }
}