#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

ll n, m;

void left(vector<vector<int>> &a) {
    for (ll i = 0; i < n; ++i) {
        ll it = 0;
        for (ll j = 0; j < m; ++j) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[i][it++] = mem;
            }
        }
    }
}

void up(vector<vector<int>> &a) {
    for (ll j = 0; j < m; ++j) {
        ll it = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[it++][j] = mem;
            }
        }
    }
}

void right(vector<vector<int>> &a) {
    for (ll i = 0; i < n; ++i) {
        ll it = m - 1;
        for (ll j = m - 1; j >= 0; --j) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[i][it--] = mem;
            }
        }
    }
}

void down(vector<vector<int>> &a) {
    for (ll j = 0; j < m; ++j) {
        ll it = n - 1;
        for (ll i = n - 1; i >= 0; --i) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[it--][j] = mem;
            }
        }
    }
}


void circle(vector<vector<pair<int, int>>> &a) {
    // left
    for (ll i = 0; i < n; ++i) {
        ll it = 0;
        for (ll j = 0; j < m; ++j) {
            if (a[i][j].first != -1) {
                auto mem = a[i][j];
                a[i][j] = {-1, -1};
                a[i][it++] = mem;
            }
        }
    }
    // up
    for (ll j = 0; j < m; ++j) {
        ll it = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i][j].first != -1) {
                auto mem = a[i][j];
                a[i][j] = {-1, -1};
                a[it++][j] = mem;
            }
        }
    }
    // right
    for (ll i = 0; i < n; ++i) {
        ll it = m - 1;
        for (ll j = m - 1; j >= 0; --j) {
            if (a[i][j].first != -1) {
                auto mem = a[i][j];
                a[i][j] = {-1, -1};
                a[i][it--] = mem;
            }
        }
    }
    // down
    for (ll j = 0; j < m; ++j) {
        ll it = n - 1;
        for (ll i = n - 1; i >= 0; --i) {
            if (a[i][j].first != -1) {
                auto mem = a[i][j];
                a[i][j] = {-1, -1};
                a[it--][j] = mem;
            }
        }
    }
}


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        vector<vector<int>> a(n, vector<int>(m, -1));
        for (ll i = 0; i < n; ++i) {
            string s;
            cin >> s;
            for (ll j = 0; j < m; ++j) {
                if (s[j] != '.') {
                    a[i][j] = s[j] - 'a';
                }
            }
        }
        string q;
        cin >> q;
        vector<vector<vector<pair<int, int>>>> to(n, vector<vector<pair<int, int>>>(m, vector<pair<int, int>>(20, {-1,-1})));
        left(a);
        up(a);
        right(a);
        down(a);

//        for (auto row: a) {
//            for (auto el: row) {
//                if (el == -1) cout << '.';
//                else cout << (char) (el + 'a');
//            }
//            cout << "\n";
//        }
        ll cnt = q.size() / 4 - 1;

        vector<vector<pair<int, int>>> f(n,vector<pair<int, int>> (m, {-1, -1}));
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < m; ++j) {
                if (a[i][j] != -1) {
                    f[i][j] = {i, j};
                }
            }
        }
        circle(f);
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < m; ++j) {
                if (f[i][j].first != -1) {
                    auto [x, y] = f[i][j];
                    to[x][y][0] = {i, j};
                }
            }
        }
        for (ll it = 1; it < 20; ++it) {
            for (ll i = 0; i < n; ++i) {
                for (ll j = 0; j < m; ++j) {
                    if (f[i][j].first != -1) {
                        auto [x, y] = to[i][j][it - 1];
                        to[i][j][it] = to[x][y][it - 1];
                    }
                }
            }
        }
        for (ll it = 0; it < 20; ++it) {
            if (cnt & (1 << it)) {
                vector<vector<int>> newa(n, vector<int>(m, -1));
                for (ll i = 0; i < n; ++i) {
                    for (ll j = 0; j < m; ++j) {
                        if (to[i][j][it].first != -1) {
                            auto [x, y] = to[i][j][it];
                            newa[x][y] = a[i][j];
                        }
                    }
                }
                a = newa;
            }
        }

        for (auto row: a) {
            for (auto el: row) {
                if (el == -1) cout << '.';
                else cout << (char) (el + 'a');
            }
            cout << "\n";
        }
    }


    return 0;
}
