#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

ll n, m;

void left(vector<vector<int>> &a) {
    for (ll i = 0; i < n; ++i) {
        ll it = 0;
        for (ll j = 0; j < m; ++j) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[i][it++] = mem;
            }
        }
    }
}

void up(vector<vector<int>> &a) {
    for (ll j = 0; j < m; ++j) {
        ll it = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[it++][j] = mem;
            }
        }
    }
}

void right(vector<vector<int>> &a) {
    for (ll i = 0; i < n; ++i) {
        ll it = m - 1;
        for (ll j = m - 1; j >= 0; --j) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[i][it--] = mem;
            }
        }
    }
}

void down(vector<vector<int>> &a) {
    for (ll j = 0; j < m; ++j) {
        ll it = n - 1;
        for (ll i = n - 1; i >= 0; --i) {
            if (a[i][j] != -1) {
                int mem = a[i][j];
                a[i][j] = -1;
                a[it--][j] = mem;
            }
        }
    }
}

void next(vector<vector<int>> &a, int &pos) {
    if (pos == 0) {
        pos = 1;
        left(a);
        return;
    }
    if (pos == 1) {
        pos = 3;
        up(a);
        return;
    }
    if (pos == 2) {
        pos = 0;
        down(a);
        return;
    }
    pos = 2;
    right(a);
}

void prev(vector<vector<int>> &a, int &pos) {
    if (pos == 1) {
        pos = 0;
        right(a);
        return;
    }
    if (pos == 3) {
        pos = 1;
        down(a);
        return;
    }
    if (pos == 0) {
        pos = 2;
        up(a);
        return;
    }
    pos = 3;
    left(a);
}


void circle(vector<vector<pair<int, int>>> &a, ll pos) {
    if (pos == 0) {
        // left
        for (ll i = 0; i < n; ++i) {
            ll it = 0;
            for (ll j = 0; j < m; ++j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it++] = mem;
                }
            }
        }
        // up
        for (ll j = 0; j < m; ++j) {
            ll it = 0;
            for (ll i = 0; i < n; ++i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it++][j] = mem;
                }
            }
        }
        // right
        for (ll i = 0; i < n; ++i) {
            ll it = m - 1;
            for (ll j = m - 1; j >= 0; --j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it--] = mem;
                }
            }
        }
        // down
        for (ll j = 0; j < m; ++j) {
            ll it = n - 1;
            for (ll i = n - 1; i >= 0; --i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it--][j] = mem;
                }
            }
        }
    } else if (pos == 1) {
        // up
        for (ll j = 0; j < m; ++j) {
            ll it = 0;
            for (ll i = 0; i < n; ++i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it++][j] = mem;
                }
            }
        }
        // right
        for (ll i = 0; i < n; ++i) {
            ll it = m - 1;
            for (ll j = m - 1; j >= 0; --j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it--] = mem;
                }
            }
        }
        // down
        for (ll j = 0; j < m; ++j) {
            ll it = n - 1;
            for (ll i = n - 1; i >= 0; --i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it--][j] = mem;
                }
            }
        }
        // left
        for (ll i = 0; i < n; ++i) {
            ll it = 0;
            for (ll j = 0; j < m; ++j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it++] = mem;
                }
            }
        }
    } else if (pos == 2) {
        // down
        for (ll j = 0; j < m; ++j) {
            ll it = n - 1;
            for (ll i = n - 1; i >= 0; --i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it--][j] = mem;
                }
            }
        }
        // left
        for (ll i = 0; i < n; ++i) {
            ll it = 0;
            for (ll j = 0; j < m; ++j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it++] = mem;
                }
            }
        }
        // up
        for (ll j = 0; j < m; ++j) {
            ll it = 0;
            for (ll i = 0; i < n; ++i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it++][j] = mem;
                }
            }
        }
        // right
        for (ll i = 0; i < n; ++i) {
            ll it = m - 1;
            for (ll j = m - 1; j >= 0; --j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it--] = mem;
                }
            }
        }
    } else if (pos == 3) {
        // right
        for (ll i = 0; i < n; ++i) {
            ll it = m - 1;
            for (ll j = m - 1; j >= 0; --j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it--] = mem;
                }
            }
        }
        // down
        for (ll j = 0; j < m; ++j) {
            ll it = n - 1;
            for (ll i = n - 1; i >= 0; --i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it--][j] = mem;
                }
            }
        }
        // left
        for (ll i = 0; i < n; ++i) {
            ll it = 0;
            for (ll j = 0; j < m; ++j) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[i][it++] = mem;
                }
            }
        }
        // up
        for (ll j = 0; j < m; ++j) {
            ll it = 0;
            for (ll i = 0; i < n; ++i) {
                if (a[i][j].first != -1) {
                    auto mem = a[i][j];
                    a[i][j] = {-1, -1};
                    a[it++][j] = mem;
                }
            }
        }
    }
}

char nt(char c) {
    if (c == 'R') return 'L';
    if (c == 'L') return 'R';
    if (c == 'D') return 'U';
    return 'D';
}

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        vector<vector<int>> a(n, vector<int>(m, -1));
        for (ll i = 0; i < n; ++i) {
            string s;
            cin >> s;
            for (ll j = 0; j < m; ++j) {
                if (s[j] != '.') {
                    a[i][j] = s[j] - 'a';
                }
            }
        }
        string qs, q;
        cin >> qs;
        vector<vector<vector<pair<int, int>>>> to(n, vector<vector<pair<int, int>>>(m, vector<pair<int, int>>(20, {-1,
                                                                                                                   -1})));
        vector<vector<vector<pair<int, int>>>> torev(n, vector<vector<pair<int, int>>>(m, vector<pair<int, int>>(20,
                                                                                                                 {-1,
                                                                                                                  -1})));
        q.push_back(qs[0]);
        for (ll i = 1; i < qs.size(); ++i) {
            if (qs[i] == qs[i - 1] || qs[i] == nt(qs[i - 1])) {
                q.pop_back();
            }
            q.push_back(qs[i]);
        }
        if (q.size() <= 10) {
            for (auto el: q) {
                if (el == 'U') {
                    up(a);
                } else if (el == 'D') {
                    down(a);
                } else if (el == 'L') {
                    left(a);
                } else {
                    right(a);
                }
            }
            for (auto &row: a) {
                for (auto el: row) {
                    if (el == -1) cout << '.';
                    else cout << (char) (el + 'a');
                }
                cout << "\n";
            }

            continue;
        }
        ll pos = 0;
        for (ll i = 0; i < 2; ++i) {
            if (q[i] == 'U') {
                up(a);
                pos += 2;
            } else if (q[i] == 'D') {
                down(a);
            } else if (q[i] == 'L') {
                left(a);
                pos += 1;
            } else {
                right(a);
            }
        }
        int basepos = pos;
        q = q.substr(2, q.size() - 2);

//        for (auto row: a) {
//            for (auto el: row) {
//                if (el == -1) cout << '.';
//                else cout << (char) (el + 'a');
//            }
//            cout << "\n";
//        }
        int cnt = 0;
        for (auto el: q) {
            // RD
            if (pos == 0) {
                if (el == 'L') {
                    pos = 1;
                    cnt++;
                } else if (el == 'U') {
                    pos = 2;
                    cnt--;
                }
            } // LD
            else if (pos == 1) {
                if (el == 'R') {
                    pos = 0;
                    cnt--;
                } else if (el == 'U') {
                    pos = 3;
                    cnt++;
                }
            } // RU
            else if (pos == 2) {
                if (el == 'D') {
                    pos = 0;
                    cnt++;
                } else if (el == 'L') {
                    pos = 3;
                    cnt--;
                }
            } // LU
            else if (pos == 3) {
                if (el == 'D') {
                    pos = 1;
                    cnt--;
                } else if (el == 'R') {
                    pos = 2;
                    cnt++;
                }
            }
        }

        vector<vector<pair<int, int>>> f(n, vector<pair<int, int>>(m, {-1, -1}));
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < m; ++j) {
                if (a[i][j] != -1) {
                    f[i][j] = {i, j};
                }
            }
        }
        circle(f, basepos);
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < m; ++j) {
                if (f[i][j].first != -1) {
                    auto [x, y] = f[i][j];
                    to[x][y][0] = {i, j};
                    torev[i][j][0] = {x, y};
                }
            }
        }
        for (ll it = 1; it < 20; ++it) {
            for (ll i = 0; i < n; ++i) {
                for (ll j = 0; j < m; ++j) {
                    if (f[i][j].first != -1) {
                        auto [x, y] = to[i][j][it - 1];
                        to[i][j][it] = to[x][y][it - 1];
                        auto [x1, y1] = torev[i][j][it - 1];
                        torev[i][j][it] = torev[x1][y1][it - 1];
                    }
                }
            }
        }
        if (cnt > 0) {
            ll cnt1 = abs(cnt) / 4;
            for (ll it = 0; it < 20; ++it) {
                if (cnt1 & (1 << it)) {
                    vector<vector<int>> newa(n, vector<int>(m, -1));
                    for (ll i = 0; i < n; ++i) {
                        for (ll j = 0; j < m; ++j) {
                            if (to[i][j][it].first != -1) {
                                auto [x, y] = to[i][j][it];
                                newa[x][y] = a[i][j];
                            }
                        }
                    }
                    a = newa;
                }
            }
            ll cnt2 = abs(cnt) % 4;
            while (cnt2--) {
                next(a, basepos);
            }
        } else {
            ll cnt1 = abs(cnt) / 4;
            for (ll it = 0; it < 20; ++it) {
                if (cnt1 & (1 << it)) {
                    vector<vector<int>> newa(n, vector<int>(m, -1));
                    for (ll i = 0; i < n; ++i) {
                        for (ll j = 0; j < m; ++j) {
                            if (torev[i][j][it].first != -1) {
                                auto [x, y] = torev[i][j][it];
                                newa[x][y] = a[i][j];
                            }
                        }
                    }
                    a = newa;
                }
            }
            ll cnt2 = abs(cnt) % 4;
            while (cnt2--) {
                prev(a, basepos);
            }
        }


        for (auto &row: a) {
            for (auto el: row) {
                if (el == -1) cout << '.';
                else cout << (char) (el + 'a');
            }
            cout << "\n";
        }
    }


    return 0;
}
