#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
using namespace std;

const int INF = 1e18;

const int maxn = 2e5 + 10;
int tree[4*maxn];
int tag[4*maxn];
int a[maxn];

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        tree[v] = a[tl];
        tag[v] = 0;
        return;
    }
    int tm = (tl + tr) / 2;
    build(2*v+1, tl, tm);
    build(2*v+2, tm, tr);
    tree[v] = max(tree[2*v+1], tree[2*v+2]);
}
void push(int v) {
    tag[2*v+1] += tag[v];
    tag[2*v+2] += tag[v];
    tag[v] = 0;
}
int getval(int v) {
    return tree[v] + tag[v];
}
void add(int v, int tl, int tr, int ql, int qr, int val) {
    if (qr <= tl || tr <= ql) return;
    if (ql <= tl && tr <= qr) {
        tag[v] += val;
        return;
    }
    int tm = (tl + tr) / 2;
    push(v);
    add(2*v+1, tl, tm, ql, qr, val);
    add(2*v+2, tm, tr, ql, qr, val);
    tree[v] = max(getval(2*v+1), getval(2*v+2));
}
int get(int v, int tl, int tr, int ql, int qr) {
    if (qr <= tl || tr <= ql) return -INF;
    if (ql <= tl && tr <= qr) return getval(v);
    int tm = (tl + tr) / 2;
    push(v);
    int g1 = get(2*v+1, tl, tm, ql, qr);
    int g2 = get(2*v+2, tm, tr, ql, qr);
    tree[v] = max(getval(2*v+1), getval(2*v+2));
    return max(g1, g2);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector <pi> ev(n+m);
    for (int i = 0; i<n+m; ++i) cin >> ev[i].first >> ev[i].second;

    set <int> x;
    int pos = 0;
    x.insert(0);
    for (auto [t, h]: ev) {
        if (t == 1) {
            x.insert(pos);
            pos += h;
        }
        else {
            x.insert(pos+h-1);
        }
    }

    for (int i = 0; i<maxn; ++i) a[i] = -INF;
    map<int,int>zip;
    for (auto& i: x) {
        int z = zip.size();
        zip[i] = z;
        a[z] = -i*c;
    }

    build(0,0,maxn);

    pos = 0;
    int ans = -INF;
    for (auto [t, h]: ev) {
        if (t == 1) {
            int L = zip.lower_bound(pos) -> second;
            int R = zip.lower_bound(pos+h) -> second;
            ans = max(ans, get(0,0,maxn,L,R));
            pos += h;
        }
        else {
            int L = zip.lower_bound(pos+h-1) -> second;
            add(0,0,maxn,L,maxn,p);
        }
    }
    int L = zip.lower_bound(pos) -> second;
    ans = max(ans, get(0,0,maxn,L,maxn));
    cout << ans << endl;

    return 0;
}