#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
#define endl "\n";
using namespace std;

struct rect{
    int xl, xr, yl, yr;
};
const int INF = 1e18;

set <pi> solve_for_line(vector <pi> segms) {
    map <int, int> add;
    vector <pi> ans;
    for (auto [l, r]: segms) {
        if (!add.count(l)) add[l] = 0;
        if (!add.count(r+1)) add[r+1] = 0;
        add[l]++;
        add[r+1]--;
    }
    int cnt = 0;
    int last_start = -INF;
    for (auto [x, d]: add) {
        int cnt_was = cnt;
        cnt += d;
        if (cnt_was > 0 && cnt == 0) ans.emplace_back(last_start, x-1);
        if (cnt > 0 && cnt_was == 0) last_start = x;
    }
    set st = set(all(ans));
    return st;
}

int calc(vector <int>& vec) {
    int best = 1;
    int cur = 1;
    for (int i = 1; i<vec.size(); ++i) {
        if (vec[i] == vec[i-1] + 1) cur++;
        else {
            best = max(best, cur);
            cur = 1;
        }
    }
    best = max(best, cur);
    return best;
}

void solve() {
    int n;
    cin >> n;
    vector <rect> rects(n);
    for (auto& el: rects) cin >> el.xl >> el.yl >> el.xr >> el.yr;
    map <int, vector<pi>> segms;
    map <int, set<pi>> solution;
    for (auto& el: rects) {
        for (int y = el.yl; y <= el.yr; ++y) {
            if (!segms.count(y)) segms[y] = {};
            segms[y].emplace_back(el.xl, el.xr);
        }
    }
    for (auto [y, vec]: segms) solution[y] = solve_for_line(vec);
    map <pi, vector<int>> enc;
    for (auto [y, st]: solution) {
        for (auto el: st) {
            if (!enc.count(el)) enc[el] = {};
            enc[el].push_back(y);
        }
    }
    for (auto [pos, vec]: enc) {
        int k = calc(vec);
        cout << pos.first << ' ' << pos.second << ' ' << vec.size() << ' ' << k << endl;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}