#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

const ll INF = 1ll << 60;

#define mp(a, b) make_pair(a, b)

struct rect {
    int xl, xr, yl, yr;

    rect() = default;

    rect(int Xl, int Yl, int Xr, int Yr) {
        xl = Xl, xr = Xr, yl = Yl, yr = Yr;
    }
};

vector<rect> R;

struct query {
    int xl, xr, y, t;

    query() = default;

    query(int Xl, int Xr, int Y, int T) {
        xl = Xl, xr = Xr, y = Y, t = T;
    }

    bool operator<(const query &B) const {
        return y < B.y;
    }
};

void solve_solo() {
    cout << "1\n";
    auto cr = R.front();
    int len = cr.yr - cr.yl + 1;
    cout << cr.xl << ' ' << cr.xr << ' ' << len << ' ' << len << endl;
}

void solve_dumb() {
    int n;
    cin >> n;
    R.resize(n);

    int mxX = 0, mxY = 0;
    for (auto &i: R) {
        cin >> i.xl >> i.yl >> i.xr >> i.yr;
        mxX = max(mxX, i.xr);
        mxY = max(mxY, i.yr);
    }
    if (n == 1) {
        solve_solo();
        return;
    }

    mxX += 3, mxY += 3;

    vector<map<int, int>> pcnt(mxX);
    vector<int> a(mxX);
    multiset<query> q;
    for (auto i: R) {
        q.insert({i.xl, i.xr, i.yl, 1});
        q.insert({i.xl, i.xr, i.yr + 1, -1});
    }

    for (int cy = 0; cy < mxY; ++cy) {
        while (!q.empty() && q.begin()->y <= cy) {
            int tl = q.begin()->xl, tr = q.begin()->xr, td = q.begin()->t;
            for (int cx = tl; cx <= tr; ++cx)
                a[cx] += td;

            q.erase(q.begin());
        }

        int cl = 0;
        for (int cr = 0; cr < mxX; ++cr) {
            if (a[cr] <= 0) {
                if (cl <= cr - 1) // check
                    pcnt[cl][cr - 1]++;
                cl = cr + 1;
            }
        }
    }

    vector<pll> ps;
    for (int i = 0; i < mxX; ++i)
        for (auto j: pcnt[i])
            ps.emplace_back(i, j.first);

    cout << ps.size() << endl;
    for (auto [i, j]: ps)
        cout << i << ' ' << j << ' ' << pcnt[i][j] << " 777\n";

}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve_dumb();
    return 0;
}
