#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#include <bits/extc++.h>
#pragma GCC target("avx,avx2")
//#define int long long
using namespace std;
using namespace __gnu_pbds;
template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

struct hasher {
    size_t operator()(const pair<int, int>& p) const {
        size_t h1 = hash<int>()(p.first);
        size_t h2 = hash<int>()(p.second);
        if (h1 != h2) return h1 ^ h2;
        return h1;
    }
};

void solve() {
    int n;
    cin >> n;
    struct rect {
        int x1, x2, y1, y2;
    };
    vector<rect> rects(n);
    int h = 1;
    int w = 1;
    vector<int> xs = {0}, ys = {0};
    for (int i = 0; i < n; i++) {
        cin >> rects[i].x1 >> rects[i].y1 >> rects[i].x2 >> rects[i].y2;
        xs.push_back(rects[i].x1);
        xs.push_back(rects[i].x2+1);
        ys.push_back(rects[i].y1);
        ys.push_back(rects[i].y2+1);
    }

    sort(xs.begin(), xs.end());
    sort(ys.begin(), ys.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    ys.resize(unique(ys.begin(), ys.end()) - ys.begin());

    for (int i = 0; i < n; i++) {
        rects[i].x1 = lower_bound(xs.begin(), xs.end(), rects[i].x1) - xs.begin();
        rects[i].y1 = lower_bound(ys.begin(), ys.end(), rects[i].y1) - ys.begin();
        rects[i].x2 = lower_bound(xs.begin(), xs.end(), rects[i].x2+1) - xs.begin();
        rects[i].y2 = lower_bound(ys.begin(), ys.end(), rects[i].y2+1) - ys.begin();
    }

    for (int i = 0; i < n; i++) {
        h = max(h, rects[i].y2);
        w = max(w, rects[i].x2);
    }

    vector grid(h+2, vector<short>(w+2));
    for (int i = 0; i < n; i++) {
        grid[rects[i].y1][rects[i].x1]++;
        grid[rects[i].y2][rects[i].x1]--;
        grid[rects[i].y1][rects[i].x2]--;
        grid[rects[i].y2][rects[i].x2]++;
    }

    gp_hash_table<pair<int, int>, int, hasher> mp;
    gp_hash_table<pair<int, int>, pair<int, int>, hasher> ans;

    for (int i = 1; i <= h+1; i++) {
        int open = -1;
        vector<pair<int, int>> st;
        for (int j = 1; j <= w + 1; j++) {
            grid[i][j] = grid[i][j] + grid[i-1][j] + grid[i][j-1] - grid[i-1][j-1];
            if (grid[i][j] != 0 && grid[i][j-1] == 0) {
                open = j;
            }

            if (grid[i][j] == 0 && grid[i][j-1] != 0) {
                st.emplace_back(xs[open], xs[j]-1);
            }
        }

        st.resize(unique(st.begin(), st.end()) - st.begin());

        gp_hash_table<pair<int, int>, int, hasher> cur;
        for (auto [u, v] : st) {
            cur[{u, v}] = mp[{u, v}] + ys[i+1] - ys[i];
            ans[{u, v}] = {ans[{u, v}].first + ys[i+1] - ys[i], max(ans[{u, v}].second, cur[{u, v}])};
        }
        mp = cur;
    }

    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u.first << ' ' << u.second << ' ' << v.first << ' ' << v.second << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}