//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#define int long long
using namespace std;
template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

void solve() {
    int n;
    cin >> n;
    struct rect {
        int x1, x2, y1, y2;
    };
    vector<rect> rects(n);
    int h = 1;
    int w = 1;
    for (int i = 0; i < n; i++) {
        cin >> rects[i].x1 >> rects[i].y1 >> rects[i].x2 >> rects[i].y2;
        h = max(h, rects[i].y2);
        w = max(w, rects[i].x2);
    }

    vector grid(h+2, vector<int>(w+2));
    for (int i = 0; i < n; i++) {
        grid[rects[i].y1][rects[i].x1]++;
        grid[rects[i].y2+1][rects[i].x1]--;
        grid[rects[i].y1][rects[i].x2+1]--;
        grid[rects[i].y2+1][rects[i].x2+1]++;
    }

    for (int i = 1; i <= h+1; i++) {
        for (int j = 1; j <= w+1; j++) {
            grid[i][j] = grid[i][j] + grid[i-1][j] + grid[i][j-1] - grid[i-1][j-1];
        }
    }

    map<pair<int, int>, int> mp;
    map<pair<int, int>, pair<int, int>> ans;

    for (int i = 1; i <= h; i++) {
        int open = -1;
        set<pair<int, int>> st;
        for (int j = 1; j <= w + 1; j++) {
            if (grid[i][j] != 0 && grid[i][j-1] == 0) {
                open = j;
            }

            if (grid[i][j] == 0 && grid[i][j-1] != 0) {
                st.insert({open, j-1});
            }
        }

        map<pair<int, int>, int> cur;
        for (auto [u, v] : st) {
            cur[{u, v}] = mp[{u, v}] + 1;
            ans[{u, v}] = {ans[{u, v}].first + 1, max(ans[{u, v}].second, cur[{u, v}])};
        }
        mp = cur;
    }

    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u.first << ' ' << u.second << ' ' << v.first << ' ' << v.second << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}
