#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

int m, n;

void do_move(vector<string>& a, char c) {
    if (c == 'L') {
        for (int i = 0; i < m; ++i) {
            string lett;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    lett.push_back(a[i][j]);
                }
            }
            a[i] = lett + string(n - szof(lett), '.');
        }
    }
    if (c == 'R') {
        for (int i = 0; i < m; ++i) {
            string lett;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    lett.push_back(a[i][j]);
                }
            }
            a[i] = string(n - szof(lett), '.') + lett;
        }
    }
    if (c == 'U') {
        for (int i = 0; i < n; ++i) {
            string lett;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != '.') {
                    lett.push_back(a[j][i]);
                }
            }
            for (int j = 0; j < szof(lett); ++j) {
                a[j][i] = lett[j];
            }
            for (int j = szof(lett); j < m; ++j) {
                a[j][i] = '.';
            }
        }
    }
    if (c == 'D') {
        for (int i = 0; i < n; ++i) {
            string lett;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != '.') {
                    lett.push_back(a[j][i]);
                }
            }
            for (int j = 0; j < m - szof(lett); ++j) {
                a[j][i] = '.';
            }
            for (int j = m - szof(lett); j < m; ++j) {
                a[j][i] = lett[j - (m - szof(lett))];
            }
        }
    }
}

void add(int& x, int& y, char c) {
    if (c == 'L') {
        --x;
    }
    if (c == 'R') {
        ++x;
    }
    if (c == 'U') {
        --y;
    }
    if (c == 'D') {
        ++y;
    }
    if (x < 0) {
        x = 0;
    }
    if (x > 1) {
        x = 1;
    }
    if (y < 0) {
        y = 0;
    }
    if (y > 1) {
        y = 1;
    }
}

void print(vector<string>& a) {
    for (int i = 0; i < m; ++i) {
        cerr << a[i] << "\n";
    }
    cerr << "\n";
}

void solve() {
    cin >> m >> n;
    vector<string> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    string s;
    cin >> s;
    int q = szof(s);
    if (q == 0) {
        for (int i = 0; i < m; ++i) {
            cout << a[i] << "\n";
        }
        return;
    }
    int j = 0;
    int c = 'L';
    if (s[0] == 'L') {
        c = 'R';
    }
    if (s[0] == 'U') {
        c = 'D';
    }
    if (s[0] == 'D') {
        c = 'U';
    }
    while (j + 1 < q && (s[j + 1] == s[0] || s[j + 1] == c)) {
        ++j;
    }
    do_move(a, s[j]);
    if (j + 1 == q) {
        for (int i = 0; i < m; ++i) {
            cout << a[i] << "\n";
        }
        return;
    }
    do_move(a, s[j + 1]);
    int p = s[j] != 'R' && s[j + 1] != 'R' ? 0 : 1;
    for (j = j + 2; j < q; ++j) {
        if (s[j] == 'L') {
            --p;
            if (p < 0) {
                p = 0;
            }
        }
        if (s[j] == 'R') {
            ++p;
            if (p > 1) {
                p = 1;
            }
        }
    }
    if (p == 0) {
        do_move(a, 'L');
    }
    if (p == 1) {
        do_move(a, 'R');
    }
    for (int i = 0; i < m; ++i) {
        cout << a[i] << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
