#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

struct Rect {
    int xl, yl, xr, yr;
};

struct Answer {
    int xl, xr, cnt, k;
    Answer(int xl, int xr, int cnt, int k) :xl(xl), xr(xr), cnt(cnt), k(k) {}
};

void solve() {
    int n;
    cin >> n;
    vector<Rect> inp(n);
    int w = 0, h = 0;
    for (auto& [xl, yl, xr, yr] : inp) {
        cin >> xl >> yl >> xr >> yr;
        w = max(w, xr + 1), h = max(h, yr + 1);
    }
    ++w, ++h;
    vector<vector<int>> ev(w, vector<int>(h));
    for (auto [xl, yl, xr, yr] : inp) {
        ++ev[xl][yl], --ev[xl][yr + 1];
        --ev[xr + 1][yl], ++ev[xr + 1][yr + 1];
    }
    vector<vector<int>> a(w, vector<int>(h));
    int d = 0;
    for (int i = 1; i < w; ++i) {
        for (int j = 1; j < h; ++j) {
            d += ev[i][j];
            a[i][j] = a[i - 1][j] + d;
        }
    }
    map<pair<int, int>, vector<int>> mp;
    for (int i = 1; i < h; ++i) {
        int l = 0;
        for (int j = 1; j < w; ++j) {
            if (a[j][i] == 0) {
                if (a[j - 1][i] > 0) {
                    mp[{l + 1, j - 1}].push_back(i);
                }
                l = j;
            }
        }
    }
    vector<Answer> ans;
    for (auto [pos, y] : mp) {
        int k = 1;
        for (int t = 0; t < szof(y); ++t) {
            int pt = t;
            while (t + 1 < szof(y) && y[t] + 1 == y[t + 1]) {
                ++t;
            }
            k = max(k, t - pt + 1);
        }
        ans.emplace_back(pos.first, pos.second, szof(y), k);
    }
    cout << szof(ans) << "\n";
    for (auto [xl, xr, cnt, k] : ans) {
        cout << xl << " " << xr << " " << cnt << " " << k << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
