#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

struct Rect {
    int xl, yl, xr, yr;
};

struct Answer {
    int xl, xr, cnt, k;
    Answer(int xl, int xr, int cnt, int k) :xl(xl), xr(xr), cnt(cnt), k(k) {}
};

void solve() {
    int n;
    cin >> n;
    map<pair<int, int>, pair<int, int>> mp;
    for (int i = 0; i < n; ++i) {
        int xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        auto& t = mp[{xl, xr}];
        t.first += yr - yl + 1;
        t.second = max(t.second, yr - yl + 1);
    }
    cout << szof(mp) << "\n";
    for (auto [pos, st] : mp) {
        cout << pos.first << " " << pos.second << " " << st.first << " " << st.second << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
