#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

void swipe(vector<vector<char>> & a, ll n, ll m, char c) {
    if (c == 'L') {
        for (int i = 0; i < m; ++i) {
            ll gap = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    if (gap > 0) {
                        a[i][j - gap] = a[i][j];
                        a[i][j] = '.';
                    }
                } else {
                    gap++;
                }
            }
        }
    } else if (c == 'R') {
        for (int i = 0; i < m; ++i) {
            ll gap = 0;
            for (int j = n - 1; j >= 0; --j) {
                if (a[i][j] != '.') {
                    if (gap > 0) {
                        a[i][j + gap] = a[i][j];
                        a[i][j] = '.';
                    }
                } else {
                    gap++;
                }
            }
        }
    } else if (c == 'U') {
        for (int j = 0; j < n; ++j) {
            ll gap = 0;
            for (int i = 0; i < m; ++i) {
                if (a[i][j] != '.') {
                    if (gap > 0) {
                        a[i - gap][j] = a[i][j];
                        a[i][j] = '.';
                    }
                } else {
                    gap++;
                }
            }
        }
    } else {
        for (int j = 0; j < n; ++j) {
            ll gap = 0;
            for (int i = m - 1; i >= 0; --i) {
                if (a[i][j] != '.') {
                    if (gap > 0) {
                        a[i + gap][j] = a[i][j];
                        a[i][j] = '.';
                    }
                } else {
                    gap++;
                }
            }
        }
    }
}

using vvc = vector<vector<char>>;

void solve() {
    ll n, m;
    cin >> m >> n;
    vvc a(m, vector<char>(n));

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

//    vvc a_l = a;
//    vvc a_r = a;
//    vvc a_u = a;
//    vvc a_d = a;
//    vvc a_lu;
//    vvc a_ld;
//    vvc a_ru;
//    vvc a_rd;

    string s;
    cin >> s;
    bool v = false;
    bool g = false;
    swipe(a, n, m, s[0]);
    for (int k = s.size() - 1; k >= 1; --k) {
        if (!v && (s[k] == 'U' || s[k] == 'D')) {
            v = true;
            swipe(a, n, m, s[k]);
        } if (!g && (s[k] == 'L' || s[k] == 'R')) {
            g = true;
            swipe(a, n, m, s[k]);
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve2() {
    ll n, m;
    cin >> m >> n;
    vvc a(m, vector<char>(n));

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

    vvc a_l;
    vvc a_r;
    vvc a_u;
    vvc a_d;

    string s;
    cin >> s;
    char last = 'N', last_v = 'N', last_g = 'N';
    for (auto c : s) {
        if (c == last_v || c == last_g) continue;

        if (c == 'U' || c == 'D') {
            last_v = c;
            if (last == 'V' && c == 'U') {
                a = a_u;
            } else if (last == 'V') {
                a = a_d;
            } else if (c == 'U') {
                last = 'V';
                swipe(a, n, m, 'D');
                a_d = a;
                swipe(a, n, m, 'U');
                a_u = a;
            } else {
                last = 'V';
                swipe(a, n, m, 'U');
                a_u = a;
                swipe(a, n, m, 'D');
                a_d = a;
            }
        }
        if (c == 'L' || c == 'R') {
            last_g = c;
            if (last == 'G' && c == 'L') {
                a = a_l;
            } else if (last == 'G') {
                a = a_r;
            } else if (c == 'L') {
                last = 'G';
                swipe(a, n, m, 'R');
                a_r = a;
                swipe(a, n, m, 'L');
                a_l = a;
            } else {
                last = 'G';
                swipe(a, n, m, 'L');
                a_l = a;
                swipe(a, n, m, 'R');
                a_r = a;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve3() {
    ll n, m;
    cin >> m >> n;
    vvc a(m, vector<char>(n));

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

    vvc a_l;
    vvc a_r;
    vvc a_u;
    vvc a_d;

    string s;
    cin >> s;
    char last_v = 'N', last_g = 'N';
    for (int i = 0; i < s.size() - 1; ++i) {
        if (s[i] == last_v || s[i] == last_g) continue;
        if ((s[i] == 'U' || s[i] == 'D') && (s[i+1] == 'U' || s[i+1] == 'D')) continue;
        if ((s[i] == 'L' || s[i] == 'R') && (s[i+1] == 'L' || s[i+1] == 'R')) continue;

        if (s[i] == 'U') last_v = 'U';
        if (s[i] == 'D') last_v = 'D';
        if (s[i] == 'L') last_g = 'L';
        if (s[i] == 'R') last_g = 'R';

        swipe(a, n, m, s[i]);
    }
    swipe(a, n, m, s[s.size() - 1]);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << a[i][j];
        }
        cout << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
    cin >> t;
    while(t--) solve3();
}
