#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct SegTree {
    struct Node {
        ll mx = -INFLL, push = 0;
    };

    vector<Node> tree;
    int n;

    SegTree(int n) : n(n) {
        tree.resize(4 * n);
    }

    void push(int v, int l, int r) {
        if (l + 1 < r) {
            tree[2 * v + 1].push += tree[v].push;
            tree[2 * v + 2].push += tree[v].push;
        }
        tree[v].mx += tree[v].push;
        tree[v].push = 0;
    }

    void update(int v, int l, int r, int li, int ri, ll x) {
        push(v, l, r);
        if (li >= r || l >= ri) {
            return;
        }
        if (li <= l && r <= ri) {
            tree[v].push += x;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, li, ri, x);
        update(2 * v + 2, m, r, li, ri, x);
        tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
    }

    void update(int li, int ri, ll x) {
        update(0, 0, n, li, ri, x);
    }

    void upd(int v, int l, int r, int i, ll x) {
        push(v, l, r);
        if (i < l || i >= r) {
            return;
        }
        if (l + 1 == r) {
            tree[v].mx = x;
            return;
        }
        int m = (l + r) / 2;
        upd(2 * v + 1, l, m, i, x);
        upd(2 * v + 2, m, r, i, x);
        tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
    }

    void upd(int i, ll x) {
        upd(0, 0, n, i, x);
    }

    ll get(int v, int l, int r, int li, int ri) {
        push(v, l, r);
        if (li >= r || l >= ri) {
            return -INFLL;
        }
        if (li <= l && r <= ri) {
            return tree[v].mx;
        }
        int m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, li, ri), get(2 * v + 2, m, r, li, ri));
    }

    ll get(int li, int ri) {
        return get(0, 0, n, li, ri);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, m;
    ll c, p;
    cin >> n >> m >> c >> p;
    ++m;
    int sz = n + m;
    vector<pair<int, int>> v(sz);
    if (sz == 0) {
        cout << "0\n";
        return 0;
    }
    v[0] = {2, 1};
    for (int i = 1; i < sz; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    vector<ll> pref(sz + 1);
    for (int i = 0; i < sz; ++i) {
        pref[i + 1] = pref[i] + (v[i].first == 1 ? v[i].second : 0);
    }
    vector<ll> dp(sz, -INFLL);
//    dp[0] = 0;
    vector<ll> crng(sz);
    vector<int> pp;
    for (int i = 0; i < sz; ++i) {
        if (v[i].first == 2) {
            pp.push_back(i);
        }
    }
    vector<ll> aa(sz);
    for (int i = 0; i < sz; ++i) {
        if (v[i].first == 2) {
            aa[i] = v[i].second + pref[i];
        }
    }
    sort(pp.begin(), pp.end(), [&](int i, int j) {
        ll a = aa[i], b = aa[j];
        return a < b || (a == b && i < j);
    });
    vector<int> pos(m);
    ll prv = -INFLL;
    int ind = -1;
    for (int i = 0; i < m; ++i) {
        if (aa[pp[i]] != prv) {
            prv = aa[pp[i]];
            ind = i;
        }
        pos[i] = ind;
    }
    vector<int> gg(sz);
    for (int i = 0; i < m; ++i) {
        gg[pp[i]] = i;
    }
//    vector<ll> huy(m, -INFLL);
//    huy[gg[0]] = dp[0];
    dp[gg[0]] = 0 + aa[0] * c;
    SegTree st(m);
    st.upd(gg[0], dp[gg[0]]);
    for (int i = 1; i < sz; ++i) {
        if (v[i].first == 1) {
            continue;
        }
        int it = gg[i];
//        st.upd(it, -INFLL);
        dp[it] = st.get(0, it);
        st.upd(it, dp[it]);
        st.update(pos[it], m, p);
//        dp[it] = -INFLL;
//        for (int j = 0; j < it; ++j) {
//            dp[it] = max(dp[it], dp[j]);
//        }
//        dp[it] += aa[i] * c;
//        dp[i] += p;
//        for (int j = pos[it]; j < m; ++j) {
//            dp[j] += p;
//        }
//        huy[it] = dp[i];
//        for (int j = i - 1; j >= 0; --j) {
//            if (v[j].first == 1) {
//                continue;
//            }
//            ll res = dp[j];
//            if (gg[i] > gg[j]) {
//                res -= (aa[i] - aa[j]) * c;
//                dp[i] = max(dp[i], res);
//            }
//        }
//        dp[i] += p;
//        for (int j = 0; j < i; ++j) {
//            if (v[j].first == 2) {
//                if (v[i].second + pref[i] <= v[j].second + pref[j]) {
//                    assert(gg[j] >= pos[gg[i]]);
//                    dp[j] += p;
//                } else {
//                    assert(gg[j] < pos[gg[i]]);
//                }
//            }
//        }
    }
    ll ans = 0;
    for (int i = 0; i < m; ++i) {
        dp[i] = st.get(i, i + 1);
        ans = max(ans, dp[i] - aa[pp[i]] * c);
    }
    cout << ans << "\n";
}
