#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

int n, m;

vector<string> move_left(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int i = 0; i < n; i++) {
        string lineChars;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.')
                lineChars += a[i][j];
        }

        int chCnt = lineChars.size();
        for (int j = 0; j < chCnt; j++) {
            b[i][j] = lineChars[j];
        }
        for (int j = chCnt; j < m; j++) {
            b[i][j] = '.';
        }
    }

    return b;
}

vector<string> move_right(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int i = 0; i < n; i++) {
        string lineChars;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.')
                lineChars += a[i][j];
        }

        int chCnt = lineChars.size();
        for (int j = 0; j < m - chCnt; j++) {
            b[i][j] = '.';
        }
        for (int j = m - chCnt; j < m; j++) {
            b[i][j] = lineChars[j - (m - chCnt)];
        }
    }

    return b;
}

vector<string> move_up(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int j = 0; j < m; j++) {
        string colChars;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.')
                colChars += a[i][j];
        }

        int chCnt = colChars.size();
        for (int i = 0; i < chCnt; i++) {
            b[i][j] = colChars[i];
        }
        for (int i = chCnt; i < n; i++) {
            b[i][j] = '.';
        }
    }

    return b;
}

vector<string> move_down(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int j = 0; j < m; j++) {
        string colChars;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.')
                colChars += a[i][j];
        }

        int chCnt = colChars.size();
        for (int i = 0; i < n - chCnt; i++) {
            b[i][j] = '.';
        }
        for (int i = n - chCnt; i < n; i++) {
            b[i][j] = colChars[i - (n - chCnt)];
        }
    }

    return b;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        cin >> n >> m;

        vector<string> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        string s;
        cin >> s;

        for (int i = 0; i < s.size(); i++) {
            if (s[i] == 'L')
                a = move_left(a);
            else if (s[i] == 'R')
                a = move_right(a);
            else if (s[i] == 'U')
                a = move_up(a);
            else
                a = move_down(a);
        }

        for (int i = 0; i < n; i++) {
            cout << a[i] << '\n';
        }
    }
}