#include <iostream>
#include <vector>
#include <set>
using namespace std;

using ll = long long;

int n, m;

vector<string> move_left(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int i = 0; i < n; i++) {
        string lineChars;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.')
                lineChars += a[i][j];
        }

        int chCnt = lineChars.size();
        for (int j = 0; j < chCnt; j++) {
            b[i][j] = lineChars[j];
        }
        for (int j = chCnt; j < m; j++) {
            b[i][j] = '.';
        }
    }

    return b;
}

vector<string> move_right(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int i = 0; i < n; i++) {
        string lineChars;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.')
                lineChars += a[i][j];
        }

        int chCnt = lineChars.size();
        for (int j = 0; j < m - chCnt; j++) {
            b[i][j] = '.';
        }
        for (int j = m - chCnt; j < m; j++) {
            b[i][j] = lineChars[j - (m - chCnt)];
        }
    }

    return b;
}

vector<string> move_up(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int j = 0; j < m; j++) {
        string colChars;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.')
                colChars += a[i][j];
        }

        int chCnt = colChars.size();
        for (int i = 0; i < chCnt; i++) {
            b[i][j] = colChars[i];
        }
        for (int i = chCnt; i < n; i++) {
            b[i][j] = '.';
        }
    }

    return b;
}

vector<string> move_down(vector<string> a) {
    vector<string> b(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            b[i] += '.';
        }
    }

    for (int j = 0; j < m; j++) {
        string colChars;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.')
                colChars += a[i][j];
        }

        int chCnt = colChars.size();
        for (int i = 0; i < n - chCnt; i++) {
            b[i][j] = '.';
        }
        for (int i = n - chCnt; i < n; i++) {
            b[i][j] = colChars[i - (n - chCnt)];
        }
    }

    return b;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        cin >> n >> m;

        vector<string> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        string s;
        cin >> s;

        vector<int> lvm, lgm, lm;
        vector<bool> used(s.size(), true);
        for (int i = 0; i < s.size(); i++) {
            if (s[i] == 'U') {
                while (lvm.size() > 0) {
                    if (s[lvm.back()] == 'U') {
                        used[i] = false;
                        break;
                    } else if (s[lm.back()] == 'D') {
                        used[lm.back()] = false;
                        lm.pop_back();
                        lvm.pop_back();
                    } else {
                        break;
                    }
                }
                if (used[i]) {
                    lvm.push_back(i);
                    lm.push_back(i);
                }
            } else if (s[i] == 'D') {
                while (lvm.size() > 0) {
                    if (s[lvm.back()] == 'D') {
                        used[i] = false;
                        break;
                    } else if (s[lm.back()] == 'U') {
                        used[lm.back()] = false;
                        lm.pop_back();
                        lvm.pop_back();
                    } else {
                        break;
                    }
                }
                if (used[i]) {
                    lvm.push_back(i);
                    lm.push_back(i);
                }
            } else if (s[i] == 'L') {
                while (lgm.size() > 0) {
                    if (s[lgm.back()] == 'L') {
                        used[i] = false;
                        break;
                    } else if (s[lm.back()] == 'R') {
                        used[lm.back()] = false;
                        lm.pop_back();
                        lgm.pop_back();
                    } else {
                        break;
                    }
                }
                if (used[i]) {
                    lgm.push_back(i);
                    lm.push_back(i);
                }
            } else {
                while (lgm.size() > 0) {
                    if (s[lgm.back()] == 'R') {
                        used[i] = false;
                        break;
                    } else if (s[lm.back()] == 'L') {
                        used[lm.back()] = false;
                        lm.pop_back();
                        lgm.pop_back();
                    } else {
                        break;
                    }
                }
                if (used[i]) {
                    lgm.push_back(i);
                    lm.push_back(i);
                }
            }
        }

        string s1;
        for (int i = 0; i < s.size(); i++) {
            if (used[i]) s1 += s[i];
        }
        s = s1;

        for (int i = 0; i < ((int)s.size() - 4) % 12 + 4; i++) {
            if (s[i] == 'L')
                a = move_left(a);
            else if (s[i] == 'R')
                a = move_right(a);
            else if (s[i] == 'U')
                a = move_up(a);
            else
                a = move_down(a);
        }

        for (int i = 0; i < n; i++) {
            cout << a[i] << '\n';
        }
    }
}