#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#define int long long

using namespace std;

mt19937 mt1(1329);

void check(string &res, string &lr, string &ud) {
    int len = res.size();
    if (res.size() <= 1) return;
    char last = res.back();
    if (last == 'L' || last == 'R') {
        if (res[len - 2] == 'L' || res[len - 2] == 'R') {
            res.pop_back();
            res.pop_back();
            res.push_back(last);
            lr.pop_back();
            lr.pop_back();
            lr.push_back(last);
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }

        if (lr.size() > 1 && lr[lr.size() - 2] == res.back()) {
            res.pop_back();
            lr.pop_back();
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }
    }

    last = res.back();
    len = res.size();
    if (last == 'U' || last == 'D') {
        if (res[len - 2] == 'U' || res[len - 2] == 'D') {
            res.pop_back();
            res.pop_back();
            res.push_back(last);
            ud.pop_back();
            ud.pop_back();
            ud.push_back(last);
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }

        if (ud.size() > 1 && ud[ud.size() - 2] == res.back()) {
            res.pop_back();
            ud.pop_back();
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }
    }

}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> v(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }

    string s;
    cin >> s;
    string res, lr, ud;
    for (int i = 0; i < s.size(); i++) {
        res.push_back(s[i]);
        if (s[i] == 'L' || s[i] == 'R') {
            lr.push_back(s[i]);
        } else {
            ud.push_back(s[i]);
        }
        check(res, lr, ud);
    }
//    cout << res << endl;
    for (char c : res) {
        if (c == 'L') {
            for (int i = 0; i < n; i++) {
                int d = 0;
                for (int j = 0; j < m; j++) {
                    if (v[i][j] == '.') {
                        d++;
                        continue;
                    }
                    v[i][j - d] = v[i][j];
                    if (d != 0) v[i][j] = '.';
                }
            }
        } else if (c == 'R') {
            for (int i = 0; i < n; i++) {
                int d = 0;
                for (int j = m - 1; j >= 0; j--) {
                    if (v[i][j] == '.') {
                        d++;
                        continue;
                    }
                    v[i][j + d] = v[i][j];
                    if (d != 0) v[i][j] = '.';
                }
            }
        } else if (c == 'U') {
            for (int j = 0; j < m; j++) {
                int d = 0;
                for (int i = 0; i < n; i++) {
                    if (v[i][j] == '.') {
                        d++;
                        continue;
                    }
                    v[i - d][j] = v[i][j];
                    if (d != 0) v[i][j] = '.';
                }
            }
        } else if (c == 'D') {
            for (int j = 0; j < m; j++) {
                int d = 0;
                for (int i = n - 1; i >= 0; i--) {
                    if (v[i][j] == '.') {
                        d++;
                        continue;
                    }
                    v[i + d][j] = v[i][j];
                    if (d != 0) v[i][j] = '.';
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << v[i][j];
        }
        cout << "\n";
    }
}

void super_solve() {
    string s;
    vector<char> z = {'L', 'R', 'U', 'D'};
    for (int i = 0; i < 200; i++) {
        s.push_back(z[mt1() % 4]);
    }
    string res, lr, ud;
    for (int i = 0; i < s.size(); i++) {
        res.push_back(s[i]);
        if (s[i] == 'L' || s[i] == 'R') {
            lr.push_back(s[i]);
        } else {
            ud.push_back(s[i]);
        }
        check(res, lr, ud);
    }
    cout << "   " << s << "\n";
    cout << "-> " << res << "\n\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
     cin >> tt;
    while (tt--) {
        solve();
    }
}

