#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#define int long long

using namespace std;

mt19937 mt1(1329);
int n, m;

const int L = 20;

void check(string &res, string &lr, string &ud) {
    int len = res.size();
    if (res.size() <= 1) return;
    char last = res.back();
    if (last == 'L' || last == 'R') {
        if (res[len - 2] == 'L' || res[len - 2] == 'R') {
            res.pop_back();
            res.pop_back();
            res.push_back(last);
            lr.pop_back();
            lr.pop_back();
            lr.push_back(last);
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }

        if (lr.size() > 1 && lr[lr.size() - 2] == res.back()) {
            res.pop_back();
            lr.pop_back();
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }
    }

    last = res.back();
    len = res.size();
    if (last == 'U' || last == 'D') {
        if (res[len - 2] == 'U' || res[len - 2] == 'D') {
            res.pop_back();
            res.pop_back();
            res.push_back(last);
            ud.pop_back();
            ud.pop_back();
            ud.push_back(last);
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }

        if (ud.size() > 1 && ud[ud.size() - 2] == res.back()) {
            res.pop_back();
            ud.pop_back();
            check(res, lr, ud);
            if (res.size() <= 1) return;
        }
    }

}

void move(char c, vector<vector<char>> &v) {
    if (c == 'L') {
        for (int i = 0; i < n; i++) {
            int d = 0;
            for (int j = 0; j < m; j++) {
                if (v[i][j] == '.') {
                    d++;
                    continue;
                }
                v[i][j - d] = v[i][j];
                if (d != 0) v[i][j] = '.';
            }
        }
    } else if (c == 'R') {
        for (int i = 0; i < n; i++) {
            int d = 0;
            for (int j = m - 1; j >= 0; j--) {
                if (v[i][j] == '.') {
                    d++;
                    continue;
                }
                v[i][j + d] = v[i][j];
                if (d != 0) v[i][j] = '.';
            }
        }
    } else if (c == 'U') {
        for (int j = 0; j < m; j++) {
            int d = 0;
            for (int i = 0; i < n; i++) {
                if (v[i][j] == '.') {
                    d++;
                    continue;
                }
                v[i - d][j] = v[i][j];
                if (d != 0) v[i][j] = '.';
            }
        }
    } else if (c == 'D') {
        for (int j = 0; j < m; j++) {
            int d = 0;
            for (int i = n - 1; i >= 0; i--) {
                if (v[i][j] == '.') {
                    d++;
                    continue;
                }
                v[i + d][j] = v[i][j];
                if (d != 0) v[i][j] = '.';
            }
        }
    }
}

void move2(char c, vector<vector<int>> &v) {
    if (c == 'L') {
        for (int i = 0; i < n; i++) {
            int d = 0;
            for (int j = 0; j < m; j++) {
                if (v[i][j] == -1) {
                    d++;
                    continue;
                }
                v[i][j - d] = v[i][j];
                if (d != 0) v[i][j] = -1;
            }
        }
    } else if (c == 'R') {
        for (int i = 0; i < n; i++) {
            int d = 0;
            for (int j = m - 1; j >= 0; j--) {
                if (v[i][j] == -1) {
                    d++;
                    continue;
                }
                v[i][j + d] = v[i][j];
                if (d != 0) v[i][j] = -1;
            }
        }
    } else if (c == 'U') {
        for (int j = 0; j < m; j++) {
            int d = 0;
            for (int i = 0; i < n; i++) {
                if (v[i][j] == -1) {
                    d++;
                    continue;
                }
                v[i - d][j] = v[i][j];
                if (d != 0) v[i][j] = -1;
            }
        }
    } else if (c == 'D') {
        for (int j = 0; j < m; j++) {
            int d = 0;
            for (int i = n - 1; i >= 0; i--) {
                if (v[i][j] == -1) {
                    d++;
                    continue;
                }
                v[i + d][j] = v[i][j];
                if (d != 0) v[i][j] = -1;
            }
        }
    }
}

int go(int v, int path_len, vector<vector<int>> &up) {
    for (int i = L - 1; i >= 0; i--) {
        if ((1ll << i) >= path_len) {
            v = up[i][v];
            path_len -= (1ll << i);
        }
    }
    return v;
}

void solve() {
    cin >> n >> m;
    vector<vector<char>> v(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }

    string s;
    cin >> s;
    string res, lr, ud;
    for (int i = 0; i < s.size(); i++) {
        res.push_back(s[i]);
        if (s[i] == 'L' || s[i] == 'R') {
            lr.push_back(s[i]);
        } else {
            ud.push_back(s[i]);
        }
        check(res, lr, ud);
    }

    if (res.size() < 20) {
        for (char c : res) {
            move(c, v);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << v[i][j];
            }
            cout << "\n";
        }
        return;
    }

    move(res[0], v);
    move(res[1], v);
    int ind = 2;
    while (true) {
        move(res[ind], v);
        if (res[ind] == 'L') break;
        ind++;
    }

    vector<vector<int>> z(n, vector<int> (m, -1));
    int cnt = 0;
    vector<int> positions;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] != '.') {
                z[i][j] = cnt;
                cnt++;
                positions.push_back(i * m + j);
            }
        }
    }

    for (int i = ind + 1; i <= ind + 4; i++) {
        move2(res[i], z);
    }


    vector<vector<int>> up(L, vector<int> (n * m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (z[i][j] == -1) continue;
            up[0][positions[z[i][j]]] = i * m + j;
        }
    }

    for (int j = 1; j < L; j++) {
        for (int i = 0; i < n; i++) {
            up[j][i] = up[j - 1][up[j - 1][i]];
        }
    }

    int l_cnt = 0;
    int last_l = ind;
    for (int i = ind + 1; i < res.size(); i++) {
        if (res[i] == 'L') {
            l_cnt++;
            last_l = i;
        }
    }

    vector<vector<char>> ans(n, vector<char> (m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') continue;
            int coord = go(i * m + j, l_cnt, up);
            ans[coord / m][coord % m] = v[i][j];
        }
    }

    for (int i = last_l + 1; i < res.size(); i++) {
        move(res[i], ans);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << ans[i][j];
        }
        cout << "\n";
    }
}

void super_solve() {
    string s;
    vector<char> z = {'L', 'R', 'U', 'D'};
    for (int i = 0; i < 200; i++) {
        s.push_back(z[mt1() % 4]);
    }
    string res, lr, ud;
    for (int i = 0; i < s.size(); i++) {
        res.push_back(s[i]);
        if (s[i] == 'L' || s[i] == 'R') {
            lr.push_back(s[i]);
        } else {
            ud.push_back(s[i]);
        }
        check(res, lr, ud);
    }
    cout << "   " << s << "\n";
    cout << "-> " << res << "\n\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
     cin >> tt;
    while (tt--) {
        solve();
    }
}

