#include <iostream>
#include <cmath>
#include <climits>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;

ll n, m;

void cU(vector<vector<char>>& a) {
	for (ll i = 1; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			if (a[i][j] == '.')
				continue;
			ll i1 = i;
			while (i1 - 1 >= 0 && a[i1 - 1][j] == '.') {
				a[i1 - 1][j] = a[i1][j];
				a[i1][j] = '.';
				i1--;
			}
		}
	}
}
void cD(vector<vector<char>>& a) {
	for (ll i = n - 2; i >= 0; i--) {
		for (ll j = 0; j < m; j++) {
			if (a[i][j] == '.')
				continue;
			ll i1 = i;
			while (i1 + 1 < n && a[i1 + 1][j] == '.') {
				a[i1 + 1][j] = a[i1][j];
				a[i1][j] = '.';
				i1++;
			}
		}
	}
}
void cL(vector<vector<char>>& a) {
	for (ll i = 0; i < n; i++) {
		for (ll j = 1; j < m; j++) {
			if (a[i][j] == '.')
				continue;
			ll j1 = j;
			while (j1 - 1 >= 0 && a[i][j1 - 1] == '.') {
				a[i][j1 - 1] = a[i][j1];
				a[i][j1] = '.';
				j1--;
			}
		}
	}
}
void cR(vector<vector<char>>& a) {
	for (ll i = 0; i < n; i++) {
		for (ll j = m - 2; j >= 0; j--) {
			if (a[i][j] == '.')
				continue;
			ll j1 = j;
			while (j1 + 1 < m && a[i][j1 + 1] == '.') {
				a[i][j1 + 1] = a[i][j1];
				a[i][j1] = '.';
				j1++;
			}
		}
	}
}

void prt(vector<vector<char>>& a) {
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cout << a[i][j];
		}
		cout << "\n";
	}
}

void solveB() {
	cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m)), aL, aR, aRU, aLU, aU, aUR, aUL;
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	string s;
	cin >> s;
	vector<bool> f(4, false);
	for (ll i = 0; i < s.size(); i++) {
		if (s[i] == 'U') {
			f[0] = true;
		}
		if (s[i] == 'D') {
			f[1] = true;

		}
		if (s[i] == 'L') {
			f[2] = true;

		}
		if (s[i] == 'R') {
			f[3] = true;

		}
	}
	if (f[0])
		cU(a);
	if (f[1])
		cD(a);

	if (f[2])
		cL(a);

	if (f[3])
		cR(a);
	prt(a);
}

int main()
{
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	ll timer = 1;
	cin >> timer;
	while (timer--) {
		solveB();
	}
}
/*

0 6 3 2
2 3
2 4
2 1
2 1
2 1
2 4

*/