#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <string>
#include <random>
#include <algorithm>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()

vector<string> tabl, tablcp;
vector<vector<int>> t1, t2;

void make_op(int n, int m, char ch) {
	if (ch == 'L' || ch == 'R') {
		for (int i = 0; i < n; ++i) {
			string s = "";
			for (int j = 0; j < m; ++j) {
				if (tabl[i][j] != '.') {
					s.push_back(tabl[i][j]);
					tabl[i][j] = '.';
				}
			}
			if (ch == 'L') {
				for (int j = 0; j < (int)s.size(); ++j) {
					tabl[i][j] = s[j];
				}
			} else {
				for (int j = 0; j < (int)s.size(); ++j) {
					tabl[i][m - (int)s.size() + j] = s[j];
				}
			}
		}
	} else {
		for (int j = 0; j < m; ++j) {
			string s = "";
			for (int i = 0; i < n; ++i) {
				if (tabl[i][j] != '.') {
					s.push_back(tabl[i][j]);
					tabl[i][j] = '.';
				}
			}
			if (ch == 'U') {
				for (int i = 0; i < (int)s.size(); ++i) {
					tabl[i][j] = s[i];
				}
			} else {
				for (int i = 0; i < (int)s.size(); ++i) {
					tabl[n - (int)s.size() + i][j] = s[i];
				}
			}
		}
	}
}

void make_op2(int n, int m, char ch) {
	if (ch == 'L' || ch == 'R') {
		for (int i = 0; i < n; ++i) {
			vector<int> s;
			for (int j = 0; j < m; ++j) {
				if (t2[i][j] != 0) {
					s.push_back(t2[i][j]);
					t2[i][j] = 0;
				}
			}
			if (ch == 'L') {
				for (int j = 0; j < (int)s.size(); ++j) {
					t2[i][j] = s[j];
				}
			} else {
				for (int j = 0; j < (int)s.size(); ++j) {
					t2[i][m - (int)s.size() + j] = s[j];
				}
			}
		}
	} else {
		for (int j = 0; j < m; ++j) {
			vector<int> s;
			for (int i = 0; i < n; ++i) {
				if (t2[i][j] != 0) {
					s.push_back(t2[i][j]);
					t2[i][j] = 0;
				}
			}
			if (ch == 'U') {
				for (int i = 0; i < (int)s.size(); ++i) {
					t2[i][j] = s[i];
				}
			} else {
				for (int i = 0; i < (int)s.size(); ++i) {
					t2[n - (int)s.size() + i][j] = s[i];
				}
			}
		}
	}
}

void dfs(int u, vector<int>& used, vector<pair<int, int>>& wr3, vector<int> &tp, vector<pair<int, int>> &wr2, int f) {
	tp.push_back(u);
	used[u] = 1;
	wr2[u] = { f, (int)tp.size() - 1 };
	int ni = wr3[u].first;
	int nj = wr3[u].second;
	int nv = t1[ni][nj] - 1;
	if (used[nv] == 0) {
		dfs(nv, used, wr3, tp, wr2, f);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	tabl.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> tabl[i];
	}
	string op; cin >> op;
	string opn = "";
	map<char, int> mp;
	mp['U'] = 1;
	mp['D'] = 1;
	for (int i = 0; i < (int)op.size(); ++i) {
		if (i + 1 == (int)op.size() || mp[op[i]] != mp[op[i + 1]]) {
			opn.push_back(op[i]);
		}
	}
	op = opn;
	make_op(n, m, op[0]);
	if (1 == (int)op.size()) {
		for (int i = 0; i < n; ++i) {
			cout << tabl[i] << '\n';
		}
		return;
	}
	make_op(n, m, op[1]);
	int nw = 0; //LURD
	if (op[0] == 'L' && op[1] == 'D') {
		// ok
	} else if (op[1 - 1] == 'D' && op[1] == 'L') {
		// ok
	} else if (op[1 - 1] == 'L' && op[1] == 'U') {
		nw = 1;
	} else if (op[1 - 1] == 'U' && op[1] == 'L') {
		nw = 1;
	} else if (op[1 - 1] == 'R' && op[1] == 'D') {
		nw = 3;
	} else if (op[1 - 1] == 'D' && op[1] == 'R') {
		nw = 3;
	} else if (op[1 - 1] == 'R' && op[1] == 'U') {
		nw = 2;
	} else if (op[1 - 1] == 'U' && op[1] == 'R') {
		nw = 2;
	}
	if (nw) {
		// to starting pos
		int nwc = nw;
		while (nwc > 0) {
			if (nwc == 1) {
				make_op(n, m, 'D');
			}
			if (nwc == 2) {
				make_op(n, m, 'L');
			}
			if (nwc == 3) {
				make_op(n, m, 'U');
			}
			--nwc;
		}
	}
	int nwost = nw;
	for (int j = 2; j < (int)op.size(); ++j) {
		if (nwost == 0) {
			if (op[j] == 'R') {
				--nw; --nwost;
			} else if (op[j] == 'U') {
				++nw; ++nwost;
			}
		} else if (nwost == 1) {
			if (op[j] == 'D') {
				--nw; --nwost;
			} else if (op[j] == 'R') {
				++nw; ++nwost;
			}
		} else if (nwost == 2) {
			if (op[j] == 'L') {
				--nw; --nwost;
			} else if (op[j] == 'D') {
				++nw; ++nwost;
			}
		} else {
			if (op[j] == 'U') {
				--nw; --nwost;
			} else if (op[j] == 'L') {
				++nw; ++nwost;
			}
		}
		nwost = (nwost + 4) % 4;
	}
	int added = 0;
	while (abs(nw) % 4 != 0) {
		++nw; ++added;
	}
	t1.clear();
	t1.resize(n, vector<int>(m, 0));
	t2 = t1; int nxt = 1;
	vector<pair<int, int>> wr;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (tabl[i][j] != '.') {
				t1[i][j] = t2[i][j] = nxt;
				++nxt;
				wr.push_back({ i, j });
			}
		}
	}
	make_op2(n, m, 'U');
	make_op2(n, m, 'R');
	make_op2(n, m, 'D');
	make_op2(n, m, 'L');
	--nxt;
	vector<int> used(nxt, 0);
	vector<vector<int>> cyc;
	vector<pair<int, int>> wr2(nxt);
	vector<pair<int, int>> wr3(nxt);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (t2[i][j] != 0) {
				wr3[t2[i][j] - 1] = { i, j };
			}
		}
	}
	for (int i = 0; i < nxt; ++i) {
		if (used[i] == 0) {
			cyc.push_back({});
			dfs(i, used, wr3, cyc[(int)cyc.size() - 1], wr2, (int)cyc.size() - 1);
		}
	}
	tablcp = tabl;
	int hm = nw / 4;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (tablcp[i][j] != '.') {
				int x = wr2[t1[i][j] - 1].first;
				int y = wr2[t1[i][j] - 1].second;
				//cyc[x][y] = t1[i][j] - 1
				ll ln = cyc[x].size();
				int nxtind = (ln * 10000000LL + (ll)y + (ll)hm) % ln;
				int nv = cyc[x][nxtind];
				x = wr[nv].first;
				y = wr[nv].second;
				tabl[x][y] = tablcp[i][j];
			}
		}
	}
	if (added == 1) {
		make_op(n, m, 'R');
	}
	if (added == 2) {
		make_op(n, m, 'R');
		make_op(n, m, 'U');
	}
	if (added == 3) {
		make_op(n, m, 'R');
		make_op(n, m, 'U');
		make_op(n, m, 'L');
	}
	for (int i = 0; i < n; ++i) {
		cout << tabl[i] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
