#include<bits/stdc++.h>
using namespace std;

using ll = long long;

struct segtree {
    int n;
    vector<ll> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(2 * n, 1e18) {}

    void update(int k, ll x) {
        for (tr[k += n] = x; k > 1; k >>= 1, tr[k] = min(tr[k << 1], tr[k << 1 | 1]));
    }

    ll get(int l, int r) {
        ll res = 1e18;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = min(res, tr[l++]);
            if (~r & 1) res = min(res, tr[r--]);
        }
        return res;
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n);
    for (auto& i : a) {
        cin >> i, --i;
    }
    vector<vector<int>> ev(k);
    for (int i = 0; i < n; ++i) {
        ev[a[i]].push_back(i);
    }
    int ptr = 0;
    vector<int> close, open;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < ev[i].size(); j += p) {
            open.push_back(ev[i][j]);
            if (j + p - 1 >= ev[i].size()) close.push_back(n - 1);
            else close.push_back(ev[i][j + p - 1]);
        }
    }
    sort(open.begin(), open.end());
    sort(close.begin(), close.end());
    auto inter = [&](int l, int r) -> int {
        return open.size() - (lower_bound(close.begin(), close.end(), l) - close.begin()) -
                (open.end() - upper_bound(open.begin(), open.end(), r));
    };
    vector<ll> dp(n + 1, (ll)1e18);
    dp[0] = 0;
    segtree tr1(n + 1), tr2(n + 1);
    for (int i = -1, j = 0; i < n; ++i) {
        if (i != -1) {
            while (inter(j, i) > m) ++j;
            if (j == 0) {
                dp[i + 1] = i + 1;
            } else {
                if (c >> 1 & 1) dp[i + 1] = min(dp[i + 1], tr1.get(j, i) + i);
                if (c >> 0 & 1) dp[i + 1] = min(dp[i + 1], tr2.get(j, i) + i);
            }
        }
        tr1.update(i + 1, dp[i + 1] + (i + 1) + 1);
        tr2.update(i + 1, dp[i + 1] + 2 * (n + 1 - (i + 1)) - 1 - (i + 1));
//        cout << i << endl;
    }
    cout << dp.back() + 1;
}
//0 1 2 9 10 13