#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct solution {
    int n, m;
    vector<string> board;

    solution() {};

    void move_l() {
        for (int i = 0; i < n; ++i) {
            string s;
            for (char c: board[i])
                if (c != '.') s += c;
            for (int j = s.size(); j < m; ++j) s += '.';
            board[i] = s;
        }
    }

    void move_r() {
        for (int i = 0; i < n; ++i) {
            string s = "";
            for (char c: board[i])
                if (c != '.') s += c;
            board[i] = "";
            for (int j = s.size(); j < m; ++j) board[i] += '.';
            board[i] += s;
        }
    }

    void move_u() {
        for (int j = 0; j < m; ++j) {
            vector<char> s;
            for (int i = 0; i < n; ++i)
                if (board[i][j] != '.') s.push_back(board[i][j]);
            for (int i = s.size(); i < n; ++i) s.push_back('.');
            for (int i = 0; i < n; ++i) board[i][j] = s[i];
        }
    }

    void move_d() {
        for (int j = 0; j < m; ++j) {
            vector<char> s;
            for (int i = 0; i < n; ++i)
                if (board[i][j] != '.') s.push_back(board[i][j]);
            vector<char> res;
            for (int i = s.size(); i < n; ++i) res.push_back('.');
            for (char c: s) res.push_back(c);
            for (int i = 0; i < n; ++i) board[i][j] = res[i];
        }
    }

    void answer() {
        for (string s: board) cout << s << "\n";
    }

    void solve() {
        cin >> n >> m;
        board.resize(n);
        for (string &s: board) cin >> s;
        string commands;
        cin >> commands;
        int L = 0, R = 0, D = 0, U = 0;
        for (char com: commands) {
            if (com == 'L') L++;
            if (com == 'R') R++;
            if (com == 'D') D++;
            if (com == 'U') U++;
        }

        if (U == 0 && D == 0) {
            if (commands.back() == 'L') {
                move_l();
                answer();
                return;
            }
            if (commands.back() == 'R') {
                move_r();
                answer();
                return;
            }
        }

        if (D == 0) {
            char last = ' ';
            int i = 0;
            for (; i < commands.size(); i++) {
                if (commands[i] == 'U') break;
                last = commands[i];
            }
            if (last == 'L') move_l();
            if (last == 'R') move_r();

            move_u();

            last = ' ';
            i = commands.size() - 1;
            for (; i >= 0; --i) {
                last = commands[i];
                if (commands[i] != 'U') break;
            }

            if (last == 'L') move_l();
            if (last == 'R') move_r();

            answer();
            return;

        }

        for (char com: commands) {
            if (com == 'L')
                move_l();
            if (com == 'R')
                move_r();
            if (com == 'U')
                move_u();
            if (com == 'D')
                move_d();
        }
        answer();
    }
};

signed main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solution().solve();

}
