#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct solution {
    int n, m;
    vector<string> board;

    solution() {};

    void move_l() {
        for (int i = 0; i < n; ++i) {
            string s;
            for (char c: board[i])
                if (c != '.') s += c;
            for (int j = s.size(); j < m; ++j) s += '.';
            board[i] = s;
        }
    }

    void move_r() {
        for (int i = 0; i < n; ++i) {
            string s = "";
            for (char c: board[i])
                if (c != '.') s += c;
            board[i] = "";
            for (int j = s.size(); j < m; ++j) board[i] += '.';
            board[i] += s;
        }
    }

    void move_u() {
        for (int j = 0; j < m; ++j) {
            vector<char> s;
            for (int i = 0; i < n; ++i)
                if (board[i][j] != '.') s.push_back(board[i][j]);
            for (int i = s.size(); i < n; ++i) s.push_back('.');
            for (int i = 0; i < n; ++i) board[i][j] = s[i];
        }
    }

    void move_d() {
        for (int j = 0; j < m; ++j) {
            vector<char> s;
            for (int i = 0; i < n; ++i)
                if (board[i][j] != '.') s.push_back(board[i][j]);
            vector<char> res;
            for (int i = s.size(); i < n; ++i) res.push_back('.');
            for (char c: s) res.push_back(c);
            for (int i = 0; i < n; ++i) board[i][j] = res[i];
        }
    }

    void answer() {
        for (string s: board) cout << s << "\n";
    }

    void solve() {
        cin >> n >> m;
        board.resize(n);
        for (string &s: board) cin >> s;
        string commands;
        cin >> commands;
        int L = 0, R = 0, D = 0, U = 0;
        for (char com: commands) {
            if (com == 'L') L++;
            if (com == 'R') R++;
            if (com == 'D') D++;
            if (com == 'U') U++;
        }

        if (commands[0] == 'L') {
            move_l();
            bool left = true;
            bool sorted = false;
            bool up = false;
            vector<int> rows;
            for (int i = 0; i < n; ++i) {
                rows.emplace_back(0);
                for (int j = 0; j < m; ++j)
                    if (board[i][j] != '.') rows[i]++;
            }
            for (int i = 1; i < commands.size(); ++i) {
                char com = commands[i];
                if (com == 'L') left = true;
                if (com == 'R') left = false;
                if (com == 'U') {
                    if (!sorted) {
                        sorted = true;
                        std::sort(rows.begin(), rows.end());
                    }
                    up = true;
                }
                if (com == 'D') {
                    if (!sorted) {
                        sorted = true;
                        std::sort(rows.begin(), rows.end());
                    }
                    up = false;
                }
            }
            if (up) std::reverse(rows.begin(), rows.end());
            for (auto row: rows) {
                if (left) for (int i = 0; i < row; ++i) cout << 'a';
                for (int i = row; i < m; ++i) cout << '.';
                if (!left) for (int i = 0; i < row; ++i) cout << 'a';
                cout << '\n';
            }
        }
        if (commands[0] == 'R') {
            move_r();
            bool left = false;
            bool sorted = false;
            bool up = false;
            vector<int> rows;
            for (int i = 0; i < n; ++i) {
                rows.emplace_back(0);
                for (int j = 0; j < m; ++j)
                    if (board[i][j] != '.') rows[i]++;
            }
            for (int i = 1; i < commands.size(); ++i) {
                char com = commands[i];
                if (com == 'L') left = true;
                if (com == 'R') left = false;
                if (com == 'U') {
                    if (!sorted) {
                        sorted = true;
                        std::sort(rows.begin(), rows.end());
                    }
                    up = true;
                }
                if (com == 'D') {
                    if (!sorted) {
                        sorted = true;
                        std::sort(rows.begin(), rows.end());
                    }
                    up = false;
                }
            }
            if (up) std::reverse(rows.begin(), rows.end());
            for (auto row: rows) {
                if (left) for (int i = 0; i < row; ++i) cout << 'a';
                for (int i = row; i < m; ++i) cout << '.';
                if (!left) for (int i = 0; i < row; ++i) cout << 'a';
                cout << '\n';
            }
        }
    }
};

signed main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solution().solve();

}
