#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Rect {
    int x_l, x_r, y_l, y_r;

    Rect() {};

    Rect(int x_l, int x_r, int y_l, int y_r) : x_l(x_l), x_r(x_r), y_l(y_l), y_r(y_r) {};
};

struct event {
    int h, type, rect_id;

    event() {};

    event(int h, int type, int rect_id) : h(h), type(type), rect_id(rect_id) {};
};

void solve() {
    int n;
    cin >> n;
    vector<Rect> rects;
    vector<event> events;
    for (int i = 0; i < n; ++i) {
        int x_l, y_l, x_r, y_r;
        cin >> x_l >> y_l >> x_r >> y_r;
        rects.emplace_back(x_l, x_r, y_l, y_r);
        events.emplace_back(y_l - 1, 1, i);
        events.emplace_back(y_r, -1, i);
    }
    std::sort(events.begin(), events.end(), [](event a, event b) {
        if (a.h < b.h) return true;
        if (a.h > b.h) return false;
        if (a.type < b.type) return true;
        if (a.type > b.type) return false;
        return a.rect_id < b.rect_id;
    });

    typedef pair<int, int> Sg;
    typedef pair<int, int> pi;

    set<Sg> segments;

    int cur_h = 0;

    map<Sg, int> total;
    map<Sg, int> max_strike;
    map<Sg, int> cur;

    for (event e: events) {
//        cout << e.h << ' ' << e.type << ' ' << e.rect_id << '\n';
//        cout << cur_h << endl;
//        for (Sg s: segments) cout << s.first << ' ' << s.second << endl;
//        cout << endl;
        int l = -1;
        int r = -1;
        if (cur_h != e.h) {
            vector<pi> small_events;
            for (Sg sg: segments) {
                small_events.emplace_back(sg.first, -1);
                small_events.emplace_back(sg.second + 1, 1);
            }
            std::sort(small_events.begin(), small_events.end());
            set<Sg> local;
            int cnt = 0;
            for (pi p: small_events) {
//                cout << "event: " << p.first << ' ' << p.second << ' ' << cnt << endl;
                if (cnt == 0 && p.second == -1) l = p.first;
                if (cnt == 1 && p.second == 1) {
                    r = p.first;
                    local.insert({l, r - 1});
                }
                cnt -= p.second;
            }
//            for (Sg s: local) cout << s.first << ' ' << s.second << endl;
            auto cur_ = cur;
            for (auto [k, v]: cur_) {
                if (local.find(k) == local.end()) {
                    cur.erase(k);
                    if (max_strike.find(k) == max_strike.end()) max_strike[k] = 0;
                    max_strike[k] = max(max_strike[k], v);
                    if (total.find(k) == total.end()) total[k] = 0;
                    total[k] += v;
                } else {
                    cur[k] += e.h - cur_h;
                }
            }
            for (auto k: local)
                if (cur.find(k) == cur.end())
                    cur[k] = e.h - cur_h;
        }

        if (e.type == 1) segments.insert({rects[e.rect_id].x_l, rects[e.rect_id].x_r});
        else segments.erase({rects[e.rect_id].x_l, rects[e.rect_id].x_r});
        cur_h = e.h;

//        cout << ">>>\n";
    }

    for (auto [k, v]: cur) {
//        cur.erase(k);
        if (max_strike.find(k) == max_strike.end()) max_strike[k] = 0;
        max_strike[k] = max(max_strike[k], v);
        if (total.find(k) == total.end()) total[k] = 0;
        total[k] += v;
    }

    cout << total.size() << endl;
    for (auto [k, v]: total) {
        cout << k.first << ' ' << k.second << ' ' << v << ' ' << max_strike[k] << "\n";
    }
//    cout << "------------------------------------------------\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();

}
