#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 30;

struct Node {
    int mn, mx;
    int add;
    Node *l, *r;

    Node() {
        mn = mx = 0;
        add = 0;
        l = r = nullptr;
    }
};

void push(Node *root) {
    if (!root->l) {
        root->l = new Node();
    }
    if (!root->r) {
        root->r = new Node();
    }
    if (root->add) {
        root->l->mn += root->add;
        root->l->mx += root->add;
        root->l->add += root->add;
        root->r->mn += root->add;
        root->r->mx += root->add;
        root->r->add += root->add;
    }
    root->add = 0;
}

void add_to_segm(int ql, int qr, int val, Node *root, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        root->mn += val;
        root->mx += val;
        root->add += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(root);
    int nm = (nl + nr) / 2;
    add_to_segm(ql, qr, val, root->l, nl, nm);
    add_to_segm(ql, qr, val, root->r, nm, nr);
    root->mn = min(root->l->mn, root->r->mn);
    root->mx = max(root->l->mx, root->r->mx);
}

pair<int, int> get(int ql, int qr, Node *root, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return {root->mn, root->mx};
    }
    if (qr <= nl || nr <= ql) {
        return {R, -1};
    }
    push(root);
    int nm = (nl + nr) / 2;
    auto p1 = get(ql, qr, root->l, nl, nm), p2 = get(ql, qr, root->r, nm, nr);
    root->mn = min(root->l->mn, root->r->mn);
    root->mx = max(root->l->mx, root->r->mx);
    return {min(p1.first, p2.first), max(p1.second, p2.second)};
}

void solve() {
    int n;
    cin >> n;
    vector<int> xl(n), yl(n), xr(n), yr(n);
    map<int, vector<int>> mp1;
    for (int i = 0; i < n; ++i) {
        cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
        xr[i]++;
        yr[i]++;
        swap(yl[i], yr[i]);
        yl[i] *= -1;
        yr[i] *= -1;
        assert(yr[i] == -1);
        mp1[yl[i]].push_back(i);
        mp1[yr[i]].push_back(i);
    }
    map<pair<int, int>, int> cnt, mx, st;
    set<pair<int, int>> segms;
    multiset<int> ls, rs;
    // Node *root = new Node();
    for (auto [nw, v] : mp1) {
        set<pair<int, int>> add, del;
        for (auto ind : v) {
            if (nw == yl[ind]) {
                ls.insert(xl[ind]);
                rs.insert(xr[ind]);
                // add_to_segm(xl[ind], xr[ind], 1, root);
                // pair<int, int> segm_nw = {xl[ind], xr[ind]};
                // while (true) {
                //     auto it = segms.lower_bound({xl[ind], 0});
                //     if (it == segms.end() || it->first > segm_nw.second) {
                //         break;
                //     }
                //     segm_nw.second = max(segm_nw.second, it->second);
                //     if (add.count(*it)) {
                //         add.erase(*it);
                //     } else {
                //         del.insert(*it);
                //     }
                //     segms.erase(it);
                // }
                // auto it = segms.lower_bound({xl[ind], 0});
                // if (it != segms.begin()) {
                //     it--;
                //     if (it->second >= segm_nw.first) {
                //         segm_nw.first = it->first;
                //         segm_nw.second = max(segm_nw.second, it->second);
                //         if (add.count(*it)) {
                //             add.erase(*it);
                //         } else {
                //             del.insert(*it);
                //         }
                //         segms.erase(it);
                //     }
                // }
                // if (del.count(segm_nw)) {
                //     del.erase(segm_nw);
                // } else {
                //     add.insert(segm_nw);
                // }
                // segms.insert(segm_nw);
            } else {
                ls.erase(ls.find(xl[ind]));
                rs.erase(rs.find(xr[ind]));
                // add_to_segm(xl[ind], xr[ind], -1, root);
            }
        }
        if (segms.empty() && !ls.empty()) {
            add.insert({*ls.begin(), *rs.rbegin()});
            segms.insert({*ls.begin(), *rs.rbegin()});
        } else if (!segms.empty() && ls.empty()) {
            del.insert(*segms.begin());
            segms.erase(segms.begin());
        } else if (!segms.empty() && !ls.empty()) {
            pair<int, int> p1 = *segms.begin();
            pair<int, int> p2 = {*ls.begin(), *rs.rbegin()};
            if (p1 != p2) {
                del.insert(p1);
                add.insert(p2);
                segms.erase(p1);
                segms.insert(p2);
            }
        }
        for (auto p : del) {
            cnt[p] += nw - st[p];
            mx[p] = max(mx[p], nw - st[p]);
        }
        for (auto p : add) {
            st[p] = nw;
        }
    }
    map<pair<int, int>, int> cnt2;
    for (auto [p, vl] : cnt) {
        if (vl != 0) {
            cnt2[p] = vl;
        }
    }
    cnt = cnt2;
    cout << cnt.size() << '\n';
    for (auto [p, vl] : cnt) {
        cout << p.first << ' ' << p.second - 1 << ' ' << vl << ' ' << mx[p] << '\n';
    }
}

/*
1
2
1 1 5 3
5 1 7 2
*/

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
