#include <bits/stdc++.h>
 
using namespace std;
 
constexpr int R = 1 << 30;
 
struct Node {
    int mn, mx;
    int add;
    Node *l, *r;
 
    Node() {
        mn = mx = 0;
        add = 0;
        l = r = nullptr;
    }
};
 
void push(Node *root) {
    if (!root->l) {
        root->l = new Node();
    }
    if (!root->r) {
        root->r = new Node();
    }
    if (root->add) {
        root->l->mn += root->add;
        root->l->mx += root->add;
        root->l->add += root->add;
        root->r->mn += root->add;
        root->r->mx += root->add;
        root->r->add += root->add;
    }
    root->add = 0;
}
 
void add_to_segm(int ql, int qr, int val, Node *root, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        root->mn += val;
        root->mx += val;
        root->add += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(root);
    int nm = (nl + nr) / 2;
    add_to_segm(ql, qr, val, root->l, nl, nm);
    add_to_segm(ql, qr, val, root->r, nm, nr);
    root->mn = min(root->l->mn, root->r->mn);
    root->mx = max(root->l->mx, root->r->mx);
}
 
pair<int, int> get(int ql, int qr, Node *root, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return {root->mn, root->mx};
    }
    if (qr <= nl || nr <= ql) {
        return {R, -1};
    }
    push(root);
    int nm = (nl + nr) / 2;
    auto p1 = get(ql, qr, root->l, nl, nm), p2 = get(ql, qr, root->r, nm, nr);
    root->mn = min(root->l->mn, root->r->mn);
    root->mx = max(root->l->mx, root->r->mx);
    return {min(p1.first, p2.first), max(p1.second, p2.second)};
}
 
void solve() {
    int n;
    cin >> n;
    vector<int> xl(n), yl(n), xr(n), yr(n);
    map<int, vector<int>> mp1;
    for (int i = 0; i < n; ++i) {
        cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
        xr[i]++;
        yr[i]++;
        mp1[yl[i]].push_back(i);
        mp1[yr[i]].push_back(i);
    }
    map<pair<int, int>, int> cnt, mx, st;
    set<pair<int, int>> segms;
    multiset<int> ls, rs;
    for (auto [nw, v] : mp1) {
        set<pair<int, int>> add, del;
        for (auto ind : v) {
            if (nw == yr[ind])  {
                ls.erase(ls.find(xl[ind]));
                rs.erase(rs.find(xr[ind]));
                auto it = segms.lower_bound({xl[ind] + 1, 0});
                it--;
                auto segm_nw = *it;
                segms.erase(it);
                if (add.count(segm_nw)) {
                    add.erase(segm_nw);
                } else {
                    del.insert(segm_nw);
                }
                int r_val = xl[ind], l_val = xr[ind];
                auto it2 = rs.lower_bound(xr[ind]);
                if (it2 != rs.begin()) {
                    it--;
                    r_val = max(r_val, *it2);
                }
                it2 = ls.lower_bound(xl[ind]);
                if (it2 != ls.end()) {
                    l_val = min(l_val, *it2);
                }
                if (r_val >= l_val) {
                    if (del.count(segm_nw)) {
                        del.erase(segm_nw);
                    } else{
                        add.insert(segm_nw);
                    }
                    segms.insert(segm_nw);
                } else {
                    if (segm_nw.first < r_val) {
                        if (del.count({segm_nw.first, r_val})) {
                            del.erase({segm_nw.first, r_val});
                        } else {
                            add.insert({segm_nw.first, r_val});
                        }
                        segms.insert({segm_nw.first, r_val});
                    }
                    if (l_val < segm_nw.second) {
                        if (del.count({l_val, segm_nw.second})) {
                            del.erase({l_val, segm_nw.second});
                        } else {
                            add.insert({l_val, segm_nw.second});
                        }
                        segms.insert({l_val, segm_nw.second});
                    }
                }
            }
        }
        for (auto ind : v) {
            if (nw == yl[ind]) {
                ls.insert(xl[ind]);
                rs.insert(xr[ind]);
                pair<int, int> segm_nw = {xl[ind], xr[ind]};
                while (true) {
                    auto it = segms.lower_bound({xl[ind], 0});
                    if (it == segms.end() || it->first > segm_nw.second) {
                        break;
                    }
                    segm_nw.second = max(segm_nw.second, it->second);
                    if (add.count(*it)) {
                        add.erase(*it);
                    } else {
                        del.insert(*it);
                    }
                    segms.erase(it);
                }
                auto it = segms.lower_bound({xl[ind], 0});
                if (it != segms.begin()) {
                    it--;
                    if (it->second >= segm_nw.first) {
                        segm_nw.first = it->first;
                        segm_nw.second = max(segm_nw.second, it->second);
                        if (add.count(*it)) {
                            add.erase(*it);
                        } else {
                            del.insert(*it);
                        }
                        segms.erase(it);
                    }
                }
                if (del.count(segm_nw)) {
                    del.erase(segm_nw);
                } else {
                    add.insert(segm_nw);
                }
                segms.insert(segm_nw);
            }
        }
        for (auto p : del) {
            cnt[p] += nw - st[p];
            mx[p] = max(mx[p], nw - st[p]);
        }
        for (auto p : add) {
            st[p] = nw;
        }
    }
    for (auto p : segms) {
        cnt[p] += -1 - st[p];
        mx[p] = max(mx[p], -1 - st[p]);
    }
    map<pair<int, int>, int> cnt2;
    for (auto [p, vl] : cnt) {
        if (vl != 0) {
            cnt2[p] = vl;
        }
    }
    cnt = cnt2;
    cout << cnt.size() << '\n';
    for (auto [p, vl] : cnt) {
        cout << p.first << ' ' << p.second - 1 << ' ' << vl << ' ' << mx[p] << '\n';
    }
}
 
/*
1
2
1 1 5 3
5 1 7 2
*/
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
