#include <bits/stdc++.h>
 
using namespace std;
 
constexpr int R = 1 << 30;
 
struct Node {
    int mn, mx;
    int cnt_mn;
    int add;
    Node *l, *r;
 
    Node(int nl, int nr) {
        mn = mx = 0;
        cnt_mn = nr - nl;
        add = 0;
        l = r = nullptr;
    }
};
 
void push(Node *root, int nl, int nm, int nr) {
    if (!root->l) {
        root->l = new Node(nl, nm);
    }
    if (!root->r) {
        root->r = new Node(nm, nr);
    }
    if (root->add) {
        root->l->mn += root->add;
        root->l->mx += root->add;
        root->l->add += root->add;
        root->r->mn += root->add;
        root->r->mx += root->add;
        root->r->add += root->add;
    }
    root->add = 0;
}
 
void add_to_segm(int ql, int qr, int val, Node *root, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        root->mn += val;
        root->mx += val;
        root->add += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    int nm = (nl + nr) / 2;
    push(root, nl, nm, nr);
    add_to_segm(ql, qr, val, root->l, nl, nm);
    add_to_segm(ql, qr, val, root->r, nm, nr);
    root->mn = min(root->l->mn, root->r->mn);
    root->mx = max(root->l->mx, root->r->mx);
    root->cnt_mn = 0;
    if (root->mn == root->l->mn) {
        root->cnt_mn += root->l->cnt_mn;
    }
    if (root->mn == root->r->mn) {
        root->cnt_mn += root->r->cnt_mn;
    }
}
 
pair<int, int> get(int ql, int qr, Node *root, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return {root->mn, root->cnt_mn};
    }
    if (qr <= nl || nr <= ql) {
        return {R, 0};
    }
    int nm = (nl + nr) / 2;
    push(root, nl, nm, nr);
    auto p1 = get(ql, qr, root->l, nl, nm), p2 = get(ql, qr, root->r, nm, nr);
    root->mn = min(root->l->mn, root->r->mn);
    root->mx = max(root->l->mx, root->r->mx);
    root->cnt_mn = 0;
    if (root->mn == root->l->mn) {
        root->cnt_mn += root->l->cnt_mn;
    }
    if (root->mn == root->r->mn) {
        root->cnt_mn += root->r->cnt_mn;
    }
    pair<int, int> ans = {0, 0};
    ans.first = min(p1.first, p2.first);
    if (ans.first == p1.first) {
        ans.second += p1.second;
    }
    if (ans.first == p2.first) {
        ans.second += p2.second;
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> xl(n), yl(n), xr(n), yr(n);
    map<pair<int, int>, vector<int>> mp1;
    for (int i = 0; i < n; ++i) {
        cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
        xr[i]++;
        yr[i]++;
        mp1[{xl[i], -xr[i]}].push_back(i);
        mp1[{xr[i], -R}].push_back(i);
        mp1[yl[i]].push_back(i);
        mp1[yr[i]].push_back(i);
    }
    Node *root = new Node(0, R);
    map<pair<int, int>, int> cnt, mx, st;
    for (auto [p, v] : mp1) {
        if (p.second == -R) {
            for (auto ind : v) {
                add_to_segm(yl[ind], yr[ind], -1, root);
            }
        } else {
            for (auto ind : v) {
                auto p = get(yl[ind], yr[ind], root);
                if (p.first == 0) {
                    cnt[{xl[ind], xr[ind]}] += p.second;
                }
                add_to_segm(yl[ind], yr[ind], 1, root);
            }
        }
    }
    map<pair<int, int>, int> cnt2;
    for (auto [p, vl] : cnt) {
        if (vl != 0) {
            cnt2[p] = vl;
        }
    }
    cnt = cnt2;
    cout << cnt.size() << '\n';
    for (auto [p, vl] : cnt) {
        cout << p.first << ' ' << p.second - 1 << ' ' << vl << ' ' << mx[p] << '\n';
    }
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
