#include <bits/stdc++.h>

using i64 = long long;

struct Answer {
    int x1, x2, cnt, k;

    Answer() {}

    Answer(int x1, int x2, int cnt, int k) : x1(x1), x2(x2), cnt(cnt), k(k) {}
};

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> x1(n), y1(n), x2(n), y2(n);
    constexpr int MAX = 10;
    std::vector<std::vector<bool>> used(MAX + 2, std::vector<bool>(MAX + 2, false));
    for (int i = 0; i < n; i++) {
        std::cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
        for (int x = x1[i]; x <= x2[i]; x++) {
            for (int y = y1[i]; y <= y2[i]; y++) {
                used[x][y] = true;
            }
        }
    }
    std::vector<Answer> res;
    for (int xl = 1; xl <= MAX; xl++) {
        for (int xr = xl; xr <= MAX; xr++) {
            auto check = [&](int xl, int xr, int y) {
                if (used[xl - 1][y] || used[xr + 1][y]) {
                    return false;
                }
                for (int x = xl; x <= xr; x++) {
                    if (!used[x][y]) {
                        return false;
                    }
                }
                return true;
            };
            int cnt = 0, cur = 0, max = 0;
            for (int y = 1; y <= MAX; y++) {
                if (check(xl, xr, y)) {
                    cnt++;
                    cur++;
                    max = std::max(max, cur);
                } else {
                    cur = 0;
                }
            }
            if (cnt > 0) {
                res.emplace_back(xl, xr, cnt, max);
            }
        }
    }
    std::cout << (int) res.size() << "\n";
    for (auto [xl, xr, cnt, k] : res) {
        std::cout << xl << " " << xr << " " << cnt << " " << k << "\n";
    }
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
}
