#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

int m, n;

char inv(char c) {
    if (c == 'L') return 'R';
    if (c == 'R') return 'L';
    if (c == 'U') return 'D';
    if (c == 'D') return 'U';
    return '0';
}

bool horizontal(char c) {
    return c == 'L' || c == 'R';
}

/*string getNormal(string alpha) {
    deque<int> posis;
    string normal;
    for (int i = 0; i < alpha.size(); ++i) {
        if (alpha[i] == 'L' || alpha[i] == 'R') {
            if (posis.size() > 0 && horizontal(alpha[posis.back()])) posis.pop_back();
            posis.push_back(i);
        } else {
            if (posis.size() > 0 && !horizontal(alpha[posis.back()])) posis.pop_back();
            posis.push_back(i);
        }
    }
    if (posis.size() == 1) {
        normal.push_back(alpha[posis[0]]);
        return normal;
    }
    normal.push_back(alpha[posis[0]]);
    normal.push_back(alpha[posis[1]]);
    normal.pop_back();
    normal.pop_back();
    while (posis.size()) {
        int pos = posis.front();
        posis.pop_front();
        char lastType = normal[normal.size() - 2];
        char search = inv(lastType);
        if (alpha[pos])
    }
}*/

string getNormal(string alpha) {
    string result;
    for (auto& c : alpha) {
        if (result.size() == 0) {
            result.push_back(c);
        } else {
            if (horizontal(result.back()) == horizontal(c)) result.pop_back();
            result.push_back(c);
            if (result.size() > 2 && result[result.size()-1] == result[result.size()-3]) result.pop_back();
        }
    }
    return result;
}

vector<vector<int>> LEFT(vector<vector<int>> matrix) {
    vector<vector<int>> result(n, vector<int>(m, -1));
    for (int i = 0; i < n; ++i) {
        int freePointer = 0;
        for (int j = 0; j < m; ++j) {
            if (matrix[i][j] != -1) {
                result[i][freePointer++] = matrix[i][j];
            }
        }
    }
    return result;
}

vector<vector<int>> RIGHT(vector<vector<int>> matrix) {
    vector<vector<int>> result(n, vector<int>(m, -1));
    for (int i = 0; i < n; ++i) {
        int freePointer = m-1;
        for (int j = m-1; j >= 0; --j) {
            if (matrix[i][j] != -1) {
                result[i][freePointer--] = matrix[i][j];
            }
        }
    }
    return result;
}

vector<vector<int>> UP(vector<vector<int>> matrix) {
    vector<vector<int>> result(n, vector<int>(m, -1));
    for (int j = 0; j < m; ++j) {
        int freePointer = 0;
        for (int i = 0; i < n; ++i) {
            if (matrix[i][j] != -1) {
                result[freePointer++][j] = matrix[i][j];
            }
        }
    }
    return result;
}

vector<vector<int>> DOWN(vector<vector<int>> matrix) {
    vector<vector<int>> result(n, vector<int>(m, -1));
    for (int j = 0; j < m; ++j) {
        int freePointer = n-1;
        for (int i = n-1; i >= 0; --i) {
            if (matrix[i][j] != -1) {
                result[freePointer--][j] = matrix[i][j];
            }
        }
    }
    return result;
}

vector<vector<int>> goByStr(vector<vector<int>> positions, string command) {
    for (auto c: command) {
        if (c == 'L') {
            positions = LEFT(positions);
        } else if (c == 'R') {
            positions = RIGHT(positions);
        } else if (c == 'U') {
            positions = UP(positions);
        } else if (c == 'D') {
            positions = DOWN(positions);
        }
    }
    return positions;
}

int encode(int y, int x) {
    return y * m + x;
}

inline void work () {
    cin >> n >> m;
    vector<string> data(n);
    for (int i = 0; i < n; ++i) cin >> data[i];
    vector<vector<int>> positions(n, vector<int>(m, -1));
    vector<char> info;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (data[i][j] == '.') continue;
            info.push_back(data[i][j]);
            positions[i][j] = int(info.size()) - 1;
        }
    }
    string command;
    cin >> command;
    command = getNormal(command);
    if (command.size() >= 10) {
        positions = goByStr(positions, command);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (positions[i][j] == -1) {
                    cout << '.';
                } else {
                    cout << info[positions[i][j]];
                }
            }
            cout << endc;
        }
    } else {
        int removePrefixCount = (int(command.size()) % 4) + 4;
        string prefix = command.substr(0, removePrefixCount);
        string otherCommands = command.substr(removePrefixCount, 4);
        int lenOf = (int(command.size()) - removePrefixCount) / 4; //?
        positions = goByStr(positions, prefix);
        vector<int> starts(info.size(), -1), ends(info.size(), -1);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (positions[i][j] != -1) {
                    starts[positions[i][j]] = encode(i, j);
                }
            }
        }
        positions = goByStr(positions, otherCommands);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (positions[i][j] != -1) {
                    ends[positions[i][j]] = encode(i, j);
                }
            }
        }
        vector<int> goTo(n*m, -1);
        for (int i = 0; i < info.size(); ++i) goTo[starts[i]] = ends[i];
        int lg = 21;
        vector<vector<int>> binups(n*m, vector<int>(lg+1, -1));
        for (int i = 1; i <= lg; ++i) {
            for (int j = 0; j < n*m; ++j) {
                if (binups[j][i-1] == -1) continue;
                binups[j][i] = binups[binups[j][i-1]][i-1];
            }
        }
        vector<string> finally(n, string(m, '.'));
        for (int i = 0; i < info.size(); ++i) {
            int v = starts[i];
            for (int j = 0; j <= lg; ++j) {
                if ((lenOf >> j) & 1) {
                    v = binups[v][j];
                }
            }
            finally[v / m][v % m] = info[i];
        }
        for (int i = 0; i < n; ++i) {
            cout << finally[i] << endc;
        }
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) work();
    return 0;
}
