#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

ll n, m, k, p;
int c;

inline void work() {
    cin >> n >> m >> k >> p >> c;
    vector<int> types(n);
    for (int i = 0; i < n; ++i) {
        cin >> types[i];
        --types[i];
    }
    if (m >= n) {
        cout << n+1 << endc;
        exit(0);
    }
    vector<vector<ll>> variants(n+1, vector<ll>(k, 0));
    for (int i = 0; i < n; ++i) {
        variants[i+1] = variants[i];
        variants[i+1][types[i]] = (variants[i][types[i]] + 1) % p;
    }
    vector<ll> dp(n+1, INTMAX_MAX);
    vector<vector<int>> posByColor(k);
    for (int i = 0; i < n; ++i) {
        posByColor[types[i]].push_back(i);
    }
    auto getSum = [&] (int l, int r, int color) { // [l; r)
        int first = lower_bound(posByColor[color].begin(), posByColor[color].end(), l) - posByColor[color].begin();
        int second = lower_bound(posByColor[color].begin(), posByColor[color].end(), r) - posByColor[color].begin();
        return second - first;
    };
    dp[0] = 0;
    auto getDist = [&] (ll from, ll to) {
        if (c == 2) {
            return from + to;
        } else if (c == 1) {
            return 2*(n+1) - from - to;
        } else {
            return min(2*(n+1) - from - to, from + to);
        }
    };
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < i; ++j) {
            ll var = dp[j] + getDist(j, j+1) + (i-j-1);
            ll needPos = 0;
            for (int z = 0; z < k; ++z) {
                ll old = (p - variants[j][z]) % p;
                ll real = getSum(j, i, z);
                needPos += (real + old) / p + (((real + old) % p) != 0);
            }
            if (needPos > m) continue;
            dp[i] = min(dp[i], var);
        }
    }
    cout << dp.back()+1 << endc;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    while (t--) work();
    return 0;
}

/*
8 3 2 2
2
1 1 1 1 1 2 2 2

8 6 6 2
2
1 2 3 4 3 5 6 1
 */