#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

struct square {
    ll left, right, up, down;
    square() {}
    square(ll _left, ll _right, ll _up, ll _down) {
        left = _left;
        right = _right;
        up = _up;
        down = _down;
    }
};

inline void work() {
    int n;
    cin >> n;
    vector<square> squares(n);
    for (int i = 0; i < n; ++i) {
        ll xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        squares[i] = square(xl, xr, yr, yl);
    }
    if (n == 1) {
        cout << 1 << endc;
        ll len = squares[0].up - squares[0].down + 1;
        cout << squares[0].left << ' ' << squares[0].right << ' ' << len << ' ' << len << endc;
    } else {
        ll maxX = 0, maxY = 0;
        for (int i = 0; i < n; ++i) {
            maxX = max(maxX, squares[i].right);
            maxY = max(maxY, squares[i].up);
        }
        vector<vector<bool>> used(maxY+1, vector<bool>(maxX+1));
        for (int i = 0; i < n; ++i) {
            for (int j = squares[i].down; j <= squares[i].up; ++j) {
                for (int k = squares[i].left; k <= squares[i].right; ++k) {
                    used[j][k] = true;
                }
            }
        }
        map<pair<int, int>, vector<int>> levels;
        for (int i = 1; i <= maxY; ++i) {
            int start = -1;
            for (int j = 1; j <= maxX; ++j) {
                if (used[i][j]) {
                    if (start == -1) start = j;
                } else {
                    if (start != -1) {
                        levels[{start, j-1}].push_back(i);
                        start = -1;
                    }
                }
            }
            if (start != -1) levels[{start, maxX}].push_back(i);
        }
        cout << levels.size() << endc;
        for (auto& [key, val] : levels) {
            cout << key.first << ' ' << key.second << ' ' << val.size() << ' ' << 1 << endc;
        }
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) work();
    return 0;
}
