#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

struct square {
    ll left, right, up, down;
    square() {}
    square(ll _left, ll _right, ll _up, ll _down) {
        left = _left;
        right = _right;
        up = _up;
        down = _down;
    }
};

inline void work() {
    int n;
    cin >> n;
    vector<square> squares(n);
    ll maxH = 1;
    for (int i = 0; i < n; ++i) {
        ll xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        squares[i] = square(xl, xr, yr, yl);
        maxH = max(maxH, yr);
    }
    set<pair<int, int>> segments;
    auto add = [&] (int l, int r) {
        auto it = segments.lower_bound({l, -1});
        auto prev = it, next = it;
        vector<pair<int, int>> toErase;
        while (prev != segments.begin()) {
            --it;
            if (prev->second >= l-1) {
                r = max(r, next->second);
                l = min(l, next->first);
                toErase.push_back(*next);
            } else {
                break;
            }
        }
        while (next != segments.end()) {
            if (next->first <= r+1) {
                r = max(r, next->second);
                l = min(l, next->first);
                toErase.push_back(*next);
                next++;
            } else {
                break;
            }
        }
        for (auto& w : toErase) segments.erase(w);
        segments.insert({l, r});
    };
    for (int i = 0; i < n; ++i) add(squares[i].left, squares[i].right);
    cout << segments.size() << endc;
    for (auto& e : segments) {
        cout << e.first << ' ' << e.second << ' ' << 1 << ' ' << 1 << endc;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) work();
    return 0;
}

