#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using dbl = double;

#define all(x) x.begin(),x.end()

#ifdef LOC 
#define debug(x) cout<<#x<<" = "<<x<<endl
#else
#define debug(x)
#endif

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")
int n, m;
void LEFT(vector<vector<char>>& tbl) {
    debug("l");
    for (auto i = 0; i < n; ++i) {
        int last = -1;
        for (int j = 0; j < m; ++j) {
            if (tbl[i][j] == '.') {
                if (last == -1) last = j;
                continue;
            }
            if (last == -1) continue;
            tbl[i][last] = tbl[i][j];
            tbl[i][j] = '.';
            last++;
        }
    }
}

void RIGHT(vector<vector<char>>& tbl) {
    debug("r");
    for (int i = 0; i < n; ++i) {
        reverse(all(tbl[i]));
    }
    LEFT(tbl);
    for (int i = 0; i < n; ++i) {
        reverse(all(tbl[i]));
    }
}

void UP(vector<vector<char>>& tbl) {
    debug("u");

    vector<vector<char>> ntbl(m, vector<char>(n, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ntbl[j][i] = tbl[i][j];
        }
    }
    swap(n, m);
    LEFT(ntbl);
    swap(n, m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            tbl[i][j] = ntbl[j][i];
        }
    }
}

void DOWN(vector<vector<char>>& tbl) {
    debug("d");

    vector<vector<char>> ntbl(m, vector<char>(n, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ntbl[j][i] = tbl[i][j];
        }
    }
    swap(n, m);
    RIGHT(ntbl);
    swap(n, m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            tbl[i][j] = ntbl[j][i];
        }
    }
}

void REVH(vector<vector<char>>& tbl) {
    debug("rH");

    for (int i = 0; i < n; ++i) {
        reverse(all(tbl[i]));
    }
}

void REVV(vector<vector<char>>& tbl) {
    debug("rV");

    vector<vector<char>> ntbl(m, vector<char>(n, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ntbl[j][i] = tbl[i][j];
        }
    }
    swap(n, m);
    REVH(ntbl);
    swap(n, m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            tbl[i][j] = ntbl[j][i];
        }
    }
}

char cr(char c) {
    if (c == 'L') return 'R';
    if (c == 'R') return 'L';
    if (c == 'U') return 'D';
    if (c == 'D') return 'U';
    return 'R';
}

void st(char& a, char& b, char& d, char c) {
    if (a == 'X') a = c;
    if (b == 'X') b = c;
    if (d == 'X') d = c;
}

void solve() { 
    cin >> m >> n;

    vector<vector<char>> tbl(n, vector<char>(m, '.'));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> tbl[i][j];
        }
    }

    string ops;
    cin >> ops;    

    char l = 'L';
    char d = 'D';
    char x = 'X';

    for (auto c: ops) {
        if (l == c || d == c || x == c) continue;

        if (l == cr(c)) {
            st(l, x, d, c);
            l = 'X';
        }

        if (d == cr(c)) {
            st(l, x, d, c);
            d = 'X';
        }

        if (x == cr(c)) {
            st(l, x, d, c);
            x = 'X';
        }
    }

    // cout << l << d << x << endl;

    if (l == 'R') {
        UP(tbl);
        RIGHT(tbl);
        DOWN(tbl);
        LEFT(tbl);
        UP(tbl);
        RIGHT(tbl);
        if (d == 'X') DOWN(tbl);
    } else if (l == 'D') {
        UP(tbl);
        RIGHT(tbl);
        DOWN(tbl);
        if (d == 'X') RIGHT(tbl);
    } else if (l == 'U') {
        RIGHT(tbl);
        UP(tbl);
        if (d != 'X') LEFT(tbl);
    } else if (l == 'L') {
        if (d == 'X') UP(tbl);
    } else {
        if (d == 'R') {
            UP(tbl);
            RIGHT(tbl);
        } else if (d == 'D') {
            RIGHT(tbl);
        } else if (d == 'U') {
            RIGHT(tbl);
            UP(tbl);
            LEFT(tbl);
            DOWN(tbl); 
            RIGHT(tbl);
            UP(tbl);
            LEFT(tbl);
        } else if (d == 'L') {
            RIGHT(tbl);
            UP(tbl);
            LEFT(tbl);
            DOWN(tbl);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << tbl[i][j];
        }
        cout << '\n';
    }
}

int main() {
    ll q = 1;
    // #ifdef LOC
    cin >> q;
    // #endif

    for (ll i = 0; i < q; ++i) {
        solve();
    }
}