#include <bits/stdc++.h>

using namespace std;

void compress(int type, vector<vector<char>> &field) {
    int n = (int) field.size();
    int m = (int) field[0].size();
    if (type == 0) {
        vector<int> lst(n, 0);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[ii][lst[ii]++] = field[ii][jj];
                }
            }
        }
        for (int ii = 0; ii < n; ii++) {
            for (int jj = lst[ii]; jj < m; jj++) {
                field[ii][jj] = '.';
            }
        }
    } else if (type == 1) {
        vector<int> lst(n, m - 1);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = m - 1; jj > -1; jj--) {
                if (field[ii][jj] != '.') {
                    field[ii][lst[ii]--] = field[ii][jj];
                }
            }
        }
        for (int ii = 0; ii < n; ii++) {
            for (int jj = lst[ii]; jj > -1; jj--) {
                field[ii][jj] = '.';
            }
        }
    } else if (type == 2) {
        vector<int> lst(m, 0);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[lst[jj]++][jj] = field[ii][jj];
                }
            }
        }
        for (int j = 0; j < m; j++) {
            while (lst[j] < n) {
                field[lst[j]++][j] = '.';
            }
        }
    } else {
        vector<int> lst(m, n - 1);
        for (int ii = n - 1; ii > -1; ii--) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[lst[jj]--][jj] = field[ii][jj];
                }
            }
        }
        for (int j = 0; j < m; j++) {
            while (lst[j] > -1) {
                field[lst[j]--][j] = '.';
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> field(n, vector<char> (m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
        }
    }
    string Q;
    cin >> Q;
    int ln = (int) Q.size();
    vector<int> type(ln);
    vector<int> cnt(4, 0);
    for (int i = 0; i < ln; i++) {
        if (Q[i] == 'L') type[i] = 0, cnt[0]++;
        else if (Q[i] == 'R') type[i] = 1, cnt[1]++;
        else if (Q[i] == 'U') type[i] = 2, cnt[2]++;
        else type[i] = 3, cnt[3]++;
    }
    if (cnt[3] == 0) {
        vector<vector<char>> compressedL(field), compressedR(field);
        compress(0, compressedL);
        compress(1, compressedR);
        bool wasU = false, lastL = false, lastR = false;
        for (int i = 0; i < ln; i++) {
            if (type[i] == 0) {
                lastL = true;
                lastR = false;
            } else if (type[i] == 1) {
                lastL = false;
                lastR = true;
            } else {
                if (wasU) continue;
                wasU = true;
                if (lastL) field = compressedL;
                else if (lastR) field = compressedR;
                compress(2, field);
                lastL = lastR = false;
                compressedR = compressedL = field;
                compress(0, compressedL);
                compress(1, compressedR);
            }
        }
        if (lastL) field = compressedL;
        else if (lastR) field = compressedR;
    } else {
        for (int i = 0; i < ln; i++) {
            compress(type[i], field);
        }
    }

    for (auto &i : field) {
        for (auto j : i) cout << j;
        cout << '\n';
    }
}

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int t;
    cin >> t;
    while (t--) {
        solve();
//        cout << '\n';
    }
}
