#include <bits/stdc++.h>

using namespace std;

void compress(int type, vector<vector<char>> &field) {
    int n = (int) field.size();
    int m = (int) field[0].size();
    if (type == 0) {
        vector<int> lst(n, 0);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[ii][lst[ii]++] = field[ii][jj];
                }
            }
        }
        for (int ii = 0; ii < n; ii++) {
            for (int jj = lst[ii]; jj < m; jj++) {
                field[ii][jj] = '.';
            }
        }
    } else if (type == 1) {
        vector<int> lst(n, m - 1);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = m - 1; jj > -1; jj--) {
                if (field[ii][jj] != '.') {
                    field[ii][lst[ii]--] = field[ii][jj];
                }
            }
        }
        for (int ii = 0; ii < n; ii++) {
            for (int jj = lst[ii]; jj > -1; jj--) {
                field[ii][jj] = '.';
            }
        }
    } else if (type == 2) {
        vector<int> lst(m, 0);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[lst[jj]++][jj] = field[ii][jj];
                }
            }
        }
        for (int j = 0; j < m; j++) {
            while (lst[j] < n) {
                field[lst[j]++][j] = '.';
            }
        }
    } else {
        vector<int> lst(m, n - 1);
        for (int ii = n - 1; ii > -1; ii--) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[lst[jj]--][jj] = field[ii][jj];
                }
            }
        }
        for (int j = 0; j < m; j++) {
            while (lst[j] > -1) {
                field[lst[j]--][j] = '.';
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> field(n, vector<char>(m, '.'));
    map<char, int> Mp;
    int char_cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
            Mp[field[i][j]]++;
            if (field[i][j] != '.') char_cnt++;
        }
    }
    string Q;
    cin >> Q;
    int ln = (int) Q.size();
    vector<int> type(ln);
    vector<int> cnt(4, 0);
    for (int i = 0; i < ln; i++) {
        if (Q[i] == 'L') type[i] = 0, cnt[0]++;
        else if (Q[i] == 'R') type[i] = 1, cnt[1]++;
        else if (Q[i] == 'U') type[i] = 2, cnt[2]++;
        else type[i] = 3, cnt[3]++;
    }

    int pos = ln;

    vector<vector<char>> compressedL(field), compressedR(field);
    compress(0, compressedL);
    compress(1, compressedR);
    bool wasU = false, wasD = false, lastL = false, lastR = false;
    for (int i = 0; i < ln; i++) {
        if (type[i] == 0) {
            lastL = true;
            lastR = false;
        } else if (type[i] == 1) {
            lastL = false;
            lastR = true;
        } else if (type[i] == 2) {
            if (wasD) {
                pos = i;
                break;
            }
            if (wasU) continue;
            wasU = true;
            if (lastL) field = compressedL;
            else if (lastR) field = compressedR;
            compress(2, field);
            lastL = lastR = false;
            compressedR = compressedL = field;
            compress(0, compressedL);
            compress(1, compressedR);
        } else {
            if (wasU) {
                pos = i;
                break;
            }
            wasD = true;
            if (lastL) field = compressedL;
            else if (lastR) field = compressedR;
            compress(3, field);
            lastL = lastR = false;
            compressedR = compressedL = field;
            compress(0, compressedL);
            compress(1, compressedR);
        }
    }
    if (lastL) field = compressedL;
    else if (lastR) field = compressedR;

    if (pos != ln && char_cnt == Mp['a']) {
        bool cntu = false, cntd = false;
        for (int i = pos; i < ln; i++) {
            if (type[i] < 2) {
                pos = i;
                break;
            }
            cntu = type[i] == 2;
            cntd = type[i] == 3;
        }
        if (cntu) compress(2, field);
        else if (cntd) compress(3, field);
        if (pos != ln) compress(type[pos], field);
        if (pos == ln) {
            for (auto &i : field) {
                for (auto j : i) cout << j;
                cout << '\n';
            }
            return;
        }
        vector<int> cnt_str(n, 0), cnt_stl(m, 0);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (field[i][j] == 'a') {
                    cnt_str[i]++;
                    cnt_stl[j]++;
                }
            }
        }
        int my = 0;
        bool f1 = cnt_str.front() > cnt_str.back(), f2 = cnt_stl.front() > cnt_stl.back();
        if (f1 && f2) {
            my = 1;
        } else if (f1 && !f2) {
            my = 0;
        } else if (!f1 && f2) {
            my = 3;
        } else {
            my = 2;
        }
        vector<int> prv{2, 0, 3, 1};
        vector<int> nxt{3, 1, 2, 0};
        int lst = type[pos];
        for (int i = pos + 1; i < ln; i++) {
            if (type[i] == lst) continue;
            else if (type[i] == prv[lst]) my = (my + 3) % 4;
            else if (type[i] == nxt[lst]) my = (my + 1) % 4;
            else my = (my + 2) % 4;
        }
        int s1, s2, p1, p2;
        if (my == 0) {
            s1 = 0, p1 = 1, s2 = m - 1, p2 = -1;
        } else if (my == 1) {
            s1 = 0, p1 = 1, s2 = 0, p2 = 1;
        } else if (my == 2) {
            s1 = n - 1, p2 = -1, s2 = 0, p2 = 1;
        } else {
            s1 = n - 1, p2 = -1, s2 = m - 1, p2 = -1;
        }
        vector<int> can1(cnt_str),can2(cnt_stl);
        if (my > 1) std::reverse(can1.begin(), can1.end());
        if (my == 0 || my == 3) std::reverse(can2.begin(), can2.end());
        for (int i = s1; i > -1 && i < n; i += p1) {
            for (int j = s2; j > -1 && j < m; j += p2) {
                if (can1[i] > 0 && can2[j] > 0) cout << 'a';
                else cout << '.';
                can1[i]--, can2[j]--;
            }
            cout << '\n';
        }
    }

    for (int i = pos; i < ln; i++) compress(type[i], field);

    for (auto &i: field) {
        for (auto j: i) cout << j;
        cout << '\n';
    }
}

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int t;
    cin >> t;
    while (t--) {
        solve();
//        cout << '\n';
    }
}