#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

void compress(int type, vector<vector<char>> &field) {
    int n = (int) field.size();
    int m = (int) field[0].size();
    if (type == 0) {
        vector<int> lst(n, 0);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[ii][lst[ii]++] = field[ii][jj];
                }
            }
        }
        for (int ii = 0; ii < n; ii++) {
            for (int jj = lst[ii]; jj < m; jj++) {
                field[ii][jj] = '.';
            }
        }
    } else if (type == 1) {
        vector<int> lst(n, m - 1);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = m - 1; jj > -1; jj--) {
                if (field[ii][jj] != '.') {
                    field[ii][lst[ii]--] = field[ii][jj];
                }
            }
        }
        for (int ii = 0; ii < n; ii++) {
            for (int jj = lst[ii]; jj > -1; jj--) {
                field[ii][jj] = '.';
            }
        }
    } else if (type == 2) {
        vector<int> lst(m, 0);
        for (int ii = 0; ii < n; ii++) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[lst[jj]++][jj] = field[ii][jj];
                }
            }
        }
        for (int j = 0; j < m; j++) {
            while (lst[j] < n) {
                field[lst[j]++][j] = '.';
            }
        }
    } else {
        vector<int> lst(m, n - 1);
        for (int ii = n - 1; ii > -1; ii--) {
            for (int jj = 0; jj < m; jj++) {
                if (field[ii][jj] != '.') {
                    field[lst[jj]--][jj] = field[ii][jj];
                }
            }
        }
        for (int j = 0; j < m; j++) {
            while (lst[j] > -1) {
                field[lst[j]--][j] = '.';
            }
        }
    }
}

void find_seg(multiset<pair<int, int>> &points, set<pair<int, int>> &segm) {
    int cnt = 0;
    int last = -1;
    for (auto [x, type] : points) {
        cnt -= type;
        if (cnt == 0) segm.insert({last, x});
        else if (type == -1 && cnt == 1) last = x;
    }
}

void solve() {
    int n;
    cin >> n;
    gp_hash_table<int, vector<pair<int, int>>> ins, del;
    set<int> used;
    for (int i = 0; i < n; i++) {
        int xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        used.insert(yl);
        used.insert(yr + 1);
        ins[yl].emplace_back(xl - 1, xr);
        del[yr + 1].emplace_back(xl - 1, xr);
    }
    multiset<pair<int, int>> st;
    set<pair<int, int>> stck;
    map<pair<int, int>, int> Cnt, Max, Last;
    for (int y : used) {
//        cout << y << endl;
        for (auto [l, r] : del[y]) {
            st.erase(st.find({l, -1}));
            st.erase(st.find({r, 1}));
        }
//        cout << y << endl;
        set<pair<int, int>> cur1;
        find_seg(st, cur1);
        vector<pair<int, int>> bad;
        for (auto i : stck) {
            if (cur1.find(i) != cur1.end()) {
                continue;
            } else {
                bad.push_back(i);
                Cnt[i] += y - Last[i];
                Max[i] = max(Max[i], y - Last[i]);
            }
        }
        for (auto i : bad) stck.erase(i);
        for (auto [l, r] : ins[y]) {
            st.insert({l, -1});
            st.insert({r, 1});
        }
        set<pair<int, int>> cur2;
        find_seg(st, cur2);
        for (auto i : stck) {
            if (cur2.find(i) != cur2.end()) {
                continue;
            } else {
                bad.push_back(i);
                Cnt[i] += y - Last[i];
                Max[i] = max(Max[i], y - Last[i]);
            }
        }
        for (auto i : bad) stck.erase(i);
        for (auto [l, r] : cur2) {
            if (stck.find({l, r}) != stck.end()) continue;
            stck.insert({l, r});
            Last[{l, r}] = y;
        }
    }
    cout << Max.size() << '\n';
    for (auto [i, j] : Max) {
        int cnt = Cnt[i];
        cout << i.first + 1 << " " << i.second << " " << cnt << " " << j << '\n';
    }
}

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
//        cout << '\n';
    }
}
