#include <iostream>
#include <string>
#include <vector>

using namespace std;

void print(vector<string>& f) {
    for (string e : f) {
        cout << e << endl;
    }
    cout << endl;
}

void left(vector<string>& f) {
    for (int i = 0; i < f.size(); ++i) {
        bool flag = false;
        int b = 0;
        for (int a = 0; a < f[i].size(); ++a) {
            if (flag) {
                break;
            }
            if (f[i][a] == '.') {
                while (b <= a || f[i][b] == '.') {
                    if (b == f[i].size() - 1) {
                        flag = true;
                        break;
                    }
                    b++;
                }
                swap(f[i][a], f[i][b]);
            }
        }
    }
}

void right(vector<string>& f) {
    for (int i = 0; i < f.size(); ++i) {
        bool flag = false;
        int b = f[i].size() - 1;
        for (int a = f[i].size() - 1; a >= 0; --a) {
            if (flag) {
                break;
            }
            if (f[i][a] == '.') {
                while (b >= a || f[i][b] == '.') {
                    if (b == 0) {
                        flag = true;
                        break;
                    }
                    b--;
                }
                swap(f[i][a], f[i][b]);
            }
        }
    }
}

void up(vector<string>& f) {
    for (int i = 0; i < f[0].size(); ++i) {
        bool flag = false;
        int b = 0;
        for (int a = 0; a < f.size(); ++a) {
            if (flag) {
                break;
            }
            if (f[a][i] == '.') {
                while (b <= a || f[b][i] == '.') {
                    if (b == f.size() - 1) {
                        flag = true;
                        break;
                    }
                    b++;
                }
                swap(f[a][i], f[b][i]);
            }
        }
    }
}

void down(vector<string>& f) {
    for (int i = 0; i < f[0].size(); ++i) {
        bool flag = false;
        int b = f.size() - 1;
        for (int a = f.size() - 1; a >= 0; --a) {
            if (flag) {
                break;
            }
            if (f[a][i] == '.') {
                while (b >= a || f[b][i] == '.') {
                    if (b == 0) {
                        flag = true;
                        break;
                    }
                    b--;
                }
                swap(f[a][i], f[b][i]);
            }
        }
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    vector<string> y = {"..aaaa", "......", "aa..a.", ".....a", "aaaaaa"};

    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int m, n;
        cin >> m >> n;
        vector<string> f;
        for (int i = 0; i < m; ++i) {
            string s;
            cin >> s;
            f.push_back(s);
        }
        vector<int> rows(m, 0);
        vector<int> cols(n, 0);

        string q;
        cin >> q;

        bool r = false;
        bool l = false;
        bool u = false;
        bool d = false;
        for (int i = 0; i < q.size(); ++i) {
            if (q[i] == 'L') {
                left(f);
            } else if (q[i] == 'R') {
                right(f);
            } else if (q[i] == 'U') {
                up(f);
            } else {
                down(f);
            }
        }
        print(f);
    }
}
