#include <iostream>
#include <string>
#include <vector>

using namespace std;

void print(vector<string>& f) {
    for (string e : f) {
        cout << e << endl;
    }
    cout << endl;
}

void left(vector<string>& f) {
    for (int i = 0; i < f.size(); ++i) {
        bool flag = false;
        int b = 0;
        for (int a = 0; a < f[i].size(); ++a) {
            if (flag) {
                break;
            }
            if (f[i][a] == '.') {
                while (b <= a || f[i][b] == '.') {
                    if (b == f[i].size() - 1) {
                        flag = true;
                        break;
                    }
                    b++;
                }
                swap(f[i][a], f[i][b]);
            }
        }
    }
}

void right(vector<string>& f) {
    for (int i = 0; i < f.size(); ++i) {
        bool flag = false;
        int b = f[i].size() - 1;
        for (int a = f[i].size() - 1; a >= 0; --a) {
            if (flag) {
                break;
            }
            if (f[i][a] == '.') {
                while (b >= a || f[i][b] == '.') {
                    if (b == 0) {
                        flag = true;
                        break;
                    }
                    b--;
                }
                swap(f[i][a], f[i][b]);
            }
        }
    }
}

void up(vector<string>& f) {
    for (int i = 0; i < f[0].size(); ++i) {
        bool flag = false;
        int b = 0;
        for (int a = 0; a < f.size(); ++a) {
            if (flag) {
                break;
            }
            if (f[a][i] == '.') {
                while (b <= a || f[b][i] == '.') {
                    if (b == f.size() - 1) {
                        flag = true;
                        break;
                    }
                    b++;
                }
                swap(f[a][i], f[b][i]);
            }
        }
    }
}

void down(vector<string>& f) {
    for (int i = 0; i < f[0].size(); ++i) {
        bool flag = false;
        int b = f.size() - 1;
        for (int a = f.size() - 1; a >= 0; --a) {
            if (flag) {
                break;
            }
            if (f[a][i] == '.') {
                while (b >= a || f[b][i] == '.') {
                    if (b == 0) {
                        flag = true;
                        break;
                    }
                    b--;
                }
                swap(f[a][i], f[b][i]);
            }
        }
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    vector<string> y = {"..aaaa", "......", "aa..a.", ".....a", "aaaaaa"};

    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int m, n;
        cin >> m >> n;
        vector<string> f;
        for (int i = 0; i < m; ++i) {
            string s;
            cin >> s;
            f.push_back(s);
        }
        vector<int> rows(m, 0);
        vector<int> cols(n, 0);

        string tq;
        cin >> tq;

        string q;
        q.push_back(tq[0]);
        for (int i = 1; i < tq.size(); ++i) {
            if (tq[i] != tq[i - 1]) {
                q.push_back(tq[i]);
            }
        }

        bool r = false;
        bool l = false;
        bool u = false;
        bool d = false;

        bool c_d = false;
        bool c_u = false;
        for (char e : q) {
            if (e == 'D') {
                c_d = true;
            } else if (e == 'U') {
                c_u = true;
            }
        }

        if (!c_d && c_u) {
            string q2;
            for (int i = 0; i < q.size() - 1; ++i) {
                if (q[i] == 'L' && !l) {
                    q2.push_back('L');
                    l = true;
                } else if (q[i] == 'R' && !r) {
                    q2.push_back('R');
                    r = true;
                } else if (q[i] == 'U' && !u) {
                    q2.push_back('U');
                    if (r || l) {
                        u = true;
                    }
                    l = false;
                    r = false;
                }
            }
            q2.push_back(q.back());

            for (int i = 0; i < q2.size(); ++i) {
                if (q2[i] == 'L') {
                    left(f);
                } else if (q2[i] == 'R') {
                    right(f);
                } else if (q2[i] == 'U') {
                    up(f);
                } else {
                    down(f);
                }
            }
        }
        else {
            for (int i = 0; i < q.size(); ++i) {
                if (!c_d && !c_u) {
                    if (i > 0 && i < q.size() - 1 &&
                        (l && q[i] == 'L' || r && q[i] == 'R' || d && q[i] == 'D' || u && q[i] == 'U' ||
                         q[i - 1] == 'L' && q[i] == 'R' && q[i + 1] == 'L' ||
                         q[i - 1] == 'R' && q[i] == 'L' && q[i + 1] == 'R' ||
                         q[i - 1] == 'D' && q[i] == 'U' && q[i + 1] == 'D' ||
                         q[i - 1] == 'U' && q[i] == 'D' && q[i + 1] == 'U')) {
                        continue;
                    }
                }
                if (q[i] == 'L') {
                    left(f);
                    l = true;
                } else if (q[i] == 'R') {
                    right(f);
                    r = true;
                } else if (q[i] == 'U') {
                    up(f);
                    u = true;
                } else {
                    down(f);
                    d = true;
                }
            }
        }
        print(f);
    }
}
