#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>

using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll
using namespace std;

mt19937 rnd(0);
#pragma GCC optimize("Ofast")

int n, m;

void sh_r(vector<vector<bool>>& v) {
	for (int i = 0; i < n; i++) {
		int nx = m - 1;
		for (int j = m - 2; j >= 0; j--) {
			if (v[i][j] != '.') {
				while (nx > j && v[i][nx] != 0) {
					nx--;
				}
				swap(v[i][j], v[i][nx]);
			}
		}
	}
}

void sh_l(vector<vector<bool>>& v) {
	for (int i = 0; i < n; i++) {
		int nx = 0;
		for (int j = 1; j < m; j++) {
			if (v[i][j] != '.') {
				while (nx < j && v[i][nx] != 0) {
					nx++;
				}
				swap(v[i][j], v[i][nx]);
			}
		}
	}
}

void sh_u(vector<vector<bool>>& v) {
	for (int j = 0; j < m; j++) {
		int nx = 0;
		for (int i = 1; i < n; i++) {
			if (v[i][j] != '.') {
				while (nx < i && v[nx][j] != 0) {
					nx++;
				}
				swap(v[i][j], v[nx][j]);
			}
		}
	}
}

void sh_d(vector<vector<bool>>& v) {
	for (int j = 0; j < m; j++) {
		int nx = n - 1;
		for (int i = n - 2; i >= 0; i--) {
			if (v[i][j] != '.') {
				while (nx > i && v[nx][j] != 0) {
					nx--;
				}
				swap(v[i][j], v[nx][j]);
			}
		}
	}
}

void sh_r(vector<vector<int>>& v) {
	for (int i = 0; i < n; i++) {
		int nx = m - 1;
		for (int j = m - 2; j >= 0; j--) {
			if (v[i][j] != '.') {
				while (nx > j && v[i][nx] != 0) {
					nx--;
				}
				swap(v[i][j], v[i][nx]);
			}
		}
	}
}

void sh_l(vector<vector<int>>& v) {
	for (int i = 0; i < n; i++) {
		int nx = 0;
		for (int j = 1; j < m; j++) {
			if (v[i][j] != '.') {
				while (nx < j && v[i][nx] != 0) {
					nx++;
				}
				swap(v[i][j], v[i][nx]);
			}
		}
	}
}

void sh_u(vector<vector<int>>& v) {
	for (int j = 0; j < m; j++) {
		int nx = 0;
		for (int i = 1; i < n; i++) {
			if (v[i][j] != '.') {
				while (nx < i && v[nx][j] != 0) {
					nx++;
				}
				swap(v[i][j], v[nx][j]);
			}
		}
	}
}

void sh_d(vector<vector<int>>& v) {
	for (int j = 0; j < m; j++) {
		int nx = n - 1;
		for (int i = n - 2; i >= 0; i--) {
			if (v[i][j] != '.') {
				while (nx > i && v[nx][j] != 0) {
					nx--;
				}
				swap(v[i][j], v[nx][j]);
			}
		}
	}
}


void solve() {
	cin >> n >> m;
	vector<vector<bool>> vf(n, vector<bool>(m));
	vector<vector<char>> vi(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> vi[i][j];
			vf[i][j] = vi[i][j] != '.';
		}
	}
	vector<vector<vector<bool>>> v0{ vf };
	map<pair<int, char>, int> to;

	string s;
	cin >> s;
	int pos = 0;
	for (auto c : s) {
		if (to.find({ pos, c }) != to.end()) {
			pos = to[{pos, c}];
			continue;
		}
		vf = v0[pos];
		if (c == 'R') {
			sh_r(vf);
		}
		if (c == 'L') {
			sh_l(vf);
		}
		if (c == 'U') {
			sh_u(vf);
		}
		if (c == 'D') {
			sh_d(vf);
		}
		bool f = 0;
		for (int i = 0; i < v0.size(); i++) {
			if (v0[i] == vf) {
				to[{pos, c}] = i;
				pos = i;
				f = 1;
				break;
			}
		}
		if (!f) {
			to[{pos, c}] = v0.size();
			pos = v0.size();
			v0.push_back(vf);
		}
	}
	map<tuple<int, int, int, char>, tuple<int, int, int>> g;
	for (int pos = 0; pos < v0.size(); pos++) {
		vf = v0[pos];
		vector<vector<int>> vn(n, vector<int>(m));
		int it = 1;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (vf[i][j]) {
					vn[i][j] = it;
					it++;
				}
			}
		}
		for (auto c : "LRUD") {
			if (to.find({ pos, c }) == to.end()) continue;
			auto v1 = vn;
			if (c == 'R') {
				sh_r(v1);
			}
			if (c == 'L') {
				sh_l(v1);
			}
			if (c == 'U') {
				sh_u(v1);
			}
			if (c == 'D') {
				sh_d(v1);
			}
			vector<pair<int, int>> ps(it);
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (v1[i][j]) {
						ps[v1[i][j]] = { i, j };
					}
				}
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (vf[i][j]) {
						g[{pos, i, j, c}] = { to[{pos, c}], ps[vn[i][j]].first, ps[vn[i][j]].second };
					}
				}
			}
		}
	}
	vector<vector<char>> res(n, vector<char>(m, '.'));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (vi[i][j] == '.') continue;
			int pos = 0;
			int i1 = i;
			int j1 = j;
			for (auto c : s) {
				auto [pos1, i2, j2] = g[{pos, i1, j1, c}];
				pos = pos1;
				i1 = i2;
				j1 = j2;
			}
			res[i1][j1] = vi[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << res[i][j];
		}
		cout << '\n';
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}