#define _GLIBCXX_DEBUG
#pragma GCC Optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define endl "\n"
#define pb push_back
#define all(x) x.begin(), x.end()
#define in cin
#define out cout
#define f first
#define s second
#define printv(v) cout << #v << " "; for (auto &x : v) { cout << x << " "; } cout << endl;

int n, m;

bool check(char x) {
	return x == 'L' || x == 'R';
}

vector<vector<char>> get_board(vector<vector<char>> board, char x) {
	vector<vector<char>> fst;
	if (check(x)) {
		fst.resize(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (board[i][j] != '.') {
					fst[i].pb(board[i][j]);
				}
			}
		}
		if (x == 'R') {
			for (auto &x : fst) {
				reverse(all(x));
			}
		}
	} else {
		fst.resize(m);
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j) {
				if (board[j][i] != '.') {
					fst[i].pb(board[j][i]);
				}
			}
		}
		if (x == 'D') {
			for (auto &x : fst) {
				reverse(all(x));
			}
		}
	}
	vector<vector<char>> ans(n, vector<char>(m, '.'));
	if (check(x)) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < fst[i].size(); ++j) {
				if (x == 'L') {
					ans[i][j] = fst[i][j];
				} else {
					ans[i][m-j-1] = fst[i][j];
				}
			}
		}
	} else {
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < fst[i].size(); ++j) {
				if (x == 'U') {
					ans[j][i] = fst[i][j];
				} else {
					ans[n-j-1][i] = fst[i][j];
				}
			}
		}
	}
	return ans;
}

vector<vector<pair<int, int>>> graph1, graph2;



signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	// ifstream in("in.txt");
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		vector<vector<char>> board(n, vector<char>(m));
		for (auto &x : board) {
			for (auto &y : x) {
				cin >> y;
			}
		}
		string s;
		cin >> s;
		board = get_board(board, s.back());
		for (auto &x : board) {
			for (auto &y : x) {
				cout << y;
			}
			cout << endl;
		}
		return 0;
		char last_hor, last_ver;
		int now = 0;
		while (now < s.length() - 1 && (check(s[now]) == check(s[now + 1]))) {
			++now;
		}
		if (check(s[now])) {
			last_hor = s[now];
		} else {
			last_ver = s[now];
		}
		board = get_board(board, s[now]);
		if (now == s.length() - 1) {
			for (auto &x : board) {
				for (auto &y : x) {
					cout << y;
				}
				cout << endl;
			}
			return 0;	
		}
		++now;
		while (now < s.length() - 1 && (check(s[now]) == check(s[now + 1]))) {
			++now;
		}
		board = get_board(board, s[now]);
		if (now == s.length() - 1) {
			for (auto &x : board) {
				for (auto &y : x) {
					cout << y;
				}
				cout << endl;
			}
			return 0;	
		}
		if (check(s[now])) {
			last_hor = s[now];
		} else {
			last_ver = s[now];
		}
		++now;
		string norm;
		while (true) {
			while (now < s.length() - 1 && (check(s[now]) == check(s[now + 1]))) {
				++now;
			}
			norm += s[now];
			if (now == s.length() - 1) {
				break;	
			}
			++now;
		}
		int cnt = 0;
		vector<int> poses1(n), poses2(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (board[i][j] != '.') {
					++poses1[i];
				}
			}
		}
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j) {
				if (board[j][i] != '.') {
					++poses2[i];
				}
			}
		}
		
		graph1.assign(n, vector<pair<int, int>>(m));
		graph2 = graph1;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				graph1[i][j] = {i, poses1[i] - j - 1};
				graph2[i][j] = {poses2[j] - i - 1, j};
			}
		}
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << graph1[i][j].f << " " << graph1[i][j].s << " : ";
			}
			cout << endl;
		}
		string last;
		for (int x = 0; x < norm.length(); ++x) {
			if (check(norm[x])) {
				if (last_hor != norm[x]) {
					last_hor = norm[x];
					last += norm[x];
				}
			} else {
				if (last_ver != norm[x]) {
					last_ver = norm[x];
					last += norm[x];
				}
			}
		}
		vector<vector<char>> ans(n, vector<char>(m, '.'));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (board[i][j] == '.') {
					continue;
				}
				pair<int, int> end = {i, j};
				for (int x = 0; x < last.length(); ++x) {
					if (check(last[x])) {
						end = graph1[end.f][end.s];
					} else {
						end = graph2[end.f][end.s];
					}
				}
				ans[end.f][end.s] = board[i][j];
			}
		}

		// board = get_board(board, last_hor);
		// board = get_board(board, last_ver);
		for (auto &x : ans) {
			for (auto &y : x) {
				cout << y;
			}
			cout << endl;
		}
	}
	return 0;
}