#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()

using namespace std;

void move_lt(vector <string>& mas)
{
	int n = mas.size(), m = mas.front().size();
	for (int i = 0; i < n; i++)
	{
		int last = 0;
		for (int j = 0; j < m; j++)
		{
			if (mas[i][j] != '.')
			{
				swap(mas[i][j], mas[i][last]);
				++last;
			}
		}
	}
}
void move_rt(vector <string>& mas)
{
	int n = mas.size(), m = mas.front().size();
	for (int i = 0; i < n; i++)
	{
		int last = m - 1;
		for (int j = m - 1; j >= 0; j--)
		{
			if (mas[i][j] != '.')
			{
				swap(mas[i][j], mas[i][last]);
				--last;
			}
		}
	}
}
void move_up(vector <string>& mas)
{
	int n = mas.size(), m = mas.front().size();
	for (int j = 0; j < m; j++)
	{
		int last = 0;
		for (int i = 0; i < n; i++)
		{
			if (mas[i][j] != '.')
			{
				swap(mas[i][j], mas[last][j]);
				++last;
			}
		}
	}
}
void move_dw(vector <string>& mas)
{
	int n = mas.size(), m = mas.front().size();
	for (int j = 0; j < m; j++)
	{
		int last = n - 1;
		for (int i = n - 1; i >= 0; i--)
		{
			if (mas[i][j] != '.')
			{
				swap(mas[i][j], mas[last][j]);
				--last;
			}
		}
	}
}

constexpr uint32_t MX_LEN_CYC = 12;
void solve()
{
	int n, m;
	cin >> n >> m;
	vector <string> mas(n);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
	}
	string s;
	cin >> s;

	bool is_rt, is_dw;
	int pos;
	if (s.front() == 'L' or s.front() == 'R')
	{
		for (pos = 0; pos < s.size(); pos++)
		{
			if (s[pos] == 'U' or s[pos] == 'D')
			{
				break;
			}
			else
			{
				if (s[pos] == 'L')
				{
					is_rt = false;
				}
				else
				{
					is_rt = true;
				}
			}
		}

		if (is_rt)
		{
			move_rt(mas);
		}
		else
		{
			move_lt(mas);
		}

		if (pos != s.size())
		{
			if (s[pos] == 'U')
			{
				is_dw = false;
				move_up(mas);
			}
			else
			{
				is_dw = true;
				move_dw(mas);
			}
		}
	}
	else
	{
		for (pos = 0; pos < s.size(); pos++)
		{
			if (s[pos] == 'L' or s[pos] == 'R')
			{
				break;
			}
			else
			{
				if (s[pos] == 'U')
				{
					is_dw = false;
				}
				else
				{
					is_dw = true;
				}
			}
		}

		if (is_dw)
		{
			move_dw(mas);
		}
		else
		{
			move_up(mas);
		}

		if (pos != s.size())
		{
			if (s[pos] == 'L')
			{
				is_rt = false;
				move_lt(mas);
			}
			else
			{
				is_rt = true;
				move_rt(mas);
			}
		}
	}

	vector <char> cyc;
	cyc.reserve(s.size());
	for (int i = pos + 1; i < s.size(); i++)
	{
		switch (s[i])
		{
		case 'L':
			if (is_rt)
			{
				is_rt = false;
				if (!cyc.empty() and cyc.back() == 'R')
				{
					cyc.pop_back();
				}
				else
				{
					cyc.push_back('L');
				}
			}
			break;
		case 'R':
			if (!is_rt)
			{
				is_rt = true;
				if (!cyc.empty() and cyc.back() == 'L')
				{
					cyc.pop_back();
				}
				else
				{
					cyc.push_back('R');
				}
			}
			break;
		case 'U':
			if (is_dw)
			{
				is_dw = false;
				if (!cyc.empty() and cyc.back() == 'D')
				{
					cyc.pop_back();
				}
				else
				{
					cyc.push_back('U');
				}
			}
			break;
		case 'D':
			if (!is_dw)
			{
				is_dw = true;
				if (!cyc.empty() and cyc.back() == 'U')
				{
					cyc.pop_back();
				}
				else
				{
					cyc.push_back('D');
				}
			}
			break;
		}
	}

	for (int i = 0; i < cyc.size() % MX_LEN_CYC; i++)
	{
		switch (cyc[i])
		{
		case 'L':
			move_lt(mas);
			break;
		case 'R':
			move_rt(mas);
			break;
		case 'U':
			move_up(mas);
			break;
		case 'D':
			move_dw(mas);
			break;
		}
	}

	for (int i = 0; i < n; i++)
	{
		cout << mas[i] << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}