#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()

using namespace std;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Ev
{
	int x1, x2, y, dop;
	Ev(int x1 = 0, int x2 = 0, int y = 0, int dop = 0) :x1(x1), x2(x2), y(y), dop(dop) {}
	bool operator< (const Ev& e) const
	{
		return y < e.y;
	}
};
struct Nab
{
	int x1, x2, y;
	Nab(int x1 = 0, int x2 = 0, int y = 0) :x1(x1), x2(x2), y(y) {}
	bool operator<(const Nab& n) const
	{
		return make_pair(make_pair(x1, x2), y) < make_pair(make_pair(n.x1, n.x2), n.y);
	}
};

void solve()
{
	int n;
	cin >> n;
	vector <int> coor_x, coor_y;
	vector <Ev> ev;
	for (int i = 0; i < n; i++)
	{
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		++x2;
		++y2;
		coor_x.push_back(x1);
		coor_x.push_back(x2);
		coor_y.push_back(y1);
		coor_y.push_back(y2);
		ev.push_back(Ev(x1, x2, y1, 1));
		ev.push_back(Ev(x1, x2, y2, -1));
	}
	sort(ALL(coor_x));
	coor_x.resize(unique(ALL(coor_x)) - coor_x.begin());
	sort(ALL(coor_y));
	coor_y.resize(unique(ALL(coor_y)) - coor_y.begin());
	sort(ALL(ev));

	vector <int> cnt(coor_x.size());
	vector <Nab> ans;
	for (int i = 0; i < ev.size(); i++)
	{
		if (i > 0 and ev[i].y > ev[i - 1].y)
		{
			bool is_otr = false;
			int beg = -1;
			for (int j = 0; j < coor_x.size(); j++)
			{
				if (is_otr)
				{
					if (cnt[j] == 0)
					{
						ans.push_back(Nab(coor_x[beg], coor_x[j], lower_bound(ALL(coor_y), ev[i - 1].y) - coor_y.begin()));
						is_otr = false;
					}
				}
				else
				{
					if (cnt[j] != 0)
					{
						is_otr = true;
						beg = j;
					}
				}
			}
		}

		int l = lower_bound(ALL(coor_x), ev[i].x1) - coor_x.begin(), r = lower_bound(ALL(coor_x), ev[i].x2) - coor_x.begin();
		for (int j = l; j < r; j++)
		{
			cnt[j] += ev[i].dop;
		}
	}

	sort(ALL(ans));
	int t_cnt = 0, mx_len = 0, last_otr = 0;
	vector <pair <pair <int, int>, pair <int, int>>> fin_ans;
	for (int i = 0; i < ans.size(); i++)
	{
		if (i > 0 and make_pair(ans[i - 1].x1, ans[i - 1].x2) != make_pair(ans[i].x1, ans[i].x2))
		{
			rmax(mx_len, last_otr);
			fin_ans.push_back({ {ans[i - 1].x1, ans[i - 1].x2 - 1}, {t_cnt, mx_len} });
			t_cnt = coor_y[ans[i].y + 1] - coor_y[ans[i].y];
			mx_len = 0;
			last_otr = coor_y[ans[i].y + 1] - coor_y[ans[i].y];
		}
		else
		{
			t_cnt += coor_y[ans[i].y + 1] - coor_y[ans[i].y];
			if (i > 0 and ans[i - 1].y + 1 == ans[i].y)
			{
				last_otr += coor_y[ans[i].y + 1] - coor_y[ans[i].y];
			}
			else
			{
				rmax(mx_len, last_otr);
				last_otr = coor_y[ans[i].y + 1] - coor_y[ans[i].y];
			}
		}
	}
	rmax(mx_len, last_otr);
	fin_ans.push_back({ {ans.back().x1, ans.back().x2 - 1}, {t_cnt, mx_len} });
	cout << fin_ans.size() << endl;
	for (int i = 0; i < fin_ans.size(); i++)
	{
		cout << fin_ans[i].first.first << ' ' << fin_ans[i].first.second << ' ' << fin_ans[i].second.first << ' ' << fin_ans[i].second.second << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}