#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}

#define int long long
#define endl "\n"

constexpr long long N = 3e4 + 52;

void solve() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pair<int, int>> ev(n + m);
    for (int i = 0; i < n + m; i++) {
        cin >> ev[i].first >> ev[i].second;
    }

    vector<int> hs(n + m, 0);
    int cur = 0;
    vector<int> al;
    for (int i = 0; i < n + m; i++) {
        if (ev[i].first == 1) {
            cur += ev[i].second;
        }
        hs[i] = cur;
        if (ev[i].first == 2) {
            al.push_back(ev[i].second + hs[i] - 1);
        }
    }

    sort(al.begin(), al.end());

    // cout << al << endl;

    int ans = 0;

    for (int i = 0; i < al.size(); i++) {
        ans = max(ans, p * (i + 1) - al[i] * c);
    }

    cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}