#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}

#define int long long
#define endl "\n"

constexpr long long N = 3e4 + 52;

int n, m;

vector<string> l(vector<string>& a) {
    vector<string> b(a.size());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') b[i] += a[i][j];
        }

        b[i].resize(m, '.');
    }

    return b;
}

vector<string> r(vector<string>& a) {
    vector<string> b(a.size());
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] != '.') b[i] = a[i][j] + b[i];
        }

        while (b[i].size() < m) b[i] = '.' + b[i];
    }

    return b;
}

vector<string> u(vector<string>& a) {
    vector<string> b(n, string (m, '.'));
    for (int j = 0; j < m; j++) {
        int cur = 0;

        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.') {
                b[cur++][j] = a[i][j];
            }
        }
    }

    return b;
}

vector<string> d(vector<string>& a) {
    vector<string> b(n, string (m, '.'));
    for (int j = 0; j < m; j++) {
        int cur = n - 1;

        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] != '.') {
                b[cur--][j] = a[i][j];
            }
        }
    }

    return b;
}

void solve() {
    cin >> n >> m;
    vector<string> a(n);
    cin >> a;
    string b; cin >> b;
    int k = b.size();

    // for (auto el : a) cout << el << endl;
    // cout << endl;

    int ok = 0;
    for (int i = 0; i < k - 20; i++) {
        // if (b[i] == 'L') a = l(a);
        // if (b[i] == 'R') a = r(a);
        if (b[i] == 'U') a = u(a);
        if (b[i] == 'D') a = d(a);

        // for (auto el : a) cout << el << endl;
        // cout << endl;

        // if (i % 4 == 3) {
        //     for (auto el : a) cout << el << endl;
        //     cout << endl;
        // }
    }

    for (int i = max(0LL, k - 20); i < k; i++) {
        if (b[i] == 'L') a = l(a);
        if (b[i] == 'R') a = r(a);
        if (b[i] == 'U') a = u(a);
        if (b[i] == 'D') a = d(a);
    }

    for (auto el : a) cout << el << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;

    while (tests --> 0) solve();
}