#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <stack>
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}

#define int long long
#define endl "\n"

constexpr long long N = 3e4 + 52;
constexpr long long inf = 3e18 + 52;

struct qu {
    stack<pair<int, int>> l, r;

    int get() {
        int ans = inf;
        if (l.size()) ans = min(ans, l.top().second);
        if (r.size()) ans = min(ans, r.top().second);

        return ans;
    }

    void push(int v) {
        int mx = v;
        if (r.size()) mx = max(mx, r.top().second);

        r.push({v, mx});
    }

    void pop() {
        if (l.size()) l.pop();
        else {
            while (r.size()) {
                int v = r.top().first;
                r.pop();

                int mx = v;
                if (l.size()) mx = max(mx, l.top().second);

                l.push({v, mx});
            }
        }
    }

    int size() {
        return l.size() + r.size();
    }
};

void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c; cin >> c;
    vector<int> a(n + 1);
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
    }

    for (auto& el : a) el--;

    vector<int> dp(n + 1, 0);

    qu q;
    dp[1] = 0;
    q.push(dp[1]);
    int ans = inf;
    for (int i = 2; i < n + 1; i++) {
        if (i + k - 1 >= n) ans = min(ans, n + q.get() + (n - i));
        dp[i] = q.get() + (n - i) * 2;
        q.push(dp[i]);

        while (q.size() > m) q.pop();
    }

    // cout << dp << endl;

    cout << ans - 1 << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}