#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <stack>
#include <map>
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}

#define int long long
#define endl "\n"

constexpr long long N = 3e4 + 52;
constexpr long long inf = 3e18 + 52;

struct qu {
    stack<pair<int, int>> l, r;

    int get() {
        int ans = inf;
        if (l.size()) ans = min(ans, l.top().second);
        if (r.size()) ans = min(ans, r.top().second);

        return ans;
    }

    void push(int v) {
        int mx = v;
        if (r.size()) mx = min(mx, r.top().second);

        r.push({v, mx});
    }

    void pop() {
        if (l.size()) l.pop();
        else {
            while (r.size()) {
                int v = r.top().first;
                r.pop();

                int mx = v;
                if (l.size()) mx = min(mx, l.top().second);

                l.push({v, mx});
            }
        }
    }

    int size() {
        return l.size() + r.size();
    }
};

void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c; cin >> c;

    auto pth = [&](int l, int r) -> int {
        if (l == 1) return 0;
        if (c == 1) {
            return 2 * (n + 1 - l);
        }
        if (c == 2) {
            return 2 * (l);
        }
        if (c == 3) {
            return min(2 * (l), 2 * (n + 1 - l));
        }
    };

    vector<int> a(n + 1);
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
    }

    auto b = a;
    sort(b.begin(), b.end());
    b.erase(unique(b.begin(), b.end()), b.end());

    for (auto& el : a) el = lower_bound(b.begin(), b.end(), el) - b.begin();
    
    int cur = 0;

    vector<vector<int>> cs(n + 1, vector<int> (n + 1, 0));
    vector<int> dp(n + 1, 0);

    for (int i = 1; i < n + 1; i++) {
        cur = 0;
        vector<int> cnt(n + 1, 0);
        for (int j = i; j < n + 1; j++) {
            cur -= (cnt[a[j]] + p - 1) / p;
            cnt[a[j]]++;
            cur += (cnt[a[j]] + p - 1) / p;

            if (cur > m) break;

            // cout << i << " " << j << " " << cur << " | " << cnt << endl;

            cs[i][j] = 1;
        }
    }

    for (int i = 1; i < n + 1; i++) {
        dp[i] = inf;
        for (int j = 1; j <= i; j++) {
            if (cs[j][i] == 1) {
                dp[i] = min(dp[i], dp[j - 1] + pth(j, i));
            }
        }
    }

    // cout << dp << endl;

    cout << dp[n] + n + 1 << endl;

    // cout << pth(2, 6) << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}