#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
using namespace std;
 
template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}
 
template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}
 
#define int long long
#define endl "\n"
 
constexpr long long N = 3e4 + 52;

struct rect {
    int x1, y1, x2, y2;
};

struct ev {
    int t, x;
};

void solve() {
    int n;
    cin >> n;
    vector<rect> a(n);
    // map<int, vector<rect>> op;
    // map<int, vector<rect>> cl;
    map<int, vector<pair<int, int>>> op;
    map<int, vector<pair<int, int>>> cl;
    vector<int> zp;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        op[a[i].y1].push_back({a[i].x1, a[i].x2});
        cl[a[i].y2].push_back({a[i].x1, a[i].x2});

        zp.push_back(a[i].y1);
        zp.push_back(a[i].y2);

        // op[a[i].y1].push_back(a[i]);
        // cl[a[i].y2].push_back(a[i]);
    }

    sort(zp.begin(), zp.end());
    zp.erase(unique(zp.begin(), zp.end()), zp.end());

    multiset<int> co, cc;
    set<pair<int, int>> ans;

    map<pair<int, int>, int> ans1;
    
    for (int i = 0; i < zp.size(); i++) {
        int el = zp[i];
        for (auto e : op[el]) {
            co.insert(e.first);
            cc.insert(e.second);
        }

        if (co.size()) {
            ans.insert({*co.begin(), *--cc.end()});
            ans1[{*co.begin(), *--cc.end()}] += zp[i + 1] - zp[i];
        }

        for (auto e : cl[el]) {
            co.erase(co.lower_bound(e.first));
            cc.erase(cc.lower_bound(e.second));
            // cc.insert(e.second);
        }
    }

    cout << ans.size() << endl;
    for (auto el : ans) cout << el.first << " " << el.second << " " << ans1[el] << " 1" << endl;

}
 
signed main() {
    int tests = 1;
 
#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;
 
    while (tests --> 0) solve();
}