#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <map>
using namespace std;
 
template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}
 
template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}
 
#define int long long
#define endl "\n"
 
constexpr long long N = 3e4 + 52;

struct rect {
    int x1, y1, x2, y2;
};

struct ev {
    int t, x;
};

void solve() {
    int n;
    cin >> n;
    vector<rect> a(n);
    int mx = 0, my = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        mx = max(mx, a[i].x2);
        my = max(my, a[i].y2);
    }

    mx += 10;
    my += 10;

    vector<vector<int>> fl(mx, vector<int> (my, 0));

    for (int i = 0; i < n; i++) {
        fl[a[i].y1][a[i].x1]++;
        fl[a[i].y1][a[i].x2 + 1]--;
        fl[a[i].y2 + 1][a[i].x1]--;
        fl[a[i].y2 + 1][a[i].x2 + 1]++;
    }

    for (int i = 0; i < mx; i++) {
        int cur = 0;
        for (int j = 0; j < my; j++) {
            cur += fl[j][i];

            fl[j][i] = cur;
        }
    }

    // for (int i = 0; i < my; i++) {
    //     cout << fl[i] << endl;
    // }

    for (int i = 0; i < my; i++) {
        int cur = 0;
        for (int j = 0; j < mx; j++) {
            cur += fl[i][j];
            fl[i][j] = cur;
        }
    }

    // for (int i = 0; i < my; i++) {
    //     cout << fl[i] << endl;
    // }

    map<pair<int, int>, int> ans1;

    for (int i = 0; i < my; i++) {
        int lst = 0;
        for (int j = 0; j < mx - 1; j++) {
            if (fl[i][j] == 0) lst = j + 1;
            else if (fl[i][j + 1] == 0) {
                ans1[{lst, j}]++;
            }
        }
    }

    cout << ans1.size() << endl;
    for (auto el : ans1) {
        cout << el.first.first << " " << el.first.second << " " << el.second << " " << 1 << endl;
    }
}
 
signed main() {
    int tests = 1;
 
#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;
 
    while (tests --> 0) solve();
}