#include <iostream>
#include <vector>
#include <algorithm>
#include <stdlib.h>
#include <unordered_map>
 
using namespace std;
typedef long long ll;
typedef vector<long long> vll;
 
 
class rect {
public:
	ll left, right, down, up;
	rect() {
		left = 0;
		right = 0;
		down = 0;
		up = 0;
	}
	rect(ll l, ll r, ll d, ll u) {
		left = l;
		right = r;
		down = d;
		up = u;
	}
};

struct event {
	ll type, x;
	event() {
		type = 0;
		x = -1;
	}
	event(ll t, ll col) {
		type = 1;
		x = col;
	}
};

bool cmp(event a, event b) {
	if (a.x != b.x) return a.x < b.x;
	return a.type < b.type;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
	ll t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		ll n;
		cin >> n;
		vector <rect> rects;
		ll max_w = 0, max_h = 0;
		for (int j = 0; j < n; ++j) {
			ll l, r, d, u;
			cin >> l >> d >> r >> u;
			rects.push_back(rect(l, r, d, u));
			max_h = max(max_h, u);
		}
		if (max_h == 1) {
			vector <event> events;
			for (auto rect: rects) {
				events.push_back(event(1, rect.left));
				events.push_back(event(2, rect.right));
			}
			ll cur_left = -1, cur_right = -1;
			sort(events.begin(), events.end(), cmp);
			vector <pair <ll, ll>> total;
			ll cur_rects = 0;
			for (int i = 0; i < events.size(); ++i) {
				event ev = events[i];
				if (cur_left == -1) { cur_left = ev.x; ++cur_rects; }
				else {
					if (!cur_rects && ev.x != events[i - 1].x) {
						total.push_back(pair <ll, ll>(cur_left, cur_right));
						cur_left = ev.x;
						cur_rects = 1;
					}
					else if (ev.type == 1) {
						cur_rects++;
						cur_right = ev.x;
					}
					else {
						cur_rects--;
						cur_right = ev.x;
					}
				}

			}
			total.push_back(pair <ll, ll>(cur_left, cur_right));
			for (auto p: total) {
				cout << p.first << " " << p.second << " " << 1 << " " << 1 << "\n";
			}
		}
		else if (n == 1) {
			rect rct = rects[0];
			ll total = rct.up - rct.down + 1;
			cout << total << "\n";
			cout << rct.left << " " << rct.right << " " << total << " " << total << "\n";
		}
	}
}