#include <iostream>
#include <vector>
using namespace std;


vector<string> move_left(int m, int n, vector<string>& a){
    vector<string> res(m, "");
    for (int i = 0; i < m; i ++){
        for (auto j: a[i]) if (j != '.') res[i].push_back(j);
        res[i] += string(n - res[i].size(), '.');
    }
    return res;
}

vector<string> move_right(int m, int n, vector<string>& a){
    vector<string> res(m, "");
    for (int i = 0; i < m; i ++){
        for (auto j: a[i]) if (j != '.') res[i].push_back(j);
        res[i] = string(n - res[i].size(), '.') + res[i];
    }
    return res;
}

vector<string> move_up(int m, int n, vector<string>& a){
    vector<string> res(m, string(n, '.'));
    vector<int> pos(n, 0);
    for (int i = 0; i < m; i ++)
        for (int j = 0; j < n; j ++)
            if (a[i][j] != '.')
                res[pos[j] ++][j] = a[i][j];
    return res;
}

vector<string> move_down(int m, int n, vector<string>& a){
    vector<string> res(m, string(n, '.'));
    vector<int> pos(n, m - 1);
    for (int i = m - 1; i >= 0; i --)
        for (int j = 0; j < n; j ++)
            if (a[i][j] != '.')
                res[pos[j] --][j] = a[i][j];
    return res;
}


int main(){
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; test ++){
        int m, n;
        cin >> m >> n;
        vector<string> a(m);
        for (auto& i: a) cin >> i;
        string q;
        cin >> q;
        for (int i = 0; i < q.size(); i ++){
            if (q[i] == 'U'){
                a = move_up(m, n, a);
                for (int j = q.size() - 1; j > i; j --)
                    if (q[j] != 'U'){
                        if (q[j] == 'L') a = move_left(m, n, a);
                        else a = move_right(m, n, a);
                        break;
                    }
                break;
            }
            if (i == q.size() - 1 or q[i + 1] == 'U'){
                if (q[i] == 'L') a = move_left(m, n, a);
                else a = move_right(m, n, a);
            }
        }
        for (auto& i: a) cout << i << "\n";
    }
}
