#include <iostream>
#include <vector>
using namespace std;


vector<string> move_left(int m, int n, vector<string>& a){
    vector<string> res(m, "");
    for (int i = 0; i < m; i ++){
        for (auto j: a[i]) if (j != '.') res[i].push_back(j);
        res[i] += string(n - res[i].size(), '.');
    }
    return res;
}

vector<string> move_right(int m, int n, vector<string>& a){
    vector<string> res(m, "");
    for (int i = 0; i < m; i ++){
        for (auto j: a[i]) if (j != '.') res[i].push_back(j);
        res[i] = string(n - res[i].size(), '.') + res[i];
    }
    return res;
}

vector<string> move_up(int m, int n, vector<string>& a){
    vector<string> res(m, string(n, '.'));
    vector<int> pos(n, 0);
    for (int i = 0; i < m; i ++)
        for (int j = 0; j < n; j ++)
            if (a[i][j] != '.')
                res[pos[j] ++][j] = a[i][j];
    return res;
}

vector<string> move_down(int m, int n, vector<string>& a){
    vector<string> res(m, string(n, '.'));
    vector<int> pos(n, m - 1);
    for (int i = m - 1; i >= 0; i --)
        for (int j = 0; j < n; j ++)
            if (a[i][j] != '.')
                res[pos[j] --][j] = a[i][j];
    return res;
}

short dir(char c){
    if (c == 'L' or c == 'R') return 0;
    return 1;
}


int main(){
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; test ++){
        int m, n;
        cin >> m >> n;
        vector<string> a(m);
        for (auto& i: a) cin >> i;
        string q;
        cin >> q;
        string t;
        for (int i = 0; i < q.size(); i ++)
            if (i == 0 or dir(q[i]) != dir(t.back())) t.push_back(q[i]);
            else t.back() = q[i];
        if (t.size() == 1){
            if (t[0] == 'L') a = move_left(m, n, a);
            else if (t[0] == 'R') a = move_right(m, n, a);
            else if (t[0] == 'U') a = move_up(m, n, a);
            else a = move_down(m, n, a);
        }else{
            int x, y;
            if (t[0] == 'L'){
                a = move_left(m, n, a);
                x = 0;
            }
            else if (t[0] == 'R'){
                a = move_right(m, n, a);
                x = 1;
            }
            else if (t[0] == 'U'){
                a = move_up(m, n, a);
                y = 0;
            }
            else{
                a = move_down(m, n, a);
                y = 1;
            }
            if (t[1] == 'L'){
                a = move_left(m, n, a);
                x = 0;
            }
            else if (t[1] == 'R'){
                a = move_right(m, n, a);
                x = 1;
            }
            else if (t[1] == 'U'){
                a = move_up(m, n, a);
                y = 0;
            }
            else{
                a = move_down(m, n, a);
                y = 1;
            }
            for (int i = 2; i < t.size(); i ++){
                if (t[0] == 'L') x = 0;
                else if (t[0] == 'R') x = 1;
                else if (t[0] == 'U') y = 0;
                else y = 1;
            }
            if (x == 0) a = move_left(m, n, a);
            else a = move_right(m, n, a);
            if (y == 0) a = move_up(m, n, a);
            else a = move_down(m, n, a);
        }
        for (auto& i: a) cout << i << "\n";
    }
}
