#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <array>
#include <random>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fout(a) cout << fixed << setprecision(a)

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

mt19937 rng(235);

void make(vector<vector<ll>>& a, char c) {
	ll n = a.size(), m = a[0].size();
	if (c == 'L') {
		for (ll i = 0; i < n; i++) {
			ll now = 0;
			for (ll j = 0; j < m; j++) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[i][now]);
					now++;
				}
			}
		}
	}
	else if (c == 'R') {
		for (ll i = 0; i < n; i++) {
			ll now = m - 1;
			for (ll j = m - 1; j >= 0; j--) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[i][now]);
					now--;
				}
			}
		}
	}
	else if (c == 'U') {
		for (ll j = 0; j < m; j++) {
			ll now = 0;
			for (ll i = 0; i < n; i++) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[now][j]);
					now++;
				}
			}
		}
	}
	else {
		for (ll j = 0; j < m; j++) {
			ll now = n - 1;
			for (ll i = n - 1; i >= 0; i--) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[now][j]);
					now--;
				}
			}
		}
	}
}

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<vector<ll>> a(n, vector<ll>(m, 0));
		ll now = 1;
		string e = " ";
		for (ll i = 0; i < n; i++) {
			string s;
			cin >> s;
			for (ll j = 0; j < m; j++) {
				if (s[j] != '.') {
					e.push_back(s[j]);
					a[i][j] = (now++);
				}
			}
		}
		string qq;
		cin >> qq;
		for (char c : qq) {
			make(a, c);
		}
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < m; j++) {
				if (a[i][j] == 0) cout << ".";
				else cout << e[a[i][j]];
			}
			cout << "\n";
		}
	}
}
/*
10
5 5
.....
a....
bc...
def..
ghij.

10
5 5
.....
a....
b....
cde..
fghij
*/