#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <array>
#include <random>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fout(a) cout << fixed << setprecision(a)

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

mt19937 rng(235);

void make(vector<vector<ll>>& a, char c) {
	ll n = a.size(), m = a[0].size();
	if (c == 'L') {
		for (ll i = 0; i < n; i++) {
			ll now = 0;
			for (ll j = 0; j < m; j++) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[i][now]);
					now++;
				}
			}
		}
	}
	else if (c == 'R') {
		for (ll i = 0; i < n; i++) {
			ll now = m - 1;
			for (ll j = m - 1; j >= 0; j--) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[i][now]);
					now--;
				}
			}
		}
	}
	else if (c == 'U') {
		for (ll j = 0; j < m; j++) {
			ll now = 0;
			for (ll i = 0; i < n; i++) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[now][j]);
					now++;
				}
			}
		}
	}
	else {
		for (ll j = 0; j < m; j++) {
			ll now = n - 1;
			for (ll i = n - 1; i >= 0; i--) {
				if (a[i][j] != 0) {
					swap(a[i][j], a[now][j]);
					now--;
				}
			}
		}
	}
}

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<vector<ll>> a(n, vector<ll>(m, 0));
		ll now = 1;
		string e = " ";
		for (ll i = 0; i < n; i++) {
			string s;
			cin >> s;
			for (ll j = 0; j < m; j++) {
				if (s[j] != '.') {
					e.push_back(s[j]);
					a[i][j] = (now++);
				}
			}
		}
		string qq;
		cin >> qq;
		ll x = 0;
		ll start = 0;
		bool isl = 0, isu = 0;
		for (ll i = 0; i < qq.size(); i++) {
			if (qq[i] == 'L' || qq[i] == 'R') x |= 1;
			if (qq[i] == 'U' || qq[i] == 'D') x |= 2;
			if (qq[i] == 'L') isl = 1;
			if (qq[i] == 'R') isl = 0;
			if (qq[i] == 'U') isu = 1;
			if (qq[i] == 'D') isu = 0;
			if (x == 3) {
				make(a, qq[i - 1]);
				make(a, qq[i]);
				start = i + 1;
				break;
			}
			if (i + 1 >= qq.size()) {
				make(a, qq[i]);
				start = i + 1;
				break;
			}
		}
		vector<char> st;
		vector<ll> super;
		for (ll i = start; i < qq.size(); i++) {
			if (isl && qq[i] == 'L') continue;
			if (!isl && qq[i] == 'R') continue;
			if (isu && qq[i] == 'U') continue;
			if (!isu && qq[i] == 'D') continue;
			if (st.size() > 0) {
				if (qq[i] == 'L' && st.back() == 'R') {
					st.pop_back();
					if (super.size() > 0 && super.back() > st.size()) super.pop_back();
					continue;
				}if (qq[i] == 'R' && st.back() == 'L') {
					st.pop_back();
					if (super.size() > 0 && super.back() > st.size()) super.pop_back();
					continue;
				}if (qq[i] == 'U' && st.back() == 'D') {
					st.pop_back();
					if (super.size() > 0 && super.back() > st.size()) super.pop_back();
					continue;
				}if (qq[i] == 'D' && st.back() == 'U') {
					st.pop_back();
					if (super.size() > 0 && super.back() > st.size()) super.pop_back();
					continue;
				}
			}
			st.push_back(qq[i]);
			if (qq[i] == 'L') isl = 1;
			if (qq[i] == 'R') isl = 0;
			if (qq[i] == 'U') isu = 1;
			if (qq[i] == 'D') isu = 0;
			if (isl && isu) super.push_back(st.size());
		}
		if (super.size() == 0) super = { (ll)st.size() };
		for (ll i = 0; i < super[0]; i++) {
			make(a, st[i]);
		}
		if (super.size() > 1) {
			auto b = a;
			for (ll i = super[0]; i < super[1]; i++) {
				make(b, st[i]);
			}
			vector<ll> gde(now);
			for (ll x = 0; x < n; x++) {
				for (ll y = 0; y < m; y++) {
					gde[a[x][y]] = x * m + y;
				}
			}
			vector<vector<ll>> go(n * m, vector<ll>(19, 0));
			for (ll x = 0; x < n; x++) {
				for (ll y = 0; y < m; y++) {
					go[x * m + y][0] = gde[b[x][y]];
				}
			}
			for (ll k = 1; k < go[0].size(); k++) {
				for (ll p = 0; p < go.size(); p++) {
					go[p][k] = go[go[p][k - 1]][k - 1];
				}
			}
			ll cnt = (super.back() - super[0]) / 4;
			for (ll x = 0; x < n; x++) {
				for (ll y = 0; y < m; y++) {
					ll p = x * m + y;
					for (ll k = 0; k < go[p].size(); k++) {
						if ((cnt >> k) & 1) {
							p = go[p][k];
						}
					}
					if (a[x][y] != 0)
						b[x][y] = a[p / m][p % m];
				}
			}
			a = b;
		}
		for (ll i = super.back(); i < st.size();i++) {
			make(a, st[i]);
		}
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < m; j++) {
				if (a[i][j] == 0) cout << ".";
				else cout << e[a[i][j]];
			}
			cout << "\n";
		}
	}
}
/*
10
5 5
.....
a....
bc...
def..
ghij.

10
5 5
.....
a....
b....
cde..
fghij
*/