#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <array>
#include <random>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fout(a) cout << fixed << setprecision(a)

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct Seg {
	struct Node {
		ll mn, pos, mod;
		Node() : mn(INF), pos(INF), mod(0) {}
		Node(ll mn, ll pos) : mn(mn), pos(pos), mod(0) {}
		Node operator+(const Node& a) const {
			if (mn + mod < a.mn + a.mod) return Node(mn + mod, pos);
			if (a.mn + a.mod < mn + mod) return Node(a.mn + a.mod, a.pos);
			return Node(mn + mod, min(pos, a.pos));
		}
	};
	vector<Node> t;
	ll sz = 1;
	Seg(vector<ll>& v) {
		sz = 1;
		while (sz < v.size())sz *= 2;
		t.resize(sz * 2, Node());
		for (ll i = 0; i < v.size(); i++) {
			t[sz + i] = Node(0, v[i]);
		}
		for (ll i = sz - 1; i >= 1; i--) {
			t[i] = t[i * 2] + t[i * 2 + 1];
		}
	}
	void push(ll v) {
		t[v * 2].mod += t[v].mod;
		t[v * 2 + 1].mod += t[v].mod;
		t[v].mod = 0;
	}
	void upd(ll lx, ll rx, ll d, ll v = 1, ll l = 0, ll r = -1) {
		if (r == -1)r = sz;
		if (lx <= l && r <= rx) {
			t[v].mod += d;
			return;
		}
		if (lx >= r || l >= rx) return;
		push(v);
		ll m = (l + r) / 2;
		upd(lx, rx, d, v * 2, l, m);
		upd(lx, rx, d, v * 2 + 1, m, r);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
	Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
		if (r == -1) r = sz;
		if (lx <= l && r <= rx) return t[v] + Node();
		if (l >= rx || lx >= r)return Node();
		push(v);
		ll m = (l + r) / 2;
		Node res = get(lx, rx, v * 2, l, m) + get(lx, rx, v * 2 + 1, m, r);
		t[v] = t[v * 2] + t[v * 2 + 1];
		return res;
	}
};

struct Ans {
	ll sm;
	ll mx;
	ll now, rnow;
	Ans() : sm(0), mx(0), now(0), rnow(-10) {};
};

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		map<array<ll, 2>, Ans> mp;
		vector<array<ll, 4>> z;
		vector<ll> xk;
		for (ll i = 0; i < n; i++) {
			ll a, b, c, d;
			cin >> a >> b >> c >> d;
			xk.push_back(c + 1);
			z.push_back({ b, a, c, 1 });
			z.push_back({ d + 1, a, c, -1 });
		}
		sort(all(z));
		z.push_back({ z.back()[0] + 1, 0, 0, 1 });
		sort(all(xk));
		xk.resize(unique(all(xk)) - xk.begin());
		Seg f = Seg(xk);
		multiset<ll> st1 = { -10 };
		set<array<ll, 3>> op = { {-1, -1, -1} };
		for (ll i = 0; i + 1 < z.size(); i++) {
			ll l = lower_bound(all(xk), z[i][1]) - xk.begin();
			ll r = upper_bound(all(xk), z[i][2]) - xk.begin();
			if (z[i][3] == 1) {
				st1.insert(z[i][1]);
			}
			else {
				st1.erase(st1.find(z[i][1]));
			}
			f.upd(l, r, z[i][3]);
			/*if (z[i][0] != z[i + 1][0] && st1.size() > 0) {
				ll d = z[i + 1][0] - z[i][0];
				ll r = *st1.begin();
				while (true) {
					ll ri = lower_bound(all(xk), r) - xk.begin();
					ll e = f.get(ri, xk.size()).pos;
					Ans j = mp[{r, e - 1}];
					j.sm += d;
					if (j.rnow == z[i][0]) {
						j.now += d;
						j.rnow = z[i + 1][0];
					}
					else {
						j.now = d;
						j.rnow = z[i + 1][0];
					}
					j.mx = max(j.mx, j.now);
					mp[{r, e - 1}] = j;
					auto it = st1.lower_bound(e);
					if (it == st1.end()) {
						break;
					}
					r = *it;
				}
			}*/
			auto it = op.lower_bound({ z[i][1], 0, 0 });
			if (it != op.begin()) it--;
			if (it != op.begin()) it--;
			r = (*it)[1];
			it++;
			while (it != op.end()) {
				if ((*it)[0] > z[i][2] + 1) {
					break;
				}
				array<ll, 3> y = *it;
				auto nit = it;
				nit++;
				op.erase(it);
				it = nit;
				Ans j = mp[{y[0], y[1]}];
				ll d = z[i][0] - y[2];
				j.sm += d;
				if (j.rnow == y[2]) {
					j.now += d;
					j.rnow = z[i][0];
				}
				else {
					j.now = d;
					j.rnow = z[i][0];
				}
				j.mx = max(j.mx, j.now);
				mp[{y[0], y[1]}] = j;
			}
			multiset<ll>::iterator jt = st1.lower_bound(r);
			while (jt != st1.end()) {
				ll r = *jt;
				ll ri = lower_bound(all(xk), r) - xk.begin();
				ll e = f.get(ri, xk.size()).pos;
				e--;
				auto kt = op.lower_bound({ r, e, -1 });
				if (kt != op.end() && (*kt)[0] == r && (*kt)[1] == e) break;
				op.insert({ r, e, z[i][0] });
				jt = st1.lower_bound(r);
			}
		}
		cout << mp.size() << "\n";
		for (auto& ee : mp) {
			cout << ee.first[0] << " " << ee.first[1] << " " << ee.second.sm << " " << ee.second.mx << "\n";
		}
	}
	return 0;
}
/*
1
4
2 2 4 5
3 4 9 7
2 9 9 10
7 1 9 7

*/