/*
 * 2) уберем ненужные действия - спарсим строку
 * 3) расделим сторку на циклы
 * 4) найдем итоговое количество поворотов
 * 5) втупую найдем изменения за один поворот
 * 6) с помощью бинапов выполним нужные количество поворотов (если не зайдет по времени - попробуем убрать лог)
 * */

//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
#define all(x) x.begin(), x.end()
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int n, m;
vector<vector<char>> field;

void clear() {
    field.clear();
}

void resize() {
    field.resize(n, vector<char>(m));
}

// сдвинуть все поле влево
void move_left() {
    for (int i = 0; i < n; ++i) {
        int lst_free = 0;
        for (int j = 0; j < m; ++j) {
            if (field[i][j] == '.') {
                continue;
            } else {
                swap(field[i][lst_free], field[i][j]);
                ++lst_free;
            }
        }
    }
}

// сдвинуть все поле вправо
void move_right() {
    for (int i = 0; i < n; ++i) {
        int lst_free = m - 1;
        for (int j = m - 1; j >= 0; --j) {
            if (field[i][j] == '.') {
                continue;
            } else {
                swap(field[i][j], field[i][lst_free]);
                --lst_free;
            }
        }
    }
}

// сдвинуть все поле вверх
void move_up() {
    for (int j = 0; j < m; ++j) {
        int lst_free = 0;
        for (int i = 0; i < n; ++i) {
            if (field[i][j] == '.') {
                continue;
            } else {
                swap(field[i][j], field[lst_free][j]);
                ++lst_free;
            }
        }
    }
}

// сдвинуть все поле вниз
void move_down() {
    for (int j = 0; j < m; ++j) {
        int lst_free = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (field[i][j] == '.') {
                continue;
            } else {
                swap(field[i][j], field[lst_free][j]);
                --lst_free;
            }
        }
    }
}

bool horiz(char sym) {
    return sym == 'L' || sym == 'R';
}

void solve() {
    clear();
    cin >> n >> m;
    resize();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> field[i][j];
        }
    }
    string s1;
    cin >> s1;
    vector<char> s;
    stack<char> h;
    stack<char> v;
    auto pop = [&]() {
        if (horiz(s.back())) {
            h.pop();
        } else {
            v.pop();
        }
        s.pop_back();
    };
    for (const auto &sym : s1) {
        while (!s.empty() && horiz(s.back()) == horiz(sym)) {
            pop();
        }
        if (horiz(sym)) {
            if (h.empty() || h.top() != sym) {
                h.push(sym);
                s.push_back(sym);
            }
        } else {
            if (v.empty() || v.top() != sym) {
                v.push(sym);
                s.push_back(sym);
            }
        }
    }
    s1 = "";
    for (const auto &sym : s) {
        if (sym == 'U') {
            move_up();
        } else if (sym == 'L') {
            move_left();
        } else if (sym == 'R') {
            move_right();
        } else if (sym == 'D') {
            move_down();
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << field[i][j];
        }
        cout << endl;
    }
}

signed main() {
#ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}