/*
 * 3) расделим сторку на циклы
 * 4) найдем итоговое количество поворотов
 * 5) втупую найдем изменения за один поворот
 * 6) с помощью бинапов выполним нужные количество поворотов (если не зайдет по времени - попробуем убрать лог)
 * */

//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
#define all(x) x.begin(), x.end()
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int n, m;
vector<vector<int>> field;
vector<vector<int>> new_field;
vector<pii> to;
vector<vector<int>> state;

void clear() {
    field.clear();
    to.clear();
    state.clear();
}

void resize() {
    field.resize(n, vector<int>(m));
    new_field = field;
    to.resize(n * m, {-1, -1});
    state.resize(n, vector<int>(m));
}

// сдвинуть все поле влево
void move_left(vector<vector<int>> &field) {
    for (int i = 0; i < n; ++i) {
        int lst_free = 0;
        for (int j = 0; j < m; ++j) {
            if (field[i][j] == -1) {
                continue;
            } else {
                swap(field[i][lst_free], field[i][j]);
                ++lst_free;
            }
        }
    }
}

// сдвинуть все поле вправо
void move_right(vector<vector<int>> &field) {
    for (int i = 0; i < n; ++i) {
        int lst_free = m - 1;
        for (int j = m - 1; j >= 0; --j) {
            if (field[i][j] == -1) {
                continue;
            } else {
                swap(field[i][j], field[i][lst_free]);
                --lst_free;
            }
        }
    }
}

// сдвинуть все поле вверх
void move_up(vector<vector<int>> &field) {
    for (int j = 0; j < m; ++j) {
        int lst_free = 0;
        for (int i = 0; i < n; ++i) {
            if (field[i][j] == -1) {
                continue;
            } else {
                swap(field[i][j], field[lst_free][j]);
                ++lst_free;
            }
        }
    }
}

// сдвинуть все поле вниз
void move_down(vector<vector<int>> &field) {
    for (int j = 0; j < m; ++j) {
        int lst_free = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (field[i][j] == -1) {
                continue;
            } else {
                swap(field[i][j], field[lst_free][j]);
                --lst_free;
            }
        }
    }
}

void move(char dir, vector<vector<int>> &field) {
    if (dir == 'U') {
        move_up(field);
    } else if (dir == 'D') {
        move_down(field);
    } else if (dir == 'L') {
        move_left(field);
    } else if (dir == 'R') {
        move_right(field);
    }
}

bool horiz(char sym) {
    return sym == 'L' || sym == 'R';
}

void solve() {
    clear();
    cin >> n >> m;
    resize();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char sym;
            cin >> sym;
            if (sym == '.') {
                field[i][j] = -1;
            } else {
                field[i][j] = (char)sym;
            }
        }
    }
    string s1;
    cin >> s1;
    vector<char> s2;
    vector<char> s3;

    // формируем s2
    {
        stack<char> h;
        stack<char> v;
        auto pop = [&]() {
            if (horiz(s2.back())) {
                h.pop();
            } else {
                v.pop();
            }
            s2.pop_back();
        };
        for (const auto &sym: s1) {
            while (!s2.empty() && horiz(s2.back()) == horiz(sym)) {
                pop();
            }
            if (horiz(sym)) {
                if (h.empty() || h.top() != sym) {
                    h.push(sym);
                    s2.push_back(sym);
                }
            } else {
                if (v.empty() || v.top() != sym) {
                    v.push(sym);
                    s2.push_back(sym);
                }
            }
        }
        s1 = "";
    }
    int sv = 0;
    int sh = 0;

    // втупую выполняем первые 2 дейтствия
    for (int i = 0; i < 2 && i < s2.size(); ++i) {
        char sym = s2[i];
        move(sym, field);
        if (sym == 'L') {
            sh = -1;
        } else if (sym == 'R') {
            sh = 1;
        } else if (sym == 'U') {
            sv = -1;
        } else if (sym == 'D') {
            sv = 1;
        }
    }

    // формируем s3
    {
        for (int i = 2; i < s2.size(); ++i) {
            const auto sym = s2[i];
            if (sym == 'L' && sh != -1) {
                sh = -1;
                if (!s3.empty() && s3.back() == 'R') {
                    s3.pop_back();
                } else {
                    s3.push_back('L');
                }
            } else if (sym == 'R' && sh != 1) {
                sh = 1;
                if (!s3.empty() && s3.back() == 'L') {
                    s3.pop_back();
                } else {
                    s3.push_back('R');
                }
            } else if (sym == 'U' && sv != -1) {
                sv = -1;
                if (!s3.empty() && s3.back() == 'D') {
                    s3.pop_back();
                } else {
                    s3.push_back('U');
                }
            } else if (sym == 'D' && sv != 1) {
                sv = 1;
                if (!s3.empty() && s3.back() == 'U') {
                    s3.pop_back();
                } else {
                    s3.push_back('D');
                }
            }
        }
    }
    int st = 0;
    // выполняем цикл
    if (s3.size() >= 4) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (field[i][j] == -1) {
                    state[i][j] = -1;
                } else {
                    state[i][j] = i * m + j;
                }
            }
        }
        for (int i = 0; i < 4; ++i) {
            move(s3[i], state);
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (state[i][j] == -1) continue;
                to[state[i][j]] = {i, j};
            }
        }
        int c = s3.size() / 4;
        for (int k = 0; k < c; ++k) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    const auto [x, y] = to[i * m + j];
                    if (x == -1) continue;
                    new_field[x][y] = field[i][j];
                }
            }
            swap(field, new_field);
        }
        st = c * 4;
    }

    for (int i = st; i < s3.size(); ++i) {
        move(s3[i], field);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (field[i][j] == -1) {
                cout << '.';
            } else {
                cout << (char)(field[i][j]);
            }
        }
        cout << endl;
    }
}

signed main() {
#ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}