//#pragma GCC optimize("Ofast")
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
#define all(x) x.begin(), x.end()
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

struct MinSt {
    int mi = LLONG_MAX;
    stack<pii> st;

    void push(int el) {
        st.push({mi, el});
        mi = min(mi, el);
    }

    int pop() {
        const auto [t, el] = st.top();
        st.pop();
        mi = t;
        return el;
    }

    int get_mi() { return mi; }

    int size() { return st.size(); }

    bool empty() { return st.empty(); }
};

struct MinQ {
    MinSt st1, st2;
    int size() { return st1.size() + st2.size(); }

    void push(int el) {
        st2.push(el);
    }

    int get_mi() {
        return min(st1.get_mi(), st2.get_mi());
    }

    void pop() {
        if (st1.empty()) {
            while (!st2.empty()) {
                st1.push(st2.pop());
            }
        }
        st1.pop();
    }
};

int n, m, k, p, c;
vector<int> arr, dp;

int cost(int i) {
    if (i == 1) return 0;
    int var1 = (i - 1) + (i - 1);
    int var2 = (n + 1 - i) * 2;
    return min(var1, var2);
}

signed main() {
#ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    cin >> n >> m >> k >> p >> c;

    arr.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        --arr[i];
    }

    dp.resize(n + 1);
    dp[0] = 0;

    MinQ q;

    q.push(0);
    for (int i = 2; i <= n; ++i) {
        int we_begin = cost(i) + dp[i - 1]; // пусть эта точка - начало нового отрезка
        q.push(we_begin);
        while (q.size() > m) {
            q.pop();
        }
        dp[i] = q.get_mi();
    }

    cout << dp[n] + n + 1 << endl;


    return 0;
}