//#pragma GCC optimize("Ofast")
#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
#define all(x) x.begin(), x.end()
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int n;
vector<vector<pii>> segs;
vector<vector<vector<int>>> hs;

const int X = 10;

constexpr int le = 0, ri = 1;
struct Event {
    int coord, type;
    pii get_pair() const { return make_pair(coord, type); }
    bool operator<(const Event &other) const {
        return get_pair() < other.get_pair();
    }
};

void clear() {
    segs.clear();
    hs.clear();
}

void solve() {
    clear();
    segs.resize(X + 1);
    hs.resize(X + 1, vector<vector<int>>(X + 1));
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        if (n == 1) {
            int d = y2 - y1 + 1;
            cout << 1 << endl;
            cout << x1 << " " << x2 << " " << d << " " << d << endl;
            return;
        }
        for (int y = y1; y <= y2; ++y) {
            segs[y].emplace_back(x1, x2);
        }
    }
    for (int y = 1; y <= X; ++y) {
        const auto &s = segs[y];
        if (s.empty()) continue;
        vector<Event> events;
        events.reserve(s.size() * 2);
        for (const auto [l, r] : s) {
            events.push_back({l, le});
            events.push_back({r, ri});
        }
        sort(all(events));
        int o = 0;
        int beg = -1;
        int lst = INT_MIN;
        for (const auto &e : events) {
            if (o > 0) {
                lst = e.coord;
                if (beg == -1) {
                    beg = e.coord;
                }
            } else {
                // o == 0
                // сейчас откроется новый отрезок
                if (lst != e.coord - 1) {
                    if (beg != -1)
                        hs[beg][lst].push_back(y);
                    beg = e.coord;
                    lst = e.coord;
                }
            }
            if (e.type == le) {
                ++o;
            } else if (e.type == ri) {
                --o;
            } else {
                cout << "unknown type" << endl;
                exit(-1);
            }
        }
        hs[beg][lst].push_back(y);
    }
    vector<vector<int>> ans;
    for (int i = 1; i <= X; ++i) {
        for (int j = i; j <= X; ++j) {
            auto &layers = hs[i][j];
            if (layers.empty()) continue;
            sort(all(layers));
            int mx = 1;
            int lst = -1;
            int cnt = 0;
            for (const auto &y: layers) {
                if (y == lst + 1) {
                    ++cnt;
                } else {
                    cnt = 1;
                }
                lst = y;
                mx = max(mx, cnt);
            }
            ans.push_back({i, j, (int)layers.size(), mx});
        }
    }
    cout << ans.size() << endl;
    for (const auto &row : ans) {
        for (const auto &el : row) {
            cout << el << " ";
        }
        cout << endl;
    }
}

signed main() {
#ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}