#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef set<pi> spi;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef queue<int> qi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

int n, m; 

vvc L(vvc a) {
	for (int i = 0; i < n; ++i) {
		qi q;
		for (int j = 0; j < m; ++j) {
			if (a[i][j] == '.')
				q.push(j);
			else if (q.size()) {
				swap(a[i][q.front()], a[i][j]);
				q.pop();
				q.push(j);
			}
		}
	}
	return a;
}
vvc R(vvc a) {
	for (int i = 0; i < n; ++i) {
		qi q;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j] == '.')
				q.push(j);
			else if (q.size()) {
				swap(a[i][q.front()], a[i][j]);
				q.pop();
				q.push(j);
			}
		}
	}
	return a;
}
vvc U(vvc a) {
	for (int j = 0; j < m; ++j) {
		qi q;
		for (int i = 0; i < n; ++i) {
			if (a[i][j] == '.')
				q.push(i);
			else if (q.size()) {
				swap(a[q.front()][j], a[i][j]);
				q.pop();
				q.push(i);
			}
		}
	}
	return a;
}
vvc D(vvc a) {
	for (int j = 0; j < m; ++j) {
		qi q;
		for (int i = n - 1; i >= 0; --i) {
			if (a[i][j] == '.')
				q.push(i);
			else if (q.size()) {
				swap(a[q.front()][j], a[i][j]);
				q.pop();
				q.push(i);
			}
		}
	}
	return a;
}

void solve() {
	cin >> n >> m;
	vvc a(n, vc(m));
	for (int i = 0; i < n; ++i)
		input(a[i]);
	string s;
	cin >> s;
	int k = s.size();
	string s2;
	for (int i = 1; i < k; ++i) {
		int t1 = 0, t2 = 0;
		if (s[i - 1] == 'U' || s[i - 1] == 'D')
			t1 = 1;
		if (s[i] == 'U' || s[i] == 'D')
			t2 = 1;
		if (t1 != t2) {
			s2 += s[i - 1];
			s2 += s[i];
			char c = s[i - 1];
			if (c == 'L')
				a = L(a);
			else if (c == 'R')
				a = R(a);
			else if (c == 'U')
				a = U(a);
			else
				a = D(a);
			c = s[i];
			if (c == 'L')
				a = L(a);
			else if (c == 'R')
				a = R(a);
			else if (c == 'U')
				a = U(a);
			else
				a = D(a);
			s = (i == k - 1 ? "" : s.substr(i + 1, s.size() - i - 1));
			break;
		}
		if (i == k - 1) {
			char c = s[i];
			if (c == 'L')
				a = L(a);
			else if (c == 'R')
				a = R(a);
			else if (c == 'U')
				a = U(a);
			else
				a = D(a);
			s = "";
			break;
		}
	}
	map<char, char> rev;
	rev['L'] = 'R';
	rev['R'] = 'L';
	rev['U'] = 'D';
	rev['D'] = 'U';
	for (auto c : s) {
		if (s2.size() && c == s2.back())
			continue;
		if (s2.size() >= 2 && c == s2[s2.size() - 2])
			continue;
		if (s2.size() >= 3 && c == rev[s2.back()])
			s2.pop_back();
		else {
			if (s2.size() == 2) {
				if (c == rev[s2.back()])
					swap(s2[0], s2[1]);
			}
			s2 += c;
		}
	}
	s = s2;
	for (auto c : s) {
		if (c == 'L')
			a = L(a);
		else if (c == 'R')
			a = R(a);
		else if (c == 'U')
			a = U(a);
		else
			a = D(a);
	}
	if (s.size() >= 4) {
		string t = s.substr(0, 4);
		for (int i = 4; i + 3< s.size(); i += 4) {
			assert(s.substr(i, 4) == t);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cout << a[i][j];
		cout << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}