#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef queue<int> qi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

void solve() {
	int n;
	cin >> n;
	int w = 0, h = 0;
	vector<tuple<int, int, int, int>> rects;
	for (int i = 0; i < n; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		maxravno(w, x2);
		maxravno(h, y2);
		rects.push_back({x1, y1, x2, y2});
	}
	maxravno(w, h);
	maxravno(h, w);
	vvi a(h + 2, vi(w + 2, 0));
	for (auto [x1, y1, x2, y2] : rects) {
		for (int x = x1; x <= x2; ++x)
			for (int y = y1; y <= y2; ++y)
				a[x][y] = 1;
	}
	vector<tuple<int, int, int, int>> ans;
	for (int x1 = 1; x1 <= w; ++x1) {
		for (int x2 = x1; x2 <= w; ++x2) {
			vi b;
			for (int y = 1; y <= h; ++y) {
				bool flag = true;
				if (a[x1 - 1][y] || a[x2 + 1][y])
					flag = false;
				for (int x = x1; x <= x2; ++x)
					if (!a[x][y])
						flag = false;
				if (flag)
					b.push_back(y);
			}
			if (!b.size())
				continue;
			int last = b[0];
			int mx = 0;
			for (int i = 1; i < b.size(); ++i) {
				if (b[i] - b[i - 1] > 1) {
					maxravno(mx, b[i - 1] - last + 1);
					last = b[i];
				}
			}
			maxravno(mx, b.back() - last + 1);
			ans.push_back({x1, x2, b.size(), mx});
		}
	}
	cout << ans.size() << '\n';
	for (auto [x1, x2, cnt, mx] : ans)
		cout << x1 << ' ' << x2 << ' ' << cnt << ' ' << mx << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}