#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

using ll = long long;

void solve();

int32_t main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

int n, m;

void clean(string& q) {
	vector<int> use(q.size(), 1);
	int nxtu = -1, nxtl = -1;
	for (int i = 0; i < q.size(); i++) {
		if (q[i] == 'U') {
			if (nxtu == 0) {
				use[i] = 0;
			}
			nxtu = 0;
		} else if (q[i] == 'D') {
			if (nxtu == 1) {
				use[i] = 0;
			}
			nxtu = 1;
		} else if (q[i] == 'L') {
			if (nxtl == 0) {
				use[i] = 0;
			}
			nxtl = 0;
		} else {
			if (nxtl == 1) {
				use[i] = 0;
			}
			nxtl = 1;
		}
	}
	string nwq;
	for (int i = 0; i < q.size(); i++) {
		if (use[i]) {
			nwq += q[i];
		}
		use[i] = 1;
	}
	swap(q, nwq);
	nwq.clear();
	for (int i = int(q.size()) - 2; i >= 0; i--) {
		if (q[i] == 'U' && q[i + 1] == 'D') {
			use[i] = 0;
		}
		if (q[i] == 'D' && q[i + 1] == 'U') {
			use[i] = 0;
		}
		if (q[i] == 'L' && q[i + 1] == 'R') {
			use[i] = 0;
		}
		if (q[i] == 'R' && q[i + 1] == 'L') {
			use[i] = 0;
		}
	}
	for (int i = 0; i < q.size(); i++) {
		if (use[i]) {
			nwq += q[i];
		}
	}
	swap(q, nwq);
}

void up(vector<string>& p) {
	for (int j = 0; j < m; j++) {
		string nw;
		for (int i = 0; i < n; i++) {
			if (p[i][j] != '.') {
				nw += p[i][j];
			}
		}
		while (nw.size() < n) {
			nw += '.';
		}
		for (int i = 0; i < n; i++) {
			p[i][j] = nw[i];
		}
	}
}

void down(vector<string>& p) {
	for (int j = 0; j < m; j++) {
		string nw;
		for (int i = n - 1; i >= 0; i--) {
			if (p[i][j] != '.') {
				nw += p[i][j];
			}
		}
		while (nw.size() < n) {
			nw += '.';
		}
		reverse(nw.begin(), nw.end());
		for (int i = 0; i < n; i++) {
			p[i][j] = nw[i];
		}
	}
}

void left(vector<string>& p) {
	for (int i = 0; i < n; i++) {
		string nw;
		for (int j = 0; j < m; j++) {
			if (p[i][j] != '.') {
				nw += p[i][j];
			}
		}
		while (nw.size() < m) {
			nw += '.';
		}
		for (int j = 0; j < m; j++) {
			p[i][j] = nw[j];
		}
	}
}

void right(vector<string>& p) {
	for (int i = 0; i < n; i++) {
		string nw;
		for (int j = j = m - 1; j >= 0; j--) {
			if (p[i][j] != '.') {
				nw += p[i][j];
			}
		}
		while (nw.size() < m) {
			nw += '.';
		}
		reverse(nw.begin(), nw.end());
		for (int j = 0; j < m; j++) {
			p[i][j] = nw[j];
		}
	}
}

void upi(vector<vector<int>>& p) {
	for (int j = 0; j < m; j++) {
		string nw;
		for (int i = 0; i < n; i++) {
			if (p[i][j] != -1) {
				nw.push_back(p[i][j]);
			}
		}
		while (nw.size() < n) {
			nw.push_back(-1);
		}
		for (int i = 0; i < n; i++) {
			p[i][j] = nw[i];
		}
	}
}

void downi(vector<vector<int>>& p) {
	for (int j = 0; j < m; j++) {
		string nw;
		for (int i = n - 1; i >= 0; i--) {
			if (p[i][j] != -1) {
				nw.push_back(p[i][j]);
			}
		}
		while (nw.size() < n) {
			nw.push_back(-1);
		}
		reverse(nw.begin(), nw.end());
		for (int i = 0; i < n; i++) {
			p[i][j] = nw[i];
		}
	}
}

void lefti(vector<vector<int>>& p) {
	for (int i = 0; i < n; i++) {
		string nw;
		for (int j = 0; j < m; j++) {
			if (p[i][j] != -1) {
				nw.push_back(p[i][j]);
			}
		}
		while (nw.size() < m) {
			nw.push_back(-1);
		}
		for (int j = 0; j < m; j++) {
			p[i][j] = nw[j];
		}
	}
}

void righti(vector<vector<int>>& p) {
	for (int i = 0; i < n; i++) {
		string nw;
		for (int j = j = m - 1; j >= 0; j--) {
			if (p[i][j] != -1) {
				nw.push_back(p[i][j]);
			}
		}
		while (nw.size() < m) {
			nw.push_back(-1);
		}
		reverse(nw.begin(), nw.end());
		for (int j = 0; j < m; j++) {
			p[i][j] = nw[j];
		}
	}
}


vector<int> perm_bin_pow(vector<int> p, int x) {
	vector<int> res(p.size());
	for (int i = 0; i < p.size(); i++) {
		res[i] = i;
	}
	while (x) {
		if (x & 1) {
			vector<int> nwres(p.size());
			for (int i = 0; i < p.size(); i++) {
				nwres[i] = p[res[i]];
			}
			swap(res, nwres);
		}
		vector<int> nwp(p.size());
		for (int i = 0; i < p.size(); i++) {
			nwp[i] = p[p[i]];
		}
		swap(p, nwp);
		x >>= 1;
	}
	return res;
}

const int K = 20;

void solve() {
	cin >> n >> m;
	vector<string> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i];
	}
	string q;
	cin >> q;
	int oldq = q.size() + 1;
	while (oldq != q.size()) {
		oldq = q.size();
		clean(q);
	}
	// cout << q << '\n';
	if (q.size() <= 50) {
		for (auto i : q) {
			if (i == 'U') {
				up(p);
			} else if (i == 'D') {
				down(p);
			} else if (i == 'L') {
				left(p);
			} else {
				right(p);
			}
		}
		for (int i = 0; i < n; i++) {
			cout << p[i] << '\n';
		}
		return;
	}
	string s;
	for (int i = 0; i < 4; i++) {
		if (q[i] == 'U') {
			up(p);
		} else if (q[i] == 'D') {
			down(p);
		} else if (q[i] == 'L') {
			left(p);
		} else {
			right(p);
		}
		s += q[i];
	}
	int fre = 0;
	vector<vector<int>> base(n, vector<int>(m, -1)), have;
	vector<pair<int, int>> obr;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (p[i][j] != '.') {
				base[i][j] = fre++;
				obr.emplace_back(i, j);
			}
		}
	}
	have = base;
	for (int i : s) {
		if (i == 'U') {
			upi(have);
		} else if (i == 'D') {
			downi(have);
		} else if (i == 'L') {
			lefti(have);
		} else {
			righti(have);
		}
	}
	vector<int> perm(fre);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (base[i][j] != -1) {
				assert(have[i][j] != -1);
				perm[base[i][j]] = have[i][j];
			}
		}
	}
	perm = perm_bin_pow(perm, ((int)q.size() - 4) / 4);
	vector<string> ans = p;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ans[i][j] = p[obr[perm[base[i][j]]].x][obr[perm[base[i][j]]].y];
		}
	}
	swap(ans, p);
	int i = (q.size() / 4) * 4;
	for (; i < q.size(); i++) {
		if (q[i] == 'U') {
			up(p);
		} else if (q[i] == 'D') {
			down(p);
		} else if (q[i] == 'L') {
			left(p);
		} else {
			right(p);
		}
		s += q[i];
	}
	for (int i = 0; i < n; i++) {
		cout << p[i] << '\n';
	}
}