#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<pair<int, int>>> gr;
vector<int> d;
vector<bool> used;

void dijkstra(int s) {
    d[s] = 0;
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
    q.emplace(0, s);
    while (!q.empty()) {
        int v = q.top().second;
        q.pop();
        if (used[v])
            continue;
        used[v] = true;
        for (auto [u, w] : gr[v]) {
            if (d[u] > d[v] + w) {
                d[u] = d[v] + w;
                q.emplace(d[u], u);
            }
        }
    }
}

inline void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;
    gr.resize(n + 1);
    d.resize(n + 1, 1e18);
    used.resize(n + 1);
    int cc = m;
    int next = 0;
    vector<int> c1(k + 1), c2(k + 1);
    for (int i = 0; i < n; ++i) {
        while (next < n && (cc > 0 || c1[a[next]] % p != 0)) {
            if (c1[a[next]] % p == 0)
                cc--;
            c1[a[next]]++;
            next++;
        }
        if (i == 0)
            gr[i].emplace_back(next, 0);
        else
            gr[i].emplace_back(next, min(i, (n - i)) * 2);
        gr[i + 1].emplace_back(i, 0);
        c2[a[i]]++;
        if (c2[a[i]] % p == 0) {
            c1[a[i]] -= p;
            cc++;
        }
    }
    dijkstra(0);
    cout << d[n] + n + 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
