#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using namespace std;

using ll = long long;

int n, m;

void transpose(vector<string> &arr) {
    vector<string> new_arr(m, string(n, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            new_arr[j][i] = arr[i][j];
        }
    }
    arr = new_arr;
    swap(n, m);
}

void apply_operation(vector<string> &arr, char c) {
    bool vertical = c == 'U' || c == 'D';
    if (vertical) {
        transpose(arr);
        if (c == 'U') {
            c = 'L';
        } else {
            c = 'R';
        }
    }
    for (int i = 0; i < n; ++i) {
        string st;
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] != '.') {
                st.push_back(arr[i][j]);
            }
        }
        if (c == 'L') {
            st += string(m - st.size(), '.');
        } else {
            st = string(m - st.size(), '.') + st;
        }
        arr[i] = st;
    }
    if (vertical) {
        transpose(arr);
    }
}

void print_ans(vector<string> &arr) {
    for (string &s : arr) {
        cout << s << "\n";
    }
}

void solve() {
    cin >> n >> m;
    vector<string> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    string q;
    cin >> q;
    if (ll(q.size()) * n * m <= ll(2e7)) {
        for (char c : q) {
            apply_operation(arr, c);
        }
        print_ans(arr);
        return;
    }
    bool is_q0_vertical = q[0] == 'U' || q[0] == 'D';
    int first_different = -1;
    for (int i = 1; i < q.size(); ++i) {
        bool is_vertical = q[i] == 'U' || q[i] == 'D';
        if (is_q0_vertical != is_vertical) {
            first_different = i;
            break;
        }
    }
    if (first_different == -1) {
        apply_operation(arr, q.back());
        print_ans(arr);
        return;
    }
    apply_operation(arr, q[first_different - 1]);
    apply_operation(arr, q[first_different]);
    if (first_different + 1 == q.size()) {
        print_ans(arr);
        return;
    }
    q = q.substr(first_different + 1, q.size() - first_different - 1);
    int last_h = -1;
    int last_v = -1;
    for (int i = 0; i < q.size(); ++i) {
        char c = q[i];
        if (c == 'L' || c == 'R') {
            last_h = i;
        } else {
            last_v = i;
        }
    }
    if (last_h != -1 && last_v != -1) {
        if (last_h < last_v) {
            apply_operation(arr, q[last_h]);
            apply_operation(arr, q[last_v]);
        } else {
            apply_operation(arr, q[last_v]);
            apply_operation(arr, q[last_h]);
        }
    } else if (last_h != -1) {
        apply_operation(arr, q[last_h]);
    } else if (last_v != -1) {
        apply_operation(arr, q[last_h]);
    }
    print_ans(arr);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

/*

*/