#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using namespace std;

using ll = long long;

int n, m;

void transpose(vector<string> &arr) {
    vector<string> new_arr(m, string(n, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            new_arr[j][i] = arr[i][j];
        }
    }
    arr = new_arr;
    swap(n, m);
}

void apply_operation(vector<string> &arr, char c) {
    bool vertical = c == 'U' || c == 'D';
    if (vertical) {
        transpose(arr);
        if (c == 'U') {
            c = 'L';
        } else {
            c = 'R';
        }
    }
    for (int i = 0; i < n; ++i) {
        string st;
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] != '.') {
                st.push_back(arr[i][j]);
            }
        }
        if (c == 'L') {
            st += string(m - st.size(), '.');
        } else {
            st = string(m - st.size(), '.') + st;
        }
        arr[i] = st;
    }
    if (vertical) {
        transpose(arr);
    }
}

void print_ans(vector<string> &arr) {
    for (string &s : arr) {
        cout << s << "\n";
    }
}

bool is_horizontal(char c) {
    return c == 'L' || c == 'R';
}

void solve() {
    cin >> n >> m;
    vector<string> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    string q;
    cin >> q;
    if (ll(q.size()) * n * m <= ll(2e7)) {
        for (char c : q) {
            apply_operation(arr, c);
        }
        print_ans(arr);
        return;
    }
    bool is_q0_vertical = q[0] == 'U' || q[0] == 'D';
    int first_different = -1;
    for (int i = 1; i < q.size(); ++i) {
        bool is_vertical = q[i] == 'U' || q[i] == 'D';
        if (is_q0_vertical != is_vertical) {
            first_different = i;
            break;
        }
    }
    if (first_different == -1) {
        apply_operation(arr, q.back());
        print_ans(arr);
        return;
    }
    apply_operation(arr, q[first_different - 1]);
    apply_operation(arr, q[first_different]);
    if (first_different + 1 == q.size()) {
        print_ans(arr);
        return;
    }
    q = q.substr(first_different + 1, q.size() - first_different - 1);
    string q1;
    for (char c : q) {
        while (!q1.empty()) {
            char c1 = q1.back();
            if (is_horizontal(c1) == is_horizontal(c)) {
                q1.pop_back();
            }
        }
        q1.push_back(c);
        if (c == 'D') {
            if (q1.ends_with("LURDLURDLURD") || q1.ends_with("RULDRULDRULD")) {
                for (int i = 0; i < 12; ++i) {
                    q1.pop_back();
                }
            } else if (q1.ends_with("LDLD") || q1.ends_with("RDRD")) {
                for (int i = 0; i < 2; ++i) {
                    q1.pop_back();
                }
            }
        } else if (c == 'U') {
            if (q1.ends_with("LDRULDRULDRU") || q1.ends_with("LDRULDRULDRU")) {
                for (int i = 0; i < 12; ++i) {
                    q1.pop_back();
                }
            } else if (q1.ends_with("LDLD") || q1.ends_with("RDRD")) {
                for (int i = 0; i < 2; ++i) {
                    q1.pop_back();
                }
            }
        }
        if (q1.ends_with("LURDLURDLURD") || q1.ends_with("LDRULDRULDRU")) {
            for (int i = 0; i < 12; ++i) {
                q1.pop_back();
            }
        } else if (q1.ends_with("LULU") || q1.ends_with("RURU") || q1.ends_with("LDLD") || q1.ends_with("RDRD")) {
            for (int i = 0; i < 2; ++i) {
                q1.pop_back();
            }
        }
    }
    print_ans(arr);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

/*
.6310
..742
...85
....9
.....
*/























#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using namespace std;

using ll = long long;

const int OPEN = 1;
const int CLOSE = -1;

struct Event {
    int y, x1, x2, tp;
};

bool operator<(Event a, Event b) {
    return tie(a.y, a.tp) < tie(b.y, b.tp);
}

void solve() {
    int n;
    cin >> n;
    vector<Event> events(n * 2);
    vector<int> x_coords(n * 6);
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x_coords[i * 6] = x1;
        x_coords[i * 6 + 1] = x2;
        x_coords[i * 6 + 2] = x1 - 1;
        x_coords[i * 6 + 3] = x2 - 1;
        x_coords[i * 6 + 4] = x1 + 1;
        x_coords[i * 6 + 5] = x2 + 1;

        events[i * 2] = {y1, x1, x2, OPEN};
        events[i * 2 + 1] = {y2 + 1, x1, x2, CLOSE};
    }
    std::sort(x_coords.begin(), x_coords.end());
    x_coords.push_back(1e9 + 1000);
    x_coords.erase(std::unique(x_coords.begin(), x_coords.end()), x_coords.end());
    unordered_map<int, int> cond_m;
    for (int i = 0; i < x_coords.size(); ++i) {
        cond_m[x_coords[i]] = i;
    }
    for (Event &e : events) {
        e.x1 = cond_m[e.x1];
        e.x2 = cond_m[e.x2];
    }
    vector<int> cnt(x_coords.size());
    std::sort(events.begin(), events.end());
    map<pair<int, int>, int> ans;
    map<pair<int, int>, int> ans1;
    map<pair<int, int>, int> last_time;
    map<pair<int, int>, pair<int, int>> last_seg;
    int prev_y = events[0].y - 1;
    unordered_map<int, int> coord_cnt;
    for (Event e : events) {
        coord_cnt[e.y]++;
        if (coord_cnt[e.y] == 1) {
            int opened = -1;
            for (int i = 0; i < x_coords.size(); ++i) {
                if (cnt[i] == 0) {
                    if (opened != -1) {
                        auto p = make_pair(x_coords[opened], x_coords[i - 1]);
                        ans[p] += e.y - prev_y;
                        if (last_seg[p] == pair<int, int>{e.x1, e.x2}) {
                            ans1[p] = max(ans1[p], e.y - last_time[p]);
                        } else {
                            ans1[p] = max(ans1[p], e.y - prev_y);
                            last_time[p] = e.y;
                        }
                        last_seg[p] = {e.x1, e.x2};
                    }
                    opened = -1;
                    continue;
                }
                if (opened == -1) {
                    opened = i;
                }
            }
            prev_y = e.y;
        }
        if (e.tp == OPEN) {
            for (int i = e.x1; i <= e.x2; ++i) {
                cnt[i]++;
            }
        } else {
            for (int i = e.x1; i <= e.x2; ++i) {
                cnt[i]--;
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto [p, c] : ans) {
        cout << p.first << " " << p.second << " " << c << " " << ans1[p] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
































#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using namespace std;

using ll = long long;

int n, m, k, p, c;
vector<int> arr;

ll check(int suf_start) {
    unordered_map<int, int> cnt;
    int sz = 0;
    ll ans = 0;
    int last_p = -1;
    for (int i = 0; i < suf_start; ++i) {
        if (cnt[arr[i]] == 0) {
            sz++;
            if (sz > m) {
                ans += i * 3 + 1;
                last_p = i;
                unordered_map<int, int> remaining;
                for (auto [a, b] : cnt) {
                    if (b > 0) {
                        remaining[a] = b;
                    }
                }
                sz = (int) remaining.size();
                cnt = remaining;
            } else {
                cnt[arr[i]] += p - 1;
            }
        } else {
            cnt[arr[i]]--;
        }
    }
    ans += suf_start - 1 - last_p;
    ans += suf_start + n + 1;
    unordered_map<int, int> remaining;
    for (auto [a, b] : cnt) {
        if (b > 0) {
            remaining[a] = b;
        }
    }
    sz = (int) remaining.size();
    cnt = remaining;
    for (int i = suf_start; i < n; ++i) {
        if (cnt[arr[i]] == 0) {
            sz++;
            if (sz > m) {
                return -1;
            } else {
                cnt[arr[i]] += p - 1;
            }
        } else {
            cnt[arr[i]]--;
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k >> p;
    cin >> c;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    ll min_ans = 1e18;
    for (int i = 0; i < n; ++i) {
        ll x = check(i);
        if (x != -1) {
            min_ans = min(min_ans, x);
        }
    }
    cout << min_ans << "\n";
}
