#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using namespace std;

using ll = long long;

const int OPEN = 1;
const int CLOSE = -1;

struct Event {
    int y, x1, x2, tp;
};

bool operator<(Event a, Event b) {
    return tie(a.y, a.tp) < tie(b.y, b.tp);
}

void solve() {
    int n;
    cin >> n;
    vector<Event> events(n * 2);
    int max_x = 0;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        events[i * 2] = {y1, x1, x2, OPEN};
        events[i * 2 + 1] = {y2 + 1, x1, x2, CLOSE};
        max_x = max(max_x, x2 + 2);
    }
    vector<int> cnt(max_x);
    std::sort(events.begin(), events.end());
    map<pair<int, int>, int> ans;
    int prev_y = events[0].y - 1;
    unordered_map<int, int> coord_cnt;
    for (int e_i = 0; e_i < events.size(); ++e_i) {
        Event e = events[e_i];
        coord_cnt[e.y]++;
        int curr_end_y = e.y;
        if (coord_cnt[e.y] == 1) {
            int opened = -1;
            for (int i = 0; i < max_x; ++i) {
                if (cnt[i] == 0) {
                    if (opened != -1) {
                        ans[make_pair(opened, i - 1)] += curr_end_y - prev_y;
                    }
                    opened = -1;
                    continue;
                }
                if (opened == -1) {
                    opened = i;
                }
            }
            prev_y = e.y;
        }
        if (e.tp == OPEN) {
            for (int i = e.x1; i <= e.x2; ++i) {
                cnt[i]++;
            }
        } else {
            for (int i = e.x1; i <= e.x2; ++i) {
                cnt[i]--;
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto [p, c] : ans) {
        cout << p.first << " " << p.second << " " << c << " " << c << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
