#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void debug(T &x) {
#ifdef LOCAL
    cout << x << '\n';
#endif
}

ll n, m;

void rev_col(vector<vector<char>> &a) {
    for (int i = 0; i < m; ++i) {
        int cnt = 0, was = 0;
        for (int j = n - 1; j >= 0; --j) {
            if (a[j][i] != '.') {
                was++;
            }
            if (!was) {
                cnt++;
            } else {
                char pr = a[j][i];
                a[j][i] = '.';
                a[j + cnt][i] = pr;
            }
        }
    }
}

void rev_row(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        int cnt = 0, was = 0;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                was++;
            }
            if (!was) {
                cnt++;
            } else {
                char pr = a[i][j];
                a[i][j] = '.';
                a[i][j + cnt] = pr;
            }
        }
    }
}

void go_up(vector<vector<char>> &a) {
    for (int i = 0; i < m; ++i) {
        vector<char> b;
        for (int j = 0; j < n; ++j) {
            if (a[j][i] != '.') {
                b.push_back(a[j][i]);
            }
        }
        for (int j = 0; j < n; ++j) {
            a[j][i] = (j < sz(b) ? b[j] : '.');
        }
    }
}

void go_left(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        vector<char> b;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        for (int j = 0; j < m; ++j) {
            a[i][j] = (j < sz(b) ? b[j] : '.');
        }
    }
}

void go_down(vector<vector<char>> &a) {
    go_up(a);
    rev_col(a);
}

void go_right(vector<vector<char>> &a) {
    go_left(a);
    rev_row(a);
}

void solve() {
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    string s, t;
    cin >> a >> s;
    ll q = sz(s);
    map<char, char> rev = {{'L', 'R'}, {'R', 'L'}, {'U', 'D'}, {'D', 'U'}};
    map<char, int> type = {{'L', 0}, {'R', 0}, {'U', 1}, {'D', 1}};
    vector<int> lst[2] = {};
    int was[2] = {0};
    for (int i = 0; i < q; ++i) {
        if (!t.empty()) {
            if (t.back() == s[i]) {
                continue;
            }
            if (t.back() == rev[s[i]] && was[type[s[i]]] > 1) {
                t.pop_back();
                lst[type[s[i]]].pop_back();
                was[type[s[i]]]--;
                continue;
            }
            if (was[type[s[i]]] && t[lst[type[s[i]]].back()] == s[i]) {
                continue;
            }
        }
        was[type[s[i]]]++;
        lst[type[s[i]]].push_back(sz(t));
        t += s[i];
    }
    q = sz(t);
    was[0] = was[1] = 0;
    int start = q;
    ll val = 0;
    for (int i = 0; i < min(start + val, q); ++i) {
        if (was[0] && was[1]) {
            start = i;
            val = (q - start) % 4;
            break;
        }
        was[type[i]]++;
        if (type[t[i]] == 0) {
            go_left(a);
            if (t[i] == 'R') {
                rev_row(a);
            }
        } else {
            go_up(a);
            if (t[i] == 'D') {
                rev_col(a);
            }
        }
        if (i % 2 == 1) {
#ifdef LOCAL
            for (int i1 = 0; i1 < n; ++i1) {
                for (int j = 0; j < m; ++j) {
                    cout << a[i1][j];
                }
                cout << '\n';
            }
            cout << '\n';
#endif
        }
        /*if (was[type[t[i]]] == 0) {
            was[type[t[i]]]++;
            if (type[t[i]] == 0) {
                go_left(a);
                if (t[i] == 'R') {
                    rev_row(a);
                }
            } else {
                go_up(a);
                if (t[i] == 'D') {
                    rev_col(a);
                }
            }
        } else {
            if (type[t[i]] == 0) {
                rev_row(a);
            } else {
                rev_col(a);
            }
        }*/
    }
    debug(t);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}