#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

struct brr {
    ll x1 = 0, y1 = 0, x2 = 0, y2 = 0;

    brr() {}
};

istream &operator>>(istream &in, brr &a) {
    return in >> a.x1 >> a.y1 >> a.x2 >> a.y2;
}

struct Event {
    ll y = 0, type, x1 = 0, x2 = 0;

    Event() {}
    Event(ll y, ll type, ll x1, ll x2) : y(y), type(type), x1(x1), x2(x2) {}
};

void solve() {
    ll n;
    cin >> n;
    vector<brr> a(n);
    cin >> a;
    vector<ll> xs = {-1};
    for (int i = 0; i < n; ++i) {
        xs.push_back(a[i].x1);
        xs.push_back(a[i].x2);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    for (int i = 0; i < n; ++i) {
        a[i].x1 = lower_bound(xs.begin(), xs.end(), a[i].x1) - xs.begin();
        a[i].x2 = lower_bound(xs.begin(), xs.end(), a[i].x2) - xs.begin();
    }
    vector<Event> e;
    for (int i = 0; i < n; ++i) {
        e.push_back({a[i].y1, -1, a[i].x1, a[i].x2});
        e.push_back({a[i].y2, 1, a[i].x1, a[i].x2});
    }
    sort(e.begin(), e.end(), [](Event a, Event b) {
        return a.y < b.y || (a.y == b.y && a.type < b.type);
    });
    int m = sz(e), mx = sz(xs) + 1;
    vector<ll> cnt(mx);
    ll prv = 0;
    map<pair<ll, ll>, vector<pair<ll, ll>>> w;
    map<pair<ll, ll>, ll> sum;
    for (int i = 0; i < m; ++i) {
        auto [y, type, x1, x2] = e[i];
        ll p0 = -1;
        for (int j = 0; j < mx; ++j) {
            if (cnt[j] == 0) {
                if (p0 != j - 1) {
                    sum[{p0 + 1, j - 1}] += y - prv;
                    w[{p0 + 1, j - 1}].push_back({prv, y - 1});
                }
                p0 = j;
            }
        }
        for (int j = x1; j <= x2; ++j) {
            cnt[j] += type;
        }
    }
    for (auto [p, c] : sum) {
        auto [x1, x2] = p;
        cout << x1 << ' ' << x2 << ' ' << c << ' ' << 0 << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
}