#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll inf = 1e18;

struct Fast {
    ll n, m;
    vector<vector<char>> a;

    void left() {
        for (int i = 0; i < n; i++) {
            ll last = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    a[i][last] = a[i][j];
                    if (j != last) {
                        a[i][j] = '.';
                    }
                    last++;
                }
            }
        }
    }

    void right() {
        for (int i = 0; i < n; i++) {
            ll last = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    a[i][last] = a[i][j];
                    if (j != last) {
                        a[i][j] = '.';
                    }
                    last--;
                }
            }
        }
    }

    void up() {
        for (int j = 0; j < m; j++) {
            ll last = 0;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') {
                    a[last][j] = a[i][j];
                    if (i != last) {
                        a[i][j] = '.';
                    }
                    last++;
                }
            }
        }
    }

    void down() {
        for (int j = 0; j < m; j++) {
            ll last = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i][j] != '.') {
                    a[last][j] = a[i][j];
                    if (i != last) {
                        a[i][j] = '.';
                    }
                    last--;
                }
            }
        }
    }

    void solve() {
        cin >> n >> m;
        a.resize(n, vector<char>(m, '.'));
        for (int i = 0; i < n; i++) {
            string s;
            cin >> s;
            for (int j = 0; j < m; j++) {
                a[i][j] = s[j];
            }
        }
        string qs;
        cin >> qs;
        string nw_qs;
        char last_op = qs.back();
        for (auto el: qs) {
            if (nw_qs.empty()) nw_qs.push_back(el);
            if (el == 'L' || el == 'R') {
                if (nw_qs.back() == 'L' || nw_qs.back() == 'R') {
                    nw_qs.back() = el;
                } else {
                    nw_qs.push_back(el);
                }
            } else {
                if (nw_qs.back() == 'U' || nw_qs.back() == 'D') {
                    nw_qs.back() = el;
                } else {
                    nw_qs.push_back(el);
                }
            }
        }
        qs.clear();
        string lf;
        string ls;
        for (auto el: nw_qs) {
            if (qs.empty()) {
                qs.push_back(el);
                if (el == 'L' || el == 'R') lf += el;
                else ls += el;
                continue;
            }
            if (el == 'L' || el == 'R') {
                if (qs.back() == 'L' || qs.back() == 'R') {
                    lf.pop_back();
                    qs.back() = el;
                    if (!lf.empty() && lf.back() == qs.back()) {
                        qs.pop_back();
                    } else {
                        lf.push_back(el);
                    }
                } else {
                    if (lf.empty() || lf.back() != el) {
                        lf += el;
                        qs.push_back(el);
                    }
                }
            } else {
                if (qs.back() == 'U' || qs.back() == 'D') {
                    qs.back() = el;
                    ls.pop_back();
                    if (!ls.empty() && qs.back() == ls.back()) {
                        qs.pop_back();
                    } else {
                        ls.push_back(el);
                    }
                } else {
                    if (ls.empty() || ls.back() != el) {
                        ls += el;
                        qs.push_back(el);
                    }
                }
            }
        }
        ll its = ll(qs.size()) / 4;
        if (its > 0) {
            string good;
            good += qs[0], good += qs[1], good += qs[2], good += qs[3];
            for (int q = 0; q < 4; q++) {
                if (good[q] == 'L') {
                    left();
                } else if (good[q] == 'R') {
                    right();
                } else if (good[q] == 'U') {
                    up();
                } else {
                    down();
                }
            }
            its--;
            ll cc = its % 3;
            for (int _ = 0; _ < cc; _++) {
                for (int q = 0; q < 4; q++) {
                    if (good[q] == 'L') {
                        left();
                    } else if (good[q] == 'R') {
                        right();
                    } else if (good[q] == 'U') {
                        up();
                    } else {
                        down();
                    }
                }
            }
        }
        ll last = ll(qs.size()) / 4 * 4;
        qs += last_op;
        for (int q = last; q < ll(qs.size()); q++) {
            if (qs[q] == 'L') {
                left();
            } else if (qs[q] == 'R') {
                right();
            } else if (qs[q] == 'U') {
                up();
            } else {
                down();
            }
        }
        for (auto el: a) {
            for (auto e: el) {
                cout << e;
            }
            cout << '\n';
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll times = 1;
    cin >> times;
    while (times--) {
        Fast fs;
        fs.solve();
    }
    return 0;
}