#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

#define int long long

void reform(int n, int m, vector<vector<char>> &arr, char type) {
    if (type == 'W') {
        return;
    } else if (type == 'L') {
        for (int i = 0; i < n; i++) {
            int place = 0;
            for (int j = 0; j < m; j++) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[i][place++] = c;
            }
        }
    } else if (type == 'R') {
        for (int i = 0; i < n; i++) {
            int place = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[i][place--] = c;
            }
        }
    } else if (type == 'U') {
        for (int j = 0; j < m; j++) {
            int place = 0;
            for (int i = 0; i < n; i++) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[place++][j] = c;
            }
        }
    } else {
        for (int j = 0; j < m; j++) {
            int place = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[place--][j] = c;
            }
        }
    }
}

void solve() {
    bool left = true, right = true, up = true, down = true;
    int n, m, i, j;
    string in, s;
    cin >> n >> m;
    vector<vector<char>> arr(n, vector<char>(m));
    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
            cin >> arr[i][j];
        }
    }
    cin >> in;
    for (char c: in) {
        while (!s.empty() && (s.back() == c || (s.back() == 'R' && c == 'L') || (s.back() == 'L' && c == 'R') ||
                              (s.back() == 'U' && c == 'D') || (s.back() == 'D' && c == 'U'))) {
            s.pop_back();
        }
        if (c == 'L') {
            if (left) {
                s.push_back(c);
            }
            left = false, right = true;
        } else if (c == 'R') {
            if (right) {
                s.push_back(c);
            }
            right = false, left = true;
        } else if (c == 'U') {
            if (up) {
                s.push_back(c);
            }
            up = false, down = true;
        } else {
            if (down) {
                s.push_back(c);
            }
            down = false, up = true;
        }
    }
    for (char c: s) {
        reform(n, m, arr, c);
    }
    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
            cout << arr[i][j];
        }
        cout << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}