#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e6 + 10;
const int inf = 1e9 + 10;

vector<string> a;
int n, m;


void move(char dir) {
    if (dir == 'L') {
        string b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b.push_back(a[i][j]);
                }
            }
            a[i] = b;
            while (a[i].size() < n) {
                a[i].push_back('.');
            }
        }
    }
    if (dir == 'R') {
        string b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b.push_back(a[i][j]);
                }
            }
            reverse(b.begin(), b.end());
            a[i] = b;
            while (a[i].size() < n) {
                a[i].push_back('.');
            }
            reverse(a[i].begin(), a[i].end());
        }
    }
    if (dir == 'U') {
        string b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b[j].push_back(a[i][j]);
                }
            }
            a[i].clear();
            a[i].resize(n, '.');
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    a[i][j] = b[j][i];
                }
            }
        }
    }

    if (dir == 'D') {
        string b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b[j].push_back(a[i][j]);
                }
            }
            a[i].clear();
            a[i].resize(n, '.');
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    a[m - i - 1][j] = b[j][b[j].size() - i - 1];
                }
            }
        }
    }
}


void solve() {
    cin >> m >> n;
    a.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }

    string s;
    cin >> s;




    string t;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'L' || s[i] == 'R') {
            while (t.size() > 0 && t[t.size() - 1] == 'L' || t[t.size() - 1] == 'R') {
                t.pop_back();
            }
            t.push_back(s[i]);
        }
        if (s[i] == 'U' || s[i] == 'D') {
            while (t.size() > 0 && t[t.size() - 1] == 'U' || t[t.size() - 1] == 'D') {
                t.pop_back();
            }
            t.push_back(s[i]);
        }
    }

    s = t;
    if (s.size() < 3) {
        for (auto c : s) {
            move(c);
        }

        for (int i = 0; i < m; i++) {
            cout << a[i] << '\n';
        }
        return;
    }


    map<char, int> pos;

    pos[t[0]] = 1;
    pos[t[1]] = 1;

    s.clear();
    s.push_back(t[0]);
    s.push_back(t[1]);
    for (int i = 2; i < t.size(); i++) {
        if (pos[t[i]]) continue;
        s.push_back(t[i]);
        pos[t[i]] = 1;
        if (t[i] == 'U' || t[i] == 'D') pos['U' + 'D' - t[i]] = 0;
        else pos['L' + 'R' - t[i]] = 0;
    }


    for (auto c : s) {
        move(c);
    }

    for (int i = 0; i < m; i++) {
        cout << a[i] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
