#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 1e6 + 10;
const int inf = 1e9 + 10;

vector<string> a;
vector<vector<int>> ac;
int n, m;


void move(char dir) {
    if (dir == 'L') {
        string b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b.push_back(a[i][j]);
                }
            }
            a[i] = b;
            while (a[i].size() < n) {
                a[i].push_back('.');
            }
        }
    }
    if (dir == 'R') {
        string b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b.push_back(a[i][j]);
                }
            }
            reverse(b.begin(), b.end());
            a[i] = b;
            while (a[i].size() < n) {
                a[i].push_back('.');
            }
            reverse(a[i].begin(), a[i].end());
        }
    }
    if (dir == 'U') {
        string b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b[j].push_back(a[i][j]);
                }
            }
            a[i].clear();
            a[i].resize(n, '.');
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    a[i][j] = b[j][i];
                }
            }
        }
    }

    if (dir == 'D') {
        string b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b[j].push_back(a[i][j]);
                }
            }
            a[i].clear();
            a[i].resize(n, '.');
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    a[m - i - 1][j] = b[j][b[j].size() - i - 1];
                }
            }
        }
    }
}

void move2(char dir) {
    if (dir == 'L') {
        vector<int> b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b.push_back(ac[i][j]);
                }
            }
            ac[i] = b;
            while (ac[i].size() < n) {
                ac[i].push_back(-1);
            }
        }
    }
    if (dir == 'R') {
        vector<int> b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b.push_back(ac[i][j]);
                }
            }
            reverse(b.begin(), b.end());
            ac[i] = b;
            while (ac[i].size() < n) {
                ac[i].push_back(-1);
            }
            reverse(ac[i].begin(), ac[i].end());
        }
    }
    if (dir == 'U') {
        vector<int> b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b[j].push_back(ac[i][j]);
                }
            }
            ac[i].clear();
            ac[i].resize(n, -1);
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    ac[i][j] = b[j][i];
                }
            }
        }
    }

    if (dir == 'D') {
        vector<int> b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b[j].push_back(ac[i][j]);
                }
            }
            ac[i].clear();
            ac[i].resize(n, -1);
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    ac[m - i - 1][j] = b[j][b[j].size() - i - 1];
                }
            }
        }
    }
}


void solve() {
    cin >> m >> n;
    a.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }

    string s;
    cin >> s;

    string t;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'L' || s[i] == 'R') {
            while (t.size() > 0 && t[t.size() - 1] == 'L' || t[t.size() - 1] == 'R') {
                t.pop_back();
            }
            t.push_back(s[i]);
        }
        if (s[i] == 'U' || s[i] == 'D') {
            while (t.size() > 0 && t[t.size() - 1] == 'U' || t[t.size() - 1] == 'D') {
                t.pop_back();
            }
            t.push_back(s[i]);
        }
    }

    s = t;
    if (s.size() < 4) {
        for (auto c : s) {
            move(c);
        }

        for (int i = 0; i < m; i++) {
            cout << a[i] << '\n';
        }
        return;
    }


    map<char, int> pos;

    pos[t[0]] = 1;
    pos[t[1]] = 1;

    s.clear();
    s.push_back(t[0]);
    s.push_back(t[1]);
    for (int i = 2; i < t.size(); i++) {
        if (pos[t[i]]) continue;
        s.push_back(t[i]);
        pos[t[i]] = 1;
        if (t[i] == 'U' || t[i] == 'D') pos['U' + 'D' - t[i]] = 0;
        else pos['L' + 'R' - t[i]] = 0;
    }

    t.clear();

    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'L' || s[i] == 'R') {
            while (t.size() > 0 && t[t.size() - 1] == 'L' || t[t.size() - 1] == 'R') {
                t.pop_back();
            }
            t.push_back(s[i]);
        }
        if (s[i] == 'U' || s[i] == 'D') {
            while (t.size() > 0 && t[t.size() - 1] == 'U' || t[t.size() - 1] == 'D') {
                t.pop_back();
            }
            t.push_back(s[i]);
        }
    }

    s = t;

    if (s.size() < 4) {
        for (auto c : s) {
            move(c);
        }

        for (int i = 0; i < m; i++) {
            cout << a[i] << '\n';
        }
        return;
    }

    move(s[0]);
    move(s[1]);
    pos.clear();
    pos[s[0]] = 1;
    pos[s[1]] = 1;
    reverse(s.begin(), s.end());
    s.pop_back();
    s.pop_back();

    while (s.size()%4 != 0) {
        auto c = s[s.size() - 1];
        move(c);
        pos[c] = 1;
        if (c == 'U' || c == 'D') pos['U' + 'D' - c] = 0;
        else pos['L' + 'R' - c] = 0;
        s.pop_back();
    }

    reverse(s.begin(), s.end());

    vector<pair<pii, pii>> p(n*m);
    int cnt = 0;
    ac.resize(m, vector<int> (n, -1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '.') continue;
            ac[i][j] = cnt++;
            p[cnt - 1].first = {i, j};
        }
    }

    p.resize(cnt);

    move2(s[0]);
    move2(s[1]);
    move2(s[2]);
    move2(s[3]);

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (ac[i][j] == -1) continue;
            p[ac[i][j]].second = {i, j};
        }
    }

    map<pii, pii> mp;
    for (auto [x, y] : p) {
        mp[x] = y;
    }

    vector<pii> ord;
    auto nxt = mp.begin()->first;
    ord.push_back(nxt);
    nxt = mp[nxt];
    while (nxt != mp.begin()->first) {
        ord.push_back(nxt);
        nxt = mp[nxt];
    }

    int d = s.size()/4;

    map<pii, pii> dd;
    for (int l = 0; l < ord.size(); l++) {
        int r = (l + d)%ord.size();
        dd[ord[r]] = ord[l];
    }

    auto aa = a;
    for (auto [x, y] : dd) {
        aa[x.first][x.second] = a[y.first][y.second];
    }

    for (int i = 0; i < m; i++) {
        cout << aa[i] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
