#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

void move_l(vector<vector<char>>& mp, int n, int m) {
	for (int i = 0; i < n; ++i) {
		int ind = 0;
		for (int j = 0; j < m; ++j) {
			if (mp[i][j] != '.') swap(mp[i][ind++], mp[i][j]);
		}
	}
}

void move_r(vector<vector<char>>& mp, int n, int m) {
	for (int i = 0; i < n; ++i) {
		int ind = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (mp[i][j] != '.') swap(mp[i][ind--], mp[i][j]);
		}
	}
}

void move_u(vector<vector<char>>& mp, int n, int m) {
	for (int j = 0; j < m; ++j) {
		int ind = 0;
		for (int i = 0; i < n; ++i) {
			if (mp[i][j] != '.') swap(mp[ind++][j], mp[i][j]);
		}
	}
}

void move_d(vector<vector<char>>& mp, int n, int m) {
	for (int j = 0; j < m; ++j) {
		int ind = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (mp[i][j] != '.') swap(mp[ind--][j], mp[i][j]);
		}
	}
}

void move(char tp, vector<vector<char>>& mp, int n, int m) {
	if (tp == 'L') move_l(mp, n, m);
	else if (tp == 'R') move_r(mp, n, m);
	else if (tp == 'D') move_d(mp, n, m);
	else if (tp == 'U') move_u(mp, n, m);
}

const int NA = 239239239;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m, '.'));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}

	string com;
	cin >> com;


	string new_com;
	for (int i = 0; i < 10; ++i) {
		char ls = com[0];
		map<char, bool> used;
		new_com += ls;
		used[ls] = true;
		for (char c : com) {
			if (used[c]) continue;
			if ((ls == 'U' && c == 'D') || (ls == 'R' && c == 'L') || (ls == 'D' && c == 'U') || (ls == 'L' && c == 'R')) {
				if (used[c]) new_com.pop_back();
				else new_com.back() = c;
			}
			else new_com.push_back(c);
			used[c] = true;
			if (c == 'L') used['R'] = false;
			else if (c == 'R') used['L'] = false;
			else if (c == 'D') used['U'] = false;
			else if (c == 'U') used['D'] = false;
			ls = new_com.back();
		}
		com = new_com;
		new_com = "";
	}

	for (char c : com) {
		if (c == 'L') move_l(a, n, m);
		if (c == 'R') move_r(a, n, m);
		if (c == 'D') move_d(a, n, m);
		if (c == 'U') move_u(a, n, m);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << a[i][j];
		}
		cout << '\n';
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int tt;
	cin >> tt;

	for (int _ = 0; _ < tt; _++) {
		solve();
	}
}