#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void move_l(vector<vector<char>>& mp, int n, int m) {
	for (int i = 0; i < n; ++i) {
		int ind = 0;
		for (int j = 0; j < m; ++j) {
			if (mp[i][j] != '.') swap(mp[i][ind++], mp[i][j]);
		}
	}
}

void move_r(vector<vector<char>>& mp, int n, int m) {
	for (int i = 0; i < n; ++i) {
		int ind = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (mp[i][j] != '.') swap(mp[i][ind--], mp[i][j]);
		}
	}
}

void move_u(vector<vector<char>>& mp, int n, int m) {
	for (int j = 0; j < m; ++j) {
		int ind = 0;
		for (int i = 0; i < n; ++i) {
			if (mp[i][j] != '.') swap(mp[ind++][j], mp[i][j]);
		}
	}
}

void move_d(vector<vector<char>>& mp, int n, int m) {
	for (int j = 0; j < m; ++j) {
		int ind = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (mp[i][j] != '.') swap(mp[ind--][j], mp[i][j]);
		}
	}
}

void move(char tp, vector<vector<char>>& mp, int n, int m) {
	if (tp == 'L') move_l(mp, n, m);
	else if (tp == 'R') move_r(mp, n, m);
	else if (tp == 'D') move_d(mp, n, m);
	else if (tp == 'U') move_u(mp, n, m);
}

const int NA = 239239239;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m, '.'));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}

	string com;
	cin >> com;
	
	int ln = (com.size() - 4) % 12 + 16;

	for (int i = 0; i < ln; ++i) {
		for (char c : vector<char>{ 'L', 'U', 'R', 'D' }) {
			move(c, a, n, m);
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << a[i][j];
		}
		cout << '\n';
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int tt;
	cin >> tt;

	for (int _ = 0; _ < tt; _++) {
		solve();
	}
}