#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void move_l(vector<vector<char>>& mp, int n, int m) {
	for (int i = 0; i < n; ++i) {
		int ind = 0;
		for (int j = 0; j < m; ++j) {
			if (mp[i][j] != '.') swap(mp[i][ind++], mp[i][j]);
		}
	}
}

void move_r(vector<vector<char>>& mp, int n, int m) {
	for (int i = 0; i < n; ++i) {
		int ind = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (mp[i][j] != '.') swap(mp[i][ind--], mp[i][j]);
		}
	}
}

void move_u(vector<vector<char>>& mp, int n, int m) {
	for (int j = 0; j < m; ++j) {
		int ind = 0;
		for (int i = 0; i < n; ++i) {
			if (mp[i][j] != '.') swap(mp[ind++][j], mp[i][j]);
		}
	}
}

void move_d(vector<vector<char>>& mp, int n, int m) {
	for (int j = 0; j < m; ++j) {
		int ind = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (mp[i][j] != '.') swap(mp[ind--][j], mp[i][j]);
		}
	}
}

void move(char tp, vector<vector<char>>& mp, int n, int m) {
	if (tp == 'L') move_l(mp, n, m);
	else if (tp == 'R') move_r(mp, n, m);
	else if (tp == 'D') move_d(mp, n, m);
	else if (tp == 'U') move_u(mp, n, m);
}

const int NA = 239239239;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m, '.'));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}

	string com;
	cin >> com;

	char ls = com[0];
	string new_com;
	new_com += ls;
	for (char c : com) {
		if (ls == c) continue;
		if ((ls == 'U' && c == 'D') || (ls == 'R' && c == 'L') || (ls == 'D' && c == 'U') || (ls == 'L' && c == 'R')) { new_com.back() = c; }
		else new_com.push_back(c);
		ls = new_com.back();
	}

	int fop[4] = { NA, NA, NA, NA };
	int eop[4] = { NA, NA, NA, NA };

	char ops[4] = { 'L', 'R', 'D', 'U' };

	int ind = 0;
	for (char c : new_com) {
		if (c == 'L') {
			if (fop[0] == NA) fop[0] = ind;
			eop[0] = ind;
		}
		else if (c == 'R') {
			if (fop[1] == NA) fop[1] = ind;
			eop[1] = ind;
		}
		else if (c == 'D') {
			if (fop[2] == NA) fop[2] = ind;
			eop[2] = ind;
		}
		else if (c == 'U') {
			if (fop[3] == NA) fop[3] = ind;
			eop[3] = ind;
		}
		++ind;
	}

	set<pair<int, char>> command;

	for (int i = 0; i < 4; ++i) {
		if (fop[i] != NA) command.insert({ fop[i], ops[i] });
		if (eop[i] != NA) command.insert({ eop[i], ops[i] });
	}

	for (auto p : command) {
		move(p.second, a, n, m);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << a[i][j];
		}
		cout << '\n';
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int tt;
	cin >> tt;

	for (int _ = 0; _ < tt; _++) {
		solve();
	}
}