#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

typedef long long ll;

using namespace std;

const ll INF = LLONG_MAX;

void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;

	int c;
	cin >> c;

	bool fl1 = (c & 1) > 0;
	bool fl2 = (c & 2) > 0;

	vector<int> dist(n, INF);
	if (fl1) {
		for (int i = 0; i < n; ++i) {
			dist[i] = i;
		}
	}
	if (fl2) {
		for (int i = 0; i < n; ++i) {
			dist[i] = min(dist[i], n - i);
		}
	}

	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i]--;
	}

	int cnt = 0;
	vector<int> g(k);
	vector<int> rs(k);

	ll ans = 0;

	int l = 0, r = 0;
	while (r < n) {
		if (r > 0) ans += dist[r - 1];
		while (cnt < m && r < n) {
			if (rs[a[r]] > 0) {
				rs[a[r]]--;
			}
			else {
				cnt++;
				g[a[r]] += p;
				rs[a[r]] += p - 1;
			}
			r++;
		}
		while (l < r) {
			cnt -= ((g[a[l]] + p - 1) / p);
			g[a[l]]--;
			cnt += ((g[a[l]] + p - 1) / p);
			l++;
		}
	}
	cout << 2 * ans + n + 1 << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();
}