#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

typedef long long ll;

using namespace std;

//#define int ll

const int INF = LONG_MAX;
const int N = 200005;

int xl[N], yl[N], xr[N], yr[N];

void solve() {
	int n;
	cin >> n;

	int h = 0;
	int w = 0;

	for (int i = 0; i < n; ++i) {
		cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
		h = max(h, yr[i]);
		w = max(w, xr[i]);
	}

	h++;
	w++;

	vector<vector<bool>> mp(h, vector<bool>(w, false));
	for (int i = 0; i < n; ++i) {
		for (int x = xl[i]; x <= xr[i]; ++x) {
			for (int y = yl[i]; y <= yr[i]; ++y) {
				mp[x][y] = true;
			}
		}
	}

	map<pair<int, int>, int> cnt;
	for (int y = 1; y < h; ++y) {
		int ls = 0;
		for (int x = 1; x < w; ++x) {
			if (mp[y][x] && !mp[y][x - 1]) {
				ls = x;
			}
			if (!mp[y][x] && mp[y][x - 1]) {
				cnt[{ls, x - 1}] ++;
			}
		}
	}

	cout << cnt.size() << '\n';
	for (auto k : cnt) {
		cout << k.first.first << ' ' << k.first.second << ' ' << k.second << ' ' << 1 << '\n';
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int tt;
	cin >> tt;

	for (int i = 0; i < tt; ++i) {
		solve();
	}
}