#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

typedef long long ll;

using namespace std;

#define int ll

const int INF = LLONG_MAX;
const int N = 200005;

int xl[N], yl[N], xr[N], yr[N];
struct event {
	int x;
	int tp;
	event(int _x, int _tp) : x(_x), tp(_tp) {}
};

void solve() {
	int n;
	cin >> n;

	map<int, vector<event>> evs;
	for (int i = 0; i < n; ++i) {
		cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
		for (int y = yl[i]; y <= yr[i]; ++y) {
			evs[y].emplace_back(xl[i], 1);
			evs[y].emplace_back(xr[i] + 1, -1);
		}
	}


	map<pair<int, int>, int> cnt;
	for (auto k : evs) {
		sort(k.second.begin(), k.second.end(), [&](auto a, auto b) {
			if (a.x != b.x) return a.x < b.x;
			return a.tp > b.tp;
			});

		int ls = 0;
		int cc = 0;
		for (event ev : k.second) {
			cc += ev.tp;
			if (cc == 1 && ev.tp == 1) {
				ls = ev.x;
			}
			if (cc == 0 && ev.tp == -1) {
				cnt[{ls, ev.x - 1}]++;
			}
		}
	}

	cout << cnt.size() << '\n';
	for (auto k : cnt) {
		cout << k.first.first << ' ' << k.first.second << ' ' << k.second << ' ' << 1 << '\n';
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int tt;
	cin >> tt;

	for (int i = 0; i < tt; ++i) {
		solve();
	}
}