#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = int;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e8);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int _ = 1;
    cin >> _;
    while (_--)
        solve(cin, cout);
}


struct st {
    ll x = 0, y = 0;
    char c = '.';


    st() = default;

    st(ll x, ll y, char c) : x(x), y(y), c(c) {}
};


struct stt {
    ll x = 0, y = 0;
    ll a = 0, b = 0;


    stt() = default;

    stt(ll x, ll y) : x(x), y(y), a(x), b(y) {}
};


ll n, m;

template<typename Ty>
void left(vector<Ty> &a) {
    auto cmp = [](const Ty &a, const Ty &b) { return make_pair(a.x, a.y) < make_pair(b.x, b.y); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].x != a[i - 1].x)
            a[i].y = 0;
        else
            a[i].y = a[i - 1].y + 1;
    }
}


template<typename Ty>
void right(vector<Ty> &a) {
    auto cmp = [](const Ty &a, const Ty &b) { return make_pair(a.x, -a.y) < make_pair(b.x, -b.y); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].x != a[i - 1].x)
            a[i].y = m - 1;
        else
            a[i].y = a[i - 1].y - 1;
    }
}


template<typename Ty>
void up(vector<Ty> &a) {
    auto cmp = [](const Ty &a, const Ty &b) { return make_pair(a.y, a.x) < make_pair(b.y, b.x); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].y != a[i - 1].y)
            a[i].x = 0;
        else
            a[i].x = a[i - 1].x + 1;
    }
}


template<typename Ty>
void down(vector<Ty> &a) {
    auto cmp = [](const Ty &a, const Ty &b) { return make_pair(a.y, -a.x) < make_pair(b.y, -b.x); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].y != a[i - 1].y)
            a[i].x = n - 1;
        else
            a[i].x = a[i - 1].x - 1;
    }
}


void solve(istream &cin, ostream &cout) {
    cin >> n >> m;
    vector<st> a;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c != '.')
                a.emplace_back(i, j, c);
        }
    }


    string s, buf;
    cin >> s;


    auto tp = [](char c) {
        return (c == 'L' || c == 'R') ? 0 : 1;
    };

    // Optimize
    auto opt = [&]() {
        buf = move(s);
        for (ll i = 0; i < buf.size(); ++i) {
            if (s.empty()) {
                s.push_back(buf[i]);
            } else if (tp(s.back()) == tp(buf[i])) {
                s.back() = buf[i];
            } else if (s.size() >= 2 && tp(s.back()) != tp(s[s.size() - 2]) && s[s.size() - 2] == buf[i]) {
                continue;
            } else {
                s.push_back(buf[i]);
            }
        }
    };
    opt();
    opt();
    opt();


    constexpr ll I = 8;
    if (s.size() > I * I) {
        ll i = 0;
        for (; i < I && i < s.size(); ++i) {
            if (s[i] == 'L')
                left(a);
            else if (s[i] == 'R')
                right(a);
            else if (s[i] == 'U')
                up(a);
            else if (s[i] == 'D')
                down(a);
        }

        vector<stt> b(a.size());
        for (ll i = 0; i < a.size(); ++i)
            b[i] = stt(a[i].x, a[i].y);
        for (ll i = I; i < I + 4; ++i) {
            if (s[i] == 'L')
                left(b);
            else if (s[i] == 'R')
                right(b);
            else if (s[i] == 'U')
                up(b);
            else if (s[i] == 'D')
                down(b);
        }
        array<vector<vector<pair<ll, ll>>>, 27> pp;
        for (auto &t: pp)
            t.resize(n, vector<pair<ll, ll>>(m));
        for (auto &[x, y, a, b]: b)
            pp[0][a][b] = {x, y};
        for (ll k = 1; k < pp.size(); ++k) {
            for (ll i = 0; i < n; ++i) {
                for (ll j = 0; j < m; ++j) {
                    auto [q, w] = pp[k - 1][i][j];
                    pp[k][i][j] = pp[k - 1][q][w];
                }
            }
        }


        for (ll k = pp.size() - 1; k >= 0; --k) {
            while (i + (1ll << k) + I <= s.size()) {
                for (auto &t: a) {
                    auto [q, w] = pp[k][t.x][t.y];
                    t.x = q, t.y = w;
                }
                i += (1ll << k);
            }
        }
        for (; i < s.size(); ++i) {
            if (s[i] == 'L')
                left(a);
            else if (s[i] == 'R')
                right(a);
            else if (s[i] == 'U')
                up(a);
            else if (s[i] == 'D')
                down(a);
        }


    } else {
        for (ll i = 0; i < s.size(); ++i) {
            if (s[i] == 'L')
                left(a);
            else if (s[i] == 'R')
                right(a);
            else if (s[i] == 'U')
                up(a);
            else if (s[i] == 'D')
                down(a);
        }
    }

    vector<string> res(n, string(m, '.'));
    for (auto &[x, y, c]: a)
        res[x][y] = c;
    for (auto &tt: res) {
        cout << tt << '\n';
    }
}