#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int _ = 1;
    cin >> _;
    while (_--)
        solve(cin, cout);
}


struct st {
    ll x = 0, y = 0;
    char c = '.';


    st() = default;

    st(ll x, ll y, char c) : x(x), y(y), c(c) {}
};


ll n, m;

void left(vector<st> &a) {
    auto cmp = [](const st &a, const st &b) { return make_pair(a.x, a.y) < make_pair(b.x, b.y); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].x != a[i - 1].x)
            a[i].y = 0;
        else
            a[i].y = a[i - 1].y + 1;
    }
}


void right(vector<st> &a) {
    auto cmp = [](const st &a, const st &b) { return make_pair(a.x, -a.y) < make_pair(b.x, -b.y); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].x != a[i - 1].x)
            a[i].y = m - 1;
        else
            a[i].y = a[i - 1].y - 1;
    }
}


void up(vector<st> &a) {
    auto cmp = [](const st &a, const st &b) { return make_pair(a.y, a.x) < make_pair(b.y, b.x); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].y != a[i - 1].y)
            a[i].x = 0;
        else
            a[i].x = a[i - 1].x + 1;
    }
}


void down(vector<st> &a) {
    auto cmp = [](const st &a, const st &b) { return make_pair(a.y, -a.x) < make_pair(b.y, -b.x); };
    sort(a.begin(), a.end(), cmp);
    for (ll i = 0; i < a.size(); ++i) {
        if (i == 0 || a[i].y != a[i - 1].y)
            a[i].x = n - 1;
        else
            a[i].x = a[i - 1].x - 1;
    }
}


void solve(istream &cin, ostream &cout) {
    cin >> n >> m;
    vector<st> a;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c != '.')
                a.emplace_back(i, j, c);
        }
    }


    string s, buf;
    cin >> s;


    auto tp = [](char c) {
        return (c == 'L' || c == 'R') ? 0 : 1;
    };

    // Optimize
    auto opt = [&]() {
        buf = move(s);
        for (ll i = 0; i < buf.size(); ++i) {
            if (s.empty()) {
                s.push_back(buf[i]);
            } else if (tp(s.back()) == tp(buf[i])) {
                s.back() = buf[i];
            } else if (s.size() >= 2 && tp(s.back()) != tp(s[s.size() - 2]) && s[s.size() - 2] == buf[i]) {
                continue;
            } else {
                s.push_back(buf[i]);
            }
        }
    };
    opt();
    opt();
    opt();


    //while (s.size() > 4 && s.substr(s.size() - 4) == "LURD")
    //    s.resize(s.size() - 4);


    for (auto &c: s) {
        if (c == 'L')
            left(a);
        else if (c == 'R')
            right(a);
        else if (c == 'U')
            up(a);
        else
            down(a);
    }


    vector<string> res(n, string(m, '.'));
    for (auto &[x, y, c]: a)
        res[x][y] = c;
    for (auto &tt: res) {
        cout << tt << '\n';
    }
}