#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

void solve();
void change(vector<vector<int>>& ids, char cmd);

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}

void change(vector<vector<int>>& ids, char cmd) {
    int n = (int)ids.size(), m = (int)ids[0].size();
    vector<vector<int>> result(n, vector<int>(m, 0));
    if (cmd == 'L') {
        for (int i = 0; i < n; ++i) {
            int id = 0;
            for (int j = 0; j < m; ++j) {
                if (ids[i][j] != 0) {
                    result[i][id] = ids[i][j];
                    ++id;
                }
            }
        }
    } else if (cmd == 'R') {
        for (int i = 0; i < n; ++i) {
            int id = m-1;
            for (int j = m-1; j >= 0; --j) {
                if (ids[i][j] != 0) {
                    result[i][id] = ids[i][j];
                    --id;
                }
            }
        }
    } else if (cmd == 'D') {
        for (int j = 0; j < m; ++j) {
            int id = n-1;
            for (int i = n-1; i >= 0; --i) {
                if (ids[i][j] != 0) {
                    result[id][j] = ids[i][j];
                    --id;
                }
            }
        }
    } else {
        for (int j = 0; j < m; ++j) {
            int id = 0;
            for (int i = 0; i < n; ++i) {
                if (ids[i][j] != 0) {
                    result[id][j] = ids[i][j];
                    ++id;
                }
            }
        }
    }
    ids.swap(result);
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> ids(n, vector<int>(m, 0));
    string chars = ".";
    int idx = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c; cin >> c;
            if (c != '.') {
                chars += c;
                ids[i][j] = idx;
                ++idx;
            }
        }
    }
    string cmd;
    cin >> cmd;
    string s_cmd;
    char LR = 'x', UD = 'x';
    for (auto c : cmd) {
        if (c == 'L' || c == 'R') {
            if (c==LR) continue;
            if (s_cmd.empty() || (s_cmd.back() == 'U' || s_cmd.back()=='D')) {
                s_cmd += c;
                LR = c;
            } else if ((s_cmd.back() == 'L' || s_cmd.back()=='R')) {
                s_cmd.pop_back();
                if (s_cmd.size() < 2) {
                    s_cmd += c;
                    LR = c;
                } else {
                    LR = ('L'+'R')-LR;
                }
            }
        } else {
            if (c==UD) continue;
            if (s_cmd.empty() || (s_cmd.back() == 'L' || s_cmd.back()=='R')) {
                s_cmd += c;
                UD = c;
            } else if ((s_cmd.back() == 'U' || s_cmd.back()=='D')) {
                s_cmd.pop_back();
                if (s_cmd.size() < 2) {
                    s_cmd += c;
                    UD = c;
                } else {
                    UD = ('U'+'D')-UD;
                }
            }
        }
    }
    //cout << s_cmd << '\n';
    for (auto c : s_cmd) {
        change(ids, c);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << chars[ids[i][j]];
        }
        cout << '\n';
    }
}