#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

void solve();
void change(vector<vector<int>>& ids, char cmd);

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}

void change(vector<vector<int>>& ids, char cmd) {
    int n = (int)ids.size(), m = (int)ids[0].size();
    vector<vector<int>> result(n, vector<int>(m, 0));
    if (cmd == 'L') {
        for (int i = 0; i < n; ++i) {
            int id = 0;
            for (int j = 0; j < m; ++j) {
                if (ids[i][j] != 0) {
                    result[i][id] = ids[i][j];
                    ++id;
                }
            }
        }
    } else if (cmd == 'R') {
        for (int i = 0; i < n; ++i) {
            int id = m-1;
            for (int j = m-1; j >= 0; --j) {
                if (ids[i][j] != 0) {
                    result[i][id] = ids[i][j];
                    --id;
                }
            }
        }
    } else if (cmd == 'D') {
        for (int j = 0; j < m; ++j) {
            int id = n-1;
            for (int i = n-1; i >= 0; --i) {
                if (ids[i][j] != 0) {
                    result[id][j] = ids[i][j];
                    --id;
                }
            }
        }
    } else {
        for (int j = 0; j < m; ++j) {
            int id = 0;
            for (int i = 0; i < n; ++i) {
                if (ids[i][j] != 0) {
                    result[id][j] = ids[i][j];
                    ++id;
                }
            }
        }
    }
    ids.swap(result);
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> ids(n, vector<int>(m, 0));
    string chars = ".";
    int idx = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c; cin >> c;
            if (c != '.') {
                chars += c;
                ids[i][j] = idx;
                ++idx;
            }
        }
    }
    string cmd;
    cin >> cmd;
    string s_cmd;
    char LR = 'x', UD = 'x';
    for (auto c : cmd) {
        if (c == 'L' || c == 'R') {
            if (c==LR) continue;
            if (s_cmd.empty() || (s_cmd.back() == 'U' || s_cmd.back()=='D')) {
                s_cmd += c;
                LR = c;
            } else if ((s_cmd.back() == 'L' || s_cmd.back()=='R')) {
                s_cmd.pop_back();
                if (s_cmd.size() < 2) {
                    s_cmd += c;
                    LR = c;
                } else {
                    LR = ('L'+'R')-LR;
                }
            }
        } else {
            if (c==UD) continue;
            if (s_cmd.empty() || (s_cmd.back() == 'L' || s_cmd.back()=='R')) {
                s_cmd += c;
                UD = c;
            } else if ((s_cmd.back() == 'U' || s_cmd.back()=='D')) {
                s_cmd.pop_back();
                if (s_cmd.size() < 2) {
                    s_cmd += c;
                    UD = c;
                } else {
                    UD = ('U'+'D')-UD;
                }
            }
        }
    }
    if (s_cmd.size() < 10) {
        for (auto c : s_cmd) {
            change(ids, c);
        }
    } else {
        change(ids, s_cmd[0]);
        change(ids, s_cmd[1]);
        int cnt = (s_cmd.size()-2)/4;
        vector<vector<int>> idsc = ids;
        for (int i = 0; i < 4; ++i) change(idsc, s_cmd[i+2]);
        /*for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << ids[i][j];
            }
            cout << '\n';
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << idsc[i][j];
            }
            cout << '\n';
        }*/
        vector<int> to(idx);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                to[idsc[i][j]] = ids[i][j];
            }
        }
        /*for (int i = 0; i < idx; ++i) {
            cout << i << ' ' << to[i] << '\n';
        }
        cout << cnt << '\n';*/
        vector<vector<int>> cycles;
        vector<int> cycleid(idx, -1);
        vector<int> id(idx, -1);
        for (int i = 0; i < idx; ++i) {
            if (cycleid[i] >= 0) continue;
            cycleid[i] = cycles.size();
            id[i] = 0;
            cycles.emplace_back();
            cycles.back().emplace_back(i);
            for (int j = to[i]; j!=i; j = to[j]) {
                cycleid[j] = cycleid[i];
                id[j] = cycles.back().size();
                cycles.back().emplace_back(j);
            }
        }
        for (int i = 0; i < idx; ++i) {
            int j = (id[i]+cnt)%(int)cycles[cycleid[i]].size();
            to[i] = cycles[cycleid[i]][j];
        }
        vector<int> from(idx);
        for (int i = 0; i < idx; ++i) {
            from[to[i]] = i;
        }
        /*cout << "!!!\n";
        for (auto& i : cycles) {
            for (auto j : i) {
                cout << j << ' ';
            }
            cout << '\n';
        }
        cout << "!!!\n";
        for (int i = 0; i < idx; ++i) {
            cout << i << ' ' << to[i] << '\n';
        }*/
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                idsc[i][j] = from[ids[i][j]];
            }
        }
        ids.swap(idsc);
        /*for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << ids[i][j];
            }
            cout << '\n';
        }*/
        for (int i = 0; i < (s_cmd.size()-2)%4; ++i) change(ids, s_cmd[i+2+cnt*4]);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << chars[ids[i][j]];
        }
        cout << '\n';
    }
}