#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

void solve1(int n, int m, int k, int p);
void solve2(int n, int m, int k, int p);

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c; cin >> c;
    if (c == 1) {
        solve1(n, m, k, p);
    } else if (c == 2) {
        solve2(n, m, k, p);
    }

    return 0;
}

void solve1(int n, int m, int k, int p) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
    }
    int id = 0;
    int cnt = 0;
    vector<int> V(k, 0);
    while (id < n) {
        if (V[a[id]]%p == 0) {
            if (cnt == m) {
                break;
            } else {
                ++cnt;
            }
        }
        ++V[a[id]];
        ++id;
    }
    int64_t ans = n+1+(n-id)*2;
    int cur = 0;
    for (int i = 0; i < k; ++i) {
        V[i] = p-V[i]%p;
        if (V[i] == p) V[i] = 0;
        else ++cur;
    }
    cnt = cur;
    while (id < n) {
        if (V[a[id]] == 0) {
            if (cnt == m) {
                ans += (n-id)*2;
                cnt = cur;
            }
            V[a[id]] = p;
            ++cnt; ++cur;
        }
        --V[a[id]];
        if (V[a[id]] == 0) --cur;
        ++id;
    }
    cout << ans << '\n';
}

int count(int n, int m, int k, int p, const vector<int>& a);

void solve2(int n, int m, int k, int p) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
    }
    int c = count(n, m, k, p, a);
    //cout << c << '\n';
    int64_t ans = n+1+c*2;
    vector<int> V(k, 0);
    int cnt = 0, cur = 0, id = c-1;
    while (id >= 0) {
        if (V[a[id]] == 0) {
            if (cnt == m) {
                //cout << "! " << id << '\n';
                ans += (id+1)*2;
                cnt = cur;
            }
            V[a[id]] = p;
            ++cnt; ++cur;
        }
        --V[a[id]];
        if (V[a[id]] == 0) --cur;
        --id;
    }
    cout << ans << '\n';
}

int count(int n, int m, int k, int p, const vector<int>& a) {
    vector<int> ostV(k, 0);
    for (int i = 0; i < n; ++i) {
        ++ostV[a[i]];
    }
    vector<int> need(k);
    int64_t sum = 0;
    for (int i = 0; i < k; ++i) {
        need[i] = (ostV[i]+p-1)/p;
        sum += need[i];
    }
    int available = m;
    if (available >= sum) {
        return 0;
    }
    vector<int> ost(k, 0);
    for (int i = 0; i < n; ++i) {
        if (ost[a[i]] == 0) {
            --available;
            ost[a[i]] = p;
        }
        --ost[a[i]];
        if (ost[a[i]] == 0) ++available;
        --ostV[a[i]];
        int newneed = (max(ostV[a[i]]-ost[a[i]], 0)+p-1)/p;
        sum += newneed-need[a[i]];
        need[a[i]] = newneed;
        if (sum <= available) {
            return i+1;
        }
    }
    return n;
}