#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <random>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void stup_op(vector<string>& s, char op)
{
	long long n = s.size(), m = s[0].size();
	vector<string> ns(n, string(m, '.'));
	if (op == 'L')
	{
		for (long long i = 0; i < n; i++)
		{
			long long idx = 0;
			for (long long j = 0; j < m; j++)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[i][idx++] = s[i][j];
			}
		}
	}
	else if (op == 'R')
	{
		for (long long i = 0; i < n; i++)
		{
			long long idx = m - 1;
			for (long long j = m - 1; j > -1; j--)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[i][idx--] = s[i][j];
			}
		}
	}
	else if (op == 'U')
	{
		for (long long j = 0; j < m; j++)
		{
			long long idx = 0;
			for (long long i = 0; i < n; i++)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[idx++][j] = s[i][j];
			}
		}
	}
	else
	{
		for (long long j = 0; j < m; j++)
		{
			long long idx = n - 1;
			for (long long i = n - 1; i > -1; i--)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[idx--][j] = s[i][j];
			}
		}
	}

	swap(s, ns);
}

void solve()
{
	long long n, m;
	vector<string> s;
	cin >> n >> m;
	s.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> s[i];
	}
	string qr;
	cin >> qr;
	long long q = qr.size();

	string nqr;
	nqr.reserve(q);
	vector<bool> optype(26);
	optype['U' - 'A'] = optype['D' - 'A'] = true;
	for (auto& i : qr)
	{
		if (!nqr.size())
		{
			nqr.push_back(i);
			continue;
		}
		
		if (optype[nqr.back() - 'A'] == optype[i - 'A'])
		{
			nqr.pop_back();
		}
		if (nqr.size() < 2 || nqr[nqr.size() - 2] != i)
		{
			nqr.push_back(i);
		}
	}
	swap(qr, nqr);
	q = qr.size();

	if (q <= 10)
	{
		for (auto& op : qr)
		{
			stup_op(s, op);
		}
		for (auto& i : s)
		{
			cout << i << "\n";
		}
		return;
	}

	/*
	string rqr = qr;
	reverse(rqr.begin(), rqr.end());
	long long times_stup = 2;
	while (rqr.size() % 4 || times_stup > 0)
	{
		stup_op(s, rqr.back());
		times_stup--;
	}
	reverse(rqr.begin(), rqr.end());
	swap(qr, rqr);
	q = qr.size();
	*/

	for (auto& op : qr)
	{
		stup_op(s, op);
	}
	for (auto& i : s)
	{
		cout << i << "\n";
	}
	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
