#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <random>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct seg
{
	long long h, l, r;
	bool op;
};

void solve()
{
	long long n;
	vector<seg> ev;
	cin >> n;
	ev.reserve(n * 2);
	for (long long i = 0; i < n; i++)
	{
		long long x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		ev.push_back({ y1, x1, x2, true });
		ev.push_back({ y2 + 1, x1, x2, false });
	}

	sort(ev.begin(), ev.end(),
		[&](seg& a, seg& b)
		{
			if (a.h == b.h)
			{
				return a.op > b.op;
			}
			return a.h < b.h;
		}
	);
	vector<bool> block_end(ev.size());
	for (long long i = 0; i < ev.size() - 1; i++)
	{
		if (ev[i].h != ev[i + 1].h)
		{
			block_end[i] = true;
		}
	}
	block_end.back() = true;

	multiset<pair<long long, long long>> alive;
	long long prev = ev[0].h;
	vector<pair<long long, long long>> upd;
	map<pair<long long, long long>, long long> cnt, cons, lst, cur;
	for (long long i = 0; i < ev.size(); i++)
	{
		for (auto& j : upd)
		{
			cnt[j] += ev[i].h - prev;
			if (lst.find(j) == lst.end())
			{
				lst[j] = -5;
				cur[j] = 0;
				cons[j] = 0;
			}
			if (lst[j] == prev - 1)
			{
				cur[j] += ev[i].h - prev;
			}
			else
			{
				cur[j] = ev[i].h - prev;
			}
			cons[j] = max(cons[j], cur[j]);
			lst[j] = ev[i].h - 1;
		}
		upd = {};

		if (ev[i].op)
		{
			alive.insert({ ev[i].l, ev[i].r });
		}
		else
		{
			alive.erase(alive.find({ ev[i].l, ev[i].r }));
		}

		if (block_end[i] && alive.size())
		{
			long long curl = alive.begin()->first, curr = alive.begin()->second;
			for (auto& j : alive)
			{
				if (curr + 1 < j.first)
				{
					upd.push_back({ curl, curr });

					curl = j.first;
					curr = j.second;
				}
				else
				{
					curr = max(curr, j.second);
				}
			}
			upd.push_back({ curl, curr });
		}
		prev = ev[i].h;
	}
	cout << cnt.size() << "\n";
	for (auto& i : cnt)
	{
		cout << i.first.first << " " << i.first.second << " " << i.second << " " << cons[i.first] << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
