#include <bits/stdc++.h>
using namespace std;

struct Fenwick {
    int n;
    vector<int> fen;
    Fenwick() {}
    Fenwick(int _n) {
        n = _n;
        fen.resize(n + 1);
    }
    void add(int i, int x) {
        while (i <= n) {
            fen[i] += x;
            i += (i & -i);
        }
    }
    int getPref(int r) {
        int res = 0;
        while (r > 0) {
            res += fen[r];
            r -= (r & -r);
        }
        return res;
    }
    int getSum(int l, int r) {
        return getPref(r) - getPref(l - 1);
    }
    ~Fenwick() {}
};

void solve() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector<long long> need(n + m), lim(n + m);
    vector<int> type(n + m), evs(n + m);
    long long bar = 0;
    for (int i = 0; i < n + m; ++i) {
        int h;
        cin >> type[i] >> h;
        if (type[i] == 1) {
            bar += h;
            need[i] = bar;
        } else {
            need[i] = bar + h - 1;
        }
        lim[i] = bar;
        evs[i] = i;
    }
    sort(evs.begin(), evs.end(), [&](const int& A, const int& B) {
        return need[A] < need[B];
    });
    Fenwick fen(n + m);
    long long ans = 0;
    for (const int& i : evs) {
        if (type[i] == 2) {
            fen.add(i + 1, 1);
        }
        int stop = upper_bound(lim.begin(), lim.end(), need[i]) - lim.begin();
        int cnt = fen.getPref(stop);
        ans = max(ans, cnt * 1ll * p - need[i] * 1ll * c);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "---------\n";
        cout << "---------\n";
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif

    return 0;
}