#include <iostream>
#include <vector>
#include <algorithm>

int64_t c, p;

struct Object {
	bool is_order;
	int64_t h;
};

std::vector<Object> objects;

void input_data() {
	int64_t n, m;
	std::cin >> n >> m >> c >> p;

	objects.resize(n + m);
	for (auto& [is_order, h] : objects) {
		int64_t t;
		std::cin >> t >> h;

		is_order = t == 2;
	}
}

std::vector<int64_t> h_to_deliver;

void compute_h_to_deliver() {
	h_to_deliver.reserve(objects.size());

	int64_t total_wall_h = 0;
	for (auto [is_order, h] : objects) {
		if (is_order) {
			h_to_deliver.push_back(total_wall_h + h);
		} else {
			total_wall_h += h;
		}
	}
}

int64_t compute_max_profit() {
	std::sort(h_to_deliver.begin(), h_to_deliver.end());

	int64_t max_profit = 0;
	for (int64_t i = 0; i < h_to_deliver.size(); ++i) {
		max_profit = std::max(p * (i + 1) - (h_to_deliver[i] - 1) * c, max_profit);
	}
	return max_profit;
}

int main() {
	input_data();
	compute_h_to_deliver();
	std::cout << compute_max_profit();
}
