#include <iostream>
#include <vector>
#include <algorithm>

int64_t n, m;
std::vector<char> board;

void input_board() {
	std::cin >> n >> m;
	board.resize(n * m);
	for (int64_t i = 0; i < n; ++i) {
		for (int64_t j = 0; j < m; ++j) {
			std::cin >> board[i * m + j];
		}
	}
}

void left() {
	for (int64_t i = 0; i < n; ++i) {
		int64_t new_j = 0;
		for (int64_t j = 0; j < m; ++j) {
			if (board[i * m + j] != '.') {
				board[i * m + new_j] = std::exchange(board[i * m + j], '.');
				++new_j;
			}
		}
	}
}

void right() {
	for (int64_t i = 0; i < n; ++i) {
		int64_t new_j = m - 1;
		for (int64_t j = m - 1; j >= 0; --j) {
			if (board[i * m + j] != '.') {
				board[i * m + new_j] = std::exchange(board[i * m + j], '.');
				--new_j;
			}
		}
	}
}

void up() {
	for (int64_t j = 0; j < m; ++j) {
		int64_t new_i = 0;
		for (int64_t i = 0; i < n; ++i) {
			if (board[i * m + j] != '.') {
				board[new_i * m + j] = std::exchange(board[i * m + j], '.');
				++new_i;
			}
		}
	}
}

void down() {
	for (int64_t j = 0; j < m; ++j) {
		int64_t new_i = n - 1;
		for (int64_t i = n - 1; i >= 0; --i) {
			if (board[i * m + j] != '.') {
				board[new_i * m + j] = std::exchange(board[i * m + j], '.');
				--new_i;
			}
		}
	}
}

void print_board() {
	for (int64_t i = 0; i < n; ++i) {
		for (int64_t j = 0; j < m; ++j) {
			std::cout << board[i * m + j];
		}
		std::cout << '\n';
	}
}


int main() {
	int64_t t;
	std::cin >> t;

	for (int64_t i = 0; i < t; ++i) {
		input_board();

		std::string queries;
		std::cin >> queries;

		for (char c : queries) {
			switch (c) {
			case 'L': left(); break;
			case 'R': right(); break;
			case 'U': up(); break;
			case 'D': down(); break;
			default: break;
			}
		}

		print_board();
	}
}
