#include <iostream>
#include <vector>
#include <algorithm>

using std::swap;

int64_t m, k, p, c;
std::vector<int64_t> a;

int64_t inf = 1'000'000'000;

void input_data() {
	int64_t n;
	std::cin >> n >> m >> k >> p >> c;

	a.resize(n);
	for (int64_t& v : a) {
		std::cin >> v;
		--v;
	}
}

std::vector<int64_t> t;

void compute_t() {
	t.reserve(a.size());
	std::vector<int64_t> counts(k, 0);
	for (int64_t v : a) {
		++counts[v];
		if (p == 1) {
			t.push_back(2);
		} else if (counts[v] % p == 0) {
			t.push_back(-1);
		} else if (counts[v] % p == 1) {
			t.push_back(1);
		} else {
			t.push_back(0);
		}
	}
}

int64_t opt_min(int64_t a, int64_t b) {
	if (a == inf) {
		return b;
	} else if (b == inf) {
		return a;
	} else {
		return std::min(a, b);
	}
}

int64_t get_restock_dist(int64_t i) {
	if (c == 1) {
		return 2 * (a.size() - i) - 2;
	} else if (c == 2) {
		return 2 * (i + 1);
	} else {
		return std::min<int64_t>(2 * (a.size() - i) - 2, 2 * (i + 1));
	}
}

std::vector<int64_t> min_dist;

void compute_min_dist() {
	if (c != 1) {
		min_dist.resize((m + 1) * (m + 1), inf);
		min_dist[0] = 0;
		std::vector<int64_t> new_min_dist(min_dist.size(), inf);

		for (int64_t i = 0; i < t.size(); ++i) {
			if (t[i] == 1 || t[i] == 2) {
				for (int64_t empty = 0; empty <= m; ++empty) {
					for (int64_t part = 1; empty + part <= m; ++part) {
						new_min_dist[empty * (m + 1) + part] = min_dist[empty * (m + 1) + part - 1];
					}
				}

				swap(min_dist, new_min_dist);
				new_min_dist.assign(new_min_dist.size(), inf);
			}

			if (t[i] == -1 || t[i] == 2) {
				for (int64_t empty = 1; empty <= m; ++empty) {
					for (int64_t part = 0; empty + part <= m; ++part) {
						new_min_dist[empty * (m + 1) + part] = min_dist[(empty - 1) * (m + 1) + part + 1];
					}
				}

				swap(min_dist, new_min_dist);
				new_min_dist.assign(new_min_dist.size(), inf);
			}

			for (int64_t part = 0; part <= m; ++part) {
				for (int64_t empty = 0; empty <= m; ++empty) {
					new_min_dist[empty * (m + 1) + part] = min_dist[empty * (m + 1) + part];
					if (min_dist[empty * (m + 1) + part] != inf) {
						new_min_dist[part] = opt_min(min_dist[empty * (m + 1) + part] + get_restock_dist(i), new_min_dist[part]);
					}
				}
			}

			swap(min_dist, new_min_dist);
			new_min_dist.assign(new_min_dist.size(), inf);
		}
	} else {
		min_dist.resize((m + 1), inf);
		min_dist[0] = 0;
		std::vector<int64_t> new_min_dist(min_dist.size(), inf);
		std::vector<int64_t> empty(m + 1, 0);

		for (int64_t i = 0; i < t.size(); ++i) {
			if (t[i] == 1 || t[i] == 2) {
				for (int64_t part = 1; part <= m; ++part) {
					new_min_dist[part] = min_dist[part - 1];
				}

				swap(min_dist, new_min_dist);
				new_min_dist.assign(new_min_dist.size(), inf);
			}

			if (t[i] == -1 || t[i] == 2) {
				for (int64_t part = 0; part < m; ++part) {
					new_min_dist[part] = min_dist[part + 1];
				}

				swap(min_dist, new_min_dist);
				new_min_dist.assign(new_min_dist.size(), inf);

				for (int64_t& v : empty) {
					++v;
				}
			}

			for (int64_t part = 0; part <= m; ++part) {
				new_min_dist[part] = min_dist[part];
				if (empty[part] + part >= m && min_dist[part] != inf) {
					new_min_dist[part] = min_dist[part] + get_restock_dist(i);
					empty[part] = 0;
				}
			}

			swap(min_dist, new_min_dist);
			new_min_dist.assign(new_min_dist.size(), inf);
		}
	}
}

int64_t get_min_dist() {
	int64_t res = inf;
	for (int64_t dist : min_dist) {
		res = opt_min(dist, res);
	}
	return res + a.size() + 1;
}

int main() {
	input_data();
	compute_t();
	compute_min_dist();
	std::cout << get_min_dist();
}
