#include <bits/stdc++.h>
#define int long long
using namespace std;

struct st {
    static constexpr int size = 1 << 20;
    int tree[size * 2 - 1];

    void set(int i, int v) {
        int x = size + i - 1;
        tree[x] = v;

        while (x) {
            x = (x - 1) / 2;
            tree[x] = min(tree[x * 2 + 1], tree[x * 2 + 2]);
        }
    }

    int get(int l, int r, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }

        if (l >= rx || lx >= r) {
            return LLONG_MAX;
        }

        return min(
                get(l, r, x * 2 + 1, lx, (lx + rx) / 2),
                get(l, r, x * 2 + 2, (lx + rx) / 2, rx)
                );
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k, p;
    cin >> n >> m >> k >> p;

    int c;
    cin >> c;

    vector<int> starts(n + 1);
    vector<int> ends(n + 1);

    vector<int> b(k);

    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        x--;

        b[x] += 1;

        if (b[x] == 1) {
            starts[i] += 1;
        }

        if (b[x] == p || i == n) {
            ends[i] += 1;
            b[x] = 0;
        }
    }

    auto dist = [&](int i, int j) -> int {
        return abs(i - j);
    };

    int l = 1;
    int cnt = 0;

    vector<int> dp(n + 1, LLONG_MAX);

    vector<int> cost(n + 1);
    for (int j = 1; j <= n; j++) {
        int val = 0;
        if (c == 1) {
            val += dist(j - 1, n + 1) + dist(n + 1, j);
        } else if (c == 2) {
            val += dist(j - 1, 0) + dist(0, j);
        } else {
            val += min(
                    dist(j - 1, n + 1) + dist(n + 1, j),
                    dist(j - 1, 0) + dist(0, j)
            );
        }

        cost[j] = val;
    }

    for (int r = 1; r <= n; r++) {
        cnt += starts[r];

        while (cnt > m) {
            cnt -= ends[l];
            l++;
        }

        if (l == 1) {
            dp[r] = r;
        } else {
            for (int j = l; j <= r; j++) {
                int val = dp[j - 1] + cost[j] - j + r;

                dp[r] = min(dp[r], val);
            }
        }
    }

    cout << dp.back() + 1 << '\n';
    return 0;
}