#include <bits/stdc++.h>
using namespace std;

struct rect {
    int x1, x2, y1, y2;
};

void solve() {
    int n;
    cin >> n;

    vector<rect> A(n);

    int W = 0;
    int H = 0;

    map<int, vector<pair<int, int>>> plus, minus;

    for (auto &[x1, x2, y1, y2] : A) {
        cin >> x1 >> y1 >> x2 >> y2;
        W = max(W, x2 + 1);
        H = max(H, y2 + 1);

        plus[y1].emplace_back(x1, x2);
        minus[y2 + 1].emplace_back(x1, x2);
    }

    vector<int> row(W);

    map<pair<int, int>, vector<int>> Q;

    for (int y = 0; y < H; y++) {
        vector<int> cur(W);

        for (const auto &[l, r] : plus[y]) {
            cur[l] += 1;
            if (r + 1 < W) {
                cur[r + 1] -= 1;
            }
        }

        for (const auto &[l, r] : minus[y]) {
            cur[l] -= 1;
            if (r + 1 < W) {
                cur[r + 1] += 1;
            }
        }

        for (int i = 1; i < W; i++) {
            cur[i] += cur[i - 1];
        }

        for (int i = 0; i < W; i++) {
            row[i] += cur[i];
        }

        for (int r = W - 1; r >= 0; r--) {
            if (row[r]) {
                int l = r;

                while (l > 0 && row[l - 1]) {
                    l--;
                }

                Q[pair(l, r)].push_back(y);

                r = l;
            }
        }
    }

    cout << Q.size() << '\n';

    for (const auto &item : Q) {
        cout << item.first.first << ' ' << item.first.second << ' ' << item.second.size() << ' ';

        auto t = item.second;

        int cur = 0;
        int prev = INT32_MIN;

        int mx = 0;

        for (int y : t) {
            if (prev != y - 1) {
                cur = 0;
            }

            cur++;
            mx = max(mx, cur);
            prev = y;
        }

        cout << mx << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}