#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>
using namespace std;
using ll = long long;
const ll INF = 1e18;
vector<ll> aa;
class SegmentTree
{
public:
	class Node
	{
	public:
		ll mx=-INF;
		ll push = 0;
		Node() { }
	};
	vector<Node> tree;
	int n;
	const void Push(int v)
	{
		tree[2*v+1].mx += tree[v].push;
		tree[2 * v + 1].push += tree[v].push;
		tree[2*v+2].mx += tree[v].push;
		tree[2 * v + 1].push += tree[v].push;
		tree[v].push = 0;
	}
	const void Build()
	{
		n = aa.size();
		tree.resize(4 * n);
		Build(0, 0, n);
	}
	const void Build(int v, int l, int r)
	{
		if (r - l == 1)
		{
			tree[v].mx = aa[l];
			return;
		}
		int mid = (r + l) / 2;
		Build(2*v+1, l, mid);
		Build(2*v+2, mid, r);
		tree[v].mx = max(tree[2*v+1].mx, tree[2*v+2].mx);
	}
	const void Set(int& l, int& x)
	{
		Set(0, 0, n, l, n, x);
	}
	const void Set(int v, int l, int r, int& ql, int& qr, int& x)
	{
		if (r <= ql || qr <= l)
		{
			return;
		}
		if (ql <= l && r <= qr)
		{
			tree[v].mx += x;
			tree[v].push += x;
			return;
		}
		int mid = (r + l) / 2;
		Push(v);
		Set(2*v+1, l, mid, ql, qr, x);
		Set(2*v+2, mid, r, ql, qr, x);
		tree[v].mx = max(tree[2*v+1].mx, tree[2*v+2].mx);
	}
	const ll Get()
	{
		return tree[0].mx;
	}
};

int main()
{
	/*ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);*/
	int n, m, c, p;
	cin >> n >> m >> c >> p;
	vector<pair<int, int>> a(n+m);
	vector<ll> b;
	b.reserve(m);
	ll cnt = 0;
	for (int i = 0; i < n + m; i++)
	{
		int t; ll h;
		cin >> t >> h;
		a[i] = { t,h };
		if (t == 1)
		{
			cnt += h;
		}
		else
		{
			b.push_back(h + cnt-1);
		}
	}
	//for (int i = 0; i < n + m; i++)
	//{
	//	int t=2; ll h=i+1;
	//	//cin >> t >> h;
	//	a[i] = { t,h };
	//	if (t == 1)
	//	{
	//		cnt += h;
	//	}
	//	else
	//	{
	//		b.push_back(h + cnt-1);
	//	}
	//}
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	map<ll, int> to;
	int bsz = b.size();
	aa.resize(bsz);
	for (int i = 0; i < bsz; i++)
	{
		to[b[i]] = i;
		aa[i] = -b[i] * c;
	}
	SegmentTree tree;
	tree.Build();
	cnt = 0;
	for (int i = 0; i < n + m; i++)
	{
		int t = a[i].first; ll h = a[i].second;
		if (t == 1)
		{
			cnt += h;
		}
		else
		{
			tree.Set(to[h+cnt-1], p);
		}
	}
	cout << max((ll)0,tree.Get()) << '\n';
}
