#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <string>
using namespace std;
using ll = long long;
const ll INF = 1e18;
vector<ll> aa;
class SegmentTree
{
public:
	class Node
	{
	public:
		ll mx = -INF;
		ll push = 0;
		Node() { }
	};
	vector<Node> tree;
	int n;
	const void Push(int v)
	{
		tree[2 * v + 1].mx += tree[v].push;
		tree[2 * v + 1].push += tree[v].push;
		tree[2 * v + 2].mx += tree[v].push;
		tree[2 * v + 2].push += tree[v].push;
		tree[v].push = 0;
	}
	const void Build()
	{
		n = aa.size();
		tree.resize(4 * n);
		Build(0, 0, n);
	}
	const void Build(int v, int l, int r)
	{
		if (r - l == 1)
		{
			tree[v].mx = aa[l];
			return;
		}
		int mid = (r + l) / 2;
		Build(2 * v + 1, l, mid);
		Build(2 * v + 2, mid, r);
		tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
	}
	const void Set(int& l, int& x)
	{
		Set(0, 0, n, l, n, x);
	}
	const void Set(int v, int l, int r, int& ql, int& qr, int& x)
	{
		if (r <= ql || qr <= l)
		{
			return;
		}
		if (ql <= l && r <= qr)
		{
			tree[v].mx += x;
			tree[v].push += x;
			return;
		}
		int mid = (r + l) / 2;
		Push(v);
		Set(2 * v + 1, l, mid, ql, qr, x);
		Set(2 * v + 2, mid, r, ql, qr, x);
		tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
	}
	const ll Get()
	{
		return tree[0].mx;
	}
};

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		int n, m;
		cin >> n >> m;
		vector<vector<int>> a(n, vector<int>(m));
		bool seven = true;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < m; j++)
			{
				char x;
				cin >> x;
				a[i][j] = x == '.' ? 0 : x - 'a' + 1;
				if (a[i][j] > 1) seven = false;
			}
		}
		string q;
		cin >> q;
		if ((ll)n * m * q.size() <= 1e7)
		{
			for (char c : q)
			{
				if (c == 'U')
				{
					for (int j = 0; j < m; j++)
					{
						int free = 0;
						for (int i = 0; i < n; i++)
						{
							if (a[i][j] == 0) continue;
							if (i != free) { a[free][j] = a[i][j]; a[i][j] = 0; }
							free++;
						}
					}
				}
				if (c == 'D')
				{
					for (int j = 0; j < m; j++)
					{
						int free = n - 1;
						for (int i = n - 1; i >= 0; i--)
						{
							if (a[i][j] == 0) continue;
							if (i != free) { a[free][j] = a[i][j]; a[i][j] = 0; }
							free--;
						}
					}
				}
				if (c == 'L')
				{
					for (int i = 0; i < n; i++)
					{
						int free = 0;
						for (int j = 0; j < m; j++)
						{
							if (a[i][j] == 0) continue;
							if (j != free) { a[i][free] = a[i][j]; a[i][j] = 0; }
							free++;
						}
					}
				}
				if (c == 'R')
				{
					for (int i = 0; i < n; i++)
					{
						int free = m - 1;
						for (int j = m - 1; j >= 0; j--)
						{
							if (a[i][j] == 0) continue;
							if (j != free) { a[i][free] = a[i][j]; a[i][j] = 0; }
							free--;
						}
					}
				}
			}
			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < m; j++)
				{
					cout << (a[i][j] == 0 ? '.' : (char)('a' + a[i][j] - 1));
				}
				cout << '\n';
			}
		}
		else if (seven)
		{
			int x = 0, y = 0;
			int lst = -1;
			for (char c : q)
			{
				if (c == 'L')
				{
					x = -1;
					if (lst == -1)lst = 0;
				}
				if (c == 'R')
				{
					x = 1;
					if (lst == -1)lst = 0;
				}
				if (c == 'U')
				{
					y = -1;
					if (lst == -1)lst = 1;
				}
				if (c == 'D')
				{
					y = 1;
					if (lst == -1)lst = 1;
				}
			}

			if (lst == 0)
			{
				vector<vector<int>> ans(n);
				if (x == -1)
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							if (a[i][j] != 0) ans[i].push_back(a[i][j]);
						}
						ans[i].resize(m);
					}
				}
				else if (x == 1)
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							if (a[i][j] != 0) ans[i].push_back(a[i][j]);
						}
						ans[i].resize(m);
						reverse(ans[i].begin(), ans[i].end());
					}
				}
				vector<vector<int>> ans1(m);
				if (y == -1)
				{
					for (int j = 0; j < m; j++)
					{
						for (int i = 0; i < n; i++)
						{
							if (ans[i][j] != 0) ans1[j].push_back(ans[i][j]);
						}
						ans1[j].resize(n);
					}
				}
				else if (y == 1)
				{
					for (int j = 0; j < m; j++)
					{
						for (int i = 0; i < n; i++)
						{
							if (ans[i][j] != 0) ans1[j].push_back(ans[i][j]);
						}
						ans1[j].resize(n);
						reverse(ans1[j].begin(), ans1[j].end());
					}
				}
				else
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							cout << (ans[i][j] == 0 ? '.' : (char)('a' + ans[i][j] - 1));
						}
						cout << '\n';
					}
					return 0;
				}
				for (int i = 0; i < n; i++)
				{
					for (int j = 0; j < m; j++)
					{
						cout << (ans1[j][i] == 0 ? '.' : (char)('a' + ans1[j][i] - 1));
					}
					cout << '\n';
				}
			}
			else
			{
				vector<vector<int>> ans1(m);
				if (y == -1)
				{
					for (int j = 0; j < m; j++)
					{
						for (int i = 0; i < n; i++)
						{
							if (a[i][j] != 0) ans1[j].push_back(a[i][j]);
						}
						ans1[j].resize(n);
					}
				}
				else if (y == 1)
				{
					for (int j = 0; j < m; j++)
					{
						for (int i = 0; i < n; i++)
						{
							if (a[i][j] != 0) ans1[j].push_back(a[i][j]);
						}
						ans1[j].resize(n);
						reverse(ans1[j].begin(), ans1[j].end());
					}
				}
				vector<vector<int>> ans(n);
				if (x == -1)
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							if (ans1[j][i] != 0) ans[i].push_back(ans1[j][i]);
						}
						ans[i].resize(m);
					}
				}
				else if (x == 1)
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							if (ans1[j][i] != 0) ans[i].push_back(ans1[j][i]);
						}
						reverse(ans[i].begin(), ans[i].end());
						ans[i].resize(m);
						reverse(ans[i].begin(), ans[i].end());
					}
				}
				else
				{
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							cout << (ans1[j][i] == 0 ? '.' : (char)('a' + ans1[j][i] - 1));
						}
						cout << '\n';
					}
					return 0;
				}
				for (int i = 0; i < n; i++)
				{
					for (int j = 0; j < m; j++)
					{
						cout << (ans[i][j] == 0 ? '.' : (char)('a' + ans[i][j] - 1));
					}
					cout << '\n';
				}
			}
		}
		else
		{
			char lst = 's';
			bool up = false;
			for(char c : q)
			{
				if (c == 'U' && !up)
				{
					if (lst == 'L')
					{
						vector<vector<int>> ans(n);
						for (int i = 0; i < n; i++)
						{
							for (int j = 0; j < m; j++)
							{
								if (a[i][j] != 0) ans[i].push_back(a[i][j]);
							}
							ans[i].resize(m);
						}
						a = ans;
					}
					else if(lst=='R')
					{
						vector<vector<int>> ans(n);
						for (int i = 0; i < n; i++)
						{
							for (int j = 0; j < m; j++)
							{
								if (a[i][j] != 0) ans[i].push_back(a[i][j]);
							}
							reverse(ans[i].begin(), ans[i].end());
							ans[i].resize(m);
							reverse(ans[i].begin(), ans[i].end());
						}
						a = ans;
					}
					vector<vector<int>> ans1(m);
					for (int j = 0; j < m; j++)
					{
						for (int i = 0; i < n; i++)
						{
							if (a[i][j] != 0) ans1[j].push_back(a[i][j]);
						}
						ans1[j].resize(n);
					}
					for (int i = 0; i < n; i++)
					{
						for (int j = 0; j < m; j++)
						{
							a[i][j] = ans1[j][i];
						}
					}
					lst = 's';
					up = true;
				}
				else if(c!='U')
				{
					lst = c;
				}
			}
			vector<vector<int>> ans(n);

			if (lst == 'L')
			{
				for (int i = 0; i < n; i++)
				{
					for (int j = 0; j < m; j++)
					{
						if (a[i][j] != 0) ans[i].push_back(a[i][j]);
					}
					ans[i].resize(m);
				}
			}
			else if(lst=='R')
			{
				for (int i = 0; i < n; i++)
				{
					for (int j = 0; j < m; j++)
					{
						if (a[i][j] != 0) ans[i].push_back(a[i][j]);
					}
					reverse(ans[i].begin(), ans[i].end());
					ans[i].resize(m);
					reverse(ans[i].begin(), ans[i].end());
				}
			}
			else
			{
				ans = a;
			}
			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < m; j++)
				{
					cout << (ans[i][j] == 0 ? '.' : (char)('a' + ans[i][j] - 1));
				}
				cout << '\n';
			}
		}
	}

}