#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 2'000'000'000;

struct segment_tree_min {
	vector<ll> tree, m;
	ll size;
	segment_tree_min(ll n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		m.resize(size * 2, 0);
		tree.resize(size * 2, 0);
	}
	void add(ll v, ll x) {
		m[v] += x;
		tree[v] += x;
	}
	void push(ll v) {
		add(v * 2, m[v]);
		add(v * 2 + 1, m[v]);
		m[v] = 0;
	}
	void add(ll l, ll r, ll x) {
		add(1, 0, size, l, r, x);
	}
	void add(ll v, ll l, ll r, ll ql, ll qr, ll x) {
		if (ql <= l && r <= qr) {
			add(v, x);
			return;
		}
		if (qr <= l || r <= ql) {
			return;
		}
		push(v);
		ll mid = (l + r) / 2;
		add(v * 2, l, mid, ql, qr, x);
		add(v * 2 + 1, mid, r, ql, qr, x);
		tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
	}
	ll first_zero(ll l, ll r) {
		return first_zero(1, 0, size, l, r);
	}
	ll first_zero(ll v, ll l, ll r, ll ql, ll qr) {
		if (qr <= l || r <= ql) {
			return -1;
		}
		if (tree[v] > 0) {
			return -1;
		}
		if (r - l == 1) {
			return l;
		}
		push(v);
		ll mid = (l + r) / 2;
		ll x = first_zero(v * 2, l, mid, ql, qr);
		if (x == -1) {
			x = first_zero(v * 2 + 1, mid, r, ql, qr);
		}
		return x;
	}
	ll last_zero(ll l, ll r) {
		return last_zero(1, 0, size, l, r);
	}
	ll last_zero(ll v, ll l, ll r, ll ql, ll qr) {
		if (qr <= l || r <= ql) {
			return -1;
		}
		if (tree[v] > 0) {
			return -1;
		}
		if (r - l == 1) {
			return l;
		}
		push(v);
		ll mid = (l + r) / 2;
		ll x = last_zero(v * 2 + 1, mid, r, ql, qr);
		if (x == -1) {
			x = last_zero(v * 2, l, mid, ql, qr);
		}
		return x;
	}
};

struct segment_tree_max {
	vector<ll> tree, m;
	ll size;
	segment_tree_max(ll n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		m.resize(size * 2, 0);
		tree.resize(size * 2, 0);
	}
	void add(ll v, ll x) {
		m[v] += x;
		tree[v] += x;
	}
	void push(ll v) {
		add(v * 2, m[v]);
		add(v * 2 + 1, m[v]);
		m[v] = 0;
	}
	void add(ll l, ll r, ll x) {
		add(1, 0, size, l, r, x);
	}
	void add(ll v, ll l, ll r, ll ql, ll qr, ll x) {
		if (ql <= l && r <= qr) {
			add(v, x);
			return;
		}
		if (qr <= l || r <= ql) {
			return;
		}
		push(v);
		ll mid = (l + r) / 2;
		add(v * 2, l, mid, ql, qr, x);
		add(v * 2 + 1, mid, r, ql, qr, x);
		tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
	}
	ll first_nzero(ll l, ll r) {
		return first_nzero(1, 0, size, l, r);
	}
	ll first_nzero(ll v, ll l, ll r, ll ql, ll qr) {
		if (qr <= l || r <= ql) {
			return -1;
		}
		if (tree[v] == 0) {
			return -1;
		}
		if (r - l == 1) {
			return l;
		}
		push(v);
		ll mid = (l + r) / 2;
		ll x = first_nzero(v * 2, l, mid, ql, qr);
		if (x == -1) {
			x = first_nzero(v * 2 + 1, mid, r, ql, qr);
		}
		return x;
	}
	ll last_nzero(ll l, ll r) {
		return last_nzero(1, 0, size, l, r);
	}
	ll last_nzero(ll v, ll l, ll r, ll ql, ll qr) {
		if (qr <= l || r <= ql) {
			return -1;
		}
		if (tree[v] == 0) {
			return -1;
		}
		if (r - l == 1) {
			return l;
		}
		push(v);
		ll mid = (l + r) / 2;
		ll x = last_nzero(v * 2 + 1, mid, r, ql, qr);
		if (x == -1) {
			x = last_nzero(v * 2, l, mid, ql, qr);
		}
		return x;
	}
};

void solve() {
	ll n;
	cin >> n;
	vector<pair<pair<ll, ll>, pair<ll, ll>>> arr(n);
	set<ll> ax, ay;
	ax.insert(INF);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >> arr[i].second.second;
		ax.insert(arr[i].first.first - 1);
		ax.insert(arr[i].first.first);
		ax.insert(arr[i].second.first);
		ax.insert(arr[i].second.first + 1);
		ay.insert(arr[i].first.second - 1);
		ay.insert(arr[i].first.second);
		ay.insert(arr[i].second.second);
		ay.insert(arr[i].second.second + 1);
	}
	vector<ll> tx, ty;
	map<ll, ll> tox, toy;
	ll lstx = 0;
	for (auto i : ax) {
		tox[i] = lstx;
		tx.push_back(i);
		lstx++;
	}
	ll lsty = 0;
	for (auto i : ay) {
		toy[i] = lsty;
		ty.push_back(i);
		lsty++;
	}
	for (auto&[fir, sec] : arr) {
		fir.first = tox[fir.first];
		fir.second = toy[fir.second];
		sec.first = tox[sec.first];
		sec.second = toy[sec.second];
	}
	vector<vector<pair<ll, ll>>> ins(lsty), del(lsty);
	for (auto&[fir, sec] : arr) {
		ins[fir.second].emplace_back(fir.first, sec.first + 1);
		del[sec.second].emplace_back(fir.first, sec.first + 1);
	}
	map<pair<ll, ll>, ll> sum, mx, lt;
	segment_tree_min stz(lstx);
	segment_tree_max stnz(lstx);
	for (ll i = 0; i < lsty; i++) {
		for (auto[l, r] : ins[i]) {
			ll nst = stz.last_zero(0, l) + 1;
			ll nen = stz.first_zero(r, lstx);
			ll nsten = stz.first_zero(nst, lstx);
			ll nenst = stz.last_zero(0, nen) + 1;
			if (nsten != nen) {
				if (nsten > nst) {
					ll x = lt[make_pair(nst, nsten)];
					ll nl = ty[i] - x;
					sum[make_pair(nst, nsten)] += nl;
					assign_max(mx[make_pair(nst, nsten)], nl);
				}
				if (nen > nenst) {
					ll x = lt[make_pair(nenst, nen)];
					ll nl = ty[i] - x;
					sum[make_pair(nenst, nen)] += nl;
					assign_max(mx[make_pair(nenst, nen)], nl);
				}
				ll fin = stnz.first_nzero(nsten, nenst), fend = stnz.last_nzero(nsten, nenst);
				if (fin != -1) {
					ll x = lt[make_pair(fin, fend)];
					ll nl = ty[i] - x;
					sum[make_pair(fin, fend)] += nl;
					assign_max(mx[make_pair(fin, fend)], nl);
				}
				lt[make_pair(nst, nen)] = ty[i];
			}
			stz.add(l, r, 1);
			stnz.add(l, r, 1);
		}
		for (auto[l, r] : del[i]) {
			stz.add(l, r, -1);
			stnz.add(l, r, -1);
			ll nst = stz.last_zero(0, l) + 1;
			ll nen = stz.first_zero(r, lstx);
			ll nsten = stz.first_zero(nst, lstx);
			ll nenst = stz.last_zero(0, nen) + 1;
			if (nsten != nen) {
				if (nsten > nst) {
					lt[make_pair(nst, nsten)] = ty[i] + 1;
				}
				if (nen > nenst) {
					lt[make_pair(nenst, nen)] = ty[i] + 1;
				}
				ll fin = stnz.first_nzero(nsten, nenst), fend = stnz.last_nzero(nsten, nenst);
				if (fin != -1) {
					lt[make_pair(fin, fend)] = ty[i] + 1;
				}
				ll x = lt[make_pair(nst, nen)];
				ll nl = ty[i] - x + 1;
				sum[make_pair(nst, nen)] += nl;
				assign_max(mx[make_pair(nst, nen)], nl);
			}
		}
	}
	cout << sum.size() << '\n';
	for (auto[i, _] : sum) {
		if (sum[i] != 0) {
			cout << tx[i.first] << ' ' << tx[i.second - 1] << ' ' << sum[i] << ' ' << mx[i] << '\n';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
