#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 2'000'000'000;

struct segment_tree {
	vector<pair<ll, ll>> tree;
	ll size;
	segment_tree(vector<ll> arr) {
		size = 1;
		while (size < arr.size()) {
			size *= 2;
		}
		tree.resize(size * 2, make_pair(0, 0));
		for (ll i = 0; i < arr.size(); i++) {
			tree[i + size] = make_pair(arr[i], i);
		}
		for (ll i = size - 1; i > 0; i--) {
			tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
		}
	}
	pair<ll, ll> get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	pair<ll, ll> get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return make_pair(INF, 0);
		}
		ll mid = (l + r) / 2;
		return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
	}
};

void rec(ll l, ll r, segment_tree& st, vector<tuple<ll, ll, ll, ll>>& ans, ll lst) {
	if (r <= l) {
		return;
	}
	auto[mi, ind] = st.get(l, r);
	rec(l, ind, st, ans, mi);
	rec(ind + 1, r, st, ans, mi);
	if (mi != lst) {
		ans.emplace_back(l, r, mi - lst, mi - lst);
	}
}

void solve() {
	ll n;
	cin >> n;
	vector<pair<pair<ll, ll>, pair<ll, ll>>> arr(n);
	set<ll> ax, ay;
	for (ll i = 0; i < n; i++) {
		cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >> arr[i].second.second;
		ax.insert(arr[i].first.first);
		ax.insert(arr[i].second.first);
		ax.insert(arr[i].second.first + 1);
	}
	vector<ll> tx, ty;
	map<ll, ll> tox, toy;
	ll lstx = 0;
	for (auto i : ax) {
		tox[i] = lstx;
		tx.push_back(i);
		lstx++;
	}
	for (auto&[fir, sec] : arr) {
		fir.first = tox[fir.first];
		sec.first = tox[sec.first];
	}
	vector<vector<ll>> ins(lstx), del(lstx);
	for (auto&[fir, sec] : arr) {
		ins[fir.first].push_back(sec.second);
		del[fir.second].push_back(sec.second);
	}
	multiset<ll> now;
	now.insert(0);
	vector<ll> mis(lstx, 0);
	for (ll i = 0; i < lstx; i++) {
		for (auto j : ins[i]) {
			now.insert(j);
		}
		mis[i] = *now.rbegin();
		for (auto j : del[i]) {
			now.erase(now.find(j));
		}
	}
	segment_tree st(mis);
	vector<tuple<ll, ll, ll, ll>> ans;
	rec(0, lstx, st, ans, 0);
	cout << ans.size() << '\n';
	for (auto[a, b, c, d] : ans) {
		cout << tx[a] << ' ' << tx[b - 1] << ' ' << c << ' ' << d << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
