#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) (int) x.size()
#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

using namespace __gnu_pbds;

template<int mod>
struct Modular {
    int v;

    Modular() : v(0) {}
    Modular(int v) : v(v) {}

    inline Modular<mod> operator+(const Modular<mod>& oth) {
        int res = v + oth.v;
        if (res >= mod) return Modular<mod>(res - mod);
        else return Modular<mod>(res);
    }

    inline Modular<mod> operator*(const Modular<mod>& oth) {
        return 1ll * v * oth.v % mod;
    }
};

const int MOD1 = (int) 1000'000'007;
using h1 = Modular<MOD1>;
const h1 flex = 239;
const h1 aboba = 179;


int n, m;
vector<vector<h1>> amogus;

int hashing(vector<string>& str) {
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            amogus[i][j] = amogus[i - 1][j] * flex + amogus[i][j - 1] * aboba + str[i - 1][j - 1];
        }
    }
    return amogus[n][m].v;
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tet;
    cin >> tet;
    while (tet--) {
        cin >> n >> m;
        amogus.assign(n + 1, vector<h1>(m + 1));
        vector<string> a(n);
        for (auto& x : a) cin >> x;
        vector<array<int, 4>> g;
        vector<vector<string>> ids;
        gp_hash_table<int, int> st;
        ids.push_back(a);
        g.push_back({-1, -1, -1, -1});
        string s;
        cin >> s;
        int u = 0;
        for (auto c : s) {
            int t, rt;
            if (c == 'U') t = 0, rt = 1;
            else if (c == 'R') t = 1, rt = 3;
            else if (c == 'D') t = 2, rt = 0;
            else t = 3, rt = 1;
            if (g[u][t] == -1) {
                vector<string> res(n, string(m, '.'));
                if (t == 0) {
                    for (int i = 0; i < m; ++i) {
                        for (int j = 0, k = 0; j < n; ++j) {
                            if (ids[u][j][i] != '.') {
                                res[k++][i] = ids[u][j][i];
                            }
                        }
                    }
                } else if (t == 1) {
                    for (int i = 0; i < n; ++i) {
                        for (int j = m - 1, k = m - 1; j > -1; --j) {
                            if (ids[u][i][j] != '.') {
                                res[i][k--] = ids[u][i][j];
                            }
                        }
                    }
                } else if (t == 2) {
                    for (int i = 0; i < m; ++i) {
                        for (int j = n - 1, k = n - 1; j > -1; --j) {
                            if (ids[u][j][i] != '.') {
                                res[k--][i] = ids[u][j][i];
                            }
                        }
                    }
                } else {
                    for (int i = 0; i < n; ++i) {
                        for (int j = 0, k = 0; j < m; ++j) {
                            if (ids[u][i][j] != '.') {
                                res[i][k++] = ids[u][i][j];
                            }
                        }
                    }
                }
                int v, h = hashing(res);
                if (st.find(h) == st.end()) {
                    v = szof(g);
                    st[h] = v;
                    g.push_back({-1, -1, -1, -1});
                    ids.push_back(res);
                } else {
                    v = st[h];
                }
                g[u][t] = v;
            }
            u = g[u][t];
        }
        for (auto x : ids[u]) cout << x << '\n';
    }
}