#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

using pll = pair<ll, ll>;
using matrix = vector<vector<pll>>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

template<typename T>
vector<vector<T>> perform(vector<vector<T>> a, T NEUTRAL, string s) {
    ll n = (ll)a.size(), m = (ll)a[0].size();

    for (char q : s) {

        if (q == 'L') {
            for (ll i = 0; i < n; i++) {
                queue<ll> free;
                for (ll j = 0; j < m; j++) {
                    if (a[i][j] == NEUTRAL) {
                        free.push(j);
                    } else if (!free.empty()) {
                        a[i][free.front()] = a[i][j];
                        free.pop();
                        a[i][j] = NEUTRAL;
                        free.push(j);
                    }
                }
            }
        } else if (q == 'R') {
            for (ll i = 0; i < n; i++) {
                queue<ll> free;
                for (ll j = m - 1; j >= 0; j--) {
                    if (a[i][j] == NEUTRAL) {
                        free.push(j);
                    } else if (!free.empty()) {
                        a[i][free.front()] = a[i][j];
                        free.pop();
                        a[i][j] = NEUTRAL;
                        free.push(j);
                    }
                }
            }
        } else if (q == 'U') {
            for (ll j = 0; j < m; j++) {
                queue<ll> free;
                for (ll i = 0; i < n; i++) {
                    if (a[i][j] == NEUTRAL) {
                        free.push(i);
                    } else if (!free.empty()) {
                        a[free.front()][j] = a[i][j];
                        free.pop();
                        a[i][j] = NEUTRAL;
                        free.push(i);
                    }
                }
            }
        } else {
            for (ll j = 0; j < m; j++) {
                queue<ll> free;
                for (ll i = n - 1; i >= 0; i--) {
                    if (a[i][j] == NEUTRAL) {
                        free.push(i);
                    } else if (!free.empty()) {
                        a[free.front()][j] = a[i][j];
                        free.pop();
                        a[i][j] = NEUTRAL;
                        free.push(i);
                    }
                }
            }
        }
    }

    return a;
}

matrix mul(matrix a, matrix b) {
    ll n = a.size(), m = a[0].size();
    matrix ans(n, vector<pll>(m, {-1, -1}));

    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a[i][j].first == -1) continue;
            auto [i1, j1] = a[i][j];
            ans[i][j] = b[i1][j1];
        }
    }

    return ans;
}

matrix out;

matrix pm(matrix a, ll b) {
    if (b == 0) return out;

    matrix k = pm(a, b / 2);
    k = mul(k, k);
    if (b % 2) k = mul(k, a);

    return k;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n, m;
        cin >> n >> m;

        vector<vector<char>> a(n, vector<char>(m));
        for (ll i = 0; i < n; i++)
            for (ll j = 0; j < m; j++)
                cin >> a[i][j];

        string s;
        cin >> s;

        string pvS;

        while (pvS != s) {
            pvS = s;

            string tmp;
            for (char q : s) {
                if (q == 'U' || q == 'D') {
                    while (!tmp.empty() && tmp.back() == 'U' || tmp.back() == 'D') tmp.pop_back();
                    tmp.push_back(q);
                } else {
                    while (!tmp.empty() && tmp.back() == 'L' || tmp.back() == 'R') tmp.pop_back();
                    tmp.push_back(q);
                }
            }

            string rs;
            char lastLR = ' ', lastUD = ' ';

            for (char q : tmp) {
                if (q == 'U' || q == 'D') {
                    char rb = 'U' + 'D' - q;
                    if (q != lastUD) {
                        while (!rs.empty() && rs.back() == rb) rs.pop_back();
                        if (rs.empty() || rs.back() != q) rs.push_back(q);
                        lastUD = q;
                    }
                } else {
                    char rb = 'L' + 'R' - q;
                    if (q != lastLR) {
                        while (!rs.empty() && rs.back() == rb) rs.pop_back();
                        if (rs.empty() || rs.back() != q) rs.push_back(q);
                        lastLR = q;
                    }
                }
            }

            s = rs;
        }

        for (ll i = 0; i + 4 < s.size(); i++) {
            assert(s[i] == s[i + 4]);
        }

        auto st = s;

        if (s.size() <= 4) {
            a = perform(a, '.', s);

            for (auto x : a) {
                for (auto y : x) cout << y;
                cout << "\n";
            }

            continue;
        }

        auto ap1 = perform(a, '.', s.substr(0, 4));

        matrix perm(n, vector<pll>(m, {-1, -1}));

        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < m; j++) {
                if (a[i][j] != '.') perm[i][j] = {i, j};
            }
        }

        out = perm;
        perm = perform(perm, {-1, -1}, s.substr(0, 4));

        std::reverse(s.begin(), s.end());
        for (ll i = 0; i < 4; i++) s.pop_back();

        ll cnt = 0;

        while ((ll)s.size() - 4 >= 0) {
            for (ll i = 0; i < 4; i++) s.pop_back();
            cnt++;
        }

        std::reverse(s.begin(), s.end());

        perm = pm(perm, cnt);

        vector<vector<char>> ax(n, vector<char>(m, '.'));

        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < m; j++) {
                if (a[i][j] == '.' || perm[i][j].first == -1) continue;
                auto [i1, j1] = perm[i][j];
                ax[i1][j1] = a[i][j];
            }
        }

        {
            a = perform(a, '.', st);

            for (auto x : a) {
                for (auto y : x) cout << y;
                cout << "\n";
            }

            continue;
        }

        ax = perform(ax, '.', s);

        for (auto x : ax) {
            for (auto y : x) cout << y;
            cout << "\n";
        }
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
