#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n, m;
        cin >> n >> m;

        vector<string> a(n);
        for (ll i = 0; i < n; i++) cin >> a[i];

        string s;
        cin >> s;

        string rs;
        char lastLR = ' ', lastUD = ' ';
        for (char q : s) {
            if (q == 'U' || q == 'D') {
                if (q != lastUD) rs.push_back(q);
                lastUD = q;
            } else {
                if (q != lastLR) rs.push_back(q);
                lastLR = q;
            }
        }

        std::reverse(rs.begin(), rs.end());
        while ((ll)rs.size() - 4 >= 100) {
            for (ll i = 0; i < 4; i++) rs.pop_back();
        }

        std::reverse(rs.begin(), rs.end());

        for (char q : rs) {
            if (q == 'L') {
                for (ll i = 0; i < n; i++) {
                    queue<ll> free;
                    for (ll j = 0; j < m; j++) {
                        if (a[i][j] == '.') {
                            free.push(j);
                        } else if (!free.empty()) {
                            a[i][free.front()] = a[i][j];
                            free.pop();
                            a[i][j] = '.';
                            free.push(j);
                        }
                    }
                }
            } else if (q == 'R') {
                for (ll i = 0; i < n; i++) {
                    queue<ll> free;
                    for (ll j = m - 1; j >= 0; j--) {
                        if (a[i][j] == '.') {
                            free.push(j);
                        } else if (!free.empty()) {
                            a[i][free.front()] = a[i][j];
                            free.pop();
                            a[i][j] = '.';
                            free.push(j);
                        }
                    }
                }
            } else if (q == 'U') {
                for (ll j = 0; j < m; j++) {
                    queue<ll> free;
                    for (ll i = 0; i < n; i++) {
                        if (a[i][j] == '.') {
                            free.push(i);
                        } else if (!free.empty()) {
                            a[free.front()][j] = a[i][j];
                            free.pop();
                            a[i][j] = '.';
                            free.push(i);
                        }
                    }
                }
            } else {
                for (ll j = 0; j < m; j++) {
                    queue<ll> free;
                    for (ll i = n - 1; i >= 0; i--) {
                        if (a[i][j] == '.') {
                            free.push(i);
                        } else if (!free.empty()) {
                            a[free.front()][j] = a[i][j];
                            free.pop();
                            a[i][j] = '.';
                            free.push(i);
                        }
                    }
                }
            }

            cout << "";
        }

        for (string w : a) cout << w << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
