#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

using pll = pair<ll, ll>;
using matrix = vector<vector<pll>>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;

    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];

    vector<vector<ll>> dp(n + 1, vector<ll>(2, INF));
    dp[0][0] = 0;

    for (ll i = 0; i < n; i++) {
        vector<ll> qt(k + 1);

        ll cntItems = 0;

        for (ll w = 0; w < i; w++) {
            if (qt[a[w]] == 0) {
                qt[a[w]] = p;
                cntItems++;
            }

            if (--qt[a[w]] == 0) cntItems--;
        }

        for (ll j = i + 1; j <= n; j++) {
            qt[a[j - 1]]++;
            if ((qt[a[j - 1]] - 1) % p == 0) cntItems++;

            for (ll from = 0; from < 2; from++) {
                ll fromPos = from * (n + 1);

                if (dp[i][from] >= INF / 2) continue;

                ll ans = dp[i][from];
                ans += abs(fromPos - (i + 1));
                ans += abs(j - (i + 1));

                if (c == 1 || c == 3) {
                    ll toPos = n + 1;
                    dp[j][1] = min(dp[j][1], ans + abs(toPos - j));
                }

                if (c == 2 || c == 3) {
                    ll toPos = 0;
                    dp[j][0] = min(dp[j][0], ans + abs(toPos - j));
                }
            }
        }
    }

    ll ans = min(dp[n][0] + n + 1, dp[n][1]);
    assert(ans < INF / 2);

    cout << ans;

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
