#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

using pll = pair<ll, ll>;
using matrix = vector<vector<pll>>;

ll INF = 3e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;

    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];

    vector<vector<ll>> dp(n + 1, vector<ll>(2, INF));
    dp[0][0] = 0;

    for (ll i = 0; i <= n; i++) {
        map<ll, ll> qt;

        for (ll w = 0; w < i; w++) {
            if (qt[a[w]] == 0)
                qt[a[w]] = p;

            qt[a[w]]--;
            if (qt[a[w]] == 0) qt.erase(a[w]);
        }

        ll items = 0;
        for (auto &w : qt) items++;

        for (ll j = i + 1; j <= n; j++) {
            if (qt[a[j - 1]] % p == 0) items++;
            qt[a[j - 1]]++;

            if (items > m) break;

            for (ll from = 0; from < 2; from++) {
                ll fromPos = from * (n + 1);

                ll ans = dp[i][from];
                ans += abs(fromPos - (i + 1));
                ans += abs(j - (i + 1));

                if (c == 1 || c == 3 || j == n) {
                    dp[j][1] = min(dp[j][1], ans + n + 1 - j);
                }

                if (c == 2 || c == 3 || j == n) {
                    dp[j][0] = min(dp[j][0], ans + j);
                }
            }
        }
    }

    ll ans = min(dp[n][0] + n + 1, dp[n][1]);
    assert(ans < INF / 2 && ans >= 0);

    cout << ans;

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}