#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

using pll = pair<ll, ll>;
using matrix = vector<vector<pll>>;

ll INF = 3e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct SegmentTree {
    struct Node {
        ll x, cnt;
    };

    Node merge(Node p1, Node p2) {
        if (p1.x < p2.x) return p1;
        if (p2.x < p1.x) return p2;

        return {p1.x, p1.cnt + p2.cnt};
    }


};

struct AnsNode {
    ll cnt = 0, mx = 0;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        map<pll, AnsNode> ans;

        vector<vector<bool>> f(15, vector<bool>(15, false));

        for (ll w = 0; w < n; w++) {
            ll x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;

            for (ll i = x1; i <= x2; i++) {
                for (ll j = y1; j <= y2; j++) {
                    f[j][i] = true;
                }
            }
        }

        map<pll, ll> cntLast;

        for (ll i = 0; i < 15; i++) {
            set<pll> used;

            ll last = -1;
            for (ll j = 0; j < 15; j++) {
                if (f[i][j] == 0 && last != -1) {
                    ll x1 = last, x2 = j - 1;
                    used.insert({x1, x2});
                    cntLast[{x1, x2}]++;
                    ans[{x1, x2}].cnt++;
                    ans[{x1, x2}].mx = max(ans[{x1, x2}].cnt, cntLast[{x1, x2}]);

                    last = -1;
                }

                if (f[i][j] == 1 && last == -1) {
                    last = j;
                }
            }

            vector<pll> reset;

            for (auto z : cntLast) {
                if (!used.count(z.first)) reset.push_back(z.first);
            }

            for (pll z : reset) cntLast.erase(z);
        }

        cout << ans.size() << "\n";
        for (auto nd : ans) cout << nd.first.first << " " << nd.first.second << " " << nd.second.cnt << " " << nd.second.mx << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}