#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

using pll = pair<ll, ll>;
using matrix = vector<vector<pll>>;

ll INF = 3e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct SegmentTree {
    struct Node {
        ll x, cnt;
    };

    Node merge(Node p1, Node p2) {
        if (p1.x < p2.x) return p1;
        if (p2.x < p1.x) return p2;

        return {p1.x, p1.cnt + p2.cnt};
    }


};

struct AnsNode {
    ll cnt = 0, mx = 0;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        map<pll, AnsNode> ans;

        map<ll, vector<pll>> add, del;

        while (n--) {
            ll x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;

            add[y1].emplace_back(x1, x2);
            del[y2].emplace_back(x1, x2);
        }

        multiset<pll> x;

        set<ll> keys;
        for (auto &w : add) keys.insert(w.first);
        for (auto &w : del) keys.insert(w.first);

        for (auto &w : keys) {
            ll y = w;

            for (auto px : add[y]) {
                x.insert({px.first, -1});
                x.insert({px.second, 0});
            }

            ll firstOpen = 0, s = 0;
            for (pll evt : x) {
                if (s == 0 && evt.second == -1) {
                    firstOpen = evt.first;
                }
                if (s == 1 && evt.second == 0) {
                    ans[{firstOpen, evt.first}].cnt++;
                }

                s += (evt.second == -1 ? 1 : -1);
            }

            for (auto px : del[y]) {
                x.erase(x.find({px.first, -1}));
                x.erase(x.find({px.second, 0}));
            }
        }

        cout << ans.size() << "\n";
        for (auto nd : ans) cout << nd.first.first << " " << nd.first.second << " " << nd.second.cnt << " " << nd.second.mx << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}