#include <bits/stdc++.h>
//#pragma GCC optimize("O3")

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vld = vector<ld>;
using vbo = vector<bool>;
using vpi = vector<pii>;
using vpl = vector<pll>;
using vvl = vector<vll>;

#define all(a) a.begin(),a.end()
#define sz(a) (ll)a.size()
#define sor(a) sort(all(a))

#define pub push_back
#define pob pop_back
#define pof pop_front

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

ll R = 1 << 21;

struct segtree {
    vll tree, flag;

    segtree() {
        tree.resize(R * 2, 1e16);
        flag.resize(R * 2, 1e16);
    }

    ll val(ll v) {
        return min(flag[v], tree[v]);
    }

    void push(ll v) {
        flag[v * 2] = min(flag[v * 2], flag[v]);
        flag[v * 2 + 1] = min(flag[v * 2 + 1], flag[v]);
        flag[v] = 1e16;
    }

    void update(ll l, ll r, ll x, ll tl = 0, ll tr = R, ll v = 1) {
        if (tr <= l || r <= tl) {
            return;
        }
        if (l <= tl && tr <= r) {
            flag[v] = min(flag[v], x);
            return;
        }
        ll m = (tl + tr) / 2;
        push(v);
        update(l, r, x, tl, m, v * 2);
        update(l, r, x, m, tr, v * 2 + 1);
        tree[v] = min(val(v * 2), val(v * 2 + 1));
    }

    ll get(ll l, ll r, ll tl = 0, ll tr = R, ll v = 1) {
        if (tr <= l || r <= tl) {
            return 1e16;
        }
        if (l <= tl && tr <= r) {
            return val(v);
        }
        ll m = (tl + tr) / 2;
        push(v);
        ll g1 = get(l, r, tl, m, v * 2);
        ll g2 = get(l, r, m, tr, v * 2 + 1);
        tree[v] = min(val(v * 2), val(v * 2 + 1));
        return min(g1, g2);
    }
};

void solve() {
    ll n;
    cin >> n;
    vvl rect(n);
    F0R(i, n) {
        ll xl, xr, yl, yr;
        cin >> xl >> yl >> xr >> yr;
        xl--; xr--; yl--; yr--;
        rect[i] = {xl, xr, yl, yr};
    }
    ll M = 5000;
    vvl mat(M, vll(M + 1));
    F0R(i, n) {
        FOR(j, rect[i][0], rect[i][1] + 1) {
            mat[j][rect[i][2]]++;
            mat[j][rect[i][3] + 1]--;
        }
    }
    F0R(i, M) {
        F0R(j, M) {
            mat[i][j + 1] += mat[i][j];
        }
    }
    map<pll, vll> mp;
    F0R(j, M) {
        ll cnt = 0;
        F0R(i, M) {
            if (i == 0) {
                if (mat[i][j] > 0) {
                    cnt++;
                }
                continue;
            }
            if (mat[i][j] == 0 && cnt > 0) {
                mp[{i - cnt, i - 1}].pub(j);
                cnt = 0;
                continue;
            }
            if (mat[i][j] > 0 && mat[i - 1][j] == 0) {
                cnt = 1;
                continue;
            }
            if (mat[i][j] > 0) {
                cnt++;
                continue;
            }
            cnt = 0;
        }
        if (cnt != 0){
            mp[{M - cnt, M - 1}].pub(j);
        }
    }
    vvl ans;
    each(i, mp){
        ll max_len = 0;
        ll cur_len = 0;
        ll cnt = 0;
        ll lst_r = -2;
        each(j, i.second){
            if (lst_r + 1 == j){
                cur_len++;
            } else {
                max_len = max(max_len, cur_len);
                cur_len = 1;
            }
            cnt++;
            lst_r = j;
        }
        max_len = max(max_len, cur_len);
        ans.pub({i.first.first, i.first.second, cnt, max_len});
    }
    cout << sz(ans) << '\n';
    F0R(i, sz(ans)){
        cout << ans[i][0] + 1 << ' ' << ans[i][1] + 1 << ' ' << ans[i][2] << ' ' << ans[i][3] << '\n';
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    ll t;
    cin >> t;
    F0R(i, t) {
        solve();
    }
    return 0;
}
