#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <stack>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <cassert>

using namespace std;

using ll = long long;
using ld = long double;

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long
#define endll "\n"

#pragma GCC optimize("03")
#pragma GCC target("avx2")

const int INF = 1e9;

int m, n;

void doo(vec<vec<char>>& a, char c) {
    if (c == 'L') {
        for (int i = 0; i < m; ++i) {
            int ind = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    a[i][ind++] = a[i][j];
                }
            }
            for (int j = ind; j < n; ++j) a[i][j] = '.';
        }
    }
    else if (c == 'R') {
        for (int i = 0; i < m; ++i) {
            int ind = n - 1;
            for (int j = n - 1; j >= 0; --j) {
                if (a[i][j] != '.') {
                    a[i][ind--] = a[i][j];
                }
            }
            for (int j = ind; j >= 0; --j) a[i][j] = '.';
        }
    }
    else if (c == 'U') {
        for (int i = 0; i < n; ++i) {
            int ind = 0;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != '.') {
                    a[ind++][i] = a[j][i];
                }
            }
            for (int j = ind; j < m; ++j) a[j][i] = '.';
        }
    }
    else if (c == 'D') {
        for (int i = 0; i < n; ++i) {
            int ind = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (a[j][i] != '.') {
                    a[ind--][i] = a[j][i];
                }
            }
            for (int j = ind; j >= 0; --j) a[j][i] = '.';
        }
    }
    else assert(0);
}

void solve() {
    cin >> m >> n;
    vec<vec<char>> a(m, vec<char>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    string s;
    cin >> s;
    for (int i = 0; i < (int)s.size() && i < 4; ++i) {
        doo(a, s[i]);
    }
    if ((int)s.size() > 4) {
        int c = ((int)s.size() - 5) % (min(n, m) * 4 + 4) + 1;
        for (int i = 0; i < c; ++i) {
            doo(a, s[i + 4]);
        }
    }
    for (auto& i : a) {
        for (char& j : i) cout << j;
        cout << endl;
    }
}

signed main() {
    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\work\\untitled\\cmake-build-debug\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}