#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <stack>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long
#define endll "\n"

#pragma GCC optimize("03")
#pragma GCC target("avx2")

const int INF = 1e18;

int n;

struct Segment{
    vec<int> t;

    void init(int n) {
        t.assign(4 * n + 10, INF);
    }

    int get(int i, int l, int r, int ql, int qr) {
        if (l >= qr || ql >= r) return INF;
        if (ql <= l && r <= qr) return t[i];
        return min(get(i * 2 + 1, l, (l + r) / 2, ql, qr),
                   get(i * 2 + 2, (l + r) / 2,  r, ql, qr));
    }

    void upd(int i, int l, int r, int k, int x) {
        if (l > k || r <= k) return;
        if (l + 1 == r) {
            t[i] = min(t[i], x);
            return;
        }
        upd(i * 2 + 1, l, (l + r) / 2, k, x);
        upd(i * 2 + 2, (l + r) / 2, r, k, x);
        t[i] = min(t[i * 2 + 1], t[i * 2 + 2]);
    }
};

void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c = 1;
    cin >> c;
    vec<int> a(n);
    map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        mp[a[i]] = 0;
    }
    int cnt = 0;
    for (auto i : mp) {
        mp[i.first] = (cnt++);
    }
    for (int i = 0; i < n; ++i) a[i] = mp[a[i]];
    k = cnt;
    vec<int> dp(n + 1, INF);
    dp[0] = 0;
    Segment t;
    t.init(n + 1);
    for (int i = 0; i < n; ++i) {
        int l = i, r = n + 1;
        while (l + 1 != r) {
            int j = (l + r) / 2;
            vec<int> cc1(k), cc2(k);
            for (int q = i; q < j; ++q) cc2[a[q]]++;
            for (int q = 0; q < i; ++q) cc1[a[q]]++;
            int sm = 0;
            for (int q = 0; q < k; ++q) {
                if (cc1[q] % p > 0) {
                    sm += (-(p - cc1[q] % p) + cc2[q] + p - 1) / p;
                    sm++;
                }
                else
                    sm += (cc2[q] + p - 1) / p;
            }
            if (sm <= m) l = j;
            else r = j;
        }
        int s = dp[i] + 2 * min(i, n - i);
        if (c == 2) {
            s = dp[i] + 2 * i;
        }
        t.upd(0, 0, n + 1, l, s);
        dp[i + 1] = t.get(0, 0, n + 1, i + 1, n + 1);
    }
    //for (int i = 0; i <= n; ++i) cout << dp[i] << " ";
    //cout << endl;
    cout << dp[n] + n + 1 << endl;
}

signed main() {
    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\work\\untitled\\cmake-build-debug\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}