#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")

#include <bits/stdc++.h>
using namespace std;
int n, m;

void down(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int j = 0; j < m; ++j){
        int cur = n - 1;
        for (int i = n - 1; i >= 0; --i){
            if (a[i][j] != '.'){
                b[cur][j] = a[i][j];
                cur--;
            }
        }
    }
    a = b;
}

void up(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int j = 0; j < m; ++j){
        int cur = 0;
        for (int i = 0; i < n; ++i){
            if (a[i][j] != '.'){
                b[cur][j] = a[i][j];
                cur++;
            }
        }
    }
    a = b;
}

void right(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int i = 0; i < n; ++i){
        int cur = m - 1;
        for (int j = m - 1; j >= 0; --j){
            if (a[i][j] != '.'){
                b[i][cur] = a[i][j];
                cur--;
            }
        }
    }
    a = b;
}

void left(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int i = 0; i < n; ++i){
        int cur = 0;
        for (int j = 0; j < m; ++j){
            if (a[i][j] != '.'){
                b[i][cur] = a[i][j];
                cur++;
            }
        }
    }
    a = b;
}

void solve(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }
    string q;
    cin >> q;
    for (int i = 0; i < q.size(); ++i){
        if (q[i] == 'D'){
            down(a);
        } else if (q[i] == 'U'){
            up(a);
        } else if (q[i] == 'L'){
            left(a);
        } else if (q[i] == 'R'){
            right(a);
        }
    }
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve_LRU(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }

    string q;
    cin >> q;
    if (q[0] == 'U'){
        up(a);
    } else {
        for (int i = 0; i < q.size(); ++i){
            if (q[i] == 'U'){
                if (q[i - 1] == 'L'){
                    left(a);
                } else {
                    right(a);
                }
                up(a);
                break;
            }
        }
    }
    for (int i = q.size() - 1; i >= 0; --i){
        if (q[i] == 'L'){
            left(a);
            break;
        } else if (q[i] == 'R'){
            right(a);
            break;
        }
    }




    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve_LURD(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }

    string q;
    cin >> q;

    for (int i = 0; i < min(50, (int) q.size() / 4); ++i) {
        left(a);
        up(a);
        right(a);
        down(a);

    }

    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve_ladder(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    vector<string> hor(n, ""), ver(n, ""), diag(n, "");
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
            if (i > j){
                hor[i - 1].push_back(a[i][j]);
                ver[j].push_back(a[i][j]);
                diag[i - j - 1].push_back(a[i][j]);
            }
        }
    }

/*    for (int i = 0; i < n; ++i){
        cout << i << " ";
        cout << hor[i] << "\n";
    }
    cout << '\n';

    for (int i = 0; i < n; ++i){
        cout << i << " ";
        cout << ver[i] << "\n";
    }
    cout << '\n';

    for (int i = 0; i < n; ++i){
        cout << i << " ";
        cout << diag[i] << "\n";
    }
    cout << '\n';*/

    string q;
    cin >> q;

    char h = 'L', v = 'D';
    for (int i = 0; i < q.size(); ++i){
        if (q[i] == 'L' || q[i] == 'R'){
            swap(diag, ver);
            h = q[i];
        } else {
            swap(diag, hor);
            v = q[i];
        }
/*        for (int i = 0; i < n; ++i){
            cout << i << " ";
            cout << hor[i] << "\n";
        }
        cout << '\n';

        for (int i = 0; i < n; ++i){
            cout << i << " ";
            cout << ver[i] << "\n";
        }
        cout << '\n';

        for (int i = 0; i < n; ++i){
            cout << i << " ";
            cout << diag[i] << "\n";
        }
        cout << '\n';*/
    }


    for (int i = 0; i < n; ++i){
        if (i != n - 1) {
            cout << hor[i];
            for (int j = hor[i].size(); j < m; ++j) {
                cout << '.';
            }
            cout << "\n";
        } else {
            for (int j = 0; j < m; ++j) {
                cout << '.';
            }
            cout << "\n";
        }
    }

}

void solve_a(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }
    string q;
    cin >> q;

    int ii = 0;
    char last;
    while (ii < q.size() && q[ii] != 'L' && q[ii] != 'R'){
        last = q[ii];
        ii++;
    }
    if (last == 'U'){
        up(a);
    } else if (last == 'D'){
        down(a);
    }
    if (q[ii] == 'L'){
        left(a);
    } else if (q[ii] == 'R'){
        right(a);
    }
    ii++;


    vector<int> cnt(n, 0);
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            if (a[i][j] != '.'){
                cnt[i]++;
            }
        }
    }

    last = 0;

/*    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j];
        }
        cout << "\n";
    }*/
    for (; ii < q.size(); ++ii){
        //cout << q[ii] << " ";
        if (q[ii] == 'U' || q[ii] == 'D') {
            sort(cnt.begin(), cnt.end());
            if (q[ii] == 'U') {
                reverse(cnt.begin(), cnt.end());
            }
        }
        if (q[ii] != 'U' && q[ii] != 'D'){
            last = q[ii];
        }
/*        for (int i : cnt){
            cout << i << " ";
        }
        cout << "\n";*/
    }

    if (last == 'L'){
        for (int i = 0; i < n; ++i){
            for (int j = 0; j < cnt[i]; ++j){
                cout << 'a';
            }
            for (int j = cnt[i]; j < m; ++j){
                cout <<'.';
            }
            cout << "\n";
        }
    } else if (last == 'R') {
        for (int i = 0; i < n; ++i){
            for (int j = cnt[i]; j < m; ++j){
                cout << '.';
            }
            for (int j = 0; j < cnt[i]; ++j){
                cout << 'a';
            }
            cout << "\n";
        }

    } else {

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << a[i][j];
            }
            cout << "\n";
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--){
        solve_a();
    }

    return 0;
}

/*
 *
 *
 *
 *
 *
 1
 5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
UD



1
 4 4
 ....
 a...
 bc..
 def.
UR

3
 4 4
 ....
 a...
 bc..
 def.
UR
 4 4
 ....
 a...
 bc..
 def.
URD
 4 4
 ....
 a...
 bc..
 def.
URDL

4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR

 * */