#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")

#include <bits/stdc++.h>
using namespace std;
int n, m;

void down(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int j = 0; j < m; ++j){
        int cur = n - 1;
        for (int i = n - 1; i >= 0; --i){
            if (a[i][j] != '.'){
                b[cur][j] = a[i][j];
                cur--;
            }
        }
    }
    a = b;
}

void up(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int j = 0; j < m; ++j){
        int cur = 0;
        for (int i = 0; i < n; ++i){
            if (a[i][j] != '.'){
                b[cur][j] = a[i][j];
                cur++;
            }
        }
    }
    a = b;
}

void right(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int i = 0; i < n; ++i){
        int cur = m - 1;
        for (int j = m - 1; j >= 0; --j){
            if (a[i][j] != '.'){
                b[i][cur] = a[i][j];
                cur--;
            }
        }
    }
    a = b;
}

void left(vector<vector<char>> &a){
    vector<vector<char>> b(n, vector<char>(m, '.'));
    for (int i = 0; i < n; ++i){
        int cur = 0;
        for (int j = 0; j < m; ++j){
            if (a[i][j] != '.'){
                b[i][cur] = a[i][j];
                cur++;
            }
        }
    }
    a = b;
}

void solve(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }
    string q;
    cin >> q;
    for (int i = 0; i < q.size(); ++i){
        if (q[i] == 'D'){
            down(a);
        } else if (q[i] == 'U'){
            up(a);
        } else if (q[i] == 'L'){
            left(a);
        } else if (q[i] == 'R'){
            right(a);
        }
    }
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve_LRU(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }

    string q;
    cin >> q;
    if (q[0] == 'U'){
        up(a);
    } else {
        for (int i = 0; i < q.size(); ++i){
            if (q[i] == 'U'){
                if (q[i - 1] == 'L'){
                    left(a);
                } else {
                    right(a);
                }
                up(a);
                break;
            }
        }
    }
    for (int i = q.size() - 1; i >= 0; --i){
        if (q[i] == 'L'){
            left(a);
            break;
        } else if (q[i] == 'R'){
            right(a);
            break;
        }
    }




    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve_LURD(){
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }

    string q;
    cin >> q;

    for (int i = 0; i < min(50, (int) q.size() / 4); ++i) {
        left(a);
        up(a);
        right(a);
        down(a);

    }

    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            cout << a[i][j];
        }
        cout << "\n";
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--){
        solve_LURD();
    }

    return 0;
}

/*
4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR

 * */