#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt,tune=native")

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define endl '\n'

using namespace std;

mt19937 rng(time(0));
uniform_int_distribution<int> uid(0, 2e9);

struct pair_hash {
    int operator()(pair <int, int> p) const {
        return (p.F << 7) ^ p.S;
    }
};

int rnd(int n) {
    return uid(rng) % n;
}

void solve() {
    int n;
    cin >> n;
    unordered_map <int, vector <pair <int, int>>> mp;
    mp.reserve(1e6);

    vector <vector <int>> inp;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        inp.push_back({x1, x2, y1, y2});
    }
    sort(inp.begin(), inp.end());
    for (auto& el : inp) {
        int x1 = el[0], x2 = el[1], y1 = el[2], y2 = el[3];
        for (int y = y1; y <= y2; y++) {
            mp[y].emplace_back(x1, x2);
        }
    }
    unordered_map <pair <int, int>, vector <int>, pair_hash> ans;
    ans.reserve(1e6);
    for (auto& [y, v] : mp) {
        int l = v[0].F, r = v[0].S;
        for (auto& [x1, x2] : v) {
            if (x1 > r + 1) {
                ans[{l, r}].push_back(y);
                l = x1;
                r = x2;
            } else
                r = max(r, x2);
        }
        ans[{l, r}].push_back(y);
    }
    cout << ans.size() << endl;
    for (auto& i : ans) {
        cout << i.F.F << ' ' << i.F.S << ' ' << i.S.size() << ' ';
        sort(i.S.begin(), i.S.end());
        int pr = -100, now = 0, mx = 0;
        for (auto& el : i.S) {
            if (pr + 1 == el)
                now++;
            else {
                pr = el;
                now = 1;
            }
            mx = max(mx, now);
        }
        cout << mx << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    auto start_time = chrono::high_resolution_clock::now();

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();

    auto end_time = chrono::high_resolution_clock::now();

    cerr << "Ulyanovsk is the best!" << endl;
    cerr << "execution time: " <<
         chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
}
