#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = (1e6)+31;

vector<vector<char>> mt;
vector<vector<char>> nmt;

int cnt[MAXN];

int n, m;

void clear(){
    for(int i = 0; i < n; i++){
        cnt[i] = 0;
        for(int j = 0; j < m; j++){
            cnt[j] = 0;
            nmt[i][j] = '.';
        }
    }
}

void do_l(){
    clear();
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(mt[i][j] == '.') continue;
            nmt[i][cnt[i]] = mt[i][j];
            cnt[i]++;
        }
    }
    swap(mt, nmt);
}

void do_r(){
    clear();
    for(int i = 0; i < n; i++){
        for(int j = m-1; j >= 0; j--){
            if(mt[i][j] == '.') continue;
            nmt[i][m-cnt[i]-1] = mt[i][j];
            cnt[i]++;
        }
    }
    swap(mt, nmt);
}

void do_u(){
    clear();
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(mt[i][j] == '.') continue;
            nmt[cnt[j]][j] = mt[i][j];
            cnt[j]++;
        }
    }
    swap(mt, nmt);
}

void do_d(){
    clear();
    for(int i = n-1; i >= 0; i--){
        for(int j = 0; j < m; j++){
            if(mt[i][j] == '.') continue;
            nmt[n-cnt[j]-1][j] = mt[i][j];
            cnt[j]++;
        }
    }
    swap(mt, nmt);
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--){
        mt.clear();
        nmt.clear();
        cin >> n >> m;
        mt.resize(n);
        nmt.resize(n);
        for(int i = 0; i < n; i++){
            mt[i].resize(m);
            nmt[i].resize(m);
            for(int j = 0; j < m; j++){
                cin >> mt[i][j];
            }
        }
        string task;
        cin >> task;
        if(task.size() >= 4 && task.substr(0, 4) == "LURD"){
            for(int i = 0; i < 4; i++){
                char x = task[i];
                if(x == 'L') do_l();
                if(x == 'R') do_r();
                if(x == 'U') do_u();
                if(x == 'D') do_d();
            }
        }
        else{
            for(auto x : task){
                if(x == 'L') do_l();
                if(x == 'R') do_r();
                if(x == 'U') do_u();
                if(x == 'D') do_d();
            }
        }
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                cout << mt[i][j];
            }
            cout << "\n";
        }

    }
}
/*
......d
.....be
....aca
...bcae
...aedd
1
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
LURDLURD
 */