#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

vector<vector<char>> a;
int n, m;

void makeL() {
	for (int i = 0; i < n; ++i) {
		int cur = 0;
		for (int j = 0; j < m; ++j) {
			if (a[i][j] != '.') {
				a[i][cur] = a[i][j];
				cur++;
			}
		}
		for (int j = cur; j < m; ++j) {
			a[i][j] = '.';
		}
	}
}
void makeR() {
	for (int i = 0; i < n; ++i) {
		int cur = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j] != '.') {
				a[i][cur] = a[i][j];
				cur--;
			}
		}
		for (int j = cur; j >= 0; --j) {
			a[i][j] = '.';
		}
	}
}
void makeU() {
	for (int j = 0; j < m; ++j) {
		int cur = 0;
		for (int i = 0; i < n; ++i) {
			if (a[i][j] != '.') {
				a[cur][j] = a[i][j];
				cur++;
			}
		}
		for (int i = cur; i < n; ++i) {
			a[i][j] = '.';
		}
	}
}
void makeD() {
	for (int j = 0; j < m; ++j) {
		int cur = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (a[i][j] != '.') {
				a[cur][j] = a[i][j];
				cur--;
			}
		}
		for (int i = cur; i >= 0; --i) {
			a[i][j] = '.';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		cin >> n >> m;
		a.resize(n, vector<char>(m));
		for (int i = 0; i < n; ++i) {
			string s; cin >> s;
			for (int j = 0; j < m; ++j) {
				a[i][j] = s[j];
			}
		}
		string s; cin >> s;
		int q = s.size();
		vector<char> s2;
		int cur = 0;
		int type = -1;
		while (cur < q) {
			if (s[cur] == 'L' || s[cur] == 'R') {
				while (cur < q && (s[cur] == 'L' || s[cur] == 'R')) {
					cur++;
				}
				if (type == 0) {
					s2.pop_back();
					s2.push_back(s[cur - 1]);
				}
				else if (s2.size() < 2 || s[cur - 1] != s2[s2.size() - 2]) {
					s2.push_back(s[cur - 1]);
					type = 0;
				}
			}
			else {
				while (cur < q && (s[cur] == 'U' || s[cur] == 'D')) {
					cur++;
				}
				if (type == 1) {
					s2.pop_back();
					s2.push_back(s[cur - 1]);
				}
				else if (s2.size() < 2 || s[cur - 1] != s2[s2.size() - 2]) {
					s2.push_back(s[cur - 1]);
					type = 1;
				}
			}
		}
		q = s2.size();
		for (int i = 0; i < q; ++i) {
			char type = s2[i];
			if (type == 'L')
				makeL();
			else if (type == 'R')
				makeR();
			else if (type == 'U')
				makeU();
			else if (type == 'D')
				makeD();
		}
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << a[i][j];
			}
			cout << "\n";
		}
		a.clear();
	}

	return 0;
}