#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

struct elem {
	char c; int i, j;
};
vector<vector<elem>> a;
int n, m;

void makeL() {
	for (int i = 0; i < n; ++i) {
		int cur = 0;
		for (int j = 0; j < m; ++j) {
			if (a[i][j].c != '.') {
				a[i][cur] = a[i][j];
				cur++;
			}
		}
		for (int j = cur; j < m; ++j) {
			a[i][j] = { '.', -1, -1 };
		}
	}
}
void makeR() {
	for (int i = 0; i < n; ++i) {
		int cur = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j].c != '.') {
				a[i][cur] = a[i][j];
				cur--;
			}
		}
		for (int j = cur; j >= 0; --j) {
			a[i][j] = { '.', -1, -1 };
		}
	}
}
void makeU() {
	for (int j = 0; j < m; ++j) {
		int cur = 0;
		for (int i = 0; i < n; ++i) {
			if (a[i][j].c != '.') {
				a[cur][j] = a[i][j];
				cur++;
			}
		}
		for (int i = cur; i < n; ++i) {
			a[i][j] = { '.', -1, -1 };
		}
	}
}
void makeD() {
	for (int j = 0; j < m; ++j) {
		int cur = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (a[i][j].c != '.') {
				a[cur][j] = a[i][j];
				cur--;
			}
		}
		for (int i = cur; i >= 0; --i) {
			a[i][j] = { '.', -1, -1 };
		}
	}
}

vector<vector<pair<int, int>>> nxt;
vector<vector<bool>> vis;
vector<vector<pair<int, int>>> comp;
vector<vector<pair<int, int>>> ind;

void dfs(int i, int j) {
	vis[i][j] = true;
	comp.back().push_back({ i, j });
	ind[i][j] = { comp.size() - 1, comp.back().size() - 1 };
	int i1 = nxt[i][j].first, j1 = nxt[i][j].second;
	if (!vis[i1][j1])
		dfs(i1, j1);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		cin >> n >> m;
		a.resize(n, vector<elem>(m));
		for (int i = 0; i < n; ++i) {
			string s; cin >> s;
			for (int j = 0; j < m; ++j) {
				a[i][j].c = s[j];
			}
		}
		string s; cin >> s;
		int q = s.size();
		makeL(); makeU(); makeR(); makeD();
		vector<vector<char>> ans(n, vector<char>(m, '.'));
		if (q >= 8) {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					a[i][j].i = i; a[i][j].j = j;
				}
			}
			makeL(); makeU(); makeR(); makeD();
			nxt.resize(n, vector<pair<int, int>>(m));
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (a[i][j].c == '.') continue;
					int i1 = a[i][j].i, j1 = a[i][j].j;
					nxt[i1][j1] = { i, j };
				}
			}
			vis.resize(n, vector<bool>(m, false));
			ind.resize(n, vector<pair<int, int>>(m));
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (!vis[i][j]) {
						comp.emplace_back();
						dfs(i, j);
					}
				}
			}
			int cnt = q / 4 - 2;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (a[i][j].c == '.') continue;
					int ind_comp = ind[i][j].first, ind_ind = ind[i][j].second;
					int sz = comp[ind_comp].size();
					auto el = comp[ind_comp][(ind_ind + cnt) % sz];
					ans[el.first][el.second] = a[i][j].c;
				}
			}
		}
		else {
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					ans[i][j] = a[i][j].c;
				}
			}
		}

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << ans[i][j];
			}
			cout << "\n";
		}
		a.clear();
		nxt.clear();
		comp.clear();
		vis.clear();
		ind.clear();
	}

	return 0;
}
