#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <set>
using namespace std;
using ll = long long;
const ll INF = 1e18;

struct rect {
	ll xl, yl, xr, yr;
};
struct seg {
	ll l, r;
};
bool cmp(seg a, seg b) {
	if (a.l == b.l)
		return a.r < b.r;
	return a.l < b.l;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t; cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n; cin >> n;
		
		if (n == 1) {
			vector<rect> mas(n);
			for (int i = 0; i < n; ++i) {
				cin >> mas[i].xl >> mas[i].yl >> mas[i].xr >> mas[i].yr;
			}
			cout << 1 << "\n";
			cout << mas[0].xl << " " << mas[0].xr << " " << mas[0].yr - mas[0].yl + 1 << " " << mas[0].yr - mas[0].yl + 1 << "\n";
		}
		else {
			vector<seg> mas(n);
			for (int i = 0; i < n; ++i) {
				ll y;
				cin >> mas[i].l >> y >> mas[i].r >> y;
			}
			sort(mas.begin(), mas.end(), cmp);
			ll pred = mas[0].l;
			vector<seg> ans;
			for (int i = 1; i < n; ++i) {
				if (mas[i].l <= mas[i - 1].r + 1) {
					continue;
				}
				else {
					ans.push_back({ pred, mas[i - 1].r });
					pred = mas[i].l;
				}
			}
			ans.push_back({ pred, mas[n - 1].r });
			cout << ans.size() << "\n";
			for (auto el : ans) {
				cout << el.l << " " << el.r << " 1 1\n";
			}
		}
	}

	return 0;
}