#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <set>
using namespace std;
using ll = long long;
const ll INF = 1e18;

struct rect {
	ll xl, yl, xr, yr;
};
struct seg {
	ll l, r;
};
bool cmp(seg a, seg b) {
	if (a.l == b.l)
		return a.r < b.r;
	return a.l < b.l;
}
struct elem {
	int x1, x2, cnt, maxk;
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t; cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n; cin >> n;
		vector<rect> mas(n);
		vector<vector<bool>> a(11, vector<bool>(11, false));
		for (int i = 0; i < n; ++i) {
			cin >> mas[i].xl >> mas[i].yl >> mas[i].xr >> mas[i].yr;
			for (int x = mas[i].xl; x <= mas[i].xr; ++x) {
				for (int y = mas[i].yl; y <= mas[i].yr; ++y) {
					a[x][y] = true;
				}
			}
		}
		set<pair<int, int>> pred;
		vector<vector<int>> cnt(11, vector<int>(11, 0));
		vector<vector<int>> cur(11, vector<int>(11, 0));
		vector<vector<int>> maxk(11, vector<int>(11, 0));
		for (int y = 0; y <= 10; ++y) {
			vector<seg> s;
			int x0 = -1, predx = -1;
			for (int x = 0; x <= 10; ++x) {
				if (a[x][y]) {
					if (x0 == -1) {
						x0 = x;
					}
					predx = x;
				}
				else {
					if (x0 != -1) {
						s.push_back({ x0, predx });
					}
					predx = -1;
					x0 = -1;
				}
			}
			if (x0 != -1) {
				s.push_back({ x0, predx });
			}
			for (auto el : s) {
				int x1 = el.l, x2 = el.r;
				cnt[x1][x2]++;
				if (pred.find({ x1, x2 }) == pred.end()) {
					cur[x1][x2] = 0;
				}
				cur[x1][x2]++;
				maxk[x1][x2] = max(maxk[x1][x2], cur[x1][x2]);
				
			}
			pred.clear();
			for (auto el : s) {
				pred.insert({ el.l, el.r });
			}
		}
		vector<elem> ans;
		for (int x1 = 0; x1 <= 10; ++x1) {
			for (int x2 = 0; x2 <= 10; ++x2) {
				if (cnt[x1][x2] > 0) {
					ans.push_back({ x1, x2, cnt[x1][x2], maxk[x1][x2] });
				}
			}
		}
		cout << ans.size() << "\n";
		for (auto el : ans) {
			cout << el.x1 << " " << el.x2 << " " << el.cnt << " " << el.maxk << "\n";
		}

		
	}
	return 0;
}