#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct fenwick{
    int n;
    vector<ll> f;

    fenwick(int n) : n(n) {
        f.resize(n);
    }

    void upd(int pos) {
        for (; pos < n; pos |= (pos + 1)) f[pos] += 1;
    }

    ll get(int pos){
        ll res = 0;
        for (; pos >= 0; pos = (pos & (pos + 1)) - 1) res += f[pos];
        return res;
    }
};

void solve() {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pair<ll, ll>> orders;

    ll cur = 0;
    forn(i, n + m) {
        ll t, x;
        cin >> t >> x;
        if (t == 1) cur += x;
        else orders.emplace_back(cur, cur + x);
    }

    sort(all(orders));
    vector<ll> ys;
    for (auto &[x, y]: orders) ys.emplace_back(y);
    sort(all(ys));
    ys.resize(unique(all(ys)) - ys.begin());
    for (auto &[x, y]: orders) y = lower_bound(all(ys), y) - ys.begin();

    ll ans = 0;
    fenwick f(1e5);
    for (auto &[x, y]: orders) {
        f.upd(y);
        ans = max(ans, p * f.get(y) - c * (ys[y] - 1));
    }

    cout << ans << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\untitled\\out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}