#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct segtree {
    struct node {
        int mn = 0;

        node() = default;

        node(int mn) : mn(mn) {}
    };

    node merge(node a, node b) {
        if (a.mn < b.mn) return a;
        return b;
    }

    int n, N;
    vector<node> t;
    vector<int> lazy;

    void push(int v) {
        if (!lazy[v]) return;
        t[v].mn += lazy[v];
        if (v * 2 + 2 < t.size()) {
            lazy[v * 2 + 1] += lazy[v];
            lazy[v * 2 + 2] += lazy[v];
        }
        lazy[v] = 0;
    }

    segtree(int n) : n(n) {
        N = 1 << (__lg(n - 1) + 1);
        t.resize(2 * N);
        lazy.resize(2 * N);
    }

    void upd(int v, int l, int r, int ql, int qr, int val) {
        push(v);
        if (r <= ql || qr <= l) return;
        if (ql <= l && r <= qr) {
            lazy[v] += val;
            push(v);
            return;
        }
        int m = (l + r) / 2;
        upd(v * 2 + 1, l, m, ql, qr, val);
        upd(v * 2 + 2, m, r, ql, qr, val);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void upd(int l, int r, int val) {
        upd(0, 0, N, l, r + 1, val);
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v);
        if (r <= ql || qr <= l) return 1e9;
        if (ql <= l && r <= qr) {
            return t[v].mn;
        }
        int m = (r + l) / 2;
        return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, N, l, r + 1);
    }
};

const int OPEN = 0, CLOSE = 1;

void solve() {
    int n;
    cin >> n;
    vector<array<int, 4>> events;
    forn(i, n) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        events.push_back({OPEN, y1, x1, x2});
        events.push_back({CLOSE, y2 + 1, x1, x2});
    }

    sort(all(events), [](const auto &a, const auto &b) {
        return tie(a[1], a[0]) < tie(b[1], b[0]);
    });

    vector<int> xs;
    for (auto &[t, y, x1, x2]: events) {
        xs.emplace_back(x1 - 1);
        xs.emplace_back(x1);
        xs.emplace_back(x2);
        xs.emplace_back(x2 + 1);
    }
    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());

    for (auto &[t, y, x1, x2]: events) {
        x1 = lower_bound(all(xs), x1) - xs.begin();
        x2 = lower_bound(all(xs), x2) - xs.begin();
    }

    segtree st(xs.size());

    set<pair<int, int>> ans;

    int last = 0;
    for (auto &[t, y, x1, x2]: events) {
        if (t == OPEN) {
            st.upd(x1, x2, 1);
        } else {
            st.upd(x1, x2, -1);
        }
//        forn(i, xs.size()) cerr << st.get(i, i) << " ";
//        cerr << nl;
        if (last != y) {
            forn(i, xs.size()) {
                if (st.get(i, i)) {
                    int l = 1, r = xs.size() - i + 1;
                    while (r - l > 1) {
                        int mid = (l + r) / 2;
                        if (st.get(i, i + mid - 1)) l = mid;
                        else r = mid;
                    }
                    ans.emplace(i, i + l - 1);
                    i = i + l - 1;
                }
            }
        }
        last = y;
    }

    cout << ans.size() << nl;
    for (auto [x1, x2]: ans) cout << xs[x1] _ xs[x2] _ 0 _ 0 << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\untitled\\out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    cin >> t;
    while (t--) solve();
}