#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

int n, m;

void move_left(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') b[i] += a[i][j];
        }
        while (b[i].size() != m) b[i] += '.';
    }
    a = b;
}

void move_right(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != '.') b[i] += a[i][j];
        }
        while (b[i].size() != m) b[i] += '.';
        reverse(all(b[i]));
    }
    a = b;
}

void move_up(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) b[i] += '.';
    }

    for (int j = 0; j < m; ++j) {
        int num = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                b[num++][j] = a[i][j];
            }
        }
    }

    a = b;
}

void move_down(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) b[i] += '.';
    }

    for (int j = 0; j < m; ++j) {
        int num = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                b[num--][j] = a[i][j];
            }
        }
    }

    a = b;
}

map<char, char> get_pair;

void get_new_s(string &s) {
    string ans;

    for (auto i : s) {
        bool can = true;

        while (true) {
            bool del = false;

            if (ans.size() >= 1 && ans.back() == i) can = false;

            if (ans.size() >= 2 && ans[ans.size() - 2] == i) can = false;

            if (ans.size() >= 2 && ans[ans.size() - 2] == i) {
                can = false;
            }
            if (!can) break;

            if (ans.size() >= 1 && ans.back() == get_pair[i]) {
                ans.pop_back();
                del = true;
            }
            if (!del) break;
        }

        if (can) ans += i;
    }

    s = ans;
}

void solve() {
    cin >> n >> m;

    vector<string> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    string s;
    cin >> s;

    get_new_s(s);

    for (auto i : s) {
        if (i == 'L') {
            move_left(a);
        }
        else if (i == 'R') {
            move_right(a);
        }
        else if (i == 'U') {
            move_up(a);
        }
        else {
            move_down(a);
        }
    }

    for (auto i : a) {
        cout << i << '\n';
    }
}

int main() {
    fast_stream();

    get_pair['L'] = 'R';
    get_pair['R'] = 'L';
    get_pair['D'] = 'U';
    get_pair['U'] = 'D';

    int tests;
    cin >> tests;

    while (tests--) {
        solve();
    }
}
