#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

int n, m;

void move_left(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') b[i] += a[i][j];
        }
        while (b[i].size() != m) b[i] += '.';
    }
    a = b;
}

void move_right(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != '.') b[i] += a[i][j];
        }
        while (b[i].size() != m) b[i] += '.';
        reverse(all(b[i]));
    }
    a = b;
}

void move_up(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) b[i] += '.';
    }

    for (int j = 0; j < m; ++j) {
        int num = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                b[num++][j] = a[i][j];
            }
        }
    }

    a = b;
}

void move_down(vector<string> &a) {
    vector<string> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) b[i] += '.';
    }

    for (int j = 0; j < m; ++j) {
        int num = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                b[num--][j] = a[i][j];
            }
        }
    }

    a = b;
}

void move_left_vec(vector<vector<pair<int, int>>> &a) {
    vector<vector<pair<int, int>>> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j].first != -1) b[i].push_back(a[i][j]);
        }
        while (b[i].size() != m) b[i].push_back({-1, -1});
    }
    a = b;
}

void move_right_vec(vector<vector<pair<int, int>>> &a) {
    vector<vector<pair<int, int>>> b(n);
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j].first != -1) b[i].push_back(a[i][j]);
        }
        while (b[i].size() != m) b[i].push_back({-1, -1});
        reverse(all(b[i]));
    }
    a = b;
}

void move_up_vec(vector<vector<pair<int, int>>> &a) {
    vector<vector<pair<int, int>>> b(n, vector<pair<int, int>> (m, {-1, -1}));

    for (int j = 0; j < m; ++j) {
        int num = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j].first != -1) {
                b[num++][j] = a[i][j];
            }
        }
    }

    a = b;
}

void move_down_vec(vector<vector<pair<int, int>>> &a) {
    vector<vector<pair<int, int>>> b(n, vector<pair<int, int>> (m, {-1, -1}));

    for (int j = 0; j < m; ++j) {
        int num = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j].first != -1) {
                b[num--][j] = a[i][j];
            }
        }
    }

    a = b;
}

map<char, char> get_pair;

void get_new_s(string &s) {
    string ans;

    for (auto i : s) {
        bool can = true;

        while (true) {
            bool del = false;

            if (ans.size() >= 1 && ans.back() == i) can = false;

            if (ans.size() >= 2 && ans[ans.size() - 2] == i) can = false;

            if (ans.size() >= 2 && ans[ans.size() - 2] == i) {
                can = false;
            }
            if (!can) break;

            if (ans.size() >= 1 && ans.back() == get_pair[i]) {
                ans.pop_back();
                del = true;
            }
            if (!del) break;
        }

        if (can) ans += i;
    }

    s = ans;
}

void solve() {
    cin >> n >> m;

    vector<string> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    string s;
    cin >> s;

    get_new_s(s);

    if (s.size() <= 20) {
        for (auto i : s) {
            if (i == 'L') {
                move_left(a);
            }
            else if (i == 'R') {
                move_right(a);
            }
            else if (i == 'U') {
                move_up(a);
            }
            else {
                move_down(a);
            }
        }

        for (auto i : a) {
            cout << i << '\n';
        }
        return;
    }

    int type = 0;
    int ind_begin = 0;

    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == 'L' && s[i + 1] == 'U' && s[i + 2] == 'R' && s[i + 3] == 'D') {
            type = 0;
            ind_begin = i;
            break;
        }
        if (s[i] == 'L' && s[i + 1] == 'D' && s[i + 2] == 'R' && s[i + 3] == 'U') {
            type = 1;
            ind_begin = i;
            break;
        }
    }

    for (int i = 0; i < ind_begin + 4; ++i) {
        if (s[i] == 'L') {
            move_left(a);
        }
        else if (s[i] == 'R') {
            move_right(a);
        }
        else if (s[i] == 'U') {
            move_up(a);
        }
        else {
            move_down(a);
        }
    }

    int cnt_cycles = (s.size() - ind_begin - 4) / 4;
    int nxt = ind_begin + 4 + cnt_cycles * 4;

    vector<vector<pair<int, int>>> real_ind(n, vector<pair<int, int>> (m, {-1, -1}));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                real_ind[i][j] = {i, j};
            }
        }
    }

    if (type == 0) {
        move_left_vec(real_ind);
        move_up_vec(real_ind);
        move_right_vec(real_ind);
        move_down_vec(real_ind);
    }
    else {
        move_left_vec(real_ind);
        move_down_vec(real_ind);
        move_right_vec(real_ind);
        move_up_vec(real_ind);
    }

    vector<vector<pair<int, int>>> jump(n, vector<pair<int, int>> (m, {-1, -1}));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (real_ind[i][j].first != -1) {
                jump[real_ind[i][j].first][real_ind[i][j].second] = {i, j};
            }
        }
    }

    vector<vector<pair<int, int>>> new_ind(n, vector<pair<int, int>> (m, {-1, -1}));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (new_ind[i][j].first == -1 && jump[i][j].first != -1) {
                int x = jump[i][j].first, y = jump[i][j].second;
                vector<pair<int, int>> in_this = {{i, j}};

                while (x != i || y != j) {
                    in_this.push_back({x, y});
                    int new_x = jump[x][y].first;
                    int new_y = jump[x][y].second;
                    x = new_x, y = new_y;
                }

                int need = (cnt_cycles - 1) % in_this.size();

                for (int k = 0; k < in_this.size(); ++k) {
                    x = in_this[k].first, y = in_this[k].second;

                    new_ind[x][y] = in_this[(k + need) % in_this.size()];
                }
            }
        }
    }

    vector<vector<pair<int, int>>> aaa(n, vector<pair<int, int>> (m, {-1, -1}));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (new_ind[i][j].first != -1) {
                aaa[new_ind[i][j].first][new_ind[i][j].second] = {i, j};
            }
        }
    }

    real_ind = aaa;

    for (int i = nxt; i < s.size(); ++i) {
        if (s[i] == 'L') {
            move_left_vec(real_ind);
        }
        else if (s[i] == 'R') {
            move_right_vec(real_ind);
        }
        else if (s[i] == 'U') {
            move_up_vec(real_ind);
        }
        else {
            move_down_vec(real_ind);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (real_ind[i][j].first == -1) {
                cout << '.';
            }
            else {
                cout << a[real_ind[i][j].first][real_ind[i][j].second];
            }
        }
        cout << '\n';
    }
}

int main() {
    fast_stream();

    get_pair['L'] = 'R';
    get_pair['R'] = 'L';
    get_pair['D'] = 'U';
    get_pair['U'] = 'D';

    int tests;
    cin >> tests;

    while (tests--) {
        solve();
    }
}
