#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<int>> rotate(vector<vector<int>> &table, char t)
{
    int n = table.size();
    int m = table[0].size();
    vector<vector<int>> ans(n, vector<int>(m, -1));
    if (t == 'L')
    {
        for (int i = 0; i < n; i++)
        {
            int cnt = 0;
            for (int j = 0; j < m; j++)
            {
                if (table[i][j] != -1)
                    ans[i][cnt++] = table[i][j];
            }
        }
    }
    else if (t == 'R')
    {
        for (int i = 0; i < n; i++)
        {
            int cnt = m - 1;
            for (int j = m - 1; j >= 0; j--)
            {
                if (table[i][j] != -1)
                    ans[i][cnt--] = table[i][j];
            }
        }
    }
    else if (t == 'U')
    {
        for (int j = 0; j < m; j++)
        {
            int cnt = 0;
            for (int i = 0; i < n; i++)
            {
                if (table[i][j] != -1)
                    ans[cnt++][j] = table[i][j];
            }
        }
    }
    else
    {
        for (int j = 0; j < m; j++)
        {
            int cnt = n - 1;
            for (int i = n - 1; i >= 0; i--)
            {
                if (table[i][j] != -1)
                    ans[cnt--][j] = table[i][j];
            }
        }
    }
    return ans;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<string> table(n);
    vector<vector<int>> t1(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++)
    {
        cin >> table[i];
        for (int j = 0; j < m; j++)
            if (table[i][j] != '.')
                t1[i][j] = i * m + j;
    }

    string s;
    cin >> s;

    string new_s = "";
    string last = "00";
    for (int i = 0; i < s.size();)
    {
        bool t = s[i] == 'L' || s[i] == 'R';
        while (i < s.size() && (s[i] == 'L' || s[i] == 'R') == t)
            ++i;
        if (!new_s.empty() && (new_s.back() == 'L' || new_s.back() == 'R') == t)
        {
            new_s.back() = s[i - 1];
            last[t] = s[i - 1];
            continue;
        }
        if (last[t] != s[i - 1])
        {
            new_s.push_back(s[i - 1]);
            last[t] = s[i - 1];
        }
    }
    if (new_s.size() < 4)
    {
        for (int i = 0; i < new_s.size(); i++)
            t1 = rotate(t1, new_s[i]);
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                if (t1[i][j] != -1)
                    cout << table[t1[i][j] / m][t1[i][j] % m];
                else
                    cout << '.';
            }
            cout << '\n';
        }
        return;
    }

    for (int i = 0; i < 4; i++)
        t1 = rotate(t1, new_s[i]);

    vector<vector<int>> perm(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            if (t1[i][j] != -1)
                perm[i][j] = i * m + j;
    }


    int k = new_s.size() / 4 - 1;
    for (int i = 0; i < 4; i++)
        perm = rotate(perm, new_s[i]);
    
    vector<vector<int>> cycles;
    vector<bool> used(n * m);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (t1[i][j] == -1)
                continue;
            int x = i * m + j;
            if (!used[x])
                cycles.emplace_back();
            while (!used[x])
            {
                used[x] = true;
                cycles.back().push_back(x);
                x = perm[x / m][x % m];
            }
        }
    }

    for (auto &v : cycles)
    {
        for (int i = 0; i < v.size(); i++)
            perm[v[i] / m][v[i] % m] = v[(i + k) % v.size()];
    }

    vector<vector<int>> t2(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (t1[i][j] != -1)
                t2[i][j] = t1[perm[i][j] / m][perm[i][j] % m];
        }
    }

    for (int i = new_s.size() / 4 * 4; i < new_s.size(); i++)
        t2 = rotate(t2, new_s[i]);

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (t2[i][j] != -1)
                cout << table[t2[i][j] / m][t2[i][j] % m];
            else
                cout << '.';
        }
        cout << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif

    while (t--)
        solve();
    return 0;
}