#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;

vector<vector<char>> ar;
ll m, n;

void right() {
	for (int i = 0; i < m; i++) {
		ll ind = n - 1;
		for (int j = n - 1; j >= 0; j--) {
			if (ar[i][j] == '.') continue;
			ar[i][ind] = ar[i][j];
			if(j != ind) ar[i][j] = '.';
			ind--;
		}
	}
}

void left() {
	for (int i = 0; i < m; i++) {
		ll ind = 0;
		for (int j = 0; j < n; j++) {
			if (ar[i][j] == '.') continue;
			ar[i][ind] = ar[i][j];
			if(j != ind) ar[i][j] = '.';
			ind++;
		}
	}
}

void down() {
	for (int j = 0; j < n; j++) {
		ll ind = m - 1;
		for (int i = m - 1; i >= 0; i--) {
			if (ar[i][j] == '.') continue;
			ar[ind][j] = ar[i][j];
			if(i != ind) ar[i][j] = '.';
			ind--;
		}
	}
}

void up() {
	for (int j = 0; j < n; j++) {
		ll ind = 0;
		for (int i = 0; i < m; i++) {
			if (ar[i][j] == '.') continue;
			ar[ind][j] = ar[i][j];
			if (i != ind) ar[i][j] = '.';
			ind++;
		}
	}
}

void solve() {
	cin >> m >> n;
	ar.assign(m, vector<char>(n));
	for (int i = 0; i < m; i++) {
		string st; cin >> st;
		for (int j = 0; j < n; j++) {
			ar[i][j] = st[j];
		}
	}
	string inp; cin >> inp;
	string st = "";
	ll q = inp.size();
	ll mode = -1;
	char last = 'O';
	for (int i = 0; i < q; i++) {
		ll curmod = 1;
		if (inp[i] == 'L' || inp[i] == 'R') curmod = 2;
		if (mode == -1) mode = curmod;
		if (curmod != mode) {
			st.push_back(last);
			mode = curmod;
		}
		last = inp[i];
	}
	st.push_back(last);
	//cout << st << endl;
	ll curh = -1, curv = -1;
	string st2 = "";
	for (int i = 0; i < st.size(); i++) {
		if (st[i] == 'U' && curv == 1) continue;
		if (st[i] == 'D' && curv == 2) continue;
		if (st[i] == 'L' && curh == 1) continue;
		if (st[i] == 'R' && curh == 2) continue;

		if (st[i] == 'U') curv = 1;
		if (st[i] == 'D') curv = 2;
		if (st[i] == 'L') curh = 1;
		if (st[i] == 'R') curh = 2;

		st2.push_back(st[i]);
	}
	//cout << st2 << endl;
	for (char c : st2) {
		if (c == 'U') {
			up();
		}
		else if (c == 'D') {
			down();
		}
		else if (c == 'L') {
			left();
		}
		else {
			right();
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cout << ar[i][j];
		}
		cout << endl;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);

	ll t; cin >> t;
	while (t--) {
		solve();
	}

}