#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;

#pragma optimize("O3")
#pragma target("avx2")

vector<vector<ll>> ar;
ll m, n;

void right() {
	for (int i = 0; i < m; i++) {
		ll ind = n - 1;
		for (int j = n - 1; j >= 0; j--) {
			if (ar[i][j] == '.') continue;
			ar[i][ind] = ar[i][j];
			if(j != ind) ar[i][j] = '.';
			ind--;
		}
	}
}

void left() {
	for (int i = 0; i < m; i++) {
		ll ind = 0;
		for (int j = 0; j < n; j++) {
			if (ar[i][j] == '.') continue;
			ar[i][ind] = ar[i][j];
			if(j != ind) ar[i][j] = '.';
			ind++;
		}
	}
}

void down() {
	for (int j = 0; j < n; j++) {
		ll ind = m - 1;
		for (int i = m - 1; i >= 0; i--) {
			if (ar[i][j] == '.') continue;
			ar[ind][j] = ar[i][j];
			if(i != ind) ar[i][j] = '.';
			ind--;
		}
	}
}

void up() {
	for (int j = 0; j < n; j++) {
		ll ind = 0;
		for (int i = 0; i < m; i++) {
			if (ar[i][j] == '.') continue;
			ar[ind][j] = ar[i][j];
			if (i != ind) ar[i][j] = '.';
			ind++;
		}
	}
}

string do1(string inp) {
	string st2 = "";
	ll curh = -1, curv = -1;
	for (int i = 0; i < inp.size(); i++) {
		if (inp[i] == 'U' && curv == 1) continue;
		if (inp[i] == 'D' && curv == 2) continue;
		if (inp[i] == 'L' && curh == 1) continue;
		if (inp[i] == 'R' && curh == 2) continue;

		if (inp[i] == 'U') curv = 1;
		if (inp[i] == 'D') curv = 2;
		if (inp[i] == 'L') curh = 1;
		if (inp[i] == 'R') curh = 2;

		st2.push_back(inp[i]);
	}
	return st2;
}

string do2(string st2) {
	ll mode = -1;
	string st = "";
	char last = 'O';
	for (int i = 0; i < st2.size(); i++) {
		ll curmod = 1;
		if (st2[i] == 'L' || st2[i] == 'R') curmod = 2;
		if (mode == -1) mode = curmod;
		if (curmod != mode) {
			st.push_back(last);
			mode = curmod;
		}
		last = st2[i];
	}
	st.push_back(last);
	return st;
}

bool prot(char c1, char c2) {
	if (c1 == 'D' && c2 == 'U') return true;
	if (c1 == 'U' && c2 == 'D') return true;
	if (c1 == 'R' && c2 == 'L') return true;
	if (c1 == 'L' && c2 == 'R') return true;
	return false;
}

void aply(char c) {
	if (c == 'U') {
		up();
	}
	else if (c == 'D') {
		down();
	}
	else if (c == 'L') {
		left();
	}
	else if (c == 'R') {
		right();
	}
}

void doCycle(string st) {
	ll cnt = (st.size() - 2) / 4;
	if (cnt == 0) return;
	vector<ll> data;
	vector<vector<ll>> ar2(m, vector<ll>(n));
	vector<vector<ll>> ar3(m, vector<ll>(n));
	ll ind = 1;
	vector<ll> info;
	vector<vector<ll>> pows;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			ar2[i][j] = ar[i][j];
			if (ar[i][j] != '.') {
				ar[i][j] = ind;
				ar3[i][j] = ind;
				data.push_back(ar2[i][j]);
				info.push_back(ind - 1);
				ind++;
			}
			else {
				ar[i][j] = 0;
			}
		}
	}
	aply(st[2]);
	aply(st[3]);
	aply(st[4]);
	aply(st[5]);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			if (ar[i][j] == 0) continue;
			info[ar3[i][j] - 1] = ar[i][j] - 1;
		}
	}
	pows.push_back(info);
	ll curpo = 1;
	while (curpo < cnt) {
		pows.push_back(vector<ll>(info.size()));
		for (int i = 0; i < info.size(); i++) {
			ll v = pows[pows.size() - 2][i];
			v = pows[pows.size() - 2][v];
			pows[pows.size() - 1][i] = v;
		}
		curpo *= 2;
	}
	ar = ar3;
	ind = pows.size() - 1;
	curpo /= 2;
	while (cnt > 0) {
		if (cnt >= curpo) {
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					if (ar[i][j] == 0) continue;
					ar[i][j] = pows[ind][ar[i][j] - 1] + 1;
				}
			}
			cnt -= curpo;
		}
		curpo /= 2;
		ind--;
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			ar[i][j] = ar[i][j] == 0 ? '.' : data[ar[i][j] - 1];
		}
	}
	int dbg = 0;
}

void solve() {
	cin >> m >> n;
	ar.assign(m, vector<ll>(n));
	for (int i = 0; i < m; i++) {
		string st; cin >> st;
		for (int j = 0; j < n; j++) {
			ar[i][j] = st[j];
		}
	}
	string inp; cin >> inp;
	inp = do1(inp);

	ll curh = -1, curv = -1;
	bool mdf = inp[0] == 'U' || inp[0] == 'D';
	char lastv = 'q', lasth = 'q';
	ll ind = -1;
	for (int i = 0; i < inp.size(); i++) {
		if (inp[i] == 'U') lastv = 'U';
		if (inp[i] == 'D') lastv = 'D';
		if (inp[i] == 'L') lasth = 'L';
		if (inp[i] == 'R') lasth = 'R';
		if (lastv != 'q' && lasth != 'q') {
			ind = i + 1;
			break;
		}
	}
	vector<ll> prev;
	ll cur = -1;
	
	for (int i = ind; i < inp.size(); i++) {

		if (cur != -1 && prot(inp[cur], inp[i])) {
			cur = prev[prev.size() - 1];
			prev.pop_back();
			continue;
		}
		else {
			prev.push_back(cur);
			cur = i;
		}
	}
	prev.push_back(cur);
	string st = "";
	if (mdf) {
		st.push_back(lastv);
		st.push_back(lasth);
	}
	else {
		st.push_back(lasth);
		st.push_back(lastv);
	}
	for (int i = 0; i < prev.size(); i++) {
		if(prev[i] != -1) st.push_back(inp[prev[i]]);
	}
	//cout << st << endl;
	//cout << st2 << endl;

	aply(st[0]);
	aply(st[1]);
	ll cnt = (st.size() - 2) / 4;
	doCycle(st);
	for (int i = 2 + cnt * 4; i < st.size(); i++) {
		aply(st[i]);
	}
	
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cout << (char)ar[i][j];
		}
		cout << endl;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);

	ll t; cin >> t;
	while (t--) {
		solve();
	}

}