#pragma GCC target("avx,avx2,popcnt,ssse3,sse4")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rndll(chrono::steady_clock::now().time_since_epoch().count());
#define allv(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
 
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
 
#ifdef DEBUG
const ll MAXN = 20, INF = 1e4;
#else
const ll MAXN = 1e6 + 10, INF = 1e9 + 57 * 4 + 52;
#endif
 
// data, ds
vector<int> a[MAXN];
char mp_char[MAXN];
int n, m;
void reflect_ud() {
    for (int i = 0; n - 1 - i > i; i++) {
        swap(a[i], a[n - 1 - i]);
    }
}
void reflect_lr() {
    for (int i = 0; m - 1 - i > i; i++) {
        for (int j = 0; j < n; j++) {
            swap(a[j][i], a[j][m - 1 - i]);
        }
    }
}
void do_op(char op) {
    if (op == 'L') {
        for (int i = 0; i < n; i++) {
            for (int j = 0, k = 0; j < m; j++) {
                while (k < m && a[i][k] == 0) k++;
                if (k == m) {
                    a[i][j] = 0;
                } else {
                    a[i][j] = a[i][k];
                    k++;
                }
            }
        }
    } else if (op == 'U') {
        for (int j = 0; j < m; j++) {
            for (int i = 0, k = 0; i < n; i++) {
                while (k < n && a[k][j] == 0) k++;
                if (k == n) {
                    a[i][j] = 0;
                } else {
                    a[i][j] = a[k][j];
                    k++;
                }
            }
        }
    } else if (op == 'D') {
        reflect_ud();
        do_op('U');
        reflect_ud();
    } else {
        reflect_lr();
        do_op('L');
        reflect_lr();
    }
}
template<typename T>
struct pairr : pair<T, T> {
    pairr() = default;
    pairr(pair<T, T> p) {
        this->first = p.first;
        this->second = p.second;
    }
    T& operator[](int i) {
        return i ? this->second : this->first;
    }
    T operator[](int i) const {
        return i ? this->second : this->first;
    }
};
void finish() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << mp_char[a[i][j]];
        }
        cout << '\n';
    }
}
int stateno(pairr<char> state) {
    int x = (state[1] == 'U' ? 1 : 0);
    x = (state[0] == 'L' ? x : 3 - x);
    return x;
}
pairr<char> getstate(int no) {
    assert(0 <= no && no <= 3);
    return make_pair("LLRR"[no], "DUUD"[no]);
}
int get_diff(int s1, int s2) {
    if (s1 == s2) return 0;
    if ((s2 - s1 + 4) % 4 == 1) return 1;
    return -1;
}
vector<int> inv(vector<int> const& v) {
    vector<int> res(sz(v));
    for (int i = 0; i < sz(v); i++) {
        res[v[i]] = i;
    }
    return res;
}
vector<int> operator*(vector<int> const& v1, vector<int> const& v2) {
    assert(sz(v1) == sz(v2));
    vector<int> res(sz(v1));
    for (int i = 0; i < sz(v1); i++) {
        res[i] = v1[v2[i]];
    }
    return res;
}

vector<int> identity(vector<int> const& a) {
    vector<int> res(sz(a));
    iota(allv(res), 0);
    return res;
}

vector<int> binpow(vector<int> a, int n) {
    if (n == 0) {
        return identity(a);
    }
    if (n % 2 == 0) {
        return binpow(a * a, n / 2);
    }
    else {
        return a * binpow(a * a, n / 2);
    }
}

int gstate;
void next_state() {
    pairr<char> s1 = getstate(gstate);
    pairr<char> s2 = getstate((gstate + 1) % 4);
    if (s1[0] != s2[0]) {
        do_op(s2[0]);
    } else {
        do_op(s2[1]);
    }
    gstate = (gstate + 1) % 4;
}
void prev_state() {
    pairr<char> s1 = getstate(gstate);
    pairr<char> s2 = getstate((gstate + 3) % 4);
    if (s1[0] != s2[0]) {
        do_op(s2[0]);
    } else {
        do_op(s2[1]);
    }
    gstate = (gstate + 3) % 4;
}

signed one() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            a[i][j] = s[j];
            if (a[i][j] == '.') {
                a[i][j] = 0;
            }
        }
    }
    string s;
    cin >> s;
    int q = sz(s);
    char optyp[256]; optyp['L'] = optyp['R'] = 0; optyp['U'] = optyp['D'] = 1;
    vector<int> states;
    int global_diff = 0;
    {
        int i = 0;
        while (i + 1 < q && optyp[s[i + 1]] == optyp[s[i]]) i++;
        do_op(s[i]);
        if (i == q - 1) {
            finish();
            return 0;
        }
        pairr<char> state;
        state[optyp[s[i]]] = s[i];
        state[optyp[s[i + 1]]] = s[i + 1];
        i++;
        do_op(s[i]);
        states.resize(1, stateno(state));
        for (i++; i < q; i++) {
            state[optyp[s[i]]] = s[i];
            int cur_no = stateno(state);
            global_diff += get_diff(states.back(), cur_no);
            states.push_back(cur_no);
        }
    }
    gstate = states[0];
    int counter = 1;
    mp_char[0] = '.';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                mp_char[counter] = a[i][j];
                a[i][j] = counter;
                counter++;
            }
        }
    }
    /*
    vector<int> perm_cyc(counter, 0);
    for (int _ = 0; _ < 4; _++) {
        next_state();
    }
    int counter2 = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                perm_cyc[counter2++] = a[i][j];
            }
        }
    }
    if (global_diff < 0) {
        perm_cyc = inv(perm_cyc);
    }
    for (int _ = 0; _ < 4; _++) {
        prev_state();
    }
    //vector<int> perm = binpow(perm_cyc, abs(global_diff) / 4);
    vector<int> perm = identity(perm_cyc);
    //global_diff %= 4;
    counter2 = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                a[i][j] = perm[counter2++];
            }
        }
    }
    */
    while (global_diff > 0) {
        next_state();
        global_diff--;
    }
    while (global_diff < 0) {
        prev_state();
        global_diff++;
    }
    finish();
    return 0;
}
 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    signed t;
    cin >> t;
    while (t--) {
        signed retcode = one();
        if (retcode) return retcode;
    }
    return 0;
}
