#ifndef SYSTY257
#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

struct Hash {
    size_t operator()(pii a) const {
        return a.first ^ a.second;
    }
};

void solve() {
    int n;
    cin >> n;
    vector <tuple <int, int, int, int> > v(n);
    int w = 0, h = 0;
    vector <int> allx, ally;
    for (auto &[x1, y1, x2, y2] : v) {
        cin >> x1 >> y1 >> x2 >> y2;
        allx.push_back(x1);
        allx.push_back(x1 + 1);
        allx.push_back(x2);
        allx.push_back(x2 + 1);
        ally.push_back(y1);
        ally.push_back(y1 + 1);
        ally.push_back(y2);
        ally.push_back(y2 + 1);
    }
    auto getid = [](int x, vector <int>& val) {
        return lower_bound(all(val), x) - val.begin();
    };
    {
        sort(all(allx));
        allx.resize(unique(all(allx)) - allx.begin());
        sort(all(ally));
        ally.resize(unique(all(ally)) - ally.begin());
        for (auto& [x1, y1, x2, y2] : v) {
            x1 = getid(x1, allx);
            x2 = getid(x2, allx);
            y1 = getid(y1, ally);
            y2 = getid(y2, ally);
        }
    }
    w = sz(allx);
    h = sz(ally);
    vector <vector <int> > field(w + 1, vector <int> (h + 1));
    for (auto [x1, y1, x2, y2] : v) {
        ++field[x1][y1];
        --field[x1][y2 + 1];
        --field[x2 + 1][y1];
        ++field[x2 + 1][y2 + 1];
    }
    for (int i = 0; i <= w; ++i) {
        for (int j = 1; j <= h; ++j) {
            field[i][j] += field[i][j - 1];
        }
    }
    for (int j = 0; j <= h; ++j) {
        for (int i = 1; i <= w; ++i) {
            field[i][j] += field[i - 1][j];
        }
    }
    map <pii, int> cnt;
    map <pii, int> mx;
    vector <tuple <int, int, int> > len;
    for (int j = 0; j < h; ++j) {
        bool opened = false;
        int curx = 0;
        vector <pii> nw;
        for (int i = 0; i <= w; ++i) {
            if (!field[i][j] && opened) {
                nw.emplace_back(curx, i - 1);
                opened = false;
            } else if (field[i][j] && !opened) {
                curx = i;
                opened = true;
            }
        }
        int width = (ally[j] - (j ? ally[j - 1] : 0));
        vector <tuple <int, int, int> > ch;
        int p1 = 0, p2 = 0;
        for (int i = 0; i <= w; ++i) {
            while (p1 < sz(len) && get<0>(len[p1]) < i) {
                ++p1;
            }
            while (p2 < sz(nw) && nw[p2].first < i) {
                ++p2;
            }
            bool done = false;
            if (p1 < sz(len) && p2 < sz(nw)) {
                auto [l1, r1, t1] = len[p1];
                auto [l2, r2] = nw[p2];
                if (l1 == l2 && r1 == r2 && l1 == i) {
                    ch.emplace_back(l1, r1, t1 + width);
                    mxr(mx[{l1, r1}], t1 + width);
                    cnt[{l1, r1}] += width;
                    done = true;
                }
            }
            if (p2 < sz(nw) && !done) {
                auto [l, r] = nw[p2];
                if (l == i) {
                    ch.emplace_back(l, r, 1);
                    mxr(mx[{l, r}], 1);
                    ++cnt[{l, r}];
                }
            }
        }
        len = ch;
    }
    cout << sz(cnt) << "\n";
    for (auto [a, b] : cnt) {
        cout << allx[a.first] << " " << allx[a.second] << " " << b << " " << mx[a] << "\n";
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}