#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
}

void solve() {
    int n;
    cin >> n;
    vector <tuple <int, int, int, int> > v(n);
    int w = 0, h = 0;
    for (auto &[x1, y1, x2, y2] : v) {
        cin >> x1 >> y1 >> x2 >> y2;
        mxr(w, x2);
        mxr(h, y2);
        --x1, --y1, --x2, --y2;
    }
    vector <vector <int> > field(w + 1, vector <int> (h + 1));
    for (auto [x1, y1, x2, y2] : v) {
        ++field[x1][y1];
        --field[x1][y2 + 1];
        --field[x2 + 1][y1];
        ++field[x2 + 1][y2 + 1];
    }
    for (int i = 0; i <= w; ++i) {
        for (int j = 1; j <= h; ++j) {
            field[i][j] += field[i][j - 1];
        }
    }
    for (int j = 0; j <= h; ++j) {
        for (int i = 1; i <= w; ++i) {
            field[i][j] += field[i - 1][j];
        }
    }
    map <pii, int> cnt;
    map <pii, int> mx;
    vector <tuple <int, int, int> > len;
    for (int j = 0; j < h; ++j) {
        bool opened = false;
        int curx = 0;
        vector <pii> nw;
        for (int i = 0; i <= w; ++i) {
            if (!field[i][j] && opened) {
                nw.emplace_back(curx, i - 1);
                opened = false;
            } else if (field[i][j] && !opened) {
                curx = i;
                opened = true;
            }
        }
        vector <tuple <int, int, int> > ch;
        for (auto [l, r, m] : len) {
            if (binary_search(all(nw), pii{l, r})) {
                ch.emplace_back(l, r, m + 1);
                mxr(mx[{l, r}], m + 1);
            }
        }
        for (auto [l, r] : nw) {
            auto it = lower_bound(all(len), tuple<int,int,int>{l, r, -1});
            bool put = true;
            if (it != len.end()) {
                auto [l1, r1, ttt] = *it;
                if (r == r1 && l == l1) {
                    put = false;
                }
            }
            if (put) {
                ch.emplace_back(l, r, 1);
                mxr(mx[{l, r}], 1);
            }
            ++cnt[{l, r}];
        }
        len = ch;
    }
    cout << sz(cnt) << "\n";
    for (auto [a, b] : cnt) {
        cout << a.first + 1 << " " << a.second + 1 << " " << b << " " << mx[a] << "\n";
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}