#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

struct FT {
    int sz;
    vector<int> ft;
    FT(int num) {
        sz = num;
        ft.assign(sz + 1, 0);
    }
    void add(int i, int x) {
        
        for (; i <= sz; i += (i & -i)) {
            ft[i] += x;
        }
    }
    int pref(int i) {
        int res = 0;
        for (; i > 0; i -= (i & -i)) {
            res += ft[i];
        }
        return res;
    }
};

enum DIR {L, R, U, D};
int n, m; // n - rows, m - cols
vector<string> a;

void f(DIR d) {
    if (d == L) {
        for (int row = 0; row < n; ++row) {
            string st;
            for (int col = 0; col < m; ++col) {
                if (a[row][col] != '.') {
                    st.push_back(a[row][col]);
                }
            }
            a[row] = st + string(m - st.size(), '.');
        }
    }
    if (d == R) {
        for (int row = 0; row < n; ++row) {
            string st;
            for (int col = 0; col < m; ++col) {
                if (a[row][col] != '.') {
                    st.push_back(a[row][col]);
                }
            }
            a[row] = string(m - st.size(), '.') + st;
        }
    }
    if (d == U) {
        for (int col = 0; col < m; ++col) {
            string st;
            for (int row = 0; row < n; ++row) {
                if (a[row][col] != '.') {
                    st.push_back(a[row][col]);
                }
            }
            for (int row = 0; row < n; ++row) {
                if (row < (int)st.size()) {
                    a[row][col] = st[row];
                } else a[row][col] = '.';
            }
        }
    }
    if (d == D) {
        for (int col = 0; col < m; ++col) {
            string st;
            for (int row = 0; row < n; ++row) {
                if (a[row][col] != '.') {
                    st.push_back(a[row][col]);
                }
            }
            for (int row = 0; row < n; ++row) {
                if (row < n - (int)st.size()) {
                    a[row][col] = '.';
                } else {
                    a[row][col] = st[row - (n - (int)st.size())];
                }
            }
        }
    }
}

inline void apply(char ch) {
    if (ch == 'L') {
                f(L);
            }
            if (ch == 'R') {
                f(R);
            }
            if (ch == 'U') {
                f(U);
            }
            if (ch == 'D') {
                f(D);
            }
}

vector<vector<int>> transformation;

void f_transformation(DIR d) {
if (d == L) {
        for (int row = 0; row < n; ++row) {
            vector<int> st;
            for (int col = 0; col < m; ++col) {
                if (transformation[row][col] != -1) {
                    st.push_back(transformation[row][col]);
                }
            }
            while ((int)st.size() < m) st.push_back(-1);
            transformation[row] = st;
        }
    }
    if (d == R) {
        for (int row = 0; row < n; ++row) {
            vector<int> st;
            for (int col = 0; col < m; ++col) {
                if (transformation[row][col] != -1) {
                    st.push_back(transformation[row][col]);
                }
            }
            reverse(in(st));
            while ((int)st.size() < m) st.push_back(-1);
            reverse(in(st));
            transformation[row] = st;
        }
    }
    if (d == U) {
        for (int col = 0; col < m; ++col) {
            vector<int> st;
            for (int row = 0; row < n; ++row) {
                if (transformation[row][col] != -1) {
                    st.push_back(transformation[row][col]);
                }
            }
            for (int row = 0; row < n; ++row) {
                if (row < (int)st.size()) {
                    transformation[row][col] = st[row];
                } else {
                    transformation[row][col] = -1;
                }
            }
        }
    }
    if (d == D) {
        for (int col = 0; col < m; ++col) {
            vector<int> st;
            for (int row = 0; row < n; ++row) {
                if (transformation[row][col] != -1) {
                    st.push_back(transformation[row][col]);
                }
            }
            for (int row = 0; row < n; ++row) {
                if (row < n - (int)st.size()) {
                    transformation[row][col] = -1;
                } else {
                    transformation[row][col] = st[row - (n - (int)st.size())];
                }
            }
        }
    }
}

inline void apply_transformation(char ch) {
    if (ch == 'L') {
                f_transformation(L);
            }
            if (ch == 'R') {
                f_transformation(R);
            }
            if (ch == 'U') {
                f_transformation(U);
            }
            if (ch == 'D') {
                f_transformation(D);
            }
        debug << ch << "done " << endl;
}

inline vector<int> mul(const vector<int>& base, const vector<int>& perm) {
    vector<int> new_base(perm.size());
    for (int i = 0; i < (int)perm.size(); ++i) {
        new_base[i] = perm[base[i]];
    }
    return new_base;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    
    int tt;
    cin >> tt;
    while (tt --> 0) {
        cin >> n >> m;
        a = vector<string>(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        int q;
        string s;
        cin >> s;
        q = s.size();
        

        for (int qry = 0; qry < 4; ++qry) {
            apply(s[qry]);
        }
        transformation.assign(n, vector<int>(m, -1));
        int id = 0;
        vector<pair<int, int>> pos;
        for (int row = 0; row < n; ++row) {
            for (int col = 0; col < m; ++col) {
                if (a[row][col] != '.') {
                    pos.emplace_back(row, col);
                    transformation[row][col] = id++;
                }
            }
        }
        debug << "here" << endl;
        for (int qry = 0; qry < 4; ++qry) {
            apply_transformation(s[qry]);
        }
        vector<int> perm(id); // perm[i] - new pos of i
        id = 0;
        for (int row = 0; row < n; ++row) {
            for (int col = 0; col < m; ++col) {
                if (a[row][col] != '.') {
                    perm[transformation[row][col]] = id;
                    id += 1;
                }
            }
        }
        int p = q / 4 - 1;
        vector<int> base(id); // pos of i
        iota(in(base), 0);
        // for (int k = 0; k < p; ++k) {
            
        //     base = mul(base, perm);
        // }
        while (p) {
            if (p& 1) {
                base = mul(base, perm);
            }
            perm = mul(perm, perm);
            p >>= 1;
        }
        vector<string> new_a(n, string(m, '.'));
        for (int i = 0; i < id; ++i) {
            int row, col;
            tie(row, col) = pos[i]; // initial position of a[row][col]
            int new_row, new_col;
            tie(new_row, new_col) = pos[base[i]]; // new position of a[row][col]
            new_a[new_row][new_col] = a[row][col];
        }
        swap(a, new_a);
        for (int i = 0; i < n; ++i) {
            cout << a[i] << '\n';
        }
    }
    return 0;
}