#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

struct FT {
    int sz;
    vector<int> ft;
    FT(int num) {
        sz = num;
        ft.assign(sz + 1, 0);
    }
    void add(int i, int x) {
        
        for (; i <= sz; i += (i & -i)) {
            ft[i] += x;
        }
    }
    int pref(int i) {
        int res = 0;
        for (; i > 0; i -= (i & -i)) {
            res += ft[i];
        }
        return res;
    }
};

enum TYPE {OPEN, CLOSE};

struct event {
    int tim;
    TYPE tp;
    int id;
    bool operator<(const event& other) {
        return make_pair(tim, tp) < make_pair(other.tim, other.tp);
    }
};

vector<vector<bool>> board;

struct SegTree {
    int sz;
    vector<int> st;
    SegTree(int num) {
        sz = num;
        st.assign(sz, 0);
    }
    void add(int l, int r, int x) {
        for (int i = l; i < r; ++i) {
            st[i] += x;
        }
    }
    void send(int x) {
        for (int i = 0; i < sz; ++i) {
            board[x][i] = st[i] ? 1 : 0;
        }
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt;
    cin >> tt;
    while (tt --> 0) {
        int n;
        cin >> n;
        const int H = 30;
        const int W = 30;
        board = vector<vector<bool>>(H, vector<bool>(W));
        vector<int> x1(n), x2(n), y1(n), y2(n);
        for (int i=  0; i < n; ++i) {
            cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
            for (int x = x1[i]; x <= x2[i]; ++x) {
                for (int y = y1[i]; y <= y2[i]; ++y) {
                    board[y][x] = 1;
                }
            }
        }
        map<pair<int, int>, vector<pair<int, int>>> mp;
        for (int l = 1; l < W; ++l) {
            for (int r = l; r < W; ++r) {
                for (int y = 0; y < H; ++y) {

                    bool all_between = true;
                    for (int x = l; x <= r; ++x) {
                        if (!board[y][x]) all_between = false;
                    }
                    if (all_between && !board[y][l - 1] && !board[y][r + 1]) {
                        mp[make_pair(l, r)].emplace_back(y, y);
                    }
                }
            }
        }


        vector<tuple<int, int, int, int>> res;
        for (const auto& elem : mp) {
            pair<int, int> p;
            vector<pair<int, int>> rngs;
            tie(p, rngs) = elem;
            int mx = 0;
            int sm = 0;
            int prev = -2;
            int starting;
            for (const auto& rng : rngs) {
                sm += rng.second - rng.first + 1;
                if (rng.first == prev + 1) {
                } else {
                    starting = rng.first;
                }
                mx = max(mx, rng.second - starting + 1);
                prev = rng.second;
            }
            res.emplace_back(p.first, p.second, sm, mx);
        }
        cout << res.size() << '\n';
        for (auto s : res) {
            // cout << s.first << ' ' << s.second << " 1 1" << '\n';
            cout << get<0>(s) << ' ' << get<1>(s) << ' ' << get<2>(s) << ' ' << get<3>(s) << '\n';
        }
    }
    return 0;
}