#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void process2(vector<string> &s, char c) {
    int n = size(s), m = size(s[0]);
    if (c == 'L') {
        for (int i = 0; i < n; ++i) {
            int t = 0;
            for (int j = 0; j < m; ++j) {
                if (s[i][j] != '.') {
                    s[i][t++] = s[i][j];
                }
            }
            fill(s[i].begin() + t, s[i].end(), '.');
        }
    } else if (c == 'R') {
        for (int i = 0; i < n; ++i) {
            int t = 0;
            for (int j = m - 1; j >= 0; --j) {
                if (s[i][j] != '.') {
                    s[i][m - 1 - t++] = s[i][j];
                }
            }
            fill(s[i].begin(), s[i].begin() + m - t, '.');
        }
    } else if (c == 'U') {
        for (int j = 0; j < m; ++j) {
            int t = 0;
            for (int i = 0; i < n; ++i) {
                if (s[i][j] != '.') {
                    s[t++][j] = s[i][j];
                }
            }
            for (int i = t; i < n; ++i) {
                s[i][j] = '.';
            }
        }
    } else {
        for (int j = 0; j < m; ++j) {
            int t = 0;
            for (int i = n - 1; i >= 0; --i) {
                if (s[i][j] != '.') {
                    s[n - 1 - t++][j] = s[i][j];
                }
            }
            for (int i = n - 1 - t; i >= 0; --i) {
                s[i][j] = '.';
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector<string> str(n);
    int N = 0;
    vector s(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        cin >> str[i];
    }

    auto process = [&](char c) {
        if (c == 'L') {
            for (int i = 0; i < n; ++i) {
                int t = 0;
                for (int j = 0; j < m; ++j) {
                    if (s[i][j] != 0) {
                        s[i][t++] = s[i][j];
                    }
                }
                fill(s[i].begin() + t, s[i].end(), 0);
            }
        } else if (c == 'R') {
            for (int i = 0; i < n; ++i) {
                int t = 0;
                for (int j = m - 1; j >= 0; --j) {
                    if (s[i][j] != 0) {
                        s[i][m - 1 - t++] = s[i][j];
                    }
                }
                fill(s[i].begin(), s[i].begin() + m - t, 0);
            }
        } else if (c == 'U') {
            for (int j = 0; j < m; ++j) {
                int t = 0;
                for (int i = 0; i < n; ++i) {
                    if (s[i][j] != 0) {
                        s[t++][j] = s[i][j];
                    }
                }
                for (int i = t; i < n; ++i) {
                    s[i][j] = 0;
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                int t = 0;
                for (int i = n - 1; i >= 0; --i) {
                    if (s[i][j] != 0) {
                        s[n - 1 - t++][j] = s[i][j];
                    }
                }
                for (int i = n - 1 - t; i >= 0; --i) {
                    s[i][j] = 0;
                }
            }
        }
    };

    auto type = [&](char c) {
        return c == 'L' || c == 'R';
    };

    string q;
    cin >> q;
    string nxt;
    for (int i = 0; i < int(size(q)); ++i) {
        char c = q[i];
        if (nxt.empty()) {
            nxt.push_back(c);
        } else if (type(nxt.back()) == type(c)) {
            nxt.pop_back();
            --i;
            continue;
        } else if (!(nxt.size() >= 2 && nxt.end()[-2] == c)) {
            nxt.push_back(c);
        }
    }
    q = nxt;

    for (int i = 0; i < min(2, int(q.size())); ++i) {
        process2(str, q[i]);
    }
    if (q.size() > 2) {
        q.erase(q.begin(), q.begin() + 2);
    } else {
        q.clear();
        for (auto v : str) {
            cout << v << '\n';
        }
        return;
    }

    string val = "?";
    vector<int> pos(1);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (str[i][j] != '.') {
                N += 1;
                s[i][j] = N;
                pos.push_back(i * m + j);
                val.push_back(str[i][j]);
            }
        }
    }
    auto init = s;
    vector<int> adj(N + 1);
    if (q.size() < 4) {
        for (char c : q) {
            process2(str, c);
        }
        for (auto v : str) {
            cout << v << '\n';
        }
        return;
    }
    for (int i = 0; i < 4; ++i) {
        process(q[i]);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (s[i][j]) {
                adj[s[i][j]] = init[i][j];
                assert(init[i][j]);
            }
        }
    }

    int need = q.size() / 4;
    vector<int> used(N + 1), place(N + 1, -1);
    for (int i = 1; i <= N; ++i) {
        if (used[i]) {
            continue;
        }
        vector<int> cyc;
        int x = i;
        while (!used[x]) {
            cyc.push_back(x);
            used[x] = true;
            x = adj[x];
        }
        for (int j = 0; j < size(cyc); ++j) {
            place[cyc[j]] = cyc[(j + need) % cyc.size()];
        }
    }

    str = vector(n, string(m, '.'));
    for (int i = 1; i <= N; ++i) {
        int to = place[i];
        int x = pos[to] / m, y = pos[to] % m;
        str[x][y] = val[i];
    }
    int rem = q.size() % 4;
    for (int i = q.size() - rem; i < q.size(); ++i) {
        process2(str, q[i]);
    }

    for (int i = 0; i < n; ++i) {
        cout << str[i] << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
