#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    auto process = [&](char c) {
        if (c == 'L') {
            for (int i = 0; i < n; ++i) {
                int t = 0;
                for (int j = 0; j < m; ++j) {
                    if (s[i][j] != '.') {
                        s[i][t++] = s[i][j];
                    }
                }
                fill(s[i].begin() + t, s[i].end(), '.');
            }
        } else if (c == 'R') {
            for (int i = 0; i < n; ++i) {
                int t = 0;
                for (int j = m - 1; j >= 0; --j) {
                    if (s[i][j] != '.') {
                        s[i][m - 1 - t++] = s[i][j];
                    }
                }
                fill(s[i].begin(), s[i].begin() + m - t, '.');
            }
        } else if (c == 'U') {
            for (int j = 0; j < m; ++j) {
                int t = 0;
                for (int i = 0; i < n; ++i) {
                    if (s[i][j] != '.') {
                        s[t++][j] = s[i][j];
                    }
                }
                for (int i = t; i < n; ++i) {
                    s[i][j] = '.';
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                int t = 0;
                for (int i = n - 1; i >= 0; --i) {
                    if (s[i][j] != '.') {
                        s[n - 1 - t++][j] = s[i][j];
                    }
                }
                for (int i = n - 1 - t; i >= 0; --i) {
                    s[i][j] = '.';
                }
            }
        }
    };

    auto type = [&](char c) {
        return c == 'L' || c == 'R';
    };

    string q;
    cin >> q;
    string nxt;
    for (char c : q) {
        if (nxt.empty()) {
            nxt.push_back(c);
        } else if (type(nxt.back()) == type(c)) {
            nxt.back() = c;
        } else if (!(nxt.size() >= 2 && nxt.end()[-2] == c)) {
            nxt.push_back(c);
        }
    }
    q = nxt;

    for (int i = 0; i < min(16, int(q.size())); ++i) {
        process(q[i]);
    }
    if (q.size() > 16) {
        q.erase(q.begin(), q.begin() + 16);
    } else {
        q.clear();
    }
    auto init = s;
    int cyc = -1;
    for (int i = 0; i < q.size(); ++i) {
        process(q[i]);
        if (s == init && (i + 1) % 4 == 0) {
            cyc = i + 1;
            break;
        }
    }

    if (cyc != -1) {
        assert(cyc % 4 == 0);
        int rem = q.size() % cyc;
        s = init;
        for (int i = q.size() - rem; i < size(q); ++i) {
            process(q[i]);
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << s[i] << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
