#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;
#define ll long long
typedef vector<string> table;

void movel(table& v)
{
	for (int k = 0; k < v.size(); k++)
		for (int i = 0, j = 0; i < v[k].size(); i++)
			if (v[k][i] != '.')
				swap(v[k][i], v[k][j++]);
}
void mover(table& v)
{
	for (int k = 0; k < v.size(); k++)
		for (int i = v[k].size() - 1, j = i; i >= 0; i--)
			if (v[k][i] != '.')
				swap(v[k][i], v[k][j--]);
}
void moveu(table& v)
{
	for (int k = 0; k < v[0].size(); k++)
		for (int i = 0, j = 0; i < v.size(); i++)
			if (v[i][k] != '.')
				swap(v[i][k], v[j++][k]);
}
void moved(table& v)
{
	for (int k = 0; k < v[0].size(); k++)
		for (int i = v.size() - 1, j = i; i >= 0; i--)
			if (v[i][k] != '.')
				swap(v[i][k], v[j--][k]);
}
void move(table& v, char c)
{
	if (c == 'L') movel(v);
	if (c == 'R') mover(v);
	if (c == 'U') moveu(v);
	if (c == 'D') moved(v);
}
void clean(string& s)
{
	string ans;
	for (int i = 0; i < s.size(); i++)
	{
		if (i != s.size() - 1 && (s[i] == 'L' || s[i] == 'R') && (s[i + 1] == 'L' || s[i + 1] == 'R'))
			continue;
		if (i != s.size() - 1 && (s[i] == 'U' || s[i] == 'D') && (s[i + 1] == 'U' || s[i + 1] == 'D'))
			continue;
		ans.push_back(s[i]);
	}
	s = ans;
}

void print(table& v)
{
	for (auto s : v)
		cout << s << '\n';
}
void printl(vector<int>& v, int m)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int k = 0; k < m; k++)
			cout << (k < v[i] ? 'a' : '.');
		cout << endl;
	}
}
void printr(vector<int>& v, int m)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int k = 0; k < m; k++)
			cout << (k >= m - v[i] ? 'a' : '.');
		cout << endl;
	}
}
void printa(vector<int> v, int m, char x, char y)
{

	if (y == 'L' && x == 'D') printl(v, m);
	if (y == 'R' && x == 'D') printr(v, m);
	reverse(v.begin(), v.end());
	if (x == 'U' && y == 'L') printl(v, m);
	if (x == 'U' && y == 'R') printr(v, m);

}
void main2()
{
	string s = "LLLRRRUUUUULLLULLLRULULU";
	clean(s);
	cout << s;
}
vector<int> sus(table& v)
{
	vector<int> ans(v.size(), 0);
	for (int i = 0; i < v.size(); i++)
		for (int j = 0; j < v[i].size(); j++)
			ans[i] += int((v[i][j] != '.'));
	sort(ans.begin(), ans.end());
	return ans;
}
int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		int n, m;
		cin >> n >> m;
		table v(n);
		for (int i = 0; i < n; i++)
			cin >> v[i];
		string s;
		cin >> s;
		clean(s);
		if (s.size() < 3)
		{
			for (auto c : s)
				move(v, c);
			print(v);
		}
		else
		{
			move(v, s[0]);
			move(v, s[1]);
			auto fft = sus(v);
			char y = 'L', x = 'U';
			for (auto c : s)
				if (c == 'U' || c == 'D') x = c;
				else y = c;
			printa(fft, m, x, y);
		}
	}
}

