#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <chrono>

using namespace std;

typedef long long ll;

void move(vector<string>& a, vector<string>& b, char c)
{
	if (c == 'D' || c == 'U')
	{
		vector<string> x(a[0].size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != '.')
				{
					x[j] += a[i][j];
				}
			}
		}
		for (int j = 0; j < a[0].size(); ++j)
		{
			if (c == 'U')
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[i][j] = x[j][i];
					}
					else
					{
						b[i][j] = '.';
					}
				}
			}
			else
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[a.size() - i - 1][j] = x[j][x[j].size() - i - 1];
					}
					else
					{
						b[a.size() - i - 1][j] = '.';
					}
				}
			}
		}
	}
	else
	{
		vector<string> x(a.size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != '.')
				{
					x[i] += a[i][j];
				}
			}
		}
		for (int i = 0; i < a.size(); ++i)
		{
			if (c == 'L')
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][j] = x[i][j];
					}
					else
					{
						b[i][j] = '.';
					}
				}
			}
			else
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][a[0].size() - j - 1] = x[i][x[i].size() - j - 1];
					}
					else
					{
						b[i][a[0].size() - j - 1] = '.';
					}
				}
			}
		}
	}
}

void cmove(vector<vector<int>>& a, vector<vector<int>>& b, char c)
{
	if (c == 'D' || c == 'U')
	{
		vector<vector<int>> x(a[0].size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != 0)
				{
					x[j].push_back(a[i][j]);
				}
			}
		}
		for (int j = 0; j < a[0].size(); ++j)
		{
			if (c == 'U')
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[i][j] = x[j][i];
					}
					else
					{
						b[i][j] = 0;
					}
				}
			}
			else
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[a.size() - i - 1][j] = x[j][x[j].size() - i - 1];
					}
					else
					{
						b[a.size() - i - 1][j] = 0;
					}
				}
			}
		}
	}
	else
	{
		vector<vector<int>> x(a.size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != 0)
				{
					x[i].push_back(a[i][j]);
				}
			}
		}
		for (int i = 0; i < a.size(); ++i)
		{
			if (c == 'L')
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][j] = x[i][j];
					}
					else
					{
						b[i][j] = 0;
					}
				}
			}
			else
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][a[0].size() - j - 1] = x[i][x[i].size() - j - 1];
					}
					else
					{
						b[i][a[0].size() - j - 1] = 0;
					}
				}
			}
		}
	}
}

void smart(vector<string>& a, vector<string>& b, string& q)
{
	int n = a.size();
	int m = a[0].size();
	vector<string>& ac = a;
	string qq;
	for (int i = 0; i < q.size(); ++i)
	{
		if (qq.size() == 0)
		{
			qq += q[i];
			continue;
		}
		if (q[i] == 'L')
		{
			if (qq.back() == 'L' || qq.back() == 'R')
				qq.pop_back();
			if (qq.size() < 2 || qq[qq.size() - 2] != 'L')
				qq.push_back(q[i]);
		}
		else if (q[i] == 'R')
		{
			if (qq.back() == 'L' || qq.back() == 'R')
				qq.pop_back();
			if (qq.size() < 2 || qq[qq.size() - 2] != 'R')
				qq.push_back(q[i]);
		}
		else if (q[i] == 'U')
		{
			if (qq.back() == 'U' || qq.back() == 'D')
				qq.pop_back();
			if (qq.size() < 2 || qq[qq.size() - 2] != 'U')
				qq.push_back(q[i]);
		}
		else if (q[i] == 'D')
		{
			if (qq.back() == 'U' || qq.back() == 'D')
				qq.pop_back();
			if (qq.size() < 2 || qq[qq.size() - 2] != 'D')
				qq.push_back(q[i]);
		}
	}
	if (qq.size() >= 2)
	{
		for (int i = 0; i < 2; ++i)
		{
			char c = qq[i];
			move(a, b, c);
			a = b;
		}
		vector<vector<int>> c(n, vector<int>(m));
		int cnt = 1;
		vector<pair<int, int>> coord;
		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j < m; ++j)
			{
				if (a[i][j] != '.')
				{
					c[i][j] = cnt;
					coord.push_back({ i, j });
					++cnt;
				}
			}
		}
		if (qq.size() >= 6)
		{
			vector<vector<int>> d = c;
			vector<vector<int>> e = c;
			for (int i = 2; i < 6; ++i)
			{
				cmove(c, d, qq[i]);
				move(a, b, qq[i]);
				a = b;
				c = d;
			}
			--cnt;
			vector<int> next(cnt);
			for (int i = 0; i < n; ++i)
			{
				for (int j = 0; j < m; ++j)
				{
					if (c[i][j] != 0)
					{
						next[c[i][j] - 1] = e[i][j] - 1;
					}
				}
			}
			vector<vector<int>> cycles;
			vector<pair<int, int>> ind(cnt);
			vector<bool> visited(cnt);
			for (int i = 0; i < cnt; ++i)
			{
				if (visited[i])
					continue;
				cycles.emplace_back();
				cycles.back().emplace_back(i);
				ind[i].first = cycles.size() - 1;
				ind[i].second = 0;
				visited[i] = true;
				int ic = next[i];
				while (ic != i)
				{
					visited[ic] = true;
					cycles.back().emplace_back(ic);
					ind[ic].first = cycles.size() - 1;
					ind[ic].second = cycles.back().size() - 1;
					ic = next[ic];
				}
			}
			int qsize = qq.size() - 6;
			int lurd = qsize / 4 + 1;
			for (int i = 0; i < n; ++i)
			{
				for (int j = 0; j < m; ++j)
				{
					if (e[i][j] != 0)
					{
						int cind = ind[e[i][j] - 1].first;
						d[i][j] = cycles[cind][(ind[e[i][j] - 1].second + lurd) % cycles[cind].size()];
						b[i][j] = a[coord[d[i][j]].first][coord[d[i][j]].second];
					}
				}
			}
			a = b;
			for (int i = qq.size() - (qsize % 4); i < qq.size(); ++i)
			{
				move(a, b, qq[i]);
				a = b;
			}
		}
		else
		{
			for (int i = 2; i < qq.size(); ++i)
			{
				move(a, b, qq[i]);
				a = b;
			}
		}
	}
	else
	{
		for (int i = 0; i < qq.size(); ++i)
		{
			char c = qq[i];
			move(a, b, c);
			a = b;
		}
	}
	b = a;
	a = ac;
}

void stupid(vector<string>& a, vector<string>& b, string& q)
{
	vector<string> ac = a;
	for (int i = 0; i < q.size(); ++i)
	{
		char c = q[i];
		move(a, b, c);
		a = b;
	}
	a = ac;
}

void gener(vector<string>& a, string& q)
{
	int n = 10, m = 20;
	a.resize(n);
	mt19937 gener(chrono::high_resolution_clock::now().time_since_epoch().count());
	uniform_int_distribution<> u(0, 50);
	for (int i = 0; i < n; ++i)
	{
		a[i].resize(m);
		for (int j = 0; j < m; ++j)
		{
			int x = u(gener);
			if (x < 36)
				a[i] = 'a' + u(gener);
			else
				a[i] = '.';
		}
	}
	uniform_int_distribution<> uq(1, 100);
	int qs = uq(gener);
	q.resize(qs);
	uniform_int_distribution<> uu(1, 4);
	for (int i = 0; i < qs; ++i)
	{
		int x = uu(gener);
		if (x == 1)
		{
			q[i] = 'L';
		}
		if (x == 2)
		{
			q[i] = 'U';
		}
		if (x == 3)
		{
			q[i] = 'R';
		}
		if (x == 4)
		{
			q[i] = 'D';
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int tt;
	cin >> tt;
	for (int t = 0; t < tt; ++t)
	{
		/*
		vector<string> a, b, c;
		string q;
		gener(a, q);
		b = a;
		c = a;
		stupid(a, b, q);
		smart(a, c, q);
		if (b != c)
		{
			for (int i = 0; i < a.size(); ++i)
				cout << a[i] << '\n';
			for (int i = 0; i < a.size(); ++i)
				cout << b[i] << '\n';
			for (int i = 0; i < a.size(); ++i)
				cout << c[i] << '\n';
			cout << q << '\n';
			break;
		}
		else
		{
			cout << "test " << t + 1 << " passed.\n";
		}
		*/
		int n, m;
		cin >> n >> m;
		vector<string> a(n);
		for (int i = 0; i < n; ++i)
			cin >> a[i];
		vector<string> b = a;
		string q;
		cin >> q;
		smart(a, b, q);
		for (int i = 0; i < n; ++i)
			cout << b[i] << '\n';
	}
	return 0;
}
