#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

void move(vector<string>& a, vector<string>& b, char c)
{
	if (c == 'D' || c == 'U')
	{
		vector<string> x(a[0].size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != '.')
				{
					x[j] += a[i][j];
				}
			}
		}
		for (int j = 0; j < a[0].size(); ++j)
		{
			if (c == 'U')
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[i][j] = x[j][i];
					}
					else
					{
						b[i][j] = '.';
					}
				}
			}
			else
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[a.size() - i - 1][j] = x[j][x[j].size() - i - 1];
					}
					else
					{
						b[a.size() - i - 1][j] = '.';
					}
				}
			}
		}
	}
	else
	{
		vector<string> x(a.size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != '.')
				{
					x[i] += a[i][j];
				}
			}
		}
		for (int i = 0; i < a.size(); ++i)
		{
			if (c == 'L')
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][j] = x[i][j];
					}
					else
					{
						b[i][j] = '.';
					}
				}
			}
			else
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][a[0].size() - j - 1] = x[i][x[i].size() - j - 1];
					}
					else
					{
						b[i][a[0].size() - j - 1] = '.';
					}
				}
			}
		}
	}
}

void cmove(vector<vector<int>>& a, vector<vector<int>>& b, char c)
{
	if (c == 'D' || c == 'U')
	{
		vector<vector<int>> x(a[0].size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != 0)
				{
					x[j].push_back(a[i][j]);
				}
			}
		}
		for (int j = 0; j < a[0].size(); ++j)
		{
			if (c == 'U')
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[i][j] = x[j][i];
					}
					else
					{
						b[i][j] = 0;
					}
				}
			}
			else
			{
				for (int i = 0; i < a.size(); ++i)
				{
					if (i < x[j].size())
					{
						b[a.size() - i - 1][j] = x[j][x[j].size() - i - 1];
					}
					else
					{
						b[a.size() - i - 1][j] = 0;
					}
				}
			}
		}
	}
	else
	{
		vector<vector<int>> x(a.size());
		for (int i = 0; i < a.size(); ++i)
		{
			for (int j = 0; j < a[0].size(); ++j)
			{
				if (a[i][j] != 0)
				{
					x[i].push_back(a[i][j]);
				}
			}
		}
		for (int i = 0; i < a.size(); ++i)
		{
			if (c == 'L')
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][j] = x[i][j];
					}
					else
					{
						b[i][j] = 0;
					}
				}
			}
			else
			{
				for (int j = 0; j < a[0].size(); ++j)
				{
					if (j < x[i].size())
					{
						b[i][a[0].size() - j - 1] = x[i][x[i].size() - j - 1];
					}
					else
					{
						b[i][a[0].size() - j - 1] = 0;
					}
				}
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int tt;
	cin >> tt;
	for (int t = 0; t < tt; ++t)
	{
		int n, m;
		cin >> n >> m;
		vector<string> a(n);
		for (int i = 0; i < n; ++i)
		{
			cin >> a[i];
		}
		vector<string> b = a;
		string q;
		cin >> q;
		if (q.size() > 10)
		{
			for (int i = 0; i < 10; ++i)
			{
				char c = q[i];
				move(a, b, c);
				a = b;
			}
			string qq;
			for (int i = 10; i < q.size(); ++i)
			{
				if (qq.size() == 0)
				{
					qq += q[i];
					continue;
				}
				if (q[i] == 'L')
				{
					if (qq.back() == 'L' || qq.back() == 'R')
						qq.pop_back();
					if (qq.size() < 2 || qq[qq.size() - 2] != 'L')
						qq.push_back(q[i]);
				}
				else if (q[i] == 'R')
				{
					if (qq.back() == 'L' || qq.back() == 'R')
						qq.pop_back();
					if (qq.size() < 2 || qq[qq.size() - 2] != 'R')
						qq.push_back(q[i]);
				}
				else if (q[i] == 'U')
				{
					if (qq.back() == 'U' || qq.back() == 'D')
						qq.pop_back();
					if (qq.size() < 2 || qq[qq.size() - 2] != 'U')
						qq.push_back(q[i]);
				}
				else if (q[i] == 'D')
				{
					if (qq.back() == 'U' || qq.back() == 'D')
						qq.pop_back();
					if (qq.size() < 2 || qq[qq.size() - 2] != 'D')
						qq.push_back(q[i]);
				}
			}
			if (qq.size() > 14)
			{
				for (int i = 0; i < 10; ++i)
				{
					char c = qq[i];
					move(a, b, c);
					a = b;
				}
				vector<vector<int>> c(n, vector<int>(m));
				int cnt = 1;
				vector<pair<int, int>> coord;
				for (int i = 0; i < n; ++i)
				{
					for (int j = 0; j < m; ++j)
					{
						if (a[i][j] != '.')
						{
							c[i][j] = cnt;
							coord.push_back({ i, j });
							++cnt;
						}
					}
				}
				vector<vector<int>> d = c;
				vector<vector<int>> e = c;
				for (int i = 10; i < 14; ++i)
				{
					cmove(c, d, qq[i]); 
					move(a, b, qq[i]);
					a = b;
					c = d;
				}
				--cnt;
				vector<int> next(cnt);
				for (int i = 0; i < n; ++i)
				{
					for (int j = 0; j < m; ++j)
					{
						if (c[i][j] != 0)
						{
							next[e[i][j] - 1] = c[i][j] - 1;
						}
					}
				}
				vector<vector<int>> cycles;
				vector<pair<int, int>> ind(cnt);
				vector<bool> visited(cnt);
				for (int i = 0; i < cnt; ++i)
				{
					if (visited[i])
						continue;
					cycles.emplace_back();
					cycles.back().emplace_back(i);
					ind[i].first = cycles.size() - 1;
					ind[i].second = 0;
					int ic = next[i];
					while (ic != i)
					{
						cycles.back().emplace_back(ic);
						ind[ic].first = cycles.size() - 1;
						ind[ic].second = cycles.back().size() - 1;
						ic = next[ic];
					}
				}
				int lurd = (qq.size() - 14) / 4;
				for (int i = 0; i < n; ++i)
				{
					for (int j = 0; j < m; ++j)
					{
						if (c[i][j] != 0)
						{
							int cind = ind[c[i][j] - 1].first;
							d[i][j] = cycles[cind][(ind[c[i][j] - 1].second + lurd) % cycles[cind].size()];
							b[i][j] = a[coord[d[i][j]].first][coord[d[i][j]].second];
						}
					}
				}
				a = b;
				for (int i = qq.size() - (qq.size() % 4); i < qq.size(); ++i)
				{
					char c = qq[i];
					move(a, b, c);
					a = b;
				}
			}
			else
			{
				for (int i = 0; i < qq.size(); ++i)
				{
					char c = qq[i];
					move(a, b, c);
					a = b;
				}
			}
		}
		else
		{
			for (int i = 0; i < q.size(); ++i)
			{
				char c = q[i];
				move(a, b, c);
				a = b;
			}
		}
		for (int i = 0; i < n; ++i)
			cout << a[i] << '\n';
	}
	return 0;
}
