#include <bits/stdc++.h>

using namespace std;
#define int long long

int type(char c) {
    if (c == 'U' || c == 'D') return 1;
    return 2;
}

void solve_stupid(int n, int m, vector<vector<char>> &a, string s) {
    if (s.empty()) return;
    int q = (int) s.size();
    for (int qr = 0; qr < q; qr++) {
        if (type(s[qr]) == 1) {
            for (int j = 0; j < m; j++) {
                string cur;
                for (int i = 0; i < n; i++)
                    if (a[i][j] != '.') cur += a[i][j];
                if (s[qr] == 'U') {
                    for (int i = 0; i < n; i++) {
                        if (i < (int) cur.size()) a[i][j] = cur[i];
                        else a[i][j] = '.';
                    }
                } else {
                    for (int i = n - 1; i >= 0; i--) {
                        if (!cur.empty()) a[i][j] = cur.back(), cur.pop_back();
                        else a[i][j] = '.';
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                string cur;
                for (int j = 0; j < m; j++)
                    if (a[i][j] != '.') cur += a[i][j];
                if (s[qr] == 'L') {
                    for (int j = 0; j < m; j++) {
                        if (j < (int) cur.size()) a[i][j] = cur[j];
                        else a[i][j] = '.';
                    }
                } else {
                    for (int j = m - 1; j >= 0; j--) {
                        if (!cur.empty()) a[i][j] = cur.back(), cur.pop_back();
                        else a[i][j] = '.';
                    }
                }
            }
        }
    }
}

void solve_stupid(int n, int m, vector<vector<int>> &a, string s) {
    if (s.empty()) return;
    int q = (int) s.size();
    for (int qr = 0; qr < q; qr++) {
        if (type(s[qr]) == 1) {
            for (int j = 0; j < m; j++) {
                vector<int> cur;
                for (int i = 0; i < n; i++)
                    if (a[i][j] != 0) cur.emplace_back(a[i][j]);
                if (s[qr] == 'U') {
                    for (int i = 0; i < n; i++) {
                        if (i < (int) cur.size()) a[i][j] = cur[i];
                        else a[i][j] = 0;
                    }
                } else {
                    for (int i = n - 1; i >= 0; i--) {
                        if (!cur.empty()) a[i][j] = cur.back(), cur.pop_back();
                        else a[i][j] = 0;
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                vector<int> cur;
                for (int j = 0; j < m; j++)
                    if (a[i][j] != 0) cur.emplace_back(a[i][j]);
                if (s[qr] == 'L') {
                    for (int j = 0; j < m; j++) {
                        if (j < (int) cur.size()) a[i][j] = cur[j];
                        else a[i][j] = 0;
                    }
                } else {
                    for (int j = m - 1; j >= 0; j--) {
                        if (!cur.empty()) a[i][j] = cur.back(), cur.pop_back();
                        else a[i][j] = 0;
                    }
                }
            }
        }
    }
}

string compress1(string s) {
    string new_s;
    int q = (int) s.size();
    for (int i = 0; i < q; i++) {
        if (!new_s.empty() && type(new_s.back()) == type(s[i])) {
            new_s.back() = s[i];
        } else {
            new_s += s[i];
        }
    }
    return new_s;
}

string compress2(string s) {
    string new_s;
    int q = (int) s.size();
    bool used[q];
    for (int i = 0; i < q; i++) used[i] = false;
    char last[3];
    last[1] = last[2] = '#';
    for (int i = 0; i < q; i++) {
        int t = type(s[i]);
        if (last[t] == s[i]) {
            used[i] = true;
        }
        last[t] = s[i];
    }
    for (int i = 0; i < q; i++) {
        if (!used[i]) new_s += s[i];
    }
    return new_s;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    string s;
    cin >> s;
    while(compress1(s) != s){
        s = compress1(s);
        s = compress2(s);
    }
    if ((int) s.size() <= 10) {
        solve_stupid(n, m, a, s);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++)
                cout << a[i][j];
            cout << "\n";
        }
        return;
    }
    string back;
    while ((int) s.size() % 4 != 0) {
        back += s.back();
        s.pop_back();
    }
    reverse(back.begin(), back.end());
    string rep;
    for (int i = 0; i < 4; i++) rep += s[i];
    for(int j = 4; j < (int)s.size(); j += 4){
        string repp;
        repp += s[j];
        repp += s[j + 1];
        repp += s[j + 2];
        repp += s[j + 3];
        if(repp != rep) exit(-1);
    }
    int cnt = (int) s.size() / 4, cur = 1;
    vector<vector<int>> exp(n, vector<int>(m));
    pair<int, int> to[22][n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.') exp[i][j] = 0;
            else exp[i][j] = cur++;
        }
    }
    pair<int, int> from[cur];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            from[exp[i][j]] = {i, j};
        }
    }
    solve_stupid(n, m, exp, rep);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (exp[i][j] != 0)
                to[0][from[exp[i][j]].first][from[exp[i][j]].second] = {i, j};
        }
    }
    for (int lg = 1; lg < 22; lg++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (exp[i][j] != 0) {
                    to[lg][i][j] = to[lg - 1][to[lg - 1][i][j].first][to[lg - 1][i][j].second];
                }
            }
        }
    }
    vector<vector<char>> b = a;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (b[i][j] == '.') a[i][j] = '.';
            else {
                int x = i, y = j;
                int p = cnt;
                for (int lg = 21; lg >= 0; lg--) {
                    if ((1 << lg) <= p) {
                        auto pr = to[lg][x][y];
                        x = pr.first, y = pr.second;
                        p -= (1 << lg);
                    }
                }
                a[x][y] = b[i][j];
            }
        }
    }
    solve_stupid(n, m, a, back);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cout << a[i][j];
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}