#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

int n, m;
std::vector<std::vector<int>> a;
void move_U() {
	for (int j = 0; j < m; ++j) {
		int pos = 0;
		for (int i = 0; i < n; ++i) {
			if (a[i][j] != 0) {
				a[pos][j] = a[i][j];
				if (i != pos) {
					a[i][j] = 0;
				}
				++pos;
			}
		}
	}
}
void move_D() {
	for (int j = 0; j < m; ++j) {
		int pos = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (a[i][j] != 0) {
				a[pos][j] = a[i][j];
				if (i != pos) {
					a[i][j] = 0;
				}
				--pos;
			}
		}
	}
}
void move_L() {
	for (int i = 0; i < n; ++i) {
		int pos = 0;
		for (int j = 0; j < m; ++j) {
			if (a[i][j] != 0) {
				a[i][pos] = a[i][j];
				if (j != pos) {
					a[i][j] = 0;
				}
				++pos;
			}
		}
	}
}
void move_R() {
	for (int i = 0; i < n; ++i) {
		int pos = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j] != 0) {
				a[i][pos] = a[i][j];
				if (j != pos) {
					a[i][j] = 0;
				}
				--pos;
			}
		}
	}
}
void move(char c) {
	if (c == 'L') {
		move_L();
	}
	else if (c == 'R') {
		move_R();
	}
	else if (c == 'D') {
		move_D();
	}
	else {
		move_U();
	}
}
void print() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			std::cout << (a[i][j] == 0 ? '.' : char(a[i][j] + 'a' - 1));
		}
		std::cout << '\n';
	}
}
void solve() {
	std::cin >> n >> m;
	a.assign(n, std::vector<int>(m));
	for (int i = 0; i < n; ++i) {
		std::string s;
		std::cin >> s;
		for (int j = 0; j < m; ++j) {
			a[i][j] = s[j] == '.' ? 0 : s[j] - 'a' + 1;
		}
	}
	std::string q;
	std::cin >> q;
	int st = 0;
	while (st < q.size() && q[st] != 'U') {
		++st;
	}
	if (st != q.size()) {
		if (st != 0) {
			move(q[st - 1]);
		}
		move_U();
	}
	st = q.size() - 1;
	while (st >= 0 && q[st] == 'U') {
		--st;
	}
	if (st >= 0) {
		move(q[st]);
	}
	print();
}
int main() {
	int q;
	std::cin >> q;
	while (q--) {
		solve();
	}
}