#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

int n, m;
std::vector<std::vector<int>> a;
void move_U() {
	for (int j = 0; j < m; ++j) {
		int pos = 0;
		for (int i = 0; i < n; ++i) {
			if (a[i][j] != 0) {
				a[pos][j] = a[i][j];
				if (i != pos) {
					a[i][j] = 0;
				}
				++pos;
			}
		}
	}
}
void move_D() {
	for (int j = 0; j < m; ++j) {
		int pos = n - 1;
		for (int i = n - 1; i >= 0; --i) {
			if (a[i][j] != 0) {
				a[pos][j] = a[i][j];
				if (i != pos) {
					a[i][j] = 0;
				}
				--pos;
			}
		}
	}
}
void move_L() {
	for (int i = 0; i < n; ++i) {
		int pos = 0;
		for (int j = 0; j < m; ++j) {
			if (a[i][j] != 0) {
				a[i][pos] = a[i][j];
				if (j != pos) {
					a[i][j] = 0;
				}
				++pos;
			}
		}
	}
}
void move_R() {
	for (int i = 0; i < n; ++i) {
		int pos = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j] != 0) {
				a[i][pos] = a[i][j];
				if (j != pos) {
					a[i][j] = 0;
				}
				--pos;
			}
		}
	}
}
void move(char c) {
	if (c == 'L') {
		move_L();
	}
	else if (c == 'R') {
		move_R();
	}
	else if (c == 'D') {
		move_D();
	}
	else {
		move_U();
	}
}
void print() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			std::cout << (a[i][j] == 0 ? '.' : char(a[i][j] + 'a' - 1));
		}
		std::cout << '\n';
	}
}
bool check(char a, char b) {
	if (a == 'L' || a == 'R') {
		return b == 'L' || b == 'R';
	}
	return b == 'U' || b == 'D';
}
void solve() {
	std::cin >> n >> m;
	a.assign(n, std::vector<int>(m));
	for (int i = 0; i < n; ++i) {
		std::string s;
		std::cin >> s;
		for (int j = 0; j < m; ++j) {
			a[i][j] = s[j] == '.' ? 0 : s[j] - 'a' + 1;
		}
	}
	std::string s;
	std::cin >> s;
	std::vector<char> q;
	for (int i = 0; i < s.size(); ++i) {
		while (q.size() > 0 && check(s[i], q.back())) {
			q.pop_back();
		}
		if (q.size() <= 1 || q[q.size() - 2] != s[i]) {
			q.push_back(s[i]);
		}
	}
	for (char c : q) {
		std::cout << c;
	}
	if (q.size() <= 2) {
		for (char c : q) {
			move(c);
		}
		print();
		return;
	}
	move(q[0]);
	move(q[1]);
	int st = 2;
	while (st < q.size()) {
		st += 12;
	}
	if (st > 2) {
		st -= 12;
	}
	for (int i = st; i < q.size(); ++i) {
		move(q[i]);
	}
	print();
}
int main() {
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}
/*
4
5 5
.....
a....
bc...
de...
ghij.
URDL

5 5
.....
a....
bc...
def..
ghij.
URDL

5 5
.....
a....
bc...
def..
ghij.
URDL

5 5
.....
a....
bc...
de...
ghij.
URDLURDLURDLURDL


*/