#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif
#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

ll n,m;

template <typename T> ostream& operator<<(ostream& s,vector<T> v) {
    for(auto &i:v) {s<<i<<' ';}
    return s;
}

void IO() {
    cin.tie(0);
    cin.sync_with_stdio(0);
}

const int SZ=30;

void glt(vector<vector<ll>> &a) {
    vector<vector<ll>> cnt(a.size());
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]!=-1) {
                cnt[i].push_back(a[i][j]);
            }
        }
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(j<cnt[i].size()){a[i][j]=cnt[i][j];}
            else {a[i][j]=-1;}
        }
    }
}

void grt(vector<vector<ll>> &a) {
    vector<vector<ll>> cnt(a.size());
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]!=-1) {
                cnt[i].push_back(a[i][j]);
            }
        }
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(j-(m-cnt[i].size())<cnt[i].size()){a[i][j]=cnt[i][j-(m-cnt[i].size())];}
            else {a[i][j]=-1;}
        }
    }
}

void gup(vector<vector<ll>> &a) {
    vector<vector<ll>> cnt(a[0].size());
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]!=-1) {
                cnt[j].push_back(a[i][j]);
            }
        }
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(i<cnt[j].size()){a[i][j]=cnt[j][i];}
            else {a[i][j]=-1;}
        }
    }
}

void gdn(vector<vector<ll>> &a) {
    vector<vector<ll>> cnt(a[0].size());
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]!=-1) {
                cnt[j].push_back(a[i][j]);
            }
        }
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(i-(n-cnt[j].size())<cnt[j].size()){a[i][j]=cnt[j][i-(n-cnt[j].size())];}
            else {a[i][j]=-1;}
        }
    }
}

void solve() {
    cin>>n>>m;
    vector<string> brd(n);
    vector<char> let;
    for(auto &i:brd) {cin>>i;}
    vector<vector<ll>> a(n,vector<ll> (m));
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(brd[i][j]=='.') {a[i][j]=-1;}
            else {a[i][j]=let.size();let.push_back(brd[i][j]);}
        }
    }
    string s;
    cin>>s;
    string q;
#define hor(x) ((x)=='L' || (x)=='R')

    for(int i=0;i<s.size();i++) {
        if(hor(s[i])) {
            if(q.size()>0 && hor(q.back())) {
                q.pop_back();
            }
            if(q.size()>1 && q[q.size()-2]==s[i]) {
                continue;
            }
            q+=s[i];
        }
        else {
            if(q.size()>0 && !hor(q.back())) {
                q.pop_back();
            }
            if(q.size()>1 && q[q.size()-2]==s[i]) {
                continue;
            }
            q+=s[i];
        }
    }
    debug(q)
    if(q.size()<10) {
        for(auto c:q) {
            if(c=='L') {glt(a);}
            if(c=='R') {grt(a);}
            if(c=='U') {gup(a);}
            if(c=='D') {gdn(a);}
        }
        for(int i=0;i<n;i++) {
            for(int j=0;j<m;j++) {
                if(a[i][j]==-1) {cout<<'.';}
                else {cout<<let[a[i][j]];}
            }
            cout<<'\n';
        }
        return;
    }
    vector<vector<ll>> b(n,vector<ll> (m));
    vector<vector<ll>> bu(SZ,vector<ll> (n*m,0));
    for(int i=0;i<4;i++) {
        if(q[i]=='L') {glt(a);}
        if(q[i]=='R') {grt(a);}
        if(q[i]=='U') {gup(a);}
        if(q[i]=='D') {gdn(a);}
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            b[i][j]=a[i][j];
        }
    }
    for(int i=4;i<8;i++) {
        if(q[i]=='L') {glt(a);}
        if(q[i]=='R') {grt(a);}
        if(q[i]=='U') {gup(a);}
        if(q[i]=='D') {gdn(a);}
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]!=-1) {
                bu[0][b[i][j]]=a[i][j];
            }
        }
    }
    for(int i=1;i<SZ;i++) {
        for(int j=0;j<n*m;j++) {
            bu[i][j]=bu[i-1][bu[i-1][j]];
        }
    }
    ll nd=q.size()/4-2;
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]==-1) {continue;}
            for(int bui=0;bui<SZ;bui++) {
                if((nd&(1<<bui))) {
                    a[i][j]=bu[bui][a[i][j]];
                }
            }
        }
    }
    for(int i=0;i<q.size()%4;i++) {
        if(q[i]=='L') {glt(a);}
        if(q[i]=='R') {grt(a);}
        if(q[i]=='U') {gup(a);}
        if(q[i]=='D') {gdn(a);}
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            if(a[i][j]==-1) {cout<<'.';}
            else {cout<<let[a[i][j]];}
        }
        cout<<'\n';
    }
    debug("")
    debug("")
    debug("")
}

signed main() {
    IO();
    ll t=1;
    cin>>t;
    while(t--) {
        solve();
    }
}
