// NoNig.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void L(vector<vector<int>>& V) {
	for (int i = 0; i < V.size(); i++) {
		vector<int> G;
		for (auto& j : V[i]) {
			if (j != -1)G.push_back(j);
		}
		G.resize(V[i].size(), -1);
		V[i] = G;
	}
}

void R(vector<vector<int>>& V) {
	for (int i = 0; i < V.size(); i++) {
		reverse(V[i].begin(), V[i].end());
		vector<int> G;
		for (auto& j : V[i]) {
			if (j != -1)G.push_back(j);
		}
		G.resize(V[i].size(), -1);
		V[i] = G;
		reverse(V[i].begin(), V[i].end());
	}
}

void U(vector<vector<int>>& V) {
	for (int i = 0; i < V[0].size(); i++) {
		vector<int> G;
		for (int j = 0; j < V.size(); j++) {
			if (V[j][i] != -1)G.push_back(V[j][i]);
		}
		for (int j = 0; j < V.size(); j++) {
			V[j][i] = -1;
		}
		for (int j = 0; j < G.size(); j++) {
			V[j][i] = G[j];
		}
	}
}

void D(vector<vector<int>>& V) {
	for (int i = 0; i < V[0].size(); i++) {
		vector<int> G;
		for (int j = 0; j < V.size(); j++) {
			if (V[j][i] != -1)G.push_back(V[j][i]);
		}
		for (int j = 0; j < V.size(); j++) {
			V[j][i] = -1;
		}
		for (int j = 0; j < G.size(); j++) {
			V[V.size() - G.size() + j][i] = G[j];
		}
	}
}

char Obr[256], Up[4], Dw[4];

void ADD(vector<int>& a, vector<int>& b, vector<int>& ans) {
	ans.assign(a.size(), 0);
	for (int i = 0; i < a.size(); i++) {
		ans[i] = a[b[i]];
	}
}

void POW(vector<int>& a, int pw, vector<int>& ans) {
	ans.assign(a.size(), 0);
	if (pw == 0) {
		for (int i = 0; i < a.size(); i++)ans[i] = i;

	}
	else if (pw % 2 == 1) {
		vector<int> ans_;
		POW(a, pw - 1, ans);
		ADD(ans, a, ans_);
		ans = ans_;
	}
	else {
		vector<int> ans_;
		POW(a, pw / 2, ans);
		ADD(ans, ans, ans_);
		ans = ans_;
	}
}

void OBR(vector<int>& a, vector<int>& ans) {
	ans.assign(a.size(), 0);
	for (int i = 0; i < ans.size(); i++) {
		ans[a[i]] = i;
	}
}

int main()
{
	Obr['L'] = 'R';
	Obr['R'] = 'L';
	Obr['U'] = 'D';
	Obr['D'] = 'U';
	Up[0] = 'U';
	Up[1] = 'R';
	Up[2] = 'D';
	Up[3] = 'L';
	Dw[0] = 'R';
	Dw[1] = 'D';
	Dw[2] = 'L';
	Dw[3] = 'U';
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int m, n;
		cin >> m >> n;
		vector<string> V(m);
		for (auto& i : V)cin >> i;
		vector<char> per;
		vector<vector<int>> T(m, vector<int>(n));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				if (V[i][j] == '.')T[i][j] = -1;
				else {
					T[i][j] = per.size();
					per.push_back(V[i][j]);
				}
			}
		}
		string Q;
		cin >> Q;
		string Nq_, Nq;
		for (auto& i : Q) {
			if (Nq_.size() != 0 and Nq_.back() == Obr[i]) {
				Nq_[Nq_.size() - 1] = i;
			}
			if (Nq_.size() == 0 or Nq_.back() != i)Nq_.push_back(i);
		}
		if (Nq_.size() == 1)Nq = Nq_;
		else {
			int sost = 0;
			Nq.push_back(Nq_[0]);
			Nq.push_back(Nq_[1]);
			if (Nq_[0] == 'L' and Nq_[1] == 'D')sost = 0;
			if (Nq_[0] == 'D' and Nq_[1] == 'L')sost = 0;
			if (Nq_[0] == 'R' and Nq_[1] == 'D')sost = 3;
			if (Nq_[0] == 'D' and Nq_[1] == 'R')sost = 3;
			if (Nq_[0] == 'L' and Nq_[1] == 'U')sost = 1;
			if (Nq_[0] == 'U' and Nq_[1] == 'L')sost = 1;
			if (Nq_[0] == 'R' and Nq_[1] == 'U')sost = 2;
			if (Nq_[0] == 'U' and Nq_[1] == 'R')sost = 2;
			for (int i = 2; i < Nq_.size(); i++) {
				//cout << Nq_[i] << " " << Up[sost] << " " << Dw[sost] << endl;
				if (Nq_[i] == Up[sost]) {
					sost = (sost + 1) % 4;
					Nq.push_back(Nq_[i]);
				}
				if (Nq_[i] == Dw[sost]) {
					sost = (sost + 3) % 4;
					Nq.push_back(Nq_[i]);
				}
			}
		}
		//cout << Nq << endl;
		if (Nq.size() == 1) {
			if (Nq[0] == 'U')U(T);
			if (Nq[0] == 'D')D(T);
			if (Nq[0] == 'R')R(T);
			if (Nq[0] == 'L')L(T);
		}
		else {
			//cout << Nq;
			if (Nq[0] == 'U')U(T);
			if (Nq[0] == 'D')D(T);
			if (Nq[0] == 'R')R(T);
			if (Nq[0] == 'L')L(T);
			if (Nq[1] == 'U')U(T);
			if (Nq[1] == 'D')D(T);
			if (Nq[1] == 'R')R(T);
			if (Nq[1] == 'L')L(T);
			auto T_ = T;
			int sost = 0;
			if (Nq[0] == 'L' and Nq[1] == 'D')sost = 0;
			if (Nq[0] == 'D' and Nq[1] == 'L')sost = 0;
			if (Nq[0] == 'R' and Nq[1] == 'D')sost = 3;
			if (Nq[0] == 'D' and Nq[1] == 'R')sost = 3;
			if (Nq[0] == 'L' and Nq[1] == 'U')sost = 1;
			if (Nq[0] == 'U' and Nq[1] == 'L')sost = 1;
			if (Nq[0] == 'R' and Nq[1] == 'U')sost = 2;
			if (Nq[0] == 'U' and Nq[1] == 'R')sost = 2;
			int COL = 0;
			int sost_ = sost;
			while (sost > 0) {
				if (sost == 1)D(T);
				if (sost == 2)L(T);
				if (sost == 3)U(T);
				COL++;
				sost--;
			}
			if (sost == 0)U(T_);
			if (sost == 1)R(T_);
			if (sost == 2)D(T_);
			if (sost == 3)L(T_);
			sost += 1;
			if (sost == 0)U(T_);
			if (sost == 1)R(T_);
			if (sost == 2)D(T_);
			if (sost == 3)L(T_);
			sost += 1;
			if (sost == 0)U(T_);
			if (sost == 1)R(T_);
			if (sost == 2)D(T_);
			if (sost == 3)L(T_);
			sost += 1;
			if (sost == 0)U(T_);
			if (sost == 1)R(T_);
			if (sost == 2)D(T_);
			if (sost == 3)L(T_);
			/*for (auto& i : T) {
				for (auto& j : i) {
					if (j == -1) {
						cout << '.';
						continue;
					}
					cout << per[j];
				}
				cout << endl;
			}
			for (auto& i : T_) {
				for (auto& j : i) {
					if (j == -1) {
						cout << '.';
						continue;
					}
					cout << per[j];
				}
				cout << endl;
			}*/
			sost -= 3;
			vector<int> perm(per.size());
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					if (T[i][j] == -1)continue;
					//cout << "!" << i << " " << j << " " << T[i][j] << " " << T_[i][j] << endl;
					perm[T[i][j]] = T_[i][j];
				}
			}
			
			for (int i = 2; i < Nq.size(); i++) {
				//cout <<"!" <<  Up[sost_] << " " << Nq[i] << endl;
				if (Nq[i] == Up[sost_]) {
					//cout << "*";
					COL++;
					sost_ = (sost_ + 1) % 4;
					//cout << "!" << Up[sost_] << " " << Nq[i] << endl;
				}
				else if (Nq[i] == Dw[sost_]) {
					COL--;
					sost_ = (sost_ + 3) % 4;
				}
				//cout << "$" << COL << endl;
			}
			//cout << COL << endl;
			if (COL < 0) {
				int NT = (-1 - COL) / 4 + 1;
				vector<int> PR, perm_;
				OBR(perm, perm_);
				POW(perm_, NT, PR);
				for (auto& i : T)for (auto& j : i) if (j != -1) j = PR[j];
				COL += NT * 4;
			}
			if (COL > 0) {
				int NT = COL / 4;
				vector<int> PR;
				POW(perm, NT, PR);
				COL -= NT * 4;
				for (auto& i : T)for (auto& j : i) if(j != -1) j = PR[j];
			}
			/*for (auto& i : T) {
				for (auto& j : i) {
					if (j == -1) {
						cout << '.';
						continue;
					}
					cout << per[j];
				}
				cout << endl;
			}*/
			//cout << COL << " " << sost << endl;
			while (COL > 0) {
				if (sost == 1)R(T);
				if (sost == 2)D(T);
				if (sost == 3)L(T);
				if (sost == 0)U(T);
				COL--;
				sost = (sost + 1) % 4;
			}
		}
		for (auto& i : T) {
			for (auto& j : i) {
				if (j == -1) {
					cout << '.';
					continue;
				}
				cout << per[j];
			}
			cout << endl;
		}
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
