#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

vector<vector<int>> stupid(vector<vector<int>> &arr, char symb) {
    int n = arr.size();
    int m = arr[0].size();
    vector<vector<int>> res(n, vector<int>(m));
    if (symb == 'L') {
        for (int i = 0; i < n; ++i) {
            int pointer = 0;
            for (int j = 0; j < m; ++j) {
                if (arr[i][j] > 0) {
                    res[i][pointer++] = arr[i][j];
                }
            }
        }
    } else if (symb == 'R') {
        for (int i = 0; i < n; ++i) {
            int pointer = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (arr[i][j] > 0) res[i][pointer--] = arr[i][j];
            }
        }
    } else if (symb == 'U') {
        for (int j = 0; j < m; ++j) {
            int pointer = 0;
            for (int i = 0; i < n; ++i) {
                if (arr[i][j] > 0) res[pointer++][j] = arr[i][j];
            }
        }
    } else if (symb == 'D') {
        for (int j = 0; j < m; ++j) {
            int pointer = n - 1;
            for (int i = n - 1; i >= 0; --i) {
                if (arr[i][j] > 0) res[pointer--][j] = arr[i][j];
            }
        }
    }
    return res;
}

bool check(char a, char b) {
    if (a == b) return true;
    if (a == 'R' && b == 'L') return true;
    if (a == 'L' && b == 'R') return true;
    if (a == 'U' && b == 'D') return true;
    if (a == 'D' && b == 'U') return true;
    return false;
}

string transit(string s) {
    string res;
    int i = 0;
    int n = s.size();
    while (i < n) {
        while (i + 1 < n && check(s[i], s[i + 1])) i++;
        res += s[i++];
    }
    return res;
}

string transit2(string s) {
    string res;
    int i = 0, n = s.size();
    vector<char> st;
    while (i < n) {
        st.push_back(s[i++]);
        if (st.size() >= 3 && st.back() == st[st.size() - 3]) st.pop_back();
    }
    for (char c : st) res += c;
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            if (s[j] == '.') arr[i][j] = 0;
            else arr[i][j] = (s[j] - 'a') + 1;
        }
    }
    string req;
    cin >> req;
    req = transit(req);
    req = transit2(req);
    int cycles_cnt = 0;
    if (req.size() <= 16) {
        for (char c : req) arr = stupid(arr, c);
    } else {
        for (int i = 0; i < 4; ++i) {
            arr = stupid(arr, req[0]);
            req.erase(0, 1);
        }
        string cycle = req.substr(0, 16);
        int was = 0;
        for (int i = 0; i < 4; ++i) {
            if (cycle.substr(4 * i, 4) != cycle.substr(0, 5)) was = 1;
        }
        if (was) {
            for (char c : req) arr = stupid(arr, c);
        } else {
            for (int i = 0; i < req.size(); i += 16) {
                if (req.substr(i, 16) == cycle) cycles_cnt++;
            }
            int nxt = cycles_cnt * 16;
            if (nxt == 0) {
                for (char c: req) arr = stupid(arr, c);
            } else {
                for (int i = nxt; i < req.size(); ++i) arr = stupid(arr, req[i]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << (arr[i][j] == 0 ? '.' : char(arr[i][j] - 1 + 'a'));
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
