#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}
int n, m;

void applyLR(vector<vector<char>> &a, char op) {
    if (op == 'L') {
        for (int i = 0; i < m; ++i) {
            int pos = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][pos]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < m; ++i) {
            int pos = n - 1;
            for (int j = n - 1; j >= 0; --j) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][pos]);
                    --pos;
                }
            }
        }
    }
}

void applyUD(vector<vector<char>> &a, char op) {
    if (op == 'U') {
        for (int i = 0; i < n; ++i) {
            int pos = 0;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != '.') {
                    swap(a[j][i], a[pos][i]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            int pos = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (a[j][i] != '.') {
                    swap(a[j][i], a[pos][i]);
                    --pos;
                }
            }
        }
    }
}

void bpplyLR(vector<vector<int>> &a, char op) {
    if (op == 'L') {
        for (int i = 0; i < m; ++i) {
            int pos = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != -1) {
                    swap(a[i][j], a[i][pos]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < m; ++i) {
            int pos = n - 1;
            for (int j = n - 1; j >= 0; --j) {
                if (a[i][j] != -1) {
                    swap(a[i][j], a[i][pos]);
                    --pos;
                }
            }
        }
    }
}

void bpplyUD(vector<vector<int>> &a, char op) {
    if (op == 'U') {
        for (int i = 0; i < n; ++i) {
            int pos = 0;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != -1) {
                    swap(a[j][i], a[pos][i]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            int pos = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (a[j][i] != -1) {
                    swap(a[j][i], a[pos][i]);
                    --pos;
                }
            }
        }
    }
}

string shorten(string &q) {
    string s = "";
    for (char c : q) {
        if (c == 'L' || c == 'R') {
            while (!s.empty() && (s.back() == 'L' || s.back() == 'R')) {
                s.pop_back();
            }
            s.push_back(c);
        } else {
            while (!s.empty() && (s.back() == 'U' || s.back() == 'D')) {
                s.pop_back();
            }
            s.push_back(c);
        }
    }

    string t = "";
    char lastX = '.';
    char lastY = '.';
    for (char c : s) {
        if (c == 'L' || c == 'R') {
            if (c != lastY) {
                lastY = c;
                t.push_back(c);
            }
        } else {
            if (c != lastX) {
                lastX = c;
                t.push_back(c);
            }
        }
    }

    string r = "";
    for (char c : t) {
        if (c == 'L' || c == 'R') {
            while (!r.empty() && (r.back() == 'L' || r.back() == 'R')) {
                r.pop_back();
            }
            r.push_back(c);
        } else {
            while (!r.empty() && (r.back() == 'U' || r.back() == 'D')) {
                r.pop_back();
            }
            r.push_back(c);
        }
    }
    return r;
}

void solve() {
    cin >> m >> n;
    vector<vector<char>> a(m, vector<char>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<char>> d = a;
    string q;
    cin >> q;
    string t = shorten(q);

    // t is now a string of type (4-cycle) * n + remainder
    // we have basically now made the problem into a merge of subtask 3 and 8
    // should be easy now...

    string ft = "";
    while (t.size() % 4 != 0) {
        ft.push_back(t.back());
        t.pop_back();
    }

    reverse(ft.begin(), ft.end());

    if (!t.empty()) {
        for (int i = 0; i < 4; ++i) {
            char c = t[i];
            if (c == 'L' || c == 'R') {
                applyLR(a, c);
            } else {
                applyUD(a, c);
            }
        }
        int len = t.size() / 4 - 1;
        if (len != 0) {
            vector<vector<int>> binups(__lg(len) + 1, vector<int>(n * m, -1));
            vector<vector<int>> b(m, vector<int>(n));
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] == '.') {
                        b[i][j] = -1;
                    } else {
                        b[i][j] = i * n + j;
                    }
                }
            }
            for (int i = 0; i < 4; ++i) {
                char c = t[i];
                if (c == 'L' || c == 'R') {
                    bpplyLR(b, c);
                } else {
                    bpplyUD(b, c);
                }
            }

            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < m; ++j) {
                    d[i][j] = '.';
                }
            }

            for (int i = 0; i < n * m; ++i) {
                binups[0][i] = b[i / n][i % n];
            }
            for (int l = 1; l < binups.size(); ++l) {
                for (int i = 0; i < n * m; ++i) {
                    binups[l][i] = binups[l - 1][binups[l - 1][i]];
                }
            }
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] == '.') {
                        b[i][j] = -1;
                    } else {
                        b[i][j] = i * n + j;
                    }
                }
            }
            for (int l = 1; (1 << l) <= len; ++l) {
                if (len & (1 << l)) {
                    for (int i = 0; i < n * m; ++i) {
                        b[i / n][i % n] = binups[l][b[i / n][i % n]];
                    }
                }
            }
            for (int i = 0; i < n * m; ++i) {
                if (b[i / n][i % n] != -1) {
                    d[i / n][i % n] = a[b[i / n][i % n] / n][b[i / n][i % n] % n];
                }
            }
        }
    }

    for (char c : ft) {
        if (c == 'L' || c == 'R') {
            applyLR(d, c);
        } else {
            applyUD(d, c);
        }
    }

    for (auto i : d) {
        for (auto j : i) {
            cout << j;
        }
        cout << '\n';
    }
}

signed main() {
    init();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}