#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}
int n, m;

void applyLR(vector<vector<char>> &a, char op) {
    if (op == 'L') {
        for (int i = 0; i < m; ++i) {
            int pos = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][pos]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < m; ++i) {
            int pos = n - 1;
            for (int j = n - 1; j >= 0; --j) {
                if (a[i][j] != '.') {
                    swap(a[i][j], a[i][pos]);
                    --pos;
                }
            }
        }
    }
}

void applyUD(vector<vector<char>> &a, char op) {
    if (op == 'U') {
        for (int i = 0; i < n; ++i) {
            int pos = 0;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != '.') {
                    swap(a[j][i], a[pos][i]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            int pos = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (a[j][i] != '.') {
                    swap(a[j][i], a[pos][i]);
                    --pos;
                }
            }
        }
    }
}

const pair<int, int> ntrl = { -1, -1 };

void bpplyLR(vector<vector<pair<int, int>>> &a, char op) {
    if (op == 'L') {
        for (int i = 0; i < m; ++i) {
            int pos = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != ntrl) {
                    swap(a[i][j], a[i][pos]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < m; ++i) {
            int pos = n - 1;
            for (int j = n - 1; j >= 0; --j) {
                if (a[i][j] != ntrl) {
                    swap(a[i][j], a[i][pos]);
                    --pos;
                }
            }
        }
    }
}

void bpplyUD(vector<vector<pair<int, int>>> &a, char op) {
    if (op == 'U') {
        for (int i = 0; i < n; ++i) {
            int pos = 0;
            for (int j = 0; j < m; ++j) {
                if (a[j][i] != ntrl) {
                    swap(a[j][i], a[pos][i]);
                    ++pos;
                }
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            int pos = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (a[j][i] != ntrl) {
                    swap(a[j][i], a[pos][i]);
                    --pos;
                }
            }
        }
    }
}

string shorten(string &q) {
    string s = "";
    for (char c : q) {
        if (c == 'L' || c == 'R') {
            while (!s.empty() && (s.back() == 'L' || s.back() == 'R')) {
                s.pop_back();
            }
            s.push_back(c);
        } else {
            while (!s.empty() && (s.back() == 'U' || s.back() == 'D')) {
                s.pop_back();
            }
            s.push_back(c);
        }
    }

    string t = "";
    char lastX = '.';
    char lastY = '.';
    for (char c : s) {
        if (c == 'L' || c == 'R') {
            if (c != lastY) {
                lastY = c;
                t.push_back(c);
            }
        } else {
            if (c != lastX) {
                lastX = c;
                t.push_back(c);
            }
        }
    }

    string r = "";
    for (char c : t) {
        if (c == 'L' || c == 'R') {
            while (!r.empty() && (r.back() == 'L' || r.back() == 'R')) {
                r.pop_back();
            }
            r.push_back(c);
        } else {
            while (!r.empty() && (r.back() == 'U' || r.back() == 'D')) {
                r.pop_back();
            }
            r.push_back(c);
        }
    }
    return r;
}

const int lg = 5;

void solve() {
    cin >> m >> n;
    vector<vector<char>> a(m, vector<char>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    string q;
    cin >> q;
    string t = shorten(q);
    if(t.size() < 4) {
        for(char c : t) {
            if(c == 'L' || c == 'R') {
                applyLR(a, c);
            } else {
                applyUD(a, c);
            }
        }
        for(auto i : a) {
            for(auto j : i) {
                cout << j;
            }
            cout << '\n';
        }
        return;
    }

    for(int i = 0; i < 4; ++i) {
        char c = t[i];
        if(c == 'L' || c == 'R') {
            applyLR(a, c);
        } else {
            applyUD(a, c);
        }
    }

    int len = t.size() / 4 - 1;

    vector<vector<pair<int, int>>> b(m, vector<pair<int, int>> (n));
    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n; ++j) {
            if(a[i][j] == '.') {
                b[i][j] = ntrl;
            } else {
                b[i][j] = { i, j };
            }
        }
    }

    for(int i = 0; i < 4; ++i) {
        char c = t[i];
        if(c == 'L' || c == 'R') {
            bpplyLR(b, c);
        } else {
            bpplyUD(b, c);
        }
    }

    vector<vector<int>> bp(lg, vector<int> (n * m));

    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n; ++j) {
            if(b[i][j] != ntrl) {
                bp[0][b[i][j].first * n + b[i][j].second] = i * n + j;
            }
        }
    }

    for(int l = 1; l < lg; ++l) {
        for(int i = 0; i < n * m; ++i) {
            if(a[i / n][i % n] != '.') {
                bp[l][i] = bp[l - 1][bp[l - 1][i]];
            }
        }
    }
    vector<vector<char>> d(m, vector<char> (n, '.'));

    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n; ++j) {
            if(a[i][j] != '.') {
                int to = i * n + j;
                for(int l = 0; (1 << l) <= len; ++l) {
                    if(len & (1 << l)) {
                        to = bp[l][to];
                    }
                }
                d[to / n][to % n] = a[i][j];
            }
        }
    }
    
    string ft = "";
    while(t.size() % 4 != 0) {
        ft.push_back(t.back());
        t.pop_back();
    }
    reverse(ft.begin(), ft.end());

    for(char c : ft) {
        if(c == 'L' || c == 'R') {
            applyLR(d, c);
        } else {
            applyUD(d, c);
        }
    }

    for(auto i : d) {
        for(auto j : i) {
            cout << j;
        }
        cout << '\n';
    }
}

signed main() {
    init();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}