#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}
int n, m;

void applyLR(vector<vector<char>> &a, char op) {
    if(op == 'L') {
        for(int i = 0; i < m; ++i) {
            int pos = 0;
            for(int j = 0; j < n; ++j) {
                if(a[i][j] != '.') {
                    swap(a[i][j], a[i][pos]);
                    ++pos;
                }
            }
        }
    } else {
        for(int i = 0; i < m; ++i) {
            int pos = n - 1;
            for(int j = n - 1; j >= 0; --j) {
                if(a[i][j] != '.') {
                    swap(a[i][j], a[i][pos]);
                    --pos;
                }
            }
        }
    }
}

void applyUD(vector<vector<char>> &a, char op) {
    if(op == 'U') {
        for(int i = 0; i < n; ++i) {
            int pos = 0;
            for(int j = 0; j < m; ++j) {
                if(a[j][i] != '.') {
                    swap(a[j][i], a[pos][i]);
                    ++pos;
                }
            }
        }
    } else {
        for(int i = 0; i < n; ++i) {
            int pos = m - 1;
            for(int j = m - 1; j >= 0; --j) {
                if(a[j][i] != '.') {
                    swap(a[j][i], a[pos][i]);
                    --pos;
                }
            }
        }
    }
}


void solve() {
    cin >> m >> n;
    vector<vector<char>> a(m, vector<char> (n));
    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    string q; cin >> q;
    string s = "";
    for(char c : q) {
        if(c == 'L' || c == 'R') {
            while(!s.empty() && (s.back() == 'L' || s.back() == 'R')) {
                s.pop_back();
            } 
            s.push_back(c);
        } else {
            while(!s.empty() && (s.back() == 'U' || s.back() == 'D')) {
                s.pop_back();
            }
            s.push_back(c);
        }
    }
    
    string t = "";
    char lastX = '.';
    char lastY = '.';
    for(char c : s) {
        if(c == 'L' || c == 'R') {
            while(!t.empty() && (t.back() == 'L' || t.back() == 'R')) {
                t.pop_back();
            }
            if(c != lastY) {
                lastY = c;
                t.push_back(c);
            } 
        } else {
            while(!t.empty() && (t.back() == 'U' || t.back() == 'D')) {
                t.pop_back();
            }
            if(c != lastX) {
                lastX = c;
                t.push_back(c);
            }
        }
    }
    


    // t is now a string of type (4-cycle) * n + remainder
    // we have basically now made the problem into a merge of subtask 3 and 8
    // should be easy now...



    // task 3 begin

    for(char c : t) {
        if(c == 'L' || c == 'R') {
            applyLR(a, c);
        } else {
            applyUD(a, c);
        }
    }

    // task 3 end

    for(auto i : a) {
        for(auto j : i) {
            cout << j;
        }
        cout << '\n';
    }
}

signed main() {
    init();
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}