#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Input {
    vector<vector<char>> a;
    string s;
};

Input input() {
    int n, m; cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    string s; cin >> s;
    return {a, s};
}

void output(const vector<vector<char>>& a) {
    for (auto& i : a) {
        for (auto j : i) cout << j;
        cout << '\n';
    }
}

void moveUp(vector<vector<char>>& a) {
    vector<char> tmp;
    tmp.reserve(a.size());
    for (int j = 0; j < (int)a[0].size(); ++j) {
        for (int i = 0; i < (int)a.size(); ++i) {
            if (a[i][j] != '.') {
                tmp.push_back(a[i][j]);
                a[i][j] = '.';
            }
        }
        for (int i = 0; i < (int)tmp.size(); ++i) {
            a[i][j] = tmp[i];
        }
        tmp.clear();
    }
}

void moveDown(vector<vector<char>>& a) {
    vector<char> tmp;
    tmp.reserve(a.size());
    for (int j = 0; j < (int)a[0].size(); ++j) {
        for (int i = (int)a.size() - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                tmp.push_back(a[i][j]);
                a[i][j] = '.';
            }
        }
        for (int i = (int)a.size() - 1, x = 0; x < (int)tmp.size(); --i, ++x) {
            a[i][j] = tmp[x];
        }
        tmp.clear();
    }
}

void moveLeft(vector<vector<char>>& a) {
    vector<char> tmp;
    tmp.reserve(a[0].size());
    for (int i = 0; i < (int)a.size(); ++i) {
        for (int j = 0; j < (int)a[i].size(); ++j) {
            if (a[i][j] != '.') {
                tmp.push_back(a[i][j]);
                a[i][j] = '.';
            }
        }
        for (int j = 0; j < (int)tmp.size(); ++j) {
            a[i][j] = tmp[j];
        }
        tmp.clear();
    }
}

void moveRight(vector<vector<char>>& a) {
    vector<char> tmp;
    tmp.reserve(a[0].size());
    for (int i = 0; i < (int)a.size(); ++i) {
        for (int j = (int)a[i].size() - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                tmp.push_back(a[i][j]);
                a[i][j] = '.';
            }
        }
        for (int j = (int)a[i].size() - 1, x = 0; x < (int)tmp.size(); --j, ++x) {
            a[i][j] = tmp[x];
        }
        tmp.clear();
    }
}

vector<vector<char>> stupidSolve(Input inp) {
    auto [a, s] = std::move(inp);
    for (auto c : s) {
        if (c == 'L') moveLeft(a);
        else if (c == 'R') moveRight(a);
        else if (c == 'U') moveUp(a);
        else moveDown(a);
    }
    return a;
}

vector<vector<char>> smartSolve(Input inp) {
    auto [a, s] = std::move(inp);
    char lastH = '.', lastV = '.';
    int startPos = -1;
    for (int i = 0; i < (int)s.size(); ++i) {
        bool last = false;
        if (s[i] == 'L' || s[i] == 'R') {
            lastH = s[i];
        }
        if (s[i] == 'U' || s[i] == 'D') {
            lastV = s[i];
            last = true;
        }
        if (lastH != '.' && lastV != '.') {
            s = s.substr(i + 1, (int)s.size() - 1 - i);
            if (lastH == 'L' && lastV == 'U') {
                startPos = 0;
                if (last) {
                    moveLeft(a);
                    moveUp(a);
                } else {
                    moveUp(a);
                    moveLeft(a);
                }
            }
            else if (lastH == 'R' && lastV == 'U') {
                startPos = 1;
                if (last) {
                    moveRight(a);
                    moveUp(a);
                } else {
                    moveUp(a);
                    moveRight(a);
                }
            }
            else if (lastH == 'R' && lastV == 'D') {
                startPos = 2;
                if (last) {
                    moveRight(a);
                    moveDown(a);
                } else {
                    moveDown(a);
                    moveRight(a);
                }
            }
            else {
                startPos = 3;
                if (last) {
                    moveLeft(a);
                    moveDown(a);
                } else {
                    moveLeft(a);
                    moveDown(a);
                }
            }
            break;
        }
    }
    if (startPos == -1) {
        if (lastH == 'L') {
            moveLeft(a);
        } else if (lastH == 'R') {
            moveRight(a);
        } else if (lastV == 'U') {
            moveUp(a);
        } else {
            moveDown(a);
        }
        return a;
    }
    const vector<vector<int>> g = {{0, 0, 1, 3},
                                   {0, 1, 1, 2},
                                   {3, 1, 2, 2},
                                   {3, 0, 2, 3}};
    int cntClcWise = 0, cntCounterClkWise = 0;
    int pos = startPos;
    for (auto i : s) {
        int x = 0;
        if (i == 'U') x = 1;
        if (i == 'R') x = 2;
        if (i == 'D') x = 3;
        int nxtPos = g[pos][x];
        pos = nxtPos;
//        if (nxtPos == startPos) {
//            if (pos == (nxtPos - 1 + 4) % 4) {
//                cntCounterClkWise++;
//            } else {
//                cntClcWise++;
//            }
//        }
    }
    if (pos == 0) {
        moveLeft(a);
        moveUp(a);
    } else if (pos == 1) {
        moveRight(a);
        moveUp(a);
    } else if (pos == 2) {
        moveDown(a);
        moveRight(a);
    } else {
        moveDown(a);
        moveLeft(a);
    }
    return a;
//    if (cntClcWise >= cntCounterClkWise) {
//        cntClcWise -= cntCounterClkWise;
//
//    }
}

void run() {
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        output(smartSolve(input()));
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}
