#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <random>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
// #define int ll

int n, m;

void f(vector<string>& a, char c) {
    if (c == 'U') {
        for (int j = 0; j < m; j++) {
            int last = 0;
            for (int i = 0; i < n; i++) {
                if (a[i][j] == '.')
                    continue;
                swap(a[i][j], a[last][j]);
                last++;
            }
        }
    }
    if (c == 'D') {
        for (int j = 0; j < m; j++) {
            int last = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i][j] == '.')
                    continue;
                swap(a[i][j], a[last][j]);
                last--;
            }
        }
    }
    if (c == 'L') {
        for (int i = 0; i < n; i++) {
            int last = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] == '.')
                    continue;
                swap(a[i][j], a[i][last]);
                last++;
            }
        }
    }
    if (c == 'R') {
        for (int i = 0; i < n; i++) {
            int last = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] == '.')
                    continue;
                swap(a[i][j], a[i][last]);
                last--;
            }
        }
    }
}

bool hor(char c) {
    return c == 'L' or c == 'R';
}

mt19937 gen(time(NULL));

int rand(int x) {
    return gen() % x;
}

char rand_c() {
    int res = rand(4);
    if (res == 0)
        return 'U';
    else if (res == 1)
        return 'D';
    else if (res == 2)
        return 'L';
    else if (res == 3)
        return 'R';
}

string rand_dir(int len) {
    string res;
    while (len--)
        res.push_back(rand_c());
    return res;
}

void improve(string& s) {
    string s2;
    for (auto i : s) {
        if (s2.size() == 0) {
            s2.push_back(i);
            continue;
        }
        if (hor(i)) {
            if (hor(s2[s2.size() - 1])) {
                if (s2.size() - 3 >= 0 and s2[s2.size() - 3] == i)
                    s2.pop_back();
                else
                    s2[s2.size() - 1] = i;
            }
            else if (s2.size() == 1 or s2[s2.size() - 2] != i)
                s2.push_back(i);
        }
        else {
            if (!hor(s2[s2.size() - 1])) {
                if (s2.size() - 3 >= 0 and s2[s2.size() - 3] == i)
                    s2.pop_back();
                else
                    s2[s2.size() - 1] = i;
            }
            else if (s2.size() == 1 or s2[s2.size() - 2] != i)
                s2.push_back(i);
        }
    } 

    string s3;
    for (int i = 0; i < min(4, (int)s2.size()); i++)
        s3.push_back(s2[i]);
    for (int i = s2.size() / 4 * 4; i < (int)s2.size(); i++)
        s3.push_back(s2[i]);
    swap(s, s2);
}

void f(vector<string>& a, string& s) {
    for (auto i : s)
        f(a, i);
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

#ifdef ORANGE
    ifstream cin("C:/Users/roi/Desktop/tour1/b1.txt");
#endif


    // string s69 = "UUUDRRRRUDUUULLLRDUDULULDDDLRDDDDULLULURLLULDUULULUDUDLRDRULRDRLLLLRLDRDDRURUDURURLDDDDUULRLURRDRDUD";
    // improve(s69);
    // cout << s69 << endl;

    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        vector<string> a(n);
        for (auto& i : a)
            cin >> i;
        
        // for (int i = 0; i < 100; i++) {
        // string s = rand_dir(100);
        // auto res1 = a;
        // f(res1, s);
        // auto s2 = s;
        // improve(s2);
        // auto res2 = a;
        // f(res2, s2);

        // if (res1 != res2) {
        //     cout << s << '\n';
        //     cout << s2 << endl;
        //     break;
        // }
        // }

        string s;
        cin >> s; 
        improve(s);
        f(a, s);
        for (auto i : a)
            cout << i << '\n';
    }
}