#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

void solve() {

    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, char>>> a(n);
    vector<vector<pair<int, char>>> b(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c == '.') {
                continue;
            }
            a[i].emplace_back(j, c);
            b[j].emplace_back(i, c);
        }
    }

    auto get_type = [] (char x) -> int {
        return x == 'L' || x == 'R';
    };

    string q;
    cin >> q;
    vector<int> u_d, l_r;
    string s;
    for (char t : q) {
        if (get_type(t)) {
            if (!s.empty() && get_type(s.back())) {
                s.pop_back();
                l_r.pop_back();
            }
            if (l_r.empty() || l_r.back() != (t == 'L')) {
                s += t;
                l_r.emplace_back(t == 'L');
            }
        } else {
            if (!s.empty() && !get_type(s.back())) {
                s.pop_back();
                u_d.pop_back();
            }
            if (u_d.empty() || u_d.back() != (t == 'U')) {
                s += t;
                u_d.emplace_back(t == 'U');
            }
        }
    }
    //cout << s << endl;
    int C = 26 * 8;
    for (int kek = 0; kek < min(C, (int) s.size()); ++kek) {
        char d = s[kek];
        if (d == 'L') {
            for (auto &i : a) {
                int cnt = 0;
                for (auto &j : i) {
                    j.first = cnt;
                    cnt++;
                }
            }
        } else if (d == 'R') {
            for (auto &i : a) {
                int cnt = 0;
                for (int it = (int) i.size() - 1; it >= 0; --it) {
                    auto &j = i[it];
                    j.first = m - 1 - cnt;
                    cnt++;
                }
            }
        } else if (d == 'U') {
            for (auto &i : b) {
                int cnt = 0;
                for (auto &j : i) {
                    j.first = cnt;
                    cnt++;
                }
            }
        } else {
            for (auto &i : b) {
                int cnt = 0;
                for (int it = (int) i.size() - 1; it >= 0; --it) {
                    auto &j = i[it];
                    j.first = n - 1 - cnt;
                    cnt++;
                }
            }
        }
        //cout << "move done!" << endl;

        if (d == 'L' || d == 'R') {
            for (auto &i : b) {
                i.clear();
            }
            for (int i = 0; i < n; ++i) {
                for (auto [j, c] : a[i]) {
                    b[j].emplace_back(i, c);
                }
            }
        } else {
            for (auto &i : a) {
                i.clear();
            }
            for (int j = 0; j < m; ++j) {
                for (auto [i, c] : b[j]) {
                    a[i].emplace_back(j, c);
                }
            }
        }
        //cout << "update done" << endl;
    }

    for (int kek = max(C, (int) s.size() - (int) s.size() % C); kek < (int) s.size(); ++kek) {
        char d = s[kek];
        if (d == 'L') {
            for (auto &i : a) {
                int cnt = 0;
                for (auto &j : i) {
                    j.first = cnt;
                    cnt++;
                }
            }
        } else if (d == 'R') {
            for (auto &i : a) {
                int cnt = 0;
                for (int it = (int) i.size() - 1; it >= 0; --it) {
                    auto &j = i[it];
                    j.first = m - 1 - cnt;
                    cnt++;
                }
            }
        } else if (d == 'U') {
            for (auto &i : b) {
                int cnt = 0;
                for (auto &j : i) {
                    j.first = cnt;
                    cnt++;
                }
            }
        } else {
            for (auto &i : b) {
                int cnt = 0;
                for (int it = (int) i.size() - 1; it >= 0; --it) {
                    auto &j = i[it];
                    j.first = n - 1 - cnt;
                    cnt++;
                }
            }
        }
        //cout << "move done!" << endl;

        if (d == 'L' || d == 'R') {
            for (auto &i : b) {
                i.clear();
            }
            for (int i = 0; i < n; ++i) {
                for (auto [j, c] : a[i]) {
                    b[j].emplace_back(i, c);
                }
            }
        } else {
            for (auto &i : a) {
                i.clear();
            }
            for (int j = 0; j < m; ++j) {
                for (auto [i, c] : b[j]) {
                    a[i].emplace_back(j, c);
                }
            }
        }
        //cout << "update done" << endl;
    }

    vector<string> ans(n, string(m, '.'));
    for (int i = 0; i < n; ++i) {
        for (auto [j, c] : a[i]) {
            ans[i][j] = c;
        }
    }
    for (auto &i : ans) {
        cout << i << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}