#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

struct Event {
    int x, y1, y2, type, id;

    Event(int x, int y1, int y2, int type, int id) : x(x), y1(y1), y2(y2), type(type), id(id) {}

    bool operator<(const Event &e) const {
        return x < e.x || (x == e.x && type > e.type);
    }
};

const int INF = 1e9 + 5;

void solve() {
    int n;
    cin >> n;
    vector<Event> evs;
    set<int> st_x, st_y;
    vector<int> v_y;
    vector<int> l, r;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        evs.emplace_back(x1, y1, y2 + 1, 1, i);
        evs.emplace_back(x2 + 1, y1, y2 + 1, -1, i);
        l.emplace_back(x1);
        r.emplace_back(x2 + 1);
        st_x.insert(x1);
        st_x.insert(x2 + 1);
        st_y.insert(y1);
        st_y.insert(y2 + 1);
    }
    for (auto y : st_y) {
        v_y.emplace_back(y);
    }
    v_y.emplace_back(INF);
//    for (auto i : v_y) {
//        cout << i << ' ';
//    }
//    cout << endl;

    sort(evs.begin(), evs.end());
    int m = (int) st_y.size();
    vector<int> q_l(m + 1, INF), q_r(m + 1, -INF), bal(m + 1);
    map<int, int> x_open;
    set<int> open;
    map<pair<int, int>, ll> ans_open;

    for (auto [x, y1, y2, type, id] : evs) {
        auto it1 = lower_bound(v_y.begin(), v_y.end(), y1) - v_y.begin();
        auto it2 = lower_bound(v_y.begin(), v_y.end(), y2) - v_y.begin();
        if (type == 1) {
            for (int i = int(it1); i < int(it2); ++i) {
                q_l[i] = min(q_l[i], l[id]);
                q_r[i] = max(q_r[i], r[id]);
                bal[i]++;
            }
        } else {
            for (int i = int(it1); i < int(it2); ++i) {
                bal[i]--;
                if (bal[i] == 0) {
                    ans_open[{q_l[i], x - 1}] += (v_y[i + 1] - v_y[i]);
                    q_l[i] = INF;
                    q_r[i] = -INF;
                }
            }
        }
        //cout << q_l[4] << ' ' << q_r[4] << ' ' << bal[4] << endl;
    }
    cout << (int) ans_open.size() << '\n';
    for (auto [i, val] : ans_open) {
        cout << i.first << ' ' << i.second << ' ' << val << ' ' << 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}