#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

const int maxn = 1e5 + 2;
const int inf = 1e9 + 1;

int n, m;

vector<vector<char>> a;

void move_right() {
    for (int i = 1; i < n + 1; i++) {
        vector<char> st;
        st.reserve(m + 1);
        for (int j = 1; j < m + 1; j++) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int j = m; j > 0; j--) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move_left() {
    for (int i = 1; i < n + 1; i++) {
        vector<char> st;
        st.reserve(m + 1);
        for (int j = m; j > 0; j--) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int j = 1; j < m + 1; j++) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move_up() {
    for (int j = 1; j < m + 1; j++) {
        vector<char> st;
        st.reserve(n + 1);
        for (int i = n; i > 0; i--) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int i = 1; i < n + 1; i++) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move_down() {
    for (int j = 1; j < m + 1; j++) {
        vector<char> st;
        st.reserve(n + 1);
        for (int i = 1; i < n + 1; i++) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int i = n; i > 0; i--) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    a.clear();
    a.resize(n + 1);
    vector<char> b(m + 1);
    fill(a.begin(), a.end(), b);
    for (int i = 1; i < n + 1; i++) {
        string s; cin >> s;
        for (int j = 1; j < m + 1; j++) {
            a[i][j] = s[j - 1];
        }
    }
    string s; cin >> s;
    int q = s.size();
    if (s[0] == 'R') {
        move_right();
    }
    if (s[0] == 'L') {
        move_left();
    }
    if (s[0] == 'U') {
        move_up();
    }
    if (s[0] == 'D') {
        move_down();
    }
    int last_hor = -1, last_vert = -1;
    for (int i = 0; i < q; i++) {
        if (s[i] == 'L' || s[i] == 'R') {
            last_hor = i;
        } else {
            last_vert = i;
        }
    }
    cout << last_hor << " " << last_vert << "\n";
    if (last_hor > last_vert) {
        if (last_vert != -1) {
            if (s[last_vert] == 'U') move_up();
            else move_down();
        }
        if (last_hor != -1) {
            if (s[last_hor] == 'R') move_right();
            else move_left();
        }
    } else {
        if (last_hor != -1) {
            if (s[last_hor] == 'R') move_right();
            else move_left();
        }
        if (last_vert != -1) {
            if (s[last_vert] == 'U') move_up();
            else move_down();
        }
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 1; j < m + 1; j++) {
            cout << a[i][j];
        } cout << "\n";
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
}

