#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define S second

const int INF = 1e9 + 7;


struct yevent {
    int type; // 1 - open, -1 - close
    int y, x1, x2;
    yevent(int t, int y, int x1, int x2) : type(t), y(y), x1(x1), x2(x2) {}
};

void solve() {
    int n;
    cin >> n;
    vector<yevent> v;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        v.emplace_back(1, y1, x1, x2);
        v.emplace_back(-1, y2 + 1, x1, x2);
    }

    sort(all(v), [&](yevent a, yevent b) {
        return a.y < b.y || a.y == b.y && a.type > b.type;
    });

    vector<pair<int, int>> v2; // {type, x// }

    set<pair<int, int>> st;

    gp_hash_table<ll, bool> used;

    int prev_y = -1;

    auto cmp = [&](pair<int, int> a, pair<int, int> b) {
        return a.S < b.S || a.S == b.S && a.F > b.F;
    };

    multiset<pair<int, int>, decltype(cmp)> events(cmp);

    //int cur_i = 0;
    for (auto [t, y, x1, x2] : v) {

        if (prev_y != y) {
            v2.clear();
            for (auto event : events)
                v2.emplace_back(event);

            int cur_cnt = y - prev_y;

            int l = -1, b = 0;
            for (auto [type, x]: v2) {
                if (b == 0) {
                    l = x;
                }
                b += type;
                if (b == 0) {
                    //cout << l << ' ' << x << '\n';
                    int r = x;
                    ll hash = 1ll * l * INF + r;
                    if (!used[hash]) {
                        st.insert({l, r});
                        used[hash] = true;
                    }
                }
            }
        }
        prev_y = y;

        if (t == 1) {
            events.insert({1, x1});
            events.insert({-1, x2 + 1});
        } else {
            events.erase(events.find({1, x1}));
            events.erase(events.find({-1, x2 + 1}));
        }
    }

    cout << st.size() << '\n';
    for (auto [l, r] : st) {
        cout << l << ' ' << r - 1 << ' ' << 1 << ' ' << 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}