#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define S second

const int INF = 1e9 + 7;


struct event {
    int type; // 1 - open, -1 - close
    int y, x1, x2;
};

void solve() {
   int n;
   cin >> n;
   vector<event> v;
   for (int i = 0; i < n; i++) {
       int x1, y1, x2, y2;
       cin >> x1 >> y1 >> x2 >> y2;
       v.emplace_back(1, y1, x1, x2);
       v.emplace_back(-1, y2 + 1, x1, x2);
   }

   sort(all(v), [&](event a, event b) {
       return a.y < b.y || a.y == b.y && a.type > b.type;
   });

   vector<pair<int, int>> v2; // {type, x}
   map<pair<int, int>, int> last, streak, max_streak, cnt;

   int prev_y = -1;

   //int cur_i = 0;
   for (int i = 0; i < v.size(); i++) {
        auto [t, y, x1, x2] = v[i];

        if (prev_y != y) {
            sort(all(v2), [&](pair<int, int> a, pair<int, int> b) {
                return a.S < b.S || a.S == b.S && a.F > b.F;
            });

            int cur_cnt = y - prev_y;

            int l = -1, b = 0;
            for (auto [type, x]: v2) {
                if (b == 0) {
                    l = x;
                }
                b += type;
                if (b == 0) {
                    //cout << l << ' ' << x << '\n';
                    int r = x;
                    // {l, r}

                    if (last[{l, r}] == prev_y) {
                        streak[{l, r}] += cur_cnt;
                    } else {
                        streak[{l, r}] = cur_cnt;
                    }
                    max_streak[{l, r}] = max(max_streak[{l, r}], streak[{l, r}]);
                    cnt[{l, r}] += cur_cnt;
                    last[{l, r}] = y;
                }
            }
        }
        prev_y = y;

       if (t == 1) {
           v2.emplace_back(1, x1);
           v2.emplace_back(-1, x2 + 1);
       } else {
           v2.erase(find(all(v2), make_pair(1, x1)));
           v2.erase(find(all(v2), make_pair(-1, x2 + 1)));
       }
   }

   cout << cnt.size() << '\n';
   for (auto [k, cur_cnt] : cnt) {
       cout << k.F << ' ' << k.S - 1 << ' ' << cur_cnt << ' ' << max(1, max_streak[k]) << '\n';
   }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}