#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<string> mtx;

void moveLR(bool isR) {
    for(int i = 0; i < n; i++) {
        string str;
        str.reserve(m);
        for(int j = 0; j < m; j++) {
            if(mtx[i][j] != '.') str.push_back(mtx[i][j]);
        }
        if(isR) reverse(str.begin(), str.end());
        while(str.size() < m) str.push_back('.');
        if(isR) reverse(str.begin(), str.end());
        mtx[i] = str;
    }
}

void moveUD(bool isD) {
    for(int i = 0; i < m; i++) {
        string str;
        str.reserve(m);
        for(int j = 0; j < n; j++) {
            if(mtx[j][i] != '.') str.push_back(mtx[j][i]);
        }
        if(isD) reverse(str.begin(), str.end());
        while(str.size() < n) str.push_back('.');
        if(isD) reverse(str.begin(), str.end());
        for(int j = 0; j < n; j++) {
            mtx[j][i] = str[j];
        }
    }
}

void moveLRi(bool isR, vector<vector<int>>& mtx) {
    for(int i = 0; i < n; i++) {
        vector<int> str;
        str.reserve(m);
        for(int j = 0; j < m; j++) {
            if(mtx[i][j] != -1) str.push_back(mtx[i][j]);
        }
        if(isR) reverse(str.begin(), str.end());
        while(str.size() < m) str.push_back(-1);
        if(isR) reverse(str.begin(), str.end());
        mtx[i] = str;
    }
}

void moveUDi(bool isD, vector<vector<int>>& mtx) {
    for(int i = 0; i < m; i++) {
        vector<int> str;
        str.reserve(m);
        for(int j = 0; j < n; j++) {
            if(mtx[j][i] != -1) str.push_back(mtx[j][i]);
        }
        if(isD) reverse(str.begin(), str.end());
        while(str.size() < n) str.push_back(-1);
        if(isD) reverse(str.begin(), str.end());
        for(int j = 0; j < n; j++) {
            mtx[j][i] = str[j];
        }
    }
}

vector<int> permMul(vector<int> a, vector<int> b) {
    vector<int> ans(a.size());
    for(int i = 0; i < a.size(); i++) ans[b[i]] = a[i];
    return ans;
}

void solve() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m;
    mtx.resize(n);
    for(int i = 0; i < n; i++) cin >> mtx[i];
    string s;
    cin >> s;
    string ns;
    for(auto i : s) {
        if(ns.size() == 0) {
            ns.push_back(i);
            continue;
        }
        if((i == 'U' || i == 'D') && (ns.back() == 'U' || ns.back() == 'D')) {
            ns.back() = i;
            continue;
        }
        if((i == 'L' || i == 'R') && (ns.back() == 'L' || ns.back() == 'R')) {
            ns.back() = i;
            continue;
        }
        ns.push_back(i);
    }
    bool isLadder = false;
    string s2;
    for(int i = 0; i < ns.size(); i++) {
        if(!isLadder) {
            vector<int> szsX(n), szsY(m);
            for(int a = 0; a < n; a++) {
                for(int b = 0; b < m; b++) {
                    if(mtx[a][b] != '.') {
                        szsX[a]++;
                        szsY[b]++;
                    }
                }
            }
            if((is_sorted(szsX.begin(), szsX.end()) || is_sorted(szsX.rbegin(), szsX.rend())) &&
               (is_sorted(szsY.begin(), szsY.end()) || is_sorted(szsY.rbegin(), szsY.rend()))) {
                isLadder = true;
            }
        }
        char cc = ns[i];
        if(!isLadder || i < 4) {
            if(cc == 'L') moveLR(false);
            if(cc == 'R') moveLR(true);
            if(cc == 'U') moveUD(false);
            if(cc == 'D') moveUD(true);
        } else {
            s2.push_back(cc);
        }
    }
    // cout << ">> " << s2 << '\n';
    vector<vector<int>> mtx2(n, vector<int>(m, -1));
    int cntr = 0;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(mtx[i][j] != '.') mtx2[i][j] = (cntr++);
        }
    }
    vector<vector<int>> mtx3 = mtx2;
    moveLRi(false, mtx3);
    moveUDi(false, mtx3);
    moveLRi(true, mtx3);
    moveUDi(true, mtx3);

    // for(auto i : mtx2) {
    //     for(auto j : i) cout << j << ' ';
    //     cout << '\n';
    // }

    // for(auto i : mtx3) {
    //     for(auto j : i) cout << j << ' ';
    //     cout << '\n';
    // }

    vector<int> p(cntr);
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(mtx2[i][j] == -1) continue;
            p[mtx2[i][j]] = mtx3[i][j];
        }
    }
    // for(auto i : p) cout << i << ' ';
    // cout << '\n';

    vector<int> p2(cntr);
    iota(p2.begin(), p2.end(), 0);
    for(int i = 0; i < s2.size() / 4; i++) p2 = permMul(p, p2);
    vector<char> cs(cntr);
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(mtx2[i][j] == -1) continue;
            cs[mtx2[i][j]] = mtx[i][j];
        }
    }
    vector<string> ansMtx = mtx;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(mtx2[i][j] == -1) continue;
            ansMtx[i][j] = cs[p2[mtx2[i][j]]];
        }
    }

    for(auto i : ansMtx) {
        cout << i << '\n';
    }
}

int main() {
    int t;
    cin >> t;
    while(t--) solve();
}
