#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<string> mtx;

void moveLR(bool isR) {
    for(int i = 0; i < n; i++) {
        string str;
        str.reserve(m);
        for(int j = 0; j < m; j++) {
            if(mtx[i][j] != '.') str.push_back(mtx[i][j]);
        }
        if(isR) reverse(str.begin(), str.end());
        while(str.size() < m) str.push_back('.');
        if(isR) reverse(str.begin(), str.end());
        mtx[i] = str;
    }
}

void moveUD(bool isD) {
    for(int i = 0; i < m; i++) {
        string str;
        str.reserve(m);
        for(int j = 0; j < n; j++) {
            if(mtx[j][i] != '.') str.push_back(mtx[j][i]);
        }
        if(isD) reverse(str.begin(), str.end());
        while(str.size() < n) str.push_back('.');
        if(isD) reverse(str.begin(), str.end());
        for(int j = 0; j < n; j++) {
            mtx[j][i] = str[j];
        }
    }
}

void moveLRi(bool isR, vector<vector<int>>& mtx) {
    for(int i = 0; i < n; i++) {
        vector<int> str;
        str.reserve(m);
        for(int j = 0; j < m; j++) {
            if(mtx[i][j] != -1) str.push_back(mtx[i][j]);
        }
        if(isR) reverse(str.begin(), str.end());
        while(str.size() < m) str.push_back(-1);
        if(isR) reverse(str.begin(), str.end());
        mtx[i] = str;
    }
}

void moveUDi(bool isD, vector<vector<int>>& mtx) {
    for(int i = 0; i < m; i++) {
        vector<int> str;
        str.reserve(m);
        for(int j = 0; j < n; j++) {
            if(mtx[j][i] != -1) str.push_back(mtx[j][i]);
        }
        if(isD) reverse(str.begin(), str.end());
        while(str.size() < n) str.push_back(-1);
        if(isD) reverse(str.begin(), str.end());
        for(int j = 0; j < n; j++) {
            mtx[j][i] = str[j];
        }
    }
}

vector<int> permMul(vector<int> a, vector<int> b) {
    vector<int> ans(a.size());
    for(int i = 0; i < a.size(); i++) ans[i] = b[a[i]];
    return ans;
}

void assert2(bool f) {
    if(f) return;
    while(true) {
        int x = rand();
    }
}

vector<int> ep;

vector<int> permBp(vector<int> p, int n) {
    if(n == 0) return ep;
    auto pp = permBp(p, n / 2);
    pp = permMul(pp, pp);
    if(n & 1) pp = permMul(pp, p);
    return pp;
}

void solve() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m;
    mtx.resize(n);
    for(int i = 0; i < n; i++) cin >> mtx[i];
    string s;
    cin >> s;
    // assert(s.size() % 4 == 0);
    // cout << "\n\n\n";
    string ns;
    for(auto i : s) {
        if(ns.size() == 0) {
            ns.push_back(i);
            continue;
        }
        if(ns.back() == i) continue;
        if((i == 'U' || i == 'D') && (ns.back() == 'U' || ns.back() == 'D')) {
            ns.back() = i;
            continue;
        }
        if((i == 'L' || i == 'R') && (ns.back() == 'L' || ns.back() == 'R')) {
            ns.back() = i;
            continue;
        }
        ns.push_back(i);
    }
    bool isLadder = false;
    string s2;
    for(int i = 0; i < ns.size(); i++) {
        if(!isLadder) {
            vector<int> szsX(n), szsY(m);
            for(int a = 0; a < n; a++) {
                for(int b = 0; b < m; b++) {
                    if(mtx[a][b] != '.') {
                        szsX[a]++;
                        szsY[b]++;
                    }
                }
            }
            if((is_sorted(szsX.begin(), szsX.end()) || is_sorted(szsX.rbegin(), szsX.rend())) &&
               (is_sorted(szsY.begin(), szsY.end()) || is_sorted(szsY.rbegin(), szsY.rend()))) {
                isLadder = true;
            }
        }
        char cc = ns[i];
        if(!isLadder || i < 8) {
            if(cc == 'L') moveLR(false);
            if(cc == 'R') moveLR(true);
            if(cc == 'U') moveUD(false);
            if(cc == 'D') moveUD(true);
        } else {
            s2.push_back(cc);
        }
    }
    int curLadderX = 0, curLadderY = 0;
    {
        vector<int> szsX(n), szsY(m);
        for(int a = 0; a < n; a++) {
            for(int b = 0; b < m; b++) {
                if(mtx[a][b] != '.') {
                    szsX[a]++;
                    szsY[b]++;
                }
            }
        }
        if(is_sorted(szsX.begin(), szsX.end())) curLadderY = 1;
        if(is_sorted(szsY.begin(), szsY.end())) curLadderX = 1;
    }
    int sLadderX = curLadderX, sLadderY = curLadderY;
    // cout << ">> " << curLadderX << ' ' << curLadderY << '\n';
    string s3;
    int cntrr = 0;
    for(auto i : s2) {
        if(i == 'L' && curLadderX == 0) continue;
        if(i == 'R' && curLadderX == 1) continue;
        if(i == 'U' && curLadderY == 0) continue;
        if(i == 'D' && curLadderY == 1) continue;
        if(i == 'L') curLadderX = 0;
        if(i == 'R') curLadderX = 1;
        if(i == 'U') curLadderY = 0;
        if(i == 'D') curLadderY = 1;
        // cout << ">> " << i << ' ' << curLadderX << ' ' << curLadderY << '\n';
        s3.push_back(i);
        if(i == 'D') {
            if(curLadderX == 0) cntrr++;
            else cntrr--;
        }
        if(i == 'U') {
            if(curLadderX == 0) cntrr--;
            else cntrr++;
        }
        if(i == 'L') {
            if(curLadderY == 0) cntrr++;
            else cntrr--;
        }
        if(i == 'R') {
            if(curLadderY == 0) cntrr--;
            else cntrr++;
        }
        if(cntrr % 4 == 0) s3.clear();
    }
    // cout << ">> " << cntrr << '\n';
    // cout << ">> " << s2 << '\n';
    // cout << ">> " << s3 << '\n';
    // vector<vector<int>> mtx2(n, vector<int>(m, -1));
    // int cntr = 0;
    // for(int i = 0; i < n; i++) {
    //     for(int j = 0; j < m; j++) {
    //         if(mtx[i][j] != '.') mtx2[i][j] = (cntr++);
    //     }
    // }
    // moveLRi(false, mtx2);
    // moveUDi(false, mtx2);
    // moveLRi(true, mtx2);
    // moveUDi(true, mtx2);
    // vector<vector<int>> mtx3 = mtx2;
    // moveLRi(false, mtx3);
    // moveUDi(false, mtx3);
    // moveLRi(true, mtx3);
    // moveUDi(true, mtx3);

    // // for(auto i : mtx2) {
    // //     for(auto j : i) cout << setw(2) << j << ' ';
    // //     cout << '\n';
    // // }

    // // for(auto i : mtx3) {
    // //     for(auto j : i) cout << setw(2) << j << ' ';
    // //     cout << '\n';
    // // }

    // vector<int> p(cntr);
    // for(int i = 0; i < n; i++) {
    //     for(int j = 0; j < m; j++) {
    //         if(mtx2[i][j] == -1) continue;
    //         if(mtx3[i][j] == -1) {
    //             assert(false);
    //         }
    //         p[mtx2[i][j]] = mtx3[i][j];
    //     }
    // }
    // // for(auto i : p) cout << i << ' ';
    // // cout << '\n';

    // ep.resize(cntr);
    // iota(ep.begin(), ep.end(), 0);
    // // for(int i = 0; i < s2.size() / 4; i++) p2 = permMul(p, p2);
    // auto p2 = permBp(p, s2.size() / 4);
    // vector<char> cs(cntr);
    // for(int i = 0; i < n; i++) {
    //     for(int j = 0; j < m; j++) {
    //         if(mtx2[i][j] == -1) continue;
    //         if(mtx3[i][j] == -1) assert(false);
    //         cs[mtx2[i][j]] = mtx[i][j];
    //     }
    // }
    // vector<string> ansMtx = mtx;
    // for(int i = 0; i < n; i++) {
    //     for(int j = 0; j < m; j++) {
    //         if(mtx2[i][j] == -1) continue;
    //         ansMtx[i][j] = cs[p2[mtx2[i][j]]];
    //     }
    // }

    if(cntrr > 0) {
        cntrr /= 4;
        for(int i = 0; i < cntrr; i++) {
            if(sLadderX == 0 && sLadderY == 1) {
                moveLR(true);
                moveUD(false);
                moveLR(false);
                moveUD(true);
            }
            if(sLadderX == 1 && sLadderY == 1) {
                moveUD(false);
                moveLR(false);
                moveUD(true);
                moveLR(true);
            }
            if(sLadderX == 1 && sLadderY == 0) {
                moveLR(false);
                moveUD(true);
                moveLR(true);
                moveUD(false);
            }
            if(sLadderX == 0 && sLadderY == 0) {
                moveUD(true);
                moveLR(true);
                moveUD(false);
                moveLR(false);
            }
        }
    } else {
        cntrr = -cntrr;
        cntrr /= 4;
        for(int i = 0; i < cntrr; i++) {
            if(sLadderX == 0 && sLadderY == 1) {
                moveUD(false);
                moveLR(true);
                moveUD(true);
                moveLR(false);
            }
            if(sLadderX == 1 && sLadderY == 1) {
                moveLR(false);
                moveUD(false);
                moveLR(true);
                moveUD(true);
            }
            if(sLadderX == 1 && sLadderY == 0) {
                moveUD(true);
                moveLR(false);
                moveUD(false);
                moveLR(true);
            }
            if(sLadderX == 0 && sLadderY == 0) {
                moveLR(true);
                moveUD(true);
                moveLR(false);
                moveUD(false);
            }
        }
    }

    for(auto cc : s3) {
        if(cc == 'L') moveLR(false);
        if(cc == 'R') moveLR(true);
        if(cc == 'U') moveUD(false);
        if(cc == 'D') moveUD(true);
    }

    for(auto i : mtx) {
        cout << i << '\n';
    }
}

int main() {
    int t;
    cin >> t;
    while(t--) solve();
}
