#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;


void solve() {
    int vs;
    cin >> vs;
    int xs = 5e3 + 1;
    int ys = 5e3 + 1;

    vector<vector<pair<int, int>>>aq(xs);
    vector<vector<pair<int, int>>>dq(xs);

    while (vs--) {
        int xf, yf, xt, yt;
        cin >> xf >> yf >> xt >> yt;
        aq[xf].push_back({yf, yt});
        dq[xt + 1].push_back({yf, yt});
    }

    vector<int>cnt(ys);
    vector<int>l(ys);

    map<pair<int, int>, int>ans;

    for (int x = 0; x < aq.size(); x++) {
        vector<int>d(ys);
        for (auto [yf, yt] : aq[x]) {
            d[yf]++;
            d[yt + 1]--;
        }
        for (auto [yf, yt] : dq[x]) {
            d[yf]--;
            d[yt + 1]++;
        }
        int smd = 0;
        for (int y = 0; y < ys; y++) {
            smd += d[y];
            cnt[y] += smd;
        }

        for (int y = 0; y < ys; y++) {
            if (!cnt[y]) {
                if (l[y] != x) {
                    ans[{l[y], x - 1}]++;
                }
                l[y] = x + 1;
            }
        }
    }

    cout << ans.size() << '\n';
    for (auto [c, cnt] : ans) {
        cout << c.first << ' ' << c.second << ' ' << cnt << " 1\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qs;
    cin >> qs;
    while (qs--) {
        solve();
        cout << '\n';
    }
}
