#include <iostream>
#include <vector>
#include <tuple>
#include <string>
#include <algorithm>
#include <cassert>
#include <math.h>

#define all(x) x.begin(),x.end()

using namespace std;
using ll = long long;
using p = pair<int, int>;


void moveL(vector<vector<char>>& arr) {
	for (auto& i : arr)
	{
		int pos = 0;
		for (int j = 0; j < i.size(); j++)
			if (i[j] != -1) {
				i[pos] = i[j];
				if (pos != j)i[j] = -1;
				pos++; }
	}
}
void moveR(vector<vector<char>>& arr) {
	for (auto& i : arr)reverse(all(i));
	moveL(arr);
	for (auto& i : arr)reverse(all(i));
}
void moveD(vector<vector<char>>& arr) {
	vector<vector<char>> arr2(arr[0].size(), vector<char>(arr.size()));
	for (int i = 0; i < arr.size(); i++)
		for (int j = 0; j < arr[0].size(); j++)
			arr2[j][i] = arr[i][j];

	moveR(arr2);

	for (int i = 0; i < arr[0].size(); i++)
		for (int j = 0; j < arr.size(); j++)
			arr[j][i] = arr2[i][j];
}

void moveU(vector<vector<char>>& arr) {
	vector<vector<char>> arr2(arr[0].size(), vector<char>(arr.size()));
	for (int i = 0; i < arr.size(); i++)
		for (int j = 0; j < arr[0].size(); j++)
			arr2[j][i] = arr[i][j];

	moveL(arr2);

	for (int i = 0; i < arr[0].size(); i++)
		for (int j = 0; j < arr.size(); j++)
			arr[j][i] = arr2[i][j];
}

char rev(char c) {
	if (c == 'L')return 'R';
	if (c == 'R')return 'L';
	if (c == 'D')return 'U';
	if (c == 'U')return 'D';
	return -1;
}

int startCr(string s) {
	int res = 0;
	if (s[0] == 'D' || s[1] == 'D')res += 2;
	if (s[0] == 'R' || s[1] == 'R')res += 1;
	return res;
}

//   corn corn cnt
tuple<string,int,int> process(string que){
	string st;
	reverse(all(que));
	for (auto& i : que)
		if (st.size() == 0 || (st.back() != i && st.back() != rev(i)))st.push_back(i);

	reverse(all(st));
	que = st;

	if (que.size() <= 2)
		return { que,-1,0 };

	string star = "AA";
	star[0] = que[0];
	star[1] = que[1];
	que.erase(que.begin());
	que.erase(que.begin());

	int corn1 = startCr(star);
	int corn = corn1;
	int cnt = 0;
	for (auto& i : que)
	{
		if (corn == 0) {
			if (i == 'U' || i == 'L')continue;
			if (i == 'R')cnt++, corn = 1;
			if (i == 'D')cnt--, corn = 2;
		}
		if (corn == 1) {
			if (i == 'U' || i == 'R')continue;
			if (i == 'D')cnt++, corn = 3;
			if (i == 'L')cnt--, corn = 0;
		}
		if (corn == 2) {
			if (i == 'D' || i == 'L')continue;
			if (i == 'U')cnt++, corn = 0;
			if (i == 'R')cnt--, corn = 3;
		}
		if (corn == 3) {
			if (i == 'D' || i == 'R')continue;
			if (i == 'L')cnt++, corn = 2;
			if (i == 'U')cnt--, corn = 1;
		}
	}
	return { star,corn1,cnt };


	/*for (auto& i : que)
		if (st.size() <= 1 || (st[(int)st.size() - 2] != i))st.push_back(i);*/
	que = st;
	//cout << que << '\n';
}

string gen(int corn, int cnt) {
	string res;
	if (cnt > 0){
		while (cnt--)
		{
			if (corn == 0)res.push_back('R'), corn = 1;
			else if (corn == 1)res.push_back('D'), corn = 3;
			else if (corn == 2)res.push_back('U'), corn = 0;
			else if (corn == 3)res.push_back('L'), corn = 2;
		}
	}
	else {
		cnt = abs(cnt);
		while (cnt--)
		{
			if (corn == 0)res.push_back('D'), corn = 2;
			else if (corn == 1)res.push_back('L'), corn = 0;
			else if (corn == 2)res.push_back('R'), corn = 3;
			else if (corn == 3)res.push_back('U'), corn = 1;
		}
	}
	return res;
}

void solve() {
	int m, n;
	cin >> m >> n;
	vector<vector<char>> arr(m, vector<char>(n));
	for (int i = 0; i < m; i++)
	{
		string s;
		cin >> s;
		for (int j = 0; j < n; j++) {
			arr[i][j] = s[j];
			if (s[j] == '.')arr[i][j] = -1;
		}
	}

	string que;
	cin >> que;
	auto[start,corn,cnt] = process(que);
	if (abs(cnt) < 4) {
		que = start + gen(corn, cnt);
		for (auto& i : que)
		{
			if (i == 'L')moveL(arr);
			if (i == 'R')moveR(arr);
			if (i == 'U')moveU(arr);
			if (i == 'D')moveD(arr);
		}
		for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++)
				if (arr[i][j] == -1)cout << '.';
				else cout << arr[i][j];
			cout << '\n';
		}
		cout << '\n';
	}
	else {
		for (auto& i : start)
		{
			if (i == 'L')moveL(arr);
			if (i == 'R')moveR(arr);
			if (i == 'U')moveU(arr);
			if (i == 'D')moveD(arr);
		}

		vector<p> fncSt;
		auto arr2 = arr;
		int ct = 0;
		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				if (arr[i][j] != -1) {
					arr[i][j] = ct;
					fncSt.push_back({ i,j });
					ct++;
				}
				else arr[i][j] = -1;

		auto arr22 = arr;
		int ln = 4;
		if (cnt < 0)ln = -4;
		string gn = gen(corn, ln);
		for (auto& i : gn)
		{
			if (i == 'L')moveL(arr);
			if (i == 'R')moveR(arr);
			if (i == 'U')moveU(arr);
			if (i == 'D')moveD(arr);
		}


		int numb = abs(cnt) / 4;

		int logn = ceil(log2(numb));
		vector<vector<int>> fncNx(logn, vector<int>(ct));

		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				if (arr[i][j] != -1)
					fncNx[0][arr[i][j]] = arr22[i][j];

		for (int i = 1; i < logn; i++)
			for (int j = 0; j < ct; j++)
				fncNx[i][j] = fncNx[i - 1][fncNx[i - 1][j]];

		vector<int> res(ct);
		for (int i = 0; i < ct; i++)res[i] = i;
			
		for (int i = logn - 1; i >= 0; i--)
		{
			if ((1 << i) <= numb) {
				numb -= 1 << i;
				for (int j = 0; j < ct; j++)
					res[j] = fncNx[i][res[j]];
			}
		}
		assert(numb == 0);

		vector<vector<char>> arr3(m, vector<char>(n, -1));
		for (int i = 0; i < ct; i++)
		{
			p st = fncSt[i];
			p nx = fncSt[res[i]];
			arr3[st.first][st.second] = arr2[nx.first][nx.second];
		}

		gn = gen(corn, cnt % 4);
		for (auto& i : gn)
		{
			if (i == 'L')moveL(arr3);
			if (i == 'R')moveR(arr3);
			if (i == 'U')moveU(arr3);
			if (i == 'D')moveD(arr3);
		}
		for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++) {
				if (arr3[i][j] == -1)cout << '.';
				else cout << arr3[i][j];
			}
			cout << '\n';
		}
		cout << '\n';
	}

	
}

int main()
{
	//string s;
	//cin >> s;
	//process(s);
	//cout << s << endl;
	int t;
	cin >> t;
	while (t--)
		solve();

}

