#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long

int m, n;
vector<vector<int>> ma;
vector<int> rows;
vector<int> cols;

void print()
{
	for (int y = m - 1; y >= 0; y--)
	{
		for (int x = 0; x < n; x++)
		{
			if (ma[x][y] == 0)
				cout << '.';
			else
				cout << (char)(ma[x][y] - 1 + 'a');
		}

		cout << endl;
	}
}

void movex(int dir)
{
	for (int y = 0; y < m; y++)
	{
		vector<int> blocks;
		for (int x = 0; x < n; x++)
		{
			if (ma[x][y] != 0)
			{
				blocks.push_back(ma[x][y]);
				ma[x][y] = 0;
			}
		}

		rows[y] = blocks.size();

		int startx;
		if (dir > 0)
			startx = n - rows[y];
		else
			startx = 0;

		for (int dx = 0; dx < rows[y]; dx++)
		{
			ma[startx + dx][y] = blocks[dx];
		}
	}
}

void movey(int dir)
{
	for (int x = 0; x < n; x++)
	{
		vector<int> blocks;
		for (int y = 0; y < m; y++)
		{
			if (ma[x][y] != 0)
			{
				blocks.push_back(ma[x][y]);
				ma[x][y] = 0;
			}
		}

		cols[x] = blocks.size();

		int starty;
		if (dir > 0)
			starty = m - cols[x];
		else
			starty = 0;

		for (int dy = 0; dy < cols[x]; dy++)
		{
			ma[x][starty + dy] = blocks[dy];
		}
	}
}
int main()
{
	int t;
	cin >> t;

	for (int i = 0; i < t; i++)
	{
		cin >> m >> n;

		ma = vector<vector<int>>(n, vector<int>(m));
		rows = vector<int>(m);
		cols = vector<int>(n);

		for (int y = m - 1; y >= 0; y--)
		{
			for (int x = 0; x < n; x++)
			{
				char c;
				cin >> c;

				if (c == '.')
					ma[x][y] = 0;
				else
					ma[x][y] = c + 1 - 'a';
			}
		}

		string com;
		cin >> com;

		int cnt = (com.size() / 4) % 3 + 3;

		for (int l = 0; l < cnt; l++)
		{
			for (int j = 0; j < 4; j++)
			{
				if (com[j] == 'L')
					movex(-1);
				if (com[j] == 'R')
					movex(1);
				if (com[j] == 'D')
					movey(-1);
				if (com[j] == 'U')
					movey(1);
			}
		}
		print();
	}

	return 0;
}