#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long

int m, n;
vector<vector<int>> ma;
vector<int> rows;
vector<int> cols;

void print()
{
	for (int y = m - 1; y >= 0; y--)
	{
		for (int x = 0; x < n; x++)
		{
			if (ma[x][y] == 0)
				cout << '.';
			else
				cout << (char)(ma[x][y] - 1 + 'a');
		}

		cout << endl;
	}
}

void movex(int dir)
{
	for (int y = 0; y < m; y++)
	{
		vector<int> blocks;
		for (int x = 0; x < n; x++)
		{
			if (ma[x][y] != 0)
			{
				blocks.push_back(ma[x][y]);
				ma[x][y] = 0;
			}
		}

		rows[y] = blocks.size();

		int startx;
		if (dir > 0)
			startx = n - rows[y];
		else
			startx = 0;

		for (int dx = 0; dx < rows[y]; dx++)
		{
			ma[startx + dx][y] = blocks[dx];
		}
	}
}

void movey(int dir)
{
	for (int x = 0; x < n; x++)
	{
		vector<int> blocks;
		for (int y = 0; y < m; y++)
		{
			if (ma[x][y] != 0)
			{
				blocks.push_back(ma[x][y]);
				ma[x][y] = 0;
			}
		}

		cols[x] = blocks.size();

		int starty;
		if (dir > 0)
			starty = m - cols[x];
		else
			starty = 0;

		for (int dy = 0; dy < cols[x]; dy++)
		{
			ma[x][starty + dy] = blocks[dy];
		}
	}
}

void move(char com)
{
	if (com == 'L')
		movex(-1);
	if (com == 'R')
		movex(1);
	if (com == 'D')
		movey(-1);
	if (com == 'U')
		movey(1);
}

void fastx(int dir)
{
	if ((cols[n - 1] - cols[0]) / dir >= 0)
		return;

	reverse(cols.begin(), cols.end());
}

void fasty(int dir)
{
	if ((rows[m - 1] - rows[0]) / dir >= 0)
		return;

	reverse(rows.begin(), rows.end());
}

void fast(char com)
{
	if (com == 'L')
		fastx(-1);
	if (com == 'R')
		fastx(1);
	if (com == 'D')
		fasty(-1);
	if (com == 'U')
		fasty(1);
}

void simple(char com)
{
	move(com);
	print();
}

void generate()
{
	int dir;
	if (cols[0] > cols[n - 1])
	{
		dir = -1;
	}
	else
	{
		dir = 1;
	}

	for (int y = 0; y < m; y++)
	{
		for (int x = 0; x < n; x++)
		{
			if (dir > 0)
			{
				if (n - x > rows[y])
					ma[x][y] = 0;
				else
					ma[x][y] = 1;
			}
			else
			{
				if (x >= rows[y])
					ma[x][y] = 0;
				else
					ma[x][y] = 1;
			}
		}
	}
}

int main()
{
	int t;
	cin >> t;

	for (int i = 0; i < t; i++)
	{
		cin >> m >> n;

		ma = vector<vector<int>>(n, vector<int>(m));
		rows = vector<int>(m);
		cols = vector<int>(n);

		for (int y = m - 1; y >= 0; y--)
		{
			for (int x = 0; x < n; x++)
			{
				char c;
				cin >> c;

				if (c == '.')
					ma[x][y] = 0;
				else
					ma[x][y] = c + 1 - 'a';
			}
		}

		string com;
		cin >> com;

		int first = -1;

		if (com[0] == 'L' || com[0] == 'R')
		{
			for (int j = 0; j < com.size(); j++)
			{
				if (com[j] == 'U' || com[j] == 'D')
				{
					first = j - 1;
					break;
				}
			}

			if (first == -1)
			{
				simple(com[com.size() - 1]);
				return 0;
			}
		}
		else
		{
			for (int j = 0; j < com.size(); j++)
			{
				if (com[j] == 'L' || com[j] == 'R')
				{
					first = j - 1;
					break;
				}
			}

			if (first == -1)
			{
				simple(com[com.size() - 1]);
				return 0;
			}
		}

		move(com[first]);
		move(com[first + 1]);
		move(com[first]);
		move(com[first + 1]);

		for (int j = first + 2; j < com.size(); j++)
		{
			fast(com[j]);
		}

		generate();

		print();
	}

	return 0;
}