#include <bits/stdc++.h>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solution();
    }

    return 0;
}


void move(vector<vector<int>> &a, char c) {
    int n = a.size();
    int m = a[0].size();
    vector<vector<int>> new_a(n, vector<int>(m, -1));
    if (c == 'L') {
        for (int i = 0; i < n; ++i) {
            int cur = 0;
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != -1) {
                    new_a[i][cur++] = a[i][j];
                }
            }
        }
    } else if (c == 'U') {
        for (int j = 0; j < m; ++j) {
            int cur = 0;
            for (int i = 0; i < n; ++i) {
                if (a[i][j] != -1) {
                    new_a[cur++][j] = a[i][j];
                }
            }
        }
    } else if (c == 'R') {
        for (int i = 0; i < n; ++i) {
            int cur = 0;
            for (int j = m - 1; j >= 0; --j) {
                if (a[i][j] != -1) {
                    new_a[i][m - ++cur] = a[i][j];
                }
            }
        }
    } else {
        for (int j = 0; j < m; ++j) {
            int cur = 0;
            for (int i = n - 1; i >= 0; --i) {
                if (a[i][j] != -1) {
                    new_a[n - ++cur][j] = a[i][j];
                }
            }
        }
    }
    a = new_a;
}

const int lg = 22;

void solution() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            a[i][j] = (int)c;
            if (a[i][j] == '.') {
                a[i][j] = -1;
            }
        }
    }

    string s;
    cin >> s;

    int q = s.size();
    int cur = 0;
    bool was_lr = false, was_ud = false;
    int last_lr = 'A', last_ud = 'A';
    for (; cur < s.size(); ++cur) {
        if (s[cur] == 'L' || s[cur] == 'R') {
            was_lr = true;
            last_lr = s[cur];
        } else {
            was_ud = true;
            last_ud = s[cur];
        }
        if (was_lr && was_ud) break;
    }

    if (cur == q) {
        if (last_lr == 'A') {
            move(a, last_ud);
        } else {
            move(a, last_lr);
        }
    } else {
        if (s[cur] == 'U' || s[cur] == 'D') {
            move(a, last_lr);
            move(a, last_ud);
        } else {
            move(a, last_ud);
            move(a, last_lr);
        }
    }
    cur++;

    string res;
//    int last_lr = 'A';
//    int last_ud = 'A';
    for (int i = cur; i < q; ++i) {
        if (res.empty()) {
            res.push_back(s[i]);
            continue;
        }
        if (s[i] == 'L') {
            if (res.back() == 'R') {
                res.pop_back();
                if (res.size() <= 1) res.push_back(s[i]);
                continue;
            }
            if (res.size() == 1) {
                if (res[0] == 'U' || res[0] == 'D') {
                    res.push_back('L');
                }
                continue;
            }
            if (res[res.size() - 2] == 'R') {
                res.push_back('L');
            }
        } else if (s[i] == 'R') {
            if (res.back() == 'L') {
                res.pop_back();
                if (res.size() <= 1) res.push_back(s[i]);
                continue;
            }
            if (res.size() == 1) {
                if (res[0] == 'U' || res[0] == 'D') {
                    res.push_back(s[i]);
                }
                continue;
            }
            if (res[res.size() - 2] == 'L') {
                res.push_back(s[i]);
            }
        } else if (s[i] == 'U') {
            if (res.back() == 'D') {
                res.pop_back();
                if (res.size() <= 1) res.push_back(s[i]);
                continue;
            }
            if (res.size() == 1) {
                if (res[0] == 'L' || res[0] == 'R') {
                    res.push_back(s[i]);
                }
                continue;
            }
            if (res[res.size() - 2] == 'D') {
                res.push_back(s[i]);
            }
        } else if (s[i] == 'D') {
            if (res.back() == 'U') {
                res.pop_back();
                if (res.size() <= 1) res.push_back(s[i]);
                continue;
            }
            if (res.size() == 1) {
                if (res[0] == 'L' || res[0] == 'R') {
                    res.push_back(s[i]);
                }
                continue;
            }
            if (res[res.size() - 2] == 'U') {
                res.push_back(s[i]);
            }
        }
    }

    for (int i = 0; i < min(res.size(), res.size() % 4 + 4); ++i) {
        move(a, res[i]);
    }

    string new_res;
    for (int i = min(res.size(), res.size() % 4 + 4); i < res.size(); ++i) {
        new_res.push_back(res[i]);
    }

    if (new_res.empty()) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << (a[i][j] == -1 ? '.' : (char)a[i][j]);
            }
            cout << '\n';
        }
        return;
    }

    res = new_res;

    vector<vector<int>> new_a = a;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != -1) {
                new_a[i][j] = cnt++;
            }
        }
    }


    auto nnew_a = new_a;

    if (res.size()) {
        move(nnew_a, res[0]);
        move(nnew_a, res[1]);
        move(nnew_a, res[2]);
        move(nnew_a, res[3]);
    }

    vector<pair<int, int>> pos(cnt);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            pos[new_a[i][j]] = {i, j};
        }
    }

    vector<vector<int>> moved(lg, vector<int>(cnt));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (nnew_a[i][j] == -1) continue;
            int ind = new_a[i][j];
            moved[0][ind] = nnew_a[pos[ind].first][pos[ind].second];
        }
    }

    for (int l = 1; l < lg; ++l) {
        for (int i = 0; i < cnt; ++i) {
            moved[l][i] = moved[l - 1][moved[l - 1][i]];
        }
    }

    int lk = res.size() / 4;

    vector<int> all_moved(cnt);
    for (int j = 0; j < lg; ++j) {
        if (lk >> j & 1) {
            for (int i = 0; i < cnt; ++i) {
                all_moved[i] = moved[j][all_moved[i]];
            }
        }
    }

    vector<vector<int>> ans(n, vector<int>(m, -1));
    for (int i = 0; i < cnt; ++i) {
        int am = all_moved[i];
        ans[pos[am].first][pos[am].second] = a[pos[i].first][pos[i].second];
    }

//    for (int i = 0; i < min(res.size() % 16 + 16, res.size()); ++i) {
//        move(a, res[i]);
//    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << (ans[i][j] == -1 ? '.' : (char)ans[i][j]);
        }
        cout << '\n';
    }
}






//void solution() {
//    int n, m, k, p;
//    cin >> n >> m >> k >> p;
//
//    vector<int> a(n);
//    int ans = 0;
//    for (int i = n - 1; i >= 0; --i) {
//        if (.size() < m)
//    }
//}