#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e16 + 7;


ostream & operator <<(ostream & os, const vector<long long> &a) {
    for (auto el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


ostream & operator <<(ostream &os, const map<int, long long> &m) {
    for (auto el : m) {
        os << "{" << el.first << " " << el.second << "} ";
    }
    os << '\n';
    return os;
}


ostream & operator <<(ostream &os, const vector<map<int, long long>> &m) {
    for (auto el : m) {
        os << el;
    }
    return os;
}


struct segTree {
    vector<long long> t;
    segTree(int MAXN);
    //void build(int v, int tl, int tr, const vector<long long> &a);
    void upd(int v, int tl, int tr, int pos, long long x);
    long long get(int v, int tl, int tr, int ql, int qr);
};


segTree::segTree(int MAXN) {
    t.resize(MAXN, inf);
}


void segTree::upd(int v, int tl, int tr, int pos, long long x) {
    if (tl + 1 == tr) {
        t.at(v) = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) {
        upd(v * 2 + 1, tl, tm, pos, x);
    } else {
        upd(v * 2 + 2, tm, tr, pos, x);
    }
    t.at(v) = min(t.at(v * 2 + 1), t.at(v * 2 + 2));
}


long long segTree::get(int v, int tl, int tr, int ql, int qr) {
    if (tl == ql && tr == qr) {
        return t.at(v);
    }
    int tm = (tl + tr) / 2;
    if (qr <= tm) {
        return get(v * 2 + 1, tl, tm, ql, qr);
    } else if (ql >= tm) {
        return get(v * 2 + 2, tm, tr, ql, qr);
    }
    return min(get(v * 2 + 1, tl, tm, ql, tm), get(v * 2 + 2, tm, tr, tm, qr));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    vector<long long> dp(n + 1, inf);
    dp.at(0) = 0;
    segTree T(4 * n + 1);
    T.upd(0, 0, n + 1, 0, 0);
    for (int i = 1; i < n + 1; i++) {
        int l = max(i - m, 0);
        long long val = T.get(0, 0, n + 1, l, i);
        dp.at(i) = val;
        long long buf = -1;
        if (c == 1) {
            buf = n - i + 1 + n - i - 1;
        } else if (c == 2) {
            buf = i * 2;
        } else {
            buf = min(i * 2, n - i - 1 + n - i + 1);
        }
        buf += val;
        T.upd(0, 0, n + 1, i, buf);
    }
    cout << dp.at(n) + n + 1;
    return 0;
}
