#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

const ll super_inf = 1e18;

struct SegTree {
	vector<ll> t, add;
	SegTree(int n) {
		add.resize(4 * n, 0);
		t.resize(4 * n, -super_inf);
	}
	void inc(int v, ll val) {
		t[v] += val;
		add[v] += val;
	}
	void push(int v) {
		inc(v * 2, add[v]);
		inc(v * 2 + 1, add[v]);
		add[v] = 0;
	}
	void update(int v, int tl, int tr, int l, int r, int val) {
		if (l > r) return;
		if (tl == l && tr == r) {
			inc(v, val);
			return;
		}
		push(v);
		int tm = (tl + tr) / 2;
		update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
	void update_pos(int v, int l, int r, int pos, ll val) {
		if (l == r) {
			t[v] = max(t[v], val);
			return;
		}
		push(v);
		int m = (l + r) / 2;
		if (pos <= m) {
			update_pos(2 * v, l, m, pos, val);
		} else {
			update_pos(2 * v + 1, m + 1, r, pos, val);
		}
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
	ll get(int v, int tl, int tr, int l, int r) {
		if (l > r) return -super_inf;
		if (tl == l && tr == r) {
			return t[v];
		}
		push(v);
		int tm = (tl + tr) / 2;
		return max(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
	}
};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, c, p;
	cin >> m >> n >> c >> p;
 	ll cur = 0;
	vector<ll> h;
	vector<ll> pr;
	for (int i = 0; i < n + m; i++) {
		int type, H;
		cin >> type >> H;
		if (type == 1) {
			cur += H;
		} else {
			h.pb(H);
			pr.pb(cur);
		}
	}
	vector<ll> u;
	for (int i = 0; i < n; i++) {
		u.pb(h[i] + pr[i]);
	}
	sort(all(u));
	u.erase(unique(all(u)), u.end());
	int sz = u.size();
	SegTree t(sz);
	vector<ll> dp(n);
	for (int i = 0; i < n; i++) {
		int j = lower_bound(all(u), h[i] + pr[i]) - u.begin();
		t.update(1, 0, sz - 1, j, sz - 1, p);
		ll res = p - 1ll * c * (h[i] + pr[i] - 1);
		res = max(res, t.get(1, 0, sz - 1, 0, j - 1) - (h[i] + pr[i]) * c + p);
		t.update_pos(1, 0, sz - 1, j, res + u[j] * c);
	}
	ll ans = 0;
	for (int i = 0; i < sz; i++) {
		ans = max(ans, t.get(1, 0, sz - 1, i, i) - u[i] * c);
	}
	cout << ans << endl;	
	return 0;
}