#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

int n, m;

// m x n

void mleft(vector<string> &table) {
	for (int i = 0; i < m; ++i) {
		vector<char> cs;
		for (int j = 0; j < n; ++j) {
			if (table[i][j] != '.') cs.emplace_back(table[i][j]);
			table[i][j] = '.';
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[i][j] = cs[j];
		}
	}
}

void mright(vector<string> &table) {
	for (int i = 0; i < m; ++i) {
		vector<char> cs;
		for (int j = 0; j < n; ++j) {
			if (table[i][j] != '.') cs.emplace_back(table[i][j]);
			table[i][j] = '.';
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[i][n - cs.size() + j] = cs[j];
		}
	}
}

void mup(vector<string> &table) {
	for (int i = 0; i < n; ++i) {
		vector<char> cs;
		for (int j = 0; j < m; ++j) { 
			if (table[j][i] != '.') cs.emplace_back(table[j][i]);
			table[j][i] = '.';
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[j][i] = cs[j];
		}
	}
}

void mdown(vector<string> &table) {
	for (int i = 0; i < n; ++i) {
		vector<char> cs;
		for (int j = 0; j < m; ++j) { 
			if (table[j][i] != '.') cs.emplace_back(table[j][i]);
			table[j][i] = '.';
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[m - cs.size() + j][i] = cs[j];
		}
	}
}

void mleft1(vector<vector<int>> &table) {
	for (int i = 0; i < m; ++i) {
		vector<int> cs;
		for (int j = 0; j < n; ++j) {
			if (table[i][j] != 0) cs.emplace_back(table[i][j]);
			table[i][j] = 0;
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[i][j] = cs[j];
		}
	}
}

void mright1(vector<vector<int>> &table) {
	for (int i = 0; i < m; ++i) {
		vector<int> cs;
		for (int j = 0; j < n; ++j) {
			if (table[i][j] != 0) cs.emplace_back(table[i][j]);
			table[i][j] = 0;
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[i][n - cs.size() + j] = cs[j];
		}
	}
}

void mup1(vector<vector<int>> &table) {
	for (int i = 0; i < n; ++i) {
		vector<int> cs;
		for (int j = 0; j < m; ++j) { 
			if (table[j][i] != 0) cs.emplace_back(table[j][i]);
			table[j][i] = 0;
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[j][i] = cs[j];
		}
	}
}

void mdown1(vector<vector<int>> &table) {
	for (int i = 0; i < n; ++i) {
		vector<int> cs;
		for (int j = 0; j < m; ++j) { 
			if (table[j][i] != 0) cs.emplace_back(table[j][i]);
			table[j][i] = 0;
		}
		for (int j = 0; j < cs.size(); ++j) {
			table[m - cs.size() + j][i] = cs[j];
		}
	}
}

void work(vector<string> &table, char type) {
	if (type == 'R') mright(table);
	else if (type == 'L') mleft(table);
	else if (type == 'U') mup(table);
	else if (type == 'D') mdown(table);
}

void work1(vector<vector<int>> &table, char type) {
	if (type == 'R') mright1(table);
	else if (type == 'L') mleft1(table);
	else if (type == 'U') mup1(table);
	else if (type == 'D') mdown1(table);
}

void answer(const vector<string> &table) {
	for (auto &it : table) cout << it << '\n';
}

void solve() {
	cin >> m >> n;
	vector<string> table(m);
	for (auto &it : table) cin >> it;

	string tmp;
	cin >> tmp;

	string q0;

	char cur = 'x';
	bool chor;

	for (char c : tmp) {
		bool hor = (c == 'L' || c == 'R');
		if (cur == 'x') {
			cur = c;
			chor = hor;
			continue;
		}
		if (hor == chor) {
			cur = c;
			continue;
		}
		q0 += cur;

		cur = c;
		chor = hor;
	}
	q0 += cur;

	work(table, q0[0]);

	if (q0.size() == 1) {
		answer(table);
		return;
	}

	work(table, q0[1]);

	if (q0[0] == 'U' || q0[0] == 'D') swap(q0[0], q0[1]);
	
	int hor = (q0[0] == 'L' ? -1 : 1);
	int ver = (q0[1] == 'U' ? -1 : 1);

	vector<char> q1;

	for (size_t i = 2; i < q0.size(); ++i) {
		char c = q0[i];
		/*
		cout << "c = " << c << endl;
		cout << "\thor = " << hor << endl;
		cout << "\bver = " << ver << endl;
		*/

		if (c == 'U') {
			if (q1.size() && q1.back() == 'D') q1.pop_back();
			else if (ver != -1) {
				q1.emplace_back(c);
			}
			ver = -1;
		}

		else if (c == 'D') {
			if (q1.size() && q1.back() == 'U') q1.pop_back();
			else if (ver != 1) {
				q1.emplace_back(c);
			}
			ver = 1;
		}

		else if (c == 'L') {
			if (q1.size() && q1.back() == 'R') q1.pop_back();
			else if (hor != -1) {
				q1.emplace_back(c);
			}
			hor = -1;
		}

		else if (c == 'R') {
			if (q1.size() && q1.back() == 'L') q1.pop_back();
			else if (hor != 1) {
				q1.emplace_back(c);
			}
			hor = 1;
		}
	}

	if (q1.size() <= 10) {
		for (auto c : q1) work(table, c);
		answer(table);
		return;
	}

	vector<vector<int>> t0(m, vector<int>(n, 0));
	vector<char> orig;
	int counter = 1;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			if (table[i][j] != '.') {
			   	t0[i][j] = counter;
				orig.emplace_back(table[i][j]);
				++counter;
			}
		}
	}

	auto t1 = t0;
	for (int i = 0; i < 4; ++i) work1(t1, q1[i]);

	vector<int> nxt(counter - 1);
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			if (t0[i][j] != 0) {
				nxt[t1[i][j] - 1] = t0[i][j] - 1; 
			}
		}
	}

	int k = q1.size();
	
	vector<int> hop = nxt;

	vector<int> lol(counter - 1);
	iota(all(lol), 0);
	
	int d = k / 4;

	while (d) {
		if (d & 1) {
			for (int i = 0; i < counter - 1; ++i) {
				lol[i] = hop[lol[i]];
			}
		}
		vector<int> hop1(counter - 1);
		for (int i = 0; i < counter - 1; ++i) {
			hop1[i] = hop[hop[i]];
		}
		hop = hop1;
		d >>= 1;
	}

	/*
	cout << "q0: " << q0 << endl;
	cout << "q1: ";
	for (auto c : q1) cout << c;
	cout << endl;
	*/
	vector<char> nw(counter - 1);
	for (int i = 0; i < counter - 1; ++i) {
		nw[lol[i]] = orig[i];
	}
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			if (table[i][j] != '.') {
				table[i][j] = nw[t0[i][j] - 1];
			}
		}
	}
	for (int i = 0; i < (k % 4); ++i) {
		work(table, q1[i]);
	}
}

int main() {
	FastIO;
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

