#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

size_t t;

struct State {
    vector<string> markers;
    bool ml, mr, mu, md;
    size_t n, m;

    bool has_nondefault_marker = false;

    State(size_t rows, size_t cols) : n(rows), m(cols) {
        markers.resize(rows);
        for (auto& s : markers) {
            cin >> s;
            for (auto& c : s) {
                if (c != '.' && c != 'a') has_nondefault_marker = true;
            }
        }
        ml = mr = mu = md = false;
    }

    void move_left() {
        if (ml) return;
        ml = true; mr = false;

        for (auto& w : markers) {
            size_t k = 0;
            for (size_t j = 0; j < m; j++) {
                if (w[j] == '.') continue;
                if (k++ == j) continue;
                w[k - 1] = w[j];
            }
            for (; k < m; k++) {
                w[k] = '.';
            }
        }
    }

    void move_right() {
        if (mr) return;
        ml = false; mr = true;

        for (auto& w : markers) {
            size_t k = m;
            for (size_t j = m; j--;) {
                if (w[j] == '.') continue;
                if (--k == j) continue;
                w[k] = w[j];
            }
            for (; k;) {
                w[--k] = '.';
            }
        }
    }

    void move_up() {
        if (mu) return;
        mu = true; md = false;

        for (size_t j = 0; j < m; j++) {
            // reading markers[_][j]
            size_t k = 0;
            for (size_t i = 0; i < n; i++) {
                if (markers[i][j] == '.') continue;
                if (k++ == i) continue;
                markers[k - 1][j] = markers[i][j];
            }
            for (; k < n; k++) {
                markers[k][j] = '.';
            }
        }
    }

    void move_down() {
        if (md) return;
        mu = false; md = true;

        for (size_t j = 0; j < m; j++) {
            // reading markers[_][j]
            size_t k = n;
            for (size_t i = n; i--;) {
                if (markers[i][j] == '.') continue;
                if (--k == i) continue;
                markers[k][j] = markers[i][j];
            }
            for (; k;) {
                markers[--k][j] = '.';
            }
        }
    }

    inline void move(char c) {
        if (c == 'L')      move_left();
        else if (c == 'R') move_right();
        else if (c == 'U') move_up();
        else if (c == 'D') move_down();
    }

    inline void show() {
        for (auto& r : markers) cout << r << "\n";
    }
};



int main() {
    #ifdef LOCAL_JUDGE
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    #endif

    cin >> t; while (t--) {
        size_t r, c; cin >> r >> c;
        State s(r, c);

        char last_x_move = '\0';
        char last_y_move = '\0';
        bool done_first = false;
        bool last_y = false;

        string moves; cin >> moves;
        if (moves.find('U') != string::npos && moves.find('D') != string::npos && s.has_nondefault_marker) {
            char last = moves[0];
            for (auto& dir : moves) {
                if ((last=='D'||last=='U') ^ (dir=='D'||dir=='U')) {
                    s.move(last);
                }
                last = dir;
            }
            s.move(last);
            s.show();
            continue;
        }

        for (auto& dir : moves) {
            if (dir == 'L' || dir == 'R') {
                last_x_move = dir;
                last_y = false;
                if (last_y_move && !done_first) {
                    // last_x_move was NUL
                    s.move(last_y_move);
                    s.move(last_x_move);
                    done_first = true;
                }
            } else {
                last_y_move = dir;
                last_y = true;
                if (last_x_move && !done_first) {
                    s.move(last_x_move);
                    s.move(last_y_move);
                    done_first = true;
                }
            }
        }
        if (last_y) {
            s.move(last_x_move);  // it's safe to call even with NUL char
            s.move(last_y_move);
        } else {
            s.move(last_y_move);
            s.move(last_x_move);
        }

        s.show();
    }

    return 0;
}
