#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;

size_t t, n, xa, ya, xb, yb;

const auto SEG_NEW = 2;
const auto SEG_DEL = 1;
using seg_event = tuple<size_t, size_t, size_t, size_t>;

map<ps, ps> stat;
vector<seg_event> events;
map<size_t, size_t> opens, closes;

int main() {
    #ifdef LOCAL_JUDGE
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    #endif

    cin >> t; while (t--) {
        cin >> n; events.clear(); events.reserve(2 * n);

        while (n--) {
            cin >> xa >> ya >> xb >> yb;
            events.emplace_back(yb, SEG_NEW, xa, xb + 1);
            events.emplace_back(ya - 1, SEG_DEL, xa, xb + 1);
        }

        sort(events.rbegin(), events.rend());
        stat.clear(); opens.clear(); closes.clear();

        map<ps, size_t> existing_lines;  // [xa; xb] -> y start

        for (auto& [yc, t, xa, xb] : events) {
            if (t == SEG_NEW) {
                opens[xa]++; closes[xb]++;
            } else {
                if (--opens[xa] == 0) opens.erase(xa);
                if (--closes[xb] == 0) closes.erase(xb);
            }

            size_t xc = -1;
            size_t depth = 0;
            set<ps> cur_lines;

            auto ito = opens.begin();
            auto itc = closes.begin();
            while (ito != opens.end()) {
                if (ito->first <= itc->first) {
                    if (depth == 0) xc = ito->first;
                    depth += ito->second;
                    ito++;
                } else {
                    if ((depth -= itc->second) == 0) {
                        // we've got segment [xc; itc->first)
                        cur_lines.emplace(xc, itc->first); xc = -1;
                    }
                    itc++;
                }
            }

            if (depth) cur_lines.emplace(xc, closes.rbegin()->first);

            auto it = existing_lines.begin();
            while (it != existing_lines.end()) {
                if (!cur_lines.erase(it->first)) {
                    auto& record = stat[it->first];
                    auto yb = it->second;
                    record.first += yb - yc;
                    record.second = max(record.second, yb - yc);
                    it = existing_lines.erase(it);
                } else {
                    it++;
                }
            }
            for (auto& new_seg : cur_lines)
                existing_lines[new_seg] = yc;
        }

        cout << stat.size() << "\n";
        for (auto& [k,v] : stat) {
            cout << k.first << " " << k.second - 1 << " " << v.first << " " << v.second << "\n";
        }
    }

    return 0;
}
