// ConsoleApplication2.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <string>
using namespace std;
const long long inf = 2e18;
struct segment_tree {
	vector<long long> arr;
	vector<long long> lazy;
	int ext_size;
	segment_tree(int sz) {
		ext_size = 1;
		while (ext_size < sz)
			ext_size *= 2;
		arr.assign(ext_size * 2, inf);
		lazy.assign(ext_size * 2, 0);
	}
	void push(int node) {
		arr[node * 2] += lazy[node];
		lazy[node * 2] += lazy[node];
		arr[node * 2 + 1] += lazy[node];
		lazy[node * 2 + 1] += lazy[node];
		lazy[node] = 0;
	}
	void set(int pos, long long x, int node, int node_l, int node_r) {
		if (pos > node_r || pos < node_l)
			return;
		if (pos == node_l && pos == node_r) {
			arr[node] = x;
			return;
		}
		push(node);
		int mid = (node_l + node_r) / 2;
		set(pos, x, node * 2, node_l, mid);
		set(pos, x, node * 2 + 1, mid + 1, node_r);
		arr[node] = min(arr[node * 2], arr[node * 2 + 1]);
	}
	void set(int pos, long long x) {
		set(pos, x, 1, 0, ext_size - 1);
	}
	void add(int l, int r, long long x, int node, int node_l, int node_r) {
		if (l > node_r || r < node_l)
			return;
		if (l <= node_l && node_r <= r) {
			arr[node] += x;
			lazy[node] += x;
			return;
		}
		push(node);
		int mid = (node_l + node_r) / 2;
		add(l, r, x, node * 2, node_l, mid);
		add(l, r, x, node * 2 + 1, mid + 1, node_r);
		arr[node] = min(arr[node * 2], arr[node * 2 + 1]);
	}
	void add(int l, int r, long long x) {
		add(l, r, x, 1, 0, ext_size - 1);
	}

	long long get(int l, int r, int node, int node_l, int node_r) {
		if (l > node_r || r < node_l)
			return inf;
		if (l <= node_l && node_r <= r) {
			return arr[node];
		}
		push(node);
		int mid = (node_l + node_r) / 2;
		return min(
			get(l, r, node * 2, node_l, mid),
			get(l, r, node * 2 + 1, mid + 1, node_r));
	}
	long long get(int l, int r) {
		return get(l, r, 1, 0, ext_size - 1);
	}
};
void solve()
{
	int n, m, k, p, c;
	cin >> n >> m >> k >> p >> c;
	int unknown = m;
	int empty = 0;
	vector<int> drinks(k, 0);
	long long result = 0;
	int pos = 0;

	int offset = 0;
	segment_tree tree(m + n + 3);
	tree.set(m, 0);
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		a--;
		long long t = tree.get(offset, offset + m);
		long long dist = inf;
		if (c & 1)
			dist = min(dist, n + 1LL - i + n + 1 - i - 1);
		if (c & 2)
			dist = min(dist, i + 1LL + i);
		dist--;
		t += dist;
		long long old = tree.get(offset + empty + unknown, offset + empty + unknown);
		if (t < old)
			tree.set(offset + empty + unknown, t);
		if (drinks[a]) {
			drinks[a]--;
			if (drinks[a] % p == 0)
				empty++;
			tree.add(offset, offset + m, 1);
		}
		else {
			unknown--;
			drinks[a] += p - 1;
			if (drinks[a] % p == 0)
				empty++;
			offset++;
			tree.add(offset, offset + m, 1);
		}
	}
	cout << tree.get(offset, offset + m) + 1 << '\n';
}
int main() {
	int t;
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	t = 1;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
