// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
int fenwick[5005][5005];
void add(int x, int y, int d) {
	for (int i = x; i < 5005; i = i | (i+1))
	{
		for (int j = y; j < 5005; j = j | (j+1))
		{
			fenwick[i][j] += d;
		}
	}
}
int query(int x, int y) {
	int result = 0;
	for (int i = x; i >= 0; i = (i & (i+1)) -1)
	{
		for (int j = y; j >= 0; j = (j & (j+1)) -1)
		{
			result += fenwick[i][j];
		}
	}
	return result;
}
void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		add(x1, y1, 1);
		add(x2 + 1, y2 + 1, 1);
		add(x2 + 1, y1, -1);
		add(x1, y2 + 1, -1);
	}

	map<pair<int, int>, int> fcnt;
	map<pair<int, int>, int> mx;
	map<pair<int, int>, int> cur;
	for (int i = 1; i <= 5004; i++)
	{
		map<pair<int, int>, int> new_cur;
		int old_x = -1;
		for (int j = 1; j <= 5004; j++) {
			int cnt = query(j, i);
			if (cnt > 0 && old_x == -1) {
				old_x = j;
				continue;
			}
			if (cnt == 0 && old_x != -1) {
				pair<int, int> key = { old_x, j - 1 };
				new_cur[key] = cur[key] + 1;
				mx[key] = max(mx[key], new_cur[key]);
				fcnt[key]++;
				old_x = -1;
			}
		}
		swap(cur, new_cur);
	}
	cout << mx.size() << '\n';
	for (auto [k, val] : mx) {
		cout << k.first << ' ' << k.second << ' ' << fcnt[k] << ' ' << val << '\n';
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
}
// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
