#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

bool intersection_major(int a1,int a2,int b1,int b2){
    return (a1<=b1&&b1<=a2)||(a1<=b2&&b2<=a2)||(b1<=a1&&a1<=b2)||(b1<=a2&&a2<=b2);
}
bool intersection_minor(int a1,int a2,int b1,int b2){
    return (a1<=b1&&b1<a2)||(a1<b2&&b2<=a2)||(b1<=a1&&a1<b2)||(b1<a2&&a2<=b2);
}
bool inside_major(int a1,int a2,int b1,int b2){
    return a1<=b1&&b2<=a2;
}

struct rect{
    int xl, yl, xr, yr;
    rect(int a,int b,int c,int d){
        xl=a;
        yl=b;
        xr=c;
        yr=d;
    }
    bool operator==(rect r){
        return xl==r.xl&&yl==r.yl&&xr==r.xr&&yr==r.yr;
    }
    void operator=(rect r){
        xl=r.xl;
        yl=r.yl;
        xr=r.xr;
        yr=r.yr;
    }
};

int main()
{
    rect R0=rect(0,0,0,0);
    int t, n, xl, yl, xr, yr, x;
    cin >> t;
    while(t-->0){
        cin >> n;
        vector<rect> rects;
        while(n-->0){
            cin >> xl >> yl >> xr >> yr;
            xl--;
            yl--;
            queue<int> q;
            q.push(rects.size());
            rects.push_back(rect(xl,yl,xr,yr));
            while(!q.empty()){
                x = q.front();
                q.pop();
                for(int i=0;i<x;i++){
                    if(rects[i]==R0)continue;
                    if(intersection_major(rects[x].xl,rects[x].xr,rects[i].xl,rects[i].xr)){
                        if(intersection_minor(rects[x].yl,rects[x].yr,rects[i].yl,rects[i].yr)){
                            if(inside_major(rects[x].xl,rects[x].xr,rects[i].xl,rects[i].xr)){
                                if(inside_major(rects[x].yl,rects[x].yr,rects[i].yl,rects[i].yr)){
                                    rects[i]=R0;
                                    continue;
                                }
                            }
                            if(inside_major(rects[i].xl,rects[i].xr,rects[x].xl,rects[x].xr)){
                                if(inside_major(rects[i].yl,rects[i].yr,rects[x].yl,rects[x].yr)){
                                    rects[x]=R0;
                                    break;
                                }
                            }
                            if(rects[i].yl<rects[x].yl&&rects[x].yl<rects[i].yr&&rects[i].yr<rects[x].yr){
                                q.push(rects.size());
                                rect rnew=R0;
                                rnew.xl = min(rects[x].xl,rects[i].xl);
                                rnew.xr = max(rects[x].xr,rects[i].xr);
                                rnew.yl = rects[x].yl;
                                rnew.yr = rects[i].yr;
                                rects[i].yr = rnew.yl;
                                rects[x].yl = rnew.yr;
                                rects.push_back(rnew);
                            }
                            else if(rects[x].yl<rects[i].yl&&rects[i].yl<rects[x].yr&&rects[x].yr<rects[i].yr){
                                q.push(rects.size());
                                rect rnew=R0;
                                rnew.xl = min(rects[x].xl,rects[i].xl);
                                rnew.xr = max(rects[x].xr,rects[i].xr);
                                rnew.yl = rects[i].yl;
                                rnew.yr = rects[x].yr;
                                rects[x].yr = rnew.yl;
                                rects[i].yl = rnew.yr;
                                rects.push_back(rnew);
                            }
                            else if(inside_major(rects[i].yl,rects[i].yr,rects[x].yl,rects[x].yr)){
                                rect rnew=rects[i];
                                rects[x].xl = min(rects[x].xl,rects[i].xl);
                                rects[x].xr = max(rects[x].xr,rects[i].xr);
                                rects[i].yl = rects[x].yr;
                                rnew.yr = rects[x].yl;
                                if(rects[i].yl==rects[i].yr)rects[i]=R0;
                                if(rnew.yl<rnew.yr){
                                    q.push(rects.size());
                                    rects.push_back(rnew);
                                }
                            }
                            else if(inside_major(rects[x].yl,rects[x].yr,rects[i].yl,rects[i].yr)){
                                rect rnew=rects[x];
                                rects[i].xl = min(rects[x].xl,rects[i].xl);
                                rects[i].xr = max(rects[x].xr,rects[i].xr);
                                rects[x].yl = rects[i].yr;
                                rnew.yr = rects[i].yl;
                                if(rnew.yl<rnew.yr){
                                    q.push(rects.size());
                                    rects.push_back(rnew);
                                }
                                if(rects[x].yl==rects[x].yr){
                                    rects[x]=R0;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
        map<pair<int,int>,set<int>> starts;
        map<pair<int,int>,set<int>> ends;
        for(auto it=rects.begin();it!=rects.end();it++){
            if(*it==R0)continue;
            pair<int,int> p={it->xl,it->xr};
            if(starts[p].count(it->yr)==1&&ends[p].count(it->yl)==1){
                starts[p].erase(it->yr);
                ends[p].erase(it->yl);
            }
            else if(starts[p].count(it->yr)==1){
                starts[p].erase(it->yr);
                starts[p].insert(it->yl);
            }
            else if(ends[p].count(it->yl)==1){
                ends[p].erase(it->yl);
                ends[p].insert(it->yr);
            }
            else{
                starts[p].insert(it->yl);
                ends[p].insert(it->yr);
            }
        }
        cout << starts.size() << endl;
        for(auto it=starts.begin();it!=starts.end();it++){
            pair<int,int> p=it->first;
            cout << p.first+1 << " " << p.second << " ";
            auto xt=starts[p].begin();
            auto yt=ends[p].begin();
            long long total=0, high=0;
            for(int i=0;i<starts[p].size();i++){
                int d=*yt-*xt;
                total+=d;
                if(high<d)high=d;
                xt++;
                yt++;
            }
            cout << total << " " << high << endl;
        }
    }
    return 0;
}
