#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#define int long long

using namespace std;

void left(int n, int m, vector<string> & a) {
    for (int x = 0; x < n; ++x) {
        int cur = 0;
        for (int y = 0; y < m; ++y) {
            if (a[x][y] != '.') {
                a[x][cur] = a[x][y];
                if (cur != y) {
                    a[x][y] = '.';
                }
                cur++;
            }
        }
    }
}

void right(int n, int m, vector<string> &a) {
    for (int x = 0; x < n; ++x) {
        int cur = m - 1;
        for (int y = m - 1; y >= 0; --y) {
            if (a[x][y] != '.') {
                a[x][cur] = a[x][y];
                if (cur != y) {
                    a[x][y] = '.';
                }
                cur--;
            }
        }
    }
}

void up(int n, int m, vector<string> &a) {
    for (int y = 0; y < m; ++y) {
        int cur = 0;
        for (int x = 0; x < n; ++x) {
            if (a[x][y] != '.') {
                a[cur][y] = a[x][y];
                if (cur != x) {
                    a[x][y] = '.';
                }
                cur++;
            }
        }
    }
}

void down(int n, int m, vector<string> & a) {
    for (int y = 0; y < m; ++y) {
        int cur = n - 1;
        for (int x = n - 1; x >= 0; --x) {
            if (a[x][y] != '.') {
                a[cur][y] = a[x][y];
                if (cur != x) {
                    a[x][y] = '.';
                }
                cur--;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<string> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        string s;
        cin >> s;
        bool pl = false, pr = false, pu = false, pd = false;
        bool l = false, r = false, u = false, d = false;
        int i = 0;
        while (i < (int)s.size() && (!l && !r) || (!u && !d)) {
            pl = l;
            pr = r;
            pu = u;
            pd = d;
            if (s[i] == 'L') {
                l = true;
                r = false;
            } else if (s[i] == 'R') {
                r = true;
                l = false;
            } else if (s[i] == 'U') {
                u = true;
                d = false;
            } else {
                d = true;
                u = false;
            }
            i++;
        }
        if ((l || r) && (u || d)) {
            i--;
            l = pl;
            r = pr;
            u = pu;
            d = pd;
        }
        if (u) {
            up(n, m, a);
        } else if (d) {
            down(n, m, a);
        } else if (l) {
            left(n, m, a);
        } else {
            right(n, m, a);
        }
        if (i != (int)s.size()) {
            if (s[i] == 'U') {
                up(n, m, a);
            } else if (s[i] == 'D') {
                down(n, m, a);
            } else if (s[i] == 'L') {
                left(n, m, a);
            } else {
                right(n, m, a);
            }
            i++;
           while (i < (int)s.size()) {
               if (s[i] == 'L') {
                   l = true;
                   r = false;
               } else if (s[i] == 'R') {
                   r = true;
                   l = false;
               } else if (s[i] == 'U') {
                   u = true;
                   d = false;
               } else {
                   d = true;
                   u = false;
               }
               i++;
           }
           if (l) {
               left(n, m, a);
           } else if (r) {
               right(n, m, a);
           }
           if (u) {
               up(n, m, a);
           } else if (d) {
               down(n, m, a);
           }
        }
        for (int qw = 0; qw < n; ++qw) {
            cout << a[qw] << endl;
        }
    }
    return 0;
}
