#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <limits.h>
#include <map>
using namespace std;

#define int long long

void solveg1(vector<string>& v, const string& c)
{
	for (auto& cmd : c)
	{
		vector<string> buff = v;
		for (auto& i : buff)
			for (auto& j : i)
				j = '.';
		if (cmd == 'L')
		{
			vector<int> d(v.size(), 0);
			for (int i = 0; i < v.size(); i++)
			{
				for (int j = 0; j < v[i].size(); j++)
				{
					if (v[i][j] == '.')
						continue;
					buff[i][d[i]++] = v[i][j];
				}
			}
		}
		if (cmd == 'R')
		{
			vector<int> d(v.size(), v[0].size() - 1);
			for (int i = 0; i < v.size(); i++)
			{
				for (int j = v[i].size() - 1; j >= 0; j--)
				{
					if (v[i][j] == '.')
						continue;
					buff[i][d[i]--] = v[i][j];
				}
			}
		}
		if (cmd == 'U')
		{
			vector<int> d(v[0].size(), 0);
			for (int j = 0; j < v[0].size(); j++)
			{
				for (int i = 0; i < v.size(); i++)
				{
					if (v[i][j] == '.')
						continue;
					buff[d[j]++][j] = v[i][j];
				}
			}
		}
		if (cmd == 'D')
		{
			vector<int> d(v[0].size(), v.size() - 1);
			for (int j = 0; j < v[0].size(); j++)
			{
				for (int i = v.size() - 1; i >= 0; i--)
				{
					if (v[i][j] == '.')
						continue;
					buff[d[j]--][j] = v[i][j];
				}
			}
		}
		swap(v, buff);
	}
}

void solveg2(vector<string>& v, const string& c)
{
	if (c.size() == 0)
		return;
	if (c.back() == 'R')
		solveg1(v, "R");
	else
		solveg1(v, "L");
}
void solveg3(vector<string>& v, const string& c)
{
	if (c.size() == 1 && c.back() == 'U')
	{
		solveg1(v, c);
		return;
	}
	string bu, au;
	bool flag = false;
	for (auto& i : c)
	{
		if (i == 'U')
		{
			flag = true;
			continue;
		}
		if (flag)
			au.push_back(i);
		else
			bu.push_back(i);

	}
	solveg2(v, bu);
	solveg1(v, "U");
	solveg2(v, au);
}

void solve()
{
	int sizex, sizey;
	cin >> sizex >> sizey;
	vector<string> v(sizex);
	for (auto& i : v)
		cin >> i;
	string c;
	cin >> c;
	string actualc;
	c.push_back('#');
	for (int i = 0; i < c.size() - 1; i++)
		if (c[i] != c[i + 1])
			actualc.push_back(c[i]);
	swap(c, actualc);
	map<char, int> cnt;
	for (auto& i : c)
		cnt[i]++;
	if (sizex * sizey * c.size() <= 1e7)
		solveg1(v, c);
	else if (cnt['U'] == 0 && cnt['D'] == 0)
		solveg2(v, c);
	else if (cnt['D'] == 0)
		solveg3(v, c);
	for (auto& i : v)
		cout << i << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}