#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <limits.h>
#include <map>
#include <unordered_map>
using namespace std;

#define int long long

void solveg1(vector<string>& v, const string& c)
{
	for (auto& cmd : c)
	{
		vector<string> buff = v;
		for (auto& i : buff)
			for (auto& j : i)
				j = '.';
		if (cmd == 'L')
		{
			vector<int> d(v.size(), 0);
			for (int i = 0; i < v.size(); i++)
			{
				for (int j = 0; j < v[i].size(); j++)
				{
					if (v[i][j] == '.')
						continue;
					buff[i][d[i]++] = v[i][j];
				}
			}
		}
		if (cmd == 'R')
		{
			vector<int> d(v.size(), v[0].size() - 1);
			for (int i = 0; i < v.size(); i++)
			{
				for (int j = v[i].size() - 1; j >= 0; j--)
				{
					if (v[i][j] == '.')
						continue;
					buff[i][d[i]--] = v[i][j];
				}
			}
		}
		if (cmd == 'U')
		{
			vector<int> d(v[0].size(), 0);
			for (int j = 0; j < v[0].size(); j++)
			{
				for (int i = 0; i < v.size(); i++)
				{
					if (v[i][j] == '.')
						continue;
					buff[d[j]++][j] = v[i][j];
				}
			}
		}
		if (cmd == 'D')
		{
			vector<int> d(v[0].size(), v.size() - 1);
			for (int j = 0; j < v[0].size(); j++)
			{
				for (int i = v.size() - 1; i >= 0; i--)
				{
					if (v[i][j] == '.')
						continue;
					buff[d[j]--][j] = v[i][j];
				}
			}
		}
		swap(v, buff);
	}
}

void solveg2(vector<string>& v, const string& c)
{
	if (c.size() == 0)
		return;
	if (c.back() == 'R')
		solveg1(v, "R");
	else
		solveg1(v, "L");
}
void solveg3(vector<string>& v, const string& c)
{
	if (c.size() == 1 && c.back() == 'U')
	{
		solveg1(v, c);
		return;
	}
	string bu, au;
	bool flag = false;
	for (auto& i : c)
	{
		if (i == 'U')
		{
			flag = true;
			continue;
		}
		if (flag)
			au.push_back(i);
		else
			bu.push_back(i);

	}
	solveg2(v, bu);
	solveg1(v, "U");
	solveg2(v, au);
}

void solvenoU(vector<string>& v, const string& c)
{
	if (c.size() == 1 && c.back() == 'D')
	{
		solveg1(v, c);
		return;
	}
	string bu, au;
	bool flag = false;
	for (auto& i : c)
	{
		if (i == 'D')
		{
			flag = true;
			continue;
		}
		if (flag)
			au.push_back(i);
		else
			bu.push_back(i);

	}
	solveg2(v, bu);
	solveg1(v, "D");
	solveg2(v, au);
}

void out(vector<string>& v)
{
	for (auto& i : v)
		cout << i << '\n';
}

void solvenoLR(vector<string>& v, const string& c)
{
	if (c.size() == 0)
		return;
	if (c.back() == 'U')
		solveg1(v, "U");
	else
		solveg1(v, "D");
}

void solvestairs(vector<string>& v, const string& c)
{
	auto lu = v, ld = v, ru = v, rd = v;
	solveg1(lu, "U");
	solveg1(ru, "UR");
	solveg1(rd, "R");
	int x = 0, y = 0;
	for (auto& i : c)
	{
		if (i == 'U')
			y = min(y + 1, 1ll);
		if (i == 'D')
			y = max(y - 1, 0ll);
		if (i == 'L')
			x = max(x - 1, 0ll);
		if (i == 'R')
			x = min(x + 1, 1ll);
	}
	if (x == 0 && y == 0)
		out(ld);
	else if (x == 0 && y == 1)
		out(lu);
	else if (x == 1 && y == 0)
		out(rd);
	else if (x == 1 && y == 1)
		out(ru);

}

void solveonlyA(vector<string>& v, string& c)
{
	bool ux = false, uy = false;
	reverse(begin(c), end(c));
	string cfirst;
	while (true)
	{
		char u = c.back();
		if (u == 'L' || u == 'R')
		{
			ux = true;
			if (uy == true)
				break;
		}
		else
		{
			uy = true;
			if (ux == true)
				break;
		}
		cfirst.push_back(u);
		c.pop_back();
	}
	if (cfirst[0] == 'U' || cfirst[0] == 'D')
		solvenoLR(v, cfirst);
	else
		solveg2(v, cfirst);
	string bufasdf;
	bufasdf.push_back(c.back());
	solveg1(v, bufasdf);
	int x = 0, y = 0;
	if (c.back() == 'U')
		y = 1;
	else if (c.back() == 'D')
		y = 0;
	else if (c.back() == 'L')
		x = 0;
	else if (c.back() == 'R')
		x = 1;
	if (cfirst.back() == 'L')
		x = 0;
	else if (cfirst.back() == 'R')
		x = 1;
	else if (cfirst.back() == 'U')
		y = 1;
	else if (cfirst.back() == 'D')
		y = 0;
	c.pop_back();
	int startx = x, starty = y;
	vector<int> d(v.size());
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
		{
			if (v[i][j] != '.')
				d[i]++;
		}
	}
	while (c.size())
	{
		if (c.back() == 'L')
			x = max(x - 1, 0ll);
		if (c.back() == 'R')
			x = min(x + 1, 1ll);
		if (c.back() == 'U')
			y = min(y + 1, 1ll);
		if (c.back() == 'D')
			y = max(y - 1, 0ll);
		c.pop_back();
	}
	for (int i = 0; i < v.size(); i++)
	{
		if (x == startx)
		{
			for (int j = 0; j < v[i].size(); j++)
			{
				if (y == starty)
					cout << v[i][j];
				else
					cout << v[v.size() - 1 - i][j];
			}
			cout << '\n';
		}
		else
		{
			for (int j = v[i].size() - 1; j >= 0; j--)
			{
					if (y == starty)
						cout << v[i][j];
					else
						cout << v[v.size() - 1 - i][j];
			}
			cout << '\n';
		}
	}
}

bool onlyone(vector<string>& v)
{
	unordered_map<char, int> m;
	for (auto& i : v)
		for (auto& j : i)
			if (j != '.')
				m[j]++;
	return m.size() == 1;
}

void solve()
{
	int sizex, sizey;
	cin >> sizex >> sizey;
	vector<string> v(sizex);
	for (auto& i : v)
		cin >> i;
	string c;
	cin >> c;
	string actualc;
	c.push_back('#');
	for (int i = 0; i < c.size() - 1; i++)
		if (c[i] != c[i + 1])
			actualc.push_back(c[i]);
	swap(c, actualc);
	map<char, int> cnt;
	for (auto& i : c)
		cnt[i]++;
	
	if (sizex * sizey * c.size() <= 1e7)
		solveg1(v, c);
	else if (cnt['U'] == 0 && cnt['D'] == 0)
		solveg2(v, c);
	else if (cnt['L'] == 0 && cnt['R'] == 0)
		solvenoLR(v, c);
	else if (cnt['D'] == 0)
		solveg3(v, c);
	else if (cnt['U'] == 0)
		solvenoU(v, c);
	else if (onlyone(v))
	{
		solveonlyA(v, c);
		return;
	}
	for (auto& i : v)
		cout << i << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}