#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>


#define int long long 
using namespace std;

struct Event
{
	int x;
	bool closed;
	int yl, yr;
	bool operator<(const Event& e) const
	{
		return x < e.x || (x == e.x && closed < e.closed);
	}
	Event(int a, bool b, int l, int r) : x(a), closed(b), yl(l), yr(r) {}
};

void solve()
{
	int size;
	cin >> size;
	vector<pair<pair<int, int>, pair<int, int>>> v(size);
	for (auto& i : v)
		cin >> i.first.first >> i.first.second >> i.second.first >> i.second.second;
	vector<Event> e;
	

	sort(begin(e), end(e));

	set<int> comp;
	comp.insert(-1);
	for (auto& i : v)
	{
		comp.insert(i.first.second - 1);
		comp.insert(i.second.second);
	}
	
	vector<int> unc;
	unordered_map<int, int> c;
	for (auto& i : comp)
	{
		c[i] = unc.size();
		unc.push_back(i);
	}

	for (auto& i : v)
	{
		i.first.second = c[i.first.second];
		i.second.second = c[i.second.second];
	}
	for (auto& i : v)
	{
		e.push_back(Event(i.first.first - 1, false, i.first.second, i.second.second));
		e.push_back(Event(i.second.first, true, i.first.second, i.second.second));
	}
	sort(begin(e), end(e));
	vector<pair<int, int>> state(comp.size() + 10, { 0, -1 });
	map<pair<int, int>, int> cnt;
	for (auto& i : e)
	{
		if (i.closed == false)
		{
			for (int j = i.yl; j <= i.yr; j++)
			{
				state[j].first++;
				if (state[j].second == -1)
					state[j].second = i.x;
			}
		}
		else
		{
			for (int j = i.yl; j <= i.yr; j++)
			{
				state[j].first--;
				if (state[j].first == 0)
				{
					cnt[{state[j].second, i.x - 1}]++;
					state[j].second = -1;
				}
			}
		}
	}
	for (auto& i : cnt)
	{
		cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second << ' ' << 0 << '\n';
	}
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}