#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
using namespace std;

int n, m;
vector<vector<char>> mat;

void u() {
    for (int j = 0; j < m; j++) {
        vector<char> b;
        for (int i = 0; i < n; i++) {
            if (mat[i][j] != '.')
                b.push_back(mat[i][j]);
        }
        int id = 0;
        for (int i = 0; i < n; i++) {
            if (id < b.size()) {
                mat[i][j] = b[id];
                id++;
            } else
                mat[i][j] = '.';
        }
    }
}

void d() {
    for (int j = 0; j < m; j++) {
        vector<char> b;
        for (int i = n - 1; i >= 0; i--) {
            if (mat[i][j] != '.')
                b.push_back(mat[i][j]);
        }
        int id = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (id < b.size()) {
                mat[i][j] = b[id];
                id++;
            } else
                mat[i][j] = '.';
        }
    }
}

void l() {
    for (int i = 0; i < n; i++) {
        vector<char> b;
        for (int j = 0; j < m; j++) {
            if (mat[i][j] != '.')
                b.push_back(mat[i][j]);
        }
        int id = 0;
        for (int j = 0; j < m; j++) {
            if (id < b.size()) {
                mat[i][j] = b[id];
                id++;
            } else
                mat[i][j] = '.';
        }
    }
}

void r() {
    for (int i = 0; i < n; i++) {
        vector<char> b;
        for (int j = m - 1; j >= 0; j--) {
            if (mat[i][j] != '.')
                b.push_back(mat[i][j]);
        }
        int id = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (id < b.size()) {
                mat[i][j] = b[id];
                id++;
            } else
                mat[i][j] = '.';
        }
    }
}

void solve() {
    mat.clear();
    string str;
    cin >> n >> m;
    map<char, int> f;
    f['U'] = 0;
    f['D'] = 1;
    f['L'] = 2;
    f['R'] = 3;
    mat.resize(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        cin >> str;
        for (int j = 0; j < m; j++)
            mat[i][j] = str[j];
    }
    cin >> str;
    int id = 0;
    vector<int> fr(4, -1);
    vector<int> ls(4, -1);
    for (char c : str) {
        if (fr[f[c]] == -1)
            fr[f[c]] = id;
        ls[f[c]] = id;
        id++;
    }
    vector<pair<int, int>> a(4);
    for (int i = 0; i < 4; i++)
        a[i] = {fr[i], i};
    vector<pair<int, int>> b(4);
    for (int i = 0; i < 4; i++)
        b[i] = {ls[i], i};
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    for (int i = 0; i < 4; i++) {
        auto [x, y] = a[i];
        if (x != -1) {
            if (y == 0)
                u();
            if (y == 1)
                d();
            if (y == 2)
                l();
            if (y == 3)
                r();
        }
    }
    for (int i = 0; i < 4; i++) {
        auto [x, y] = b[i];
        if (x != -1) {
            if (y == 0)
                u();
            if (y == 1)
                d();
            if (y == 2)
                l();
            if (y == 3)
                r();
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cout << mat[i][j];
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
