#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace  std;
using ll = long long;

int type = 1;

const int INF = INT_MAX;

vector<vector<char>> Left(vector<vector<char>> &field) {
    int n = (int)field.size();
    int m = (int)field[0].size();
    vector<vector<char>> nf(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < m; j++) {
            if (field[i][j] != '.') nf[i][cnt++] = field[i][j];
        }
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') nf[i][cnt++] = field[i][j];
        }
    }
    return nf;
}

vector<vector<char>> Right(vector<vector<char>> &field) {
    int n = (int)field.size();
    int m = (int)field[0].size();
    vector<vector<char>> nf(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') nf[i][cnt++] = field[i][j];
        }
        for (int j = 0; j < m; j++) {
            if (field[i][j] != '.') nf[i][cnt++] = field[i][j];
        }
    }
    return nf;
}

vector<vector<char>> Up(vector<vector<char>> &field) {
    int n = (int)field.size();
    int m = (int)field[0].size();
    vector<vector<char>> finField(n, vector<char>(m));
    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (field[i][j] != '.') finField[cnt++][j] = field[i][j];
        }
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '.') finField[cnt++][j] = field[i][j];
        }
    }
    return finField;
}

vector<vector<char>> Down(vector<vector<char>> &field) {
    int n = (int)field.size();
    int m = (int)field[0].size();
    vector<vector<char>> finField(n, vector<char>(m));
    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '.') finField[cnt++][j] = field[i][j];
        }
        for (int i = 0; i < n; i++) {
            if (field[i][j] != '.') finField[cnt++][j] = field[i][j];
        }
    }
    return finField;
}

void act(vector<vector<char>> &field, char c) {
    if (c == 'L') {
        field = Left(field);
    } else if (c == 'R'){
        field = Right(field);
    } else if (c == 'U') {
        field = Up(field);
    } else {
        field = Down(field);
    }
}

void solve(int att) {
    int n,m;
    cin >> n >> m;
    vector<vector<char>> field(n, vector<char>(m));
    vector<int> cnt(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
        }
    }
    string s;
    cin >> s;
    int len = s.size();
    int mask = 0;
    for (int i = 0; i < len; i++) {
        if (s[i] == 'U' || s[i] == 'D') mask |= 1;
        else mask |= 2;
    }
    if (mask != 3) {  // типо чего-то нет, то мы просто делаем
        act(field, s.back());
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << field[i][j];
            }
            cout << "\n";
        }
    } else {  // если оба есть, находим последние
        char hor, vert;
        mask = 0;
        int por = 0;
        for (int i = 0; i < len; i++) {
            if (s[i] == 'L' || s[i] == 'R') hor = s[i], mask |= 1;
            else vert = s[i], mask |= 2;
            if (mask == 1) {  // первым был горизонт
                por = 1;
            }
            if (mask == 2) {
                por = 2;
            }
            if (mask == 3) break;  // всё нашли
        }
        if (por == 2) swap(hor, vert);
        act(field, hor);
        act(field, vert);
        mask = 0;
        hor = 'U', vert = 'L';
        for (int i = len - 1; i >= 0; i--) {
            if (s[i] == 'L' || s[i] == 'R') {
                if (hor == 'U') hor = s[i], mask |= 1;
            }
            else {
                if (vert == 'L') vert = s[i], mask |= 2;
            }
            if (mask == 1) {  // первым был горизонт
                por = 1;
            }
            if (mask == 2) {
                por = 2;
            }
            if (mask == 3) break;  // всё нашли
        }
        if (por == 1) swap(hor, vert);
        act(field, hor);
        act(field, vert);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << field[i][j];
            }
            cout << "\n";
        }
    }
}

int main() {
    cin.tie(0)->ios::sync_with_stdio(false);
    int nT = 1;
    if (type) cin >> nT;
    for (int t = 1; t <= nT; t++) {
        solve(t);
        if (nT - t) cout << "\n";
    }
    return 0;
}