#pragma GCC optimize("O3,unroll-loops")

// #define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int LOG = 21;

int n, m;
vector<string> board, new_board;
vector<vector<int>> ind_board;
vector<vector<int>> bin_up;
string reqs;

void print_board(vector<string> &b) {
    for (int i = 0; i < n; i++) {
        cout << b[i] << '\n';
    }
}

void print_board(vector<vector<int>> &b) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << b[i][j] << ' ';
        }
        cout << '\n';
    }
}

vector<int> _move_ind;
void move_board(vector<string> &b, char dir) {
    char tmp;
    if (dir == 'L') {
        for (int i = 0; i < n; i++) {
            for (int j = 0, t = 0; j < m; j++) {
                if (b[i][j] != '.') {
                    tmp = b[i][j];
                    b[i][j] = '.';
                    b[i][t] = tmp;
                    t++;
                }
            }
        }
    } else if (dir == 'R') {
        for (int i = 0; i < n; i++) {
            for (int j = m - 1, t = m - 1; j >= 0; j--) {
                if (b[i][j] != '.') {
                    tmp = b[i][j];
                    b[i][j] = '.';
                    b[i][t] = tmp;
                    t--;
                }
            }
        }
    } else if (dir == 'U') {
        _move_ind.assign(m, 0);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (b[i][j] != '.') {
                    tmp = b[i][j];
                    b[i][j] = '.';
                    b[_move_ind[j]][j] = tmp;
                    _move_ind[j]++;
                }
            }
        }
    } else {
        _move_ind.assign(m, n - 1);
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < m; j++) {
                if (b[i][j] != '.') {
                    tmp = b[i][j];
                    b[i][j] = '.';
                    b[_move_ind[j]][j] = tmp;
                    _move_ind[j]--;
                }
            }
        }
    }
}

void move_board(vector<vector<int>> &b, char dir) {
    int tmp;
    if (dir == 'L') {
        for (int i = 0; i < n; i++) {
            for (int j = 0, t = 0; j < m; j++) {
                if (b[i][j] != -1) {
                    tmp = b[i][j];
                    b[i][j] = -1;
                    b[i][t] = tmp;
                    t++;
                }
            }
        }
    } else if (dir == 'R') {
        for (int i = 0; i < n; i++) {
            for (int j = m - 1, t = m - 1; j >= 0; j--) {
                if (b[i][j] != -1) {
                    tmp = b[i][j];
                    b[i][j] = -1;
                    b[i][t] = tmp;
                    t--;
                }
            }
        }
    } else if (dir == 'U') {
        _move_ind.assign(m, 0);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (b[i][j] != -1) {
                    tmp = b[i][j];
                    b[i][j] = -1;
                    b[_move_ind[j]][j] = tmp;
                    _move_ind[j]++;
                }
            }
        }
    } else {
        _move_ind.assign(m, n - 1);
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < m; j++) {
                if (b[i][j] != -1) {
                    tmp = b[i][j];
                    b[i][j] = -1;
                    b[_move_ind[j]][j] = tmp;
                    _move_ind[j]--;
                }
            }
        }
    }
}

bool is_horiz(char dir) {
    return dir == 'L' || dir == 'R';
}

bool is_vertic(char dir) {
    return dir == 'U' || dir == 'D';
}

void solve() {
    cin >> n >> m;
    board.assign(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        cin >> board[i];
    }
    // cout << 'k';
    cin >> reqs;
    // print_board(board); cout << endl; for (int i = 0; i < 3; i++) { move_board(board, 'R'); print_board(board); cout << endl; move_board(board, 'D'); print_board(board); cout << endl; move_board(board, 'L'); print_board(board); cout << endl; move_board(board, 'U'); print_board(board); cout << endl; }

    string new_reqs;
    char last_horiz = '.', last_vertic = '.', last = '.';
    for (auto el : reqs) {
        if (is_horiz(el)) {
            if (last_horiz != el) {
                if (is_horiz(last)) new_reqs.pop_back();
                new_reqs.push_back(el);
                last_horiz = el;
                last = el;
            }
        }
        if (is_vertic(el)) {
            if (last_vertic != el) {
                if (is_vertic(last)) new_reqs.pop_back();
                new_reqs.push_back(el);
                last_vertic = el;
                last = el;
            }
        }
    }
    reqs = new_reqs;
    if (reqs.size() < 6) {
        for (auto el : reqs) {
            move_board(board, el);
        }
        print_board(board);
        return;
    }
    // cerr << 'k';
    move_board(board, reqs[0]);
    move_board(board, reqs[1]);
    reqs.erase(reqs.begin(), reqs.begin() + 2);

    ind_board.assign(n, vector<int>(m, -1));
    for (int i = 0, cnt = 0; i < n; i++) {
        for (int j = 0; j < m; j++, cnt++) {
            if (board[i][j] != '.') ind_board[i][j] = cnt;
        }
    }
    // cerr << 'k' << endl;
    // print_board(ind_board);
    for (int i = 0; i < 4; i++) {
        move_board(ind_board, reqs[i]);
    }
    // print_board(ind_board);
    // cerr << 'k';
    bin_up.assign(LOG, vector<int>(n * m, -1));
    for (int i = 0, cnt = 0; i < n; i++) {
        for (int j = 0; j < m; j++, cnt++) {
            bin_up[0][cnt] = ind_board[i][j];
        }
    }
    // cerr << 'k';
    for (int p = 1; p < LOG; p++) {
        for (int i = 0; i < n * m; i++) {
            if (bin_up[p - 1][i] != -1) bin_up[p][i] = bin_up[p - 1][bin_up[p - 1][i]];
        }
    }
    // cerr << 'k';
    for (int i = 0, cnt = 0; i < n; i++) {
        for (int j = 0; j < m; j++, cnt++) {
            if (board[i][j] != '.') ind_board[i][j] = cnt;
            else ind_board[i][j] = -1;
        }
    }
    // for (auto el : bin_up) { for (auto el1 : el) cout << el1 << ' '; cout << endl; }
    // print_board(board);
    // print_board(ind_board);
    // cerr << 'k';
    int needed_iter = ((int) reqs.size()) / 4;
    reqs.erase(reqs.begin(), reqs.begin() + 4 * needed_iter);
    // cerr << needed_iter << endl;
    int ii, jj;
    for (int p = LOG - 1; p >= 0; p--) {
        if (needed_iter >= (1 << p)) {
            needed_iter -= (1 << p);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (board[i][j] != '.') ind_board[i][j] = bin_up[p][ind_board[i][j]];
                }
            }
        }
    }
    // cerr << 'k';
    new_board.assign(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (board[i][j] != '.') new_board[i][j] = board[ind_board[i][j] / m][ind_board[i][j] % m];
        }
    }
    // cerr << 'k';
    for (auto el : reqs) {
        move_board(new_board, el);
    }
    // cerr << 'k';
    print_board(new_board);
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
/*
1
5 6
abcd..
efg...
h.....
i.....
......
RDLURDLURDLURDLURDLURDLUR


1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR
*/
