#pragma GCC optimize("O3,unroll-loops")

#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

typedef long long ll;

const int LOG = 22;
const int INF = 1e9 + 7;

#define cia const int&
#define ff first
#define ss second

struct rect {
    int x1, y1, x2, y2;
};

struct event {
    int l, r, y, type;
};

bool cmp(event a, event b) {
    return a.y < b.y;
}

void solve() {
    int n;
    cin >> n;
    vector<rect> rects(n);
    for (auto &[x1, y1, x2, y2] : rects) {
        cin >> x1 >> y1 >> x2 >> y2;
        x2++;
        y2++;
    }
    vector<int> x_coords{0}, y_coords{0};
    for (auto [x1, y1, x2, y2] : rects) {
        x_coords.push_back(x1);
        x_coords.push_back(x2);
        y_coords.push_back(y1);
        y_coords.push_back(y2);
    }
    sort(x_coords.begin(), x_coords.end());
    x_coords.erase(unique(x_coords.begin(), x_coords.end()), x_coords.end());
    sort(y_coords.begin(), y_coords.end());
    y_coords.erase(unique(y_coords.begin(), y_coords.end()), y_coords.end());
    int w = x_coords.size(), h = y_coords.size();
    vector<event> events;
    for (auto [x1, y1, x2, y2] : rects) {
        x1 = lower_bound(x_coords.begin(), x_coords.end(), x1) - x_coords.begin();
        x2 = lower_bound(x_coords.begin(), x_coords.end(), x2) - x_coords.begin();
        y1 = lower_bound(y_coords.begin(), y_coords.end(), y1) - y_coords.begin();
        y2 = lower_bound(y_coords.begin(), y_coords.end(), y2) - y_coords.begin();
        events.push_back({x1, x2, y1, 1});
        events.push_back({x1, x2, y2, -1});
    }
    sort(events.begin(), events.end(), cmp);

    vector<vector<int>> used(h, vector<int>(w + 1));
    vector<int> pref(w + 1);
    for (int i = 0, j = 0; i < h; i++) {
        while (j < events.size() && events[j].y == i) {
            pref[events[j].l] += events[j].type;
            pref[events[j].r] -= events[j].type;
            j++;
        }
        for (int t = 0, cnt = 0; t < w; t++) {
            cnt += pref[t];
            used[i][t] = (cnt != 0);
        }
    }
    vector<set<int>> all_ends(w);
    for (int i = 0; i < h; i++) {
        int last_start = INF;
        for (int j = 0; j <= w; j++) {
            if (used[i][j]) {
                last_start = (last_start == INF ? j : last_start);
            } else {
                if (last_start != INF) all_ends[last_start].insert(j);
                last_start = INF;
            }
        }
    }
    vector<rect> res;
    for (int l = 0; l < w; l++) {
        for (auto cur : all_ends[l]) res.push_back({x_coords[l], x_coords[cur] - 1, 1, 1});
    }
    cout << res.size() << '\n';
    for (auto [a, b, c, d] : res) cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
/*
1
2
2 2 3 3
3 3 4 4
*/
