#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector <vector<char>> up(vector<vector<char>> pos, int n, int m) {
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (pos[i][j] != '.') {
				int teki = i;
				while (teki != 0 && pos[teki - 1][j] == '.') {
					swap(pos[teki][j], pos[teki - 1][j]);
					teki--;
				}
			}
		}
	}
	return pos;
}
vector <vector<char>> down(vector<vector<char>> pos, int n, int m) {
	for (int j = 0; j < m; j++) {
		for (int i = n - 1; i >= 0; i--) {
			if (pos[i][j] != '.') {
				int teki = i;
				while (teki != n - 1 && pos[teki + 1][j] == '.') {
					swap(pos[teki][j], pos[teki + 1][j]);
					teki++;
				}
			}
		}
	}
	return pos;
}
vector <vector<char>> left(vector<vector<char>> pos, int n, int m) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (pos[i][j] != '.') {
				int tekj = j;
				while (tekj > 0 && pos[i][tekj - 1] == '.') {
					swap(pos[i][tekj], pos[i][tekj - 1]);
					tekj--;
				}
			}
		}
	}
	return pos;
}
vector <vector<char>> right(vector<vector<char>> pos, int n, int m) {
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (pos[i][j] != '.') {
				int tekj = j;
				while (tekj < m - 1 && pos[i][tekj + 1] == '.') {
					swap(pos[i][tekj], pos[i][tekj + 1]);
					tekj++;
				}
			}
		}
	}
	return pos;
}
vector <vector<char>> fastup(vector<vector<char>> pos, int n, int m) {
	for (int j = 0; j < m; j++) {
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (pos[i][j] == 'a') { cnt++; }
		}
		for (int i = 0; i < n; i++) {
			if (i < cnt) { pos[i][j] = 'a'; }
			else { pos[i][j] = '.'; }
		}
	}
	return pos;
}
vector <vector<char>> fastdown(vector<vector<char>> pos, int n, int m) {
	for (int j = 0; j < m; j++) {
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (pos[i][j] == 'a') { cnt++; }
		}
		for (int i = 0; i<n; i++) {
			if (i>=n-cnt) { pos[i][j] = 'a'; }
			else { pos[i][j] = '.'; }
		}
	}
	return pos;
}
vector <vector<char>> fastleft(vector<vector<char>> pos, int n, int m) {
	for (int i = 0; i < n; i++) {
		int cnt = 0;
		for (int j = 0; j < m; j++) {
			if (pos[i][j] == 'a') { cnt++; }
		}
		for (int j = 0; j < m; j++) {
			if (j < cnt) { pos[i][j] = 'a'; }
			else { pos[i][j] = '.'; }
		}
	}
	return pos;
}
vector <vector<char>> fastright(vector<vector<char>> pos, int n, int m) {
	for (int i = 0; i < n; i++) {
		int cnt = 0;
		for (int j = 0; j < m; j++) {
			if (pos[i][j] == 'a') { cnt++; }
		}
		for (int j = 0; j < m; j++) {
			if (j >= m - cnt) { pos[i][j] = 'a'; }
			else { pos[i][j] = '.'; }
		}
	}
	return pos;
}
int main() {
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		vector <vector<char>> pos(n, vector <char>(m));
		int gra = 1;
		for (int i = 0; i < n; i++) {
			string sa; cin >> sa;
			for (int j = 0; j < m; j++) {
				if (sa[j] != '.' && sa[j] != 'a') { gra = 0; }
				pos[i][j] = sa[j];
			}
		}
		string sapr; cin >> sapr;
		int q = sapr.size(), colD = 0;
		for (int i = 0; i < q; i++) {
			if (sapr[i] == 'D') { colD++; }
		}
		if (gra == 1) {
			int colDU = 0, colLR = 0;
			for (int i = 0; i < q; i++) {
				if (sapr[i] == 'D' || sapr[i] == 'U') { colDU++; }
				else { colLR++; }
			}
			if (colDU == 0 || colLR == 0) {
				char sym = sapr[q-1];
				if (sym == 'U') { pos = fastup(pos, n, m); }
				else if (sym == 'D') { pos = fastdown(pos, n, m); }
				else if (sym == 'L') { pos = fastleft(pos, n, m); }
				else { pos = fastright(pos, n, m); }
			}
			else {
				int firstDU = -1, firstLR = -1;
				for (int i = 0; i < q; i++) {
					if (sapr[i] == 'D' || sapr[i] == 'U') { 
						if (firstDU == -1) { firstDU = i; }
					} else {
						if (firstLR == -1) { firstLR = i; }
					}
				}
				int k = max(firstDU, firstLR);
				char syms = sapr[k-1], syms2 = sapr[k];
				if (syms == 'U') { pos = fastup(pos, n, m); }
				else if (syms == 'D') { pos = fastdown(pos, n, m); }
				else if (syms == 'L') { pos = fastleft(pos, n, m); }
				else { pos = fastright(pos, n, m); }
				if (syms2 == 'U') { pos = fastup(pos, n, m); }
				else if (syms2 == 'D') { pos = fastdown(pos, n, m); }
				else if (syms2 == 'L') { pos = fastleft(pos, n, m); }
				else { pos = fastright(pos, n, m); }
				char ss1 = '.', ss2 = '.';
				for (int i = k + 1; i < q; i++) {
					if (sapr[i] == 'U') { ss1 = 'U'; }
					if (sapr[i] == 'D') { ss1 = 'D'; }
					if (sapr[i] == 'L') { ss2 = 'L'; }
					if (sapr[i] == 'R') { ss2 = 'R'; }
				}
				if (ss1 == 'D') { pos = fastdown(pos, n, m); }
				if (ss1 == 'U') { pos = fastup(pos, n, m); }
				if (ss2 == 'L') { pos = fastleft(pos, n, m); }
				if (ss2 == 'R') { pos = fastright(pos, n, m); }
			}
		} else if (colD == 0) {
			int posU = -1, posnotU = -1;
			for (int i = 0; i < q; i++) {
				if (sapr[i] == 'U' && posU == -1) { posU = i; }
				if (sapr[i] != 'U') { posnotU = i; }
			}
			vector <int> ispind;
			if (posU == -1) { ispind.push_back(q - 1); }
			else if (posU == 0) {
				ispind.push_back(0);
				if (posnotU != -1) { ispind.push_back(posnotU); }
			}
			else {
				ispind.push_back(posU - 1);
				ispind.push_back(posU);
				if (posnotU > posU) { ispind.push_back(posnotU); }
			}
			for (auto i : ispind) {
				char sym = sapr[i];
				if (sym == 'U') { pos = up(pos, n, m); }
				else if (sym == 'D') { pos = down(pos, n, m); }
				else if (sym == 'L') { pos = left(pos, n, m); }
				else { pos = right(pos, n, m); }
			}
		}
		else {
			for (int i = 0; i < q; i++) {
				char sym = sapr[i];
				if (sym == 'U') {
					pos = up(pos, n, m);
				}
				else if (sym == 'D') {
					pos = down(pos, n, m);
				}
				else if (sym == 'L') {
					pos = left(pos, n, m);
				}
				else {
					pos = right(pos, n, m);
				}
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << pos[i][j];
			} cout << "\n";
		}
	}
	return 0;
}