#include <iostream>
#include <string>
#include <stdio.h>
#include <vector>
#include <set>
#include <charconv>
#include <numeric>

using namespace std;

#define elif else if
#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define RRANGE(i, n) for (int i = n - 1; i >= 0; i--)
#define RRANGE1(i, n) for (int i = n - 2; i >= 0; i--)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using pole = vector<vector<char>>;
using ull = unsigned long long;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val/* << " "*/;
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}


int m, n;

inline void left(vector<vector<char>> &p) {
    RANGE(i, m) {
        vector<char> new_row(n, '.');
        int k = 0;
        for (char ch: p[i]) {
            if (ch != '.') {
                new_row[k] = ch;
                k++;
            }
        }
        p[i] = new_row;
    }
}

inline void right(vector<vector<char>> &p) {
    RANGE(i, m) {
        vector<char> new_row(n, '.');
        int k = n - 1;
        RRANGE(j, n) {
            if (p[i][j] != '.') {
                new_row[k] = p[i][j];
                k--;
            }
        }
        p[i] = new_row;
    }
}

inline void up(vector<vector<char>> &p) {
    RANGE(j, n) {
        vector<char> new_column(m, '.');
        int k = 0;
        RANGE(i, m) {
            if (p[i][j] != '.') {
                new_column[k] = p[i][j];
                k++;
            }
        }
        RANGE(i, m) {
            p[i][j] = new_column[i];
        }
    }
}

inline void down(vector<vector<char>> &p) {
    RANGE(j, n) {
        vector<char> new_column(m, '.');
        int k = m - 1;
        RRANGE(i, m) {
            if (p[i][j] != '.') {
                new_column[k] = p[i][j];
                k--;
            }
        }
        RANGE(i, m) {
            p[i][j] = new_column[i];
        }
    }
}

vector<char> optimize(string &s) {
    vector<char> new_s;
    new_s.reserve(s.size());
    vector<char> last_v = {'.'};
    vector<char> last_h = {'.'};
    char last = '.';
    for (char ch: s) {
        if (ch == last_v.back() || ch == last_h.back()) {
            continue;
        }
        if (ch == 'L' && last == 'R') {
            new_s.pop_back();
            last_h.pop_back();
        }
        if (ch == 'R' && last == 'L') {
            new_s.pop_back();
            last_h.pop_back();
        }
        if (ch == 'U' && last == 'D') {
            new_s.pop_back();
            last_v.pop_back();
        }
        if (ch == 'D' && last == 'U') {
            new_s.pop_back();
            last_v.pop_back();
        }
        if (ch == last_v.back() || ch == last_h.back()) {
            if (new_s.empty()) {
                last = '.';
            } else {
                last = new_s.back();
            }
            continue;
        }
        new_s.push_back(ch);
        last = ch;
        if (ch == 'U' || ch == 'D') {
            last_v.push_back(ch);
        } else {
            last_h.push_back(ch);
        }
    }
    return new_s;
}

inline void run(pole &p, char ch) {
    if (ch == 'L') {
        left(p);
    } elif (ch == 'R') {
        right(p);
    } elif (ch == 'U') {
        up(p);
    } else {
        down(p);
    }
}

inline int get_p(pole &p) {
    int ans = 0;
    RANGE(i, n) {
        ans += p[0][i] != '.';
        ans += p[m - 1][i] != '.';
    }
    for (int i = 1; i < m - 1; i++) {
        ans += p[i][0] != '.';
        ans += p[i][n - 1] != '.';
    }
    return ans;
}

inline void run(pole &p, vector<char> &s) {
    if (s.size() <= 2) {
        for (char ch: s) {
            run(p, ch);
        }
        return;
    }
    run(p, s[0]);
    run(p, s[1]);
    int k1;
    {
        int per = get_p(p);
        if (per <= 2 * min(n, m)) {
            k1 = 3;
        } else {
            per += min(n, m);
            k1 = per * min(n, m) / gcd(per, min(n, m));
        }
    }
    const int k = ((s.size() - 2) / 4) / k1;
    const int S = s.size();
    for (int i = k * 4 * k1 + 2; i < S; i++) {
        run(p, s[i]);
    }
}

void solve() {
    cin >> m >> n;
    pole p(m, vector<char>(n));
    cin >> p;
    string s;
    getline(cin, s);
    getline(cin, s);
    vector<char> s2 = optimize(s);
//    DEBUG(s2)
    run(p, s2);
    cout << p;
}


int main() {
//    string s;
//    while (true) {
//        getline(cin, s);
//        auto o = optimize(s);
//        cout << o << ENDLINE;
//    }
    int t;
    cin >> t;
    LOOP(t) {
        solve();
    }
}
