#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>

using namespace std;

#define elif else if
#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define RRANGE(i, n) for (int i = n - 1; i >= 0; i--)
#define RRANGE1(i, n) for (int i = n - 2; i >= 0; i--)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using ull = unsigned long long;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val/* << " "*/;
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}


int m, n;

void left(vector<vector<char>> &p) {
    RANGE(i, m) {
        vector<char> new_row(n, '.');
        int k = 0;
        for (char ch : p[i]){
            if (ch != '.') {
                new_row[k] = ch;
                k++;
            }
        }
        p[i] = new_row;
    }
}

void right(vector<vector<char>> &p) {
    RANGE(i, m) {
        vector<char> new_row(n, '.');
        int k = n - 1;
        RRANGE(j, n) {
            if (p[i][j] != '.') {
                new_row[k] = p[i][j];
                k--;
            }
        }
        p[i] = new_row;
    }
}

void up(vector<vector<char>> &p) {
    RANGE(j, n) {
        vector<char> new_column(m, '.');
        int k = 0;
        RANGE(i, m) {
            if (p[i][j] != '.') {
                new_column[k] = p[i][j];
                k++;
            }
        }
        RANGE(i, m) {
            p[i][j] = new_column[i];
        }
    }
}

void down(vector<vector<char>> &p) {
    RANGE(j, n) {
        vector<char> new_column(m, '.');
        int k = m - 1;
        RRANGE(i, m) {
            if (p[i][j] != '.') {
                new_column[k] = p[i][j];
                k--;
            }
        }
        RANGE(i, m) {
            p[i][j] = new_column[i];
        }
    }
}

void solve() {
    cin >> m >> n;
    vector<vector<char>> p(m, vector<char>(n));
    cin >> p;
    string s;
    getline(cin, s);
    getline(cin, s);
    for (char ch: s) {
        if (ch == 'L') {
            left(p);
        } elif (ch == 'R') {
            right(p);
        } elif (ch == 'U') {
            up(p);
        } else {
            down(p);
        }
    }
    cout << p;
}

int main() {
    int t;
    cin >> t;
    LOOP(t) {
        solve();
    }
}
