#include <iostream>
#include <string>
#include <stdio.h>
#include <vector>
#include <set>
#include <charconv>
#include <numeric>
#include <map>

using namespace std;

#define elif else if
#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define RRANGE(i, n) for (int i = n - 1; i >= 0; i--)
#define RRANGE1(i, n) for (int i = n - 2; i >= 0; i--)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using ull = unsigned long long;
using xxyy = tuple<int, int, int, int>;
using pii = pair<int, int>;

template<typename T1, typename T2, typename T3, typename T4>
istream &operator>>(istream &in, tuple<T1, T2, T3, T4> &v) {
    in >> get<0>(v) >> get<1>(v) >> get<2>(v) >> get<3>(v);
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val/* << " "*/;
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<xxyy> coors(n);
    map<int, int> zipx, zipy, unzipx, unzipy;
    int w, h;
    {
        vector<xxyy> coors0(n);
        set<int> xs, ys;
        RANGE(i, n) {
            int x1, x2, y1, y2;
            cin >> x1 >> y1 >> x2 >> y2;
            xs.insert(x1);
            xs.insert(x2 + 1);
            ys.insert(y1);
            ys.insert(y2 + 1);
            coors0[i] = {x1, x2, y1, y2};
        }
        int i = 0;
        for (int x: xs) {
            zipx[x] = i;
            unzipx[i] = x;
            i++;
        }
        w = i;
        i = 0;
        for (int y: ys) {
            zipy[y] = i;
            unzipy[i] = y;
            i++;
        }
        h = i;
        i = 0;
        for (auto [x1, x2, y1, y2]: coors0) {
            coors[i] = {zipx[x1], zipx[x2 + 1], zipy[y1], zipy[y2 + 1]};
            i++;
        }
    }
    vector<vector<bool>> p(h, vector<bool>(w, false));
    for (auto [x1, x2, y1, y2]: coors) {
        for (int y = y1; y < y2; y++) {
            for (int x = x1; x < x2; x++) {
                p[y][x] = true;
            }
        }
    }
    map<pii, set<int>> m;
    int count = 0;
    RANGE(y, h) {
        int start = -1;
        RANGE(x, w) {
            if (!p[y][x] && start != -1) {
                auto it = m.find({start, x});
                if (it == m.end()) {
                    m[{start, x}] = {y};
                    count++;
                } else {
                    it->second.insert(y);
                }
                start = -1;
            } elif (p[y][x] && start == -1) {
                start = x;
            }
        }
    }
    cout << count << ENDLINE;
    for (auto [xx, s]: m) {
        count = 0;
        int max_len = 0;
        {
            int now_len = 0;
            int last = -2;
            for (int y: s) {
                count += unzipy[y + 1] - unzipy[y];
                if (y == last + 1) {
                    now_len += unzipy[y + 1] - unzipy[y];
                } else {
                    max_len = max(max_len, now_len);
                    now_len = unzipy[y + 1] - unzipy[y];
                }
                last = y;
            }
            max_len = max(max_len, now_len);
        }
        auto [x1, x2] = xx;
        cout << unzipx[x1] << " " << unzipx[x2] - 1 << " " << count << " " << max_len << ENDLINE;
    }
}

int main() {
    int t;
    cin >> t;
    LOOP(t) {
        solve();
    }
}
