#include <iostream>
#include <string>
#include <stdio.h>
#include <vector>
#include <set>
#include <charconv>
#include <numeric>
#include <map>

using namespace std;

#define elif else if
#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define RRANGE(i, n) for (int i = n - 1; i >= 0; i--)
#define RRANGE1(i, n) for (int i = n - 2; i >= 0; i--)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using ull = unsigned long long;
using xxyy = tuple<int, int, int, int>;
using pii = pair<int, int>;

template<typename T1, typename T2, typename T3, typename T4>
istream &operator>>(istream &in, tuple<T1, T2, T3, T4> &v) {
    in >> get<0>(v) >> get<1>(v) >> get<2>(v) >> get<3>(v);
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val/* << " "*/;
    }
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &v) {
    for (auto &val: v) {
        out << val << ENDLINE;
    }
    return out;
}

vector<bool> do_;

void do_build(int n) {
    do_.clear();
    do_.resize(4 * n, false);
}

void do_push(int i, int l, int r) {
    if (l + 1 != r && do_[i]) {
        do_[2 * i + 1] = do_[2 * i + 2] = true;
        do_[i] = false;
    }
}

void do_set(int i, int l, int r, int q_l, int q_r) {
    if (q_r <= l || r <= q_l) {
        return;
    }
    if (q_l <= l && r <= q_r) {
        do_[i] = true;
        return;
    }
    do_push(i, l, r);
    int c = (l + r) / 2;
    do_set(2 * i + 1, l, c, q_l, q_r);
    do_set(2 * i + 2, c, r, q_l, q_r);
}

void do_set(int q_l, int q_r, int n) {
    do_set(0, 0, n, q_l, q_r);
}

bool do_get(int i, int l, int r, int q) {
    if (l + 1 == r && l == q) {
        return do_[i];
    }
    if (do_[i]) {
        return true;
    }
    int c = (l + r) / 2;
    if (q < c) {
        return do_get(2 * i + 1, l, c, q);
    } else {
        return do_get(2 * i + 2, c, r, q);
    }
}

bool do_get(int q, int n) {
    return do_get(0, 0, n, q);
}

void solve() {
    int n;
    cin >> n;
    vector<pii> xx(n);
    set<int> xs;
    RANGE(i, n) {
        int x1, x2, _t;
        cin >> x1 >> _t >> x2 >> _t;
        xx[i] = {x1, x2 + 1};
        xs.insert(x1);
        xs.insert(x2 + 1);
    }
    const int K = xs.size();
    vector<int> unzipx(K);
    map<int, int> zipx;
    {
        int i = 0;
        for (int x: xs) {
            unzipx[i] = x;
            zipx[x] = i;
            i++;
        }
    }
    do_build(K);
    for (auto [x1, x2]: xx) {
        do_set(zipx[x1], zipx[x2], K);
    }
    vector<pii> ans;
    int start = -1;
    RANGE(i, K) {
        if (do_get(i, K)) {
            if (start == -1) {
                start = i;
            }
        } elif (start != -1) {
            ans.emplace_back(start + 1, i);
        }
    }
    cout << ans.size() << ENDLINE;
    for (auto [x1, x2]: ans) {
        cout << unzipx[x1] << " " << unzipx[x2] - 1 << " 1 1" << ENDLINE;
    }
}

int main() {
    int t;
    cin >> t;
    LOOP(t) {
        solve();
    }
}
