// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#include <bits/stdc++.h>
using namespace std;

bool is_lr(char c) {
  return c == 'L' || c == 'R';
}

vector<int> composition(vector<int>& p, vector<int>& q) {
  int n = (int)p.size();
  vector<int> ans(n);
  for (int i = 0; i < n; i++) {
    ans[i] = p[q[i]];
  }
  return ans;
}

vector<int> binpow(vector<int> p, int k) {
  vector<int> ans(p.size());
  iota(ans.begin(), ans.end(), 0);
  while (k > 0) {
    if (k & 1) {
      ans = composition(ans, p);
    }
    p = composition(p, p);
    k /= 2;
  }
  return ans;
}

int main() {
  // cin.tie(nullptr)->sync_with_stdio(false);
  int t;
  cin >> t;
  while (t--) {
    int m, n;
    cin >> m >> n;
    vector<string> s(m);
    for (int i = 0; i < m; i++) {
      cin >> s[i];
    }
    auto Anchor = [&](char c) {
      if (c == 'U') {
        for (int j = 0; j < n; j++) {
          string t;
          for (int i = 0; i < m; i++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }	
          for (int i = 0; i < m; i++) {
            s[i][j] = i < (int)t.size() ? t[i] : '.';
          }
        }
      } else if (c == 'L') {
        for (int i = 0; i < m; i++) {
          string t;
          for (int j = 0; j < n; j++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int j = 0; j < n; j++) {
            s[i][j] = j < (int)t.size() ? t[j] : '.';
          }
        }
      } else if (c == 'D') {
        for (int j = 0; j < n; j++) {
          string t;
          for (int i = 0; i < m; i++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int i = 0; i < m; i++) {
            s[i][j] = m - i <= (int)t.size() ? t[(int)t.size() - (m - i)] : '.';
          }
        }
      } else {
        for (int i = 0; i < m; i++) {
          string t;
          for (int j = 0; j < n; j++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int j = 0; j < n; j++) {
            s[i][j] = n - j <= (int)t.size() ? t[(int)t.size() - (n - j)] : '.';
          }
        }
      }
    };
    string A;
    cin >> A;
    while (true) {
      string tmp = A;
      {
        char last_lr = 0, last_ud = 0;
        string new_A;
        for (auto c : A) {
          if (c == 'L' || c == 'R') {
            if (last_lr != c) {
              new_A += c;
            }
            last_lr = c;
          } else {
            if (last_ud != c) {
              new_A += c;
            }
            last_ud = c;
          }
        }
        A = new_A;
      }
      {
        int k = (int)A.size();
        string new_A;
        for (int i = 0; i < k; i++) {
          int j = i;
          while (j < k && is_lr(A[i]) == is_lr(A[j])) {
            j++;
          }
          new_A += A[j - 1];
          i = j - 1;
        }
        A = new_A;
      }
      if (A == tmp) {
        break;
      }
    }
    int k = (int)A.size();
    if (k <= 4) {
      for (int i = 0; i < k; i++) {
        Anchor(A[i]);
      }
      for (int i = 0; i < m; i++) {
        cout << s[i] << "\n";
      }
    } else {
      for (int i = 0; i < 4; i++) {
        Anchor(A[i]);
      }
      vector<vector<int>> grid(m, vector<int>(n));
      for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
          grid[i][j] = i * n + j;
        }
      }
      vector<vector<bool>> used(m, vector<bool>(n));
      for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
          used[i][j] = s[i][j] != '.';
        }
      }
      for (int r = 0; r < 4; r++) {
        char c = A[r];
        vector<vector<bool>> new_used(m, vector<bool>(n));
        vector<vector<int>> new_grid(m, vector<int>(n));
        if (c == 'U') {
          for (int j = 0; j < n; j++) {
            int pos = 0;
            for (int i = 0; i < m; i++) {
              if (used[i][j]) {
                pos = i;
                break;
              }
            }
            for (int i = 0; i < m; i++) {
              new_used[i][j] = used[(i + pos) % m][j];
              new_grid[i][j] = grid[(i + pos) % m][j];
            }
          }
        } else if (c == 'L') {
          for (int i = 0; i < m; i++) {
            int pos = 0;
            for (int j = 0; j < n; j++) {
              if (used[i][j]) {
                pos = i;
                break;
              }
            }
            for (int j = 0; j < n; j++) {
              new_used[i][j] = used[i][(j + pos) % n];
              new_grid[i][j] = grid[i][(j + pos) % n];
            }
          }
        } else if (c == 'D') {
          for (int j = 0; j < n; j++) {
            int pos = 0;
            for (int i = m - 1; i >= 0; i--) {
              if (used[i][j]) {
                pos = i;
                break;
              }
            }
            pos = m - 1 - pos;
            for (int i = 0; i < m; i++) {
              new_used[i][j] = used[(i - pos + m) % m][j];
              new_grid[i][j] = grid[(i - pos + m) % m][j];
            }
          }
        } else {
          for (int i = 0; i < m; i++) {
            int pos = 0;
            for (int j = n - 1; j >= 0; j--) {
              if (used[i][j]) {
                pos = j;
                break;
              }
            }
            pos = n - 1 - pos;
            for (int j = 0; j < n; j++) {
              new_used[i][j] = used[i][(j - pos + n) % n];
              new_grid[i][j] = grid[i][(j - pos + n) % n];
            }
          }
        }
        used = new_used;
        grid = new_grid;
      }
      vector<int> perm(n * m);
      for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
          perm[i * n + j] = grid[i][j];
        }
      }
      vector<int> ord = binpow(perm, k / 4 - 1);
      vector<string> new_s(m);
      for (int i = 0; i < m; i++) {
        new_s[i] = string(n, '.');
        for (int j = 0; j < n; j++) {
          int x = ord[i * n + j] / n, y = ord[i * n + j] % n;
          new_s[i][j] = s[x][y];
        }
      }
      s = new_s;
      for (int i = k - k % 4; i < k; i++) {
        Anchor(A[i]);
      }
      for (int i = 0; i < m; i++) {
        cout << s[i] << "\n";
      }
    }
  }
}
