﻿#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <random>
#include <ctime>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;

mt19937 gen(time(0));

const ll OPEN = 1, CLOSE = 2;

struct Seg {
	ll x1, x2, y, t;
};

bool cmp(Seg a, Seg b) {
	return a.y < b.y;
}

const ll INF = 2e9;

void solve() {
	ll n;
	cin >> n;
	vector<Seg> a(2 * n);
	vector<ll> Y;

	set<pair<ll, ll>> st;

	map<pair<ll, ll>, ll> mp;

	for (ll i = 0; i < n; i++) {
		ll x1, x2, y1, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		st.insert({ x1, x2 });
		mp[{ x1, x2 }] += (y2 - y1 + 1);
	}

	cout << st.size() << "\n";
	for (pair<ll, ll> elem : st) {
		cout << elem.first << " " << elem.second << " " << mp[elem] << " " << mp[elem] << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	ll t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}