#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

struct Line {
    int l, r, y;

    bool operator <(const Line& l) const {
        if (this->l != l.l) return this->l < l.l;
        if (r != l.r) return r < l.r;
        return y < l.y;
    }
};

void solve() {
    int n;
    cin >> n;

    vector<vector<char>> mat(11, vector<char>(11));

    for(int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        for(int x = x1; x <= x2; ++x)
            for(int y = y1; y <= y2; ++y)
                mat[x][y] = 1;
    }

    set<Line> ls;
    for(int y = 1; y<=10; ++y) {
        int l = 0, r =0;
        while (r <= 11) {
            if (r <= 10 && mat[r][y]) r++;
            else {
                if (r-l)
                    ls.insert({l, r-1, y});
                l=++r;
            }   
        }
    }

    vector<tuple<int, int, int, int>> ans;
    for(int xa = 1; xa < 10; ++xa) {
        for(int xb = xa+1; xb <= 10; ++xb) {
            int cnt =0,k=0,tmpk=0;
            for(int y = 1; y <= 10; ++y) {
                auto l = *ls.lower_bound({xa, xb, y});
                if (l.l == xa && l.r == xb && l.y == y) {
                    tmpk++;
                    cnt++;
                    k = max(k, tmpk);
                }
            }
            if (cnt)
                ans.push_back({xa, xb, cnt, k});
        }
    }
    cout << ans.size() << '\n';
    for(auto [xa, xb, cnt, k] : ans) {
        cout << xa << ' ' << xb << ' ' << cnt << ' ' << k << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();


    return 0;
}