#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<map>
#include<set>
using namespace std;

#define ll long long
const int INF = 1e9 + 7;
const ll INFL = 1e16 + 7;

#ifdef LOCAL
#define debug(x) cout << __LINE << ": " << #x << "  =>  " << x << '\n'
#define debugvec(x) cout << #x << ": "; for (auto i : x) cout << i << ' '; cout << '\n';
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

int solve() {
    ll n, m ,c, p;
    cin >> n >> m >> c >> p;
    vector<int> windows = {};
    vector<pair<int, int>> walls = {};
    for (int i = 0; i < n + m; i++) {
        int t, h;
        cin >> t >> h;
        if (t == 1) {
            walls.push_back({windows.size(), h});
        } else {
            windows.push_back(h);
        }
    }
    if (m == 0) {
        cout << "0" << '\n';
        return 0;
    }
    vector<int> win_pref(m + 1, 0);
    win_pref[0] = windows[0];
    for (int i = 1; i < m; i++) {
        win_pref[i] = windows[i] - windows[i - 1];
    }
    debugvec(win_pref);
    for (int i = 0; i < n; i++) {
        win_pref[walls[i].first] += walls[i].second;
    }
    vector<int> newwin(m, 0);
    newwin[0] = win_pref[0];
    for (int i = 1; i < m; i++) {
        newwin[i] = newwin[i - 1] + win_pref[i];
    }
    debugvec(newwin);
    map<int, int> floors = {};
    for (int i = 0; i < m; i++) {
        if (floors.find(newwin[i]) == floors.end()) {
            floors[newwin[i]] = 0;
        }
        floors[newwin[i]]++;
    }
    ll f = 0;
    int manywas = 0;
    for (auto [high, many] : floors) {
        manywas += many;
        f = max(f, manywas * p - (high - 1) * c);
    }
    cout << f << '\n';
    return 0;
}

int main() {
#ifdef LOCAL
    string way_to_input = "C:\\Users\\roi\\Documents\\tour1\\input.txt";
    string way_to_output = "C:\\Users\\roi\\Documents\\tour1\\output.txt";
    freopen(way_to_input.c_str(), "r", stdin);
    freopen(way_to_output.c_str(), "w", stdout);
    while (!cin.eof()) {
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
#endif
}