#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<map>
#include<set>
using namespace std;

#define ll long long
const int INF = 1e9 + 7;
const ll INFL = 1e16 + 7;

#ifdef LOCAL
#define debug(x) cout << __LINE__ << ": " << #x << "  =>  " << x << '\n'
#define debugvec(x) cout << #x << ": "; for (auto i : x) cout << i << ' '; cout << '\n';
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

void toleft(int n, int m, vector<vector<char>> &v) {
    for (int i = 0; i < n; i++) {
        int k = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') continue;
            swap(v[i][j], v[i][k]);
            k++;
        }
    }
}

void toright(int n, int m, vector<vector<char>> &v) {
    for (int i = 0; i < n; i++) {
        int k = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j] == '.') continue;
            swap(v[i][j], v[i][k]);
            k--;
        }
    }
}

void toup(int n, int m, vector<vector<char>> &v) {
    for (int j = 0; j < m; j++) {
        int k = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == '.') continue;
            swap(v[i][j], v[k][j]);
            k++;
        }
    }
}

void todown(int n, int m, vector<vector<char>> &v) {
    for (int j = 0; j < m; j++) {
        int k = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (v[i][j] == '.') continue;
            swap(v[i][j], v[k][j]);
            k--;
        }
    }
}

int solve() {
    int tests;
    cin >> tests;
    for (int t = 0; t < tests; t++) {
        int n, m;
        cin >> n >> m;
        vector<vector<char>> v(n, vector<char>(m, '.'));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cin >> v[i][j];
            }
        }
        string s;
        cin >> s;
        for (int i = 0; i < s.size(); i++) {
            if (s[i] == 'L') {
                toleft(n, m, v);
            } else if (s[i] == 'R') {
                toright(n, m, v);
            } else if (s[i] == 'U') {
                toup(n, m, v);
            } else {
                todown(n, m, v);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << v[i][j];
            }
            cout << '\n';
        }
    }
    return 0;
}

int main() {
#ifdef LOCAL
    string way_to_input = "C:\\Users\\roi\\Documents\\tour1\\input.txt";
    string way_to_output = "C:\\Users\\roi\\Documents\\tour1\\output.txt";
    freopen(way_to_input.c_str(), "r", stdin);
    freopen(way_to_output.c_str(), "w", stdout);
    while (!cin.eof()) {
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
#endif
}