#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<map>
#include<set>
using namespace std;

#define ll long long
const int INF = 1e9 + 7;
const ll INFL = 1e16 + 7;

#ifdef LOCAL
#define debug(x) cout << __LINE__ << ": " << #x << "  =>  " << x << '\n'
#define debugv(x) cout << #x << ": "; for (auto i : x) cout << i << ' '; cout << '\n';
#define debugvv(x) cout << #x << ":\n"; for (auto i : x) {for (auto j : i) cout << j << ' '; cout << '\n';}
#else
#define debug(x) ;
#define debugv(x) ;
#define debugvv(x) ;
#endif

void toleft(int n, int m, vector<vector<int>> &v) {
    for (int i = 0; i < n; i++) {
        int k = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == 0) continue;
            swap(v[i][j], v[i][k]);
            k++;
        }
    }
}

void toright(int n, int m, vector<vector<int>> &v) {
    for (int i = 0; i < n; i++) {
        int k = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j] == 0) continue;
            swap(v[i][j], v[i][k]);
            k--;
        }
    }
}

void toup(int n, int m, vector<vector<int>> &v) {
    for (int j = 0; j < m; j++) {
        int k = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == 0) continue;
            swap(v[i][j], v[k][j]);
            k++;
        }
    }
}

void todown(int n, int m, vector<vector<int>> &v) {
    for (int j = 0; j < m; j++) {
        int k = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (v[i][j] == 0) continue;
            swap(v[i][j], v[k][j]);
            k--;
        }
    }
}

void to_do(int n, int m, vector<vector<int>> &v, char c) {
    if (c == 'L') toleft(n, m, v);
    else if (c == 'R') toright(n, m, v);
    else if (c == 'U') toup(n, m, v);
    else todown(n, m, v);
}

int num_v(char c) {
    if (c == 'L') return 0;
    if (c == 'R') return 1;
    if (c == 'U') return 2;
    return 3;
}

int num_v(char c1, char c2) {
    int x1 = num_v(c1);
    int x2 = num_v(c2);
    if (x1 > x2) swap(x1, x2);
    return 2 * x2 + x1 - 4;
}

bool dif(char a, char b) {
    int an = num_v(a), bn = num_v(b);
    if (an > bn) swap(an, bn);
    return an < 2 && bn > 1;
}

int to_clock(int n, int m, vector<vector<int>> &v, int where) {
    if (where == 0) {toright(n, m, v); return 1;}
    if (where == 1) {todown(n, m, v); return 3;}
    if (where == 2) {toup(n, m, v); return 0;}
    else {toleft(n, m, v); return 2;}
}

int not_to_clock(int n, int m, vector<vector<int>> &v, int where) {
    if (where == 0) {todown(n, m, v); return 2;}
    if (where == 1) {toleft(n, m, v); return 0;}
    if (where == 2) {toright(n, m, v); return 3;}
    else {toup(n, m, v); return 1;}
}

int solve() {
    int tests;
    cin >> tests;
    for (int t = 0; t < tests; t++) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> v(n, vector<int>(m, 0));
        vector<char> symb = {'.'};
        int many = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char c; cin >> c;
                if (c != '.') {
                    v[i][j] = many;
                    many++;
                    symb.push_back(c);
                }
            }
        }
        string s;
        cin >> s;
        int k = s.size(), begsec = -1;
        int where = -1;
        //первая фаза
        {
            bool finish = true;
            for (int i = 0; i < k - 1; i++) {
                if (dif(s[i], s[i + 1])) {
                    to_do(n, m, v, s[i]);
                    to_do(n, m, v, s[i + 1]);
                    where = num_v(s[i], s[i + 1]);
                    begsec = i + 2;
                    finish = false;
                    break;
                }
            }
            if (finish) {
                to_do(n, m, v, s[k - 1]);
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        cout << symb[v[i][j]];
                    }
                    cout << '\n';
                }
                return 0;
            }
        }
        int go = 0, beg_where = where;
        //вторая фаза
        {
            for (int i = begsec; i < k; i++) {
                if (where == 0 && s[i] == 'R') {go++; where = 1;}
                else if (where == 0 && s[i] == 'D') {go--; where = 2;}
                else if (where == 1 && s[i] == 'D') {go++; where = 3;}
                else if (where == 1 && s[i] == 'L') {go--; where = 0;}
                else if (where == 2 && s[i] == 'U') {go++; where = 0;}
                else if (where == 2 && s[i] == 'R') {go--; where = 3;}
                else if (where == 3 && s[i] == 'L') {go++; where = 2;}
                else if (where == 3 && s[i] == 'U') {go--; where = 1;}
            }
        }

        //третья фаза
        {
            vector<vector<int>> begv = v;
            if (beg_where == 0) {
                toright(n, m, v);
                todown(n, m, v);
                toleft(n, m, v);
                toup(n, m, v);
            } else if (beg_where == 1) {
                todown(n, m, v);
                toleft(n, m, v);
                toup(n, m, v);
                toright(n, m, v);
            } else if (beg_where == 2) {
                toup(n, m, v);
                toright(n, m, v);
                todown(n, m, v);
                toleft(n, m, v);
            } else {
                toleft(n, m, v);
                toup(n, m, v);
                toright(n, m, v);
                todown(n, m, v);
            }
            debugvv(v);
            vector<vector<int>> ways = {};
            vector<int> inway(many, -1), ininway(many, -1);
            vector<int> nextv(many, -1);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    nextv[begv[i][j]] = v[i][j];
                }
            }
            for (int i = 0; i < many; i++) {
                if (inway[i] != -1) continue;
                ways.push_back({i});
                inway[i] = ways.size() - 1;
                ininway[i] = 0;
                int now = nextv[i];
                while (now != i) {
                    inway[now] = ways.size() - 1;
                    ininway[now] = ways.back().size();
                    ways.back().push_back(now);
                    now = nextv[now];
                }
            }
            debugvv(ways);
            debugv(inway);
            debugv(ininway);
            vector<vector<int>> finv = begv;
            int manyfor = abs(go) / 4;
            if (go < 0) manyfor = -manyfor;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    int x = begv[i][j];
                    int ind = ininway[x] + manyfor;
                    int sz = ways[inway[x]].size();
                    finv[i][j] = ways[inway[x]][(ind % sz + sz) % sz];
                }
            }
            int mod = abs(go) % 4;
            where = beg_where;
            if (go > 0) {
                for (int i = 0; i < mod; i++) {
                    where = to_clock(n, m, finv, where);
                }
            } else {
                for (int i = 0; i < mod; i++) {
                    where = not_to_clock(n, m, finv, where);
                }
            }
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    cout << symb[finv[i][j]];
                }
                cout << '\n';
            }
        }
    }
    return 0;
}

int main() {
#ifdef LOCAL
    string way_to_input = "C:\\Users\\roi\\Documents\\tour1\\input.txt";
    string way_to_output = "C:\\Users\\roi\\Documents\\tour1\\output.txt";
    freopen(way_to_input.c_str(), "r", stdin);
    freopen(way_to_output.c_str(), "w", stdout);
    while (!cin.eof()) {
        solve();
    }
#else
    solve();
#endif
}