#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>

#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> v;
    return in;
}

const int inf = 1'000'000'000'000'000;

struct SegTree {
    int n;
    vector<int> t;
    SegTree() = default;
    SegTree(int _n) {
        n = _n;
        t.assign(4 * n, -inf);
    }
    void set(int p, int l, int r, int i, int x) {
        if (l > i || r <= i) return;
        if (l + 1 == r) {
            t[p] = x;
            return;
        }
        int mid = (l + r) / 2;
        set(2 * p + 1, l, mid, i, x);
        set(2 * p + 2, mid, r, i, x);
        t[p] = max(t[2 * p + 1], t[2 * p + 2]);
    }
    int get(int p, int l, int r, int a, int b) {
        if (l >= b || r <= a) return -inf;
        if (a <= l && r <= b) return t[p];
        int mid = (l + r) / 2;
        return max(get(2 * p + 1, l, mid, a, b), get(2 * p + 2, mid, r, a, b));
    }
    void set(int i, int x) {
        set(0, 0, n, i, x);
    }
    int get(int l, int r) {
        if (l == r) return -inf;
        return get(0, 0, n, l, r);
    }
};

vector<int> pref, hi;

void solve() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    pref.assign(m + 1, 0);
    hi.assign(m + 1, 1);
    int sm = 0, ind = 1;
    for (int i = 0; i < n + m; ++i) {
        int tp, h; cin >> tp >> h;
        if (tp == 1) {
            sm += h;
        } else {
            hi[ind] = h;
            pref[ind] = sm;
            ind++;
        }
    }
    SegTree ls(m + 1), gt(m + 1);
    vector<int> perm(m + 1); iota(all(perm), 0);
    sort(all(perm), [](int i, int j) {
        return pref[i] + hi[i] < pref[j] + hi[j];
    });
    vector<int> order(m + 1), srt(m + 1);
    for (int i = 0; i <= m; ++i) order[perm[i]] = i, srt[i] = pref[perm[i]] + hi[perm[i]];
    ls.set(order[0], c); gt.set(order[0], 0);
    vector<pair<int, int>> dp(m + 1, {0, 0});
    int opt = 0;
    for (int i = 1; i <= m; ++i) {
        int idx = upper_bound(all(srt), pref[i] + hi[i]) - srt.begin();
        dp[i].first = ls.get(0, idx) - (pref[i] + hi[i]) * c + p;
        dp[i].second = max(dp[i].first, gt.get(idx, gt.n) + p);
        ls.set(order[i], dp[i].first + (pref[i] + hi[i]) * c);
        gt.set(order[i], dp[i].first);
        opt = max(opt, dp[i].second);
    }
    cout << opt << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/a.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}