#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>

#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> v;
    return in;
}

const int inf = 1'000'000'000'000'000'000, sz = 400'000'000'000;

struct BadSegTree {
    struct node {
        int val, cache;
        node *left, *right;
        node() = default;
        node(int x) {
            val = x; cache = 0;
            left = right = nullptr;
        }
        void push(int l, int r, int c) {
            int mid = (l + r) / 2;
            if (!left) left = new node(-inf + (mid - 1) * c);
            if (!right) right = new node(-inf + (r - 1) * c);
        }
        void add(int x) {
            val += x; cache += x;
        }
    };
    int n, c; node* root;
    void push(node *p, int l, int r) {
        p->push(l, r, c);
        if (p->cache == 0) return;
        p->left->add(p->cache);
        p->right->add(p->cache);
        p->cache = 0;
    }
    BadSegTree() = default;
    BadSegTree(int _n, int _c) {
        n = _n, c = _c;
        root = new node(-inf + (n - 1) * c);
    }
    void add(node *p, int l, int r, int a, int b, int x) {
        if (l >= b || r <= a) return;
        if (a <= l && r <= b) {
            p->add(x);
            return;
        }
        int mid = (l + r) / 2; push(p, l, r);
        add(p->left, l, mid, a, b, x);
        add(p->right, mid, r, a, b, x);
        p->val = max(p->left->val, p->right->val);
    }
    void set(node *p, int l, int r, int i, int x) {
        if (l > i || r <= i) return;
        if (l + 1 == r) {
            p->val = max(p->val, x);
            p->cache = 0;
            return;
        }
        int mid = (l + r) / 2; push(p, l, r);
        set(p->left, l, mid, i, x);
        set(p->right, mid, r, i, x);
        p->val = max(p->left->val, p->right->val);
    }
    int get(node *p, int l, int r, int a, int b) {
        if (l >= b || r <= a) return -inf;
        if (a <= l && r <= b) return p->val;
        int mid = (l + r) / 2; push(p, l, r);
        return max(get(p->left, l, mid, a, b), get(p->right, mid, r, a, b));
    }
    void add(int l, int r, int x) {
        add(root, 0, n, l, r, x);
    }
    void set(int i, int x) {
        set(root, 0, n, i, x);
    }
    int get(int l, int r) {
        return get(root, 0, n, l, r);
    }
};

void solve() {
    int n, m, c, p; cin >> n >> m >> c >> p;
    BadSegTree g(sz, 0), b(sz, c); int zero = 0, opt = 0;
    g.set(1, 0); b.set(1, c);
    for (int i = 0; i < n + m; ++i) {
        int tp, h; cin >> tp >> h;
        if (tp == 1) {
            zero += h;
        } else {
            g.add(zero + h, g.n, p);
            int val = b.get(0, zero + h) - (zero + h) * c + p;
            g.set(zero + h, val);
            b.add(zero + h, g.n, p);
            b.set(zero + h, val + (zero + h) * c);
        }
        opt = max(opt, g.get(zero, g.n));
    }
    cout << opt << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/a.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}