#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>

#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

int n, m;
vector<vector<char>> tab;

void move(char mode) {
    if (mode == 'U' || mode == 'D') {
        vector<int> last(m, (mode == 'U') ? 0: n - 1);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                int ti = (mode == 'U') ? i: n - i - 1;
                if (tab[ti][j] == '.') continue;
                swap(tab[ti][j], tab[last[j]][j]);
                last[j] += (mode == 'U') ? 1: -1;
            }
        }
    } else {
        vector<int> last(n, (mode == 'L') ? 0: m - 1);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                int tj = (mode == 'L') ? j: m - j - 1;
                if (tab[i][tj] == '.') continue;
                swap(tab[i][tj], tab[i][last[i]]);
                last[i] += (mode == 'L') ? 1: -1;
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    tab.assign(n, vector<char>(m)); cin >> tab;
    string s; cin >> s; int q = (int)s.size();
    string t;
    map<char, char> d = {
        {'U', 'D'},
        {'L', 'R'},
        {'D', 'U'},
        {'R', 'L'}
    };
    for (int i = 0; i < q; ++i) {
        if (t.empty()) {
            t.push_back(s[i]);
        } else if (t.back() == s[i] || d[t.back()] == s[i]) {
            t.pop_back();
            if ((int)t.size() <= 1 || t[(int)t.size() - 2] != s[i]) {
                t.push_back(s[i]);
            }
        } else if ((int)t.size() <= 1 || t[(int)t.size() - 2] != s[i]) {
            t.push_back(s[i]);
        }
    }
    for (auto c: t) {
        move(c);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << tab[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/b.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
#endif
    cin >> _t;
    while (_t--) solve();
}