#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

vector<vector<int>> transform(vector<vector<int>> t, char c) {
    int m = t.size(), n = t[0].size();
    if (c == 'L') {
        for (int i = 0; i < m; ++i) {
            vector<int> res(n, -1);
            int k = 0;
            for (int j = 0; j < n; ++j) {
                if (t[i][j] != -1) {
                    res[k] = t[i][j];
                    k++;
                }
            }
            t[i] = res;
        }
    } else if (c == 'R') {
        for (int i = 0; i < m; ++i) {
            vector<int> res(n, -1);
            int k = 1;
            for (int j = n - 1; j >= 0; --j) {
                if (t[i][j] != -1) {
                    res[n - k] = t[i][j];
                    k++;
                }
            }
            t[i] = res;
        }
    } else if (c == 'U') {
        for (int j = 0; j < n; ++j) {
            vector<int> res(m, -1);
            int k = 0;
            for (int i = 0; i < m; ++i) {
                if (t[i][j] != -1) {
                    res[k] = t[i][j];
                    k++;
                }
            }
            for (int i = 0; i < m; ++i) {
                t[i][j] = res[i];
            }
        }
    } else if (c == 'D') {
        for (int j = 0; j < n; ++j) {
            vector<int> res(m, -1);
            int k = 1;
            for (int i = m - 1; i >= 0; --i) {
                if (t[i][j] != -1) {
                    res[m - k] = t[i][j];
                    k++;
                }
            }
            for (int i = 0; i < m; ++i) {
                t[i][j] = res[i];
            }
        }
    }
    return t;
}

void print_t(vector<vector<int>> t) {
    int m = t.size(), n = t[0].size();
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << (char)(t[i][j] == -1 ? '.' : 'a' + t[i][j]);
        }
        cout << "\n";
    }
}

void solve() {
    int n, m;
    cin >> m >> n;

    vector<vector<int>> t(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            char c;
            cin >> c;
            t[i][j] = (c == '.' ? -1 : c - 'a');
        }
    }

    string s;
    cin >> s;

    int vertical = 0, horizontal = 0;
    int v = 0, h = 0;

    string qs;

    for (auto c : s) {
        if (c == 'U' && vertical != -1) {
            if (v >= 2 && !qs.empty() && qs.back() == 'D') {
                qs.pop_back();
                v--;
            } else {
                qs.push_back('U');
                v++;
            }
            vertical = -1;
        }
        if (c == 'D' && vertical != 1) {
            if (v >= 2 && !qs.empty() && qs.back() == 'U') {
                qs.pop_back();
                v--;
            } else {
                qs.push_back('D');
                v++;
            }
            vertical = 1;
        }
        if (c == 'R' && horizontal != 1) {
            if (h >= 2 && !qs.empty() && qs.back() == 'L') {
                qs.pop_back();
                h--;
            } else {
                qs.push_back('R');
                h++;
            }
            horizontal = 1;
        }
        if (c == 'L' && horizontal != -1) {
            if (h >= 2 && !qs.empty() && qs.back() == 'R') {
                qs.pop_back();
                h--;
            } else {
                qs.push_back('L');
                h++;
            }
            horizontal = -1;
        }
    }

    if (vertical == 0) {
        if (horizontal == 1) {
            t = transform(t, 'R');
        } else {
            t = transform(t, 'L');
        }
        print_t(t);
        return;
    } else if (horizontal == 0) {
        if (vertical == 1) {
            t = transform(t, 'D');
        } else {
            t = transform(t, 'U');
        }
        print_t(t);
        return;
    }


    for (int i = 0; i < min(2, (int)qs.size()); ++i) {
        auto c = qs[i];
        t = transform(t, c);
    }

    if (qs.size() <= 2) {
        print_t(t);
        return;
    }

    for (auto c : "UL") {
        t = transform(t, c);
    }

    if (vertical == 1) {
        reverse(t.begin(), t.end());
    }
    if (horizontal == 1) {
        for (int i = 0; i < m; ++i) {
            reverse(t[i].begin(), t[i].end());
        }
    }

    print_t(t);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
