#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

const ll LLINF = 1e18;

struct SegmentTree {
    vector<ll> tree;
    SegmentTree(int n) {
        tree.resize(4 * n);
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = LLINF;
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void assign(int v, int l, int r, int qi, ll qx) {
        if (qi < l || r <= qi) {
            return;
        }
        if (r - l == 1) {
            tree[v] = qx;
            return;
        }
        int mid = (l + r) / 2;
        assign(2 * v + 1, l, mid, qi, qx);
        assign(2 * v + 2, mid, r, qi, qx);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }

    ll get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return LLINF;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        auto lres = get(2 * v + 1, l, mid, ql, qr);
        auto rres = get(2 * v + 2, mid, r, ql, qr);
        return min(lres, rres);
    }
};

void solve() {
    ll n, m, k, p;
    cin >> n >> m >> k >> p;

    m = min(m, n);

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> ldp(n + 1, LLINF), rdp(n + 1, LLINF);
    SegmentTree ltree(n + 1), rtree(n + 1), rtreep(n + 1);
    ldp[0] = 0;
    rdp[0] = n + 1;
    ltree.assign(0, 0, n + 1, 0, 0);
    rtree.assign(0, 0, n + 1, 0, n + 1);
    rtreep.assign(0, 0, n + 1, 0, 3 * (n + 1) - 2);
    for (int i = 1; i <= n; ++i) {
        ldp[i] = min(ltree.get(0, 0, n + 1, i - m, i) + 2 * i, rtree.get(0, 0, n + 1, i - m, i) + n + 1);
        rdp[i] = min(ltree.get(0, 0, n + 1, i - m, i) + n + 1, rtreep.get(0, 0, n + 1, i - m, i));
        ltree.assign(0, 0, n + 1, i, ldp[i]);
        rtree.assign(0, 0, n + 1, i, rdp[i]);
        rtreep.assign(0, 0, n + 1, i, rdp[i] + 2 * (n - i));
    }

    cout << rdp[n] << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
