#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

const ll LLINF = 1e18;

vector<int> a;
void shrink_init() {
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
}

int get_shrinked(int x) {
    return lower_bound(a.begin(), a.end(), x) - a.begin();
}

struct Rect {
    int x1, y1, x2, y2;
};

void solve() {
    int n;
    cin >> n;

    vector<Rect> rectangles(n);
    for (int i = 0; i < n; ++i) {
        cin >> rectangles[i].x1 >> rectangles[i].y1 >> rectangles[i].x2 >> rectangles[i].y2;
        a.push_back(rectangles[i].y1);
        a.push_back(rectangles[i].y2);
    }

    shrink_init();

    int m = a.size();
    vector<vector<pair<int, int>>> rows(m);
    for (auto [x1, y1, x2, y2] : rectangles) {
        for (int y = get_shrinked(y1); y <= get_shrinked(y2); ++y) {
            rows[y].push_back({x1, 1});
            rows[y].push_back({x2, -1});
        }
    }
    for (int i = 0; i < m; ++i) {
        sort(rows.begin(), rows.end());
    }
    map<pair<int, int>, int> cnt;
    for (int i = 0; i < m; ++i) {
        int px = -1, s = 0;
        for (auto [x, d] : rows[i]) {
            if (d == 1 && s == 0) {
                px = x;
            }
            s += d;
            if (s == 0) {
                cnt[{px, x}]++;
                px = -1;
            }
        }
    }
    cout << cnt.size() << "\n";
    for (auto [p, c] : cnt) {
        cout << p.first << " " << p.second << " " << c << " " << 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
     cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
