#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

const ll LLINF = 1e18;

struct Rect {
    int x1, y1, x2, y2;
};

void solve() {
    int n;
    cin >> n;

    vector<Rect> rectangles(n);
    int W = 0, H = 0;
    for (int i = 0; i < n; ++i) {
        cin >> rectangles[i].x1 >> rectangles[i].y1 >> rectangles[i].x2 >> rectangles[i].y2;
        auto [x1, y1, x2, y2] = rectangles[i];
        W = max(W, x2);
        H = max(H, y2);
    }
    W++, H++;
    W++, H++;

    vector<vector<int>> d(H + 1, vector<int>(W + 1, 0));

    for (auto [x1, y1, x2, y2] : rectangles) {
        x2++, y2++;
        d[y1][x1]++;
        d[y2][x1]--;
        d[y1][x2]--;
        d[y2][x2]++;
    }

    vector<vector<int>> pref(H, vector<int>(W, 0));
    for (int i = 0; i < H; ++i) {
        for (int j = 0; j < W; ++j) {
            pref[i][j] = d[i][j];
            if (i != 0) {
                pref[i][j] += pref[i - 1][j];
            }
            if (j != 0) {
                pref[i][j] += pref[i][j - 1];
            }
            if (i != 0 && j != 0){
                pref[i][j] -= pref[i - 1][j - 1];
            }
        }
    }

    vector<vector<pair<int, int>>> rows(H);
    for (int i = 0; i < H; ++i) {
        for (int j = 0; j < W; ++j) {
            if (pref[i][j] > 0 && (j == 0 || pref[i][j - 1] == 0)) {
                rows[i].push_back({j, -1});
            } else if (pref[i][j] == 0 && j > 0 && pref[i][j - 1] > 0) {
                rows[i].push_back({j, 1});
            }
        }
    }

    for (int i = 0; i < H; ++i) {
        sort(rows[i].begin(), rows[i].end());
    }
    map<pair<int, int>, int> cnt;
    map<pair<int, int>, int> cnt_max;
    map<pair<int, int>, int> prev;
    for (int i = 0; i < H - 1; ++i) {
        map<pair<int, int>, int> cur;
        int px = -1, s = 0;
        for (auto [x, d] : rows[i]) {
            d *= -1;
            if (d == 1 && s == 0) {
                px = x;
            }
            s += d;
            if (s == 0) {
                cnt[{px, x - 1}] += 1;
                if (prev.count({px, x - 1})) {
                    cur[{px, x - 1}] = prev[{px, x - 1}] + 1;
                } else {
                    cur[{px, x - 1}] = 1;
                }
                cnt_max[{px, x - 1}] = max(cnt_max[{px, x - 1}], cur[{px, x - 1}]);
                px = -1;
            }
        }
        prev = cur;
    }
    cout << cnt.size() << "\n";
    for (auto [p, c] : cnt) {
        cout << p.first << " " << p.second << " " << c << " " << cnt_max[p] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
