#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

const ll LLINF = 1e18;

vector<int> a;
void shrink_init() {
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
}

int get_shrinked(int x) {
    return lower_bound(a.begin(), a.end(), x) - a.begin();
}

struct Rect {
    int x1, y1, x2, y2;
};

const int SZ = 5002;

void solve() {
    int n;
    cin >> n;
    a.clear();

    vector<Rect> rectangles(n);
    vector<vector<int>> d(SZ + 1, vector<int>(SZ + 1, 0));
    for (int i = 0; i < n; ++i) {
        cin >> rectangles[i].x1 >> rectangles[i].y1 >> rectangles[i].x2 >> rectangles[i].y2;
        auto [x1, y1, x2, y2] = rectangles[i];
        x2++, y2++;
        d[x1][y1]++;
        d[x2][y1]--;
        d[x1][y2]--;
        d[x2][y2]++;
        a.push_back(rectangles[i].y1);
        a.push_back(rectangles[i].y2 + 1);
    }

    vector<vector<int>> pref(SZ, vector<int>(SZ, 0));
    for (int i = 0; i < SZ; ++i) {
        for (int j = 0; j < SZ; ++j) {
            pref[i][j] = d[i][j];
            if (i != 0) {
                pref[i][j] += pref[i - 1][j];
            }
            if (j != 0) {
                pref[i][j] += pref[i][j - 1];
            }
            if (i != 0 && j != 0){
                pref[i][j] -= pref[i - 1][j - 1];
            }
        }
    }

    vector<vector<pair<int, int>>> rows(SZ);
    for (int i = 0; i < SZ; ++i) {
        for (int j = 0; j < SZ; ++j) {
            if (pref[i][j] > 0 && (j == 0 || pref[i][j - 1] == 0)) {
                rows[i].push_back({j, -1});
            } else if (pref[i][j] == 0 && j > 0 && pref[i][j - 1] == 0) {
                rows[j].push_back({j, 1});
            }
        }
    }

    for (int i = 0; i < SZ; ++i) {
        sort(rows[i].begin(), rows[i].end());
    }
    map<pair<int, int>, int> cnt;
    map<pair<int, int>, int> cnt_max;
    map<pair<int, int>, int> prev;
    for (int i = 0; i < SZ - 1; ++i) {
        map<pair<int, int>, int> cur;
        int px = -1, s = 0;
        for (auto [x, d] : rows[i]) {
            d *= -1;
            if (d == 1 && s == 0) {
                px = x;
            }
            s += d;
            if (s == 0) {
                cnt[{px, x - 1}] += a[i + 1] - a[i];
                if (prev.count({px, x - 1})) {
                    cur[{px, x - 1}] = prev[{px, x - 1}] + a[i + 1] - a[i];
                } else {
                    cur[{px, x - 1}] = a[i + 1] - a[i];
                }
                cnt_max[{px, x - 1}] = max(cnt_max[{px, x - 1}], cur[{px, x - 1}]);
                px = -1;
            }
        }
        prev = cur;
    }
    cout << cnt.size() << "\n";
    for (auto [p, c] : cnt) {
        cout << p.first << " " << p.second << " " << c << " " << cnt_max[p] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
