#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct rect {
    int xl, yl, xr, yr;
};

bool comp(rect& r1, rect& r2) {
    if (r1.xl != r2.xl) return r1.xl < r2.xl;
    return r1.xr < r2.xr;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n;
        cin >> n;
        vector<rect> rects(n);
        for (int j = 0; j < n; ++j)
            cin >> rects[j].xl >> rects[j].yl >> rects[j].xr >> rects[j].yr;
        sort(rects.begin(), rects.end(), comp);
        int curL = rects[0].xl, curR = rects[0].xr;
        vector<pair<int, int>> ans;
        for (int j = 1; j < n; ++j) {
            if (rects[j].xl > curR) {
                ans.emplace_back(curL, curR);
                curL = rects[j].xl;
                curR = rects[j].xr;
            } else {
                curR = max(curR, rects[j].xr);
            }
        }
        ans.emplace_back(curL, curR);
        cout << ans.size() << "\n";
        for (auto &[l, r] : ans)
            cout << l << ' ' << r << " 1 1\n";
    }
    return 0;
}