#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using pii = pair<int, int>;


void left(vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int p = j;
            while (p != 0 && a[i][p] != -1 && a[i][p - 1] == -1) {
                swap(a[i][p], a[i][p - 1]);
                p--;
            }
        }
    }
}

void right(vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            int p = j;
            while (p != m - 1 && a[i][p] != -1 && a[i][p + 1] == -1) {
                swap(a[i][p], a[i][p + 1]);
                p++;
            }
        }
    }
}

void up(vector<vector<int>>& a, int n, int m) {
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            int p = i;
            while (p != 0 && a[p][j] != -1 && a[p - 1][j] == -1) {
                swap(a[p][j], a[p - 1][j]);
                --p;
            }
        }
    }
}


void down(vector<vector<int>>& a, int n, int m) {
    for (int j = 0; j < m; ++j) {
        for (int i = n - 1; i >= 0; --i) {
            int p = i;
            while (p != n - 1 && a[p][j] != -1 && a[p + 1][j] == -1) {
                swap(a[p][j], a[p + 1][j]);
                ++p;
            }
        }
    }
}

int type(char c) {
    if (c == 'L' || c == 'R') return 0;
    return 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> a(n, vector<int> (m));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                char c;
                cin >> c;
                if (c == '.') {
                    a[i][j] = -1;
                } else {
                    a[i][j] = c - 'a';
                }
            }
        }
        string s, old_s;
        cin >> old_s;
        int q = old_s.size();
        for (int i = 1; i < q; ++i) {
            if (type(old_s[i - 1]) == type(old_s[i])) continue;
            s += old_s[i - 1];
        }
        s += old_s[q - 1];
        if (s.size() <= 3) {
            for (int i = 0; i < (int) s.size(); ++i) {
                char c = s[i];
                if (c == 'L') {
                    left(a, n, m);
                } else if (c == 'R') {
                    right(a, n, m);
                } else if (c == 'U') {
                    up(a, n, m);
                } else {
                    down(a, n, m);
                }
            }
            for (auto& el : a) {
                for (auto c : el) {
                    if (c == -1) {
                        cout << '.';
                    } else {
                        cout << string(1, 'a' + c);
                    }
                }
                cout << "\n";
            }
            continue;
        }
        int last_lr = -1, last_ud = -1;
        string s2;
        s2 += s[0];
        s2 += s[1];
        if (type(s[0]) == 0) {
            if (s[0] == 'L') {
                last_lr = 0;
            } else {
                last_lr = 1;
            }
        } else {
            if (s[0] == 'U') {
                last_ud = 0;
            } else {
                last_ud = 1;
            }
        }
        if (type(s[1]) == 0) {
            if (s[1] == 'L') {
                last_lr = 0;
            } else {
                last_lr = 1;
            }
        } else {
            if (s[1] == 'U') {
                last_ud = 0;
            } else {
                last_ud = 1;
            }
        }
        for (int i = 2; i < s.size(); ++i) {
            if (type(s[i]) == 0) {
                if (last_lr == 0 && s[i] == 'L' || last_lr == 1 && s[i] == 'R') continue;
                last_lr = 1 - last_lr;
                s2 += s[i];
            } else {
                if (last_ud == 0 && s[i] == 'U' || last_ud == 1 && s[i] == 'D') continue;
                last_ud = 1 - last_ud;
                s2 += s[i];
            }
        }
        s = s2;
        if (s.size() > 4) {
            for (int i = s.size() - 5; i < s.size(); ++i) {
                char c = s[i];
                if (c == 'L') {
                    left(a, n, m);
                } else if (c == 'R') {
                    right(a, n, m);
                } else if (c == 'U') {
                    up(a, n, m);
                } else {
                    down(a, n, m);
                }
            }
        } else {
            for (int i = 0; i < min(4, (int) s.size()); ++i) {
                char c = s[i];
                if (c == 'L') {
                    left(a, n, m);
                } else if (c == 'R') {
                    right(a, n, m);
                } else if (c == 'U') {
                    up(a, n, m);
                } else {
                    down(a, n, m);
                }
            }
        }
        for (auto& el : a) {
            for (auto c : el) {
                if (c == -1) {
                    cout << '.';
                } else {
                    cout << string(1, 'a' + c);
                }
            }
            cout << "\n";
        }
    }
    return 0;
}
