#include <iostream>
#include <vector>
using namespace std;

int m, n;
vector<string> a;

void left()
{
    for(int i = 0; i < m; ++i){
        int p = 0;
        for(int j = 0; j < n; ++j){
            if(a[i][j] != '.'){
                swap(a[i][j], a[i][p]);
                ++p;
            }
        }
    }
}
void right()
{
    for(int i = 0; i < m; ++i){
        int p = n - 1;
        for(int j = n - 1; j >= 0; --j){
            if(a[i][j] != '.'){
                swap(a[i][j], a[i][p]);
                --p;
            }
        }
    }
}
void up()
{
    for(int i = 0; i < n; ++i){
        int p = 0;
        for(int j = 0; j < m; ++j){
            if(a[j][i] != '.'){
                swap(a[j][i], a[p][i]);
                ++p;
            }
        }
    }
}
void down()
{
    for(int i = 0; i < n; ++i){
        int p = m - 1;
        for(int j = m - 1; j >= 0; --j){
            if(a[j][i] != '.'){
                swap(a[j][i], a[p][i]);
                --p;
            }
        }
    }
}

void f(char c)
{
    if(c == 'L') left();
    if(c == 'R') right();
    if(c == 'D') down();
    if(c == 'U') up();
}

bool blr = 0, bud = 0;

void lr()
{
    for(int i = 0; i < m; ++i){
        for(int j = 0; 2*j < n - 1; ++j){
            swap(a[i][j], a[i][n - 1 - j]);
        }
    }
    blr = !blr;
}
void ud()
{
    for(int i = 0; i < n; ++i){
        for(int j = 0; 2*j < m - 1; ++j){
            swap(a[j][i], a[m - 1 - j][i]);
        }
    }
    bud = !bud;
}

void print(bool z = 1)
{
    bool x = blr, y = bud;
    if(z){
        if(x) lr();
        if(y) ud();
    }
    // cout << endl;
    for(int i = 0; i < m; ++i) cout << a[i] << endl;
    if(z){
        if(x) lr();
        if(y) ud();
    }
}

int *w, *h;

void move(int &i, int &j, int x)
{
    bool lr = 1;
    if(x < 0) lr = 0;
    for(int k = 0; k < abs(x); ++k){
        if(lr) j = w[i] - 1 - j;
        else i = h[j] - 1 - i;
        lr = !lr;
    }
}

int main()
{
    int t;
    cin >> t;
    for(int test = 0; test < t; ++test){
        cin >> m >> n;
        a.resize(m);
        for(int i = 0; i < m; ++i) cin >> a[i];
        string s;
        cin >> s;
        int q = s.size();
        int i = 0;
        while(i < q && s[i] == 'L' || s[i] == 'R') ++i;
        if(i > 0) f(s[i - 1]);
        if(i == q){
            print();
            continue;
        }
        while(i < q && s[i] == 'U' || s[i] == 'D') ++i;
        f(s[i - 1]);
        if(s[i - 1] == 'D') ud(); 
        if(i == q){
            print();
            continue;
        }
        while(i < q && s[i] == 'L' || s[i] == 'R') ++i;
        f(s[i - 1]);
        if(s[i - 1] == 'R') lr(); 
        if(i == q){
            print();
            continue;
        }
        // print(0);
        int x = 0;
        for(; i < q; ++i){
            char c = s[i];
            if(blr){
                if(c == 'L') c = 'R';
                else if(c == 'R') c = 'L';
            }
            if(bud){
                if(c == 'U') c = 'D';
                else if(c == 'D') c = 'U';
            }
            int r = (x%4 + 4)%4;
            if(c == 'L'){
                if(r == 1) x -= 1;
                if(r == 2) x += 1;
            }
            if(c == 'R'){
                if(r == 3) x -= 1;
                if(r == 0) x += 1;
            }
            if(c == 'D'){
                if(r == 0) x -= 1;
                if(r == 1) x += 1;
            }
            if(c == 'U'){
                if(r == 2) x -= 1;
                if(r == 3) x += 1;
            }
        }
        int r = (x%4 + 4)%4;
        vector<string> b;
        b.resize(m);
        for(int i = 0; i < m; ++i) for(int j = 0; j < n; ++j) b[i].push_back('.');
        w = new int[m];
        for(int i = 0; i < m; ++i){
            int j = 0;
            for(; j < n && a[i][j] != '.'; ++j){}
            w[i] = j;
        }
        h = new int[n];
        for(int i = 0; i < n; ++i){
            int j = 0;
            for(; j < m && a[j][i] != '.'; ++j){}
            h[i] = j;
        }
        // for(int i = 0; i < n; ++i) cout << ' ' << h[i];
        // cout << endl;
        // for(int j = 0; j < m; ++j) cout << ' ' << w[j];
        // cout << endl;
        // // print();
        // cout << x << endl;
        if(x%2 == 0) x = -x;
        // print(0);
        for(int i = 0; i < m; ++i) for(int j = 0; j < w[i]; ++j){
            if(b[i][j] == '.'){
                int ii = i, jj = j;
                move(ii, jj, x);
                b[i][j] = a[ii][jj];
                int i1 = i, j1 = j;
                move(i1, j1, 2);
                while(i1 != i || j1 != j){
                    if(x%2 == 0) move(ii, jj, 2);
                    else move(ii, jj, -2);
                    b[i1][j1] = a[ii][jj];
                    move(i1, j1, 2);
                }
            }
        }
        swap(a, b);
        if(r == 1 || r == 2) blr = !blr;
        if(r == 3 || r == 2) bud = !bud;
        print();
    }
}