#include "iostream"
#include "vector"

using ll = long long;

void update(int t, int posH, int posV, std::vector<std::vector<char>> &h, std::vector<std::vector<char>> &v) {
    if(t == 1) {
        for(auto &vec : h) {
            vec.resize(0);
        }
        for(auto &vec : v) {
            for(int i = 0; i < vec.size(); i++) {
                if(posV == 1) {
                    h[i].push_back(vec[i]);
                } else {
                    h[h.size() - 1 - i].push_back(vec[vec.size() - 1 - i]);
                }
            }
        }
    } else {
        for(auto &vec : v) {
            vec.resize(0);
        }
        for(auto &vec : h) {
            for(int i = 0; i < vec.size(); i++) {
                if(posH == 1) {
                    v[i].push_back(vec[i]);
                } else {
                    v[v.size() - 1 - i].push_back(vec[vec.size() - 1 - i]);
                }
            }
        }
    }
}

void solve() {
    int n, m;
    std::cin >> m >> n;
    std::vector<std::vector<char>> horizontal(m), vertical(n);
    for(int i = 0; i < m; i++) {
        for(int j = 0; j < n; j++) {
            char c;
            std::cin >> c;
            if(c != '.') {
                horizontal[i].push_back(c);
                vertical[j].push_back(c);
            }
        }
    }
    std::vector<char> op;
    {
        std::string s;
        std::cin >> s;
        bool wasD, wasR, wasU, wasL;
        wasD = wasR = wasU = wasL = false;
        for(auto &c : s) {
            if(c == 'D' && !wasD) {
                wasD = true;
                wasU = false;
                op.push_back(c);
            } else if(c == 'U' && !wasU) {
                wasU = true;
                wasD = false;
                op.push_back(c);
            } else if(c == 'L' && !wasL) {
                wasL = true;
                wasR = false;
                op.push_back(c);
            } else if(c == 'R' && !wasR) {
                wasR = true;
                wasL = false;
                op.push_back(c);
            }
        }
    }
    int v = 0, h = 0;
    bool updateH = false, updateV = false;
    for(auto &c : op) {
        if(c == 'L' || c == 'R') {
            if(!h) {
                updateV = true;
            }
            h = (c == 'R') + 1;
            if(updateH) {
                update(1, h, v, horizontal, vertical);
                updateH = false;
                updateV = true;
            }
        } else {
            if(!v) {
                updateH = true;
            }
            v = (c == 'D') + 1;
            if(updateV) {
                update(2, h, v, horizontal, vertical);
                updateV = false;
                updateH = true;
            }
        }
    }
    std::vector<std::vector<char>> ans(m, std::vector<char>(n, '.'));
    if(!updateH) {
        for(int i = 0; i < m; i++) {
            for(int j = 0; j < horizontal[i].size(); j++) {
                if(h == 1) {
                    ans[i][j] = horizontal[i][j];
                } else {
                    ans[i][n - j - 1] = horizontal[i][horizontal[i].size() - 1 - j];
                }
            }
        }
    } else {
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < vertical[i].size(); j++) {
                if(v == 1) {
                    ans[j][i] = vertical[i][j];
                } else {
                    ans[m - j - 1][i] = vertical[i][vertical[i].size() - 1 - j];
                }
            }
        }
    }
    for(auto &vec : ans) {
        for(auto &i : vec) std::cout << i;
        std::cout << '\n';
    }
}

signed main() {
    int t;
    std::cin >> t;
    while(t--) {
        solve();
    }
}