#include "iostream"
#include "vector"
#include "map"
#include "algorithm"
using ll = long long;

struct point{
    ll x, y;
};

struct edge{
    int x, y, y1;
    bool type;
};

void solve() {
    int n;
    std::cin >> n;
    if(n == 1) {
        int x1, x2, y1, y2;
        std::cin >> x1 >> y1 >> x2 >> y2;
        std::cout << 1 << '\n';
        std::cout << x1 << ' ' << x2 << ' ' << y2 - y1 + 1 << ' ' << y2 - y1 + 1 << '\n';
    } else {
        std::vector<edge> a;
        int maxY = 0;
        for(int i = 0; i < n; i++) {
            edge open;
            std::cin >> open.x >> open.y;
            edge close;
            std::cin >> close.x >> close.y1;
            close.y = open.y;
            open.y1 = close.y1;
            maxY = std::max(maxY, open.y1);
            open.type = true;
            close.type = false;
            a.push_back(open);
            a.push_back(close);
        }
        std::sort(a.begin(), a.end(), [](edge &a, edge &b){
            if(a.type != b.type) {
                if(a.type) {
                    return a.x - 1 <= b.x;
                } else {
                    return !(b.x - 1 <= a.x);
                }
            } else {
                return a.x < b.x;
            }
        });
        std::vector<std::pair<int, int>> ys(maxY + 1, {0, 1e9});
        std::map<std::pair<int, int>, std::pair<int, int>> ans;
        for(auto &e : a) {
            if(e.type) {
                for(int i = e.y; i <= e.y1; i++) {
                    ys[i].first++;
                    ys[i].second = std::min(e.x, ys[i].second);
                }
            } else {
                ll x1 = -1;
                int cnt = 0;
                for(int i = e.y; i <= e.y1; i++) {
                    if(ys[i].first == 1) {
                        if(ys[i].second == x1) {
                            cnt++;
                        } else {
                            x1 = ys[i].second;
                            cnt = 1;
                        }
                        ans[{x1, e.x}].first++;
                        ans[{x1, e.x}].second = std::max(cnt, ans[{x1, e.x}].second);
                        ys[i].second = 1e9;
                    } else {
                        x1 = -1;
                    }
                    ys[i].first--;
                }
            }
        }
        std::cout << ans.size() << '\n';
        for(auto [f, s] : ans) {
            std::cout << f.first << ' ' << f.second << ' ' << s.first << ' ' << s.second << '\n';
        }
    }
}

void solve2() {
    int n;
    std::cin >> n;
    if(n == 1) {
        int x1, x2, y1, y2;
        std::cin >> x1 >> y1 >> x2 >> y2;
        std::cout << 1 << '\n';
        std::cout << x1 << ' ' << x2 << ' ' << y2 - y1 + 1 << ' ' << y2 - y1 + 1 << '\n';
    } else {
        std::vector<edge> a;
        int maxY = 0;
        for(int i = 0; i < n; i++) {
            edge open;
            std::cin >> open.x >> open.y;
            edge close;
            std::cin >> close.x >> close.y1;
            close.y = open.y;
            open.y1 = close.y1;
            maxY = std::max(maxY, open.y1);
            open.type = true;
            close.type = false;
            a.push_back(open);
            a.push_back(close);
        }
        std::sort(a.begin(), a.end(), [](edge &a, edge &b){
            if(a.type != b.type) {
                if(a.type) {
                    return a.x - 1 <= b.x;
                } else {
                    return !(b.x - 1 <= a.x);
                }
            } else {
                return a.x < b.x;
            }
        });
        std::vector<std::pair<int, int>> ys(maxY + 2, {0, 1e9});
        std::map<std::pair<int, int>, std::pair<int, int>> ans;
        for(auto &e : a) {
            if(e.type) {
                ys[e.y].first++;
                ys[e.y].second = std::min(ys[e.y].second, e.x);
                ys[e.y1 + 1].first--;
                ys[e.y1 + 1].second = std::min(ys[e.y1 + 1].second, int(1e9));
            } else {
                ll x1 = -1;
                int cnt = 0;    
                for(int i = e.y; i <= e.y1; i++) {
                    if(ys[i].first == 1) {
                        if(ys[i].second == x1) {
                            cnt++;
                        } else {
                            x1 = ys[i].second;
                            cnt = 1;
                        }
                        ans[{x1, e.x}].first++;
                        ans[{x1, e.x}].second = std::max(cnt, ans[{x1, e.x}].second);
                        ys[i].second = 1e9;
                    } else {
                        x1 = -1;
                    }
                    ys[i].first--;
                }
            }
        }
        std::cout << ans.size() << '\n';
        for(auto [f, s] : ans) {
            std::cout << f.first << ' ' << f.second << ' ' << s.first << ' ' << s.second << '\n';
        }
    }
}

signed main() {
    int t;
    std::cin >> t;
    while(t--) {
        solve();
    }
}