#include "iostream"
#include "vector"
#include "map"
#include "algorithm"
using ll = long long;

struct point{
    ll x, y;
};

struct edge{
    int x, y, y1;
    bool type;
};

void solve() {
    int n;
    std::cin >> n;
    if(n == 1) {
        int x1, x2, y1, y2;
        std::cin >> x1 >> y1 >> x2 >> y2;
        std::cout << 1 << '\n';
        std::cout << x1 << ' ' << x2 << ' ' << y2 - y1 + 1 << ' ' << y2 - y1 + 1 << '\n';
    } else {
        std::vector<edge> a;
        int maxY = 0;
        std::vector<int> sorted;
        for(int i = 0; i < n; i++) {
            edge open;
            std::cin >> open.x >> open.y;
            edge close;
            std::cin >> close.x >> close.y1;
            sorted.push_back(open.y);
            sorted.push_back(close.y1);
            sorted.push_back(close.y1 + 1);
            close.y = open.y;
            open.y1 = close.y1;
            maxY = std::max(maxY, open.y1);
            open.type = true;
            close.type = false;
            a.push_back(open);
            a.push_back(close);
        }
        std::sort(sorted.begin(), sorted.end());
        sorted.erase(std::unique(sorted.begin(), sorted.end()), sorted.end());
        std::sort(a.begin(), a.end(), [](edge &a, edge &b){
            if(a.type != b.type) {
                if(a.type) {
                    return a.x - 1 <= b.x;
                } else {
                    return !(b.x - 1 <= a.x);
                }
            } else {
                return a.x < b.x;
            }
        });
        std::vector<std::pair<int, int>> mys(sorted.size() + 1, {0, 1e9});
        std::map<std::pair<int, int>, std::pair<int, int>> ans;
        for(auto &e : a) {
            int y1 = std::lower_bound(sorted.begin(), sorted.end(), e.y) - sorted.begin();
            int y2 = std::lower_bound(sorted.begin(), sorted.end(),e.y1) - sorted.begin();
            if(e.type) {
                mys[y1].first++;
                mys[y2 + 1].first--;
                for(int i = y1; i <= y2; i++) {
                    mys[i].second = std::min(mys[i].second, e.x);
                }
            } else {
                ll x1 = -1;
                int cnt = 0;
                int cur = 0;
                for(int i = 0; i <= sorted.size(); i++) {
                    cur += mys[i].first;
                    if(y1 <= i && i <= y2) {
                        if(cur == 1) {
                            if(mys[i].second == x1) {
                                cnt++;
                            } else {
                                x1 = mys[i].second;
                                cnt = 1;
                            }
                            ans[{x1, e.x}].first++;
                            ans[{x1, e.x}].second = std::max(cnt, ans[{x1, e.x}].second);
                            mys[i].second = 1e9;
                        } else {
                            x1 = -1;
                        }
                    } else {
                        x1 = -1;
                    }
                }
                mys[y1].first--;
                mys[y2 + 1].first++;
            }
        }
        std::cout << ans.size() << '\n';
        for(auto [f, s] : ans) {
            std::cout << f.first << ' ' << f.second << ' ' << s.first << ' ' << s.second << '\n';
        }
    }
}

signed main() {
    int t;
    std::cin >> t;
    while(t--) {
        solve();
    }
}