#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

void to_up(vector<string>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = '.';

    for (int i = 0; i < m; ++i) {
        int it = 0;
        for (int j = 0; j < n; ++j)
            if (a[j][i] != '.')
                res[it++][i] = a[j][i];
    }
    a = res;
}

void to_down(vector<string>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = '.';

    for (int i = 0; i < m; ++i) {
        int it = n - 1;
        for (int j = n - 1; j > -1; --j)
            if (a[j][i] != '.')
                res[it--][i] = a[j][i];
    }
    a = res;
}

void to_left(vector<string>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = '.';

    for (int i = 0; i < n; ++i) {
        int it = 0;
        for (int j = 0; j < m; ++j)
            if (a[i][j] != '.')
                res[i][it++] = a[i][j];
    }
    a = res;
}

void to_right(vector<string>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = '.';

    for (int i = 0; i < n; ++i) {
        int it = m - 1;
        for (int j = m - 1; j > -1; --j)
            if (a[i][j] != '.')
                res[i][it--] = a[i][j];
    }
    a = res;
}

void to_up(vector<vector<int>>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = -1;

    for (int i = 0; i < m; ++i) {
        int it = 0;
        for (int j = 0; j < n; ++j)
            if (a[j][i] != -1)
                res[it++][i] = a[j][i];
    }
    a = res;
}

void to_down(vector<vector<int>>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = -1;

    for (int i = 0; i < m; ++i) {
        int it = n - 1;
        for (int j = n - 1; j > -1; --j)
            if (a[j][i] != -1)
                res[it--][i] = a[j][i];
    }
    a = res;
}

void to_left(vector<vector<int>>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = -1;

    for (int i = 0; i < n; ++i) {
        int it = 0;
        for (int j = 0; j < m; ++j)
            if (a[i][j] != -1)
                res[i][it++] = a[i][j];
    }
    a = res;
}

void to_right(vector<vector<int>>& a) {
    int n = (int)a.size(), m = (int)a[0].size();

    auto res = a;
    for (auto& i : res)
        for (auto& j : i)
            j = -1;

    for (int i = 0; i < n; ++i) {
        int it = m - 1;
        for (int j = m - 1; j > -1; --j)
            if (a[i][j] != -1)
                res[i][it--] = a[i][j];
    }
    a = res;
}

vector<int> prod(const vector<int>& p, const vector<int>& q) {
    int n = p.size();

    vector<int> res(n);
    for (int i = 0; i < n; ++i)
        res[i] = p[q[i]];
    return res;
}

vector<int> qpow(const vector<int>& p, int n) {
    if (n == 0) {
        auto res = p;
        iota(all(res), 0);
        return res;
    }
    if (n % 2 == 0)
        return qpow(prod(p, p), n / 2);
    return prod(p, qpow(prod(p, p), n / 2));
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto &i: a)
        cin >> i;
    string s;
    cin >> s;

    map<char, char> op;
    op['U'] = 'D';
    op['D'] = 'U';
    op['L'] = 'R';
    op['R'] = 'L';

    vector<char> b;
    for (auto c: s) {
        if (b.empty()) {
            b.push_back(c);
            continue;
        }

        if (b.back() == c || b.back() == op[c])
            b.back() = c;
        else
            b.push_back(c);
    }

    s = "";
    for (auto c: b)
        s += c;

    if (s.size() <= 10) {
        for (auto c: s) {
            if (c == 'U')
                to_up(a);
            else if (c == 'D')
                to_down(a);
            else if (c == 'L')
                to_left(a);
            else
                to_right(a);
        }

        for (auto &i: a) {
            for (auto j: i)
                cout << j;
            cout << "\n";
        }

        return;
    }

    string t;
    t += s[0];
    t += s[1];
    string last = t;
    for (int i = 2; i < s.size(); ++i) {
        if (s[i] == op[last[0]]) {
            string tmp;
            tmp += last[1];
            tmp += s[i];
            last = tmp;

            t += s[i];
        } else if (s[i] == op[last[1]]) {
            last[1] = s[i];
            t.back() = s[i];
        }
    }
    s = t;

    if (s.size() <= 10) {
        for (auto c: s) {
            if (c == 'U')
                to_up(a);
            else if (c == 'D')
                to_down(a);
            else if (c == 'L')
                to_left(a);
            else
                to_right(a);
        }

        for (auto &i: a) {
            for (auto j: i)
                cout << j;
            cout << "\n";
        }

        return;
    }

    for (int i = 0; i < 2; ++i) {
        char c = s[i];
        if (c == 'U')
            to_up(a);
        else if (c == 'D')
            to_down(a);
        else if (c == 'L')
            to_left(a);
        else
            to_right(a);
    }

    vector<vector<int>> p(n, vector<int>(m, -1));
    int it = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (a[i][j] != '.')
                p[i][j] = it++;

    vector<char> chr(it);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (a[i][j] != '.')
                chr[p[i][j]] = a[i][j];

    auto q = p;
    for (int i = 2; i < 6; ++i) {
        char c = s[i];
        if (c == 'U')
            to_up(q);
        else if (c == 'D')
            to_down(q);
        else if (c == 'L')
            to_left(q);
        else
            to_right(q);
    }

    vector<int> x(it);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (p[i][j] != -1)
                x[p[i][j]] = q[i][j];

    int cnt = ((int)s.size() - 2) / 4;
    x = qpow(x, cnt);

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            p[i][j] = x[p[i][j]];

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (a[i][j] != '.')
                a[i][j] = chr[p[i][j]];

    for (int i = cnt * 4 + 2; i < s.size(); ++i) {
        char c = s[i];
        if (c == 'U')
            to_up(q);
        else if (c == 'D')
            to_down(q);
        else if (c == 'L')
            to_left(q);
        else
            to_right(q);
    }

    for (auto& i : a) {
        for (auto j : i)
            cout << j;
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}