#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = (int)(1e18) + 42;
const int MAXN = 5000;

vector<pii> to_seg(const vector<bool>& a) {
    int n = a.size();

    int last = 0;
    vector<pii> res;
    for (int i = 0; i < n; ++i) {
        if (!a[i]) {
            if (last < i)
                res.push_back({last, i});
            last = i + 1;
        }
    }

    if (last < n)
        res.push_back({last, n});

    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int, int>> a(n);
    for (auto& [xl, yl, xr, yr] : a)
        cin >> xl >> yl >> xr >> yr, --xl, --yl;

    vector<tuple<int, int, int, bool>> ev;
    for (auto& [xl, yl, xr, yr] : a) {
        ev.push_back({yl, xl, xr, 0});
        ev.push_back({yr, xl, xr, 1});
    }
    sort(all(ev));

    int it = 0, nxt = 0;
    set<pii> s;
    vector<vector<bool>> used(MAXN, vector<bool>(MAXN));
    for (auto [y, xl, xr, flag] : ev) {
        ++it;
        if (it < ev.size())
            nxt = get<0>(ev[it]);

        if (flag)
            s.erase({xl, xr});
        else
            s.insert({xl, xr});

        for (int t = y; t < nxt; ++t)
            for (auto [l, r] : s)
                for (int i = l; i < r; ++i)
                    used[t][i] = 1;
    }

    map<pii, vector<bool>> v;
    for (int i = 0; i < MAXN; ++i) {
        auto res = to_seg(used[i]);

        //cout << "! " << i << endl;
        for (auto [l, r] : res) {
            //cout << l << " " << r << endl;

            if (!v.count({l, r}))
                v[{l, r}] = vector<bool>(MAXN);
            v[{l, r}][i] = 1;
        }
    }

    map<pii, pii> ans;
    for (auto [p, vec] : v) {
        auto seg = to_seg(vec);
        ans[p] = {0, 0};
        for (auto [l, r] : seg) {
            ans[p].first += r - l;
            ans[p].second = max(ans[p].second, r - l);
        }
    }

    cout << ans.size() << "\n";
    for (auto [p, q] : ans)
        cout << p.first + 1 << " " << p.second << " " << q.first << " " << q.second << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}

/*
1
3
1 1 5 1
4 1 7 1
10 1 12 1
 */