#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

const int MAXN = 1e6 + 123;
string f[MAXN];

enum Dirs{right, up, left, down};

void move_dumb(int n, int m, Dirs dir) {
    switch (dir) {
        case Dirs::right:
            for (int i = 0; i < n; ++i) {
                int curj = m - 1;
                for (int j = m - 1; j >= 0; --j) if (f[i][j] != '.') {
                    swap(f[i][curj--], f[i][j]);
                }
            }
            break;
        case Dirs::up:
            for (int j = 0; j < m; ++j) {
                int curi = 0;
                for (int i = 0; i < n; ++i) if (f[i][j] != '.') {
                    swap(f[curi++][j], f[i][j]);
                }
            }
            break;
        case Dirs::left:
            for (int i = 0; i < n; ++i) {
                int curj = 0;
                for (int j = 0; j < m; ++j) if (f[i][j] != '.') {
                    swap(f[i][curj++], f[i][j]);
                }
            }
            break;
        case Dirs::down:
            for (int j = 0; j < m; ++j) {
                int curi = n - 1;
                for (int i = n - 1; i >= 0; --i) if (f[i][j] != '.') {
                    swap(f[curi--][j], f[i][j]);
                }
            }
            break;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> f[i];
    string pstr;
    cin >> pstr;
    int q = pstr.size();
    vector<Dirs> p(q);
    for (int i = 0; i < q; ++i) {
        if (pstr[i] == 'R')
            p[i] = Dirs::right;
        else if (pstr[i] == 'U')
            p[i] = Dirs::up;
        else if (pstr[i] == 'L')
            p[i] = Dirs::left;
        else if (pstr[i] == 'D')
            p[i] = Dirs::down;
    }
    bool only_oneside = true;
    for (int i = 0; i < q; ++i)
        only_oneside &= (int(p[0]) ^ int(p[i])) % 2 == 0;
    if (only_oneside) {
        move_dumb(n, m, p[q - 1]);
        for (int i = 0; i < n; ++i)
            cout << f[i] << '\n';
        return;
    }
    move_dumb(n, m, p[0]);
    for (int i = 1; i < q; ++i) if ((int(p[0]) ^ int(p[1])) % 2 == 0) {
        move_dumb(n, m, p[i - 1]);
        move_dumb(n, m, p[i]);
        rotate(p.begin(), p.begin() + i + 1, p.end());
        q -= i + 1;
        p.resize(q);
        break;
    }

    for (auto dir : p)
        move_dumb(n, m, dir);
    for (int i = 0; i < n; ++i)
        cout << f[i] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
