#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const ll INF = 1e12 + 177013;

vector<int> input_a(int n) {
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    vector<int> cmp;
    for (int i = 1; i <= n; ++i)
        cmp.push_back(a[i]);
    sort(cmp.begin(), cmp.end());
    cmp.resize(unique(cmp.begin(), cmp.end()) - cmp.begin());
    for (int i = 1; i <= n; ++i)
        a[i] = lower_bound(cmp.begin(), cmp.end(), a[i]) - cmp.begin();
    return a;
}

bool is_transition_possible(const vector<int>& pcnts, const vector<int>& cnts, int p, int m) {
    int k = pcnts.size();
    int filled = 0;
    for (int c = 0; c < k; ++c) {
        if (pcnts[c] == cnts[c] && cnts[c] % p == 0)
            continue;
        filled += (cnts[c] - 1 + p) / p - (pcnts[c] + p) / p + 1;
    }
    return filled <= m;
}

signed main() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int tp;
    cin >> tp;
    vector<int> a = input_a(n);
    a[0] = -1;
    k = *max_element(a.begin(), a.end()) + 1;
    ll ans = INF;

    for (int msk = 1; msk < (1 << n); msk += 2) {
        ll newans = n + 1;
        vector<int> cnts(k, 0);
        vector<int> pcnts(k, 0);
        /*cout << "#";
        for (int i = 1; i <= n; ++i) {
            if (!(msk & (1 << i)) && i != n)
                cout << ".";
            else
                cout << "#";
        }
        cout << ": ";*/

        for (int i = 1; i <= n; ++i) {
            ++cnts[a[i]];
            if (!(msk & (1 << i)) && i != n)
                continue;
            if (!is_transition_possible(pcnts, cnts, p, m)) {
                newans = INF;
                break;
            }
            if (i == n)
                break;
            ll add = INF;
            if (tp & 2)
                add = min(add, 1ll * i * 2);
            if (tp & 1)
                add = min(add, 1ll * (n + 1 - i) * 2 - 2);
            // cout << add << ' ';
            newans += add;
            pcnts = cnts;
        }
        // cout << endl;
        ans = min(ans, newans);
    }
    cout << ans << endl;
}
