#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const ll INF = 1e12 + 177013;

vector<int> input_a(int n) {
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    vector<int> cmp;
    for (int i = 1; i <= n; ++i)
        cmp.push_back(a[i]);
    sort(cmp.begin(), cmp.end());
    cmp.resize(unique(cmp.begin(), cmp.end()) - cmp.begin());
    for (int i = 1; i <= n; ++i)
        a[i] = lower_bound(cmp.begin(), cmp.end(), a[i]) - cmp.begin();
    return a;
}

bool is_transition_possible(const vector<int>& pcnts, const vector<int>& cnts, int p, int m) {
    int k = pcnts.size();
    int filled = 0;
    for (int c = 0; c < k; ++c) {
        filled += (cnts[c] - 1 + p) / p - pcnts[c] / p;
    }
    return filled <= m;
}

signed main() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int tp;
    cin >> tp;
    vector<int> a = input_a(n);
    a[0] = -1;
    k = *max_element(a.begin(), a.end()) + 1;

    vector<ll> remilia(n + 1);
    vector<ll> flandre(n + 1);
    vector<int> cnts(k, 0);
    int remval = 0;
    int flanval = 0;
    for (int i = 1; i <= n; ++i) {
        int c = a[i];
        remval -= (cnts[c] - 1 + p) / p;
        flanval -= cnts[c] / p;
        ++cnts[c];
        remval += (cnts[c] - 1 + p) / p;
        flanval += cnts[c] / p;

        remilia[i] = remval;
        flandre[i] = flanval;
    }

    vector<ll> dp(n + 1, INF);
    dp[n] = n + 1;
    for (int i = n - 1; i >= 0; --i) {
        vector<int> cnts(k, 0);
        for (int j = 1; j <= i; ++j) {
            ++cnts[a[j]];
        }
        vector<int> pcnts = cnts;
        for (int j = i + 1; j <= n; ++j) {
            if (remilia[j] - flandre[i] >  m)
                break;
            ll add = INF;
            if (tp & 2)
                add = min(add, 1ll * i * 2);
            if (tp & 1)
                add = min(add, 1ll * (n + 1 - i) * 2 - 2);
            if (i == 0)
                add = 0;
            dp[i] = min(dp[i], dp[j] + add); 
        }
    }
    cout << dp[0] << endl;

    /*for (int msk = 1; msk < (1 << n); msk += 2) {
        ll newans = n + 1;

        for (int i = 1; i <= n; ++i) {
            ++cnts[a[i]];
            if (!(msk & (1 << i)) && i != n)
                continue;
            if (!is_transition_possible(pcnts, cnts, p, m)) {
                newans = INF;
                break;
            }
            if (i == n)
                break;
            // cout << add << ' ';
            newans += add;
            pcnts = cnts;
        }
        // cout << endl;
        ans = min(ans, newans);
    }
    cout << ans << endl;*/
}
