#include <bits/stdc++.h>

using ll = long long;

using namespace std;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
  for (t &e : a) {
    din >> e;
  }
  return din;
}

template<typename t>
ostream &operator<<(ostream &dout, vector<t> a) {
  for (t e : a) {
    dout << e << ' ';
  }
  dout << '\n';
  return dout;
}

char dot = '.';

char operator>(vector<vector<char>> &a, pair<ll, ll> p) {
  if (p == pair<ll, ll>(-1, -1)) return dot;
  else return a[p.first][p.second];
}

struct perm {
  ll n, m;
  vector<vector<pair<ll, ll>>> a;
  perm(ll n, ll m, const vector<vector<pair<ll, ll>>> &A) : n(n), m(m) {
    a.assign(n, vector<pair<ll, ll>>(m, {-1, -1}));
    for (ll i = 0; i < n; i++) {
      for (ll j = 0; j < m; j++) {
        if (A[i][j] != pair<ll, ll>(-1, -1)) a[i][j] = {i, j};
      }
    }
  }
  perm(ll n, ll m, const vector<vector<char>> A) : n(n), m(m) {
    a.assign(n, vector<pair<ll, ll>>(m, {-1, -1}));
    for (ll i = 0; i < n; i++) {
      for (ll j = 0; j < m; j++) {
        if (A[i][j] != '.') a[i][j] = {i, j};
      }
    }
  }
  vector<pair<ll, ll>> &operator[](ll i) {
    return a[i];
  }
};

pair<ll, ll> negone = {-1, -1};

pair<ll, ll> &operator>(perm &a, pair<ll, ll> p) {
  if (p == pair<ll, ll>(-1, -1)) return negone;
  else return a.a[p.first][p.second];
}

perm &g(perm &p, char c) {
  if (c == 'U') {
    for (ll j = 0; j < p.m; j++) {
      ll l = 0;
      for (ll i = 0; i < p.n; i++) {
        if (p.a[i][j] != pair<ll, ll>(-1, -1)) {
          swap(p.a[i][j], p.a[l][j]);
          l++;
        }
      }
    }
  }
  if (c == 'D') {
    for (ll j = 0; j < p.m; j++) {
      ll l = p.n - 1;
      for (ll i = p.n - 1; i >= 0; i--) {
        if (p.a[i][j] != pair<ll, ll>(-1, -1)) {
          swap(p.a[i][j], p.a[l][j]);
          l--;
        }
      }
    }
  }
  if (c == 'L') {
    for (ll i = 0; i < p.n; i++) {
      ll l = 0;
      for (ll j = 0; j < p.m; j++) {
        if (p.a[i][j] != pair<ll, ll>(-1, -1)) {
          swap(p.a[i][j], p.a[i][l]);
          l++;
        }
      }
    }
  }
  if (c == 'R') {
    for (ll i = 0; i < p.n; i++) {
      ll l = p.m - 1;
      for (ll j = p.m - 1; j >= 0; j--) {
        if (p.a[i][j] != pair<ll, ll>(-1, -1)) {
          swap(p.a[i][j], p.a[i][l]);
          l--;
        }
      }
    }
  }
  return p;
}

bool opp(char a, char b) {
  return ((a == 'L' && b == 'R') || (a == 'R' && b == 'L') || (a == 'U' && b == 'D') || (a == 'D' && b == 'U'));
}

perm operator*(const perm &a, const perm &b) {
  perm c(a.n, a.m, a.a);
  ll n = a.n, m = a.m;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      if (a.a[i][j] != pair<ll, ll>(-1, -1)) {
        c > (b.a[i][j]) = a.a[i][j];
      }
    }
  }
  return c;
}

perm qperm(perm &a, ll n) {
  if (n == 1) return a;
  if (n & 1) return qperm(a, n - 1) * a;
  else {
    perm tmp = qperm(a, n / 2);
    tmp = tmp * tmp;
    return tmp;
  }
}

int main() {
#ifdef DBG
  freopen("in.txt", "r", stdin);
  freopen("out.txt", "w+", stdout);
#endif
  ll t;
  cin >> t;
  for (ll ti = 0; ti < t; ti++) {
    ll n, m;
    cin >> n >> m;
    vector<vector<char>> A(n, vector<char>(m));
    cin >> A;
    perm a(n, m, A);
    string S;
    cin >> S;
    string s;
    for (char e : S) {
      if (s.size() == 0) {
        s.push_back(e);
      }
      if (s.size() == 1) {
        if (opp(s[0], e) || s[0] == e) {
          s[0] = e;
        } else {
          s.push_back(e);
        }
      } else {
        if (opp(s.back(), e) || s.back() == e) {
          s.back() = e;
          if (s.size() >= 3) {
            if (s.back() == s[s.size() - 3]) s.pop_back();
          }
        } else if (s[s.size() - 2] != e) {
          s.push_back(e);
        }
      }
    }
    ll q = s.size();
    if (q < 1000) {
      for (char c : s) {
        g(a, c);
      }
    } else {
      g(g(a, s[0]), s[1]);
      s = s.substr(2, s.size() - 2);
      perm aa(n, m, a.a);
      g(g(g(g(aa, s[0]), s[1]), s[2]), s[3]);
      ll k = s.size() / 4;
      aa = qperm(aa, k);
      s = s.substr(4 * k, s.size() - 4 * k);
      while (s.size() > 0) {
        g(aa, s[0]);
        s = s.substr(1, s.size() - 1);
      }
      a = a * aa;
    }
    for (ll i = 0; i < n; i++) {
      for (ll j = 0; j < m; j++) {
        cout << (A > a[i][j]);
      }
      cout << '\n';
    }
  }
  return 0;
}