#include <bits/stdc++.h>

using ll = long long;

using namespace std;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
  for (t &e : a) {
    din >> e;
  }
  return din;
}

template<typename t>
ostream &operator<<(ostream &dout, vector<t> a) {
  for (t e : a) {
    dout << e << ' ';
  }
  dout << '\n';
  return dout;
}

struct ev {
  ll x1, x2, y, t;
  ev() = default;
  ev(ll x1, ll x2, ll y, ll t) : x1(x1), x2(x2), y(y), t(t) {}
};

struct event {
  ll x, t;
  event() = default;
  event(ll x, ll t) : x(x), t(t) {}
};

bool operator>(const event &a, const event &b) {
  return a.x > b.x;
}

bool operator>=(const event &a, const event &b) {
  return a.x >= b.x;
}

bool operator<(const ev &a, const ev &b) {
  return a.y < b.y;
}

mt19937_64 rng(2007);

struct Nd {
  Nd *l = nullptr, *r = nullptr;
  ll x, y;
  Nd(ll x) : x(x), y(rng()) {}
};

Nd *merge(Nd *l, Nd *r) {
  if (l == nullptr) return r;
  if (r == nullptr) return l;
  if (l->y > r->y) {
    l->r = merge(l->r, r);
    return l;
  } else {
    r->l = merge(l, r->l);
    return r;
  }
}

void upd(map<pair<ll, ll>, ll> &s, map<pair<ll, ll>, ll> &mx, map<pair<ll, ll>, ll> &k, const vector<event> &events, ll dy) {
  ll l = 0, c = 0;
  for (event e : events) {
    if (e.t == 1) {
      if (c == 0) l = e.x;
      c++;
    } else {
      c--;
      if (c == 0) {
        k[{l, e.x}] = -k[{l, e.x}] - dy;
      }
    }
  }
  vector<pair<ll, ll>> toerr;
  for (pair<const pair<ll, ll>, ll> &p : k) {
    if (p.second > 0) {
      toerr.push_back(p.first);
      mx[p.first] = max(mx[p.first], p.second);
      s[p.first] += p.second;
    } if (p.second < 0) {
      p.second *= -1;
    }
  }
  for (pair<ll, ll> p : toerr) {
    k.erase(p);
  }
}

int main() {
#ifdef DBG
  freopen("in.txt", "r", stdin);
  freopen("out.txt", "w+", stdout);
#endif
  ll t;
  cin >> t;
  for (ll ti = 0; ti < t; ti++) {
    ll n;
    cin >> n;
    vector<ev> evs;
    for (ll i = 0; i < n; i++) {
      ll x1, y1, x2, y2;
      cin >> x1 >> y1 >> x2 >> y2;
      evs.emplace_back(x1, x2 + 1, y1, 1);
      evs.emplace_back(x1, x2 + 1, y2 + 1, -1);
    }
    sort(evs.begin(), evs.end());
    vector<event> events;
    map<pair<ll, ll>, ll> s, mx, k;
    for (ll i = 0; i < 2 * n; i++) {
      if (evs[i].t == 1) {
        events.emplace_back(evs[i].x1, 1);
        for (ll j = events.size() - 2; j >= 0; j--) {
          if (events[j] >= events[j + 1]) swap(events[j], events[j + 1]);
          else break;
        }
        events.emplace_back(evs[i].x2, -1);
        for (ll j = events.size() - 2; j >= 0; j--) {
          if (events[j] > events[j + 1]) swap(events[j], events[j + 1]);
          else break;
        }
      } else {
        ll j = 0;
        while (events[j].x != evs[i].x1 || events[j].t != 1) j++;
        while (j < events.size() - 1) {
          swap(events[j], events[j + 1]);
          j++;
        }
        events.pop_back();
        j = 0;
        while (events[j].x != evs[i].x2 || events[j].t != -1) j++;
        while (j < events.size() - 1) {
          swap(events[j], events[j + 1]);
          j++;
        }
        events.pop_back();
      }
      upd(s, mx, k, events, (i < 2 * n - 1 ? evs[i + 1].y : evs[i].y) - evs[i].y);
    }
    cout << s.size() << '\n';
    for (pair<pair<ll, ll>, ll> p : s) {
      cout << p.first.first << ' ' << p.first.second - 1 << ' ' << p.second << ' ' << mx[p.first] << '\n';
    }
  }
  return 0;
}