#include <bits/stdc++.h>

using ll = long long;

using namespace std;

template<typename t1, typename t2>
istream &operator>>(istream &din, pair<t1, t2> &p) {
  din >> p.first >> p.second;
  return din;
}

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
  for (t &e : a) {
    din >> e;
  }
  return din;
}

template<typename t>
ostream &operator<<(ostream &dout, vector<t> a) {
  for (t e : a) {
    dout << e << ' ';
  }
  dout << '\n';
  return dout;
}

struct ev {
  ll x1, x2, y, t;
  ev() = default;
  ev(ll x1, ll x2, ll y, ll t) : x1(x1), x2(x2), y(y), t(t) {}
};

struct event {
  ll x, t;
  event() = default;
  event(ll x, ll t) : x(x), t(t) {}
};

bool operator<(const event &a, const event &b) {
  return a.x < b.x || (a.x == b.x && a.t > b.t);
}
bool operator>(const event &a, const event &b) {
  return a.x > b.x;
}

bool operator>=(const event &a, const event &b) {
  return a.x >= b.x;
}

bool operator<(const ev &a, const ev &b) {
  return a.y < b.y;
}

mt19937_64 rng(2007);

struct Nd {
  Nd *l = nullptr, *r = nullptr;
  ll x, y;
  Nd(ll x) : x(x), y(rng()) {}
};

Nd *merge(Nd *l, Nd *r) {
  if (l == nullptr) return r;
  if (r == nullptr) return l;
  if (l->y > r->y) {
    l->r = merge(l->r, r);
    return l;
  } else {
    r->l = merge(l, r->l);
    return r;
  }
}

void upd(map<pair<ll, ll>, ll> &s,
         map<pair<ll, ll>, ll> &mx,
         map<pair<ll, ll>, ll> &k,
         const vector<event> &events,
         ll dy) {
  ll l = 0, c = 0;
  for (event e : events) {
    if (e.t == 1) {
      if (c == 0) l = e.x;
      c++;
    } else {
      c--;
      if (c == 0) {
        k[{l, e.x}] = -k[{l, e.x}] - dy;
      }
    }
  }
  vector<pair<ll, ll>> toerr;
  for (pair<const pair<ll, ll>, ll> &p : k) {
    if (p.second > 0) {
      toerr.push_back(p.first);
      mx[p.first] = max(mx[p.first], p.second);
      s[p.first] += p.second;
    }
    if (p.second < 0) {
      p.second *= -1;
    }
  }
  for (pair<ll, ll> p : toerr) {
    k.erase(p);
  }
}

int main() {
#ifdef DBG
  freopen("in.txt", "r", stdin);
  freopen("out.txt", "w", stdout);
#endif
  ll t;
  cin >> t;
  for (ll ti = 0; ti < t; ti++) {
    ll n;
    cin >> n;
    vector<pair<pair<ll, ll>, pair<ll, ll>>> pps(n);
    cin >> pps;
    vector<event> evs;
    for (ll i = 0; i < n; i++) {
      evs.emplace_back(pps[i].first.first, 1);
      evs.emplace_back(pps[i].second.first + 1, -1);
    }
    sort(evs.begin(), evs.end());
    ll l = 0, c = 0;
    vector<pair<ll, ll>> ans;
    for (ll i = 0; i < 2 * n; i++) {
      if (evs[i].t == 1) {
        if (c == 0) l = evs[i].x;
        c++;
      } else {
        c--;
        if (c == 0) ans.emplace_back(l, evs[i].x);
      }
    }
    cout << ans.size() << '\n';
    for (pair<ll, ll> p : ans) {
      cout << p.first << ' ' << p.second - 1 << ' ' << 1 << ' ' << 1 << '\n';
    }
  }
  return 0;
}