#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
int sz(T& a) {
    return (int)a.size();
}


ll inf = 1e17;

struct node {
    ll val=-inf, push=0; bool flag = 0;
    node() {}
    node(ll x) : val(x) {}
};
vector<node> t;

node merge(node a, node b) {
    return node(max(a.val, b.val));
}
void apply(int v, int l, int r, ll add) {
    t[v].flag = 1;
    t[v].val += add;
    t[v].push += add;
}
void push(int v, int l, int r) {
    if (t[v].flag && l+1!=r) {
        int mid = (l+r) / 2;
        apply(v*2+1, l, mid, t[v].push);
        apply(v*2+2, mid, r, t[v].push);
    }
    t[v].flag = 0; t[v].push = 0;
}
void update(int v, int l, int r, int L, int R, ll add) {
    if (r<=L || R<=l) return;
    if (L<=l && r<=R) {
        apply(v, l, r, add);
        return;
    }
    push(v, l, r);
    int mid = (l+r) / 2;
    update(v*2+1, l, mid, L, R, add);
    update(v*2+2, mid, r, L, R, add);
    t[v] = merge(t[v*2+1], t[v*2+2]);
}
void updateh(int v, int l, int r, int id, ll val) {
    if (l+1 == r) {
        t[v] = node(max(val, t[v].val));
        return;
    }
    push(v, l, r);
    int mid = (l+r) / 2;
    if (mid<=id) updateh(v*2+2, mid, r, id, val);
    else updateh(v*2+1, l, mid, id, val);
    t[v] = merge(t[v*2+1], t[v*2+2]);
}
node get(int v, int l, int r, int L, int R) {
    if (r<=L || R<=l) return node();
    if (L<=l && r<=R) return t[v];
    push(v, l, r);
    int mid = (l+r) / 2;
    return merge(get(v*2+1, l, mid, L, R), get(v*2+2, mid, r, L, R));
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int maxh = 1e6 + 1;
    int n, m; ll c, p;
    cin >> n >> m >> c >> p;
    vector<pll> nums(n+m);
    vector<ll> cords{1};
    for (int i=0; i<n+m; i++) {
        cin >> nums[i].first >> nums[i].second;
        cords.push_back(nums[i].second);
    }
    sort(cords.begin(), cords.end());
    cords.resize(unique(cords.begin(), cords.end()) - cords.begin());
    int M = sz(cords);
    unordered_map<ll, ll> ids;
    for (int i=0; i<M; i++) ids[cords[i]] = i;

    t.resize(maxh*4);
    updateh(0, 0, maxh, 1, 0);

    ll ans = 0;
    for (int iter=0; iter<n+m; iter++) {
//        if (nums[iter].first == 1) {
//            for (int i=1; i+nums[iter].second<=maxh; i++)
//                dp1[i] = dp[i+nums[iter].second];
//        }

//        for (ll i=1; i<nums[iter].second; i++)
//            dp1[nums[iter].second] = max(dp1[nums[iter].second], dp[i] - c*(nums[iter].second-i) + p);


        update(0, 0, maxh, nums[iter].second, maxh, p);
        if (ids[nums[iter].second]!=0) {
            ll pred = cords[ids[nums[iter].second]-1];
            ll val = get(0, 0, maxh, pred, pred+1).val;
            updateh(0, 0, maxh, nums[iter].second, val - c*(nums[iter].second-pred) + p);
        }

        ans = max(ans, t[0].val);
    }

    cout << ans;

//    vector<ll> dp(maxh+1, -inf);
//    dp[1] = 0;
//    for (int i=2; i<=maxh; i++) dp[i] = dp[i-1]-c;
//    for (int iter=0; iter<n+m; iter++) {
//        vector<ll> dp1(maxh+1, -inf);
//        if (nums[iter].first == 1) {
//            for (int i=1; i+nums[iter].second<=maxh; i++)
//                dp1[i] = dp[i+nums[iter].second];
//        }
//        else {
//            for (int i=1; i<=maxh; i++) dp1[i] = dp[i];
//            for (ll i=1; i<nums[iter].second; i++)
//                dp1[nums[iter].second] = max(dp1[nums[iter].second], dp[i] - c*(nums[iter].second-i) + p);
//            for (ll i=nums[iter].second; i<=maxh; i++) dp1[i] = dp[i] + p;
//        }
//        dp = dp1;
//        ans = max(ans, *max_element(dp.begin(), dp.end()));
//    }
//
//    cout << ans;

    return 0;
}



//
//
//#include <bits/stdc++.h>
//
//using namespace std;
//
//using ll = long long;
//using pii = pair<int, int>;
//using pll = pair<ll, ll>;
//using ld = long double;
//template <typename T>
//int sz(T& a) {
//    return (int)a.size();
//}
//
//
//ll c, p;
//ll inf = 1e17;
//struct node {
//    ll val=-inf, dp=-inf; ll push=0; int l=-1, r=-1; bool flag = 0;
//    node() {}
//    node(ll x, ll id) : val(x), dp(id) {}
//};
//int MAXSIZ = 1e7;
//int cnt = 1;
//vector<node> nodes(1);
//
//void merge(int v) {
//    nodes[v].val = max(nodes[nodes[v].l].val, nodes[nodes[v].r].val);
//    nodes[v].dp = max(nodes[nodes[v].l].dp, nodes[nodes[v].r].dp);
//}
//node merge(const node& a, const node& b) {
//    return node(max(a.val, b.val), max(a.dp, b.dp));
//}
//void gen(int v, ll l, ll r) {
//    ll mid = (l+r) / 2;
//    if (nodes[v].l == -1) {
//        nodes[v].l = cnt;
//        nodes.push_back(node(0, (l+mid-1)*(mid-l) / 2));
//        cnt++;
//    }
//    if (nodes[v].r == -1) {
//        nodes[v].r = cnt;
//        nodes.push_back(node(0, (mid+r-1)*(r-mid) / 2));
//        cnt++;
//    }
//}
//void apply(int v, ll l, ll r, ll push) {
//    nodes[v].flag = 1;
//    nodes[v].val += push;
//    nodes[v].dp += c*push;
//    nodes[v].push += push;
//}
//void push(int v, ll l, ll r) {
//    if (nodes[v].flag && l+1!=r) {
//        ll mid = (l+r) / 2;
//        apply(nodes[v].l, l, mid, nodes[v].push);
//        apply(nodes[v].r, mid, r, nodes[v].push);
//    }
//    nodes[v].flag=0; nodes[v].push = 0;
//}
//void updateh(int v, ll l, ll r, ll pos, ll val1, ll val2) {
//    if (l+1 == r) {
//        nodes[v] = node(val1, val2);
//        return;
//    }
//    if (nodes[v].l==-1 || nodes[v].r==-1) gen(v, l, r);
//    push(v, l, r);
//    ll mid = (l+r) / 2;
//    if (mid<=pos) updateh(nodes[v].r, mid, r, pos, val1, val2);
//    else updateh(nodes[v].r, l, mid, pos, val1, val2);
//    merge(v);
//}
//void update(int v, ll l, ll r, ll L, ll R, ll add) {
//    if (r<=L || R<=l) return;
//    if (L<=l && r<=R) {
//        apply(v, l, r, add);
//        return;
//    }
//    if (nodes[v].l==-1 || nodes[v].r==-1) gen(v, l, r);
//    push(v, l, r);
//    ll mid = (l+r) / 2;
//    update(nodes[v].l, l, mid, L, R, add);
//    update(nodes[v].r, mid, r, L, R, add);
//    merge(v);
//}
//node get(int v, ll l, ll r, ll L, ll R) {
//    if (r<=L || R<=l) return node(-inf, -inf);
//    if (L<=l && r<=R) return nodes[v];
//    if (nodes[v].l==-1 || nodes[v].r==-1) gen(v, l, r);
//    push(v, l, r);
//    ll mid = (l+r) / 2;
//    return merge(get(nodes[v].l, l, mid, L, R), get(nodes[v].r, mid, r, L, R));
//}
//
//
//int main() {
//    ios_base::sync_with_stdio(false); cin.tie(nullptr);
//#ifdef local
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
//
//
//    ll maxh = 1e12;
//    int n, m;
//    cin >> n >> m >> c >> p;
//    vector<pll> nums(n+m);
//    for (int i=0; i<n+m; i++) cin >> nums[i].first >> nums[i].second;
//
//    ll start = 0;
//    ll tmp = 1e6 + 1;
//    updateh(0, 0, maxh, 1, 0, 0);
//    ll ans = 0;
//
//    for (int iter=0; iter<n+m; iter++) {
//        if (nums[iter].first == 1) {
//            start += nums[iter].second;
//        }
//        else {
//            ll val = get(0, 0, maxh, start, start+nums[iter].second).dp;
//            updateh(0, 0, maxh, start+nums[iter].second, val-c*nums[iter].second+p, val-c*nums[iter].second+p + c*nums[iter].second);
//            update(0, 0, maxh, start+nums[iter].second, start+maxh+1, p);
//        }
//        ans = max(ans, nodes[0].val);
//    }
//
//    cout << ans;
//
//
//    return 0;
//}