#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

void print(vector<vector<ll>>& a, vector<char> who) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == -1) {
                cout << '.';
            } else {
                cout << who[a[i][j]];
            }
        }
        cout << '\n';
    }
    cout << '\n';
}

void simulate_r(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        vector<ll> has;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        reverse(has.begin(), has.end());
        while (has.size() < m) {
            has.push_back(-1);
        }
        reverse(has.begin(), has.end());
        a[i] = has;
    }
}

void simulate_l(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        vector<ll> has;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        while (has.size() < m) {
            has.push_back(-1);
        }
        a[i] = has;
    }
}

void simulate_u(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int j = 0; j < m; j++) {
        vector<ll> has;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        while (has.size() < n) {
            has.push_back(-1);
        }
        for (int i = 0; i < n; i++) {
            a[i][j] = has[i];
        }
    }
}

void simulate_d(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int j = 0; j < m; j++) {
        vector<ll> has;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        reverse(has.begin(), has.end());
        while (has.size() < n) {
            has.push_back(-1);
        }
        reverse(has.begin(), has.end());
        for (int i = 0; i < n; i++) {
            a[i][j] = has[i];
        }
    }
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll> (m));

    ll num = 0;
    vector<char> who(n * m);
    for (int i = 0; i < n; i++) {
        string nw; cin >> nw;
        for (int j = 0; j < m; j++) {
            if (nw[j] == '.') {
                a[i][j] = -1;
            } else {
                a[i][j] = num;
                who[num] = nw[j];
                num++;
            }
        }
    }
    string s; cin >> s;

    for (auto c : s) {
        if (c == 'U') {
            simulate_u(a);
        } else if (c == 'D') {
            simulate_d(a);
        } else if (c == 'L') {
            simulate_l(a);
        } else {
            simulate_r(a);
        }
    }
    print(a, who);
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }
}
