#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

void print(vector<vector<ll>>& a, vector<char> who) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == -1) {
                cout << '.';
            } else {
                cout << who[a[i][j]];
            }
        }
        cout << '\n';
    }
    cout << '\n';
}

void print_row(vector<vector<ll>>& a, vector<char> who) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j] << " ";
        }
        cout << '\n';
    }
    cout << '\n';
}

void simulate_r(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        vector<ll> has;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        reverse(has.begin(), has.end());
        while (has.size() < m) {
            has.push_back(-1);
        }
        reverse(has.begin(), has.end());
        a[i] = has;
    }
}

void simulate_l(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int i = 0; i < n; i++) {
        vector<ll> has;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        while (has.size() < m) {
            has.push_back(-1);
        }
        a[i] = has;
    }
}

void simulate_u(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int j = 0; j < m; j++) {
        vector<ll> has;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        while (has.size() < n) {
            has.push_back(-1);
        }
        for (int i = 0; i < n; i++) {
            a[i][j] = has[i];
        }
    }
}

void simulate_d(vector<vector<ll>>& a) {
    ll n = a.size(), m = a[0].size();
    for (int j = 0; j < m; j++) {
        vector<ll> has;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != -1) {
                has.push_back(a[i][j]);
            }
        }
        reverse(has.begin(), has.end());
        while (has.size() < n) {
            has.push_back(-1);
        }
        reverse(has.begin(), has.end());
        for (int i = 0; i < n; i++) {
            a[i][j] = has[i];
        }
    }
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll> (m));

    ll num = 0;
    vector<char> who(n * m);
    for (int i = 0; i < n; i++) {
        string nw; cin >> nw;
        for (int j = 0; j < m; j++) {
            if (nw[j] == '.') {
                a[i][j] = -1;
            } else {
                a[i][j] = num;
                who[num] = nw[j];
                num++;
            }
        }
    }
    string s; cin >> s;
    ll q = s.size();

    if (num == 0) {
        print(a, who);
        return;
    }

    ll pos_x = -1, pos_y = -1;

    ll start = 0;
    if (s[0] == 'D' || s[0] == 'U') {
        ll bad = q;
        for (int i = 0; i < q; i++) {
            if (s[i] == 'L' || s[i] == 'R') {
                bad = i;
                break;
            }
        }
        if (s[bad - 1] == 'D') {
            simulate_d(a);
            pos_x = 0;
        } else {
            simulate_u(a);
            pos_x = 1;
        }
        if (bad != q) {
            if (s[bad] == 'R') {
                simulate_r(a);
                pos_y = 1;
            } else {
                simulate_l(a);
                pos_y = 0;
            }
        }
        start = bad + 1;
    } else {
        ll bad = q;
        for (int i = 0; i < q; i++) {
            if (s[i] == 'U' || s[i] == 'D') {
                bad = i;
                break;
            }
        }
        if (s[bad - 1] == 'L') {
            simulate_l(a);
            pos_y = 0;
        } else {
            simulate_r(a);
            pos_y = 1;
        }
        if (bad != q) {
            if (s[bad] == 'U') {
                simulate_u(a);
                pos_x = 1;
            } else {
                simulate_d(a);
                pos_x = 0;
            }
        }
        start = bad + 1;
    }

    if (start >= q) {
        print(a, who);
        return;
    }

    ll was_pos_x = pos_x, was_pos_y = pos_y;

    // from start
    vector<vector<ll>> b = a;
    // cout << pos_x << " " << pos_y << '\n';
    if (pos_x == 0 && pos_y == 0) {
        simulate_r(b);
        simulate_u(b);
        simulate_l(b);
        simulate_d(b);
    } else if (pos_x == 0 && pos_y == 1) {
        simulate_u(b);
        simulate_l(b);
        simulate_d(b);
        simulate_r(b);
    } else if (pos_x == 1 && pos_y == 1) {
        simulate_l(b);
        simulate_d(b);
        simulate_r(b);
        simulate_u(b);
    } else {
        simulate_d(b);
        simulate_r(b);
        simulate_u(b);
        simulate_l(b);
    }

//    print(a, who);
//    print(b, who);

    vector<pair<ll, ll>> where_was(n * m), where_now(n * m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                where_was[a[i][j]] = {i, j};
            }
            if (b[i][j] != -1) {
                where_now[b[i][j]] = {i, j};
            }
        }
    }

    ll spin = 0;
    for (int i = start; i < q; i++) {
        char c = s[i];
        if (pos_x == 0 && pos_y == 0) {
            if (c == 'U') {
                spin--;
                pos_x = 1;
            } else if (c == 'R') {
                spin++;
                pos_y = 1;
            }
        } else if (pos_x == 0 && pos_y == 1) {
            if (c == 'U') {
                spin++;
                pos_x = 1;
            } else if (c == 'L') {
                spin--;
                pos_y = 0;
            }
        } else if (pos_x == 1 && pos_y == 1) {
            if (c == 'L') {
                spin++;
                pos_y = 0;
            } else if (c == 'D') {
                spin--;
                pos_x = 0;
            }
        } else {
            if (c == 'D') {
                spin++;
                pos_x = 0;
            } else if (c == 'R') {
                spin--;
                pos_y = 1;
            }
        }
    }

    if (spin > 0) {
        ll cnt = spin / 4;

        vector<pair<ll, ll>> final(n * m);

        vector<bool> used(n * m, false);

        // cout << cnt << " " << spin << '\n';
        for (int cur_num = 0; cur_num < num; cur_num++) {
            if (used[cur_num]) continue;

            vector<pair<ll, ll>> path;
            ll was = cur_num;

            while (true) {
                ll nxt_x = where_now[cur_num].first, nxt_y = where_now[cur_num].second;
                path.push_back(where_now[cur_num]);
                used[cur_num] = true;
                cur_num = a[nxt_x][nxt_y];
                if (cur_num == was) {
                    break;
                }
            }
            ll sz = (ll)path.size();
            for (int i = 0; i < sz; i++) {
                ll was_x = path[i].first, was_y = path[i].second;
                final[a[was_x][was_y]] = path[(i + cnt) % sz];
            }
        }

        vector<vector<ll>> ans(n, vector<ll> (m, -1));
        for (int i = 0; i < num; i++) {
            ans[final[i].first][final[i].second] = i;
        }

        pos_x = was_pos_x;
        pos_y = was_pos_y;

        spin %= 4;
        while (spin > 0) {
            if (pos_x == 0 && pos_y == 0) {
                simulate_r(ans);
                pos_y = 1;
            } else if (pos_x == 0 && pos_y == 1) {
                simulate_u(ans);
                pos_x = 1;
            } else if (pos_x == 1 && pos_y == 1) {
                simulate_l(ans);
                pos_y = 0;
            } else {
                simulate_d(ans);
                pos_x = 0;
            }
            spin--;
        }

        print(ans, who);
    } else {
        spin = -spin;

        ll cnt = spin / 4;

        vector<pair<ll, ll>> final(n * m);
        vector<bool> used(n * m, false);

        // cout << cnt << " " << spin << '\n';
        for (int cur_num = 0; cur_num < num; cur_num++) {
            if (used[cur_num]) continue;

            vector<pair<ll, ll>> path;
            ll was = cur_num;
            while (true) {
                ll nxt_x = where_now[cur_num].first, nxt_y = where_now[cur_num].second;
                path.push_back(where_now[cur_num]);
                cur_num = a[nxt_x][nxt_y];
                used[cur_num] = true;
                if (cur_num == was) {
                    break;
                }
            }
            ll sz = (ll)path.size();
            for (int i = 0; i < sz; i++) {
                ll was_x = path[i].first, was_y = path[i].second;
                final[a[was_x][was_y]] = path[(i - cnt % sz + sz) % sz];
            }
        }

        vector<vector<ll>> ans(n, vector<ll> (m, -1));
        for (int i = 0; i < num; i++) {
            ans[final[i].first][final[i].second] = i;
        }

        pos_x = was_pos_x;
        pos_y = was_pos_y;

        spin %= 4;
        while (spin > 0) {
            if (pos_x == 0 && pos_y == 0) {
                simulate_u(ans);
                pos_x = 1;
            } else if (pos_x == 0 && pos_y == 1) {
                simulate_l(ans);
                pos_y = 0;
            } else if (pos_x == 1 && pos_y == 1) {
                simulate_d(ans);
                pos_x = 0;
            } else {
                simulate_r(ans);
                pos_y = 1;
            }
            spin--;
        }

        print(ans, who);
    }


    // print(a, who);
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }
}
