#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

struct segtree {
    ll n;
    vector<ll> t;

    segtree() {}

    segtree(vector<ll>& in) {
        n = in.size();
        t.resize(4 * n);
        build(0, 0, n - 1, in);
    }

    void build(ll v, ll tl, ll tr, vector<ll>& in) {
        if (tl == tr) {
            t[v] = in[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm, in);
        build(2 * v + 2, tm + 1, tr, in);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return INF;
        }
        ll tm = (tl + tr) / 2;
        return min(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
    }

    void upd(ll val, ll idx, ll v, ll tl, ll tr) {
        if (tl == tr && tl == idx) {
            t[v] = val;
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        ll tm = (tl + tr) / 2;
        upd(val, idx, 2 * v + 1, tl, tm);
        upd(val, idx, 2 * v + 2, tm + 1, tr);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
};

void solve() {
    ll n, m, k, p; cin >> n >> m >> k >> p;
    ll group; cin >> group;
    vector<ll> a(n + 2);
    for (int i = 1; i <= n; i++) cin >> a[i];



    vector<ll> dp(n + 1, INF);
    dp[0] = 0;

    segtree t(dp);

    set<ll> occ;
    vector<vector<ll>> idx(k + 1);
    for (int i = 1; i <= n; i++) {
        if (i <= m) {
            dp[i] = i;
        } else {
            ll j = i - m + 1;
            // cout << j << " " << i << '\n';
            // [i - m, i - 1]
            dp[i] = t.get(0, 0, n - 1, i - m, i - 1) + i;
//            cout << "B " << dp[j - 1] - (j - 1) - j - j + n + 1 +
//            cout << "A " << dp[j - 1] + ((n + 1 - (j - 1)) + (n + 1 - j)) + (i - j) << ", " << j << '\n';
            // dp[i] = min(dp[i], dp[j - 1] + ((n + 1 - (j - 1)) + (n + 1 - j)) + (i - j));
        }
        // cout << i << " " << dp[i] << '\n';

        t.upd(dp[i] + (i - 1), i, 0, 0, n - 1);
    }
    cout << dp[n] + 1 << '\n';

//    if (j == 1) {
//        dp[i] = min(dp[i], (ll)i);
//    } else {
//        dp[i] = min(dp[i], dp[j - 1] + ((n + 1 - (j - 1)) + (n + 1 - j)) + (i - j));
//    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}