#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

int n, m;

vector<vector<char>> aL(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(i, m){
		vector<char> guys;
		rep(j, n) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		int ptr = 0;
		for(char c : guys) res[i][ptr++] = c;
		while(ptr < n) res[i][ptr++] = '.';
	}
	return res;
}

vector<vector<char>> aR(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(i, m){
		vector<char> guys;
		rep(j, n) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		reverse(guys.begin(), guys.end());
		int ptr = n - 1;
		for(char c : guys) res[i][ptr--] = c;
		while(ptr >= 0) res[i][ptr--] = '.';
	}
	return res;
}

vector<vector<char>> aU(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(j, n){
		vector<char> guys;
		rep(i, m) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		int ptr = 0;
		for(char c : guys) res[ptr++][j] = c;
		while(ptr < m) res[ptr++][j] = '.';
	}
	return res;
}

vector<vector<char>> aD(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(j, n){
		vector<char> guys;
		rep(i, m) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		reverse(guys.begin(), guys.end());
		int ptr = m - 1;
		for(char c : guys) res[ptr--][j] = c;
		while(ptr >= 0) res[ptr--][j] = '.';
	}
	return res;
}

/*
LD     LU       RD       RU1      RD1      ?       RU2    LU2     ?2    
a...   acfj     ...a     acfj     ...j     j...    gdba   gdba    g...
bc..   bei.			..bc     .bei     ..fi     fi..    .hec   hec.    hd..
def.	 dh..     .def     ..dh     .ceh     ceh.    ..if   if..    ieb.
ghij   g...     ghij     ...g     abdg     abdg    ...j   j...    jfca
*/

void solve(){
	cin >> m >> n;
	vector<vector<char>> a(m, vector<char>(n));
	rep(i, m){
		string s;
		cin >> s;
		rep(j, n) a[i][j] = s[j];
	}
	string s;
	cin >> s;
	int q = s.size();
	rep(i, q){
		if(s[i] == 'L') a = aL(a);
		if(s[i] == 'R') a = aR(a);
		if(s[i] == 'D') a = aD(a);
		if(s[i] == 'U') a = aU(a);
	}
	rep(i, m){
		rep(j, n) cout << a[i][j];
		cout << '\n';
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#ifdef requiem
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	int tt = 1;
	cin >> tt;
	while(tt--) solve();
	return 0;
}