#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

int n, m;

vector<vector<char>> aL(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(i, m){
		vector<char> guys;
		rep(j, n) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		int ptr = 0;
		for(char c : guys) res[i][ptr++] = c;
		while(ptr < n) res[i][ptr++] = '.';
	}
	return res;
}

vector<vector<char>> aR(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(i, m){
		vector<char> guys;
		rep(j, n) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		reverse(guys.begin(), guys.end());
		int ptr = n - 1;
		for(char c : guys) res[i][ptr--] = c;
		while(ptr >= 0) res[i][ptr--] = '.';
	}
	return res;
}

vector<vector<char>> aU(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(j, n){
		vector<char> guys;
		rep(i, m) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		int ptr = 0;
		for(char c : guys) res[ptr++][j] = c;
		while(ptr < m) res[ptr++][j] = '.';
	}
	return res;
}

vector<vector<char>> aD(vector<vector<char>> &a){
	vector<vector<char>> res(m, vector<char>(n));
	rep(j, n){
		vector<char> guys;
		rep(i, m) if(a[i][j] != '.'){
			guys.push_back(a[i][j]);
		}
		reverse(guys.begin(), guys.end());
		int ptr = m - 1;
		for(char c : guys) res[ptr--][j] = c;
		while(ptr >= 0) res[ptr--][j] = '.';
	}
	return res;
}

/*
LD     LU       RD       RU1      RD1      ?       RU2    LU2     ?2    
a...   acfj     ...a     acfj     ...j     j...    gdba   gdba    g...
bc..   bei.			..bc     .bei     ..fi     fi..    .hec   hec.    hd..
def.	 dh..     .def     ..dh     .ceh     ceh.    ..if   if..    ieb.
ghij   g...     ghij     ...g     abdg     abdg    ...j   j...    jfca
*/

void solve(){
	cin >> m >> n;
	vector<vector<char>> a(m, vector<char>(n));
	rep(i, m){
		string s;
		cin >> s;
		rep(j, n) a[i][j] = s[j];
	}
	string s;
	cin >> s;
	int q = s.size();
	auto solve_one = [&](int r) -> int {
		int dn = (s[0] == 'L' ? -1 : 1), dm = (s[0] == 'U' ? -1 : 1);
		rep(i, r){
			if(s[i] == 'L') dn = -1;
			else if(s[i] == 'R') dn = 1;
			else if(s[i] == 'U') dm = -1;
			else if(s[i] == 'D') dm = 1;
		}
		return (s[0] == 'L' || s[0] == 'R' ? dn : dm);
	};
	set<int> se;
	int first = q;
	rep(i, q){
		if(s[i] == 'L' || s[i] == 'R') se.insert(0);
		else se.insert(1);
		if(se.size() == 2){
			first = i;
			break;
		}
	}
	auto c = a;
	int x = solve_one(first);
	if(s[0] == 'L' || s[0] == 'R'){
		if(x == -1) c = aL(a);
		else c = aR(a);
	}else{
		if(x == -1) c = aU(a);
		else c = aD(a);
	}
	if(first == q){
		rep(i, m){
			rep(j, n) cout << c[i][j];
			cout << '\n';
		}
		return;
	}
	if(s[first] == 'U') c = aU(c);
	if(s[first] == 'D') c = aD(c);
	if(s[first] == 'L') c = aL(c);
	if(s[first] == 'R') c = aR(c);
	a = c;
	map<vector<vector<char>>, int> id;
	map<int, vector<vector<char>>> what;
	map<int, map<int, int>> adj; // first - LR, second - UD
	auto dfs = [&](auto dfs, int v, int dn = -1, int dm = 1) -> void {
		if(dn == -1){
			auto b = aR(what[v]);
			if(id.find(b) == id.end()){ 
				what[id.size()] = b;
				id[b] = id.size();
				dfs(dfs, id[b], -dn, dm);
			}
			adj[v][0] = id[b];
		}else if(dn == 1){
			auto b = aL(what[v]);
			if(id.find(b) == id.end()){ 
				what[id.size()] = b;
				id[b] = id.size();
				dfs(dfs, id[b], -dn, dm);
			}
			adj[v][0] = id[b];
		}

		if(dm == -1){
			auto b = aD(what[v]);
			if(id.find(b) == id.end()){ 
				what[id.size()] = b;
				id[b] = id.size();
				dfs(dfs, id[b], dn, -dm);
			}
			adj[v][1] = id[b];
		}else if(dm == 1){
			auto b = aU(what[v]);
			if(id.find(b) == id.end()){ 
				what[id.size()] = b;
				id[b] = id.size();
				dfs(dfs, id[b], dn, -dm);
			}
			adj[v][1] = id[b];
		}
	};
	{
		what[id.size()] = a;
		id[a] = id.size();
		dfs(dfs, 0);
	}
	int v = 0, dn = -1, dm = 1;
	for(int i = first + 1; i < q; ++i){
		if(s[i] == 'L' && dn == -1) continue;
		if(s[i] == 'R' && dn == 1) continue;
		if(s[i] == 'U' && dm == -1) continue;
		if(s[i] == 'D' && dm == 1) continue;
		if(s[i] == 'L' || s[i] == 'R'){
			dn *= -1;
			v = adj[v][0];
		}else{
			dm *= -1;
			v = adj[v][1];
		}
	}
	rep(i, m){
		rep(j, n) cout << what[v][i][j];
		cout << '\n';
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#ifdef requiem
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	int tt = 1;
	cin >> tt;
	while(tt--) solve();
	return 0;
}