#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>

//#define int long long

using namespace std;

int n, m;

char get_char(int c) {
	if (c == 0)
		return 'L';
	if (c == 1)
		return 'U';
	if (c == 2)
		return 'R';
	if (c == 3)
		return 'D';
}

int get_int(char c) {
	if (c == 'L')
		return 0;
	if (c == 'U')
		return 1;
	if (c == 'R')
		return 2;
	if (c == 'D')
		return 3;
}

void step(char c, vector <vector <char>>& mp) {
	if (c == 'U') {
		for (int j = 0; j < n; j++) {
			int lst = 0;
			char now;
			for (int i = 0; i < m; i++) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[lst][j] = now;
					lst++;
				}
			}
		}
	}
	if (c == 'D') {
		for (int j = 0; j < n; j++) {
			int lst = m - 1;
			char now;
			for (int i = m - 1; i >= 0; i--) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[lst][j] = now;
					lst--;
				}
			}
		}
	}
	if (c == 'L') {
		for (int i = 0; i < m; i++) {
			int lst = 0;
			char now;
			for (int j = 0; j < n; j++) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[i][lst] = now;
					lst++;
				}
			}
		}
	}
	if (c == 'R') {
		for (int i = 0; i < m; i++) {
			int lst = n - 1;
			char now;
			for (int j = n - 1; j >= 0; j--) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[i][lst] = now;
					lst--;
				}
			}
		}
	}
}

signed main()
{
	int t;
	cin >> t;
	while (t--) {
		cin >> m >> n;
		vector <vector <char>> mp(m, vector<char>(n));
		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				cin >> mp[i][j];
		string s1;
		cin >> s1;
		vector <int> s2(s1.size());
		int l = -1;
		for (int i = 0; i < s1.size(); i++) {
			int now = get_int(s1[i]);
			if (l < 0) {
				l++;
				s2[l] = now;
				continue;
			}
			if (s2[l] == now)
				continue;
			if (abs(s2[l] - now) == 2) {
				s2[l] = now;
			}
			else {
				l++;
				s2[l] = now;
			}
			while (l >= 2 && s2[l] == s2[l - 2])
				l--;
		}
		for (int i = 0; i <= l; i++)
			step(get_char(s2[i]), mp);
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++)
				cout << mp[i][j];
			cout << endl;
		}
	}
}

