#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>

//#define int long long

using namespace std;

int n, m;

char get_char(int c) {
	if (c == 0)
		return 'L';
	if (c == 1)
		return 'U';
	if (c == 2)
		return 'R';
	if (c == 3)
		return 'D';
}

int get_int(char c) {
	if (c == 'L')
		return 0;
	if (c == 'U')
		return 1;
	if (c == 'R')
		return 2;
	if (c == 'D')
		return 3;
}

void ps_step(char c, vector <vector <int>>& mp) {
	if (c == 'U') {
		for (int j = 0; j < n; j++) {
			int lst = 0;
			int now;
			for (int i = 0; i < m; i++) {
				if (mp[i][j] != 0) {
					now = mp[i][j];
					mp[i][j] = 0;
					mp[lst][j] = now;
					lst++;
				}
			}
		}
	}
	if (c == 'D') {
		for (int j = 0; j < n; j++) {
			int lst = m - 1;
			int now;
			for (int i = m - 1; i >= 0; i--) {
				if (mp[i][j] != 0) {
					now = mp[i][j];
					mp[i][j] = 0;
					mp[lst][j] = now;
					lst--;
				}
			}
		}
	}
	if (c == 'L') {
		for (int i = 0; i < m; i++) {
			int lst = 0;
			int now;
			for (int j = 0; j < n; j++) {
				if (mp[i][j] != 0) {
					now = mp[i][j];
					mp[i][j] = 0;
					mp[i][lst] = now;
					lst++;
				}
			}
		}
	}
	if (c == 'R') {
		for (int i = 0; i < m; i++) {
			int lst = n - 1;
			int now;
			for (int j = n - 1; j >= 0; j--) {
				if (mp[i][j] != 0) {
					now = mp[i][j];
					mp[i][j] = 0;
					mp[i][lst] = now;
					lst--;
				}
			}
		}
	}
}

void step(char c, vector <vector <char>>& mp) {
	if (c == 'U') {
		for (int j = 0; j < n; j++) {
			int lst = 0;
			char now;
			for (int i = 0; i < m; i++) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[lst][j] = now;
					lst++;
				}
			}
		}
	}
	if (c == 'D') {
		for (int j = 0; j < n; j++) {
			int lst = m - 1;
			char now;
			for (int i = m - 1; i >= 0; i--) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[lst][j] = now;
					lst--;
				}
			}
		}
	}
	if (c == 'L') {
		for (int i = 0; i < m; i++) {
			int lst = 0;
			char now;
			for (int j = 0; j < n; j++) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[i][lst] = now;
					lst++;
				}
			}
		}
	}
	if (c == 'R') {
		for (int i = 0; i < m; i++) {
			int lst = n - 1;
			char now;
			for (int j = n - 1; j >= 0; j--) {
				if (mp[i][j] != '.') {
					now = mp[i][j];
					mp[i][j] = '.';
					mp[i][lst] = now;
					lst--;
				}
			}
		}
	}
}

signed main()
{
	int t;
	cin >> t;
	while (t--) {
		cin >> m >> n;
		vector <vector <char>> mp(m, vector<char>(n));
		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				cin >> mp[i][j];
		string s1;
		cin >> s1;
		vector <int> s2(s1.size());
		int l = -1;
		for (int i = 0; i < s1.size(); i++) {
			int now = get_int(s1[i]);
			if (l < 0) {
				l++;
				s2[l] = now;
				continue;
			}
			if (s2[l] == now)
				continue;
			if (abs(s2[l] - now) == 2) {
				s2[l] = now;
			}
			else {
				l++;
				s2[l] = now;
			}
			while (l >= 2 && s2[l] == s2[l - 2])
				l--;
		}
		if (l < 10) {
			for (int i = 0; i <= l; i++)
				step(get_char(s2[i]), mp);
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++)
					cout << mp[i][j];
				cout << endl;
			}
		}
		else {
			int ost = (l + 1) % 4 + 4;
			for (int i = 0; i < ost; i++)
				step(get_char(s2[i]), mp);
			vector <vector <int>> ps_mp1(m, vector<int> (n, 0)), ps_mp2(m, vector<int> (n, 0));
			int cnt = 0;
			vector <pair <int, int>> n_pos(1), k_pos(1);
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					if (mp[i][j] != '.') {
						cnt++;
						ps_mp1[i][j] = cnt;
						n_pos.push_back({ i , j });
						ps_mp2[i][j] = cnt;
					}
				}
			}
			for (int i = 0; i < 4; i++) {
				ps_step(get_char(s2[ost + i]), ps_mp2);
			}
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					if (ps_mp2[i][j] != 0) {
						k_pos[ps_mp2[i][j]] = { i , j };
					}
				}
			}
			vector <vector <int>> cikls;
			vector <int> q(0);
			vector <bool> f(cnt + 1, 1);
			//vector <int> ind(cnt + 1);
			int cnt_c = -1;
			for (int i = 1; i <= cnt; i++) {
				if (f[i] == 0)
					continue;
				cnt_c++;
				cikls.push_back(q);
				cikls[cnt_c].push_back(i);
				//ind[i] = 0;
				f[i] = 0;
				int now = ps_mp1[k_pos[i].first][k_pos[i].second];
				while (now != cikls[cnt_c][0]) {
					cikls[cnt_c].push_back(now);
					//ind[now] = cikls[cnt_c].size() - 1;
					f[now] = 0;
					now = ps_mp1[k_pos[now].first][k_pos[now].second];
				}
			}
			int cnt_ = (l + 1 - ost) / 4;
			vector <vector <char>> ans(m, vector<char>(n, '.'));
			for (int i = 0; i <= cnt_c; i++) {
				for (int j = 0; j < cikls[cnt_c].size(); j++) {
					int kon = (j + cnt_) % cikls[cnt_c].size();
					ans[n_pos[kon].first][n_pos[kon].second] = mp[n_pos[cikls[i][j]].first][n_pos[cikls[i][j]].second];
				}
			}
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					cout << ans[i][j];
				}
				cout << endl;
			}
		}
	}
}

