#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()
#define sz(x) (int)((x).size())

const ll INF = 3e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

vector<vector<vector<vector<vector<int>>>>> g;
string cl;

vector<vector<vector<bool>>> used;

vector<vector<int>> path;
vector<vector<vector<int>>> cycle;
vector<vector<vector<int>>> percycle;
vector<vector<vector<int>>> idxcycle;
void dfs(int state, int x, int y) {
    used[state][x][y] = 1;
    path.push_back({state, x, y});
    for (auto& v : g[state][x][y]) {
        if (used[v[0]][v[1]][v[2]]) {
            for (int i = 0; i < sz(path); ++i) {
                percycle[path[i][0]][path[i][1]][path[i][2]] = sz(cycle);
                idxcycle[path[i][0]][path[i][1]][path[i][2]] = i;
            }
            cycle.push_back(path);
        } else {
            dfs(v[0], v[1], v[2]);
        }
    }
    path.pop_back();
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.clear();
    used.assign(4, vector<vector<bool>>(n, vector<bool>(m, false)));
    g = vector(4, vector(n, vector(m, vector<vector<int>>{})));
    vector<vector<char>> field(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> field[i][j];
        }
    }
    vector<vector<int>> pri(n, vector<int>(m + 1)), sfi(n, vector<int>(m + 1)), prj(m, vector<int>(n + 1)), sfj(m, vector<int>(n + 1));
    auto recalc = [&](){
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                pri[i][j + 1] = pri[i][j];
                if (field[i][j] != '.') {
                    pri[i][j + 1]++;
                }
            }
            for (int j = m - 1; j >= 0; --j) {
                sfi[i][j] = sfi[i][j + 1];
                if (field[i][j] != '.') {
                    sfi[i][j]++;
                }
            }
        }
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                prj[j][i + 1] = prj[j][i];
                if (field[i][j] != '.') {
                    prj[j][i + 1]++;
                }
            }
            for (int i = n - 1; i >= 0; --i) {
                sfj[j][i] = sfj[j][i + 1];
                if (field[i][j] != '.') {
                    sfj[j][i] += 1;
                }
            }
        }
    };
    auto print = [&]() {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << field[i][j];
            }
            cout << '\n';
        }
    };
    auto calc = [&](char p) {
        auto nf = vector(n, vector(m, '.'));
        if (p == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[i][pri[i][j]] = field[i][j];
                    }
                }
            }
        } else if (p == 'R') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[i][m - sfi[i][j]] = field[i][j];
                    }
                }
            }
        } else if (p == 'D') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[n - sfj[j][i]][j] = field[i][j];
                    }
                }
            }
        } else if (p == 'U') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[prj[j][i]][j] = field[i][j];
                    }
                }
            }
        }
        field = nf;
        recalc();
    };
    auto perehod = [&](int cur) {
        char p = cl[cur];

        if (p == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        g[cur][i][j].push_back({(cur + 1) % 4, i, pri[i][j]});
//                        g[(cur + 1) % 4][i][pri[i][j]].push_back({cur, i, j});
                    }
                }
            }
        } else if (p == 'R') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        g[cur][i][j].push_back({(cur + 1) % 4, i, m - sfi[i][j]});
//                        g[(cur + 1) % 4][i][m - sfi[i][j]].push_back({cur, i, j});
                    }
                }
            }
        } else if (p == 'D') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        g[cur][i][j].push_back({(cur + 1) % 4, n - sfj[j][i], j});
//                        g[(cur + 1) % 4][n - sfj[j][i]][j].push_back({cur, i, j});
                    }
                }
            }
        } else if (p == 'U') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        g[cur][i][j].push_back({(cur + 1) % 4, prj[j][i], j});
//                        g[(cur + 1) % 4][prj[j][i]][j].push_back({cur, i, j});
                    }
                }
            }
        }

    };
    recalc();
    string pt;
    cin >> pt;
    int q;
    q = sz(pt);
    char lr = ' ';
    char ud = ' ';
    string tr;
    int idx;
    for (int i = 0 ; i < q; ++i) {
        idx = i;
        if (pt[i] == 'L' || pt[i] == 'R') {
            lr = pt[i];
            if (ud != ' ') {
                tr.push_back(ud);
                tr.push_back(lr);
                break;
            }
        } else {
            ud = pt[i];
            if (lr != ' ') {
                tr.push_back(lr);
                tr.push_back(ud);
                break;
            }
        }
    }
    ++idx;
    if (lr == ' ') {
        calc(ud);
    } else if (ud == ' ') {
        calc(lr);
    } else {
        calc(tr[0]);
        calc(tr[1]);
        if (lr == 'L' && ud == 'U') {
            cl = "RDLU";
        } else if (lr == 'L' && ud == 'D') {
            cl = "URDL";
        } else if (lr == 'R' && ud == 'U') {
            cl = "DLUR";
        } else if (lr == 'R' && ud == 'D') {
            cl = "LURD";
        }
        auto sg = field;
        perehod(0);
        calc(cl[0]);
        perehod(1);
        calc(cl[1]);
        perehod(2);
        calc(cl[2]);
        perehod(3);
        field = sg;
        cycle.clear();
        percycle = vector(4, vector(n, vector(m, 0)));
        idxcycle = vector(4, vector(n, vector(m, 0)));

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (!used[0][i][j]) {
                    dfs(0, i, j);
                }
            }
        }

        int cur = 0;
        for (int i = idx; i < q; ++i) {
            if (cl[(cur % 4 + 4) % 4] == pt[i]) {
                ++cur;
            } else if (cl[((cur + 1) % 4 + 4) % 4] == pt[i]) {
                --cur;
            }
        }
        auto nf = vector(n, vector(m, '.'));

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (field[i][j] != '.') {
                    int ic = percycle[0][i][j];
                    int ix = idxcycle[0][i][j] + cur;
                    ix %= sz(cycle[ic]);
                    ix += sz(cycle[ic]);
                    ix %= sz(cycle[ic]);
                    nf[cycle[ic][ix][1]][cycle[ic][ix][2]] = field[i][j];
                }
            }
        }
        field = nf;
    }
    print();
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);

#endif
    int tt =1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;

}