#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()
#define sz(x) (int)((x).size())

const ll INF = 3e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n;
    cin >> n;
    vector<int> xl(n), yl(n), xr(n), yr(n);
    vector<int> x, y;
    for (int i = 0; i < n; ++i) {
        cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
        x.push_back(xl[i]);
        x.push_back(xr[i]);
        y.push_back(yl[i]);
        y.push_back(yr[i]);
    }
    sort(all(x));
    sort(all(y));
    x.resize(unique(all(x)) - x.begin());
    y.resize(unique(all(y)) - y.begin());
    vector<vector<pair<int, int>>> d(sz(y));
    for (int i = 0; i < n; ++i) {
        xl[i] = lower_bound(all(x), xl[i]) - x.begin();
        xr[i] = lower_bound(all(x), xr[i]) - x.begin();
        yl[i] = lower_bound(all(y), yl[i]) - y.begin();
        yr[i] = lower_bound(all(y), yr[i]) - y.begin();
        for (int j = yl[i]; j <= yr[i]; ++j) {
            d[j].push_back({xl[i], -1});
            d[j].push_back({xr[i] + 1, 1});
        }
    }
    vector<vector<int>> cnt(sz(x), vector<int>(sz(x), 0));
    for (int i = 0; i < sz(y); ++i) {
        sort(all(d[i]));
        int pr = -1;
        int sum = 0;
        for (auto [c, delta] : d[i]) {
            if (sum == 0 && delta == -1) {
                pr = c;
            } else if (sum == 1 && delta == 1) {
                cnt[pr][c - 1]++;
            }
            sum -= delta;
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < sz(x); ++i) {
        for (int j = i; j < sz(x); ++j) {
            if (cnt[i][j]) {
                ans.push_back({i, j});
            }
        }
    }
    cout << sz(ans) << '\n';
    for (auto [i, j] : ans) {
        cout << x[i] << ' ' << x[j] << ' ' << 0 << ' ' << 0 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);

#endif
    int tt =1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;

}