#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using ll = long long;
using ull = unsigned long long;
#define INF 1'000'000'000
#define LINF 1'000'000'000'000'000'000

int main()
{
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif // LOCAL
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    int n, m;
    ll c, p;
    std::cin >> n >> m >> c >> p;
    std::vector<ll> goals;
    ll current_cost = 0;
    for (int i = 0; i < n + m; ++i)
    {
        int type;
        ll h;
        std::cin >> type >> h;
        if (type == 1)
        {
            current_cost += h;
        }
        else
        {
            goals.push_back(current_cost + h);
        }
    }

    goals.push_back(1);
    std::sort(goals.begin(), goals.end());
    ll ans = 0;
    ll cur = 0;
    for (int i = 1; i <= m; ++i)
    {
        cur -= c*(goals[i] - goals[i - 1]);
        cur += p;
        ans = std::max(ans, cur);
    }
    std::cout << ans << std::endl;

    return 0;
}
