#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()




void solve() {
	int n, m; cin >> n >> m;
	vector <string> v(n);
	for (auto& x : v) cin >> x;
	string s; cin >> s;
	reverse(all(s));

	while (s.size() > 1 && (s.back() == s[s.size() - 2]
		|| s.back() == 'L' && s[s.size() - 2] == 'R'
		|| s.back() == 'R' && s[s.size() - 2] == 'L'
		|| s.back() == 'D' && s[s.size() - 2] == 'U'
		|| s.back() == 'U' && s[s.size() - 2] == 'D')) {

		s.pop_back();
	}

	auto step = [&]() {
		if (s.empty()) return;
		if (s.back() == 'R') {
			for (int i = 0; i < n; ++i) {
				string p;
				for (int j = 0; j < m; ++j) {
					if (v[i][j] != '.') {
						p += v[i][j];
					}
				}
				p = string(m - p.size(), '.') + p;
				v[i] = p;
			}
		}
		else if (s.back() == 'L') {
			for (int i = 0; i < n; ++i) {
				string p;
				for (int j = 0; j < m; ++j) {
					if (v[i][j] != '.') {
						p += v[i][j];
					}
				}
				p = p + string(m - p.size(), '.');
				v[i] = p;
			}
		}
		else if (s.back() == 'U') {
			for (int i = 0; i < m; ++i) {
				string p;
				for (int j = 0; j < n; ++j) {
					if (v[j][i] != '.') {
						p += v[j][i];
					}
				}
				p = p + string(n - p.size(), '.');
				for (int j = 0; j < n; ++j) {
					v[j][i] = p[j];
				}
			}
		}
		else {
			for (int i = 0; i < m; ++i) {
				string p;
				for (int j = 0; j < n; ++j) {
					if (v[j][i] != '.') {
						p += v[j][i];
					}
				}
				p = string(n - p.size(), '.') + p;
				for (int j = 0; j < n; ++j) {
					v[j][i] = p[j];
				}
			}
		}
		s.pop_back();
	};
	step();
	step();

	map <char, char> mp = { {'L', 'R'}, {'R', 'L'}, {'U', 'D'}, {'D', 'U'} };
	
	
	string p;
	while (!s.empty()) {
		if (p.empty()) p.push_back(s.back());
		else if (p.back() == s.back() || p.back() == mp[s.back()]) {
			p.pop_back();
			continue;
		}
		else if (p.size() == 1) {
			p.push_back(s.back());
		}
		else if (p[p.size() - 2] == s.back()) {
			
		}
		else {
			p.push_back(s.back());
		}

		s.pop_back();
	}

	s = p;
	reverse(all(s));
	while (s.size() % 4 != 0) step();
	step();
	step();
	step();
	step();

	int cnt = s.size() / 4;
	s = s.substr(0, 4);

	vector <vector <int>> v1(n, vector <int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (v[i][j] == '.') v1[i][j] = -1;
			else v1[i][j] = i * m + j;
		}
	}
	vector <vector <int>> v2 = v1;
	auto step1 = [&]() {
		if (s.empty()) return;
		if (s.back() == 'R') {
			for (int i = 0; i < n; ++i) {
				vector <int> p;
				for (int j = 0; j < m; ++j) {
					if (v1[i][j] != -1) {
						p.push_back(v1[i][j]);
					}
				}
				vector <int> z(m - p.size(), -1);
				p.insert(p.begin(), all(z));
				v1[i] = p;
			}
		}
		else if (s.back() == 'L') {
			for (int i = 0; i < n; ++i) {
				vector <int> p;
				for (int j = 0; j < m; ++j) {
					if (v1[i][j] != -1) {
						p.push_back(v1[i][j]);
					}
				}
				vector <int> z(m - p.size(), -1);
				p.insert(p.end(), all(z));
				v1[i] = p;
			}
		}
		else if (s.back() == 'U') {
			for (int i = 0; i < m; ++i) {
				vector <int> p;
				for (int j = 0; j < n; ++j) {
					if (v1[j][i] != -1) {
						p.push_back(v1[j][i]);
					}
				}
				vector <int> z(n - p.size(), -1);
				p.insert(p.end(), all(z));
				for (int j = 0; j < n; ++j) {
					v1[j][i] = p[j];
				}
			}
		}
		else {
			for (int i = 0; i < m; ++i) {
				vector <int> p;
				for (int j = 0; j < n; ++j) {
					if (v1[j][i] != -1) {
						p.push_back(v1[j][i]);
					}
				}
				vector <int> z(n - p.size(), -1);
				p.insert(p.begin(), all(z));
				for (int j = 0; j < n; ++j) {
					v1[j][i] = p[j];
				}
			}
		}
		s.pop_back();
	};
	step1();
	step1();
	step1();
	step1();


	while (cnt) {
		if (cnt & 1) {
			auto v3 = v2;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (v1[i][j] != -1) v3[i][j] = v2[v1[i][j] / m][v1[i][j] % m];
				}
			}
			v2 = v3;
		}

		auto v3 = v1;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (v1[i][j] != -1) v3[i][j] = v1[v1[i][j] / m][v1[i][j] % m];
			}
		}
		v1 = v3;

		cnt >>= 1;
	}

	vector <string> vp = v;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (v1[i][j] != -1) vp[i][j] = v[v2[i][j] / m][v2[i][j] % m];
		}
	}
	v = vp;

	for (auto& x : v) {
		cout << x << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}