#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


class SegmentTree {
private:
	vector <int> data;
	int sz;

	int get(int ql, int qr, int nl, int nr, int node) {
		if (ql >= nr || nl >= qr) return 1e18;
		if (ql <= nl && nr <= qr) return data[node];

		return min(
			get(ql, qr, nl, (nl + nr) / 2, node * 2),
			get(ql, qr, (nl + nr) / 2, nr, node * 2 + 1)
		);
	}

public:
	SegmentTree(int n) {
		sz = 1;
		while (sz < n) sz *= 2;

		data.assign(2 * sz, 0);
	}

	int get(int l, int r) {
		return get(l, r, 0, sz, 1);
	}
	
	void upd(int pos, int val) {
		pos += sz;
		data[pos] = val;
		while ((pos /= 2) > 0) {
			data[pos] = min(data[pos * 2], data[pos * 2 + 1]);
		}
	}
};


void solve() {
	int n, m, k, p; cin >> n >> m >> k >> p;
	int c; cin >> c;
	vector <int> v(n);
	for (auto& x : v) {
		cin >> x;
		--x;
	}


	vector <int> skoka(k, 0);
	int emp = m;
	set <int> st;
	vector <pair <int, int>> sg;
	int ans = n + 1;
	for (int i = 0; i < n; ++i) {
		if (skoka[v[i]] == 0) {
			if (emp == 0) {
				++emp;
				sg.push_back({ *st.begin(), i });
				st.erase(st.begin());
			}
			--emp;
			skoka[v[i]] += p;
		}
		--skoka[v[i]];
		if (skoka[v[i]] % p == 0) st.insert(i);
	}

	if (sg.empty()) {
		cout << n + 1;
		return;
	}

	
	sort(all(sg));
	vector <int> dp(sg.size() + 1, 0);
	for (int i = 0; i < sg.size(); ++i) {
		int l = -1, r = i;
		while (l + 1 != r) {
			int mid = (l + r) / 2;
			if (sg[mid].second > sg[i].first) r = mid;
			else l = mid;
		}
		dp[i + 1] = dp[l + 1] + (sg[i].first + 1) * 2;
	}

	vector <int> dph(sg.size() + 1, 0);
	for (int i = sg.size() - 1; i >= 0; --i) {
		int l = i, r = sg.size();
		while (l + 1 != r) {
			int mid = (l + r) / 2;
			if (sg[i].second > sg[mid].first) l = mid;
			else r = mid;
		}
		dph[i] = dph[r] + (n - sg[i].second) * 2;
	}

	if (c == 1) {
		cout << n + 1 + dph[0];
	}
	else if (c == 2) {
		cout << n + 1 + dp[sg.size()];
	}
	else {
		int mn = 1e18;
		for (int i = 0; i < sg.size() + 1; ++i) {
			mn = min(dph[i] + dp[i], mn);
		}
		cout << n + 1 + mn;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}