#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


int hs(pair <int, int> p) {
	return (p.first << 32) | p.second;
}

pair <int, int> getp(int h) {
	return { h >> 32, h % (1ll << 32) };
}

void solve() {
	int n; cin >> n;
	vector <tuple <int, int, int, int>> v(n);
	

	vector <int> bigx, bigy;
	for (auto& [lx, rx, ly, ry] : v) {
		cin >> lx >> ly >> rx >> ry;
		--lx;
		--ly;
		bigx.push_back(lx);
		bigx.push_back(rx);
		bigy.push_back(ly);
		bigy.push_back(ry);
	}

	sort(all(bigx));
	bigx.resize(unique(all(bigx)) - bigx.begin());
	sort(all(bigy));
	bigy.resize(unique(all(bigy)) - bigy.begin());
	for (auto& [lx, rx, ly, ry] : v) {
		lx = lower_bound(all(bigx), lx) - bigx.begin();
		rx = lower_bound(all(bigx), rx) - bigx.begin();
		ry = lower_bound(all(bigy), ry) - bigy.begin();
		ly = lower_bound(all(bigy), ly) - bigy.begin();
	}

	
	vector <int> h(bigx.size());
	vector <vector <int>> add(bigx.size()), del(bigx.size());
	for (auto& [lx, rx, ly, ry] : v) {
		add[lx].push_back(ry);
		del[rx].push_back(ry);
	}

	{
		multiset <int, greater <int>> st;
		for (int i = 0; i < bigx.size(); ++i) {
			for (auto& x : add[i]) st.insert(x);
			for (auto& x : del[i]) st.erase(st.find(x));
			if (!st.empty()) {
				h[i] = *st.begin();
			}
		}
	}

	assert(h[bigx.size() - 1] == 0);
	vector <pair <int, int>> st;
	map <pair <int, int>, int> cnt;
	for (int i = 0; i < bigx.size(); ++i) {
		int ps = i;
		while (!st.empty() && st.back().first >= h[i]) {
			if (st.back().first > h[i]) {
				if (st.size() == 1) {
					cnt[{st.back().second, i}] = bigy[st.back().first] - bigy[h[i]];
				}
				else {
					cnt[{st.back().second, i}] = bigy[st.back().first] - bigy[max(h[i], st[st.size() - 2].first)];
				}
			}
			ps = st.back().second;
			st.pop_back();
		}
		st.push_back({ h[i], ps });
	}

	cout << cnt.size() << '\n';
	for (auto [p, c] : cnt) {
		cout << bigx[p.first] + 1 << ' ' << bigx[p.second] << ' ' << c << ' ' << c << '\n';
	}
}

//void solve1() {
//	int n; cin >> n;
//	vector <tuple <int, int, int, int>> v(n);
//
//
//	vector <int> bigx, bigy;
//	for (auto& [lx, rx, ly, ry] : v) {
//		cin >> lx >> ly >> rx >> ry;
//		--lx;
//		--ly;
//		bigx.push_back(lx);
//		bigx.push_back(rx);
//		bigy.push_back(ly);
//		bigy.push_back(ry);
//	}
//
//	sort(all(bigx));
//	bigx.resize(unique(all(bigx)) - bigx.begin());
//	sort(all(bigy));
//	bigy.resize(unique(all(bigy)) - bigy.begin());
//	for (auto& [lx, rx, ly, ry] : v) {
//		lx = lower_bound(all(bigx), lx) - bigx.begin();
//		rx = lower_bound(all(bigx), rx) - bigx.begin();
//		ry = lower_bound(all(bigy), ry) - bigy.begin();
//		ly = lower_bound(all(bigy), ly) - bigy.begin();
//	}
//
//
//	vector <int> hl(bigy.size());
//	{
//		vector <vector <int>> add(bigy.size()), del(bigy.size());
//		for (auto& [lx, rx, ly, ry] : v) {
//			add[ly].push_back(lx);
//			del[ry].push_back(lx);
//		}
//
//		multiset <int> st;
//		for (int i = 0; i < bigy.size(); ++i) {
//			for (auto& x : add[i]) st.insert(x);
//			for (auto& x : del[i]) st.erase(st.find(x));
//			if (!st.empty()) {
//				hl[i] = *st.begin();
//			}
//		}
//	}
//	vector <int> hr(bigy.size());
//	{
//		vector <vector <int>> add(bigy.size()), del(bigy.size());
//		for (auto& [lx, rx, ly, ry] : v) {
//			add[ly].push_back(lx);
//			del[ry].push_back(lx);
//		}
//
//		multiset <int> st;
//		for (int i = 0; i < bigy.size(); ++i) {
//			for (auto& x : add[i]) st.insert(x);
//			for (auto& x : del[i]) st.erase(st.find(x));
//			if (!st.empty()) {
//				hl[i] = *st.begin();
//			}
//		}
//	}
//
//
//	vector <pair <int, int>> st;
//	map <pair <int, int>, int> cnt;
//	for (int i = 0; i < bigx.size(); ++i) {
//		int ps = i;
//		while (!st.empty() && st.back().first >= h[i]) {
//			if (st.back().first > h[i]) {
//				if (st.size() == 1) {
//					cnt[{st.back().second, i}] += st.back().first - h[i];
//				}
//				else {
//					cnt[{st.back().second, i}] += st.back().first - max(h[i], st[st.size() - 2].first);
//				}
//			}
//			ps = st.back().second;
//			st.pop_back();
//		}
//		st.push_back({ h[i], ps });
//	}
//
//	cout << cnt.size() << '\n';
//	for (auto [p, c] : cnt) {
//		cout << bigx[p.first] + 1 << ' ' << bigx[p.second] << ' ' << c << ' ' << c << '\n';
//	}
//}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}