#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <unordered_set>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


int hs(pair <int, int> p) {
	return (p.first << 32) | p.second;
}

void solve() {
	int n; cin >> n;
	vector <tuple <int, int, int, int>> v(n);
	

	vector <int> bigx, bigy;
	for (auto& [lx, rx, ly, ry] : v) {
		cin >> lx >> ly >> rx >> ry;
		--lx;
		--ly;
		bigx.push_back(lx);
		bigx.push_back(rx);
		bigy.push_back(ly);
		bigy.push_back(ry);
	}

	sort(all(bigx));
	sort(all(bigy));
	for (auto& [lx, rx, ly, ry] : v) {
		lx = lower_bound(all(bigx), lx) - bigx.begin();
		rx = lower_bound(all(bigx), rx) - bigx.begin();
		ry = lower_bound(all(bigy), ry) - bigy.begin();
		ly = lower_bound(all(bigy), ly) - bigy.begin();
	}

	vector <vector <int32_t>> mp(bigy.size(), vector <int32_t>(bigx.size()));
	for (auto [lx, rx, ly, ry] : v) {
		mp[ly][lx] += 1;
		mp[ry][rx] += 1;
		mp[ly][rx] -= 1;
		mp[ry][lx] -= 1;
	}

	for (int i = bigy.size() - 2; i >= 0; --i) {
		mp[i][bigx.size() - 1] += mp[i + 1][bigx.size() - 1];
	}
	for (int i = bigx.size() - 2; i >= 0; --i) {
		mp[bigy.size() - 1][i] += mp[bigy.size() - 1][i + 1];
	}
	for (int i = bigy.size() - 2; i >= 0; --i) {
		for (int j = bigx.size() - 2; j >= 0; --j) {
			mp[i][j] = mp[i][j] + mp[i + 1][j] + mp[i][j + 1] - mp[i + 1][j + 1];
		}
	}

	map <pair <int, int>, int> ans;
	map <pair <int, int>, pair <int, int>> lmp;
	map <pair <int, int>, int> mx;
	for (int i = 1; i < bigy.size(); ++i) {
		int lst = 0;
		for (int j = 1; j < bigx.size(); ++j) {
			if (mp[i][j] && !mp[i][j - 1]) lst = j;
			if (mp[i][j] && (j == bigx.size() - 1 || !mp[i][j + 1])) {
				ans[{lst, j}] += bigy[i] - bigy[i - 1];
				mx[{lst, j}] = max(mx[{lst, j}], bigy[i] - bigy[i - 1]);
				if (lmp.count({ lst, j }) && lmp[{lst, j}].second == i - 1) {
					mx[{lst, j}] = max(mx[{lst, j}], bigy[i] - bigy[lmp[{lst, j}].first - 1]);
					lmp[{lst, j}].second = i;
				}
				else {
					lmp[{lst, j}] = { i, i };
				}
				
			}
		}
	}

	cout << ans.size() << '\n';
	for (auto& [p, cnt] : ans) cout << bigx[p.first - 1] + 1 << ' ' << bigx[p.second] << ' ' << cnt << ' ' << mx[p] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}