// NEVER USE ENDL IN INTERACTIVE TASKS!
// AND SOLVE IT ON 100 POINTS!
// ENDL & FLUSH is a FAKE!
// (c) Mark Privodnov
//
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <sstream>

using namespace std;
using ll=long long;
using ld=long double;

struct table_int
{
	int n, m;
	vector <vector<ll>> tmp;
	table_int(int n, int m) :tmp(n, vector<ll>(m, -1)), n(n), m(m)
	{
	}

	void on_cmd(char c)
	{
		vector <vector<ll>> cache(n, vector<ll>(m, -1));
		switch (c)
		{
		case 'U':
		{
			vector <int>pos(m);
			for (size_t i = 0; i < n; i++)
			{
				for (size_t j = 0; j < m; j++)
				{
					if (tmp[i][j] == -1)
					{
						continue;
					}
					cache[pos[j]++][j] = tmp[i][j];
				}
			}
			break;
		}
		case 'D':
		{
			vector <int>pos(m, n - 1);
			for (int i = n - 1; i >= 0; i--)
			{
				for (size_t j = 0; j < m; j++)
				{
					if (tmp[i][j] == -1)
					{
						continue;
					}
					cache[pos[j]--][j] = tmp[i][j];
				}
			}
			break;
		}
		case 'L':
		{
			vector <int>pos(n);
			for (size_t i = 0; i < m; i++)
			{
				for (size_t j = 0; j < n; j++)
				{
					if (tmp[j][i] == -1)
					{
						continue;
					}
					cache[j][pos[j]++] = tmp[j][i];
				}
			}
			break;
		}
		case 'R':
		{
			vector <int>pos(n, m - 1);
			for (int i = m - 1; i >= 0; i--)
			{
				for (size_t j = 0; j < n; j++)
				{
					if (tmp[j][i] == -1)
					{
						continue;
					}
					cache[j][pos[j]--] = tmp[j][i];
				}
			}
			break;
		}
		default:
			break;
		}
		tmp = cache;
	}
};

struct cycle
{
	vector<ll> path;
	unordered_map<int, int> go;

	ll get(ll t, int cnt)
	{
		int id = go[t];
		id += cnt;
		id %= path.size();
		return path[id];
	}

	void push(ll k)
	{
		go[k] = path.size();
		path.push_back(k);
	}
};

struct table
{
	int n, m;
	vector <vector<char>> tmp;
	table(int n, int m):tmp(n,vector<char>(m)),n(n),m(m)
	{
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				cin >> tmp[i][j];
			}
		}
	}

	void on_cmd(char c)
	{
		vector <vector<char>> cache(n, vector<char>(m, '.'));
		switch (c)
		{
		case 'U':
		{
			vector <int>pos(m);
			for (size_t i = 0; i < n; i++)
			{
				for (size_t j = 0; j < m; j++)
				{
					if (tmp[i][j] == '.')
					{
						continue;
					}
					cache[pos[j]++][j] = tmp[i][j];
				}
			}
			break;
		}
		case 'D':
		{
			vector <int>pos(m, n - 1);
			for (int i = n - 1; i >= 0; i--)
			{
				for (size_t j = 0; j < m; j++)
				{
					if (tmp[i][j] == '.')
					{
						continue;
					}
					cache[pos[j]--][j] = tmp[i][j];
				}
			}
			break;
		}
		case 'L':
		{
			vector <int>pos(n);
			for (size_t i = 0; i < m; i++)
			{
				for (size_t j = 0; j < n; j++)
				{
					if (tmp[j][i] == '.')
					{
						continue;
					}
					cache[j][pos[j]++] = tmp[j][i];
				}
			}
			break;
		}
		case 'R':
		{
			vector <int>pos(n, m - 1);
			for (int i = m - 1; i >= 0; i--)
			{
				for (size_t j = 0; j < n; j++)
				{
					if (tmp[j][i] == '.')
					{
						continue;
					}
					cache[j][pos[j]--] = tmp[j][i];
				}
			}
			break;
		}
		default:
			break;
		}
		tmp = cache;
	}

	void lurd(int cnt)
	{
		if (cnt == 0)
			return;
		on_cmd('L');
		on_cmd('U');
		on_cmd('R');
		on_cmd('D');
		cnt--;
		/*for (size_t i = 0; i < cnt; i++)
		{
			on_cmd('L');
			on_cmd('U');
			on_cmd('R');
			on_cmd('D');
		}*/
		table_int tbl(n, m);
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				tbl.tmp[i][j] = i + j * n;
			}
		}
		tbl.on_cmd('L');
		tbl.on_cmd('U');
		tbl.on_cmd('R');
		tbl.on_cmd('D');
		vector <ll> go(n * m);
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				go[tbl.tmp[i][j]] = i + j * n;
			}
		}
		vector<int> cm(n * m, -1);
		vector <cycle> ct;
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				if (cm[i + j * n] != -1)
					continue;
				cycle t;
				ll we = i + j * n;
				do
				{
					cm[we] = ct.size();
					t.push(we);
					we = go[we];
				} while (we != (i+j*n));
				ct.push_back(t);
			}
		}
		vector <vector<char>> cache(n, vector<char>(m, '.'));
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				ll from = i + j * n, to = ct[cm[from]].get(from, cnt);
				cache[to % n][to / n] = tmp[i][j];
				/*ll cur = i + j * n;
				for (size_t i = 0; i < cnt; i++)
				{
					cur = go[cur];
				}
				cache[cur % n][cur / n] = tmp[i][j];*/
			}
		}
		tmp = cache;
		/*for (size_t i = 0; i < cnt; i++)
		{
			on_cmd('L');
			on_cmd('U');
			on_cmd('R');
			on_cmd('D');
		}*/
	}

	void ldru(int cnt)
	{
		if (cnt == 0)
			return;
		on_cmd('L');
		on_cmd('D');
		on_cmd('R');
		on_cmd('U');
		cnt--;
		/*for (size_t i = 0; i < cnt; i++)
		{
			on_cmd('L');
			on_cmd('U');
			on_cmd('R');
			on_cmd('D');
		}*/
		table_int tbl(n, m);
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				tbl.tmp[i][j] = i + j * n;
			}
		}
		tbl.on_cmd('L');
		tbl.on_cmd('D');
		tbl.on_cmd('R');
		tbl.on_cmd('U');
		vector <ll> go(n * m);
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				go[tbl.tmp[i][j]] = i + j * n;
			}
		}
		vector<int> cm(n * m, -1);
		vector <cycle> ct;
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				if (cm[i + j * n] != -1)
					continue;
				cycle t;
				ll we = i + j * n;
				do
				{
					cm[we] = ct.size();
					t.push(we);
					we = go[we];
				} while (we != (i + j * n));
				ct.push_back(t);
			}
		}
		vector <vector<char>> cache(n, vector<char>(m, '.'));
		for (size_t i = 0; i < n; i++)
		{
			for (size_t j = 0; j < m; j++)
			{
				if (tmp[i][j] == '.')
					continue;
				ll from = i + j * n, to = ct[cm[from]].get(from, cnt);
				cache[to % n][to / n] = tmp[i][j];
				/*ll cur = i + j * n;
				for (size_t i = 0; i < cnt; i++)
				{
					cur = go[cur];
				}
				cache[cur % n][cur / n] = tmp[i][j];*/
			}
		}
		tmp = cache;
		/*for (size_t i = 0; i < cnt; i++)
		{
			on_cmd('L');
			on_cmd('D');
			on_cmd('R');
			on_cmd('U');
		}*/
	}
};

void solve()
{
	int m, n;
	cin >> n >> m;
	table t(n, m);
	string s;
	cin >> s;
	int q = s.size();
	string st;
	int x = 1, y = 1;
	for (auto& i : s)
	{
		switch (i)
		{
		case 'U':
			if (x == 0)
				break;
			x = 0;
			if (!st.empty() && st.back() == 'D')
			{
				st.pop_back();
			}
			{
				st.push_back(i);
			}
			break;
		case 'D':
			if (x == 2)
				break;
			x = 2;
			if (!st.empty() && st.back() == 'U')
			{
				st.pop_back();
			}
			{
				st.push_back(i);
			}
			break;
		case 'L':
			if (y == 0)
				break;
			y = 0;
			if (!st.empty() && st.back() == 'R')
			{
				st.pop_back();
			}
			{
				st.push_back(i);
			}
			break;
		case 'R':
			if (y == 2)
				break;
			y = 2;
			if (!st.empty() && st.back() == 'L')
			{
				st.pop_back();
			}
			{
				st.push_back(i);
			}
			break;
		default:
			break;
		}
	}
	size_t i;
	string qas = "";
	for (i = 0; i < st.size(); i++)
	{
		if (st[i] == 'L')
			break;
		t.on_cmd(st[i]);
		qas += st[i];
	}
	int sz = st.size() - i;
	if (sz / 4 != 0)
	{
		if (st[i + 1] == 'U')
		{
			t.lurd(sz / 4);
			string qas = "";
			for (size_t i = 0; i < sz / 4; i++)
			{
				qas += "LURD";
			}
			if (st[i + 2] != 'R')
				exit(-1);
		}
		else
		{
			t.ldru(sz / 4);
			for (size_t i = 0; i < sz / 4; i++)
			{
				qas += "LDRU";
			}
		}
	}
	i += (sz / 4) * 4;
	for (; i < st.size(); i++)
	{
		t.on_cmd(st[i]);
		qas += st[i];
	}
	/*if (qas.size() != st.size())
		exit(-1);*/
	//unordered_map<char, int> lst;
	//for (size_t i = 0; i < q; i++)
	//{
	//	char c = s[i];
	//	lst[c] = i;
	//	t.on_cmd(c);
	//}
	//vector <pair<int, char>> req;
	//for (auto& i : lst)
	//{
	//	req.emplace_back(i.second, i.first);
	//}
	//sort(req.begin(), req.end());
	///*for (auto& i : req)
	//{
	//	t.on_cmd(i.second);
	//}*/
	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < m; j++)
		{
			cout << t.tmp[i][j];
		}
		cout << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
