#include <algorithm>
#include <iostream>
#include <unordered_map>
#include <vector>

std::unordered_map<long long, int> f;
constexpr long long maxc = 1000000000000;

void addf(long long i, int x) {
    while (i < maxc) {
        f[i] += x;
        i |= (i + 1);
    }
}

int getpreff(long long i) {
    int res = 0;
    while (i >= 0) {
        if (f.find(i) != f.end()) {
            res += f[i];
        }
        i = (i & (i + 1)) - 1;
    }
    return res;
}

long long cadd = 0;

void add(long long x) {
    addf(x + cadd, 1);
}

int cntpref(long long x) {
    return getpreff(x + cadd);
}

void suball(long long x) {
    cadd += x;
}

int main() {
    int n, m, c, p;
    std::cin >> n >> m >> c >> p;
    std::vector<std::pair<int, int>> a(n + m);
    for (int i = 0; i < n + m; i++) {
        std::cin >> a[i].first >> a[i].second;
    }
    long long res = 0;
    long long csum2 = 0;
    for (int i = 0; i < n + m; i++) {
        if (a[i].first == 2) {
            add(a[i].second + csum2);
        } else {
            csum2 += a[i].second;
        }
    }
    for (int i = 0; i < n + m; i++) {
        if (a[i].first == 1) {
            suball(a[i].second);
        } else {
            long long cres = p * 1ll * cntpref(a[i].second) - c * 1ll * (cadd + a[i].second - 1);
            res = std::max(res, cres);
        }
    }
    std::cout << res << '\n';
    return 0;
}