#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> a(n, std::vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cin >> a[i][j];
        }
    }

    std::string q;
    std::cin >> q;
    bool curleft = false;
    bool curright = false;
    bool hadu = false;
    for (char el : q) {
        if (el == 'U' && !hadu) {
            if (curleft) {
                for (int i = 0; i < n; i++) {
                    int clast = 0;
                    for (int j = 0; j < m; j++) {
                        if (a[i][j] != '.') {
                            a[i][clast++] = a[i][j];
                        }
                    }
                    for (int j = clast; j < m; j++) {
                        a[i][j] = '.';
                    }
                }
            } else if (curright) {
                for (int i = 0; i < n; i++) {
                    int clast = m - 1;
                    for (int j = m - 1; j >= 0; j--) {
                        if (a[i][j] != '.') {
                            a[i][clast--] = a[i][j];
                        }
                    }
                    for (int j = clast; j >= 0; j--) {
                        a[i][j] = '.';
                    }
                }
            }
            for (int j = 0; j < m; j++) {
                int clast = 0;
                for (int i = 0; i < n; i++) {
                    if (a[i][j] != '.') {
                        a[clast++][j] = a[i][j];
                    }
                }
                for (int i = clast; i < n; i++) {
                    a[i][j] = '.';
                }
            }
            hadu = true;
        } else if (el == 'L') {
            curleft = true;
            curright = false;
        } else if (el == 'R') {
            curleft = false;
            curright = true;
        } else if (el == 'D') {
            exit(1);
        }
    }
    if (curleft) {
        for (int i = 0; i < n; i++) {
            int clast = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    a[i][clast++] = a[i][j];
                }
            }
            for (int j = clast; j < m; j++) {
                a[i][j] = '.';
            }
        }
    } else if (curright) {
        for (int i = 0; i < n; i++) {
            int clast = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    a[i][clast--] = a[i][j];
                }
            }
            for (int j = clast; j >= 0; j--) {
                a[i][j] = '.';
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cout << a[i][j];
        }
        std::cout << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}