#include <algorithm>
#include <cassert>
#include <iostream>
#include <string>
#include <vector>

void alignl(int n, int m, std::vector<std::vector<char>>& a) {
    for (int i = 0; i < n; i++) {
        int clast = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                a[i][clast++] = a[i][j];
            }
        }
        for (int j = clast; j < m; j++) {
            a[i][j] = '.';
        }
    }
}

void alignr(int n, int m, std::vector<std::vector<char>>& a) {
    for (int i = 0; i < n; i++) {
        int clast = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] != '.') {
                a[i][clast--] = a[i][j];
            }
        }
        for (int j = clast; j >= 0; j--) {
            a[i][j] = '.';
        }
    }
}

void alignu(int n, int m, std::vector<std::vector<char>>& a) {
    for (int j = 0; j < m; j++) {
        int clast = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.') {
                a[clast++][j] = a[i][j];
            }
        }
        for (int i = clast; i < n; i++) {
            a[i][j] = '.';
        }
    }
}

void alignd(int n, int m, std::vector<std::vector<char>>& a) {
    for (int j = 0; j < m; j++) {
        int clast = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] != '.') {
                a[clast--][j] = a[i][j];
            }
        }
        for (int i = clast; i >= 0; i--) {
            a[i][j] = '.';
        }
    }
}

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> a(n, std::vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cin >> a[i][j];
            assert(a[i][j] == 'a' || a[i][j] == '.');
        }
    }
    std::string q;
    std::cin >> q;
    bool curl = false;
    bool curr = false;
    bool curu = false;
    bool curd = false;
    for (char el : q) {
        if (el == 'U') {
            if (!curu && !curd) {
                if (curl) {
                    alignl(n, m, a);
                } else if (curr) {
                    alignr(n, m, a);
                }
                alignu(n, m, a);
            }
            curu = true;
            curd = false;
        } else if (el == 'D') {
            if (!curu && !curd) {
                if (curl) {
                    alignl(n, m, a);
                } else if (curr) {
                    alignr(n, m, a);
                }
                alignd(n, m, a);
            }
            curd = true;
            curu = false;
        } else if (el == 'L') {
            if (!curl && !curr) {
                if (curu) {
                    alignu(n, m, a);
                } else if (curd) {
                    alignd(n, m, a);
                }
                alignl(n, m, a);
            }
            curl = true;
            curr = false;
        } else {
            if (!curl && !curr) {
                if (curu) {
                    alignu(n, m, a);
                } else if (curd) {
                    alignd(n, m, a);
                }
                alignr(n, m, a);
            }
            curr = true;
            curl = false;
        }
    }
    if (curl) {
        alignl(n, m, a);
    } else if (curr) {
        alignr(n, m, a);
    }
    if (curu) {
        alignu(n, m, a);
    } else if (curd) {
        alignd(n, m, a);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cout << a[i][j];
        }
        std::cout << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
