#include <algorithm>
#include <iostream>
#include <map>
#include <vector>

struct Ev {
    int y;
    int l;
    int r;
    int type;
    Ev() = default;
    Ev(int _y, int _l, int _r, int _type) : y(_y), l(_l), r(_r), type(_type) {}
};

void solve() {
    int n;
    std::cin >> n;
    std::vector<Ev> evs;
    evs.reserve(2 * n);
    int w = 0;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        std::cin >> x1 >> y1 >> x2 >> y2;
        evs.emplace_back(y1, x1, x2, 1);
        evs.emplace_back(y2 + 1, x1, x2, -1);
        w = std::max(w, x2);
    }
    std::sort(evs.begin(), evs.end(), [](const Ev& a, const Ev& b) {
        return a.y < b.y;
    });
    std::vector<int> cnt(w + 1);
    std::map<std::pair<int, int>, long long> cnts, maxh;
    for (int i = 0; i < 2 * n; i++) {
        if (evs[i].type == 1) {
            for (int j = evs[i].l; j <= evs[i].r; j++) {
                cnt[j]++;
            }
        } else {
            for (int j = evs[i].l; j <= evs[i].r; j++) {
                cnt[j]--;
            }
        }
        if (i != 2 * n - 1 && evs[i + 1].y != evs[i].y) {
            int cfirst = 0;
            for (int j = 0; j <= w; j++) {
                if (cnt[j] == 0) {
                    if (cfirst != j) {
                        cnts[{cfirst, j - 1}] += ((long long)evs[i + 1].y - evs[i].y);
                        maxh[{cfirst, j - 1}] = std::max(maxh[{cfirst, j - 1}], (long long)evs[i + 1].y - evs[i].y);
                    }
                    cfirst = j + 1;
                }
            }
            if (cfirst != w + 1) {
                cnts[{cfirst, w}] += ((long long)evs[i + 1].y - evs[i].y);
                maxh[{cfirst, w}] = std::max(maxh[{cfirst, w - 1}], (long long)evs[i + 1].y - evs[i].y);
            }
        }
    }
    std::cout << cnts.size() << '\n';
    for (const auto& [p, ccnt] : cnts) {
        std::cout << p.first << ' ' << p.second << ' ' << ccnt << ' ' << maxh[p] << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
