#include <algorithm>
#include <iostream>
#include <map>
#include <set>
#include <vector>

constexpr int inf = 2000000000;

struct Ev {
    int y;
    int l;
    int r;
    int type;
    int num;
    Ev() = default;
    Ev(int _y, int _l, int _r, int _type) : y(_y), l(_l), r(_r), type(_type) {}
};

struct Evline {
    int x;
    int type;
    int i;
    Evline() = default;
    Evline(int _x, int _type, int _i) : x(_x), type(_type), i(_i) {}
    bool operator<(const Evline& other) const {
        if (x != other.x) return x < other.x;
        if (type != other.type) return type > other.type;
        return i < other.i;
    }
};

void solve() {
    int n;
    std::cin >> n;
    std::vector<Ev> evs;
    evs.reserve(2 * n);
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        std::cin >> x1 >> y1 >> x2 >> y2;
        evs.emplace_back(y1, x1, x2, 1);
        evs.back().num = i;
        evs.emplace_back(y2 + 1, x1, x2, -1);
        evs.back().num = i;
    }
    std::sort(evs.begin(), evs.end(), [](const Ev& a, const Ev& b) {
        return a.y < b.y;
    });
    std::map<std::pair<int, int>, long long> cnts, maxh;
    std::set<Evline> evs2;
    for (int i = 0; i < 2 * n; i++) {
        if (evs[i].type == 1) {
            evs2.emplace(evs[i].l, 1, 2 * evs[i].num);
            evs2.emplace(evs[i].r + 1, -1, 2 * evs[i].num + 1);
        } else {
            evs2.erase(Evline(evs[i].l, 1, 2 * evs[i].num));
            evs2.erase(Evline(evs[i].r + 1, -1, 2 * evs[i].num + 1));
        }
        if (i != 2 * n - 1 && evs[i + 1].y != evs[i].y) {
            int curcnt = 0;
            int curleft = inf;
            for (auto it = evs2.begin(); it != evs2.end(); it++) {
                if (it->type == 1) {
                    curcnt++;
                } else {
                    curcnt--;
                }
                if (curcnt == 0) {
                    cnts[{curleft, it->x - 1}] += evs[i + 1].y - evs[i].y;
                    maxh[{curleft, it->x - 1}] = std::max(maxh[{curleft, it->x - 1}], (long long)evs[i + 1].y - evs[i].y);
                    curleft = inf;
                } else if (std::next(it)->x != it->x && curleft == inf) {
                    curleft = it->x;
                }
            }
        }
    }
    std::cout << cnts.size() << '\n';
    for (const auto& [p, ccnt] : cnts) {
        std::cout << p.first << ' ' << p.second << ' ' << ccnt << ' ' << maxh[p] << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
