#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using ll = long long;

const int LOG = 20;

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> a(n, std::vector<char>(m));
    for (auto &e : a) {
        for (auto &c : e) {
            std::cin >> c;
        }
    }
    auto move = [&](char dir) {
        if (dir == 'L') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != '.') {
                        char c = a[i][j];
                        a[i][j] = '.';
                        a[i][cnt++] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'R') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = m - 1; j >= 0; j--) {
                    if (a[i][j] != '.') {
                        char c = a[i][j];
                        a[i][j] = '.';
                        a[i][m - ++cnt] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'U') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (a[i][j] != '.') {
                        auto c = a[i][j];
                        a[i][j] = '.';
                        a[cnt++][j] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'D') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = n - 1; i >= 0; i--) {
                    if (a[i][j] != '.') {
                        auto c = a[i][j];
                        a[i][j] = '.';
                        a[n - ++cnt][j] = c;
                    }
                }
                cnt = 0;
            }
        }
    };
    std::string s;
    std::cin >> s;
    auto type = [&](char c){
        return c == 'L' || c == 'R';
    };
    std::string s1;
    std::stack<char> prefh, prefv;
    prefh.push('a');
    prefv.push('a');
    for (auto c : s) {
        if (s1.empty()) {
            s1.push_back(c);
            if (type(c)) {
                prefh.push(c);
            } else {
                prefv.push(c);
            }
            continue;
        } else {
            if (type(s1.back()) == type(c) && s1.back() != c) {
                s1.pop_back();
                if (type(c)) {
                    prefh.pop();
                } else {
                    prefv.pop();
                }
            }
        }
        if (type(c) && c == prefh.top()) {
            continue;
        } else {
            if (!type(c) && c == prefv.top()) {
                continue;
            } else {
                s1.push_back(c);
                if (type(c)) {
                    prefh.push(c);
                } else {
                    prefv.push(c);
                }
            }
        }
    }
//    int L = s1.size() % 4 + 8;
    int L = 24;
    if (s1.size() <= L) {
        for (auto c : s1) {
            move(c);
        }
        for (auto &e : a) {
            for (auto c : e) {
                std::cout << c;
            }
            std::cout << '\n';
        }
        return;
    }

    auto X = a;
    for (auto c : s1) {
        move(c);
    }
    /*for (auto &e : a) {
        for (auto c : e) {
            std::cout << c;
        }
        std::cout << '\n';
    }
    a = X;

    for (int i = 0; i < L; i++) {
        move(s1[i]);
    }



    ///



    std::vector<std::vector<int>> b(n, std::vector<int>(m, -1));
    auto move2 = [&](char dir) {
        if (dir == 'L') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (b[i][j] != -1) {
                        int c = b[i][j];
                        b[i][j] = -1;
                        b[i][cnt++] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'R') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = m - 1; j >= 0; j--) {
                    if (b[i][j] != -1) {
                        int c = b[i][j];
                        b[i][j] = -1;
                        b[i][m - ++cnt] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'U') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (b[i][j] != -1) {
                        int c = b[i][j];
                        b[i][j] = -1;
                        b[cnt++][j] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'D') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = n - 1; i >= 0; i--) {
                    if (b[i][j] != -1) {
                        int c = b[i][j];
                        b[i][j] = -1;
                        b[n - ++cnt][j] = c;
                    }
                }
                cnt = 0;
            }
        }
    };
    int cnt = 0;
    std::vector<char> lit;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                b[i][j] = cnt++;
                lit.push_back(a[i][j]);
            }
        }
    }
    a.clear();
    auto c = b;
    for (int i = L; i < L + 4; i++) {
        move2(s1[i]);
    }
    std::vector<int> up[LOG];
    for (auto &e : up) {
        e.resize(cnt);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (b[i][j] != -1) {
                up[0][b[i][j]] = c[i][j];
            }
        }
    }
    for (int l = 1; l < LOG; l++) {
        for (int i = 0; i < cnt; i++) {
            up[l][i] = up[l - 1][up[l - 1][i]];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (c[i][j] == -1) {
                std::cout << '.';
                continue;
            }
            int x = c[i][j];
            int k = ((int)s1.size() - L) / 4;
            for (int l = LOG - 1; l >= 0; l--) {
                if (k >= (1 << l)) {
                    x = up[l][x];
                    k -= (1 << l);
                }
            }
            std::cout << lit[x];
        }
        std::cout << '\n';
    }*/
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}