#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using ll = long long;

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> a(n, std::vector<char>(m));
    for (auto &e : a) {
        for (auto &c : e) {
            std::cin >> c;
        }
    }
    std::string s;
    std::cin >> s;
    auto move = [&](char dir) {
        if (dir == 'L') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != '.') {
                        char c = a[i][j];
                        a[i][j] = '.';
                        a[i][cnt++] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'R') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = m - 1; j >= 0; j--) {
                    if (a[i][j] != '.') {
                        char c = a[i][j];
                        a[i][j] = '.';
                        a[i][m - ++cnt] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'U') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (a[i][j] != '.') {
                        auto c = a[i][j];
                        a[i][j] = '.';
                        a[cnt++][j] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'D') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = n - 1; i >= 0; i--) {
                    if (a[i][j] != '.') {
                        auto c = a[i][j];
                        a[i][j] = '.';
                        a[n - ++cnt][j] = c;
                    }
                }
                cnt = 0;
            }
        }
    };
    auto type = [&](char c){
        return c == 'L' || c == 'R';
    };
    std::string s1;
    std::stack<char> prefh, prefv;
    prefh.push('a');
    prefv.push('a');
    for (auto c : s) {
        if (s1.empty()) {
            s1.push_back(c);
            if (type(c)) {
                prefh.push(c);
            } else {
                prefv.push(c);
            }
            continue;
        } else {
            if (type(s1.back()) == type(c) && s1.back() != c) {
                s1.pop_back();
                if (type(c)) {
                    prefh.pop();
                } else {
                    prefv.pop();
                }
            }
        }
        if (type(c) && c == prefh.top()) {
            continue;
        } else {
            if (!type(c) && c == prefv.top()) {
                continue;
            } else {
                s1.push_back(c);
                if (type(c)) {
                    prefh.push(c);
                } else {
                    prefv.push(c);
                }
            }
        }
    }
//    std::cout << s1 << '\n';
    /*for (auto c : s1) {
        move(c);
    }*/
    for (int i = std::max((int)s1.size() - 7, 0); i < s1.size(); i++) {
        move(s1[i]);
    }
    for (auto &e : a) {
        for (auto c : e) {
            std::cout << c;
        }
        std::cout << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
