#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using ll = long long;

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> a(n, std::vector<char>(m));
    for (auto &e : a) {
        for (auto &c : e) {
            std::cin >> c;
        }
    }
    auto move = [&](char dir) {
        if (dir == 'L') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != '.') {
                        char c = a[i][j];
                        a[i][j] = '.';
                        a[i][cnt++] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'R') {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                for (int j = m - 1; j >= 0; j--) {
                    if (a[i][j] != '.') {
                        char c = a[i][j];
                        a[i][j] = '.';
                        a[i][m - ++cnt] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'U') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (a[i][j] != '.') {
                        auto c = a[i][j];
                        a[i][j] = '.';
                        a[cnt++][j] = c;
                    }
                }
                cnt = 0;
            }
        }
        if (dir == 'D') {
            int cnt = 0;
            for (int j = 0; j < m; j++) {
                for (int i = n - 1; i >= 0; i--) {
                    if (a[i][j] != '.') {
                        auto c = a[i][j];
                        a[i][j] = '.';
                        a[n - ++cnt][j] = c;
                    }
                }
                cnt = 0;
            }
        }
    };
    std::string s;
    std::cin >> s;
    auto type = [&](char c){
        return c == 'L' || c == 'R';
    };
    std::vector<std::string> x = {"LURD", "LDRU", "RULD", "RDLU",
                                  "DLUR", "DRUL", "ULDR", "URDL"};
    std::vector<std::string> y(x.size());
    for (int i = 0; i < x.size(); i++) {
        int idx = 0;
        for (auto c : s) {
            if (c == x[i][idx]) {
                y[i].push_back(c);
                idx = (idx + 1) % 4;
            }
        }
    }
    std::string s1;
    for (auto &e : y) {
        if (s1.size() < e.size()) {
            s1 = e;
        }
    }
//    std::cout << s1 << '\n';
    /*for (auto c : s1) {
        move(c);
//        std::cout << "***\n";
    }*/
    for (int i = std::max(int(s1.size() - s.size() % 4 - 8), 0); i < s1.size(); i++) {
        move(s1[i]);
    }
    for (auto &e : a) {
        for (auto c : e) {
            std::cout << c;
        }
        std::cout << '\n';
    }
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
