#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

struct Ev {
    int t, l, r;
};

void solve() {
    int n;
    std::cin >> n;
    std::vector<Ev> a;
    for (int i = 0; i < n; i++) {
        int xl, xr, yl, yr;
        std::cin >> xl >> yl >> xr >> yr;
        a.push_back({yl, xl, xr});
        a.push_back({-(yr + 1), xl, xr});
    }
    std::sort(a.begin(), a.end(), [&](Ev &x, Ev& y){
        return std::abs(x.t) < std::abs(y.t);
    });
    std::map<std::pair<int, int>, int> m;
    std::multiset<std::pair<int, int>> s;
    int prev = 0;
    for (auto [t, l, r] : a) {
        int u = std::abs(t);
        int ll = -1, rr = -1;
        for (auto [x, y] : s) {
            if (rr + 1 < x) {
                if (rr != -1 && u != prev) {
                    m[{ll, rr}] += u - prev;
                }
                ll = x;
                rr = y;
            } else {
                rr = std::max(rr, y);
            }
        }
        if (rr != -1 && u != prev) {
            m[{ll, rr}] += u - prev;
        }
        prev = u;
        if (t < 0) {
            s.erase(s.find({l, r}));
        } else {
            s.insert({l, r});
        }
    }
    std::cout << m.size() << '\n';
    for (auto [p, x] : m) {
        std::cout << p.first << ' ' << p.second << ' ' << x << ' ' << 0 << '\n';
    }
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
}