#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
using dl = long double;
#define endl "\n"

const ll INF = 3e18;

struct segmentTree {
	vector<ll> vec;
	vector<ll> segTree;
	vector<ll> segTree2;
	vector<ll> hmass;

	void build(ll i, ll l, ll r) {
		if (r - l == 1) {
			segTree[i] = l;
			segTree2[i] = vec[l];
			return;
		}
		ll m = (l + r) / 2;
		build(i * 2 + 1, l, m);
		build(i * 2 + 2, m, r);
		segTree2[i] = min(segTree2[i * 2 + 1], segTree2[i * 2 + 2]);
		segTree[i] = segTree[i * 2 + 1];
		if (segTree2[i * 2 + 2] < segTree2[i * 2 + 1]) segTree[i] = segTree[i * 2 + 2];
	}

	segmentTree(vector<ll> vec) : vec(vec) {
		ll n = vec.size();
		segTree.resize(n * 4);
		segTree2.resize(n * 4);
		hmass.resize(4 * n);
		build(0, 0, n);
	}

	void push(ll i, ll l, ll r) {
		segTree2[i] += hmass[i];
		if (r - l > 1) {
			hmass[i * 2 + 1] += hmass[i];
			hmass[i * 2 + 2] += hmass[i];
		}
		hmass[i] = 0;
	}

	pair<ll, ll> get() {
		push(0, 0, vec.size());
		return { segTree[0], segTree2[0] };
	}

	void add(ll i, ll l, ll r, ll ql, ll qr, ll x) {
		push(i, l, r);
		if (l >= ql && r <= qr) {
			hmass[i] += x;
			push(i, l, r);
			return;
		}
		if (l >= qr || r <= ql) return;
		ll m = (l + r) / 2;
		add(i * 2 + 1, l, m, ql, qr, x);
		add(i * 2 + 2, m, r, ql, qr, x);
		segTree2[i] = min(segTree2[i * 2 + 1], segTree2[i * 2 + 2]);
		segTree[i] = segTree[i * 2 + 1];
		if (segTree2[i * 2 + 2] < segTree2[i * 2 + 1]) segTree[i] = segTree[i * 2 + 2];
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m, c, p; cin >> n >> m >> c >> p;
	vector<ll> vec;
	ll sm = 0;
	for (ll i = 0; i < n + m; i++) {
		ll t, h; cin >> t >> h;
		if (t == 1) sm += h;
		else vec.push_back(h + sm);
	}
	ll ans = 0;
	segmentTree st(vec);
	for (ll i = 0; i < vec.size(); i++) {
		ll lans = (i + 1) * p;
		pair<ll, ll> pr = st.get();
		lans -= (pr.second - 1) * c;
		ans = max(ans, lans);
		st.add(0, 0, vec.size(), pr.first, pr.first + 1, INF);
		//st.add(0, 0, vec.size(), pr.first, INF, 1);
	}

	cout << ans << endl;
}
