#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
using dl = long double;
#define endl "\n"

const ll INF = 3e18;

vector<vector<ll>> vec;
ll n, m;

void doL() {
	for (ll i = 0; i < n; i++) {
		ll id = 0;
		for (ll j = 0; j < m; j++) {
			if (vec[i][j] == 0) continue;
			vec[i][id] = vec[i][j];
			id++;
		}
		for (ll j = id; j < m; j++) vec[i][j] = 0;
	}
}

void doR() {
	for (ll i = 0; i < n; i++) {
		ll id = m - 1;
		for (ll j = m - 1; j >= 0; j--) {
			if (vec[i][j] == 0) continue;
			vec[i][id] = vec[i][j];
			id--;
		}
		for (ll j = id; j >= 0; j--) vec[i][j] = 0;
	}
}

void doU() {
	for (ll i = 0; i < m; i++) {
		ll id = 0;
		for (ll j = 0; j < n; j++) {
			if (vec[j][i] == 0) continue;
			vec[id][i] = vec[j][i];
			id++;
		}
		for (ll j = id; j < n; j++) vec[j][i] = 0;
	}
}

void doD() {
	for (ll i = 0; i < m; i++) {
		ll id = n - 1;
		for (ll j = n - 1; j >= 0; j--) {
			if (vec[j][i] == 0) continue;
			vec[id][i] = vec[j][i];
			id--;
		}
		for (ll j = id; j >= 0; j--) vec[j][i] = 0;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--) {
		cin >> n >> m;
		vec.assign(n, vector<ll>(m, 0));
		for (ll i = 0; i < n; i++) {
			string s; cin >> s;
			for (ll j = 0; j < m; j++) {
				if (s[j] == '.') continue;
				vec[i][j] = s[j] - 'a' + 1;
			}
		}
		string s1; cin >> s1;
		string s = "";
		for (auto sym : s1) {
			bool b = true;
			while (b) {
				b = false;
				if (!s.empty()) {
					bool b1 = s.back() == 'L' || s.back() == 'R';
					bool b2 = sym == 'L' || sym == 'R';
					if (b1 == b2) {
						s.pop_back();
						b = true;
					}
				}
			}
			s.push_back(sym);
		}

		for (ll i = 0; i < s.size(); i++) {
			if (s[i] == 'L') doL();
			if (s[i] == 'R') doR();
			if (s[i] == 'D') doD();
			if (s[i] == 'U') doU();
		}

		for (ll i = 0; i < n; i++) {
			string ans = "";
			for (ll j = 0; j < m; j++) {
				if (vec[i][j] == 0) ans.push_back('.');
				else ans.push_back(vec[i][j] + 'a' - 1);
			}
			cout << ans << endl;
		}
	}
}
