#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numeric>
#include <random>
#include <algorithm>

using namespace std;
using ll = long long;
using dl = long double;
#define endl "\n"

const ll INF = 3e18;

vector<vector<ll>> vec;
ll n, m;

void doL() {
	for (ll i = 0; i < n; i++) {
		ll id = 0;
		for (ll j = 0; j < m; j++) {
			if (vec[i][j] == 0) continue;
			vec[i][id] = vec[i][j];
			id++;
		}
		for (ll j = id; j < m; j++) vec[i][j] = 0;
	}
}

void doR() {
	for (ll i = 0; i < n; i++) {
		ll id = m - 1;
		for (ll j = m - 1; j >= 0; j--) {
			if (vec[i][j] == 0) continue;
			vec[i][id] = vec[i][j];
			id--;
		}
		for (ll j = id; j >= 0; j--) vec[i][j] = 0;
	}
}

void doU() {
	for (ll i = 0; i < m; i++) {
		ll id = 0;
		for (ll j = 0; j < n; j++) {
			if (vec[j][i] == 0) continue;
			vec[id][i] = vec[j][i];
			id++;
		}
		for (ll j = id; j < n; j++) vec[j][i] = 0;
	}
}

void doD() {
	for (ll i = 0; i < m; i++) {
		ll id = n - 1;
		for (ll j = n - 1; j >= 0; j--) {
			if (vec[j][i] == 0) continue;
			vec[id][i] = vec[j][i];
			id--;
		}
		for (ll j = id; j >= 0; j--) vec[j][i] = 0;
	}
}

vector<ll> graph;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--) {
		cin >> n >> m;
		vec.assign(n, vector<ll>(m, 0));
		for (ll i = 0; i < n; i++) {
			string s; cin >> s;
			for (ll j = 0; j < m; j++) {
				if (s[j] == '.') continue;
				vec[i][j] = s[j] - 'a' + 1;
			}
		}
		string s1; cin >> s1;
		string s = "";
		vector<char> dpprev1(1, 0), dpprev2(1, 0);
		for (auto sym : s1) {
			bool b = true;
			bool b2 = sym == 'L' || sym == 'R';
			while (b) {
				b = false;
				if (!s.empty()) {
					bool b1 = s.back() == 'L' || s.back() == 'R';
					if (b1 == b2) {
						s.pop_back();
						dpprev1.pop_back();
						dpprev2.pop_back();
						b = true;
					}
				}
			}
			if (b2) {
				if (dpprev1[dpprev1.size() - 1] == sym) continue;
			}
			if (!b2) {
				if (dpprev2[dpprev2.size() - 1] == sym) continue;
			}
			s.push_back(sym);
			dpprev1.push_back(dpprev1.back());
			dpprev2.push_back(dpprev2.back());
			if (b2) {
				dpprev1[dpprev1.size() - 1] = sym;
			}
			if (!b2) {
				dpprev2[dpprev2.size() - 1] = sym;
			}
		}
		ll id = 0;
		for (ll i = 0; i < s.size(); i++) {
			if (i > 3 && s[i] == 'L') {
				id = i;
				break;
			}
			if (s[i] == 'L') doL();
			if (s[i] == 'R') doR();
			if (s[i] == 'D') doD();
			if (s[i] == 'U') doU();
		}
		string add = "";
		while (((ll)s.size() - id) % 4) {
			add.push_back(s.back());
			s.pop_back();
		}
		reverse(add.begin(), add.end());

		string ns1 = "";
		for (ll i = id; i < s.size(); i++) ns1.push_back(s[i]);
		s = ns1;

		//make LURD
		ll cnt = s.size() / 4;
		if (cnt > 0) {
			vector<vector<ll>> v0 = vec;
			ll num = 1;
			unordered_map<ll, ll> um;
			for (ll i = 0; i < n; i++) {
				for (ll j = 0; j < m; j++) {
					if (vec[i][j]) {
						um[num] = vec[i][j];
						vec[i][j] = num;
						num++;
					}
				}
			}
			vector<vector<ll>> v2 = vec;
			for (ll i = 0; i < 4; i++) {
				if (s[i] == 'L') doL();
				if (s[i] == 'R') doR();
				if (s[i] == 'D') doD();
				if (s[i] == 'U') doU();
			}
			graph.assign(num, -1);
			for (ll i = 0; i < n; i++) {
				for (ll j = 0; j < m; j++) {
					if (vec[i][j]) {
						graph[v2[i][j] - 1] = vec[i][j] - 1;
					}
				}
			}
			vector<vector<ll>> up(21, vector<ll>(num));
			for (ll i = 0; i < num; i++) up[0][i] = graph[i];
			for (ll i = 1; i < 21; i++) {
				for (ll j = 0; j < num - 1; j++) up[i][j] = up[i - 1][up[i - 1][j]];
			}

			for (ll i = 0; i < n; i++) {
				for (ll j = 0; j < m; j++) {
					if (!v2[i][j]) continue;
					ll id = v2[i][j] - 1;
					ll uper = cnt;
					for (ll k = 20; k >= 0; k--) {
						if ((1 << k) <= uper) {
							uper -= 1 << k;
							id = up[k][id];
						}
					}
					v2[i][j] = um[id + 1];
				}
			}
			vec = v2;
		}


		//endof make LURD


		for (ll i = 0; i < add.size(); i++) {
			if (add[i] == 'L') doL();
			if (add[i] == 'R') doR();
			if (add[i] == 'D') doD();
			if (add[i] == 'U') doU();
		}
		for (ll i = 0; i < n; i++) {
			string ans = "";
			for (ll j = 0; j < m; j++) {
				if (vec[i][j] == 0) ans.push_back('.');
				else ans.push_back(vec[i][j] + 'a' - 1);
			}
			cout << ans << endl;
		}
	}
}