#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
using namespace std;
#define int long long 
#define debug(x) cerr << (#x) << ": " << x << endl
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n, m;
vector<vector<int> > now;
void make_U() {
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(m, 0);
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (now[i][j] != -1) {
				next[cur_used[j]][j] = now[i][j];
				cur_used[j]++;
			}
		}
	}
	now = next;
}
void make_D() {
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(m, n - 1);
	for (int j = 0; j < m; j++) {
		for (int i = n - 1; i >= 0; i--) {
			if (now[i][j] != -1) {
				next[cur_used[j]][j] = now[i][j];
				cur_used[j]--;
			}
		}
	}
	now = next;
}
void make_L() {
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(n, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (now[i][j] != -1) {
				next[i][cur_used[i]] = now[i][j];
				cur_used[i]++;
			}
		}
	}
	now = next;
}
void make_R() {
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(n, m - 1);
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (now[i][j] != -1) {
				next[i][cur_used[i]] = now[i][j];
				cur_used[i]--;
			}
		}
	}
	now = next;
}
void solve() {
	cin >> n >> m;
	now = vector<vector<int> >(n, vector<int>(m, -1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c; cin >> c;
			if (c == '.') continue;
			int p = c - 'a';
			now[i][j] = p;
		}
	}
	string s;
	cin >> s;
	char last = '.';
	int bal = 0, fl = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == 'U' && !fl) {
			if (last == 'L') make_L();
			if (last == 'R') make_R();
			make_U();
			fl = 1;
		}
		if (s[i] == 'D') make_D();
		last = s[i];
		if (s[i] == 'L') bal++;
		if (s[i] == 'R') bal--;
	}
	if (last == 'L') make_L();
	if (last == 'R') make_R();
	for (auto c : now) {
		for (auto x : c) {
			char p = '.';
			if (x != -1) p = 'a' + x;
			cout << p;
		}
		cout << '\n';
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
    cin >> t;
	while (t--) {
		solve();
	}
}
/*
1
7
2 1 2 9
5 1 6 8
4 5 7 6
1 8 4 10
1 6 3 6
1 2 7 3
4 1 7 1

*/