#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
using namespace std;
#define int long long 
#define debug(x) cerr << (#x) << ": " << x << endl
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n, m;
int now_ver = 0, now_gor = 0, fl_to_stop = 0, fl_to_move = 1;
vector<vector<int> > now;
void make_U() {
	if (fl_to_move == 1) {
		now_ver--;
		now_ver = max(0, now_ver);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(m, 0);
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (now[i][j] != -1) {
				next[cur_used[j]][j] = now[i][j];
				cur_used[j]++;
			}
		}
	}
	now = next;
}
void make_D() {
	if (fl_to_move) {
		now_ver++;
		now_ver = min(1, now_ver);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(m, n - 1);
	for (int j = 0; j < m; j++) {
		for (int i = n - 1; i >= 0; i--) {
			if (now[i][j] != -1) {
				next[cur_used[j]][j] = now[i][j];
				cur_used[j]--;
			}
		}
	}
	now = next;
}
void make_L() {
	if (fl_to_move == 1) {
		now_gor--;
		now_gor = max(0, now_gor);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(n, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (now[i][j] != -1) {
				next[i][cur_used[i]] = now[i][j];
				cur_used[i]++;
			}
		}
	}
	now = next;
}
void make_R() {
	if (fl_to_move == 1) {
		now_gor++;
		now_gor = min(1, now_gor);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(n, m - 1);
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (now[i][j] != -1) {
				next[i][cur_used[i]] = now[i][j];
				cur_used[i]--;
			}
		}
	}
	now = next;
}
void make_op(char c) {
	if (c == 'U') make_U();
	if (c == 'D') make_D();
	if (c == 'L') make_L();
	if (c == 'R') make_R();
}
void out() {
	for (auto c : now) {
		for (auto x : c) {
			char p = '.';
			if (x != -1) p = 'a' + x;
			cout << p;
		}
		cout << '\n';
	}
}
void solve() {
	cin >> n >> m;
	fl_to_stop = 0;
	fl_to_move = 1;
	now = vector<vector<int> >(n, vector<int>(m, -1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c; cin >> c;
			if (c == '.') continue;
			int p = c - 'a';
			now[i][j] = p;
		}
	}
	string s;
	cin >> s;
	char last = '.';
	int bal = 0, fl = 0, last_u_d = '.', last_l_r = '.', fl_u_d = 0, fl_l_r = 0, is_f = 0, pos = -1;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == 'U' || s[i] == 'D') {
			fl_u_d = 1;
			last_u_d = s[i];
			if (is_f == 0) is_f = 1;
		} 
		if (s[i] == 'L' || s[i] == 'R') {
			fl_l_r = 1;
			last_l_r = s[i];
			if (is_f == 0) is_f = 2;
		}
		if (fl_u_d && fl_l_r) {
			pos = i + 1;
			break;
		}
	}
	vector<char> op;
	op.push_back(last_u_d);
	op.push_back(last_l_r);
	if (is_f == 2) reverse(op.begin(), op.end());
	for (auto c : op) make_op(c);
	if (pos == -1) {
		out();
		return;
	}
	if (last_u_d == 'U') now_ver = 0;
	if (last_u_d == 'D') now_ver = 1;
	if (last_l_r == 'L') now_gor = 0;
	if (last_l_r == 'R') now_gor = 1;
	int st_ver = now_ver, st_gor = now_gor;
	fl_to_stop = 1;
	for (int i = pos; i < s.size(); i++) {
		make_op(s[i]);
	}
	fl_to_stop = 0;
	fl_to_move = 0;
	while (st_ver < now_ver) {
		make_D();
		st_ver++;
	}
	while (st_ver > now_ver) {
		make_U();
		st_ver--;
	}
	while (st_gor > now_gor) {
		make_L();
		st_gor--;
	}
	while (st_gor < now_gor) {
		make_R();
		st_gor++;
	}
	out();
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
    cin >> t;
	while (t--) {
		solve();
	}
}
/*
1
5 5
...aa
aa...
aaa..
.....
.....
ULDR
*/