#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
using namespace std;
#define int long long 
#define debug(x) cerr << (#x) << ": " << x << endl
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n, m;
int now_ver = 0, now_gor = 0, fl_to_stop = 0, fl_to_move = 1;
vector<vector<int> > now;
void make_U() {
	if (fl_to_move == 1) {
		now_ver--;
		now_ver = max(0, now_ver);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(m, 0);
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (now[i][j] != -1) {
				next[cur_used[j]][j] = now[i][j];
				cur_used[j]++;
			}
		}
	}
	now = next;
}
void make_D() {
	if (fl_to_move) {
		now_ver++;
		now_ver = min(1, now_ver);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(m, n - 1);
	for (int j = 0; j < m; j++) {
		for (int i = n - 1; i >= 0; i--) {
			if (now[i][j] != -1) {
				next[cur_used[j]][j] = now[i][j];
				cur_used[j]--;
			}
		}
	}
	now = next;
}
void make_L() {
	if (fl_to_move == 1) {
		now_gor--;
		now_gor = max(0, now_gor);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(n, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (now[i][j] != -1) {
				next[i][cur_used[i]] = now[i][j];
				cur_used[i]++;
			}
		}
	}
	now = next;
}
void make_R() {
	if (fl_to_move == 1) {
		now_gor++;
		now_gor = min(1, now_gor);
	}
	if (fl_to_stop) return;
	vector<vector<int> > next(n, vector<int>(m, -1));
	vector<int> cur_used(n, m - 1);
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (now[i][j] != -1) {
				next[i][cur_used[i]] = now[i][j];
				cur_used[i]--;
			}
		}
	}
	now = next;
}
void make_op(char c) {
	if (c == 'U') make_U();
	if (c == 'D') make_D();
	if (c == 'L') make_L();
	if (c == 'R') make_R();
}
void out() {
	for (auto c : now) {
		for (auto x : c) {
			char p = '.';
			if (x != -1) p = 'a' + x;
			cout << p;
		}
		cout << '\n';
	}
}
void solve() {
	cin >> n >> m;
	fl_to_stop = 0;
	fl_to_move = 1;
	now = vector<vector<int> >(n, vector<int>(m, -1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c; cin >> c;
			if (c == '.') continue;
			int p = c - 'a';
			now[i][j] = p;
		}
	}
	string s;
	cin >> s;
	now_ver = 1;
	now_gor = 0;
	int st_ver = now_ver, st_gor = now_gor, pr_ver = now_ver, pr_gor = now_gor, is_f = 0;
	fl_to_stop = 1;
	char last_u_d = '.', last_l_r = '.';
	int b_0_0 = 0, b_1_1 = 0, cnt_circle = 0, fl = 0;
	vector<pair<int, int> > path;
	for (int i = 0; i < s.size(); i++) {
		path.push_back({ now_ver, now_gor });
		make_op(s[i]);
	}
	path.push_back({ now_ver, now_gor });
	vector<int> poses;
	for (int i = 0; i < path.size(); i++) {
		if (path[i].first == 1 && path[i].second == 0) poses.push_back(i);
	}
	for (int i = 0; i < poses.size() - 1; i++) {
		int l = poses[i], stx = -1, sty = -1, r = poses[i + 1];
		vector<vector<int> > used(2, vector<int>(2, 0));
		for (int j = l; j <= r; j++) {
			int x = path[j].first, y = path[j].second;
			used[x][y] = 1;
			if ((x != 1 || y != 0) && !fl) {
				fl = 1;
				stx = x;
				sty = y;
			}
		}
		int cnt = 0;
		for (auto c : used) {
			for (auto x : c) {
				cnt += x;
			}
		}
		if (cnt == 4) {
			if (stx == 0) {
				cnt_circle++;
			} else {
				cnt_circle--;
			}
		}
	}
	fl_to_move = 0;
	if (cnt_circle < 0) {
		cnt_circle += 3 * INF;
		cnt_circle %= 3;
		for (int i = 0; i < cnt_circle; i++) {
			make_R();
			make_U();
			make_L();
			make_D();
		}
	} else {
		cnt_circle %= 3;
		for (int i = 0; i < cnt_circle; i++) {
			make_R();
			make_U();
			make_L();
			make_D();
		}
	}
	fl_to_stop = 0;
	fl_to_move = 0;
	while (st_ver < now_ver) {
		make_D();
		st_ver++;
	}
	while (st_ver > now_ver) {
		make_U();
		st_ver--;
	}
	while (st_gor > now_gor) {
		make_L();
		st_gor--;
	}
	while (st_gor < now_gor) {
		make_R();
		st_gor++;
	}
	out();
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
    cin >> t;
	while (t--) {
		solve();
	}
}
/*
1
5 5
.....
a....
aa...
aaa..
aaaa.
UURDL
*/