#ifndef DBG
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

ll n, m;

string compress(const string &ops) {
    char last = '.';
    string ans;
    for (char c: ops) {
        if (c == last) continue;

        if (c == 'L' && last == 'R') ans.pop_back(), ans.push_back(c);
        else if (c == 'R' && last == 'L') ans.pop_back(), ans.push_back(c);

        else if (c == 'U' && last == 'D') ans.pop_back(), ans.push_back(c);
        else if (c == 'D' && last == 'U') ans.pop_back(), ans.push_back(c);
        else ans.push_back(c);

        last = c;
    }

    return ans;
}

void perform(vector<string> &mat, char c) {
    if (c == 'L') {
        for (ll i = 0; i < n; i++) {
            string x;
            for (ll j = 0; j < m; j++) {
                if (mat[i][j] != '.') {
                    x.push_back(mat[i][j]);
                }
            }
            while (x.size() < m) x.push_back('.');
            mat[i] = x;
        }
    }

    if (c == 'R') {
        for (ll i = 0; i < n; i++) {
            string x;
            for (ll j = m - 1; j >= 0; j--) {
                if (mat[i][j] != '.') {
                    x.push_back(mat[i][j]);
                }
            }
            while (x.size() < m) x.push_back('.');
            std::reverse(x.begin(), x.end());
            mat[i] = x;
        }
    }

    if (c == 'U') {
        for (ll j = 0; j < m; j++) {
            string x;
            for (ll i = 0; i < n; i++) {
                if (mat[i][j] != '.') {
                    x.push_back(mat[i][j]);
                }
            }
            while (x.size() < n) x.push_back('.');
//                std::reverse(x.begin(), x.end());
            for (ll i = 0; i < n; i++) {
                mat[i][j] = x[i];
            }
        }
    }

    if (c == 'D') {
        for (ll j = 0; j < m; j++) {
            string x;
            for (ll i = 0; i < n; i++) {
                if (mat[i][j] != '.') {
                    x.push_back(mat[i][j]);
                }
            }
            std::reverse(x.begin(), x.end());
            while (x.size() < n) x.push_back('.');
            std::reverse(x.begin(), x.end());
            for (ll i = 0; i < n; i++) {
                mat[i][j] = x[i];
            }
        }
    }
}

void solve_dumb() {
    cin >> n >> m;

    vector<string> mat(n);

    for (ll i = 0; i < n; i++) {
        cin >> mat[i];
    }

    string ops;
    cin >> ops;

    ops = compress(ops);

    for (char c: ops) {
        perform(mat, c);
    }

    for (ll i = 0; i < n; i++) {
        cout << mat[i] << '\n';
    }
    cout << endl;
}



void solve_smart() {
    cin >> n >> m;

    vector<string> mat(n);

    for (ll i = 0; i < n; i++) {
        cin >> mat[i];
    }

    string ops;
    cin >> ops;

    if (ops.empty()) {
        for (ll i = 0; i < n; i++) {
            cout << mat[i] << '\n';
        }
        cout << endl;
        return;
    }

    ops = compress(ops);

    if (ops.size() < 10) {

    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        solve_dumb();
    }
}
