#ifndef DBG
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

const ll inf = 1e17; //sus

void solvep1() {
    ll n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;

    vector<ll> a(n);
    for (ll &i: a) cin >> i;
    a.insert(a.begin(), -1);

}

struct node {
    ll v = inf;

    node *l = 0, *r = 0;
};

//const ll maxnode = 1e7;

//node narr[maxnode];
//ll lastnode = 0;
//
//node *alloc() {
//    return narr + lastnode++;
//}

node *alloc() {
    return new node();
}

void modify(node *t, ll l, ll r, ll p, ll v) {
    if (!t) t = alloc();

    if (r - l <= 1) {
        t->v = min(t->v, v);
        return;
    }

    ll m = (l + r) / 2;

    if (p < m) {
        if (!t->l) t->l = alloc();
        modify(t->l, l, m, p, v);
    } else {
        if (!t->r) t->r = alloc();
        modify(t->r, m, r, p, v);
    }

    t->v = inf;
    if (t->l) t->v = min(t->v, t->l->v);
    if (t->r) t->v = min(t->v, t->r->v);
}

ll getmin(node *t, ll l, ll r, ll ql, ll qr) {
    if (!t) return inf;

    if (ql <= l && r <= qr) {
        return t->v;
    }

    if (ql >= r || qr <= l) {
        return inf;
    }
    ll m = (l + r) / 2;
    ll ans = inf;
    if (t->l) ans = min(ans, getmin(t->l, l, m, ql, qr));
    if (t->r) ans = min(ans, getmin(t->r, m, r, ql, qr));
    return ans;
}

void solve() {
    ll n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;

    vector<ll> a(n);
    for (ll &i: a) cin >> i;
    a.insert(a.begin(), -1);

    vector<ll> dp(n + 2), open(n + 2), hold(n + 2), sts(n + 2);

    vector<bool> here_open(n + 2), here_close(n + 2);

    unordered_map<ll, ll> caps;

    for (ll i = 1; i <= n; i++) {
        if (caps.count(a[i]) == 0) {
            here_open[i] = true;
        }
        caps[a[i]]++;
        if (caps[a[i]] == p) {
            here_close[i] = true;
            caps.erase(a[i]);
        }

        hold[i] = caps.size();
    }

    for (ll i = 1; i <= n; i++) {
        sts[i] = sts[i-1] + here_open[i];
    }

    auto getdist = [&](ll i) -> ll {
        if (i == 0) return 0;

        if (c == 2) return i * 2;
        if (c == 1) return (n + 1 - i) * 2 - 2;
        if (c == 3) return min(i * 2, (n + 1 - i) * 2 - 2);

        exit(-1);
    };

    here_close[0] = true;

    node *tree = alloc();

    vector<pll> prev = {{0, 0}};

    const ll MAXX = 1e18;

    modify(tree, -MAXX, MAXX, 0, 0);

    for (ll i = 1; i <= n; i++) {
        dp[i] = getmin(tree, -MAXX, MAXX, -MAXX, m - sts[i] + 1) + i;

        modify(tree, -MAXX, MAXX, hold[i] - sts[i], dp[i] + getdist(i) - i);
    }

    cout << dp[n] + 1 << endl;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    solve();
}
