#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;
int n, m;
void move_LR(char a, vector<vector<char>>& t) {
	vector<vector<char>> t1(n, vector<char>(m, '.'));
	if (a == 'L') {
		for (int i = 0; i < n; i++) {
			int fr = 0;
			for (int j = 0; j < m; j++) {
				if (t[i][j] != '.') {
					t1[i][fr] = t[i][j];
					fr++;
				}
			}
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			int fr = m - 1;
			for (int j = m - 1; j >= 0; j--) {
				if (t[i][j] != '.') {
					t1[i][fr] = t[i][j];
					fr--;
				}
			}
		}
	}
	t = t1;
}


void move_UD(char b, vector<vector<char>>& t) {
	vector<vector<char>> t1(n, vector<char>(m, '.'));
	if (b == 'U') {
		for (int i = 0; i < m; i++) {
			int fr = 0;
			for (int j = 0; j < n; j++) {
				if (t[j][i] != '.') {
					t1[fr][i] = t[j][i];
					fr++;
				}
			}
		}
	}
	else {
		for (int i = 0; i < m; i++) {
			int fr = n - 1;
			for (int j = n - 1; j >= 0; j--) {
				if (t[j][i] != '.') {
					t1[fr][i] = t[j][i];
					fr--;
				}
			}
		}
	}
	t = t1;
}

void upd_s(int idx, int& q, string& s, vector<vector<char>>& t) {
	s = s.substr(idx, s.size() - idx);
	string s1 = "";
	idx = 0;
	char a = 'L', b = 'U';
	q = s.size();
	while (idx < q) {
		if (idx < q && (s[idx] == 'L' || s[idx] == 'R')) {
			while (idx < q && (s[idx] == 'L' || s[idx] == 'R')) {
				a = s[idx];
				idx++;
			}
			s1 += a;
		}
		if (idx < q && (s[idx] == 'U' || s[idx] == 'D')) {
			while (idx < q && (s[idx] == 'U' || s[idx] == 'D')) {
				b = s[idx];
				idx++;
			}
			s1 += b;
		}
	}
	s = s1;
	if (s != "" && (s[0] == 'U' || s[0] == 'D')) {
		move_UD(s[0], t);
		s = s.substr(1, s.size() - 1);
	}
	vector<pair<char, char>> st;
	q = s.size();
	for (int i = 0; 2 * i + 1 < q; i++) {
		while (!st.empty() && (st.back().first == s[2 * i] || st.back().second == s[2 * i + 1])) {
			st.pop_back();
		}
		st.push_back({ s[2 * i],s[2 * i + 1] });
	}
	s1 = "";
	for (auto p : st) {
		s1 += p.first;
		s1 += p.second;
	}
	if (s != "" && (s.back() == 'L' || s.back() == 'R')) {
		s1 += s.back();
	}
	s = s1;
}

vector<vector<char>> solve() {
	string s;
	cin >> n >> m;
	vector<vector<char>> t(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> t[i][j];
		}
	}	cin >> s;
	int q = s.size();
	int idx = 0;
	char a = 'L', b = 'U';
	while (idx < q && (s[idx] == 'L' || s[idx] == 'R')) {
		a = s[idx];
		idx++;
	}
	bool is_LR = true;
	if (idx > 0) {
		move_LR(a, t);
	}
	else {
		is_LR = false;
	}
	if (idx == q) {
		return t;
	}
	while (idx < q && (s[idx] == 'U' || s[idx] == 'D')) {
		b = s[idx];
		idx++;
	}
	move_UD(b, t);
	if (idx == q) {
		return t;
	}
	if (!is_LR) {
		while (idx < q && (s[idx] == 'L' || s[idx] == 'R')) {
			a = s[idx];
			idx++;
		}
		move_LR(a, t);
		if (idx == q) {
			return t;
		}
	}
	upd_s(idx, q, s, t);
	q = s.size();
	if (q >= 2) {
		move_LR(s[0], t);
		move_UD(s[1], t);
		s = s.substr(2, s.size() - 2);
	}
	/*if (s.size() >= 4) {
		vector<int> to(n * m);
		vector<vector<int>> T(n, vector<int>(m, -1));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (t[i][j] != '.') {
					T[i][j] = i * m + j;
				}
			}
		}
		for (idx = 0; idx < 4; idx++) {
			vector<vector<int>> t1(n, vector<int>(m, '.'));
			if (s[idx] == 'L') {
				for (int i = 0; i < n; i++) {
					int fr = 0;
					for (int j = 0; j < m; j++) {
						if (T[i][j] != -1) {
							t1[i][fr] = T[i][j];
							fr++;
						}
					}
				}
			}
			else if (s[idx] == 'R') {
				for (int i = 0; i < n; i++) {
					int fr = m - 1;
					for (int j = m - 1; j >= 0; j--) {
						if (T[i][j] != '.') {
							t1[i][fr] = T[i][j];
							fr--;
						}
					}
				}
			}
			else if (s[idx] == 'U') {
				for (int i = 0; i < m; i++) {
					int fr = 0;
					for (int j = 0; j < n; j++) {
						if (T[j][i] != -1) {
							t1[fr][i] = T[j][i];
							fr++;
						}
					}
				}
			}
			else {
				for (int i = 0; i < m; i++) {
					int fr = n - 1;
					for (int j = n - 1; j >= 0; j--) {
						if (T[j][i] != '.') {
							t1[fr][i] = T[j][i];
							fr--;
						}
					}
				}
			}
			T = t1;
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (T[i][j] != -1) {
					to[T[i][j]] = i * m + j;
				}
			}
		}
		vector<vector<int>> cycle;
		vector<int> used(n * m);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				int v = i * m + j;
				if (t[i][j] != '.' && used[v] == 0) {
					int u = v;
					while (u != v) {
						used[u] = 1;
						cycle.back().push_back(u);
						u = to[u];
					}
				}
			}
		}
		int cnt = s.size() / 4;
		vector<int> ans(n * m);
		for (auto c : cycle) {
			for (int i = 0; i < (int)c.size(); i++) {
				ans[c[i]] = c[(i + cnt) % (int)c.size()];
			}
		}
		vector<vector<char>> t2(n, vector<char>(m, '.'));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (t[i][j] != '.') {
					int v = ans[i * m + j];
					t2[v / m][v % m] = t[i][j];
				}
			}
		}
		t = t2;
	}*/
	q = s.size();
	s = s.substr(q / 4 * 4, q - q / 4 * 4);
	for (char c : s) {
		if (c == 'L' || c == 'R') {
			move_LR(c, t);
		}
		else {
			move_UD(c, t);
		}
	}
	return t;
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		vector<vector<char>> t = solve();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << t[i][j];
			}
			cout << '\n';
		}
	}
}
