#include <bits/stdc++.h>

using namespace std;

vector<string> U(const vector<string> &a) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    vector<string> b(n, string(m, '.'));
    for (int j = 0; j < m; j++) {
        int it = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.') {
                b[it][j] = a[i][j];
                it++;
            }
        }
    }
    return b;
}

vector<string> D(const vector<string> &a) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    vector<string> b(n, string(m, '.'));
    for (int j = 0; j < m; j++) {
        int it = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] != '.') {
                b[it][j] = a[i][j];
                it--;
            }
        }
    }
    return b;
}

vector<string> L(const vector<string> &a) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    vector<string> b(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        int it = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                b[i][it] = a[i][j];
                it++;
            }
        }
    }
    return b;
}

vector<string> R(const vector<string> &a) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    vector<string> b(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        int it = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] != '.') {
                b[i][it] = a[i][j];
                it--;
            }
        }
    }
    return b;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    auto apply = [&](char cc) {
        if (cc == 'U') {
            a = U(a);
        } else if (cc == 'D') {
            a = D(a);
        } else if (cc == 'L') {
            a = L(a);
        } else {
            a = R(a);
        }
    };
    string s;
    cin >> s;
    if (count(s.begin(), s.end(), 'U') + count(s.begin(), s.end(), 'D') == 0 || count(s.begin(), s.end(), 'L') + count(s.begin(), s.end(), 'R') == 0) {
        apply(s.back());
        for (int ii = 0; ii < n; ii++) {
            cout << a[ii] << '\n';
        }
        return;
    }
    auto UL = L(U(a));
    auto UR = R(U(a));
    auto DL = L(D(a));
    auto DR = R(D(a));
    assert(UL == U(L(a)));
    assert(UR == U(R(a)));
    assert(DL == D(L(a)));
    assert(DR == D(R(a)));
    string st;
    for (char c : s) {
        if (c == 'U') {
            if (st == "L") {
                st = "UL";
            } else if (st == "R") {
                st = "UR";
            } else {
                st = "U";
            }
        } else if (c == 'D') {
            if (st == "L") {
                st = "DL";
            } else if (st == "R") {
                st = "DR";
            } else {
                st = "D";
            }
        } else if (c == 'L') {
            if (st == "U") {
                st = "UL";
            } else if (st == "D") {
                st = "DL";
            } else {
                st = "L";
            }
        } else {
            if (st == "U") {
                st = "UR";
            } else if (st == "D") {
                st = "DR";
            } else {
                st = "R";
            }
        }
    }
    if (st == "UL") {
        a = UL;
    } else if (st == "UR") {
        a = UR;
    } else if (st == "DL") {
        a = DL;
    } else {
        a = DR;
    }
    for (int ii = 0; ii < n; ii++) {
        cout << a[ii] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*

4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR

 */