#include <bits/stdc++.h>
using namespace std;

vector<string> rotate_cw(vector<string>& v) {
    int m(v.size()), n(v[0].size());
    vector<string> ans(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans[i][j] = v[m - 1 - j][i];
        }
    }
    return ans;
}

vector<string> rotate_ccw(vector<string>& v) {
    int m(v.size()), n(v[0].size());
    vector<string> ans(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans[n - 1 - i][j] = v[j][i];
        }
    }
    return ans;
}

vector<string> flip(vector<string>& v) {
    int m(v.size()), n(v[0].size());
    vector<string> ans(m, string(n, '.'));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            ans[i][j] = v[m - 1 - i][j];
        }
    }
    return ans;
}

vector<string> rccw(vector<string>& v) {
    int m(v.size()), n(v[0].size());
    vector<string> ans(m, string(n, '.'));
    vector<int> cnt(m, 0);
    for (int i = 0; i < m; i++) {
        for (int j = n - 1; j >= 0; j--) {
            if (v[i][j] != '.') {
                ans[i][n - 1 - cnt[i]] = v[i][j];
                cnt[i]++;
            }
        }
    }
    vector<string> ans2(n, string(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans2[n - 1 - i][j] = ans[j][i];
        }
    }
    return ans2;
}

vector<vector<int>> rccw(vector<vector<int>>& v) {
    int m(v.size()), n(v[0].size());
    vector<vector<int>> ans(m, vector<int>(n, -1));
    vector<int> cnt(m, 0);
    for (int i = 0; i < m; i++) {
        for (int j = n - 1; j >= 0; j--) {
            if (v[i][j] != -1) {
                ans[i][n - 1 - cnt[i]] = v[i][j];
                cnt[i]++;
            }
        }
    }
    vector<vector<int>> ans2(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans2[n - 1 - i][j] = ans[j][i];
        }
    }
    return ans2;
}

vector<string> rdlu(vector<string>& v, int k) {
    int m(v.size()), n(v[0].size());
    vector<vector<int>> u(m, vector<int>(n, -1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (v[i][j] != '.') {
                u[i][j] = i * n + j;
            }
        }
    }
    for (int p = 0; p < 4; p++) {
        /*for (auto i : u) {
            for (auto j : i) {
                cout << j << " ";
            }
            cout << endl;
        }*/
        u = rccw(u);
    }
    vector<int> s{};
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            s.push_back(u[i][j]);
        }
    }
    vector<vector<int>> cycs{};
    for (int i = 0; i < n * m; i++) {
        if (s[i] == -1) {
            continue;
        }
        int x(i);
        cycs.push_back(vector<int>(0));
        do {
            cycs[cycs.size() - 1].push_back(x);
            int y(s[x]);
            s[x] = -1;
            x = y;
        } while (x != i);
    }
    vector<string> ans(m, string(n, '.'));
    for (int i = 0; i < cycs.size(); i++) {
        for (int j = 0; j < cycs[i].size(); j++) {
            int x(cycs[i][j]), y(cycs[i][(j + k) % cycs[i].size()]);
            ans[x / n][x % m] = v[y / n][y % n];
        }
    }
    return ans;
}

void f() {
    int n, m;
    cin >> m >> n;
    vector<string> v(m, "");
    string s;
    for (int i = 0; i < m; i++) {
        cin >> s;
        v[i] = s;
    }
    cin >> s;
    string t("");
    int r(0);
    for (int i = 0; i < s.size(); i++) {
        if ((s[i] == 'L') || (s[i] == 'R')) {
            if ((r != 1) && (i > 0)) {
                t += s[i - 1];
            }
            r = 1;
        } else {
            if ((r != -1) && (i > 0)) {
                t += s[i - 1];
            }
            r = -1;
        }
    }
    t += s[s.size() - 1];
    //cout << t << endl;
    string t2("");
    for (int i = 0; i < t.size(); i++) {
        if ((t2.size() >= 2) && (t[i] == t2[t2.size() - 2])) {
            if (i != t.size() - 1) {
                t2.pop_back();
            }
        } else {
            t2 += t[i];
        }
    }
    //cout << t2 << endl;
    int tm;
    bool fli(false);
    if (t2[0] == 'R') {
        tm = 0;
    } else if (t2[0] == 'D') {
        tm = 1;
    } else if (t2[0] == 'L') {
        tm = 2;
    } else if (t2[0] == 'U') {
        tm = 3;
    }
    s = "RULD";
    for (int i = 0; i < t2.size(); i++) {
        int x(s.find(t2[i]));
        x += tm;
        x %= 4;
        t2[i] = s[x];
    }
    //cout << t2 << endl;
    if ((t2.size() >= 2) && (t2[1] == 'U')) {
        fli = true;
    }
    int init(1), rem(0), k(0);
    if (t2.size() >= 2) {
        init = 2;
        rem = (t2.size() - 2) % 4;
        k = (t2.size() - 2) / 4;
    }
    //cout << tm << " " << fli << endl;
    for (int i = 0; i < tm; i++) {
        v = rotate_ccw(v);
    }
    if (fli) {
        v = flip(v);
    }
    /*for (auto i : v) {
        cout << i << endl;
    }*/
    for (int i = 0; i < init; i++) {
        v = rccw(v);
        /*for (auto i : v) {
            cout << i << endl;
        }*/
    }
    if (k > 0) {
        v = rdlu(v, k);
    }
    for (int i = 0; i < rem; i++) {
        v = rccw(v);
    }
    /*for (auto i : v) {
        cout << i << endl;
    }*/
    if (fli) {
        v = flip(v);
    }
    int ss(tm);
    if (!fli) {
        ss += t2.size();
    } else {
        ss -= t2.size();
        ss += 1e7;
    }
    ss %= 4;
    for (int i = 0; i < ss; i++) {
        v = rotate_cw(v);
    }
    for (auto i : v) {
        cout << i << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        f();
    }
}
