#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
using vll = vector<ll>;
#define all(x) x.begin(), x.end()

const int INF = 2e9 + 7;

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cout << fixed; cout.precision(8);
	int t;
	cin >> t;
	while (t--) {
		int m, n, q;
		string s;
		cin >> m >> n;
		vector<vector<char>> t(m, vector<char>(n));
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j)
				cin >> t[i][j];
		}
		int pL = 0, pR = 0, pU = 0, pD = 0;
		cin >> s; q = size(s);
		for (int i = 0; i < q; ++i) {
			if (s[i] == 'L')
				pL = 1;
			else if (s[i] == 'R')
				pR = 1;
			else if (s[i] == 'L')
				pU = 1;
			else
				pD = 1;
		}
		if (pU == 0 && pD == 0) {
			for (int i = 0; i < m; ++i) {
				vector<char> vec;
				for (int j = 0; j < n; ++j) {
					if (t[i][j] != '.') {
						vec.push_back(t[i][j]);
						t[i][j] = '.';
					}
				}
				if (s.back() == 'L') {
					for (int j = 0; j < size(vec); ++j)
						t[i][j] = vec[j];
				}
				else {
					for (int j = n - 1; j >= 0; --j) {
						if (vec.empty())
							break;
						t[i][j] = vec.back();
						vec.pop_back();
					}
				}
			}
			for (int i = 0; i < m; ++i) {
				for (int j = 0; j < n; ++j)
					cout << t[i][j];
				cout << '\n';
			}
		}
		else if (pL == 0 && pR == 0) {
			for (int j = 0; j < n; ++j) {
				vector<char> vec;
				for (int i = 0; i < m; ++i) {
					if (t[i][j] != '.') {
						vec.push_back(t[i][j]);
						t[i][j] = '.';
					}
				}
				if (s.back() == 'U') {
					for (int i = 0; i < size(vec); ++i)
						t[i][j] = vec[i];
				}
				else {
					for (int i = m - 1; i >= 0; --i) {
						if (vec.empty())
							break;
						t[i][j] = vec.back();
						vec.pop_back();
					}
				}
			}
			for (int i = 0; i < m; ++i) {
				for (int j = 0; j < n; ++j)
					cout << t[i][j];
				cout << '\n';
			}
		}
		else {
			pL = INF; pR = INF; pU = INF; pD = INF;
			for (int i = 0; i < q; ++i) {
				if (s[i] == 'L')
					pL = min(pL, i);
				if (s[i] == 'R')
					pR = min(pR, i);
				if (s[i] == 'U')
					pU = min(pU, i);
				if (s[i] == 'D')
					pD = min(pD, i);
			}
			if (min(pU, pD) < min(pL, pR)) {
				for (int j = 0; j < n; ++j) {
					vector<char> vec;
					for (int i = 0; i < m; ++i) {
						if (t[i][j] != '.') {
							vec.push_back(t[i][j]);
							t[i][j] = '.';
						}
					}
					for (int i = 0; i < size(vec); ++i)
						t[i][j] = vec[i];
				}
				vint cnti(m);
				for (int i = 0; i < m; ++i) {
					for (int j = 0; j < n; ++j) {
						if (t[i][j] != '.')
							cnti[i]++;
					}
				}
				pL = 0; pR = 0; pD = 0; pU = 0;
				for (int i = q - 1; i >= 0; --i) {
					if (!pL && !pR) {
						if (s[i] == 'L')
							pL = 1;
						else if (s[i] == 'R')
							pR = 1;
					}
					if (!pU && !pD) {
						if (s[i] == 'U')
							pU = 1;
						else if (s[i] == 'D')
							pD = 1;
					}
				}
				if (pD)
					reverse(all(cnti));
				for (int i = 0; i < m; ++i) {
					vector<char> vec;
					for (int j = 0; j < cnti[i]; ++j)
						vec.push_back('a');
					for (int j = cnti[i]; j < n; ++j)
						vec.push_back('.');
					if (pR)
						reverse(all(vec));
					for (auto el : vec)
						cout << el;
					cout << '\n';
				}
			}
			else {
				for (int i = 0; i < m; ++i) {
					vector<char> vec;
					for (int j = 0; j < n; ++j) {
						if (t[i][j] != '.') {
							vec.push_back(t[i][j]);
							t[i][j] = '.';
						}
					}
					for (int j = 0; j < size(vec); ++j)
						t[i][j] = vec[j];
				}
				vint cntj(n);
				for (int i = 0; i < m; ++i) {
					for (int j = 0; j < n; ++j) {
						if (t[i][j] != '.')
							cntj[j]++;
					}
				}
				pL = 0; pR = 0; pD = 0; pU = 0;
				for (int i = q - 1; i >= 0; --i) {
					if (!pL && !pR) {
						if (s[i] == 'L')
							pL = 1;
						else if (s[i] == 'R')
							pR = 1;
					}
					if (!pU && !pD) {
						if (s[i] == 'U')
							pU = 1;
						else if (s[i] == 'D')
							pD = 1;
					}
				}
				if (pR)
					reverse(all(cntj));
				for (int j = 0; j < n; ++j) {
					vector<char> vec;
					for (int i = 0; i < cntj[j]; ++i)
						vec.push_back('a');
					for (int i = cntj[j]; i < m; ++i)
						vec.push_back('.');
					if (pD)
						reverse(all(vec));
					for (int i = 0; i < m; ++i)
						t[i][j] = vec[i];
				}
				for (int i = 0; i < m; ++i) {
					for (int j = 0; j < n; ++j)
						cout << t[i][j];
					cout << '\n';
				}
			}
		}
	}
}