#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
using vll = vector<ll>;
#define all(x) x.begin(), x.end()

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cout << fixed; cout.precision(8);
	int t;
	cin >> t;
	while (t--) {
		int m, n, q;
		string s;
		cin >> m >> n;
		vector<vector<char>> t(m, vector<char>(n));
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j)
				cin >> t[i][j];
		}
		cin >> s; q = size(s);
		for (char ch : s) {
			if (ch == 'L') {
				for (int i = 0; i < m; ++i) {
					int l = 0, r = 0;
					while (l < n && t[i][l] != '.')
						l++;
					r = l + 1;
					while (l < n && r < n) {
						while (r < n && t[i][r] == '.')
							r++;
						if (r < n) {
							swap(t[i][l], t[i][r]);
							l++; r++;
						}
					}
				}
			}
			else if (ch == 'R') {
				for (int i = 0; i < m; ++i) {
					int l = n - 1, r = n - 1;
					while (l >= 0 && t[i][l] != '.')
						l--;
					r = l - 1;
					while (l >= 0 && r >= 0) {
						while (r >= 0 && t[i][r] == '.')
							r--;
						if (r >= 0) {
							swap(t[i][l], t[i][r]);
							l--; r--;
						}
					}
				}
			}
			else if (ch == 'U') {
				for (int j = 0; j < n; ++j) {
					int l = 0, r = 0;
					while (l < m && t[l][j] != '.')
						l++;
					r = l + 1;
					while (l < m && r < m) {
						while (r < m && t[r][j] == '.')
							r++;
						if (r < m) {
							swap(t[l][j], t[r][j]);
							l++; r++;
						}
					}
				}
			}
			else {
				for (int j = 0; j < n; ++j) {
					int l = m - 1, r = m - 1;
					while (l >= 0 && t[l][j] != '.')
						l--;
					r = l - 1;
					while (l >= 0 && r >= 0) {
						while (r >= 0 && t[r][j] == '.')
							r--;
						if (r >= 0) {
							swap(t[l][j], t[r][j]);
							l--; r--;
						}
					}
				}
			}
		}
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j)
				cout << t[i][j];
			cout << '\n';
		}
	}
}