#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll mod = 1e9 + 7;
const ll w = 31;

void squeeze(string& s_) {
    string s = "";
    string cur = "";
    for (ll i = 0; i < s_.size(); ++i) {
        if (cur == "") {
            cur.push_back(s_[i]);
        } else {
            if (cur.back() == 'D' || cur.back() == 'U') {
                if (s_[i] == 'D' || s_[i] == 'U') {
                    cur.push_back(s_[i]);
                } else {
                    s.push_back(cur.back());
                    cur = s_[i];
                }
            } else {
                if (s_[i] == 'D' || s_[i] == 'U') {
                    s.push_back(cur.back());
                    cur = s_[i];
                } else {
                    cur.push_back(s_[i]);
                }
            }
        }
    }
    s.push_back(cur.back());
    s_ = s;
}

void do_lr(ll& m, ll& n, vector<vector<char>>& field, char d) {
    vector<string> rows(m);
    for (ll r = 0; r < m; ++r) {
        rows[r] = "";
        for (ll c = 0; c < n; ++c) {
            if (field[r][c] != '.') {
                rows[r].push_back(field[r][c]);
            }
        }
    }

    for (auto& row : rows) {
        if (row.size() == n) {
            continue;
        }
        string s1(n - row.size(), '.');
        if (d == 'R') {
            row = s1 + row;
        }
        if (d == 'L') {
            row = row + s1;
        }
    }
    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            field[r][c] = rows[r][c];
        }
    }
}

void do_ud(ll& m, ll& n, vector<vector<char>>& field, char d) {
    vector<string> cols(n);
    for (ll c = 0; c < n; ++c) {
        cols[c] = "";
        for (ll r = 0; r < m; ++r) {
            if (field[r][c] != '.') {
                cols[c].push_back(field[r][c]);
            }
        }
    }

    for (auto& col : cols) {
        if (col.size() == m) {
            continue;
        }
        string s1(m - col.size(), '.');
        if (d == 'D') {
            col = s1 + col;
        }
        if (d == 'U') {
            col = col + s1;
        }
    }
    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            field[r][c] = cols[c][r];
        }
    }
}

void lurd(ll& m, ll& n, vector<vector<char>>& field) {
    do_lr(m, n, field, 'L');
    do_ud(m, n, field, 'U');
    do_lr(m, n, field, 'R');
    do_ud(m, n, field, 'D');
}

ll hashify(ll& m, ll& n, vector<vector<char>>& field) {
    ll hsh = 0;
    ll r = m - 1;
    for (ll c = 0; c < n; ++c) {
        if (field[r][c] == '.') {
            hsh = (hsh * w) % mod;
        } else {
            hsh = ((hsh * w) + (field[r][c] - 'a' + 1)) % mod;
        }
    }
    return hsh;
}

void solve() {
    ll m, n;
    cin >> m >> n;
    bool case5 = true;
    vector<vector<char>> field(m, vector<char>(n));
    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            cin >> field[r][c];
            if (field[r][c] != '.' && field[r][c] != 'a') {
                case5 = false;
            }
        }
    }

    string s;
    cin >> s;
    squeeze(s);
    ll q = s.size();

    bool case8 = false;
    if (q % 4 == 0) {
        case8 = true;
        string cl = "LURD";
        for (ll i = 0; i < q; ++i) {
            if (s[i] != cl[i % 4]) case8 = false;
        }
    }

    bool case4 = true;
    for (auto c : s) {
        if (c == 'D') case4 = false;
    }
    if (case4) {
        string s_ = s;
        s = "";
        bool hadu = false;
        for (auto c : s_) {
//            cout << c << " " << hadu << endl;
            if (c == 'U' && hadu == false) {
                s.push_back(c);
                hadu = true;
            }
            if (c != 'U') {
                s.push_back(c);
            }
        }
        squeeze(s);
    }
//    cout << "%" << s << endl;

    if (case8 && q / 4 > 2) {
        q = q / 4;
        lurd(m, n, field);
        --q;

        ll step = 0;
        ll hsh0 = hashify(m, n, field);
        while (true) {
            lurd(m, n, field);
            ll hsh = hashify(m, n, field);
            --q;
            ++step;
            if (q == 0) {
                break;
            }
            if (hsh == hsh0) {
                break;
            }
        }

        q = q % step;
        while (q--) {
            lurd(m, n, field);
        }
    } else {
        for (ll i = 0; i < q; ++i) {
            if (case5 && i != 0 && i != 1 && i != q - 2 && i != q - 1) continue;
            if (s[i] == 'L' || s[i] == 'R') {
                do_lr(m, n, field, s[i]);
            } else {
                do_ud(m, n, field, s[i]);
            }
        }
    }

    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            cout << field[r][c];
        }
        cout << endl;
    }
}

int main() {
    ll t;
    cin >> t;
    while (t--) solve();
    return 0;
}
