#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<string> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	string ops;
	cin >> ops;
	string seq;
	bool wasU = false;
	for (char op : ops) {
		if (seq.empty()) {
			seq += op;
			if (op == 'U')
				wasU = true;
		}
		if (op == 'U' && wasU)
			continue;
		if (op == 'U') {
			seq += op;
			wasU = true;
			continue;
		}
		if (seq.back() == 'U') {
			seq += op;
			continue;
		}
		seq.back() = op;
	}
	ops = seq;
	for (char op : ops) {
		if (op == 'L') {
			for (int i = 0; i < n; i++) {
				int cur = 0;
				for (int j = 0; j < m; j++) {
					if (s[i][j] == '.')
						continue;
					swap(s[i][j], s[i][cur]);
					cur++;
				}
			}
		}
		if (op == 'R') {
			for (int i = 0; i < n; i++) {
				int cur = m - 1;
				for (int j = m - 1; j > -1; j--) {
					if (s[i][j] == '.')
						continue;
					swap(s[i][j], s[i][cur]);
					cur--;
				}
			}
		}
		if (op == 'D') {
			for (int j = 0; j < m; j++) {
				int cur = n - 1;
				for (int i = n - 1; i > -1; i--) {
					if (s[i][j] == '.')
						continue;
					swap(s[i][j], s[cur][j]);
					cur--;
				}
			}
		}
		if (op == 'U') {
			for (int j = 0; j < m; j++) {
				int cur = 0;
				for (int i = 0; i < n; i++) {
					if (s[i][j] == '.')
						continue;
					swap(s[i][j], s[cur][j]);
					cur++;
				}
			}
		}
	}
	for (int i = 0; i < n; i++)
		cout << s[i] << '\n';
}

signed main() {
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int tt = 1;
	cin >> tt;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}