#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const ll inf = 3e18;

struct segtree {
	vector<ll> tree;
	int sz;

	segtree() {}

	segtree(int n) {
		sz = 1;
		while (sz < n)
			sz *= 2;
		tree.resize(2 * sz, inf);
	}

	void set(int i, ll v, int x, int tl, int tr) {
		if (tr - tl == 1) {
			tree[x] = v;
			return;
		}
		int m = (tl + tr) / 2;
		if (i < m)
			set(i, v, 2 * x + 1, tl, m);
		else
			set(i, v, 2 * x + 2, m, tr);
		tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
	}

	void set(int i, ll v) {
		set(i, v, 0, 0, sz);
	}

	ll get(int l, int r, int x, int tl, int tr) {
		if (l <= tl && tr <= r)
			return tree[x];
		if (l >= tr || r <= tl)
			return inf;
		int m = (tl + tr) / 2;
		ll s1, s2;
		s1 = get(l, r, 2 * x + 1, tl, m);
		s2 = get(l, r, 2 * x + 2, m, tr);
		return min(s1, s2);
	}

	ll get(int l, int r) {
		return get(l, r, 0, 0, sz);
	}
};

inline void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		a[i]--;
	}
	ll ans = 0;
	vector<int> cnt(k);
	vector<int> li(n + 2);
	int l = 1;
	int take = 0;
	auto add = [&](int v) {
		v = a[v];
		if (cnt[v] == 0)
			take++;
		cnt[v]++;
		if (cnt[v] == p)
			cnt[v] = 0;
	};
	auto del = [&](int v) {
		v = a[v];
		if (cnt[v] == 0)
			take--;
		cnt[v]--;
		if (cnt[v] < 0)
			cnt[v] = p - 1;
	};
	for (int r = 1; r <= n; r++) {
		add(r);
		while (take > m)
			del(l++);
		li[r] = l;
	}
	segtree st(n + 2);
	st.set(0, 0);
	for (int i = 1; i <= n; i++) {
		ll dp = st.get(li[i] - 1, i) + i;
		st.set(i, dp + i);
	}
	cout << st.get(n, n + 1) - n + 1 << '\n';
}

signed main() {
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}