#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const ll inf = 3e18;

void smin(ll& a, ll b) {
	a = min(a, b);
}

struct segtree {
	vector<ll> tree;
	int sz;

	segtree() {}

	segtree(int n) {
		sz = 1;
		while (sz < n)
			sz *= 2;
		tree.resize(2 * sz, inf);
	}

	void set(int i, ll v, int x, int tl, int tr) {
		if (tr - tl == 1) {
			tree[x] = v;
			return;
		}
		int m = (tl + tr) / 2;
		if (i < m)
			set(i, v, 2 * x + 1, tl, m);
		else
			set(i, v, 2 * x + 2, m, tr);
		tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
	}

	void set(int i, ll v) {
		set(i, v, 0, 0, sz);
	}

	ll get(int l, int r, int x, int tl, int tr) {
		if (l <= tl && tr <= r)
			return tree[x];
		if (l >= tr || r <= tl)
			return inf;
		int m = (tl + tr) / 2;
		ll s1, s2;
		s1 = get(l, r, 2 * x + 1, tl, m);
		s2 = get(l, r, 2 * x + 2, m, tr);
		return min(s1, s2);
	}

	ll get(int l, int r) {
		return get(l, r, 0, 0, sz);
	}
};

int ceil(int a, int b) {
	if (a <= 0)
		return 0;
	return (a - 1) / b + 1;
}

const int N = 2002;
ll dp[2][N];

inline void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vector<int> a(n + 1);
	vector<int> cc;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i <= n; i++)
		dp[0][i] = dp[1][i] = inf;
	dp[0][0] = 0;
	for (int i = 1; i <= n; i++) {
		vector<int> pref(k), cnt(k);
		for (int j = 1; j <= i; j++) {
			pref[a[j]]++;
			if (pref[a[j]] == p)
				pref[a[j]] = 0;
		}
		int take = 0;
		int cur = 0;
		for (int j = 0; j < k; j++)
			take += pref[j] > 0;
		for (int j = i; j > 0; j--) {
			cur -= ceil(cnt[a[j]] - pref[a[j]], p);
			take -= pref[a[j]] > 0;
			pref[a[j]]--;
			if (pref[a[j]] == -1)
				pref[a[j]] = p - 1;
			take += pref[a[j]] > 0;
			cnt[a[j]]++;
			cur += ceil(cnt[a[j]] - pref[a[j]], p);
			if (take + cur <= m) {
				if (c == 1 || c == 3) {
					smin(dp[1][i], dp[1][j - 1] + 2 * (n + 1 - j));
					smin(dp[0][i], dp[1][j - 1] + n + 1 - j + i);
					if (j == 1) {
						smin(dp[1][i], dp[0][j - 1] + n + 1);
						smin(dp[0][i], dp[0][j - 1] + 2 * i);
					}
				}
				if (c == 2 || c == 3) {
					smin(dp[1][i], dp[0][j - 1] + n + 1);
					smin(dp[0][i], dp[0][j - 1] + 2 * i);
				}
			}
		}
	}
	cout << dp[1][n] << '\n';
}

signed main() {
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}