#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

struct rect {
	int x1, y1, x2, y2;
	rect() {}

	rect(int x1, int y1, int x2, int y2) : x1(x1), y1(y1), x2(x2), y2(y2) {}
};

inline void solve() {
	int n;
	cin >> n;
	vector<rect> a(n);
	vector<int> cx, cy;
	for (int i = 0; i < n; i++) {
		cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
		a[i].x2++;
		a[i].y2++;
		cx.push_back(a[i].x1);
		cx.push_back(a[i].x2);
		cy.push_back(a[i].y1);
		cy.push_back(a[i].y2);
	}
	sort(all(cx));
	cx.erase(unique(all(cx)), cx.end());
	sort(all(cy));
	cy.erase(unique(all(cy)), cy.end());
	for (int i = 0; i < n; i++) {
		a[i].x1 = lower_bound(all(cx), a[i].x1) - cx.begin();
		a[i].x2 = lower_bound(all(cx), a[i].x2) - cx.begin();
		a[i].y1 = lower_bound(all(cy), a[i].y1) - cy.begin();
		a[i].y2 = lower_bound(all(cy), a[i].y2) - cy.begin();
	}
	vector<vector<bool>> used(cy.size(), vector<bool>(cx.size(), false));
	for (int i = 0; i < n; i++)
		for (int x = a[i].x1; x < a[i].x2; x++)
			for (int y = a[i].y1; y < a[i].y2; y++)
				used[y][x] = true;
	vector<pii> good;
	
	for (int i = 0; i < n; i++) {
		for (int x = a[i].x1; x < a[i].x2; x++) {
			for (int y = a[i].y1; y < a[i].y2; y++) {
				used[y][x] = true;
			}
		}
	}
	for (int y = 0; y < cy.size(); y++) {
		int x1 = 0;
		while (x1 < cx.size()) {
			if (!used[y][x1]) {
				x1++;
				continue;
			}
			int x2 = x1;
			while (used[y][x2])
				x2++;
			good.push_back({ x1, x2 });
			x1 = x2;
		}
	}
	sort(all(good));
	good.erase(unique(all(good)), good.end());
	cout << good.size() << '\n';
	for (int i = 0; i < (int)good.size(); i++) {
		cout << cx[good[i].first] << ' ' << cx[good[i].second] - 1 << ' ' << 1 << ' ' << 1 << '\n';
	}
}

signed main() {
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int tt = 1;
	cin >> tt;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
