#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

#define int long long

int n, m, c, p, ans = 0, INF = -1e18;

mt19937 rd(2);

struct node{
    node* l = nullptr;
    node* r = nullptr;
    int x, y, dp1, dp2, dp, p1 = INF, p2 = INF;

    node(){}

    node(int h, int dp):dp(dp){
        x = h;
        dp1 = dp;
        dp2 = dp + h * c;
        y = rd();
    }
};

void upd(node* v){
    if (v == nullptr){
        return;
    }
    v->dp1 = v->dp;
    v->dp2 = v->dp + v->x * c;
    if (v->l != nullptr){
        v->dp1 = max(v->dp1, v->l->dp1);
        v->dp2 = max(v->dp2, v->l->dp2);
    }
    if (v->r != nullptr){
        v->dp1 = max(v->dp1, v->r->dp1);
        v->dp2 = max(v->dp2, v->r->dp2);
    }
}

void push(node* v){
    if (v == nullptr){
        return;
    }
    v->dp1 = max(v->dp1, v->p1);
    v->dp2 = max(v->dp2, v->p2);
    if (v->l != nullptr){
        v->l->p1 = max(v->p1, v->l->p1);
        v->l->p2 = max(v->p2, v->l->p2);
    }
    if (v->r != nullptr){
        v->r->p1 = max(v->p1, v->r->p1);
        v->r->p2 = max(v->p2, v->r->p2);
    }
    v->p1 = INF;
    v->p2 = INF;
}
// < and >=
pair<node*, node*> split(node* v, int x){
    push(v);
    if (v == nullptr){
        return {nullptr, nullptr};
    }
    if (v->x < x){
        auto t = split(v->r, x);
        v->r = t.first;
        upd(v);
        return {v, t.second};
    }
    auto t = split(v->l, x);
    v->l = t.second;
    upd(v);
    return {t.first, v};
}

node* merge(node*f, node*s){
    if (f == nullptr){
        return s;
    }
    if (s == nullptr){
        return f;
    }
    if (f->y > s->y){
        push(f);
        f->r = merge(f->r, s);
        upd(f);
        return f;
    }
    push(s);
    s->l = merge(f, s->l);
    upd(s);
    return s;
}

node* insert(node* root, int h){
    auto t = split(root, h);
    auto f = t.first, s = t.second;
    int dp = p - h * c;
    if (f != nullptr){
        dp = max(dp, f->dp2 - h * c + p);
    }if (s != nullptr){
        dp = max(dp, s->dp1 + p);
    }
    ans = max(dp, ans);
    node* v = new node(h, dp);
    if (f != nullptr)
        f->p2 = dp;
    if (s != nullptr){
        s->p1 = dp + h * c;
    }
    return merge(merge(f, v), s);
}

signed main() {
    cin >> n >> m >> c >> p;
    int sd = -1;
    node* root = nullptr;
    for (int i = 0; i < n + m; i++){
        int t, h;
        cin >> t >> h;
        if (t == 1){
            sd += h;
        }
        else{
            root = insert(root, h + sd);
        }
    }
    cout << ans;
}
