#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

string cut(const string &src) {
    string res;
    ll n = ll(src.length());
    for (ll i = 0; i < n; ++i) {
        if (i == n - 1) {
            res += src[i];
            continue;
        }

        if (src[i] == 'L' || src[i] == 'R') {
            if (src[i + 1] == 'U' || src[i + 1] == 'D') {
                res += src[i];
            }
        } else {
            if (src[i + 1] == 'L' || src[i + 1] == 'R') {
                res += src[i];
            }
        }
    }

    return res;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<string> src(n);
    for (auto &item: src) {
        cin >> item;
    }

    string act;
    cin >> act;
    string abc;
    bool wasU = false;
    for (const auto &item: act) {
        if (item == 'U') {
            if (wasU) {
                continue;
            }

            wasU = true;
        }

        abc += item;
    }

    act = abc;

    act = cut(act);
    for (auto &move: act) {
        if (move == 'L') {
            for (ll i = 0; i < n; ++i) {
                string nxt;
                for (const auto &item: src[i]) {
                    if (item != '.') {
                        nxt += item;
                    }
                }
                while (ll(nxt.length()) < m) {
                    nxt += '.';
                }
                src[i] = nxt;
            }
        } else if (move == 'R') {
            for (ll i = 0; i < n; ++i) {
                string nxt;
                for (const auto &item: src[i]) {
                    if (item != '.') {
                        nxt += item;
                    }
                }
                reverse(nxt.begin(), nxt.end());
                while (ll(nxt.length()) < m) {
                    nxt += '.';
                }
                reverse(nxt.begin(), nxt.end());
                src[i] = nxt;
            }
        } else if (move == 'U') {
            for (ll j = 0; j < m; ++j) {
                string nxt;
                for (ll i = 0; i < n; ++i) {
                    if (src[i][j] != '.') {
                        nxt += src[i][j];
                    }
                }

                while (ll(nxt.length()) < n) {
                    nxt += '.';
                }
                for (ll i = 0; i < n; ++i) {
                    src[i][j] = nxt[i];
                }
            }
        } else if (move == 'D') {
            for (ll j = 0; j < m; ++j) {
                string nxt;
                for (ll i = 0; i < n; ++i) {
                    if (src[i][j] != '.') {
                        nxt += src[i][j];
                    }
                }

                reverse(nxt.begin(), nxt.end());
                while (ll(nxt.length()) < n) {
                    nxt += '.';
                }
                reverse(nxt.begin(), nxt.end());

                for (ll i = 0; i < n; ++i) {
                    src[i][j] = nxt[i];
                }
            }
        }
    }

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cout << src[i][j];
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
