#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;

struct Rect {
    ll xl, yl, xr, yr;
};

constexpr ll MAX_SIDE = 11;

void solve() {
    ll n;
    cin >> n;
    vector<Rect> src(n);
    set<ll> LS;
    set<ll> RS;
    vector<vector<bool>> F(MAX_SIDE + 1, vector<bool>(MAX_SIDE + 1));
    for (auto &item: src) {
        cin >> item.xl >> item.yl >> item.xr >> item.yr;
        LS.insert(item.xl);
        RS.insert(item.xr);
        for (ll i = item.yl; i <= item.yr; ++i) {
            for (ll j = item.xl; j <= item.xr; ++j) {
                F[i][j] = true;
            }
        }
    }

    vector<vector<ll>> res;
    for (const auto &xl: LS) {
        for (const auto &xr: RS) {
            if (xr < xl) {
                continue;
            }

            vector<ll> rows;
            for (ll r = 0; r < MAX_SIDE; ++r) {
                if (F[r][xl - 1] || F[r][xr + 1]) {
                    continue;
                }

                bool can = true;
                for (ll i = xl; i <= xr; ++i) {
                    if (!F[r][i]) {
                        can = false;
                        break;
                    }
                }

                if (!can) {
                    continue;
                }

                rows.push_back(r);
            }

            ll cnt = 1;
            ll tmp = 1;
            for (ll i = 1; i < ll(rows.size()); ++i) {
                if (rows[i] - 1 > rows[i - 1]) {
                    tmp = 1;
                } else {
                    ++tmp;
                }
                cnt = max(cnt, tmp);
            }

            if (!rows.empty()) {
                res.push_back({xl, xr, ll(rows.size()), cnt});
            }
        }
    }

    cout << res.size() << '\n';
    for (const auto &row: res) {
        for (const auto &item: row) {
            cout << item << ' ';
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
