#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <stdio.h>
#include <queue>

using namespace std;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << '\n';
#define debug(a) cerr << a << '\n';
#define all(a) a.begin(), a.end()

int n, m, q;
string s;
vector<vector<char>> a;
vector<vector<int>> a1, jump;
vector <pii> h {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};

bool ok (int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < m;
}

void solve() {
    cin >> n >> m;
    a.clear(); a.assign(n, vector<char>(m, '?'));
    a1.clear(); a1.assign(n, vector<int>(m));
    vector<vector<char>> b(n), c(m);
    vector<vector<int>> b1(n), c1(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            if (a[i][j] != '.') {
                b[i].push_back(a[i][j]);
                c[j].push_back(a[i][j]);
            }
        }
    }
    auto apply = [&] (char op) {
        if (op == 'R') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < m - b[i].size()) a[i][j] = '.';
                    else a[i][j] = b[i][j - (m - b[i].size())];
                }
            }
        }
        else if (op == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < b[i].size()) a[i][j] = b[i][j];
                    else a[i][j] = '.';
                }
            }
        }
        else if (op == 'U') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < c[j].size()) a[i][j] = c[j][i];
                    else a[i][j] = '.';
                }
            }
        }
        else if (op == 'D') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < n - c[j].size()) a[i][j] = '.';
                    else a[i][j] = c[j][i - (n - c[j].size())];
                }
            }
        }
        b.clear(); b.resize(n);
        c.clear(); c.resize(m);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') {
                    b[i].push_back(a[i][j]);
                    c[j].push_back(a[i][j]);
                }
            }
        }
    };
    auto apply1 = [&] (char op) {
        if (op == 'R') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < m - b1[i].size()) a1[i][j] = -1;
                    else a1[i][j] = b1[i][j - (m - b1[i].size())];
                }
            }
        }
        else if (op == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < b1[i].size()) a1[i][j] = b1[i][j];
                    else a1[i][j] = -1;
                }
            }
        }
        else if (op == 'U') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < c1[j].size()) a1[i][j] = c1[j][i];
                    else a1[i][j] = -1;
                }
            }
        }
        else if (op == 'D') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < n - c1[j].size()) a1[i][j] = -1;
                    else a1[i][j] = c1[j][i - (n - c1[j].size())];
                }
            }
        }
        b1.clear(); b1.resize(n);
        c1.clear(); c1.resize(m);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a1[i][j] != -1) {
                    b1[i].push_back(a1[i][j]);
                    c1[j].push_back(a1[i][j]);
                }
            }
        }
    };
    cin >> s; q = s.size();
    string t;
    for (auto i : s) {
        if (t.empty()) t += i;
        else {
            if (t.back() == 'L' || t.back() == 'R') {
                if (i == 'L' || i == 'R') t.back() = i;
                else t += i;
            }
            else {
                if (i == 'L' || i == 'R') t += i;
                else t.back() = i;
            }
        }
    }
    s = t; q = s.size();
    t.clear();
    for (auto i : s) {
        if (t.empty()) t += i;
        else {
            if (t.back() == 'L' || t.back() == 'R') {
                if (i == 'L' || i == 'R') t.back() = i;
                else {
                    if (t.size() == 1) t += i;
                    else {
                        if (i != t[t.size() - 2]) t += i;
                    }
                }
            }
            else {
                if (i == 'L' || i == 'R') {
                    if (t.size() == 1) t += i;
                    else {
                        if (i != t[t.size() - 2]) t += i;
                    }
                }
                else t.back() = i;
            }
        }
        if (t.size() >= 3 && t.back() == t[t.size() - 3]) t.pop_back();
    }

    s = t; q = s.size();

    for (int i = 4; i < q; ++i) {
        if (s[i] != s[i - 4]) exit(1);
    }

    if (q <= 50) {
        for (auto i : s) apply(i);
    }
    else {
        auto merge = [&](vector<vector<int>> &a, vector<vector<int>> &b) {
            vector<vector<int>> res(n, vector<int>(m, -1));
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] == -1) res[i][j] = -1;
                    else res[i][j] = b[a[i][j] / m][a[i][j] % m];
                }
            }
            a = res;
        };
        for (int i = 0; i < 4; ++i) {
            apply(s[i]);
        }
        int cnt = ((q - q % 4) - 4) / 4;

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] == '.') a1[i][j] = -1;
                else {
                    a1[i][j] = i * m + j;
                    b1[i].push_back(a1[i][j]);
                    c1[j].push_back(a1[i][j]);
                }
            }
        }
        for (int i = 0; i < 4; ++i) {
            apply1(s[i]);
        }
        jump.clear(); jump.assign(n, vector<int>(m, -1));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a1[i][j] != -1) {
                    jump[a1[i][j] / m][a1[i][j] % m] = i * m + j;
                }
            }
        }
        vector<vector<int>> lisa(n, vector<int>(m));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] == '.') lisa[i][j] = -1;
                else lisa[i][j] = i * m + j;
            }
        }
        while (cnt) {
            if (cnt & 1) {
                merge(lisa, jump);
            }
            cnt >>= 1; merge(jump, jump);
        }
        vector<vector<char>> result(n, vector<char>(m, '.'));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (lisa[i][j] != -1) result[lisa[i][j] / m][lisa[i][j] % m] = a[i][j];
            }
        }
        a = result;
        b.clear(); b.resize(n);
        c.clear(); c.resize(m);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') {
                    b[i].push_back(a[i][j]);
                    c[j].push_back(a[i][j]);
                }
            }
        }
        for (int i = q - q % 4; i < q; ++i) {
            apply(s[i]);
        }
    }


    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}

/*
....e
...de
..cde
.bcde
abcde

....e
...ed
..edc
.edcb
edcba

....a
...bb
..ccc
.dddd
eeeee

....e
...de
..cde
.bcde
abcde

....e
...ed
..edc
.edcb
edcba

*/