#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <stdio.h>
#include <queue>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << '\n';
#define debug(a) cerr << a << '\n';
#define all(a) a.begin(), a.end()

int n, m, q;
string s;
vector<vector<char>> a;
vector <pii> h {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};

bool ok (int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < m;
}

void solve() {
    cin >> n >> m;
    a.clear(); a.assign(n, vector<char>(m, '?'));
    vector<vector<int>> b(n), c(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            if (a[i][j] != '.') {
                b[i].push_back(a[i][j]);
                c[j].push_back(a[i][j]);
            }
        }
    }
    auto apply = [&] (char op) {
        if (op == 'R') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < m - b[i].size()) a[i][j] = '.';
                    else a[i][j] = b[i][j - (m - b[i].size())];
                }
            }
        }
        else if (op == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < b[i].size()) a[i][j] = b[i][j];
                    else a[i][j] = '.';
                }
            }
        }
        else if (op == 'U') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < c[j].size()) a[i][j] = c[j][i];
                    else a[i][j] = '.';
                }
            }
        }
        else if (op == 'D') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < n - c[j].size()) a[i][j] = '.';
                    else a[i][j] = c[j][i - (n - c[j].size())];
                }
            }
        }
        b.clear(); b.resize(n);
        c.clear(); c.resize(m);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') {
                    b[i].push_back(a[i][j]);
                    c[j].push_back(a[i][j]);
                }
            }
        }
    };
    cin >> s; q = s.size();
    string t;
    for (auto i : s) {
        if (t.empty()) t += i;
        else {
            if (t.back() == 'L' || t.back() == 'R') {
                if (i == 'L' || i == 'R') t.back() = i;
                else t += i;
            }
            else {
                if (i == 'L' || i == 'R') t += i;
                else t.back() = i;
            }
        }
    }
    s = t; q = s.size();
    t.clear();
    for (auto i : s) {
        if (t.empty()) t += i;
        else {
            if (t.back() == 'L' || t.back() == 'R') {
                if (i == 'L' || i == 'R') t.back() = i;
                else {
                    if (t.size() == 1) t += i;
                    else {
                        if (i != t[t.size() - 2]) t += i;
                    }
                }
            }
            else {
                if (i == 'L' || i == 'R') {
                    if (t.size() == 1) t += i;
                    else {
                        if (i != t[t.size() - 2]) t += i;
                    }
                }
                else t.back() = i;
            }
        }
    }

    s = t; q = s.size();

    if (q <= 100) {
        for (auto i : s) apply(i);
    }
    else {
        for (int i = 0; i < 100; ++i) apply(s[i]);
        for (int i = q - 100; i < q; ++i) apply(s[i]);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}