#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>

#define res(a, n); a.clear(); a.resize(n);
#define int long long
#define endl '\n'

using namespace std;

int n, m;

vector<vector<char>> a;

void move(char t){
	if (t == 'U') {
		for (int j = 0; j < m; j++) {
			queue<char> q;
			for (int i = 0; i < n; i++) {
				if (a[i][j] != '.') q.push(a[i][j]);
				a[i][j] = '.';
			}
			int nx = 0;
			while (!q.empty()) {
				a[nx][j] = q.front(); q.pop();
				nx++;
			}
		}
	}
	if (t == 'D') {
		for (int j = 0; j < m; j++) {
			queue<char> q;
			for (int i = n - 1; i >= 0; i--) {
				if (a[i][j] != '.') q.push(a[i][j]);
				a[i][j] = '.';
			}
			int nx = n - 1;
			while (!q.empty()) {
				a[nx][j] = q.front(); q.pop();
				nx--;
			}
		}
	}if (t == 'L') {
		for (int j = 0; j < n; j++) {
			queue<char> q;
			for (int i = 0; i < m; i++) {
				if (a[j][i] != '.') q.push(a[j][i]);
				a[j][i] = '.';
			}
			int nx = 0;
			while (!q.empty()) {
				a[j][nx] = q.front(); q.pop();
				nx++;
			}
		}
	}
	if (t == 'R') {
		for (int j = 0; j < n; j++) {
			queue<char> q;
			for (int i = m - 1; i >= 0; i--) {
				if (a[j][i] != '.') q.push(a[j][i]);
				a[j][i] = '.';
			}
			int nx = m - 1;
			while (!q.empty()) {
				a[j][nx] = q.front(); q.pop();
				nx--;
			}
		}
	}
}

void print() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << a[i][j];
		}cout << endl;
	}
}

void solve() {
	cin >> n >> m;
	res(a, n);
	for (auto& x : a) {
		res(x, m);
		for (auto& y : x) {
			cin >> y;
		}
	}

	string s;
	/*res(s, rand() % 100 + 20);
	for (int i = 0; i < s.size(); i++) {
		int g = rand() % 4;
		if (g == 0) s[i] = 'D';
		if (g == 1) s[i] = 'L';
		if (g == 2) s[i] = 'R';
		if (g == 3) s[i] = 'U';
	}*/

	cin >> s;

	vector<char> s2;
	pair<char, int> lastd, lastr;
	lastd = { '.', -1 }; lastr = { '.', -1 };
	for (int i = 0; i < s.size(); i++) {
		if (lastd.first == s[i] || lastr.first == s[i]) continue;
		if (s[i] == 'D' || s[i] == 'U') {
			lastd = { s[i], i };
		}
		if (s[i] == 'R' || s[i] == 'L') {
			lastr = { s[i], i };
		}
		bool f = false;
		while (s2.size() > 0) {
			if (s2[s2.size() - 1] == 'U' && s[i] == 'D' || s2[s2.size() - 1] == 'D' && s[i] == 'U') {
				s2.pop_back();
			}
			else if (s2[s2.size() - 1] == 'L' && s[i] == 'R' || s2[s2.size() - 1] == 'R' && s[i] == 'L') {
				s2.pop_back();
			}
			else if (s2.size() > 1 && s2[s2.size() - 2] == s[i]) {
				f = true; break;
			}
			else break;
		}
		if (f) continue;
		s2.push_back(s[i]);
	}

	/*for (auto x : s2) cout << x;
	cout << endl;
	return;*/

	for (auto x : s2) move(x);
	print();
	return;

	if (s2.size() < 2) {

		for (int i = 0; i < s2.size(); i++) {
			move(s2[i]);
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << a[i][j];
			}cout << endl;
		}
		return;
	}

	for (int i = 0; i < 2; i++) {
		move(s2[i]);
	}

	move('L'); move('U');
	move(s2[s2.size() - 2]); move(s2[s2.size() - 1]);
	
	print();
}
/*

4
4
4
.a.b
..e.
....
.cd.
LRU


*/

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}