#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>

#define res(a, n); a.clear(); a.resize(n);
#define int long long
#define endl '\n'

using namespace std;

int n, m;

vector<vector<char>> a;
vector<vector<int>> b;

vector<vector<vector<int>>> graf;
int st = 1;


void move(char t){
	if (t == 'U') {
		for (int j = 0; j < m; j++) {
			queue<int> q;
			for (int i = 0; i < n; i++) {
				if (b[i][j] != -1) q.push(b[i][j]);
				b[i][j] = -1;
			}
			int nx = 0;
			while (!q.empty()) {
				b[nx][j] = q.front(); q.pop();
				nx++;
			}
		}
	}
	if (t == 'D') {
		for (int j = 0; j < m; j++) {
			queue<int> q;
			for (int i = n - 1; i >= 0; i--) {
				if (b[i][j] != -1) q.push(b[i][j]);
				b[i][j] = -1;
			}
			int nx = n - 1;
			while (!q.empty()) {
				b[nx][j] = q.front(); q.pop();
				nx--;
			}
		}
	}if (t == 'L') {
		for (int j = 0; j < n; j++) {
			queue<int> q;
			for (int i = 0; i < m; i++) {
				if (b[j][i] != -1) q.push(b[j][i]);
				b[j][i] = -1;
			}
			int nx = 0;
			while (!q.empty()) {
				b[j][nx] = q.front(); q.pop();
				nx++;
			}
		}
	}
	if (t == 'R') {
		for (int j = 0; j < n; j++) {
			queue<int> q;
			for (int i = m - 1; i >= 0; i--) {
				if (b[j][i] != -1) q.push(b[j][i]);
				b[j][i] = -1;
			}
			int nx = m - 1;
			while (!q.empty()) {
				b[j][nx] = q.front(); q.pop();
				nx--;
			}
		}
	}
}

void move2(vector<char>& t) {
	for (auto x : t) { move(x); }
}

void print() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int key = b[i][j];
			if (key == -1) cout << '.';
			else cout << a[key / n][key % n];
		}cout << endl;
	}
}

void solve() {
	cin >> n >> m;
	res(a, n); res(graf, n); res(b, n);
	for (int i = 0; i < n; i++) {
		res(a[i], m); res(graf[i], m); res(b[i], m);
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			if (a[i][j] != '.') b[i][j] = n * i + j;
			else b[i][j] = -1;
		}
	}

	string s;

	cin >> s;

	vector<char> s2;
	pair<char, int> lastd, lastr;
	lastd = { '.', -1 }; lastr = { '.', -1 };
	for (int i = 0; i < s.size(); i++) {
		if (lastd.first == s[i] || lastr.first == s[i]) continue;
		if (s[i] == 'D' || s[i] == 'U') {
			lastd = { s[i], i };
		}
		if (s[i] == 'R' || s[i] == 'L') {
			lastr = { s[i], i };
		}
		bool f = false;
		while (s2.size() > 0) {
			if (s2[s2.size() - 1] == 'U' && s[i] == 'D' || s2[s2.size() - 1] == 'D' && s[i] == 'U') {
				s2.pop_back();
			}
			else if (s2[s2.size() - 1] == 'L' && s[i] == 'R' || s2[s2.size() - 1] == 'R' && s[i] == 'L') {
				s2.pop_back();
			}
			else if (s2.size() > 1 && s2[s2.size() - 2] == s[i]) {
				f = true; break;
			}
			else break;
		}
		if (f) continue;
		s2.push_back(s[i]);
	}



	move2(s2);
	print();
	return;

	if (s2.size() < 6) {

		for (int i = 0; i < s2.size(); i++) {
			move(s2[i]);
		}
		print();
		return;
	}

	int col = 0; string t = "";
	t[0] = s[2]; t[1] = s[3]; t[2] = s[4]; t[3] = s[5];
	for (int i = 6; i < s2.size(); i+=4) {
		if (t[0] == s[i] && t[1] == s[i + 1] && t[2] == s[i + 2] && t[3] == s[i + 3]) {
			col++;
		}
	}

	for (int i = 0; i < 2; i++) {
		move(s2[i]);
	}

	while (st < col) st <<= 1;
	for (auto& x : graf) {
		for (auto& y : x) {
			res(y, st);
		}
	}




	int last = (s2.size() - 2) % 4;

	for (int i = s2.size() - last; i < s2.size(); i++) {
		move(s2[i]);
	}

	print();
}
/*

4
4
4
.a.b
..e.
....
.cd.
LRU


*/

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}