#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <time.h>
#include <cstdlib>

using namespace std;

using ll = long long;
using dlle = long double;
using vl = vector <long long>;
using pl = pair <long long, long long>;
using vpl = vector <pair<long long, long long>>;

ll cost, madd;
vl fenwick;

void adds(ll ind, ll add) {
	++ind;
	while (ind < fenwick.size()) {
		fenwick[ind] += add;
		ind += ind & -ind;
	}
}

ll gets(ll r) {
	r += 1;
	ll res = 0;
	while (r > 0) {
		res += fenwick[r];

		r -= r & -r;
	}

	return res;
}

ll gets(ll l, ll r) {
	return gets(r) - gets(l - 1);
}

int main(){
	ll n, m;

	cin >> n >> m >> cost >> madd;

	vector <ll> mas(m);

	{
		ll d = 0;

		for (int i = 0, j = 0; i < n + m; i++) {
			ll t, h; cin >> t >> h;

			if (t == 1) d += h;
			else {
				mas[j] = d + h;
				++j;
			}
		}
	}

	vl tab(m);

	{
		vpl cumas(m);
		for (int i = 0; i < m; i++) {
			cumas[i].second = i;
			cumas[i].first = mas[i];
		}
		sort(cumas.begin(), cumas.end());

		ll t = 0;
		for (int i = 0; i < m; i++) {
			if (i != 0 && mas[cumas[i].second] != mas[cumas[i - 1].second]) ++t;
			
			tab[cumas[i].second] = t;
		}

		fenwick.assign(t + 2, 0);
	}

	ll res = 0;

	for (int i = 0; i < m; i++) {
		adds(tab[i], 1);
	}

	for (int i = 0; i < m; i++) {
		ll cu = -(mas[i] - 1) * cost;
		ll k = gets(tab[i]);
		cu += k * madd;

		res = max(res, cu);

		//adds(tab[i], 1);
	}

	cout << res;
}