#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pp = pair<ll, ll>;

void compress(int n, int m, vector<vector<int>> &table, char dir) {
    if (dir == 'L') {
        for (int i = 0; i < n; i++) {
            vector<int> tmp;
            for (int el: table[i]) {
                if (el != -1) {
                    tmp.push_back(el);
                }
            }
            while (tmp.size() < m) {
                tmp.push_back(-1);
            }
            swap(tmp, table[i]);
        }
    } else if (dir == 'R') {
        for (int i = 0; i < n; i++) {
            vector<int> tmp;
            for (int el: table[i]) {
                if (el != -1) {
                    tmp.push_back(el);
                }
            }
            reverse(tmp.begin(), tmp.end());
            while (tmp.size() < m) {
                tmp.push_back(-1);
            }
            reverse(tmp.begin(), tmp.end());
            swap(tmp, table[i]);
        }
    } else if (dir == 'U') {
        for (int j = 0; j < m; j++) {
            vector<int> tmp;
            for (int i = 0; i < n; i++) {
                if (table[i][j] != -1) {
                    tmp.push_back(table[i][j]);
                }
            }
            while (tmp.size() < n) {
                tmp.push_back(-1);
            }
            for (int i = 0; i < n; i++) {
                table[i][j] = tmp[i];
            }
        }
    } else {
        for (int j = 0; j < m; j++) {
            vector<int> tmp;
            for (int i = 0; i < n; i++) {
                if (table[i][j] != -1) {
                    tmp.push_back(table[i][j]);
                }
            }
            reverse(tmp.begin(), tmp.end());
            while (tmp.size() < n) {
                tmp.push_back(-1);
            }
            reverse(tmp.begin(), tmp.end());
            for (int i = 0; i < n; i++) {
                table[i][j] = tmp[i];
            }
        }
    }
}

const int maxn = 2e6 + 11, maxlog = 20;
int up[maxlog][maxn];
int ps[maxn];

int code(int n, int m, int x, int y) {
    return x * m + y;
}

void compress(int n, int m, vector<string> &table, char dir) {
    if (dir == 'L') {
        for (int i = 0; i < n; i++) {
            string tmp;
            for (char ch: table[i]) {
                if (ch != '.') {
                    tmp += ch;
                }
            }
            while (tmp.size() < m) {
                tmp += '.';
            }
            swap(tmp, table[i]);
        }
    } else if (dir == 'R') {
        for (int i = 0; i < n; i++) {
            string tmp;
            for (char ch: table[i]) {
                if (ch != '.') {
                    tmp += ch;
                }
            }
            reverse(tmp.begin(), tmp.end());
            while (tmp.size() < m) {
                tmp += '.';
            }
            reverse(tmp.begin(), tmp.end());
            swap(tmp, table[i]);
        }
    } else if (dir == 'U') {
        for (int j = 0; j < m; j++) {
            string tmp;
            for (int i = 0; i < n; i++) {
                if (table[i][j] != '.') {
                    tmp += table[i][j];
                }
            }
            while (tmp.size() < n) {
                tmp += '.';
            }
            for (int i = 0; i < n; i++) {
                table[i][j] = tmp[i];
            }
        }
    } else {
        for (int j = 0; j < m; j++) {
            string tmp;
            for (int i = 0; i < n; i++) {
                if (table[i][j] != '.') {
                    tmp += table[i][j];
                }
            }
            reverse(tmp.begin(), tmp.end());
            while (tmp.size() < n) {
                tmp += '.';
            }
            reverse(tmp.begin(), tmp.end());
            for (int i = 0; i < n; i++) {
                table[i][j] = tmp[i];
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> table(n);
    for (string &s: table) {
        cin >> s;
    }
    string qr;
    cin >> qr;
    vector<vector<int>> pos(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (j < i) {
                pos[i][j] = code(n, m, i, j);
            } else {
                pos[i][j] = -1;
            }
        }
    }
    for (char ch: "URDL") {
        compress(n, m, pos, ch);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (pos[i][j] != -1)
                ps[pos[i][j]] = code(n, m, i, j);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (j < i) {
                up[0][code(n, m, i, j)] = ps[code(n, m, i, j)];
            }
        }
    }
    for (int j = 1; j < maxlog; j++) {
        for (int i = 0; i < maxn; i++) {
            up[j][i] = up[j - 1][up[j - 1][i]];
        }
    }
    //cout << clock() << '\n';
    vector<string> ans(n, string(m, '.'));
    int sz = ((int) qr.size() - 1) / 4;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            int curr = code(n, m, i, j);
            for (int lg = 0; lg < maxlog; lg++) {
                if ((sz >> lg) & 1) {
                    curr = up[lg][curr];
                }
            }
            ans[curr / m][curr % m] = table[i][j];

        }
    }
    for (int i = 1 + sz * 4; i < qr.size(); i++) {
        compress(n, m, ans, qr[i]);
    }
    for (auto &i: ans) {
        for (auto j: i) {
            cout << j;
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}