#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pp = pair<ll, ll>;

struct Event {
    ll x, y1, y2, tp;
};

bool operator<(Event a, Event b) {
    if (a.x == b.x) {
        return a.tp < b.tp;
    }
    return a.x < b.x;
}

vector<pp> seg_union(multiset<pp> &segs) {
    vector<pp> events;
    for (auto [x1, x2]: segs) {
        events.emplace_back(x1, -1);
        events.emplace_back(x2, 1);
    }
    sort(events.begin(), events.end());
    ll bal = 0;
    vector<pp> ans;
    ll px = -1;
    for (auto [x, tp]: events) {
        if (tp == -1) {
            if (bal == 0) {
                px = x;
            }
            bal++;
        } else {
            bal--;
            if (bal == 0) {
                ans.emplace_back(px, x);
            }
        }
    }
    vector<pp> ans2 = {ans[0]};
    for (int i = 1; i < ans.size(); i++) {
        if (ans[i].first == ans2.back().second + 1) {
            ans2.back().second = ans[i].second;
        } else {
            ans2.push_back(ans[i]);
        }
    }
    return ans2;
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<pp, pp>> arr(n);
    vector<Event> events;
    for (ll i = 0; i < n; i++) {
        ll x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        swap(x1, y1);
        swap(x2, y2);
        events.push_back({x1, y1, y2, -1});
        events.push_back({x2 + 1, y1, y2, 1});
    }
    sort(events.begin(), events.end());
    multiset<pp> segs;
    ll prv = -1;
    map<pp, ll> cnt;
    for (auto &[x, y1, y2, tp]: events) {
        if (prv != -1 && prv != x && !segs.empty()) {
            //cout << "before x=" << x << '\n';
            for (pp el: seg_union(segs)) {
                cnt[el] += x - prv;
                //cout << el.first << ' ' << el.second << '\n';
            }
        }
        if (tp == -1) {
            segs.emplace(y1, y2);
        } else {
            segs.extract({y1, y2});
        }
        prv = x;
    }
    cout << cnt.size() << '\n';
    for (auto [sg, val]: cnt) {
        cout << sg.first << ' ' << sg.second << ' ' << val << ' ' << 0 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}