

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include<string>



using namespace std;


void U(vector<vector<int>>& v) {
	int m = v.size();
	int n = v[0].size();
	for (int i = 0; i < n; i++) {
		int am = 0;
		for (int j = 0; j < m; j++) {
			if (v[j][i] != '.') {
				v[am][i] = v[j][i];
				am++;
			}
		}
		for (int j = am; j < m; j++) {
			v[j][i] = '.';
		}
	}
	return;
}

void D(vector<vector<int>>& v) {
	int m = v.size();
	int n = v[0].size();
	for (int i = 0; i < n; i++) {
		int am = m - 1;
		for (int j = m - 1; j >= 0; j--) {
			if (v[j][i] != '.') {
				v[am][i] = v[j][i];
				am--;
			}
		}
		for (int j = am; j >= 0; j--) {
			v[j][i] = '.';
		}
	}
	return;
}

void R(vector<vector<int>>& v) {
	int m = v.size();
	int n = v[0].size();
	for (int i = 0; i < m; i++) {
		int am = n - 1;
		for (int j = n - 1; j >= 0; j--) {
			if (v[i][j] != '.') {
				v[i][am] = v[i][j];
				am--;
			}
		}
		for (int j = am; j >= 0; j--) {
			v[i][j] = '.';
		}
	}
	return;
}


void L(vector<vector<int>>& v) {
	int m = v.size();
	int n = v[0].size();
	for (int i = 0; i < m; i++) {
		int am = 0;
		for (int j = 0; j < n; j++) {
			if (v[i][j] != '.') {
				v[i][am] = v[i][j];
				am++;
			}
		}
		for (int j = am; j < n; j++) {
			v[i][j] = '.';
		}
	}
	return;
}

string socr(string s) {
	string ans;
	for (int i = 0; i < s.size() - 1; i++) {
		if (s[i] == s[i + 1]) {
			continue;
		}
		if (s[i] == 'U' && s[i + 1] == 'D') {
			continue;
		}
		if (s[i] == 'D' && s[i + 1] == 'U') {
			continue;
		}
		if (s[i] == 'R' && s[i + 1] == 'L') {
			continue;
		}
		if (s[i] == 'L' && s[i + 1] == 'R') {
			continue;
		}
		ans += s[i];
	}
	ans += s[s.size() - 1];
	return ans;
}

bool check(string s) {
	int am = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == 'D') {
			am++;
		}
	}
	return (am < 2);
}

string del(string s) {
	string ans;
	int am = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == 'U') {
			am++;
		}
		if (am > 1) {
			continue;
		}
		ans += s[i];
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t, m, n;
	cin >> t;
	while (t--) {
		cin >> m >> n;
		vector<int> qq(n);
		vector<vector<int>> v;
		for (int i = 0; i < m; i++) {
			string s;
			v.push_back(qq);
			cin >> s;
			for (int j = 0; j < n; j++) {
				v[i][j] = (int)s[j];
			}
		}
		string s;
		cin >> s;
		if (check(s)) {
			s=del(s);
		}
		s = socr(s);
		for (int i = 0; i < s.size(); i++) {
			if (s[i] == 'U') {
				U(v);
			}
			if (s[i] == 'L') {
				L(v);
			}
			if (s[i] == 'R') {
				R(v);
			}
			if (s[i] == 'D') {
				D(v);
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cout << (char)v[i][j];
			}
			cout << '\n';
		}
	}
	
	return 0;
}

