#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n, m;
vector <string> mt;
string way;

void toleftmt() {
    for (int i = 0; i < n; ++i) {
        vector <int> cd;
        for (int j = 0; j < m; ++j) {
            if (mt[i][j] != '.') {
                cd.push_back(j);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int j = 0; j < m; ++j) {
                while (ind < cd.size() && cd[ind] <= j) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[i][cd[ind]]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}
void torightmt() {
    for (int i = 0; i < n; ++i) {
        vector <int> cd;
        for (int j = m - 1; j >= 0; --j) {
            if (mt[i][j] != '.') {
                cd.push_back(j);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int j = m - 1; j >= 0; --j) {
                while (ind < cd.size() && cd[ind] >= j) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[i][cd[ind]]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}
void toupmt() {
    for (int j = 0; j < m; ++j) {
        vector <int> cd;
        for (int i = 0; i < n; ++i) {
            if (mt[i][j] != '.') {
                cd.push_back(i);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int i = 0; i < n; ++i) {
                while (ind < cd.size() && cd[ind] <= i) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[cd[ind]][j]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}
void todownmt() {
    for (int j = 0; j < m; ++j) {
        vector <int> cd;
        for (int i = n - 1; i >= 0; --i) {
            if (mt[i][j] != '.') {
                cd.push_back(i);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int i = n - 1; i >= 0; --i) {
                while (ind < cd.size() && cd[ind] >= i) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[cd[ind]][j]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int _;
    cin >> _;
    for (int __ = 0; __ < _; ++__) {
        cin >> n >> m;
        mt.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> mt[i];
        }
        cin >> way;
        int ind = 0;
        for (int j = 0; ind < way.size(); ++j) {
            if (ind < way.size()) {
                if (way[ind] == 'L' || way[ind] == 'R') {
                    for (; ind < way.size(); ++ind) {
                        if (way[ind] != 'L' && way[ind] != 'R') {
                            break;
                        }
                    }
                    if (way[ind - 1] == 'L') {
                        toleftmt();
                    } else {
                        torightmt();
                    }
                } else {
                    for (; ind < way.size(); ++ind) {
                        if (way[ind] != 'U' && way[ind] != 'D') {
                            break;
                        }
                    }
                    if (way[ind - 1] == 'U') {
                        toupmt();
                    } else {
                        todownmt();
                    }
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            cout << mt[i] << "\n";
        }
    }
}
