#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n, m;
vector <string> mt;
string way;

void toleftmt() {
    for (int i = 0; i < n; ++i) {
        vector <int> cd;
        for (int j = 0; j < m; ++j) {
            if (mt[i][j] != '.') {
                cd.push_back(j);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int j = 0; j < m; ++j) {
                while (ind < cd.size() && cd[ind] <= j) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[i][cd[ind]]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}
void torightmt() {
    for (int i = 0; i < n; ++i) {
        vector <int> cd;
        for (int j = m - 1; j >= 0; --j) {
            if (mt[i][j] != '.') {
                cd.push_back(j);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int j = m - 1; j >= 0; --j) {
                while (ind < cd.size() && cd[ind] >= j) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[i][cd[ind]]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}
void toupmt() {
    for (int j = 0; j < m; ++j) {
        vector <int> cd;
        for (int i = 0; i < n; ++i) {
            if (mt[i][j] != '.') {
                cd.push_back(i);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int i = 0; i < n; ++i) {
                while (ind < cd.size() && cd[ind] <= i) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[cd[ind]][j]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}
void todownmt() {
    for (int j = 0; j < m; ++j) {
        vector <int> cd;
        for (int i = n - 1; i >= 0; --i) {
            if (mt[i][j] != '.') {
                cd.push_back(i);
            }
        }
        int ind = 0;
        if (cd.size() > 0) {
            for (int i = n - 1; i >= 0; --i) {
                while (ind < cd.size() && cd[ind] >= i) {
                    ++ind;
                }
                if (ind >= cd.size()) {
                    break;
                }
                if (mt[i][j] == '.') {
                    swap(mt[i][j], mt[cd[ind]][j]);
                    ++ind;
                    if (ind >= cd.size()) {
                        break;
                    }
                }
            }
        }
    }
}

bool isnullN(int i) {
    for (int j = 0; j < m; ++j) {
        if (mt[i][j] != '.') {
            return false;
        }
    }
    return true;
}
bool isnullM(int j) {
    for (int i = 0; i < n; ++i) {
        if (mt[i][j] != '.') {
            return false;
        }
    }
    return true;
}

map <pair<int, char>, int> mp;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    mp[{0, 'U'}] = 0;
    mp[{0, 'D'}] = 3;
    mp[{0, 'R'}] = 1;
    mp[{0, 'L'}] = 0;

    mp[{1, 'U'}] = 1;
    mp[{1, 'D'}] = 2;
    mp[{1, 'R'}] = 1;
    mp[{1, 'L'}] = 0;

    mp[{2, 'U'}] = 1;
    mp[{2, 'D'}] = 2;
    mp[{2, 'R'}] = 2;
    mp[{2, 'L'}] = 3;

    mp[{3, 'U'}] = 0;
    mp[{3, 'D'}] = 3;
    mp[{3, 'R'}] = 2;
    mp[{3, 'L'}] = 3;

    int _;
    cin >> _;
    for (int __ = 0; __ < _; ++__) {
        cin >> n >> m;
        mt.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> mt[i];
        }
        cin >> way;
        int ind = 0;
        int cursor = 0; // 0 - UP left, 1 - UP right, 2 - DOWN right, 3 - DOWN left
        for (int j = 0; j < 2; ++j) {
            if (ind < way.size()) {
                if (way[ind] == 'L' || way[ind] == 'R') {
                    for (; ind < way.size(); ++ind) {
                        if (way[ind] != 'L' && way[ind] != 'R') {
                            break;
                        }
                    }
                    if (way[ind - 1] == 'L') {
                        toleftmt();
                        cursor = 0;
                    } else {
                        torightmt();
                        cursor = 1;
                    }
                } else {
                    for (; ind < way.size(); ++ind) {
                        if (way[ind] != 'U' && way[ind] != 'D') {
                            break;
                        }
                    }
                    if (way[ind - 1] == 'U') {
                        toupmt();
                        if (cursor == 0) {
                            cursor = 0;
                        } else {
                            cursor = 1;
                        }
                    } else {
                        todownmt();
                        if (cursor == 0) {
                            cursor = 3;
                        } else {
                            cursor = 2;
                        }
                    }
                }
            }
        }
        int cnext = cursor;
        int rot = 0;
        for (; ind < way.size(); ++ind) {
            int ctemp = mp[{cnext, way[ind]}];
            if (ctemp == 0 && cnext == 3) {
                ++rot;
            } else if (ctemp == 3 && cnext == 0) {
                --rot;
            } else {
                rot += ctemp - cnext;
            }
            cnext = ctemp;
        }
        if (cursor == 0) {
            torightmt();
            cursor = 1;
            --rot;
        }
        if (cursor == 2) {
            toupmt();
            cursor = 1;
            ++rot;
        }
        if (cursor == 3) {
            torightmt();
            toupmt();
            cursor = 1;
            rot += 2;
        }
        // big moove
        if (cursor == 1) {
            vector <char> ast;
            int leftgr = 0;
            while (leftgr < m && isnullM(leftgr)) {
                ++leftgr;
            }
            int rightgr = m - 1;
            if (leftgr < rightgr) {
                for (int i = 0; i < n; ++i) {
                    if (mt[i][leftgr] != '.') {
                        ast.push_back(mt[i][leftgr]);
                    }
                }
                for (int i = n - 1; i >= 0; --i) {
                    if (mt[i][rightgr] != '.') {
                        ast.push_back(mt[i][rightgr]);
                    }
                }
                int ind;
                if (rot > 0) {
                    ind = rot / 4;
                } else {
                    ind = (-rot) / 4;
                    ind = -ind;
                }
                ind = -ind;
                for (int i = 0; i < n; ++i) {
                    if (mt[i][leftgr] != '.') {
                        mt[i][leftgr] = ast[ind];
                        ++ind;
                        ind %= ast.size();
                    }
                }
                for (int i = n - 1; i >= 0; --i) {
                    if (mt[i][rightgr] != '.') {
                        mt[i][rightgr] = ast[ind];
                        ++ind;
                        ind %= ast.size();
                    }
                }
            }
        }
        // end of bigmoove
        rot = rot % 4;
        if (rot < 0) {
            rot += 4;
        }
        if (rot == 1) {
            if (cursor == 0) {
                torightmt();
            } else if (cursor == 1) {
                todownmt();
            } else if (cursor == 2) {
                toleftmt();
            } else {
                toupmt();
            }
        } else if (rot == 2) {
            if (cursor == 0) {
                torightmt();
                todownmt();
            } else if (cursor == 1) {
                todownmt();
                toleftmt();
            } else if (cursor == 2) {
                toleftmt();
                toupmt();
            } else {
                toupmt();
                torightmt();
            }
        } else if (rot == 3) {
            if (cursor == 0) {
                torightmt();
                todownmt();
                toleftmt();
            } else if (cursor == 1) {
                todownmt();
                toleftmt();
                toupmt();
            } else if (cursor == 2) {
                toleftmt();
                toupmt();
                torightmt();
            } else {
                toupmt();
                torightmt();
                todownmt();
            }
        }

        for (int i = 0; i < n; ++i) {
            cout << mt[i] << "\n";
        }
    }
}
