#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n;
map <int, vector<pair<pair<int, int>, int>>> rect;


struct Vert {
    int dmin, dmax, dadd;
    int l, r;
};
vector <Vert> d;
int addnullVert() {
    Vert e;
    e.dmin = 0;
    e.dmax = 0;
    e.dadd = 0;
    e.l = -1;
    e.r = -1;
    d.push_back(e);
    return d.size() - 1;
}
void dpush(int v, int l, int r) {
    if (l + 1 != r) {
        if (d[v].l == -1) {
            d[v].l = addnullVert();
        }
        if (d[v].r == -1) {
            d[v].r = addnullVert();
        }
        d[d[v].l].dadd += d[v].dadd;
        d[d[v].l].dmin += d[v].dadd;
        d[d[v].l].dmax += d[v].dadd;
        d[d[v].r].dadd += d[v].dadd;
        d[d[v].r].dmin += d[v].dadd;
        d[d[v].r].dmax += d[v].dadd;
    }
    d[v].dadd = 0;
}
void addnew(int v, int l, int r, int Ql, int Qr, int e) {
    if (Qr <= l || Ql >= r) {
        return;
    }
    if (Ql <= l && r <= Qr) {
        d[v].dmin += e;
        d[v].dmax += e;
        d[v].dadd += e;
    } else {
        int m = l + (r - l) / 2;
        dpush(v, l, r);
        addnew(d[v].l, l, m, Ql, Qr, e);
        addnew(d[v].r, m, r, Ql, Qr, e);
        d[v].dmin = min(d[d[v].l].dmin, d[d[v].r].dmin);
        d[v].dmax = max(d[d[v].l].dmax, d[d[v].r].dmax);
    }
}
vector <pair<int, int>> resgetony;
void getony(int v, int l, int r) {
    if (d[v].dmax == 0) {
        return;
    }
    if (d[v].dmin != 0) {
        resgetony.push_back({l, r});
        return;
    }
    int m = l + (r - l) / 2;
    dpush(v, l, r);
    getony(d[v].l, l, m);
    getony(d[v].r, m, r);
}
void makeony() {
    vector <pair<int, int>> resgetonyold;
    int last = -INF;
    for (auto i : resgetony) {
        if (i.first == last) {
            resgetonyold.back().second = i.second;
        } else {
            resgetonyold.push_back({i.first, i.second});
        }
        last = i.second;
    }
    swap(resgetony, resgetonyold);
}



map <pair<int, int>, vector<int>> anss;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int _;
    cin >> _;
    for (int __ = 0; __ < _; ++__) {
        d.clear();
        addnullVert();
        anss.clear();
        cin >> n;
        rect.clear();
        for (int i = 0; i < n; ++i) {
            int x1,y1,x2,y2;
            cin >> x1 >> y1 >> x2 >> y2;
            rect[y1].push_back({{x1, x2 + 1}, 1});
            rect[y2 + 1].push_back({{x1, x2 + 1}, -1});
        }
        int indi = -INF;
        map <int, int> cnto;
        for (auto &i : rect) {
            cnto[indi] = i.first - 1;
            indi = i.first;
            for (auto &j : i.second) {
                addnew(0, -INF, INF, j.first.first, j.first.second, j.second);
            }
            resgetony.clear();
            getony(0, -INF, INF);
            makeony();
            for (auto j : resgetony) {
                anss[{j.first, j.second - 1}].push_back(i.first);
            }
        }
        cout << anss.size() << "\n";
        for (auto &i : anss) {
            cout << i.first.first << " " << i.first.second << " ";
            int cnty = 0;
            for (int j : i.second) {
                cnty += cnto[j] - j + 1;
            }
            int foronlydowny = 0;
            cout << cnty << " " << foronlydowny;
            cout << "\n";
        }
        cout << "\n";
    }
}
