#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#pragma GCC optimize("O3,Ofast,unroll-loops")
using namespace std;
using ll = long long;

const ll MAXN = ll(1e5) + 7;
const long long INF = (long long)(1e9) + 7;

ll n;
map <ll, vector<pair<pair<ll, ll>, ll>>> rect;


struct Vert {
    ll dmin, dmax, dadd;
    ll l, r;
};
vector <Vert> d;
ll addnullVert() {
    Vert e;
    e.dmin = 0;
    e.dmax = 0;
    e.dadd = 0;
    e.l = -1;
    e.r = -1;
    d.push_back(e);
    return d.size() - 1;
}
void dpush(ll v, ll l, ll r) {
    if (l + 1 != r) {
        if (d[v].l == -1) {
            d[v].l = addnullVert();
        }
        if (d[v].r == -1) {
            d[v].r = addnullVert();
        }
        d[d[v].l].dadd += d[v].dadd;
        d[d[v].l].dmin += d[v].dadd;
        d[d[v].l].dmax += d[v].dadd;
        d[d[v].r].dadd += d[v].dadd;
        d[d[v].r].dmin += d[v].dadd;
        d[d[v].r].dmax += d[v].dadd;
    }
    d[v].dadd = 0;
}
void addnew(ll v, ll l, ll r, ll Ql, ll Qr, ll e) {
    if (Qr <= l || Ql >= r) {
        return;
    }
    if (Ql <= l && r <= Qr) {
        d[v].dmin += e;
        d[v].dmax += e;
        d[v].dadd += e;
    } else {
        ll m = l + (r - l) / 2;
        dpush(v, l, r);
        addnew(d[v].l, l, m, Ql, Qr, e);
        addnew(d[v].r, m, r, Ql, Qr, e);
        d[v].dmin = min(d[d[v].l].dmin, d[d[v].r].dmin);
        d[v].dmax = max(d[d[v].l].dmax, d[d[v].r].dmax);
    }
}
vector <pair<ll, ll>> resgetony;
void getony(ll v, ll l, ll r) {
    if (d[v].dmax == 0) {
        return;
    }
    if (d[v].dmin != 0) {
        resgetony.push_back({l, r});
        return;
    }
    ll m = l + (r - l) / 2;
    dpush(v, l, r);
    getony(d[v].l, l, m);
    getony(d[v].r, m, r);
}
void makeony() {
    vector <pair<ll, ll>> resgetonyold;
    ll last = -INF;
    for (auto i : resgetony) {
        if (i.first == last) {
            resgetonyold.back().second = i.second;
        } else {
            resgetonyold.push_back({i.first, i.second});
        }
        last = i.second;
    }
    swap(resgetony, resgetonyold);
}



map <pair<ll, ll>, vector<ll>> anss;
vector <pair<ll, ll>> acans;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll _;
    cin >> _;
    for (ll __ = 0; __ < _; ++__) {
        d.clear();
        addnullVert();
        anss.clear();
        cin >> n;
        rect.clear();
        for (ll i = 0; i < n; ++i) {
            ll x1,y1,x2,y2;
            cin >> x1 >> y1 >> x2 >> y2;
            rect[y1].push_back({{x1, x2 + 1}, 1});
            rect[y2 + 1].push_back({{x1, x2 + 1}, -1});
        }
        ll indi = -INF;
        map <ll, ll> cnto;
        for (auto &i : rect) {
            cnto[indi] = i.first - 1;
            indi = i.first;
            for (auto &j : i.second) {
                addnew(0, -INF, INF, j.first.first, j.first.second, j.second);
            }
            resgetony.clear();
            getony(0, -INF, INF);
            makeony();
            for (auto j : resgetony) {
                anss[{j.first, j.second - 1}].push_back(i.first);
            }
        }
        cout << anss.size() << "\n";
        for (auto &i : anss) {
            cout << i.first.first << " " << i.first.second << " ";
            ll cnty = 0;
            ll last = -INF;
            acans.clear();
            for (ll j : i.second) {
                if (j == last) {
                    acans.back().second = cnto[j] + 1;
                } else {
                    acans.push_back({j, cnto[j] + 1});
                }
                last = cnto[j] + 1;
                cnty += cnto[j] - j + 1;
            }
            pair <ll, ll> acc = *max_element(acans.begin(), acans.end(), [](auto i, auto j) {
                return i.second - i.first < j.second - j.first;
            });
            cout << cnty << " " << acc.second - acc.first;
            cout << "\n";
        }
        cout << "\n";
    }
}
