#include <bits/stdc++.h>
using namespace std;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;

const int INF = 1e9 + 10;
int R;

struct stree {
    struct node {
        pii mn = {0, 0};
        int push = 0;
    };

    vector<node> t;

    stree(int n) {
        R = 1;
        while (R < n)
            R <<= 1;
        t.assign(R * 2, {});
        for (int i = 0; i < n; ++i)
            t[R + i].mn.second = i;
        for (int i = R - 1; i > 0; --i)
            t[i].mn.second = t[i << 1].mn.second;
    }

    void push(int v) {
        if (t[v].push != 0) {
            t[v << 1].mn.first += t[v].push;
            t[v << 1].push += t[v].push;
            t[(v << 1) | 1].mn.first += t[v].push;
            t[(v << 1) | 1].push += t[v].push;
            t[v].push = 0;
        }
    }

    void update(int ql, int qr, int x, int v = 1, int l = 0, int r = R) {
        if (ql >= r || l >= qr)
            return;
        if (ql <= l && r <= qr) {
            t[v].mn.first += x;
            t[v].push += x;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        update(ql, qr, x, (v << 1), l, m);
        update(ql, qr, x, ((v << 1) | 1), m, r);
        t[v].mn = min(t[v << 1].mn, t[(v << 1) | 1].mn);
    }

    pii get_min(int ql, int qr, int v = 1, int l = 0, int r = R) {
        if (ql >= r || l >= qr)
            return {INF, 0};
        if (ql <= l && r <= qr)
            return t[v].mn;
        push(v);
        int m = (l + r) / 2;
        return min(get_min(ql, qr, (v << 1), l, m), get_min(ql, qr, ((v << 1) | 1), m, r));
    }
};

struct S {
    int x1, x2, y1, y2;
    S(int x1 = 0, int x2 = 0, int y1 = 0, int y2 = 0): x1(x1), x2(x2), y1(y1), y2(y2) {}
};

void solve() {
    int n;
    cin >> n;
    vector<S> a(n);
    vi y(n + n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        ++a[i].y2;
        y[i] = a[i].y1;
        y[n + i] = a[i].y2;
    }
    sort(all(y));
    y.resize(unique(all(y)) - y.begin());
    y.push_back(y.back() + 1);
    map<pii, vector<pii>> ans;
    for (int i = 0; i < n; ++i) {
        a[i].y1 = lower_bound(all(y), a[i].y1) - y.begin();
        a[i].y2 = lower_bound(all(y), a[i].y2) - y.begin();
        ans[{a[i].x1, a[i].x2}].emplace_back(a[i].y1, a[i].y2);
    }
    cout << ans.size() << '\n';
    for (auto [p, v]: ans) {
        cout << p.first << ' ' << p.second << ' ';
        sort(all(v));
        int d = y[v[0].second] - y[v[0].first], mx = d, u = d;
        for (int i = 1; i < (int)v.size(); ++i) {
            if (v[i].first > v[i - 1].second) {
                mx = max(mx, d);
                d = 0;
            }
            d += y[v[i].second] - y[v[i].first];
            u += y[v[i].second] - y[v[i].first];
        }
        mx = max(mx, d);
        cout << u << ' ' << mx << '\n';
    }
}

int main() {
    fast;
    int ts;
    cin >> ts;
    while (ts--)
        solve();
}
