#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int, int>> rects(n);
    vector<int> xs, ys;
    for (auto& [x1, x2, y1, y2] : rects) {
        cin >> x1 >> y1 >> x2 >> y2;
        xs.push_back(x1);
        xs.push_back(x2 + 1);
        ys.push_back(y2);
    }
    sort(ys.begin(), ys.end());
    ys.resize(unique(ys.begin(), ys.end()) - ys.begin());
    map<int, int> xcomp, ycomp;
    for (int i = 0; i < xs.size(); ++i)
        xcomp[xs[i]] = i;
    for (int i = 0; i < ys.size(); ++i)
        ycomp[ys[i]] = i;
    vector<vector<pair<int, int>>> op(ys.size());
    for (auto& [x1, x2, y1, y2] : rects) {
        y2 = ycomp[y2];
        op[y2].push_back({ x1, x2 + 1 });
    }
    vector<tuple<int, int, int, int>> ans;
    set<tuple<int, int, int>> cursegs;
    for (int y = ys.size() - 1; y >= 0; --y) {
        for (auto [xl, xr] : op[y]) {
            auto it = cursegs.upper_bound({ xl, INF, -1 });
            bool flag = 0;
            if (it != cursegs.begin()) {
                it--;
                auto [l, r, h] = *it;
                if (r >= xr)
                    flag = 1;
                if (r < xl)
                    it++;
            }
            if (!flag) {
                int mnl = xl;
                int mxr = xr;
                vector<tuple<int, int, int>> to_rem;
                while (it != cursegs.end()) {
                    auto [l, r, h] = *it;
                    if (l > xr)
                        break;
                    mnl = min(mnl, l);
                    mxr = max(mxr, r);
                    to_rem.push_back({ l, r, h });
                    if (h != ys[y])
                        ans.push_back({ l, r - 1, h - ys[y], h - ys[y] });
                    ++it;
                }
                for (auto el : to_rem)
                    cursegs.erase(el);
                cursegs.insert({ mnl, mxr, ys[y] });
            }
        }
    }
    auto it = cursegs.begin();
    while (it != cursegs.end()) {
        auto [l, r, h] = *it;
        ans.push_back({ l, r - 1, h, h });
        ++it;
    }
    sort(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for (auto [a, b, c, d] : ans)
        cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}