#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,unroll-loops,inline,fast-math")
#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int, int>> rects(n);
    vector<int> xs, ys;
    for (auto& [x1, x2, y1, y2] : rects) {
        cin >> x1 >> y1 >> x2 >> y2;
        xs.push_back(x1);
        xs.push_back(x2 + 1);
        ys.push_back(y1);
        ys.push_back(y2 + 1);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    sort(ys.begin(), ys.end());
    ys.resize(unique(ys.begin(), ys.end()) - ys.begin());
    map<int, int> xcomp, ycomp;
    for (int i = 0; i < xs.size(); ++i)
        xcomp[xs[i]] = i;
    for (int i = 0; i < ys.size(); ++i)
        ycomp[ys[i]] = i;
    vector<vector<pair<int, int>>> op(ys.size()), cl(ys.size());
    for (auto& [x1, x2, y1, y2] : rects) {
        x1 = xcomp[x1], x2 = xcomp[x2 + 1], y1 = ycomp[y1], y2 = ycomp[y2 + 1];
        op[y1].push_back({ x1, x2 });
        cl[y2].push_back({ x1, x2 });
    }
    vector<int> cnt(xs.size());
    map<pair<int, int>, int> tot, curcont, maxcont;
    multiset<int> ls, rs;
    int lastl = -1, lastr = -1;
    for (int y = 0; y < ys.size(); ++y) {
        for (auto [xl, xr] : op[y]) {
            ls.insert(xl);
            rs.insert(xr);
        }
        for (auto [xl, xr] : cl[y]) {
            ls.extract(xl);
            rs.extract(xr);
        }
        if (ls.empty())
            continue;
        int newl = *ls.begin(), newr = *rs.rbegin();
        if (newl != lastl || newr != lastr)
            curcont[{lastl, lastr}] = 0;

        int ny = (y + 1 < ys.size() ? ys[y + 1] : 0);
        tot[{newl, newr}] += ny - ys[y];
        curcont[{newl, newr}] += ny - ys[y];
        maxcont[{newl, newr}] = max(maxcont[{newl, newr}], curcont[{newl, newr}]);
        lastl = newl, lastr = newr;
    }
    cout << tot.size() << '\n';
    for (auto& [key, val] : tot) {
        auto [xl, xr] = key;
        cout << xl << ' ' << xr - 1 << ' ' << val << ' ' << maxcont[{xl, xr}] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}