#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int m, n;
vector<string> field;
map<char, tuple<int, int, int>> directions = {
	{'L', {0, -1, 0}},
	{'R', {0, 1, 1}},
	{'U', {-1, 0, 2}},
	{'D', {1, 0, 3}}
};
map<char, pair<int, int>> ordering;
int timer = 0;
vector<vector<int>> used;
bool move_place(int y, int x, int dy, int dx) {
	used[y][x] = timer;
	if (field[y][x] == '.') return false;
	int ny = y + dy;
	int nx = x + dx;
	if (0 <= ny && ny < m && 0 <= nx && nx < n) {
		if (used[ny][nx] != timer)
			move_place(ny, nx, dy, dx);
		if (field[ny][nx] == '.') {
			swap(field[y][x], field[ny][nx]);
			return true;
		}
	}
	return false;
}

void move(int dy, int dx) {
	while (true) {
		bool moved = false;
		for (int y = 0; y < m; y++) {
			for (int x = 0; x < n; x++) {
				if (used[y][x] == timer) continue;
				if (move_place(y, x, dy, dx)) moved = true;
			}
		}
		timer++;
		if (!moved) break;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		cin >> m >> n;
		field.resize(m);
		used.resize(m, vector<int>(n, -1));
		for (string &s: field) {
			cin >> s;
		}
		string q;
		cin >> q;
		for (char d: q) {
			auto [dy, dx, pipa] = directions[d];
			move(dy, dx);
		}
		for (int y = 0; y < m; y++) {
			cout << field[y] << endl;
		}
		field.clear();
		used.clear();
	}
}