#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int m, n;

int empty_spot = '.';

template<typename T>
void move(char d, vector<T> &field) {
	if (d == 'U' || d == 'D') {
		vector<T> columns(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (field[j][i] != empty_spot)
					columns[i].push_back(field[j][i]);
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				field[i][j] = empty_spot;
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < columns[i].size(); j++) {
				if (d == 'U')
					field[j][i] = columns[i][j];
				else
					field[m-j-1][i] = columns[i][columns[i].size() - j - 1];
			}
		}
	}
	else {
		vector<T> rows(m);
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				if (field[i][j] != empty_spot) 
					rows[i].push_back(field[i][j]);
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				field[i][j] = empty_spot;
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < rows[i].size(); j++) {
				if (d == 'L') {
					field[i][j] = rows[i][j];
				}
				else {
					field[i][n-j-1] = rows[i][rows[i].size() - j - 1];
				}
			}
		}
	}
}

void output(vector<string> &field) {
	for (int i = 0; i < field.size(); i++) {
		cout << field[i] << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		cin >> m >> n;
		vector<string> field(m);
		for (string &s: field) {
			cin >> s;
		}
		string q;
		cin >> q;
		string actual;
		int i;
		bool right;
		bool up;
		if (q[0] == 'L' || q[0] == 'R') {
			bool side;
			for (i = 0; i < q.size(); i++) {
				if (q[i] == 'L' || q[i] == 'R') {
					side = (q[i] == 'R');
				}
				else {
					break;
				}
			}
			right = side;
			if (side) {
				move('R', field);
			}
			else {
				move('L', field);
			}
			if (i == q.size()) {
				output(field);
				continue;
			}
			for (; i < q.size(); i++) {
				if (q[i] == 'D' || q[i] == 'U') {
					side = (q[i] == 'U');
				}
				else {
					break;
				}
			}
			up = side;
			if (side) {
				move('U', field);
			}
			else {
				move('D', field);
			}
			if (i == q.size()) {
				output(field);
				continue;
			}
		}
		else {
			bool side;
			for (i = 0; i < q.size(); i++) {
				if (q[i] == 'D' || q[i] == 'U') {
					side = (q[i] == 'U');
				}
				else {
					break;
				}
			}
			up = side;
			if (side) {
				move('U', field);
			}
			else {
				move('D', field);
			}
			if (i == q.size()) {
				output(field);
				continue;
			}
			for (; i < q.size(); i++) {
				if (q[i] == 'L' || q[i] == 'R') {
					side = (q[i] == 'R');
				}
				else {
					break;
				}
			}
			right = side;
			if (side) {
				move('R', field);
			}
			else {
				move('L', field);
			}
			if (i == q.size()) {
				output(field);
				continue;
			}
		}
		for (; i < q.size(); i++) {
			if (q[i] == 'D') {
				if (!up) continue;
				if (!actual.empty() && actual.back() == 'U') actual.pop_back();
				else actual.push_back('D');
			}
			else if (q[i] == 'U') {
				if (up) continue;
				if (!actual.empty() && actual.back() == 'D') actual.pop_back();
				else actual.push_back('U');
			}
			else if (q[i] == 'R') {
				if (right) continue;
				if (!actual.empty() && actual.back() == 'L') actual.pop_back();
				else actual.push_back('R');
			}
			else {
				if (!right) continue;
				if (!actual.empty() && actual.back() == 'R') actual.pop_back();
				else actual.push_back('L');
			}
		}
		for (char d: actual) {
			move(d, field);
		}
		actual.clear();
		for (int y = 0; y < m; y++) {
			cout << field[y] << endl;
		}
		field.clear();
	}
}