#include <bits/stdc++.h>

using namespace std;

void print(int n, int m, vector<vector<int>> grid) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (grid[i][j] == -1) {
                cout << '.';
            } else {
                cout << (char)('a' + grid[i][j]);
            }
        }
        cout << "\n";
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> grid(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            grid[i][j] = -1;
        }
    }
    for (int i = 0; i < n; i++) {
        string row;
        cin >> row;
        for (int j = 0; j < m; j++) {
            if (row[j] != '.') {
                grid[i][j] = row[j] - 'a';
            }
        }
    }
    string query;
    cin >> query;
    for (char q : query) {
        vector<vector<int>> new_grid(n, vector<int>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                new_grid[i][j] = -1;
            }
        }
        if (q == 'L' || q == 'R') {
            vector<vector<int>> rows(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (grid[i][j] != -1) {
                        rows[i].push_back(grid[i][j]);
                    }
                }
            }
            if (q == 'L') {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < rows[i].size(); j++) {
                        new_grid[i][j] = rows[i][j];
                    }
                }
            } else {
                for (int i = 0; i < n; i++) {
                    reverse(rows[i].begin(), rows[i].end());
                    for (int j = 0; j < rows[i].size(); j++) {
                        new_grid[i][m - j - 1] = rows[i][j];
                    }
                }   
            }
        } else {
            vector<vector<int>> cols(m);
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (grid[i][j] != -1) {
                        cols[j].push_back(grid[i][j]);
                    }
                }
            }
            if (q == 'U') {
                for (int i = 0; i < m; i++) {
                    for (int j = 0; j < cols[i].size(); j++) {
                        new_grid[j][i] = cols[i][j];
                    }
                }
            } else {
                for (int i = 0; i < m; i++) {
                    reverse(cols[i].begin(), cols[i].end());
                    for (int j = 0; j < cols[i].size(); j++) {
                        new_grid[n - j - 1][i] = cols[i][j];
                    }
                }
            }
        }
        grid = new_grid;
    }
    print(n, m, grid);
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}