#include <bits/stdc++.h>

using namespace std;

void print(int n, int m, vector<vector<int>> grid) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (grid[i][j] == -1) {
                cout << '.';
            } else {
                cout << (char)('a' + grid[i][j]);
            }
        }
        cout << "\n";
    }
}

int get_dir(char dir) {
    if (dir == 'L' || dir == 'R') return 0;
    return 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> grid(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            grid[i][j] = -1;
        }
    }
    for (int i = 0; i < n; i++) {
        string row;
        cin >> row;
        for (int j = 0; j < m; j++) {
            if (row[j] != '.') {
                grid[i][j] = row[j] - 'a';
            }
        }
    }
    string query;
    cin >> query;
    int first_dir = get_dir(query[0]);
    vector<vector<int>> ans_rows, ans_cols;
    char lastLR = '0', lastUD = '0';
    bool found = false;
    bool is_rows = false;
    for (char q : query) {
        if (get_dir(q) == first_dir || found) {
            if (q == 'L' || q == 'R') lastLR = q;
            else
                lastUD = q;
            continue;
        }
        if (q == 'U' || q == 'D') {
            vector<vector<int>> rows(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (grid[i][j] != -1) {
                        rows[i].push_back(grid[i][j]);
                    }
                }
            }
            if (lastLR == 'L') {
                vector<vector<int>> new_grid(n, vector<int>(m));
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        new_grid[i][j] = -1;
                    }
                }
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < rows[i].size(); j++) {
                        new_grid[i][j] = rows[i][j];
                    }
                }
                grid = new_grid;
            } else if (lastLR == 'R') {
                vector<vector<int>> new_grid(n, vector<int>(m));
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        new_grid[i][j] = -1;
                    }
                }
                for (int i = 0; i < n; i++) {
                    reverse(rows[i].begin(), rows[i].end());
                    for (int j = 0; j < rows[i].size(); j++) {
                        new_grid[i][m - j - 1] = rows[i][j];
                    }
                }
                grid = new_grid;
            }
            vector<vector<int>> cols(m);
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (grid[i][j] != -1) {
                        cols[j].push_back(grid[i][j]);
                    }
                }
            }
            vector<vector<int>> new_grid(n, vector<int>(m));
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    new_grid[i][j] = -1;
                }
            }
            if (q == 'U') {
                for (int i = 0; i < m; i++) {
                    for (int j = 0; j < cols[i].size(); j++) {
                        new_grid[j][i] = cols[i][j];
                    }
                }
            } else {
                for (int i = 0; i < m; i++) {
                    reverse(cols[i].begin(), cols[i].end());
                    for (int j = 0; j < cols[i].size(); j++) {
                        new_grid[n - j - 1][i] = cols[i][j];
                    }
                }
            }
            grid = new_grid;
            vector<vector<int>> new_rows(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (grid[i][j] != -1) {
                        new_rows[i].push_back(grid[i][j]);
                    }
                }
            }
            if (q == 'D') reverse(new_rows.begin(), new_rows.end());
            rows = new_rows;
            found = true;
            ans_rows = rows;
            is_rows = true;
        } else {
            vector<vector<int>> cols(m);
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (grid[i][j] != -1) {
                        cols[j].push_back(grid[i][j]);
                    }
                }
            }
            if (lastUD == 'U') {
                vector<vector<int>> new_grid(n, vector<int>(m));
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        new_grid[i][j] = -1;
                    }
                }
                for (int i = 0; i < m; i++) {
                    for (int j = 0; j < cols[i].size(); j++) {
                        new_grid[j][i] = cols[i][j];
                    }
                }
                grid = new_grid;
            } else if (lastUD == 'D') {
                vector<vector<int>> new_grid(n, vector<int>(m));
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        new_grid[i][j] = -1;
                    }
                }
                for (int i = 0; i < m; i++) {
                    reverse(cols[i].begin(), cols[i].end());
                    for (int j = 0; j < cols[i].size(); j++) {
                        new_grid[n - j - 1][i] = cols[i][j];
                    }
                }
                grid = new_grid;
            }
            vector<vector<int>> rows(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (grid[i][j] != -1) {
                        rows[i].push_back(grid[i][j]);
                    }
                }
            }
            vector<vector<int>> new_grid(n, vector<int>(m));
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    new_grid[i][j] = -1;
                }
            }
            if (q == 'L') {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < rows[i].size(); j++) {
                        new_grid[i][j] = rows[i][j];
                    }
                }
            } else {
                for (int i = 0; i < n; i++) {
                    reverse(rows[i].begin(), rows[i].end());
                    for (int j = 0; j < rows[i].size(); j++) {
                        new_grid[i][m - j - 1] = rows[i][j];
                    }
                }
            }
            grid = new_grid;
            vector<vector<int>> new_cols(m);
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (grid[i][j] != -1) {
                        new_cols[j].push_back(grid[i][j]);
                    }
                }
            }
            if (q == 'R') reverse(new_cols.begin(), new_cols.end());
            cols = new_cols;
            ans_cols = cols;
            found = true;
        }
    }
    vector<vector<int>> new_grid(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            new_grid[i][j] = -1;
        }
    }
    if (is_rows) {
        if (lastUD == 'D') reverse(ans_rows.begin(), ans_rows.end());
        for (int i = 0; i < n; i++) {
            if (lastLR == 'R') reverse(ans_rows[i].begin(), ans_rows[i].end());
            for (int j = 0; j < ans_rows[i].size(); j++) {
                if (lastLR == 'L') {
                    new_grid[i][j] = ans_rows[i][j];
                } else {
                    new_grid[i][m - j - 1] = ans_rows[i][j];
                }
            }
        }
    } else {
        if (lastLR == 'R') reverse(ans_cols.begin(), ans_cols.end());
        for (int i = 0; i < m; i++) {
            if (lastUD == 'D') reverse(ans_cols[i].begin(), ans_cols[i].end());
            for (int j = 0; j < ans_cols[i].size(); j++) {
                if (lastUD == 'U') {
                    new_grid[j][i] = ans_cols[i][j];
                } else {
                    new_grid[n - j - 1][i] = ans_cols[i][j];
                }
            }
        }
    }
    grid = new_grid;
    print(n, m, grid);
}

// ПРИВЕТ, МАМ!!!!!!!!!!!!!!!!!!!!!

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
        // return 0;
    }
}