#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct edge {
    int u, c, id;

    edge(const int u = 0, const int c = 0, const int id = 0) : u(u), c(c), id(id) {}
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<int> color(m);
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        color[i] = c;
        g[v].emplace_back(u, c, i);
        g[u].emplace_back(v, c, i);
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int v = 0; v < n; v++) {
        for (auto &[u, c, id]: g[v]) {
            if (s[v] == s[u] && c != s[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    int k = (1 << (n + m));
    queue<int> q;
    vector<int> dist(k, (int) (1e9)), par(k, -1);
    dist[0] = 0;
    q.emplace(0);
    while (!q.empty()) {
        int mask = q.front();
        q.pop();
        for (int i = 0; i < n; i++) {
            int nmask = mask;
            if ((mask >> i) & 1) {
                nmask -= (1 << i);
                for (auto &[u, c, id]: g[i]) {
                    if (((mask >> (n + id)) & 1) && !((mask >> u) & 1))
                        nmask -= ((1 << (n + id)));
                }
                if (dist[nmask] > dist[mask] + 1) {
                    dist[nmask] = dist[mask] + 1;
                    par[nmask] = mask;
                    q.emplace(nmask);
                }
            } else {
                nmask += (1 << i);
                for (auto &[u, c, id]: g[i]) {
                    if (((mask >> (n + id)) & 1) || !((mask >> u) & 1)) {}
                    else
                        nmask += ((1 << (n + id)));
                    //cout << "EDGE: " << i << ' ' << u << ' ' << ((mask >> (n + id)) & 1) << ' ' << (!((mask >> u) & 1))
                    //     << ' ' << mask << ' '
                    //     << nmask << endl;
                }
                if (dist[nmask] > dist[mask] + 1) {
                    dist[nmask] = dist[mask] + 1;
                    par[nmask] = mask;
                    q.emplace(nmask);
                }
            }
        }
    }
    vector<pair<int, int>> way;
    int en = 0;
    for (int i = 0; i < n; i++)
        if (s[i] == 1)
            en += (1 << i);
    for (int i = 0; i < m; i++)
        if (color[i] == 1)
            en += (1 << (n + i));
    if (dist[en] == (int) (1e9)) {
        cout << "NO\n";
        return;
    }
    for (; en != 0; en = par[en]) {
//        for (int i = 0; i < n; i++) {
//            if ((en >> i) & 1)
//                cout << i << ' ';
//        }
//        cout << "; ";
//        for (int i = 0; i < m; i++)
//            if ((en >> (i + n)) & 1)
//                cout << i << ' ';
//        cout << endl;
        int pr = par[en];
        for (int i = 0; i < n; i++) {
            if (((en >> i) & 1) && !((pr >> i) & 1)) {
                way.emplace_back(i, 1);
            } else if (!((en >> i) & 1) && ((pr >> i) & 1)) {
                way.emplace_back(i, 0);
            }
        }
    }
    reverse(way.begin(), way.end());
    cout << "YES\n";
    cout << (int) way.size() << '\n';
    for (auto &[v, c]: way)
        cout << v + 1 << ' ' << c << '\n';
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
