#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct edge {
    int u, c;

    edge(const int u = 0, const int c = 0) : u(u), c(c) {}
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        g[v].emplace_back(u, c);
        g[u].emplace_back(v, c);
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int v = 0; v < n; v++) {
        for (auto &[u, c]: g[v]) {
            if (s[v] == s[u] && c != s[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    vector<pair<int, int>> way;
    vector<bool> cur(n, false);
    for (int v = 0; v < n; v++) {
        for (auto &[u, c]: g[v]) {
            if (c == 0)
                continue;
            if (!cur[u])
                way.emplace_back(u, 1);
            if (!cur[v])
                way.emplace_back(v, 1);
            cur[v] = cur[u] = true;
        }
    }
    for (int v = n - 1; v >= 0; v--) {
        if (s[v] == 0 && cur[v])
            way.emplace_back(v, 0);
    }
    cout << "YES\n";
    cout << (int) way.size() << '\n';
    for (auto &[v, c]: way)
        cout << v + 1 << ' ' << c << '\n';
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
