#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <vector>
using namespace std;
#define int long long
#define maxn 100000ll
#define MX (maxn + 1)
int n, m;
int a[maxn], b[maxn], c[maxn], d[maxn];
bool check_1() {
    for (int i = 0; i < m; i++) {
        if (d[a[i]] && d[b[i]] && !c[i]) {
            return false;
        }
        if (!d[a[i]] && !d[b[i]] && c[i]) {
            return false;
        }
    }
    return true;
}
int din[maxn], dout[maxn];
vector<int> E[maxn];
void set_con() {
    for (int i = 0; i < n; i++) {
        din[i] = 0, dout[i] = 0;
        E[i].clear();
    }
    for (int i = 0; i < m; i++) {
        if (d[a[i]] == d[b[i]]) {
            continue;
        }
        if (!d[a[i]]) {
            swap(a[i], b[i]);
        }
        if (c[i]) {
            din[b[i]]++; dout[a[i]]++;
            E[a[i]].push_back(b[i]);
        } else {
            din[a[i]]++; dout[b[i]]++;
            E[b[i]].push_back(a[i]);
        }
    }
}
bool used[maxn];
bool dfs(int i, int p) {
    used[i] = true;
    for (int j : E[i]) {
        if (j == p) {
            continue;
        }
        if (used[j]) {
            return false;
        }
        if (!dfs(j, i)) {
            return false;
        }
    }
    return true;
}
bool check_2() {
    for (int i = 0; i < n; i++) {
        used[i] = false;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (!dfs(i, -1)) {
                return false;
            }
        }
    }
    return true;
}
vector<pair<int, int>> s;
int in[maxn];
void solve() {
    s.clear();
    vector<int> pr, cr;
    for (int i = 0; i < n; i++) {
        in[i] = 0;
        if (in[i] == din[i]) {
            pr.push_back(i);
        }
    }
    while (!pr.empty()) {
        for (int i : pr) {
            if (d[i]) {
                s.emplace_back(i, 1);
            } else {
                s.emplace_back(i, 1);
                s.emplace_back(i, 0);
            }
            for (int j : E[i]) {
                in[j]++;
                if (in[j] == din[j]) {
                    cr.push_back(j);
                }
            }
        }
        pr = cr;
        cr.clear();
    }
    cout << "YES" << endl;
    cout << s.size() << endl;
    for (auto [v, x] : s) {
        cout << v + 1 << ' ' << x << endl;
    }
}
signed main() {
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < m; i++) {
            cin >> a[i] >> b[i] >> c[i]; a[i]--; b[i]--;
        }
        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }
        set_con();
        if (!check_1() || !check_2()) {
            cout << "NO" << endl;
            continue;
        }
        solve();
    }
}