#include "bits/stdc++.h"

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int infll = 1e18 + 10;

const int N = 2e5 + 10;
vector<pair<int, int>> g[N];

map<pair<int, int>, int> edges;
int n, m;
int s[N];
int d[N];

deque<int> actions[N];

vector<pair<int, int>> ans;

void dfs (int u, int p = -1) {

    for (auto x : g[u]) {
        int v = x.first, c = x.second;
        if (v == p) continue;
        dfs(v, u);
    }
}

const int K = 2e5 + 10;

vector<int> r[K];

int color[N];

bool ok = true;

void dfs2 (int u, int p = -1) {
    color[u] = 1;
    for (auto v : r[u]) {
        if (v == p) continue;
        if (!ok) return;
        if (!color[v]) {
            dfs2(v, u);
        } else if (color[v] == 1) {
            ok = false;
            return;
        } else {
            continue;
        }
    }
    color[u] = 2;
}

void solve() {
    cin >> n >> m;
    ok = true;

    edges.clear();

    for (int i = 0; i < max(n, m); i++) {
        r[i].clear();
    }

    fill(s, s + n, 0);
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }

    vector<int> z;

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--;v--;
        z.push_back(c);
        g[u].push_back({v, c});
        g[v].push_back({u, c});
        edges[{u, v}] = i;
        edges[{v, u}] = i;
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    for (int i = 0; i < n; i++) {
        for (auto x : g[i]) {
            if (d[i] == 0 && d[x.first] == 0 && x.second == 1) {
                cout << "NO\n";
                return;
            }
            if (d[i] == 1 && d[x.first] == 1 && x.second == 0) {
                cout << "NO\n";
                return;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (auto x : g[i]) {
            int v = x.first, c = x.second;
            for (auto t : g[v]) {
                int vv = t.first, cc = t.second;
                if (c != cc) {
                    r[edges[{i, v}]].push_back({edges[{vv, v}]});
                    r[edges[{vv, v}]].push_back(edges[{i, v}]);
                }
            }
        }
    }

    fill(color, color + m, 0);

    for (int i = 0; i < m; i++) {
        if (color[i] == 0) {
            dfs2(i);
        }
    }

    if (!ok) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";
    cout << "-1\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}