#include "bits/stdc++.h"

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int infll = 1e18 + 10;

const int N = 1e5 + 10;
vector<pair<int, int>> g[N];
vector<int> t[N];

vector<vector<int>> edges;

int n, m;
int s[N];
int d[N];
int col[N];
bool ok = true;

vector<int> order;

void dfs (int u) {
    col[u] = 1;

    for (auto v : t[u]) {
        if (!ok) return;
        if (!col[v]) {
            dfs(v);
        } else if (col[v] == 1) {
            ok = false;
            return;
        }
    }

    col[u] = 2;
    order.push_back(u);
}

void solve() {
    cin >> n >> m;

    ok = true;
    order.clear();
    edges.clear();
    fill(s, s + n, 0);
    for (int i = 0; i < n; i++) {
        g[i].clear();
        t[i].clear();
    }

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--;v--;
        edges.push_back({u, v, c});
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    fill(col, col + n, 0);

    for (int i = 0; i < n; i++) {
        for (auto x : g[i]) {
            if (d[i] == 0 && d[x.first] == 0 && x.second == 1) {
                cout << "NO\n";
                return;
            }
            if (d[i] == 1 && d[x.first] == 1 && x.second == 0) {
                cout << "NO\n";
                return;
            }
        }
    }

    for (int i = 0; i < m; i++) {
        int u = edges[i][0], v = edges[i][1];
        if (d[u] == d[v] && d[u] == edges[i][2]) continue;
        if (d[u] == edges[i][2]) {
            t[u].push_back(v);
        } else {
            t[v].push_back(u);
        }
    }

    for (int i = 0; i < n; i++) {
        if (!col[i]) {
            dfs(i);
        }
    }

    reverse(all(order));

    vector<int> ind(n, 0);
    for (int i = 0; i < n; i++) {
        ind[order[i]] = i;
    }

    vector<vector<int>> actions;

    for (auto u : order) {
        for (auto x : g[u]) {
            int v = x.first, c = x.second;
            if (ind[v] < ind[u]) {
                actions.push_back({u, c});
                actions.push_back({v, c});
            }
        }
    }

    for (int i = 0; i < n; i++) {
        actions.push_back({i, d[i]});
    }

    if (!ok) {
        cout << "NO\n";
        return;
    }

    reverse(all(order));

    cout << "YES\n";

    for (auto v : actions) {
        cout << v[0] + 1 << " " << v[1] << endl;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}