#include <bits/stdc++.h>
using namespace std;
#define vec vector
#define ll long long
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)
#ifdef DEBUG
  #define debug if(1)
#else
  #define debug if(0)
#endif

struct edg {
  int ai, bi;
  bool tgt;
};

vec<vec<int>> G;
vec<bool> vx_tgt;
vec<pair<int, int>> cmds;
vec<int> cnt;
vec<bool> done;
int used = 0;

bool dfs(int vx, bool hp = false) {
  if (done[vx])
    return true;
  if (cnt[vx] > 0)
    return false;
  done[vx] = true;
  ++used;
  if (vx_tgt[vx] || hp) {
    cmds.push_back({vx, 1});
    if (!vx_tgt[vx])
      cmds.push_back({vx, 0});
  }
  for (auto i : G[vx]) {
    --cnt[i];
    if (dfs(i, true))
      return true;
  }
  return false;
}

void solve () {
  int n, m; cin >> n >> m;
  vec<edg> edgs(m);
  forn(i, m) {
    cin >> edgs[i].ai >> edgs[i].bi >> edgs[i].tgt;
    --edgs[i].ai; --edgs[i].bi;
  }
  vx_tgt.resize(n);
  G.clear();
  G.resize(n);
  cmds.clear();
  cnt.assign(n, 0);
  done.assign(n, false);
  forn(i, n) {
    int v;
    cin >> v;
    vx_tgt[i] = v;
  }

  for (auto [ai, bi, tgt] : edgs) {
    if (vx_tgt[ai] == vx_tgt[bi] && tgt != vx_tgt[ai]) {
      debug cout << "conn " << ai+1 << " " << bi+1 << " clr " << vx_tgt[ai] << " edge " << tgt << endl;
      cout << "NO" << '\n';
      return;
    } else if (vx_tgt[ai] == vx_tgt[bi] && tgt == vx_tgt[ai])
      continue;
    if (vx_tgt[ai] == tgt)
      G[ai].push_back(bi), ++cnt[bi];
    else
      G[bi].push_back(ai), ++cnt[ai];
  }
  debug {
    forn(i, n) {
      cout << i+1 << " c "<< cnt[i] << " -> ";
      for(auto j : G[i]) cout << j+1 << ' ';
      cout << endl;
    }
  }

  used = 0;
  forn(i, n) {
    if (!done[i] && dfs(i)) { 
      cout << "NO" << '\n';
      debug cout << "loop" << endl;
      return;
    }
  }

  if (used != n) {
    cout << "NO" << '\n';
    debug cout << "loop, not all used" << endl;
    return;
  }

  cout << "YES\n";
  cout << cmds.size() << '\n';
  for (auto [idx, st] : cmds)
    cout << idx+1 << " " << st << '\n';
  debug cout.flush();
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int t; cin >> t;
  forn(i, t)
    solve();
  return 0;
}
