#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

vector<ll> t;
vector<ll> used;


struct edge {
    ll u;
    bool c;
    ll id;

    edge() = default;

    edge(ll u, bool c, ll id) : u(u), c(c), id(id) {}
};

vector<vector<edge>> g;

bool check(ll v = 0) {
    used[v] = true;
    bool can = true;
    for (auto &[u, c, id]: g[v]) {
        if (t[v] == t[u] && t[v] != c) {
            return false;
        }
        if (used[u]) continue;
        can = min(can, check(u));
    }
    return can;
}

vector<pair<ll, bool>> p;
bool can = false;
vector<ll> cur;

vector<ll> col, need;

void dfs(ll v = 0, ll pId = -1) {
    used[v] = 1;
    p.emplace_back(v, !t[v]);
    cur[v] = !t[v];
    for (auto &[u, c, id]: g[v]) {
        if (id == pId) continue;
        if (!used[u]) {
            if (c != cur[v]) continue;
            dfs(u, id);
            col[id] = need[id];
        } else if (used[v] == 1) {
            if (cur[v] == cur[u]) col[id] = cur[v];
        }
    }
    p.emplace_back(v, t[v]);
    cur[v] = t[v];
    for (auto &[u, c, id]: g[v]) {
        if (id == pId) continue;
        if (!used[u]) {
            if (c != cur[v]) continue;
            dfs(u, id);
            col[id] = need[id];
        } else if (used[v] == 1) {
            if (cur[v] == cur[u]) col[id] = cur[v];
        }
    }
    used[v] = 2;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.assign(n, {});
    t.resize(n);
    cur.assign(n, false);
    need.resize(m);
    col.assign(m, 0);
    map <pair <ll, ll>, ll> mp;
    can = true;
    for (ll id = 0; id < m; id++) {
        ll u, v, c;
        cin >> u >> v >> c;
        u--;
        v--;
        if (u > v) swap(u, v);
        if (mp.count({u, v}) && mp[{u, v}] != c) {
            can = false;
            break;
        }
        g[u].emplace_back(v, c, id);
        g[v].emplace_back(u, c, id);
        need[id] = c;
    }
    if (!can) {
        cout << "NO\n";
        return;
    }
    for (auto &it: t) cin >> it;
    used.assign(n, false);
    can = check();
    if (!can) {
        cout << "NO\n";
        return;
    }
    used.assign(n, false);
    p.clear();
    dfs();
    for (ll id = 0; id < m; id++) {
        if (col[id] != need[id]) {
            can = false;
            break;
        }
    }
    if (!can) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n" << p.size() << '\n';
    for (auto &[v, c]: p) {
        cout << v + 1 << ' ' << c << '\n';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll testC;
#ifdef home
    freopen("input.txt", "r", stdin);
#endif
    cin >> testC;
    while (testC--) {
        solve();
    }
    return 0;
}
