#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
typedef long long ll;

const int maxn = 1e5;
int used[maxn], d[maxn];
bool fl = 1;

void dfs(int v, vector<vector<pair<int, int>>>& g) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!fl) return;
		if (u.second == d[v]) {
			if (used[v] == 1) {
				fl = 0;
				return;
			}
			if (used[v] == 0) {
				dfs(u.first, g);
			}
		}
	}
	used[v] = 2;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		fl = 1;
		fill(used, used + n, 0);
		vector<vector<pair<int, int>>> g(n);
		for (int i = 0; i < n; ++i) {
			int a, b, c;
			cin >> a >> b >> c;
			--a;
			--b;
			g[a].push_back({ b, c });
			g[b].push_back({ a, c });
		}
		for (int i = 0; i < n; ++i) {
			cin >> d[i];
		}
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				dfs(i, g);
			}
		}
		if (fl) {
			cout << "YES\n";
			cout << "-1\n";
		}
		else {
			cout << "NO\n";
		}
	}

	return 0;
}