#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
typedef long long ll;

const int maxn = 1e5;
int used[maxn], d[maxn];
bool fl = 1;

void dfs(int v, vector<vector<pair<int, int>>>& g) {
	used[v] = 1;
	if (!fl) return;
	for (auto u : g[v]) {
		if (!fl) return;
		if (u.second == d[v] && d[v] != d[u.first]) {
			if (used[u.first] == 1) {
				fl = 0;
				return;
			}
			if (used[u.first] == 0) {
				dfs(u.first, g);
			}
		}
	}
	used[v] = 2;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		fl = 1;
		fill(used, used + n, 0);
		vector<vector<pair<int, int>>> g(n);
		for (int i = 0; i < m; ++i) {
			int a, b, c;
			cin >> a >> b >> c;
			--a;
			--b;
			g[a].push_back({ b, c });
			g[b].push_back({ a, c });
		}
		for (int i = 0; i < n; ++i) {
			cin >> d[i];
		}
		for (int i = 0; i < n; ++i) {
			for (auto u : g[i]) {
				if (d[i] == d[u.first] && d[u.first] != u.second) {
					fl = 0;
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			if (!fl) break;
			if (!used[i]) {
				dfs(i, g);
				if (!fl) break;
			}
		}
		if (fl) {
			cout << "YES\n";
			vector<pair<int, int>> v;
			vector<vector<int>> x;
			for (int i = 0; i < n; ++i) {
				for (auto u : g[i]) {
					if (u.first > i) {
						x.push_back({ i, u.first, u.second });
					}
				}
			}
			for (int i = 0; i < n; ++i) {
				if (d[i] == 1) {
					v.push_back({ i + 1, 1 });
				}
			}
			for (int i = 0; i < m; ++i) {
				if (d[x[i][0]] != d[x[i][1]] && x[i][2] == 1) {
					if (d[x[i][0]] == 0) {
						v.push_back({x[i][0] + 1, 1});
						v.push_back({ x[i][0] + 1, 0 });
					}
					else {
						v.push_back({ x[i][1] + 1, 1 });
						v.push_back({ x[i][1] + 1, 0 });
					}
				}
			}
			cout << v.size() << '\n';
			for (auto u : v) {
				cout << u.first << ' ' << u.second << '\n';
			}
		}
		else {
			cout << "NO\n";
		}
	}

	return 0;
}