#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;
typedef long long ll;

const int maxn = 1e5;
int used[maxn], d[maxn], cnt[maxn];
bool fl = 1;

void dfs(int v, vector<vector<pair<int, int>>>& g) {
	used[v] = 1;
	if (!fl) return;
	for (auto u : g[v]) {
		if (!fl) return;
		if (u.second == d[v] && d[v] != d[u.first]) {
			if (used[u.first] == 1) {
				fl = 0;
				return;
			}
			if (used[u.first] == 0) {
				dfs(u.first, g);
			}
		}
	}
	used[v] = 2;
}

void dfs1(int v, vector<vector<pair<int, int>>>& g, vector<int>& tt) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (u.second == d[v] && d[v] != d[u.first]) {
			cnt[u.first] += 1;
		}
		if (u.second == d[v] && d[v] != d[u.first] && !used[u.first]) {
			dfs1(u.first, g, tt);
		}
	} 
	tt.push_back(v);
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		fl = 1;
		fill(used, used + n, 0);
		vector<vector<pair<int, int>>> g(n);
		for (int i = 0; i < m; ++i) {
			int a, b, c;
			cin >> a >> b >> c;
			--a;
			--b;
			g[a].push_back({ b, c });
			g[b].push_back({ a, c });
		}
		for (int i = 0; i < n; ++i) {
			cin >> d[i];
		}
		for (int i = 0; i < n; ++i) {
			for (auto u : g[i]) {
				if (d[i] == d[u.first] && d[u.first] != u.second) {
					fl = 0;
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			if (!fl) break;
			if (!used[i]) {
				dfs(i, g);
				if (!fl) break;
			}
		}
		if (fl) {
			cout << "YES\n";
			vector<int> tt;
			fill(used, used + n, 0);
			for (int i = 0; i < n; ++i) {
				if (used[i] == 0) {
					dfs1(i, g, tt);
				}
			}
			vector<pair<int, int>> rs;
			for (int i = 0; i < n; ++i) {
				rs.push_back({ i, 1 });
			}
			for (int i = n - 1; i >= 0; --i) {
				if (d[tt[i]] == 1) continue;
				rs.push_back({ tt[i], 0 });
				for (auto u : g[tt[i]]) {
					if (u.second == d[tt[i]] && d[tt[i]] != d[u.first]) {
						rs.push_back({ u.first, 0 });
						rs.push_back({ u.first, 1 });
					}
				}
			}
			cout << rs.size() << '\n';
			for (auto u : rs) {
				cout << u.first + 1 << ' ' << u.second << '\n';
			}
		}
		else {
			cout << "NO\n";
		}
	}

	return 0;
}