#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

const int maxn = 1e6;

ll fn[maxn + 1];

void upd(int v, ll vl) {
	for (; v <= maxn; v += (v & -v)) {
		fn[v] = max(fn[v], vl);
	}
}

ll get(int v) {
	ll mx = -1;
	for (; v > 0; v -= (v & -v)) {
		mx = max(mx, fn[v]);
	}
	return mx;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);
	fill(fn, fn + maxn + 1, -1);
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n), id(n, -1);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	ll res = n * n * n;
	for (int i = 0; i <= n; ++i) {
		if (i != n) {
			if (x == 0) continue;
			swap(a[i], x);
		}
		fill(fn, fn + n + 1, -1);
		vector<ll> na(n);
		for (int j = 0; j < n; ++j) {
			na[max(0ll, j - a[j])] = max(na[max(0ll, j - a[j])], min(n - 1, j + a[j]));
		}
		for (int j = 1; j < n; ++j) {
			na[j] = max(na[j], na[j - 1]);
		}
		ll ans = 0;
		for (ll j = 0; j < n; ++j) {
			ans += (j - get(n-j) - 1) * (n-j);
			upd(n - na[j], j);
		}
		res = min(res, ans);
		if (i != n) {
			swap(a[i], x);
		}
	}

	cout << res;

	return 0;
}