#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define int long long
#define endl "\n"
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int _TestNum; cin >> _TestNum; while(_TestNum--)


const int INF = 1e18;

struct Vertex {
    int a, b, c;

    Vertex(int _a, int _b, int _c) {
        a = _a;
        b = _b;
        c = _c;
    }
};

int match(int i, string s) {
    int ans = i * 2;
    ans += (s == "on");
    return ans;
}

vector<vector<int>> g;
vector<int> opened;
vector<int> used;

bool cycle = false;
vector<int> topsort;

void dfs(int v) {
    opened[v] = 1;
    used[v] = 1;
    for (auto u: g[v]) {
        if (opened[u]) {
            cycle = true;
            continue;
        }
        if (used[u]) {
            continue;
        }
        dfs(u);
    }
    opened[v] = 0;
    topsort.push_back(v);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    MNOGO {

        int n, m;
        cin >> n >> m;

        vector<Vertex> ver(m, {0, 0, 0});

        for (int i = 0; i < m; i++) {
            cin >> ver[i].a >> ver[i].b >> ver[i].c;
            ver[i].a--;
            ver[i].b--;
        }

        vector<int> d(n, 0);

        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }

        bool canwe = true;

        for (auto [a, b, c]: ver) {
            if (d[a] == d[b] && d[a] != c) {
                canwe = false;
            }
        }

        if (!canwe) {
            cout << "NO" << endl;
            continue;
        }

        g = {};
        g.resize(2 * n);

        for (auto [a, b, c]: ver) {
            if (d[a] == d[b]) {
                continue;
            }
            int v = 0;
            int u = 0;
            if (c == 0) {
                if (d[a] == 1) {
                    v = match(b, "off");
                    u = match(a, "on");
                } else {
                    v = match(a, "off");
                    u = match(b, "on");
                }
            } else {
                if (d[a] == 1) {
                    v = match(a, "on");
                    u = match(b, "off");
                } else {
                    v = match(b, "on");
                    u = match(a, "off");
                }
            }
            g[v].push_back(u);
        }

        for (int i = 0; i < n; i++) {
            int v = match(i, "on");
            int u = match(i, "off");
            g[v].push_back(u);
        }

        opened = {};
        opened.resize(2 * n);

        used = {};
        used.resize(2 * n);

        topsort = {};

        cycle = false;

        for (int i = 0; i < 2 * n; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }

        if (cycle) {
            cout << "NO" << endl;
            continue;
        }

        cout << "YES" << endl;

        reverse(all(topsort));

        vector<pair<int, int>> ans;

        for (auto it: topsort) {
            int i = it / 2;
            int com = it % 2;
            if (d[i] == 1 && com == 0) {

            } else {
                ans.push_back({i + 1, com});
            }
        }

        cout << ans.size() << endl;

        for (auto it: ans) {
            cout << it.ff << " " << it.ss << endl;
        }

    };

}
