#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt")

#define int long long
#define ll long long
#define endl "\n"
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int _TestNum; cin >> _TestNum; while(_TestNum--)


const int INF = 1e18;

struct Req {
    int x, t, r;

    Req(int _x, int _t, int _r) {
        x = _x;
        t = _t;
        r = _r;
    }

    bool operator<(const Req &other) const {
        if (x != other.x) {
            return x < other.x;
        }
        return t > other.t;
    }
};

int bad_solve(int n, int x, vector<int> b) {

    int ans = INF;

    for (int change = -1; change < n; change++) {
        auto a = b;
        if (change != -1) {
            a[change] = x;
        }
        vector<int> max_r(n, 0);

        vector<Req> sl;

        for (int i = 0; i < n; i++) {
            sl.push_back({i - a[i], 1, i + a[i]});
            sl.push_back({i + a[i], -1, i + a[i]});
            sl.push_back({i, 0, 0});
        }

        sort(all(sl));

        multiset<int> st;

        for (auto [pos, t, r]: sl) {
            if (t == 1) {
                st.insert(r);
            } else if (t == -1) {
                st.extract(r);
            } else {
                max_r[pos] = *(st.rbegin());
            }
        }


        int now = 0;

        for (int i = 0; i < n; i++) {
            int now_r = -INF;
            int curr_ans = 0;
            for (int j = i; j < n; j++) {
                if (j > now_r) {
                    if (now_r != -INF) {
                        curr_ans++;
                    }
                    now_r = max_r[j];
                }
                if (i != j) {
                    now += curr_ans;
                }
            }
        }

        ans = min(ans, now);
    }

    return ans;


}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, x;
    cin >> n >> x;

    vector<int> a(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

//    cout << bad_solve(n, x, a) << endl;

    a[n / 2] = x;

    int l1 = 0;
    int l2 = 0;
    int mid = 0;

    for (int i = 0; i < n; i++) {
        if (i < n / 2 - x) {
            l1++;
        } else if (i > n / 2 + x) {
            l2++;
        } else {
            mid++;
        }
    }

    int ans = 0;

    for (int i = 1; i <= l1; i++) {
        ans += i * (l1 - i);
    }

    for (int i = 1; i <= l2; i++) {
        ans += i * (l2 - i);
    }

    for (int i = 1; i <= l1; i++) {
        ans += i * mid;
    }

    for (int i = 1; i <= l2; i++) {
        ans += i * mid;
    }

    for (int i = 2; i <= l1 + l2; i++) {
        ans += i * (min(l1, i - 1) - max(1ll, i - l2) + 1);
    }


    cout << ans << endl;

}
