#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << (x) << '\n'

template <typename T>
ostream &operator<<(ostream &out, vector <T> &a) {
    for (auto &i : a) cout << i << ' ';
    cout << '\n';
    return out;
}

vector <int> tree(262144 * 2);

void upd(int v, int l, int r, int l0) {
    if (l > l0 || r <= l0) return;
    if (r - l == 1) {
        tree[v] = 1;
        return;
    }
    int m = (r + l) / 2;
    upd(2 * v + 1, l, m, l0);
    upd(2 * v + 2, m, r, l0);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int l0, int r0) {
    if (l >= r0 || r <= l0) return 0;
    if (l0 <= l && r <= r0) return tree[v];
    int m = (r + l) / 2;
    return get(2 * v + 1, l, m, l0, r0) + get(2 * v + 2, m, r, l0, r0);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, m, d, k;
    cin >> n >> m;
    k = 1;
    vector <int> t(n), idx(n);
    vector <long long> cnt(1, 1), s;
    for (int &i : t) cin >> i;
    vector <pair <int, int> > a(n);
    for (int i = 0; i < n; i++) a[i].first = t[i], a[i].second = i;
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++) idx[a[i].second] = i;
    cin >> d;
    s.push_back(d);
    int pr = d;
    for (int i = 0; i < m - 1; i++) {
        cin >> d;
        if (d - pr <= s[k - 1]) cnt[k - 1]++;
        else s.push_back(d - pr), cnt.push_back(1), k++;
        pr = d;
    }
    // debug(s);
    // debug(cnt);
    // debug(idx);
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        ans += m * i;
        upd(0, 0, n, idx[i]);
        for (int j = 0; j < k; j++) {
            int l = -1, r = idx[i];
            while (r - l > 1) {
                int m1 = (r + l) / 2;
                if (s[k - 1] * a[m1].first > s[j] * t[i]) r = m1;
                else l = m1;
            }
            // if (i == n - 1) debug(r);
            ans += cnt[j] * get(0, 0, n, r, idx[i]);
            l = idx[i], r = n;
            while (r - l > 1) {
                int m1 = (r + l) / 2;
                if (s[k - 1] * t[i] >= s[j] * a[m1].first) l = m1;
                else r = m1;
            }
            // if (i == n - 1) debug(r);
            ans += cnt[j] * get(0, 0, n, idx[i] + 1, r);
        }
        cout << ans << ' ';
    }
}