#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << (x) << '\n'

template <typename T>
ostream &operator<<(ostream &out, vector <T> &a) {
    for (auto &i : a) cout << i << ' ';
    cout << '\n';
    return out;
}

vector <int> tree(262144);

void upd(int v, int l, int r, int &l0) {
    if (l > l0 || r <= l0) return;
    if (r - l == 1) {
        tree[v] = 1;
        return;
    }
    int m = (r + l) / 2;
    upd(2 * v + 1, l, m, l0);
    upd(2 * v + 2, m, r, l0);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int l0, int &r0) {
    if (l0 <= l && r <= r0) return tree[v];
    int m = (r + l) / 2;
    if (m >= r0 || r <= l0) return get(2 * v + 1, l, m, l0, r0);
    if (l >= r0 || m <= l0) return get(2 * v + 2, m, r, l0, r0);
    return get(2 * v + 1, l, m, l0, r0) + get(2 * v + 2, m, r, l0, r0);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, m, d, k;
    cin >> n >> m;
    k = 1;
    vector <int> idx(n);
    vector <long long> cnt(1, 1), s, t(n), c(3), st(3);
    for (auto &i : t) cin >> i, c[i]++;
    vector <pair <int, int> > a(n);
    for (int i = 0; i < n; i++) a[i].first = t[i], a[i].second = i;
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++) idx[a[i].second] = i;
    cin >> d;
    s.push_back(d);
    int pr = d;
    for (int i = 0; i < m - 1; i++) {
        cin >> d;
        if (d - pr <= s[k - 1]) cnt[k - 1]++;
        else s.push_back(d - pr), cnt.push_back(1), k++;
        pr = d;
    }
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        ans += m * i;
        int pr1 = -1, pr2 = n;
        for (int j = 0; j < k; j++) {
            // int l = pr1, r = idx[i];
            // t[i] *= s[j];
            // while (r - l > 1) {
            //     int m1 = (r + l) / 2;
            //     if (s[k - 1] * a[m1].first > t[i]) r = m1;
            //     else l = m1;
            // }
            // t[i] = t[i] / s[j] * s[k - 1];
            // pr1 = l;
            // l = idx[i], r = pr2;
            // while (r - l > 1) {
            //     int m1 = (r + l) / 2;
            //     if (t[i] >= s[j] * a[m1].first) l = m1;
            //     else r = m1;
            // }
            // t[i] /= s[k - 1];
            // ans += cnt[j] * get(0, 0, n, pr1 + 1, r);
            // pr2 = r;
            int r = idx[i];
            if (t[i] == 1) {
                if (s[k - 1] > s[j]) ans += cnt[j] * st[1];
                if (s[j] * 2 <= s[k - 1]) ans += cnt[j] * st[2];
            } else {
                if (s[k - 1] > s[j] * 2) ans += cnt[j] * st[1];
                if (s[k - 1] > s[j]) ans += cnt[j] * st[2];
            }
        }
        // upd(0, 0, n, idx[i]);
        st[t[i]]++;
        cout << ans << ' ';
    }
}