#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
#define endl "\n"
using namespace std;

const int INF = 1e9;

vector <vector <int>> g;
vector <int> color;
bool has_cycle = 0;

vector <pi> ans;
vector <int> already;
vector <int> a, b, c, d;
vector <int> topsort;

void dfs(int u, int p) {
    if (has_cycle) return;

    color[u] = 1;
    for (auto v: g[u]) if (v != p) {
        if (color[v] == 0) {
            dfs(v, u);
        }
        else if (color[v] == 1) {
            has_cycle = 1;
            return;
        }
    }
    color[u] = 2;
    topsort.push_back(u);
}

void calc_ans(int u) {
    if (already[u] != d[u]) {
        ans.emplace_back(u, d[u]);
        already[u] = d[u];
    }
    for (auto v: g[u]) {
        ans.emplace_back(v, 1 - already[v]);
        ans.emplace_back(v, already[v]);
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    g.clear();
    g.resize(n);
    color.clear();
    color.resize(n, 0);
    ans.clear();
    already.clear();
    already.resize(n, 0);
    has_cycle = 0;
    a.clear(); a.resize(m);
    b.clear(); b.resize(m);
    c.clear(); c.resize(m);
    d.clear(); d.resize(n);
    for (int i = 0; i<m; ++i) cin >> a[i] >> b[i] >> c[i];
    for (int i = 0; i<n; ++i) cin >> d[i];

    for (int i = 0; i<m; ++i) {
        int u = a[i] - 1;
        int v = b[i] - 1;
        if (d[u] == d[v]) {
            if (c[i] == d[u]) continue;
            else {
                cout << "NO" << endl;
                return;
            }
        }
        else {
            if (c[i] == d[u]) g[u].push_back(v);
            else g[v].push_back(u);
        }
    }

    //color.resize(n, 0);
    topsort.clear();
    for (int i = 0; i<n; ++i) if (color[i] == 0) dfs(i, -1);
    if (has_cycle) {
        cout << "NO" << endl;
        return;
    }
    reverse(all(topsort));
    for (auto u: topsort) {
        //cout << u+1 << ' ';
        calc_ans(u);
    }
    cout << "YES" << endl;
    cout << ans.size() << endl;
    for (auto [u, col] : ans) cout << u+1 << ' ' << col << endl;
    return;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}