#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
#define endl "\n"
using namespace std;

const int INF = 1e15;

vector <int> a;
int n, x;

struct segm{
    int i, l, r;
    bool operator<(segm s) {
        return r < s.r;
    }
    bool contains(int pos) {
        return (l <= pos && r >= pos);
    }
    segm(int _i, int _l, int _r) : i(_i), l(_l), r(_r) {};
    segm() {};
    void debug() {
        cout << i << ": " << "[" << l << "," << r << "]" << endl;
    }
};
vector <segm> segms;

struct sparse{
    vector <int> vec;
    vector <vector <int>> tree;
    int N;
    int B = 25;
    int mix(int i, int j) {
        if (i > j) swap(i, j);
        if (i == -1 || vec[i] == -1) return j;
        if (j == -1 || vec[j] == -1) return i;
        return (segms[vec[i]].r >= segms[vec[j]].r ? i : j);
    }
    sparse(vector <int>& _vec) {
        vec = _vec;
        //for (auto el: vec) cout << el << ' ';
        //cout << endl;
        N = vec.size();
        tree.resize(B, vector<int>(N, -1));
        for (int b = 0; b<B; ++b) {
            for (int i = 0; i + (1LL << b) <=N; ++i) {
                if (b == 0) tree[b][i] = i;
                else tree[b][i] = mix(tree[b-1][i], tree[b-1][i + (1LL << (b-1))]);
            }
        }
    }
    int get(int ql, int qr) {
        if (qr <= ql) return -1;
        int b = __lg(qr - ql);
        return vec[mix(tree[b][ql], tree[b][qr - (1LL << b)])];
    }
};


int calc() {
    int F = 0;
    segms.clear();
    for (int i = 0; i<n; ++i) segms.emplace_back(i, max(0LL, i - a[i]), min(n-1, i + a[i]));

    vector <int> to_sparse(n, -1);
    for (int i = 0; i<n; ++i) {
        int j = to_sparse[segms[i].l];
        if (j == -1 || segms[j].r < segms[i].r) to_sparse[segms[i].l] = i;
    }
    //cout << "OK" << endl;
    sparse sp = sparse(to_sparse);
    vector <int> ant(n);
    for (int i = 0; i<n; ++i) {
        ant[i] = sp.get(0, i+1);
        //cout << i << ": " << ant[i] << endl;
    }

    vector <int> nxt(n);
    for (int i = 0; i<n; ++i) nxt[i] = segms[ant[i]].r + 1;

    vector <int> dp(n);
    vector <int> rec(n);
    for (int s = n-1; s>=0; --s) {
        if (nxt[s] == n) {
            dp[s] = 0;
            rec[s] = 1;
        }
        else {
            dp[s] = dp[nxt[s]] + rec[nxt[s]] + 1;
            rec[s] = rec[nxt[s]] + 1;
        }
        F += dp[s];
    }

    return F;
}



signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> x;
    a.resize(n);
    for (auto& el: a) cin >> el;

    int bestF = calc();
    for (int i = 0; i<n; ++i) {
        int tmp = a[i];
        a[i] = x;
        bestF = min(bestF, calc());
        a[i] = tmp;
    }
    cout << bestF << endl;

    return 0;
}