#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
//#define endl "\n"
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,unroll-loops")
using namespace std;

const int INF = 1e15;

vector <int> a;
int n, x;

struct segm{
    int i, l, r;
    bool operator<(segm s) {
        return r < s.r;
    }
    bool contains(int pos) {
        return (l <= pos && r >= pos);
    }
    segm(int _i, int _l, int _r) : i(_i), l(_l), r(_r) {};
    segm() {};
    void debug() {
        cout << i << ": " << "[" << l << "," << r << "]" << endl;
    }
};
vector <segm> segms;

struct sparse{
    vector <int> vec;
    vector <vector <int>> tree;
    int N;
    int B = 20;
    int mix(int i, int j) {
        if (i == -1) return j;
        if (j == -1) return i;
        return (segms[i].r >= segms[j].r ? i : j);
    }
    sparse(vector <int>& _vec) {
        vec = _vec;
        N = vec.size();
        tree.resize(B, vector<int>(N, -1));
        for (int b = 0; b<B; ++b) {
            for (int i = 0; i + (1LL << b) <=N; ++i) {
                if (b == 0) tree[b][i] = vec[i];
                else tree[b][i] = mix(tree[b-1][i], tree[b-1][i + (1LL << (b-1))]);
            }
        }
    }
    int get(int ql, int qr) {
        if (qr <= ql) return -1;
        int b = __lg(qr - ql);
        return mix(tree[b][ql], tree[b][qr - (1LL << b)]);
    }
};


int calc() {
    int F = 0;
    segms.clear();
    for (int i = 0; i<n; ++i) segms.emplace_back(i, max(0LL, i - a[i]), min(n-1, i + a[i]));

    vector <int> to_sparse(n, -1);
    for (int i = 0; i<n; ++i) {
        int j = to_sparse[segms[i].l];
        if (j == -1 || segms[j].r < segms[i].r) to_sparse[segms[i].l] = i;
    }
    //cout << "OK" << endl;
    sparse sp = sparse(to_sparse);
    vector <int> ant(n);
    for (int i = 0; i<n; ++i) {
        ant[i] = sp.get(0, i+1);
        //cout << i << ": " << ant[i] << endl;
    }

    vector <int> check(n);
    check[0] = 0;
    for (int i = 1; i<n; ++i) check[i] = (ant[i] != ant[i-1]);
    //for (auto el: check) cout << el << ' ';
    vector <int> ps(n);
    ps[0] = check[0];
    for (int i = 1; i<n; ++i) ps[i] = ps[i-1] + check[i];

    for (int i = 0; i<n; ++i) F += ps[i] * (i+i-n+1);
    return F;
}



signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> x;
    a.resize(n);
    for (auto& el: a) cin >> el;

    int bestF = calc();
    for (int i = 0; i<n; ++i) {
        int tmp = a[i];
        a[i] = x;
        bestF = min(bestF, calc());
        a[i] = tmp;
    }
    cout << bestF << endl;

    return 0;
}