#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

struct Edge {
    int a, b, c;

    Edge() = default;

    Edge(int A, int B, int C) {
        a = A, b = B, c = C;
    }
};

const ll INF = 1ll << 60, MAXN = 110000;

vector<int> g[MAXN];
vector<Edge> E;
vector<int> a;

ll used[MAXN];
ll ct = 0, bct = 0;
vector<int> tout;
vector<pll> act;


void resolve(int v) {
    for (auto i: g[v])
        resolve(i);
    a[v] ^= 1;
    act.emplace_back(v, a[v]);
}

void blink(int v) {
    resolve(v);
    resolve(v);
}

void dfs(int v) {
    used[v] = ct;
    for (auto i: g[v])
        if (used[i] < ct)
            dfs(i);
    tout.push_back(v);
}

bool checkCyc(int v) {
    if (used[v] == ct)
        return true;
    if (used[v] >= bct)
        return false;
    used[v] = ct;
    for (auto i: g[v])
        if (checkCyc(i))
            return true;
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    a.resize(n);
    E.clear();

    for (int i = 0; i < m; ++i) {
        int ta, tb, tc;
        cin >> ta >> tb >> tc;
        ta--, tb--;
        E.emplace_back(ta, tb, tc);
    }

    for (auto &i: a)
        cin >> i;

    bool cool = true;

    for (auto [ta, tb, tc]: E) {
        if (a[ta] == a[tb]) {
            if (a[ta] != tc)
                cool = false;
        } else {
            if (a[ta] != tc)
                swap(ta, tb);
            g[ta].push_back(tb);
        }
    }

    bct = ct;
    for (auto i = 0; i < n; ++i) {
        if (used[i] < bct && checkCyc(i))
            cool = false;
        ct++;
    }

    if (!cool) {
        cout << "NO\n";
        for (int i = 0; i < n; ++i)
            g[i].clear();
        return;
    }

    tout.clear();
    for (int i = 0; i < n; ++i)
        if (used[i] < ct)
            dfs(i);
    ct++;

    act.clear();
    for (int i = 0; i < n; ++i)
        if (a[i])
            act.emplace_back(i, 1);


    for (auto [ta, tb, tc]: E) {
        if (tc == 1 && (a[ta] + a[tb] < 2)) {
            if (a[tb] != tc)
                swap(ta, tb);
            used[ta] = ct;
        }
    }
    for (auto i: tout)
        if (used[i] == ct)
            blink(i);

    ct++;


    cout << "YES\n";
    cout << act.size() << '\n';
    for (auto [ta, tb]: act)
        cout << ta + 1 << ' ' << tb << '\n';


    for (int i = 0; i < n; ++i)
        g[i].clear();
}

int main() {
    fill(used, used + MAXN, -1);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
    return 0;
}
