#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

struct Edge {
    int to, c;
};

vector<Edge> ed;
vector<vector<int>> gr, grr;
vector<int> d, color;

bool dfsr(int v) {
    color[v] = 1;
    for (auto u : grr[v]) {
        if (color[u] == 1) {
            return true;
        }
        if (color[u] == 0 && dfsr(u)) {
            return true;
        }
    }
    color[v] = 2;
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    ed.resize(2 * m);
    gr.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u, --v;
        ed[2 * i] = {v, c};
        ed[2 * i + 1] = {u, c};
        gr[u].push_back(2 * i);
        gr[v].push_back(2 * i + 1);
    }
    d.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        for (auto e_i : gr[i]) {
            auto [v, c] = ed[e_i];
            if ((d[i] ^ d[v]) == 0 && d[i] != c) {
                cout << "NO\n";
                return;
            }
        }
    }
    grr.assign(n, {});
    for (int i = 0; i < n; ++i) {
        for (auto e_i : gr[i]) {
            auto [v, c] = ed[e_i];
            if (d[i] != c) {
                grr[i].push_back(v);
            }
        }
    }
    color.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0 && dfsr(i)) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << "-1\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
