#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

const ll INF = 1e9;

struct robot {
    ll x, p, d;

    robot() = default;

    robot(ll x, ll p, ll d) : x(x), p(p), d(d) {}
};

void solve() {
    ll n;
    cin >> n;
    vector<robot> a(n);
    for (auto &r : a) cin >> r.x >> r.p >> r.d;

    vector<vll> dp(n, vll(2));
    dp[0][0] = (a[0].d == 1);
    dp[0][1] = (a[0].d == -1);

    for (int i = 1; i < n; ++i) {
        // j = 0
        ll v1, v2;
        if (a[i].p >= a[i].x - a[i - 1].x) {
            v1 = dp[i - 1][0] + (a[i].d == 1);
        } else {
            v1 = INF;
        }
        if (a[i].p + a[i - 1].p >= a[i].x - a[i - 1].x) {
            v2 = dp[i - 1][1] + (a[i].d == 1);
        }
        else {
            v2 = INF;
        }

        dp[i][0] = min(v1, v2);
        // j = 1

        if (a[i].x - a[i - 1].x <= a[i - 1].p) {
            dp[i][1] = dp[i - 1][1] + (a[i].d == -1);
        } else {
            dp[i][1] = INF;
        }
    }
    ll res = min(dp[n - 1][0], dp[n - 1][1]);
    cout << (res == INF ? -1 : res) << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve();
}