#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

const ll INF = 1e18 + 3;

struct edge {
    ll from, to;
    bool cur, want;

    edge() = default;

    edge(ll f, ll t, bool c, bool w) : from(f), to(t), cur(c), want(w) {}
};

bool dfs(const vector<vll> & gr, vll & top_sort, vll & used, ll u) {
    used[u] = 2;

    for (auto v : gr[u]) {
        if (used[v] == 2) return false;

        if (used[v] == 0)
            if (!dfs(gr, top_sort, used, v)) return false;
    }

    used[u] = 1;
    top_sort.push_back(u);
    return true;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> gr(n);
    vector<edge> edges(m);
    vector<int> wanted_v(n);
    for (int i = 0; i < m; ++i) {
        ll ai, bi, ci;
        cin >> ai >> bi >> ci;
        ai--;
        bi--;
        edges[i] = {ai, bi, false, (bool) ci};
    }
    ll s = n * 2;
    for (int i = 0; i < n; ++i) {
        cin >> wanted_v[i];
        s -= wanted_v[i];
    }
    for (int i = 0; i < m; ++i) {
        if (wanted_v[edges[i].from] == wanted_v[edges[i].to] && wanted_v[edges[i].to] != edges[i].want) {
            cout << "NO\n";
            return;
        } else if (wanted_v[edges[i].from] != wanted_v[edges[i].to] && wanted_v[edges[i].from] == edges[i].want) {
            gr[edges[i].to].push_back(edges[i].from);
        } else if (wanted_v[edges[i].from] != wanted_v[edges[i].to] && wanted_v[edges[i].to] == edges[i].want) {
            gr[edges[i].from].push_back(edges[i].to);
        }
    }

    vll top_sort;
    vll used(n);
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            bool success = dfs(gr, top_sort, used, i);
            if (!success) {
                cout << "NO\n";
                return;
            }
        }
    }

    cout << "YES\n" << s << "\n";
    for (auto u : top_sort) {
        cout << u + 1 << " 1\n";
        if (!wanted_v[u]) cout << u + 1 << " 0\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
    cin >> t;
    while(t--) solve();
}