#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

const ll INF = 1e18 + 3;

void solve_naive() {
    ll n, m;
    cin >> n >> m;
    vll t(n);
    vll s(m + 1);

    for (auto &i : t) cin >> i;
    for (int i = 1; i <= m; ++i) cin >> s[i];

    cout << "0\n";

    for (int k = 2; k < n + 1; ++k) {
        vll saves(k);
        ll finished = 0;
        ll teleports_cnt = 0;

        while (finished < k) {
            ll min_ind = 0;
            ll min_v = INF;
            for (int i = 0; i < k; ++i) {
                if (saves[i] == m) continue;
                ll cur_v = t[i] * (s[saves[i] + 1] - s[saves[i]]);

                if (cur_v < min_v) {
                    min_ind = i;
                    min_v = cur_v;
                }
            }
            saves[min_ind]++;
            teleports_cnt += k - finished - 1;
            if (saves[min_ind] == m) finished++;
        }
        cout << teleports_cnt << "\n";
    }
}

void solve_all_ds_the_same() {
    ll n, m;
    cin >> n >> m;
    vll t(n);
    vll s(m + 1);

    for (auto &i : t) cin >> i;
    for (int i = 1; i <= m; ++i) cin >> s[i];

    for (int k = 1; k < n + 1; ++k) {
        cout << m * k * (k - 1) / 2 << "\n";
    }
}

void solve_all_t_the_same() {
    ll n, m;
    cin >> n >> m;
    vll t(n);
    vll s(m + 1);
    vll ds(m + 1);

    for (auto &i: t) cin >> i;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
        ds[i - 1] = s[i] - s[i - 1];
    }
    ds[m] = INF;

    cout << "0\n";

    for (int k = 2; k < n + 1; ++k) {
        set<vll> st;
        for (int i = 0; i < k; ++i) {
            st.insert({ds[0], i, 0});
        }
        ll teleports_cnt = 0;

        while (!st.empty()) {
            teleports_cnt += st.size() - 1;

            auto it = st.begin();
            auto v = *it;
            st.erase(it);

            if (v[2] == m - 1) continue;

            v[2]++;
            v[0] = ds[v[2]];
            st.insert(v);
        }
        cout << teleports_cnt << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve_all_t_the_same();
}