#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

const ll INF = 1e9;

ll F(const vll & p, const vll & r, ll n) {
    ll res = 0;
    for (int s = 0; s < n - 1; ++s) {
        ll cur_f = 0;
        ll cur_antenna = p[s];
        for (int t = s + 1; t < n; ++t) {
            if (r[cur_antenna] < t) {
                cur_antenna = p[t];
                cur_f++;
            }
            res += cur_f;
        }
    }
    return res;
}

void solve_naive() {
    ll n, x;
    cin >> n >> x;
    vll a(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        l[i] = max(0ll, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
    }

    vll p(n); // p[i] = max(var = j, cond = Lj<=i<=Rj, f = Rj)

    for (int j = 0; j < n; ++j) {
        p[j] = j;
        for (ll k = l[j]; k <= r[j]; ++k) {
            if (r[p[k]] < r[j]) p[k] = j;
        }
    }

    ll tmp;
    ll ans = F(p, r, n);

    for (int i = 0; i < n; ++i) {
        tmp = a[i];
        a[i] = x;
        l[i] = max(0ll, i - a[i]);
        r[i] = min(n - 1, i + a[i]);

        for (int j = 0; j < n; ++j) {
            p[j] = j;
            for (ll k = l[j]; k <= r[j]; ++k) {
                if (r[p[k]] < r[j]) p[k] = j;
            }
        }

        ans = min(ans, F(p, r, n));
        a[i] = tmp;
        l[i] = max(0ll, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
        for (int j = 0; j < n; ++j) {
            p[j] = j;
            for (ll k = l[j]; k <= r[j]; ++k) {
                if (r[p[k]] < r[j]) p[k] = j;
            }
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve_naive();
}