#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<array<int, 3>> ed(m);
        for (auto &[a, b, c] : ed) {
            cin >> a >> b >> c;
            --a; --b;
        }
        vector<int> d(n);
        cin >> d;
        vector<vector<int>> g(2 * n), gr(2 * n);
        auto add = [&](int a, int b) {
            g[a].push_back(b);
            gr[b].push_back(a);
        };
        bool ans = 1;
        for (auto [a, b, c] : ed) {
            if (d[a] && d[b] && !c) {
                ans = 0;
            }
            if (!d[a] && !d[b] && c) {
                ans = 0;
            }
        }
        // a = 0
        // a + n = 1
        for (auto [a, b, c] : ed) {
            if (c == 0) { // !a || !b
                if (d[a] || d[b]) {
                    add(a + n, b);
                    add(b + n, a);
                }
            } else { // a && b
                add(a, a + n);
//                add(a + n, a);
                add(b, b + n);
//                add(b + n, b);
            }
        }
        for (int i = 0; i < n; ++i) {
            if (d[i]) {
                add(i, i + n);
            }
        }
        vector<bool> used(2 * n);
        vector<int> topsort;
        auto dfs1 = [&](auto dfs1, int v) -> void {
            used[v] = 1;
            for (auto u : g[v]) {
                if (!used[u]) {
                    dfs1(dfs1, u);
                }
            }
            topsort.push_back(v);
        };
        for (int i = 0; i < 2 * n; ++i) {
            if (!used[i]) {
                dfs1(dfs1, i);
            }
        }
        reverse(topsort.begin(), topsort.end());
        vector<int> comp(2 * n, -1);
        int c = 0;
        auto dfs2 = [&](auto dfs2, int v) -> void {
            comp[v] = c;
            for (auto u : gr[v]) {
                if (comp[u] == -1) {
                    dfs2(dfs2, u);
                }
            }
        };
        for (auto i : topsort) {
            if (comp[i] == -1) {
                dfs2(dfs2, i);
                ++c;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (comp[i] == comp[i + n]) {
                ans = 0;
                break;
            }
        }
//        for (int i : comp) {
//            cout << i << " ";
//        }
//        cout << "\n";
        if (ans) {
            cout << "YES\n";
            cout << "-1\n";
        } else {
            cout << "NO\n";
        }
    }
}
