#include <iostream>
#include <vector>
using namespace std;

struct Edge {
    int v, u, c;
};

int main() {
    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        vector<Edge> eds;
        vector<int> edCol(m);
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v >> edCol[i];
            u--;
            v--;

            eds.push_back({u, v, 0});
        }

        vector<int> vertCol(n), curCol(n);
        for (int i = 0; i < n; i++) {
            cin >> vertCol[i];
            curCol[i] = vertCol[i];
        }

        for (int i = 0; i < m; i++) {
            if (edCol[i] == 1) {
                eds[i].c = 1;
                if (curCol[eds[i].v] == 0)
                    curCol[eds[i].v] = 1;
                if (curCol[eds[i].u] == 0)
                    curCol[eds[i].u] = 1;
            } else if (curCol[eds[i].v] == 1 && curCol[eds[i].u] == 1) {
                eds[i].c = 1;
            }
        }

        for (int i = 0; i < n; i++) {
            if (vertCol[i] == 0)
                curCol[i] = 0;
            else
                curCol[i] = 1;
        }

        bool fl = true;
        for (int i = 0; i < m; i++) {
            if (eds[i].v == 1 && eds[i].u == 1)
                eds[i].c = 1;
            else if (eds[i].v == 0 && eds[i].u == 0)
                eds[i].c = 0;
            
            if (eds[i].c != edCol[i]) {
                fl = false;
                break;
            }
        }

        if (!fl) {
            cout << "NO\n";
            continue;
        }
        
        cout << "YES\n";
        
        cout << -1 << '\n';
    }
}