#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<vector<pair<int, int>>> g;
vector<bool> used;
vector<int> curCol;
vector<int> rCol;

bool dfs(int v) {
    used[v] = true;
    if (g[v].size() > 0 && g[v][0].first == 0) {
        for (auto x : g[v]) {
            int c = x.first;
            int u = x.second;
            if (used[u]) {
                if (c == 1 && curCol[u] == 0) {
                    cout << v << ' ' << u << '\n';
                    return false;
                }
            } else {
                if (c == 1) continue;
                if (!dfs(u)) {
                    return false;
                }
            }
        }
    }
    if (g[v].size() > 0 && g[v].back().first == 1) {
        curCol[v] = 1;
        for (auto x : g[v]) {
            int c = x.first;
            int u = x.second;
            if (used[u]) {
                if (c == 0 && curCol[u] == 1) {
                    cout << v << ' ' << u << '\n';
                    return false;
                }
            } else {
                if (c == 0) continue;
                if (!dfs(u)) {
                    return false;
                }
            }
        }
    }

    if (rCol[v] == 0) {
        curCol[v] = 0;
    } else {
        curCol[v] = 1;
    }

    return true;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        g.assign(n, {});
        for (int i = 0; i < m; i++) {
            int u, v, c;
            cin >> u >> v >> c;
            u--;
            v--;

            g[u].push_back({c, v});
            g[v].push_back({c, u});
        }
        for (int i = 0; i < n; i++) {
            sort(g[i].begin(), g[i].end());
        }

        rCol.assign(n, 0);
        for (int i = 0; i < n; i++) {
            cin >> rCol[i];
        }

        used.assign(n, false);
        curCol.assign(n, 0);
        bool fl = true;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                fl = fl && dfs(i);
            }
        }

        if (fl)
            cout << "YES\n";
        else
            cout << "NO\n";
        
        cout << -1 << '\n';
    }
}