#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> rCol;
vector<pair<int, int>> moves;

void dfs(int v, int p) {
    for (auto x : g[v]) {
        int c = x.first;
        int u = x.second;
        if (u == p || c != 0) continue;
        dfs(u, v);
    }

    if (g[v].back().first == 1)
        moves.push_back({v + 1, 1});
    for (auto x : g[v]) {
        int c = x.first;
        int u = x.second;
        if (u == p || c != 1) continue;
        dfs(u, v);
    }

    if (rCol[v] == 0)
        moves.push_back({v + 1, 0});
    else
        moves.push_back({v + 1, 1});
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        g.assign(n, {});
        for (int i = 0; i < m; i++) {
            int u, v, c;
            cin >> u >> v >> c;
            u--;
            v--;

            g[u].push_back({c, v});
            g[v].push_back({c, u});
        }
        for (int i = 0; i < n; i++) {
            sort(g[i].begin(), g[i].end());
        }

        rCol.assign(n, 0);
        for (int i = 0; i < n; i++) {
            cin >> rCol[i];
        }

        bool fl = true;
        for (int v = 0; v < n; v++) {
            for (auto x : g[v]) {
                int c = x.first;
                int u = x.second;
                if ((c == 0 && rCol[v] == 1 && rCol[u] == 1) || (c == 1 && rCol[v] == 0 && rCol[u] == 0)) {
                    fl = false;
                    break;
                }
            }
            if (!fl)
                break;
        }

        if (!fl) {
            cout << "NO\n";
            continue;
        }

        cout << "YES\n";

        dfs(0, -1);
        cout << moves.size() << '\n';
        for (int i = 0; i < moves.size(); i++) {
            cout << moves[i].first << ' ' << moves[i].second << '\n';
        }
    }
}