
#include<bits/stdc++.h>

using namespace std;


struct Node {
    long long cnt_blocked;
    long long summ, push;
    Node() : cnt_blocked(0), summ(0), push(0) {}

    void apply(long long add, long long l, long long r) {
        push += add;
        summ += (r - l - cnt_blocked) * add;
    }
};

struct seg_tree {
    vector<Node> tree;
    void build(long long n) {
        tree.assign(4 * n, Node());
    }

    void update(long long v, long long l, long long r, long long ql, long long qr, long long add) {
        if (ql <= l && r <= qr) {
            if (v == 6 || v == 2) {
                //cout << add << endl;
            }//
            tree[v].push += add;
            tree[v].summ += (r - l - tree[v].cnt_blocked) * add;
            return;
        }
        if (qr <= l || r <= ql) {
            return;
        }
        long long mid = (l + r) / 2;
        tree[2 * v + 1].apply(tree[v].push, l, mid);
        tree[2 * v + 2].apply(tree[v].push, mid, r);
        tree[v].push = 0;

        update(2 * v + 1, l, mid, ql, qr, add);
        update(2 * v + 2, mid, r, ql, qr, add);
        tree[v].summ = tree[2 * v + 1].summ + tree[2 * v + 2].summ;
    }

    void update_blocked(long long v, long long l, long long r, long long pos) {
        if (l == r - 1) {
            tree[v].cnt_blocked = 1;
            return;
        }
        long long mid = (l + r) / 2;
        tree[2 * v + 1].apply(tree[v].push, l, mid);
        tree[2 * v + 2].apply(tree[v].push, mid, r);
        tree[v].push = 0;

        if (pos < mid) {
            update_blocked(2 * v + 1, l, mid, pos);
        } else {
            update_blocked(2 * v + 2, mid, r, pos);
        }
        tree[v].cnt_blocked = tree[2 * v + 1].cnt_blocked + tree[2 * v + 2].cnt_blocked;
    }

    pair<long long, long long> get(long long v, long long l, long long r, long long ql, long long qr) {
        if (ql <= l && r <= qr) {
            return {tree[v].summ, tree[v].cnt_blocked};
        }
        if (qr <= l || r <= ql) {
            return {0, 0};
        }
        long long mid = (l + r) / 2;
        tree[2 * v + 1].apply(tree[v].push, l, mid);
        tree[2 * v + 2].apply(tree[v].push, mid, r);
        tree[v].push = 0;

        auto ans1 = get(2 * v + 1, l, mid, ql, qr);
        auto ans2 = get(2 * v + 2, mid, r, ql, qr);
        return {ans1.first + ans2.first, ans1.second + ans2.second};
    }
};



int main() {
    long long n, m;
    cin >> n >> m;
    vector<long long> t(n);
    for (auto &i : t) {
        cin >> i;
    }
    vector<long long> s(m + 1);
    for (long long i = 1; i <= m; i++) {
        cin >> s[i];
    }
    vector<long long> c(n);
    vector<long long> need_time(n), now(n);
    vector<bool> had_finished(n);
    set<pair<long long, long long>> all;
    for (long long i = 0; i < n; i++) {
        need_time[i] = (s[1] - s[0]) * t[i];
        all.insert({need_time[i], i});
    }
    long long cnt_not_finished = n;
    seg_tree tp;
    tp.build(n);
    while (true) {
        long long mn_ind = all.begin()->second;
        all.erase(all.begin());
        /*
        for (long long i = 0; i < n; i++) {
            if (i == mn_ind) {
                continue;
            }
            if (!had_finished[i]) {
                c[n - 1]++;
                if (i < mn_ind) {
                    tp_less[mn_ind]++;
                } else {
                    less_tp[i]++;
                }
            }
        }*/
        c[n - 1] += cnt_not_finished - 1;
        tp.update(0, 0, n, mn_ind, mn_ind + 1, mn_ind - tp.get(0, 0, n, 0, mn_ind).second);
        tp.update(0, 0, n, mn_ind + 1, n, 1);
        now[mn_ind]++;
        if (now[mn_ind] == m) {
            cnt_not_finished--;;
            //had_finished[mn_ind] = true;
            tp.update_blocked(0, 0, n, mn_ind);
        } else {
            need_time[mn_ind] = (s[now[mn_ind] + 1] - s[now[mn_ind]]) * t[mn_ind];
            all.insert({need_time[mn_ind], mn_ind});
        }
        if (cnt_not_finished == 0) {
            break;
        }
    }
    for (long long i = n - 2; i >= 0; i--) {
        c[i] = c[i + 1] - tp.get(0, 0, n, i + 1, i + 2).first;
    }
    for (auto &i : c) {
        cout << i << "\n";
    }
}

