#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

#define int long long

using namespace std;
vector<vector<pair<int, int>>> g;
vector<pair<int, int>> ans;
vector<int> d, cnt, used;
vector<vector<int>> ord;
void dfs(int v, int p) {


    if (!d[v]) {
        vector<int> black, white;
        for (auto [u, c] : g[v]) {
            if (d[u] && c) black.push_back(u);
            else white.push_back(u);
        }

        for (int i = 0; i < (int) black.size() - 1; i++) {
            ord[black[i]].push_back(black[i + 1]);
        }

        if (black.size()) ord[black.back()].push_back(v);
        if (white.size()) ord[v].push_back(white[0]);

        for (int i = 0; i < (int) white.size() - 1; i++) {
            ord[white[i]].push_back(white[i + 1]);
        }
    }


    for (auto [u, c] : g[v]) {
        if (u == p) continue;
        dfs(u, v);
    }
}

void dfs2(int v) {
    used[v] = 1;
    ans.emplace_back(v, 1);
    if (!d[v]) ans.emplace_back(v, 0);
    for (int u : ord[v]) {
        if (!used[u]) {
            cnt[u]--;
            if (cnt[u] == 0) {
                dfs2(u);
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    ord.assign(n, {});
    d.assign(n, 0);
    cnt.assign(n, 0);
    used.assign(n, 0);
    ans = {};
    vector<tuple<int, int, int>> v(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        v[i] = {a, b, c};
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }


    for (int &i : d) {
        cin >> i;
    }

    for (auto [a, b, c] : v) {
        if (c == 1 && !d[a] && !d[b]) {
            cout << "NO\n";
            return;
        }
        if (c == 0 && d[a] && d[b]) {
            cout << "NO\n";
            return;
        }
    }

    dfs(0, -1);

//    for (int i = 0; i < n; i++) {
//        cout << i << " ::: " << endl;
//        for (int j : ord[i]) {
//            cout << j << " ";
//            cnt[j]++;
//        }
//        cout << endl;
//    }


    for (int i = 0; i < n; i++) {
        if (cnt[i] == 0 && !used[i]) {
            dfs2(i);
        }
    }

    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b << "\n";
    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int tt = 1;
     cin >> tt;
    while (tt--) {
        solve();
    }
}
