#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

#define int long long

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> used, start, tin, tout, depth;

bool f = false;
int t = 0;

void dfs1(int v) {
    used[v] = 1;
    tin[v] = t++;
    for (auto [u, c] : g[v]) {
        if (!used[u]) {
            depth[u] = depth[v] + 1;
            dfs1(u);
        }
    }
    tout[v] = t++;
}

bool anc(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

void dfs2(int v, int edge_status, int p) {
    used[v] = 1;
    for (auto [u, c] : g[v]) {
        if (u == p) continue;
        if (!used[u]) {
            if (c == edge_status) {
                start[u] = v;
            } else {
                start[u] = start[v];
            }
            dfs2(u, c, v);
        } else {
            if (depth[u] > depth[v]) continue;
            if (c == edge_status) continue;
//            cout << start[v] << " " << u << " " << " " << abs(depth[v] - depth[u]) << endl;
            if (anc(start[v], u) && abs(depth[v] - depth[u]) % 2) {
                f = true;
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    g.assign(n, {});
    used.assign(n, 0);
    start.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    depth.assign(n, 0);
    t = 0;
    f = false;

    vector<tuple<int, int, int>> v(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        v[i] = {a, b, c};
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }

    vector<int> d(n);
    for (int &i : d) {
        cin >> i;
    }

    for (auto [a, b, c] : v) {
        if (c == 1 && !d[a] && !d[b]) {
            cout << "NO\n";
            return;
        }
        if (c == 0 && d[a] && d[b]) {
            cout << "NO\n";
            return;
        }
    }

    if (m == n-1) {
        vector<pair<int, int>> ans;
        for (auto [a, b, c] : v) {
            if (c == 1) {
                ans.emplace_back(a, 1);
                ans.emplace_back(b, 1);
                if (!d[b]) ans.emplace_back(b, 0);
            }
        }

        for (int i = 0; i < n; i++) {
            if (!d[i]) ans.emplace_back(i, 0);
        }
        for (int i = 0; i < n; i++) {
            if (d[i]) {
                ans.emplace_back(i, 1);
            }
        }
        cout << "YES\n";
        cout << ans.size() << "\n";
        for (auto [a, b] : ans) {
            cout << a + 1 << " " << b << "\n";
        }

        return;
        // ?
    }

    dfs1(0);
    used.assign(n, 0);
    dfs2(0, -1, -1);
    if (f) {
        cout << "NO\n";
        return;
    }

    vector<pair<int, int>> ans;
    for (auto [a, b, c] : v) {
        if (c == 1) {
            ans.emplace_back(a, 1);
            ans.emplace_back(b, 1);
            if (!d[b]) ans.emplace_back(b, 0);
        }
    }

    for (int i = 0; i < n; i++) {
        if (!d[i]) ans.emplace_back(i, 0);
    }
    for (int i = 0; i < n; i++) {
        if (d[i]) {
            ans.emplace_back(i, 1);
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}