#include <iostream>
#include <algorithm>
#include <climits>
#include <queue>
#include <map>
#include <set>
#include <vector>
#include <random>

using namespace std;
typedef long long ll;

struct str1 {
	ll i, x, t;
};

struct str {
	ll v, c;
};

bool operator<(str1 a, str1 b) {
	if (a.t == b.t)
		return a.i > b.i;
	return a.t > b.t;
}


struct st {
	ll l, r;
};

bool operator<(st a, st b) {
	if (a.l == b.l)
		return a.r < b.r;
	return a.l < b.l;
}

ll MX = 1000000000;

vector<vector<str>> a;
vector<ll> b;

void solveC1() {
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (ll i = 0; i < m; i++)
	{
		cin >> s[i];
	}
	cout << 0 << "\n";
	for (ll i = 2; i <= n; i++) {
		priority_queue<str1> q;
		for (ll j = 0; j < i; j++) {
			q.push({ j, 0, t[j] * s[0] });
		}
		ll c = 0;
		while (!q.empty()) {
			auto x = q.top();
			q.pop();
			c += q.size();
			if (x.x != m - 1) {
				x.x++;
				q.push({ x.i, x.x, t[x.i] * (s[x.x] - s[x.x - 1]) });
			}
		}
		cout << c << "\n";
	}
}

void solveC() {
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (ll i = 0; i < m; i++)
	{
		cin >> s[i];
	}
	cout << 0 << "\n";
	for (ll i = 2; i <= n; i++) {
		priority_queue<str1> q;
		for (ll j = 0; j < i; j++) {
			q.push({ j, 0, t[j] * s[0] });
		}
		ll c = 0;
		while (!q.empty()) {
			auto x = q.top();
			q.pop();
			c += q.size();
			x.x++;
			if (!q.empty())
				while (x.x < m && q.top().t >= t[x.i] * (s[x.x] - s[x.x - 1])) {
					c += q.size();
					x.x++;
				}

			if (x.x <= m - 1) {
				q.push({ x.i, x.x, t[x.i] * (s[x.x] - s[x.x - 1]) });
			}
		}
		cout << c << "\n";
	}
}

void solveB() {
	vector<str> v0;
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, pair<ll, ll>>> vv(m);
	a.assign(n, v0);
	b.assign(n, 0);
	for (ll i = 0; i < m; i++) {
		ll v, u, c;
		cin >> v >> u >> c;
		v--; u--;
		a[v].push_back({ u, c });
		a[u].push_back({ v, c });
		vv[i] = { c, { u, v } };
	}
	ll c0 = 0, c1 = 0;
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
		if (b[i] == 1)
			c1++;
		else
			c0++;
	}

	if (n == 1) {
		cout << "YES\n";
		cout << c1 << "\n";
		if (c1 > 0) {
			cout << "1 1\n";
		}
		return;
	}
	if (n == 2) {
		if (m == 0) {
			cout << "YES\n";
			cout << c1 << "\n";
			for (ll i = 0; i < n; i++) {
				if (b[i]) {
					cout << i + 1 << " " << 1 << "\n";
				}
			}
			return;
		}
		else {
			if (a[0][0].c == 1) {
				cout << "YES\n" << n + c0 << "\n";
			}
			for (ll i = 0; i < n; i++) {
				cout << i + 1 << " " << 1 << "\n";
			}
			for (ll i = 0; i < n; i++) {
				if (!b[i]) {
					cout << i + 1 << " " << 0 << "\n";
				}
			}
		}
	}


	for (ll i = 0; i < n; i++) {
		for (auto x : a[i]) {
			if (b[i] == 0 && b[x.v] == 0 && x.c == 1) {
				cout << "NO\n";
				return;
			}
			if (b[i] == 1 && b[x.v] == 1 && x.c == 0) {
				cout << "NO\n";
				return;
			}
		}
	}


	for (auto x : vv) {

	}




}

void solveB1() {
	vector<str> v0;
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, pair<ll, ll>>> vv(m);
	a.assign(n, v0);
	b.assign(n, 0);
	vector<ll> c(n);
	vector<ll> ans;
	map<pair<ll, ll>, ll> mp;

	for (ll i = 0; i < m; i++) {
		ll v, u, c1;
		cin >> v >> u >> c1;
		v--; u--;
		a[v].push_back({ u, c1 });
		a[u].push_back({ v, c1 });
		mp[{v, u}] = c1;
		mp[{u, v}] = c1;
		vv[i] = { c1, { u, v } };
		c[min(u, v)] = c1;
	}
	vector<ll> d(n);
	for (ll i = 0; i < n; i++) {
		cin >> d[i];
		b[i] = d[i];
		if (d[i]) {
			ans.push_back(i);
		}
		else {
			ans.push_back(i);
			ans.push_back(i);
		}
	}
	for (ll i = 0; i < n; i++) {
		for (auto x : a[i]) {
			if (b[i] == 0 && b[x.v] == 0 && x.c == 1) {
				cout << "NO\n";
				return;
			}
			if (b[i] == 1 && b[x.v] == 1 && x.c == 0) {
				cout << "NO\n";
				return;
			}
		}
	}


	for (ll i = 0; i < 1000; i++) {
		random_device rd;
		mt19937 g(rd());
		shuffle(ans.begin(), ans.end(), g);
		vector<ll> col(n);
		map<pair<ll, ll>, ll> m;
		for (auto x : ans) {
			col[x] = 1 - col[x];
			for (auto y : a[x]) {
				if (col[y.v] == col[x]) {
					m[{x, y.v}] = col[x];
					m[{y.v, x}] = col[x];
				}
			}
		}
		bool f = true;
		for (auto x : mp) {
			if (m[x.first] != x.second) {
				f = false;
				break;
			}
		}
		if (f)
		{
			cout << "YES\n";
			cout << ans.size() << "\n";
			col.assign(n, 0);
			for (auto x : ans) {
				cout << x + 1 << " " << 1 - col[x] << "\n";
				col[x] = 1 - col[x];
			}
			return;
		}
	}
	cout << "NO\n";
}

void solveD() {
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n);
	vector<st> b(n);

	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		b[i] = { max(0ll, i - a[i]), min(n - 1, i + a[i]) };
	}
	sort(b.begin(), b.end());
	vector<ll> mxs(n);
	set<ll> s;
	for (ll i = 0; i < n; i++) {
		s.insert(b[i].l);
		mxs[b[i].l] = max(mxs[b[i].l], b[i].r);
	}
	for (ll i = 1; i < n; i++) {
		mxs[i] = max(mxs[i], mxs[i - 1]);
	}
	s.insert(n);
	vector<ll> t;
	for (auto x : s)
		t.push_back(x);


	for (ll i = 0; i < t.size() - 1; i++) {
		ll v = t[i + 1] - t[i];

	}

}

/*

1
6 6
1 2 1
1 5 1
4 5 1
2 3 0
2 4 0
5 6 0
1 0 0 1 0 1

*/

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	//cin >> t;
	while (t--) {
		solveC();
	}
}