#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <random>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()
mt19937 rnd(52);

vector<int> a, b, c, d;
vector<pair<int, int>> posl;
vector<vector<int>> edge;

void solve(int u, int p) {
	if (d[u] == 0) {
		posl.push_back({ u, 1 });
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (v == p) {
				continue;
			}
			if (c[i] == 0) {
				continue;
			}
			solve(v, u);
		}
		posl.push_back({ u, 0 });
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (v == p) {
				continue;
			}
			if (c[i] == 1) {
				continue;
			}
			solve(v, u);
		}
	} else {
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (v == p) {
				continue;
			}
			if (c[i] == 1) {
				continue;
			}
			solve(v, u);
		}
		posl.push_back({ u, 1 });
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (v == p) {
				continue;
			}
			if (c[i] == 0) {
				continue;
			}
			solve(v, u);
		}
	}
}

void solve() {
	edge.clear();
	posl.clear();
	int n, m; cin >> n >> m;
	edge.resize(n);
	a.resize(m);
	b.resize(m);
	c.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> a[i] >> b[i] >> c[i]; --a[i]; --b[i];
		edge[a[i]].push_back(i);
		edge[b[i]].push_back(i);
	}
	d.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < m; ++i) {
		if (c[i] == 1) {
			if (d[a[i]] + d[b[i]] == 0) {
				cout << "NO\n";
				return;
			}
		} else {
			if (d[a[i]] + d[b[i]] == 2) {
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n";
	solve(0, 0);
	cout << posl.size() << '\n';
	for (auto p : posl) {
		cout << p.first + 1 << ' ' << p.second << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
