#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <random>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()
mt19937 rnd(52);

vector<int> a, b, c, d, nw, dnw, used;
vector<pair<int, int>> posl;
vector<vector<int>> edge;

void turn_on(int u) {
	posl.push_back({ u, 1 });
	dnw[u] = 1;
	for (int i : edge[u]) {
		if (dnw[a[i]] == 1 && dnw[b[i]] == 1) {
			nw[i] = 1;
		}
	}
}

void turn_off(int u) {
	dnw[u] = 0;
	posl.push_back({ u, 0 });
	for (int i : edge[u]) {
		if (dnw[a[i]] == 0 && dnw[b[i]] == 0) {
			nw[i] = 0;
		}
	}
}

void solve(int u) {
	used[u] = 1;
	if (d[u] == 0) {
		turn_on(u);
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 0) {
				continue;
			}
			solve(v);
		}
		turn_off(u);
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 1) {
				continue;
			}
			solve(v);
		}
	} else {
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 1) {
				continue;
			}
			solve(v);
		}
		turn_on(u);
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 0) {
				continue;
			}
			solve(v);
		}
	}
}

int cn[(1 << 14)];
int lstch[(1 << 14)], fr[(1 << 14)];

void solve() {
	edge.clear();
	int n, m; cin >> n >> m;
	for (int mask = 0; mask < (1 << (n + m)); ++mask) {
		cn[mask] = 0;
	}
	edge.resize(n);
	a.resize(m);
	b.resize(m);
	c.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> a[i] >> b[i] >> c[i]; --a[i]; --b[i];
		edge[a[i]].push_back(i);
		edge[b[i]].push_back(i);
	}
	d.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	cn[0] = 1;
	vector<int> bfs = { 0 };
	for (int _ = 0; _ < (int)bfs.size(); ++_) {
		int msk = bfs[_];
		vector<int> dnw(n, 0);
		vector<int> nw(m, 0);
		for (int i = 0; i < n; ++i) {
			if ((1 & (msk >> i))) {
				dnw[i] = 1;
			}
		}
		for (int i = 0; i < m; ++i) {
			if ((1 & (msk >> (n + i)))) {
				nw[i] = 1;
			}
		}
		for (int ch = 0; ch < n; ++ch) {
			dnw[ch] ^= 1;
			vector<int> tb;
			for (int i = 0; i < m; ++i) {
				if (nw[i] == 1 && dnw[a[i]] == 0 && dnw[b[i]] == 0) {
					tb.push_back(i);
					nw[i] ^= 1;
				} else if (nw[i] == 0 && dnw[a[i]] == 1 && dnw[b[i]] == 1) {
					tb.push_back(i);
					nw[i] ^= 1;
				}
			}
			int mskn = 0;
			for (int i = 0; i < n; ++i) {
				if (dnw[i]) {
					mskn += (1 << i);
				}
			}
			for (int i = 0; i < m; ++i) {
				if (nw[i]) {
					mskn += (1 << (n + i));
				}
			}
			if (cn[mskn] == 0) {
				cn[mskn] = 1;
				lstch[mskn] = ch;
				fr[mskn] = msk;
				bfs.push_back(mskn);
			}
			dnw[ch] ^= 1;
			for (int i : tb) {
				nw[i] ^= 1;
			}
		}
	}
	int mskn = 0;
	for (int i = 0; i < n; ++i) {
		if (d[i]) {
			mskn += (1 << i);
		}
	}
	for (int i = 0; i < m; ++i) {
		if (c[i]) {
			mskn += (1 << (n + i));
		}
	}
	if (cn[mskn] == 0) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
		vector<int> tl, ws;
		while (mskn != 0) {
			tl.push_back(lstch[mskn]);
			ws.push_back((1 & (mskn >> (tl.back()))));
			mskn = fr[mskn];
		}
		reverse(all(tl));
		reverse(all(ws));
		cout << tl.size() << '\n';
		for (int i = 0; i < (int)tl.size(); ++i) {
			cout << tl[i] + 1 << ' ' << ws[i] << '\n';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
