#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <random>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()
mt19937 rnd(52);

vector<int> a, b, c, d, nw, dnw, used;
vector<pair<int, int>> posl;
vector<vector<int>> edge;

void turn_on(int u) {
	posl.push_back({ u, 1 });
	dnw[u] = 1;
	for (int i : edge[u]) {
		if (dnw[a[i]] == 1 && dnw[b[i]] == 1) {
			nw[i] = 1;
		}
	}
}

void turn_off(int u) {
	dnw[u] = 0;
	posl.push_back({ u, 0 });
	for (int i : edge[u]) {
		if (dnw[a[i]] == 0 && dnw[b[i]] == 0) {
			nw[i] = 0;
		}
	}
}

void solve(int u) {
	used[u] = 1;
	if (d[u] == 0) {
		turn_on(u);
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 0) {
				continue;
			}
			solve(v);
		}
		turn_off(u);
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 1) {
				continue;
			}
			solve(v);
		}
	} else {
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 1) {
				continue;
			}
			solve(v);
		}
		turn_on(u);
		for (int i : edge[u]) {
			int v = (u ^ a[i] ^ b[i]);
			if (used[v]) {
				continue;
			}
			if (c[i] == 0) {
				continue;
			}
			solve(v);
		}
	}
}

void solve() {
	edge.clear();
	posl.clear();
	nw.clear();
	used.clear();
	dnw.clear();
	int n, m; cin >> n >> m;
	edge.resize(n);
	a.resize(m);
	b.resize(m);
	c.resize(m);
	nw.resize(m, 0);
	used.resize(n, 0);
	dnw.resize(n, 0);
	for (int i = 0; i < m; ++i) {
		cin >> a[i] >> b[i] >> c[i]; --a[i]; --b[i];
		edge[a[i]].push_back(i);
		edge[b[i]].push_back(i);
	}
	d.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < m; ++i) {
		if (c[i] == 1) {
			if (d[a[i]] + d[b[i]] == 0) {
				cout << "NO\n";
				return;
			}
		} else {
			if (d[a[i]] + d[b[i]] == 2) {
				cout << "NO\n";
				return;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i] == 0) {
			solve(i);
		}
	}
	for (int i = 0; i < m; ++i) {
		if (nw[i] == 0 && c[i] == 1) {
			if (dnw[a[i]] == 0) {
				turn_on(a[i]);
				turn_off(a[i]);
			} else {
				turn_on(b[i]);
				turn_off(b[i]);
			}
		} else if (nw[i] == 1 && c[i] == 0) {
			if (dnw[a[i]] == 1) {
				turn_off(a[i]);
				turn_on(a[i]);
			} else {
				turn_off(b[i]);
				turn_on(b[i]);
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		if (nw[i] != c[i]) {
			cout << "NO\n";
			return;
		}
	}
	for (int i = 0; i < m; ++i) {
		if (nw[i] == 0 && c[i] == 1) {
			if (dnw[a[i]] == 0) {
				turn_on(a[i]);
				turn_off(a[i]);
			} else {
				turn_on(b[i]);
				turn_off(b[i]);
			}
		} else if (nw[i] == 1 && c[i] == 0) {
			if (dnw[a[i]] == 1) {
				turn_off(a[i]);
				turn_on(a[i]);
			} else {
				turn_off(b[i]);
				turn_on(b[i]);
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		if (nw[i] != c[i]) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	cout << posl.size() << '\n';
	for (auto p : posl) {
		cout << p.first + 1 << ' ' << p.second << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}