#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <random>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()
mt19937 rnd(52);

ll gthm(ll t1, ll t2, vector<ll>& prs, bool y) {
	//t1 <= t2
	ll mxs = prs.back();
	int L = -1, R = prs.size();
	while (L + 1 != R) {
		int mid = (L + R) / 2;
		if (prs[mid] * t2 < mxs * t1 || (y && prs[mid] * t2 == mxs * t1)) {
			L = mid;
		} else {
			R = mid;
		}
	}
	return L + 1LL + (ll)prs.size();
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	vector<ll> s(m), prs(m);
	for (int i = 0; i < m; ++i) {
		cin >> s[i];
	}
	for (int i = m - 2; i >= 0; --i) {
		s[i + 1] -= s[i];
	}
	prs[0] = s[0];
	for (int i = 1; i < m; ++i) {
		prs[i] = max(s[i], prs[i - 1]);
	}
	ll ans = 0;
	ll cnt21 = gthm(1, 2, prs, true);
	ll cnt22 = gthm(2, 2, prs, false);
	ll cnt11 = gthm(1, 1, prs, false);
	ll cnt12 = gthm(1, 2, prs, false);
	ll cnt1 = 0, cnt2 = 0;
	for (int k = 0; k < n; ++k) {
		if (t[k] == 1) {
			ans += cnt11 * cnt1 + cnt21 * cnt2;
			++cnt1;
		} else {
			ans += cnt12 * cnt1 + cnt22 * cnt2;
			++cnt2;
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
