#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <random>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()
mt19937 rnd(52);

vector<int> tree1, tree2;

ll gtsm1(int i, int l, int r, int lq, int rq) {
	if (rq <= l || r <= lq) {
		return 0;
	}
	if (lq <= l && r <= rq) {
		return tree1[i];
	}
	int mid = (l + r) / 2;
	return gtsm1(2 * i + 1, l, mid, lq, rq) + gtsm1(2 * i + 2, mid, r, lq, rq);
}

ll gtsm2(int i, int l, int r, int lq, int rq) {
	if (rq <= l || r <= lq) {
		return 0;
	}
	if (lq <= l && r <= rq) {
		return tree2[i];
	}
	int mid = (l + r) / 2;
	return gtsm2(2 * i + 1, l, mid, lq, rq) + gtsm2(2 * i + 2, mid, r, lq, rq);
}

void add1(int i, int l, int r, int q, int wh) {
	tree1[i] += wh;
	if (l + 1 == r) {
		return;
	}
	int mid = (l + r) / 2;
	if (q < mid) {
		add1(2 * i + 1, l, mid, q, wh);
	} else {
		add1(2 * i + 2, mid, r, q, wh);
	}
}

void add2(int i, int l, int r, int q, int wh) {
	tree2[i] += wh;
	if (l + 1 == r) {
		return;
	}
	int mid = (l + r) / 2;
	if (q < mid) {
		add2(2 * i + 1, l, mid, q, wh);
	} else {
		add2(2 * i + 2, mid, r, q, wh);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	vector<ll> s(m), prs(m);
	for (int i = 0; i < m; ++i) {
		cin >> s[i];
	}
	for (int i = m - 2; i >= 0; --i) {
		s[i + 1] -= s[i];
	}
	prs[0] = s[0];
	for (int i = 1; i < m; ++i) {
		prs[i] = max(s[i], prs[i - 1]);
	}
	vector<pair<ll, pair<int, int>>> sob;
	for (int i = 0; i < n; ++i) {
		sob.push_back({ prs[0] * t[i], {i, 0} });
		sob.push_back({ prs[1] * t[i], {i, 1} });
	}
	sort(all(sob));
	vector<int> f1(n), f2(n);
	tree1.resize(8 * n, 0);
	tree2.resize(8 * n, 0);
	for (int i = 0; i < 2 * n; ++i) {
		if (sob[i].second.second == 1) {
			f2[sob[i].second.first] = i;
		} else {
			f1[sob[i].second.first] = i;
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ll nd1 = gtsm1(0, 0, 2 * n, 0, f1[i]);
		ans += (ll)i - nd1;
		ll nd2 = gtsm1(0, 0, 2 * n, 0, f2[i]);
		ans += (ll)i - nd2;
		ans += 2LL * (ll)i - gtsm2(0, 0, 2 * n, f2[i], 2 * n);
		add1(0, 0, 2 * n, f2[i], 1);
		add2(0, 0, 2 * n, f1[i], 1);
		add2(0, 0, 2 * n, f2[i], 1);
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
