#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> edges(m);
    for (auto& [u, v, c] : edges){
        cin >> u>> v >> c;
        --u, --v;
    }
    vector<int> d(n);
    for (auto& i : d) cin >> i;
    vector<vector<int>> g(n);
    for (auto& [u, v, c] : edges) {
        if (d[u] == d[v]) {
            if (d[u] != c){
                cout << "NO\n";
                return;
            }
        } else {
            if (d[u] == 1) swap(u, v);
            if (c == 0) g[u].push_back(v);
            else g[v].push_back(u);
        }
    }
    vector<int> top;
    vector<int> used(n, 0);
    bool cycle = false;
    auto dfs = [&](auto dfs, int u) -> void {
        used[u] = 1;
        for (auto to : g[u]) {
            if (!used[to]) dfs(dfs, to);
            else if (used[to] == 1) cycle = true;
        }
        used[u] = 2;
        top.push_back(u);
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(dfs, i);
    }
    if (!cycle) cout << "YES\n-1\n";
    else cout << "NO\n";
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) solve();
}
