#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N = 1.5e5;
const int B = 390;

namespace sqrt1 {
    ll block[B], elem[N];

    void upd(int k, int x) {
        block[k / B] += x;
        elem[k] += x;
    }

    ll get(int k) {
        ll res = 0;
        int bl = k / B;
        for (int i = 0; i < bl; ++i) {
            res += block[i];
        }
        for (int i = bl * B; i <= k;++i) res += elem[i];
        return res;
    }
}

namespace sqrt2 {
    int elem[N], block[B];

    int get(int k) {
        return elem[k] + block[k / B];
    }

    void upd(int k, int x) {
        int bl = k / B + 1;
        for (int i = k; i < N && i < bl * B; ++i) elem[i] += x;
        for (int i = bl; i < B; ++i) block[i] += x;
    }
}

const int M = 550;

int pos[N][M];

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (auto &i: t) cin >> i;
    for (auto &i: s) cin >> i;
    for (int i = m - 1; i; --i) s[i] -= s[i - 1];
    vector<pair<int, int>> mx;
    for (int i = 0; i < m; ++i) {
        if (mx.empty() || mx.back().first < s[i]) mx.emplace_back(s[i], 1);
        else mx.back().second++;
    }
    m = mx.size();
    vector<int> ptr(n, m - 1);
    priority_queue<pair<ll, int>> pq;
    for (int i = 0; i < n; ++i) pq.emplace(1ll * t[i] * mx[ptr[i]].first, i);
    int num = n;
    while (pq.size()) {
        int id = pq.top().second;
        pq.pop();
        if (ptr[id] == m - 1) num--;
        pos[id][ptr[id]--] = num;
        if (ptr[id] >= 0) pq.emplace(1ll * t[id] * mx[ptr[id]].first, id);
    }
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        res += sqrt1::get(pos[i][m - 1]);
        for (int j = 0; j < m; ++j) {
            auto [x, y] = mx[j];
            res += 1ll * y * (i - sqrt2::get(pos[i][j] - 1));
            sqrt1::upd(pos[i][j], y);
        }
        sqrt2::upd(pos[i][m - 1], 1);
        cout << res << ' ';
    }
}