//#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N = 1e5;
const int B = 320;

namespace sqrt1 {
    ll block[B], elem[N];

    void upd(int k, int x) {
        assert(k / B < B);
        block[k / B] += x;
        elem[k] += x;
    }

    ll get(int k) {
        ll res = 0;
        int bl = k / B;
        assert(bl < B);
        for (int i = 0; i < bl; ++i) {
            res += block[i];
        }
        for (int i = bl * B; i <= k; ++i) res += elem[i];
        return res;
    }
}

namespace sqrt2 {
    int elem[N], block[B];

    int get(int k) {
        assert(k / B < B);
        return elem[k] + block[k / B];
    }

    void upd(int k, int x) {
        int bl = k / B + 1;
        assert(bl < B);
        for (int i = k; i < N && i < bl * B; ++i) elem[i] += x;
        for (int i = bl; i < B; ++i) block[i] += x;
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);


    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (auto &i: t) cin >> i;
    for (auto &i: s) cin >> i;
    for (int i = m - 1; i; --i) s[i] -= s[i - 1];
    vector<pair<int, int>> mx;
    for (int i = 0; i < m; ++i) {
        if (mx.empty() || mx.back().first < s[i]) mx.emplace_back(s[i], 1);
        else mx.back().second++;
    }
    m = mx.size();
    vector<ll> val;
    for (int i = 0; i < n; ++i) {
        val.emplace_back(1ll * t[i] * mx.back().first);
    }
    sort(val.begin(), val.end());
    val.resize(unique(val.begin(), val.end()) - val.begin());
    auto find = [&](ll x) {
        return lower_bound(val.begin(), val.end(), x) - val.begin();
    };
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        res += sqrt1::get(find(1ll * mx.back().first * t[i]));
        for (auto [x, y]: mx) {
            res += 1ll * y * (i - sqrt2::get(find(1ll * x * t[i] + 1) - 1));
            sqrt1::upd(find(1ll * x * t[i]), y);
        }
        sqrt2::upd(find(1ll * mx.back().first * t[i]), 1);
        cout << res << ' ';
    }
}