#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N = 1.5e5;
const int Q = 1.5e5 * 547;

namespace fenwick {
    int fenw[Q];

    void upd(int k, int x) {
        for (; k < Q; k |= k + 1) {
//            cout << k <<endl;
            fenw[k] += x;
        }
    }

    int get(int k) {
        int res = 0;
        for (; k >= 0; k &= k + 1, --k) res += fenw[k];
        return res;
    }
}
namespace fenwick2 {
    int fenw[N];
    int all = 0;

    void upd(int k, int x) {
        all += x;
        for (; k < N; k |= k + 1) fenw[k] += x;
    }

    int get(int k) {
        k--;
        int res = 0;
        for (; k >= 0; k &= k + 1, --k) res += fenw[k];
        return all - res;
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (auto &i: t) cin >> i;
    for (auto &i: s) cin >> i;
    for (int i = m - 1; i; --i) s[i] -= s[i - 1];
    vector<pair<int, int>> mx;
    for (int i = 0; i < m; ++i) {
        if (mx.empty() || mx.back().first < s[i]) mx.emplace_back(s[i], 1);
        else mx.back().second++;
    }
    m = mx.size();
    vector<pair<ll, int>> val_small, val_big;
    val_big.reserve(n * m);
    val_small.reserve(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            val_big.emplace_back(1ll * t[i] * mx[j].first, i);
        }
    }
    sort(val_big.begin(), val_big.end());
    for (int i = 0; i < n; ++i) {
        val_small.emplace_back(1ll * t[i] * mx.back().first, i);
    }
    sort(val_small.begin(), val_small.end());
//    cout << 111 << endl;
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        res += fenwick::get(upper_bound(val_big.begin(), val_big.end(), make_pair(1ll * mx.back().first * t[i], i)) -
                            val_big.begin() - 1);
//        cout << i << endl;
        for (auto [x, y]: mx) {
//            cout << i << ' ' << x << endl;
            res += 1ll * y * fenwick2::get(
                    lower_bound(val_small.begin(), val_small.end(), make_pair(1ll * x * t[i], i)) - val_small.begin());

//            cout << i << ' ' << x << endl;
            fenwick::upd(lower_bound(val_big.begin(), val_big.end(), make_pair(1ll * x * t[i], i)) - val_big.begin(), 1);
        }
//        cout << i << endl;
        fenwick2::upd(lower_bound(val_small.begin(), val_small.end(), make_pair(1ll * mx.back().first * t[i], i)) -
                      val_small.begin(), 1);
//        cout << i << endl;
        cout << res << ' ';
    }
}
