#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N_ = 1e5;
const int B = 330;

int N;

namespace sqrt1 {
    ll block[B], elem[N_];

    void upd(int k, int x) {
        block[k / B] += x;
        elem[k] += x;
    }

    ll get(int k) {
        ll res = 0;
        int bl = k / B;
        for (int i = 0; i < bl; ++i) {
            res += block[i];
        }
        for (int i = bl * B; i <= k; ++i) res += elem[i];
        return res;
    }
}

namespace sqrt2 {
    int elem[N_], block[B];

    int get(int k) {
        return elem[k] + block[k / B];
    }

    void upd(int k, int x) {
        int bl = k / B + 1;
        for (int i = k; i < N && i < bl * B; ++i) elem[i] += x;
        for (int i = bl; i * B < N; ++i) block[i] += x;
    }
}

const int A = 5e7 + 1;

int nxt[A];

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);


    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (auto &i: t) cin >> i;
    for (auto &i: s) cin >> i;
    for (int i = m - 1; i; --i) s[i] -= s[i - 1];
    vector<pair<ll, ll>> mx;
    for (int i = 0; i < m; ++i) {
        if (mx.empty() || mx.back().first < s[i]) mx.emplace_back(s[i], 1);
        else mx.back().second++;
    }
    m = mx.size();
    ll ss = mx.back().first;
    vector<int> val;
    for (int i = 0; i < n; ++i) {
        val.push_back(t[i]);
    }
    sort(val.begin(), val.end());
    val.resize(unique(val.begin(), val.end()) - val.begin());
    fill(nxt, nxt + A, -1);
    int mn = -1;
    for (int i = 0; i < val.size(); ++i) {
        if (val[i] >= A) {
            if (mn == -1 || val[mn] > val[i]) mn = i;
        } else {
            nxt[val[i]] = i;
        }
    }
    for (int i = A - 1; i >= 0; --i) {
        if (nxt[i] != -1) mn = nxt[i];
        nxt[i] = mn;
    }
    auto find = [&](int x) -> int {
        if (x >= A) return lower_bound(val.begin(), val.end(), x) - val.begin();
        else return nxt[x];
    };
    N = val.size();
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        int k = find(t[i]);
        res += sqrt1::get(k);
        for (auto [x, y]: mx) {
            int q = find((x * t[i] + ss - 1) / ss);
            sqrt1::upd(q, y);
            if (val[q] * ss == x * t[i]) q++;
            res += y * (i - sqrt2::get(q - 1));
        }
        sqrt2::upd(k, 1);
        cout << res << ' ';
    }
}