//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N_ = 1e5;
const int B = 330;

int N;

namespace sqrt1 {
    ll block[B], elem[N_];

    void upd(int k, int x) {
        block[k / B] += x;
        elem[k] += x;
    }

    ll get(int k) {
        ll res = 0;
        int bl = k / B;
        for (int i = 0; i < bl; ++i) {
            res += block[i];
        }
        for (int i = bl * B; i <= k; ++i) res += elem[i];
        return res;
    }
}

namespace sqrt2 {
    int elem[N_], block[B];

    int get(int k) {
        return elem[k] + block[k / B];
    }

    void upd(int k, int x) {
        int bl = k / B + 1;
        for (int i = k; i < N && i < bl * B; ++i) elem[i] += x;
        for (int i = bl; i * B < N; ++i) block[i] += x;
    }
}

const int K = 600;

int pos[N_][K];

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);


    int n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m);
    for (auto &i: t) cin >> i;
    for (auto &i: s) cin >> i;
    for (int i = m - 1; i; --i) s[i] -= s[i - 1];
    vector<pair<ll, ll>> mx;
    for (int i = 0; i < m; ++i) {
        if (mx.empty() || mx.back().first < s[i]) mx.emplace_back(s[i], 1);
        else mx.back().second++;
    }
    m = mx.size();
    ll ss = mx.back().first;
    vector<ll> val;
    for (int i = 0; i < n; ++i) {
        val.push_back(t[i]);
    }
    sort(val.begin(), val.end());
    val.resize(unique(val.begin(), val.end()) - val.begin());
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int i, int j) {
        return t[i] < t[j];
    });
    for (int c = 0; c < m; ++c) {
        int j = 0;
        for (auto i : p) {
            while (val[j] * ss < t[i] * mx[c].first) ++j;
            pos[i][c] = j;
        }
    }
    N = val.size();
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        int k = pos[i][m - 1];
        res += sqrt1::get(k);
        for (int j = 0; j < m; ++j) {
            auto [x, y] = mx[j];
            int q = pos[i][j];
            sqrt1::upd(q, y);
            if (val[q] * ss == x * t[i]) q++;
            res += y * (i - sqrt2::get(q - 1));
        }
        sqrt2::upd(k, 1);
        cout << res << ' ';
    }
}