#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define forn(i, n) for (int i = 0; i < n; ++i)
 
 
struct To {
    int to;
    bool c;
 
    To(int _to, bool _c) : to(_to), c(_c) {}
};
 
 
struct Edge {
    int v1, v2;
    bool c;
 
    Edge(int _v1, int _v2, bool _c) : v1(_v1), v2(_v2), c(_c) {}
};
 
 
vector<vector<To>> g;
vector<Edge> edges;
vector<int> cmp;
vector<pair<int, int>> ans;
vector<bool> arr, cur_arr;
 
void clear_arrays() {
    g.clear();
    edges.clear();
    cmp.clear();
    ans.clear();
    arr.clear();
    cur_arr.clear();
}
 
 
bool dfs(int v, bool c, int cur_cmp) {
    cmp[v] = cur_cmp;
 
    for (auto& [to, ec] : g[v]) {
        if (ec == c) {
            continue;
        }
        if (arr[to] == c) {
            return false;
        }
        if (cmp[to] == cur_cmp) {
            return false;
        }
        if (!cmp[to]) {
            if(!dfs(to, (c ^ 1), cur_cmp)) {
                return false;
            }
        }
    }

    if (arr[v]) {
        ans.push_back({v, 1});
    } else {
        ans.push_back({v, 1});
        ans.push_back({v, 0});
    }
    return true;
}
 
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
 
    int t;
    cin >> t;
 
    forn(_, t) {
        int n, m;
        cin >> n >> m;
 
        g.resize(n);
        cmp.resize(n, 0);
        forn(i, m) {
            int v1, v2;
            bool c;
            cin >> v1 >> v2 >> c;
            --v1, --v2;
            g[v1].push_back(To(v2, c));
            g[v2].push_back(To(v1, c));
            edges.push_back(Edge(v1, v2, c));
        }
 
        arr.resize(n);
        cur_arr.resize(n);
        forn(i, n) {
            bool d;
            cin >> d;
            arr[i] = d;
        }
 
        bool check = true;
        int cur_cmp = 1;
        forn(i, n) {
            if (!cmp[i] && !dfs(i, arr[i], cur_cmp)) {
                cout << "NO\n";
                check = false;
                break;
            }
            ++cur_cmp;
        }
 
        if (check) {
            cout << "YES\n";
            cout << ans.size() << '\n';
            for (auto [i, op] : ans) {
                cout << i + 1 << ' ' << op << '\n';
            }
        }
 
        clear_arrays();
    }
 
    return 0;
}