#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename t>
using orderet_set = tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename t, typename v>
using table = gp_hash_table<t, v>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using uint = unsigned int;

#define int ll

vector<vector<int>> g;
vector<int> color;
vector<int> t;
vector<pair<int, int>> ans;
map<pair<int, int>, int> need, have;

void dfs(int v, int p = -1) {
    color[v] = 1;
    ans.push_back({v, 1});
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v);
            if (color[v] == color[u]) {
                have[{u, v}] = color[v];
                have[{v, u}] = color[v];
            }
            if (need[{v, u}] == 0) {
                have[{v, u}] = 0;
                have[{u, v}] = 0;
                ans.push_back({u, 0});
                ans.push_back({v, 0});
                ans.push_back({v, 1});
                ans.push_back({u, color[u]});
            } else {
                have[{v, u}] = 1;
                have[{v, u}] = 1;
                have[{u, v}] = 1;
                ans.push_back({u, 1});
                ans.push_back({u, color[u]});
            }
        }
    }
    ans.push_back({v, t[v]});
    color[v] = t[v];
    for (auto u: g[v]) {
        if (u == p) continue;
        if (color[v] == color[u]) {
            have[{u, v}] = color[u];
            have[{v, u}] = color[v];
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    t.assign(n, 0);
    ans.assign(0, {0, 0});
    color.assign(n, 0);
    need.clear();
    have.clear();
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        need[{u, v}] = c;
        need[{v, u}] = c;
        have[{u, v}] = 0;
        have[{u, v}] = 0;
    }
    for (int i = 0; i < n; ++i) ans.push_back({i, 0});
    for (int i = 0; i < n; ++i)cin >> t[i];
    dfs(0);
    for (auto c: have) {
        if (need[c.first] != c.second) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [a, b]: ans) {
        cout << a + 1 << " " << b << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
    //stress();
}