#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Robot {
    ll x;
    ll p;
    int d;

    Robot() {};

    Robot(ll x, ll p, int d) : x(x), p(p), d(d) {};
};

int main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    int n;
    cin >> n;
    vector<Robot> robots(n);
    for (auto &r: robots)
        cin >> r.x >> r.p >> r.d;

    vector<bool> ok_right(n, false);

    ok_right[0] = true; // count of segments that goes to the right

    for (int i = 1; i < n; ++i)
        ok_right[i] = ok_right[i - 1] && (robots[i - 1].p >= robots[i].x - robots[i - 1].x);

//    for (bool x: ok_right) cout << x << ' ';
//    cout << endl;

    vector<bool> ok_left(n, false);

    ok_left[0] = true;

    for (int i = 1; i < n; ++i) {
        int cur = n - i;
        int next = cur - 1;
        ok_left[i] = ok_left[i - 1] && (robots[cur].p >= robots[cur].x - robots[next].x);
    }

//    for (bool x: ok_left) cout << x << ' ';
//    cout << endl;

    int ans = 1000000;
    if (ok_right[n - 1]) {
        int res = 0;
        for (auto r: robots)
            if (r.d == -1) res++;
        ans = min(ans, res);
    }
    if (ok_left[n - 1]) {
        int res = 0;
        for (auto r: robots)
            if (r.d == 1) res++;
        ans = min(ans, res);
    }

    int right = 0;
    int left = n - 2 - right;

    int to_swap = 0;
    for (int i = 0; i < n; ++i)
        if (robots[i].d == 1) to_swap++;

    while (right < n - 1) {
        // make robot[right] facing right
        if (robots[right].d == -1) to_swap++;
        else to_swap--;

//        cout << robots[right + 1].x << ' ' << robots[right].x << ' ' << robots[right + 1].p << ' ' << robots[right].p
//             << endl;

        if (robots[right + 1].x - robots[right].x <= robots[right + 1].p + robots[right].p)
            if (ok_right[right] && ok_left[left]) {
//                cout << right << ' ' << left << endl;
                ans = min(ans, to_swap);
            }

        right++;
        left--;
    }


    if (ans == 1000000) cout << -1 << endl;
    else cout << ans << endl;


    return 0;
}
