#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct edge {
    int a, b, c;

    edge() {};

    int to(int x) {
        if (x == a) return b;
        return a;
    };
};

struct vertex {
    int deg = 0;
    set<int> edges;
    int c;

    vertex() {};
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vertex> vertexes(n);
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        edge e;
        cin >> e.a >> e.b >> e.c;
        --e.a;
        --e.b;
        edges.push_back(e);
        vertexes[e.a].deg++;
        vertexes[e.a].edges.insert(i);
        vertexes[e.b].deg++;
        vertexes[e.b].edges.insert(i);
    }

    vector<pair<int, int>> start;
    vector<pair<int, int>> finish;

    set<pair<int, int>> deg_and_vert;

    for (int i = 0; i < n; ++i) deg_and_vert.insert({vertexes[i].deg, i});

    for (int i = 0; i < n; ++i) cin >> vertexes[i].c;

    for (int i = 0; i < n; ++i) {
        for (int e: vertexes[i].edges) {
            int u = edges[e].to(i);
            int ec = edges[e].c, ic = vertexes[i].c, uc = vertexes[u].c;
            start.emplace_back(i, ic);
            start.emplace_back(u, ic);
            finish.emplace_back(u, uc);
        }
    }
    cout << "YES\n";
    cout << start.size() + finish.size() << '\n';
    for (auto [u, c]: start) cout << u << ' ' << c << '\n';
    std::reverse(finish.begin(), finish.end());
    for (auto [u, c]: finish) cout << u << ' ' << c << '\n';
}

int main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
