#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct edge {
    int a, b, c;

    edge() {};

    int other(int x) {
        if (x == a) return b;
        return a;
    };
};

struct vertex {
    int deg = 0;
    set<int> edges;
    int c;
    int c0 = 0;
    int c1 = 0;

    vertex() {};

    void add_edge(int e, int ec) {
        deg++;
        edges.insert(e);
        if (ec == 0) c0++;
        else c1++;
    }

    void remove_edge(int e, int ec) {
        deg--;
        edges.erase(e);
        if (ec == 0) c0--;
        else c1--;
    }

    bool good() {
        return (c0 == 0) || (c1 == 0);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vertex> vertexes(n);
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        edge e;
        cin >> e.a >> e.b >> e.c;
        --e.a;
        --e.b;
        edges.push_back(e);
        vertexes[e.a].add_edge(i, e.c);
        vertexes[e.b].add_edge(i, e.c);
    }

    vector<pair<int, int>> start;
    vector<pair<int, int>> finish;

    set<int> vert;


    for (int i = 0; i < n; ++i) cin >> vertexes[i].c;

    for (int i = 0; i < n; ++i)
        if (vertexes[i].good()) vert.insert(i);

//    for (int i = 0; i < m; ++i) {
//        int ec = edges[i].c, ac = vertexes[edges[i].a].c, bc = vertexes[edges[i].b].c;
//        if (ec != ac && ec != bc) {
//            cout << "NO\n";
//            return;
//        }
//    }
//    cout << "YES\n";
//    cout << 2 * n << "\n";
//    for (int i = 0; i < n; ++i) cout << i + 1 << ' ' << 1 << '\n';
//    for (int i = 0; i < n; ++i) cout << i + 1 << ' ' << vertexes[i].c << '\n';
//    return;
    int cnt = 0;
    while (!vert.empty()) {
        cnt++;
        auto i = *vert.begin();
//        cout << deg << ' ' << i << endl;
        auto v = vertexes[i];
        if (v.deg == 0) {
            start.emplace_back(i, vertexes[i].c);
            break;
        }
        vert.erase(i);
        for (int e_id: vertexes[i].edges) {
//        cout << e_id << endl;
            int u = edges[e_id].other(i);
//        cout << u << endl;
            vertexes[u].deg--;
            vertexes[u].edges.erase(e_id);
            if (vertexes[u].good())
                vert.insert(u);
            int ec = edges[e_id].c, ic = vertexes[i].c, uc = vertexes[u].c;
            if (ec != ic && ec != uc) {
                cout << "NO\n";
                return;
            }
            start.emplace_back(i, ec);
            start.emplace_back(u, ec);
            finish.emplace_back(i, ic);
        }
    }
    if (cnt != n) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
//    cout << -1 << '\n';
    cout << start.size() + finish.size() << "\n";
    for (auto [u, c]: start) cout << u + 1 << ' ' << c << '\n';
    std::reverse(finish.begin(), finish.end());
    for (auto [u, c]: finish) cout << u + 1 << ' ' << c << '\n';

}

int main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}