#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct edge {
    int a, b, c;

    edge() {};

    int other(int x) {
        if (x == a) return b;
        return a;
    };
};

struct vertex {
    int deg = 0;
    set<int> edges;
    int c;
    int c0 = 0;
    int c1 = 0;

    vertex() {};

    void add_edge(int e, int ec) {
        deg++;
        edges.insert(e);
        if (ec == 0) c0++;
        else c1++;
    }

    void remove_edge(int e, int ec) {
        deg--;
        edges.erase(e);
        if (ec == 0) c0--;
        else c1--;
    }

    bool good() {
        return (c0 == 0) || (c1 == 0);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vertex> vertexes(n);
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        edge e;
        cin >> e.a >> e.b >> e.c;
        --e.a;
        --e.b;
        edges.push_back(e);
        vertexes[e.a].add_edge(i, e.c);
        vertexes[e.b].add_edge(i, e.c);
    }

    for (int i = 0; i < n; ++i) cin >> vertexes[i].c;


    for (int i = 0; i < m; ++i) {
        int ec = edges[i].c, ac = vertexes[edges[i].a].c, bc = vertexes[edges[i].b].c;
        if (ec != ac && ec != bc) {
            cout << "NO\n";
            return;
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; ++i) {
        ans.emplace_back(i, vertexes[i].c);
        for (int e: vertexes[i].edges) {
            int u = edges[e].other(i);
            if (u < i) continue;
            ans.emplace_back(u, vertexes[i].c);
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [u, c]: ans) cout << u + 1 << ' ' << c << '\n';
}

int main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}