#include <bits/stdc++.h>

using i64 = long long;

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> adj(n);
    std::vector<std::pair<int, int>> good, bad;
    std::map<std::pair<int, int>, int> on, goal;
    for (int i = 0; i < m; i++) {
        int v, u, c;
        std::cin >> v >> u >> c;
        v--, u--;
        adj[v].emplace_back(u);
        adj[u].emplace_back(v);
        on[std::make_pair(v, u)] = on[std::make_pair(u, v)] = 0;
        goal[std::make_pair(v, u)] = goal[std::make_pair(u, v)] = c;
        if (c == 1) {
            good.emplace_back(v, u);
        } else {
            bad.emplace_back(v, u);
        }
    }
    std::vector<int> d(n);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i];
    }
    std::vector<int> vis(n, 0);
    std::vector<std::pair<int, int>> res;
    auto paint = [&](auto self, int v, int c) -> void {
        if (vis[v] == c) {
            return;
        }
        res.emplace_back(v, c);
        vis[v] = c;
        for (int u : adj[v]) {
            if (vis[u] == c) {
                on[std::make_pair(v, u)] = on[std::make_pair(u, v)] = c;
                if (c == 0 && goal[std::make_pair(v, u)] == 1) {
                    self(self, v, 1);
                    self(self, u, 1);
                    self(self, v, 0);
                }
            }
        }
    };
    for (auto [v, u] : good) {
        paint(paint, v, 1);
        paint(paint, u, 1);
    }
    for (auto [v, u] : bad) {
        if (on[std::make_pair(v, u)] == 0) {
            continue;
        }
        if (on[std::make_pair(v, u)]) {
            paint(paint, v, 0);
            paint(paint, u, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        paint(paint, i, d[i]);
    }
    for (auto [v, u] : good) {
        if (!on[std::make_pair(v, u)]) {
            std::cout << "NO\n";
            return;
        }
    }
    for (auto [v, u] : bad) {
        if (on[std::make_pair(v, u)]) {
            std::cout << "NO\n";
            return;
        }
    }
    std::cout << "YES\n";
    std::cout << (int) res.size() << "\n";
    for (auto [v, c] : res) {
        std::cout << v + 1 << " " << c << "\n";
    }
}

signed main() {
    int t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
}
