#pragma GCC optimize("Ofast")
#include <bits/extc++.h>

using i64 = long long;

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> adj(n);
    std::vector<std::pair<int, int>> good, bad;
    std::vector<std::unordered_map<int, int>> on(n), goal(n);
    for (int i = 0; i < m; i++) {
        int v, u, c;
        std::cin >> v >> u >> c;
        v--, u--;
        adj[v].emplace_back(u);
        adj[u].emplace_back(v);
        on[std::min(v, u)][std::max(v, u)] = 0;
        goal[std::min(v, u)][std::max(v, u)] = c;
        if (c == 1) {
            good.emplace_back(v, u);
        } else {
            bad.emplace_back(v, u);
        }
    }
    std::vector<int> d(n);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i];
    }
    std::vector<int> vis(n, 0);
    std::vector<std::pair<int, int>> res;
    int phase = 0;
    std::vector<std::unordered_map<int, int>> got(n);
    auto paint = [&](auto self, int v, int c) -> void {
        if (vis[v] == c) {
            return;
        }
        if (got[v][phase] > 1) {
            return;
        }
        got[v][phase]++;
        for (int u : adj[v]) {
            if (vis[u] == c && goal[std::min(v, u)][std::max(v, u)] != c) {
                self(self, u, c ^ 1);
            }
        }
        res.emplace_back(v, c);
        vis[v] = c;
        for (int u : adj[v]) {
            if (vis[v] == vis[u]) {
                on[std::min(v, u)][std::max(v, u)] = c;
            }
        }
    };
    for (int iter = 0; iter < 2; iter++) {
        for (auto [v, u]: good) {
            if (d[v] == 0 && d[u] == 0) {
                std::cout << "NO\n";
                return;
            }
            if (!on[v][u]) {
                phase++;
                paint(paint, v, 1);
                phase++;
                paint(paint, u, 1);
            }
        }
        for (auto [v, u]: bad) {
            if (d[v] == 1 && d[u] == 1) {
                std::cout << "NO\n";
                return;
            }
            if (on[v][u]) {
                phase++;
                paint(paint, v, 0);
                phase++;
                paint(paint, u, 0);
            }
        }
        for (int i = 0; i < n; i++) {
            phase++;
            paint(paint, i, d[i]);
        }
    }
    for (auto [v, u] : good) {
        if (!on[v][u]) {
            std::cout << "NO\n";
            return;
        }
    }
    for (auto [v, u] : bad) {
        if (on[v][u]) {
            std::cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i] != vis[i]) {
            std::cout << "NO\n";
            return;
        }
    }
    std::cout << "YES\n";
    std::cout << (int) res.size() << "\n";
    for (auto [v, c] : res) {
        std::cout << v + 1 << " " << c << "\n";
    }
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
}