#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int R = 1 << 13;

struct Tree {
    vector<int> t, psh;

    Tree() {
        psh.resize(R * 2, -1);
        t.resize(R * 2, -1);
    }

    void push(int node) {
        for (int i = node * 2; i <= node * 2 + 1; ++i) {
            psh[i] = max(psh[i], psh[node]), t[i] = max(t[i], psh[node]);
        }
    }

    void go(int node = 1) {
        if (node >= R) return;
        push(node);
        go(node * 2), go(node * 2 + 1);
    }

    void update(int ql, int qr, int val, int node = 1, int nl = 1, int nr = R) {
        if (ql <= nl && nr <= qr) {
            t[node] = max(t[node], val);
            psh[node] = max(psh[node], val);
            return;
        }
        if (qr < nl || nr < ql) {
            return;
        }
        push(node);
        int nm = (nr + nl) / 2;
        update(ql, qr, val, node * 2, nl, nm);
        update(ql, qr, val, node * 2 + 1, nm + 1, nr);
        t[node] = max(t[node * 2], t[node * 2 + 1]);
    }
};

ll get(vector<int> a) {
    int n = a.size();
    vector<int> mx(n + 1, -1);
    Tree tree;
    for (int i = 1; i <= n; ++i) {
        tree.update(max(1, i - a[i - 1]), min(n, i + a[i - 1]), min(n, i + a[i - 1]), 1, 1, R);
    }
    tree.go();
    for (int i = 1; i <= n; ++i) {
        mx[i] = tree.t[i + R - 1];
    }
    assert(is_sorted(mx.begin(), mx.end()));
    ll ans = 0;
    vector<int> go(n + 1);
    for (int i = 1; i <= n; ++i) {
        go[i] = mx[i] + 1;
    }
    deque<pair<int, int>> d;
    for (int i = 1; i <= n; i = go[i]) {
        d.emplace_back(i, go[i] - 1);
    }
    for (int s = 1; s <= n; ++s) {
        ll sm = 1;
//        while (!d.empty() && d.front().second < go[s]) d.pop_front();
//        for (auto &[l, r] : d) {
//            ans += (r - l + 1) * (sm++);
//        }
        for (auto &[l, r] : d) {
            if (l > s) {
                ans += (r - l + 1) * (sm++);
            }
        }
//        for (int t = go[s]; t <= n; t = go[t]) {
//            ans += 1LL * (go[t] - t) * sm, ++sm;
//        }
    }
    return ans;
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    ll mn = get(a);
    for (int i = 0; i < n; ++i) {
        int pa = a[i];
        a[i] = x;
        mn = min(mn, get(a));
        a[i] = pa;
    }
    cout << mn;
}