#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

int n, m;

struct border {
    int a, b;
    bool lightMust;
    border(int _a, int _b, bool _lightMust) {
        a = _a;
        b = _b;
        lightMust = _lightMust;
    }
    border() {}
    int get(int v) {
        return a == v ? b : a;
    }
};

vector<border> borders;
vector<bool> lightsV, used;
vector<vector<int>> g;

vector<pair<int, int>> operations;

void logIt(int v, int color) {
    operations.push_back({v, color});
}

void dfs(int v, int p = -1) {
    used[v] = true;
    logIt(v, lightsV[v]);
    for (auto& toId : g[v]) {
        int to = borders[toId].get(v);
        if (to == p) continue;
        logIt(to, lightsV[v]);
        dfs(to, v);
    }
}

inline void work() {
    cin >> n >> m;
    operations.clear();
    borders.assign(m, border());
    lightsV.assign(n, false);
    g.assign(n, vector<int>());
    used.assign(n, false);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        g[a].push_back(i);
        borders[i] = border(a, b, c);
    }
    for (int i = 0; i < n; ++i) {
        int d;
        cin >> d;
        lightsV[i] = d;
    }
    for (auto& b : borders) {
        if (lightsV[b.a] == lightsV[b.b] && b.lightMust != lightsV[b.a]) {
            cout << "NO" << endc;
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, -1);
        }
    }
    cout << "YES" << endc;
    cout << operations.size() << endc;
    for (int i = 0; i < operations.size(); ++i) {
        cout << operations[i].first+1 << ' ' << operations[i].second << endc;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) work();
    return 0;
}
