#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

int n, m;

struct border {
    int a, b;
    bool lightMust;
    border(int _a, int _b, bool _lightMust) {
        a = _a;
        b = _b;
        lightMust = _lightMust;
    }
    border() {}
    int get(int v) {
        return a == v ? b : a;
    }
};

vector<border> borders;
vector<bool> lightsV;
vector<vector<int>> g;

vector<pair<int, int>> operations;

void logIt(int v, int color) {
    operations.push_back({v, color});
}

map<pair<vector<bool>, vector<bool>>, bool> used;

void slow(pair<vector<bool>, vector<bool>> now) {
    used[now] = true;
    auto change = [&] (pair<vector<bool>, vector<bool>> next, int x) {
        next.first[x] = !next.first[x];
        for (auto& toId : g[x]) {
            int to = borders[toId].get(x);
            if (next.first[to] == next.first[x]) {
                next.second[toId] = next.first[to];
            }
        }
        return next;
    };
    for (int i = 0; i < n; ++i) {
        auto res = change(now, i);
        if (!used[res]) slow(res);
    }
}

inline void work() {
    cin >> n >> m;
    operations.clear();
    borders.assign(m, border());
    lightsV.assign(n, false);
    used.clear();
    g.assign(n, vector<int>());
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        g[a].push_back(i);
        g[b].push_back(i);
        borders[i] = border(a, b, c);
    }
    for (int i = 0; i < n; ++i) {
        int d;
        cin >> d;
        lightsV[i] = d;
    }
    for (auto& b : borders) {
        if (lightsV[b.a] == lightsV[b.b] && b.lightMust != lightsV[b.a]) {
            cout << "NO" << endc;
            return;
        }
    }
    vector<bool> iniV = vector<bool>(n, false), iniB = vector<bool>(m, false);
    slow({iniV, iniB});
    vector<bool> needB(m, false);
    for (int i = 0; i < m; ++i) needB[i] = borders[i].lightMust;
    if (used[{lightsV, needB}]) {
        cout << "YES" << endc;
        cout << -1 << endc;
        /*cout << operations.size() << endc;
        for (int i = 0; i < operations.size(); ++i) {
            cout << operations[i].first + 1 << ' ' << operations[i].second << endc;
        }*/
    } else {
        cout << "NO" << endc;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) work();
    return 0;
}
