#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
const char endc = '\n';

int n, m;

struct border {
    int a, b;
    bool lightMust;
    border(int _a, int _b, bool _lightMust) {
        a = _a;
        b = _b;
        lightMust = _lightMust;
    }
    border() {}
    int get(int v) {
        return a == v ? b : a;
    }
};

vector<border> borders;
vector<bool> lightsV;
vector<vector<int>> g;

vector<pair<int, int>> operations;

void logIt(int v, int color) {
    operations.push_back({v, color});
}

unordered_map<int, bool> used;
gp_hash_table<int, int> fff;

inline bool bi(int x, int pos) {
    return (x >> pos) & 1;
}

int key = 0;

bool slow(int now) {
    used[now] = true;
    if (now == key) return true;
    auto change = [&] (int next, int x) {
        next ^= (1 << x);
        for (auto& toId : g[x]) {
            int to = borders[toId].get(x);
            if (bi(next, to) == bi(next, x)) {
                next |= (1 << (toId + n));
                if (!bi(next, to)) {
                    next ^= (1 << (toId + n));
                }
            }
        }
        return next;
    };
    for (int i = 0; i < n; ++i) {
        auto res = change(now, i);
        if (!used[res]) {
            if (slow(res)) {
                logIt(i, bi(res, i));
                return true;
            }
        }
    }
    return false;
}

inline void work() {
    cin >> n >> m;
    operations.clear();
    borders.assign(m, border());
    lightsV.assign(n, false);
    used.clear();
    g.assign(n, vector<int>());
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        g[a].push_back(i);
        g[b].push_back(i);
        borders[i] = border(a, b, c);
    }
    for (int i = 0; i < n; ++i) {
        int d;
        cin >> d;
        lightsV[i] = d;
    }
    for (auto& b : borders) {
        if (lightsV[b.a] == lightsV[b.b] && b.lightMust != lightsV[b.a]) {
            cout << "NO" << endc;
            return;
        }
    }
    key = 0;
    for (int i = 0; i < n; ++i) key |= lightsV[i] << i;
    for (int i = 0; i < m; ++i) key |= borders[i].lightMust << (n + i);
    if (slow(0)) {
        cout << "YES" << endc;
        cout << operations.size() << endc;
        reverse(operations.begin(), operations.end());
        for (auto& e : operations) cout << e.first+1 << ' ' << e.second << endc;
    } else {
        cout << "NO" << endc;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) work();
    return 0;
}