#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

ll n, m;
vector<ll> invspeed, portals;

inline vector<ll> work1() {
    vector<int> goTo(m);
    ll lastMoment = -1;
    for (int i = 0; i < m;) {
        int j = i+1;
        int deltaFix = portals[i+1] - portals[i];
        while (j+1 < m && portals[j+1] - portals[j] <= deltaFix) j++;
        for (int k = i; k < j; ++k) goTo[k] = j;
        if (j == m-1) lastMoment = i;
        i = j;
    }
    vector<ll> toret;
    for (ll len = 1; len <= n; ++len) {
        ll answer = 0;
        answer += lastMoment * len * (len - 1);
        ll suff = m - 1 - lastMoment;
        answer += (len * (len - 1)) / 2 * suff;
        toret.push_back(answer);
    }
    return toret;
}

inline vector<ll> work2() {
    vector<int> goTo(m);
    for (int i = 0; i < m;) {
        int j = i+1;
        while (j+1 < m && portals[j+1] - portals[j] <= portals[j] - portals[j-1]) j++;
        for (int k = i; k < j; ++k) goTo[k] = j;
        i = j;
    }
    vector<ll> toret;
    for (int len = 1; len <= n; ++len) {
        set<pair<ll, int>> bests;
        vector<int> nowIds(len, 0);
        for (int i = 0; i < len; ++i) bests.insert({portals[1] * invspeed[i], i});
        ll answer = 0, free = len;
        while (bests.size() > 0) {
            auto [dist, v] = *bests.begin();
            bests.erase(bests.begin());
            int toVertex = goTo[nowIds[v]];
            ll subStations = toVertex - nowIds[v];
            answer += subStations * (free-1);
            nowIds[v] = toVertex;
            if (nowIds[v] == m-1) {
                free--;
            } else {
                ll deltaDist = portals[nowIds[v]+1] - portals[nowIds[v]];
                bests.insert({deltaDist * invspeed[v], v});
            }
        }
        toret.push_back(answer);
    }
    return toret;
}

inline void work() {
    cin >> n >> m;
    invspeed.assign(n, -1), portals.assign(m+1, 0);
    for (auto& e : invspeed) cin >> e;
    for (int i = 0; i < m; ++i) cin >> portals[i+1];
    ++m;
    auto ans1 = work1();
    for (auto& e : ans1) {
        cout << e << endc;
    }
}

void testgen() {
    for (int test = 0; test < 1000; ++test) {
        n = (rand() % 3) + 1, m = ((rand() % 3) + 2);
        invspeed.assign(n, (rand() % 100) + 1);
        portals.clear();
        set<int> ports;
        ports.insert(0);
        while (ports.size() < m) ports.insert((rand() % 100) + 1);
        for (auto& e : ports) portals.push_back(e);
        auto ans1 = work1();
        auto ans2 = work2();
        if (ans1 == ans2) {
            cout << "OK" << endc;
        } else {
            cout << "WA" << endc;
            cout << n << ' ' << m-1 << endc;
            for (int i = 0; i < n; ++i) {
                cout << invspeed[i] << ' ';
            }
            cout << endc;
            for (int i = 1; i < m; ++i) {
                cout << portals[i] << ' ';
            }
            exit(-1);
        }
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t --> 0) work();
    return 0;
}
