#include<bits/stdc++.h>

using ll = long long;
using dbl = double;
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<endl
#else
#define debug(x)
#endif

#define all(x) x.begin(),x.end()

const ll INF = 1e9;

struct Graph {
    int n;
    vector<vector<int>> g;
    Graph(vector<vector<int>> g_): g(g_) {
        n = g.size();
        used.assign(n, 0);
    }

    vector<int> used;

    bool have_cycle() {
        used.assign(n, 0);
        for (int v = 0; v < n; ++v) {
            if (used[v] == 0) {
                if (cycle(v, v)) return 1;
            }
        }

        return 0;
    }

    bool cycle(int v, int p) {
        // debug(v);

        if (used[v] == 1) return 1;
        else if (used[v] == 2) return 0;
        used[v] = 1;

        for (auto u : g[v]) {
            if (cycle(u, v)) return 1;
        }

        used[v] = 2;
        return 0;
    }

    void top_sort_dfs(int v, vector<int>& ans) {
        // debug(v);
        used[v] = 1;
        for (int u : g[v]) {
            if (used[u] != 0) continue;
            top_sort_dfs(u, ans);
        }

        ans.push_back(v);
    }

    vector<int> top_sort() {
        vector<int> ans;
        used.assign(n, 0);
        for (int v = 0; v < n; ++v) {
            if (used[v] == 0) {
                top_sort_dfs(v, ans);
            }
        }

        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    debug(n);
    debug(m);
    vector<bool> e(m);
    vector<vector<pair<int, int>>> h(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;

        e[i] = c;

        h[a].emplace_back(b, i);
        h[b].emplace_back(a, i);
    }
    
    vector<bool> clr(n), cur(n, 0);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        clr[i] = x;
    }

    vector<vector<int>> g(n);

    for (int v = 0; v < n; ++v) {
        for (auto [u, i] : h[v]) {
            if (clr[v] != e[i] && e[i] != clr[u]) {
                debug("str");
                cout << "NO\n";
                return;
            }
            if (e[i] == clr[v] && e[i] == clr[u]) continue;
            if (e[i] == clr[v]) {
                g[v].push_back(u);
            }
        }
    }

    auto gr = Graph(g);

    if (gr.have_cycle()) {
        debug("cycle");
        cout << "NO\n";
        return;
    }
    vector<pair<int, int>> dos;


    vector<int> top = gr.top_sort();
    debug("top_sort_find");

    for (int i : top) {
        dos.emplace_back(i + 1, !(clr[i]));
    }

    reverse(all(top));

    // for (auto i : top) 

    cout << "YES\n";

    for (int i : top) {
        if (cur[i] == 1) {
            dos.emplace_back(i + 1, 1);
        }
    }



    for (int i = 0; i < n; ++i) {
        if (clr[i] == 0) {
            cur[i] = 0;
            dos.emplace_back(i + 1, 0);
        } else if (clr[i] == 1) {
            dos.emplace_back(i + 1, 1);
        }
    }

    cout << dos.size() << endl;
    for (auto [a, b] : dos) {
        cout << a << " " << b << endl;
    }
}

int main() {
    ll q = 1;
    // #ifdef LOC
    cin >> q;
    // #endif
    for (ll i = 0; i < q; ++i) solve();
}
