#include<bits/stdc++.h>

using ll = long long;
using dbl = double;
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<endl
#else
#define debug(x)
#endif

#define all(x) x.begin(),x.end()

const ll INF = 1e18;

struct Tree {
    vector<ll> v;
    vector<ll> t;

    Tree(ll n) {
        t.assign(4 * n, 0);
    }

    void upd(ll i, ll l, ll r, ll q, ll x) {
        if (l > q || q >= r) return;
        if(l + 1 == r) {
            t[i] = x;
            return;
        }
        ll mid = (l + r) / 2;
        upd(i * 2 + 1, l, mid, q, x);
        upd(i * 2 + 2, mid, r, q, x);
        t[i] = t[i * 2 + 1] + t[i * 2 + 2];
    }

    ll get(ll i, ll l, ll r, ll ql, ll qr) {
        if (qr <= l || r <= ql) return 0;
        if (ql <= l && r <= qr) return t[i];
        ll mid = (l + r) / 2;
        return get(i * 2 + 1, l, mid, ql, qr) + get(i * 2 + 2, mid, r, ql, qr);
    }
};

pair<ll, ll> findd(vector<pair<ll, ll>> g, ll l, ll r) {
    ll L = 0;
    ll R = g.size();

    while (L + 1 < R) {
        ll MID = (L + R) / 2;
        if (g[MID].second <= l) {
            L = MID;
        } else {
            R = MID;
        }
    }

    ll al = L;

    L = 0;
    R = g.size();

    while (L + 1 < R) {
        ll MID = (L + R) / 2;
        if (g[MID].second < r) {
            L = MID;
        } else {
            R = MID;
        }
    }

    return {al, R};
}

void solve() {
    ll n, x;
    cin >> n >> x;
    vector<ll> a(n);


    for (ll& i : a) cin >> i;
    ll res = INF;

    vector<pair<pair<ll, ll>, ll>> as;
    for (ll i = 0; i < n; ++i) {
        as.push_back({{max(0ll, i - a[i]), -min(n, i + a[i] + 1)}, i});
    }    

    sort(all(as));

    vector<pair<ll, ll>> g;
    ll mx = -1;
    for (ll i = 0; i < n; ++i) {
        if (mx >= -as[i].first.second) continue;
        mx = -as[i].first.second;
        g.push_back({ as[i].first.first, -as[i].first.second });
    }

    ll m = g.size();
    Tree dp(m), ddp(m);
    vector<ll> odp(m, 0);



    for (ll i = 0; i < m; ++i) {
        ll mend = n;
        if (i != m - 1) {
            mend = g[i + 1].first;
        }

        dp.upd(0, 0, m, i, mend - g[i].first);

        auto [l, r] = findd(g, g[i].first, mend);

        dp.upd(0, 0, m, i, dp.get(0, 0, m, l, r));
        odp[i] = ddp.get(0, 0, m, l, r);
        // for (ll j = 0; j < i; ++j) {
        //     if (i == j) continue;
        //     if (g[i].first <= g[j].second && g[j].second < mend) {
        //         dp[i] += dp[j];
        //         odp[i] += dp[j] * (n - g[j].second);
        //     }
        // }

        ddp.upd(0, 0, m, i, dp.get(0, 0, m, i, i + 1) * (n - g[i].second));
    }

    ll ans = 0;
    for (ll i = 0; i < m; ++i) {
        ans += odp[i];
    }

    res = min(res, ans);  

    cout << res << '\n';
}
int main() {
    ll q = 1;
    #ifdef LOC
    cin >> q;
    #endif
    for (ll i = 0; i < q; ++i) solve();
}
