#include <bits/stdc++.h>

using namespace std;

long long INF = 1e12;
vector<long long> t, d, used;

void push(long long v, long long l, long long r) {
    if (d[v] == INF || l + 1 == r) return;
    long long m  = (l + r) / 2;
    t[v * 2 + 1] = d[v] * (m - l);
    t[v * 2 + 2] = d[v] * (r - m);
    d[v * 2 + 1] = d[v];
    d[v * 2 + 2] = d[v];
    d[v] = INF;
}

void update(long long v, long long l, long long r, long long ql, long long qr, long long num) {
    if (l >= qr || r <= ql) return;
    if (ql <= l && r <= qr) {
        t[v] = num * (r - l);
        d[v] = num;
        return;
    }
    long long m = (l + r) / 2;
    push(v, l, r);
    update(v * 2 + 1, l, m, ql, qr, num);
    update(v * 2 + 2, m, r, ql, qr, num);
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

long long get_sum(long long v, long long l, long long r, long long ql, long long qr) {
    if (l >= qr || r <= ql) return 0;
    if (ql <= l && r <= qr) return t[v];
    long long m = (l + r) / 2;
    push(v, l, r);
    return get_sum(v * 2 + 1, l, m, ql, qr) + get_sum(v * 2 + 2, m, r, ql, qr);
}

void dfs(long long v, vector<long long>& ans, vector<vector<long long>>& g) {
    used[v] = 1;
    long long n = ans.size() - 1;
    for (auto u : g[v]) {
        if (used[u] == -1) {
            ans[u] = ans[v] + (n - v);
            dfs(u, ans, g);
        }
    }
}

long long get_ans(vector<long long>& a) {
    long long n = a.size(), sum = 0;
    t.assign(n * 4, 0);
    d.assign(n * 4, INF);
    used.assign(n + 1, -1);
    vector<pair<long long, long long>> num;
    for (long long i = 0; i < n; ++i) {
        num.push_back({min(n - 1, i + a[i]), i});
    }
    sort(num.begin(), num.end());
    for (auto [y, u] : num) {
        update(0, 0, n, max((long long)0, u - a[u]), min(n, a[u] + u + 1), a[u] + u + 1);
    }
    vector<vector<long long>> g(n + 1);
    for (long long i = 0; i < n; ++i) {
        long long x = get_sum(0, 0, n, i, i + 1);
        g[min(n, x)].push_back(i);
    }
    vector<long long> ans(n + 1, 0);
    dfs(n, ans, g);
    for (long long i = 0; i < n; ++i) sum += ans[i];
    return sum;
}

int main() {
    long long n, x, sum = 0, ans = INF; cin >> n >> x;
    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    if (sum == 0) {
        a[min(n - 1, x)] = x;
        x = 0;
    }
    if (x == 0) {
        ans = get_ans(a);
    } else {
        vector<long long> b = a;
        for (long long i = 0; i < n; ++i) {
            b[i] = x;
            ans = min(get_ans(b), ans);
            b[i] = a[i];
        }
    }
    cout << ans;
}
