#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>

using namespace std;
const int MAXN = 100100;
int n, m;
struct edge{
	int u, v, c;
};	

vector<vector<pii>> g;
int light[MAXN];
int cur[MAXN];
vector<edge> edges;
vector<pii> ans;
map<pii, int> state;
vector<bool> used;

bool wecan = true;

void upd(int v, int c) {
	if (cur[v] != c) {
		cur[v] = c;
		ans.push_back({v, c});
	}
}

void dfs(int v) {
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to.first]) {
			dfs(to.first);
			int u = to.first;
			if (to.second == 1) {
				upd(u, 1);
				upd(v, 1);
				state[{u, v}] = 1;
			} else {
				upd(u, 0);
				upd(v, 0);
				state[{u, v}] = 0;
			}
		}
		 else {
			int u = to.first;
			if (to.second == 1) {
				upd(v, 1);
				upd(u, 1);
			} else {
				upd(v, 0);
				upd(u, 0);
			}
		}
	}
}

void dfs2(int v) {
	used[v] = true;
	upd(v, light[v]);
	for (auto to : g[v]) {
		if (!used[to.first]) {
			dfs2(to.first);
		}
	}
}

bool check() {
	for (int i = 0; i < n; i++) {
		if (light[i] != cur[i]) {
			return false;
		}
	}
	for (auto i : edges) {
		if (state[{i.u, i.v}] != i.c) {
			return false;
		}
	}
	return true;
}

void bamboo() {
	vector<bool> can1(n, true);
	vector<bool> can0(n, true);
	for (int i = n-2; i >= 0; i--) {
		int color = edges[i].c;
		if (color == 1) {
			upd(i + 1, 1);
			upd(i, 1);
		} else {
			upd(i + 1, 0);
			upd(i, 0);
		}
	}
	for (int i = 0; i < n; i++) {
		upd(i, light[i]);
	}
	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first + 1 << ' ' << i.second << '\n';
	}
}

bool found = false;

void tup(vector<int> color, vector<int> edgec, vector<pii> answer, int it) {
	//cout << color[0] << '-' << endl;
	if (found) {
		return;
	}
	if (it == n + m + 2) {
		return;
	}
	for (int i = 0; i < m; i++) {
		int u = edges[i].u;
		int v = edges[i].v;
		if (color[u] == color[v]) {
			edgec[i] = color[u];
		}
	}
	bool F = true;
	for (int i = 0; i < n; i++) {
		if (color[i] != light[i]) {
			F = false;
			break;
		}
	}
	for (int i = 0; i < m; i++) {
		if (edges[i].c != edgec[i]) {
			F = false;
			break;
		}
	}
	if (F) {
		found = true;
		cout << "YES\n";
		cout << answer.size() << '\n';
		for (auto i : answer) {
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
		return;
	}
	for (int i = 0; i < n; i++) {
		color[i] ^= 1;
		answer.push_back({i, color[i]});
		tup(color, edgec, answer, it + 1);
		answer.pop_back();
		color[i] ^= 1;
	}
}

void solve() {
	cin >> n >> m;
	g.clear();
	g.resize(n);
	edges.clear();
	ans.clear();
	state.clear();
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[u].push_back({v, c});
		g[v].push_back({u, c});
		edges.push_back({u, v, c});
		state[{u, v}] = 0;
		state[{v, u}] = 0;
	}
	for (int i = 0; i < n; i++) {
		cin >> light[i];
		cur[i] = 0;
	}
	for (auto i : edges) {
		if (light[i.u] == light[i.v] && i.c != light[i.u]) {
			cout << "NO\n";
			return;
		}
	}
	wecan = true;
	used.assign(n, false);
	dfs(0);
	used.assign(n, false);
	dfs2(0);
	if (0 && !check()) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto i : ans) {
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout << fixed << setprecision(64);
	int tt; cin >> tt;
	while (tt--) {
		solve();
	}
}