#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>

using namespace std;
const int MAXN = 100100;
int n, m;
struct edge{
	int u, v, c;
};	

vector<vector<pii>> g;
int light[MAXN];
int cur[MAXN];
vector<edge> edges;
vector<pii> ans;
map<pii, int> state;

bool wecan = true;

void upd(int v, int c) {
	if (cur[v] != c) {
		cur[v] = c;
		ans.push_back({v, c});
	}
}

void dfs(int v, int p) {
	for (auto to : g[v]) {
		if (to.first != p) {
			dfs(to.first, v);
			int u = to.first;
			if (to.second == 1) {
				upd(u, 1);
				upd(v, 1);
				state[{u, v}] = 1;
			} else {
				upd(u, 0);
				upd(v, 0);
				state[{u, v}] = 0;
			}
		}
	}
}

void dfs2(int v, int p) {
	upd(v, light[v]);
	for (auto to : g[v]) {
		if (to.first != p) {
			dfs2(to.first, v);
		}
	}
}

bool check() {
	for (int i = 0; i < n; i++) {
		if (light[i] != cur[i]) {
			return false;
		}
	}
	for (auto i : edges) {
		if (state[{i.u, i.v}] != i.c) {
			return false;
		}
	}
	return true;
}

void bamboo() {
	vector<bool> can1(n, true);
	vector<bool> can0(n, true);
	for (int i = n-2; i >= 0; i--) {
		int color = edges[i].c;
		if (color == 1) {
			upd(i + 1, 1);
			upd(i, 1);
		} else {
			upd(i + 1, 0);
			upd(i, 0);
		}
	}
	for (int i = 0; i < n; i++) {
		upd(i, light[i]);
	}
	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first + 1 << ' ' << i.second << '\n';
	}
}

bool found = false;
int it = 0;

void tup(vector<pii> color, vector<int> edgec, vector<pii> answer) {
	if (it++ >= 75000) {
		return;
	}
	if (found) {
		return;
	}
	for (int i = 0; i < m; i++) {
		int u = edges[i].u;
		int v = edges[i].v;
		if (color[u].first == color[v].first) {
			edgec[i] = color[u].first;
		}
	}
	bool F = true;
	for (int i = 0; i < n; i++) {
		if (color[i].first != light[i]) {
			F = false;
			break;
		}
	}
	for (int i = 0; i < m; i++) {
		if (edges[i].c != edgec[i]) {
			F = false;
			break;
		}
	}
	if (F) {
		found = true;
		cout << "YES\n";
		cout << -1 << endl;
		return;
	}
	for (int i = 0; i < n; i++) {
		if (answer.size() && answer.back().first == i || color[i].second > g[i].size()) {
			continue;
		}
		color[i].first ^= 1;
		color[i].second++;
		answer.push_back({i, color[i].first});
		tup(color, edgec, answer);
		answer.pop_back();
		color[i].first ^= 1;
		color[i].second--;
	}
}

void solve() {
	cin >> n >> m;
	g.clear();
	g.resize(n);
	edges.clear();
	ans.clear();
	state.clear();
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[u].push_back({v, c});
		g[v].push_back({u, c});
		edges.push_back({u, v, c});
		state[{u, v}] = 0;
		state[{v, u}] = 0;
	}
	for (int i = 0; i < n; i++) {
		cin >> light[i];
		cur[i] = 0;
	}
	for (auto i : edges) {
		if (light[i.u] == light[i.v] && i.c != light[i.u]) {
			cout << "NO\n";
			return;
		}
	}
	vector<pii> color(n, {0, 0});
	vector<int> edgec(m, 0);
	vector<pii> answer;
	found = false;
	it = 0;
	tup(color, edgec, answer);
	if (!found) {
		cout << "NO\n";
	}
	return;
	/*
	for (auto i : edges) {
		if (i.c == 1) {
			if (!cur[i.u]) {
				cur[i.u] = 1;
				ans.push_back({i.u, 1});
			}
			if (!cur[i.v]) {
				cur[i.v] = 1;
				ans.push_back({i.v, 1});
			}
			state[{i.u, i.v}] = 1;
		}
	}
	for (auto i : edges) {
		if (cur[i.u] && cur[i.v]) {
			state[{i.u, i.v}] = 1;
		}
	}
	for (auto i : edges) {
		if (i.c == 0 && state[{i.u, i.v}]) {
			if (cur[i.u]) {
				cur[i.u] = 0;
				ans.push_back({i.u, 0});
			}
			if (cur[i.v]) {
				cur[i.v] = 0;
				ans.push_back({i.v, 0});
			}
			state[{i.u, i.v}] = 0;
		}
	}
	for (int i = 0; i < n; i++) {
		if (cur[i] != light[i]) {
			ans.push_back({i, light[i]});
			cur[i] = light[i];
		}
	}
	for (auto i : edges) {
		if (!cur[i.u] && !cur[i.v]) {
			state[{i.u, i.v}] = 0;
		}
	}

	if (!check()) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto i : ans) {
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
	}
	*/
	wecan = true;
	dfs(0, 0);
	dfs2(0, 0);
	if (0 && !check()) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto i : ans) {
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout << fixed << setprecision(64);
	int tt; cin >> tt;
	while (tt--) {
		solve();
	}
}