#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>

using namespace std;
const int MAXN = 100100;
int n, m;
struct edge{
	int u, v, c;
};	

vector<vector<pii>> g;
int light[MAXN];
int cur[MAXN];
vector<edge> edges;
vector<pii> ans;
map<pii, int> state;

bool wecan = true;

void upd(int v, int c) {
	if (cur[v] != c) {
		cur[v] = c;
		ans.push_back({v, c});
	}
}

void dfs(int v, int p) {
	for (auto to : g[v]) {
		if (to.first != p) {
			dfs(to.first, v);
			int u = to.first;
			if (to.second == 1) {
				upd(u, 1);
				upd(v, 1);
			} else {
				upd(u, 0);
				upd(v, 0);
			}
		}
	}
}

bool check() {
	for (int i = 0; i < n; i++) {
		if (light[i] != cur[i]) {
			return false;
		}
	}
	for (auto i : edges) {
		if (state[{i.u, i.v}] != i.c) {
			return false;
		}
	}
	return true;
}

void bamboo() {
	vector<bool> can1(n, true);
	vector<bool> can0(n, true);
	for (int i = n-2; i >= 0; i--) {
		int color = edges[i].c;
		if (color == 1) {
			if (can1[i + 1]) {
				upd(i + 1, 1);
				upd(i, 1);
			} else {
				cout << "NO\n";
				return;
			}
			if (light[i + 1] == 0) {
				upd(i + 1, 0);
				can0[i] = false;
				can1[i] = true;
			} else {
				can1[i] = true;
				can0[i] = true;
			}
		} else {
			if (can0[i + 1]) {
				upd(i + 1, 0);
				upd(i, 0);
			} else {
				cout << "NO\n";
				return;
			}
			if (light[i + 1] == 1) {
				upd(i + 1, 1);
				can0[i] = true;
				can1[i] = false;
			} else {
				can1[i] = true;
				can0[i] = true;
			}
		}
	}
	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first + 1 << ' ' << i.second << '\n';
	}
}

void solve() {
	cin >> n >> m;
	g.clear();
	g.resize(n);
	edges.clear();
	ans.clear();
	state.clear();
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[u].push_back({v, c});
		g[v].push_back({u, c});
		edges.push_back({u, v, c});
		state[{u, v}] = 0;
		state[{v, u}] = 0;
	}
	for (int i = 0; i < n; i++) {
		cin >> light[i];
		cur[i] = 0;
	}
	for (auto i : edges) {
		if (light[i.u] == light[i.v] && i.c != light[i.u]) {
			cout << "NO\n";
			return;
		}
	}
	bamboo();
	return;
	/*
	for (auto i : edges) {
		if (i.c == 1) {
			if (!cur[i.u]) {
				cur[i.u] = 1;
				ans.push_back({i.u, 1});
			}
			if (!cur[i.v]) {
				cur[i.v] = 1;
				ans.push_back({i.v, 1});
			}
			state[{i.u, i.v}] = 1;
		}
	}
	for (auto i : edges) {
		if (cur[i.u] && cur[i.v]) {
			state[{i.u, i.v}] = 1;
		}
	}
	for (auto i : edges) {
		if (i.c == 0 && state[{i.u, i.v}]) {
			if (cur[i.u]) {
				cur[i.u] = 0;
				ans.push_back({i.u, 0});
			}
			if (cur[i.v]) {
				cur[i.v] = 0;
				ans.push_back({i.v, 0});
			}
			state[{i.u, i.v}] = 0;
		}
	}
	for (int i = 0; i < n; i++) {
		if (cur[i] != light[i]) {
			ans.push_back({i, light[i]});
			cur[i] = light[i];
		}
	}
	for (auto i : edges) {
		if (!cur[i.u] && !cur[i.v]) {
			state[{i.u, i.v}] = 0;
		}
	}

	if (!check()) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto i : ans) {
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
	}
	*/
	wecan = true;
	dfs(0, 0);
	for (int i = 0; i < n; i++) {
		upd(i, light[i]);
	}
	for (auto i : edges) {
		if (cur[i.u] == cur[i.v]) {
			state[{i.u, i.v}] = cur[i.u];
		}
	}
	if (!check()) {
		cout << "NO\n";
	} else {
		cout << "YES\n";
		cout << ans.size() << '\n';
		for (auto i : ans) {
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout << fixed << setprecision(64);
	int tt; cin >> tt;
	while (tt--) {
		solve();
	}
}