#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

vector<vector<int>> g1;
vector<bool> used;
vector<int> ts;

void dfs(int v) {
	used[v] = 1;
	for (auto to : g1[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	ts.push_back(v);
}

void solve() {
	int n, m;
	cin >> n >> m;
	g1.assign(m, {});
	used.assign(m, 0);
	ts.clear();
	vector<tuple<int, int, int>> e;
	vector<vector<pair<int, int>>> g(n);
	map<pair<int, int>, int> col;
	map<pair<int, int>, int> ps;
	for (int i = 0; i < m; i++) {
		int u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		e.push_back({ u, v, c });
		g[u].push_back({ v, c });
		g[v].push_back({ u, c });
		col[{u, v}] = c;
		col[{v, u}] = c;
		ps[{u, v}] = i;
		ps[{v, u}] = i;
	}
	vector<int>d(n);
	vector<int>d1(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (auto [u, v, c] : e) {
		if (c) {
			d1[u] = 1;
			d1[v] = 1;
		}
	}
	bool f = 1;
	for (auto [u, v, c] : e) {
		if (d[u] && d[v] && c == 0) f = 0;
		if (!d[u] && !d[v] && c == 1) f = 0;
	}
	for (int u = 0; u < n; u++) {
		for (auto [o, c1] : g[u]) {
			if (c1 == 0 || d[o] == 1) continue;
			for (auto [v, c2] : g[o]) {
				if (v == u || d[v] == 0 || c2 == 1) continue;
				g1[ps[{u, o}]].push_back(ps[{v, o}]);
			}
		}
	}
	for (int i = 0; i < m; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	vector<int> pos(m);
	for (int i = 0; i < m; i++) {
		pos[ts[i]] = i;
	}
	for (int i = 0; i < m; i++) {
		for (auto to : g1[i]) {
			if (pos[i] < pos[to]) { 
				f = 0;
			}
		}
	}
	cout << (f ? "YES\n-1\n" : "NO\n");
}

signed main() {
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}