#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define all(a) a.begin(), a.end()
using namespace std;
#pragma GCC optimize("Ofast")

vector<vector<int>> g1;
vector<bool> used;
vector<int> ts;

void dfs(int v) {
	used[v] = 1;
	for (auto to : g1[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	ts.push_back(v);
}

void solve() {
	int n, m;
	cin >> n >> m;
	g1.assign(m, {});
	used.assign(m, 0);
	ts.clear();
	vector<tuple<int, int, int>> e;
	vector<vector<pair<int, int>>> g(n);
	map<pair<int, int>, int> col;
	map<pair<int, int>, int> ps;
	for (int i = 0; i < m; i++) {
		int u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		e.push_back({ u, v, c });
		g[u].push_back({ v, c });
		g[v].push_back({ u, c });
		col[{u, v}] = c;
		col[{v, u}] = c;
		ps[{u, v}] = i;
		ps[{v, u}] = i;
	}
	vector<int>d(n);
	vector<int>d1(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (auto [u, v, c] : e) {
		if (c) {
			d1[u] = 1;
			d1[v] = 1;
		}
	}
	bool f = 1;
	for (auto [u, v, c] : e) {
		if (d[u] && d[v] && c == 0) f = 0;
		if (!d[u] && !d[v] && c == 1) f = 0;
	}
	vector<vector<int>> vu(n), vo2(n);
	for (int v = 0; v < n; v++) {
		for (auto [o2, c3] : g[v]) {
			if (d[o2] || !d[v] || !c3) continue;
			vo2[v].push_back(o2);
		}
	}
	for (int o = 0; o < n; o++) {
		for (auto [u, c1] : g[o]) {
			if (d[o] || !d[u] || !c1) continue;
			vu[o].push_back(u);
		}
		for (auto [v, c2] : g[o]) {
			if (d[o] || !d[v] || c2) continue;
			for (auto u : vu[o]) {
				for (auto o2 : vo2[v]) {
					g1[ps[{u, o}]].push_back(ps[{v, o2}]);
				}
			}
		}

	}
	for (int i = 0; i < m; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	vector<int> pos(m);
	for (int i = 0; i < m; i++) {
		pos[ts[i]] = i;
	}
	for (int i = 0; i < m; i++) {
		for (auto to : g1[i]) {
			if (pos[i] < pos[to]) {
				f = 0;
			}
		}
	}
	cout << (f ? "YES\n" : "NO\n");
	if (f) {
		reverse(all(ts));
		vector<pair<int, int>> res;
		for (auto edg : ts) {
			if (d[get<0>(e[edg])] == 0 && d[get<1>(e[edg])] == 1 && get<2>(e[edg]) == 1) {
				res.push_back({ get<1>(e[edg]) , 1 });
				res.push_back({ get<0>(e[edg]) , 1 });
				res.push_back({ get<0>(e[edg]) , 0 });
			}
			if (d[get<1>(e[edg])] == 0 && d[get<0>(e[edg])] == 1 && get<2>(e[edg]) == 1) {
				res.push_back({ get<0>(e[edg]) , 1 });
				res.push_back({ get<1>(e[edg]) , 1 });
				res.push_back({ get<1>(e[edg]) , 0 });
			}
		}
		for (int i = 0; i < n; i++) {
			if (d[i] == 1) {
				res.push_back({ i, 1 });
			}
		}
		cout << res.size() << '\n';
		for (auto [i, j] : res) {
			cout << i + 1 << ' ' << j << '\n';
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}