#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

struct SegTree {
	vector<ll> t;
	ll sz = 1;
	void Init(ll n)
	{
		while (sz < n) sz *= 2;
		t.assign(2 * sz, 0);
	}
	void set1(ll v, ll l, ll r, ll ind)
	{
		if (ind >= r || ind < l) return;
		if (r - l == 1)
		{
			t[v] = 1;
			return;
		}
		ll mid = (l + r) / 2;
		set1(2 * v + 1, l, mid, ind);
		set1(2 * v + 2, mid, r, ind);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
	ll sum(ll v, ll l, ll r, ll ql, ll qr)
	{
		if (r <= ql || qr <= l) return 0;
		if (ql <= l && r <= qr)
			return t[v];
		ll mid = (l + r) / 2;
		return sum(2 * v + 1, l, mid, ql, qr) + sum(2 * v + 2, mid, r, ql, qr);
	}
};


int main()
{
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++)
		cin >> t[i];
	for (ll i = 0; i < m; i++)
		cin >> s[i];
	SegTree t1, t2;
	t1.Init(2 * n);
	t2.Init(2 * n);


	//  
	vector<ll> time1(n), time2(n), pos1(n), pos2(n);
	vector<pair<ll, ll>> pos;
	for (ll i = 0; i < n; i++)
	{
		time1[i] = s[0] * t[i];
		time2[i] = (s[1] - s[0]) * t[i];
		pos.push_back({ time1[i], i });
		pos.push_back({ time2[i], i });
	}
	sort(pos.begin(), pos.end());
	for (ll i = 0; i < 2 * n; i++)
	{
		ll ind = pos[i].second, timecur = pos[i].first;
		if (timecur == time1[ind])
			pos1[ind] = i;
		else
			pos2[ind] = i;
	}

	ll sum = 0;
	for (ll i = 0; i < n; i++)
	{
		sum += 2 * i;
		if (pos1[i] < pos2[i])
			sum += t2.sum(0, 0, t2.sz, pos1[i], pos2[i]) + t1.sum(0, 0, t1.sz, pos1[i], pos2[i]);
		//sum += t2.sum(0, 0, t2.sz, 0, pos2[i]);
		//sum += t2.sum(0, 0, t1.sz, pos2[i], 2 * n);
		t1.set1(0, 0, t1.sz, pos1[i]);
		t2.set1(0, 0, t2.sz, pos2[i]);
		cout << sum << endl;
	}
}