#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

ll n, x;
vector<ll> a;
vector<pair<ll, ll>> R, R2;

pair<ll, ll> findR(ll p)
{
	ll ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i] + i >= p && i - a[i] <= p)
		{
			if (a[i] + i > a[ans] + ans)
			{
				ans = i;
			}
		}
	}
	return { a[ans] + ans, ans };
}

pair<ll, ll> findR2(ll p)
{
	ll ans1 = p, ans2 = p;
	for (int i = 0; i < n; i++)
	{
		if (a[i] + i >= p && i - a[i] <= p)
		{
			ll r = a[i] + i;
			if (r > ans1 + a[ans1])
			{
				ans2 = ans1;
				ans1 = i;
			}
			else if (r > ans2 + a[ans2])
				ans2 = i;
		}
	}
	return { a[ans2] + ans2, ans2 };
}

ll findseg(ll s, ll t, ll ch)
{
	ll last = -1, cnt = -1;
	for (int i = s; i <= t; i++)
	{
		if (last < i)
		{
			if (x + ch >= i && ch-x <= i)
				last = ch + x;
			if (R[i].second == ch)
			{
				last = max(last, R2[i].first);
			}
			else
				last = max(R[i].first, last);
			cnt++;
		}
	}
	return cnt;
}

int main()
{
	cin >> n >> x;
	a.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		R.push_back(findR(i));
		R2.push_back(findR2(i));
	}

	ll ans = 1e9;
	for (int l = 0; l < n; l++)
	{
		ll sum = 0;
		for (int i = 0; i < n; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				sum += findseg(i, j, l);
			}
		}
		ans = min(ans, sum);
	}
	cout << ans;
}