#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
#define pb push_back

const int INF = 1000000000;

struct Edge{
    int st;
    int end;
    int nst;
};

struct Op{
    int ind;
    int op;
};

vector<int> nst;
vector<vector<Edge>> gr;
vector<vector<Edge>> angr;
vector<ll> tme;
vector<int> topsort;
vector<Op> ans;

bool dfs(int v, ll t){
    tme[v] = t;

    for(auto &e : angr[v]){
        if(tme[e.end] < t) return false;
        if(tme[e.end] == INF) if(!dfs(e.end, t + 1)) return false;
    }

    tme[v] += INF / 2;

    topsort.pb(v);
    return true;
}

void solve(){

    topsort.clear();
    ans.clear();

    int qv, qe, sv, ev, nv;
    cin >> qv >> qe;
    nst.assign(qv, 0);
    gr.assign(qv, {});
    angr.assign(qv, {});
    tme.assign(qv, INF);

    while(qe--){
        cin >> sv >> ev >> nv;
        sv--;
        ev--;
        gr[sv].pb({sv, ev, nv});
        gr[ev].pb({ev, sv, nv});
    }

    for(int i = 0; i < qv; ++i){
        cin >> nst[i];
    }

    for(auto &i : gr){
        for(auto &t : i){
            if(nst[t.st] == t.nst && t.nst != nst[t.end]) angr[t.st].pb(t);
            else if(nst[t.st] != t.nst && t.nst != nst[t.end]) {
                cout << "NO\n";
                return;
            }
        }
    }

    for(int i = 0; i < qv; ++i){
        if(tme[i] == INF) {
            if(!dfs(i, (ll)-INF * i)){
                cout << "NO\n";
                return;
            }
        }
    }

    cout << "YES\n";

    for(int i = topsort.size() - 1; i > -1; --i){
        if(nst[topsort[i]] == 1){
            ans.pb({topsort[i], 1});
            for(auto &t : angr[topsort[i]]){
                ans.pb({t.end, 1});
                ans.pb({t.end, 0});
            }
        }
    }

    cout << ans.size() << '\n';
    for(auto &i : ans) cout << i.ind + 1 << ' ' << i.op << '\n';

}


int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "w", stdin);
    //freopen("output.txt", "r", stdout);
#endif


    int t = 1;

    cin >> t;

    while(t--){
        solve();
    }

    return 0;
}