#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
#define pb push_back

const int INF = 1000000000;



vector<int> speed;
vector<int> gates;
vector<int> dist;
vector<int> mdist = {0};

void solve(){

    int qd, qg;
    ll ans = 0;
    cin >> qd >> qg;
    speed.assign(qd, 0);
    gates.assign(qg + 1, 0);
    for(int i = 0; i < qd; ++i) cin >> speed[i];
    for(int i = 0; i < qg; ++i) cin >> gates[i + 1];
    for(int i = 0; i < qg; ++i) dist.pb(gates[i + 1] - gates[i]);
    for(auto i : dist) mdist.pb(max(mdist.back(), i));
    for(int i = 0; i < qd; ++i){

        for(int t = 0; t < i; ++t){
            //how much teleports
            int l = -1, r = dist.size();
            while(r - l > 1){
                int m = ((l + r) >> 1);
                if((ll)mdist[m + 1] * speed[t] > (ll)mdist.back() * speed[i]) {  //mdist[m + 1] / speed[i] > mdist.back() / speed[t]
                    r = m;
                }
                else l = m;
            }
            ans += r;

            //how much is teleported
            l = -1, r = dist.size();
            while(r - l > 1){
                int m = ((l + r) >> 1);
                if((ll)mdist[m + 1] * speed[i] < (ll)mdist.back() * speed[t]){ //mdist[m + 1] / speed[t] < mdist.back() / speed[i]
                    l = m;
                }
                else r = m;
            }
            ans += r;

        }

        cout << ans << '\n';
    }

}


int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "w", stdin);
    //freopen("output.txt", "r", stdout);
#endif


    int t = 1;

    //cin >> t;

    while(t--){
        solve();
    }

    return 0;
}
