#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
using namespace std;
   
#define int long long
#define endl "\n"
  
mt19937 rn(556);
int rnd() {return abs((int) rn());}
  
constexpr long long inf = 1e18;
constexpr long long N = 2e5 + 556;
   
template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}
   
template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}
   
struct ined {
    int u, v, c;
};
   
struct edge {
    int to, c, i;
};
  
int p[N];
  
int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}
  
int unite(int a, int b) {
    a = get(a); b = get(b);
    if (a == b) return 0;
    if (rnd() & 1) p[a] = b;
    else p[b] = a;
    return 1;
}
   
void solve() {
    int n, m;
    cin >> n >> m;
  
    for (int i = 0; i < n; i++) p[i] = i;
   
    vector<ined> ed;
    vector<vector<edge>> gr(n, vector<edge> (0));
    for (int i = 0; i < m; i++) {
        int u, v, c; cin >> u >> v >> c; u--;--v;
        gr[u].push_back({v, c, i}); gr[v].push_back({u, c, i});
        ed.push_back({u, v, c});
    }
    vector<int> a(n), b(n, 0), cl(m, 0);
    cin >> a;
  
    for (auto [u, v, c] : ed) {
        if (a[u] == a[v] && a[u] != c) {
            cout << "NO" << endl;
            return;
        }
  
        if (c == 1) {
            unite(u, v);
        }
    }
  
    vector<vector<int>> ng(n, vector<int> (0));
  
    for (auto [u, v, c] : ed) {
        if (get(u) == get(v)) continue;
        if (c == 0) {
            if (a[u] == 1 && a[v] == 0) {
                ng[get(v)].push_back(get(u));
            }
            if (a[u] == 0 && a[v] == 1) {
                ng[get(u)].push_back(get(v));
            }
        }
    }
  
    vector<int> used(n, 0);
    int ok = 1;
  
    auto dfs1 = [&](auto dfs, int v, int p) -> void {
        used[v] = 1;
        for (int to : ng[v]) {
            // cout << to << endl;
            if (used[to] == 1) ok = 0;
            else if (used[to] == 0) {
                dfs(dfs, to, v);
            }
        }
        used[v] = 2;
    };
  
    for (int i = 0; i < n; i++) {
        int v = get(i);
        if (!used[v]) {
            dfs1(dfs1, v, -1);
        }
    }
  
    if (ok) {
        cout << "YES" << endl;
        // cout << -1 << endl;
    } else {
        cout << "NO" << endl;
        return;
    }

    
    vector<int> tp;
 
    used.assign(n, 0);
 
    auto dfs2 = [&](auto dfs, int v) -> void {
        used[v] = 1;
        for (int to : ng[v]) {
            if (!used[to]) {
                dfs(dfs, to);
            }
        }
        tp.push_back(v);
    };
 
    for (int i = 0; i < n; i++) {
        int v = get(i);
 
        if (!used[v]) {
            dfs2(dfs2, v);
        }
    }
 
    reverse(tp.begin(), tp.end());
 
    vector<pair<int, int>> ans;
 
    vector<int> cur;
 
    auto dfs3 = [&](auto dfs, int v, int w) -> void {
        used[v] = w;
        cur.push_back(v);
        for (auto [to, c, i] : gr[v]) {
            if (!used[to] && c == 1) {
                dfs(dfs, to, w);
            }
        }
    };
 
    used.assign(n, 0);
 
    for (auto el : tp) {
        cur.clear();
        dfs3(dfs3, el, el + 1);

        vector<int> wh, bl;
        for (auto e : cur) {
            if (a[e] == 0) wh.push_back(e);
            else bl.push_back(e);
        }

        for (int e : wh) {
            ans.push_back({e, 1});
            for (auto [to, c, i] : gr[e]) {
                if (c == 1) {
                    ans.push_back({to, 1});
                }
            }
            ans.push_back({e, 0});
        }

        for (int e : bl) {
            ans.push_back({e, 1});
        }
 
        // for (auto e : cur) ans.push_back({e, 1});
        // for (auto e : cur) if (a[e] == 0) ans.push_back({e, 0});
 
        // for (auto e : cur) {
        //     for (auto [to, c, i] : gr[e]) {
        //         if (c == 0 && used[to] == el + 1) {
        //             if (a[e] == 1) {
        //                 ans.push_back({e, 0});
        //                 ans.push_back({e, 1});
        //             }
 
        //             // cout << e << " " << endl;
        //         }
        //     }
        // }
 
        // cout << cur << endl;
    }
 
    // cout << ans << endl;
    // for (auto [v, c] : ans) cout << ":: " << v + 1 << " " << c << endl;
     
    auto color = [&](int v, int c) -> void {
        b[v] = c;
        for (auto [to, c, i] : gr[v]) {
            if (b[v] == b[to]) {
                cl[i] = b[v];
            }
        }
 
        // cout << cl << endl;
    };
   
    // for (auto [v, c] : ans) {
    //     color(v, c);
    // }
 
    // // cout << b << endl;
    // // cout << cl << endl;
   
    // if (a != b) {
    //     cout << "NO" << endl;
    //     return;
    // }
   
    // for (int i = 0; i < m; i++) {
    //     if (cl[i] != ed[i].c) {
    //         cout << "NO" << endl;
    //         return;
    //     }
    // }
 
    // cout << "YES" << endl;
    cout << ans.size() << endl;
    for (auto [v, c] : ans) cout << v + 1 << " " << c << endl;
}
   
signed main() {
    int tests = 1;
   
#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;
   
    while (tests --> 0) solve();
}