#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
#define endl "\n"

constexpr long long inf = 1e18;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

struct ined {
    int u, v, c;
};

struct edge {
    int to, c, i;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector<ined> ed;
    vector<vector<edge>> gr(n, vector<edge> (0));
    for (int i = 0; i < m; i++) {
        int u, v, c; cin >> u >> v >> c; u--;--v;
        gr[u].push_back({v, c, i}); gr[v].push_back({u, c, i});
        ed.push_back({u, v, c});
    }
    vector<int> a(n);
    cin >> a;


    for (auto [u, v, c] : ed) {
        if (a[u] == a[v] && a[u] != c) {
            cout << "No" << endl;
            return;
        }
    }

    cout << "Yes" << endl;
    return;

    vector<int> used(n, 0);
    vector<pair<int, int>> ans;
    auto dfs = [&](auto dfs, int v) -> void {
        used[v] = 1;
        for (auto [to, c, i] : gr[v]) {
            if (used[to]) continue;

            if (c == 1) {
                ans.push_back({to, 1});
            }
        }

        if (a[v] == 0) ans.push_back({v, 0});

        for (auto [to, c, i] : gr[v]) {
            if (used[to]) continue;

            if (c == 1) {
                ans.push_back({to, 1});
            }
        }
    };

    for (int v = 0; v < n; v++) {
        if (!used[v] && a[v] == 1) {
            ans.push_back({v, 1});
            dfs(dfs, v);
        } 
    }

    vector<int> b(n, 0);
    vector<int> cl(m, 0);

    auto color = [&](int v, int c) -> void {
        b[v] = c;
        for (auto [to, i, c] : gr[v]) {
            if (b[v] == b[to]) {
                cl[i] = b[v];
            }
        }
    };

    for (auto [v, c] : ans) {

        // cout << v + 1 << " " << c << endl;

        color(v, c);
    }

    if (a != b) {
        cout << "No" << endl;
        return;
    }

    for (int i = 0; i < m; i++) {
        if (cl[i] != ed[i].c) {
            cout << "No" << endl;
            return;
        }
    }

    cout << "Yes" << endl;
    for (auto [v, c] : ans) cout << v + 1 << " " << c << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;

    while (tests --> 0) solve();
}