#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
using namespace std;

#pragma GCC optimize("O3")
 
#define int long long
#define endl "\n"

mt19937 rn(556);
int rnd() {return abs((int) rn());}

constexpr long long inf = 1e18;
constexpr long long N = 2e5 + 556;
 
ostream& operator << (ostream& out, pair<int, int> a) {
    out << "| " << a.first << " " << a.second << " |";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}
 
template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

int n, m;
pair<int, int> tr[N << 2];
vector<int> t, s;

void build(int v = 0, int vl = 0, int vr = n) {
    if (vr - vl == 1) {
        tr[v] = {t[vl] * s[0], vl};
        return;
    }
    int vm = vl + vr >> 1;
    build(v * 2 + 1, vl, vm);
    build(v * 2 + 2, vm, vr);

    if (tr[v * 2 + 1].first <= tr[v * 2 + 2].first) {
        tr[v] = tr[v * 2 + 1];
    } else if (tr[v * 2 + 1].first > tr[v * 2 + 2].first) {
        tr[v] = tr[v * 2 + 2];
    }
}

void update(int p, int x, int v = 0, int vl = 0, int vr = n) {
    if (vr - vl == 1) {
        tr[v] = {x, vl};
        return;
    }
    int vm = vl + vr >> 1;
    if (p < vm) update(p, x, v * 2 + 1, vl, vm);
    else update(p, x, v * 2 + 2, vm, vr);

    if (tr[v * 2 + 1].first <= tr[v * 2 + 2].first) {
        tr[v] = tr[v * 2 + 1];
    } else if (tr[v * 2 + 1].first > tr[v * 2 + 2].first) {
        tr[v] = tr[v * 2 + 2];
    }
}

void solve() {
    cin >> n >> m;
    t.resize(n);
    cin >> t;
    s.resize(m);
    cin >> s;
    for (int i = m - 1; i > 0; i--) s[i] -= s[i - 1];

    // cout << s << endl;

    int tg = 0;

    for (int k = 1; k < 3; k++) {
        vector<int> pos(k, 0);
        int ans = 0;

        build(0, 0, k);
        int cnt = k;

        while (tr[0].first != inf) {
            int i = tr[0].second;
            // for (int j = 0; j < k; j++) {
            //     if (pos[j] == m) continue;
            //     // cout << pos[i] << " " << pos[j] << endl;
            //     if (pos[i] == m || s[pos[j]] * t[j] < s[pos[i]] * t[i]) {
            //         i = j;
            //     }
            //     cnt++;
            // }
            
            // break;
            ans += cnt - 1;
            pos[i]++;
            if (pos[i] == m) {
                update(i, inf, 0, 0, k);
                cnt--;
            } else update(i, s[pos[i]] * t[i], 0, 0, k);

            if (cnt == 0) break;
            // cout << pos << endl;
        }

        cout << ans << endl;

        tg = ans;
    }

    for (int i = 3; i < n + 1; i++) {
        cout << i * (i - 1) * tg / 2 << endl;
    }
}
 
signed main() {
    int tests = 1;
 
#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    // cin >> tests;
 
    while (tests --> 0) solve();
}