#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
using namespace std;

#pragma GCC optimize("O3")
 
#define int long long
#define endl "\n"

mt19937 rn(556);
int rnd() {return abs((int) rn());}

constexpr long long inf = 1e18;
constexpr long long N = 1e6 + 556;
 
ostream& operator << (ostream& out, pair<int, int> a) {
    out << "| " << a.first << " " << a.second << " |";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}
 
template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

int n;
int tr[N << 2];

void build(int v = 0, int vl = 0, int vr = n) {
    if (vr - vl == 1) {
        tr[v] = vr;
        return;
    }
    int vm = vl + vr >> 1;
    build(v * 2 + 1, vl, vm);
    build(v * 2 + 2, vm, vr);
    tr[v] = 0;
}

void update(int l, int r, int x, int v = 0, int vl = 0, int vr = n) {
    if (l >= vr || vl >= r) return;
    if (l <= vl && vr <= r) {
        tr[v] = max(tr[v], x);
        return;
    }
    int vm = vl + vr >> 1;
    update(l, r, x, v * 2 + 1, vl, vm);
    update(l, r, x, v * 2 + 2, vm, vr);
}

int get(int p, int v = 0, int vl = 0, int vr = n) {
    if (vr - vl == 1) return tr[v];
    int vm = vl + vr >> 1;
    if (p < vm) return max(tr[v], get(p, v * 2 + 1, vl, vm));
    else return max(tr[v], get(p, v * 2 + 2, vm, vr));
}

void solve() {
    int x;
    cin >> n >> x;
    vector<int> a(n);
    cin >> a;

    auto b = a;

    int ans = 0;

    build();
    for (int i = 0; i < n; i++) {
        // cout << max(0LL, i - a[i]) << " " << i << " " << min(n, i + a[i] + 1) << endl;
        update(max(0LL, i - a[i]), min(n, i + a[i] + 1), min(n, i + a[i] + 1));
    }

    vector<int> ind(n, 0);
    for (int i = 0; i < n; i++) {
        ind[i] = get(i);
    }

    vector<int> dp(n + 1, 0);
    // dp[n] = -1;
    int cans = 0;
    for (int i = n - 1; i >= 0; i--) {
        // cout << i << ": " << get(i) << " " <<  << endl;
        dp[i] = dp[get(i)] + (1) * (n - get(i));

        ans += dp[i];
    }
    for (int j = 0; j < n; j++) {
        // a[i] = x;
        dp.assign(n + 1, 0);

        // build();
        // for (int i = 0; i < n; i++) {
        //     // cout << max(0LL, i - a[i]) << " " << i << " " << min(n, i + a[i] + 1) << endl;
        //     update(max(0LL, i - a[i]), min(n, i + a[i] + 1), min(n, i + a[i] + 1));
        // }

        // dp[n] = -1;
        int cans = 0;
        for (int i = n - 1; i >= 0; i--) {
            // cout << i << ": " << get(i) << " " <<  << endl;
            int t = ind[i];

            if (j - x <= i && i <= j + x) t = max(t, min(n, j + x + 1));

            dp[i] = dp[t] + n - t;

            cans += dp[i];
        }

        ans = min(ans, cans);

        // a = b;
    }

    // cout << dp << endl;

    cout << ans << endl;
}
 
signed main() {
    int tests = 1;
 
#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    // cin >> tests;
 
    while (tests --> 0) solve();
}