#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
 
using namespace std;
 
typedef long long ll;
typedef vector <long long> vll;
typedef vector <vll> vvll;
 
 
const ll MAX_N = 1e+9;
 
 
struct robot {
    ll x, p, d;
    robot() {
        x = -1;
        p = -1;
        d = -1;
    }
    robot(ll xs, ll ps, ll ds) {
        x = xs;
        p = ps;
        d = ds;
    }
};
 
ll get_out(ll mid, ll n, vector <robot> robots ) {
    ll cur_out = 0;
    ll cur_dir = 1;
    ll last_x = 0;
    if (mid < 0 || mid >= n) return MAX_N;
    for (int i = 0; i < n; ++i) {
        if (i == mid) cur_dir = -1;
        robot rob = robots[i];
        if (rob.d != cur_dir) ++cur_out;
         if (cur_dir == 1) {
            if (last_x < rob.x) { return MAX_N; }
            last_x = rob.x + rob.p;
        }
        else {
            if (last_x < rob.x - rob.p) { return MAX_N; }
            last_x = rob.x;
        }
    }
    return cur_out;
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    vector <robot> robots;
    ll mn_d = 1;
    for (int i = 0; i < n; ++i) {
        ll xs, ps, ds;
        cin >> xs >> ps >> ds;
        robots.push_back(robot(xs, ps, ds));
        mn_d = min(ds, mn_d);
    }
    ll last_x = 0;
    ll output = MAX_N;
    ll left = 0, right = n + 1;
    ll mid = -1;
    if (n <= 2000) {
        ll min_out = MAX_N;
        for (int i = 0; i <= n; ++i) {
            ll current_dir = 1;
            ll cur_out = 0;
            ll last_x = 0;
            for (int j = 0; j < n; ++j) {
                robot rob = robots[j];
                if (j == i) current_dir = -1;
                if (rob.d != current_dir) ++cur_out;
                if (current_dir == 1) {
                    if (last_x < rob.x) { cur_out = MAX_N; break; }
                    last_x = rob.x + rob.p;
                }
                else {
                    if (last_x < rob.x - rob.p) { cur_out = MAX_N; break; }
                    last_x = rob.x;
                }
            }
            min_out = min(min_out, cur_out);
        }
        if (min_out == MAX_N) {cout << -1; return 0;}
        else {cout << min_out; return 0;}
    }
    else if (mn_d == 1) {
        ll last_x = 0;
        ll cur_dir = 1;
        ll total = 0;
        for (int i = 0; i < n; ++i) {
            robot rob = robots[i];
            if (cur_dir == 1) {
                if (last_x < rob.x) cur_dir = -1;
            }
            if (rob.d != cur_dir) ++total;
            if (cur_dir == 1) {
                last_x = rob.x + rob.p;
            }
            else {
                if (last_x < rob.x - rob.p) { cout << -1; return 0;}
                last_x = rob.x;
            }
        }
        cout << total;
    }
}