#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct Edge
{
    int a, b, c;
};

int n, m;
vector<vector<int>> G, G_R;
vector<int> D;
vector<Edge> E;
vector<int> used;
vector<int> order;

bool dfs_cycle(int v)
{
    used[v] = 1;
    bool ans = false;
    for (int u : G[v])
    {
        if (used[u] == 1)
            ans = true;
        else if (used[u] == 0)
            ans |= dfs_cycle(u);
    }
    used[v] = 2;
    return ans;
}

void dfs(int v)
{
    used[v] = 1;
    for (int u : G[v])
    {
        if (used[u] == 0)
            dfs(u);
    }
    order.push_back(v);
}

void solve()
{
    cin >> n >> m;
    int a, b, c;
    E = vector<Edge>(m, {0, 0, 0});
    for (int i = 0; i < m; i++)
    {
        cin >> a >> b >> c; a--; b--;
        E[i] = {a, b, c};
    }
    D = vector<int>(n, 0);
    for (int i = 0; i < n; i++)
        cin >> D[i];
    G = vector<vector<int>>(2 * n, vector<int>());
    for (int i = 0; i < m; i++)
    {
        if ((E[i].c && D[E[i].a] + D[E[i].b] == 0) ||
                (!E[i].c && D[E[i].a] + D[E[i].b] == 2))
        {
            cout << "NO\n";
            return;
        }
        if (D[E[i].a] + D[E[i].b] != 1)
            continue;
        if (D[E[i].b] == 1)
            swap(E[i].a, E[i].b);
        if (E[i].c)
            G[E[i].b + n].push_back(E[i].a);
        else
            G[E[i].a].push_back(E[i].b + n);
    }
    for (int i = 0; i < n; i++) {
        if (!D[i]) {
            G[i + n].push_back(i);
        }
    }
    used = vector<int>(2 * n, 0);
    bool res = false;
    for (int i = 0; i < 2 * n; i++)
        if (used[i] == 0)
            res |= dfs_cycle(i);
    if (res)
    {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
//    G_R.assign(2 * n, vector<int>());
//    for (int i = 0; i < 2 * n; i++)
//    {
//        for (int v : G[i])
//        {
//            G_R[v].push_back(i);
//        }
//    }
    used = vector<int>(2 * n, 0);
    order.clear();
    for (int i = 0; i < 2 * n; i++)
        if (used[i] == 0)
            dfs(i);
    vector<pair<int, int>> ans;
    for (int i = 0; i < 2 * n; i++)
    {
        int cur = order[i];
        if (cur >= n)
            cur -= n;
        if (D[cur] == 1 && order[i] >= n)
            continue;
        ans.emplace_back(cur + 1, order[i] < n);
    }
    cout << ans.size() << '\n';
    for (auto& elem : ans)
        cout << elem.first << ' ' << elem.second << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t; cin >> t;
    while (t--)
        solve();
    return 0;
}