#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(v) (int)(v).size()
#define all(v) (v).begin(), (v).end()
const int inf = 1e9;
const ll INF = 1e18;

struct edge {
    int i, c, now;
    edge(int i, int c, int now): i(i), c(c), now(now) {};
};

const int N = 1e5 + 10;
vector <edge> g[N];
int n, m, d[N], state[N], used[2 * N];
vector <pair <int, int>> ans;

vector <int> g2[N * 2];

void set_v(int v, int clr) {
    if (state[v] != clr) {
        ans.emplace_back(v, clr);
        state[v] = clr;
    }
}

int dfs(int v) {
    used[v] = 1;
    for (auto [i, c, now] : g[v]) {
        if (used[i]) {
            continue;
        }
        int x = dfs(i);
        if (!x) {
            return 0;
        }
        if (d[i] == d[v]) {
            if (c != d[i]) {
                return 0;
            }
            set_v(i, c),  set_v(v, c);
        } else {
            if (d[i] == c) {
                set_v(i, d[i]), set_v(v, d[i]);
            } else if (d[i] == 0) {
                set_v(i, 1), set_v(v, 1);
                g2[i * 2].push_back(v * 2 + 1);
            } else {
                set_v(i, 0), set_v(v, 0);
                g2[i * 2 + 1].push_back(v * 2);
            }
        }
    }
    return 1;
}

void dfs2(int v) {
    used[v] = 1;
    for (int i : g2[v]) {
        if (!used[i]) {
            dfs2(i);
        }
    }
    set_v(v / 2, (v & 1));
}

void solve() {
    cin >> n >> m;
    ans = {};
    for (int i = 1; i <= n; ++i) {
        g[i] = {};
        state[i] = used[i] = 0;
    }
    for (int i = 1; i <= m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].emplace_back(b, c, 0);
        g[b].emplace_back(a, c, 0);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    if (!dfs(1)) {
        cout << "NO\n";
        return;
    }
    for (int i = 1; i <= 2 * n + 1; ++i) {
        used[i] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[2 * i + d[i]]) {
            dfs2(2 * i + d[i]);
        }
    }
    for (int i = 1; i <= n; ++i) {
        set_v(i, d[i]);
    }
    cout << "YES\n";
    cout << sz(ans) << '\n';
    for (auto [i, j] : ans) {
        cout << i << ' ' << j << '\n';
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}