#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int main() {
	fastio();
	ll n;
	cin >> n;
	vector<ll>x(n), p(n), d(n);
	for (ll i = 0; i < n; i++) {
		cin >> x[i] >> p[i] >> d[i];
		if (d[i] == -1) d[i] = 0;
	}
	vector<array<ll, 2>> dp(n, { INF, INF });
	dp[0][d[0]] = 0;
	dp[0][1 - d[0]] = 1;
	for (ll i = 1; i < n; i++) {
		for (ll a = 0; a < 2; a++) {
			for (ll b = 0; b < 2; b++) {
				ll l = x[i] - x[i - 1];
				bool ok = 0;
				ok |= (a == 1 && p[i - 1] >= l);
				ok |= (b == 0 && p[i] >= l);
				ok |= (a == 1 && b == 0 && p[i] + p[i - 1] >= l);
				if (ok) {
					dp[i][b] = min(dp[i][b], dp[i - 1][a] + (d[i] != b));
				}
			}
		}
	}
	if (min(dp[n - 1][0], dp[n - 1][1]) < INF) cout << min(dp[n - 1][0], dp[n - 1][1]) << "\n";
	else cout << "-1\n";
	return 0;
}