#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

bool isc(ll v, vector<vector<ll>>& g, vector<ll>& used) {
	used[v] = 1;
	for (ll u : g[v]) {
		if (used[u] == 0) {
			if (isc(u, g, used)) return 1;
		}
		else if (used[u] == 1) return 1;
	}
	used[v] = 2;
	return 0;
}

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<vector<array<ll, 2>>> gog(n + 1);
		for (ll i = 0; i < m; i++) {
			ll u, v, w;
			cin >> u >> v >> w;
			gog[u].push_back({ v, w });
			gog[v].push_back({ u, w });
		}
		vector<ll> c(n + 1, 0);
		for (ll i = 1; i <= n; i++) {
			cin >> c[i];
		}
		bool ok = 1;
		vector<vector<ll>> g(n+1);
		for (ll v = 1; v <= n; v++) {
			for (auto p : gog[v]) {
				ll u = p[0], w = p[1];
				if (w != c[u] && w != c[v]) {
					ok = 0;
				}
				if (w != c[v]) {
					g[v].push_back(u);
				}
			}
		}
		vector<ll> used(n + 1, 0);
		for (ll v = 1; v <= n; v++) {
			if (!used[v]) {
				ok &= !isc(v, g, used);
			}
		}
		if (!ok) {
			cout << "NO\n";
			continue;
		}
		else {
			cout << "YES\n-1\n";
			continue;
		}
	}
	return 0;
}