#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll N = 1e7 + 10;
int fenend[N], fencnt[N];

ll fenget(int fen[], ll i) {
	i++;
	ll ans = 0;
	for (ll j = i; j > 0; j -= (j & (-j))) {
		ans += fen[j];
	}
	return ans;
}

void fenadd(int fen[], ll i, ll d) {
	i++;
	for (ll j = i; j < N; j += (j & (-j))) {
		fen[j] += d;
	}
}

int main() {
	fastio();
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n);
	for (ll i = 0; i < n; i++) cin >> t[i];
	vector<ll> s(m + 1, 0);
	for (ll i = 1; i <= m; i++) cin >> s[i];
	vector<ll> d(m, 0);
	for (ll i = 0; i < m; i++) d[i] = s[i + 1] - s[i];
	vector<vector<int>> num(n);
	ll cnt = 0;
	for (ll k = n; k <= n; k++) {
		set<array<ll, 2>> st;
		vector<ll> pos(k, 0);
		for (ll i = 0; i < k; i++) {
			st.insert({ (s[pos[i] + 1] - s[pos[i]]) * t[i], i });
		}
		ll res = 0;
		while (st.size() > 0) {
			auto p = *st.begin();
			st.erase(st.begin());
			res += st.size();
			ll v = p[1];
			num[v].push_back(cnt++);
			pos[v]++;
			if (pos[v] != m) {
				st.insert({ (s[pos[v] + 1] - s[pos[v]]) * t[v], v });
			}
		}
	}
	fill(fenend, fenend + cnt, 0);
	fill(fencnt, fencnt + cnt, 0);
	ll res = 0;
	for (ll i = 0; i < n; i++) {
		ll p = num[i].back();
		res += fenget(fencnt, p) + (i - fenget(fenend, p));
		fenadd(fenend, p, 1);
		fenadd(fencnt, p, 1);
		for (ll x = 0; x + 1 < num[i].size(); x++) {
			ll p = num[i][x];
			res += i - fenget(fenend, p);
			fenadd(fencnt, p, 1);
		}
		cout << res << "\n";
	}
	return 0;
}