#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

ll calc(vector<ll>& a) {
	ll n = a.size();
	vector<ll> r(n);
	for (ll i = 0; i < n; i++) {
		ll p = max(0ll, i - a[i]);
		r[p] = max(r[p], min(n - 1, i + a[i]));
	}
	for (ll i = 1; i < n; i++) {
		r[i] = max(r[i], r[i - 1]);
	}
	vector<ll> cnt(n + 1, 1);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		ans += cnt[i] * (n - 1 - r[i]);
		cnt[r[i] + 1] += cnt[i];
	}
	return ans;
}

int main() {
	fastio();
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	ll ans = calc(a);
	for (ll i = n / 2 - 10; i < n / 2 + 10; i++) {
		if (i < 0 || i >= n) continue;
		swap(a[i], x);
		ans = min(ans, calc(a));
		swap(a[i], x);
	}
	cout << ans << "\n";
	return 0;
}