#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

ll calc(vector<ll>& a) {
	ll n = a.size();
	vector<ll> r(n);
	for (ll i = 0; i < n; i++) {
		ll p = max(0ll, i - a[i]);
		r[p] = max(r[p], min(n - 1, i + a[i]));
	}
	for (ll i = 1; i < n; i++) {
		r[i] = max(r[i], r[i - 1]);
	}
	vector<ll> cnt(n + 1, 1);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		ans += cnt[i] * (n - 1 - r[i]);
		cnt[r[i] + 1] += cnt[i];
	}
	return ans;
}

int main() {
	fastio();
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i]; vector<ll> r(n);
	for (ll i = 0; i < n; i++) {
		ll p = max(0ll, i - a[i]);
		r[p] = max(r[p], min(n - 1, i + a[i]));
	}
	for (ll i = 1; i < n; i++) {
		r[i] = max(r[i], r[i - 1]);
	}
	vector<ll> cnt(n + 1, 1), smcnt(n + 1, 0), smgo(n + 1, 0);
	ll ans = 0;
	vector<ll> pref(n + 1, 0);
	for (ll i = 0; i < n; i++) {
		smcnt[i + 1] = smcnt[i] + cnt[i];
		ans += cnt[i] * (n - 1 - r[i]);
		pref[i + 1] = pref[i] + cnt[i] * (n - 1 - r[i]);
		cnt[r[i] + 1] += cnt[i];
	}
	vector<ll> addfor1(n + 1, 0), suff(n + 1, 0);
	for (ll i = n - 1; i >= 0; i--) {
		addfor1[i] = (n - 1 - r[i]) + addfor1[r[i] + 1];
		suff[i] = suff[i + 1] + addfor1[i];
	}
	for (ll i = 0; i < n; i++) {
		smgo[i + 1] = smgo[i] + addfor1[r[i] + 1] * cnt[i];
	}
	for (ll i = 0; i < n; i++) {
		ll a = max(0ll, i - x), b = min(n - 1, i + x);
		if (r[a] >= b) continue;
		ll e = lower_bound(r.begin() + a, r.end(), b) - r.begin();
		ll res = pref[a] + suff[e];
		ll f = lower_bound(all(r), e - 1) - r.begin();
		if (f <= a) {
			res += smgo[a] - smgo[f];
			res += (e - (smcnt[a] - smcnt[f])) * (addfor1[b + 1] + n - 1 - b);
		}
		else {
			res += e * (addfor1[b + 1] + n - 1 - b);
		}
		ans = min(ans, res);
	}
	cout << ans << "\n";
	return 0;
}