//#pragma GCC optimize("Ofast")
#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fastio

using namespace std;

#define int long long
#ifdef fastio
#define endl '\n'
#endif
#define all(x) x.begin(), x.end()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

struct Robot {
    int x, p, d;
};

int n;
vector<Robot> arr;
map<int, int> dp;

// получить минимум дп на этом отрезке
int get(int l) {
    int res = INT_MAX;
    for (const auto [k, v] : dp) {
        if (l <= k) {
            res = min(res, v);
        }
    }
    return res;
}

void save(int k, int v) {
    if (!dp.count(k) || v < dp[k]) {
        dp[k] = v;
    }
}

signed main() {
#ifdef ROMALOCAL
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    cin >> n;
    arr.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> arr[i].x >> arr[i].p >> arr[i].d;
    }

    dp[0] = 0;

    for (int i = 0; i < n; ++i) {
        int max_right = LLONG_MAX;
        if (i != n - 1) {
            max_right = arr[i + 1].x;
        }
        int max_left = LLONG_MIN;
        if (i != 0) {
            max_left = arr[i - 1].x;
        }
        {
            // пусть данный робот едет влево
            int y = max(arr[i].x - arr[i].p, max_left);
            int d = (arr[i].d == -1) ? 0 : 1;
            // значит нам нужно закрыть префикс до y, и сделать это более ранними роботами
            int var = get(y);
            if (var != INT_MAX) {
                save(arr[i].x, var + d);
            }
        }
        {
            // пусть данный робот едет вправо
            int y = min(arr[i].x + arr[i].p, max_right);
            int d = (arr[i].d == 1) ? 0 : 1;
            // значит нам нужно закрыть префикс до arr[i].x и сделать это более ранними роботами
            int var = get(arr[i].x);
            if (var != INT_MAX) {
                save(y, var + d);
            }
        }
    }

    int ans = get(arr[n - 1].x);
    if (ans == INT_MAX) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }

    return 0;
}