/*
 * 1) покрасить в + все вершины, у которых есть хотя бы одно положительное ребро
 * 2) найти все рисковые положительные ребра
 * 3) задать приоритеты вершин согласно рисковым положительным ребрам
 * 4) найти все испорченные отрицательные ребра, отсортировать их в рисковом порядке (не используется)
 * 5) для каждого испорченного ребра
 *   - сделать обе вершины 0
 *   - вернуть вершины в ответное состояние
 * 6) пройти по всем вершинам, присвоить им нужное состояние
 * */

//#pragma GCC optimize("Ofast")
#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fastio

using namespace std;

//#define int long long
#ifdef fastio
#define endl '\n'
#endif
#define all(x) x.begin(), x.end()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

struct Edge {
    int a, b, c, id;
};

int n, m;
bool ok = true;
vector<Edge> edges;
vector<pii> ans;
vector<int> needed;
vector<int> state;
vector<int> used;
vector<pair<vector<int>, vector<int>>> g;


void clear() {
    ok = true;
    edges.clear();
    ans.clear();
    needed.clear();
    state.clear();
    used.clear();
    g.clear();
}

void make(int a, int d) {
    if (state[a] == d) return;
    ans.emplace_back(a, d);
    state[a] = d;
}

void dfs(int v) {
    used[v] = true;
    if (needed[v] == 0) {
        make(v, 1);
        for (const auto &u: g[v].second) {
            if (!used[u]) {
                dfs(u);
            } else if (state[u] != 1) {
                ok = false;
            }
        }
        make(v, 0);
        for (const auto &u: g[v].first) {
            if (!used[u]) {
                dfs(u);
            } else {
                continue;
            }
        }
        make(v, needed[v]);
    } else {
        make(v, 0);
        for (const auto &u: g[v].first) {
            if (!used[u]) {
                dfs(u);
            } else if (state[u] != 0) {
                ok = false;
            }
        }
        make(v, 1);
        for (const auto &u: g[v].second) {
            if (!used[u]) {
                dfs(u);
            } else {
                continue;
            }
        }
        make(v, needed[v]);
    }
}

void solve() {
    clear();
    cin >> n >> m;

    edges.resize(m);
    state.resize(n, 0);
    needed.resize(n, false);
    used.resize(n, 0);
    g.resize(n);

    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        edges[i] = {a, b, c};
    }

    for (int i = 0; i < n; ++i) {
        int d;
        cin >> d;
        needed[i] = d;
    }

    // проверяем элементарные противоречия
    for (int i = 0; i < m; ++i) {
        if (!ok) break;
        if (edges[i].c == 1) {
            if (!needed[edges[i].a] && !needed[edges[i].b]) {
                ok = false;
            }
        } else if (edges[i].c == 0) {
            if (needed[edges[i].a] && needed[edges[i].b]) {
                ok = false;
            }
        } else {
            exit(-1);
        }
    }
    for (const auto &ed : edges) {
        if (needed[ed.a] == needed[ed.b]) {
            continue; // такие ребра сами примут нужный цвет
        }
        if (ed.c == 0) {
            g[ed.a].first.push_back(ed.b);
            g[ed.b].first.push_back(ed.a);
        } else if (ed.c == 1) {
            g[ed.a].second.push_back(ed.b);
            g[ed.b].second.push_back(ed.a);
        } else {
            exit(-1);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    if (!ok) {
        cout << "NO" << endl;
        return;
    }
    for (int i = 0; i < n; ++i) {
        make(i, state[i]);
    }
    cout << "YES" << endl;
    cout << ans.size() << endl;
    for (const auto &[a, b] : ans) {
        cout << a + 1 << " " << b << endl;
    }
}

signed main() {
#ifdef ROMALOCAL
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}