//#pragma GCC optimize("Ofast")
#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fastio

using namespace std;

//#define int long long
#ifdef fastio
#define endl '\n'
#endif
#define all(x) x.begin(), x.end()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

struct Edge {
    int a, b, c;
};

int n, m;
bool ok = true;
vector<Edge> edges;
vector<pii> ans;
vector<bool> first_plus;
vector<bool> needed;
set<pii> rules;

void clear() {
    ok = true;
    edges.clear();
    ans.clear();
    first_plus.clear();
    needed.clear();
    rules.clear();
}

void solve() {
    clear();
    cin >> n >> m;

    edges.resize(m);
    first_plus.resize(n, false);
    needed.resize(n, false);

    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        edges[i] = {a, b, c};
        if (c == 1) {
            first_plus[a] = true;
            first_plus[b] = true;
        }
    }

    for (int i = 0; i < n; ++i) {
        int d;
        cin >> d;
        needed[i] = d == 1;
    }

    // проверяем элементарные противоречия
    for (int i = 0; i < m; ++i) {
        if (!ok) break;
        if (edges[i].c == 1) {
            if (!needed[edges[i].a] && !needed[edges[i].b]) {
                ok = false;
            }
        } else if (edges[i].c == 0) {
            if (needed[edges[i].a] && needed[edges[i].b]) {
                ok = false;
            }
        } else {
            exit(-1);
        }
    }
    // создаем приоритеты в обработке ребер
    for (int i = 0; i < m; ++i) {
        if (!ok) break;
        if (edges[i].c == 0) continue;
        auto a = edges[i].a, b = edges[i].b;
        if (needed[a] && !needed[b]) {
            swap(a, b);
        }
        if (needed[a] && needed[b]) continue;
        assert(!needed[a] && needed[b]);
        // сначала обрабатываем ребра с b, потом с a
        rules.insert({b, a});
    }
    if (!ok) {
        cout << "NO" << endl;
        return;
    }
    // нет элементарных противоречий
    // первично включаем
    for (int i = 0; i < n; ++i) {
        if (first_plus[i]) {
            ans.emplace_back(i, 1);
        }
    }
    vector<Edge> e;
    for (int i = 0; i < m; ++i) {
        if (edges[i].c == 1) continue;
        if (!first_plus[edges[i].a] || !first_plus[edges[i].b]) {
            // ребро не было сломано
            continue;
        }
        e.push_back(edges[i]);
    }
    auto cmp = [&](const Edge &a, const Edge & b) {
        const auto [a1, b1, c1] = a;
        const auto [a2, b2, c2] = b;
        bool h1 = rules.count({a1, a2});
        bool h2 = rules.count({a1, b2});
        bool h3 = rules.count({b1, a2});
        bool h4 = rules.count({b1, b2});
        return h1 || h2 || h3 || h4;
    };
    for (int i = 0; i < e.size(); ++i) {
        if (!ok) break;
        for (int j = i + 1; j < e.size(); ++j) {
            if (cmp(e[i], e[j]) && cmp(e[j], e[i])) {
                exit(-1);
                ok = false;
                break;
            }
        }
    }
    if (!ok) {
        cout << "NO" << endl;
        return;
    }
    sort(all(e), cmp);
    for (const auto &ed : e) {
        // отрицательное ребро стало положительным. непорядок
        ans.emplace_back(ed.a, 0);
        ans.emplace_back(ed.b, 0);
        if (needed[ed.a]) {
            assert(!needed[ed.b]);
            ans.emplace_back(ed.a, 1);
        } else if (needed[ed.b]) {
            ans.emplace_back(ed.b, 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (needed[i] && !first_plus[i]) {
            ans.emplace_back(i, 1);
        } else if (first_plus[i] && !needed[i]) {
            ans.emplace_back(i, 0);
        }
    }
    cout << "YES" << endl;
    cout << ans.size() << endl;
    for (const auto &[a, b] : ans) {
        cout << a + 1 << " " << b << endl;
    }
}

signed main() {
#ifdef ROMALOCAL
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}