// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")
#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

using ll = long long;

void solve();

int32_t main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

const int N = 150150;
int t[N], s[N];
// pair<int, int> sst[N];

struct segment_tree1 {
    vector<ll> st;
    int size;
    segment_tree1(int sz = N) {
        size = sz;
        st.resize(2 * size, 0);
    }
    void update(int l, int r, int v) {
        l += size;
        r += size;
        while (l <= r) {
            if (l & 1) {
                st[l] += v;
                l++;
            }
            if (~r & 1) {
                st[r] += v;
                r--;
            }
            l >>= 1;
            r >>= 1;
        }
    }
    ll get(int i) {
        ll res = 0;
        i += size;
        while (i) {
            res += st[i];
            i >>= 1;
        }
        return res;
    }
};

struct segment_tree2 {
    vector<int> st;
    int size;
    segment_tree2(int sz = N) {
        size = sz;
        st.resize(2 * size, 0);
    }
    int get(int l, int r) {
    	int res = 0;
        l += size;
        r += size;
        while (l <= r) {
            if (l & 1) {
                res += st[l++];
            }
            if (~r & 1) {
                res += st[r--];
            }
            l >>= 1;
            r >>= 1;
        }
        return res;
    }
    void update(int i, int v) {
        i += size;
        while (i) {
        	st[i] += v;
            i >>= 1;
        }
    }
};

pair<ll, int> en[N];

int lb(pair<ll, int> k, int psl, int psr) {
	if (k <= en[psl + 1]) {
		return psl;
	}
	int l = psl, r = psr;
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (en[m] < k) {
			l = m;
		} else {
			r = m;
		}
	}
	return l;
}

const int K = 500;
int tmp[N * 500];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> t[i];
		// sst[i] = {t[i], i};
	}
	// sort(sst, sst + n);
	for (int i = 0; i < m; i++) {
		cin >> s[i];
	}
	int pr = 0;
	for (int i = 0; i < m; i++) {
		int prr = s[i];
		s[i] -= pr;
		pr = prr;
	}
	vector<pair<int, int>> nws(1, {s[0], 1});
	for (int i = 1; i < m; i++) {
		if (s[i] <= nws.back().x) {
			nws.back().y++;
		} else {
			nws.emplace_back(s[i], 1);
		}
	}
	m = nws.size();
	for (int i = 0; i < n; i++) {
		en[i] = make_pair(1ll * nws.back().x * t[i], i);
	}
	sort(en, en + n);
	vector<int> obr(n);
	for (int i = 0; i < n; i++) {
		obr[en[i].y] = i;
	}
	segment_tree1 st1(n);
	segment_tree2 st2(n);
	ll ans = 0;
	priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
	vector<int> ptr(n, 0);
	for (int i = 0; i < n; i++) {
		q.emplace(1ll * nws[ptr[i]].x * t[i], i);
	}
	assert(m < 500);
	int ptrr = 0;
	while (!q.empty()) {
		auto nw = q.top();
		q.pop();
		while (ptrr < n && en[ptrr] < nw) {
			ptrr++;
		}
		tmp[nw.y * m + ptr[nw.y]] = ptrr - 1;
		ptr[nw.y]++;
		if (ptr[nw.y] < m) {
			q.emplace(1ll * nws[ptr[nw.y]].x * t[nw.y], nw.y);
		}
	}
	for (int i = 0; i < n; i++) {
		ans += st1.get(obr[i]);
		int oldps = -1;
		for (int j = 0; j < m; j++) {
			int pos = tmp[i * m + j];
			// pair<ll, int> k = make_pair(1ll * nws[j].x * t[i], i);
			// if (oldps + K >= n || en[oldps + K] >= k) {
			// 	pos = lb(k, oldps, min(n, oldps + K));
			// } else {
			// 	pos = lb(k, oldps, n);
			// }
			// int pos = i - 1;
			// if (j != m - 1) {
			// 	pos = -1;
			// }
			oldps = pos;
			ans += 1ll * st2.get(pos + 1, n - 1) * nws[j].y;
			st1.update(pos + 1, n - 1, nws[j].y);
		}
		st2.update(obr[i], 1);
		cout << ans << '\n';
	}
}