#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

const int LG = 20, N = 1 << LG;
int a[N];

struct segment_tree {
	vector<int> st;
	int size;
	segment_tree(int sz = N) {
		size = sz;
		st.resize(2 * size, 0);
	}
	void update(int l, int r, int v) {
		l += size;
		r += size;
		while (l <= r) {
			if (l & 1) {
				st[l] = max(st[l], v);
				l++;
			}
			if (~r & 1) {
				st[r] = max(st[r], v);
				r--;
			}
			l >>= 1;
			r >>= 1;
		}
	}
	int get(int i) {
		int res = 0;
		i += size;
		while (i) {
			res = max(res, st[i]);
			i >>= 1;
		}
		return res;
	}
};

ll calc(int n) {
	vector<ll> dp(n + 1);
	dp[n] = 0;
	segment_tree st(n + 1);
	for (int i = 0; i < n; i++) {
		st.update(max(0, i - a[i]), min(n - 1, i + a[i]), min(n, i + a[i] + 1));
	}
	ll res = 0;
	for (int i = n - 1; i >= 0; i--) {
		int to = st.get(i);
		dp[i] = dp[to] + n - to;
		res += dp[i];
	}
	return res;
}

void solve() {
	int n, x;
	cin >> n >> x;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll ans = calc(n);
	// for (int i = 0; i < n; i++) {
	// 	if (x > a[i]) {
	// 		swap(a[i], x);
	// 		ans = min(ans, calc(n));
	// 		swap(a[i], x);
	// 	}
	// }
	swap(a[n / 2], x);
	ans = min(ans, calc(n));
	cout << ans << '\n';
}