#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
vector<pair<int, int>> answer;
vector<int> D;
vector<vector<pair<int, int>>> g;
vector<int> used;
bool has_cycle;

void dfs(int u, int prev = -1, int prev_c = -1) {
    used[u] = 1;
    for (auto [v, c] : g[u]) {
        if (v == prev || c == prev_c) continue;
        if (used[v] == 0) {
            dfs(v, u, c);
            if (has_cycle) return;
        } else if (used[v] == 1) {
            has_cycle = true;
            return;
        }
    }
    used[u] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> E(m);
    vector<int> C(m + 1);
    map<pair<int, int>, int> cc;
    g.assign(n + 1, {});
    used.assign(n + 1, 0);
    answer.clear();
    has_cycle = false;

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        cc[{u, v}] = c;
        cc[{v, u}] = c;
        E[i] = {u, v, c};
        C[i + 1] = c;
    }
    D.assign(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (auto [u, v, c] : E) {
        if (D[u] != D[v]) {
            g[u].emplace_back(v, c);
            g[v].emplace_back(u, c);
        }
    }

    for (auto& [u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs(i);
            if (has_cycle) {
                cout << "NO\n";
                return;
            }
        }
    }

    cout << "YES\n-1\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}