#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
vector<pair<int, int>> answer;
vector<int> D;
vector<vector<pair<int, int>>> g;
vector<int> used;
bool has_cycle;

void dfs(int u, int prev = -1, int prev_c = -1) {
    used[u] = 1;
    for (auto [v, c]: g[u]) {
        if (v == prev || c == prev_c) continue;
        if (used[v] == 0) {
            dfs(v, u, c);
            if (has_cycle) return;
        } else if (used[v] == 1) {
            has_cycle = true;
            return;
        }
    }
    used[u] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> E(m);
    vector<int> C(m);
    map<pair<int, int>, int> cc;
    g.assign(n + 1, {});
    used.assign(n + 1, 0);
    answer.clear();
    has_cycle = false;

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        cc[{u, v}] = c;
        cc[{v, u}] = c;
        E[i] = {u, v, c};
        C[i] = c;
    }
    D.assign(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (auto [u, v, c]: E) {
        if (D[u] != D[v]) {
            g[u].emplace_back(v, c);
            g[v].emplace_back(u, c);
        }
    }

    for (auto &[u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs(i);
            if (has_cycle) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector<int> A(n + 1), B(m);
    while (true) {
        bool is_correct = true;
        for (int i = 1; i <= n; i++) {
            if (A[i] != D[i]) {
                answer.emplace_back(i, D[i]);
                A[i] = D[i];
                is_correct = false;
                for (int j = 0; j < m; j++) {
                    if (get<0>(E[j]) == i) {
                        if (A[i] == A[get<1>(E[j])]) {
                            B[j] = A[i];
                        }
                    }
                    if (get<1>(E[j]) == i) {
                        if (A[i] == A[get<0>(E[j])]) {
                            B[j] = A[i];
                        }
                    }
                }
            }
        }
        for (int i = 0; i < m; i++) {
            auto [u, v, c] = E[i];
            if (c != B[i]) {
                answer.emplace_back(u, c);
                A[u] = c;
                for (int j = 0; j < m; j++) {
                    if (get<0>(E[j]) == u) {
                        if (A[u] == A[get<1>(E[j])]) {
                            B[j] = A[u];
                        }
                    }
                    if (get<1>(E[j]) == u) {
                        if (A[u] == A[get<0>(E[j])]) {
                            B[j] = A[u];
                        }
                    }
                }
                answer.emplace_back(v, c);
                A[v] = c;
                for (int j = 0; j < m; j++) {
                    if (get<0>(E[j]) == v) {
                        if (A[v] == A[get<1>(E[j])]) {
                            B[j] = A[v];
                        }
                    }
                    if (get<1>(E[j]) == v) {
                        if (A[v] == A[get<0>(E[j])]) {
                            B[j] = A[v];
                        }
                    }
                }
                is_correct = false;
            }
        }
        if (is_correct) {
            break;
        }
    }

    cout << "YES\n" << answer.size() << "\n";
    for (auto [v, x]: answer) {
        cout << v << " " << x << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}