#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
vector<pair<int, int>> answer;
vector<int> D;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> sg;
vector<int> used;
bool has_cycle;

void dfs(int u, int prev = -1, int prev_c = -1) {
    used[u] = 1;
    for (auto [v, c]: g[u]) {
        if (v == prev || c == prev_c) continue;
        if (used[v] == 0) {
            dfs(v, u, c);
            if (has_cycle) return;
        } else if (used[v] == 1) {
            has_cycle = true;
            return;
        }
    }
    used[u] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> E(m);
    vector<int> C(m);
    g.assign(n + 1, {});
    sg.assign(n + 1, {});
    used.assign(n + 1, 0);
    answer.clear();
    has_cycle = false;

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        E[i] = {u, v, c};
        C[i] = c;
        sg[u].emplace_back(v, i);
        sg[v].emplace_back(u, i);
    }
    D.assign(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (auto [u, v, c]: E) {
        if (D[u] != D[v]) {
            g[u].emplace_back(v, c);
            g[v].emplace_back(u, c);
        }
    }

    for (auto &[u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs(i);
            if (has_cycle) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector<int> order1(n), order2(m);
    for (int i = 0; i < n; i++) order1[i] = i + 1;
    for (int i = 0; i < m; i++) order2[i] = i;
    mt19937 rnd(42);
    shuffle(order1.begin(), order1.end(), rnd);
    shuffle(order2.begin(), order2.end(), rnd);

    vector<int> A(n + 1), B(m);
    while (true) {
        bool is_correct = true;
        for (int i: order1) {
            if (A[i] != D[i]) {
                answer.emplace_back(i, D[i]);
                A[i] = D[i];
                is_correct = false;
                for (auto [v, num]: sg[i]) {
                    if (A[i] == A[v]) {
                        B[num] = A[i];
                    }
                }
            }
        }
        for (int i: order2) {
            auto [u, v, c] = E[i];
            if (c != B[i]) {
                if (A[u] != c) {
                    answer.emplace_back(u, c);
                    A[u] = c;
                    for (auto [x, num]: sg[u]) {
                        if (A[u] == A[x]) {
                            B[num] = A[x];
                        }
                    }
                }
                if (A[v] != c) {
                    answer.emplace_back(v, c);
                    A[v] = c;
                    for (auto [x, num]: sg[v]) {
                        if (A[v] == A[x]) {
                            B[num] = A[x];
                        }
                    }
                }
                is_correct = false;
            }
        }
        if (is_correct) {
            break;
        }
    }

    cout << "YES\n" << answer.size() << "\n";
    for (auto [v, x]: answer) {
        cout << v << " " << x << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}