#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

const int INF = 1e9 + 1000;

struct Edge {
    int i, x;

    Edge(int i, int x) : i(i), x(x) {}
};

vector<bool> target_vert;
vector<bool> target_edges;
vector<bool> curr_edges;
vector<vector<Edge>> graph;
unordered_set<int> bad_edges;
vector<pair<int, int>> ans;

void turn_on(int v) {
    ans.emplace_back(v, 1);
    for (Edge e : graph[v]) {
        if (target_vert[e.x]) {
            curr_edges[e.i] = true;
            if (!target_edges[e.i]) {
                bad_edges.insert(e.i);
            } else {
                bad_edges.erase(e.i);
            }
        }
    }
}

void turn_off(int v) {
    ans.emplace_back(v, 0);
    for (Edge e : graph[v]) {
        if (!target_vert[e.x]) {
            curr_edges[e.i] = false;
            if (target_edges[e.i]) {
                bad_edges.insert(e.i);
            } else {
                bad_edges.erase(e.i);
            }
        }
    }
}

void solve() {
    ans.clear();
    int n, m;
    cin >> n >> m;
    graph = vector<vector<Edge>>(n);
    target_vert = vector<bool>(n);
    target_edges = vector<bool>(m);
    curr_edges = vector<bool>(m);
    vector<pair<int, int>> edges(m);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        target_edges[i] = c;
        edges[i] = {a - 1, b - 1};
        graph[a - 1].emplace_back(i, b - 1);
        graph[b - 1].emplace_back(i, a - 1);
    }
    for (int i = 0; i < n; ++i) {
        int d;
        cin >> d;
        target_vert[i] = d;
        if (d == 1) {
            ans.emplace_back(i, 1);
        }
    }
    vector<int> times(m);
    bad_edges.clear();
    bad_edges.reserve(m);
    for (int i = 0; i < m; ++i) {
        curr_edges[i] = target_vert[edges[i].first] && target_vert[edges[i].second];
        if (target_edges[i] != curr_edges[i]) {
            bad_edges.insert(i);
        }
    }
    while (!bad_edges.empty()) {
        int e_i = *bad_edges.begin();
        if (++times[e_i] > 30) {
            cout << "NO\n";
            return;
        }
        auto [a, b] = edges[e_i];
        if (target_edges[e_i]) {
            assert(!(target_vert[a] && target_vert[b]));
            if (!target_vert[a] && !target_vert[b]) {
                cout << "NO\n";
                return;
            } else if (!target_vert[a]) {
                turn_on(a);
                turn_off(a);
            } else {
                turn_on(b);
                turn_off(b);
            }
        } else {
            assert(target_vert[a] || target_vert[b]);
            if (target_vert[a] && target_vert[b]) {
                cout << "NO\n";
                return;
            } else if (target_vert[a]) {
                turn_off(a);
                turn_on(a);
            } else {
                turn_off(b);
                turn_on(b);
            }
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b << "\n";
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
