#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

const ll INF = 1e18;

void solve() {
    ll n;
    cin >> n;
    vector<ll> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == -1) {
            d[i]++;
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(2, INF));
    dp[0][d[0]] = 0;
    dp[0][d[0] ^ 1] = 1;
    for (int i = 1; i < n; ++i) {
        ll dist = x[i] - x[i - 1];
        if (p[i] >= dist) {
            dp[i][0] = min(dp[i][0], min(dp[i - 1][0], dp[i - 1][1]) + d[i]);
        }
        if (p[i] + p[i - 1] >= dist) {
            dp[i][0] = min(dp[i][0], dp[i - 1][1] + d[i]);
        }
        if (p[i - 1] >= dist) {
            dp[i][1] = min(dp[i][1], dp[i - 1][1] + (d[i] ^ 1));
        }
    }
    ll ans = min(dp[n - 1][1], dp[n - 1][0]);
    cout << (ans == INF ? -1 : ans);
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
    return 0;
}
