#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << '\n';
        }
    }
    return out;
}

const int MAXN = 1e5 + 1;
vector<ll> g[MAXN], order;
ll d[MAXN], used[MAXN];

vector<pair<ll, ll>> ans;

bool dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 1) {
            return true;
        }
        if (!used[u]) {
            bool x = dfs(u);
            if (x) {
                return x;
            }
        }
    }
    order.push_back(v);
    used[v] = 2;
    return false;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    ans.clear();
    order.clear();
    fill(d, d + n + 1, 0);
    fill(used, used + n + 1, 0);
    fill(g, g + n + 1, vector<ll>(0));
    vector<tuple<ll, ll, ll>> e(m);
    for (int i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        e[i] = {a, b, c};
    }
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (auto &[a, b, c] : e) {
        if (d[a] == d[b] && d[a] != c) {
            return void(cout << "NO");
        }
        if (d[a] == d[b]) {
            continue;
        }
        if (d[a] > d[b]) {
            swap(a, b);
        }
        if (c == 0) {
            g[a].push_back(b);
        } else {
            g[b].push_back(a);
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            bool x = dfs(i);
            if (x) {
                return void(cout << "NO");
            }
        }
    }
    reverse(order.begin(), order.end());
    for (int i = 0; i < n; ++i) {
        int v = order[i];
        if (d[v] == 1) {
            ans.emplace_back(v, 1);
        }
        for (auto u : g[v]) {
            if (d[u] == 0) {
                ans.emplace_back(u, 1);
                ans.emplace_back(u, 0);
            }
        }
    }
    cout << "YES\n" << sz(ans) << '\n' << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
    return 0;
}
