#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

const ll MAXN = 3e5 + 5;
ll tree[MAXN * 4], tree1[MAXN * 4], tree2[MAXN * 4], tree3[MAXN * 4];

void update(ll v, ll l, ll r, ll i, ll x) {
    if (r - l == 1) {
        tree[v] += x;
    } else {
        int m = (r + l) / 2;
        if (i < m) {
            update(v << 1, l, m, i, x);
        } else {
            update(v << 1 | 1, m, r, i, x);
        }
        tree[v] = tree[v << 1] + tree[v << 1 | 1];
    }
}

ll get(ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= rq || lq >= r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree[v];
    }
    ll m = (r + l) / 2;
    return get(v << 1, l, m, lq, rq) + get(v << 1 | 1, m, r, lq, rq);
}

void update1(ll v, ll l, ll r, ll i, ll x) {
    if (r - l == 1) {
        tree1[v] += x;
    } else {
        int m = (r + l) / 2;
        if (i < m) {
            update1(v << 1, l, m, i, x);
        } else {
            update1(v << 1 | 1, m, r, i, x);
        }
        tree1[v] = tree1[v << 1] + tree1[v << 1 | 1];
    }
}

ll get1(ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= rq || lq >= r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree1[v];
    }
    ll m = (r + l) / 2;
    return get1(v << 1, l, m, lq, rq) + get1(v << 1 | 1, m, r, lq, rq);
}

void update2(ll v, ll l, ll r, ll i, ll x) {
    if (r - l == 1) {
        tree2[v] += x;
    } else {
        int m = (r + l) / 2;
        if (i < m) {
            update2(v << 1, l, m, i, x);
        } else {
            update2(v << 1 | 1, m, r, i, x);
        }
        tree2[v] = tree2[v << 1] + tree2[v << 1 | 1];
    }
}

ll get2(ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= rq || lq >= r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree2[v];
    }
    ll m = (r + l) / 2;
    return get2(v << 1, l, m, lq, rq) + get2(v << 1 | 1, m, r, lq, rq);
}

void update3(ll v, ll l, ll r, ll i, ll x) {
    if (r - l == 1) {
        tree3[v] += x;
    } else {
        int m = (r + l) / 2;
        if (i < m) {
            update3(v << 1, l, m, i, x);
        } else {
            update3(v << 1 | 1, m, r, i, x);
        }
        tree3[v] = tree3[v << 1] + tree3[v << 1 | 1];
    }
}

ll get3(ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= rq || lq >= r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree3[v];
    }
    ll m = (r + l) / 2;
    return get3(v << 1, l, m, lq, rq) + get3(v << 1 | 1, m, r, lq, rq);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m);
    cin >> t >> s;
    vector<vector<ll>> val(n, vector<ll>(m));
    vector<ll> vals;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (j == 0) {
                val[i][j] = t[i] * s[j];
            } else {
                val[i][j] = t[i] * (s[j] - s[j - 1]);
            }
            vals.push_back(val[i][j]);
        }
    }
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            val[i][j] = lower_bound(vals.begin(), vals.end(), val[i][j]) - vals.begin();
        }
    }
    ll ans = 0;
    // 0 -- po y
    // 1 -- max(x, y)
    // 2 -- po x
    // 3 -- min(x, y)
    for (int i = 0; i < n; ++i) {
        ll c = get1(1, 0, MAXN, 0, val[i][0] + 1);
        ll c1 = get(1, 0, MAXN, val[i][0], val[i][1] + 1);
        ans += i - c + i - c - c1;
        ll a1 = get2(1, 0, MAXN, val[i][0], val[i][1] + 1);
        ll a2 = get3(1, 0, MAXN, max(val[i][0], val[i][1]) + 1, MAXN);
        ans += c + c1 + a1;
        cout << ans << '\n';
        update(1, 0, MAXN, val[i][1], 1);
        update1(1, 0, MAXN, max(val[i][0], val[i][1]), 1);
        update2(1, 0, MAXN, val[i][0], 1);
        update3(1, 0, MAXN, min(val[i][0], val[i][1]), 1);
    }
//    for (int i = 2; i <= n; ++i) {
//        ans += m * (i - 1);
//        cout << ans << '\n';
//    }
//    for (int i = 0; i < n; ++i) {
//        set<tuple<ll, ll, ll>> q;
//        for (int j = 0; j <= i; ++j) {
//            q.insert({s[0] * t[j], j, 0});
//        }
//        ll ans = 0;
//        while (!q.empty()) {
//            auto [tm, j, id] = *q.begin();
//            q.erase(q.begin());
//            ans += sz(q);
//            if (id != m - 1) {
//                q.insert({t[j] * (s[id + 1] - s[id]), j, id + 1});
//            }
//        }
//        cout << ans << '\n';
//    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
    return 0;
}
