#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << '\n';
        }
    }
    return out;
}

const ll MAXN = 1e6 + 5;
ll tree[MAXN * 4], tree1[MAXN * 4];

void update(ll v, ll l, ll r, ll i, ll x) {
    if (r - l == 1) {
        tree[v] = x;
    } else {
        int m = (r + l) / 2;
        if (i < m) {
            update(v << 1, l, m, i, x);
        } else {
            update(v << 1 | 1, m, r, i, x);
        }
        tree[v] = tree[v << 1] + tree[v << 1 | 1];
    }
}

ll get(ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= rq || lq >= r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree[v];
    }
    ll m = (r + l) / 2;
    return get(v << 1, l, m, lq, rq) + get(v << 1 | 1, m, r, lq, rq);
}

void update1(ll v, ll l, ll r, ll i, ll x) {
    if (r - l == 1) {
        tree1[v] = x;
    } else {
        int m = (r + l) / 2;
        if (i < m) {
            update1(v << 1, l, m, i, x);
        } else {
            update1(v << 1 | 1, m, r, i, x);
        }
        tree1[v] = tree1[v << 1] + tree1[v << 1 | 1];
    }
}

ll get1(ll v, ll l, ll r, ll lq, ll rq) {
    if (l >= rq || lq >= r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree1[v];
    }
    ll m = (r + l) / 2;
    return get1(v << 1, l, m, lq, rq) + get1(v << 1 | 1, m, r, lq, rq);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m);
    cin >> t >> s;
    vector<vector<ll>> val(n, vector<ll>(m));
    vector<ll> vals;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (j == 0) {
                val[i][j] = t[i] * s[j];
            } else {
                val[i][j] = t[i] * (s[j] - s[j - 1]);
            }
            //vals.push_back(val[i][j]);
        }
    }
    /*sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            val[i][j] = lower_bound(vals.begin(), vals.end(), val[i][j]) - vals.begin();
        }
    }*/
    vector<ll> vec(n * m + 1);
    vector<vector<ll>> idx(n, vector<ll>(m));
    set<tuple<ll, ll, ll>> q;
    for (int j = 0; j < n; ++j) {
        q.insert({s[0] * t[j], j, 0});
    }
    ll ans = 0, now = 0;
    while (!q.empty()) {
        auto [tm, j, id] = *q.begin();
        vec[now] = tm;
        idx[j][id] = now;
        q.erase(q.begin());
        update1(1, 0, MAXN, now, 1);
        ans += sz(q);
        if (id != m - 1) {
            q.insert({t[j] * (s[id + 1] - s[id]), j, id + 1});
        } else {
            update(1, 0, MAXN, now, 1);
        }
        now++;
    }
    vector<ll> answer(n);
    for (int i = n - 1; i >= 0; --i) {
        answer[i] = ans;
        for (int j = 0; j < m; ++j) {
            ans -= i - get(1, 0, MAXN, 0, idx[i][j]);
            update1(1, 0, MAXN, idx[i][j], 0);
        }
        update(1, 0, MAXN, idx[i][m - 1], 0);
        ans -= get1(1, 0, MAXN, 0, idx[i][m - 1]);
    }
    cout << answer << '\n';
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
    return 0;
}
