#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    ll n = sz(a);
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << '\n';
        }
    }
    return out;
}

const ll maxx = 1 << 24;
int tree[maxx << 1], tree1[maxx << 1];

void update(ll i, ll x) {
    i += maxx;
    tree[i] = x;
    i >>= 1;
    while (i) {
        tree[i] = tree[i << 1] + tree[i << 1 | 1];
        i >>= 1;
    }
}

int get(int l, int r) {
    l += maxx;
    r += maxx;
    int res = 0;
    while (r - l) {
        if (l & 1) {
            res += tree[l++];
        }
        if (r & 1) {
            res += tree[--r];
        }
        l >>= 1;
        r >>= 1;
    }
    return res;
}

void update1(ll i, ll x) {
    i += maxx;
    tree1[i] = x;
    i >>= 1;
    while (i) {
        tree1[i] = tree1[i << 1] + tree1[i << 1 | 1];
        i >>= 1;
    }
}

int get1(int l, int r) {
    l += maxx;
    r += maxx;
    int res = 0;
    while (r - l) {
        if (l & 1) {
            res += tree1[l++];
        }
        if (r & 1) {
            res += tree1[--r];
        }
        l >>= 1;
        r >>= 1;
    }
    return res;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m);
    cin >> t >> s;
    vector<vector<ll>> val(n, vector<ll>(m));
    vector<ll> vals;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (j == 0) {
                val[i][j] = t[i] * s[j];
            } else {
                val[i][j] = t[i] * (s[j] - s[j - 1]);
            }
            //vals.push_back(val[i][j]);
        }
    }
    /*sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            val[i][j] = lower_bound(vals.begin(), vals.end(), val[i][j]) - vals.begin();
        }
    }*/
    vector<ll> vec(n * m + 1);
    vector<vector<ll>> idx(n, vector<ll>(m));
    set<tuple<ll, ll, ll>> q;
    for (int j = 0; j < n; ++j) {
        q.insert({s[0] * t[j], j, 0});
    }
    ll ans = 0, now = 0;
    while (!q.empty()) {
        auto [tm, j, id] = *q.begin();
        vec[now] = tm;
        idx[j][id] = now;
        q.erase(q.begin());
        update1(now, 1);
        ans += sz(q);
        if (id != m - 1) {
            q.insert({t[j] * (s[id + 1] - s[id]), j, id + 1});
        } else {
            update(now, 1);
        }
        now++;
    }
    vector<ll> answer(n);
    for (int i = n - 1; i >= 0; --i) {
        answer[i] = ans;
        for (int j = 0; j < m; ++j) {
            ans -= i - get(0, idx[i][j]);
            update1(idx[i][j], 0);
        }
        update(idx[i][m - 1], 0);
        ans -= get1(0, idx[i][m - 1]);
    }
    cout << answer << '\n';
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
    return 0;
}
