#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 2e9;

struct Fast {
    vector<int> t;

    void change(int v, int l, int r, int ql, int qr, int val) {
        if (l >= qr || r <= ql) return;
        if (l >= ql && r <= qr) {
            t[v] = max(t[v], val);
            return;
        }
        int mid = (r + l) / 2;
        change(2 * v + 1, l, mid, ql, qr, val);
        change(2 * v + 2, mid, r, ql, qr, val);
    }

    int get(int v, int l, int r, int pos) {
        if (r - l == 1) {
            return t[v];
        }
        int mid = (r + l) / 2;
        if (mid > pos) {
            return max(t[v], get(2 * v + 1, l, mid, pos));
        }
        return max(t[v], get(2 * v + 2, mid, r, pos));
    }

    void solve() {
        int n, x;
        cin >> n >> x;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        t.resize(4 * n, 0);
        vector<int> nxt(n, 0);
        vector<ll> ans(n, 0);
        ll res = inf;
        for (int pos = -1; pos < n; pos++) {
            int pred;
            if (pos != -1) {
                pred = a[pos];
                a[pos] = x;
            }
            fill(t.begin(), t.end(), 0);
            for (int i = 0; i < n; i++) {
                int l = max(0, i - a[i]);
                int r = min(n - 1, i + a[i]);
                change(0, 0, n, l, r + 1, r);
            }
            for (int i = 0; i < n; i++) {
                nxt[i] = get(0, 0, n, i);
            }
            ll cres = 0;
            ans[n - 1] = 0;
            for (int i = n - 2; i >= 0; i--) {
                if (nxt[i + 1] == nxt[i]) {
                    ans[i] = ans[i + 1];
                } else {
                    int nx_p = nxt[i] + 1;
                    ans[i] = ans[nx_p] + (n - nx_p);
                }
                cres += ans[i];
            }
            if (pos != -1) {
                a[pos] = pred;
            }
            res = min(res, cres);
        }
        cout << res;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll times = 1;
//    cin >> times;
    while (times--) {
        Fast f;
        f.solve();
    }
    return 0;
}