#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct edge {
    int u, v;
    bool c;
    int ind;
    edge(int u = 0, int v = 0, bool c = 0, int ind = 0) : u(u), v(v), c(c), ind(ind) {}
};

vector<edge> ed;
vector<bool> col;
vector<int> g[100000 + 1];
vector<pair<int, int>> ans;

void dfs(int v = 1, int p = -1) {
    vector<int> p00, p11, p01, p10;
    for (auto i : g[v]) {
        if (i == p)
            continue;
        if (ed[i].u != v)
            swap(ed[i].u, ed[i].v);
        auto e = ed[i];
        
        if (col[e.v]) {
            if (!e.c) {
                p01.push_back(i);
            } else {
                p11.push_back(i);
            }
        } else {
            if (!e.c) {
                p00.push_back(i);
            } else {
                p10.push_back(i);
            }
        }
    }
    if (!col[v]) {
        ans.push_back({v, 1});
        for (auto i : p11)
            dfs(ed[i].v, i);
        ans.push_back({v, 0});
        for (auto i : p01)
            dfs(ed[i].v, i);
        for (auto i : p00)
            dfs(ed[i].v, i);
    } else {
        //ans.push_back({v, 0});
        for (auto i : p00)
            dfs(ed[i].v, i);
        ans.push_back({v, 1});
        for (auto i : p10)
            dfs(ed[i].v, i);
        for (auto i : p11)
            dfs(ed[i].v, i);
    }
}

void solve() {
    ed.clear();
    col.clear();
    ans.clear();

    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        g[i].clear();
    col.assign(n + 1, 0);

    bool tf2 = 1;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        ed.push_back(edge(u, v, c, i));
        g[u].push_back(i);
        g[v].push_back(i);
        if (c == 0)
            tf2 = 0;
    }
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        col[i] = x;
    }

    bool tf = 1;
    for (auto [u, v, c, i] : ed) {
        if ((col[u] && col[v] && !c) || (!col[u] && !col[v] && c))
            tf = 0;
    }

    if (!tf) {
        cout << "NO" << endl;
        return;
    } else {
        cout << "YES" << endl;

        if (m != n - 1 && !tf2) {
            cout << -1 << endl;
            return;
        }
    }

    if (tf2) {
        for (int i = 1; i <= n; i++)
            ans.push_back({i, 1});
        for (int i = 1; i <= n; i++)
            if (!col[i])
                ans.push_back({i, 0});
    } else {
        dfs();
    }

    cout << ans.size() << '\n';
    for (auto [x, y] : ans)
        cout << x << ' ' << y << '\n';
    cout << endl;
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t > 0) {
        t--;
        solve();
    }
}