#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
 
struct edge {
    int u, v;
    bool c;
    int ind;
    edge(int u = 0, int v = 0, bool c = 0, int ind = 0) : u(u), v(v), c(c), ind(ind) {}
};
 
vector<edge> ed;
vector<bool> col;
vector<int> g[100000 + 1];
vector<int> used(100000 + 1, 0);
vector<int> ts;

bool topsort(int v, int p = -1) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p || used[u] == 2)
            continue;
        if (used[u] == 1 || !topsort(u, v))
            return 0;
    }
    ts.push_back(v);
    used[v] = 2;
    return 1;
}

void solve() {
    ed.clear();
    col.clear();
    ts.clear();
 
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        used[i] = 0;
    }
    col.assign(n + 1, 0);
 
    bool tf2 = 1;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        ed.push_back(edge(u, v, c, i));
    }
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        col[i] = x;
    }

    for (auto [u, v, c, i] : ed) {
        if (c) {
            if (col[u] && !col[v]) {
                g[u].push_back(v);
            }
            if (col[v] && !col[u]) {
                g[v].push_back(u);
            }
        } else {
            if (!col[u] && col[v]) {
                g[u].push_back(v);
            }
            if (!col[v] && col[u]) {
                g[v].push_back(u);
            }
        }
    }

    bool tf = 1;
    for (auto [u, v, c, i] : ed) {
        if ((col[u] && col[v] && !c) || (!col[u] && !col[v] && c))
            tf = 0;
    }
    for (int i = 1; i <= n; i++)
        if (used[i] == 0)
            tf = (!topsort(i) ? 0 : tf);
 
    if (!tf) {
        cout << "NO" << endl;
        return;
    }
    cout << "YES\n";

    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; i++)
        if (col[i])
            ans.push_back({i, 1});
    reverse(ts.begin(), ts.end());
    for (auto x : ts) {
        ans.push_back({ x, !col[x] });
        ans.push_back({ x, col[x] });
    }

    cout << ans.size() << '\n';
    for (auto [x, y] : ans)
        cout << x << ' ' << y << '\n';
    cout << endl;
}
 
int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
 
    int t;
    cin >> t;
    while (t > 0) {
        t--;
        solve();
    }
}