#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;


const int inf = 1e9 + 10;
const int maxn = 1e5 + 10;

vector<pii> g[maxn];
vector<int> g1[maxn];
vector<int> tin;
int cycles;
vector<int> ts;


void dfs(int v) {
    if (cycles) return;
    if (tin[v] == 2) return;
    tin[v] = 1;
    for (auto u : g1[v]) {
        if (tin[u] == 1) {
            cycles = 1;
            return;
        }
        dfs(u);
    }
    tin[v] = 2;
    ts.push_back(v);
}


void glebkuslin() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i <= n; i++) {
        g[i].clear();
        g1[i].clear();
    }
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        g[v].push_back({u, c});
        g[u].push_back({v, c});
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    for (int v = 0; v < n; v++) {
        for (auto [u, c] : g[v]) {
            if (d[v] != d[u] && d[v] == c) {
                g1[v].push_back(u);
            }
            if (d[v] == d[u] && d[v] != c) {
                cout << "NO";
                return;
            }
        }
    }

    cycles = 0;
    tin.clear();
    tin.resize(n + 1, 0);
    ts.clear();

    for (int i = 0; !cycles && i < n; i++) {
        if (tin[i] == 0) {
            dfs(i);
        }
    }
    if (cycles) {
        cout << "NO";
        return;
    }

    reverse(ts.begin(), ts.end());
    vector<pii> res;
    for (int i = 0; i < n; i++) {
        if (d[i] == 0) {
            res.push_back({i, 1});
        }
    }

    for (auto v : ts) {
        res.push_back({v, d[v]});
    }

    cout << "YES\n";
    cout << res.size() << '\n';
    for (auto [x, y] : res) {
        cout << x + 1 << " " << y << '\n';
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    cin >> T;
    while (T--) {
        glebkuslin();
        cout << '\n';
    }
    return 0;
}
