#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

struct edge
{
	int to, c;
	edge(int to_, int c_) : to(to_), c(c_) {}
	edge() = default;
};

void solve() {
	int n, m;
	cin >> n >> m;

	vector<vector<int>> g(n);
	vector<edge> edges(2 * m);
	for (int i = 0; i < m; ++i) {
		int x, y, c;
		cin >> x >> y >> c; x--, y--;
		edges[2 * i] = edge(x, c);
		edges[2 * i + 1] = edge(y, c);
		g[y].push_back(2 * i);
		g[x].push_back(2 * i + 1);
	}

	vector<int> d(n);
	for (int i = 0; i < n; ++i) cin >> d[i];

	vector<vector<int>> ng(n);
	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) {
			if (d[i] != edges[j].c) ng[i].push_back(edges[j].to);
		}
	}

	queue<int> q;
	vector<int> cnt(n, 0);
	for (int i = 0; i < n; ++i) {
		for (int j : ng[i]) cnt[j]++;
	}
	for (int i = 0; i < n; ++i)
		if (cnt[i] == 0)
			q.push(i);


	vector<pair<int, int>> ans;
	while (!q.empty()) {
		int v = q.front(); q.pop();
		ans.emplace_back(v, 1 - d[v]);
		for (int u : ng[v]) {
			ans.emplace_back(u, 1 - d[v]);
			cnt[u]--;
			if (cnt[u] == 0) q.push(u);
		}
		ans.emplace_back(v, d[v]);
	}

	for (int i = 0; i < n; ++i) {
		if (cnt[i] > 0) {
			cout << "NO\n";
			return;
		}
	}


	cout << "YES\n";
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i].first << ' ' << ans[i].second << '\n';
	}
}

int main()
{
	int tt;
	cin >> tt;

	for (; tt > 0; --tt) solve();
}