#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

struct edge
{
	int to, c;
	edge(int to_, int c_) : to(to_), c(c_) {}
	edge() = default;
};

void solve() {
	int n, m;
	cin >> n >> m;
	
	vector<vector<int>> g(n);
	vector<edge> edges(2 * m);
	for (int i = 0; i < m; ++i) {
		int x, y, c;
		cin >> x >> y >> c; x--, y--;
		edges[2 * i] = edge(x, c);
		edges[2 * i + 1] = edge(y, c);
		g[y].push_back(2 * i);
		g[x].push_back(2 * i + 1);
	}

	vector<int> d(n);
	for (int i = 0; i < n; ++i) cin >> d[i];
	/*
	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) {
			if (d[i] == d[edges[j].to] && d[i] != edges[j].c) {
				cout << "NO\n";
				return;
			}
		}
	}
	*/
	vector<vector<int>> ng(n);
	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) {
			if (d[i] != edges[j].c) ng[i].push_back(edges[j].to);
		}
	}

	queue<int> q;
	vector<int> cnt(n, 0);
	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) cnt[j]++;
	}
	for (int i = 0; i < n; ++i)
		if (cnt[i] == 0)
			q.push(i);


	while (!q.empty()) {
		int v = q.front(); q.pop();
		for (int u : g[v]) {
			cnt[u]--;
			if (cnt[u] == 0) q.push(u);
		}
	}

	for (int i = 0; i < n; ++i) {
		if (cnt[i] > 0) {
			cout << "NO\n";
			return;
		}
	}
	
	
	cout << "YES\n-1\n";
}

int main()
{
	int tt;
	cin >> tt;

	for (; tt > 0; --tt) solve();
}
