#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

const ll inf = 1ll << 60;

const int sz = 1 << 20;
vector<pair<ll, bool>> tree(sz, { 0, false });
vector<ll> add(sz, 0);

pair<ll, bool> merge(pair<ll, bool> a, pair<ll, bool> &b) {
	if (b.second) a.first += b.first;
	a.second = a.second || b.second;
	return a;
}

void push(int v, int ln) {
	if (add[v] == 0) return;

	if (ln > 1) {
		add[v * 2] += add[v];
		add[v * 2 + 1] += add[v];
	}
	tree[v].first += add[v];
	add[v] = 0;
}

pair<ll, bool> sum(int v, int l, int r, int ql, int qr) {
	push(v, r - l);

	if (l >= qr || ql >= r) return { 0, false };
	if (l >= ql && r <= qr) return tree[v];

	int m = (l + r) / 2;
	pair<ll, bool> s1 = sum(v * 2, l, m, ql, qr);
	pair<ll, bool> s2 = sum(v * 2 + 1, m, r, ql, qr);
	return merge(s1, s2);
}

void upd(int v, int l, int r, int ql, int qr, ll x) {
	push(v, r - l);

	if (l >= qr || ql >= r) return;
	if (l >= ql && r <= qr) {
		add[v] += x;
		push(v, r - l);
		return;
	}
	int m = (l + r) / 2;
	upd(v * 2, l, m, ql, qr, x);
	upd(v * 2 + 1, m, r, ql, qr, x);
	tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
}

void upd(int v, int l, int r, int ind) {
	push(v, r - l);

	if (r - l == 1) {
		tree[v].second = true;
		return;
	}

	int m = (l + r) / 2;
	if (ind < m)
		upd(v * 2, l, m, ind);
	else
		upd(v * 2 + 1, m, r, ind);
	tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
}

void solve() {
	int n, m;
	cin >> n >> m;

	ll l = 0;

	vector<ll> t(n), ins(m + 1, 0), ind(m);
	for (int i = 0; i < n; ++i) cin >> t[i];
	for (int i = 0; i < m; ++i) cin >> ins[i + 1];
	for (int i = 0; i < m; ++i) ind[i] = ins[i + 1] - ins[i];
	l = m;

	vector<ll> w = { 1 };
	vector<ll> d = { ind[0] };
	for (int i = 1; i < m; ++i) {
		if (ind[i] <= d.back()) w.back()++;
		else {
			d.push_back(ind[i]);
			w.push_back(1);
		}
	}

	m = w.size();
	if (m == 1) {
		for (int k = 1; k <= n; ++k) {
			cout << k * 1ll * (k - 1) << '\n';
		}
		return;
	}
	else if (m == 2) {
		vector<pair<int, int>> a(2 * n);
		for (int i = 0; i < n; ++i) {
			a[2 * i] = { t[i] * d[0], i };
			a[2 * i + 1] = { t[i] * d[1], i };
		}
		sort(a.begin(), a.end());

		vector<pair<int, int>> poses(n, {-1, -1});
		for (int i = 0; i < 2 * n; ++i) {
			if (poses[a[i].second].first == -1) poses[a[i].second].first = i;
			else poses[a[i].second].second = i;
		}

		for (int k = 0; k < n; ++k) {
			upd(1, 0, 2 * n, poses[k].first);
			upd(1, 0, 2 * n, poses[k].second);
			upd(1, 0, 2 * n, 0, poses[k].second + 1, 1);

			cout << sum(1, 0, 2 * n, 0, 2 * n).first << '\n';
		}
	}
	else {
		exit(-1);
	}
}

int main()
{
	int tt = 1;
	// cin >> tt;

	for (; tt > 0; --tt) solve();
}