#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    int _ = 1;
    // cin >> _;
    while (_--)
        solve(cin, cout);
}


struct st {
    ll x = 0, p = 0, d = 0;

    st() = default;

    st(ll x, ll p, ll d) : x(x), p(p), d(d) {}
};


vector<st> v;
vector<ll> lp, rp;
ll n;

void solve(istream &cin, ostream &cout) {
    cin >> n;
    v.resize(n);
    for (auto &[x, p, d]: v) {
        cin >> x >> p >> d;
    }

    lp.resize(n, INF);
    rp.resize(n, INF);

    for (ll i = 0; i < n; ++i) {
        lp[i] = lp[i - 1];
        if (v[i].d != -1)
            ++lp[i];
        if (i - 1 >= 0 && v[i].x - v[i].p > v[i - 1].x) {
            lp[i] = INF;
            break;
        }
    }
    for (ll i = n - 1; i >= 0; --i) {
        rp[i] = rp[i + 1];
        if (v[i].d != 1)
            ++rp[i];
        if (i + 1 < n && v[i].x + v[i].p < v[i + 1].x) {
            rp[i] = INF;
            break;
        }
    }


    ll res = min(lp.back(), rp[0]);
    for (ll i = 0; i + 1 < n; ++i) {
        res = min(res, rp[i] + lp[i + 1]);
    }

    if (res == INF)
        cout << "-1\n";
    else
        cout << res << '\n';
}