#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    int _ = 1;
    cin >> _;
    while (_--)
        solve(cin, cout);
}


void solve(istream &cin, ostream &cout) {
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> edges(m);
    vector<vector<ll>> g(n);
    vector<bool> tre(m), trv(n), e(m), v(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        tre[i] = c;
        edges[i] = make_pair(min(a, b), max(a, b));
        g[a].push_back(i);
        g[b].push_back(i);
    }
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        trv[i] = x;
    }


    auto cmp_fn = [&](ll i) {
        if (tre[i] && int(trv[edges[i].first]) + int(trv[edges[i].second]) == 1)
            return 1;
        else if (tre[i] && trv[edges[i].first] && trv[edges[i].second])
            return 2;
        return 3;
    };


    vector<pair<ll, ll>> res;
    auto fn = [&](ll i, bool on = true) {
        if (v[i] == on)
            return;
        res.emplace_back(i, on);
        v[i] = on;
        for(auto& j : g[i]) {
            if (v[edges[j].first] == v[edges[j].second])
                e[j] = v[edges[j].first];
        }
    };


    vector<ll> eg(m);
    for (ll i = 0; i < m; ++i)
        eg[i] = i;
    sort(eg.begin(), eg.end(), [&](ll i, ll j) { return cmp_fn(i) < cmp_fn(j); });
    for (auto &i: eg) {
        if (cmp_fn(i) == 1) {
            fn(edges[i].first);
            fn(edges[i].second);
            if (trv[edges[i].first])
                fn(edges[i].second, false);
            else
                fn(edges[i].first, false);
        } else if (cmp_fn(i) == 2) {
            fn(edges[i].first);
            fn(edges[i].second);
        } else {
            break;
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (trv[i])
            fn(i);
    }

    if (trv != v || tre != e) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";
    cout << res.size() << '\n';
    for (auto &[a, b]: res)
        cout << a + 1 << ' ' << b << '\n';
}