#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    int _ = 1;
    cin >> _;
    while (_--)
        solve(cin, cout);
}


vector<vector<ll>> gg;
vector<bool> used;
vector<ll> stk;


void dfs_top(ll v) {
    if (used[v])
        return;
    used[v] = true;
    for (auto &u: gg[v])
        dfs_top(u);
    stk.push_back(v);
}


void solve(istream &cin, ostream &cout) {
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> edges(m);
    vector<vector<ll>> g(n);
    vector<bool> tre(m), trv(n), e(m), v(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        tre[i] = c;
        edges[i] = make_pair(min(a, b), max(a, b));
        g[a].push_back(i);
        g[b].push_back(i);
    }
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        trv[i] = x;
    }


    auto cmp_fn = [&](ll i) {
        if (tre[i] && int(trv[edges[i].first]) + int(trv[edges[i].second]) == 1)
            return 1;
        else if (tre[i] && trv[edges[i].first] && trv[edges[i].second])
            return 2;
        return 3;
    };


    vector<pair<ll, ll>> res;
    auto fn = [&](ll i, bool on = true) {
        if (v[i] == on)
            return;
        res.emplace_back(i, on);
        v[i] = on;
        for (auto &j: g[i]) {
            if (v[edges[j].first] == v[edges[j].second])
                e[j] = v[edges[j].first];
        }
    };


    vector<bool> mark(n);
    for (ll i = 0; i < m; ++i) {
        if (cmp_fn(i) == 1) {
            if (trv[edges[i].first])
                mark[edges[i].first] = true;
            else
                mark[edges[i].second] = true;
        }
    }

    gg.clear();
    used.clear();
    stk.clear();
    gg.resize(m);
    used.resize(m);
    stk.reserve(m);
    for (ll i = 0; i < m; ++i) {
        if (cmp_fn(i) == 1) {
            if (!trv[edges[i].first]) {
                for (auto &j: g[edges[i].first]) {
                    if (j != i && (mark[edges[j].first] || mark[edges[j].second]))
                        gg[i].push_back(j);
                }
            }
        }
    }
    for (ll i = 0; i < m; ++i)
        dfs_top(i);
    reverse(stk.begin(), stk.end());
    for (auto &i: stk) {
        if (cmp_fn(i) == 1) {
            fn(edges[i].first);
            fn(edges[i].second);
            if (!trv[edges[i].first])
                fn(edges[i].first, false);
            else
                fn(edges[i].second, false);
        }
    }
    for (auto &i: stk) {
        if (cmp_fn(i) == 2) {
            fn(edges[i].first);
            fn(edges[i].second);
        }
    }


    for (ll i = 0; i < n; ++i) {
        if (trv[i])
            fn(i);
    }

    if (trv != v || tre != e) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";
    cout << res.size() << '\n';
    for (auto &[a, b]: res)
        cout << a + 1 << ' ' << b << '\n';
}