#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}

struct Segment {
    int a, b, c;
};

bool dfs(int v, const vector<vector<int>>& graph, vector<int>& color, vector<int>& top_sort) {
    for (auto u : graph[v]) {
        if (color[u] == 1) {
            return false;
        } else if (color[u] == 0) {
            color[u] = 1;
            if (!dfs(u, graph, color, top_sort)) {
                return false;
            }
        }
    }
    color[v] = 2;
    top_sort.emplace_back(v);
    return true;
}

void solve() {
    int n, m; cin >> n >> m;
    vector<Segment> seg(m);
    for (int i = 0; i < m; ++i) {
        cin >> seg[i].a >> seg[i].b >> seg[i].c;
        --seg[i].a; --seg[i].b;
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    bool ok = true;
    vector<vector<int>> graph(n);
    for (auto& s : seg) {
        if (d[s.a] == d[s.b]) {
            if (d[s.a] != s.c) {
                ok = false;
                break;
            }
        } else if (s.c == d[s.a]) {
            graph[s.a].emplace_back(s.b);
        } else {
            graph[s.b].emplace_back(s.a);
        }
    }
    if (!ok) {
        cout << "NO\n";
        return;
    }
    vector<int> top_sort;
    vector<int> color(n, 0);
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            color[i] = 1;
            if (!dfs(i, graph, color, top_sort)) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += 1-d[i];
    }
    cout << cnt+n << '\n';
    for (int i = 0; i < n; ++i) {
        if (!d[i]) {
            cout << i+1 << " 1\n";
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << top_sort[i]+1 << ' ' << d[top_sort[i]] << '\n';
    }
}
