#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>
#include <queue>

using namespace std;

struct Segment {
    int l, r;
};

bool cmp(const Segment& a, const Segment& b) {
    return a.l < b.l;
}

int64_t get(const vector<int>& R) {
    int64_t ans = 0;
    vector<int64_t> sum(R.size(), 0);
    for (int i = R.size()-1; i>=0; --i) {
        if (R[i] >= R.size()) continue;
        sum[i] = sum[R[i]]+(R.size()-R[i]);
        ans += sum[i];
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, x; cin >> n >> x;
    vector<int> a(n);
    vector<Segment> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s[i].l = max(i-a[i], 0);
        s[i].r = min(i+a[i], n-1);
    }
    sort(s.begin(), s.end(), cmp);
    vector<int> R(n, 1);
    for (int i = 0, j = 0; i < n; ++i) {
        if (i > 0) R[i] = R[i-1];
        while (j<s.size() && s[j].l <= i) {
            R[i] = max(R[i], s[j].r+1);
            ++j;
        }
    }
    if (n > 5000 && x != 0) {
        int l = 0, r = 2*x;
        for (int j = l; j < r; ++j) {
            if (r+1 > R[j]) R[j] = r+1;
        }
        cout << get(R) << '\n';
        return 0;
    }
    int64_t ans = get(R);
    for (int i = 0; i < n; ++i) {
        int l = max(i-x, 0), r = min(i+x, n-1);
        if (r <= min(i+a[i], n-1)) continue;
        vector<int> Rc = R;
        for (int j = l; j < r; ++j) {
            if (r+1 > Rc[j]) Rc[j] = r+1;
        }
        ans = min(ans, get(Rc));
    }
    cout << ans << '\n';

    return 0;
}