#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct fenwick
{
	long long n;
	vector<long long> t;

	fenwick(long long in)
	{
		n = in;
		t.resize(n + 1);
	}

	void upd(long long k, long long x)
	{
		k++;
		for (; k <= n; k += k & -k)
		{
			t[k] += x;
		}
	}

	long long get(long long k)
	{
		k++;
		long long res = 0;
		for (; k > 0; k -= k & -k)
		{
			res += t[k];
		}
		return res;
	}
};

void solve()
{
	long long n, m;
	vector<long long> t;
	cin >> n >> m;
	t.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	m++;
	vector<long long> s(m);
	s[0] = 0;
	for (long long i = 1; i < m; i++)
	{
		cin >> s[i];
	}

	vector<long long> pos(n, 0);
	long long alive = n;
	set<pair<long long, long long>> st;
	for (long long i = 0; i < n; i++)
	{
		st.insert({ s[1] * t[i], i });
	}
	vector<long long> ord;
	while (alive)
	{
		auto [dist, idx] = *st.begin();
		ord.push_back(idx);
		st.erase(st.begin());

		pos[idx]++;
		if (pos[idx] != m - 1)
		{
			st.insert({ (s[pos[idx] + 1] - s[pos[idx]]) * t[idx], idx });
		}
		else
		{
			alive--;
		}
	}

	vector<vector<long long>> add(n);
	for (long long i = 0; i < n; i++)
	{
		add[i].reserve(m);
	}
	for (long long i = 0; i < ord.size(); i++)
	{
		add[ord[i]].push_back(i);
	}

	long long ans = 0;
	fenwick allev(ord.size()), endev(ord.size());
	for (long long k = 0; k < n; k++)
	{
		ans += allev.get(add[k].back());

		for (long long j = 0; j < add[k].size(); j++)
		{
			ans += k - endev.get(add[k][j]);
			allev.upd(add[k][j], 1);
		}
		endev.upd(add[k].back(), 1);

		cout << ans << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
