#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));
//mt19937_64 rnd(0);

const int INF = 1e18, MOD = 1e9 + 7;

long long calc(vector<int>& a, vector<int>& cov)
{
	int n = a.size();
	vector<long long> dp(n + 1);
	for (int i = n - 2; i > -1; i--)
	{
		int to = min(cov[i] + a[cov[i]], n - 1);
		dp[i] = dp[to + 1] + (n - to - 1);
	}
	long long res = 0;
	for (auto& i : dp)
	{
		res += i;
	}
	return res;
}

void solve()
{
	int n, x;
	vector<int> v;
	cin >> n >> x;
	v.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	vector<int> ord(n);
	iota(ord.begin(), ord.end(), 0);
	sort(ord.begin(), ord.end(),
		[&](int f, int s)
		{
			return f + v[f] > s + v[s];
		}
	);

	vector<vector<pair<int, int>>> ev(n + 1);
	for (int j = 0; j < n; j++)
	{
		int l = max(0, ord[j] - v[ord[j]]), r = min(n - 1, ord[j] + v[ord[j]]);
		ev[l].push_back({ j + 1, ord[j] });
		ev[r + 1].push_back({ -j - 1, ord[j] });
	}
	vector<int> cov(n, -1);
	set<pair<int, int>> st;
	for (int j = 0; j < n; j++)
	{
		for (auto& [pr, idx] : ev[j])
		{
			if (pr > 0)
			{
				st.insert({ pr, idx });
			}
			else
			{
				st.erase({ -pr, idx });
			}
		}

		cov[j] = st.begin()->second;
	}

	cout << calc(v, cov) << "\n";
}

long long solve1(int n, int x, vector<int> v)
{
	long long ans = INF;
	for (int i = 0; i < n; i++)
	{
		vector<int> a = v;
		a[i] = max(a[i], x);

		vector<int> ord(n);
		iota(ord.begin(), ord.end(), 0);
		sort(ord.begin(), ord.end(),
			[&](int f, int s)
			{
				return f + a[f] > s + a[s];
			}
		);

		vector<int> cov(n, -1);
		for (auto& j : ord)
		{
			int l = max(0, j - a[j]), r = min(n - 1, j + a[j]);
			for (int k = l; k <= r; k++)
			{
				if (cov[k] == -1)
				{
					cov[k] = j;
				}
			}
		}

		ans = min(ans, calc(a, cov));
	}
	return ans;
}

long long solve2(int n, int x, vector<int> v)
{
	long long ans = INF;
	for (int i = 0; i < n; i++)
	{
		vector<int> a = v;
		a[i] = max(a[i], x);

		vector<int> ord(n);
		iota(ord.begin(), ord.end(), 0);
		sort(ord.begin(), ord.end(),
			[&](int f, int s)
			{
				return f + a[f] > s + a[s];
			}
		);

		vector<int> cov(n, -1);
		for (auto& j : ord)
		{
			int l = max(0, j - a[j]), r = min(n - 1, j + a[j]);
			for (int k = l; k <= r; k++)
			{
				if (cov[k] == -1)
				{
					cov[k] = j;
				}
			}
		}

		long long cur = 0;
		for (int l = 0; l < n; l++)
		{
			int idx = cov[l];
			long long cnt = 0;
			for (int r = l + 1; r < n; r++)
			{
				if (abs(idx - r) > a[idx])
				{
					cnt++;
					idx = cov[r];
				}
				cur += cnt;
			}
		}
		ans = min(ans, cur);
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	/*
	while (true)
	{
		int n = rnd() % 10 + 1, x = rnd() % 3 + 1;
		vector<int> v(n);
		for (int i = 0; i < n; i++)
		{
			v[i] = rnd() % 3 + 1;
		}

		if (solve1(n, x, v) != solve2(n, x, v))
		{
			cout << "POSDVNOSNDPV\n";
			cout << solve1(n, x, v) << "\n";
			cout << solve2(n, x, v) << "\n";
			return 0;
		}
		cout << "OK\n";
	}
	*/

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
