#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));
//mt19937_64 rnd(0);

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,ssse3,sse3,abm,mmx,popcnt")

const long long INF = 1e18, MOD = 1e9 + 7;

long long calc(vector<long long>& a, vector<long long>& cov)
{
	long long n = a.size();
	vector<long long> dp(n + 1);
	for (long long i = n - 2; i > -1; i--)
	{
		long long to = min(cov[i] + a[cov[i]], n - 1);
		dp[i] = dp[to + 1] + (n - to - 1);
	}
	long long res = 0;
	for (auto& i : dp)
	{
		res += i;
	}
	return res;
}

int n, x;
int v[5005], a[5005], cov[5005];

long long calc2()
{
	vector<long long> dp(n + 1);
	for (long long i = n - 2; i > -1; i--)
	{
		long long to = min(cov[i] + a[cov[i]], n - 1);
		dp[i] = dp[to + 1] + (n - to - 1);
	}
	long long res = 0;
	for (auto& i : dp)
	{
		res += i;
	}
	return res;
}

void solve()
{
	cin >> n >> x;
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
		a[i] = v[i];
	}

	long long ans = INF;
	for (long long i = 0; i < n; i++)
	{
		if (v[i] >= x && ans != INF)
		{
			continue;
		}	

		a[i] = max(v[i], x);

		vector<int> ord(n);
		iota(ord.begin(), ord.end(), 0);
		sort(ord.begin(), ord.end(),
			[&](long long f, long long s)
			{
				return f + a[f] > s + a[s];
			}
		);

		vector<vector<pair<int, int>>> ev(n + 1);
		for (long long j = 0; j < n; j++)
		{
			long long l = max(0, ord[j] - a[ord[j]]), r = min(n - 1, ord[j] + a[ord[j]]);
			ev[l].push_back({ j + 1, ord[j] });
			ev[r + 1].push_back({ -j - 1, ord[j] });
		}
		set<pair<int, int>> st;
		for (long long j = 0; j < n; j++)
		{
			for (auto& [pr, idx] : ev[j])
			{
				if (pr > 0)
				{
					st.insert({ pr, idx });
				}
				else
				{
					st.erase({ -pr, idx });
				}
			}

			cov[j] = st.begin()->second;
		}

		ans = min(ans, calc2());
		a[i] = v[i];
	}
	cout << ans << "\n";
}

long long solve1(long long n, long long x, vector<long long> v)
{
	long long ans = INF;
	for (long long i = 0; i < n; i++)
	{
		vector<long long> a = v;
		a[i] = max(a[i], x);

		vector<long long> ord(n);
		iota(ord.begin(), ord.end(), 0);
		sort(ord.begin(), ord.end(),
			[&](long long f, long long s)
			{
				return f + a[f] > s + a[s];
			}
		);

		vector<long long> cov(n, -1);
		for (auto& j : ord)
		{
			long long l = max(0ll, j - a[j]), r = min(n - 1, j + a[j]);
			for (long long k = l; k <= r; k++)
			{
				if (cov[k] == -1)
				{
					cov[k] = j;
				}
			}
		}

		ans = min(ans, calc(a, cov));
	}
	return ans;
}

long long solve2(long long n, long long x, vector<long long> v)
{
	long long ans = INF;
	for (long long i = 0; i < n; i++)
	{
		vector<long long> a = v;
		a[i] = max(a[i], x);

		vector<long long> ord(n);
		iota(ord.begin(), ord.end(), 0);
		sort(ord.begin(), ord.end(),
			[&](long long f, long long s)
			{
				return f + a[f] > s + a[s];
			}
		);

		vector<long long> cov(n, -1);
		for (auto& j : ord)
		{
			long long l = max(0ll, j - a[j]), r = min(n - 1, j + a[j]);
			for (long long k = l; k <= r; k++)
			{
				if (cov[k] == -1)
				{
					cov[k] = j;
				}
			}
		}

		long long cur = 0;
		for (long long l = 0; l < n; l++)
		{
			long long idx = cov[l];
			long long cnt = 0;
			for (long long r = l + 1; r < n; r++)
			{
				if (abs(idx - r) > a[idx])
				{
					cnt++;
					idx = cov[r];
				}
				cur += cnt;
			}
		}
		ans = min(ans, cur);
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	/*
	while (true)
	{
		long long n = rnd() % 10 + 1, x = rnd() % 3 + 1;
		vector<long long> v(n);
		for (long long i = 0; i < n; i++)
		{
			v[i] = rnd() % 3 + 1;
		}

		if (solve1(n, x, v) != solve2(n, x, v))
		{
			cout << "POSDVNOSNDPV\n";
			cout << solve1(n, x, v) << "\n";
			cout << solve2(n, x, v) << "\n";
			return 0;
		}
		cout << "OK\n";
	}
	*/

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
