#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long calc(vector<long long>& a, vector<long long>& cov)
{
	long long n = a.size();
	vector<long long> dp(n);
	for (long long i = n - 2; i > -1; i--)
	{
		long long to = min(cov[i] + a[cov[i]], n - 1);
		if (i != to)
		{
			dp[i] = dp[i + 1];
			continue;
		}

		dp[i] = dp[i + 1] + n - i - 1;
	}
	long long res = 0;
	for (auto& i : dp)
	{
		res += i;
	}
	return res;
}

void solve()
{
	long long n, x;
	vector<long long> v;
	cin >> n >> x;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	long long ans = INF;
	for (long long i = 0; i < n; i++)
	{
		vector<long long> a = v;
		a[i] = max(a[i], x);

		vector<long long> ord(n);
		iota(ord.begin(), ord.end(), 0);
		sort(ord.begin(), ord.end(),
			[&](long long f, long long s)
			{
				return f + a[f] > s + a[s];
			}
		);

		vector<long long> cov(n, -1);
		for (auto& j : ord)
		{
			long long l = max(0ll, j - a[j]), r = min(n - 1, j + a[j]);
			for (long long k = l; k <= r; k++)
			{
				if (cov[k] == -1)
				{
					cov[k] = j;
				}
			}
		}

		ans = min(ans, calc(a, cov));
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
