#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> edg(m);
    for (auto &ed : edg) {
        int u, v, c;
        cin >> u >> v >> c;
        ed = {u - 1, v - 1, c};
    }
    vector<int> d(n);
    for (int &col : d) {
        cin >> col;
    }
    vector<vector<pair<int, int>>> gr(n);
    for (auto [u, v, c] : edg) {
        if (d[u] == d[v] && c != d[u]) {
            cout << "NO\n";
            return;
        } else if (d[u] != d[v]) {
            gr[u].emplace_back(v, c);
            gr[v].emplace_back(u, c);
        }
    }
    vector<bool> used(n);
    vector<int> dist(n, 1000000000);
    vector<bool> hvEdge1(n), hvEdge0(n);
    stringstream order;
    int order_sz = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }
        vector<vector<int>> ds; // in i element vertexes with distance = i.
        deque<int> que;
        que.push_back(i);
        ds.emplace_back();
        ds[0].push_back(i);
        dist[i] = 0;
        while (!que.empty()) {
            // if u, v connected => abs(dist[u]-dist[v])==1
            // because d[u] != d[v] (line 23)
            int u = que.front();
            que.pop_front();
            used[u] = true;
            for (auto [v, col] : gr[u]) {
                if (dist[v] == 1000000000) {
                    que.push_back(v);
                    dist[v] = dist[u] + 1;
                    if (ds.size() <= dist[v]) {
                        ds.emplace_back();
                    }
                }
                if (dist[v] == dist[u] - 1) {
                    continue;
                }
                ds.back().push_back(v);
                hvEdge1[v] = hvEdge1[v] || col;
                hvEdge0[v] = hvEdge0[v] || (1 - col);
            }
        }
        reverse(ds.begin(), ds.end());
        for (int i = 0; i < -1 + (int) ds.size(); ++i) {
            for (int u : ds[i + (1 - d[ds[i][0]])]) {
                if (hvEdge1[u]) {
                    order_sz++;
                    order << u + 1 << " " << 1 << "\n";
                }
            }
            for (int u : ds[i + 1 + (i - d[ds[i][0]])]) {
                order_sz++;
                order << u + 1 << " " << 1 << "\n";
                order_sz++;
                order << u + 1 << " " << 0 << "\n";
            }
            if (d[ds[i][0]] == 0) {
                for (int u : ds[i]) {
                    if (hvEdge1[u]) {
                        order_sz++;
                        order << u + 1 << " " << 1 << "\n";
                    }
                }
                for (int u : ds[i]) {
                    if (hvEdge1[u]) {
                        order_sz++;
                        order << u + 1 << " " << 0 << "\n";
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (hvEdge1[i] && hvEdge0[i]) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (d[i] == 1 && !hvEdge1[i]) {
            order_sz++;
            order << i + 1 << " " << 1 << "\n";
        }
    }
    cout << "YES\n" << order_sz << "\n" << order.str();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for (int tc = 0; tc < t; ++tc) {
        solve();
    }
}