#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5;
vector<int> g[maxn];
char vis[maxn];
vector<int> top;

bool dfs(int v) {
    vis[v] = 1;
    bool cycle = false;
    for (const int& u : g[v]) {
        if (vis[u] == 0) {
            if (dfs(u)) {
                cycle = true;
            }
        } else if (vis[u] == 1) {
            cycle = true;
        }
    }
    top.emplace_back(v);
    vis[v] = 2;
    return cycle;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> from(m), to(m), c(m);
    for (int i = 0; i < m; ++i) {
        cin >> from[i] >> to[i] >> c[i];
        --from[i], --to[i];
    }
    vector<int> d(n);
    vector<bool> need(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        vis[i] = false;
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        if (d[from[i]] == d[to[i]] && d[from[i]] != c[i]) {
            cout << "NO\n";
            return;
        }
        if (c[i] == 1) {
            if (d[from[i]] == 0) {
                need[from[i]] = true;
            }
            if (d[to[i]] == 0) {
                need[to[i]] = true;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (d[from[i]] != d[to[i]]) {
            if (c[i] == 1) {
                int v, u;
                if (d[from[i]] == 1) {
                    v = from[i], u = to[i];
                } else {
                    v = to[i], u = from[i];
                }
                g[v].emplace_back(u);
            } else {
                int v, u;
                if (d[from[i]] == 1) {
                    v = to[i], u = from[i];
                } else {
                    v = from[i], u = to[i];
                }
                g[v].emplace_back(u);
            }
        }
    }
    top.clear();
    for (int v = 0; v < n; ++v) {
        if (vis[v] == 0 && (need[v] || d[v] == 1)) {
            if (dfs(v)) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int v = 0; v < n; ++v) {
        if (need[v]) {
            // to the very beginning
            top.emplace_back(v);
        }
    }
    reverse(top.begin(), top.end());
    cout << "YES\n";
    cout << (int)top.size() << '\n';
    for (const int& v : top) {
        cout << v + 1 << ' ';
        cout << (need[v] || d[v] == 1) << '\n';
        if (need[v]) {
            need[v] = false;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "---------\n";
        cout << "---------\n";
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif

    return 0;
}