#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e7;
int fenEvs[maxn], fenFin[maxn], N;

void addEvs(int i) {
    while (i <= N) {
        ++fenEvs[i];
        i += (i & -i);
    }
}

void addFin(int i) {
    while (i <= N) {
        ++fenFin[i];
        i += (i & -i);
    }
}

int getPrefEvs(int r) {
    int res = 0;
    while (r > 0) {
        res += fenEvs[r];
        r -= (r & -r);
    }
    return res;
}

int getPrefFin(int r) {
    int res = 0;
    while (r > 0) {
        res += fenFin[r];
        r -= (r & -r);
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<int> s(m + 1);
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
    }
    vector<int> start(n);
    priority_queue<pair<long long, int>, vector<pair<long long, int>>, greater<pair<long long, int>>> q;
    for (int i = 0; i < n; ++i) {
        q.emplace((s[1] - s[0]) * 1ll * t[i], i);
    }
    vector<vector<int>> posOf(n, vector<int>(m));
    N = 0;
    while (!q.empty()) {
        int i = q.top().second;
        q.pop();
        posOf[i][start[i]] = N++;
        ++start[i];
        if (start[i] != m) {
            q.emplace((s[start[i] + 1] - s[start[i]]) * 1ll * t[i], i);
        }
    }
    long long sub = 0;
    for (int k = 0; k < n; ++k) {
        sub += k * 1ll * m - getPrefEvs(posOf[k][m - 1]);
        for (int j = 0; j < m; ++j) {
            sub += getPrefFin(posOf[k][j]);
            addEvs(posOf[k][j] + 1);
        }
        addFin(posOf[k][m - 1] + 1);
        cout << k * 1ll * (k + 1) * 1ll * m - sub << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "---------\n";
        cout << "---------\n";
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif

    return 0;
}