#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e6 + 1;
vector<int> g[maxn];
int sz[maxn], h[maxn], anc[maxn], tin[maxn], tout[maxn], euler[maxn], tt;

void dfs(int v) {
    tin[v] = tt;
    euler[tt] = tin[v];
    ++tt;
    sz[v] = 1;
    for (const int& u : g[v]) {
        h[u] = h[v] + 1;
        anc[u] = anc[v] + v;
        dfs(u);
        sz[v] += sz[u];
    }
    tout[v] = tt;
}

bool isAncestor(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

struct Query {
    int l, r, newH;
    long long newAnc, init;
    Query() {}
    Query(int _l, int _r, int _newH,  long long _newAnc, long long _init) {
        l = _l, r = _r, newH = _newH, newAnc = _newAnc;
        init = _init;
    }
    ~Query() {}
};
/*
int fen[maxn], N;

void add(int i) {
    while (i <= N) {
        ++fen[i];
        i += (i & -i);
    }
}

int getPref(int r) {
    int res = 0;
    while (r > 0) {
        res += fen[r];
        r -= (r & -r);
    }
    return res;
}

int getSum(int l, int r) {
    return getPref(r) - getPref(l - 1);
}*/

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> nxt(n + 1);
    nxt[n] = -1;
    auto calc = [&]() -> void {
        // [i - a[i], i + a[i]]
        multiset<int> rights;
        vector<int> byRight(n);
        vector<vector<int>> byLeft(n);
        for (int i = 0; i < n; ++i) {
            int l = max(0, i - a[i]), r = min(n - 1, i + a[i]);
            ++byRight[r];
            byLeft[l].emplace_back(r);
        }
        for (int i = n - 1; i >= 0; --i) {
            while (byRight[i] > 0) {
                rights.emplace(i);
                --byRight[i];
            }
            assert(!rights.empty());
            nxt[i] = *rights.rbegin() + 1;
            while (!byLeft[i].empty()) {
                rights.extract(byLeft[i].back());
                byLeft[i].pop_back();
            }
        }
    };
    calc();
    for (int i = 0; i < n; ++i) {
        g[nxt[i]].emplace_back(i);
    }
    h[n] = 0, anc[n] = 0, tt = 0;
    dfs(n);
    vector<long long> prefancsz(n + 1), prefhsz(n + 1);
    long long start = 0;
    for (int i = 0; i < n; ++i) {
        start += n * 1ll * h[i] - anc[i];
        prefancsz[i + 1] = prefancsz[i] + anc[i] * 1ll * sz[i];
        prefhsz[i + 1] = prefhsz[i] + h[i] * 1ll * sz[i];
    }
    long long ans = start;
    vector<Query> queries;
    for (int j = 0; j < n; ++j) {
        if (x > a[j]) {
            int l = max(0, j - x), r = min(n - 1, j + x);
            int firstStop = lower_bound(nxt.begin(), nxt.end(), r + 1) - nxt.begin();
            if (firstStop <= l) {
                continue;
            }
            long long res = start;
            int newH = h[r + 1] + 1;
            long long newAnc = anc[r + 1] + (r + 1);
            int limr = min(firstStop - 1, r);
            queries.emplace_back(l, limr, newH, newAnc, prefancsz[limr + 1] - prefancsz[l] - (prefhsz[limr + 1] - prefhsz[l]) * n);
        }
    }
    for (int i = 1; i < (int)queries.size(); ++i) {
        assert(queries[i - 1].r <= queries[i].r);
    }
    int l = 0, r = -1;
    long long sumSz = 0;
    for (const Query& q : queries) {
        for (int v = l; v < q.l; ++v) {
            for (int u = v; u != -1; u = nxt[u]) {
                ++sz[u];
                if (u >= l && u <= r) {
                    ++sumSz;
                }
            }
        }
        while (l < q.l) {
            sumSz -= sz[l];
            ++l;
        }
        while (r < q.r) {
            ++r;
            sumSz += sz[r];
        }
        long long cur = start + q.init;
        long long curSz = sumSz + q.r - q.l + 1;
        cur -= curSz * q.newAnc;
        cur += curSz * n * q.newH;
        ans = min(ans, cur);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "---------\n";
        cout << "---------\n";
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif

    return 0;
}