#include <iostream>
#include <vector>
#include <algorithm>

struct Actor {
	int64_t x;
	int64_t p;
	int64_t d;
};

std::vector<Actor> actors;

void input_actors() {
	int64_t n;
	std::cin >> n;

	actors.resize(n);
	for (auto& [x, p, d] : actors) {
		std::cin >> x >> p >> d;
	}
}

int64_t add_d_cost(int64_t cost, int64_t i, int64_t d) {
	if (cost == -1) {
		return -1;
	}

	return cost + (actors[i].d == d ? 0 : 1);
}

int64_t opt_min(int64_t a, int64_t b) {
	if (a == -1) {
		return b;
	} else if (b == -1) {
		return a;
	} else {
		return std::min(a, b);
	}
}

std::vector<int64_t> lcost;
std::vector<int64_t> rcost;

int64_t compute_n_changes() {
	lcost.resize(actors.size());
	rcost.resize(actors.size());

	lcost[0] = add_d_cost(0, 0, -1);
	rcost[0] = add_d_cost(0, 0,  1);

	for (int64_t i = 0; i + 1 < actors.size(); ++i) {
		int64_t dx = actors[i + 1].x - actors[i].x;
		if (dx > actors[i + 1].p + actors[i].p) {
			lcost[i + 1] = rcost[i + 1] = -1;
		} else if (dx <= actors[i + 1].p && dx <= actors[i].p) {
			rcost[i + 1] = add_d_cost(rcost[i], i + 1, 1);
			lcost[i + 1] = add_d_cost(opt_min(lcost[i], rcost[i]), i + 1, -1);
		} else if (dx <= actors[i + 1].p) {
			rcost[i + 1] = -1;
			lcost[i + 1] = add_d_cost(opt_min(lcost[i], rcost[i]), i + 1, -1);
		} else if (dx <= actors[i].p) {
			rcost[i + 1] = add_d_cost(rcost[i], i + 1, 1);
			lcost[i + 1] = add_d_cost(rcost[i], i + 1, -1);
		} else {
			rcost[i + 1] = -1;
			lcost[i + 1] = add_d_cost(rcost[i], i + 1, -1);
		}
	}

	return opt_min(lcost.back(), rcost.back());
}

int main() {
	input_actors();
	std::cout << compute_n_changes();
}
