#include <iostream>
#include <vector>
#include <limits>

std::vector<int64_t> delays;
std::vector<int64_t> checkpoints;

void input_data() {
	int64_t n, m;
	std::cin >> n >> m;

	delays.resize(n);
	for (int64_t& delay : delays) {
		std::cin >> delay;
	}

	checkpoints.resize(m);
	for (int64_t& checkpoint : checkpoints) {
		std::cin >> checkpoint;
	}
	checkpoints.insert(checkpoints.begin(), 0);
}

std::vector<int64_t> saved;

int64_t time_to_next(int64_t i) {
	if (saved[i] == checkpoints.size() - 1) {
		return std::numeric_limits<int64_t>::max();
	}

	return (checkpoints[saved[i] + 1] - checkpoints[saved[i]]) * delays[i];
}

int64_t simulate(int64_t k) {
	int64_t n_tp = 0;
	int64_t n_finished = 0;
	saved.assign(k, 0);

	while (n_finished != k) {
		int64_t first = 0;
		for (int64_t i = 1; i < k; ++i) {
			if (time_to_next(i) < time_to_next(first)) {
				first = i;
			}
		}

		n_tp += k - n_finished - 1;

		++saved[first];
		if (saved[first] == checkpoints.size() - 1) {
			++n_finished;
		}
	}

	return n_tp;
}

int main() {
	input_data();
	for (int64_t k = 1; k <= delays.size(); ++k) {
		std::cout << simulate(k) << '\n';
	}
}
