#include <iostream>
#include <vector>
#include <algorithm>

using std::swap;

int64_t x;

std::vector<int64_t> a;

void input_data() {
	int64_t n;
	std::cin >> n >> x;

	a.resize(n);
	for (int64_t& v : a) {
		std::cin >> v;
	}
}

int64_t compute_cost(int64_t i) {
	if (i != -1) {
		swap(a[i], x);
	}

	int64_t total_cost = 0;
	for (int64_t s = 0; s < a.size(); ++s) {
		for (int64_t t = s + 1; t < a.size(); ++t) {
			int64_t source = -1;
			--total_cost;
			for (int64_t j = s; j <= t; ++j) {
				if (source == -1 || j - source > a[source]) {
					++total_cost;
					source = -1;
					for (int64_t k = 0; k < a.size(); ++k) {
						if (std::abs(j - k) <= a[k]) {
							if (source == -1 || a[k] >= a[source]) {
								source = k;
							}
						}
					}
				}
			}
		}
	}

	if (i != -1) {
		swap(a[i], x);
	}
	return total_cost;
}

int64_t brute_force() {
	int64_t min_cost = compute_cost(-1);
	for (int64_t i = 0; i < a.size(); ++i) {
		min_cost = std::min(compute_cost(i), min_cost);
	}
	return min_cost;
}

int main() {
	input_data();
	std::cout << brute_force();
}
