#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> G(n);

    vector<tuple<int, int, int>> edges(m);
    for (auto &[u, v, c] : edges) {
        cin >> u >> v >> c;
        u--, v--;
    }

    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    for (const auto &[u, v, c] : edges) {
        if ((d[u] && d[v] && !c) || (!d[u] && !d[v] && c)) {
            cout << "NO\n";
            return;
        }
    }

    vector<int> ans;

    vector<bool> sv(n);
    vector<bool> se(m);

    for (const auto &[u, v, c] : edges) {
        if (c == 1) {
            if (!sv[u]) {
                sv[u] = true;
                ans.push_back(u);
            }

            if (!sv[v]) {
                sv[v] = true;
                ans.push_back(v);
            }
        }
    }

    for (int i = 0; i < m; i++) {
        const auto &[u, v, c] = edges[i];
        if (sv[u] && sv[v]) {
            se[i] = true;
        }

        G[u].emplace_back(v, i);
        G[v].emplace_back(u, i);
    }

    vector<vector<int>> g(m);

    for (int i = 0; i < m; i++) {
        auto [u, v, c] = edges[i];
        if (d[u] == 1) {
            swap(u, v);
        }

        if (d[u] == 0 && d[v] == 1 && c == 1) {
            for (auto [v1, i1] : G[u]) {
                if (d[v1] && get<2>(edges[i1]) == 0 && se[i1]) {
                    for (auto [v2, i2]: G[v]) {
                        if (d[v2] == 0 && get<2>(edges[i2]) == 0 && se[i2]) {
                            g[i1].push_back(i2);
                        }
                    }
                }
            }
        }
    }

    vector<int> used(m);
    bool ok = true;

    auto dfs = [&](auto &&dfs, int u) -> void {
        used[u] = 1;
        for (int v : g[u]) {
            if (used[v] == 1) {
                ok = false;
            } else if (used[v] == 0) {
                dfs(dfs, v);
            }
        }
        used[u] = 2;
    };

    for (int u = 0; u < m; u++) {
        if (!used[u]) {
            dfs(dfs, u);
        }
    }

    if (!ok) {
        cout << "NO\n";
        return;
    }

    used.assign(m, 0);
    vector<int> ts;

    auto dfs2 = [&](auto &&dfs, int u) -> void {
        used[u] = 1;

        for (int v : g[u]) {
            if (!used[v]) {
                dfs(dfs, v);
            }
        }

        ts.push_back(u);
    };

    for (int u = 0; u < m; u++) {
        if (!used[u]) {
            dfs2(dfs2, u);
        }
    }

    for (int i : ts) {
        const auto &[u, v, c] = edges[i];

        if (se[i] != c && (d[u] || d[v])) {
            if (sv[u]) {
                ans.push_back(u);
                sv[u] = !sv[u];
            }
            if (sv[v]) {
                ans.push_back(v);
                sv[v] = !sv[v];
            }

            if (d[u] != sv[u]) {
                ans.push_back(u);
                sv[u] = !sv[u];
            }

            if (d[v] != sv[v]) {
                ans.push_back(v);
                sv[v] = !sv[v];
            }
        }
    }

    for (int u = 0; u < n; u++) {
        if (d[u] != sv[u]) {
            ans.push_back(u);
        }
    }

    cout << "YES\n";

    {
        cout << ans.size() << '\n';
        vector<bool> state(n);
        for (int u : ans) {
            if (state[u]) {
                cout << u + 1 << ' ' << 0 << '\n';
            } else {
                cout << u + 1 << ' ' << 1 << '\n';
            }
            state[u] = !state[u];
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
