#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
typedef long double ld;
mt19937 rnd(228337);

#define all(a) a.begin(), a.end()
#define int long long

int INF = 1e9 + 3;

struct segtree {
    vector<int> t;
    vector<int> a;

    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);

        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    segtree(vector<int> &_a) {
        a = _a;
        int n = a.size();
        t.resize(4 * n);
        build(0, 0, n);
    }

    void update(int v, int l, int r, int pos) {
        if (r - l == 1) {
            t[v]++;
            return;
        }
        int m = (r + l) / 2;
        if (m > pos) {
            update(2 * v + 1, l, m, pos);
        } else {
            update(2 * v + 2, m, r, pos);
        }
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    void update2(int v, int l, int r, int pos) {
        if (r - l == 1) {
            t[v] = 1;
            return;
        }
        int m = (r + l) / 2;
        if (m > pos) {
            update2(2 * v + 1, l, m, pos);
        } else {
            update2(2 * v + 2, m, r, pos);
        }
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int gets(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) {
            return t[v];
        }
        if(l >= qr || r <= ql) {
            return 0;
        }
        int m = (r + l) / 2;
        return gets(2 * v + 1, l, m, ql, qr) + gets(2 * v + 2, m, r, ql, qr);
    }
};


signed main() {
#ifdef Local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<int> t(n);
    vector<int> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    int indmax = 0;
    int maxs = s[0];
    for(int i = 1; i < m; i++) {
        int s1 = s[i] - s[i - 1];
        if(s1 > maxs) {
            maxs = s1;
            indmax = i;
        }
    }

    for(int i = 1; i <= n; i++) {
        ll ans = 0;
        ans = i * (i - 1) * indmax + (m - indmax) * (i * (i - 1)) / 2;
        cout << ans << '\n';
    }
}