#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
using namespace std;
const int INF = 1e9 + 7;
vector<vector<int>> g;
vector<int> top;
vector<int> used;
bool cycle = false;

void dfs(int v)
{
	used[v] = 1;
	for (int u : g[v])
	{
		if (used[u] == 0)
		{
			dfs(u);
		}
		else if (used[u] == 1)
		{
			cycle = true;
		}
	}
	used[v] = 2;
}

void dfs2(int v)
{
	used[v] = true;
	for (int u : g[v])
	{
		if (!used[u])
		{
			dfs(u);
		}
	}
	top.push_back(v);
}

void solve()
{
	int n, m;
	cin >> n >> m;
	g.clear();
	g.resize(2 * n);
	vector<tuple<int, int, int>> r(m);
	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		r[i] = { a,b,c };
	}
	vector<int> col(n);
	for (int i = 0; i < n; i++)
	{
		cin >> col[i];
		if (col[i] == 0)
		{
			g[2 * i + 1].push_back(2 * i);
		}
		else
		{
			g[2 * i].push_back(2 * i+1);
		}
	}
	for (auto [a, b, c] : r)
	{
		if (col[a] == col[b])
		{
			if (col[a] != c)
			{
				cout << "NO\n";
				return;
			}
			continue;
		}
		if (col[a] == 1) swap(a, b);
		if (c == 0)
		{
			g[2 * a].push_back(2 * b + 1);
		}
		else
		{
			g[2 * b + 1].push_back(2 * a);
		}
	}
	top.clear();
	used.assign(2 * n, 0);
	cycle = false;
	for (int i = 0; i < n; i++)
	{
		if (used[i] == 0) dfs(i);
	}
	if (cycle)
	{
		cout << "NO\n";
		return;
	}
	used.assign(2 * n, 0);
	for (int i = 0; i < n; i++)
	{
		if (used[i] == 0) dfs2(i);
	}
	cout << "YES\n";
	cout << -1;
	/*cout << top.size() << '\n';
	reverse(top.begin(), top.end());
	for (int v : top)
	{
		cout << v / 2+1 << ' ' << v % 2 << '\n';
	}*/
}
int main()
{
	int t;
	cin >> t;
	while (t--) solve();
}