#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(ll& a, ll b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(ll& a, ll b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

bool dfs(ll v, vector<ll>& used, vector<vector<ll>>& arr) {
	used[v] = 2;
	for (auto i : arr[v]) {
		if (used[i] == 0) {
			if (!dfs(i, used, arr)) {
				return false;
			}
		} else {
			if (used[i] == 2) {
				return false;
			}
		}
	}
	used[v] = 1;
	return true;
}

void dfs(ll v, vector<bool>& used, vector<vector<ll>>& arr, vector<ll>& ts) {
	used[v] = true;
	for (auto i : arr[v]) {
		if (!used[i]) {
			dfs(i, used, arr, ts);
		}
	}
	ts.push_back(v);
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<tuple<ll, ll, ll>> arr;
	for (ll i = 0; i < m; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		arr.emplace_back(a, b, c);
	}
	vector<ll> all(n);
	for (ll i = 0; i < n; i++) {
		cin >> all[i];
	}
	vector<vector<ll>> to(n);
	bool bb = true;
	for (auto[a, b, c] : arr) {
		if (all[a] == all[b] && all[a] != c) {
			bb = false;
		}
		if (all[a] != all[b]) {
			if (all[a] == c) {
				to[b].push_back(a);
			} else {
				to[a].push_back(b);
			}
		}
	}
	if (!bb) {
		cout << "NO" << '\n';
		return;
	}
	vector<ll> used(n, 0);
	for (ll i = 0; i < n; i++) {
		if (used[i] == 0) {
			if (!dfs(i, used, to)) {
				cout << "NO" << '\n';
				return;
			}
		}
	}
	cout << "YES" << '\n';
	vector<pair<ll, ll>> ans;
	for (ll i = 0; i < n; i++) {
		ans.emplace_back(i, 1 - all[i]);
	}
	vector<bool> u(n, false);
	vector<ll> ts;
	for (ll i = 0; i < n; i++) {
		if (!u[i]) {
			dfs(i, u, to, ts);
		}
	}
	for (auto i : ts) {
		ans.emplace_back(i, all[i]);
	}
	cout << ans.size() << '\n';
	for (auto[a, b] : ans) {
		cout << a + 1 << ' ' << b << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
