#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(ll& a, ll b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(ll& a, ll b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const ll K = 400, INF = 1'000'000'000'000'000'000, MAXN = 200'000;

struct sqrt_dec1 {
	vector<ll> arr, sb;
	sqrt_dec1(ll n) {
		arr.resize(n, 0);
		sb.resize((n + K - 1) / K, 0);
	}
	void add(ll x, ll y) {
		arr[x] += y;
		sb[x / K] += y;
	}
	ll get(ll x) {
		ll ans = 0;
		for (ll i = 0; i < sb.size(); i++) {
			if ((i + 1) * K - 1 <= x) {
				ans += sb[i];
			} else {
				for (ll j = i * K; j <= x; j++) {
					ans += arr[j];
				}
				break;
			}
		}
		return ans;
	}
};

struct sqrt_dec2 {
	vector<ll> arr, sb;
	sqrt_dec2(ll n) {
		arr.resize(n, 0);
		sb.resize((n + K - 1) / K, 0);
	}
	void add(ll x, ll y) {
		for (ll i = sb.size() - 1; i >= 0; i--) {
			if (i * K > x) {
				sb[i] += y;
			} else {
				for (ll j = x; j < min((ll)arr.size(), (i + 1) * K); j++) {
					arr[j] += y;
				}
			}
		}
	}
	ll get(ll x) {
		return arr[x] + sb[x / K];
	}
};

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, ll>> t(n);
	for (ll i = 0; i < n; i++) {
		cin >> t[i].first;
		t[i].second = i;
	}
	vector<ll> s;
	ll nsu = 0;
	for (ll i = 0; i < m; i++) {
		ll x;
		cin >> x;
		s.push_back(x - nsu);
		nsu += s.back();
	}
	vector<pair<ll, ll>> ns;
	ll nsum = 0;
	for (ll i = 0; i < m; i++) {
		if (ns.empty() || s[i] > ns.back().first) {
			ns.emplace_back(s[i], 0);
		}
		ns.back().second++;
	}
	set<ll> all;
	all.insert(0);
	for (auto[i, num] : t) {
		all.insert(ns.back().first * i);
	}
	sqrt_dec1 sd1(MAXN);
	sqrt_dec2 sd2(MAXN);
	ll na = 0;
	for (auto[i, num] : t) {
        	na += sd1.get(i);
        	for (ll j = 0; j < ns.size(); j++) {
            		na += (num - sd2.get(ns[j].first * i / ns.back().first)) * ns[j].second;
            		sd1.add((ns[j].first * i + ns.back().first - 1) / ns.back().first, ns[j].second);
       		}
        	sd2.add(i, 1);
        	cout << na << '\n';
    	}
	for (auto[i, num] : t) {
		for (ll j = 0; j < ns.size(); j++) {
			auto it = all.upper_bound(ns[j].first * i);
			it--;
			if (it == all.end()) {
				exit(1);
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
