#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 1'000'000'000'000'000'000, C = 10;

struct segment_tree {
	vector<ll> tree;
	ll size;
	segment_tree(ll n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 2, 0);
	}
	ll get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return 0;
		}
		ll mid = (l + r) / 2;
		return get(v * 2, l, mid, ql, qr) + get(v * 2 + 1, mid, r, ql, qr);
	}
	void set(ll x, ll y) {
		set(1, 0, size, x, y);
	}
	void set(ll v, ll l, ll r, ll x, ll y) {
		if (x < l || r <= x) {
			return;
		}
		if (r - l == 1) {
			tree[v] += y;
			return;
		}
		ll mid = (l + r) / 2;
		set(v * 2, l, mid, x, y);
		set(v * 2 + 1, mid, r, x, y);
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
};

void solve() {
	ll n, x;
	cin >> n >> x;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<ll> to(n);
	ll mx = 0;
	vector<ll> smx(n, 0);
	for (ll i = 0; i < n; i++) {
		assign_max(smx[max(0ll, i - arr[i])], min(n - 1, i + arr[i]));
	}
	for (ll i = 0; i < n; i++) {
            	assign_max(mx, smx[i]);
            	to[i] = mx;
        }
	vector<ll> dp(n);
	ll ans = 0;
        for (ll i = n - 1; i >= 0; i--) {
            	dp[i] = (to[i] < n - 1 ? dp[to[i] + 1] : 0) + (n - to[i] - 1);
		ans += dp[i];
        }
	vector<ll> sp(n + 1, 0);
	for (ll i = n - 1; i >= 0; i--) {
		if (i + 1 < n) {
			sp[i] = sp[i + 1];
		}
		sp[i] += dp[i];
	}
	deque<tuple<ll, ll, ll>> qs;
	for (ll i = 0; i < n; i++) {
		ll np = min(n - 1, i + x);
		ll y = upper_bound(to.begin(), to.end(), np) - to.begin();
		ll st = max(0ll, i - x);
		if (y <= st) {
			continue;
		}
		qs.emplace_back(st, y, (np < n - 1 ? dp[np + 1] : 0) + (n - np - 1));
	}
	sort(qs.begin(), qs.end());
	map<ll, ll> col;
	ll nsum = 1;
	ll nconst = 0;
	col[0] = 1;
	segment_tree stc(n), sts(n);
	stc.set(0, 1);
	sts.set(0, dp[0]);
	while (!col.empty()) {
		while (!qs.empty() && get<0>(qs.front()) == col.begin()->first) {
			auto[nst, en, x] = qs.front();
			qs.pop_front();
			ll y = col.rbegin()->first;
			if (y < en) {
				assign_min(ans, (en - y - 1 + nsum) * x + nconst + sp[en]);
			} else {
				assign_min(ans, stc.get(nst, en) * x + sts.get(en, n) + nconst + sp[y + 1]);
			}
		}
		auto[x, c] = *col.begin();
		if (to[x] == n - 1) {
			col.erase(col.begin());
			continue;
		}
		while (col.rbegin()->first <= to[x]) {
			stc.set(col.rbegin()->first + 1, 1);
			sts.set(col.rbegin()->first + 1, dp[col.rbegin()->first + 1]);
			col[col.rbegin()->first + 1] = 1;
			nsum++;
		}
		col.erase(col.begin());
		stc.set(to[x] + 1, c);
		sts.set(to[x] + 1, dp[to[x] + 1] * c);
		col[to[x] + 1] += c;
		nconst += (n - to[x] - 1) * c;
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
