#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>

using namespace std;

const int inf = 1e9;

void solve() {
    int n;
    cin >> n;
    int m;
    cin >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        x--;
        y--;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto u: g[i]) {
            int to = u.first;
            int zn = u.second;
            if (d[i] == d[to]) {
                if (zn != d[i]) {
                    cout << "NO\n";
                    return;
                }
            }
        }
    }
    set<pair<pair<int, int>, int>> gp; /// <<pok, nepok>, ind>
    set<pair<pair<int, int>, int>> gn; /// <<nepok, pok>, ind>
    vector<pair<int, int>> stat(n); /// <pok, nepok>
    for (int i = 0; i < n; i++) {
        int pok = 0, nepok = 0;
        for (auto u : g[i]) {
            int to = u.first;
            int zn = u.second;
            if (d[i] == d[to]) {
                continue;
            }
            if (zn == 0) {
                nepok++;
            } else {
                pok++;
            }
        }
        gp.insert({{pok, nepok}, i});
        gn.insert({{nepok, pok}, i});
        stat[i] = {pok, nepok};
    }
    vector<pair<int, int>> way; /// second = 0 -> все pok, second = 1 -> все nepok
    vector<bool> used(n, false);
    for (int i = 0; i < n; i++) {
        pair<pair<int, int>, int> pok = *(gp.begin());
        pair<pair<int, int>, int> nep = *(gn.begin());
        if (pok.first.first != 0 && nep.first.first != 0) {
            cout << "NO\n";
            return;
        }
        if (pok.first.first == 0) {
            int ind = pok.second;
            way.push_back({ind, 1});
            used[ind] = true;
            for (auto u : g[ind]) {
                int to = u.first;
                int zn = u.second;
                if (used[to]) {
                    continue;
                }
                gp.erase({stat[to], to});
                gn.erase({{stat[to].second, stat[to].first}, to});
                if (zn == 0) {
                    stat[to].second--;
                } else {
                    stat[to].first--;
                }
                gp.insert({stat[to], to});
                gn.insert({{stat[to].second, stat[to].first}, to});
            }
            continue;
        }
        if (nep.first.first == 0) {
            int ind = pok.second;
            way.push_back({ind, 0});
            used[ind] = true;
            for (auto u : g[ind]) {
                int to = u.first;
                int zn = u.second;
                if (used[to]) {
                    continue;
                }
                gp.erase({stat[to], to});
                gn.erase({{stat[to].second, stat[to].first}, to});
                if (zn == 0) {
                    stat[to].second--;
                } else {
                    stat[to].first--;
                }
                gp.insert({stat[to], to});
                gn.insert({{stat[to].second, stat[to].first}, to});
            }
            continue;
        }
    }
    cout << "YES\n-1\n";
}

int main() {
    int _;
    cin >> _;
    while (_--) {
        solve();
    }
}

/*
 * 5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

 */
