#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <deque>

using namespace std;

const int inf = 1e9;

void solve() {
    int n;
    cin >> n;
    int m;
    cin >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        x--;
        y--;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto u: g[i]) {
            int to = u.first;
            int zn = u.second;
            if (d[i] == d[to]) {
                if (zn != d[i]) {
                    cout << "NO\n";
                    return;
                }
            }
        }
    }
    deque<int> gn, gp;
    vector<pair<int, int>> stat(n); /// <pok, nepok>
    for (int i = 0; i < n; i++) {
        int pok = 0, nepok = 0;
        for (auto u : g[i]) {
            int to = u.first;
            int zn = u.second;
            if (d[i] == d[to]) {
                continue;
            }
            if (zn == 0) {
                nepok++;
            } else {
                pok++;
            }
        }
        if (pok == 0) {
            gp.push_back(i);
        }
        if (nepok == 0) {
            gn.push_back(i);
        }
        stat[i] = {pok, nepok};
    }
    vector<pair<int, int>> way; /// second = 0 -> все pok, second = 1 -> все nepok
    vector<bool> used(n, false);
    for (int i = 0; i < n; i++) {
        while (true) {
            if (gp.empty()) {
                break;
            }
            int ind = gp.front();
            if (used[ind]) {
                gp.pop_front();
            } else {
                break;
            }
        }
        while (true) {
            if (gn.empty()) {
                break;
            }
            int ind = gn.front();
            if (used[ind]) {
                gn.pop_front();
            } else {
                break;
            }
        }
        if (gp.empty() && gn.empty()) {
            cout << "NO\n";
            return;
        }
        if (!gp.empty()) {
            int ind = gp.front();
            gp.pop_front();
            way.push_back({ind, 1});
            used[ind] = true;
            for (auto u : g[ind]) {
                int to = u.first;
                int zn = u.second;
                if (d[to] == d[ind]) {
                    continue;
                }
                if (used[to]) {
                    continue;
                }
                if (zn == 0) {
                    stat[to].second--;
                } else {
                    stat[to].first--;
                }
                if (stat[to].first == 0) {
                    gp.push_back(to);
                }
                if (stat[to].second == 0) {
                    gn.push_back(to);
                }
            }
            continue;
        }
        if (!gn.empty()) {
            int ind = gn.front();
            gn.pop_front();
            way.push_back({ind, 1});
            used[ind] = true;
            for (auto u : g[ind]) {
                int to = u.first;
                int zn = u.second;
                if (d[to] == d[ind]) {
                    continue;
                }
                if (used[to]) {
                    continue;
                }
                if (zn == 0) {
                    stat[to].second--;
                } else {
                    stat[to].first--;
                }
                if (stat[to].first == 0) {
                    gp.push_back(to);
                }
                if (stat[to].second == 0) {
                    gn.push_back(to);
                }
            }
            continue;
        }
    }
    cout << "YES\n-1\n";
    return;
    reverse(way.begin(), way.end());
    for (int i = 0; i < n; i++) {
        cout << way[i].first << " " << way[i].second << "\n";
    }
}

int main() {
    int _;
    cin >> _;
    while (_--) {
        solve();
    }
}

/*
 * 5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

 */
