#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n;
    cin >> n;

    vector<ll> x(n), p(n), d(n);
    for (ll i = 0; i < n; i++) cin >> x[i] >> p[i] >> d[i];

    vector<ll> pref(n + 1), suf(n + 1);

    for (ll i = 1; i <= n; i++) {
        if (i == n || x[i] - x[i - 1] <= p[i - 1]) {
            pref[i] = pref[i - 1] + (d[i - 1] != -1);
        } else {
            pref[i] = INF;
        }

        pref[i] = min(pref[i], INF);
    }

    for (ll i = n - 1; i >= 0; i--) {
        if (i == 0 || x[i] - x[i - 1] <= p[i]) {
            suf[i] = suf[i + 1] + (d[i] != 1);
        } else {
            suf[i] = INF;
        }

        suf[i] = min(suf[i], INF);
    }

    ll ans = INF;
    for (ll i = 0; i <= n; i++) {
        ans = min(ans, pref[i] + suf[i]);
    }

    cout << (ans < INF ? ans : -1);

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
