#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct Edge {
    ll to, c, ind;
};

//struct DSU {
//    vector<ll> p, sz;
//
//    DSU(ll n) {
//        p.assign(n, 0);
//        std::iota(p.begin(), p.end(), 0);
//        sz.assign(n, 1);
//    }
//
//    ll get(ll v) {
//        if (p[v] == v) return v;
//        return p[v] = get(p[v]);
//    }
//
//    void merge(ll a, ll b) {
//        a = get(a), b = get(b);
//        if (a == b) return;
//
//        if (sz[a] < sz[b]) swap(a, b);
//    }
//};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    ll total = 0;

    while (t--) {
        ll n, m;
        cin >> n >> m;

        vector<vector<Edge>> g(n);
        for (ll i = 0; i < m; i++) {
            ll u, v, c;
            cin >> u >> v >> c;

            u--, v--;

            g[u].push_back({v, c, i});
            g[v].push_back({u, c, i});
        }

        vector<ll> cv(n);
        for (ll i = 0; i < n; i++) cin >> cv[i];

        bool ok = true;

        for (ll i = 0; i < n; i++) {
            for (Edge e : g[i]) {
                if (cv[i] == cv[e.to] && cv[i] != e.c) ok = false;
            }
        }

        vector<vector<bool>> used(n, vector<bool>(2, false));

        for (ll i = 0; i < n && ok; i++) {
            queue<pll> q;

            if (!used[i][0])
                q.push({i, 0});

            if (!used[i][1])
                q.push({i, 1});

            used[i][0] = used[i][1] = true;

            while (!q.empty()) {
                auto [v, lastC] = q.front();
                q.pop();

                for (Edge e : g[v]) {
                    if (e.c == lastC) continue;
                    if (cv[e.to] == cv[v]) continue;

                    if (e.to == i) {
                        ok = false;
                        break;
                    }

                    if (used[e.to][e.c]) continue;

                    used[e.to][e.c] = true;
                    q.push({e.to, e.c});
                }
            }
        }

        if (!ok) {
            cout << "NO\n";
            continue;
        }

        // restore

        vector<vector<pll>> d(1 << n, vector<pll>(1 << m, {-1, -1}));
        vector<vector<pll>> rb(1 << n, vector<pll>(1 << m, {-1, -1}));

        queue<pll> q;
        q.push({0, 0});

        while (!q.empty()) {
            auto [maskVert, maskEdg] = q.front();
            q.pop();

            for (ll i = 0; i < n; i++) {
                ll newMaskVert = maskVert ^ (1 << i);
                ll newMaskEdg = maskEdg;

                for (Edge e : g[i]) {
                    if ((newMaskVert >> i & 1) == (newMaskVert >> e.to & 1)) {
                        if (newMaskEdg >> e.ind & 1) newMaskEdg -= 1 << e.ind;
                        newMaskEdg += (newMaskVert >> i & 1) << e.ind;
                    }
                }

                if (d[newMaskVert][newMaskEdg].first == -1 && (newMaskVert != 0 || newMaskEdg != 0)) {
                    d[newMaskVert][newMaskEdg] = {i, (newMaskVert >> i & 1)};
                    rb[newMaskVert][newMaskEdg] = {maskVert, maskEdg};
                    q.push({newMaskVert, newMaskEdg});
                }
            }
        }

        ll maskVert = 0, maskEdg = 0;
        for (ll i = 0; i < n; i++) maskVert += cv[i] << i;
        for (ll i = 0; i < n; i++) {
            for (Edge e : g[i]) {
                if (e.c == 1 && (maskEdg >> e.ind & 1) == 0)
                    maskEdg += 1 << e.ind;
            }
        }

        vector<pll> ans;

        while (maskVert != -1) {
            ans.push_back(d[maskVert][maskEdg]);
            auto z = rb[maskVert][maskEdg];

            maskVert = z.first;
            maskEdg = z.second;
        }

        ans.pop_back();
        std::reverse(ans.begin(), ans.end());

        cout << "YES\n" << ans.size() << "\n";
        for (auto [v, c] : ans) cout << v + 1 << " " << c << "\n";
    }

    assert(total <= 1000000);

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}