#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct Edge {
    ll to, c, ind;
};

//struct DSU {
//    vector<ll> p, sz;
//
//    DSU(ll n) {
//        p.assign(n, 0);
//        std::iota(p.begin(), p.end(), 0);
//        sz.assign(n, 1);
//    }
//
//    ll get(ll v) {
//        if (p[v] == v) return v;
//        return p[v] = get(p[v]);
//    }
//
//    void merge(ll a, ll b) {
//        a = get(a), b = get(b);
//        if (a == b) return;
//
//        if (sz[a] < sz[b]) swap(a, b);
//    }
//};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    ll total = 0;

    while (t--) {
        ll n, m;
        cin >> n >> m;

        vector<vector<Edge>> g(n);
        for (ll i = 0; i < m; i++) {
            ll u, v, c;
            cin >> u >> v >> c;

            u--, v--;

            g[u].push_back({v, c, i});
            g[v].push_back({u, c, i});
        }

        vector<ll> cv(n);
        for (ll i = 0; i < n; i++) cin >> cv[i];

        bool ok = true;

        for (ll i = 0; i < n; i++) {
            for (Edge e : g[i]) {
                if (cv[i] == cv[e.to] && cv[i] != e.c) ok = false;
            }
        }

        vector<vector<bool>> used(n, vector<bool>(2, false));

        for (ll i = 0; i < n && ok; i++) {
            queue<pll> q;

            if (!used[i][0])
                q.push({i, 0});

            if (!used[i][1])
                q.push({i, 1});

            used[i][0] = used[i][1] = true;

            while (!q.empty()) {
                auto [v, lastC] = q.front();
                q.pop();

                for (Edge e : g[v]) {
                    if (e.c == lastC) continue;
                    if (cv[e.to] == cv[v]) continue;

                    if (e.to == i) {
                        ok = false;
                        break;
                    }

                    if (used[e.to][e.c]) continue;

                    used[e.to][e.c] = true;
                    q.push({e.to, e.c});
                }
            }
        }

        if (!ok) {
            cout << "NO\n";
            continue;
        }

        // restore

        vector<pll> ans;
        for (ll i = 0; i < n; i++) {
            if (cv[i] == 1)
                ans.emplace_back(i, 1);
        }

        set<pll> bad;
        for (ll i = 0; i < n; i++) {
            for (Edge e : g[i]) {
                ll u = i, v = e.to;
                if (u > v) swap(u, v);

                if (e.c == 1 && (cv[u] == 0 || cv[v] == 0)) bad.insert({u, v});
            }
        }

        ll cntBad = bad.size();

        vector<ll> nwCol(m);
        for (ll i = 0; i < n; i++) {
            for (Edge e : g[i]) {
                if (cv[i] == 1 && cv[e.to] == 1) nwCol[e.ind] = 1;
            }
        }

        vector<ll> cntUsed(n, 0);

        while (cntBad > 0) {
            ll mxInd = -1, mxAns = -INF;

            for (ll v = 0; v < n; v++) {
                if (cntUsed[v] > 5) continue;

                ll cntNew = cntBad;

                for (Edge e : g[v]) {
                    cntNew -= e.c != nwCol[e.ind];
                    if (cv[e.to] == 1 - cv[v])
                        cntNew += cv[e.to] != e.c;
                }

                if (cntBad - cntNew > mxAns) {
                    mxAns = cntBad - cntNew;
                    mxInd = v;
//                    if (cntBad - cntNew > 0) break;
                }
            }

            cntBad -= mxAns;

            ll v = mxInd;
            cntUsed[v]++;

            ans.emplace_back(v, 1 - cv[v]);
            ans.emplace_back(v, cv[v]);

            for (Edge e : g[v]) {
                if (cv[e.to] == 1 - cv[v])
                    nwCol[e.ind] = cv[e.to];
            }
        }

        total += ans.size();

        cout << "YES\n" << ans.size() << "\n";

        for (auto [v, c] : ans) {
            cout << v + 1 << " " << c << "\n";
        }
    }

    assert(total <= 1000000);

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}