#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct Edge {
    ll to, ind;
};

vector<vector<Edge>> g;
vector<ll> needVert, needEdg;

bool rec(ll h, vector<ll> vert, vector<ll> edg) {
    if (h > 6) return false;

    bool ok = true;
    for (ll i = 0; i < vert.size(); i++) ok &= vert[i] == needVert[i];
    for (ll i = 0; i < edg.size(); i++) ok &= edg[i] == needEdg[i];

    if (ok) return true;

    for (ll i = 0; i < vert.size(); i++) {
        vert[i] ^= 1;
        vector<pll> rb;

        for (Edge e : g[i]) {
            if (vert[i] == vert[e.to]) {
                rb.push_back({e.ind, edg[e.ind]});
                edg[e.ind] = vert[i];
            }
        }

        if (rec(h + 1, vert, edg)) return true;

        vert[i] ^= 1;
        for (auto [ind, x] : rb) edg[ind] = x;
    }

    return false;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n, m;
        cin >> n >> m;

        g.assign(n, {});
        needVert.assign(n, 0);
        needEdg.assign(m, 0);

        for (ll i = 0; i < m; i++) {
            ll u, v, c;
            cin >> u >> v >> c;
            u--, v--;

            needEdg[i] = c;
            g[u].push_back({v, i});
            g[v].push_back({u, i});
        }

        for (ll i = 0; i < n; i++) cin >> needVert[i];

        cout << (rec(0, vector<ll>(n, 0), vector<ll>(m, 0)) ? "YES\n-1" : "NO") << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
