#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct Edge {
    ll u, v, c;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n, m;
        cin >> n >> m;

        assert(m == n);

        vector<Edge> e(m);
        for (ll i = 0; i < m; i++) {
            cin >> e[i].u >> e[i].v >> e[i].c;
            e[i].u--, e[i].v--;
        }

        vector<ll> d(n);
        for (ll i = 0; i < n; i++) cin >> d[i];

        bool ok = true;

        for (ll i = 0; i < m; i++) {
            if (d[e[i].u] == d[e[i].v] && d[e[i].u] != e[i].c) ok = false;
        }

        bool ddV = true, ddE = true;

        for (ll i = 0; i < n; i++) {
            ddV &= d[i] != d[(i + 1) % n];
            ddE &= e[i].c != (e[(i + 1) % n].c);
        }

        if (ddV && ddE) ok = false;

        cout << (ok ? "YES\n-1" : "NO") << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}