#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct Edge {
    ll to, c;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, m;
    cin >> n >> m;

    vector<ll> t(n), s(m);
    for (ll i = 0; i < n; i++) cin >> t[i];
    for (ll i = 0; i < m; i++) cin >> s[i];

    s.insert(s.begin(), 0);
    m++;

    for (ll pref = 0; pref < n; pref++) {
        ll ans = 0;

        vector<ll> nwAt(n);
        auto getNext = [&] (ll i) {
            return (ld)(s[nwAt[i] + 1] - s[nwAt[i]]) * t[i];
        };

        set<pll> q;
        for (ll i = 0; i <= pref; i++)
            q.insert({getNext(i), i});

        while (!q.empty()) {
            ll v = q.begin()->second;
            q.erase(q.begin());

            ans += (ll)q.size();

            nwAt[v]++;
            if (nwAt[v] < m - 1) {
                q.insert({getNext(v), v});
            }
        }

        cout << ans << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}