#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

struct Edge {
    ll to, c;
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, m;
    cin >> n >> m;

    vector<ll> t(n), s(m);
    for (ll i = 0; i < n; i++) cin >> t[i];
    for (ll i = 0; i < m; i++) cin >> s[i];

    s.insert(s.begin(), 0);
    m++;

    vector<ll> nwAt(n);
    auto getNext = [&] (ll i) {
        return (ld)(s[nwAt[i] + 1] - s[nwAt[i]]) * t[i];
    };

    vector<pll> q;
    for (ll i = 0; i < n; i++)
        q.push_back({getNext(i), i});

    vector<ll> pref(n);

    while (!q.empty()) {
        auto it = std::min_element(q.begin(), q.end());
        ll v = it->second;
        q.erase(it);

        for (auto z : q) pref[max(z.second, v)]++;

        nwAt[v]++;
        if (nwAt[v] < m - 1) {
            q.push_back({getNext(v), v});
        }
    }

    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        ans += pref[i];
        cout << ans << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}