#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace  std;
#define int long long
const int INF = 9e18;

struct edge {
    int u, col;
};
mt19937 rng(42239777);
vector<vector<edge>> g;
vector<int> c, used, cur_c;
vector<pair<int, int>> ans;
set<pair<int, int>> on;
bool flag;

void dfs(int v){
    used[v] = 1;
    for (auto &e : g[v]){
        int u = e.u;
        int col = e.col;
        if (!used[u] && !col && !c[u]){
            dfs(u);
        }
    }

    bool need = true;
    for (auto &e : g[v]) {
        int u = e.u;
        if (cur_c[u] == 1 && !e.col){
            need = false;
        }
    }
    if (need) {
        ans.push_back({v, 1});
        cur_c[v] = 1;
        for (auto &e: g[v]) {
            int u = e.u;
            int col = e.col;
            if (!used[u] && col) {
                ans.push_back({u, 1});
                ans.push_back({u, 0});
                on.insert({min(v, u), max(v, u)});
                dfs(u);
            }
        }
    }

    if (!c[v]){
        cur_c[v] = 0;
        ans.push_back({v, 0});
        for (auto &e : g[v]){
            int u = e.u;
            if (cur_c[u] == 0){
                on.erase({min(v, u), max(v, u)});
            }
        }
    }
    for (auto &e : g[v]){
        int u = e.u;
        int col = e.col;
        if (!used[u] && !col && c[u]){
            dfs(u);
        }
    }
}

void solve(){
    flag = true;
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    c.assign(n, 0);
    cur_c.assign(n, 0);
    set<pair<int, int>> real_on;
    for (int i = 0; i < m; ++i){
        int v, u, d;
        cin >> v >> u >> d;
        v--;
        u--;
        g[v].push_back({u, d});
        g[u].push_back({v, d});
        if (d) real_on.insert({min(v, u), max(v, u)});
    }
    for (int i = 0; i < n; ++i){
        cin >> c[i];
    }

    int x = 1e5;
    while (ans.size() < x){
        int v = rng() % n;
        cur_c[v] = !cur_c[v];
        ans.push_back({v, cur_c[v]});
        for (auto &e : g[v]){
            int u = e.u;
            if (cur_c[e.u] == cur_c[v]){
                if (cur_c[v] == 0){
                    on.erase({min(v, u), max(v, u)});
                } else {
                    on.insert({min(v, u), max(v, u)});
                }
            }
        }
        if (on == real_on && c == cur_c) {
            cout << "YES\n";
            //cout << "-1\n";
            cout << ans.size() << "\n";
            for (auto i: ans) {
                cout << i.first + 1 << " " << i.second << "\n";
            }
            break;
        } else if (ans.size() == x - 1){
            cout << "NO\n";
        }
    }

    g = {};
    c = {};
    cur_c = {};
    ans = {};
    used = {};
    on = {};
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--){
        solve();
    }

    return 0;
}
/*
 *
5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

2
3 2
1 2 0
1 3 1
0 0 1
4 3
1 2 0
1 3 1
1 4 0
0 0 0 0

3
4 3
 1 2 0
 1 3 1
 1 4 1
 0 0 1 1
3 2
 1 2 0
 1 3 1
 0 0 1
5 4
 1 2 0
 1 3 1
 1 4 1
 1 5 0
 1 0 0 0 1

1
 3 2
 1 2 1
 1 3 1
 1 1 1
 */