#include <bits/stdc++.h>

using namespace std;

#define int long long

constexpr int inf = 1e18;

bool cycle(vector<vector<int>> gr3) {
    int n = gr3.size();
    vector<int> used(n, 0);
    auto dfs = [&](auto self, int v) -> bool {
        if (used[v] == 1)
            return true;
        if (used[v] == 2)
            return false;
        used[v] = 1;
        for (int u: gr3[v])
            if (self(self, u))
                return true;
        used[v] = 2;
        return false;
    };
    for (int i = 0; i < n; ++i)
        if (dfs(dfs, i))
            return true;
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<array<int, 3>> e(m);
    for (auto &i: e)
        cin >> i[0] >> i[1] >> i[2], --i[0], --i[1];
    vector<int> d(n);
    for (int &i: d)
        cin >> i;
    vector<vector<int>> gr1(n), gr2(n);
    bool ok = true;
    for (auto i: e) {
        if (d[i[0]] != d[i[1]]) {
            if (i[2] == 0) {
                gr1[(d[i[0]] == 0 ? i[0] : i[1])].push_back((d[i[0]] == 1 ? i[0] : i[1]));
                gr2[(d[i[0]] == 1 ? i[0] : i[1])].push_back((d[i[0]] == 0 ? i[0] : i[1]));
            } else {
                gr2[(d[i[0]] == 0 ? i[0] : i[1])].push_back((d[i[0]] == 1 ? i[0] : i[1]));
                gr1[(d[i[0]] == 1 ? i[0] : i[1])].push_back((d[i[0]] == 0 ? i[0] : i[1]));
            }
        } else if (d[i[0]] != i[2])
            ok = false;
    }
    vector<vector<pair<int, int>>> gr3(n);
    for (int i = 0; i < n; ++i) {
        for (int j : gr1[i])
            gr3[i].push_back({j, d[i] == 0 ? 0 : 1});
        for (int j : gr2[i])
            gr3[i].push_back({j, d[i] == 0 ? 1 : 0});
    }
    if (!ok || cycle(gr1) || cycle(gr2)) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        vector<pair<int, int>> op;
        vector<bool> used(n, false);
        auto upd = [&](int v) -> void {
            if (used[v])
                return;
            used[v] = true;
            if (d[v] == 0) {
                op.push_back({v, 1});
                op.push_back({v, 0});
            }
            if (d[v] == 1)
                op.push_back({v, 1});
            for (auto u : gr3[v]) {
                if (u.second == d[v]) {
                    op.push_back({u.first, 1});
                    op.push_back({u.first, 0});
                }
            }
        };
        vector<vector<int>> gr4(n);
        for (int i = 0; i < n; ++i) {
            for (auto [j, type] : gr3[i])
                if (type == d[i])
                    gr4[i].push_back(j);
        }
        vector<int> ord;
        vector<bool> used2(n, false);
        auto dfs = [&](auto self, int v) -> void {
            if (used2[v])
                return;
            used2[v] = true;
            while (gr4[v].size() > 0) {
                self(self, gr4[v].back());
                gr4[v].pop_back();
            }
            ord.push_back(v);
        };
        for (int i = 0; i < n; ++i)
            dfs(dfs, i);
        reverse(ord.begin(), ord.end());
        for (auto i : ord)
            upd(i);
        cout << op.size() << '\n';
        for (auto i : op)
            cout << i.first + 1 << ' ' << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}