#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll inf = 1e12;

struct edge
{
    ll a, b, c;
};

struct vert
{
    ll i, inc;
    bool operator <(const vert &other)
    const
    {
        if(inc == other.inc)
        {
            return i < other.i;
        }
        return inc < other.inc;
    }
};

bool cycle_search_dfs(ll v, vector <vector <ll> > &g, vector <ll> &used)
{
    used[v] = 1;
    for(ll i = 0; i < g[v].size(); i++)
    {
        ll u = g[v][i];
        if(used[u] == 1)
        {
            return true;
        }
        if(used[u] == 0 && cycle_search_dfs(u, g, used))
        {
            return true;
        }
    }
    used[v] = 2;
    return false;
}

void solve()
{
    ll n, m;
    cin >> n >> m;
    vector <vector <ll> > g(n);
    vector <edge> e(m);
    for(ll i = 0; i < m; i++)
    {
        cin >> e[i].a >> e[i].b >> e[i].c;
        e[i].a--;
        e[i].b--;
        g[e[i].a].push_back(e[i].b);
        g[e[i].b].push_back(e[i].a);
    }
    vector <ll> d(n);
    for(ll i = 0; i < n; i++)
    {
        cin >> d[i];
    }
    vector <vector <ll> > or_g(n);
    bool flag = false;
    for(ll i = 0; i < m; i++)
    {
        if(d[e[i].a] == d[e[i].b] && d[e[i].a] != e[i].c)
        {
            flag = true;
        }

        if(d[e[i].a] != d[e[i].b])
        {
            if(e[i].c == d[e[i].a])
            {
                or_g[e[i].a].push_back(e[i].b);
            }
            else
            {
                or_g[e[i].b].push_back(e[i].a);
            }
        }
    }
    if(flag)
    {
        cout << "NO" << endl;
        return;
    }
    vector <ll> used(n, 0);
    for(ll i = 0; i < n; i++)
    {
        if(used[i] == 0)
        {
            if(cycle_search_dfs(i, or_g, used))
            {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    vector <ll> inc(n, 0);
    for(ll v = 0; v < n; v++)
    {
        for(ll i = 0; i < or_g[v].size(); i++)
        {
            ll u = or_g[v][i];
            inc[u]++;
        }
    }
    set <vert> st;
    vector <ll> ord;
    for(ll i = 0; i < n; i++)
    {
        st.insert({i, inc[i]});
    }
    while(!st.empty())
    {
        ll v = st.begin() -> i;
        ord.push_back(v);
        st.erase({v, inc[v]});
        for(ll i = 0; i < or_g[v].size(); i++)
        {
            ll u = or_g[v][i];
            st.erase({u, inc[u]});
            inc[u]--;
            st.insert({u, inc[u]});
        }
    }
    vector <ll> ans;
    vector <ll> c_ans;
    vector <bool> dead(n, false);
    for(ll t = 0; t < n; t++)
    {
        ll v = ord[t];
        ans.push_back(v);
        c_ans.push_back(d[v]);
        for(ll i = 0; i < g[v].size(); i++)
        {
            ll u = g[v][i];
            if(!dead[u])
            {
                ans.push_back(u);
                c_ans.push_back(d[v]);
            }
        }
        dead[v] = true;
    }
    cout << ans.size() << endl;
    for(ll i = 0; i < ans.size(); i++)
    {
        cout << ans[i] + 1 << ' ' << c_ans[i] << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    ll t = 1;
    cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
