#include<iostream>
#include<vector>
#include<iomanip>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
#include<random>
using namespace std;
using ll=long long;
const int INF = 1e9 + 7;
vector<vector<pair<int, int>>>g;
vector<int>used;
vector<int>top_sort;
bool dfs(int v) {
	used[v] = 1;
	for (auto [u, i] : g[v]) {
		if (used[u] == 1) {
			return false;
		}
		if (used[u] == 0) {
			if (!dfs(u))return false;
		}
	}
	used[v] = 2;
	top_sort.push_back(v);
	return true;
}
void solve() {
	int n, m; cin >> n >> m;
	g.assign(n, {});
	vector<tuple<int, int, int>>edges(m);
	vector<int>sts(n);
	for (int i = 0; i < m; ++i) {
		int v, u, c; cin >> v >> u >> c; --v, --u;
		edges[i] = { v,u,c };
	}
	for (int i = 0; i < n; ++i)cin >> sts[i];
	for (int i = 0; i < m; ++i) {
		auto [v, u, c] = edges[i];
		if (sts[v] == sts[u]) {
			if (c != sts[v]) {
				cout << "NO\n";
				return;
			}
		}
		else {
			if (c == sts[v])g[v].push_back({ u,i });
			else g[u].push_back({ v,i });
		}
	}
	used.assign(n, 0);
	top_sort.resize(0);
	for (int v = 0; v < n; ++v) {
		if (used[v] == 0 && !dfs(v)) {
			cout << "NO\n"; return;
		}
	}
	reverse(top_sort.begin(), top_sort.end());
	used.assign(n, 0);
	vector<pair<int, int>>ans;
	for (int i = 0; i < n; ++i)ans.push_back({ i,0 });
	for (auto v : top_sort) {
		used[v] = 1;
		if (sts[v] == 1) {
			ans.push_back({ v,1 });
		}
		for (auto [u, i] : g[v]) {
			if (used[u])continue;
			if (sts[v] == 1) {
				ans.push_back({ u,1 });
				ans.push_back({ u,0 });
			}
		}
	}

	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto c : ans)cout << c.first + 1 << " " << c.second << '\n';
}
int main()
{
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int t; cin >> t;
	while (t--)solve();
}
