#include<iostream>
#include<vector>
#include<iomanip>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
#include<random>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
const ll LINF = 1000000000000000000 + 9;
struct Node {
	ll v=0, push = 0;
	Node() {}
	Node(ll v) :v(v) {}
};
Node f(Node a, Node b) {
	return Node(a.v + b.v);
}
vector<ll>base;
vector<Node>seg_tree;
void push(int v, ll l, ll r) {
	if (seg_tree[v].push == 0)return;
	int md = (r + l) / 2;
	seg_tree[2 * v + 1].push += seg_tree[v].push;
	seg_tree[2 * v + 1].v += seg_tree[v].push * (md - l);
	seg_tree[2 * v + 2].push += seg_tree[v].push;
	seg_tree[2 * v + 2].v += seg_tree[v].push * (r - md);
	seg_tree[v].push = 0;
}

ll gt(int v, int l, int r, int ql, int qr) {
	if (qr <= l or r <= ql)return 0;
	if (ql <= l and r <= qr)return seg_tree[v].v;
	push(v, l, r);
	int md = (r + l) / 2;
	return gt(2 * v + 1, l, md, ql, qr) + gt(2 * v + 2, md, r, ql, qr);
}
void add(int v, ll l, ll r, int ql, int qr, ll x) {
	if (qr <= l or r <= ql)return;
	if (ql <= l and r <= qr) {
		seg_tree[v].v += (x) * (r - l);
		seg_tree[v].push += x;
		return;
	}
	push(v, l, r);
	int md = (r + l) / 2;
	add(2 * v + 1, l, md, ql, qr, x);
	add(2 * v + 2, md, r, ql, qr, x);
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}
int main()
{
	//  
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ll n, m; cin >> n >> m;
	vector<ll>t(n), s(m);
	for (int i = 0; i < n; ++i)cin >> t[i];
	for (int i = 0; i < m; ++i)cin >> s[i];
	ll j = 0, i = 0;
	ll ans = 0;
	//for (auto c : s)cout << c << " "; cout << "\n";
	ll solo = 0, ww = 0;
	while(i<m) {
		//cout << i << " " << j << "\n";
		ll d1 = s[i], d2=s[j];
		if (i > 0)d1 -= s[i - 1];
		if (j > 0)d2 -= s[j - 1];
		//cout << d1 << " " << d2 << "\n";
		if (d1 <= d2) {
			//cout << "solo +=" << n - 1 << "\n";
			ans += (n - 1);
			solo++;
			++i;
		}
		else
		{
			//cout << "wait dudes +=" << (n - 1) * (n - 1) * (i - j) << "\n";
			ans += (n - 1) * (n - 1) * (i - j);
			ww += (i - j);
			j = i;
		}
	}
	base.resize(n);
	seg_tree.resize(4 * n);
	for (ll k = 1; k <= n; ++k) {
		base[k - 1] = solo * (k - 1) + (k - 1) * (k - 1) * ww;
	}
	for (ll k = 1; k < n; ++k) {
		
		add(0, 0, n, k+1, n, (n - k - 1) * (m - j));
	}
	for (int i = 0; i < n; ++i) {
		cout << base[i] + gt(0, 0, n, i, i + 1)<<"\n";
	}
}