#include<iostream>
#include<vector>
#include<iomanip>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
#include<random>
using namespace std;
using ll=long long;
const int INF = 1e9 + 7;

struct Node {
	ll v=0; int ind=0;
	Node() {}
	Node(ll v, int ind) :v(v), ind(ind) {}
};
Node f(Node a, Node b) {
	if (a.v < b.v or a.v == b.v && a.ind < b.ind)return a;
	return b;
}
vector<Node>seg_tree;
vector<int>way_b;
void build(int v,int l,int r) {
	if (r - l == 1) {
		seg_tree[v] = Node(way_b[l], l);
		return;
	}
	int md = (r + l) / 2;
	build(2 * v + 1, l, md);
	build(2 * v + 2, md, r);
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}
Node gt(int v, int l, int r, int ql, int qr) {
	if (qr <= l or r <= ql)return Node(INF, -1);
	if (ql <= l and r <= qr)return seg_tree[v];
	int md = (r + l) / 2;
	return f(gt(2 * v + 1, l, md, ql, qr), gt(2 * v + 2, md, r, ql, qr));
}
void st(int v, int l, int r, int i, int x) {
	if (r - l == 1) {
		seg_tree[v].v = x;
		way_b[l] = x;
		return;
	}
	int md = (r + l) / 2;
	if (i < md)st(2 * v + 1, l, md, i, x);
	else st(2 * v + 2, md, r, i, x);
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}
int main()
{
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int n, m; cin >> n >> m;
	vector<ll>t(n); vector<ll>s(1); s[0] = 0;
	for (int i = 0; i < n; ++i)cin >> t[i];
	for (int i = 0; i < m; ++i) {
		int x; cin >> x;
		s.push_back(x);
	}
	seg_tree.resize(4 * n);
	for (int k = 1; k <= n; ++k) {
		way_b.assign(n, INF);
		for (int i = 0; i < k; ++i)way_b[i] = (s[1] - s[0]) * t[i];
		build(0, 0, n);
		vector<int>sts(n, 0);
		ll ans = 0; int finished = 0;
		while (finished<k) {
			Node ff = gt(0, 0, n, 0, k);
			int ch = ff.ind;
			//cout << "ch is " << ch << '\n';
			sts[ch]++;
			ans += k - finished - 1;
			if (sts[ch] == m) {
				st(0, 0, n, ch, INF);
				finished++;
			}
			else {
				st(0, 0, n, ch, (s[sts[ch] + 1] - s[sts[ch]]) * t[ch]);
			}
		}
		cout << ans << "\n";
	}
}
