#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("bmi,popcnt,avx2")
#include<iostream>
#include<vector>
#include<iomanip>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
#include<random>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
const ll LINF = 1000000000000000000 + 9;
struct Node {
	ll v = 0; int ind = 0;
	Node() {}
	Node(ll v, int ind) :v(v), ind(ind) {}
};
Node f(Node a, Node b) {
	if (a.v < b.v or a.v == b.v && a.ind < b.ind)return a;
	return b;
}
vector<Node>seg_tree;
vector<ll>way_b;
void build(int v, int l, int r) {
	if (r - l == 1) {
		seg_tree[v] = Node(way_b[l], l);
		return;
	}
	int md = (r + l) / 2;
	build(2 * v + 1, l, md);
	build(2 * v + 2, md, r);
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}
Node gt(int v, int l, int r, int ql, int qr) {
	if (qr <= l or r <= ql)return Node(LINF, -1);
	if (ql <= l and r <= qr)return seg_tree[v];
	int md = (r + l) / 2;
	return f(gt(2 * v + 1, l, md, ql, qr), gt(2 * v + 2, md, r, ql, qr));
}
void st(int v, int l, int r, int i, ll x) {
	if (r - l == 1) {
		seg_tree[v].v = x;
		way_b[l] = x;
		return;
	}
	int md = (r + l) / 2;
	if (i < md)st(2 * v + 1, l, md, i, x);
	else st(2 * v + 2, md, r, i, x);
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}



vector<pair<int,int>>SG;
void add(int v, int l, int r, int i, pair<int,int>x) {
	if (r - l == 1) {
		SG[v].first += x.first;
		SG[v].second += x.second;
		return;
	}
	int md = (r + l) / 2;
	if (i < md)add(2 * v + 1, l, md, i, x);
	else add(2 * v + 2, md, r, i, x);
	SG[v].first = SG[2 * v + 1].first + SG[2 * v + 2].first;
	SG[v].second = SG[2 * v + 1].second + SG[2 * v + 2].second;
}
pair<int,int> get(int v, int l, int r, int ql, int qr) {
	if (qr <= l or r <= ql)return { 0,0 };
	if (ql <= l and r <= qr)return SG[v];
	int md = (r + l) / 2;

	auto a = get(2 * v + 1, l, md, ql, qr), b = get(2 * v + 2, md, r, ql, qr);
	return { a.first + b.first,a.second + b.second };
}
int main()
{
	//  
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int n, m; cin >> n >> m;
	vector<ll>t(n); vector<ll>s(1); s[0] = 0;
	for (int i = 0; i < n; ++i)cin >> t[i];
	for (int i = 0; i < m; ++i) {
		ll x; cin >> x;
		s.push_back(x);
	}
	seg_tree.resize(4 * n);
	vector<int>hst;
	int k = n;
	//cout << k << "\n";
	vector<vector<int>>kkw(n);
	way_b.assign(n, LINF);
	for (int i = 0; i < k; ++i)way_b[i] = (s[1] - s[0]) * t[i];
	build(0, 0, n);
	vector<int>sts(n, 0);
	int finished = 0;

	while (finished < k) {
		//for (auto c : way_b)cout << c << " "; cout << "\n";
		Node ff = gt(0, 0, n, 0, k);
		int ch = ff.ind;
		//cout << "ch is " << ch << '\n';
		sts[ch]++;
		kkw[ch].push_back(hst.size());
		hst.push_back(ch);
		if (sts[ch] == m) {
			st(0, 0, n, ch, LINF);
			finished++;
		}
		else {
			st(0, 0, n, ch, (s[sts[ch] + 1] - s[sts[ch]]) * t[ch]);
		}
	}
	SG.resize(4 * hst.size());
	
	ll ans = 0;
	for (int k = 0; k < n; ++k) {
		//cout << "k is " << k << "\n";
		for (int i = 0; i < m; ++i) {
			int x = kkw[k][i];
			ans += k - get(0, 0, hst.size(), 0, x).second;
			//cout << ans << '\n';
		}
		ans += get(0, 0, hst.size(), 0, kkw[k].back()).first;
		for (int i = 0; i < m; ++i) {
			add(0, 0, hst.size(), kkw[k][i], { 1,0 });
		}
		add(0, 0, hst.size(), kkw[k].back(), { 0,1 });
		cout << ans << "\n";
	}
	
	
}