#include <bits/stdc++.h>
#define int long long

using namespace std;

struct edge {
  int u, v, c;
  edge() = default;
  edge(int u, int v, int c) : u(u), v(v), c(c) {}
};

void solve() {
  int n, m;
  cin >> n >> m;
  vector<edge> e(m);
  for (int i = 0; i < m; i++) {
    cin >> e[i].u >> e[i].v >> e[i].c;
    e[i].u--;
    e[i].v--;
  }
  vector<int> d(n);
  for (int i = 0; i < n; i++) {
    cin >> d[i];
  }
  vector<vector<int>> g1(n);
  for (int i = 0; i < m; i++) {
    if (d[e[i].u] != d[e[i].v]) {
      int f = e[i].u;
      int t = e[i].v;
      if (e[i].c == 1) {
        if (d[e[i].u] == 1) swap(f, t);
      }
      else {
        if (d[e[i].v] == 1) swap(f, t);
      }
      swap(f,t);
      g1[f].push_back(t);
    }
  }
  vector<int> cl(n, 0);
  bool can = true;
  for (int i = 0; i < m; i++) {
    if (e[i].c == 0 && d[e[i].u] == 1 && d[e[i].v] == 1) {
      can = false;
    }
    if (e[i].c == 1 && d[e[i].u] == 0 && d[e[i].v] == 0) {
      can = false;
    }
  }
  if (!can) {
    cout << "NO\n";
    return;
  }
  function<void(int)> dfs1 = [&](int v) {
    cl[v] = 1;
    for (auto& to : g1[v]) {
      if (cl[to] == 0) {
        dfs1(to);
      } else if (cl[to] == 1) {
        can = false;
      }
    }
    cl[v] = 2;
  };
  for (int i = 0; i < n; i++) {
    if (cl[i] == 0) {
      dfs1(i);
    }
  }
  vector<int> ts;
  vector<bool> used(n, false);
  function<void(int)> dfs2 = [&](int v) {
    used[v] = true;
    for (auto& to : g1[v]) {
      if (!used[to]) {
        dfs2(to);
      }
    }
    ts.push_back(v);
  };
  for (int i = 0; i < n; i++) {
    if (!used[i]) {
      dfs2(i);
    }
  }
  reverse(ts.begin(), ts.end());
  if (can) {
    cout << "YES\n";
    vector<pair<int, int>> op;
    vector<bool> c(n, false);
    for (int i = 0; i < n; i++) {
      int v = ts[i];
      if (!d[v]) continue;
      op.emplace_back(v, 1);
      c[v] = !c[v];
      for (auto& to : g1[i]) {
        op.emplace_back(to, 1);
        op.emplace_back(to, 0);
      }
    }
    for (int i = 0; i < m; i++) {
      if (c[i] != d[i]) {
        op.emplace_back(i, d[i]);
      }
    }
    cout << op.size() << '\n';
    for (auto& [v, _] : op) {
      cout << v + 1 << ' ' << _ << '\n';
    }
  } else {
    cout << "NO\n";
  }
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}