//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct segtree {
    struct node {
        ll sum = 0, suma = 0;
        ll op1 = 0, op2 = 0, op3 = 0;
        ll len = 1;


        void mna(ll d) {
            suma -= d;
            op2 += d;
        }

        void minus(ll x) {
            sum -= len * x;
            op3 += x;
        }

        void add(ll f) {
            sum += f * suma;
            op3 += op2 * f;
            op1 += f;
        }

        node operator+(node b) const {
            return {sum + b.sum, suma + b.suma, 0, 0, 0, len + b.len};
        }
    };

    vector<node> tr;
    int sz = 1;

    void push(int v){
        tr[2 * v + 1].add(tr[v].op1);
        tr[2 * v + 1].mna(tr[v].op2);
        tr[2 * v + 1].minus(tr[v].op3);
        tr[2 * v + 2].add(tr[v].op1);
        tr[2 * v + 2].mna(tr[v].op2);
        tr[2 * v + 2].minus(tr[v].op3);
        tr[v].op1 = 0;
        tr[v].op2 = 0;
        tr[v].op3 = 0;
    }

    void rec(int v){
        tr[v].sum = tr[2 * v + 1].sum + tr[2 * v + 2].sum;
        tr[v].suma = tr[2 * v + 1].suma + tr[2 * v + 2].suma;
    }
    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
        for (int v = sz - 1; v < 2 * sz - 1; v++) {
            tr[v] = {0, v - (sz - 1) + 1, 0, 0, 0, 1};
        }
        for (int v = sz - 2; v > -1; v--) {
            tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
        }
    }

    void ch1(int v, int l, int r, int lseg, int rseg, ll x) {
        if (lseg <= l && r <= rseg){
            tr[v].add(x);
            return;
        }
        if (rseg <= l || r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch1(2 * v + 1, l, mid, lseg, rseg, x);
        ch1(2 * v + 2, mid, r, lseg, rseg, x);
        rec(v);
    }

    void ch1(int lseg, int rseg, ll x){
        ch1(0, 0, sz, lseg, rseg, x);
    }


    void ch2(int v, int l, int r, int lseg, int rseg){
        if (lseg <= l && r <= rseg){
            tr[v].mna(1);
            return;
        }
        if (rseg <= l || r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch2(2 * v + 1, l, mid, lseg, rseg);
        ch2(2 * v + 2, mid, r, lseg, rseg);
        rec(v);
    }

    void ch2(int lseg, int rseg){
        ch2(0, 0, sz, lseg, rseg);
    }

    void ans(){
        for (int i = 0; i < sz - 1; i++){
            push(i);
        }
    }
};


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    ll col = 0;
    for (ll i =0 ;i < n; i++){
        col += (i) * m;
        cout << col << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//   cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}