#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
struct node {
    ll sum = 0;
    int suma = 0;
    ll op1 = 0;
    int op2 = 0;
    ll op3 = 0;
    ll len = 1;


    void mna(int d) {
        suma -= d;
        op2 += d;
    }

    void minus(ll x) {
        sum -= len * x;
        op3 += x;
    }

    void add(ll f) {
        sum += f * suma;
        op3 += op2 * f;
        op1 += f;
    }

    node operator+(node b) const {
        return {sum + b.sum, suma + b.suma, 0, 0, 0, len + b.len};
    }
};
node tr[200000];
struct segtree {
    int sz = 1;

    void push(int v){
        tr[2 * v + 1].add(tr[v].op1);
        tr[2 * v + 1].mna(tr[v].op2);
        tr[2 * v + 1].minus(tr[v].op3);
        tr[2 * v + 2].add(tr[v].op1);
        tr[2 * v + 2].mna(tr[v].op2);
        tr[2 * v + 2].minus(tr[v].op3);
        tr[v].op1 = 0;
        tr[v].op2 = 0;
        tr[v].op3 = 0;
    }

    void rec(int v){
        tr[v].sum = tr[2 * v + 1].sum + tr[2 * v + 2].sum;
        tr[v].suma = tr[2 * v + 1].suma + tr[2 * v + 2].suma;
    }
    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        for (int v = sz - 1; v < 2 * sz - 1; v++) {
            tr[v] = {0, v - (sz - 1) + 1, 0, 0, 0, 1};
        }
        for (int v = sz - 2; v > -1; v--) {
            tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
        }
    }

    void ch1(int v, int l, int r, int lseg, int rseg, ll x) {
        if (lseg <= l && r <= rseg){
            tr[v].add(x);
            return;
        }
        if (rseg <= l || r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch1(2 * v + 1, l, mid, lseg, rseg, x);
        ch1(2 * v + 2, mid, r, lseg, rseg, x);
        rec(v);
    }

    void ch1(int lseg, int rseg, ll x){
        ch1(0, 0, sz, lseg, rseg, x);
    }


    void ch2(int v, int l, int r, int lseg, int rseg){
        if (lseg <= l && r <= rseg){
            tr[v].mna(1);
            return;
        }
        if (rseg <= l || r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch2(2 * v + 1, l, mid, lseg, rseg);
        ch2(2 * v + 2, mid, r, lseg, rseg);
        rec(v);
    }

    void ch2(int lseg, int rseg){
        ch2(0, 0, sz, lseg, rseg);
    }

    void ans(){
        for (int i = 0; i < sz - 1; i++){
            push(i);
        }
    }
};


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    vector<pair<int, int>> d;
    int pred = 0;
    for (int i = 0; i < m; i++) {
        int delta = s[i] - pred;
        if (!d.empty() && d.back().first >= delta) {
            d.back().second++;
        } else {
            d.push_back({delta, 1});
        }
        pred = s[i];
    }
    segtree mach(n);
    set<pair<ll, int>> had;
    for (int i = 0; i< n; i++){
        had.insert({d[0].first * t[i], i});
    }
    vector<int> yk(n, 0);
    vector<bool> used(n, false);
    vector<int> col(n, 0);
    vector<int> ops;
    ops.reserve(n);
    while (!had.empty()){
        int j = had.begin()->second;
        had.erase(had.begin());
        if (!used[j]){
            used[j] = true;
            ops.push_back(j);
        }
        col[j] += d[yk[j]].second;
        yk[j]++;
        if (yk[j] != d.size()){
            had.insert({d[yk[j]].first * t[j], j});
        }
        else {
            for (auto el : ops){
                mach.ch1(el, mach.sz, col[el]);
                col[el] = 0;
                used[el] = false;
            }
            ops.clear();
            mach.ch2(j , mach.sz);
        }
    }
    mach.ans();
    for (int i = 0; i < n; i++){
        cout << tr[i + mach.sz - 1].sum - (i + 1) * m << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//   cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}