#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
ll tr[400000][6];
struct segtree {

    static void mna(int v, ll d){
        tr[v][1] -= d;
        tr[v][3]  += d;
    }

    static void minus(int v, ll x){
        tr[v][0] -= x * tr[v][5];
        tr[v][4] += x;
    }

    static void add(int v, ll f){
        tr[v][0] += f * tr[v][1];
        tr[v][4] += tr[v][3] * f;
        tr[v][2] += f;
    }
    int sz = 1;

    static void push(int v){
        add(2 * v + 1, tr[v][2]);
        mna(2 * v + 1, tr[v][3]);
        minus(2 * v + 1, tr[v][4]);
        add(2 * v + 2, tr[v][2]);
        mna(2 * v + 2, tr[v][3]);
        minus(2 * v + 2, tr[v][4]);
        tr[v][2] = tr[v][3] = tr[v][4] =  0;
    }

    static void rec(int v){
        tr[v][0] = tr[2 * v + 1][0] + tr[2 * v + 2][0];
        tr[v][1] = tr[2 * v + 1][1] + tr[2 * v + 2][1];
    }
    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        for (int v = sz - 1; v < 2 * sz - 1; v++) {
            tr[v][1]= v - (sz - 1) + 1;
            tr[v][5] = 1 ;
        }
        for (int v = sz - 2; v > -1; v--) {
            rec(v);
            tr[v][5] = tr[2 * v + 1][5] + tr[2 * v + 2][5];
        }
    }

    void ch1(int v, int l, int r, int lseg, int rseg, ll x) {
        if (lseg <= l && r <= rseg){
            add(v, x);
            return;
        }
        if (rseg <= l || r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch1(2 * v + 1, l, mid, lseg, rseg, x);
        ch1(2 * v + 2, mid, r, lseg, rseg, x);
        rec(v);
    }

    void ch1(int lseg, int rseg, ll x){
        ch1(0, 0, sz, lseg, rseg, x);
    }


    void ch2(int v, int l, int r, int lseg, int rseg){
        if (lseg <= l && r <= rseg){
            mna(v, 1);
            return;
        }
        if (rseg <= l || r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch2(2 * v + 1, l, mid, lseg, rseg);
        ch2(2 * v + 2, mid, r, lseg, rseg);
        rec(v);
    }

    void ch2(int lseg, int rseg){
        ch2(0, 0, sz, lseg, rseg);
    }

    void ans(){
        for (int i = 0; i < sz - 1; i++){
            push(i);
        }
    }
};

bool comp(ll a, ll b){
    if (min(a, b) <= 1e9){
        return a < b;
    }
    return ld(b) / ld(a) >= 1.05;

}


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    vector<ll> one;
    vector<ll> two;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
        if (t[i] == 1){
            one.push_back(i);
        }
        else{
            two.push_back(i);
        }
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    vector<pair<int, int>> d;
    int pred = 0;
    for (int i = 0; i < m; i++) {
        int delta = s[i] - pred;
        if (!d.empty() && !comp(d.back().first, delta)) {
            d.back().second++;
        } else {
            d.emplace_back(delta, 1);
        }
        pred = s[i];
    }
    segtree mach(n);
    vector<int> yk(n, 0);
    vector<bool> used(n, false);
    vector<int> col(n, 0);
    vector<int> ops;
    ops.reserve(n);
    ll yk1 = 0;
    ll yk2 = 0;
    while (true){
        pair<ll,ll> a1 = {1e17, -1};
        pair<ll,ll> b1 = {1e17, -1};
        pair<ll, ll > sp;
        bool good = false;
        if (!one.empty() && d.size() != yk1 / one.size()){
            good = true;
            a1 = {d[yk1 / one.size()].first, one[yk1 % one.size()]};
        }
        if (!two.empty() && d.size() != yk2 / two.size()){
            good = true;
            b1 = {2 * d[yk2 / two.size()].first, two[yk2 % two.size()]};
        }
        if (!good){
            break;
        }
        if (a1 < b1){
            sp = {yk1 / one.size(), one[yk1 % one.size()]};
            yk1++;
        }
        else{
            sp = {yk2 / two.size(), two[yk2 % two.size()]};
            yk2++;
        }
        if (!used[sp.second]){
            used[sp.second] = true;
            ops.push_back(sp.second);
        }
        col[sp.second] += d[sp.first].second;
        if (d[sp.first].first == d.back().first) {
            for (auto el : ops){
                mach.ch1(el, mach.sz, col[el]);
                col[el] = 0;
                used[el] = false;
            }
            ops.clear();
            mach.ch2(sp.second , mach.sz);
        }
    }
    mach.ans();
    for (int i = 0; i < n; i++){
        cout << tr[i + mach.sz - 1][0] - (i + 1) * m << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//   cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}