#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
ll tr[400000][6];
struct segtree {

    static void mna(const int v, const ll d){
        tr[v][1] -= d;
        tr[v][3]  += d;
    }

    static void minus(const int v, const ll x){
        tr[v][0] -= x * tr[v][5];
        tr[v][4] += x;
    }

    static void add(const int v, const ll f){
        tr[v][0] += f * tr[v][1];
        tr[v][4] += tr[v][3] * f;
        tr[v][2] += f;
    }
    int sz = 1;

    static void push(const int v){
        add(2 * v + 1, tr[v][2]);
        mna(2 * v + 1, tr[v][3]);
        minus(2 * v + 1, tr[v][4]);
        add(2 * v + 2, tr[v][2]);
        mna(2 * v + 2, tr[v][3]);
        minus(2 * v + 2, tr[v][4]);
        tr[v][2] = tr[v][3] = tr[v][4] =  0;
    }

    static void rec(const int v){
        tr[v][0] = tr[2 * v + 1][0] + tr[2 * v + 2][0];
        tr[v][1] = tr[2 * v + 1][1] + tr[2 * v + 2][1];
    }
    segtree(ll n) {
        while (sz < n) {
            sz *= 2;
        }
        for (int v = sz - 1; v < 2 * sz - 1; v++) {
            tr[v][1]= v - (sz - 1) + 1;
            tr[v][5] = 1 ;
        }
        for (int v = sz - 2; v > -1; v--) {
            rec(v);
            tr[v][5] = tr[2 * v + 1][5] + tr[2 * v + 2][5];
        }
    }

    void ch1(int v, int l, int r,const  int lseg, const ll x) {
        if (lseg <= l){
            add(v, x);
            return;
        }
        if (r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch1(2 * v + 1, l, mid, lseg, x);
        ch1(2 * v + 2, mid, r, lseg, x);
        rec(v);
    }

    void ch1(const int lseg, const ll x){
        ch1(0, 0, sz, lseg, x);
    }


    void ch2(int v, int l, int r, int lseg){
        if (lseg <= l){
            mna(v, 1);
            return;
        }
        if (r <= lseg){
            return;
        }
        push(v);
        int mid = (r + l) / 2;
        ch2(2 * v + 1, l, mid, lseg);
        ch2(2 * v + 2, mid, r, lseg);
        rec(v);
    }

    void ch2(int lseg){
        ch2(0, 0, sz, lseg);
    }

    void ans(){
        for (int i = 0; i < sz - 1; i++){
            push(i);
        }
    }
};

bool comp(ll a, ll b){
    if (min(a, b) <= 1e9){
        return a < b;
    }
    return ld(b) / ld(a) >= 1.05;

}


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    vector<pair<int, int>> d;
    int pred = 0;
    for (int i = 0; i < m; i++) {
        int delta = s[i] - pred;
        if (!d.empty() && !comp(d.back().first, delta)) {
            d.back().second++;
        } else {
            d.emplace_back(delta, 1);
        }
        pred = s[i];
    }
    segtree mach(n);
    set<pair<ll, int>> had;
    for (int i = 0; i< n; i++){
        had.insert({d[0].first * t[i], i});
    }
    vector<int> yk(n, 0);
    vector<bool> used(n, false);
    vector<int> col(n, 0);
    vector<int> ops;
    ops.reserve(n);
    while (!had.empty()){
        int j = had.begin()->second;
        had.erase(had.begin());
        if (!used[j]){
            used[j] = true;
            ops.push_back(j);
        }
        col[j] += d[yk[j]].second;
        yk[j]++;
        if (yk[j] != d.size()){
            had.insert({d[yk[j]].first * t[j], j});
        }
        else {
            for (auto el : ops){
                mach.ch1(el, col[el]);
                col[el] = 0;
                used[el] = false;
            }
            ops.clear();
            mach.ch2(j);
        }
    }
    mach.ans();
    for (int i = 0; i < n; i++){
        cout << tr[i + mach.sz - 1][0] - (i + 1) * m << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//   cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}