#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
ll tr[200000][6];

static void mna(const int v, const ll d){
    tr[v][1] -= d;
    tr[v][3]  += d;
}

static void myadd(const int v, const ll x){
    tr[v][0] -= x * tr[v][5];
    tr[v][4] += x;
}

static void add(const int v, const ll f){
    tr[v][0] += f * tr[v][1];
    tr[v][4] += tr[v][3] * f;
    tr[v][2] += f;
}
static void sigma(const int v, const ll f, const ll x, const ll d){
    tr[v][0] += f * tr[v][1];
    tr[v][4] += tr[v][3] * f;
    tr[v][2] += f;
    tr[v][1] -= d;
    tr[v][3]  += d;
    tr[v][0] -= x * tr[v][5];
    tr[v][4] += x;
}

int sz = 1;

static void push(const int v){
    sigma(2 * v + 1, tr[v][2], tr[v][4], tr[v][3]);
    sigma(2 * v + 2, tr[v][2], tr[v][4], tr[v][3]);
    tr[v][2] = tr[v][3] = tr[v][4] =  0;
}

static void rec(const int v){
    tr[v][0] = tr[2 * v + 1][0] + tr[2 * v + 2][0];
    tr[v][1] = tr[2 * v + 1][1] + tr[2 * v + 2][1];
}
void init(ll n) {
    while (sz < n) {
        sz *= 2;
    }
    for (int v = sz - 1; v < 2 * sz - 1; v++) {
        tr[v][1]= v - (sz - 1) + 1;
        tr[v][5] = 1 ;
    }
    for (int v = sz - 2; v > -1; v--) {
        rec(v);
        tr[v][5] = tr[2 * v + 1][5] + tr[2 * v + 2][5];
    }
}

void ch1(int v, int l, int r,const  int lseg, const ll x) {
    if (lseg <= l){
        add(v, x);
        return;
    }
    if (r <= lseg){
        return;
    }
    push(v);
    int mid = (r + l) / 2;
    if (lseg < mid) {
        add(2 * v + 2, x);
        ch1(2 * v + 1, l, mid, lseg, x);
    }
    else {
        ch1(2 * v + 2, mid, r, lseg, x);
    }
    rec(v);
}

void ch1(const int lseg, const ll x){
    int v = 0;
    int l = 0;
    int r = sz;
    while (true){
        if (lseg <= l){
            add(v, x);
            break;
        }
        push(v);
        int mid = (r + l) / 2;
        if (lseg < mid) {
            add(2 * v + 2, x);
            v = 2 * v + 1;
            r = mid;
        }
        else {
            v = 2 * v + 2;
            l = mid;
        }
    }
    while (v != 0){
        v = (v - 1) / 2;
        rec(v);
    }
}

void ch2(int lseg){
    int v = 0;
    int l = 0;
    int r = sz;
    while (true){
        if (lseg <= l){
            mna(v, 1);
            break;
        }
        push(v);
        int mid = (r + l) / 2;
        if (lseg < mid) {
            mna(2 * v + 2, 1);
            v = 2 * v + 1;
            r = mid;
        }
        else {
            v = 2 * v + 2;
            l = mid;
        }
    }
    while (v != 0){
        v = (v - 1) / 2;
        rec(v);
    }
}

void ans(){
    for (int i = 0; i < sz - 1; i++){
        push(i);
    }
}


bool comp(ll a, ll b){
    if (min(a, b) <= 1e9){
        return a < b;
    }
    return ld(b) / ld(a) >= 1.05;

}


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    vector<pair<int, int>> d;
    int pred = 0;
    for (int i = 0; i < m; i++) {
        int delta = s[i] - pred;
        if (!d.empty() && !comp(d.back().first, delta)) {
            d.back().second++;
        } else {
            d.emplace_back(delta, 1);
        }
        pred = s[i];
    }
    init(n);
    set<pair<ll, int>> had;
    for (int i = 0; i< n; i++){
        had.insert({d[0].first * t[i], i});
    }
    vector<int> yk(n, 0);
    vector<bool> used(n, false);
    vector<int> col(n, 0);
    vector<int> ops;
    ops.reserve(n);
    while (!had.empty()){
        int j = had.begin()->second;
        had.erase(had.begin());
        if (!used[j]){
            used[j] = true;
            ops.push_back(j);
        }
        col[j] += d[yk[j]].second;
        yk[j]++;
        if (yk[j] != d.size()){
            had.insert({d[yk[j]].first * t[j], j});
        }
        else {
            for (auto el : ops){
                ch1(el, col[el]);
                col[el] = 0;
                used[el] = false;
            }
            ops.clear();
            ch2(j);
        }
    }
    ans();
    for (int i = 0; i < n; i++){
        cout << tr[i + sz - 1][0] - (i + 1) * m << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//   cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}