#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
const int INF = 1e9;

struct edge {
	int a, b, c;
};
struct elem {
	int u, x;
};

vector<vector<pair<int, int>>> g;
vector<int> cur, d;
vector<elem> ans;

void dfs(int u, int p) {
	for (auto el : g[u]) {
		int v = el.first;
		if (v == p) continue;
		dfs(v, u);
	}
	for (auto el : g[u]) {
		int v = el.first, c = el.second;
		if (v == p) continue;
		if (c == 1) {
			if (cur[u] != 1) {
				ans.push_back({ u, 1 });
				cur[u] = 1;
			}
			if (cur[v] != 1) {
				ans.push_back({ v, 1 });
				cur[v] = 1;
			}
		}
	}
	if (d[u] == 0 && cur[u] != 0) {
		ans.push_back({ u, 0 });
		cur[u] = 0;
	}
	else if (d[u] == 1 && cur[u] != 1) {
		ans.push_back({ u, 1 });
		cur[u] = 1;
	}
	
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t; cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n, m;
		cin >> n >> m;
		vector<edge> mas(m);
		g.resize(n);
		for (int i = 0; i < m; ++i) {
			cin >> mas[i].a >> mas[i].b >> mas[i].c;
			mas[i].a--; mas[i].b--;
			g[mas[i].a].push_back({ mas[i].b, mas[i].c });
			g[mas[i].b].push_back({ mas[i].a, mas[i].c });
		}
		d.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> d[i];
		}
		bool flag = true;
		for (int i = 0; i < m; ++i) {
			int a = mas[i].a, b = mas[i].b;
			if (d[a] == 1 && d[b] == 1 && mas[i].c != 1) {
				flag = false;
				break;
			}
			if (d[a] == 0 && d[b] == 0 && mas[i].c != 0) {
				flag = false;
				break;
			}
		}
		if (!flag) {
			cout << "NO\n";
		}
		else {
			cout << "YES\n";
			cur.resize(n, 0);
			dfs(0, -1);
			cout << ans.size() << "\n";
			for (auto el : ans) {
				cout << el.u + 1 << " " << el.x << "\n";
			}
		}
		g.clear();
		cur.clear();
		ans.clear();
		d.clear();
	}

	return 0;
}