#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<tuple<int, int, int>> edges;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int x, y, z;
    cin >> x >> y >> z;
    --x; --y;
    edges.emplace_back(x, y, z);
    g[x].emplace_back(y, z);
    g[y].emplace_back(x, z);
  }
  vector<int> d(n);
  for (int i = 0; i < n; ++i) {
    cin >> d[i];
  }
  bool ok = true;
  for (auto [x, y, z] : edges) {
    if (z == 0 && d[x] == 1 && d[y] == 1) {
      ok = false;
    }
    if (z == 1 && d[x] == 0 && d[y] == 0) {
      ok = false;
    }
  }
  if (!ok) {
    cout << "NO\n";
    return;
  }
  vector<pair<int, int>> tot_res;
  vector<pair<int, int>> res;
  vector<pair<int, int>> after;
  set<pair<int, int>> vis;
  vector<int> used(n);
  function<void(int, int, int)> Dfs = [&](int v, int pr, int col) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
      if (!used[u] && vis.find(make_pair(min(u, v), max(u, v))) == vis.end()) {
        vis.emplace(min(u, v), max(u, v));
        Dfs(u, v, w);
      }
    }
    if (v == pr) {
      res.emplace_back(v, d[v]);
      return;
    }
    if (d[v] == col) {
      if (d[v] == 1) {
        res.emplace_back(v, 1);
        res.emplace_back(pr, 1);
      } else {
        res.emplace_back(v, 0);
        res.emplace_back(pr, 0);
      }
    } else {
      if (d[v] == 0) {
        res.emplace_back(v, 1);
        res.emplace_back(pr, 1);
        after.emplace_back(v, 0);
      } else {
        res.emplace_back(v, 0);
        res.emplace_back(pr, 0);
        after.emplace_back(v, 1);
      }
    }
  };
  for (auto [x, y, z] : edges) {
    if (vis.find(make_pair(min(x, y), max(x, y))) == vis.end()) {
      used.assign(n, 0);
      res.clear();
      after.clear();
      Dfs(x, x, 0);
      //cerr << x << endl;
      reverse(after.begin(), after.end());
      for (auto [a1, a2] : res) tot_res.emplace_back(a1, a2);
      for (auto [a1, a2] : after) tot_res.emplace_back(a1, a2);
    }
  }
  for (int v = 0; v < n; ++v) {
    if (g[v].empty()) {
      tot_res.emplace_back(v, d[v]);
    }
  }
  /*reverse(after.begin(), after.end());
  for (auto [v, col] : after) {
    res.emplace_back(v, col);
  }*/
  swap(res, tot_res);
  ok = true;
  map<pair<int, int>, int> mp;
  vector<int> ff(n);
  for (auto [v, col] : res) {
    ff[v] = col;
    for (auto [u, w] : g[v]) {
      if (ff[v] == ff[u]) {
        mp[{min(u, v), max(u, v)}] = ff[v];
      }
    }
  }
  for (auto [x, y, z] : edges) {
    int cur_col = mp[{min(x, y), max(x, y)}];
    if (cur_col != z) {
      ok = false;
      break;
    }
  }
  if (!ok) {
    cout << "NO\n";
    return;
  }
  cout << "YES\n";
  cout << res.size() << '\n';
  for (auto [x, y] : res) {
    cout << x + 1 << ' ' << y << '\n';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}