#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<tuple<int, int, int>> edges;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int x, y, z;
    cin >> x >> y >> z;
    --x; --y;
    edges.emplace_back(x, y, z);
    g[x].emplace_back(y, z);
    g[y].emplace_back(x, z);
  }
  vector<int> d(n);
  for (int i = 0; i < n; ++i) {
    cin >> d[i];
  }
  for (auto [x, y, z] : edges) {
    if (d[x] == d[y] && z != d[x]) {
      cout << "NO\n";
      return;
    }
  }
  vector<int> used(n);
  vector<pair<int, int>> res;
  vector<pair<int, int>> after;
  function<void(int, int, int)> Dfs = [&](int v, int pr, int col) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
      if (used[u]) {
        continue;
      }
      Dfs(u, v, w);
    }
    if (v == pr) {
      res.emplace_back(v, d[v]);
      return;
    }
    if (d[v] == col) {
      if (d[v] == 1) {
        res.emplace_back(v, 1);
        res.emplace_back(pr, 1);
      } else {
        res.emplace_back(v, 0);
        res.emplace_back(pr, 0);
      }
    } else {
      if (d[v] == 0) {
        res.emplace_back(v, 1);
        res.emplace_back(pr, 1);
        after.emplace_back(v, 0);
      } else {
        res.emplace_back(v, 0);
        res.emplace_back(pr, 0);
        after.emplace_back(v, 1);
      }
    }
  };
  Dfs(0, 0, 0);
  reverse(after.begin(), after.end());
  for (auto [v, col] : after) {
    res.emplace_back(v, col);
  }
  cout << "YES\n";
  cout << res.size() << '\n';
  for (auto [x, y] : res) {
    cout << x + 1 << ' ' << y << '\n';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}