#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<tuple<int, int, int>> edges;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int x, y, z;
    cin >> x >> y >> z;
    --x; --y;
    edges.emplace_back(x, y, z);
    g[x].emplace_back(y, z);
    g[y].emplace_back(x, z);
  }
  vector<int> d(n);
  for (int i = 0; i < n; ++i) {
    cin >> d[i];
  }
  for (auto [x, y, z] : edges) {
    if (d[x] == d[y] && z != d[x]) {
      cout << "NO\n";
      return;
    }
  }
  vector<int> used(n);
  vector<pair<int, int>> res;
  vector<pair<int, int>> after;
  set<pair<int, int>> done;
  vector<int> f(n);
  vector<vector<pair<int, int>>> at(n);
  for (int v = 0; v < n; ++v) {
    at[v].emplace_back(0, -1);
  }
  int ptr = 0;
  auto Paint = [&](int v, int col) {
    if (f[v] == col) return;
    res.emplace_back(v, col);
    at[v].emplace_back(col, ptr++);
    f[v] = col;
  };
  function<void(int, int, int)> Dfs = [&](int v, int pr, int col) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
      if (used[u]) {
        continue;
      }
      done.emplace(u, v);
      done.emplace(v, u);
      Dfs(u, v, w);
    }
    if (v == pr) {
      Paint(v, d[v]);
      return;
    }
    if (d[v] == col) {
      if (d[v] == 1) {
        Paint(v, 1);
        Paint(pr, 1);
      } else {
        Paint(v, 0);
        Paint(pr, 0);
      }
    } else {
      if (d[v] == 0) {
        Paint(v, 1);
        Paint(pr, 1);
        after.emplace_back(v, 0);
      } else {
        Paint(v, 0);
        Paint(pr, 0);
        after.emplace_back(v, 1);
      }
    }
  };
  for (int v = 0; v < n; ++v) {
    if (!used[v]) {
      Dfs(v, v, -1);
    }
  }
  reverse(after.begin(), after.end());
  for (auto [v, col] : after) {
    Paint(v, col);
  }
  map<pair<int, int>, int> mp;
  for (auto [x, y, z] : edges) {
    mp[{x, y}] = z;
    mp[{y, x}] = z;
  }
  for (auto [x, y, z] : edges) {
    if (done.find({x, y}) == done.end()) {
      int cur = -1;
      if (at[x].back().first == at[y].back().first) {
        cur = at[x].back().first;
      } else {
        if (at[x].back().second > at[y].back().second) {
          cur = at[y].back().first;
        } else {
          cur = at[x].back().first;
        }
      }
      if (cur != z) {
        if (f[x] != z && f[y] != z) {
          cout << "NO1\n";
          return;
        }
        if (f[x] != z) {

          Paint(x, z);
          Paint(x, z ^ 1);
        }
        if (f[y] != z) {

          Paint(y, z);
          Paint(y, z ^ 1);
        }
      }
      done.emplace(x, y);
      done.emplace(y, x);
    }
  }
  mp.clear();
  vector<int> ff(n);
  for (auto [v, col] : res) {
    ff[v] = col;
    for (auto [u, w] : g[v]) {
      if (ff[v] == ff[u]) {
        mp[{min(u, v), max(u, v)}] = ff[v];
      }
    }
  }
  for (auto [x, y, z] : edges) {
    int cur_col = mp[{min(x, y), max(x, y)}];
    if (cur_col != z) {
      cout << "NO\n";
      return;
    }
  }
  cout << "YES\n";
  cout << res.size() << '\n';
  for (auto [x, y] : res) {
    cout << x + 1 << ' ' << y << '\n';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}