#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<tuple<int, int, int>> edges;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int x, y, z;
    cin >> x >> y >> z;
    --x; --y;
    edges.emplace_back(x, y, z);
    g[x].emplace_back(y, z);
    g[y].emplace_back(x, z);
  }
  vector<int> d(n);
  for (int i = 0; i < n; ++i) {
    cin >> d[i];
  }
  bool ok = true;
  for (auto [x, y, z] : edges) {
    if (z == 0 && d[x] == 1 && d[y] == 1) {
      ok = false;
    }
    if (z == 1 && d[x] == 0 && d[y] == 0) {
      ok = false;
    }
  }
  bool cycle = false;
  vector<int> used(n);
  vector<int> col_from(n, -1);
  function<void(int, int, int)> Dfs = [&](int v, int pr, int col) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
      if (w == col || u == pr) {
        continue;
      }
      if (used[u] && col_from[u] != w) {
        cycle = true;
      } else {
        col_from[v] = w;
        Dfs(u, v, w);
      }
    }
  };
  for (int v = 0; v < n; ++v) {
    if (!used[v]) {
      Dfs(v, v, -1);
    }
  }
  if (ok && !cycle) {
    cout << "YES\n-1\n";
  } else {
    cout << "NO\n";
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}