#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define ull unsigned long long
#define _ <<" "<<

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct segtree {
    int n, N;
    vector<ll> t, lazy;

    segtree(int n) : n(n) {
        N = 1 << (__lg(n - 1) + 1);
        t.resize(2 * N - 1);
        lazy.resize(2 * N - 1, -1);
    }

    void push(int v) {
        if (lazy[v] == -1) return;
        t[v] = lazy[v];
        if (v * 2 + 2 < lazy.size()) {
            lazy[v * 2 + 1] = lazy[v];
            lazy[v * 2 + 2] = lazy[v];
        }
        lazy[v] = -1;
    }

    void update(int v, int l, int r, int ql, int qr, ll val) {
        push(v);
        if (r <= ql || qr <= l) return;
        if (ql <= l && r <= qr) {
            lazy[v] = val;
            push(v);
            return;
        }
        int m = (l + r) / 2;
        update(v * 2 + 1, l, m, ql, qr, val);
        update(v * 2 + 2, m, r, ql, qr, val);
    }

    void update(int l, int r, ll val) {
        update(0, 0, N, l, r + 1, val);
    }

    ll get(int v, int l, int r, int pos) {
        push(v);
        if (r - l == 1) return t[v];
        int m = (l + r) / 2;
        if (pos < m) return get(v * 2 + 1, l, m, pos);
        return get(v * 2 + 2, m, r, pos);
    }

    ll get(int pos) {
        return get(0, 0, N, pos);
    }
};

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n), R(n), L(n);
    forn(i, n) cin >> a[i];

    segtree cnt(n);

    vector<pair<int, int>> events;
    forn(i, n) events.emplace_back(i, n), events.emplace_back(max(0, i - a[i]), min(n - 1, i + a[i]));
    sort(all(events));

    auto calc = [&](int pos) -> ll {
        if (pos != -1) {
//            swap(a[pos], x);
            int it = lower_bound(all(events), make_pair(max(0, pos - a[pos]), min(n - 1, pos + a[pos]))) -
                     events.begin();
            events[it] = {max(0, pos - x), min(n - 1, pos + x)};
            while (it > 0 && events[it] < events[it - 1]) swap(events[it], events[it - 1]), it--;
            while (it < n - 1 && events[it] > events[it + 1]) swap(events[it], events[it + 1]), it++;
        }

        int mx = 0;
        for (auto [i, r]: events) {
            if (r == n) R[i] = mx;
            else mx = max(mx, r);
        }

        ll res = 0;
        cnt.update(n - 1, n - 1, 0);
        for (int i = n - 2; i >= 0; i--) {
            int l = 0, r = i + 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (R[i - mid] == R[i]) l = mid;
                else r = mid;
            }

            ll c1;
            if (R[i] < n - 1) {
                c1 = cnt.get(R[i] + 1) + n - R[i] - 1;
            } else c1 = 0;
            cnt.update(i - l, i, c1);
            res += c1 * (l + 1);
            i -= l;
        }

        if (pos != -1) {
//            swap(a[pos], x);
            int it = lower_bound(all(events), make_pair(max(0, pos - x), min(n - 1, pos + x))) - events.begin();
            events[it] = {max(0, pos - a[pos]), min(n - 1, pos + a[pos])};
            while (it > 0 && events[it] < events[it - 1]) swap(events[it], events[it - 1]), it--;
            while (it < n - 1 && events[it] > events[it + 1]) swap(events[it], events[it + 1]), it++;
        }

//        forn(i, n) cerr << cnt.get(i) << " \n"[i == n - 1];
        return res;
    };

    if (*max_element(all(a)) == 0) {
        cout << calc(n / 2) << nl;
        return;
    }

    ll ans = calc(-1);
    if (x) {
        forn(sw, n) {
//        for(int sw = max(0, n / 2 - 100); sw < min(n - 1, n / 2 + 100); sw++) {
            if (a[sw] < x) ans = min(ans, calc(sw));
        }
    }
    cout << ans << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\untitled\\out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
//    cin >> t;
    while (t--) solve();
}