#include <bits/stdc++.h>

#pragma GCC optimize("02,03,Ofast,inline,unroll-loops")
#pragma GCC target("avx,sse,sse2,ssse3,sse4")

void speedInput() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
}

class Edge {
public:
    int from, to, color;
};
class Quest {
 public:
    int id, val;
};

std::vector <Quest> quests;

void solveB() {
    int t;
    std::cin >> t;

    while (t--) {
        quests.clear();

        int n, m;
        std::cin >> n >> m;

        std::vector <std::vector <Edge>> edges(n);
        for (int i = 0; i < m; i++) {
            int from, to, color;
            std::cin >> from >> to >> color;

            from--; to--;

            edges[from].push_back({from, to, color});
            edges[to].push_back({to, from, color});
        }

        std::vector <int> color(n);
        for (int i = 0; i < n; i++) {
            std::cin >> color[i];
        }

        for (int i = 0; i < n; i++) {
            quests.push_back({i + 1, 1});
        }
        for (int i = 0; i < n; i++) {
            quests.push_back({i + 1, color[i]});
        }



        bool check = true;
        for (int i = 0; i < n; i++) {
            for (auto j : edges[i]) {
                if (color[j.from] == 0 && color[j.to] == 0) {
                    check = false;
                }
            }
        }

        if (check) {
            std::cout << "YES" << '\n';
            std::cout << quests.size() << '\n';
            for (auto i : quests) {
                std::cout << i.id << ' ' << i.val << '\n';
            }
        } else {
            std::cout << "NO" << '\n';
        }
    }
}

class Seg {
 public:
   int l, r, i;
   bool operator < (const Seg& other) const {
       if (r == other.r) {
           return l < other.l;
       } return r < other.r;
   }
};

void solveD() {
    int n, x;
    std::cin >> n >> x;

    std::vector <int> array(n);
    for (int i = 0; i < n; i++) {
        std::cin >> array[i];
    }

    long long resG = LLONG_MAX;
    
    std::vector <Seg> segments;
    for (int i = 1; i <= n; i++) {
        segments.push_back({std::max(1, i - array[i - 1]), std::min(n, i + array[i - 1])});
    }

    std::vector <int> city(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (segments[j].l <= i + 1 && i + 1 <= segments[j].r) {
                city[i] = std::max(city[i], segments[j].r - 1);
            }
        }
    }

    long long res = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int cur = city[i];
            int cnt = 0;
            while (cur < j) {
                cnt++;
                cur = city[cur + 1];
            }
            res += cnt;
        }
    }

    resG = std::min(res, resG);

    std::cout << resG;
}

signed main() {
    speedInput();

    solveD();

    return 0;
}
