#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5;
vector<int> in_out[MAXN];
int used[MAXN];
int n, m;

bool find_cycle(int v) {
    if (used[v] == 1) {
        return true;
    }
    used[v] = 1;

    bool flag = false;
    for (auto i : in_out[v]) {
        flag |= find_cycle(i);
    }
    used[v] = 2;
    return flag;
}

void chist() {
    for (int i = 0; i < 2 * n; ++i) {
        in_out[i].clear();
        used[i] = 0;
    }
}

void solve() {
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;

        --a, --b;

        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    vector<int> by_camp(n);
    for (int i = 0; i < n; ++i) cin >> by_camp[i];

    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (by_camp[i] == by_camp[j.first] && by_camp[i] != j.second) {
                cout << "NO\n";
                return;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (i > j.first) continue;
            if (by_camp[i] != by_camp[j.first]) {
                int ed, nol;
                if (by_camp[i] == 1) {
                    ed = i;
                    nol = j.first;
                }
                else {
                    ed = j.first;
                    nol = i;
                }

                if (j.second == 1) {
                    in_out[ed].push_back(nol + n);
                }
                else {
                    in_out[nol + n].push_back(ed);
                }
            }
        }
    }

    bool cycle = false;
    for (int i = 0; i < 2 * n; ++i) {
        if (used[i] == 0) {
            cycle |= find_cycle(i);
        }
    }

    if (cycle) {
        cout << "NO\n";
        chist();
        return;
    }

    cout << "YES\n";
    cout << "-1\n";
    chist();
}

int main() {
    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}
