#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(time(0));

#define all(x) x.begin(), x.end()

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

const int MAXN = 4e5;
vector<int> in_out[MAXN];
int used[MAXN];
int n, m;

bool find_cycle(int v) {
    if (used[v] == 1) {
        return true;
    }
    used[v] = 1;

    for (auto i : in_out[v]) {
        if (used[i] != 2 && find_cycle(i)) return true;
    }
    used[v] = 2;
    return false;
}

vector<int> ans;

void chist() {
    ans.clear();
    for (int i = 0; i < 2 * n; ++i) {
        in_out[i].clear();
        used[i] = 0;
    }
}

void top_sort(int v) {
    used[v] = 1;

    for (auto i : in_out[v]) {
        if (used[i] == 0) top_sort(i);
    }
    ans.push_back(v);
}

void solve() {
    cin >> n >> m;

    bool all_c_one = true;

    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int a = 1, b = i + 2, c = rnd() % 2;
        cin >> a >> b >> c;

        if (c != 1) {
            all_c_one = false;
        }

        --a, --b;

        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    vector<int> by_camp(n);
    for (int i = 0; i < n; ++i) {
        cin >> by_camp[i];
//        by_camp[i] = rnd() % 2;
    }

    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (by_camp[i] == by_camp[j.first] && by_camp[i] != j.second) {
                cout << "NO\n";
                return;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (i > j.first) continue;
            if (by_camp[i] != by_camp[j.first]) {
                int ed, nol;
                if (by_camp[i] == 1) {
                    ed = i;
                    nol = j.first;
                }
                else {
                    ed = j.first;
                    nol = i;
                }

                if (j.second == 1) {
                    in_out[ed].push_back(nol + n);
                }
                else {
                    in_out[nol + n].push_back(ed);
                }
            }
        }
    }

    bool cycle = false;
    for (int i = 0; i < 2 * n; ++i) {
        if (used[i] == 0) {
            cycle |= find_cycle(i);
            if (cycle) break;
        }
    }

    if (cycle) {
        cout << "NO\n";
        chist();
        return;
    }

    cout << "YES\n";
    for (int i = 0; i < n; ++i) {
        if (by_camp[i]) continue;
        in_out[i].push_back(i + n);
    }
    for (int i = 0; i < 2 * n; ++i) used[i] = 0;

    for (int i = 0; i < 2 * n; ++i) {
        if (i >= n && by_camp[i - n]) continue;
        if (used[i] == 0) top_sort(i);
    }
    reverse(all(ans));

    cout << ans.size() << '\n';
    for (auto i : ans) {
        if (i >= n) {
            cout << i - n + 1 << " 0\n";
        }
        else {
            cout << i + 1 << " 1\n";
        }
    }
    chist();
}

int main() {
    fast_stream();
    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}
