#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(time(0));

using ll = long long;
#define all(x) x.begin(), x.end()

const ll INF = (ll)1e18;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

bool cmp(const pair<ll, ll> &fir, const pair<ll, ll> &sec) {
    if (fir.first != sec.first) return fir.first > sec.first;
    return fir.second < sec.second;
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<ll> t(n);
    for (ll i = 0; i < n; ++i) cin >> t[i];

    vector<pair<ll, ll>> sort_by_t(n);
    for (ll i = 0; i < n; ++i) sort_by_t[i] = {t[i], i};
    sort(all(sort_by_t), cmp);

    bool all_t_equal = true;
    for (ll i = 1; i < n; ++i) {
        if (t[i] != t[0]) all_t_equal = false;
    }

    vector<ll> s(m + 1, 0);
    for (ll i = 0; i < m; ++i) cin >> s[i + 1];

    vector<vector<ll>> dist(n, vector<ll> (n, 0));
    vector<ll> lenn, step;
    for (ll i = 1; i <= m; ++i) {
        ll now = s[i] - s[i - 1];

        if (lenn.size() >= 1 && lenn.back() >= now) {
            step.back()++;
        }
        else {
            lenn.push_back(now);
            step.push_back(1);
        }
    }
    for (int i = 1; i < step.size(); ++i) step[i] += step[i - 1];

    for (ll i = 0; i < n - 1; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            if (sort_by_t[i].first != sort_by_t[j].first) dist[sort_by_t[i].second][sort_by_t[j].second] = m;
            else if (step.size() >= 2)                    dist[sort_by_t[i].second][sort_by_t[j].second] = step[step.size() - 2];
        }
    }

    for (ll i = 0; i < n; ++i) {
        ll ind = lenn.size() - 1;
        ll fir = sort_by_t[i].second;
        for (ll j = i - 1; j >= 0; --j) {
            ll sec = sort_by_t[j].second;
            while (ind >= 0 && lenn[ind] * t[sec] > lenn.back() * t[fir]) --ind;
            while (ind >= 0 && lenn[ind] * t[sec] == lenn.back() * t[fir] && sec > fir) --ind;
            if (ind >= 0) dist[fir][sec] = step[ind];
        }
    }

//    for (auto i : dist) {
//        for (auto j : i) {
//            cout << j << ' ';
//        }
//        cout << endl;
//    }

    for (ll k = 1; k <= n; ++k) {
        ll ans = 0;
        if (all_t_equal) {
            ans += m * (k - 1) * k / 2;
            if (step.size() >= 2) ans += step[step.size() - 2] * (k - 1) * k / 2;
            cout << ans << '\n';
            continue;
        }

        for (ll i = 0; i < k; ++i) {
            for (ll j = 0; j < k; ++j) {
                ans += dist[i][j];
            }
        }

        cout << ans << '\n';
    }
}

int main() {
    fast_stream();
    int tests = 1;
//    cin >> tests;

    while (tests--) {
        solve();
    }
}