#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif

void solve()
{
    int n;
    cin >> n;

    vector<ll> x(n);
    vector<ll> p(n);
    vector<ll> d(n);

    for (int i = 0; i < n; i++)
        cin >> x[i] >> p[i] >> d[i];

    vector<int> suf(n + 1);
    for (int i = n - 1; i >= 0; i--)
        suf[i] = suf[i + 1] + (d[i] == 1);
    
    vector<bool> suf_ok(n + 1);
    suf_ok[n] = true;
    for (int i = n - 1; i >= 1; i--)
    {
        if (p[i] < x[i] - x[i - 1])
            break;
        suf_ok[i] = true;
    }

    int ans = INT_MAX;
    int cur = 0;
    for (int i = 0; i < n - 1; i++)
    {

        if (p[i] + p[i + 1] < x[i + 1] - x[i])
            return void(cout << -1 << '\n');
        if (suf_ok[i + 1])
        {
            ans = min(ans, cur + suf[i + 1]);
        }
        else if (suf_ok[i + 2])
        {
            int v = cur + (d[i] != 1);
            if (p[i] < x[i + 1] - x[i])
                v += suf[i + 1];
            else
                v += suf[i + 2];
            ans = min(ans, v);
        }
        if (p[i] < x[i + 1] - x[i])
            break;
        cur += d[i] != 1;
    }
    if (ans == INT_MAX)
        return void(cout << -1 << '\n');
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
}