#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif

vector<vector<array<int, 2>>> old_g;
vector<vector<array<int, 2>>> g;
vector<int> light;
vector<int> color;
bool dfs(int u)
{
    color[u] = 1;
    for (auto [v, c] : g[u])
    {
        if (color[v] == 1)
            return false;
        if (color[v] == 0)
        {
            if (!dfs(v))
                return false;
        }
    }
    color[u] = 2;
    return true;
}

void solve()
{
    old_g.clear();
    g.clear();
    color.clear();
    light.clear();

    int n, m;
    cin >> n >> m;

    old_g.resize(n);
    for (int i = 0; i < m; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --b;

        old_g[a].push_back({b, c});
        old_g[b].push_back({a, c});
    }

    light.resize(n);
    for (int i = 0; i < n; i++)
        cin >> light[i];

    g.resize(n);
    for (int i = 0; i < n; i++)
    {
        for (auto [j, c] : old_g[i])
        {
            if (light[j] != light[i] && c == light[i])
                g[i].push_back({j, c});
        }
    }

    color.resize(n);
    for (int i = 0; i < n; i++)
    {
        if (color[i] == 0)
        {
            if (!dfs(i))
                return void(cout << "NO\n");
        }
    }
    cout << "YES\n";
    cout << "-1\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif

    while (t--)
        solve();
}