#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

#pragma optimize("O3")
#pragma target("avx2")

using namespace std;
typedef long long ll;

vector<vector<pair<ll, ll>>> gr;
vector<bool> used;
vector<ll> rem;
vector<pair<ll, ll>> ans;
vector<ll> inf;

ll skipv = -1, skipu = -1, skipc = -1;

void dfs(ll v) {
	used[v] = 1;
	for (auto [to, c] : gr[v]) {
		if (v == skipv && to == skipu) continue;
		if (v == skipu && to == skipv) continue;
		if (!used[to]) dfs(to);
	}
	for (auto [to, c] : gr[v]) {
		if (v == skipv && to == skipu) continue;
		if (v == skipu && to == skipv) continue;
		ans.push_back({ v, c });
		ans.push_back({ to, c });
	}
	used[v] = 2;
}

void dfs2(ll v) {
	used[v] = 1;
	ans.push_back({ v, inf[v] });
	for (auto [to, c] : gr[v]) {
		if (v == skipv && to == skipu) continue;
		if (v == skipu && to == skipv) continue;
		if (!used[to]) dfs2(to);
	}
	used[v] = 2;
}


void solve() {
	ll n, m; cin >> n >> m;
	gr.assign(n, {});
	rem.assign(n, 0);
	used.assign(n, 0);
	for (int i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c;
		a--, b--;
		gr[a].push_back({ b, c });
		gr[b].push_back({ a, c });
		rem[b]++;
	}
	inf.assign(n, 0);
	ans.assign(0, { 0, 0 });
	bool can = true;
	for (int i = 0; i < n; i++) cin >> inf[i];
	for (int v = 0; v < n; v++) {
		for (auto [to, c] : gr[v]) {
			if (c == 1 && inf[v] == 0 && inf[to] == 0) can = false;
			if (c == 0 && inf[v] == 1 && inf[to] == 1) can = false;
		}
	}
	ll cur = 0, col = -1, firabs = 0, last = -1;
	bool first = true, cher = true;
	while (cur != firabs || first) {
		first = false;
		if (gr[cur].size() < 2) break;
		auto [to, c] = gr[cur][0].first == last ? gr[cur][1] : gr[cur][0];
		if (c == col) cher = false;
		last = cur;
		col = c;
		cur = to;
	}
	if (cher && n % 2 == 0) can = false;
	if (!can) {
		cout << "NO" << "\n";
		return;
	}
	cout << "YES" << "\n";

	skipv = -1;
	skipu = -1;
	skipc = -1;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	if (skipv != -1) {
		ans.push_back({ skipv, skipc });
		ans.push_back({ skipu, skipc });
	}
	used.assign(n, 0);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs2(i);
		}
	}

	cout << ans.size() << "\n";
	for (auto [f, s] : ans) {
		cout << (f + 1) << " " << s << "\n";
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);

	ll t; cin >> t;
	while (t--) {
		solve();
	}
}