#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;

vector<vector<pair<ll, ll>>> gr;
vector<bool> used;
vector<ll> rem;
vector<pair<ll, ll>> ans;
vector<ll> inf;


void solve() {
	ll n, m; cin >> n >> m;
	gr.assign(n, {});
	rem.assign(n, 0);
	used.assign(n, 0);
	for (int i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c;
		a--, b--;
		gr[a].push_back({ b, c });
		rem[b]++;
	}
	inf.assign(n, 0);
	ans.assign(0, { 0, 0 });
	bool can = true;
	for (int i = 0; i < n; i++) cin >> inf[i];
	for (int v = 0; v < n; v++) {
		for (auto [to, c] : gr[v]) {
			if (c == 1 && inf[v] == 0 && inf[to] == 0) can = false;
			if (c == 0 && inf[v] == 1 && inf[to] == 1) can = false;
		}
	} 
	if (!can) {
		cout << "NO" << endl;
		return;
	}
	cout << "YES" << endl;
	
	for (int i = 0; i < n; i++) {
		ans.push_back({ i, 0 });
	}
	for (int i = 0; i < n; i++) {
		ans.push_back({ i, inf[i] });
		for (auto [to, c] : gr[i]) {
			ans.push_back({ to, c });
		}
	}

	cout << ans.size() << endl;
	for (auto [f, s] : ans) {
		cout << (f + 1) << " " << s << endl;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);

	ll t; cin >> t;
	while (t--) {
		solve();
	}
}