#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

#pragma optimize("O3")
#pragma target("avx2")

using namespace std;
typedef long long ll;

struct Event {
	ll x, tp, ind;
};

bool cmp(Event e1, Event e2) {
	if (e1.x == e2.x) {
		if (e1.tp == e2.tp) {
			return e1.ind < e2.ind;
		}
		return e1.tp < e2.tp;
	}
	return e1.x < e2.x;
}

ll solve(ll n, vector<pair<ll, ll>> segs) {
	vector<Event> evs;
	for (ll i = 0; i < segs.size(); i++) {
		evs.push_back({ segs[i].first, 1, i });
		evs.push_back({ segs[i].second, -1, i });
	}
	sort(evs.begin(), evs.end(), cmp);
	vector<pair<ll, ll>> ar;
	ll curma = -1, curr = 0, curind = -1;
	for (int i = 0; i < evs.size(); i++) {
		auto [l, r] = segs[evs[i].ind];
		if (l > curr) {
			curr = curma;
			ar.push_back({ segs[evs[curind].ind].first, segs[evs[curind].ind].second - 1 });
		}
		if (r > curma) {
			curma = r;
			curind = i;
		}
	}
	ar.push_back({ segs[evs[curind].ind].first, segs[evs[curind].ind].second - 1 });
	vector<ll> pokr(n);
	ll ind = 0, r = ar[0].second;
	ll ans = 0;
	ll su = 0;
	for (int i = 0; i < n; i++) {
		while (i > r) {
			ind++;
			r = ar[ind].second;
		}
		pokr[i] = ind;
		su += pokr[i];
	}
	for (int i = 0; i < n; i++) {
		su -= pokr[i];
		ans += su - pokr[i] * (n - i - 1);
	}
	return ans;
}

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);

	ll n, x; cin >> n >> x;
	vector<pair<ll, ll>> segs(n);
	for (ll i = 0; i < n; i++) {
		ll a; cin >> a;
		segs[i] = { max(0LL, i - a), min(n, i + a + 1) };
	}
	ll ans = solve(n, segs);
	segs.push_back({ 0, 0 });
	if (x != 0) {
		ll acc = 0;
		for (int i = n/2; i < n; i++) {
			acc++;
			segs[segs.size() - 1] = { max(0LL, i - x), min(n, i + x + 1) };
			ans = min(ans, solve(n, segs));
			if (acc == 5) break;
		}
	}
	cout << ans << endl;
	int dbg = 0;
}