#include <iostream>
#include <vector>

struct edge {
    int to, c;

    edge(int _to, int _c) : to(_to), c(_c) {}
};

std::vector<std::vector<edge>> g;
std::vector<int> d, used;
std::vector<std::pair<int, int>> mv;

int dfs(int v) {
    used[v] = 1;
    if (d[v] == 1) {
        for (auto& [to, c] : g[v]) {
            if (used[to] == 1) {
                continue;;
            }
            if (d[v] == d[to] && d[v] != c) {
                return -1;
            }
            if (c == 0 && d[to] == 0) {
                if (dfs(to) == -1) {
                    return -1;
                }
            }
        }
        mv.emplace_back(v + 1, 1);
        for (auto& [to, c] : g[v]) {
            if (used[to] == 1) {
                continue;
            }
            if (d[to] == 0) {
                mv.emplace_back(to + 1, 1);
                mv.emplace_back(to + 1, 0);
                if (dfs(to) == -1) {
                    return -1;
                }
            } else {
                if (dfs(to) == -1) {
                    return -1;
                }
            }
        }
    } else {
        mv.emplace_back(v + 1, 1);
        for (auto& [to, c] : g[v]) {
            if (used[to] == 1) {
                continue;
            }
            if (d[v] == d[to] && d[v] != c) {
                return -1;
            }
            if (d[to] == 0 || c == 1) {
                if (dfs(to) == -1) {
                    return -1;
                }
            }
        }
        mv.emplace_back(v + 1, 0);
        for (auto& [to, c] : g[v]) {
            if (used[to] == 1) {
                continue;
            }
            if (dfs(to) == -1) {
                return -1;
            }
        }
    }
    return 0;
}


int main() {
    int t;
    std::cin >> t;
    for (; t > 0; --t) {
        int n, m;
        std::cin >> n >> m;
        g.resize(n);
        used.resize(n);
        d.resize(n);
        for (int i = 0; i < m; ++i) {
            int u, v, c;
            std::cin >> u >> v >> c;
            u -= 1;
            v -= 1;
            g[u].emplace_back(v, c);
            g[v].emplace_back(u, c);
        }
        for (int i = 0; i < n; ++i) {
            std::cin >> d[i];
        }
        int ans = dfs(0);
        if (ans == -1) {
            std::cout << "NO\n";
        } else {
            std::cout << "YES\n";
            std::cout << mv.size() << '\n';
            for (auto& [v, c] : mv) {
                std::cout << v << ' ' << c << '\n';
            }
        }
        g.resize(0);
        used.resize(0);
        d.resize(0);
        mv.resize(0);
    }
    return 0;
}

