#include <iostream>
#include <vector>

struct edge {
    int a, b, c, c1;

    edge(int _a, int _b, int _c) : a(_a), b(_b), c(_c), c1(0) {}
};

std::vector<std::vector<int>> g;
std::vector<int> d, used, cur;
std::vector<std::pair<int, int>> mv;
std::vector<edge> edges;

int dfs(int v) {
    used[v] = 1;
    if (d[v] == 1) {
        for (auto& i : g[v]) {
            auto& [a, b, c, c1] = edges[i];
            int to = a;
            if (to == v) {
                to = b;
            }
            if (cur[to] == cur[v]) {
                edges[i].c1 = cur[to];
            }
            if (used[to] == 1) {
                continue;
            }
            if (d[v] == d[to] && d[v] != c) {
                return -1;
            }
            if (c == 0 && d[to] == 0) {
                if (dfs(to) == -1) {
                    return -1;
                }
            }
        }
        mv.emplace_back(v + 1, 1);
        cur[v] = 1;
        for (auto& i : g[v]) {
            auto& [a, b, c, c1] = edges[i];
            int to = a;
            if (to == v) {
                to = b;
            }
            if (cur[to] == cur[v]) {
                edges[i].c1 = cur[to];
            }
            if (used[to] == 1) {
                continue;
            }
            if (d[to] == 0) {
                if (dfs(to) == -1) {
                    return -1;
                }
            } else {
                if (dfs(to) == -1) {
                    return -1;
                }
            }
        }
    } else {
        mv.emplace_back(v + 1, 1);
        cur[v] = 1;
        for (auto& i : g[v]) {
            auto& [a, b, c, c1] = edges[i];
            int to = a;
            if (to == v) {
                to = b;
            }
            if (cur[to] == cur[v]) {
                edges[i].c1 = cur[to];
            }
            if (used[to] == 1) {
                continue;
            }
            if (d[v] == d[to] && d[v] != c) {
                return -1;
            }
            if (d[to] == 0 || c == 1) {
                if (dfs(to) == -1) {
                    return -1;
                }
            }
        }
        mv.emplace_back(v + 1, 0);
        cur[v] = 0;
        for (auto& i : g[v]) {
            auto& [a, b, c, c1] = edges[i];
            int to = a;
            if (to == v) {
                to = b;
            }
            if (cur[to] == cur[v]) {
                edges[i].c1 = cur[to];
            }
            if (used[to] == 1) {
                continue;
            }
            if (dfs(to) == -1) {
                return -1;
            }
        }
    }
    return 0;
}

bool chesk() {
    for (int i = 0; i < cur.size(); ++i) {
        if (cur[i] != d[i]) {
            return false;
        }
    }
    for (auto& [a, b, c, c1] : edges) {
        if (c != c1) {
            return false;
        }
    }
    return true;
}

int main() {
    int t;
    std::cin >> t;
    for (; t > 0; --t) {
        int n, m;
        std::cin >> n >> m;
        g.resize(n);
        used.resize(n);
        d.resize(n);
        cur.resize(n);
        for (int i = 0; i < m; ++i) {
            int u, v, c;
            std::cin >> u >> v >> c;
            u -= 1;
            v -= 1;
            edges.emplace_back(u, v, c);
            g[u].emplace_back(edges.size() - 1);
            g[v].emplace_back(edges.size() - 1);
        }
        for (int i = 0; i < n; ++i) {
            std::cin >> d[i];
        }
        for (auto& [a, b, c, c1] : edges) {
            if (d[a] == 0 && d[b] == 0) {
                std::cout << "NO\n";
                return 0;
            }
        }
        std::cout << "YES\n";
        for (int i = 0; i < n; ++i) {
            mv.emplace_back(i + 1, 1);
        }
        for (int i = 0; i < n; ++i) {
            if (d[i] == 0) {
               mv.emplace_back(i + 1, 0);
            }
        }
        std::cout << mv.size() << '\n';
            for (auto& [v, c] : mv) {
                std::cout << v << ' ' << c << '\n';
            }
        cur.resize(0);
        g.resize(0);
        used.resize(0);
        d.resize(0);
        mv.resize(0);
        edges.clear();
    }
    return 0;
}

