#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> p) {
    return out << p.first << " " << p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = (int)2e6 + 1000;

struct Node {
    int l, r, val;

    Node() {
        l = r = -1;
        val = 0;
    }
};
vector<Node> p(MAXN);
int sz = 1;

int get_val(int v) {
    return (v == -1 ? 0 : p[v].val);
}

void recalc(int v) {
    p[v].val = get_val(p[v].l) + get_val(p[v].r);
}

void upd_segtree(int v, int pos, int val, int tl, int tr) {
    if (tl == tr) {
        p[v].val += val;
        return;
    }
    int tm = (tl+tr)/2;
    if (pos <= tm) {
        if (p[v].l == -1) p[v].l = sz++;
        upd_segtree(p[v].l, pos, val, tl, tm);
    } else {
        if (p[v].r == -1) p[v].r = sz++;
        upd_segtree(p[v].r, pos, val, tm+1, tr);
    }
    recalc(v);
}

int get_sum(int v, int l, int r, int tl, int tr) {
    if (l > tr || r < tl) return 0;
    if (l <= tl && tr <= r) return p[v].val;
    int tm = (tl+tr)/2;
    return (p[v].l == -1 ? 0 : get_sum(p[v].l, l, r, tl, tm)) + (p[v].r == -1 ? 0 : get_sum(p[v].r, l, r, tm+1, tr));
}

void solve() {
    int n, m; cin >> n >> m;
    vector<int> t(n); input(t);
    vector<int> s(m); input(s);
    vector<pair<int, int>> l;
    for (int i = 0; i<m; ++i) {
        int val = (s[i] - (i == 0 ? 0 : s[i-1]));
        if (l.empty() || l.back().first < val) l.emplace_back(val, 1);
        else l.back().second++;
    }
    int N = (int)l.size(); // N <= sqrt(MAXC)
    int mx = 0;
    for (int i = 0; i<n; ++i) assign_max(mx, t[i] * l[N-1].first);
    vector<int> tree(n+1);
    auto upd = [&](int k, int x) -> void {
        for (; k <= n; k += k&-k) tree[k] += x;
    };
    auto sum = [&](int r) -> int {
        int res = 0;
        for (int k = r; k > 0; k -= k&-k) res += tree[k];
        return res;
    };
    vector<int> reqs(n);
    for (int i = 0; i<n; ++i) {
        reqs[i] = l[N-1].first * t[i];
    }
    sort(all(reqs)); reqs.erase(unique(all(reqs)), reqs.end());
    vector<int> ind(n);
    for (int i = 0; i<n; ++i) ind[i] = lower_bound(all(reqs), l[N-1].first * t[i]) - reqs.begin() + 1;
    int res = 0;
    for (int i = 0; i<n; ++i) {
        res += get_sum(0, 0, t[i] * l[N-1].first, 0, mx);
        for (int j = 0; j<N; ++j) {
            int r = upper_bound(all(reqs), l[j].first * t[i]) - reqs.begin();
            res += l[j].second * (i - sum(r));
            upd_segtree(0, l[j].first * t[i], l[j].second, 0, mx);
        }
        upd(ind[i], 1);
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
