#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> p) {
    return out << p.first << " " << p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = (int)2e7 + 1000;

struct fenwick {
    vector<int> tree;
    int n;

    void init(int sz) {
        n = sz;
        tree.resize(sz+1);
    }

    void upd(int k, int x) {
        for (; k <= n; k += k&-k) tree[k] += x;
    }

    int sum(int r) {
        int res = 0;
        for (int k = r; k > 0; k -= k&-k) res += tree[k];
        return res;
    }
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> t(n); input(t);
    vector<int> s(m); input(s);
    vector<pair<int, int>> l;
    for (int i = 0; i<m; ++i) {
        int val = (s[i] - (i == 0 ? 0 : s[i-1]));
        if (l.empty() || l.back().first < val) l.emplace_back(val, 1);
        else l.back().second++;
    }
    int N = (int)l.size(); // N <= sqrt(MAXC)
    fenwick tree, tree2;
    tree.init(n);
    tree2.init(n);
    vector<int> reqs(n);
    for (int i = 0; i<n; ++i) {
        reqs[i] = l[N-1].first * t[i];
    }
    sort(all(reqs)); reqs.erase(unique(all(reqs)), reqs.end());
    vector<int> ind(n);
    for (int i = 0; i<n; ++i) ind[i] = lower_bound(all(reqs), l[N-1].first * t[i]) - reqs.begin() + 1;
    int res = 0;
    for (int i = 0; i<n; ++i) {
        res += tree2.sum(ind[i]);
        for (int j = 0; j<N; ++j) {
            int r = upper_bound(all(reqs), l[j].first * t[i]) - reqs.begin();
            res += l[j].second * (i - tree.sum(r));
            int r2 = lower_bound(all(reqs), l[j].first * t[i]) - reqs.begin() + 1;
            tree2.upd(r2, l[j].second);
        }
        tree.upd(ind[i], 1);
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
