#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6;
int d[maxn];

struct edge {
    int to, w;
};
vector<edge> g[maxn];
vector<int> g1[maxn], g2[maxn];

int used[maxn];
int zazh[maxn];

bool check_cycles(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (used[u] == 2) continue;
        if (used[u] == 1) {
            return 1;
        }
        if (check_cycles(u)) {
            return 1;
        }
    }
    used[v] = 2;
    return 0;
}

vector<int> order;

void topsort(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (used[u]) continue;
        topsort(u);
    }
    order.push_back(v);
}

int tests;

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        g1[i].clear();
        g[i].clear();
    }
    fill(used, used + n, 0);
    for (int i = 0; i < m; i++) {
        int x, y, w;
        cin >> x >> y >> w; x--, y--;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [u, w] : g[i]) {
            if (d[i] == 1 && d[u] == 0) {
                if (w == 1) g1[i].push_back(u);
                else g1[u].push_back(i);
            }
            if (d[i] == d[u] && w != d[i]) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (auto u : g1[i]) {
            g2[u].push_back(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        bool fl = check_cycles(i);
        if (fl == 1) {
            cout << "NO\n";
            return;
        }
    }
    order.clear();
    fill(used, used + n, 0);
    fill(zazh, zazh + n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        topsort(i);
    }
    reverse(order.begin(), order.end());
    cout << "YES\n";
    vector<pair<int, int>> ans;
    for (auto i : order) {
        if (d[i] == 0) continue;
        for (auto u : g2[i]) {
            if (zazh[u] && d[u] == 0) {
                ans.push_back({u + 1, 0});
                zazh[u] = 0;
            }
        }
        ans.push_back({i + 1, 1});
        for (auto u : g1[i]) {
            if (!zazh[u] && d[u] == 0) {
                ans.push_back({u + 1, 1});
                zazh[u] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i] == 0 && zazh[i] == 1) {
            ans.push_back({i + 1, 0});
        }
    }
    cout << (int) ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x << ' ' << y << '\n';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> tests;
    while (tests--) solve();
    return 0;
}
