#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6;
long long pos[maxn], t[maxn];
int tests;
int gate[maxn];
long long n, m;

struct tme {
    int idx;
    bool operator < (const tme & other) const {
        return (t[idx] < t[other.idx] || (t[idx] == t[other.idx] && idx < other.idx));
    }
    bool operator == (const tme & other) const {
        return idx == other.idx;
    }
};

struct Node {
    long long mn, idx;
    Node(long long _val = 1e18, int _idx = -1) {
        mn = _val;
        idx = _idx;
    }
    Node operator + (const Node & other) const {
        if (mn < other.mn) {
            return *this;
        }
        if (mn > other.mn) {
            return other;
        }
        if (idx < other.idx) {
            return *this;
        }
        return other;
    }
};

Node tr[maxn * 4];

void build(int v, int l, int r) {
    if (l + 1 == r) {
        return;
    }
    int mid = (l + r) / 2;
    tr[v] = Node();
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
}

void update(int v, int l, int r, int pos, long long val) {
    if (pos < l || pos >= r) return;
    if (l + 1 == r) {
        tr[v] = Node(val, pos);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, pos, val);
    update(v * 2 + 1, mid, r, pos, val);
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
}

int getmin() {
    return tr[1].idx;
}

void emulate(int n) {
    vector<multiset<tme>> gates(m + 1);
    build(1, 0, m + 1);
    for (int i = 0; i < n; i++) {
        update(1, 0, m + 1, 0, (pos[1] - pos[0]) * t[i]);
        gates[0].insert({i});
    }
    long long ans = 0, curk = n;
    while (curk != 0) {
        long long bidx = getmin();
        int bestgo = gates[bidx].begin() -> idx;
        gates[bidx].erase(gates[bidx].begin());
        int nwbestgo = 1e18;
        if (!gates[bidx].empty()) {
            nwbestgo = gates[bidx].begin() -> idx;
        }
        update(1, 0, m + 1, bidx, (pos[bidx + 1] - pos[bidx]) * t[nwbestgo]);
        gates[bidx + 1].insert({bestgo});
        update(1, 0, m + 1, bidx, (pos[bidx + 2] - pos[bidx + 1]) * t[bestgo]);
        if (curk != 0) {
            ans += curk - 1;
        }
        if (!gates[m].empty()) {
            curk -= (int) gates[m].size();
            gates[m].clear();
        }
    }
    cout << ans << '\n';
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> pos[i + 1];
    }
    pos[m + 1] = 2e9;
    for (int i = 1; i <= n; i++) {
        cout << m * i * (i - 1) / 2ll << '\n';
        //emulate(i);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    tests = 1;
    while (tests--) solve();
    return 0;
}
