#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

struct DSU {
private:
    vector <int> p, r;

public:
    explicit DSU(int n) : p(n), r(n) {
        iota(all(p), 0ll);
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) {
            return;
        }
        if (r[a] > r[b]) {
            swap(a, b);
        }
        p[a] = b;
        r[b] += (r[a] == r[b]);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<tuple <int, int, int> > > g(n);
    vector<tuple<int, int, int> > edges;
    set <pii> tt;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a, --b;
        edges.emplace_back(a, b, c);
        g[a].emplace_back(b, c, i);
        g[b].emplace_back(a, c, i);
    }
    vector<int> col(n);
    for (auto &i: col) {
        cin >> i;
    }
    for (auto [a, b, c]: edges) {
        if (col[a] == col[b] && col[a] != c) {
            cout << "NO\n";
            return;
        }
    }
    bool cycle = false;
    vector <vector <pii> > wg(n);
    for (int i = 0; i < n; ++i) {
        for (auto [j, c, id] : g[i]) {
            if (c) {
                wg[i].emplace_back(j, id);
            }
        }
    }
    vector <int> fulfilled(n);
    vector <vector <int> > cg(n);
    for (int i = 0; i < m; ++i) {
        auto [a1, b1, c1] = edges[i];
        if (c1 || (!col[a1] && !col[b1])) {
            continue;
        }
        if (!col[a1]) {
            cg[b1].push_back(a1);
        } else {
            cg[a1].push_back(b1);
        }
    }
    vector <int> used(m);
    vector <int> ord;
    function <void(int, int)> fulfill = [&](int cur, int par) {
        if (fulfilled[cur]) {
            if (fulfilled[cur] == 1) {
                cycle = true;
            }
            return;
        }
        fulfilled[cur] = 1;
        for (auto to : cg[cur]) {
            if (fulfilled[to] == 1) {
                cycle = true;
            }
            if (!fulfilled[to]) {
                fulfill(to, cur);
            }
        }
        for (auto [to, id] : wg[cur]) {
            if (!used[id]) {
                auto [a, b, c] = edges[id];
                if (a != cur && a != par) {
                    fulfill(a, cur);
                }
                if (b != cur && b != par) {
                    fulfill(b, cur);
                }
                ord.push_back(id);
                used[id] = 1;
            }
        }
        fulfilled[cur] = 2;
    };
    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            auto [a, b, c] = edges[i];
            if (c) {
                fulfill(a, -1);
                fulfill(b, -1);
            }
        }
    }
    if (cycle) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        vector <pii> ops;
        vector <int> ncol(n);
        for (auto i : ord) {
            auto [a, b, c] = edges[i];
            if (!c) {
                continue;
            }
            ops.emplace_back(a, 1);
            ops.emplace_back(b, 1);
            ops.emplace_back(a, col[a]);
            ops.emplace_back(b, col[b]);
            ncol[a] = col[a];
            ncol[b] = col[b];
        }
        for (int i = 0; i < n; ++i) {
            if (col[i] != ncol[i]) {
                ops.emplace_back(i, col[i]);
            }
        }
        cout << sz(ops) << "\n";
        for (auto [a, b] : ops) {
            cout << a + 1 << " " << b << "\n";
        }
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}