#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

struct DSU {
private:
    vector <int> p, r;

public:
    explicit DSU(int n) : p(n), r(n) {
        iota(all(p), 0ll);
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) {
            return;
        }
        if (r[a] > r[b]) {
            swap(a, b);
        }
        p[a] = b;
        r[b] += (r[a] == r[b]);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pii> > g(n);
    vector<tuple<int, int, int> > edges;
    set <pii> tt;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
//        if (tt.count({a, b}) || tt.count({b, a})) {
//            assert(false);
//        }
//        tt.insert({a, b});
        --a, --b;
        edges.emplace_back(a, b, c);
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    vector<int> ncol(n), col(n);
    for (auto &i: col) {
        cin >> i;
    }
    for (auto [a, b, c]: edges) {
        if (col[a] == col[b] && col[a] != c) {
            cout << "NO\n";
            return;
        }
    }
    DSU dsu(n);
    for (auto [a, b, c] : edges) {
        if (c == 1) {
            dsu.unite(a, b);
            ncol[a] = ncol[b] = 1;
        }
    }
    vector <vector <int> > cg(n);
    vector <vector <int> > comp(n);
    for (auto [a, b, c] : edges) {
        if (c == 0 && max(col[a], col[b])) {
            if (col[a] == 0) {
                cg[dsu.get(a)].push_back(dsu.get(b));
            } else {
                cg[dsu.get(b)].push_back(dsu.get(a));
            }
        }
    }
    vector <int> used(n, 0);
    bool cycle = false;
    function <void(int)> dfs = [&](int cur) {
        used[cur] = 1;
        for (auto to : cg[cur]) {
            if (used[to] == 1) {
                cycle = true;
            }
            if (!used[to]) {
                dfs(to);
            }
        }
        used[cur] = 2;
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    if (cycle) {
        cout << "NO\n";
    } else {
        cout << "YES\n0\n";
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}