#ifndef SYSTY257
#pragma GCC optimize("Ofast")
#endif
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

struct Fenwick {
private:
    vector <int> d;
    int n;

public:
    explicit Fenwick(int n1) : d(n1), n(n1) { }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += d[i];
        }
        return res;
    }

    void upd(int i, int x) {
        for (; i < n; i |= (i + 1)) {
            d[i] += x;
        }
    }
};

void solve(int n, int m, const vector <int>& v, const vector <int>& cord) {

    vector <tuple <long long, int, int> > ds;
    for (int i = 0; i < n; ++i) {
        int pmax = 0;
        for (int j = 1; j <= m; ++j) {
            pmax = max(pmax, cord[j] - cord[j - 1]);
            ds.emplace_back(1ll * pmax * v[i], i, j);
        }
    }
    sort(all(ds));
    vector <vector <int> > pos(n);
    for (int i = 0; i < sz(ds); ++i) {
        auto [a, b, c] = ds[i];
        pos[b].push_back(i);
    }
    long long res = 0;
    Fenwick f1(sz(ds));
    Fenwick f2(sz(ds));
    for (int pref = 1; pref <= n; ++pref) {
        res -= 2 * m - 1;
        f2.upd(pos[pref - 1].back(), 1);
        for (auto ps : pos[pref - 1]) {
            res += pref - f2.get(ps);
            f1.upd(ps, 1);
        }
        res += f1.get(pos[pref - 1].back());
        cerr << res << "\n";
    }
}
signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n, m;
    cin >> n >> m;
    vector <int> v(n);
    for (auto &i : v) {
        cin >> i;
    }
    vector <int> cord(m + 1);
    for (int i = 1; i <= m; ++i) {
        cin >> cord[i];
    }
    vector <int> pmax(m + 1);
    int point = 0;
    for (int i = 1; i <= m; ++i) {
        pmax[i] = max(pmax[i - 1], cord[i] - cord[i - 1]);
        if (pmax[i] > pmax[i - 1]) {
            point = i - 1;
        }
    }
    int vklad21 = 0, vklad12 = 0;
    int vklad22 = 0, vklad11 = 0;
    for (int i = 1; i <= m; ++i) {
        if (pmax[i] * 2 < pmax.back()) {
            vklad21++;
        }
        if (pmax[i] < pmax.back()) {
            vklad22++;
        }
        if (pmax[i] < pmax.back() * 2) {
            vklad12++;
        }
        if (pmax[i] < pmax.back()) {
            vklad11++;
        }
    }
    long long res = 0;
    int cnt1 = 0, cnt2 = 0;
    for (int pref = 1; pref <= n; ++pref) {
        if (v[pref - 1] == 2) {
            res += (pref - 1) * m;
            res += vklad22 * cnt2;
            res += vklad21 * cnt1;
            ++cnt2;
        } else {
            res += vklad21 * cnt2;
            res += vklad12 * cnt2;
            res += vklad11 * cnt1;
            res += m * cnt1;
            ++cnt1;
        }
        cout << res << "\n";
    }
//    solve(n, m, v, cord);
}