#include <bits/stdc++.h>
using namespace std;
 
#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif
 
#define in(x) x.begin(), x.end()
typedef long long ll;
 
template<typename T>
bool cmin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
int n, m;
const int mxN = 1e5 + 500;
const int mxM = 2e5 + 500;
vector<pair<int, int>> g[mxN];
pair<int, int> edges[mxM];
int c[mxM], d[mxN];
 
vector<pair<int, int>> res;
 
void rec(int i) {
    if (i == n - 1) {
     
        return;
    }
    int nxt_e = -1;
        debug << i << ": ";
    for (auto e : g[i]) {
        debug << e.first << ' ';
        if (e.first == i + 1) {
            nxt_e = e.second;
        }
    }
    debug << endl;
    assert(nxt_e != -1);
    if (c[nxt_e] == 1) {
        res.emplace_back(i, 1);
        res.emplace_back(i + 1, 1);
        res.emplace_back(i + 1, 0);
 
    }
    rec(i + 1);
    if (c[nxt_e] == 1) {
        if (d[i + 1] == 1) {
            res.emplace_back(i + 1, 1);
        }
        if (!d[i]) {
            res.emplace_back(i, 0);
        }
    }
}
 
void dfs(int v, int p = -1) {
     
    for (auto e : g[v]) {
        int u, e_id;
        tie(u, e_id) = e;
        if (u == p) continue;
 
        if (c[e_id] == 1) {
            res.emplace_back(v, 1);
            res.emplace_back(u, 1);
            res.emplace_back(u, 0);
            dfs(u, v);
            res.emplace_back(v, 0);
            res.emplace_back(u, 1);
        }
    }
    for (auto e : g[v]) {
        int u, e_id;
        tie(u, e_id) = e;
        if (u == p) continue;
 
        if (c[e_id] == 0) {
            dfs(u, v);
        }
    }
    if (d[v] == 1) {
        res.emplace_back(v, 1);
    }
 
    for (auto e : g[v]) {
        int u, e_id;
        tie(u, e_id) = e;
        if (u == p) continue;
 
        if (d[u] == 0) {
            res.emplace_back(u, 0);
        }
    }
    
     
}
 
void solve() {
    cin >> n >> m;
    debug << "n m : " << n << ' ' << m << endl;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w, --u, --v;
        c[i] = w;
        edges[i] = {u, v};
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
    }
    for (int i = 0; i < n; ++i) {
        sort(in(g[i]));
        g[i].erase(unique(in(g[i])), g[i].end());
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    // tree
    bool can = true;
    for (int i = 0; i < m; ++i) {
        int u, v;
        tie(u, v) = edges[i];
        if (c[i] == 1) {
            if (!(d[u] || d[v])) {
                can = false;
            }
        } else {
            if (d[u] && d[v]) {
                can = false;
            }
        }
    }
    if(!can) {
        cout << "NO\n";
        for (int i= 0 ; i < n; ++i) {
        g[i].clear();
    }
    res.clear();
        return;
    }
    // rec(0);
    dfs(0);
    cout << "YES\n";
    for (int i = 0; i < n; ++i) {
        if (d[i]) {
            res.emplace_back(i, 1);
        }
    }
    vector<int> now_me(n);
    vector<pair<int, int>> new_res;
    for (auto op : res) {
        int v, c;
        tie(v, c) = op;
        if (now_me[v] != c) {
            new_res.emplace_back(v, c);
            now_me[v] = c;
        }
    }
    swap(res, new_res);
    cout << res.size() << '\n';
    for (auto elem : res) {
        cout << elem.first + 1 << ' ' << elem.second << '\n';
    }
    for (int i= 0 ; i < n; ++i) {
        g[i].clear();
    }
    res.clear();
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt;
    cin >> tt;
    while (tt --> 0) {
        solve();
    }
    return 0;
}