#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Fenwick {
    vector<int> t;
    int n;

    void init(int m) {
        n = m;
        t.assign(n + 1, 0);
    }

    void add(int x) {
        for (++x; x <= n; x += x & -x) {
            t[x] += 1;
        }
    }

    int sum(int x) {
        int ans = 0;
        for (++x; x > 0; x -= x & -x) {
            ans += t[x];
        }
        return ans;
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    vector<int> s(m + 1), d(m), mx, pos;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < m; ++i) {
        d[i] = s[i + 1] - s[i];
        if (mx.empty() || mx.back() < d[i]) {
            mx.push_back(d[i]);
            pos.push_back(i);
        }
    }

    vector<int> st = t;
    sort(st.begin(), st.end());
    st.resize(unique(st.begin(), st.end()) - st.begin());
    int k = size(st);
    Fenwick fn;
    fn.init(k);

    int P = size(mx);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        auto query1 = [&](int p, ll val) {
            ll need = val / mx[p];
            int pos = std::upper_bound(st.begin(), st.end(), need) - st.begin();
            int res = i - fn.sum(pos - 1);
            return res;
        };
        auto query2 = [&](ll val) {
            ll need = val / mx[P - 1];
            int pos = std::upper_bound(st.begin(), st.end(), need) - st.begin();
            int res = fn.sum(pos - 1);
            return res;
            for (int j = 0; j < i; ++j) {
                res += 1LL * mx[P - 1] * t[j] <= val;
            }
            return res;
        };
        int prv = 0;
        ll ans_now = 0;
        for (int p = 0; p < P; ++p) {
            int now = query1(p, 1LL * mx[P - 1] * t[i]);
            ans_now += (now - prv) * 1LL * pos[p];
            prv = now;
        }
        prv = 0;
        for (int p = 0; p < P; ++p) {
            int now = query2(1LL * mx[p] * t[i]);
            ans_now += 1LL * pos[p] * (now - prv);
            prv = now;
        }
        ans += ans_now;
        fn.add(std::lower_bound(st.begin(), st.end(), t[i]) - st.begin());
        cout << ans + 1LL * i * (i + 1) / 2 * m << "\n";
    }

    return 0;
}
