#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,bmi")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

namespace CoolAdder {
    constexpr int N = 1.5e5 + 7;
    constexpr int B_sz = 256, B_cnt = (N - 1) / B_sz + 1;
    int lazy_sum[B_cnt];
    int pref[N];

    void clear() {
        memset(lazy_sum, 0, sizeof(lazy_sum));
        memset(pref, 0, sizeof(pref));
    }

    void add(int x) {
        int b = x / B_sz;
        int r = min(N, (b + 1) * B_sz);
#pragma ivdep
        for (int i = x; i < r; ++i) {
            pref[i] += 1;
        }
#pragma ivdep
        for (int f = b + 1; f < B_cnt; ++f) {
            lazy_sum[f] += 1;
        }
    }

    int query(int x) {
        return x < 0 ? 0 : pref[x] + lazy_sum[x >> 8];
    }
}

int check[150001][550];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    vector<int> s(m + 1), d(m);
    vector<ll> mx, pos;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < m; ++i) {
        d[i] = s[i + 1] - s[i];
        if (mx.empty() || mx.back() < d[i]) {
            mx.push_back(d[i]);
            pos.push_back(i);
        }
    }

    vector<int> st = t;
    sort(st.begin(), st.end());
    vector<pair<int, int>> pp(n);
    for (int i = 0; i < n; ++i) {
        pp[i] = pair{t[i], i};
    }
    sort(pp.begin(), pp.end());
    vector<int> posi(n);
    for (int i = 0; i < n; ++i) {
        posi[pp[i].second] = i;
    }
    pos.push_back(0);


    int P = size(mx);
    vector<ll> result(n);
    for (int type = 0; type < 2; ++type) {
        ll ans = 0;
        if (type == 0) {
            for (int p = 0; p < P; ++p) {
                for (int i = 0, j = 0; j < n;) {
                    if (i < n && st[i] * mx[p] <= mx[P - 1] * st[j]) {
                        ++i;
                    } else {
                        check[j++][p] = i;
                    }
                }
            }
        } else {
            for (int p = 0; p < P; ++p) {
                for (int i = 0, j = 0; j < n;) {
                    if (i < n && st[i] * mx[P - 1] <= mx[p] * st[j]) {
                        ++i;
                    } else {
                        check[j++][p] = i;
                    }
                }
            }
        }
        if (type == 1) {
            CoolAdder::clear();
        }
        for (int i = 0; i < n; ++i) {
            ll ans_now = 0;
            if (type == 0) {
                for (int p = P - 1; p >= 0; --p) {
                    int now = i-CoolAdder::query(check[posi[i]][p] - 1);
                    if (now == 0) {
                        break;
                    }
                    ans_now += now * (pos[p] - pos[p + 1]);
                }
            } else {
                for (int p = P - 1; p >= 0; --p) {
                    int now = CoolAdder::query(check[posi[i]][p] - 1);
                    if (now == 0) {
                        break;
                    }
                    ans_now += now * (pos[p] - pos[p + 1]);
                }
            }
            ans += ans_now;
            result[i] += ans;
            CoolAdder::add(std::lower_bound(st.begin(), st.end(), t[i]) - st.begin());
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << result[i] + 1LL * i * (i + 1) / 2 * m << '\n';
    }

    return 0;
}