#include <bits/stdc++.h>

using namespace std;
using ll = long long;

namespace CoolAdder {
    constexpr int N = 1.5e5 + 7;
    constexpr int B_sz = 400, B_cnt = (N - 1) / B_sz + 1;
    int lazy_sum[B_cnt];
    int pref[N];

    void clear() {
        memset(lazy_sum, 0, sizeof(lazy_sum));
        memset(pref, 0, sizeof(pref));
    }

    void add(int x) {
        int b = x / B_sz;
        int r = min(N, (b + 1) * B_sz);
        for (int i = x; i < r; ++i) {
            pref[i] += 1;
        }
        for (int f = b + 1; f < B_cnt; ++f) {
            lazy_sum[f] += 1;
        }
    }

    int query(ll x) {
        if (x < 0) {
            return 0;
        }
        if (x >= N) {
            return pref[N - 1] + lazy_sum[B_cnt - 1];
        }
        return pref[x] + lazy_sum[x / B_sz];
    }
}

int check[550][150000];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    vector<int> s(m + 1), d(m), mx, pos;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < m; ++i) {
        d[i] = s[i + 1] - s[i];
        if (mx.empty() || mx.back() < d[i]) {
            mx.push_back(d[i]);
            pos.push_back(i);
        }
    }

    vector<int> st = t;
    sort(st.begin(), st.end());
    vector<pair<int, int>> pp(n);
    for (int i = 0; i < n; ++i) {
        pp[i] = pair{t[i], i};
    }
    sort(pp.begin(), pp.end());
    vector<int> posi(n);
    for (int i = 0; i < n; ++i) {
        posi[pp[i].second] = i;
    }


    int P = size(mx);
    assert(P < 550);
    vector<ll> result(n);
    for (int type = 0; type < 2; ++type) {
        ll ans = 0;
        if (type == 0) {
            for (int p = 0; p < P; ++p) {
                fill(check[p], check[p] + n, 0);
                for (int i = 0, j = 0; j < n;) {
                    if (i < n && st[i] * 1LL * mx[p] <= 1LL * mx[P - 1] * st[j]) {
                        ++i;
                    } else {
                        check[p][j++] = i;
                    }
                }
            }
        } else {
            for (int p = 0; p < P; ++p) {
                fill(check[p], check[p] + n, 0);
                for (int i = 0, j = 0; j < n;) {
                    if (i < n && st[i] * 1LL * mx[P - 1] <= 1LL * mx[p] * st[j]) {
                        ++i;
                    } else {
                        check[p][j++] = i;
                    }
                }
            }
        }
        if (type == 1) {
            CoolAdder::clear();
        }
        for (int i = 0; i < n; ++i) {
            auto query1 = [&](int p) {
                int pos = check[p][posi[i]];
                return i - CoolAdder::query(pos - 1);
//            int res = i - fn.sum(pos - 1);
//            return res;
            };
            auto query2 = [&](int p) {
//            return CoolAdder::query(need);
                int pos = check[p][posi[i]];
                return CoolAdder::query(pos - 1);
//            int res = fn.sum(pos - 1);
//            return res;
//            for (int j = 0; j < i; ++j) {
//                res += 1LL * mx[P - 1] * t[j] <= val;
//            }
//            return res;
            };
            int prv = 0;
            ll ans_now = 0;
            if (type == 0) {
                for (int p = 0; p < P; ++p) {
                    int now = query1(p);
                    ans_now += (now - prv) * 1LL * pos[p];
                    prv = now;
                }
            } else {
                for (int p = 0; p < P; ++p) {
                    int now = query2(p);
                    ans_now += 1LL * pos[p] * (now - prv);
                    prv = now;
                }
            }
            ans += ans_now;
            result[i] += ans;
            CoolAdder::add(std::lower_bound(st.begin(), st.end(), t[i]) - st.begin());
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << result[i] + 1LL * i * (i + 1) / 2 * m << '\n';
    }

    return 0;
}
