#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll smart(int n, int X, vector<int> a) {
    vector<ll> jumpL(n + 1), sumR(n + 1);
    vector<int> maxr(n + 1);
    maxr[n] = n;
    for (int i = 0; i < n; ++i) {
        int l = max(0, i - a[i]);
        int r = min(n - 1, i + a[i]);
        maxr[l] = max(maxr[l], r);
    }
    for (int i = 1; i < n; ++i) {
        maxr[i] = max(maxr[i], maxr[i - 1]);
    }
    for (int i = 0; i < n; ++i) {
        maxr[i] += 1;
    }
    for (int i = 0; i < n; ++i) {
        jumpL[maxr[i]] += jumpL[i] + 1;
    }
    for (int i = n - 1; i >= 0; --i) {
        sumR[i] = (n - i) + sumR[maxr[i]];
    }
    vector<ll> ans_suf(n + 1), ans_pref(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        ans_suf[i] = ans_suf[i + 1] + sumR[maxr[i]];
    }
    for (int i = 0; i < n; ++i) {
        ans_pref[i] = (i > 0 ? ans_pref[i - 1] : 0) + jumpL[i] * (n - i);
    }

    ll answer = ans_suf[0];
    auto work = [&](int l, int r) -> ll {
        if (maxr[l] > r) {
            return 3e18;
        }
        r += 1;
        int m = l;
        int lo = l, hi = r;
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (maxr[mid] >= r) {
                hi = mid;
            } else {
                lo = mid;
            }
        }
        m = hi;
        ll cnt_j = m - l;
        ll cnt_m = 0;
        ll add = 0;
        lo = -1, hi = l;
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (maxr[mid] < l) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        int L = hi;
        lo = L - 1, hi = l;
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (maxr[mid] < m) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        for (int i = L; i < hi; ++i) {
            cnt_j += jumpL[i] + 1;
            add += (n - maxr[i]) * (jumpL[i] + 1);
        }
        for (int i = hi; i < l; ++i) {
            cnt_m += (jumpL[i] + 1) * sumR[maxr[i]];
        }
//        for (int i = l - 1; i >= 0; --i) {
//            if (maxr[i] < l) {
//                break;
//            }
//            if (maxr[i] < m) {
//                cnt_j += jumpL[i] + 1;
//                add += (n - maxr[i]) * (jumpL[i] + 1);
//            } else {
//                cnt_m += (jumpL[i] + 1) * sumR[maxr[i]];
//            }
//        }
        ll cur = ans_suf[m] + cnt_j * sumR[r] + (l > 0 ? ans_pref[l - 1] : 0);
        cur += cnt_m + add;
        return cur;
    };

    for (int i = 0; i < n; ++i) {
        answer = min(answer, work(max(0, i - X), min(n - 1, i + X)));
    }

    return answer;
}

ll stupid(int n, int X, vector<int> a) {
    auto work = [&]() -> ll {
        vector<ll> dp(n + 1);
        vector<int> maxr(n);
        for (int i = 0; i < n; ++i) {
            int l = max(0, i - a[i]);
            int r = min(n - 1, i + a[i]);
            maxr[l] = max(maxr[l], r);
        }
        for (int i = 1; i < n; ++i) {
            maxr[i] = max(maxr[i], maxr[i - 1]);
        }
        for (int i = 0; i < n; ++i) {
            dp[maxr[i] + 1] += dp[i] + 1;
        }
        ll ans = 0;
        for (int i = n - 1; i >= 0; --i) {
            ans += dp[i] * (n - i);
        }
        return ans;
    };

    ll ans = work();

    if (X > 0) {
        for (int ch = 0; ch < n; ++ch) {
            swap(X, a[ch]);
            ans = min(ans, work());
            swap(X, a[ch]);
        }
    }

    return ans;
}

void stress() {
    mt19937 rnd(228);
    while (true) {
        int n = rnd() % 10 + 1, X = rnd() % (n + 1);
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            a[i] = rnd() % (n + 1);
        }
        auto sm = smart(n, X, a);
        auto st = stupid(n, X, a);
        if (sm != st) {
            cout << n << " " << X << endl;
            for (int x : a) {
                cout << x << " ";
            }
            cout << endl;
            cout << "smart: " << sm << endl << "stupid: " << st << endl;
            exit(0);
        }
        static int cnt = 0;
        if (++cnt % 100 == 0) {
            cout << "OK: " << cnt << endl;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

//    stress();

    int n, X;
    cin >> n >> X;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    auto res = smart(n, X, a);
    cout << res << '\n';
    return 0;

    vector<ll> jumpL(n + 1), sumR(n + 1);
    vector<int> maxr(n + 1);
    maxr[n] = n;
    for (int i = 0; i < n; ++i) {
        int l = max(0, i - a[i]);
        int r = min(n - 1, i + a[i]);
        maxr[l] = max(maxr[l], r);
    }
    for (int i = 1; i < n; ++i) {
        maxr[i] = max(maxr[i], maxr[i - 1]);
    }
    for (int i = 0; i < n; ++i) {
        maxr[i] += 1;
    }
    for (int i = 0; i < n; ++i) {
        jumpL[maxr[i]] += jumpL[i] + 1;
    }
    for (int i = n - 1; i >= 0; --i) {
        sumR[i] = (n - i) + sumR[maxr[i]];
    }
    vector<ll> ans_suf(n + 1), ans_pref(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        ans_suf[i] = ans_suf[i + 1] + sumR[maxr[i]];
    }
    for (int i = 0; i < n; ++i) {
        ans_pref[i] = (i > 0 ? ans_pref[i - 1] : 0) + jumpL[i] * (n - i);
    }

    ll answer = ans_suf[0];
    auto work = [&](int l, int r) -> ll {
        if (maxr[l] > r) {
            return 3e18;
        }
        r += 1;
        int m = l;
        while (maxr[m] < r) {
            m += 1;
        }
        ll cnt_j = m - l;
        ll cnt_m = 0;
        ll add = 0;
        for (int i = l - 1; i >= 0; --i) {
            if (maxr[i] < l) {
                break;
            }
            if (maxr[i] < m) {
                cnt_j += jumpL[i] + 1;
                add += (n - maxr[i]) * (jumpL[i] + 1);
            } else {
                cnt_m += (jumpL[i] + 1) * sumR[maxr[i]];
            }
        }
        ll cur = ans_suf[m] + cnt_j * sumR[r] + (l > 0 ? ans_pref[l - 1] : 0);
        cur += cnt_m + add;
//        cout << l << " " << r << ": " << cur << endl;
        return cur;
    };

    for (int i = 0; i < n; ++i) {
        answer = min(answer, work(max(0, i - X), min(n - 1, i + X)));
    }

    cout << answer << '\n';

    return 0;
}