#include <vector>
#include <set>
#include <tuple>
#include <algorithm>
#include <map>
#include <iostream>

using namespace std;
#define ll long long
const ll N = 1e5, inf = 1e18;
int n, m;
vector<int> t(N), s(N);
map<int, int> mp1, mp2;
struct segtree {
	vector<int> t;
	int g;
	segtree(int n) { g = n, t.assign(n * 2, 0); }
	void upd(int i, int x)
	{
		this -> t[i += this->g] += x;
		for (i = i >> 1; i > 0; i = i >> 1)
			this->t[i] = this->t[i << 1] + this->t[1 | (i << 1)];
	}
	int get(int l, int r)
	{
		l += this->g, r += this->g;
		int ans = 0;
		while (r > l)
		{
			if (l & 1)
				ans += this->t[l++];
			if (r & 1)
				ans += this->t[--r];
			l = l >> 1; r = r >> 1;
		}
		return ans;
	}
};
void compress(vector<int>& v, map<int, int>& mp)
{
	for (auto x : v)
		if (mp.count(x) == 0)
			mp[x] = mp.size();
}
int main()
{
	vector<int> w, w1;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> t[i], w1.push_back(t[i]);
	for (int i = 0; i < m; i++)
		cin >> s[i];
	for (int i = m - 1; i > 0; i--)
		s[i] = s[i] - s[i - 1];

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			w.push_back(s[i] * t[i]);
	compress(w, mp1);
	compress(w1, mp2);
	segtree t1(mp1.size()), t2(mp2.size());
	int ans = 0;
	for (int k = 0; k < n; k++)
	{
		ans += t2.get(0, mp2[t[k]] + 1) * 2 + t1.get(mp1[t[k] * s[0]] + 1, t1.g) + t2.get(mp2[t[k]] + 1, t2.g);
		cout << ans << '\n';
		t2.upd(mp2[t[k]], 1), t1.upd(mp1[max(t[k] * s[0], t[k] * s[1])], 1);
	}
}
