#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Edge
{
	int a;
	int b;
	int c;
};

vector<vector<int>> graph;
vector<int> visited;
vector<pair<int, int>> order;
bool ok = true;

void dfs(int me, int c)
{
	visited[me] = 1;
	order.emplace_back(me, 1 - c);
	for (int v : graph[me])
	{
		if (visited[v] == 1)
		{
			ok = false;
			return;
		}
		if (visited[v] == 0)
		{
			order.emplace_back(v, 1 - c);
			dfs(v, 1 - c);
			if (!ok)
				return;
		}
	}
	order.emplace_back(me, c);
	visited[me] = 2;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int tt;
	cin >> tt;
	for (int t = 0; t < tt; ++t)
	{
		int n, m;
		cin >> n >> m;
		graph = vector<vector<int>>(n);
		visited = vector<int>(n);
		order = vector<pair<int, int>>();
		ok = true;
		vector<Edge> e(m);
		for (int i = 0; i < m; ++i)
		{
			cin >> e[i].a >> e[i].b >> e[i].c;
		}
		vector<int> d(n);
		for (int i = 0; i < n; ++i)
			cin >> d[i];
		for (int i = 0; i < m; ++i)
		{
			if (d[e[i].a - 1] == d[e[i].b - 1])
			{
				if (e[i].c != d[e[i].a - 1])
				{
					ok = false;
					break;
				}
			}
			else
			{
				if (d[e[i].a - 1] != 0)
				{
					swap(e[i].a, e[i].b);
				}
				if (e[i].c == 1)
				{
					graph[e[i].a - 1].emplace_back(e[i].b - 1);
				}
				else
				{
					graph[e[i].b - 1].emplace_back(e[i].a - 1);
				}
			}
		}
		if (!ok)
		{
			cout << "NO\n";
			continue;
		}
		for (int i = 0; i < n; ++i)
		{
			if (visited[i] == 0)
			{
				dfs(i, d[i]);
			}
		}
		if (!ok)
		{
			cout << "NO\n";
			continue;
		}
		cout << "YES\n";
		cout << order.size() << '\n';
		for (int i = 0; i < order.size(); ++i)
		{
			cout << order[i].first + 1 << ' ' << order[i].second << '\n';
		}
	}
	return 0;
}
