#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

struct node {
	long long sum;
	long long left, right;
	node* l;
	node* r;
	node(int lef, int rig) {
		sum = 0;
		left = lef;
		right = rig;
		l = nullptr;
		r = nullptr;
	}
};
void add(node* root, long long tl, long long tr, long long val) {
	if (val < tl || val >= tr) {
		return;
	}
	++root->sum;
	if (tl == tr - 1) {
		return;
	}
	long long tm = (tl + tr) >> 1;
	if (root->l == nullptr) {
		root->l = new node(tl, tm);
		root->r = new node(tm, tr);
	}
	add(root->l, tl, tm, val);
	add(root->r, tm, tr, val);
}
long long get(node* u, long long tl, long long tr, long long ql, long long qr) {
	if (u == nullptr || tl >= qr || tr <= ql) {
		return 0;
	}
	if (ql <= tl && tr <= qr) {
		return u->sum;
	}
	const long long tm = (tl + tr) >> 1;
	return get(u->l, tl, tm, ql, qr) + get(u->r, tm, tr, ql, qr);
}
int main() {
	int n, m;
	std::cin >> n >> m;
	if (n == 1) {
		std::cout << "0\n";
		return 0;
	}
	std::vector<long long> v(n);
	for (long long& i : v) {
		std::cin >> i;
	}
	long long l1, l2;
	std::cin >> l1 >> l2;
	l2 -= l1;
	std::vector<int> cnt(1e5 + 1);
	long long ans = 0;
	const int max_p = (1ll << 62);
	node* root = new node(0, max_p);
	for (int i = 0; i < n; ++i) {
		if (i == n - 3) {
			--i;
			++i;
		}
		ans += get(root, 0, max_p, l1 * v[i] + 1, l2 * v[i] + 1);
		add(root, 0, max_p, v[i] * l1);
		add(root, 0, max_p, v[i] * l2);
		++cnt[v[i]];
		std::cout << ans + (i * (i + 1)) << '\n';
	}
}
/*
14 2
1 3 2 19 6 10 128 50 291 92 9 40 60 1
2 10

0
3
9
15
26
39
51
67
84
105
129
155
184
213

0
3
9
15
26
39
51
67
84
105
129
155
184
213
*/