#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

struct lec {
	int l, r;
};
bool operator<(const lec& a, const lec& b) {
	if (a.l == b.l) {
		return a.r < b.r;
	}
	return a.l < b.l;
}
int n;
std::set<lec> p;
std::vector<long long> dp;
long long get() {
	std::vector<int> next(n);
	int r = 0;
	auto j = p.begin();
	for (int i = 0; i < n; ++i) {
		while (j != p.end() && j->l <= i) {
			r = std::max(r, j->r);
			++j;
		}
		next[i] = r + 1;
	}
	dp[n] = 0;
	long long ans = 0;
	for (int i = n - 1; i >= 0; --i) {
		dp[i] = dp[next[i]] + (n - next[i]);
		ans += dp[i];
	}
	return ans;
}
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int x;
	std::cin >> n >> x;
	std::vector<int> a(n);
	dp.resize(n + 1);
	for (int i = 0; i < n; ++i) {
		std::cin >> a[i];
		p.insert({std::max(0, i - a[i]), std::min(n - 1, i + a[i])});
	}
	int st = (n >> 1);
	lec t = { std::max(0, st - x), std::min(n - 1, st + x) });
	p.insert(t);
	long long ans = get();
	std::cout << ans << '\n';
}