#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

const ll INF=1e9;

struct Edge {
    ll u,c;
};

ll n,m;

vector<ll> dc;

bool dfs(vector<vector<ll>> &g,ll v,ll col) {
    if(dc[v]==col) {return false;}
    if(dc[v]!=-1) {return true;}
    dc[v]=col;
    for(auto u:g[v]) {
        if(!dfs(g,u,col)) {return false;}
    }
    return true;
}

void solve() {
    cin>>n>>m;
    vector<vector<Edge>> g(n);
    for(int i=0;i<m;i++) {
        ll v,u,c;
        cin>>v>>u>>c;v--;u--;
        g[v].push_back({u,c});
        g[u].push_back({v,c});
    }
    vector<ll> vc(n);
    for(int i=0;i<n;i++) {
        cin>>vc[i];
    }
    vector<vector<ll>> gg(n);
    for(int v=0;v<n;v++) {
        for(auto [u,c]:g[v]) {
            if(vc[v]==1 && vc[u]==0 && c==1) {gg[v].push_back(u);}
            if(vc[v]==0 && vc[u]==1 && c==0) {gg[v].push_back(u);}
        }
    }
    dc.assign(n,-1);
    for(int i=0;i<n;i++) {
        if(!dfs(gg,i,i)) {
            cout<<"NO\n";
            return;
        }
    }
    cout<<"YES\n-1\n";
}

signed main() {
    ll t=1;
    cin>>t;
    while(t--) {
        solve();
    }
}
