#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

template<typename T> ostream &operator<<(ostream& s,vector<T> v) {
    for(auto &i:v) {
        s<<i<<' ';
    }
    return s;
}

const ll INF=1e9;

struct Edge {
    ll u,c;
};

ll n,m;

vector<ll> dc;
vector<ll> ts;

bool dfs(vector<vector<ll>> &g,ll v) {
    if(dc[v]==0) {return false;}
    if(dc[v]==1) {return true;}
    dc[v]=0;
    for(auto u:g[v]) {
        if(!dfs(g,u)) {return false;}
    }
    dc[v]=1;
    ts.push_back(v);
    return true;
}

void solve() {
    cin>>n>>m;
    vector<vector<Edge>> g(n);
    for(int i=0;i<m;i++) {
        ll v,u,c;
        cin>>v>>u>>c;v--;u--;
        g[v].push_back({u,c});
        g[u].push_back({v,c});
    }
    vector<ll> vc(n);
    for(int i=0;i<n;i++) {
        cin>>vc[i];
    }
    vector<vector<ll>> gg(n);
    bool ok1=true;
    for(int v=0;v<n;v++) {
        for(auto [u,c]:g[v]) {
            if(vc[v]==1 && vc[u]==0 && c==1) {gg[v].push_back(u);}
            if(vc[v]==0 && vc[u]==1 && c==0) {gg[v].push_back(u);}
            if(vc[v]==vc[u] && c!=vc[v]) {ok1=false;}
        }
    }
    if(!ok1) {cout<<"NO\n";return;}
    dc.assign(n,-1);
    ts.clear();
    ts.reserve(n);
    for(int i=0;i<n;i++) {
        if(dc[i]==-1 && !dfs(gg,i)) {
            cout<<"NO\n";
            return;
        }
    }
    debug(1)
    debug(ts)
    reverse(ts.begin(),ts.end());
    cout<<"YES\n";
    vector<pair<ll,ll>> ans;
    for(auto v:ts) {
        ans.push_back({v+1,1});
        if(vc[v]==0) {
            ans.push_back({v+1,0});
        }
    }
    cout<<ans.size()<<'\n';
    for(auto [v,c]:ans) {
        cout<<v<<' '<<c<<'\n';
    }
}

signed main() {
    ll t=1;
    cin>>t;
    while(t--) {
        solve();
    }
}
