#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;

typedef long long ll;

template<typename T> istream &operator>>(istream& s,vector<T> &v) {
    for(auto &i:v) {
        s>>i;
    }
    return s;
}

template<typename T> ostream &operator<<(ostream& s,vector<T> &v) {
    for(auto &i:v) {
        s<<i<<' ';
    }
    return s;
}

const ll INF=1e9;

struct Dr {
    ll n,m;
};

bool operator< (Dr a,Dr b) {
    return a.n*b.m<b.n*a.m;
}

void solve() {
    ll n,m;
    cin>>n>>m;
    vector<ll> t(n);
    vector<ll> s(m);
    vector<ll> d(m);
    cin>>t>>s;
    d[0]=s[0];
    ll mx=0;
    for(int i=1;i<m;i++) {
        d[i]=s[i]-s[i-1];
        if(d[i]>d[mx]) {mx=i;}
    }
    for(ll i=0;i<n;i++) {
        cout<<i*(i+1)*mx+i*(i+1)/2*(m-mx)<<'\n';
    }
}

signed main() {
    ll t=1;
    while(t--) {
        solve();
    }
}
