#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;

typedef long long ll;

template<typename T> istream &operator>>(istream& s,vector<T> &v) {
    for(auto &i:v) {
        s>>i;
    }
    return s;
}

template<typename T> ostream &operator<<(ostream& s,vector<T> &v) {
    for(auto &i:v) {
        s<<i<<' ';
    }
    return s;
}

const ll INF=1e9;

vector<ll> tree;
vector<ll> tree2;

void build(vector<ll> &tree,ll v,ll l,ll r) {
    if(r-l==1) {
        tree[v]=0;
        return;
    }
    ll m=(r+l)/2;
    build(tree,v*2+1,l,m);
    build(tree,v*2+2,m,r);
    tree[v]=0;
}

void chg(vector<ll> &tree,ll v,ll l,ll r,ll q,ll val) {
    if(r<=q || l>q) {return;}
    if(r-l==1) {tree[v]+=val;return;}
    ll m=(r+l)/2;
    chg(tree,v*2+1,l,m,q,val);
    chg(tree,v*2+2,m,r,q,val);
    tree[v]=tree[v*2+1]+tree[v*2+2];
}

ll gt(vector<ll> &tree,ll v,ll l,ll r,ll ql,ll qr) {
    if(l>=qr || ql>=r) {return 0;}
    if(l>=ql && r<=qr) {return tree[v];}
    ll m=(r+l)/2;
    return gt(tree,v*2+1,l,m,ql,qr)+gt(tree,v*2+2,m,r,ql,qr);
}


struct Dr {
    ll n,m;
};

bool operator< (Dr a,Dr b) {
    return a.n*b.m<b.n*a.m;
}

void solve() {
    ll n,m;
    cin>>n>>m;
    vector<ll> t(n);
    vector<ll> s(m);
    vector<ll> d(m);
    cin>>t>>s;
    d[0]=s[0];
    for(int i=1;i<m;i++) {
        d[i]=s[i]-s[i-1];
    }
    set<pair<Dr,ll>> dsts;
    for(int i=0;i<n;i++) {
        dsts.insert({{d[0],t[i]},-i});
    }
    ll ans=0;
    vector<ll> pos(n,0);
    vector<ll> ord;
    while(!dsts.empty()) {
        ll v=-dsts.begin()->second;
        ans+=dsts.size()-1;
        debug(v)
        debug(dsts.size())
        dsts.erase({{d[pos[v]],t[v]},-v});
        pos[v]++;
        if(pos[v]!=m) {
            dsts.insert({{d[pos[v]],t[v]},-v});
        }
        ord.push_back(v);
    }
    debug(ord)
    ll os=ord.size();
    tree.resize(os*4);
    tree2.resize(os*4);
    build(tree,0,0,os);
    build(tree2,0,0,os);
    ans=0;
    vector<vector<ll>> oind(n);
    for(int i=0;i<ord.size();i++) {
        oind[ord[i]].push_back(i);
    }
    for(auto i:oind) {
        debug(i)
    }
    for(int k=0;k<n;k++) {
        for(auto i:oind[k]) {
            ans+=gt(tree,0,0,os,0,i+1);
            debug(1)
            debug(ans)
        }
        //ans+=lidx.lower_bound(oind[k].back())-lidx.begin();
        ans+=gt(tree2,0,0,os,0,oind[k].back());
        debug(2)
        debug(ans)
        for(auto i:oind[k]) {
            chg(tree2,0,0,os,i,1);
        }
        chg(tree,0,0,os,0,1);
        chg(tree,0,0,os,oind[k].back(),-1);
        cout<<ans<<'\n';
        /*ans=0;
        ll cnt=k;
        for(auto &i:pos) {i=0;}
        for(auto i:ord) {
            if(i>k) {continue;}
            ans+=cnt;
            if(++pos[i]==m) {cnt--;}
        }
        cout<<ans<<'\n';*/
    }
    //cout<<ans;
}

signed main() {
    ll t=1;
    while(t--) {
        solve();
    }
}
