#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;

typedef long long ll;

template<typename T> istream &operator>>(istream& s,vector<T> &v) {
    for(auto &i:v) {
        s>>i;
    }
    return s;
}

template<typename T> ostream &operator<<(ostream& s,vector<T> &v) {
    for(auto &i:v) {
        s<<i<<' ';
    }
    return s;
}

const ll INF=1e9;
ll n,x;

ll get_ans(vector<ll> &a) {
    vector<pair<ll,ll>> segs(n);
    for(int i=0;i<a.size();i++) {
        segs[i]={i-a[i],i+a[i]};
    }
    sort(segs.begin(),segs.end());
    vector<ll> nxt(n);
    int j=0;
    ll mx=0;
    for(int i=0;i<n;i++) {
        while(j<n && segs[j].first<=i) {
            mx=max(mx,segs[j].second+1);j++;
        }
        nxt[i]=mx;
        debug(nxt[i])
    }
    vector<ll> dp(n);
    ll sum=0;
    for(int i=n-1;i>=0;i--) {
        if(nxt[i]>=n) {dp[i]=0;}
        else {
            dp[i]=dp[nxt[i]]+n-nxt[i];
        }
        debug(dp[i])
        sum+=dp[i];
    }
    return sum;
}

void solve() {
    cin>>n>>x;
    vector<ll> a(n);
    cin>>a;
    cout<<get_ans(a)<<'\n';
}

signed main() {
    ll t=1;
    while(t--) {
        solve();
    }
}
