// Batta Negra.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void build(int v, int vl, int vr, vector<int>& V, vector<pair<int, int>>& slf) {
	if (vl + 1 == vr and vl < V.size())slf[v] = { V[vl], vl };
	else if (vl + 1 == vr)return;
	else {
		int vm = (vl + vr) / 2;
		build(2 * v, vl, vm, V, slf);
		build(2 * v + 1, vm, vr, V, slf);
		slf[v] = min(slf[2 * v], slf[2 * v + 1]);
	}
	//cout << "!" << v << " " << slf[v].first << " " << slf[v].second;
}

void make_SegTree(vector<int> v, vector<pair<int, int>>& slf) {
	int n = 1;
	while (n < v.size())n *= 2;
	slf.assign(2 * n, { 1e9, -1 });
	build(1, 0, n, v, slf);
}



pair<int, int> get(vector<pair<int, int>>& slf) {
	return slf[1];
}

void add(int n, int z, int v, int vl, int vr, vector<pair<int, int>>& slf) {
	if (n < vl or n >= vr)return;
	if (vl + 1 == vr)slf[v].first += z;
	else {
		int vm = (vl + vr) / 2;
		add(n, z, 2 * v, vl, vm, slf);
		add(n, z, 2 * v + 1, vm, vr, slf);
		slf[v] = min(slf[2 * v], slf[2 * v + 1]);
	}
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n, m;
		cin >> n >> m;
		vector<vector<pair<int, int>>> V(n, vector<pair<int, int>>());
		for (int i = 0; i < m; i++) {
			int a, b, c;
			cin >> a >> b >> c;
			V[a - 1].push_back({ b - 1, c });
			V[b - 1].push_back({ a - 1, c });
		}
		vector<int> d(n);
		for (auto& i : d)cin >> i;
		int n0 = 0, n1 = 0;
		vector<int> Zs_(n, 1e9), Os_(n, 1e9);
		for (int i = 0; i < n; i++) {
			int cnt = 0, cnt_ = 0;
			for (auto& j : V[i]) {
				if (d[j.first] != d[i] and j.second != d[i]) {
					cnt++;
				}
				if (d[j.first] != d[i]) {
					cnt_++;
				}
			}
			//cout << i << " " << cnt << " " << cnt_ << endl;
			if (d[i] == 0) {
				Zs_[i] = cnt_ - cnt;
			}
			else Os_[i] = cnt_ - cnt;
		}
		vector<pair<int, int>> Zs, Os;
		make_SegTree(Zs_, Zs), make_SegTree(Os_, Os);
		vector<pair<int, int>> ANS;
		int Zc = 0, Oc = 0;
		vector<pair<int, int>> Ch;
		int Pos0 = 0, Pos1 = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < V[i].size(); j++) {
				if (V[i][j].second != d[i] and V[i][j].second != d[V[i][j].first]) {
					cout << "NO";
					goto end;
				}
			}
		}
		//cout << "YES";

		for (int i = 0; i < n; i++) {
			ANS.push_back({ i, d[i] });
			if (d[i] == 0)n0++;
			else n1++;
		}
		while (1) {
			auto G0 = get(Zs), G1 = get(Os);
			if (G0.first >= 3e8 and G1.first >= 3e8)break;
			if (G0.first == 0) {
				Ch.push_back({ G0.second, 1 });
				for (auto& i : V[G0.second]) {
					add(i.first, -1, 1, 0, Os.size() / 2, Os);
				}
				add(G0.second, 1e9, 1, 0, Zs.size() / 2, Zs);
			}
			else if (G1.first == 0) {
				Ch.push_back({ G1.second, 0 });
				for (auto& i : V[G1.second]) {
					add(i.first, -1, 1, 0, Zs.size() / 2, Zs);
				}
				add(G1.second, 1e9, 1, 0, Os.size() / 2, Os);
			}
			else {
				cout << "NO\n";
				goto end;
			}
		}
		for (auto& i : Ch)ANS.push_back(i);
		reverse(Ch.begin(), Ch.end());
		for (auto& i : Ch)i.second = 1 - i.second;
		for (auto& i : Ch)ANS.push_back(i);
		cout << "YES\n";
		cout << ANS.size() << endl;
		for (auto& i : ANS)cout << i.first + 1 << " " << i.second << endl;
	end:;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
