#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const int N = 1e5 + 5;
vector<int> g[N];
int n, m;
int clr[N];
int needClr[N];

struct Edge {int a, b, c;};
vector<Edge> edges, edges2;
vector<pair<int, int>> res;

inline void change(int v) {
    res.push_back({v + 1, clr[v] ^ 1});
    clr[v] ^= 1;
    for (int edgeId : g[v]) {
        int a = edges[edgeId].a;
        int b = edges[edgeId].b;
        int to = (a == v ? b : a);
        if (clr[v] == clr[to]) {
            edges[edgeId].c = clr[v];
        }
    }
}

inline int get(int v) {
    return clr[v];
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) g[i].clear();
    for (int i = 0; i < n; ++i) clr[i] = needClr[i] = 0;
    edges.clear();
    edges.resize(m);
    edges2.clear();
    res.clear();
    edges2.resize(m);
    bool bad_res = false;
    for (int i = 0; i < m; ++i) {
        cin >> edges[i].a >> edges[i].b;
        edges[i].a--; edges[i].b--;
        edges2[i].a = edges[i].a;
        edges2[i].b = edges[i].b;
        edges[i].c = 0;
        cin >> edges2[i].c;
        g[edges[i].a].push_back(i);
        g[edges[i].b].push_back(i);
    }
    for (int i = 0; i < n; ++i) cin >> needClr[i];
    for (int i = 0; i < m; ++i) {
        int a = edges[i].a, b = edges[i].b;
        if (needClr[a] == needClr[b] && needClr[a] != edges2[i].c) {
            bad_res = true;
            break;
        }
    }
    if (bad_res) {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < m; ++i) {
        int a = edges[i].a, b = edges[i].b, c = edges2[i].c;
        if (c == 1 && (needClr[a] ^ needClr[b]) == 1) {
            if (needClr[b] == 1) swap(a, b);
            if (get(a) == 1) {
                change(b);
                change(b);
            } else {
                change(a);
                change(b);
                change(b);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (get(i) != needClr[i] && needClr[i] == 1) change(i);
    }
    for (int i = 0; i < m; ++i) {
        if (edges[i].c != edges2[i].c) {
            bad_res = true;
            break;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (get(i) != needClr[i]) {
            bad_res = true;
            break;
        }
    }
    if (bad_res) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << res.size() << '\n';
        for (auto &[a, b] : res) {
            cout << a << ' ' << b << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
