#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const int N = 1e5 + 5;
vector<int> g[N];
int n, m;
int clr[N];
int needClr[N];

struct Edge {int a, b, c, c2; };
vector<Edge> edges;
vector<pair<int, int>> res;

inline void change(int v) {
    res.push_back({v + 1, clr[v] ^ 1});
    clr[v] ^= 1;
    for (int edgeId : g[v]) {
        int a = edges[edgeId].a;
        int b = edges[edgeId].b;
        int to = (a == v ? b : a);
        if (clr[v] == clr[to]) {
            edges[edgeId].c = clr[v];
        }
    }
}

inline int get(int v) {
    return clr[v];
}

int used[N];

void dfs(int v) {
    used[v] = 1;
    if (needClr[v] == 0) {
        change(v);
        change(v);
        for (int toId: g[v]) {
            int a = edges[toId].a, b = edges[toId].b, c = edges[toId].c, c2 = edges[toId].c2;
            int to = (a == v ? b : a);
            if (used[to]) continue;
            dfs(to);
        }
    } else {
        for (int toId : g[v]) {
            int a = edges[toId].a, b = edges[toId].b, c = edges[toId].c, c2 = edges[toId].c2;
            int to = (a == v ? b : a);
            if (used[to]) continue;
            if (needClr[a] == 1 && needClr[b] == 1) continue;
            if (needClr[to] == 0 && c2 == 0) dfs(to);
        }
        change(v);
        for (int toId : g[v]) {
            int a = edges[toId].a, b = edges[toId].b, c = edges[toId].c, c2 = edges[toId].c2;
            int to = (a == v ? b : a);
            if (used[to]) continue;
            if (needClr[a] == 1 && needClr[b] == 1) continue;
            if (needClr[to] == 0 && c2 == 1) dfs(to);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) g[i].clear();
    for (int i = 0; i < n; ++i) clr[i] = needClr[i] = 0;
    edges.clear();
    edges.resize(m);
    res.clear();
    bool bad_res = false;
    int cc = 0;
    for (int i = 0; i < m; ++i) {
        cin >> edges[i].a >> edges[i].b >> edges[i].c2;
        edges[i].a--; edges[i].b--;
        edges[i].c = 0;
        cc += edges[i].c2;
        g[edges[i].a].push_back(i);
        g[edges[i].b].push_back(i);
    }
    for (int i = 0; i < n; ++i) cin >> needClr[i];
    for (int i = 0; i < m; ++i) {
        int a = edges[i].a, b = edges[i].b;
        if (needClr[a] == needClr[b] && needClr[a] != edges[i].c2) {
            bad_res = true;
            break;
        }
    }
    if (bad_res) {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && needClr[i] == 1) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (get(i) != needClr[i]) change(i);
    }
    for (int i = 0; i < m; ++i) {
        if (edges[i].c != edges[i].c2) {
            bad_res = true;
            break;
        }
    }
    if (bad_res) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << res.size() << '\n';
        for (auto &[a, b] : res) {
            cout << a << ' ' << b << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
