#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

struct SegmentTree {
    int size;
    vector<int> tree;
    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }
    void update(int lx, int rx, int x, int l, int r, int v) {
        if (rx <= l || r <= lx) return;
        if (lx <= l && r <= rx) {
            tree[v] = std::max(tree[v], x);
            return;
        }
        int m = (l + r) >> 1;
        update(lx, rx, x, l, m, 2 * v + 1);
        update(lx, rx, x, m, r, 2 * v + 2);
    }
    void update(int l, int r, int x) {
        update(l, r, x, 0, size, 0);
    }
    int get(int i, int l, int r, int v) {
        if (l + 1 == r) return tree[v];
        int m = (l + r) >> 1;
        return std::max((i < m ? get(i, l, m, 2 * v + 1) : get(i, m, r, 2 * v + 2)), tree[v]);
    }
    int get(int i) {
        return get(i, 0, size, 0);
    }
};

mt19937 rnd(12873);

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    vector<int> mx(n);
    for (int &i : a) cin >> i;
    auto calc = [&]() {
        ll res = 0;
        vector<pair<ll, ll>> dp(n);
        for (int i = n - 1; i >= 0; --i) {
            if (mx[i] + 1 == n) {
                dp[i] = {n - i, 0};
            } else {
                dp[i].first = dp[mx[i] + 1].first + (mx[i] + 1 - i);
                dp[i].second = dp[mx[i] + 1].second + dp[mx[i] + 1].first;
            }
            res += dp[i].second;
        }
        return res;
    };
    auto build = [&]() {
        for (int i = 0; i < n; ++i) mx[i] = i;
        SegmentTree st;
        st.init(n);
        for (int i = 0; i < n; ++i) {
            int l = max(i - a[i], 0);
            int r = min(n - 1, i + a[i]);
            st.update(l, r + 1, r);
        }
        for (int i = 0; i < n; ++i) mx[i] = st.get(i);
    };
    build();
    ll sum = calc();
    ll start = clock();
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    shuffle(ord.begin(), ord.end(), rnd);
    int pointer = 0;
    while (pointer < n && double(clock() - start) < 2.8) {
        int id = ord[pointer++];
        if (a[id] >= x) continue;
        int t = a[id];
        a[id] = x;
        build();
        sum = min(sum, calc());
        a[id] = t;
    }
    cout << sum;
}