#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

struct SegmentTree {
    int size;
    vector<int> tree;
    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }
    void update(int lx, int rx, int x, int l, int r, int v) {
        if (rx <= l || r <= lx) return;
        if (lx <= l && r <= rx) {
            tree[v] = std::max(tree[v], x);
            return;
        }
        int m = (l + r) >> 1;
        update(lx, rx, x, l, m, 2 * v + 1);
        update(lx, rx, x, m, r, 2 * v + 2);
    }
    void update(int l, int r, int x) {
        update(l, r, x, 0, size, 0);
    }
    int get(int i, int l, int r, int v) {
        if (l + 1 == r) return tree[v];
        int m = (l + r) >> 1;
        return std::max((i < m ? get(i, l, m, 2 * v + 1) : get(i, m, r, 2 * v + 2)), tree[v]);
    }
    int get(int i) {
        return get(i, 0, size, 0);
    }
};

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    vector<int> mx(n);
    for (int &i : a) cin >> i;
    auto get = [&](int s, int t) {
        int changes = 0;
        s = mx[s];
        while (s < t) {
            s++;
            changes++;
            if (s < t) s = mx[s];
        }
        return changes;
    };
    auto calc = [&]() {
        vector<int> groups;
        int i = 0;
        ll res = 0;
        while (i < n) {
            int j = i;
            while (j + 1 < n && mx[j] == mx[j + 1]) ++j;
            groups.push_back(j - i + 1);
            i = j + 1;
        }
        ll sum = 0;
        vector<int> pref(groups.size());
        for (int i = 0; i < groups.size(); ++i) {
            sum += i * 1ll * groups[i];
            pref[i] = groups[i];
        }
        for (int i = groups.size() - 2; i >= 0; --i) pref[i] += pref[i + 1];
        for (int i = 0; i + 1 < groups.size(); ++i) {
            res += sum * groups[i];
            sum -= pref[i + 1];
        }
        return res;
    };
    auto build = [&]() {
        for (int i = 0; i < n; ++i) mx[i] = i;
        SegmentTree st;
        st.init(n);
        for (int i = 0; i < n; ++i) {
            int l = max(i - a[i], 0);
            int r = min(n - 1, i + a[i]);
            st.update(l, r + 1, r);
        }
        for (int i = 0; i < n; ++i) mx[i] = st.get(i);
    };
    build();
    ll sum = calc();
    for (int i = 0; i < n; ++i) {
        int t = a[i];
        a[i] = x;
        build();
        sum = min(sum, calc());
        a[i] = t;
    }
    cout << sum;
}
