#include <bits/stdc++.h>

using namespace std;

#define int long long
const int inf = 1e18;
using pii = pair<int, int>;

struct edge{
    int v, u, c;
};

vector<pii> ans;

void dfs(int v, int par, vector<vector<pii>> &gr, vector<int> &d) {
    if (par != -1) {
        if (gr[v].size() == 1) {
            if (d[v] == 1) {
                ans.push_back({v + 1, d[v]});
            }
            return;
        }
    }
    if (par == -1 && gr[v].size() == 0) {
        if (d[v] == 1) {
            ans.push_back({v + 1, d[v]});
        }
        return;
    }
    if (d[v] == 0) {
        vector<int> f, s;
        for (pii p : gr[v]) {
            int u = p.first;
            if (u == par) continue;
            if (d[u] == 1) {
                if (p.second == 1) {
                    f.push_back(u);
                } else {
                    s.push_back(u);
                }
            } else {
                s.push_back(u);
            }
        }
        ans.push_back({v + 1, 1});
        for (int u : f) dfs(u, v, gr, d);
        ans.push_back({v + 1, 0});
        for (int u : s) dfs(u, v, gr, d);
    } else {
        vector<int> f;
        for (pii p : gr[v]) {
            int u = p.first;
            if (u == par) continue;

            if (d[u] == 0 && p.second == 0) {
                dfs(u, v, gr, d);
            } else {
                f.push_back(u);
            }
        }
        ans.push_back({v + 1, 1});
        for (int u : f) {
            if (d[u] == 0) {
                ans.push_back({u + 1, 1});
                ans.push_back({u + 1, 0});
            }
        }
        for (int u : f) {
            dfs(u, v, gr, d);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> e;
    vector<vector<pii>> gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u, c;
        cin >> v >> u >> c;

        v--;
        u--;
        e.push_back({v, u, c});
        gr[v].push_back({u, c});
        gr[u].push_back({v, c});
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[e[i].v] == 0 && d[e[i].u] == 0) {
            if (e[i].c == 1) {
                cout << "NO" << endl;
                return;
            }
        } else if (d[e[i].v] == 1 && d[e[i].u] == 1) {
            if (e[i].c == 0) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    dfs(0, -1, gr, d);
    cout << ans.size() << endl;
    for (pii p : ans) {
        cout << p.first << " " << p.second << endl;
    }
    ans.clear();
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int ttp = 1;
    cin >> ttp;
    while (ttp--) {
        solve();
        //cout << endl;
    }
}