#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define pii pair<int, int>
#define ff first
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

const int INF = 1e9 + 7;

vector<pii> ans;
vector < vector<set<int>>> g;

set<vi> bad;
vector<int> need, used, col_v;

vector<pii> lol;

bool dfs(int v) {
	int x = col_v[v];
	int c;
	if (x == 0) c = 1;
	else c = 2;

	used[v] = 1;

	for (auto& u : g[v][c]) {
		if (used[u]) return 0;
		int f = dfs(u);
		if (!f)return 0;
	}

	ans.push_back({ v, 1 - x });
	ans.push_back({ v, x });
	return 1;
}

void write() {
	cout << "YES\n";
	cout << ans.size() << "\n";
	for (auto& el : ans) {
		cout << el.ff + 1 << " " << el.ss << "\n";
	}
	cout << "\n";
}

void solve() {
	int n; cin >> n;
	int m; cin >> m;

	g.clear();
	g.resize(n, vector<set<int>>(4));
	vvi edges;
	for (int i = 0; i < m; ++i) {
		int v, u, x;
		cin >> v >> u >> x;
		v--; u--;
		edges.push_back({ v, u, x });
	}

	col_v.clear();
	col_v.resize(n);
	for (auto& i : col_v) cin >> i;

	bad.clear();
	for (auto& el : edges) {
		int v = el[0], u = el[1], x = el[2];
		if (col_v[v] == col_v[u] && col_v[v] != x) {
			cout << "NO\n";
			return;
		}

		if (col_v[v] != col_v[u]) bad.insert(el);

		int c1 = 2 * x + col_v[u];
		g[v][c1].insert(u);
		int c2 = 2 * x + col_v[v];
		g[u][c2].insert(v);
	}

	ans.clear();
	for (int i = 0; i < n; ++i) {
		if (col_v[i]) ans.push_back({ i, 1 });
	}


	used.clear();
	used.resize(n, 0);

	for (int i = 0; i < n; ++i) {
		int x = col_v[i];
		int c;
		if (x == 0) c = 3;
		else c = 0;

		if (x == 0 && g[i][c].size() != 0 && !used[i]) {
			int f = dfs(i);
			if (f == 0) {
				cout << "NO\n";
				return;
			}
		}
	}

	write();
}

signed main()
{
	int t; cin >> t;
	while (t--) {
		solve();
	}
}
