#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define ff first
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

const int INF = 1e9 + 7;

vector<pii> ans;
vector < vector<set<int>>> g;
vi col_v, used;

void dfs(int v, int p) {
	int x = col_v[v];
	int c;
	if (x == 0) {
		for (auto& u : g[v][1]) {
			if (u == p) continue;
			ans.push_back({ u, 0 });
		}

		ans.push_back({ v, 1 });
		for (auto& u : g[v][3]) {
			if (u == p) continue;
			dfs(u, v);
		}

		ans.push_back({ v, 0 });

		for (auto& u : g[v][1]) {
			if (u == p) continue;
			ans.push_back({ u, 1 });
		}

		for (auto& u : g[v][1]) {
			if (u == p) continue;
			dfs(u, v);
		}

		for (auto& u : g[v][0]) {
			if (u == p) continue;
			dfs(u, v);
		}
	}
	else {
		for (auto& u : g[v][2]) {
			if (u == p) continue;
			ans.push_back({ u, 1 });
		}

		ans.push_back({ v, 0 });
		for (auto& u : g[v][0]) {
			if (u == p) continue;
			dfs(u, v);
		}

		ans.push_back({ v, 1 });

		for (auto& u : g[v][2]) {
			if (u == p) continue;
			ans.push_back({ u, 0 });
		}

		for (auto& u : g[v][2]) {
			if (u == p) continue;
			dfs(u, v);
		}

		for (auto& u : g[v][3]) {
			if (u == p) continue;
			dfs(u, v);
		}
	}
}

void write() {
	cout << "YES\n";
	cout << ans.size() << "\n";
	for (auto& el : ans) {
		cout << el.ff + 1 << " " << el.ss << "\n";
	}
	cout << "\n";
}

void solve() {
	int n; cin >> n;
	int m; cin >> m;

	vvi edges;
	for (int i = 0; i < m; ++i) {
		int v, u, x;
		cin >> v >> u >> x;
		v--; u--;
		edges.push_back({ v, u, x });
	}

	ans.clear();
	col_v.clear();
	col_v.resize(n);
	g.clear();
	g.resize(n, vector < set<int>>(4));
	for (auto& i : col_v) cin >> i;

	for (int i = 0; i < n; ++i) {
		if (col_v[i]) ans.push_back({ i, 1 });
	}

	for (auto& el : edges) {
		int v = el[0], u = el[1], x = el[2];
		if (col_v[v] == col_v[u] && col_v[v] != x) {
			cout << "NO\n";
			return;
		}

		int c1 = 2 * x + col_v[u];
		g[v][c1].insert(u);
		int c2 = 2 * x + col_v[v];
		g[u][c2].insert(v);
	}

	dfs(0, 0);
	cout << "YES\n";
	write();
}

signed main()
{
	int t; cin >> t;
	while (t--) {
		solve();
	}
}