#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int int64_t

using ll = int64_t;
using pii = pair<int, int>;

vector<int> c, d;
vector<pii> edges;
vector<vector<pii>> g;
vector<pii> ans;
vector<int> curc, curd;

bool found = false;
vector<int> used;
void circledfs(int v) {
	used[v] = 1;
	for (auto pa : g[v]) {
		int to = pa.first;
		if (used[to] == 0) {
			circledfs(to);
		} else if (used[to] == 1) {
			found = true;
		}
	}
	used[v] = 2;
}

vector<int> deg;
void dfs(int v) {
	if (deg[v] != 0) {
		return;
	}
	used[v] = 1;
	for (auto pa : g[v]) {
		int to = pa.first, ind = pa.second;
		if (used[to] == 0) {
			if (c[ind] != curc[ind]) {
				if (curd[v] != c[ind]) {
					ans.push_back({ v, c[ind] });
					curd[v] = c[ind];
				}
				if (curd[to] != c[ind]) {
					ans.push_back({ to, c[ind] });
					curd[to] = c[ind];
				}
				if (curd[v] != d[v]) {
					ans.push_back({ v, d[v] });
					curd[v] = d[v];
				}
				if (curd[to] != d[to]) {
					ans.push_back({ to, d[to] });
					curd[to] = d[to];
				}
			}
			deg[to]--;
			dfs(to);
		}
	}
	if (curd[v] != d[v]) {
		ans.push_back({ v, d[v] });
		curd[v] = d[v];
	}
}

void solve() {
	c.clear(), d.clear();
	edges.clear(), g.clear();
	ans.clear(), curc.clear(), curd.clear();
	found = false;
	used.clear();
	deg.clear();

	int n, m;
	cin >> n >> m;
	g.resize(n);
	c.resize(m), d.resize(n);
	edges.resize(m);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v >> c[i];
		u--, v--;
		edges[i] = { u, v };
	}
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}

	

	bool ok = true;
	for (int i = 0; i < m; i++) {
		if (c[i] == 1 && d[edges[i].first] == 0 && d[edges[i].second] == 0 ||
				c[i] == 0 && d[edges[i].first] == 1 && d[edges[i].second] == 1) {
			ok = false;
		}
	}

	if (!ok) {
		cout << "NO\n";
		return;
	}

	for (int i = 0; i < m; i++) {
		if (d[edges[i].first] == d[edges[i].second]) {
			continue;
		}
		if (d[edges[i].first] == c[i]) {
			g[edges[i].first].push_back({ edges[i].second, i });
		}
		if (d[edges[i].second] == c[i]) {
			g[edges[i].second].push_back({ edges[i].first, i });
		}
	}


	used.resize(n, 0);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			circledfs(i);
		}
	}
	
	if (found) {
		cout << "NO\n";
		return;
	}

	curc.resize(m, 0);
	curd.resize(n, 0);

	deg.resize(n, 0);
	for (int i = 0; i < n; i++) {
		for (auto pa : g[i]) {
			int to = pa.first;
			deg[to]++;
		}
	}
	used.assign(n, 0);
	for (int i = 0; i < n; i++) {
		int ind = -1;
		for (int j = 0; j < n; j++) {
			if (!used[j] && deg[j] == 0) {
				ind = j;
				break;
			}
		}
		if (ind == -1) {
			break;
		}
		dfs(ind);
	}

	for (int i = 0; i < m; i++) {
		if (d[edges[i].first] == d[edges[i].second] && d[edges[i].first] == 1) {
			if (curd[edges[i].first] != d[edges[i].first]) {
				ans.push_back({ edges[i].first, 1 });
			}
			if (curd[edges[i].second] != d[edges[i].second]) {
				ans.push_back({ edges[i].second, 1 });
			}
			curc[i] = 1;
			curd[edges[i].first] = 1;
			curd[edges[i].second] = 1;
		}
	}

	cout << "YES\n" << ans.size() << "\n";
	for (auto pa : ans) {
		cout << pa.first + 1 << " " << pa.second << "\n";
	}










}


signed main() {
	

	

	int T;
	cin >> T;
	while (T--) {
		solve();
	}
















	return 0;
}