#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int int64_t

using ll = int64_t;
using pii = pair<int, int>;

vector<int> c, d;
vector<pii> edges;
vector<vector<pii>> g;
vector<pii> ans;
void dfs(int v, int p) {
	for (auto pa : g[v]) {
		int to = pa.first, ind = pa.second;
		if (to != p) {
			dfs(to, v);
			if (c[ind] && d[to]) {
				ans.push_back({ to, 1 });
				ans.push_back({ v, 1 });
				ans.push_back({ v, 0 });
			} else if (c[ind] && !d[to]) {
				ans.push_back({ to, 1 });
				ans.push_back({ v, 1 });
				ans.push_back({ to, 0 });
			}
		}
	}
}

bool found = false;
vector<int> used;
void circledfs(int v) {
	used[v] = 1;
	for (auto pa : g[v]) {
		int to = pa.first;
		if (used[to] == 0) {
			circledfs(to);
		} else if (used[to] == 1) {
			found = true;
		}
	}
	used[v] = 2;
}

void solve() {

	int n, m;
	cin >> n >> m;
	g.resize(n);
	c.resize(m), d.resize(n);
	edges.resize(m);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v >> c[i];
		u--, v--;
		edges[i] = { u, v };
	}
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}

	bool ok = true;
	for (int i = 0; i < m; i++) {
		if (c[i] == 1 && d[edges[i].first] == 0 && d[edges[i].second] == 0 ||
				c[i] == 0 && d[edges[i].first] == 1 && d[edges[i].second] == 1) {
			ok = false;
		}
	}

	if (!ok) {
		cout << "NO\n";
		return;
	}

	for (int i = 0; i < m; i++) {
		if (d[edges[i].first] == d[edges[i].second]) {
			continue;
		}
		if (d[edges[i].first] == c[i]) {
			g[edges[i].first].push_back({ edges[i].second, i });
		}
		if (d[edges[i].second] == c[i]) {
			g[edges[i].second].push_back({ edges[i].first, i });
		}
	}


	used.resize(n, 0);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			circledfs(i);
		}
	}
	
	if (found) {
		cout << "NO\n";
	} else {
		cout << "YES\n-1\n";
	}










}


signed main() {
	

	

	int T;
	cin >> T;
	while (T--) {
		solve();
	}
















	return 0;
}