#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>

using namespace std;

//#define int int64_t

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using ll = int64_t;
using pii = pair<int, int>;

const int MAXN = 5000;
int treex[4 * MAXN], treepush[4 * MAXN];
inline void push(int v, bool leaf) {
	if (treepush[v] == -1) {
		return;
	}
	if (leaf) {
		treex[v] = max(treex[v], treepush[v]);
		treepush[v] = -1;
	}
	else {
		treex[v] = max(treex[v], treepush[v]);
		treepush[2 * v + 1] = max(treepush[2 * v + 1], treepush[v]);
		treepush[2 * v + 2] = max(treepush[2 * v + 2], treepush[v]);
		treepush[v] = -1;
	}
}
void upd(int v, int l, int r, int ql, int qr, int x) {
	//push(v, l == r - 1);
	if (r <= ql || qr <= l) {
		return;
	}
	if (ql <= l && r <= qr) {
		treepush[v] = max(treepush[v], x);
		//push(v, l == r - 1);
		return;
	}
	int m = (l + r) / 2;
	upd(2 * v + 1, l, m, ql, qr, x);
	upd(2 * v + 2, m, r, ql, qr, x);
	treex[v] = max(treex[2 * v + 1], treex[2 * v + 2]);
}
void dfs(int v, int l, int r, vector<int>& a) {
	push(v, l == r - 1);
	if (l == r - 1) {
		a[l] = treex[v];
		return;
	}
	int m = (l + r) / 2;
	dfs(2 * v + 1, l, m, a);
	dfs(2 * v + 2, m, r, a);
}


ll calc(int n, vector<int> a) {
	for (int i = 0; i < 4 * MAXN; i++) {
		treex[i] = -1;
		treepush[i] = -1;
	}
	for (int i = 0; i < n; i++) {
		upd(0, 0, n, max((int)0, i - a[i]), min(n, i + a[i] + 1), min(n - 1, i + a[i]));
	}
	vector<int> vals(n);
	dfs(0, 0, n, vals);

	ll ans = 0;
	vector<ll> rem(n, 0);
	vector<bool> used(n + 1, false);
	for (int i = n - 1; i >= 0; --i) {
		int cur = vals[i];
		ll cnt = 0;
		ll res = 0;
		if (!used[cur]) {
			ll j = cur + 1;
			cur = vals[j];
			cnt++;
			res = cnt * (n - j) + rem[cur];
		}
		else {
			res = rem[vals[i]];
		}
		used[vals[i]] = true;
		rem[vals[i]] = res;
		ans += res;
	}
	return ans;
}


signed main() {





	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	ll ans = calc(n, a);
	for (int i = 0; i < 1; i++) {
		int tmp = a[n - x + 1];
		a[n - x - 1] = x;
		ans = min(ans, calc(n, a));
		a[i] = tmp;
	}


	cout << ans << "\n";














	return 0;
}
