#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int int64_t

#pragma GCC optimize("O3,unroll-loops")

using ll = int64_t;
using pii = pair<int, int>;

const int MAXN = 500 + 100;
int treex[4 * MAXN], treepush[4 * MAXN];
void push(int v, int l, int r) {
	if (treepush[v] == -1) {
		return;
	}
	if (l == r - 1) {
		treex[v] = max(treex[v], treepush[v]);
		treepush[v] = -1;
	} else {
		treex[v] = max(treex[v], treepush[v]);
		treepush[2 * v + 1] = max(treepush[2 * v + 1], treepush[v]);
		treepush[2 * v + 2] = max(treepush[2 * v + 2], treepush[v]);
		treepush[v] = -1;
	}
}
int get(int v, int l, int r, int ql, int qr) {
	push(v, l, r);
	if (r <= ql || qr <= l) {
		return -1;
	}
	if (ql <= l && r <= qr) {
		return treex[v];
	}
	int m = (l + r) / 2;
	return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}
void upd(int v, int l, int r, int ql, int qr, int x) {
	push(v, l, r);
	if (r <= ql || qr <= l) {
		return;
	}
	if (ql <= l && r <= qr) {
		treepush[v] = max(treepush[v], x);
		push(v, l, r);
		return;
	}
	int m = (l + r) / 2;
	upd(2 * v + 1, l, m, ql, qr, x);
	upd(2 * v + 2, m, r, ql, qr, x);
	treex[v] = max(treex[2 * v + 1], treex[2 * v + 2]);
}


int calc(int n, vector<int> a) {
	for (int i = 0; i < 4 * MAXN; i++) {
		treex[i] = -1;
		treepush[i] = -1;
	}
	for (int i = 0; i < n; i++) {
		upd(0, 0, n, max((int)0, i - a[i]), min(n, i + a[i] + 1), i + a[i]);
	}
	vector<int> vals(n);
	for (int i = 0; i < n; i++) {
		vals[i] = get(0, 0, n, i, i + 1);
	}

	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int cur = vals[i];
		int cnt = 0;
		for (int j = i + 1; j < n; ++j) {
			if (j > cur) {
				cur = vals[j];
				cnt++;
			}
			ans += cnt;
		}
	}
	return ans;
}


signed main() {




	
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int ans = calc(n, a);
	for (int i = 0; i < n; i++) {
		int tmp = a[i];
		a[i] = x;
		ans = min(ans, calc(n, a));
		a[i] = tmp;
	}


	cout << ans << "\n";














	return 0;
}
