#include <bits/stdc++.h>
using namespace std;


void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}
vector<int> d, used, order;
vector<pair<int, int>> op;
vector<vector<int>> g;

int find_cycle(int v) {
    used[v] = 1;
    for(auto to : g[v]) {
        if(!used[to]) {
            int res = find_cycle(to);
            if(res == 1) {
                return 1;
            }
        } else if(used[to] == 1) {
            return 1;
        }
    }
    used[v] = 2;
    return 0;
}

void topsort(int v) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(!used[u]) {
            topsort(u);
        }
    }
    order.push_back(v);
}

void flash(int v) {
    if(d[v] == 0) {
        return;
    } 
    op.emplace_back(v + 1, 1);
    for(auto u : g[v]) {
        op.emplace_back(u + 1, 1);
    }
    for(auto u : g[v]) {
        op.emplace_back(u + 1, 0);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    d.resize(n);
    used.assign(n, 0);
    order.clear();
    op.clear();
    vector<int> _u(m), _v(m), _c(m);
    for(int i = 0; i < m; ++i) {
        cin >> _u[i] >> _v[i] >> _c[i];
        --_u[i];
        --_v[i];
    }
    for(int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for(int i = 0; i < m; ++i) {
        if(d[_u[i]] == d[_v[i]]) {
            if(_c[i] != d[_v[i]]) {
                cout << "NO\n";
                return;
            }
        } else {
            if(d[_u[i]] == _c[i]) {
                g[_u[i]].push_back(_v[i]);
            } else {
                g[_v[i]].push_back(_u[i]);
            }
        }
    }

    for(int i = 0; i < n; ++i) {
        if(!used[i]) {
            int res = find_cycle(i);
            if(res == 1) {
                cout << "NO\n";
                return;
            }
        }
    }

    for(int i = 0; i < n; ++i) {
        used[i] = 0;
    }

    for(int i = 0; i < n; ++i) {
        if(!used[i]) {
            topsort(i);
        }
    }
    reverse(order.begin(), order.end());

    for(auto v : order) {
        flash(v);
    }

    cout << "YES\n";
    cout << op.size() << '\n';
    for(auto [v, c] : op) {
        cout << v << " " << c << '\n';
    }
}


signed main() {
    init();
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}