#include <bits/stdc++.h>
using namespace std;


void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}


#define int long long

const int inf = 1e18 + 1;

struct st {
    int n;
    vector<int> t, lazy;

    st(int _n) {
        n = _n;
        t.resize(4 * n);
        lazy.resize(4 * n, -inf);
    }

    void push(int v, int l, int r) {
        t[v] = max(t[v], lazy[v]);
        if(r - l > 1) {
            lazy[2 * v + 1] = max(lazy[2 * v + 1], lazy[v]);
            lazy[2 * v + 2] = max(lazy[2 * v + 2], lazy[v]);
        }
        lazy[v] = -inf;
    }

    void upd(int v, int l, int r, int ql, int qr, int x) {
        if(max(l, ql) >= min(r, qr)) {
            return;
        }
        push(v, l, r);
        if(ql <= l && qr >= r) {
            lazy[v] = max(lazy[v], x);
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        upd(2 * v + 1, l, m, ql, qr, x);
        upd(2 * v + 2, m, r, ql, qr, x);
    }

    void upd(int ql, int qr, int x) {
        upd(0, 0, n, ql, qr, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if(max(l, ql) >= min(r, qr)) {
            return -inf;
        }
        push(v, l, r);
        if(ql <= l && qr >= r) {
            return t[v];
        }
        int m = (r + l) / 2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    int get(int ql, int qr) {
        return get(0, 0, n, ql, qr);
    }
};

int n, x;
vector<int> a;

int count(int idx) {
    st t(n);
    vector<int> f(n + 1), P(n);
    for(int i = 0; i < n; ++i) {
        if(i == idx) {
            t.upd(max(0ll, i - x), min(n, i + x + 1), min(n, i + x + 1));
        } else {
            t.upd(max(0ll, i - a[i]), min(n, i + a[i] + 1), min(n, i + a[i] + 1));
        }
    }
    for(int i = 0; i < n; ++i) {
        P[i] = t.get(i, i + 1);
    }

    for(int i = n - 1; i >= 0; --i) {
        f[i] = (n - P[i]) + f[P[i]];
    }
    int F = 0;
    for(int i = 0; i < n; ++i) {
        F += 1ll * f[i];
    }
    return F;
} 

signed main() {
    init();
    cin >> n >> x;
    a.resize(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if(x == 0) {
        cout << count(n) << '\n';
        return 0;
    }
    int ans = 1e18;
    for(int i = 0; i <= n; ++i) {
        ans = min(ans, count(i));
    }
    cout << ans << '\n';
}