#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Edge {
    int u, v, c;
};

vector<int> used;
bool ok = true;

void dfs(int v, const vector<vector<Edge>>& g, vector<pair<int, int>>& ans, vector<int>& color) {
    used[v] = 1;
    for (auto [from, to, c] : g[v]) {
        if (used[to] == 1) {
            ok = false;
            continue;
        }
        if (c == 1) {
            ans.push_back({from, 1});
            ans.push_back({to, 1});
            ans.push_back({from, 0});
            color[from] = 0;
            color[to] = 1;
        }
        if (used[to] == 0) {
            dfs(to, g, ans, color);
        }
    }
    used[v] = 2;
}

void solve() {
    int n, m; cin >> n >> m;
    vector<Edge> e(m);
    vector<vector<Edge>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c; cin >> u >> v >> c;
        u--; v--;
        e[i] = {u, v, c};
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (auto [u, v, c] : e) {
        if (d[u] == d[v]) continue;
        if (c == 1) {
            if (d[u] == 1) swap(u, v);
            g[u].push_back({u, v, c});
        } else {
            if (d[u] == 0) swap(u, v);
            g[u].push_back({u, v, c});
        }
    }
    for (int i = 0; i < m; ++i) {
        if (e[i].c == 1 && d[e[i].u] == 0 && d[e[i].v] == 0) {
            cout << "NO\n";
            return;
        }
        if (e[i].c == 0 && d[e[i].u] == 1 && d[e[i].v] == 1) {
            cout << "NO\n";
            return;
        }
    }
    used.assign(n, 0);
    vector<pair<int, int>> ans;
    vector<int> color(n);
    ok = true;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i, g, ans, color);
        }
    }
    if (ok) {
        for (int i = 0; i < n; ++i) {
            if (color[i] != d[i]) {
                ans.push_back({i, d[i]});
            }
        }
        cout << "YES\n";
        cout << ans.size() << '\n';
        for (auto [i, j] : ans) {
            cout << i + 1 << ' ' << j << '\n';
        }
    } else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}