#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Edge {
    int u, v, c;
};


void dfs(int v, const vector<vector<Edge>>& g, vector<pair<int, int>>& ans, vector<int>& color, vector<int>& used, bool& ok) {
    used[v] = 1;
    for (auto [from, to, c] : g[v]) {
        if (used[to] == 1) {
            ok = false;
            continue;
        }
        if (c == 1) {
            ans.push_back({from, 1});
            ans.push_back({to, 1});
            ans.push_back({from, 0});
            color[from] = 0;
            color[to] = 1;
        }
        if (used[to] == 0) {
            dfs(to, g, ans, color, used, ok);
        }
    }
    used[v] = 2;
}

struct Input {
    vector<Edge> e;
    vector<int> d;
};

Input input() {
    int n, m; cin >> n >> m;
    vector<Edge> e(m);
    for (int i = 0; i < m; ++i) {
        int u, v, c; cin >> u >> v >> c;
        u--; v--;
        e[i] = {u, v, c};
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    return {e, d};
}

pair<int, vector<pair<int, int>>> smartSolve(Input inp) {
    auto [e, d] = std::move(inp);
    int n = (int)d.size(), m = (int)e.size();
    vector<vector<Edge>> g(n);
    for (auto [u, v, c] : e) {
        if (d[u] == d[v]) continue;
        if (c == 1) {
            if (d[u] == 1) swap(u, v);
            g[u].push_back({u, v, c});
        } else {
            if (d[u] == 0) swap(u, v);
            g[u].push_back({u, v, c});
        }
    }
    for (int i = 0; i < m; ++i) {
        if (e[i].c == 1 && d[e[i].u] == 0 && d[e[i].v] == 0) {
            return {0, {}};
        }
        if (e[i].c == 0 && d[e[i].u] == 1 && d[e[i].v] == 1) {
            return {0, {}};
        }
    }
    vector<int> used(n, 0);
    bool ok = true;
    vector<pair<int, int>> ans;
    vector<int> color(n);
    ok = true;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i, g, ans, color, used, ok);
        }
    }
    if (ok) {
        for (int i = 0; i < n; ++i) {
            if (color[i] != d[i]) {
                ans.push_back({i, d[i]});
            }
        }
        return {1, ans};
    } else {
        return {0, {}};
    }
}

void output(pair<int, vector<pair<int, int>>> ans) {
    if (ans.first == 0) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << ans.second.size() << '\n';
    for (auto [i, j] : ans.second) cout << i + 1 << ' ' << j << '\n';
}

void run() {
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        output(smartSolve(input()));
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}