#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Edge {
    int u, v, c;
};

void dfs(int v, int p, const vector<vector<Edge>>& g, vector<pair<int, int>>& ans, vector<int>& color) {
    if (g[v].size() == 1 && v != p) return;
    for (auto [from, to, c] : g[v]) {
        if (to == p) continue;
        dfs(to, from, g, ans, color);
        if (c == 1) {
            ans.push_back({to, 1});
            color[to] = 1;
        }
    }
    ans.push_back({v, 1});
    ans.push_back({v, 0});
    color[v] = 0;
}

void dfs2(int v, int p, const vector<vector<Edge>>& g, vector<pair<int, int>>& ans,
          vector<int>& color, const vector<int>& d) {
    if (d[v] != color[v]) {
        ans.push_back({v, d[v]});
        color[v] = d[v];
    }
    for (auto [from, to, c] : g[v]) {
        if (to == p) continue;
        dfs2(to, v, g, ans, color, d);
    }
}

void solve() {
    int n, m; cin >> n >> m;
    vector<Edge> e(m);
    vector<vector<Edge>> g(n);
    for (int i = 0; i < m; ++i) {
        cin >> e[i].u >> e[i].v >> e[i].c;
        e[i].v--; e[i].u--;
        g[e[i].u].push_back({e[i].u, e[i].v, e[i].c});
        g[e[i].v].push_back({e[i].v, e[i].u, e[i].c});
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < m; ++i) {
        if (e[i].c == 1 && d[e[i].u] == 0 && d[e[i].v] == 0) {
            cout << "NO\n";
            return;
        }
        if (e[i].c == 0 && d[e[i].u] == 1 && d[e[i].v] == 1) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    vector<pair<int, int>> ans;
    vector<int> color(n);
    dfs(0, 0, g, ans, color);
    dfs2(0, 0, g, ans, color, d);
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        cout << i + 1 << ' ' << j << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}
