#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Edge {
    int u, v, c;
};

vector<int> used;
bool ok = true;

void dfs(int v, const vector<vector<Edge>>& g) {
    used[v] = 1;
    for (auto [from, to, c] : g[v]) {
        if (used[to] == 1) {
            ok = false;
            continue;
        }
        if (used[to] == 0) {
            dfs(to, g);
        }
    }
    used[v] = 2;
}

void solve() {
    int n, m; cin >> n >> m;
    vector<Edge> e(m);
    vector<vector<Edge>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c; cin >> u >> v >> c;
        u--; v--;
        e[i] = {u, v, c};
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (auto [u, v, c] : e) {
        if (d[u] == d[v]) continue;
        if (c == 1) {
            if (d[u] == 1) swap(u, v);
            g[u].push_back({u, v, c});
        } else {
            if (d[u] == 0) swap(u, v);
            g[u].push_back({u, v, c});
        }
    }
    for (int i = 0; i < m; ++i) {
        if (e[i].c == 1 && d[e[i].u] == 0 && d[e[i].v] == 0) {
            cout << "NO\n";
            return;
        }
        if (e[i].c == 0 && d[e[i].u] == 1 && d[e[i].v] == 1) {
            cout << "NO\n";
            return;
        }
    }
    used.assign(n, 0);
    ok = true;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0)
            dfs(i, g);
    }
    if (ok) {
        cout << "YES\n-1\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}