#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n; cin >> n;
    vector <int> x(n), p(n), d(n);
    for (int i=0; i<n; i++)
        cin >> x[i] >> p[i] >> d[i];

    vector <pair <int, int>> dp(n, {INF, INF});
    dp[0] = {(int)(d[0] == 1), (int)(d[0] == -1)};

    for (int i=1; i<n; i++)
    {
        if (p[i] + p[i-1] < x[i] - x[i-1])
        {
            cout << -1;
            return;
        }

        if (p[i] >= x[i] - x[i-1])
            dp[i].first = dp[i-1].first + (int)(d[i] == 1);
        else if (dp[i-1].second == -1) dp[i].first = -1;
        if (dp[i-1].second != -1) dp[i].first = min(dp[i].first, dp[i-1].second + (int)(d[i] == 1));
        
        if (p[i-1] < x[i] - x[i-1]) dp[i].second = -1;
        else dp[i].second = dp[i-1].second + (int)(d[i] == -1);
    }

    if (dp[n-1].first == -1 && dp[n-1].second == -1) cout << -1;
    else cout << min(dp[n-1].first, dp[n-1].second);

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}