#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;
 
vector <vector <pair <int, int>>> g;

void solve()
{
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
 
    int v, u, w;
    for (int i=0; i<m; i++)
    {
        cin >> v >> u >> w; v--; u--;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }
 
    vector <int> d(n);
    for (int i=0; i<n; i++) cin >> d[i];
 
    for (int v=0; v<n; v++)
        for (auto [u, w] : g[v])
            if (d[v] == d[u] && d[v] != w)
            {
                cout << "NO\n";
                return;
            }
 
    vector <pair <int, int>> ans;

    if (g[0][0].second) ans.push_back({0, 1});
    for (int i=1; i<n; i++)
    {
        if (g[i][0].second)
        {
            ans.push_back({i, 1});
            ans.push_back({i, 0});
        }
        if (i < n-1 && g[i][1].second)
        {
            ans.push_back({i, 1});
        }
    }
    for (int i=n-1; i>=0; i--)
    {
        ans.push_back({i, d[i]});
    }

    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) cout << i+1 << ' ' << j << '\n';
 
    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
 
    int tests = 1;
 
    // #ifdef LOCAL
        cin >> tests;
    // #endif
 
    for (int _=0; _<tests; _++)
    {
        solve();
    }
 
    return 0;
}