#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;
 
vector <vector <pair <int, int>>> g;

void solve()
{
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
 
    int v, u, w;
    for (int i=0; i<m; i++)
    {
        cin >> v >> u >> w; v--; u--;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }
 
    vector <int> d(n);
    for (int i=0; i<n; i++) cin >> d[i];
 
    for (int v=0; v<n; v++)
        for (auto [u, w] : g[v])
            if (d[v] == d[u] && d[v] != w)
            {
                cout << "NO\n";
                return;
            }
 
    vector <pair <int, int>> ans;

    swap(g[0][0], g[0][1]);

    vector <int> d1(n, 0);
    for (int i=0; i<n; i++)
    {
        if (g[i][0].second)
        {
            ans.push_back({i, 1});
            ans.push_back({i, 0});
        }
        if (g[i][1].second)
        {
            ans.push_back({i, 1});
            d1[i] = 1;
        }
    }

    int ind=-1;
    for (int i=0; i<n; i++)
    {
        if (d1[i] == d1[(i+1)%n]) ind=i;
    }
    if (ind == -1) {cout << "NO\n"; return;}
    for (int i=0; i<n; i++)
    {
        ans.push_back({ind, d[ind]});
        ind--; ind += n; ind %= n;
    }

    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) cout << i+1 << ' ' << j << '\n';
 
    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
 
    int tests = 1;
 
    // #ifdef LOCAL
        cin >> tests;
    // #endif
 
    for (int _=0; _<tests; _++)
    {
        solve();
    }
 
    return 0;
}