#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int ll

vector<vector<pair<int, int>>> g, g2;
vector<pair<int, int>> ans;
vector<int> final_c, used, cur_c;
int used_cnt;

inline void change_c(int v, int c) {
    if (cur_c[v] == c)
        return;
    ans.push_back({v, c});
    cur_c[v] = c;
}

bool cycle(int v) {
    if (used[v] == used_cnt)
        return true;
    if (used[v] > 0)
        return false;
    used[v] = used_cnt;
    for (auto& [to, c] : g2[v]) {
        if (cycle(to))
            return true;
    }
    used[v] = used_cnt + 1;
    return false;
}

void update_c(int v) {
    for (auto& [to, c] : g2[v]) {
        change_c(v, c);
        update_c(to);
    }
    change_c(v, final_c[v]);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

#ifdef ORANGE
    ifstream cin("C:/Users/roi/Desktop/tour1/b1.txt");
#endif

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.assign(n, {});
        g2.assign(n, {});
        final_c.resize(n);
        cur_c.assign(n, 0);
        ans.clear();
        for (int i = 0; i < m; i++) {
            int v1, v2, c;
            cin >> v1 >> v2 >> c;
            g[v1 - 1].push_back({v2 - 1, c});
            g[v2 - 1].push_back({v1 - 1, c});
        }
        for (auto& i : final_c)
            cin >> i;
        
        bool correct = true;
        vector<int> enter(n);
        for (int v1 = 0; v1 < n; v1++) {
            for (auto& [v2, c] : g[v1]) {
                if (final_c[v1] == final_c[v2]) {
                    if (c != final_c[v1])
                        correct = false;
                }
                else {
                    if (c != final_c[v1]) {
                        g2[v1].push_back({v2, c});
                        enter[v2]++;
                    }
                }
            }
        }

        used.assign(n, 0);
        used_cnt = 0;
        for (int v = 0; v < n; v++) {
            if (used[v] > 0)
                continue;
            used_cnt += 2;
            if (cycle(v))
                correct = false;
        }

        for (int v = 0; v < n; v++)
            change_c(v, final_c[v]);

        for (int v = 0; v < n; v++) {
            if (enter[v] > 0)
                continue;
            update_c(v);
        }

        for (int v1 = 0; v1 < n; v1++) {
            for (auto& [v2, c] : g[v1]) {
                if (final_c[v1] == final_c[v2]) {
                    change_c(v1, c);
                    change_c(v2, c);
                }
            }
        }

        if (correct) {
            cout << "YES" << '\n';
            cout << ans.size() << '\n';
            for (auto i : ans)
                cout << i.first + 1 << ' ' << i.second << '\n';
        }
        else
            cout << "NO" << '\n';
    }
}
