#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int ll

const int INF = 1e9;

struct BinTree {
    vector<int> tree, psh;

    void push(int v) {
        if (psh[v] == 0)
            return;
        tree[v] = tree[v] + psh[v];
        if (v * 2 < tree.size()) {
            psh[v * 2] += psh[v];
            psh[v * 2 + 1] += psh[v];
        }
        psh[v] = 0;
    }

    void update(int v, int l, int r, int lq, int rq, int val) {
        push(v);
        if (l >= rq or r <= lq)
            return;
        if (l >= lq and r <= rq) {
            psh[v] += val;
            push(v);
            return;
        }
        update(v * 2, l, (l + r) / 2, lq, rq, val);
        update(v * 2 + 1, (l + r) / 2, r, lq, rq, val);
        tree[v] = tree[v * 2] + tree[v * 2 + 1];
    }

    void update(int lq, int rq, int val) {
        update(1, 0, tree.size() / 2, lq, rq, val);
    }

    void update(int pos, int val) {
        update(pos, pos + 1, val);
    }

    int get(int v, int l, int r, int lq, int rq) {
        push(v);
        if (l >= rq or r <= lq)
            return 0;
        if (l >= lq and r <= rq) {
            return tree[v];
        }
        return get(v * 2, l, (l + r) / 2, lq, rq) + get(v * 2 + 1, (l + r) / 2, r, lq, rq);
    }

    int get(int lq, int rq) {
        return get(1, 0, tree.size() / 2, lq, rq);
    }


    BinTree() {}

    BinTree(int n) {
        tree.assign((1 << (int)log2(n)) * 4, 0);
        psh.assign((1 << (int)log2(n)) * 4, 0);
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

#ifdef ORANGE
    ifstream cin("C:/Users/roi/Desktop/tour1/c1.txt");
#endif

    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (auto& i : t)
        cin >> i;
    for (auto& i : s)
        cin >> i;
    for (int i = m - 1; i >= 1; i--)
        s[i] -= s[i - 1];

    int mn = *min_element(all(s)), mx = *max_element(all(s));
    vector<int> loc_mn(n), loc_mx(n);
    BinTree bin(1e5 + 1), bin_mx(1e5 + 1);
    int ans = 0;
    for (int k = 0; k < n; k++) {
        ans += bin.get(0, mx * t[k] + 1);
        int cur_mx = 0;
        for (int i = 0; i < m; i++) {
            cur_mx = max(cur_mx, s[i] * t[k]);
            ans += bin_mx.get(cur_mx + 1, 1e5 + 1);
            bin.update(cur_mx, 1);
        }
        bin_mx.update(mx * t[k], 1);
        cout << ans << '\n';
    }
}
