#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int ll

struct BinTree {
    vector<int> tree, psh;
 
    void push(int v) {
        if (psh[v] == 0)
            return;
        tree[v] = tree[v] + psh[v];
        if (v * 2 < tree.size()) {
            psh[v * 2] += psh[v];
            psh[v * 2 + 1] += psh[v];
        }
        psh[v] = 0;
    }
 
    void update(int v, int l, int r, int lq, int rq, int val) {
        push(v);
        if (l >= rq or r <= lq)
            return;
        if (l >= lq and r <= rq) {
            psh[v] += val;
            push(v);
            return;
        }
        update(v * 2, l, (l + r) / 2, lq, rq, val);
        update(v * 2 + 1, (l + r) / 2, r, lq, rq, val);
        tree[v] = tree[v * 2] + tree[v * 2 + 1];
    }
 
    void update(int lq, int rq, int val) {
        update(1, 0, tree.size() / 2, lq, rq, val);
    }
 
    void update(int pos, int val) {
        update(pos, pos + 1, val);
    }
 
    int get(int v, int l, int r, int lq, int rq) {
        push(v);
        if (l >= rq or r <= lq)
            return 0;
        if (l >= lq and r <= rq) {
            return tree[v];
        }
        return get(v * 2, l, (l + r) / 2, lq, rq) + get(v * 2 + 1, (l + r) / 2, r, lq, rq);
    }
 
    int get(int lq, int rq) {
        return get(1, 0, tree.size() / 2, lq, rq);
    }
 
 
    BinTree() {}
 
    BinTree(int n) {
        tree.assign((1 << (int)log2(n)) * 4, 0);
        psh.assign((1 << (int)log2(n)) * 4, 0);
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

#ifdef ORANGE
    ifstream cin("C:/Users/roi/Desktop/tour1/d1.txt");
#endif

    int n, x;
    cin >> n >> x;
    int answer = 1e18;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    for (int k = n / 2; k <= n / 2; k++) {
        int prev = a[k];
        a[k] = x;
        vector<int> best(n);

        for (int i = 1; i < n; i++) {
            best[i] = best[i - 1];
            if (i + a[i] > best[i] + a[best[i]])
                best[i] = i;
        }
        vector<vector<int>> to_del(n);
        set<pair<int, int>, greater<pair<int, int>>> st;
        for (int i = n - 1; i >= 0; i--) {
            st.insert({i + a[i], i});
            if (st.begin()->first > best[i] + a[best[i]])
                best[i] = st.begin()->second;
            to_del[max(i - a[i], 0ll)].push_back(i);
            for (auto j : to_del[i])
                st.erase(pair<int, int>{a[j] + j, j});
        }

        vector<int> ans(n);
        for (int i = n - 1; i >= 0; i--) {
            if (best[i] + a[best[i]] + 1 < n)
                ans[i] = ans[best[i] + a[best[i]] + 1] + (n - (best[i] + a[best[i]] + 1));
        }

        int res = 0;
        for (auto i : ans)
            res += i;
        answer = min(answer, res);

        a[k] = prev;
    }
    cout << answer;
}
