#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector<pair<int, int>> can_left(n + 1, {0, 0});
    can_left[0] = {1, 0};
    for (int i = 0; i < n - 1; ++i) {
        if (!can_left[i].first) {
            break;
        }
        if (x[i] + p[i] >= x[i + 1]) {
            can_left[i + 1] = can_left[i];
            can_left[i + 1].second += (d[i] == -1);
        }
    }
    vector<pair<int, int>> can_right(n, {0, 0});
    can_right[n - 1] = {1, 0};
    for (int i = n - 1; i > 0; --i) {
        if (!can_right[i].first) {
            break;
        }
        if (x[i] - p[i] <= x[i - 1]) {
            can_right[i - 1] = can_right[i];
            can_right[i - 1].second += (d[i] == 1);
        }
    }
    int ans = n + 1;
    for (int i = 0; i < n; ++i) {
        if (can_left[i].first && can_right[i].first) {
            ans = min(ans, can_left[i].second + can_right[i].second);
        }
    }
    if (ans == n + 1) {
        ans = -1;
    }
    cout << ans;
}