#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<int> c(m);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u >> c[i];
        v--;
        u--;
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
    }
    vector<int> d(n);
    for (auto &i : d) {
        cin >> i;
    }
    bool is_ans = true;
    for (int v = 0; v < n; ++v) {
        for (auto [u, id] : g[v]) {
            if ((d[v] && d[u] && !c[id]) || (!d[v] && !d[u] && c[id])) {
                is_ans = false;
            }
        }
    }

    vector<int> go(n), used(n);
    auto dfs = [&] (auto self, int v, int p, int pst) {
        used[v] = 1;
        for (auto [u, id] : g[v]) {
            if (id == pst) {
                continue;
            }
            if (used[u] == 1 && go[u] != c[id]) {
                is_ans = false;
                return;
            }
            if (used[u] != 0 || c[id] == pst) {
                continue;
            }
            go[v] = c[id];
            self(self, u, c[id], id);
        }
        used[v] = 2;
    };

    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfs(dfs, v, -1, -1);
        }
    }

    if (is_ans) {
        cout << "YES\n-1\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}