#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<int> c(m);
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u >> c[i];
        v--;
        u--;
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
        edges.emplace_back(v, u);
    }
    vector<int> d(n);
    for (auto &i : d) {
        cin >> i;
    }
    /*for (auto i : d) {
        cout << i << ' ';
    }
    cout << endl;*/

    bool is_ans = true;

    for (int v = 0; v < n; ++v) {
        for (auto [u, id] : g[v]) {
            if ((d[v] && d[u] && !c[id]) || (!d[v] && !d[u] && c[id])) {
                //cout <<
                is_ans = false;
            }
        }
    }

    vector<pair<int, int>> ans;
    vector<int> used(n);
    auto dfs = [&] (auto &&self, int v, int p) -> void {
        ans.emplace_back(v, 1);
        used[v] = 1;
        for (auto [u, id] : g[v]) {
            if (u == p) {
                continue;
            }
            if ((d[v] && d[u] && !c[id]) || (!d[v] && !d[u] && c[id])) {
                is_ans = false;
                return;
            }
            if (d[u]) {
                self(self, u, v);
            } else if (c[id]) {
                ans.emplace_back(u, 1);
                ans.emplace_back(u, 0);
            }
        }
    };

    for (int v = 0; v < n; ++v) {
        if (!used[v] && d[v]) {
            dfs(dfs, v, -1);
        }
    }

    if (is_ans) {
        cout << "YES\n" << (int) ans.size() << '\n';
        for (auto [v, t] : ans) {
            cout << v + 1 << ' ' << t << '\n';
        }
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}