#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<int> c(m);
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u >> c[i];
        v--;
        u--;
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
        edges.emplace_back(v, u);
    }
    vector<int> d(n);
    for (auto &i : d) {
        cin >> i;
    }
    /*for (auto i : d) {
        cout << i << ' ';
    }
    cout << endl;*/

    bool is_ans = true;
    vector<int> used(n);
    vector<pair<int, int>> ans;
    auto dfs = [&] (auto self, int v) -> void {
        used[v] = 1;
        //cout << v << ' ' << d[v] << endl;
        for (auto [u, id] : g[v]) {
            if (!used[u]) {
                self(self, u);
                ans.emplace_back(v, c[id]);
                ans.emplace_back(u, c[id]);
                ans.emplace_back(u, d[u]);
                if ((d[v] && d[u] && !c[id]) || (!d[v] && !d[u] && c[id])) {
                    is_ans = false;
                }
            }
        }
        ans.emplace_back(v, d[v]);
    };

    //cout << endl;
    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfs(dfs, v);
        }
    }

    if (is_ans) {
        cout << "YES\n" << (int) ans.size() << '\n';
        for (auto [v, t] : ans) {
            cout << v + 1 << ' ' << t << '\n';
        }
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}