#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }

    auto calc = [&] () -> ll {
        vector<int> l(n), r(n);
        vector<tuple<int, int, int>> seg;
        for (int i = 0; i < n; ++i) {
            r[i] = min(n - 1, i + a[i]);
            l[i] = max(0, i - a[i]);
            seg.emplace_back(l[i], -1, i);
            seg.emplace_back(r[i], 1, i);
            seg.emplace_back(i, 0, i);
        }

        sort(seg.begin(), seg.end(), [&] (const auto &a, const auto &b) {
            auto [p1, t1, id1] = a;
            auto [p2, t2, id2] = b;
            return p1 < p2 || (p1 == p2 && (t1 < t2 || (t1 == t2 && id1 < id2)));
        });

        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            int mx_to = 0;
            int mx = i - 1;
            int p = -1;
            for (auto [pos, type, id] : seg) {
                if (type == 0) {
                    if (mx < pos) {
                        mx = mx_to;
                        p++;
                        //cout << i << ' ' << pos << ' ' << mx << ' ' << p << endl;
                    }
                    if (pos > i) {
                        ans += p;
                    }
                } else if (type == -1) {
                    mx_to = max(mx_to, r[id]);
                }
            }
        }

        return ans;
    };

    ll ans = calc();

    for (int v = 0; v < n; ++v) {
        int pst_a = a[v];
        a[v] = x;
        ans = min(ans, calc());
        a[v] = pst_a;
    }

    cout << ans;
}