#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

const int maxn = 1e5 + 2;
const int inf = 1e9 + 1;

int d[maxn];

struct edge {
    int to, color;
};

vector<int> way[maxn];

vector<int> top_sort;

bool found = 0;

int used[maxn];

void dfs(int v) {
    used[v] = 1;
    for (int u : way[v]) {
        if (used[u] == 1) {
            found = 1;
        } else if (used[u] == 0) {
            dfs(u);
        }
    }
    top_sort.push_back(v);
    used[v] = 2;
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 1; i < n + 1; i++) {
        way[i].clear();
        used[i] = 0;
    }
    top_sort.clear();
    vector<tuple<int, int, int>> edges;
    edges.reserve(m + 1);
    for (int i = 1; i < m + 1; i++) {
        int u, v, c; cin >> u >> v >> c;
        edges.emplace_back(u, v, c);
    }
    for (int i = 1; i < n + 1; i++) {
        cin >> d[i];
    }
    for (auto [u, v, c] : edges) {
        if (d[u] == 1 && d[v] == 1 && c == 0) {
            cout << "NO\n";
            return;
        }
        if (d[u] == 0 && d[v] == 0 && c == 1) {
            cout << "NO\n";
            return;
        }
    }
    for (auto [u, v, c] : edges) {
        if (d[u] ^ d[v] == 1) {
            if (d[u] == 1) {
                swap(u, v);
            }
            if (c == 0) {
                way[u].push_back(v);
            } else {
                way[v].push_back(u);
            }
        }
    }
    found = 0;
    for (int v = 1; v < n + 1; v++) {
        //cout << v << " --> " << used[v] << " " << d[v] << " " << !way[v].empty() << "\n";
        if (!used[v] && (d[v] || !way[v].empty())) {
            dfs(v);
            //cout << "ok\n";
        }
    }
    reverse(top_sort.begin(), top_sort.end());
    if (found) {
        cout << "NO\n";
        return;
    } else {
        cout << "YES\n";
        vector<pair<int, int>> ans;
        for (int x : top_sort) {
            ans.push_back({x, 1});
            if (!d[x]) {
                ans.push_back({x, 0});
            }
        }
        cout << ans.size() << "\n";
        for (auto [x, type] : ans) {
            cout << x << " " << type << "\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
}
