#include <bits/stdc++.h>
 
using namespace std;
 
vector<vector<pair<int, int>>> g;
vector<int> arr;
vector<int> col;
 
void dfs(int v, int st, int cc) {
    col[v] = cc;
    for(auto [t, ii] : g[v]) {
        if(arr[t] != st) continue;
        if(col[t] != -1) continue;
        dfs(t, st, cc);
    }
}
 
void solve() {
    int n, m;
    cin >> n >> m;
    g.clear();
    arr.clear();
    col.clear();
 
    g.resize(n);
    arr.resize(n);
    vector<array<int, 3>> edges(m);
    vector<int> et(m);
    for(int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        edges[i] = {a, b, i};
        et[i] = c;
    }
    for(int i = 0; i < n; i++) cin >> arr[i];
    for(auto [a, b, c] : edges) {
        if(arr[a] == arr[b] && arr[a] != et[c]) {
            cout << "NO\n";
            return;
        }
    }
    col.resize(n, -1);
    int cols = 0;
    for(int i = 0; i < n; i++) {
        if(col[i] == -1) {
            dfs(i, arr[i], cols++);
        }
    }
    vector<pair<int, int>> ans;
    for(int i = 0; i < n; i++) {
        ans.push_back({i, arr[i]});
    }
 
    vector<array<int, 3>> edges2;
    for(auto [a, b, c] : edges) {
        if(col[a] == col[b]) continue;
        edges2.push_back({a, b, c});
    }
    vector<int> et2(edges2.size());
    vector<int> tr(m, -1);
    for(int i = 0; i < edges2.size(); i++) tr[edges2[i][2]] = i;
    for(int i = 0; i < edges2.size(); i++) et2[i] = et[edges2[i][2]];
    for(int i = 0; i < edges2.size(); i++) edges2[i][2] = i;
    // cout << ">> ";
    // for(auto c : col) cout << c << ' ';
    // cout << '\n';
    m = edges2.size();
    vector<int> currE(m);
 
    queue<int> q;
    vector<bool> queued(m);
    for(int i = 0; i < m; i++) {
        if(currE[i] != et2[i]) {
            queued[i] = true;
            q.push(i);
        }
    }
 
    while(ans.size() <= 1000000 && !q.empty()) {
        int ri = q.front();
        q.pop();
        auto [a, b, c] = edges2[ri];
        queued[ri] = false;
        if(et2[ri] == currE[ri]) continue;
 
        ans.push_back({a, et2[c]});
        ans.push_back({b, et2[c]});
        currE[c] = et2[c];
        for(auto [tt, ii] : g[a]) {
            if(tr[ii] == -1) continue;
            if(tt == a) continue;
            if(tt == b) continue;
            if(arr[tt] == et2[c] && currE[tr[ii]] != et2[c]) {
                currE[tr[ii]] = et2[c];
                if(!queued[tr[ii]]) {
                    queued[tr[ii]] = true;
                    q.push(tr[ii]);
                }
            }
        }
        for(auto [tt, ii] : g[b]) {
            if(tr[ii] == -1) continue;
            if(tt == a) continue;
            if(tt == b) continue;
            if(arr[tt] == et2[c] && currE[tr[ii]] != et2[c]) {
                currE[tr[ii]] = et2[c];
                if(!queued[tr[ii]]) {
                    queued[tr[ii]] = true;
                    q.push(tr[ii]);
                }
            }
        }
        ans.push_back({a, arr[a]});
        ans.push_back({b, arr[b]});
    }
    if(ans.size() > 1000000) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for(auto [a, b] : ans) cout << a + 1 << ' ' << b << '\n';
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while(t--) solve();
}