#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,lzcnt,bmi,bmi2,tune=native")

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> arr;
vector<int> col;

void dfs(int v, int st, int cc) {
    col[v] = cc;
    for(auto [t, ii] : g[v]) {
        if(arr[t] != st) continue;
        if(col[t] != -1) continue;
        dfs(t, st, cc);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.clear();
    arr.clear();
    col.clear();

    g.resize(n);
    arr.resize(n);
    vector<array<int, 3>> edges(m);
    vector<int> et(m);
    for(int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        edges[i] = {a, b, i};
        et[i] = c;
    }
    for(int i = 0; i < n; i++) cin >> arr[i];
    for(auto [a, b, c] : edges) {
        if(arr[a] == arr[b] && arr[a] != et[c]) {
            cout << "NO\n";
            return;
        }
    }
    col.resize(n, -1);
    int cols = 0;
    for(int i = 0; i < n; i++) {
        if(col[i] == -1) {
            dfs(i, arr[i], cols++);
        }
    }
    vector<pair<int, int>> ans;
    for(int i = 0; i < n; i++) {
        if(arr[i] == 1) ans.push_back({i, arr[i]});
    }

    vector<array<int, 3>> edges2;
    for(auto [a, b, c] : edges) {
        if(col[a] == col[b]) continue;
        edges2.push_back({a, b, c});
    }
    vector<int> et2(edges2.size());
    for(int i = 0; i < edges2.size(); i++) et2[i] = et[edges2[i][2]];
    vector<int> tr(m, -1);
    for(int i = 0; i < edges2.size(); i++) tr[edges2[i][2]] = i;
    for(int i = 0; i < edges2.size(); i++) edges2[i][2] = i;
    m = edges2.size();

    vector<int> currE(m);
    vector<int> used(n, -1);
    int timer = 0;

    queue<pair<int, int>> q;
    for(int t = 0; t < 5; t++) {
        for(auto [a, b, c] : edges2) {
            if(currE[c] == et2[c]) continue;
            // timer++;
            if(arr[a] != et2[c]) {
                used[a] = timer;
                q.push({a, et2[c]});
            } else {
                used[b] = timer;
                q.push({b, et2[c]});
            }

            while(q.size()) {
                auto [v, col] = q.front();
                q.pop();
                if(col != arr[v]) {
                    ans.push_back({v, col});
                    ans.push_back({v, arr[v]});
                }
                if(ans.size() > 1000000) {
                    cout << "NO\n";
                    return;
                }
                for(auto [t, ii] : g[v]) {
                    if(tr[ii] == -1) continue;
                    if(arr[t] != col) continue;
                    currE[tr[ii]] = col;
                    if(et2[tr[ii]] == col) continue;
                    if(used[t] == timer) continue;
                    used[t] = timer;
                    q.push({t, 1 - col});
                }
            }
        }
    }

    for(int i = 0; i < m; i++) {
        if(et2[i] != currE[i]) {
            cout << "NO\n";
            return;
        }
    }

    if(ans.size() > 1000000) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for(auto [a, b] : ans) cout << a + 1 << ' ' << b << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while(t--) solve();
}
