#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Edge {
    int v, u, c, s;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector <Edge> edges(m);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;

        edges[i] = {u, v, c, 0};
    }

    vector <int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    vector <bool> on(n, false);

    auto relax = [&]() {
        for (Edge& e : edges) {
            if (on[e.u] == 1 && on[e.v] == 1) {
                e.s = 1;
            } else if (on[e.u] == 0 && on[e.v] == 0) {
                e.s = 0;
            }
        }
    };

    vector <pair <int, int>> ans;

    for (Edge& e : edges) {
        if (e.c == 1) {
            if (d[e.u] == 0 && d[e.v] == 0) {
                cout << "NO\n";
                return;
            }
            on[e.v] = 1;
            on[e.u] = 1;
            ans.push_back({e.v + 1, 1});
            ans.push_back({e.u + 1, 1});
        } else {
            if (d[e.u] == 1 && d[e.v] == 1) {
                cout << "NO\n";
                return;
            }
        }
    }

    relax();

    for (int v = 0; v < n; v++) {
        if (d[v] == 0 && on[v] == 1) {
            on[v] = 0;
            ans.push_back({v + 1, 0});
        } else if (d[v] == 1 && on[v] == 0) {
            on[v] = 1;
            ans.push_back({v + 1, 1});
        }
    }

    relax();

    for (Edge& e : edges) {
        if (e.s != e.c) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";

    cout << ans.size() << "\n";
    for (auto [v, m] : ans) {
        cout << v << " " << m << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
