#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Edge {
    int v, u, c, s;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector <Edge> edges(m);
    vector <vector <Edge>> gr(n);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;

        edges[i] = {u, v, c, 0};
        gr[u].push_back({u, v, c});
        gr[v].push_back({v, u, c});
    }

    vector <int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    vector <bool> on(n, false);

    auto relax = [&]() {
        for (Edge& e : edges) {
            if (on[e.u] == 1 && on[e.v] == 1) {
                e.s = 1;
            } else if (on[e.u] == 0 && on[e.v] == 0) {
                e.s = 0;
            }
        }
    };

    vector <pair <int, int>> ans;

    for (Edge& e : edges) {
        if (e.c == 1) {
            if (d[e.u] == 0 && d[e.v] == 0) {
                cout << "NO\n";
                return;
            }
        } else {
            if (d[e.u] == 1 && d[e.v] == 1) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector <int> rem_edges_0(n, 0); // for ones!
    for (Edge& e : edges) {
        if (e.c == 0) {
            if (d[e.u] == 1) {
                rem_edges_0[e.u]++;
            } else if (d[e.v] == 1) {
                rem_edges_0[e.v]++;
            }
        }
    }

    vector <int> rem_edges_1(n, 0); // for zeros!
    for (Edge& e : edges) {
        if (e.c == 1) {
            if (d[e.u] == 0) {
                rem_edges_1[e.u]++;
            } else if (d[e.v] == 0) {
                rem_edges_1[e.v]++;
            }
        }
    }

    queue <int> q0, q1;
    for (int v = 0; v < n; v++) {
        if (d[v] == 0) {
            if (rem_edges_1[v] == 0) {
                q0.push(v);
            }
        } else {
            if (rem_edges_0[v] == 0) {
                q1.push(v);
            }
        }
    }

    int done = 0;
    while (true) {
        if (!q0.empty()) {
            int v = q0.front();
            q0.pop();
            ans.push_back({v + 1, 1});
            ans.push_back({v + 1, 0});
            for (Edge& e : gr[v]) {
                if (e.c == 0 && d[e.u] == 1) {
                    rem_edges_0[e.u]--;
                    if (rem_edges_0[e.u] == 0) {
                        q1.push(e.u);
                    }
                }
            }
        } else if (!q1.empty()) {
            int v = q1.front();
            q1.pop();
            ans.push_back({v + 1, 1});
            for (Edge& e : gr[v]) {
                if (e.c == 1 && d[e.u] == 0) {
                    rem_edges_1[e.u]--;
                    if (rem_edges_1[e.u] == 0) {
                        q0.push(e.u);
                    }
                }
            }
        } else {
            break;
        }
        done++;
    }

    if (done < n) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [v, m] : ans) {
        cout << v << " " << m << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
