#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct SegmentTree {
    int sz;
    vector <int> tree;

    SegmentTree(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz, 0);
    }

    void add(int pos, int x) {
        pos += sz;
        tree[pos] += x;
        for (pos /= 2; pos > 0; pos /= 2) {
            tree[pos] = tree[2 * pos] + tree[2 * pos + 1];
        }
    }

    int get(int l, int r) {
        l += sz;
        r += sz;
        int ans = 0;
        while (l <= r) {
            if (l % 2 == 1) {
                ans += tree[l];
                l++;
            }
            if (r % 2 == 0) {
                ans += tree[r];
                r--;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

int get(int n) {
    return n * (n + 1) / 2;
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector <int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    vector <int> s(m + 1);
    s[0] = 0;
    for (int i = 1; i <= m; i++) {
        cin >> s[i];
    }

    int len1 = s[1] - s[0], len2 = s[2] - s[1];
    if (len1 < len2) {
        int ans = 0;
        const int MAX = 2e5;
        SegmentTree st(MAX);
        for (int k = 0; k < n; k++) {
            ans += m * k * 2;
            int cnt2p = st.get(0, len1 * t[k] / len2);
            ans -= cnt2p;
            int cnt2pd = st.get((len2 * t[k]) / len1 + 1, MAX - 1);
            ans -= cnt2pd;

            st.add(t[k], 1);

            cout << ans << "\n";
        }
    } else if (len1 >= len2) {
        int ans = 0;
        const int MAX = 2e5;
        SegmentTree st(MAX);
        for (int k = 0; k < n; k++) {
            ans += m * k * 2;
            int cnt2p = st.get(0, t[k]);
            ans -= cnt2p;
            int cnt2pd = st.get(t[k] + 1, MAX - 1);
            ans -= cnt2pd;

            st.add(t[k], 1);

            cout << ans << "\n";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
