#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct SegmentTree {
    int sz;
    vector <int> tree;

    SegmentTree(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz, 0);
    }

    void add(int pos, int x) {
        pos += sz;
        tree[pos] += x;
        for (pos /= 2; pos > 0; pos /= 2) {
            tree[pos] = tree[2 * pos] + tree[2 * pos + 1];
        }
    }

    int get(int l, int r) {
        l += sz;
        r += sz;
        int ans = 0;
        while (l <= r) {
            if (l % 2 == 1) {
                ans += tree[l];
                l++;
            }
            if (r % 2 == 0) {
                ans += tree[r];
                r--;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

int get(vector <int>& a) {
    int n = a.size();

    vector <vector <int>> ant(n);
    vector <int> cnt(n, 0);
    for (int i = 0; i < n; i++) {
        // i - a[i]; i + a[i]
        int L = max(0ll, i - a[i]);
        int R = min(n - 1, i + a[i]);
        ant[L].push_back(R);
        cnt[R]++;
    }

    multiset <int> cond;
    vector <int> r(n);
    for (int i = n - 1; i >= 0; i--) {
        while (cnt[i]--) {
            cond.insert(-i);
        }
        r[i] = -(*cond.begin());
        for (int j : ant[i]) {
            cond.erase(cond.find(-j));
        }
    }

    int ans = 0;
    vector <int> res(n, 0);
    res[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        if (r[i] == n - 1) continue;
        res[i] = res[r[i] + 1] + n - 1 - r[i];
        ans += res[i];
    }
    return ans;
}

void solve() {
    int n, x;
    cin >> n >> x;

    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int ans = get(a);
    for (int i = 0; i < n; i++) {
        int tmp = a[i];
        a[i] = x;
        ans = min(ans, get(a));
        a[i] = tmp;
    }

    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
