#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <cassert>
#include <random>

#define all(x) x.begin(),x.end()
//#define mp(x) lower_bound(all(nw),x) - nw.begin()
//#define int ll 

using namespace std;
using ll = long long;

vector<int> were1;
vector<bool> were2;
vector<pair<int,int>> tmei;
vector<vector<int>> graph;
vector<vector<int>> graphR;
bool stop = false;

void dfs(int v, int c) {
	if (were2[v]) { 
		stop = true;
		return;
	}
	if (were1[v] != 0) return;
	were1[v] = true;
	were2[v] = true;
	for (auto& i : graph[v])
		dfs(i, c);
	were2[v] = false;
	return;
}

int tin;
void dfs2(int v) {
	if (were2[v])return;
	were2[v] = true;
	for (auto& i : graphR[v])
		dfs2(i);
	tmei[v].first = tin++;
}

bool solve(int n,int m,vector<bool> col, vector<tuple<int,int,int>> tmp) {
	stop = false;
	tin = 0;
	were1 = vector<int>(n, 0);
	tmei = vector<pair<int,int>>(n);
	for (int i = 0; i < n; i++)
		tmei[i].second = i;
	were2 = vector<bool>(n, false);
	graph = vector<vector<int>>(n);
	graphR = vector<vector<int>>(n);
	for (auto&[a,b,c] : tmp)
	{
		if (col[a] == col[b]) {
			if (col[a] == c)continue;
			else {
				return false;
			}
		}
		
		if (col[a] == c)graph[a].push_back(b), graphR[b].push_back(a);
		else { 
			assert(col[b] == c);
			graph[b].push_back(a), graphR[a].push_back(b); 
		}
	}

	for (int i = 0; i < n; i++)
		if (were1[i] == 0)
			dfs(i, i + 2);
	if (stop)return false;
	

	for (int i = 0; i < n; i++)
		if (!were2[i])dfs2(i);

	sort(all(tmei));

	vector<pair<int, int>> res;
	for (int i = 0; i < n; i++)
		if (col[i] == false)res.push_back({ i,1 });

	for (auto& i : tmei)
	{
		res.push_back({i.second, col[i.second]});
	}
	cout << "YES\n";
	cout << res.size() << '\n';
	for (auto& i : res)
		cout << i.first << " " << i.second << '\n';
	return true;
}

bool inp() {
	int n, m;
	cin >> n >> m;
	vector<bool> col(n);
	vector<tuple<int, int, int>> tmp(m);
	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		tmp[i] = { a,b,c };
	}

	for (int i = 0; i < n; i++)
	{
		int c;
		cin >> c;
		col[i] = c;
	}

	return solve(n, m, col, tmp);
}

mt19937 rnd;
bool gen() {
	int n = 4 , m = 4;
//	cin >> n >> m;
	vector<bool> col(n);
	for (int i = 0; i < n; i++)
		col[i] = rnd() % 2;
	vector<tuple<int, int, int>> tmp(m);
	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		a = rnd() % n;
		b = rnd() % n;
		if (a == b) {
			i--;
			continue;
		}
		if (a > b)swap(a, b);
		c = col[a];
		tmp[i] = { a,b,c };
	}
	sort(all(tmp));
	if (unique(all(tmp)) != tmp.end())return 0;
	if (!solve(n, m, col, tmp)) {
		return 0;
	}
	cout << 1;
}
signed  main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = -1;
	cin >> t;
	while (t--)
	{
		
		//gen();


		if (!inp())	cout << "NO\n";
		/*if (t == 4) cout << "5\n4 1\n3 1\n2 1\n3 0\n4 0\n";
		if (t == 2) cout << "1\n1 1\n";
		if (t == 1) cout << "1\n1 0\n";
		if (t == 0) cout << "0\n";*/
	}
}

