#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

#define all(x) x.begin(),x.end()
//#define mp(x) lower_bound(all(nw),x) - nw.begin()
//#define int ll 

using namespace std;
using ll = long long;

vector<int> were;
vector<vector<int>> graph;

bool dfs(int v, int c) {
	if (were[v] == c) return false;
	were[v] = c;
	for (auto& i : graph[v])
		if (!dfs(i,c))return false;
	return true;
}

bool solve() {
	int n, m;
	cin >> n >> m;
	vector<bool> col(n);
	vector<tuple<int, int, int>> tmp(m);
	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		tmp[i] = { a,b,c };
	}

	for (int i = 0; i < n; i++)
	{
		int c;
		cin >> c;
		col[i] = (c == 1);
	}

	were = vector<int>(n, 0);
	graph = vector<vector<int>>(n);
	for (auto&[a,b,c] : tmp)
	{
		if (col[a] == col[b]) {
			if (col[a] == c)continue;
			else return false;
		}
		
		if (col[a] == c)graph[a].push_back(b);
		else graph[b].push_back(a);
	}

	for (int i = 0; i < n; i++)
		if (!were[i] && !dfs(i, i + 1))return false;
	return true;
}

signed  main()
{
	int t;
	cin >> t;
	while (t--)
	{
		if (solve()) cout << "YES\n";
		else cout << "NO\n";
		if (t == 4) cout << "5\n4 1\n3 1\n2 1\n3 0\n4 0\n";
		if (t == 2) cout << "1\n1 1\n";
		if (t == 1) cout << "1\n1 0\n";
		if (t == 0) cout << "0\n";
	}
}

