#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

#define ll long long
#define IM INT32_MAX 

int n, m;

class per
{
public:
	int from;
	int to;
	bool need;
};

class corp
{
public:
	vector<per*> pers;
	bool need;
	vector<corp*> before;
	vector<corp*> after;
	int id;

	int b;
};

vector<corp*> corps;
vector<per*> pers;

int main()
{
	int t;
	cin >> t;

	for (int t1 = 0; t1 < t; t1++)
	{
		cin >> n >> m;
		pers = vector<per*>(m);
		corps = vector<corp*>(n);

		for (int i = 0; i < n; i++)
		{
			corps[i] = new corp();
			corps[i]->id = i;
		}

		for (int i = 0; i < m; i++)
		{
			pers[i] = new per();
			int a, b, c;
			cin >> a >> b >> c;
			a--;
			b--;

			pers[i]->from = a;
			pers[i]->to = b;
			pers[i]->need = c;

			corps[a]->pers.push_back(pers[i]);
			corps[b]->pers.push_back(pers[i]);
		}

		for (int i = 0; i < n; i++)
		{
			cin >> corps[i]->need;
		}

		bool end = false;
		for (per* p : pers)
		{
			corp* from = corps[p->from];
			corp* to = corps[p->to];
			bool eqfr = p->need == from->need;
			bool eqto = p->need == to->need;
			if (!eqfr && !eqto)
			{
				cout << "NO" << endl;
				end = true;
				break;
			}
			else if (eqfr && !eqto)
			{
				from->before.push_back(to);
				to->after.push_back(from);
			}
			else if (!eqfr && eqto)
			{
				from->after.push_back(to);
				to->before.push_back(from);
			}
		}

		if (end)
			continue;

		vector<corp*> order;
		stack<corp*> stoks;

		for (corp* c : corps)
		{
			c->b = c->before.size();
			if (c->b == 0)
				stoks.push(c);
		}

		while (stoks.size() > 0)
		{
			corp* c = stoks.top();
			stoks.pop();
			order.push_back(c);

			for (corp* oc : c->after)
			{
				oc->b--;

				if (oc->b == 0)
					stoks.push(oc);
			}
		}

		if (order.size() != n)
		{
			cout << "NO" << endl;
			continue;
		}
		else
		{
			cout << "YES" << endl;

			vector<int> ids;
			vector<bool> values;

			for (corp* c : order)
			{
				ids.push_back(c->id);
				values.push_back(c->need);

				for (corp* oc : c->before)
				{
					ids.push_back(oc->id);
					values.push_back(c->need);
				}
			}

			int s = ids.size();
			cout << s << endl;

			for (int i = s - 1; i >= 0; i--)
			{
				cout << ids[i] + 1 << " " << (int)values[i] << endl;
			}

			continue;
		}
	}
	
	return 0;
}