#include <bits/stdc++.h>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solution();
    }

    return 0;
}

vector<vector<pair<int, int>>> gr;
vector<vector<int>> dag;
vector<int> used;
vector<int> d;
vector<pair<int, int>> moves;


bool dfs(int s) {
    used[s] = 1;
    moves.emplace_back(s, d[s] ^ 1);
    for (auto v : dag[s]) {
        if (used[v] == 1) return false;
        if (used[v] == 2) continue;
        if (!dfs(v)) return false;
    }
    moves.emplace_back(s, d[s]);
    used[s] = 2;
    return true;
}


void solution() {
    gr.clear();
    used.clear();
    d.clear();
    moves.clear();
    dag.clear();

    int n, m;
    cin >> n >> m;

    gr.resize(n);
    used.resize(n);
    d.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;

        a--;
        b--;
        gr[a].emplace_back(b, c);
        gr[b].emplace_back(a, c);
    }

    for (auto &x : d) {
        cin >> x;
    }

    dag.resize(n);

    for (int i = 0; i < n; ++i) {
        for (auto [v, c] : gr[i]) {
            if (d[i] == d[v] && c != d[i]) {
                cout << "NO\n";
                return;
            }
            if (d[i] == d[v]) continue;
            if (c != d[i]) {
                dag[i].push_back(v);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (!dfs(i)) {
                cout << "NO\n";
                return;
            }
        }
    }

    cout << "YES\n";
    cout << moves.size() << '\n';
    for (auto [v, c] : moves) {
        cout << v + 1 << ' ' << c << '\n';
    }
}