#include <bits/stdc++.h>


using namespace std;


using ll = long long;
const long long inf = 1e18 + 7;


struct segTree {
    vector<pair<ll, int>> t;
    segTree(int MAXN, const vector<ll> &a);
    void build(int v, int tl, int tr, const vector<ll> &a);
    void upd(int v, int tl, int tr, int pos, ll x);
    pair<ll, int> get(int v, int tl, int tr, int ql, int qr);
};


segTree::segTree(int MAXN, const vector<ll> &a) {
    t.resize(MAXN);
    build(0, 0, int(a.size()), a);
}


void segTree::build(int v, int tl, int tr, const vector<ll> &a) {
    if (tl + 1 == tr) {
        t.at(v) = {a.at(tl), tl};
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm, a);
    build(v * 2 + 2, tm, tr, a);
    t.at(v) = min(t.at(v * 2 + 1), t.at(v * 2 + 2));
}


void segTree::upd(int v, int tl, int tr, int pos, ll x) {
    if (tl + 1 == tr) {
        t.at(v).first = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) {
        upd(v * 2 + 1, tl, tm, pos, x);
    } else {
        upd(v * 2 + 2, tm, tr, pos, x);
    }
    t.at(v) = min(t.at(v * 2 + 1), t.at(v * 2 + 2));
}


pair<ll, int> segTree::get(int v, int tl, int tr, int ql, int qr) {
    if (ql == tl && qr == tr) {
        return t.at(v);
    }
    int tm = (tl + tr) / 2;
    if (qr <= tm) {
        return get(v * 2 + 1, tl, tm, ql, qr);
    } else if (ql >= tm) {
        return get(v * 2 + 2, tm, tr, ql, qr);
    }
    return min(get(v * 2 + 1, tl, tm, ql, tm), get(v * 2 + 2, tm, tr, tm, qr));
}


template<typename T>
ostream & operator <<(ostream & os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


int solve(int n, const vector<ll> &t, const vector<ll> &s, int m) {
    vector<int> point(n, 0);
    vector<ll> pos(n, 0);
    vector<ll> dist(n, 0);
    for (int i = 0; i < n; i++) {
        dist.at(i) = t.at(i) * (s.at(point.at(i)) - pos.at(i));
    }
    segTree T(4 * n + 1, dist);
    ll ans = 0;
    int all = n;
    while (all > 0) {
        auto v = T.t.at(0);
        int pl = v.second;
        pos.at(pl) = s.at(point.at(pl));
        point.at(pl)++;
        ans += (all - 1);
        if (point.at(pl) == m) {
            all--;
            T.upd(0, 0, n, pl, inf);
        } else {
            ll buf = t.at(pl) * (s.at(point.at(pl)) - pos.at(pl));
            T.upd(0, 0, n, pl, buf);
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t.at(i);
    }
    for (int i = 0; i < m; i++) {
        cin >> s.at(i);
    }
    vector<ll> ans(n + 1);
    for (int i = 1; i <= n; i++) {
        ans.at(i) = solve(i, t, s, m);
    }
    for (int i = 1; i < n + 1; i++) {
        cout << ans.at(i) << '\n';
    }
    return 0;
}
