#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

struct Fenwick {
	vector<int> t;
	Fenwick(int n) {
		t.resize(n);
	}
	void inc(int i, int d) {
		for (; i < t.size(); i = (i | (i + 1))) {
			t[i] += d;
		}
	}
	int get(int r) {
		int ans = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			ans += t[r];
		}
		return ans;
	}
};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> t(n), s(m + 1);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 1; i <= m; i++) {
		cin >> s[i];
	}
	vector<pair<int, int>> mxs;
	int cur = -1, cnt = 0;
	for (int j = 1; j <= m; j++) {
		if (s[j] - s[j - 1] > cur) {
			if (cur != -1) {
				mxs.pb({cur, cnt});
			}
			cur = s[j] - s[j - 1];
			cnt = 1;
		} else {
			cnt++;
		}
	}
	mxs.pb({cur, cnt});
	vector<ll> Ut;
	{
		for (int i = 0; i < n; i++) {
			Ut.pb(t[i]);
		}
		sort(all(Ut));
		Ut.erase(unique(all(Ut)), Ut.end());
	}
	vector<ll> mem, mx(n);
	ll ans = 0;
	int sz = Ut.size();
	Fenwick tr(sz);
	for (int i = 0; i < n; i++) {
		vector<ll> u;
		for (int j = 0; j < i; j++) {
			u.pb(mx[j]);
		}
		sort(all(u));
		mx[i] = 1ll * mxs.back().first * t[i];
		int cnt = i, ind = 0, pos = 0;
		ll cur_mx = 0;
		sort(all(mem));
		for (int j = 1; j <= m; j++) {
			ll T = 1ll * (s[j] - s[j - 1]) * t[i];
			while (ind < u.size() && u[ind] <= T) {
				ind++;
				cnt--;
			}
			ans += cnt;
		}
		for (auto [cur, cnt] : mxs) {
			ll need_t = mx[i] / cur;
			int j = upper_bound(all(Ut), need_t) - Ut.begin();
			ans += 1ll * cnt * tr.get(j - 1);
		}
		int j = lower_bound(all(Ut), 1ll * t[i]) - Ut.begin();
		tr.inc(j, 1);
		cout << ans << endl;
	}
	return 0;
}