#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

struct Fenwick {
	vector<int> t;
	Fenwick(int n) {
		t.resize(n);
	}
	void inc(int i, int d) {
		for (; i < t.size(); i = (i | (i + 1))) {
			t[i] += d;
		}
	}
	int get(int r) {
		int ans = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			ans += t[r];
		}
		return ans;
	}
};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> t(n), s(m + 1);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 1; i <= m; i++) {
		cin >> s[i];
	}
	vector<pair<int, int>> mxs;
	int cur = -1, cnt = 0;
	for (int j = 1; j <= m; j++) {
		if (s[j] - s[j - 1] > cur) {
			if (cur != -1) {
				mxs.pb({cur, cnt});
			}
			cur = s[j] - s[j - 1];
			cnt = 1;
		} else {
			cnt++;
		}
	}
	mxs.pb({cur, cnt});
	vector<ll> Ut, arr;
	{
		for (int i = 0; i < n; i++) {
			Ut.pb(t[i]);
		}
		sort(all(Ut));
		Ut.erase(unique(all(Ut)), Ut.end());
	}
	vector<ll> mx(n);
	{
		for (int i = 0; i < n; i++) {
			mx[i] = 1ll * mxs.back().first * t[i];
			arr.pb(mx[i]);
		}
		sort(all(arr));
		arr.erase(unique(all(arr)), arr.end());
	}
	ll ans = 0;
	Fenwick tr(Ut.size()), fen(arr.size());
	for (int i = 0; i < n; i++) {
		for (auto [cur, cnt] : mxs) {
			ll T = 1ll * cur * t[i];
			int j = upper_bound(all(arr), T) - arr.begin();
			ans += 1ll * cnt * (i - fen.get(j - 1));
		}
		int k = lower_bound(all(arr), mx[i]) - arr.begin();
		fen.inc(k, 1);
		for (auto [cur, cnt] : mxs) {
			ll need_t = mx[i] / cur;
			int j = upper_bound(all(Ut), need_t) - Ut.begin();
			ans += 1ll * cnt * tr.get(j - 1);
		}
		int j = lower_bound(all(Ut), 1ll * t[i]) - Ut.begin();
		tr.inc(j, 1);
		cout << ans << '\n';
	}
	return 0;
}