#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

const int N = 1e5 + 10;

vector<pair<int, int>> g[N];
int clr[N];
int used[N];

vector<int> ts;

void precount() {
	ts.clear();
	for (int i = 0; i < N; ++i) {
		g[i].clear();
		used[i] = 0;
	}
}

struct Edge {
	int u, v, c;
	Edge(int u, int v, int c): u(u), v(v), c(c) {}
	Edge() {}
};


bool dfs(int v, int lst=-1) {
	used[v] = 1;
	for (auto [u, c] : g[v]) {
		if (c == lst || used[u] == 2) continue;
		if (used[u] == 1) return 1;
		if (dfs(u, c)) return 1;
	}	
	used[v] = 2;
	ts.emplace_back(v);
	return 0;
}

void solve() {
	precount();
	int n, m;
	cin >> n >> m; 
	vector<Edge> es(m);
	for (int i = 0; i < m; ++i) {
		cin >> es[i].u >> es[i].v >> es[i].c;
		--es[i].u; --es[i].v;
	}
	for (int i = 0; i < n; ++i) cin >> clr[i];
	for (int i = 0; i < m; ++i) {
		int u = es[i].u;
		int v = es[i].v;
		int c = es[i].c;
		if (clr[u] == clr[v]) {
			if (clr[u] != c) {
				cout << "NO\n";
				return;
			}
			continue;
		}
		if (clr[u] != c) swap(u, v);
		g[u].emplace_back(v, c);
	}
	bool flag = 0;
	for (int v = 0; v < n; ++v) {
		if (used[v]) continue;
		if (dfs(v)) {
			flag = 1;
			break;
		}
	}
	reverse(all(ts));
	if (!flag) {
		cout << "YES\n";
		vector<pair<int, int>> ans;
		for (int v : ts) {
			ans.emplace_back(v, 1);
			if (clr[v] == 0) ans.emplace_back(v, 0);
		}
		cout << ans.size() << '\n';
		for (auto &[v, t] : ans) cout << v + 1 << ' ' << t << '\n';
	} else {
		cout << "NO\n";
	}
}

int main() {
	FastIO;
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

