#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif // LOCAL_JUDGE
#include <bits/stdc++.h>
using namespace std;

size_t t, n, m, i, u, v, c;

vector<bool> used;
vector<size_t> verts;
vector<vector<size_t>> edges_zero, edges_one;

vector<pair<size_t, size_t>> actions;

bool dfs(size_t u, size_t parent) {
    if (used[u]) return true;
    used[u] = true;

    for (auto& v : edges_zero[u]) {
        if (v == parent) continue;
        if (used[v]) return false;
        if (!dfs(v, u)) return false;
    }

    actions.emplace_back(u, 1);

    for (auto& v : edges_one[u]) {
        if (v == parent) continue;
        if (used[v]) return false;
        if (!dfs(v, u)) return false;
    }

    actions.emplace_back(u, verts[u]);

    return true;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    cin >> t; while (t--) {
        cin >> n >> m;
        edges_zero.clear(); edges_zero.resize(n);
        edges_one.clear();  edges_one.resize(n);

        while (m--) {
            cin >> u >> v >> c; --u; --v;

            (c ? edges_one : edges_zero)[u].push_back(v);
            (c ? edges_one : edges_zero)[v].push_back(u);
        }

        used.assign(n, false);
        verts.resize(n); for (auto& c : verts) cin >> c;

        bool ok = true;
        for (u = 0; u < n && ok; u++) {
            if (verts[u]) {
                for (auto& v : edges_zero[u]) {
                    if (verts[v]) {ok = false; break;}
                }
            } else {
                for (auto& v : edges_one[u]) {
                    if (verts[v] == 0) {ok = false; break;}
                }
            }
        }
        if (!ok) {
            cout << "NO\n"; continue;
        }

        actions.clear();

        bool tree = true;
        for (u = 0; u < n && tree; u++) {
            if (!used[u] && !dfs(u, -1)) tree = false;
        }
        if (!tree) {  // not a tree
            cout << "YES\n-1\n"; continue;
        }

        cout << "YES\n" << actions.size() << "\n";
        for (auto& [v, c] : actions)
            cout << v+1 << " " << c << "\n";

    }

    return 0;
}
