#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;

size_t n, x, k;
vector<size_t> a;

vector<size_t> reaching_ant_count; // by R

#define SEGIN size_t si, size_t sl, size_t sr
#define QIN   size_t ql, size_t qr
#define SEGL  si*2+1, sl, (sl+sr)/2
#define SEGR  si*2+2, (sl+sr)/2, sr
#define QP    ql, qr

void max_set(SEGIN, QIN, size_t v) {
    if (qr <= sl || sr <= ql) return;
    if (ql <= sl && sr <= qr) {
        reaching_ant_count[si] = max(reaching_ant_count[si], v);
        return;
    }
    max_set(SEGL, QP, v); max_set(SEGR, QP, v);
}
size_t query(SEGIN, size_t q) {
    if (q < sl || q >= sr) return 0;
    if (sr - sl == 1) return reaching_ant_count[si];
    return max(reaching_ant_count[si],
               query(SEGL, q) | query(SEGR, q));
}

void add_antenna(size_t x, size_t p) {
    size_t e = min(x + p, n - 1);
    size_t s = x - min(x, p);
    
    max_set(0, 0, n, s, e + 1, e);
}

size_t evaluate() {
    size_t reconnects = 0;
    
    for (size_t i = 0; i < n-1; i++) {
        size_t r = query(0, 0, n, i) + 1;
        size_t c = 0;
        while (r < n) {
            size_t nr = query(0, 0, n, r) + 1;
            reconnects += (min(nr, n) - r) * ++c;
            r = nr;
        }
    }
    
    return reconnects;
}
size_t evaluate(size_t lc, size_t rc) {
    size_t reconnects = 0;
    
    for (size_t i = 0; i < n-1; i++) {
        size_t r = query(0, 0, n, i) + 1;
        if (lc <= i && i <= rc) r = max(r, rc + 1);
        size_t c = 0;
        while (r < n) {
            size_t nr = query(0, 0, n, r) + 1;
            if (lc <= r && r <= rc) nr = max(nr, rc + 1);
            reconnects += (min(nr, n) - r) * ++c;
            r = nr;
        }
    }
    
    return reconnects;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    
    cin >> n >> x;
    a.resize(n); reaching_ant_count.resize(4 * n);
    for (auto& v : a) {
        cin >> v;
        add_antenna(k++, v);
    }
    
    if (!x) {
        cout << evaluate();
    } else {
        size_t ans = evaluate();
        for (size_t i = x; i < n; i++) {
            if (x <= a[i]) continue;
            ans = min(ans, evaluate(i - x, min(i+x, n-1)));
        }
        cout << ans;
    }
    
    return 0;
}
