#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#define DBG(x) cout << x;
#define DBGN(x) cout << #x << ": " << x << endl;
#else
#define DBG(x)
#define DBGN(x)
#endif
#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;

template <class T, class W>
ostream& operator<<(ostream& dst, const pair<T,W>& src) {
    return dst << '(' << src.first << ';' << src.second << ')';
}
template <class T>
ostream& operator<<(ostream& dst, const vector<T>& src) {
    dst << '[';
    for (auto& v : src) dst << v << ' ';
    return dst << ']';
}


size_t n, x, k;
vector<size_t> a;

vector<pair<size_t, size_t>> antenna_events;
vector<size_t> antenna_reach;


size_t evaluate() {
    size_t reconnects = 0;
    
    for (size_t i = 0; i < n-1; i++) {
        size_t r = antenna_reach[i] + 1;
        size_t c = 0;
        
        reconnects += (r - i) * c;
        DBG(i << "-[" << i+1 << ".." << r << "] = 0\n");
        
        while (r < n) {
            size_t nr = antenna_reach[r] + 1;
            reconnects += (min(nr, n) - r) * ++c;
            
            DBG(i << "-[" << r+1 << ".." << nr << "] = "
                 << (min(nr, n) - r) * c << "\n");
            
            r = nr;
        }
        
    }
    
    return reconnects;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    
    cin >> n >> x;
    a.resize(n);
    for (auto& v : a) {
        cin >> v;
        size_t cx = k++;
        antenna_events.emplace_back(cx - min(cx, v), min(cx + v, n-1));
    }
    sort(antenna_events.begin(), antenna_events.end());
    size_t r = 0;
    for (auto& [x, prop_r] : antenna_events) {
        r = max(r, prop_r);
        antenna_reach.resize(x, r);
        antenna_reach.push_back(r);
    }
    antenna_reach.resize(n, r);
    
    DBGN(antenna_events);
    DBGN(antenna_reach);
    
    if (!x) {
        cout << evaluate();
    } else {
        /*
        size_t ans = evaluate();
        for (size_t i = 0; i < n; i++) {
            if (x <= a[i]) continue;
            add_antenna(i, x);
            ans = min(ans, evaluate());
            remove_antenna(i, x);
        }
        cout << ans;
        */
    }
    
    return 0;
}
