// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
const int inf = (int)2e9;
using namespace std;
int n, m;
vector<vector<pair<int, int>>> graph;
vector<pair<int, int>> edges;
vector<pair<int, bool>> answer;
vector<bool> node_lighted, node_need_light, edge_need_light, node_blocked;
bool dfs(bool to_enable, int vertex) {
	if (to_enable == node_lighted[vertex])
		return true;
	if (node_blocked[vertex])
		return false;
	node_blocked[vertex] = true;
	bool result = true;
	for (auto [child, edge] : graph[vertex]) {
		result &= dfs(edge_need_light[edge], child);
		if (!result)
			return false;
	}
	answer.push_back({ vertex, to_enable});
	node_lighted[vertex] = to_enable;
	
	node_blocked[vertex] = false;
	return true;
}
bool dfs_return(int vertex) {
	if (node_lighted[vertex] == node_need_light[vertex])
		return true;
	if (node_blocked[vertex])
		return false;
	node_blocked[vertex] = true;
	node_lighted[vertex] = node_need_light[vertex];
	answer.push_back({ vertex, node_need_light[vertex] });
	for (auto [child, edge] : graph[vertex]) {
		bool result = dfs_return(child);
		if (!result)
			return false;
	}

	node_blocked[vertex] = false;
	return true;
}
void solve()
{
	cin >> n >> m;
	graph.clear();
	node_blocked.assign(n, false);
	node_lighted.assign(n, false);
	edge_need_light.assign(m, false);
	node_need_light.assign(n, false);
	graph.resize(n);
	answer.clear();
	edges.clear();
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		int c;
		cin >> c;
		edge_need_light[i] = c;
		edges.push_back({ u, v });
	}
	for (int i = 0; i < n; i++)
	{
		int s;
		cin >> s;
		if (s)
			answer.push_back({ i, s });
		node_lighted[i] = node_need_light[i] = s;
	}
	for (int i = 0; i < m; i++)
	{
		if (node_need_light[edges[i].first] != edge_need_light[i] && node_need_light[edges[i].second] != edge_need_light[i]) {
			cout << "NO\n";
			return;
		}
		else if (node_need_light[edges[i].first] != edge_need_light[i])
			swap(edges[i].first, edges[i].second);
	}
	bool success = true;
	for (int i = 0; i < m; i++)
	{
		auto [u, v] = edges[i];
		node_blocked[u] = true;
		graph[u].push_back({ v, i });
		graph[v].push_back({ u, i });
		success &= dfs(edge_need_light[i], v);
		success &= dfs_return(v);
		node_blocked[edges[i].first] = false;
	}
	if (success) {
		cout << "YES\n";
		cout << answer.size() << '\n';
		for (auto [vertex, c] : answer)
			cout << vertex + 1 << ' ' << c << '\n';
	}
	else
		cout << "NO\n";
	return;

}
int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}
// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
