#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <set>
#include <queue>
const int inf = (int)2e9;
using namespace std;
struct node {
	node* left = nullptr, * right = nullptr;
	long long sum = 0;
	long long block = 0;
	int lazy = 0;
	void check_children() {
		if (!left) {
			left = new node();
			right = new node();
		}
	}
	void add_lazy(int node_l, int node_r, int x) {
		lazy += x;
		sum += (node_r - node_l + 1LL - block) * x;
	}
	void push(int node_l, int node_r) {
		check_children();
		int mid = (node_l + node_r) / 2;
		left->add_lazy(node_l, mid, lazy);
		right->add_lazy(mid+1, node_r, lazy);
		lazy = 0;
	}
	void add(int x, int l, int r, int node_l, int node_r) {
		if (l > node_r || r < node_l)
			return;
		if (l <= node_l && node_r <= r)
			return add_lazy(node_l, node_r, x);
		push(node_l, node_r);
		int mid = (node_l + node_r) / 2;
		left->add(x, l, r, node_l, mid);
		right->add(x, l, r, mid+1, node_r);
		sum = left->sum + right->sum;
		block = left->block + right->block;
	}
	long long get(int l, int r, int node_l, int node_r) {
		if (l > node_r || r < node_l)
			return 0;
		if (l <= node_l && node_r <= r)
			return sum;
		push(node_l, node_r);
		int mid = (node_l + node_r) / 2;
		return
		left->get(l, r, node_l, mid) + 
		right->get(l, r, mid + 1, node_r);
	}
	void blockf(int pos, int node_l, int node_r){
		if (pos > node_r || pos < node_l)
			return;
		if (pos <= node_l && node_r <= pos) {
			block = 1;
			return;
		}
		push(node_l, node_r);
		int mid = (node_l + node_r) / 2;
		left->blockf(pos, node_l, mid);
		right->blockf(pos, mid + 1, node_r);
		sum = left->sum + right->sum;
		block = left->block + right->block;
	}
};
void solve()
{
	int n, m;
	cin >> n >> m;
	long long end_of_seg = (long long)n * m - 1;
	node root;
	vector<int> t(n);
	for (auto& i : t)
		cin >> i;
	vector<int> dist(m);
	int old = 0;
	for (int i = 0; i < m; i++)
	{
		int s;
		cin >> s;
		dist[i] = s - old;
		old = s;
	}
	vector<int> step(n, 0);
	vector<int> drone_final(n, -1);
	vector<int> drone_add(n, 0);
	node dr;
	priority_queue<pair<long long, int>, vector<pair<long long, int>>, greater<pair<long long, int>>> time;
	for (int i = 0; i < n; i++)
	{
		time.push({ (long long)dist[step[i]] * t[i], i });
	}
	int i = 0;
	node alive;
	alive.add(1, 0, n - 1, 0, n - 1);
	while (time.size()) {
		int drone = time.top().second;
		time.pop();
		step[drone]++;
		dr.add(alive.get(0, drone - 1, 0, n - 1), drone, drone, 0, n - 1);
		dr.add(1, drone + 1, n - 1, 0, n - 1);
		if (step[drone] == m){
			drone_final[drone] = i;
			alive.add(-1, drone, drone, 0, n - 1);
			dr.blockf(drone, 0, n - 1);
		}
		else {
			time.push({ (long long)dist[step[drone]] * t[drone], drone });
		}

		i++;
	}
	long long result = 0;
	for (int i = 0; i < n; i++)
	{
		result += dr.get(i, i, 0, n-1);
		cout << result << '\n';
	}
	cout << '\n';
}
int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
	return 0;
}