#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, v, c;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector<Edge> edges;
    vector<int> need(m);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;

        need[i] = c;
        edges.push_back({u - 1, v - 1, c});
        g[u - 1].push_back(edges.size() - 2);
        g[v - 1].push_back(edges.size() - 1);
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }

    vector<int> changes;
    for (int i = 0; i < m; ++i) {
        if (need[i] == 1) changes.push_back(i);
    }

    function<bool(vector<pair<int, int>>)> check = [&](vector<pair<int, int>> mv) -> bool {
        vector<int> colV(n);
        vector<int> colE(m);

        for (auto [v, c]: mv){
            colV[v - 1] = c;
            for (int j = 0; j < m; ++j) {
                if (colV[edges[j].u] == colV[edges[j].v]) {
                    colE[j] = colV[edges[j].u];
                }
            }
        }
        return (colE == need && colV == d);
    };

    do {
        vector<int> colV(n);
        vector<int> colE(m);

        vector<pair<int, int>> ans;
        for (auto i: changes) {
            int u = edges[i].u;
            int v = edges[i].v;
            for (int j = 0; j < m; ++j) {
                if (edges[j].u == u || edges[j].v == u) {
                    int vv = edges[j].u ^ edges[j].v ^ u;
                    if (need[j] == 0 && colV[vv] == 1) {
                        ans.push_back({vv + 1, 0});
                        colV[vv] = 0;
                    }
                }
                if (edges[j].u == v || edges[j].v == v) {
                    int vv = edges[j].u ^ edges[j].v ^ v;
                    if (need[j] == 0 && colV[vv] == 1) {
                        ans.push_back({vv + 1, 0});
                        colV[vv] = 0;
                    }
                }
            }
            ans.push_back({u + 1, 1});
            ans.push_back({v + 1, 1});
            colV[u] = colV[v] = 1;
            for (int j = 0; j < m; ++j) {
                if (colV[edges[j].u] == colV[edges[j].v]) {
                    colE[j] = colV[edges[j].u];
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (d[i] == 0) {
                ans.push_back({i + 1, d[i]});
                colV[i] = d[i];
            }
        }
        for (int i = 0; i < n; ++i) {
            if (d[i] == 1) {
                ans.push_back({i + 1, d[i]});
                colV[i] = d[i];
            }
        }
        for (int j = 0; j < m; ++j) {
            if (colV[edges[j].u] == colV[edges[j].v]) {
                colE[j] = colV[edges[j].u];
            }
        }
        if (check(ans)) {
            cout << "YES" << "\n";
            cout << ans.size() << "\n";
            for (auto [u, v]: ans) cout << u << " " << v << "\n";
            return;
        }
    } while (next_permutation(changes.begin(), changes.end()));


    cout << "NO" << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}