#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, v, c;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector<Edge> edges;
    vector<int> need(m);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;

        need[i] = c;
        edges.push_back({u - 1, v - 1, c});
        g[u - 1].push_back(edges.size() - 1);
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[edges[i].u] == d[edges[i].v] && d[edges[i].u] != need[i]) {
            cout << "NO" << "\n";
            return;
        }
    }

    vector<int> used(n);
    vector<pair<int, int>> changes;
    function<void(int)> bfs = [&](int st) {
        deque<int> q = {st};
        used[st] = true;
        while (!q.empty()) {
            int v = q.front();
            q.pop_front();
            changes.push_back({v + 1, d[v]});
            if (g[v].empty()) return;
            for (int id: g[v]) {
                int u = edges[id].u ^ edges[id].v ^ v;
                if (!used[u]) {
                    used[u] = true;
                    changes.push_back({u + 1, d[v]});
                    q.push_back(u);
                }
            }
        }
    };


    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    function<bool(vector<pair<int, int>>)> check = [&](vector<pair<int, int>> mv) -> bool {
        vector<int> colV(n);
        vector<int> colE(m);

        for (auto [v, c]: mv) {
            colV[v - 1] = c;
            for (int j: g[v - 1]) {
                if (colV[edges[j].u] == colV[edges[j].v]) {
                    colE[j] = colV[edges[j].u];
                }
            }
        }
        return (colE == need && colV == d);
    };

    if (check(changes)) {
        cout << "YES" << "\n";
        cout << changes.size() << "\n";
        for (int i = 0; i < changes.size(); ++i) {
            cout << changes[i].first << " " << changes[i].second << "\n";
        }
    } else {
        cout << "NO" << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}