#include <bits/stdc++.h>

#define int long long

using namespace std;


const int inf = 1e9 + 7;


struct e{
    int start;
    int finish;
    int colour;
};



void dfs(int v, int p, vector<pair<int, int>> & ans, vector<int> & colour_v, vector<vector<e>> & edges) {
    for (auto u : edges[v]) {
        int next = u.finish;
        if (next != p) {
            if (u.colour == 0) {
                dfs(next, v, ans, colour_v, edges);
            }
        }
    }
    ans.push_back({v, 1});
    for (auto u : edges[v]) {
        int next = u.finish;
        if (next != p) {
            if (u.colour == 1) {
                dfs(next, v, ans, colour_v, edges);
            }
        }
    }
    if (colour_v[v] == 0) {
        ans.push_back({v, 0});
    }

}




void sol() {
    int n, m;
    cin >> n >> m;
    vector<vector<e>> edges(n + 1, vector<e>());
    vector<e> lst_of_edges;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edges[a].push_back({a, b, c});
        edges[b].push_back({b, a, c});
        lst_of_edges.push_back({a, b, c});
    }
    vector<int> colour_v(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> colour_v[i];
    }
    int cou_0 = 0;
    for (int i = 0; i < lst_of_edges.size(); i++) {
        if (lst_of_edges[i].colour == 0) {
            cou_0++;
        }
        if (colour_v[lst_of_edges[i].start] == colour_v[lst_of_edges[i].finish] && colour_v[lst_of_edges[i].start] != lst_of_edges[i].colour) {
            cout << "NO" << endl;
            return;
        }
    }
    vector<pair<int, int>> ans;
    dfs(1, -1, ans, colour_v, edges);
    cout << "YES" << endl;
    for (auto v : ans) {
        cout << v.first << " " << v.second << endl;
    }
}




signed main()
{
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
