#include <bits/stdc++.h>

#define int long long

using namespace std;


const int inf = 1e9 + 7;


struct e{
    int start;
    int finish;
    int colour;
    int ind_of_edge;
};



void addd(int a, int b, vector<pair<int, int>> & ans, vector<int> & now_colour) {
    if (now_colour[a] != b) {
        ans.push_back({a, b});
        now_colour[a] = b;
    }
}

const int maxn = 2e5 + 100;

vector<bool> used(maxn, false);
vector<bool> where_edge_in_graph(maxn, false);




void dfs(int v, int p, vector<pair<int, int>> & ans, vector<int> & colour_v, vector<vector<e>> & edges, int col_to_par, vector<int> & now_colour) {
    used[v] = true;
    if (col_to_par == 1) {
        addd(v, 1, ans, now_colour);
        addd(v, 0, ans, now_colour);
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 0 && colour_v[next] == 0) {
            addd(v, 0, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 0, now_colour);
        }
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 1 && colour_v[next] == 1) {
            addd(v, 1, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 1, now_colour);
        }
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 1 && colour_v[next] == 0) {
            addd(v, 1, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 1, now_colour);
        }
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 0 && colour_v[next] == 1) {
            addd(v, 0, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 0, now_colour);
        }
    }

    if (colour_v[v] == 0) {
        addd(v, 0, ans, now_colour);
    } else {
        addd(v, 1, ans, now_colour);
    }

}




void sol() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        where_edge_in_graph[i] = false;
        used[i] = false;
    }
    vector<vector<e>> edges(n + 1, vector<e>());
    vector<e> lst_of_edges;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edges[a].push_back({a, b, c, i});
        edges[b].push_back({b, a, c, i});
        lst_of_edges.push_back({a, b, c, i});
    }
    vector<int> colour_v(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> colour_v[i];
    }
    int cou_0 = 0;
    for (int i = 0; i < lst_of_edges.size(); i++) {
        if (lst_of_edges[i].colour == 0) {
            cou_0++;
        }
        if (colour_v[lst_of_edges[i].start] == colour_v[lst_of_edges[i].finish] && colour_v[lst_of_edges[i].start] != lst_of_edges[i].colour) {
            cout << "NO" << endl;
            return;
        }
    }
    vector<pair<int, int>> ans;
    vector<int> now_colour(n + 1, 0);
    dfs(1, -1, ans, colour_v, edges, -1, now_colour);
    vector<int> colour_of_v_now(n + 1, 0);
    vector<int> colour_of_edge(m, 0);
    for (auto v : ans) {
        colour_of_v_now[v.first] = v.second;
        for (int i = 0; i < m; i++) {
            if (colour_of_v_now[lst_of_edges[i].start] == colour_of_v_now[lst_of_edges[i].finish]) {
                colour_of_edge[i] = colour_of_v_now[lst_of_edges[i].start];
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (lst_of_edges[i].colour != colour_of_edge[i]) {
            cout << "NO" << endl;
            return;
        }
    }
    cout << "YES" << endl;
    cout << ans.size() << endl;
    for (auto v : ans) {
        cout << v.first << " " << v.second << endl;
    }
}




signed main()
{
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
