#include <bits/stdc++.h>

#define int long long

using namespace std;


const int inf = 1e9 + 7;



struct e{
    int start;
    int finish;
    int colour;
    int ind_of_edge;
};



void addd(int a, int b, vector<pair<int, int>> & ans, vector<int> & now_colour) {
    if (now_colour[a] != b) {
        ans.push_back({a, b});
        now_colour[a] = b;
    }
}

const int maxn = 2e5 + 100;

vector<bool> used(maxn, false);
vector<bool> where_edge_in_graph(maxn, false);




void dfs(int v, int p, vector<pair<int, int>> & ans, vector<int> & colour_v, vector<vector<e>> & edges, int col_to_par, vector<int> & now_colour) {
    used[v] = true;
    if (col_to_par == 1) {
        addd(v, 1, ans, now_colour);
        addd(v, 0, ans, now_colour);
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 0 && colour_v[next] == 0) {
            addd(v, 0, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 0, now_colour);
        }
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 1 && colour_v[next] == 1) {
            addd(v, 1, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 1, now_colour);
        }
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 1 && colour_v[next] == 0) {
            addd(v, 1, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 1, now_colour);
        }
    }
    for (auto u : edges[v]) {
        int next = u.finish, col = u.colour;
        if (!used[next] && next != p && col == 0 && colour_v[next] == 1) {
            addd(v, 0, ans, now_colour);
            where_edge_in_graph[u.ind_of_edge] = true;
            dfs(next, v, ans, colour_v, edges, 0, now_colour);
        }
    }

    if (colour_v[v] == 0) {
        addd(v, 0, ans, now_colour);
    } else {
        addd(v, 1, ans, now_colour);
    }

}




void sol() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        where_edge_in_graph[i] = false;
        used[i] = false;
    }
    vector<vector<e>> edges(n + 1, vector<e>());
    vector<e> lst_of_edges;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edges[a].push_back({a, b, c, i});
        edges[b].push_back({b, a, c, i});
        lst_of_edges.push_back({a, b, c, i});
    }
    vector<int> colour_v(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> colour_v[i];
    }
    for (int tr = 0; tr < 100; tr++) {
        vector<pair<int, int>> ans;
        vector<int> now_v(n + 1, 0);
        vector<int> now_e(m, 0);
        for (int j = 0; j < 40; j++) {
            int rand_v = rand() % n + 1;
            int rand_cl = rand() % 2;
            ans.push_back({rand_v, rand_cl});
            now_v[rand_v] = rand_cl;
            int cou_bad = 0;
            for (int ind = 1; ind <= n; ind++) {
                if (colour_v[ind] != now_v[ind]) {
                    cou_bad++;
                }
            }
            for (int ind = 0; ind < m; ind++) {
                if (now_v[lst_of_edges[ind].start] == now_v[lst_of_edges[ind].finish]) {
                    now_e[ind] = now_v[lst_of_edges[ind].start];
                }
                if (now_e[ind] != lst_of_edges[ind].colour) {
                    cou_bad++;
                }
            }
            if (cou_bad == 0) {
                cout << "YES" << endl << ans.size() << endl;
                for (auto v : ans) {
                    cout << v.first << " " << v.second << endl;
                }
                return;
            }
        }
    }
    cout << "NO" << endl;
}




signed main()
{
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
