// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

class MST
{
private:
	int size;
	int tsize;
	vector<vector<int>> t;
	int q(int l, int r, int ql, int qr, int ind, int val)
	{
		if (l >= qr || ql >= r)
			return 0;
		if (l >= ql && r <= qr)
			return upper_bound(all(t[ind]), val) - lower_bound(all(t[ind]), val);
		int m = (l + r) / 2;
		return q(l, m, ql, qr, ind * 2, val) + q(m, r, ql, qr, ind * 2 + 1, val);
	}
public:
	MST(vector<int>& v)
	{
		for (size = 1; size < v.size(); size <<= 1);
		tsize = size * 2;
		t.resize(tsize);
		for (int i = 0; i < v.size(); i++)
			t[i + size].push_back(v[i]);
		for (int i = size - 1; i > 0; i--)
			merge(all(t[i * 2]), all(t[i * 2 + 1]), back_inserter(t[i]));
	}
	int q(int l, int r, int val)
	{
		return q(0, size, l, r, 1, val);
	}
};

int main()
{
	int size;
	cin >> size;
	vector<int> d(size), p(size), x(size);
	for (int i = 0; i < size; i++)
		cin >> x[i] >> p[i] >> d[i];
	vector<int> canleft(size), canright(size);
	canleft[0] = 1;
	canright.back() = 1;
	for (int i = 1; i < size; i++)
		if (x[i] - p[i] <= x[i - 1])
			canleft[i] = 1;
	for (int i = size - 2; i >= 0; i--)
		if (x[i] + p[i] >= x[i + 1])
			canright[i] = 1;

	MST tcl(canleft), tcr(canright);
	MST td(d);

	int res = 1e9;

	if (tcl.q(0, size, 1) == size)
		res = min(res, size - td.q(0, size, -1));
	if (tcr.q(0, size, 1) == size)
		res = min(res, size - td.q(0, size, 1));

	for (int i = 1; i < size - 1; i++)
	{
		int cntl = tcr.q(0, i, 1);
		if (cntl < i)
			continue;
		int cntr = tcl.q(i, size, -1);
		if (cntr < size - i)
			continue;
		res = min(res, (i - td.q(0, i, 1) + (size - i - td.q(i, size, -1))));
	}

	if (res == 1e9)
		cout << -1;
	else
		cout << res << '\n';
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
