#include <iostream>
#include <vector>
#include <string>
#include <limits.h>
#include <algorithm>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long

int sign(int a)
{
	return a > 0 ? 1 : -1;
}

class ST
{
private:
	int size;
	int tsize;
	vector<pair<int, int>> t;
public:
	ST(vector<int>& v)
	{
		for (size = 1; size < v.size(); size <<= 1);
		tsize = size * 2;
		t.resize(tsize * 100000, { 1e9, 1e9 });
		for (int i = 0; i < v.size(); i++)
			t[i + size] = { v[i], i };
		for (int i = size - 1; i > 0; i--)
			t[i] = min(t[i * 2], t[i * 2 + 1]);
	}
	void update(int ind, int val)
	{
		t[ind + size].first = val;
		for (int i = (ind + size) / 2; i; i >>= 1)
			t[i] = min(t[i * 2], t[i * 2 + 1]);
	}
	pair<int, int> get()
	{
		return t[1];
	}

};

void solve()
{
	int size, m;
	cin >> size >> m;
	vector<int> done(size, 0);
	vector<int> x(m), t(size);
	for (auto& i : t)
		cin >> i;
	for (auto& i : x)
		cin >> i;
	vector<int> times;
	for (int cnt = 0; cnt < size; cnt++)
	{
		times.push_back(t[cnt] * x[0]);
		ST tree(times);
		vector<int> done(cnt + 1, 0);
		int over = 0;
		int res = 0;
		while (over < cnt)
		{
			auto p = tree.get();
			res += (cnt - over);
			done[p.second]++;
			if (done[p.second] == m)
			{
				tree.update(p.second, 1e18);
				over++;
			}
			else
				tree.update(p.second, t[p.second] * (x[done[p.second]] - x[done[p.second]-1]));
		}
		cout << res << '\n';
	}
}


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t = 1;
	//cin >> t;
	while (t--)
		solve();
	return 0;
}