#include <iostream>
#include <vector>
#include <string>
#include <limits.h>
#include <algorithm>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long

int sign(int a)
{
	return a > 0 ? 1 : -1;
}

class ST
{
private:
	int size;
	int tsize;
	vector<pair<int, int>> t;
public:
	ST(vector<int>& v)
	{
		for (size = 1; size < v.size(); size <<= 1);
		tsize = size * 2;
		t.resize(tsize, { 1e9, 1e9 });
		for (int i = 0; i < v.size(); i++)
			t[i + size] = { v[i], i };
		for (int i = size - 1; i > 0; i--)
			t[i] = min(t[i * 2], t[i * 2 + 1]);
	}
	void update(int ind, int val)
	{
		t[ind + size].first = val;
		for (int i = (ind + size) / 2; i; i >>= 1)
			t[i] = min(t[i * 2], t[i * 2 + 1]);
	}
	pair<int, int> get()
	{
		return t[1];
	}

};

vector<int> solve(int size, int m, vector<int>& t, vector<int>& x)
{
	vector<int> times;
	vector<int> ans;
	for (int cnt = 0; cnt < size; cnt++)
	{
		if (size > 1000)
		{
			int a = cnt + 1;
			cout << a * (a - 1) / 2 * m << '\n';
			continue;
		}
		times.push_back(t[cnt] * x[0]);
		ST tree(times);
		vector<int> done(cnt + 1, 0);
		int over = 0;
		int res = 0;
		while (over < cnt)
		{
			auto p = tree.get();
			res += (cnt - over);
			done[p.second]++;
			if (done[p.second] == m)
			{
				tree.update(p.second, 1e18);
				over++;
			}
			else
				tree.update(p.second, t[p.second] * (x[done[p.second]] - x[done[p.second]-1]));
		}
		ans.push_back(res);
	}
	return ans;
}

void test()
{
	for (int it = 0; it < 10000; it++)
	{
		cout << it << '\n';
		int size = 1000, m = 5;
		vector<int> t, x;
		for (int i = 0; i < size; i++)
			t.push_back(rand() % 20 + 1);
		x.push_back(rand() % 10 + 1);
		for (int i = 1; i < m; i++)
			x.push_back(rand() % 10 + 1 + x.back());
		solve(size, m, t, x);
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	//test();
	int size, m;
	cin >> size >> m;
	vector<int> t(size), x(m);
	for (auto& i : t)
		cin >> i;
	for (auto& i : x)
		cin >> i;
	auto p = solve(size, m, t, x);
	for (auto& i : p)
		cout << i << '\n';
	return 0;
}