#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <limits.h>
using namespace std;

#define int long long

class ST
{
private:
	int size;
	int tsize;
	vector<int> t;
	vector<int> p;
	void push(int ind)
	{
		if (p[ind] == -1)
			return;
		t[ind] = max(t[ind], p[ind]);
		if (ind >= size)
		{
			p[ind] = -1;
			return;
		}
		p[ind * 2] = max(p[ind * 2], p[ind]);
		p[ind * 2 + 1] = max(p[ind * 2 + 1], p[ind]);
		p[ind] = -1;
	}
	void update(int l, int r, int ql, int qr, int ind, int val)
	{
		push(ind);
		if (l >= qr || ql >= r)
			return;
		if (l >= ql && r <= qr)
		{
			p[ind] = max(p[ind], val);
			push(ind);
			return;
		}
		int m = (l + r) / 2;
		update(l, m, ql, qr, ind * 2, val);
		update(m, r, ql, qr, ind * 2 + 1, val);
	}
public:
	ST(int s)
	{
		for (size = 1; size < s; size <<= 1);
		tsize = size * 2;
		t.resize(tsize, -1);
		p.resize(tsize, -1);
	}
	void globalpush()
	{
		for (int i = 1; i < tsize; i++)
			push(i);
	}
	void update(int l, int r, int val)
	{
		update(0, size, l, r, 1, val);
	}
	int get(int ind)
	{
		return t[ind + size];
	}
};

class Pref
{
private:
	vector<int> p;
public:
	Pref(vector<int>& v)
	{
		p.resize(v.size() + 1, 0);
		for (int i = 0; i < v.size(); i++)
			p[i + 1] = p[i] + v[i];
	}
	int get(int l, int r)
	{
		return p[r] - p[l];
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int size, x;
	cin >> size >> x;
	if (x > 0)
	{
		cout << 0 << '\n';
		return 0;
	}
	vector<int> a(size);
	for (auto& i : a)
		cin >> i;
	ST t(size);
	for (int i = 0; i < size; i++)
	{
		int lb = max(0ll, i - a[i]);
		int rb = min(size - 1, i + a[i]);
		t.update(lb, rb + 1, rb + 1);
	}
	t.globalpush();
	vector<int> dp(size);
	dp.back() = 0;
	for (int i = size - 1; i >= 0; i--)
	{
		int n = t.get(i);
		if (n >= size - 1)
			dp[i] = 0;
		else
			dp[i] = dp[n] + 1;
	}
	int res = 0;
	Pref p(dp);
	for (int i = 0; i < size - 1; i++)
		res += dp[i] * (size - 1 - i) - p.get(i + 1, size);
	cout << res << '\n';
}