#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
using namespace std;
using ll = long long;
ll inf = 1e16;

#define r(v) (l(v) | 1)
#define l(v) (v << 1)
#define mid ((t[v].l + t[v].r) >> 1)


struct segTree {
	struct node {
		int l, r;
		ll val;
	};
	vector<node> t;
	void build(int v, int l, int r, vector<ll>& a) {
		t[v].l = l; t[v].r = r;
		if (l < r) {
			build(l(v), l, mid, a);
			build(r(v), mid + 1, r, a);
			t[v].val = min(t[l(v)].val, t[r(v)].val);
		}
		else t[v].val = a[l];
	}
	void init(int n, vector<ll>& a) {
		int sz = 1;
		while (sz < n) sz *= 2;
		t.resize(sz * 2);
		build(1, 0, n - 1, a);
	}
	void ins(int v, int pos, ll nw) {
		if (t[v].l == t[v].r) t[v].val = nw;
		else {
			ins(pos <= mid ? l(v) : r(v), pos, nw);
			t[v].val = min(t[l(v)].val, t[r(v)].val);
		}
	}
	ll get(int v, int l, int r) {
		if (l <= t[v].l && t[v].r <= r) return t[v].val;
		if (mid >= r) return get(l(v), l, r);
		if (mid < l) return get(r(v), l, r);
		return min(get(l(v), l, r), get(r(v), l, r));
	}
	int get_ind(int v, ll mn) {
		if (t[v].l == t[v].r) return t[v].l;
		return (t[l(v)].val == mn ? get_ind(l(v), mn) : get_ind(r(v), mn));
	}
};


void solve(int n, int m, vector<ll> &dist, vector<ll> &s, vector<ll> &t) {
	ll cnt_live = n;
	ll ans = 0;
	vector<int> pos(n);
	segTree tr;
	tr.init(n, dist);
	while (cnt_live > 0) {
		int p = tr.get_ind(1, tr.get(1, 0, n - 1));
		ans += cnt_live - 1;
		pos[p]++;
		if (pos[p] == m - 1) {
			tr.ins(1, p, inf);
			cnt_live--;
		}
		else tr.ins(1, p, (s[pos[p] + 1] - s[pos[p]]) * t[p]);
	}
	cout << ans << " ";
}

int main() {
	ll n, m;
	cin >> n >> m;

	vector<ll> t(n);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	vector<ll> s(m + 1);
	for (int i = 1; i <= m; i++) {
		cin >> s[i];
	}

	vector<ll> pos(n);

	vector<ll> dist(n);
	for (int i = 0; i < n; i++) dist[i] = s[1] * t[i];
	
	for (int k = 1; k <= n; k++) {
		solve(k, m + 1, dist, s, t);
	}
	cout << endl;
}
