#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
using namespace std;
using ll = long long;
ll inf = 1e16;

#define r(v) (l(v) | 1)
#define l(v) (v << 1)
#define mid ((t[v].l + t[v].r) >> 1)


struct segTree {
	struct node {
		int l, r;
		ll val;
	};
	vector<node> t;
	void build(int v, int l, int r, vector<ll>& a) {
		t[v].l = l; t[v].r = r;
		if (l < r) {
			build(l(v), l, mid, a);
			build(r(v), mid + 1, r, a);
			t[v].val = min(t[l(v)].val, t[r(v)].val);
		}
		else t[v].val = a[l];
	}
	void init(int n, vector<ll>& a) {
		int sz = 1;
		while (sz < n) sz *= 2;
		t.resize(sz * 2);
		build(1, 0, n - 1, a);
	}
	void ins(int v, int pos, ll nw) {
		if (t[v].l == t[v].r) t[v].val = nw;
		else {
			ins(pos <= mid ? l(v) : r(v), pos, nw);
			t[v].val = min(t[l(v)].val, t[r(v)].val);
		}
	}
	ll get(int v, int l, int r) {
		if (l <= t[v].l && t[v].r <= r) return t[v].val;
		if (mid >= r) return get(l(v), l, r);
		if (mid < l) return get(r(v), l, r);
		return min(get(l(v), l, r), get(r(v), l, r));
	}
	int get_ind(int v, ll mn) {
		if (t[v].l == t[v].r) return t[v].l;
		return (t[l(v)].val == mn ? get_ind(l(v), mn) : get_ind(r(v), mn));
	}
};


ll solve(int n, vector<int> a) {
	vector<int> R(n + 1);
	for (int i = 0; i < n; i++) {
		int pos = i + 1;
		int r = a[i];
		R[max(1, pos - r)] = max(R[max(1, pos - r)], min(n, pos + r));
	}
	for (int i = 2; i <= n; i++) {
		R[i] = max(R[i - 1], R[i]);
	}
	ll ans = 0;
	vector<ll> otv(n + 1);
	for (int i = n; i >= 1; i--) {
		if (R[i] >= n) continue;
		otv[i] = otv[R[i] + 1] + n - (R[i] + 1) + 1;
		ans += otv[i];
	}
	return ans;
}

int main() {
	int n, x;
	cin >> n >> x;

	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	ll ans = solve(n, a);
	for (int i = 0; i < n; i++) {
		if (x > a[i]) {
			int last = a[i];
			a[i] = x;
			ans = min(ans, solve(n, a));
			a[i] = last;
		}
	}
	cout << ans << endl;
}
