#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, m, x;
vector<vector<pair<int, int>>> graph;
vector<pair<int, int>> e;
vector<int> used;
vector<pair<int, int>> moves;
vector<int> c;
vector<int> d;
vector<int> r;
vector<int> l;

void dfs(int v) {
    used[v] = x;
    for (auto [u, id] : graph[v]) {
        if (l[v] == 1 && l[u] == 1)
            r[id] = 1;
        if (l[v] == 0 && l[u] == 0)
            r[id] = 0;
        if (used[u] != x)
            dfs(u);
    }
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int v, u;
    cin >> n >> m;
    graph.clear();
    e.clear();
    c.clear();
    d.clear();
    r.clear();
    used.clear();
    moves.clear();
    graph.resize(n + 1);
    e.resize(m);
    c.resize(m);
    r.resize(m, 0);
    l.resize(n + 1, 0);
    d.resize(n + 1);
    used.resize(n + 1, 0);
    x = 0;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> c[i];
        graph[v].push_back({u, i});
        graph[u].push_back({v, i});
        e[i] = {v, u};
    }
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    for (int i = 0; i < m; i++) {
        if (c[i] == 1) {
            auto [a, b] = e[i];
            l[a] = 1;
            l[b] = 1;
            moves.push_back({a, 1});
            moves.push_back({b, 1});
        }
    }
    x++;
    dfs(1);
    for (int i = 0; i < m; i++) {
        if (c[i] == 0 && r[i] != 0) {
            auto [a, b] = e[i];
            l[a] = 0;
            l[b] = 0;
            moves.push_back({a, 0});
            moves.push_back({b, 0});
        }
    }
    x++;
    dfs(1);
    for (int i = 1; i <= n; i++) {
        if (l[i] != d[i]) {
            moves.push_back({i, d[i]});
            l[i] = d[i];
            for (auto [j, id] : graph[i]) {
                if (l[i] == 1 && l[j] == 1)
                    r[id] = 1;
                if (l[i] == 0 && l[j] == 0)
                    r[id] = 0;
            }
        }
    }
    bool flag = true;
    for (int i = 0; i < m; i++) {
        if (r[i] != c[i]) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        cout << "NO" << '\n';
        return;
    }
    cout << "YES" << '\n';
    cout << -1 << '\n';
    //cout << moves.size() << '\n';
    //for (auto [a, b] : moves)
    //    cout << a << ' ' << b << '\n';
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
