#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, m, x;
vector<bool> used;
vector<vector<vector<int>>> graph;
vector<pair<int, int>> e;
vector<pair<int, int>> moves;
vector<int> c;
vector<int> d;
vector<int> r;

void dfs(int v) {
    if (d[v] == 0)
        sort(graph[v].rbegin(), graph[v].rend());
    else
        sort(graph[v].begin(), graph[v].end());
    used[v] = true;
    for (auto &elem : graph[v]) {
        int u = elem[1], id = elem[2];
        if (!used[u]) {
            moves.push_back({v, c[id]});
            moves.push_back({u, c[id]});
            r[id] = c[id];
            dfs(u);
        }
    }
    moves.push_back({v, d[v]});
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int v, u;
    cin >> n >> m;
    graph.clear();
    e.clear();
    c.clear();
    d.clear();
    r.clear();
    moves.clear();
    used.clear();
    graph.resize(n + 1);
    e.resize(m);
    c.resize(m);
    d.resize(n + 1);
    r.resize(m);
    used.resize(n + 1, false);
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> c[i];
        graph[v].push_back({c[i], u, i});
        graph[u].push_back({c[i], v, i});
        e[i] = {v, u};
    }
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    bool flag = true;
    for (int i = 0; i < m; i++) {
        auto [a, b] = e[i];
        if (c[i] != d[a] && c[i] != d[b]) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        cout << "NO" << '\n';
        return;
    }
    cout << "YES" << '\n';
    dfs(1);
    cout << moves.size() << '\n';
    for (auto [a, b] : moves)
        cout << a << ' ' << b << '\n';
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
