#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
using namespace std;

mt19937 rnd(444);

int n, m, x;
vector<vector<pair<int, int>>> graph;
vector<int> used;
vector<pair<int, int>> e;
vector<int> c;
vector<int> d;
vector<int> r;
vector<int> l;
vector<pair<int, int>> moves;

void dfs(int v) {
    used[v] = x;
    for (auto [u, id] : graph[v]) {
        if (l[v] == l[u])
            r[id] = l[v];
        if (used[u] != x)
            dfs(u);
    }
}

void solve() {
    int v, u, id;
    cin >> n >> m;
    graph.clear();
    e.clear();
    c.clear();
    l.clear();
    d.clear();
    used.clear();
    moves.clear();
    graph.resize(n + 1);
    e.resize(m);
    c.resize(m);
    r.resize(m, 0);
    used.resize(n + 1, 0);
    l.resize(n + 1, 0);
    d.resize(n + 1);
    x = 0;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> c[i];
        graph[v].push_back({u, i});
        graph[u].push_back({v, i});
        e[i] = {v, u};
    }
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    bool flag = true;
    for (int i = 0; i < m; i++) {
        auto [a, b] = e[i];
        //cout << "edge " << a << ' ' << b << " || " << d[a] << ' ' << d[b] << ' ' << c[i] << '\n';
        if (c[i] != d[a] && c[i] != d[b]) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        cout << "NO" << '\n';
        return;
    }
    for (int i = 0; i < 10000; i++) {
        if (m != 0) {
            id = rnd() % m;
            if (r[id] != c[id]) {
                auto [a, b] = e[id];
                if (l[a] != c[id]) {
                    moves.push_back({a, c[id]});
                    l[a] = c[id];
                }
                if (l[b] != c[id]) {
                    moves.push_back({b, c[id]});
                    l[b] = c[id];
                }
                x++;
                dfs(a);
            }
        }
        id = rnd() % n + 1;
        if (l[id] != d[id]) {
            moves.push_back({id, d[id]});
            l[id] = d[id];
            x++;
            dfs(id);
        }
    }
    for (int i = 1; i <= n; i++) {
        id = i;
        if (l[id] != d[id]) {
            moves.push_back({id, d[id]});
            l[id] = d[id];
            x++;
            dfs(id);
        }
    }
    flag = true;
    for (int i = 0; i < m; i++) {
        if (r[i] != c[i])
            flag = false;
    }
    if (!flag) {
        cout << "NO" << '\n';
        return;
    }
    cout << "YES" << '\n';
    cout << moves.size() << '\n';
    for (auto [a, b] : moves)
        cout << a << ' ' << b << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}

