//#pragma GCC optimitze ("03,unroll-loops")

#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace  std;
using ll = long long;
using ii = pair<ll, ll>;
using lst = vector<vector<ii>>;

int type = 1;

const int INF = INT_MAX;

struct Edge {
    int v1, v2, c;
};

vector<ii> ans;

void dfs(int v, lst &adj, vector<bool> &vis, vector<int> &d, vector<int> &clr) {
    vis[v] = true;
    bool have = false;
    for (auto [u,c] : adj[v]) {
        if (!vis[u]) {
            have |= c;
            dfs(u, adj, vis, d, clr);  // сначала наведём порядок в детях
            ans.pb({u, c});
            clr[u] = c;
        }
    }
    if (have) {
        ans.pb({v, 1});
        clr[v] = 1;
        if (d[v] != 1) ans.pb({v, 0}), clr[v] = 0;
    }
    for (auto [u, c] : adj[v]) {
        if (clr[u] != d[u]) ans.pb({u, d[u]}), clr[u] = d[u];
    }
    return;
}

void solve(int att) {
    int nV, nE;
    cin >> nV >> nE;
    vector<Edge> edges(nE);
    vector<vector<ii>> adj(nV);
    for (int i = 0; i < nE; i++) {
        int v1, v2, c;
        cin >> v1 >> v2 >> c; v1--;v2--;
        edges[i] = {v1,v2,c};
        adj[v1].pb({v2,c});
        adj[v2].pb({v1, c});
    }
    vector<int> d(nV);
    for (int &v : d) cin >> v;
    bool good = true;
    for (auto [v1,v2,c] : edges) {
        if (d[v1] == d[v2] && d[v1] != c) good = false;
    }  // просто проверка для дерева
    if (good) {
        vector<bool> vis(nV, false);
        vector<int> clr(nV, 0);
        dfs(0, adj, vis, d, clr);
        cout << "YES\n" << ans.size() << "\n";
        for (auto [v, cl] : ans) {
            cout << v + 1 << " " << cl << "\n";
        }
    } else cout << "NO\n";
}

int main() {
    cin.tie(0)->ios::sync_with_stdio(false);
    int nT = 1;
    if (type) cin >> nT;
    for (int t = 1; t <= nT;t++) {
        solve(t);
        if (nT - t) cout << "\n";
    }
    return 0;
}
