// #define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

struct edge {
    int v, u, c, ind;
};

vector<vector<pair<int, int>>> graph;
vector<int> used, color, topsort;
vector<edge> edges;
vector<pair<int, int>> res;
vector<int> cur_color;

bool dfs_is_cycle(int v) {
    used[v] = 1;
    for (auto [u, ind] : graph[v]) {
        if (used[u] == 1) return true;
        if (used[u] == 0) {
            if (dfs_is_cycle(u)) return true;
        }
    }
    used[v] = 2;
    return false;
}

void dfs_topsort(int v) {
    used[v] = true;
    for (auto [u, ind] : graph[v]) {
        if (!used[u]) {
            dfs_topsort(u);
        }
    }
    for (auto [u, ind] : graph[v]) {
        topsort.push_back(ind);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    graph.assign(n, vector<pair<int, int>>(0));
    edges.assign(m, {0, 0, 0, 0});
    for (int i = 0; i < m; i++) edges[i].ind = i;
    for (auto &[v, u, c, ind] : edges) {
        cin >> v >> u >> c; v--; u--;
    }
    color.assign(n, 0);
    for (auto &el : color) cin >> el;
    for (auto &[v, u, c, ind] : edges) {
        if (color[v] == color[u]) {
            if (color[v] != c) {
                cout << "NO\n";
                return;
            }
            continue;
        }
        if (color[v]) swap(v, u);
        if (c) graph[v].push_back({u, ind});
        else graph[u].push_back({v, ind});
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        if (dfs_is_cycle(i)) {
            cout << "NO\n";
            return;
        }
    }
    used.assign(n, 0);
    topsort.clear();
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        dfs_topsort(i);
    }
    res.clear();
    cur_color.assign(n, 0);
    for (auto el : topsort) {
        auto &[v, u, c, ind] = edges[el];
        if (c) {
            res.push_back({u, 1});
            res.push_back({v, 1});
            res.push_back({v, 0});
            cur_color[v] = 0;
            cur_color[u] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        if (cur_color[i] != color[i]) {
            res.push_back({i, color[i]});
        }
    }
    cout << "YES\n";
    for (auto [a, b] : res) cout << a + 1 << ' '  << b << '\n';
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
/*
4
0 1 1
2 1 -1
3 1 1
5 1 -1
*/
