// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9 + 7;
const int LOG = 20;

struct stable_min {
    int n;
    vector<vector<pair<int, int>>> table;
    vector<int> logs;

    stable_min() {}

    stable_min(int _n, const vector<int> &v) {
        n = _n;
        table.resize(LOG, vector<pair<int, int>>(n, pair<int, int>{INF, INF}));
        for (int i = 0; i < n; i++) table[0][i] = {v[i], i};
        for (int p = 1; p < LOG; p++) {
            for (int i = 0; i < n; i++) table[p][i] = min(table[p - 1][i], table[p - 1][min(i + (1 << (p - 1)), n - 1)]);
        }
        logs.resize(n + 1, -1);
        for (int i = 1; i <= n; i++) {
            logs[i] = logs[i - 1] + !(i & (i - 1));
        }
    }

    pair<int, int> get_min(int l, int r) {
        return min(table[logs[r - l]][l], table[logs[r - l]][r - (1 << logs[r - l])]);
    }
};

struct stable_max {
    int n;
    vector<vector<pair<int, int>>> table;
    vector<int> logs;

    stable_max() {}

    stable_max(int _n, const vector<int> &v) {
        n = _n;
        table.resize(LOG, vector<pair<int, int>>(n, pair<int, int>{-INF, -INF}));
        for (int i = 0; i < n; i++) table[0][i] = {v[i], i};
        for (int p = 1; p < LOG; p++) {
            for (int i = 0; i < n; i++) table[p][i] = max(table[p - 1][i], table[p - 1][min(i + (1 << (p - 1)), n - 1)]);
        }
        logs.resize(n + 1, -1);
        for (int i = 1; i <= n; i++) {
            logs[i] = logs[i - 1] + !(i & (i - 1));
        }
    }

    pair<int, int> get_max(int l, int r) {
        return max(table[logs[r - l]][l], table[logs[r - l]][r - (1 << logs[r - l])]);
    }
};

int n, m;
vector<int> times, dist;
//stable_min stmin;
stable_max stmax;

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    cin >> n >> m;
    times.resize(n);
    dist.resize(m);
    for (auto &el : times) cin >> el;
    for (auto &el : dist) cin >> el;
    for (int i = m - 1; i >= 0; i--) dist[i] = (i == 0 ? dist[i] : dist[i] - dist[i - 1]);
    //stmin = stable_min(m, dist);
    stmax = stable_max(m, dist);

    set<pair<ll, int>> order;
    ll res = 0;
    auto it = order.begin();
    int left, right, mid;
    ll a, b;
    for (int i = 0; i < n; i++) {
        order.insert({(ll)stmax.get_max(0, m).first * times[i], i});
        for (it = order.begin(); it->second != i; ++it) {
            auto &[tmp, j] = (*it);
            res += m;
            left = 0, right = m + 1;
            a = (ll)stmax.get_max(0, m).first * times[j];
            while (left + 1 < right) {
                mid = (left + right) / 2;
                b = (ll)stmax.get_max(0, mid).first * times[i];
                if (b < a || (b == a && i < j)) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            res += left;
        }
        for (++it; it != order.end(); ++it) {
            auto &[tmp, j] = (*it);
            res += m;
            left = 0, right = m + 1;
            a = (ll)stmax.get_max(0, m).first * times[i];
            while (left + 1 < right) {
                mid = (left + right) / 2;
                b = (ll)stmax.get_max(0, mid).first * times[j];
                if (b < a || (b == a && j < i)) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            res += left;
        }
        cout << res << '\n';
    }
}
/*
4
0 1 1
2 1 -1
3 1 1
5 1 -1
*/
