#include<iostream>
#include<algorithm>
#include<vector>

using namespace std;

#define int long long
int inf = 1e9 + 5;

struct Edge {
	int u, v, c;
};

Edge edge[200005];
int col[200005];
bool used[200005];
vector<int>gr[200005];

void print_NO() {
	cout << "NO" << '\n';
	return;
}

bool dfs(int v, int st) {
	used[v] = true;
	for (auto u : gr[v]) {
		if (u == st) {
			print_NO();
			return true;
		}
		if (!used[u]) {
			if (dfs(u, st))
				return true;
		}
	}
	return false;
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, c;
		cin >> u >> v >> c; u--; v--;
		edge[i] = { u, v, c };
	}
	for (int i = 0; i < n; i++) {
		used[i] = false;
		gr[i].clear();
		cin >> col[i];
	}
	for (int j = 0; j < m; j++) {
		if (col[edge[j].u] == col[edge[j].v]) {
			if (col[edge[j].u] != edge[j].c) {
				print_NO();
				return;
			}
		}
		else {
			if (col[edge[j].u] == edge[j].c) {
				gr[edge[j].v].push_back(edge[j].u);
			}
			else {
				gr[edge[j].u].push_back(edge[j].v);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			if (dfs(i, i)) {
				return;
			}
		}
	}
	cout << "YES" << '\n';
	cout << "-1" << '\n';
	return;
}

signed main() {
	int t = 1;
	cin >> t;
	while (t--)
		solve();
	return 0;
}
