#include <iostream>
#include <vector>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define DEBUG(x) ;
#endif

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

int solve() {
    int n;
    cin >> n;
    vector<int> x(n + 1);
    vector<int> p(n + 1);
    vector<int> d(n + 1);
    RANGE(i, n) {
        cin >> x[i] >> p[i] >> d[i];
    }
    x[n] = x[n - 1];
    p[n] = 0;
    d[n] = -1;
    int ans = 0;
    int max_x = 0;
    int max_x1 = 0;
    RANGE(i, n) {
        if (d[i] == -1) {
            if (max_x1 + p[i] < x[i]) {
                return -1;
            } elif (max_x + p[i] < x[i]) {
                ans++;
                max_x = max_x1;
            } elif (max_x < x[i]) {
                max_x1 = max_x = x[i];
            } elif (x[i] + p[i + 1] < x[i + 1] || (x[i] + p[i] >= x[i + 1] && d[i + 1] == 1)) {
                ans++;
                max_x1 = max_x = x[i] + p[i];
            } elif (x[i] + p[i] < x[i + 1]) {
                max_x1 = max_x = x[i];
            } else {
                max_x1 = x[i + 1];
            }
        } else {
            if (max_x >= x[i]) {
                max_x1 = max_x = x[i] + p[i];
            } elif (max_x1 >= x[i]) {
                ans++;
                max_x1 = max_x = x[i] + p[i];
            } elif (max_x1 + p[i] < x[i]) {
                return -1;
            } elif (max_x + p[i] < x[i]) {
                ans += 2;
                max_x1 = max_x = x[i];
            } else {
                ans++;
                max_x1 = max_x = x[i];
            }
        }
    }
    return ans;
}

bool check(int n, vector<int> &x, vector<int> &p, vector<int> &d) {
    int max_x = 0;
    RANGE(i, n) {
        if (d[i] == 1) {
            if (max_x < x[i]) {
                return false;
            }
            max_x = x[i] + p[i];
        } else {
            if (max_x + p[i] < x[i]) {
                return false;
            }
            max_x = x[i];
        }
    }
    return true;
}

void solve_slow() {
    int n;
    cin >> n;
    vector<int> x(n);
    vector<int> p(n);
    vector<int> d(n);
    RANGE(i, n) {
        cin >> x[i] >> p[i] >> d[i];
    }
    int MASKS = 1 << n;
    int best = 2 * n;
    for (int mask = 0; mask < MASKS; mask++) {
        int c = 0;
        RANGE(i, n) {
            if ((mask >> i) & 1) {
                d[i] *= -1;
                c++;
            }
        }
        if (check(n, x, p, d)){
            best = min(best, c);
        }
        RANGE(i, n) {
            if ((mask >> i) & 1) {
                d[i] *= -1;
            }
        }
    }
    if (best > n) {
        cout << -1 << ENDLINE;
    } else {
        cout << best << ENDLINE;
    }
}

int main() {
    solve_slow();
//    cout << solve() << ENDLINE;
}
