#include <iostream>
#include <vector>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define DEBUG(x) ;
#endif

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

int n;

int ans1l(int start, vector<int> &x, vector<int> &p, vector<int> &d) {
    int ans = 0;
    for (int i = start; i < n; i++) {
        if (x[i + 1] - x[i] < p[i + 1]) {
            return -1;
        }
        ans += d[i + 1] == 1;
    }
    return ans;
}

int ans1r(int start, int end, vector<int> &x, vector<int> &p, vector<int> &d) {
    int ans = 0;
    for (int i = start; i < end; i++) {
        if (x[i + 1] - x[i] < p[i]) {
            return -1;
        }
        ans += d[i] == -1;
    }
    return ans;
}

int ans1(int start, int i, vector<int> &x, vector<int> &p, vector<int> &d) {
    int r1 = ans1l(i + 1, x, p, d);
    int r2 = ans1r(start, i, x, p, d);
    if (r1 == -1 || r2 == -1) {
        return -1;
    }
    return r1 + r2;
}

int ans2(int start, int end, vector<int> &x, vector<int> &p, vector<int> &d) {
    vector<int> left(n + 1, 0);
    for (int i = start; i <= end; i++) {
        left[i + 1] = left[i] + (d[i] == -1);
    }
    vector<int> right(n + 1, 0);
    for (int i = end - 1; i >= start; i--) {
        right[i] = right[i + 1] + (d[i] == 1);
    }
    int ans = 1e9;
    for (int i = start; i <= end; i++) {
        ans = min(ans, left[i] + right[i]);
    }
    return ans;
}

int solve() {
    cin >> n;
    vector<int> x(n);
    vector<int> p(n);
    vector<int> d(n);
    RANGE(i, n) {
        cin >> x[i] >> p[i] >> d[i];
    }
    int start = 0;
    int ans = 0;
    RANGE(i, n - 1) {
        int s = x[i + 1] - x[i];
        if (p[i] + p[i + 1] < s) {
            return -1;
        }
        if (max(p[i], p[i + 1]) < s) {
            return ans1(start, i, x, p, d);
        }
        if (min(p[i], p[i + 1]) < s) {
            if (p[i] < s) {
                int r1 = ans1l(i + 1, x, p, d);
                if (r1 == -1) {
                    return -1;
                }
                return r1 + ans2(start, i, x, p, d) + d[i + 1] == 1;
            } else {
                int r = ans1r(start, i, x, p, d);
                if (r == -1) {
                    return -1;
                }
                ans += r + d[i] == -1;
                start = i + 1;
            }
        }
    }
    return ans + ans2(start, n, x, p, d);
}

int main() {
    cout << solve() << ENDLINE;
}
