#include <iostream>
#include <vector>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define DEBUG(x) ;
#endif

using tiii = tuple<int, int, int>;

template<typename T1, typename T2, typename T3>
istream &operator>>(istream &in, tuple<T1, T2, T3> &v) {
    in >> get<0>(v) >> get<1>(v) >> get<2>(v);
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

bool dfs(int v, int p, vector<bool> &used, vector<vector<int>> &g) {
    used[v] = true;
    for (int u:g[v]) {
        if (u != p) {
            if (used[u]) {
                return true;
            }
            if (dfs(u, v, used, g)) {
                return true;
            }
        }
    }
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    {
        vector<tiii> edges(m);
        vector<pair<int, int>> edges2;
        vector<int> d(n);
        cin >> edges >> d;
        for (auto [a, b, c]: edges) {
            if (d[a - 1] == d[b - 1]) {
                if (d[a - 1] != c) {
                    cout << "NO" << ENDLINE;
                    return;
                }
            } else {
                g[a - 1].push_back(b - 1);
                g[b - 1].push_back(a - 1);
            }
        }
    }
    vector<bool> used(n, false);
    RANGE(i, n) {
        if (!used[i]) {
            if (dfs(i, i, used, g)) {
                cout << "NO" << ENDLINE;
                return;
            }
        }
    }
    cout << "YES\n-1" << ENDLINE;
}

int main() {
    int t;
    cin >> t;
    LOOP(t) {
        solve();
    }
}
