#include <iostream>
#include <vector>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define DEBUG(x) ;
#endif

using tiii = tuple<int, int, int>;
using pii = pair<int, int>;

template<typename T1, typename T2, typename T3>
istream &operator>>(istream &in, tuple<T1, T2, T3> &v) {
    in >> get<0>(v) >> get<1>(v) >> get<2>(v);
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

bool dfs(int v, int p, vector<bool> &used, vector<vector<int>> &g) {
    used[v] = true;
    for (int u: g[v]) {
        if (u != p) {
            if (used[u]) {
                return true;
            }
            if (dfs(u, v, used, g)) {
                return true;
            }
        }
    }
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g2(n);
    vector<vector<int>> g(n);
    vector<tiii> edges(m);
    vector<pii> edges2(m);
    vector<int> d(n);
    cin >> edges >> d;
    for (auto [a, b, c]: edges) {
        if (d[a - 1] == d[b - 1]) {
            if (d[a - 1] != c) {
                cout << "NO" << ENDLINE;
                return;
            }
        } else {
            g2[a - 1].push_back(b - 1);
            g2[b - 1].push_back(a - 1);
            edges2.emplace_back(a - 1, b - 1);
        }
        if (c) {
            g[a - 1].push_back(b - 1);
            g[b - 1].push_back(a - 1);
        }
    }
    vector<bool> used(n, false);
    RANGE(i, n) {
        if (!used[i]) {
            if (dfs(i, i, used, g2)) {
                cout << "NO" << ENDLINE;
                return;
            }
        }
    }
    cout << "YES" << ENDLINE;
    vector<pii> h;
    if (n == 1) {
        if (d[0]) {
            h.emplace_back(0, 1);
        }
    } elif (n == 2) {
        if (edges.empty() || !get<2>(edges[0])) {
            if (d[0]) {
                h.emplace_back(0, 1);
            }
            if (d[1]) {
                h.emplace_back(1, 1);
            }
        } else {
            h.emplace_back(0, 1);
            h.emplace_back(1, 1);
            if (!d[0]) {
                h.emplace_back(0, 0);
            }
            if (!d[1]) {
                h.emplace_back(1, 0);
            }
        }
    } elif (n == 3) {
        int c = 0;
        RANGE(i, n) {
            c += d[i];
        }
        if (c == 1) {
            int i = 0;
            for (; !d[i]; i++) {}
            h.emplace_back(i, 1);
            for (int u: g[i]) {
                h.emplace_back(u, 1);
                h.emplace_back(u, 0);
            }
        } elif (c == 2) {
            int i = 0;
            for (; d[i]; i++) {}
            int a, b;
            if (i == 0) {
                a = 1;
                b = 2;
            } else {
                a = 0;
                b = 3 - i;
            }

            if (g[i].size() == 0) {
                h.emplace_back(a, 1);
                h.emplace_back(b, 1);
            } elif (g[i].size() == 1) {
                h.emplace_back(i, 1);
                h.emplace_back(g[i][0], 1);
                h.emplace_back(i, 0);
                h.emplace_back(3 - (i + g[i][0]), 1);
            } elif (g[i].size() == 2) {
                h.emplace_back(a, 1);
                h.emplace_back(b, 1);
                h.emplace_back(i, 1);
                h.emplace_back(i, 0);
            }
        } elif (c == 3) {
            h.emplace_back(0, 1);
            h.emplace_back(1, 1);
            h.emplace_back(2, 1);
        }
//    } elif (m == n - 1) {
//        cout << "-1" << ENDLINE;
//        return;
    } else {
        cout << "-1" << ENDLINE;
//        cout << "5\n4 1\n3 1\n2 1\n3 0\n4 0" << ENDLINE;
        return;
    }
    cout << h.size() << ENDLINE;
    for (auto [a, b]: h) {
        cout << a + 1 << " " << b << ENDLINE;
    }
}

int main() {
    int t;
    cin >> t;
    LOOP(t) {
        solve();
    }
}
