#include <iostream>
#include <vector>
#include <set>
#include <vector>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define RANGE1(i, n) for (int i = 1; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define DEBUG(x) ;
#endif

using tiii = tuple<int, int, int>;
using pii = pair<int, int>;
using ll = long long;

ll INFLL = 1e18;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

int n;

int get(vector<int> &R, int i, int j) {
    int ans = 0;
    i = R[i];
    while (i <= j) {
        i = R[i];
        ans++;
    }
    return ans;
}

ll get(vector<int> &R) {
    ll ans = 0;
    RANGE(i, n - 1) {
        for (int j = i + 1; j < n; j++) {
            ans += get(R, i, j);
        }
    }
    return ans;
}

void get_R(vector<int> &R, set<pii> &s) {
    auto it = s.begin();
    R[0] = 1;
    while (it->first <= 0) {
        R[0] = max(R[0], it->second + 1);
        it++;
    }
    RANGE1(i, n) {
        R[i] = R[i - 1];
        while (it->first <= i) {
            R[i] = max(R[i], it->second + 1);
            it++;
        }
    }
}


int main() {
    int x;
    cin >> n >> x;
    vector<int> a(n);
    cin >> a;
    vector<int> R(n);

    set<pii> s;
    s.insert({n + 2, n + 2});
    RANGE(i, n) {
        s.insert({i - a[i], i + a[i]});
    }
    get_R(R, s);

    ll best = get(R);
    RANGE(i, n) {
        s.erase(s.find({i - a[i], i + a[i]}));
        int t = a[i];
        a[i] = x;
        s.insert({i - a[i], i + a[i]});
        get_R(R, s);
        best = min(best, get(R));
        s.erase(s.find({i - a[i], i + a[i]}));
        a[i] = t;
        s.insert({i - a[i], i + a[i]});
    }
    cout << best << ENDLINE;
}
