#include <bits/stdc++.h>
using namespace std;
 
vector<int> comp;
vector<vector<pair<int, int>>> graph;
vector<vector<int>> dag;
vector<int> a, b, c, d;
vector<bool> used;
vector<int> ord;
 
void mark(int u, int c) {
  comp[u] = c;
  for (auto [v, col] : graph[u]) {
    if (comp[v] == -1 && d[v] == 1) {
      mark(v, c);
    }
  }
}
 
void topsort(int u) {
  used[u] = true;
  for (int v : dag[u]) {
    if (!used[v]) {
      topsort(v);
    }
  }
  ord.push_back(u);
}
 
int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    graph = vector<vector<pair<int, int>>>(n);
    a = b = c = vector<int>(m);
    for (int i = 0; i < m; i++) {
      cin >> a[i] >> b[i] >> c[i];
      a[i]--, b[i]--;
      graph[a[i]].push_back({b[i], c[i]});
      graph[b[i]].push_back({a[i], c[i]});
    }
    d = vector<int>(n);
    for (int i = 0; i < n; i++) {
      cin >> d[i];
    }
    bool f = true;
    for (int i = 0; i < m; i++) {
      if (d[a[i]] == d[b[i]] && c[i] != d[a[i]]) {
        cout << "NO\n";
        f = false;
        break;
      }
    }
    if (f) {
      comp = vector<int>(n, -1);
      int comps = 0;
      for (int i = 0; i < n; i++) {
        if (comp[i] == -1 && d[i] == 1) {
          mark(i, comps++);
        }
      }
      dag = vector<vector<int>>(comps + n);
      for (int u = 0; u < n; u++) {
        for (auto [v, c] : graph[u]) {
          if (comp[v] == -1) {
            continue;
          }
          if (c == 1) {
            dag[comp[v]].push_back(comps + u);
          } else {
            dag[comps + u].push_back(comp[v]);
          }
        }
        // sort(dag[comps + u].begin(), dag[comps + u].end());
        // dag[comps + u].resize(unique(dag[comps + u].begin(), dag[comps + u].end()) - dag[comps + u].begin());
      }
      used = vector<bool>(comps + n);
      ord = vector<int>();
      for (int i = 0; i < comps + n; i++) {
        if (!used[i]) {
          topsort(i);
        }
      }
      reverse(ord.begin(), ord.end());
      vector<int> pos(comps + n);
      for (int i = 0; i < comps + n; i++) {
        pos[ord[i]] = i;
      }
      bool can = true;
      for (int u = 0; u < comps + n; u++) {
        for (int v : dag[u]) {
          can &= pos[u] < pos[v];
        }
      }
      vector<vector<int>> vert(comps);
      for (int i = 0; i < n; i++) {
        if (comp[i] != -1) {
          vert[comp[i]].push_back(i);
        }
      }
      if (can) {
        cout << "YES\n";
        vector<pair<int, int>> answer;
        for (int i : ord) {
          if (i >= comps) {
            continue;
          }
          for (int v : vert[i]) {
            answer.push_back({v, 1});
          }
        }
        for (int u = 0; u < n; u++) {
          if (comp[u] == -1) {
            answer.push_back({u, 1});
            answer.push_back({u, 0});
          }
        }
        cout << answer.size() << "\n";
        for (auto [u, c] : answer) {
          cout << 1 + u << " " << c << "\n";
        }
      } else {
        cout << "NO\n";
      }
    }
  }
}