#include <bits/stdc++.h>
using namespace std;

vector<int> comp, rep;
vector<vector<pair<int, int>>> graph;
vector<vector<int>> dag;
vector<int> a, b, c, d;
vector<bool> used;
vector<int> ord;

void mark(int u, int c) {
  comp[u] = c;
  for (auto [v, col] : graph[u]) {
    if (comp[v] == -1 && col == 1) {
      mark(v, c);
    }
  }
}

void topsort(int u) {
  used[u] = true;
  for (int v : dag[u]) {
    if (!used[v]) {
      topsort(v);
    }
  }
  ord.push_back(u);
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    graph = vector<vector<pair<int, int>>>(n);
    a = b = c = vector<int>(m);
    for (int i = 0; i < m; i++) {
      cin >> a[i] >> b[i] >> c[i];
      a[i]--, b[i]--;
      graph[a[i]].push_back({b[i], c[i]});
      graph[b[i]].push_back({a[i], c[i]});
    }
    d = vector<int>(n);
    for (int i = 0; i < n; i++) {
      cin >> d[i];
    }
    bool f = true;
    for (int i = 0; i < m; i++) {
      if (d[a[i]] == d[b[i]] && c[i] != d[a[i]]) {
        cout << "NO\n";
        f = false;
        break;
      }
    }
    if (f) {
      comp = rep = vector<int>(n, -1);
      int comps = 0;
      for (int i = 0; i < n; i++) {
        if (comp[i] == -1) {
          rep[comps] = i;
          mark(i, comps++);
        }
      }
      dag = vector<vector<int>>(comps);
      for (int i = 0; i < m; i++) {
        int x = comp[a[i]], y = comp[b[i]];
        if (d[a[i]] != d[b[i]] && c[i] == 0) {
          if (d[a[i]] == 0) {
            dag[x].push_back(y);
          } else {
            dag[y].push_back(x);
          }
        }
      }
      used = vector<bool>(comps);
      for (int i = 0; i < comps; i++) {
        if (!used[i]) {
          topsort(i);
        }
      }
      reverse(ord.begin(), ord.end());
      vector<int> pos(comps);
      for (int i = 0; i < comps; i++) {
        pos[ord[i]] = i;
      }
      bool can = true;
      for (int u = 0; u < comps; u++) {
        for (int v : dag[u]) {
          can &= pos[u] < pos[v];
        }
      }
      vector<vector<int>> vert(n);
      for (int i = 0; i < n; i++) {
        vert[comp[i]].push_back(i);
      }
      if (can) {
        cout << "YES\n";
        vector<pair<int, int>> answer;
        for (int i : ord) {
          for (int v : vert[comp[i]]) {
            answer.push_back({v, 1});
          }
          for (int v : vert[comp[i]]) {
            if (d[v] == 0) {
              answer.push_back({v, 0});
            }
          }
        }
        cout << answer.size() << "\n";
        for (auto [u, c] : answer) {
          cout << 1 + u << " " << c << "\n";
        }
      } else {
        cout << "NO\n";
      }
    }
  }
}
