#include <bits/stdc++.h>

using namespace std;
#define int long long

const int maxn = 1e5 + 5;

vector<vector<pair<int, int>>> g;
vector<int> cops;
vector<tuple<int, int, int>> pere;
vector<int> copsCur;
vector<int> pereCur;

void turn(int u, int c) {
    copsCur[u] = c;
    for(auto [v, id] : g[u]) {
        if(copsCur[v] == copsCur[u]) {
            pereCur[id] = copsCur[v];
        }
    }
}

void changeAsNeeded(int u) {
    if(copsCur[u] == cops[u]) return;
    copsCur[u] = cops[u];
    for(auto [v, id] : g[u]) {
        if(copsCur[v] == copsCur[u]) {
            pereCur[id] = copsCur[v];
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, vector<pair<int, int>>());
    cops.assign(n + 1, 0);
    pere.assign(m + 1, {0, 0, 0});
    pereCur.assign(m + 1, 0);
    copsCur.assign(n + 1, 0);
    
    for(int i = 1; i<=m; ++i) {
        auto& [u, v, c] = pere[i];
        cin >> u >> v >> c;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
    }

    for(int i = 1; i<=n; ++i) {
        cin >> cops[i];
    }

    for(auto [u, v, c] : pere) {
        if(cops[u] != c && cops[v] != c) {
            cout << "NO\n";
            return;
        }
    }

    bool changed = 1;
    int MaxChanges = max(n, m) * 20;
    int changes = 0;
    for(int i = 1; i<=n; ++i) {
        changeAsNeeded(i);
    }
    while(changed && changes <= MaxChanges) {
        changed = 0;
        for(int i = 1; i<=m; ++i) {
            auto [u, v, c] = pere[i];
            if(c != pereCur[i]) {
                turn(u, c);
                turn(v, c);
                changeAsNeeded(u);
                changeAsNeeded(v);
                changed = 1;
                changes += 2;
            }
        }
    }

    for(int i = 1; i<=m; ++i) {
        auto [u, v, c] = pere[i];
        if(c != pereCur[i]) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n-1\n";
    
}

signed main() {
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}