#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll INF = 2e18;

vector<vector<pair<ll, ll>>> G;

void solve() {
	ll n, m;
	cin >> n >> m;
	G.assign(n, {});
	ll u, v, type;
	for (ll i = 0; i < m; i++) {
		cin >> u >> v >> type; u--; v--;
		G[u].push_back({ v, type });
		G[v].push_back({ u, type });
	}
	vector<ll> c(n);
	for (ll& elem : c) {
		cin >> elem;
	}
	for (ll cur_v = 0; cur_v < n; cur_v++) {
		for (auto [to, cur_type] : G[cur_v]) {
			if (c[cur_v] == c[to] && c[to] != cur_type) {
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n";
	cout << "-1\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
4 1
0 0 0 0

3

5 1
0 0 0 0 0

8


6 1
0 0 0 0 0 0

18
*/