#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll INF = 2e18;
const ll WHITE = 0, GREY = 1, BLACK = 2;

vector<vector<pair<ll, ll>>> G;

vector<vector<ll>> G2;

vector<ll> col;

bool AOA = false;

void dfs(ll v, ll p) {
	col[v] = GREY;
	for (ll to : G2[v]) {
		if (col[to] == GREY && p != to) {
			AOA = true;
		}
		if (col[to] == WHITE) {
			dfs(to, v);
		}
	}
	col[v] = BLACK;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	G.assign(n, {});
	ll u, v, type;
	for (ll i = 0; i < m; i++) {
		cin >> u >> v >> type; u--; v--;
		G[u].push_back({ v, type });
		G[v].push_back({ u, type });
	}
	vector<ll> c(n);
	for (ll& elem : c) {
		cin >> elem;
	}
	for (ll cur_v = 0; cur_v < n; cur_v++) {
		for (auto [to, cur_type] : G[cur_v]) {
			if (c[cur_v] == c[to] && c[to] != cur_type) {
				cout << "NO\n";
				return;
			}
		}
	}

	col.assign(n, WHITE);
	G2.assign(n, {});
	for (ll cur_v = 0; cur_v < n; cur_v++) {
		for (auto [to, cur_type] : G[cur_v]) {
			if (c[cur_v] != c[to]) { //   |"
				G2[cur_v].push_back(to);
			}
		}
	}
	AOA = false;
	for (ll vv = 0; vv < n; vv++) {
		if (col[vv] == WHITE) {
			dfs(vv, -1);
		}
	}
	if (AOA) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		cout << "-1\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
4 1
0 0 0 0

3

5 1
0 0 0 0 0

8


6 1
0 0 0 0 0 0

18
*/