#include <iostream>
#include <vector>

using namespace std;

struct Edge {
    int u;
    bool c;
};

vector<vector<Edge>> g;
vector<int> used, d;
int t = 0;

bool dfs(int v) {
    if (used[v] == t) return true;
    used[v] = t;
    for (auto [u, c]: g[v]) {
        if (c == d[v] && d[u] != d[v]) {
            bool ans = dfs(u);
            if (ans) return true;
        }
    }
    return false;
}

void solve() {
    ++t;
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<Edge>());
    d.resize(n);
    used.resize(n);
    vector<int> a(m), b(m), c(m);
    for (int i = 0; i < m; ++i)
        cin >> a[i] >> b[i] >> c[i], a[i]--, b[i]--;
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] == d[b[i]] && c[i] != d[a[i]]) {
            cout << "NO\n";
            return;
        }
        g[a[i]].push_back({b[i], !!c[i]});
        g[b[i]].push_back({a[i], !!c[i]});
    }

    for (int i = 0; i < n; ++i) {
        if (used[i] == t) continue;
        ++t;
        if (dfs(i)) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n-1\n";
}


int main() {
    int n;
    cin >> n;
    while (n--) solve();

    return 0;
}