#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

vector<vector<int>> ga, ge;
vector<int> used, d, act;
vector<int> order;
int t = 0;

bool dfs(int v) {
    if (used[v] == t) return true;
    used[v] = t;
    auto &g = (d[v] ? ga : ge);
    for (auto u: g[v]) {
        if (d[u] != d[v]) {
            bool ans = dfs(u);
            if (ans) return true;
            used[u]--;
        }
    }
    return false;
}

void bfs(int v) {
    t++;
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        v = q.front();
        q.pop();
        if (used[v] == t) continue;
        used[v] = t;
        for (auto u: ga[v]) {
            if (used[u] == t) continue;
            if (!act[v]) {
                order.push_back(v);
                act[v] = true;
            }
            if (!act[u]) {
                order.push_back(u);
                act[u] = true;
            }
            if (!d[u]) {
                order.push_back(u);
                act[u] = false;
            }
            q.push(u);
        }
        if (d[v] != act[v]) {
            act[v] = d[v];
            order.push_back(v);
        }
        for(auto u : ge[v]) {
            if (used[v] == t) continue;
            q.push(v);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    ga.assign(n, vector<int>());
    ge.assign(n, vector<int>());
    d.resize(n);
    vector<int> p(n, -1);
    used.resize(n);
    act.assign(n, false);
    order.clear();
    vector<int> a(m), b(m), c(m);
    for (int i = 0; i < m; ++i)
        cin >> a[i] >> b[i] >> c[i], a[i]--, b[i]--;
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] == d[b[i]] && c[i] != d[a[i]]) {
            cout << "NO\n";
            return;
        }
        if (c[i]) {
            ga[a[i]].push_back(b[i]);
            ga[b[i]].push_back(a[i]);
        } else {
            ge[a[i]].push_back(b[i]);
            ge[b[i]].push_back(a[i]);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!d[i]) {
            for(int u : ge[i]) {
                if (d[u]) {
                    p[i] = u;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (d[i]) {
            for(int u : ge[i]) {
                if (!d[u]) {
                    p[i] = p[u];
                    break;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        ++t;
        if (dfs(i)) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";

    int s = 0;
    while (p[s] != -1) s = p[s];

    bfs(s);
    act.assign(n, false);
    cout << order.size() << '\n';
    for(int u : order) {
        cout << u+1 << ' ' << (act[u]=!act[u]) << '\n';
    }
}


int main() {
    int n;
    cin >> n;
    while (n--) solve();

    return 0;
}
