#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

vector<vector<int>> ga, ge;
vector<int> used, d, act;
vector<int> order;

bool dfs(int v) {
	if (used[v]) return used[v] == 1;
	used[v] = 1;
	auto& g = (d[v] ? ga : ge);
	for (auto u : g[v]) {
		if (d[u] != d[v]) {
			bool ans = dfs(u);
			if (ans) return true;
		}
	}
	used[v] = 2;
	return false;
}

void bfs(int v) {
	queue<int> q;
	q.push(v);
	while (!q.empty()) {
		v = q.front();
		q.pop();
		if (used[v]) continue;
		used[v] = 1;
		for (auto u : ga[v]) {
			if (used[u]) continue;
			if (!act[v]) {
				order.push_back(v);
				act[v] = true;
			}
			if (!act[u]) {
				order.push_back(u);
				act[u] = true;
			}
			if (!d[u]) {
				order.push_back(u);
				act[u] = false;
			}
			q.push(u);
		}
		if (d[v] != act[v]) {
			act[v] = d[v];
			order.push_back(v);
		}
		for (auto u : ge[v]) {
			if (used[u]) continue;
			q.push(u);
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	ga.assign(n, vector<int>());
	ge.assign(n, vector<int>());
	d.resize(n);
	used.assign(n, false);
	act.assign(n, false);
	order.clear();

	vector<int> a(m), b(m), c(m);
	for (int i = 0; i < m; ++i)
		cin >> a[i] >> b[i] >> c[i], a[i]--, b[i]--;
	for (int i = 0; i < n; ++i) cin >> d[i];
	for (int i = 0; i < m; ++i) {
		if (d[a[i]] == d[b[i]] && c[i] != d[a[i]]) {
			cout << "NO\n";
			return;
		}
		if (c[i]) {
			ga[a[i]].push_back(b[i]);
			ga[b[i]].push_back(a[i]);
		}
		else {
			ge[a[i]].push_back(b[i]);
			ge[b[i]].push_back(a[i]);
		}
	}

	for (int i = 0; i < n; ++i) {
		if (dfs(i)) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";

	int s = 0;

	used.assign(n, 0);
	bfs(s);
	act.assign(n, false);
	cout << order.size() << '\n';
	for (int u : order) {
		cout << u + 1 << ' ' << (act[u] = !act[u]) << '\n';
	}
}


int main() {
	int n;
	cin >> n;
	while (n--) solve();

	return 0;
}