#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

vector<vector<pair<int, int>>> graph;
vector<bool> used;
vector<int> d;

bool dfs(int i, int l, int c) {
    if (used[i]) {
        return false;
    }
    used[i] = true;
    for (auto [j, cj] : graph[i]) {
        if (used[j]) {
            if (cj != c && (d[i]-d[j]+1)%2 == 0 && l >= d[i]-d[j]) {
                return true;
            }
            continue;
        }
        int lj = 1;
        if (cj != c) {
            lj += l;
        }
        d[j] = d[i]+1;
        if (dfs(j, lj, cj)) {
            return true;
        }
    }
    return false;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<tuple<int, int, int>> edges(m);
        used.assign(n, false);
        graph.assign(n, vector<pair<int, int>>());
        d.assign(n, 0);
        for (int i = 0; i < m; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;
            edges[i] = {a, b, c};
            graph[a].push_back({b, c});
            graph[b].push_back({a, c});
        }
        vector<int> dc(n);
        for (int i = 0; i < n; i++) {
            cin >> dc[i];
        }
        bool meow = true;
        for (int i = 0; i < m; i++) {
            auto [a, b, c] = edges[i];
            if (dc[a] == dc[b] && c != dc[a]) {
                meow = false;
                break;
            }
        }
        bool cher = false;
        for (int i = 0; i < n; i++) {
            cher = cher || dfs(i, 0, -1);
        }
        if (meow && !cher) {
            cout << "YES\n";
            cout << -1 << '\n';
        } else {
            cout << "NO\n";
            continue;
        }
    }
    return 0;
}