#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;

vector<vector<pair<int, int>>> graph;
vector<bool> used;
vector<int> d;
vector<pair<int, int>> ans;
vector<int> cur;

bool dfs(int i, int l, int c) {
    if (used[i]) {
        return false;
    }
    used[i] = true;
    for (auto [cj, j] : graph[i]) {
        if (used[j]) {
            if (cj != c && (d[i]-d[j]+1)%2 == 0 && l >= d[i]-d[j] && d[i] > d[j]) {
                return true;
            }
            continue;
        }
        int lj = 1;
        if (cj != c) {
            lj += l;
        }
        d[j] = d[i]+1;
        if (dfs(j, lj, cj)) {
            return true;
        }
    }
    return false;
}

void dfs2(int i, int c, int p) {
    if (used[i]) {
        return;
    }
    used[i] = true;
    for (auto [cj, j] : graph[i]) {
        if ((d[j] > d[i] && used[j]) || (d[i]-d[j] == 1)) {
            continue;
        }
        if (used[j]) {
            if (cj == -1) {
                ans.push_back({i + 1, 1});
                ans.push_back({j + 1, 1});
            } else {
                ans.push_back({i + 1, 0});
                ans.push_back({j + 1, 0});
            }
            cur[i] = cj;
            cur[j] = cj;
        }
        dfs2(j, cj, i);

    }
    if (d[i] != 0) {
        if (c == -1) {
            ans.push_back({i + 1, 1});
            ans.push_back({p + 1, 1});
        } else {
            ans.push_back({i + 1, 0});
            ans.push_back({p + 1, 0});
        }
        cur[i] = c;
        cur[p] = c;
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<tuple<int, int, int>> edges(m);
        used.assign(n, false);
        graph.assign(n, vector<pair<int, int>>());
        d.assign(n, 0);
        for (int i = 0; i < m; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;
            c = -c;
            edges[i] = {a, b, c};
            graph[a].push_back({c, b});
            graph[b].push_back({c, a});
        }
        for (int i = 0; i < n; i++) {
            sort(graph[i].begin(), graph[i].end());
        }
        vector<int> dc(n);
        for (int i = 0; i < n; i++) {
            cin >> dc[i];
            dc[i] = -dc[i];
        }
        bool meow = true;
        for (int i = 0; i < m; i++) {
            auto [a, b, c] = edges[i];
            if (dc[a] == dc[b] && c != dc[a]) {
                meow = false;
                break;
            }
        }
        bool cher = false;
        for (int i = 0; i < n; i++) {
            cher = cher || dfs(i, 0, -2);
        }
        if (meow && !cher) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
            continue;
        }
        used.assign(n, false);
        ans.clear();
        cur.assign(n, 0);
        for (int i = 0; i < n; i++) {
            dfs2(i, -1, -1);
        }
        for (int i = 0; i < n; i++) {
            if (dc[i] == 0 && cur[i] == -1) {
                cur[i] = 0;
                ans.push_back({i+1, 0});
            }
        }
        for (int i = 0; i < n; i++) {
            if (dc[i] == -1 && cur[i] == 0) {
                cur[i] = 0;
                ans.push_back({i+1, 1});
            }
        }
        cout << ans.size() << '\n';
        for (auto [v, c] : ans) {
            cout << v << ' ' << c << '\n';
        }
    }
    return 0;
}