#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>

using namespace std;

#ifdef LOCAL
#define debug(x) cout << __LINE__ << ": " << #x << " => " << x << '\n';
#define debugv(x) cout << #x << ": "; for (auto xels : x) cout << xels << ' '; cout << endl;
#define debugvv(x) cout << #x << ":\n"; for (auto xels : x) {for (auto xelsels : xels) cout << xelsels << ' '; cout << '\n';}
#else
#define debug(x) ;
#define debugv(x) ;
#define debugvv(x) ;
#endif



bool dfs(int v, vector<vector<int>> &graph, vector<int> &used, vector<int> &f) {
    used[v] = 1;
    for (int u : graph[v]) {
        if (used[u] == 0) {
            if (!dfs(u, graph, used, f))
                return false;
        } else if (used[u] == 1) {
            return false;
        }
    }
    f.push_back(v);
    used[v] = 2;
    return true;
}

int solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> edges(m);
    vector<int> colsed(m);
    vector<vector<int>> graph = {};
    graph.assign(n, {});
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v >> colsed[i];
        u--; v--;
        edges[i] = {u, v};
    }
    vector<int> colsv(n);
    int all = 0;
    for (int i = 0; i < n; i++) {
        cin >> colsv[i];
        all += 2 - colsv[i];
    }
    for (int i = 0; i < m; i++) {
        int u = edges[i].first;
        int v = edges[i].second;
        if (colsv[u] == colsv[v] && colsv[u] != colsed[i]) {
            cout << "NO\n";
            return 0;
        }
        if (colsv[u] != colsv[v] && colsv[u] == colsed[i]) {
            graph[u].push_back(v);
        } else if (colsv[u] != colsv[v]) {
            graph[v].push_back(u);
            swap(edges[i].first, edges[i].second);
        }
    }
    vector<int> top = {};
    vector<int> used(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (!dfs(i, graph, used, top)) {
                cout << "NO\n";
                return 0;
            }
        }
    }
    cout << "YES\n" << all << '\n';
    for (int i = 0; i < n; i++) {
        if (colsv[top[i]]) {
            cout << top[i] + 1 << " 1\n";
        } else {
            cout << top[i] + 1 << " 1\n" << top[i] + 1 << " 0\n";
        }
    }
    return 0;
}

int main() {
#ifdef LOCAL
    string way_to_input = "C:\\Users\\roi\\tour2\\input.txt";
    string way_to_output = "C:\\Users\\roi\\tour2\\output.txt";
    freopen(way_to_input.c_str(), "r", stdin);
    freopen(way_to_output.c_str(), "w", stdout);
    while (!cin.eof()) {
        solve();
    }
#else
    int t; cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
#endif
}