#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
using namespace std;
using namespace __gnu_pbds;

using ll = long long;

#define int long long

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e9;

struct SegTree {
    vector<ll> t, p;
    SegTree(int n) {
        t.resize(4 * n);
        p.assign(4 * n, 0);
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = 0;
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    void push(int v, int l, int r) {
        if (p[v] == 0) {
            return;
        }
        t[v] = max(t[v], p[v]);
        if (r - l > 1) {
            p[2 * v + 1] = max(p[2 * v + 1], p[v]);
            p[2 * v + 2] = max(p[2 * v + 2], p[v]);
        }
        p[v] = 0;
    }

    ll get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        push(v, l, r);
        if (ql <= l && r <= qr) {
            return t[v];
        }
        int mid = (l + r) / 2;
        auto lans = get(2 * v + 1, l, mid, ql, qr);
        auto rans = get(2 * v + 2, mid, r, ql, qr);
        return max(lans, rans);
    }

    void assign(int v, int l, int r, int ql, int qr, ll x) {
        if (qr <= l || r <= ql) {
            return;
        }
        push(v, l, r);
        if (ql <= l && r <= qr) {
            p[v] = max(p[v], x);
            push(v, l, r);
            return;
        }
        int mid = (l + r) / 2;
        assign(2 * v + 1, l, mid, ql, qr, x);
        assign(2 * v + 2, mid, r, ql, qr, x);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
};

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a0(n);
    for (int i = 0; i < n; ++i) {
        cin >> a0[i];
    }
    ll ans = INF;
    for (int p = 0; p <= n; ++p) {
        if (p < n && a0[p] > x) {
            continue;
        }
        vector<int> a = a0;
        if (p < n) {
            a[p] = x;
        }
        SegTree tree(n);

        for (int i = 0; i < n; ++i) {
            ll r = min(n, i + a[i] + 1);
            tree.assign(0, 0, n, i - a[i], r, r);
        }
        vector<int> next(n);
        for (int i = 0; i < n; ++i) {
            next[i] = tree.get(0, 0, n, i, i + 1);
        }
        ll cans = 0;
        ll cd = 0;
        for (ll s = n - 2; s >= 0; --s) {
            if (next[s] != next[s + 1]) {
                cd += n - next[s];
            }
            cans += cd;
        }
        ans = min(ans, cans);
    }
    cout << ans << "\n";

}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}