#include <iostream>
#include <vector>
#define INF 2e9
using namespace std;

struct robot {
    int x, p, d;
};

int main() {
    int n;
    cin >> n;
    vector<robot> robots(n);
    for (int i = 0; i < n; ++i)
        cin >> robots[i].x >> robots[i].p >> robots[i].d;
    robots.push_back(robots[n - 1]);
    vector<bool> nxt(n, false), prev(n, false);
    for (int i = 0; i < n - 1; ++i) {
        if (robots[i].p >= robots[i + 1].x - robots[i].x)
            nxt[i] = true;
    }
    for (int i = 1; i < n; ++i) {
        if (robots[i].p >= robots[i].x - robots[i - 1].x)
            prev[i] = true;
    }
    vector<int> forward(n + 1);
    forward[0] = 0;
    for (int i = 0; i < n; ++i) {
        if (robots[i].d == 1)
            forward[i + 1] = forward[i] + 1;
        else
            forward[i + 1] = forward[i];
    }
    int j = 0, k = n - 1;
    while (nxt[j]) {
        j++;
    }
    while (prev[k]) {
        k--;
    }
    if (k - j > 1) {
        cout << -1 << endl;
        return 0;
    }
    int ans = INF;
    for (int i = k - 1; i <= j; ++i) {
        if (robots[i].p + robots[i + 1].p >= robots[i + 1].x - robots[i].x) {
            ans = min(ans, i + 1 - forward[i + 1] + forward[n] - forward[i + 1]);
        }
    }
    if (ans == INF) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
    return 0;
}
