#include <iostream>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
using namespace std;

struct node {
    int u, c;
};

vector<vector<node>> graph;
vector<node> acts;
vector<int> d, curD;

void dfs(int v, int p = -1) {
    for (node& nd : graph[v]) {
        if (nd.u != p) {
            if (d[nd.u] == d[v]) {
                if (curD[nd.u] != d[nd.u]) {
                    acts.push_back({nd.u, d[nd.u]});
                    curD[nd.u] = d[nd.u];
                }
                dfs(nd.u, v);
            } else if (nd.c != d[v]) {
                if (curD[v] != (d[v] ^ 1)) {
                    acts.push_back({v, (d[v] ^ 1)});
                    curD[v] = d[v] ^ 1;
                }
                if (curD[nd.u] != d[nd.u]) {
                    acts.push_back({nd.u, d[nd.u]});
                    curD[nd.u] = d[nd.u];
                }
                dfs(nd.u, v);
                if (curD[v] != d[v]) {
                    acts.push_back({v, d[v]});
                    curD[v] = d[v];
                }
            } else {
                if (curD[nd.u] != (d[nd.u] ^ 1)) {
                    acts.push_back({nd.u, (d[nd.u] ^ 1)});
                    curD[nd.u] = d[nd.u] ^ 1;
                }
                if (curD[nd.u] != d[nd.u]) {
                    acts.push_back({nd.u, d[nd.u]});
                    curD[nd.u] = d[nd.u];
                }
                dfs(nd.u, v);
            }
        }
    }
}

bool check(int n) {
    for (int i = 0; i < n; ++i)
        for (node& nd : graph[i])
            if (d[nd.u] == d[i] && nd.c != d[i])
                return false;
    return true;
}

int cur;

bool comp(node& nd1, node& nd2) {
    if (d[nd1.u] == d[cur])
        return true;
    if (d[nd2.u] == d[cur])
        return false;
    return (nd1.c == d[cur]) <= (nd2.c == d[cur]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        graph = {};
        int n, m;
        cin >> n >> m;
        graph.resize(n);
        for (int j = 0; j < m; ++j) {
            int a, b, c;
            cin >> a >> b >> c;
            a--; b--;
            graph[a].push_back({b, c});
            graph[b].push_back({a, c});
        }
        d = {}; curD = {};
        d.resize(n); curD.assign(n, 0);
        for (int j = 0; j < n; ++j)
            cin >> d[j];
        if (!check(n)) {
            cout << "NO\n";
            continue;
        }
        cout << "YES\n";
        for (int j = 0; j < n; ++j) {
            cur = j;
            sort(graph[j].begin(), graph[j].end(), comp);
        }
        acts = {{0, d[0]}};
        curD[0] = d[0];
        dfs(0);
        cout << acts.size() << "\n";
        for (node& nd : acts)
            cout << nd.u + 1 << ' ' << nd.c << "\n";
    }
    return 0;
}
