#include <bits/stdc++.h>

#define int long long
using namespace std;
vector<vector<pair<int, int>>> g;
vector<vector<int>> g1;
vector<bool> used;
vector<int> tops;
vector<int> par;
vector<int> z;
vector<int> col;
bool cyc;

int get_par(int v) {
    if (par[v] == v)return v;
    return par[v] = get_par(par[v]);
}

void unite(int u, int v) {
    u = get_par(u);
    v = get_par(v);
    par[v] = u;
}

void tree(int v, int p) {
    used[v] = true;
    for (auto to: g[v]) {
        if (z[to.second]) {
            unite(v, to.first);
        }
        if (to.first == p || used[to.first])continue;
        tree(to.first, v);
    }
}

void dfs(int v) {
    col[v] = 1;
    for (int to: g1[v]) {
        if (col[to] == 0) {
            dfs(to);
        } else if (col[to] == 1) {
            cyc = true;
        }
    }
    col[v] = 2;
    tops.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    z.assign(m, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--;
        v--;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        z[i] = c;
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    bool e = true;
    for (int i = 0; i < n; ++i) {
        for (auto to: g[i]) {
            if (d[i] && d[to.first] && !z[to.second]) {
                e = false;
            }
            if (!d[i] && !d[to.first] && z[to.second]) {
                e = false;
            }
        }
    }
    if (!e) {
        cout << "NO\n";
        return;
    }
    par.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        par[i] = i;
    }
    used.assign(n, false);
    tree(0, 0);
    map<int, vector<int>> mp;
    for (int i = 0; i < n; ++i) {
        int o = get_par(i);
        mp[o].push_back(i);
    }
    vector<bool> can(n, false);
    for (int i = 0; i < n; ++i) {
        can[par[i]] = true;
    }
    g1.assign(n, {});
    for (int i = 0; i < n; ++i) {
        for (auto to: g[i]) {
            int p1 = par[i];
            int p2 = par[to.first];
            if (p1 == p2)continue;
            if (!d[i] && d[to.first]) {
                g1[p1].push_back(p2);
            } else if (d[i] && !d[to.first]) {
                g1[p2].push_back(p1);
            }
        }
    }
    used.assign(n, false);
    tops.clear();
    cyc = false;
    col.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (can[i] && !col[i]) {
            dfs(i);
        }
    }
    if (cyc) {
        cout << "NO\n";
        return;
    }
    vector<pair<int, int>> ans;
    std::reverse(tops.begin(), tops.end());
    for (int i = 0; i < tops.size(); ++i) {
        int id = tops[i];
        vector<int> po;
        for (int to: mp[id]) {
            if (!d[to]) {
                po.push_back(to);
                ans.push_back({to, 1});
            }
        }
        for (int j = 0; j < po.size(); ++j) {
            for (auto to: g[po[j]]) {
                if (z[to.second]) {
                    ans.push_back({to.first, 1});
                }
            }
        }
        for (int j = 0; j < po.size(); ++j) {
            ans.push_back({po[j], 0});
        }
        for (int to: mp[id]) {
            ans.push_back({to, d[to]});
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first + 1 << " " << ans[i].second << "\n";
    }
}

signed main() {
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
