#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

int main()
{
    int n;
    cin >> n;
    vector<tuple<int, int, int>> v(n);
    vector<int> dr(n, 0);
    vector<int> dst(n - 1);
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        v[i] = {a, b, c};
        dr[i] = c;
    }
    for (int i = 0; i < n - 1; i++) {
        auto [x1, p1, d1] = v[i];
        auto [x2, p2, d2] = v[i + 1];
        dst[i] = x1 - x1;
    }
    for (int i = 0; i < n - 1; i++) {
        auto [x1, p1, d1] = v[i];
        auto [x2, p2, d2] = v[i + 1];
        int x = x2 - x1;
        if (p1 + p2 < x) {
            cout << "-1";
            return 0;
        }
    }


    vector<int> dp1(n, -INF);
    vector<int> dp2(n, -INF);
    dp1[0] = 0;
    for (int i = 1; i < n; i++) {
        auto [x, p, d] = v[i - 1];
        dp1[i] = dp1[i - 1];
        if (d == -1) {
            dp1[i]++;
        }
        if (p < dst[i - 1]) {
            dp1[i] *= -1;
            break;
        }
    }
    dp2[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        auto [x, p, d] = v[i];
        dp2[i] = dp2[i + 1];
        if (d == 1) {
            dp2[i]++;
        }
        if (p < dst[i]) {
            dp2[i] *= -1;
            break;
        }
    }
    /*for (auto i : dp1) {
        cout << i << " ";
    } cout << endl;
    for (auto i : dp2) {
        cout << i << " ";
    } cout << endl;*/

    int mn = INF;
    for (int i = 0; i < n; i++) {
        if (dp1[i] == -INF || dp2[i] == -INF) {
            continue;
        }
        if (i != 0 && i != n - 1 && dp1[i] <= 0 && dp2[i] <= 0) {
            auto [x1, p1, d1] = v[i];
            auto [x2, p2, d2] = v[i + 1];
            if (x2 - x1 <= p1 + p2) {
                mn = min(mn, -dp1[i] - dp2[i]);
            }
        }
        if (dp1[i] >= 0 && dp2[i] >= 0) {
            mn = min(mn, dp1[i] + dp2[i]);
        }
    }
    if (mn == INF) {
        mn = -1;
    }
    cout << mn << endl;

    return 0;
}
