#include <iostream>
#include <vector>
#include <set>

using namespace std;

const long long INF = 1e15;

long long solve(int n, vector<int> &v) {
    vector<int> r(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (abs(j - i) <= v[j]) {
                r[i] = max(r[i], j + v[j] + 1);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        r[i] = min(r[i], n);
    }
    vector<int> dp(n);
    for (int i = n - 1; i >= 0; i--) {
        if (r[i] == n) {
            dp[i] = 0;
        } else {
            dp[i] = dp[r[i]] + n - r[i];
        }
    }
    long long cur = 0;
    for (auto i : dp) {
        cur += i;
    }

    /*for (auto i : v) {
        cout << i << " ";
    } cout << endl;
    for (auto i : r) {
        cout << i << " ";
    } cout << endl;
    for (auto i : dp) {
        cout << i << " ";
    } cout << endl << endl;*/

    return cur;
}

int main()
{
    int n, x;
    cin >> n >> x;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    long long ans = solve(n, v);
    for (int i = 0; i < n; i++) {
        int t = v[i];
        v[i] = x;
        ans = min(ans, solve(n, v));
        v[i] = t;
    }
    cout << ans << endl;

    return 0;
}
