#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const long long INF = 1e15;

long long solve(long long n, vector<long long> &v) {
    vector<long long> r(n, 0);

    vector<tuple<long long, long long, long long>> ev;

    for (long long i = 0; i < n; i++) {
        ev.push_back({max((long long)0, i - v[i]), -1, i + v[i] + 1});
        ev.push_back({min(n - 1, i + v[i]), 1, i + v[i] + 1});
    }
    for (long long i = 0; i < n; i++) {
        ev.push_back({i, 0, 0});
    }
    sort(ev.begin(), ev.end());
    multiset<long long> st;
    for (auto [x, tp, k] : ev) {
        //cout << x << " " << tp << " " << k << endl;
        if (tp == -1) {
            st.insert(k);
        } else if (tp == 1){
            st.erase(st.find(k));
        }
        if (st.size() != 0) {
            r[x] = max(r[x], *(st.rbegin()));
        }

    }
    for (long long i = 0; i < n; i++) {
        r[i] = min(r[i], n);
    }
    vector<long long> dp(n);
    for (long long i = n - 1; i >= 0; i--) {
        if (r[i] == n) {
            dp[i] = 0;
        } else {
            dp[i] = dp[r[i]] + n - r[i];
        }
    }
    long long cur = 0;
    for (auto i : dp) {
        cur += i;
    }

    /*for (auto i : v) {
        cout << i << " ";
    } cout << endl;
    for (auto i : r) {
        cout << i << " ";
    } cout << endl;
    for (auto i : dp) {
        cout << i << " ";
    } cout << endl << endl;*/

    return cur;
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    long long n, x;
    cin >> n >> x;
    vector<long long> v(n);
    for (long long i = 0; i < n; i++) {
        cin >> v[i];
    }

    long long ans = solve(n, v);
    for (long long i = 0; i < n; i++) {
        long long t = v[i];
        if (t >= x) {
            continue;
        }
        v[i] = x;
        ans = min(ans, solve(n, v));
        v[i] = t;
    }
    cout << ans << endl;

    return 0;
}
