#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int INF = 1e9;

struct tree{
    vector<int> tr;
    vector<int> dat;


    void add(int id, int l, int r, int k, int x) {
        //cout << id << " " << l << " " << r << " " << k << " " <<x << endl;
        if (r - l == 1) {
            if (x >= 1) {
                dat[l]++;
                if (dat[l] == 1) {
                    tr[id] = l;
                }
            } else {
                dat[l]--;
                if (dat[l] == -1) {
                    tr[id] = -1;
                }
            }
            return;
        }
        int mid = (l + r) / 2;
        if (k < mid) {
            add(id * 2 + 1, l, mid, k, x);
        } else {
            add(id * 2 + 2, mid, r, k, x);
        }
        int a = tr[id * 2 + 1], b = tr[id * 2 + 2];
        tr[id] = max(a, b);
    }

    tree(int n) {
        dat.resize(n, 0);
        tr.resize(n * 4, -1);
        add(0, 0, n, 0, 1);
    }

    int ask() {
        return tr[0];
    }
};


 int solve(int n, vector<int> &v) {
    vector<int> r(n, 0);

    vector<tuple<int, int, int>> ev;

    for (int i = 0; i < n; i++) {
        ev.push_back({max((int)0, i - v[i]), -1, i + v[i] + 1});
        ev.push_back({min(n - 1, i + v[i]), 1, i + v[i] + 1});
    }
    for (int i = 0; i < n; i++) {
        ev.push_back({i, 0, 0});
    }
    sort(ev.begin(), ev.end());
    tree tr(n + 1);
    for (auto [x, tp, k] : ev) {
        k = min(k, n);
        //cout << x << " " << tp << " " << k << " : ";
        if (tp == -1) {
            tr.add(0, 0, n + 1, k, 1);
            /*cout << "A " << k << " | ";
            cout << endl;
            for (auto i : tr.tr) {
                cout << i << " ";
            } cout << endl;*/
        } else if (tp == 1){
            tr.add(0, 0, n + 1, k, -1);
            //cout << "R " << k << " | ";
        }
        //cout << tr.ask() << endl;
        r[x] = max(r[x], tr.ask());

    }
    for (int i = 0; i < n; i++) {
        r[i] = min(r[i], n);
    }
    vector<int> dp(n);
    for (int i = n - 1; i >= 0; i--) {
        if (r[i] == n) {
            dp[i] = 0;
        } else {
            dp[i] = dp[r[i]] + n - r[i];
        }
    }
    int cur = 0;
    for (auto i : dp) {
        cur += i;
    }

    /*for (auto i : v) {
        cout << i << " ";
    } cout << endl;
    for (auto i : r) {
        cout << i << " ";
    } cout << endl;
    for (auto i : dp) {
        cout << i << " ";
    } cout << endl << endl;*/
    return cur;
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, x;
    cin >> n >> x;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    int ans = solve(n, v);
    for (int i = 0; i < n; i++) {
        int t = v[i];
        if (t >= x) {
            continue;
        }
        v[i] = x;
        ans = min(ans, solve(n, v));
        v[i] = t;
    }
    cout << ans << endl;

    return 0;
}
