#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int INF = 1e9;

struct tree{
    vector<int> tr;
    vector<int> dat;


    void add(int id, int l, int r, int k, int x) {
        if (r - l == 1) {
            dat[l] += x;
            if (dat[l] == 1 && x == 1) {
                tr[id] = l;
            } else if (dat[l] == 0) {
                tr[id] = -1;
            }
            return;
        }
        int mid = (l + r) / 2;
        if (k < mid) {
            add(id * 2 + 1, l, mid, k, x);
        } else {
            add(id * 2 + 2, mid, r, k, x);
        }
        tr[id] = max(tr[id * 2 + 1], tr[id * 2 + 2]);
    }

    tree(int n) {
        dat.resize(n, 0);
        tr.resize(n * 4, -1);
        add(0, 0, n, 0, 1);
    }
};


inline int solve(int n, vector<int> &v) {
    vector<int> r(n, 0);

    vector<tuple<int, int, int>> ev;

    for (int i = 0; i < n; i++) {
        ev.push_back({max((int)0, i - v[i]), -1, i + v[i] + 1});
        ev.push_back({min(n - 1, i + v[i]), 1, i + v[i] + 1});
    }
    for (int i = 0; i < n; i++) {
        ev.push_back({i, 0, 0});
    }
    sort(ev.begin(), ev.end());
    tree tr(n + 1);
    for (auto [x, tp, k] : ev) {
        k = min(k, n);
        if (tp == -1) {
            tr.add(0, 0, n + 1, k, 1);
        } else if (tp == 1){
            tr.add(0, 0, n + 1, k, -1);
        }
        r[x] = max(r[x], tr.tr[0]);

    }
    for (int i = 0; i < n; i++) {
        r[i] = min(r[i], n);
    }
    vector<int> dp(n);
    for (int i = n - 1; i >= 0; i--) {
        if (r[i] == n) {
            dp[i] = 0;
        } else {
            dp[i] = dp[r[i]] + n - r[i];
        }
    }
    int cur = 0;
    for (auto i : dp) {
        cur += i;
    }
    return cur;
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, x;
    cin >> n >> x;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    int ans = solve(n, v);
    for (int i = 0; i < n; i++) {
        int t = v[i];
        if (t >= x) {
            continue;
        }
        v[i] = x;
        ans = min(ans, solve(n, v));
        v[i] = t;
    }
    cout << ans << endl;

    return 0;
}
