//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using pii = pair<int, int>;


struct SegmentTree {
    vector<int> tree;
    int n;


    void build(int v, int cl, int cr, vector<int>& a) {
        if (cr - cl == 1) {
            tree[v] = a[cl];
            if (cl > 0) tree[v] -= a[cl - 1];
            return;
        }
        int m = (cl + cr) / 2;
        build(2 * v + 1, cl, m, a);
        build(2 * v + 2, m, cr, a);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }


    SegmentTree(int sz, vector<int>& a) {
        n = sz;
        tree.resize(4 * n);
        build(0, 0, n, a);
    }

    int get(int v, int cl, int cr, int l, int r) {
        if (cl >= r || cr <= l) return 0;
        if (cl >= l && cr <= r) return tree[v];
        int m = (cl + cr) / 2;
        return max(get(2 * v + 1, cl, m, l, r), get(2 * v + 2, m, cr, l, r));
    }
};


struct node {
    int s, t, id;

    bool operator<(const node& other) const {
        if (1ll * s * t != 1ll * other.s * other.t) return (1ll * s * t < 1ll * other.s * other.t);
        return id < other.id;
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < m; ++i) cin >> s[i];
    SegmentTree tree(m, s);
    for (int k = 1; k <= n; ++k) {
        vector<int> pos(k);
        set<node> now;
        for (int i = 0; i < k; ++i) {
            now.insert({s[pos[i]], t[i], i});
        }
        ll ans = 0;
        int cnt = k - 1;
        while (cnt != 0) {
            auto v = *now.begin();
            now.erase(now.begin());
            ans += cnt;
            pos[v.id]++;
            if (pos[v.id] == m) {
                --cnt;
                continue;
            }
            auto u = *now.begin();
            int l = pos[v.id], r = m + 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                ll maxx = tree.get(0, 0, tree.n, pos[v.id], mid + 1);
                if (maxx * v.t < 1ll * u.s * u.t || maxx * v.t == 1ll * u.s * u.t && v.id < u.id) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            ans += (l - pos[v.id]) * cnt;
            pos[v.id] = l;
            if (pos[v.id] == m) {
                --cnt;
                continue;
            }
            v.s = s[pos[v.id]] - s[pos[v.id] - 1];
            now.insert(v);
        }
        cout << ans << "\n";
    }
    return 0;
}