#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define all(x) x.begin(), x.end()
#define pi pair<int, int>
#define ff first
#define ss second
#define vpi vector<pi>

const int INF = 2e9;

vvi graph;
vi h;
vi used;
vector<set<int>> tr;
void dfs_tree(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (used[v]) continue;
		h[v] = h[u] + 1;
		tr[u].insert(v);
		dfs_tree(v);
	}
}

vpi ans;
vi d;
map<pi, int> dm;
bool bad = 0;

bool cmp(int u, int v) {
	return h[u] < h[v];
}

vi col;
void dfs(int u, int p) {
	sort(all(graph[u]), cmp);
	reverse(all(graph[u]));


	if (!d[u]) {
		col[u] = 1;
		ans.push_back({ u, 1 });
		for (int v : tr[u]) {
			if (dm[{u, v}]) {
				ans.push_back({ v, 1 });
				col[v] = 1;
				dfs(v, u);
			}
		}
		col[u] = 0;
		ans.push_back({ u, 0 });

		for (int v : tr[u]) {
			if (!dm[{u, v}]) {
				dfs(v, u);
			}
		}
	}
	else {
		col[u] = 0;
		ans.push_back({ u, 0 });

		for (int v : tr[u]) {
			if (!dm[{u, v}]) {
				dfs(v, u);
			}
		}

		col[u] = 1;
		ans.push_back({ u, 1 });
		for (int v : tr[u]) {
			if (dm[{u, v}]) {
				ans.push_back({ v, 1 });
				col[v] = 1;
				dfs(v, u);
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		graph.assign(n, vi());
		tr.assign(n, set<int>());
		d.assign(n, 0);
		h.assign(n, 0);
		col.assign(n, 0);
		used.assign(n, 0);
		bad = 0;
		ans.clear();
		for (int i = 0; i < m; i++) {
			int u, v, c;
			cin >> u >> v >> c;
			u--;
			v--;
			graph[u].push_back(v);
			graph[v].push_back(u);
			dm[{u, v}] = c;
			dm[{v, u}] = c;
		}
		for (int i = 0; i < n; i++) cin >> d[i];
		vi have_light(n);
		for (int i = 0; i < n; i++) {
			for (int j : graph[i]) {
				have_light[i] += dm[{i, j}];
			}
			for (int j : graph[i]) {
				if (d[i] && d[j] && !dm[{i, j}]) {
					bad = 1;
					break;
				}
				if (!d[i] && !d[j] && dm[{i, j}]) {
					bad = 1;
					break;
				}
			}
		}

		vi roots;
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				dfs_tree(i);
				roots.push_back(i);
			}
		}

		for (int r : roots) dfs(r, r);

		if (bad) {
			cout << "NO" << endl;
			continue;
		}

		cout << "YES" << endl;
		cout << ans.size() << endl;
		for (pi el : ans) cout << el.ff + 1 << ' ' << el.ss << endl;
	}

	return 0;
}