#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define all(x) x.begin(), x.end()
#define pi pair<int, int>
#define ff first
#define ss second
#define vpi vector<pi>

const int INF = 2e9;

vvi graph;
vi h;
vi used;
vector<set<int>> tr;
void dfs_tree(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (used[v]) continue;
		h[v] = h[u] + 1;
		tr[u].insert(v);
		dfs_tree(v);
	}
}

vpi ans;
vi d;
map<pi, int> dm;
bool bad = 0;



vi col;
vi tout;
vvi tgraph;
void dfsc(int u) {
	used[u] = 1;
	for (int v : tgraph[u]) {
		if (used[v] == 1) {
			bad = 1;
			return;
		}
		if (!used[v]) dfsc(v);
	}
	used[u] = 2;
	tout.push_back(u);
}
vi pr;

bool cmp(int u, int v) {
	return pr[u] < pr[v];
}

void dfs(int u, int p) {
	used[u] = 1;
	sort(all(graph[u]), cmp);
	reverse(all(graph[u]));


	if (!d[u]) {
		col[u] = 1;
		ans.push_back({ u, 1 });
		for (int v : graph[u]) {
			if (dm[{u, v}]) {
				ans.push_back({ v, 1 });
				col[v] = 1;
				if (tr[u].count(v)) dfs(v, u);
			}
		}
		col[u] = 0;
		ans.push_back({ u, 0 });

		for (int v : graph[u]) {
			if (!dm[{u, v}]) {
				if (tr[u].count(v))dfs(v, u);
			}
		}
	}
	else {
		col[u] = 0;
		ans.push_back({ u, 0 });

		for (int v : graph[u]) {
			if (!dm[{u, v}]) {
				if (tr[u].count(v)) dfs(v, u);
			}
		}

		col[u] = 1;
		ans.push_back({ u, 1 });
		for (int v : graph[u]) {
			if (dm[{u, v}]) {
				ans.push_back({ v, 1 });
				col[v] = 1;
				if (tr[u].count(v)) dfs(v, u);
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		graph.assign(n, vi());
		tr.assign(n, set<int>());
		d.assign(n, 0);
		h.assign(n, 0);
		col.assign(n, 0);
		used.assign(n, 0);
		bad = 0;
		ans.clear();
		tout.clear();
		pr.assign(n, 0);
		for (int i = 0; i < m; i++) {
			int u, v, c;
			cin >> u >> v >> c;
			u--;
			v--;
			graph[u].push_back(v);
			graph[v].push_back(u);
			dm[{u, v}] = c;
			dm[{v, u}] = c;
		}
		tgraph.assign(n, vi());
		for (int i = 0; i < n; i++) cin >> d[i];
		for (int i = 0; i < n; i++) {
			for (int j : graph[i]) {
				int u = i;
				int v = j;
				if (d[u] && !d[v]) {
					if (!dm[{u, v}]) swap(u, v);
					tgraph[u].push_back(v);
				}
			}
		}

		for (int i = 0; i < n; i++) {
			for (int j : graph[i]) {
				if (d[i] && d[j] && !dm[{i, j}]) {
					bad = 1;
					break;
				}
				if (!d[i] && !d[j] && dm[{i, j}]) {
					bad = 1;
					break;
				}
			}
		}

		used.assign(n, 0);
		for (int i = 0; i < n; i++) {
			if (!used[i]) dfsc(i);
		}
		if (bad) {
			cout << "NO" << endl;
			continue;
		}
		reverse(all(tout));
		for (int i = 0; i < n; i++) {
			pr[tout[i]] = i;
		}

		if (bad) {
			cout << "NO" << endl;
			continue;
		}
		used.assign(n, 0);
		vi roots;
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				dfs_tree(i);
				roots.push_back(i);
			}
		}

		for (int u : roots) dfs(u, u);

		cout << "YES" << endl;
		cout << ans.size() << endl;
		for (pi el : ans) cout << el.ff + 1 << ' ' << el.ss << endl;
	}

	return 0;
}