#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define all(x) x.begin(), x.end()
#define pi pair<int, int>
#define ff first
#define ss second
#define vpi vector<pi>

const int INF = 2e9;

vvi graph;
vi h;
vi used;
vector<set<int>> tr;
void dfs_tree(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (used[v]) continue;
		h[v] = h[u] + 1;
		tr[u].insert(v);
		dfs_tree(v);
	}
}

vpi ans;
vi d;
map<pi, int> dm;
bool bad = 0;

bool cmp(int u, int v) {
	return h[u] < h[v];
}

vi col;

vvi tgraph;
void dfsc(int u) {
	used[u] = 1;
	for (int v : tgraph[u]) {
		if (used[v] == 1) {
			bad = 1;
			return;
		}
		if (!used[v]) dfsc(v);
	}
	used[u] = 2;
}

void dfs(int u, int p) {
	sort(all(graph[u]), cmp);
	reverse(all(graph[u]));


	if (!d[u]) {
		col[u] = 1;
		ans.push_back({ u, 1 });
		for (int v : graph[u]) {
			if (dm[{u, v}]) {
				ans.push_back({ v, 1 });
				col[v] = 1;
				if (tr[u].count(v)) dfs(v, u);
			}
		}
		col[u] = 0;
		ans.push_back({ u, 0 });

		for (int v : graph[u]) {
			if (!dm[{u, v}]) {
				if (tr[u].count(v))dfs(v, u);
			}
		}
	}
	else {
		col[u] = 0;
		ans.push_back({ u, 0 });

		for (int v : graph[u]) {
			if (!dm[{u, v}]) {
				if (tr[u].count(v)) dfs(v, u);
			}
		}

		col[u] = 1;
		ans.push_back({ u, 1 });
		for (int v : graph[u]) {
			if (dm[{u, v}]) {
				ans.push_back({ v, 1 });
				col[v] = 1;
				if (tr[u].count(v)) dfs(v, u);
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	int x;
	cin >> x;
	vi p(n);
	vpi vec(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i];
		int a = p[i];
		vec[i] = { i - a, i + a };
	}

	int ans = 2e9;

	for (int c = -1; c < n; c++) {
		vpi tvec = vec;
		int tans = 0;
		if (c != -1) {
			tvec[c] = { c - x, c + x };
		}
		sort(all(tvec));
		vi pre(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (tvec[i].ff <= j && tvec[i].ss >= j) pre[j] = max(pre[j], tvec[i].ss);
			}
		}
		for (int s = 0; s < n; s++) {
			int cur = s;
			int tt = 0;
			while (cur != n) {
				int nxt = min(pre[cur], n - 1);
				tans += (nxt - cur + 1) * tt;
				tt++;
				cur = nxt + 1;
			}
		}
		ans = min(ans, tans);
	}
	cout << ans << endl;

	return 0;
}