#include "iostream"
#include "vector"
#include "algorithm"


struct edge {
    int x, i, r;
    edge(int x, int i, int r) :x(x), i(i), r(r) {};
};

void can(bool &flag, std::vector<edge> &a, std::vector<bool> &reversed, int from, int need, int r) {
    if(flag) return;
    if(need == 0) {
        int prev = -1;
        int x = 0;
        std::vector<int> used(reversed.size(), 0);
        for(auto &i : a) {
            if(i.r == reversed[i.i]) {
                if(used[i.i] == -1) continue;
                if((x != i.x && prev != i.i && used[prev] == -1) && x >= 0 && i.x >= 0) {
                    break;
                }
                x = i.x;
                if(prev != i.i && prev != -1) {
                    used[prev] = -1;
                }
                prev = i.i;
                if(used[i.i]) {
                    used[i.i] = -1;
                }
                else {
                    used[i.i]++;
                }
            }
        }
        if(x >= r) {
            flag = true;
        }
    } else {
        need--;
        for(int i = from; i < reversed.size() - need; i++) {
            reversed[i] = true;
            can(flag, a, reversed, i + 1, need, r);
            reversed[i] = false;
        }
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<edge> a;
    int r=  0;
    int pi = 1e9;
    std::vector<int> dir;
    for(int i = 0; i < n; i++) {
        int x, p, d;
        std::cin >> x >> p >> d;
        pi = std::min(p, pi);
        r = std::max(x, r);
        dir.push_back(d);
        a.emplace_back(x, i, 0);
        a.emplace_back(x, i, 1);
        a.emplace_back(x + p * d, i, 0);
        a.emplace_back(x - p * d, i, 1);
    }
    std::sort(a.begin(), a.end(), [](edge &a, edge &b) {
        if(a.x == b.x) {
            return a.i < b.i;
        } else {
            return a.x < b.x;
        }
    });
    for(int i = 0; i <= n; i++) {
        bool flag = false;
        std::vector<bool> reversed(n, false);
        can(flag, a, reversed, 0, i, r);
        if(flag) {
            std::cout << i;
            return;
        }
    }
    std::cout << -1;
}

struct kos{
    int p, i, d;
    kos(int p, int i, int d) : p(p), i(i), d(d) {};
};

void can1(bool &flag, std::vector<kos> a, std::vector<bool> &reversed, int from, int need, int r) {
    if(flag) return;
    if(need == 0) {
        std::vector<int> used(r + 1);
        std::vector<bool> stoped(a.size(), false);
        for(int i = 0; i < a.size(); i++) {
            used[a[i].p] = 2;
            a[i].p += a[i].d;
        }
        int drives = a.size();
        for(int t = 0; drives > 0; t++) {
            for(int i = 0; i < a.size(); i++) {
                if(!stoped[i]) {
                    if(a[i].p >= 0 && a[i].p <= r) {
                        if(used[a[i].p]){
                            drives--;
                            stoped[i] = true;
                        } else {
                            used[a[i].p - a[i].d] = 1;
                            used[a[i].p] = 2;
                            a[i].p += a[i].d;
                        }
                    } else {
                        drives--;
                        stoped[i] = true;
                    }
                }
            }
        }
        bool can = true;
        for(int i = 1; i <= r; i++) {
            can = can && (used[i] && used[i - 1]);
        }
        flag = can;
    } else {
        need--;
        for(int i = from; i < reversed.size() - need; i++) {
            reversed[i] = true;
            a[i].d *= -1;
            can1(flag, a, reversed, i + 1, need, r);
            reversed[i] = false;
        }
    }
}

void solve1() {
    int n;
    std::cin >> n;
    std::vector<kos> a;
    int r=  0;
    for(int i = 0; i < n; i++) {
        int x, p, d;
        std::cin >> x >> p >> d;
        r = std::max(x, r);
        a.emplace_back(x, p, d);
    }
    for(int i = 0; i <= n; i++) {
        bool flag = false;
        std::vector<bool> reversed(n, false);
        can1(flag, a, reversed, 0, i, r);
        if(flag) {
            std::cout << i;
            return;
        }
    }
    std::cout << -1;
}

int main() {
    solve();
}