#include "iostream"
#include "vector"
#include "algorithm"


struct edge {
    int x, i, r;
    edge(int x, int i, int r) :x(x), i(i), r(r) {};
};

void can(bool &flag, std::vector<edge> &a, std::vector<bool> &reversed, int from, int need, int r) {
    if(flag) return;
    if(need == 0) {
        int cnt = 0;
        int x = 0;
        std::vector<bool> used(reversed.size(), false);
        for(auto &i : a) {
            if(i.r == reversed[i.i]) {
                if(x != i.x && x >= 0) {
                    if(cnt == 0) {
                        break;
                    }
                }
                x = i.x;
                if(used[i.i]) {
                    cnt--;
                } else {
                    used[i.i] = true;
                    cnt++;
                }
            }
        }
        if(x >= r) {
            flag = true;
        }
    } else {
        need--;
        for(int i = from; i < reversed.size() - need; i++) {
            reversed[i] = true;
            can(flag, a, reversed, i + 1, need, r);
            reversed[i] = false;
        }
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<edge> a;
    int r=  0;
    int pi = 1e9;
    std::vector<int> dir;
    for(int i = 0; i < n; i++) {
        int x, p, d;
        std::cin >> x >> p >> d;
        pi = std::min(p, pi);
        r = std::max(x, r);
        dir.push_back(d);
        a.emplace_back(x, i, 0);
        a.emplace_back(x, i, 1);
        a.emplace_back(x + p * d, i, 0);
        a.emplace_back(x - p * d, i, 1);
    }
    if(pi == 1e9) {
        if(dir[0] == 1 || dir.back() == -1) {
            std::cout << 0;
            return;
        }
        int d1 = 0, d2 = 0;
        for(int i = 0; i < n; i++) {
            if(dir[i] == 1) {
                d1++;
            } else {
                d2++;
            }
        }
        if(d1 > 0 && d2 > 0) {
            std::cout << 0;
            return;
        }
        std::cout << 1;
        return;
    }
    std::sort(a.begin(), a.end(), [](edge &a, edge &b) {
        if(a.x == b.x) {
            return a.i > b.i;
        } else {
            return a.x < b.x;
        }
    });
    for(int i = 0; i <= n; i++) {
        bool flag = false;
        std::vector<bool> reversed(n, false);
        can(flag, a, reversed, 0, i, r);
        if(flag) {
            std::cout << i;
            return;
        }
    }
    std::cout << -1;
}

int main() {
    solve();
}