#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
using namespace std;
const int inf = 1e17;

struct node{
    int push, val, cnt, cntp;
    node(){
        push = val = cnt = cntp = 0;
    }
};

struct segTree{
    int n;
    vector<node>tree;
    segTree(int _n){
        n = _n;
        tree.resize(4 * n, node());
    }

    node merge(const node& a, const node& b){
        node tmp;
        tmp.cnt = a.cnt + b.cnt;
        tmp.val = a.val + b.val;
        return tmp;
    }

    void apply(int v, int val, int cntp, int l, int r){
        tree[v].push += val;
        tree[v].cntp += cntp;
        if(l == r - 1) tree[v].val += (r - 1 - tree[v].cnt) * val - cntp;
    }

    void push(int v, int l, int r){
        if(tree[v].push == 0 || l == r - 1) return;
        int m = (r + l) / 2;
        apply(2 * v + 1, tree[v].push, tree[v].cntp, l, m);
        apply(2 * v + 2, tree[v].push, tree[v].cntp + tree[2 * v + 1].cnt, m, r);
        tree[v].push = tree[v].cntp = 0;
    }

    void change(int v, int l, int r, int pos){
        if(l == r - 1){
            tree[v].cnt++;
            return;
        }
        push(v, l, r);
        int m = (r + l) / 2;
        if(pos < m){
            change(2 * v + 1, l, m, pos);
        } else {
            change(2 * v + 2, m, r, pos);
        }
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void upd(int v, int l, int r, int ql, int qr, int cntp){
        if(r <= ql || qr <= l) return;
        if(ql <= l && r <= qr) {
            apply(v, 1, cntp, l, r);
            return;
        }
        push(v, l, r);
        int m = (r + l) / 2;
        upd(2 * v + 1, l, m, ql, qr, cntp);
        upd(2 * v + 2, m, r, ql, qr, cntp + tree[2*v+1].cnt);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void print(int v, int l, int r){
        if(l == r - 1){
            cout << tree[v].val << '\n';
            return;
        }
        push(v, l, r);
        int m = (r + l) / 2;
        print(2 * v + 1, l, m);
        print(2 * v + 2, m, r);
    }
};

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int>t(n);
    for(int i = 0; i < n; i++){
        cin >> t[i];
    }
    vector<int>r(m+1);
    r[0] = 0;
    for(int i = 1; i <= m; i++){
        cin >> r[i];
    }
    vector<int>pos(n);
    segTree tr(n);

        set<pii>s;
        for(int j = 0; j <= n - 1; j++){
            pos[j] = 1;
            s.insert({(r[pos[j]] - r[pos[j] - 1]) * t[j], j});
        }
        while(!s.empty()){
            pii tmp = *s.begin();
            s.erase(s.begin());

            int i = tmp.second;
            tr.upd(0, 0, n, i, n, 0);
            pos[i]++;
            if(pos[i] == m + 1) {
                tr.change(0, 0, n, i);
                continue;
            }
            s.insert({(r[pos[i]] - r[pos[i] - 1]) * t[i], i});
        }

        tr.print(0, 0, n);
//    for(auto& i : ans){
//        cout << i << '\n';
//    }

    return 0;
}
