#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

void dfs(int v, vector<bool>& used, vector<int>& p, const vector<vector<int>>& g) {
    used[v] = 1;
    for (auto u : g[v])
        if (!used[u])
            dfs(u, used, p, g);
    p.push_back(v);
}

bool is_cyc(int v, int p, vector<int>& used, const vector<vector<int>>& g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p)
            continue;
        if (used[u] == 1)
            return 1;
        if (used[u] == 0 && is_cyc(u, v, used, g))
            return 1;
    }
    used[v] = 2;
    return 0;
}

vector<int> top_sort(const vector<vector<int>>& g) {
    int n = (int)g.size();

    vector<int> col(n);
    for (int i = 0; i < n; ++i)
        if (col[i] == 0 && is_cyc(i, i, col, g))
            return {};

    vector<int> p;
    vector<bool> used(n);
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i, used, p, g);
    return p;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pii>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    bool flag = 1;
    for (int i = 0; i < n; ++i)
        for (auto [j, w] : g[i])
            if (a[i] == a[j] && a[i] != w)
                flag = 0;
    if (!flag) {
        cout << "NO\n";
        return;
    }

    vector<vector<int>> g1(n);
    for (int i = 0; i < n; ++i)
        if (a[i] == 0)
            for (auto [j, w] : g[i])
                if (a[j] == 1) {
                    if (w == 0)
                        g1[j].push_back(i);
                    else
                        g1[i].push_back(j);
                }

    auto ts = top_sort(g1);

    if (ts.empty()) {
        cout << "NO\n";
        return;
    }

    vector<pair<int, int>> ans;
    for (auto i : ts) {
        if (a[i] == 0) {
            ans.push_back({i, 1});
            ans.push_back({i, 0});
        } else {
            ans.push_back({i, 1});
        }
    }

    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [i, w] : ans)
        cout << i + 1 << " " << w << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}