#include <iostream>
#include <bitset>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

const ll MAXN = 1e5 + 123;
ll pos[MAXN];
ll mv[MAXN];

signed main() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        ll dir;
        cin >> pos[i] >> mv[i] >> dir;
        mv[i] *= dir;
    }
    int ans = n + 1;
    bitset<MAXN> pref_isoks;
    pref_isoks[0] = pref_isoks[1] = 1;
    for (int i = 2; i <= n; ++i)
        pref_isoks[i] = pref_isoks[i - 1] & (pos[i - 2] + abs(mv[i - 2]) >= pos[i - 1]);
    bitset<MAXN> suf_isoks;
    suf_isoks[n - 1] = 1;
    for (int i = n - 2; i >= 0; --i) {
        suf_isoks[i] = suf_isoks[i + 1] & (pos[i + 1] - abs(mv[i + 1]) <= pos[i]);
    }
    for (int i = 0; i <= n; ++i) {
        bool isok = true;
        isok &= pref_isoks[i];
        isok &= pos[i] - (i == 0 ? 0 : pos[i - 1]) <= abs(mv[i]) + (i == 0 ? 0 : abs(mv[i - 1]));
        isok &= suf_isoks[i];
        if (!isok)
            continue;
        int nans = 0;
        for (int j = 0; j < i; ++j)
            nans += int(mv[j] < 0);
        for (int j = i; j < n; ++j)
            nans += int(mv[j] > 0);
        ans = min(ans, nans);

    }
    if (ans == n + 1) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
}
