#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
using ll = long long;

const int MAXN = 1.5e5 + 123;
const int SQN = sqrt(MAXN) + 3;
const ll INF = 1e18 + 177013;
int a[SQN * 3 / 2];
int cnta_[SQN * 3 / 2];
int* cnta = cnta_ + 1;

int initialize_a(int m) {
    vector<int> s(m);
    for (int i = 0; i < m; ++i)
        cin >> s[i];
    for (int i = m - 1; i >= 1; --i)
        s[i] -= s[i - 1];
    for (int i = 1; i < m; ++i)
        s[i] = max(s[i], s[i - 1]);
    int m0 = 1;
    a[0] = s[0];
    cnta[0] = 1;
    for (int i = 1; i < m; ++i) {
        if (s[i] == s[i - 1]) {
            ++cnta[m0 - 1];
        } else {
            a[m0] = s[i];
            cnta[m0] = 1;
            ++m0;
        }
    }
    for (int i = 0; i < m0; ++i)
        cnta[i] += cnta[i - 1];
    return m0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<ll> cprt(n);
    for (int i = 0; i < n; ++i)
        cprt[i] = t[i];
    sort(cprt.begin(), cprt.end());
    cprt.resize(unique(cprt.begin(), cprt.end()) - cprt.begin());
    for (int i = 0; i < n; ++i)
        t[i] = lower_bound(cprt.begin(), cprt.end(), t[i]) - cprt.begin();

    m = initialize_a(m);
    vector<ll> ans(n, 0);
    vector<int> toccur_(n + 1, 0);
    vector<int>::iterator toccur = toccur_.begin() + 1;
    for (int i = 0; i < n; ++i) {
        for (int k = 0; k < m; ++k) {
            // a[k] * t[i] < a[m - 1] * t[j]
            // t[j] > a[k] * t[i] / a[m - 1]
            // t[j] >= floor(a[k] * t[i] / a[m - 1]) + 1
            int mnt = 1ll * a[k] * cprt[t[i]] / a[m - 1] + 1;
            int j = lower_bound(cprt.begin(), cprt.end(), mnt) - cprt.begin() - 1;
            ans[i] += 1ll * (cnta[k] - cnta[k - 1]) * (i - toccur[j]);
        }
        for (int j = t[i]; j < n; ++j)
            ++toccur[j];
    }
    for (int i = 0; i < n; ++i)
        toccur[i] = 0;
    /*for (int i = 0; i < n; ++i) {
        for (int k = 0; k < m; ++k) {
            // a[k] * t[j] <= a[m - 1] * t[i]
            // t[j] <= floor(a[m - 1] * t[i] / a[k])
            int mxt = 1ll * a[m - 1] * cprt[t[i]] / a[k];
            int j = upper_bound(cprt.begin(), cprt.end(), mxt) - cprt.begin() - 1;
            ans[i] += 1ll * (cnta[k] - cnta[k - 1]) * toccur[j];
        }
        for (int j = t[i]; j < n; ++j)
            ++toccur[j];
    } */
    for (int i = 0; i < n; ++i) for (int j = 0; j < i; ++j) {
        ans[i] += cnta[upper_bound(a, a + m, a[m - 1] * cprt[t[i]] / cprt[t[j]]) - a - 1];
    }
    for (int i = 1; i < n; ++i)
        ans[i] += ans[i - 1];
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}
