#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
using ll = long long;
 
const int MAXN = 1.5e5 + 123;
const int SQN = sqrt(MAXN) + 3;
const ll INF = 1e18 + 177013;
int a[SQN * 3 / 2];
int cnta_[SQN * 3 / 2];
int* cnta = cnta_ + 1;
 
int initialize_a(int m) {
    vector<int> s(m);
    for (int i = 0; i < m; ++i)
        cin >> s[i];
    for (int i = m - 1; i >= 1; --i)
        s[i] -= s[i - 1];
    for (int i = 1; i < m; ++i)
        s[i] = max(s[i], s[i - 1]);
    int m0 = 1;
    a[0] = s[0];
    cnta[0] = 1;
    for (int i = 1; i < m; ++i) {
        if (s[i] == s[i - 1]) {
            ++cnta[m0 - 1];
        } else {
            a[m0] = s[i];
            cnta[m0] = 1;
            ++m0;
        }
    }
    for (int i = 0; i < m0; ++i)
        cnta[i] += cnta[i - 1];
    return m0;
}
 
struct fenwick {
    int sz;
    vector<int> t;
 
    void resize(int n) {
        sz = n;
        t.assign(n, 0);
    }
 
    void add(int i, int x) {
        while (i < sz) {
            t[i] += x;
            i |= i + 1;
        }
    }
 
    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += t[i];
            i &= i + 1;
            --i;
        }
        return ans;
    }
};
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<ll> cprt(n);
    for (int i = 0; i < n; ++i)
        cprt[i] = t[i];
    sort(cprt.begin(), cprt.end());
    cprt.resize(unique(cprt.begin(), cprt.end()) - cprt.begin());
    for (int i = 0; i < n; ++i)
        t[i] = lower_bound(cprt.begin(), cprt.end(), t[i]) - cprt.begin();
 
    m = initialize_a(m);
    vector<ll> ans(n, 0);
    fenwick tr;
    tr.resize(n + 1);

    vector<vector<int>> remilia(m, vector<int>(cprt.size(), 0));
    for (int k = 0; k < m; ++k) {
        int j = -1;
        for (int i = 0; i < int(cprt.size()); ++i) {
            ll mnt = 1ll * a[k] * cprt[i] / a[m - 1] + 1;
            // cprt[j] < mnt
            while (j + 1 < int(cprt.size()) && cprt[j + 1] < mnt)
                ++j;
            remilia[k][i] = j;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int k = 0; k < m; ++k) {
            int j = remilia[k][t[i]];
            ans[i] += 1ll * (cnta[k] - cnta[k - 1]) * (i - tr.get(j));
        }
        tr.add(t[i], 1);
    }
    tr.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        int j = -1;
        for (int k = m - 1; k >= 0; --k) {
            ll mxt = 1ll * a[m - 1] * cprt[t[i]] / a[k];
            // cprt[j] <= mxt
            int bt = 1;
            while (j + bt < int(cprt.size()) && cprt[j + bt] <= mxt) {
                j += bt;
                bt *= 2;
            }
            while (bt > 0) {
                if (j + bt < int(cprt.size()) && cprt[j + bt] <= mxt)
                    j += bt;
                bt /= 2;
            }
            ans[i] += 1ll * (cnta[k] - cnta[k - 1]) * tr.get(j);
        }
        tr.add(t[i], 1);
    }
    for (int i = 1; i < n; ++i)
        ans[i] += ans[i - 1];
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}
