#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 1e5 + 123;
const ll INF = 1e18 + 177013;
ll a[MAXN];
ll pmx_[MAXN];
ll* pmx = pmx_ + 1;

ll solve_slow(vector<ll> t, int m) {
    int n = t.size();
    ll ans = 0;
    for (int i = 0; i < n; ++i) for (int j = 0; j < i; ++j) {
        ans += upper_bound(pmx, pmx + m, pmx[m - 1] * t[i] / t[j]) - pmx;
    }
    for (int i = 0; i < n; ++i) for (int j = i + 1; j < n; ++j) {
        ans += upper_bound(pmx, pmx + m, (pmx[m - 1] * t[i] - 1) / t[j]) - pmx;
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<ll> allt(n);
    for (int i = 0; i < n; ++i)
        cin >> allt[i];
    for (int i = 0; i < m; ++i)
        cin >> a[i];
    for (int i = m - 1; i >= 1; --i)
        a[i] -= a[i - 1];
    for (int i = 0; i < m; ++i)
        pmx[i] = max(pmx[i - 1], a[i]);
    vector<ll> t;
    for (int i = 0; i < n; ++i) {
        t.push_back(allt[i]);
        cout << solve_slow(t, m) << '\n';
    }
}
