#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
using ll = long long;

const int MAXN = 1.5e5 + 123;
const int SQN = sqrt(MAXN) + 3;
const ll INF = 1e18 + 177013;
int a[SQN * 3 / 2];
int cnta_[SQN * 3 / 2];
int* cnta = cnta_ + 1;

int initialize_a(int m) {
    vector<int> s(m);
    for (int i = 0; i < m; ++i)
        cin >> s[i];
    for (int i = m - 1; i >= 1; --i)
        s[i] -= s[i - 1];
    for (int i = 1; i < m; ++i)
        s[i] = max(s[i], s[i - 1]);
    int m0 = 1;
    a[0] = s[0];
    cnta[0] = 1;
    for (int i = 1; i < m; ++i) {
        if (s[i] == s[i - 1]) {
            ++cnta[m0 - 1];
        } else {
            a[m0] = s[i];
            cnta[m0] = 1;
            ++m0;
        }
    }
    for (int i = 0; i < m0; ++i)
        cnta[i] += cnta[i - 1];
    return m0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<ll> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    m = initialize_a(m);
    vector<ll> ans(n, 0);
    for (int i = 0; i < n; ++i) for (int j = 0; j < i; ++j) {
        ans[i] += cnta[upper_bound(a, a + m, (a[m - 1] * t[j] - 1) / t[i]) - a - 1];
    }
    for (int i = 0; i < n; ++i) for (int j = 0; j < i; ++j) {
        ans[i] += cnta[upper_bound(a, a + m, a[m - 1] * t[i] / t[j]) - a - 1];
    }
    for (int i = 1; i < n; ++i)
        ans[i] += ans[i - 1];
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}
