#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

ll get_ans_slow(vector<int> a) {
    int n = a.size();
    vector<int> good_is;
    for (int i = 0; i < n; ++i) {
        while (good_is.size() && i - a[i] <= good_is.back() - a[good_is.back()])
            good_is.pop_back();
        if (good_is.empty() || i + a[i] > good_is.back() + a[good_is.back()])
            good_is.push_back(i);
    }
    vector<int> rs(n);
    int j = 0;
    int m = good_is.size();
    for (int i = 0; i < n; ++i) {
        if (j + 1 < m && i >= good_is[j + 1] - a[good_is[j + 1]])
            ++j;
        rs[i] = good_is[j] + a[good_is[j]] + 1;
    }
    vector<ll> dp(n);
    ll ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (rs[i] >= n)
            continue;
        dp[i] = dp[rs[i]] + n - rs[i];
        ans += dp[i];
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    ll ans = get_ans_slow(a);
    for (int i = 0; i < n; ++i) if (a[i] < x) {
        swap(a[i], x);
        ans = min(ans, get_ans_slow(a));
        swap(a[i], x);
    }
    cout << ans << endl;
}
