#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;

ll get_ans_slow(const vector<int>& a) {
    auto left_border = [&](int i) { return i - a[i]; };
    auto right_border = [&](int i) { return i + a[i]; };
    int n = a.size();
    vector<int> good_is;
    for (int i = 0; i < n; ++i) {
        while (good_is.size() && left_border(i) <= left_border(good_is.back()))
            good_is.pop_back();
        if (good_is.empty() || right_border(i) > right_border(good_is.back()))
            good_is.push_back(i);
    }
    vector<int> rs(n);
    int j = 0;
    int m = good_is.size();
    for (int i = 0; i < n; ++i) {
        while (j + 1 < m && i >= left_border(good_is[j + 1]))
            ++j;
        assert(i >= left_border(good_is[j]));
        rs[i] = right_border(good_is[j]) + 1;
    }
    vector<ll> dp(n);
    ll ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (rs[i] >= n)
            continue;
        dp[i] = dp[rs[i]] + n - rs[i];
        ans += dp[i];
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    ll ans = get_ans_slow(a);
    for (int i = 0; i < n; ++i) if (a[i] < x) {
        swap(a[i], x);
        ans = min(ans, get_ans_slow(a));
        swap(a[i], x);
    }
    cout << ans << endl;
}
