#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

vector<int> get_rs(const vector<int>& a) {
    auto left_border = [&](int i) { return i - a[i]; };
    auto right_border = [&](int i) { return i + a[i]; };
    int n = a.size();
    vector<int> good_is;
    for (int i = 0; i < n; ++i) {
        while (good_is.size() && left_border(i) <= left_border(good_is.back()))
            good_is.pop_back();
        if (good_is.empty() || right_border(i) > right_border(good_is.back()))
            good_is.push_back(i);
    }
    vector<int> rs(n);
    int j = 0;
    int m = good_is.size();
    for (int i = 0; i < n; ++i) {
        while (j + 1 < m && i >= left_border(good_is[j + 1]))
            ++j;
        rs[i] = right_border(good_is[j]) + 1;
    }
    return rs;
}

vector<ll> get_dp(const vector<int>& rs) {
    int n = rs.size();
    vector<ll> dp(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        if (rs[i] >= n)
            continue;
        dp[i] = dp[rs[i]] + n - rs[i];
    }
    return dp;
}

ll get_ans_slow(const vector<int>& a) {
    vector<ll> dp = get_dp(get_rs(a));
    ll ans = 0;
    for (auto& x : dp)
        ans += x;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    if (2 * x + 1 >= n) {
        cout << 0 << endl;
        return 0;
    }
    vector<int> rs = get_rs(a);
    vector<ll> dp = get_dp(rs);
    vector<ll> psmdp_(n + 2);
    vector<ll>::iterator psmdp = psmdp_.begin() + 1;
    for (int i = 0; i <= n; ++i)
        psmdp[i] = psmdp[i - 1] + dp[i];
    ll ans = psmdp[n - 1];

    int r = -1;
    vector<int> visits(n);
    for (int i = 0; i < n; ++i)
        visits[i] = i;
    for (int i = x; i < n - x; ++i) {
        while (rs[r + 1] < i + x + 1)
            ++r;
        if (r < i - x) {
            continue;
        }
        vector<int> cntvisits(r + 1, 1);
        for (int j = i - x - 1; j >= 0; --j) {
            if (rs[j] > r)
                continue;
            if (rs[j] >= i - x) {
                visits[j] = rs[j];
                ++cntvisits[rs[j]];
            } else {
                visits[j] = visits[rs[j]];
                ++cntvisits[visits[j]];
            }
        }
        ll curans = psmdp[n - 1];
        for (int j = r; j >= i - x; --j) {
            curans += (dp[i + x + 1] + n - i - x - 1 - dp[j]) * cntvisits[j] ;
        }
        ans = min(ans, curans);
    }
    cout << ans << endl;
}
