#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

vector<int> get_rs(const vector<int>& a) {
    auto left_border = [&](int i) { return i - a[i]; };
    auto right_border = [&](int i) { return i + a[i]; };
    int n = a.size();
    vector<int> good_is;
    for (int i = 0; i < n; ++i) {
        while (good_is.size() && left_border(i) <= left_border(good_is.back()))
            good_is.pop_back();
        if (good_is.empty() || right_border(i) > right_border(good_is.back()))
            good_is.push_back(i);
    }
    vector<int> rs(n);
    int j = 0;
    int m = good_is.size();
    for (int i = 0; i < n; ++i) {
        while (j + 1 < m && i >= left_border(good_is[j + 1]))
            ++j;
        rs[i] = right_border(good_is[j]) + 1;
    }
    return rs;
}

vector<ll> get_dp(const vector<int>& rs) {
    int n = rs.size();
    vector<ll> dp(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        if (rs[i] >= n)
            continue;
        dp[i] = dp[rs[i]] + n - rs[i];
    }
    return dp;
}

ll get_ans_slow(const vector<int>& a) {
    vector<ll> dp = get_dp(get_rs(a));
    ll ans = 0;
    for (auto& x : dp)
        ans += x;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    if (2 * x + 1 >= n) {
        cout << 0 << endl;
        return 0;
    }
    vector<int> rs = get_rs(a);
    vector<ll> dp = get_dp(rs);
    vector<ll> psmdp_(n + 2);
    vector<ll>::iterator psmdp = psmdp_.begin() + 1;
    for (int i = 0; i <= n; ++i)
        psmdp[i] = psmdp[i - 1] + dp[i];
    ll ans = psmdp[n - 1];

    int r = -1;
    vector<int> visits(n + 1);
    vector<int> cntvisits(n + 1, 1);
    for (int i = 0; i < n; ++i) {
        visits[i] = i;
    }
    ll total_cntvisits = 0;
    ll remilia = 0;
    for (int i = x; i < n - x; ++i) {
        if (i > x && rs[i - x - 1] < n) {
            if (rs[i - x - 1] > r && i - x - 1 <= r) {
                total_cntvisits -= cntvisits[i - x - 1];
            }
            if (i - x - 1 <= r)
                remilia -= cntvisits[i - x - 1] * dp[i - x - 1];
            if (rs[i - x - 1] <= r) {
                remilia += dp[rs[i - x - 1]] * cntvisits[i - x - 1];
            }
            cntvisits[rs[i - x - 1]] += cntvisits[i - x - 1];
            cntvisits[i - x - 1] = 0;
        }

        while (rs[r + 1] < i + x + 1) {
            ++r;
            if (r >= i - x) {
                total_cntvisits += cntvisits[r];
                remilia += dp[r] * cntvisits[r];
            }
        }
        if (r < i - x)
            continue;
        ll curans = psmdp[n - 1] + (dp[i + x + 1] + n - i - x - 1) * total_cntvisits - remilia;
        ans = min(ans, curans);
    }
    cout << ans << endl;
}
