#include <bits/stdc++.h>
//#define int long long

#ifdef LOCAL
#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << x << "\n"
#else
#define debug(x) ;
#endif

using namespace std;

bool dfs(int v, int p, int cnt, int prev, vector<int> &c, vector<int> &used, vector<int> &col, vector<int> &d, vector<vector<pair<int, int>>> &g) {
    used[v] = cnt;
    bool ans = 0;
    for (auto [u, i] : g[v]) {
        if (!col[u] || d[v] == d[u] || (used[u] != cnt && used[u] != 0) || p == u) {
            continue;
        }
        if (c[i] == prev) {
            cnt++;
        }
        if (used[u] == cnt) {
            return 1;
        }
        ans |= dfs(u, v, cnt, c[i], c, used, col, d, g);
        if (c[i] == prev) {
            cnt--;
        }
    }
    used[v] = 1e6;
    return ans;
}

void dfs2(int v, int p, vector<pair<int, int>> &ans, vector<int> &c, vector<int> &used, vector<int> &col, vector<int> &d, vector<vector<pair<int, int>>> &g) {
    if (d[v]) {
        ans.push_back({v, 1});
    }
    used[v] = 1;
    for (auto [u, i] : g[v]) {
        if (!col[u] || used[u] == 2 || u == p) {
            continue;
        }
        if (c[i] && d[v] && !d[u]) {
            ans.push_back({u, 1});
            ans.push_back({u, 0});
        } else if (c[i] && d[u] && !d[v]) {
            ans.push_back({v, 1});
            ans.push_back({v, 0});
        }
        if (!used[u]) {
            dfs2(u, v, ans, c, used, col, d, g);
        }
    }
    used[v] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> col(n, 0), used(n, 0), used2(n, 0);
    vector<int> a(m), b(m), c(m), d(n);
    vector<pair<int, int>> ans;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        cin >> a[i] >> b[i] >> c[i];
        a[i]--;
        b[i]--;
        if (c[i]) {
            col[a[i]] = 1;
            col[b[i]] = 1;
        }
        g[a[i]].push_back({b[i], i});
        g[b[i]].push_back({a[i], i});
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        int v = i;
        for (auto [u, num] : g[v]) {
            if (d[u] == d[v] && c[num] != d[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            continue;
        }
        if (col[i] && dfs(i, -1, 1, -1, c, used, col, d, g)) {
            cout << "NO" << "\n";
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (used2[i]) {
            continue;
        }
        if (col[i]) {
            dfs2(i, -1, ans, c, used2, col, d, g);
        }
    }
    cout << "YES\n";
    cout << (int)ans.size() << "\n";
    for (int i = 0; i < (int)ans.size(); i++) {
        cout << ans[i].first + 1 << " " << ans[i].second << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

