#include <bits/stdc++.h>

using ll = long long;

using namespace std;

const ll inf = 1'000'000'000'000;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
  for (t &e : a) {
    din >> e;
  }
  return din;
}

struct edge {
  ll v, u;
  bool d;
  edge() = default;
  edge(ll v, ll u, ll d) : v(v), u(u), d(d) {}
  friend istream &operator>>(istream &din, edge &e) {
    din >> e.v >> e.u >> e.d;
    e.v--, e.u--;
    return din;
  }
};

void solve() {
  ll n, m;
  cin >> n >> m;
  vector<edge> es(m);
  cin >> es;
  vector<ll> d(n);
  cin >> d;
  vector<pair<ll, ll>> ans;
  for (edge e : es) {
    if ((d[e.v] == d[e.u]) && (e.d ^ d[e.v])) {
      cout << "NO\n";
      return;
    }
    if (e.d) {
      ans.emplace_back(e.v + 1, 1);
      ans.emplace_back(e.u + 1, 1);
      ans.emplace_back(e.v + 1, -1);
      ans.emplace_back(e.u + 1, -1);
    }
  }
  for (ll i = 0; i < n; i++) {
    if (d[i]) {
      ans.emplace_back(i + 1, 1);
    }
  }
  cout << "YES\n";
  cout << ans.size() << '\n';
  for (pair<ll, ll> p : ans) {
    cout << p.first << ' ' << p.second << '\n';
  }
}

int main() {
#ifdef DBG
  freopen("in.txt", "r", stdin);
  freopen("out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  ll t;
  cin >> t;
  for (ll ti = 0; ti < t; ti++) {
    solve();
  }
  return 0;
}
