#include <bits/stdc++.h>

using ll = long long;

using namespace std;

const ll inf = 1'000'000'000'000;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
  for (t &e : a) {
    din >> e;
  }
  return din;
}

struct edge {
  ll u;
  bool d;
  edge() = default;
  edge(ll u, ll d) : u(u), d(d) {}
};

bool dfs(const vector<vector<ll>> &dg, vector<bool> &used, ll v, vector<ll> &ts) {
  if (used[v]) return true;
  used[v] = true;
  for (ll u : dg[v]) {
    if (dfs(dg, used, u, ts)) return true;
  }
  ts.push_back(v);
  return false;
}

void solve() {
  ll n, m;
  cin >> n >> m;
  vector<vector<edge>> g(n);
  for (ll i = 0; i < m; i++) {
    ll a, b, c;
    cin >> a >> b >> c;
    a--, b--;
    g[a].emplace_back(b, c);
    g[b].emplace_back(a, c);
  }
  vector<ll> d(n);
  cin >> d;
  vector<vector<ll>> dg(n);
  for (ll v = 0; v < n; v++) {
    for (edge e : g[v]) {
      if (d[v] == e.d && e.d == !d[e.u]) {
        dg[v].push_back(e.u);
      }
    }
  }
  vector<bool> used(n);
  vector<ll> ts;
  for (ll v = 0; v < n; v++) {
    if (!used[v]) {
      if (dfs(dg, used, v, ts)) {
        cout << "NO\n";
        return;
      }
    }
  }
  vector<pair<ll, ll>> ans;
  reverse(ts.begin(), ts.end());
  for (ll i : ts) {
    ans.emplace_back(i + 1, 1);
    if (!d[i]) ans.emplace_back(i + 1, 0);
  }
  cout << "YES\n" << ans.size() << '\n';
  for (const pair<ll, ll> &p : ans) {
    cout << p.first << ' ' << p.second << '\n';
  }
}

int main() {
#ifdef DBG
  freopen("in.txt", "r", stdin);
  freopen("out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  ll t;
  cin >> t;
  for (ll ti = 0; ti < t; ti++) {
    solve();
  }
  return 0;
}
