#include <bits/stdc++.h>
using namespace  std;
typedef long long ll;

const ll INF = 1e18;

void dfs(ll v, vector<bool>& used, vector<ll>& cmp, ll num, vector<vector<ll>>& g) {
    used[v] = true;
    cmp[v] = num;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, used, cmp, num, g);
        }
    }
}

void make_top(ll v, vector<bool>& used, vector<ll>& top, vector<set<ll>>& g) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            make_top(to, used, top, g);
        }
    }
    top.push_back(v);
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<pair<ll, ll>>> g(n);
    vector<vector<ll>> want(n);
    vector<array<ll, 3>> e(m);
    for (int i = 0; i < m; i++) {
        ll u, v, c; cin >> u >> v >> c;
        u--; v--;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
        if (c == 1) {
            want[u].push_back(v);
            want[v].push_back(u);
        }
        e[i] = {u, v, c};
    }
    vector<ll> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < m; i++) {
        ll u = e[i][0], v = e[i][1], c = e[i][2];
        if (c == 1 && d[u] + d[v] == 0) {
            cout << "NO" << '\n';
            return;
        } else if (c == 0 && d[u] + d[v] == 2) {
            cout << "NO" << '\n';
            return;
        }
    }

    vector<ll> cmp(n, -1);
    ll num = 0;
    vector<bool> used(n, false);

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, used, cmp, num, want);
            num++;
        }
    }

    vector<vector<ll>> where(num);
    for (int i = 0; i < n; i++) {
        where[cmp[i]].push_back(i);
    }

    vector<set<ll>> for_top(n);
    for (int i = 0; i < m; i++) {
        ll u = e[i][0], v = e[i][1], c = e[i][2];
        if (c == 0 && cmp[u] != cmp[v]) {
            if (d[u] == 1 && d[v] == 0) {
                for_top[cmp[v]].insert(cmp[u]);
            } else if (d[u] == 0 && d[v] == 1) {
                for_top[cmp[u]].insert(cmp[v]);
            }
        }
    }

    vector<ll> top;
    used.assign(num, false);
    for (int i = 0; i < num; i++) {
        if (!used[i]) {
            make_top(i, used, top, for_top);
        }
    }
    reverse(top.begin(), top.end());

//    vector<ll> idx(num);
//    for (int i = 0; i < num; i++) {
//        idx[top[i]] = i;
//    }
//    for (int i = 0; i < num; i++) {
//        for (auto to : for_top[i]) {
//            if (idx[i] > idx[to]) {
//                cout << "NO" << '\n';
//                return;
//            }
//        }
//    }

    cout << "YES" << '\n';
    cout << -1 << '\n';
//    vector<pair<ll, ll>> ans;
//    for (int nw = 0; nw < num; nw++) {
//        for (auto v : where[nw]) {
//            ans.push_back({v, 1});
//        }
//        for (auto v : where[nw]) {
//            if (d[v] == 0) {
//                ans.push_back({v, 0});
//            }
//        }
//    }
//    cout << ans.size() << '\n';
//    for (auto [v, c] : ans) {
//        cout << v + 1 << " " << c << '\n';
//    }

}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(0);

    ll t; cin >> t;
    while (t--) {
        solve();
    }
}