#include <bits/stdc++.h>
using namespace  std;
typedef long long ll;

const ll INF = 1e18;

void dfs(ll v, vector<bool>& used, vector<ll>& cmp, ll num, vector<vector<ll>>& g) {
    used[v] = true;
    cmp[v] = num;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, used, cmp, num, g);
        }
    }
}

void make_top(ll v, vector<bool>& used, vector<ll>& top, vector<set<ll>>& g) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            make_top(to, used, top, g);
        }
    }
    top.push_back(v);
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<pair<ll, ll>>> g(n);
    vector<vector<ll>> want(n);
    vector<array<ll, 3>> e(m);
    for (int i = 0; i < m; i++) {
        ll u, v, c; cin >> u >> v >> c;
        u--; v--;
        g[u].push_back({v, c});
        // g[v].push_back({u, c});
        if (c == 1) {
            want[u].push_back(v);
            want[v].push_back(u);
        }
        e[i] = {u, v, c};
    }
    vector<ll> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < m; i++) {
        ll u = e[i][0], v = e[i][1], c = e[i][2];
        if (c == 1 && d[u] + d[v] == 0) {
            cout << "NO" << '\n';
            return;
        } else if (c == 0 && d[u] + d[v] == 2) {
            cout << "NO" << '\n';
            return;
        }
    }

    cout << "YES" << '\n';

    vector<pair<ll, ll>> ans;
    for (int i = 0; i < n; i++) {
        if (d[i] == 0) continue;
        ans.push_back({i, 1});
        for (auto [to, c] : g[i]) {
            if (c == 1) {
                ans.push_back({to, 1});
                ans.push_back({to, 0});
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto [v, c] : ans) {
        cout << v + 1 << " " << c << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(0);

    ll t; cin >> t;
    while (t--) {
        solve();
    }
}