#include <bits/stdc++.h>
using namespace  std;
typedef long long ll;

const ll INF = 1e18;

void dfs(ll v, vector<bool>& used, vector<ll>& cmp, ll num, vector<vector<ll>>& g) {
    used[v] = true;
    cmp[v] = num;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, used, cmp, num, g);
        }
    }
}

void make_top(ll v, vector<bool>& used, vector<ll>& top, vector<set<ll>>& g) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            make_top(to, used, top, g);
        }
    }
    top.push_back(v);
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<pair<ll, ll>>> g_c(n), g_num(n);
    vector<vector<ll>> want(n);
    vector<array<ll, 3>> e(m);
    for (int i = 0; i < m; i++) {
        ll u, v, c; cin >> u >> v >> c;
        u--; v--;
        g_c[u].push_back({v, c});
        g_c[v].push_back({u, c});
        g_num[u].push_back({v, i});
        g_num[v].push_back({u, i});
        if (c == 1) {
            want[u].push_back(v);
            want[v].push_back(u);
        }
        e[i] = {u, v, c};
    }
    vector<ll> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
//    for (int i = 0; i < m; i++) {
//        ll u = e[i][0], v = e[i][1], c = e[i][2];
//        if (c == 1 && d[u] + d[v] == 0) {
//            cout << "NO" << '\n';
//            return;
//        } else if (c == 0 && d[u] + d[v] == 2) {
//            cout << "NO" << '\n';
//            return;
//        }
//    }

    ll sz = n + m;
    vector<bool> dp((1 << sz), false);
    dp[0] = true;
    vector<pair<ll, ll>> p((1 << sz), {-1, -1});
    for (int mask = 0; mask < (1 << sz); mask++) {
        if (!dp[mask]) continue;
        for (int i = m; i < sz; i++) {
            if (((mask >> i) & 1)) {
                ll v = i - m;
                ll nxt = (mask ^ (1 << i));
                for (auto [to, num] : g_num[v]) {
                    if (((mask >> num) & 1) && !((mask >> (m + to)) & 1)) {
                        nxt = (nxt ^ (1 << num));
                    }
                }
                if (dp[nxt]) {
                    dp[mask] = true;
                    p[mask] = {v, -1};
                }
            }
        }

        for (int i = m; i < sz; i++) {
            if (!((mask >> i) & 1)) {
                ll v = i - m;
                ll nxt = (mask ^ (1 << i));
                for (auto [to, num] : g_num[v]) {
                    if (!((mask >> num) & 1) && ((mask >> (m + to)) & 1)) {
                        nxt = (nxt ^ (1 << num));
                    }
                }
                dp[nxt] = true;
                p[nxt] = {v, 1};
            }
        }
    }
    ll cur = 0;
    for (int i = 0; i < m; i++) {
        if (e[i][2]) {
            cur = (cur ^ (1 << i));
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i]) {
            cur = (cur ^ (1 << (m + i)));
        }
    }

    if (!dp[cur]) {
        cout << "NO" << '\n';
        return;
    }

    cout << "YES" << '\n';
    cout << -1 << '\n';

}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(0);

    ll t; cin >> t;
    while (t--) {
        solve();
    }
}