#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;

#define int long long

const long long INF = 1e15;
vector<vector<pair<int, int>>> graph;
vector<int> color;
vector<int> color_pass;
vector<int> needed_color;
vector<int> needed_color_pass;
vector<bool> used;
vector<int> ancestor;
vector<int> temp;
vector<int> depth;
vector<int> last_norm;

struct edge {
    int u, v, c;
};

vector<edge> edges;

vector<pair<int, int>> ans;

void dfs(int v, int cur_last_norm, int prev_edge) {
    used[v] = true;
    for (auto [u, c] : graph[v]) {
        if (!used[u]) {
            depth[u] = depth[v] + 1;
            int next_norm = cur_last_norm;
            if (needed_color[u] == needed_color[v]) {
                next_norm = depth[u];
            }
            if (c == cur_last_norm) {
                next_norm = depth[u];
            }
            dfs(u, next_norm, c);
            ancestor[u] = v;
            if (c == 1) {
                ans.push_back({v + 1, 1});
                ans.push_back({u + 1, 1});
                color[v] = 1;
                color[u] = 1;
                ans.push_back({v + 1, 0});
                color[v] = 0;
            }
        }
    }
}

void solve() {
    int n, m, u, v, c;
    cin >> n >> m;
    graph.clear();
    graph.resize(n, {});
    used.clear();
    edges.clear();
    ancestor.clear();
    temp.clear();
    depth.clear();
    ancestor.resize(n, -1);
    used.resize(n, false);
    temp.assign(n, 0);
    depth.assign(n, 0);
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> c;
        u--;
        v--;
        graph[u].push_back({v, c});
        graph[v].push_back({u, c});
        edges.push_back({u, v, c});
    }
    ans.clear();
    needed_color.clear();
    color_pass.resize(m, 0);
    color.resize(n, 0);
    needed_color.resize(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> needed_color[i];
    }
    for (int i = 0; i < m; i++) {
        if (needed_color[edges[i].u] == needed_color[edges[i].v] && needed_color[edges[i].u] != edges[i].c) {
            cout << "NO" << endl;
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, 0, -1);
        }
    }
    for (int i = 0; i < n; i++) {
        ans.push_back({i + 1, needed_color[i]});
    }
    for (int i = 0; i < m; i++) {
        if (edges[i].v != ancestor[edges[i].u] && edges[i].u != ancestor[edges[i].v]) {
            if (depth[edges[i].v] > depth[edges[i].u]) {
                swap(edges[i].v, edges[i].u);
            }
            if (needed_color[edges[i].v] != needed_color[edges[i].u] && last_norm[edges[i].u] <= depth[edges[i].v]) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    cout << -1 << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
