#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

vector<vector<vector<pair<int, int>>>> g;
vector<vector<pair<int, int>>> gg;

vector<pair<int, int>> order;
vector<vector<bool>> used;

void topsort(int v, int on) {
    used[v][on] = true;
    for (auto [u, uon] : g[v][on]) {
        if (!used[u][uon]) {
            topsort(u, uon);
        }
    }
    order.push_back({v, on});
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m), b(m), c(m);
    gg.clear();
    gg.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i];
        --a[i];
        --b[i];
        gg[a[i]].push_back({b[i], c[i]});
        gg[b[i]].push_back({a[i], c[i]});
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] && d[b[i]] && !c[i]) {
            cout << "NO\n";
            return;
        }
        if (!d[a[i]] && !d[b[i]] && c[i]) {
            cout << "NO\n";
            return;
        }
    }
//    cout << "YES\n";
//    cout << -1 << '\n';
//    return;
    vector<pair<int, int>> res;
    vector<int> onv(n);
    for (int i = 0; i < m; ++i) {
        if (c[i] == 1) {
            onv[a[i]] = 1;
            onv[b[i]] = 1;
            res.push_back({a[i] + 1, 1});
            res.push_back({b[i] + 1, 1});
        }
    }
    vector<int> donv = onv;
    for (int i = 0; i < m; ++i) {
        if (c[i] == 0 && donv[a[i]] && donv[b[i]]) {
            onv[a[i]] = 0;
            onv[b[i]] = 0;
            res.push_back({a[i] + 1, 0});
            res.push_back({b[i] + 1, 0});
        }
    }

    for (int i = 0; i < m; ++i) {
        if (c[i] == 1 && !onv[a[i]] && !onv[b[i]]) {
            onv[a[i]] = 1;
            onv[b[i]] = 1;
            res.push_back({a[i] + 1, 1});
            res.push_back({b[i] + 1, 1});
        }
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] == 0 && onv[a[i]] && onv[b[i]]) {
            cout << "NO\n";
            return;
        }
    }

    g.clear();
    g.resize(n, vector<vector<pair<int, int>>>(2));

    for (int i = 0; i < n; ++i) {
        for (auto [u, cc] : gg[i]) {
            if (cc == 0) {
                g[i][1].push_back({u, 0});
            }
        }
        for (auto [u, cc] : gg[i]) {
            if (cc == 1) {
                g[i][0].push_back({u, 1});
            }
        }
    }
    order.clear();
    used.clear();
    used.resize(n, vector<bool>(2));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            if (j == d[i] && onv[i] != j && !used[i][j]) {
                topsort(i, j);
            }
        }
    }
    used.clear();
    used.resize(n, vector<bool>(2));
    for (auto [v, vn] : order) {
        if (used[v][0] || used[v][1]) {
            cout << "NO\n";
            return;
        }
        used[v][vn] = true;
        for (auto [u, un] : g[v][vn]) {
            if (!used[u][un]) {
                cout << "NO\n";
                return;
            }
        }
        onv[v] = vn;
        res.push_back({v + 1, vn});
    }
    for (int i = 0; i < n; ++i) {
        if (used[i][0] && used[i][1]) {
            cout << "NO\n";
            return;
        }
        if (onv[i] != d[i]) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] == 1 && onv[a[i]] == 0 && onv[b[i]] == 0) {
            cout << "NO\n";
            return;
        }
        if (c[i] == 0 && onv[a[i]] == 1 && onv[b[i]] == 1) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << sz(res) << '\n';
    for (auto [t, tt] : res) {
        cout << t << ' ' << tt << '\n';
    }
    return;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}