#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

struct S {
    int n;
    vector<int> t;
    vector<int> pu;
    S() {}
    S(int n) : n(n) {

        t.resize(4 * n);
        pu.resize(4 * n, -1);
    }
    void push(int node, int l, int r) {
        if (pu[node] != -1) {
            t[node] = pu[node];
            if (l != r) {
                pu[2 * node] = pu[node];
                pu[2 * node + 1] = pu[node];
            }
            pu[node] = -1;
        }
    }
    void upd(int node, int l, int r, int ql, int qr, int x) {
        push(node, l, r);
        if (ql > r || l > qr) return;
        if (ql <= l && r <= qr) {
            pu[node] = x;
            push(node, l, r);
            return;
        }
        int m = (l + r) >> 1;
        upd(2 * node, l, m, ql, qr, x);
        upd(2 * node + 1, m + 1, r, ql, qr, x);
    }
    int get(int node, int l, int r, int idx) {
        push(node, l, r);
        if (l == r) return t[node];
        int m = (l + r) >> 1;
        if (idx <= m) {
            return get(2 * node, l, m, idx);
        }
        return get(2 * node + 1, m + 1, r, idx);
    }
};

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    vector<int> l(n);
    vector<int> r(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        l[i] = max(0ll, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
    }
    vector<int> order(n);
    iota(all(order), 0);
    sort(all(order), [&](int x, int y) {
        return r[x] < r[y];
    });
    S s(n);
    for (auto i : order) {
        s.upd(1, 0, n - 1, l[i], r[i], i);
    }
    vector<int> best(n);
    for (int i = 0; i < n; ++i) {
        best[i] = s.get(1, 0, n - 1, i);
//        cout << best[i] << ' ';
    }
    vector<int> dp(n - 1);
    dp[n - 1] = 0;
    int sum = 0;
    for (int i = n - 2; i >= 0; --i) {
        if (r[best[i]] != n - 1) {
            dp[i] = dp[r[best[i]] + 1] + n - 1 - r[best[i]];
        }
        sum += dp[i];
    }
    cout << sum << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}