#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define pii pair<int, int>
#define f first
#define s second
#define int long long

using namespace std;

template<typename T1, typename T2>
ostream& operator<< (ostream& out, pair<T1, T2>& p) {
    return out << "(" << p.f << "; " << p.s << ")";
}

template<typename T>
ostream& operator<< (ostream& out, vector<T> &v) {
    for (T& x: v)
        out << x << " ";
    return out;
}

template<typename T>
ostream& operator<< (ostream& out, vector<vector<T>>& v) {
    for (vector<T>& x: v)
        out << x << endl;
    return out;
}

template<typename T1, typename T2>
istream& operator>> (istream& in, pair<T1, T2>& p) {
    return in >> p.f >> p.s;
}

template<typename T>
istream& operator>> (istream& in, vector<T>& v) {
    for (T& x: v)
        in >> x;
    return in;
}

int n;
vector<int> x;
vector<int> d;
vector<int> p;

int popcount(int msk) {
    int cnt = 0;
    for (int i = 0; i < 30; i++)
        if (msk & (1 << i))
            cnt++;
    return cnt;
}

bool check(int msk) {
    int lst = 0;
    for (int i = 0; i < n; i++) {
        if (msk & (1 << i)) {
            if (d[i] == -1) {
                if (lst < x[i])
                    return 0;
                lst = x[i] + p[i];
            }
            else {
                if (lst < x[i] - p[i])
                    return 0;
                lst = x[i];
            }
        }
        else {
            if (d[i] == 1) {
                if (lst < x[i])
                    return 0;
                lst = x[i] + p[i];
            }
            else {
                if (lst < x[i] - p[i])
                    return 0;
                lst = x[i];
            }
        }
    }
    return 1;
}

int solve_stpd() {
    int ans = 100;
    for (int msk = 0; msk < (1 << n); msk++) {
        int chg = popcount(msk);
        if (check(msk) && ans > chg) {
            bitset<8> b = msk;
            cout << b << endl;
            ans = chg;
        }
    }
    if (ans == 100)
        return -1;
    else
        return ans;
}

int solve_fast() {
    vector<int> pref_calc(n + 1), pref_pos(n + 1);
    vector<int> suf_calc(n + 1), suf_pos(n + 1);
    pref_pos[0] = 1;
    suf_pos[n] = 1;
    for (int i = 0; i < n - 1; i++) {
        pref_calc[i + 1] = pref_calc[i];
        if (d[i] == -1)
            pref_calc[i+1]++;
        pref_pos[i + 1] = pref_pos[i];
        if (x[i] + p[i] < x[i + 1])
            pref_pos[i + 1] = 0;
    }
    pref_pos[n] = pref_pos[n - 1];
    pref_calc[n] = pref_calc[n-1] + (d[n - 1] == -1);

    for (int i = n-1; i > 0; i--) {
        suf_calc[i] = suf_calc[i+1];
        suf_pos[i] = suf_pos[i+1];
        if (d[i] == 1)
            suf_calc[i]++;
        if (x[i] - p[i] > x[i-1])
            suf_pos[i] = 0;
    }
    suf_pos[0] = suf_pos[1];
    suf_calc[0] = suf_calc[1] + (d[0] == 1);
    int ans = 1e9 + 7;
    //cout << pref_pos << " | " << pref_calc << endl;
    //cout << suf_pos << " | " << suf_calc << endl;
    for (int i = 0; i < n - 1; i++) {
        if (!pref_pos[i] || !suf_pos[i+2])
            continue;
        if (x[i] + p[i] < x[i + 1] - p[i + 1])
            continue;
        if (ans > pref_calc[i + 1] + suf_calc[i + 1]) {
            //cout << i << endl;
            ans = pref_calc[i + 1] + suf_calc[i + 1];
        }
        //ans = min(ans, pref_calc[i + 1] + suf_calc[i]);
    }
    //all left
    if (suf_pos[0] && ans > suf_calc[0])
        ans = suf_calc[0];
    //all right
    if (pref_pos[n] && ans > pref_calc[n])
        ans = pref_calc[n];

    if (ans == 1e9 + 7)
        return -1;
    else
        return ans;
}

signed main() {
    cin >> n;
    x.resize(n);
    d.resize(n);
    p.resize(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> p[i] >> d[i];
    cout << solve_fast() << endl;

}
