#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using ll = long long;
#define INF 1'000'000'000
#define LINF 1'000'000'000'000'000'000

int main()
{
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif // LOCAL
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    int n;
    std::cin >> n;
    std::vector<ll> x(n + 2);
    std::vector<ll> p(n + 2);
    std::vector<ll> d(n + 2);
    for (int i = 1; i <= n; ++i)
    {
        std::cin >> x[i] >> p[i] >> d[i];
    }
    x[0] = 0; p[0] = 0;
    x[n + 1] = 0; p[n + 1] = 0;

    std::vector<ll> l(n + 2, INF);
    std::vector<ll> r(n + 2, INF);
    l[0] = 0;
    r[n + 1] = 0;
    for (int i = 1; i <= n; ++i)
    {
        if (p[i - 1] < x[i] - x[i - 1]) break;
        l[i] = l[i - 1];
        if (d[i] != 1) ++l[i];
    }
    for (int i = n; i > 0; --i)
    {
        if (p[i + 1] < x[i + 1] - x[i]) break;
        r[i] = r[i + 1];
        if (d[i] != -1) ++r[i];
    }

    ll ans = INF;
    for (int i = 0; i <= n; ++i)
    {
        if (p[i] + p[i + 1] < x[i + 1] - x[i]) continue;
        ans = std::min(ans, l[i] + r[i + 1]);
    }

    if (ans == INF) ans = -1;
    std::cout << ans;

    return 0;
}
