#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using ll = long long;
#define INF 1'000'000'000
#define LINF 1'000'000'000'000'000'000

struct Edge
{
    int u, v;
    int c;
};

std::vector<std::vector<int>> g;
std::vector<int> used;
std::vector<int> tout;
int timer;

bool dfs(int u)
{
    if (used[u] == 1) return false;
    if (used[u] == 2) return true;
    used[u] = 1;

    bool out = true;
    for (auto v : g[u])
    {
        out = out && dfs(v);
    }
    used[u] = 2;
    tout[u] = ++timer;
    return out;
}

int main()
{
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif // LOCAL
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    int T;
    std::cin >> T;
    while(T--)
    {
        int n, m;
        std::cin >> n >> m;
        std::vector<Edge> e(m);
        for (auto& [u, v, c] : e)
        {
            std::cin >> u >> v >> c;
            --u; --v;
        }
        std::vector<int> d(n);
        for (auto& i : d)
        {
            std::cin >> i;
        }

        bool ans = true;
        g.assign(n, std::vector<int>());
        used.assign(n, 0);
        tout.assign(n, -1);
        timer = 0;
        for (auto& [u, v, c] : e)
        {
            if (d[u] == d[v])
            {
                if (d[u] != c)
                {
                    ans = false;
                }
                continue;
            }
            if (d[u]) std::swap(u, v);
            if (c) g[u].push_back(v);
            else g[v].push_back(u);
        }

        for (int i = 0; i < n; ++i)
        {
            if (used[i] != 0) continue;
            ans = ans && dfs(i);
        }

        if (ans)
        {
            std::cout << "YES\n";
            std::vector<std::pair<int, int>> seq(n);
            for (int i = 0; i < n; ++i)
            {
                seq[i] = std::make_pair(tout[i], i);
            }
            std::sort(seq.begin(), seq.end());
            std::vector<std::pair<int, int>> out;
            for (auto [_, i] : seq)
            {
                out.push_back(std::make_pair(i + 1, 1));
                if (d[i] == 0) out.push_back(std::make_pair(i + 1, 0));
            }
            std::cout << out.size() << "\n";
            for (auto [v, x] : out) std::cout << v << " " << x << "\n";
        }
        else std::cout << "NO\n";
    }

    return 0;
}
