#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()


void solve() {
	int n, m; cin >> n >> m;
	vector <tuple <int, int, int>> eg(m);
	for (auto& [u, v, c] : eg) {
		cin >> u >> v >> c;
		--u; --v;
	}
	vector <int> d(n);
	for (auto& x : d) cin >> x;

	vector <vector <pair <int, int>>> g(n);
	for (auto& [u, v, c] : eg) {
		if (d[u] == d[v] && d[u] != c) {
			cout << "NO";
			return;
		}
		if (d[u] != d[v]) {
			g[u].push_back({ v, c });
			g[v].push_back({ u, c });
		}
	}

	vector <pair <int, int>> ans;
	for (int i = 0; i < n; ++i) {
		if (d[i] == 1) {
			ans.push_back({ i, 1 });
		}
	}
	

	vector <int> cnt0(n), cnt1(n);
	for (int i = 0; i < n; ++i) {
		for (auto [u, c] : g[i]) {
			if (c == 0) ++cnt0[i];
			else ++cnt1[i];
		}
	}

	set <tuple <int, int, int>> st;
	for (int i = 0; i < n; ++i) {
		st.insert({ cnt0[i], 0, i });
		st.insert({ cnt1[i], 1, i });
	}

	vector <bool> used(n, false);
	vector <pair <int, int>> sta;

	while (!st.empty()) {
		auto [cnt, t, v] = *st.begin();
		st.erase(st.begin());

		if (used[v]) continue;

		if (cnt != 0) {
			cout << "NO";
			return;
		}

		if (d[v] == 0) {
			if (t == 0) {
				ans.push_back({ v, 1 });
				sta.push_back({ v, 0 });
				used[v] = true;
				for (auto [u, c] : g[v]) {
					if (!used[u]) {
						st.erase({ cnt1[u], 1, u });
						--cnt1[u];
						st.insert({ cnt1[u], 1, u });
					}
				}
			}
			else {
				used[v] = true;
				for (auto [u, c] : g[v]) {
					if (!used[u]) {
						ans.push_back({ u, 0 });
						ans.push_back({ u, 1 });
						st.erase({ cnt0[u], 0, u });
						--cnt0[u];
						st.insert({ cnt0[u], 0, u });
					}
				}
			}
		}
		else {
			if (t == 1) {
				ans.push_back({ v, 0 });
				sta.push_back({ v, 1 });
				used[v] = true;
				for (auto [u, c] : g[v]) {
					if (!used[u]) {
						st.erase({ cnt0[u], 0, u });
						--cnt0[u];
						st.insert({ cnt0[u], 0, u });
					}
				}
			}
			else {
				used[v] = true;
				for (auto [u, c] : g[v]) {
					if (!used[u]) {
						ans.push_back({ u, 1 });
						ans.push_back({ u, 0 });
						st.erase({ cnt1[u], 1, u });
						--cnt1[u];
						st.insert({ cnt1[u], 1, u });
					}
				}
			}
		}
	}
	while (!sta.empty()) {
		ans.push_back(sta.back());
		sta.pop_back();
	}

	cout << "YES\n";
	cout << ans.size() << '\n';
	for (auto [v, t] : ans) cout << v + 1 << ' ' << t << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}
