#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()

class Fenwick {
private:
	vector <int32_t> data;

public:
	Fenwick(int n) {
		data.assign(n, 0);
	}

	void add(int pos) {
		for (; pos < data.size(); pos |= pos + 1) {
			++data[pos];
		}
	}

	int get(int r) {
		int ans = 0;
		for (--r; r >= 0; r = (r & (r + 1)) - 1) {
			ans += data[r];
		}
		return ans;
	}
};

void solve() {
	int n, m; cin >> n >> m;
	vector <int> t(n), d0(m);
	for (auto& x : t) cin >> x;
	for (auto& x : d0) cin >> x;

	vector <pair <int, int>> d(m);
	d[0] = { d0[0], 1 };
	for (int i = 1; i < m; ++i) {
		d[i] = { d0[i] - d0[i - 1], 1 };
	}

	{
		vector <pair <int, int>> st;
		for (auto [l, c] : d) {
			if (!st.empty() && st.back().first >= l) {
				++st.back().second;
			}
			else {
				st.push_back({ l, 1 });
			}
		}
		d = st;
	}


	vector <int> big = t;
	sort(all(big));
	big.resize(unique(all(big)) - big.begin());
	Fenwick tree(big.size());

	int ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += 2 * m * i;
		for (auto [l, c] : d) {
			int a = t[i] * d.back().first / l;
			int b = t[i] * l / d.back().first;
			int cnt = 0;
			cnt += tree.get(upper_bound(all(big), b) - big.begin());
			cnt += i - tree.get(upper_bound(all(big), a) - big.begin());
			ans -= cnt * c;
		}
		tree.add(lower_bound(all(big), t[i]) - big.begin());

		cout << ans << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}
