#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstdint>
#include <numeric>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()

int calc(vector <int> v) {
	int n = v.size();

	vector <int> r(n);
	for (int i = 0; i < n; ++i) {
		int cl = max(i - v[i], 0ll);
		int cr = min(i + v[i], n - 1) + 1;
		r[cl] = max(r[cl], cr);
	}
	for (int i = 1; i < n; ++i) {
		r[i] = max(r[i], r[i - 1]);
	}

	vector <int> dp(n + 1, 0);
	for (int i = n - 2; i >= 0; --i) {
		dp[i] = dp[r[i]] + n - r[i];
	}

	return accumulate(all(dp), 0ll);
}

void solve() {
	int n, x; cin >> n >> x;
	vector <int> v(n);
	for (auto& x : v) cin >> x;

	if (x >= n / 2) {
		cout << 0;
		return;
	}

	int ans = calc(v);
	if (x == 0) {
		cout << ans;
		return;
	}

	vector <int> r(n);
	for (int i = 0; i < n; ++i) {
		int cl = max(i - v[i], 0ll);
		int cr = min(i + v[i], n - 1) + 1;
		r[cl] = max(r[cl], cr);
	}
	for (int i = 1; i < n; ++i) {
		r[i] = max(r[i], r[i - 1]);
	}

	vector <int> cnt(n);
	vector <int> ln(n);
	for (int i = 0; i < n; ++i) {
		if (r[i] < n) cnt[r[i]] += cnt[i] + 1;
		if (r[i] < n) ln[r[i]] += ln[i] + cnt[i] + 1;
	}


	vector <int> dp(n + 1, 0);
	for (int i = n - 2; i >= 0; --i) {
		dp[i] = dp[r[i]] + n - r[i];
	}

	vector <int> sf(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		sf[i] = sf[i + 1] + dp[i];
	}

	vector <int> l(n, 0);
	for (int i = 0; i < n; ++i) {
		int cl = max(i - v[i], 0ll) - 1;
		int cr = min(i + v[i], n - 1);
		l[cr] = min(l[cr], cl);
	}

	vector <int> rdp(n + 1, 0);
	for (int i = 0; i < n; ++i) {
		rdp[i + 1] = rdp[l[i] + 1] + l[i] + 1;
	}

	vector <int> pr(n + 1, 0);
	for (int i = 0; i < n; ++i) {
		pr[i + 1] = pr[i] + rdp[i + 1];
	}
	

	for (int i = x; i + x < n; ++i) {
		int cur = 0;
		if (v[i + x] == 0) cur = sf[i + x] + (2 * x) * (dp[i + x + 1] + n - (i + x + 1));
		else cur = sf[i + x - 1] + (2 * x - 1) * (dp[i + x + 1] + n - (i + x + 1));

		int a = cnt[i - x], al = ln[i - x];
		int b = cnt[i - x + 1], bl = ln[i - x + 1];
		if (v[i - x] == 0) {
			b -= cnt[i - x] + 1;
			bl -= ln[i - x] + cnt[i - x] + 1;
		}
		a = i - x;
		al = (i - x) * (i - x + 1) / 2;

		cur += al * (n - (i - x)) + a * (i - x) * (dp[i + x + 1] + n - (i + x + 1));
		//cur += bl * (n - (i - x + 1)) + b * (i - x) * (dp[i + x + 1] + n - (i + x + 1));
		//cur += bl;

		cur += pr[i - x];
		
		ans = min(ans, cur);
	}

	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}