#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstdint>
#include <numeric>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()

int calc(vector <int> v) {
	int n = v.size();

	vector <int> r(n);
	for (int i = 0; i < n; ++i) {
		int cl = max(i - v[i], 0ll);
		int cr = min(i + v[i], n - 1) + 1;
		r[cl] = max(r[cl], cr);
	}
	for (int i = 1; i < n; ++i) {
		r[i] = max(r[i], r[i - 1]);
	}

	vector <int> dp(n + 1, 0);
	for (int i = n - 2; i >= 0; --i) {
		dp[i] = dp[r[i]] + n - r[i];
	}

	return accumulate(all(dp), 0ll);
}

void solve() {
	int n, x; cin >> n >> x;
	vector <int> v(n);
	for (auto& x : v) cin >> x;

	int ans = calc(v);

	int l = -1, r = n;
	while (l + 2 < r) {
		int m1 = (l * 2 + r) / 3;
		int m2 = (l + r * 2) / 3;

		int o1 = v[m1];
		v[m1] = x;
		int a1 = calc(v);
		v[m1] = o1;
		int o2 = v[m2];
		v[m2] = x;
		int a2 = calc(v);
		v[m2] = o1;

		if (a1 < a2) r = m2;
		else l = m1;
	}

	for (int i = max(0ll, l); i < min(n - 1, r); ++i) {
		int o = v[i];
		v[i] = x;
		ans = min(ans, calc(v));
		v[i] = o;
	}

	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}