#include <algorithm>
#include <iostream>
#include <vector>

struct Point {
    int x;
    int p;
    int d;
};

constexpr int inf = 1000000000;

int main() {
    int n;
    std::cin >> n;
    std::vector<Point> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i].x >> a[i].p >> a[i].d;
    }
    std::vector<std::vector<int>> dp(n, std::vector<int>(2, inf));
    dp[0][0] = (a[0].d == 1);
    dp[0][1] = (a[0].d == -1);
    for (int i = 1; i < n; i++) {
        if (a[i - 1].p >= a[i].x - a[i - 1].x) {
            dp[i][1] = std::min(dp[i][1], dp[i - 1][1] + (a[i].d == -1));
        }
        if (a[i].p >= a[i].x - a[i - 1].x) {
            dp[i][0] = std::min(dp[i][0], dp[i - 1][0] + (a[i].d == 1));
        }
        if (a[i].p + a[i - 1].p >= a[i].x - a[i - 1].x) {
            dp[i][0] = std::min(dp[i][0], dp[i - 1][1] + (a[i].d == 1));
        }
    }
    if (dp[n - 1][0] == inf && dp[n - 1][1] == inf) {
        std::cout << "-1\n";
    } else {
        std::cout << std::min(dp[n - 1][0], dp[n - 1][1]) << '\n';
    }
    return 0;
}