#include <algorithm>
#include <iostream>
#include <vector>

struct Edge {
    int a;
    int b;
    int t;
};

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> gr(n);
    std::vector<Edge> edges(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        std::cin >> a >> b >> c;
        a--;
        b--;
        edges[i].a = a;
        edges[i].b = b;
        edges[i].t = c;
        gr[a].emplace_back(i);
        gr[b].emplace_back(i);
    }
    std::vector<int> tv(n);
    for (int i = 0; i < n; i++) {
        std::cin >> tv[i];
    }
    bool good = true;
    for (int i = 0; i < m; i++) {
        if (tv[edges[i].a] == tv[edges[i].b] && tv[edges[i].a] != edges[i].t) {
            good = false;
            break;
        }
    }
    if (!good) {
        std::cout << "NO\n";
        return;
    }
    std::vector<int> bade;
    std::vector<int> curst(m, 0);
    std::vector<int> curtv(n, 0);
    for (int i = 0; i < m; i++) {
        if (edges[i].t != curst[i]) {
            bade.emplace_back(i);
        }
    }
    std::vector<std::pair<int, int>> ans;
    good = true;
    std::vector<int> cntch(n);
    while (good && !bade.empty()) {
        int curv = -1;
        for (int v = 0; v < n; v++) {
            bool cgood = true;
            int nwtv = !curtv[v];
            if (nwtv != tv[v]) {
                if (cntch[v] != 0) {
                    cgood = false;
                    continue;
                }
            }
            for (int j : gr[v]) {
                auto [a, b, t] = edges[j];
                if (b == v) {
                    std::swap(a, b);
                }
                if (curtv[b] == nwtv && nwtv != t) {
                    cgood = false;
                }
            }
            if (cgood) {
                // if (curtv[v] == tv[v]) {
                cntch[v]++;
                // }
                curv = v;
                break;
            }
        }
        if (curv == -1) {
            good = false;
            break;
        }
        curtv[curv] = !curtv[curv];
        ans.emplace_back(curv, curtv[curv]);
        for (int j : gr[curv]) {
            auto [a, b, t] = edges[j];
            if (b == curv) {
                std::swap(a, b);
            }
            if (curtv[a] == curtv[b] && curtv[a] == t) {
                curst[j] = curtv[a];
            }
        }
        bade.resize(0);
        for (int i = 0; i < m; i++) {
            if (edges[i].t != curst[i]) {
                bade.emplace_back(i);
            }
        }
    }
    for (int v = 0; v < n; v++) {
        bool cgood = true;
        int nwtv = !curtv[v];
        if (nwtv != tv[v]) {
            continue;
        }
        for (int j : gr[v]) {
            auto [a, b, t] = edges[j];
            if (b == v) {
                std::swap(a, b);
            }
            if (curtv[b] == nwtv && nwtv != t) {
                cgood = false;
            }
        }
        if (cgood) {
            curtv[v] = !curtv[v];
            ans.emplace_back(v, curtv[v]);
        }
    }
    if (bade.empty()) {
        std::cout << "YES\n";
        std::cout << ans.size() << '\n';
        for (auto el : ans) {
            std::cout << el.first + 1 << ' ' << el.second << '\n';
        }
    } else {
        std::cout << "NO\n";
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}