#include <algorithm>
#include <iostream>
#include <vector>

struct Edge {
    int a, b, t;
};

void dfs(int v, int p, const std::vector<std::vector<int>>& gr, const std::vector<Edge>& edges, std::vector<std::pair<int, int>>& ans, const std::vector<int>& tv, std::vector<int>& state) {
    for (int en : gr[v]) {
        auto [a, b, t] = edges[en];
        if (b == v) {
            std::swap(a, b);
        }
        if (b == p) {
            continue;
        }
        if (!t) {
            ans.emplace_back(v, 0);
            state[v] = 0;
        } else {
            ans.emplace_back(v, 1);
            ans.emplace_back(b, 1);
            state[v] = 1;
            state[b] = 1;
        }
        dfs(b, v, gr, edges, ans, tv, state);
        if (tv[v] != state[v]) {
            ans.emplace_back(v, tv[v]);
        }
    }
}

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> gr(n);
    std::vector<Edge> edges(m);
    for (int i = 0; i < m; i++) {
        std::cin >> edges[i].a >> edges[i].b >> edges[i].t;
        edges[i].a--;
        edges[i].b--;
        gr[edges[i].a].emplace_back(i);
        gr[edges[i].b].emplace_back(i);
    }
    std::vector<int> tv(n);
    for (int i = 0; i < n; i++) {
        std::cin >> tv[i];
    }
    bool good = true;
    for (int i = 0; i < m; i++) {
        if (tv[edges[i].a] == tv[edges[i].b] && tv[edges[i].a] != edges[i].t) {
            good = false;
            break;
        }
    }
    if (!good) {
        std::cout << "NO\n";
        return;
    }
    std::vector<std::pair<int, int>> ans;
    std::vector<int> ctv(n, 0);
    dfs(0, 0, gr, edges, ans, tv, ctv);
    std::cout << "YES\n" << ans.size() << '\n';
    for (auto [v, nt] : ans) {
        std::cout << v + 1 << ' ' << nt << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}