#include <algorithm>
#include <iostream>
#include <vector>

struct Edge {
    int a;
    int b;
    int t;
};

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> gr(n);
    std::vector<Edge> edges(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        std::cin >> a >> b >> c;
        a--;
        b--;
        edges[i].a = a;
        edges[i].b = b;
        edges[i].t = c;
        gr[a].emplace_back(i);
        gr[b].emplace_back(i);
    }
    std::vector<int> tv(n);
    for (int i = 0; i < n; i++) {
        std::cin >> tv[i];
    }
    bool good = true;
    for (int i = 0; i < m; i++) {
        if (tv[edges[i].a] == tv[edges[i].b] && tv[edges[i].a] != edges[i].t) {
            good = false;
            break;
        }
    }
    if (!good) {
        std::cout << "NO\n";
        return;
    }
    std::vector<std::pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        ans.emplace_back(i, 1);
    }
    for (int i = 0; i < n; i++) {
        if (!tv[i]) {
            ans.emplace_back(i, 0);
        }
    }
    std::cout << "YES\n" << ans.size() << '\n';
    for (auto [v, vt] : ans) {
        std::cout << v + 1 << ' ' << vt << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}