#include <algorithm>
#include <iostream>
#include <vector>

struct Edge {
    int a, b, t;
};

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> gr(n);
    std::vector<Edge> edges(m);
    for (int i = 0; i < m; i++) {
        std::cin >> edges[i].a >> edges[i].b >> edges[i].t;
        edges[i].a--;
        edges[i].b--;
        gr[edges[i].a].emplace_back(i);
        gr[edges[i].b].emplace_back(i);
    }
    std::vector<int> tv(n);
    for (int i = 0; i < n; i++) {
        std::cin >> tv[i];
    }
    bool good = true;
    for (int i = 0; i < m; i++) {
        if (tv[edges[i].a] == tv[edges[i].b] && tv[edges[i].a] != edges[i].t) {
            good = false;
            break;
        }
    }
    if (!good) {
        std::cout << "NO\n";
        return;
    }
    std::vector<std::pair<int, int>> ans;
    ans.emplace_back(0, 1);
    for (int i = 1; i < n; i++) {
        if (edges[i - 1].t == 1) {
            ans.emplace_back(i, 1);
            if (tv[i] != 1) {
                ans.emplace_back(i, 0);
            }
        }
    }
    if (tv[0] != 1) {
        ans.emplace_back(0, 0);
    }
    // std::cout << "YES\n" << ans.size() << '\n';
    // for (auto [v, vt] : ans) {
    //     std::cout << v + 1 << ' ' << vt << '\n';
    // }
    std::cout << "YES\n-1\n";
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}