#include <algorithm>
#include <iostream>
#include <vector>

struct Edge {
    int a, b, t;
};

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> gr(n);
    std::vector<Edge> edges(m);
    for (int i = 0; i < m; i++) {
        std::cin >> edges[i].a >> edges[i].b >> edges[i].t;
        edges[i].a--;
        edges[i].b--;
        gr[edges[i].a].emplace_back(i);
        gr[edges[i].b].emplace_back(i);
    }
    std::vector<int> tv(n);
    for (int i = 0; i < n; i++) {
        std::cin >> tv[i];
    }
    bool good = true;
    for (int i = 0; i < m; i++) {
        if (tv[edges[i].a] == tv[edges[i].b] && tv[edges[i].a] != edges[i].t) {
            good = false;
            break;
        }
    }
    if (!good) {
        std::cout << "NO\n";
        return;
    }
    std::vector<std::pair<int, int>> ans;
    for (int v = 0; v < n; v++) {
        if (tv[v] == 1) {
            ans.emplace_back(v, 1);
        }
        for (int en : gr[v]) {
            auto [a, b, t] = edges[en];
            if (b == v) {
                std::swap(a, b);
            }
            if (t == 1) {
                ans.emplace_back(b, 1);
                ans.emplace_back(b, 0);
            }
        }
    }
    std::cout << "YES\n" << ans.size() << '\n';
    for (auto [v, nt] : ans) {
        std::cout << v + 1 << ' ' << nt << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}