#include <algorithm>
#include <iostream>
#include <vector>

constexpr int maxn = 262144;

long long tree[2 * maxn];
long long modif[2 * maxn];

void push(int v, int vl, int vr) {
    if (vr - vl != 1) {
        modif[2 * v + 1] += modif[v];
        modif[2 * v + 2] += modif[v];
        tree[2 * v + 1] += ((vl + vr) / 2 - vl) * modif[v];
        tree[2 * v + 2] += (vr - (vl + vr) / 2) * modif[v];
    }
    modif[v] = 0;
}

void add(int v, int vl, int vr, int ql, int qr, long long x) {
    if (vl >= qr || vr <= ql) {
        return;
    }
    if (vl >= ql && vr <= qr) {
        tree[v] += x * (vr - vl);
        modif[v] += x;
        return;
    }
    push(v, vl, vr);
    add(2 * v + 1, vl, (vl + vr) / 2, ql, qr, x);
    add(2 * v + 2, (vl + vr) / 2, vr, ql, qr, x);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

long long getsum(int v, int vl, int vr, int ql, int qr) {
    if (vl >= qr || vr <= ql) {
        return 0;
    }
    if (vl >= ql && vr <= qr) {
        return tree[v];
    }
    push(v, vl, vr);
    return getsum(2 * v + 1, vl, (vl + vr) / 2, ql, qr) + getsum(2 * v + 2, (vl + vr) / 2, vr, ql, qr);
}

int main() {
    int n, m;
    std::cin >> n >> m;
    std::vector<int> t(n);
    std::vector<std::pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> t[i];
        a[i].first = t[i];
        a[i].second = i;
    }
    std::vector<int> s(m);
    for (int i = 0; i < m; i++) {
        std::cin >> s[i];
    }
    std::sort(a.begin(), a.end());
    for (int i = 0; i < n; i++) {
        add(0, 0, maxn, a[i].second + 1, n, m);
    }
    for (int i = 0; i < n; i++) {
        std::cout << getsum(0, 0, maxn, 0, i + 1) << '\n';
    }
    return 0;
}