#include <algorithm>
#include <iostream>
#include <map>
#include <vector>

constexpr long long inf = 1000000000000000000;

long long getf(int n, const std::vector<int>& a) {
    std::vector<std::vector<int>> firstr(n);
    std::vector<int> rcnt(n);
    for (int i = 0; i < n; i++) {
        if (i - a[i] > 0) {
            firstr[i - a[i] - 1].emplace_back(std::min(n - 1, i + a[i]));
        }
        rcnt[std::min(n - 1, i + a[i])]++;
    }
    std::vector<int> nxt(n);
    std::map<int, int> rs;
    for (int i = n - 1; i >= 0; i--) {
        // rs[i] += rcnt[i];
        if (rcnt[i] != 0) {
            rs[i] += rcnt[i];
        }
        for (auto curr : firstr[i]) {
            rs[curr]--;
            if (rs[curr] == 0) {
                rs.erase(curr);
            }
        }
        if (rs.empty()) {
            nxt[i] = i + 1;
        } else {
            nxt[i] = (--rs.end())->first + 1;
        }
    }
    std::vector<long long> add(n, 0);
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        int cnxt = nxt[i];
        if (cnxt != n) {
            add[cnxt] += add[i] + 1;
        }
        ans += add[i] * (cnxt - i);
    }
    return ans;
}

int main() {
    int n, x;
    std::cin >> n >> x;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    long long minres = getf(n, a);
    for (int i = 0; i < n; i++) {
        int oldval = a[i];
        a[i] = x;
        minres = std::min(minres, getf(n, a));
        a[i] = oldval;
    }
    std::cout << minres << '\n';
    return 0;
}