#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5;

vector <pair <int, int>> g[MAXN];

deque <int> leaf;

int color[MAXN], par[MAXN], need[MAXN];

void dfs(int v, int p = 0) {
    int cnt = 0;
    for (auto [to, w] : g[v]) {
        if (to != p) {
            cnt++;
            par[to] = v;
            need[to] = w;
            dfs(to, v);
        }
    }
    if (cnt == 0) {
        leaf.push_back(v);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <int> d(n);
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --b;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    bool flag = true;
    for (int i = 0; i < n; ++i) {
        for (auto [to, w] : g[i]) {
            if (d[i] == 1 && d[to] == 1 && w == 0) {
                flag = false;
            }
            if (d[i] == 0 && d[to] == 0 && w == 1) {
                flag = false;
            }
        }
    }
    if (!flag) {
        cout << "NO" << '\n';
        return;
    }
    vector <pair <int, int>> ans;
    cout << "YES" << '\n';
    while (!leaf.empty()) {
        int v = leaf.front();
        leaf.pop_front();
        if (v != 0) {
            if (need[v] == 1) {
                if (color[v] == 0) {
                    color[v] = 1;
                    ans.push_back({v, 1});
                }
                if (color[par[v]] == 0) {
                    color[par[v]] = 1;
                    ans.push_back({par[v], 1});
                }
            }
            leaf.push_back(par[v]);
        }
        if (color[v] != d[v]) {
            ans.push_back({v, d[v]});
        }
    }
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x << " " << y << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}