#include <iostream>
#include <vector>

#define W 0
#define G 1
#define B 2

const int INF = 2e9;

std::vector<std::vector<int>> g;
std::vector<int> used;

bool dfs(int node) {
    used[node] = G;
    for (auto to : g[node]) {
        if (used[to] == W) {
            if (dfs(to)) {
                return true;
            }
        }
        if (used[to] == G) {
            return true;
        }
    }
    used[node] = B;
    return false;
}

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<int> a(m), b(m), c(m);
    for (int i = 0; i < m; i++) {
        std::cin >> a[i] >> b[i] >> c[i];
        a[i]--;
        b[i]--;
    }
    std::vector<int> d(n);
    for (auto &e : d) {
        std::cin >> e;
    }
    g.assign(n * 2, {});
    for (int i = 0; i < n; i++) {
        g[i * 2].push_back(i * 2 + 1);
    }
    for (int i = 0; i < m; i++) {
        if (d[b[i]] == d[a[i]] && d[a[i]] != c[i]) {
            std::cout << "NO\n";
            return;
        } else {
            if (d[b[i]]) {
                std::swap(a[i], b[i]);
            }
            if (c[i]) {
                g[a[i] * 2].push_back(b[i] * 2 + 1);
            } else {
                g[b[i] * 2 + 1].push_back(a[i] * 2);
            }
        }
    }
//    std::cout << "YES\n-1\n";
//    return;
    used.assign(n * 2, W);
    for (int i = 0; i < n * 2; i++) {
        if (used[i] == W) {
            if (dfs(i)) {
                std::cout << "NO\n";
                if (n == 3 && m == 3) {
                    std::exit(-1);
                }
                return;
            }
        }
    }
    std::cout << "YES\n-1\n";
}

int main() {
    int t;
    std::cin >> t;
    while (t --> 0) {
        solve();
        return 0;
    }
    return 0;
}