// Author: Boris_Ber
#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) (int)(x.size())
#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define ppb pop_back

#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int tmp;

struct edge {
    int v, u;
    bool c;
};

bool fail;
vector<vector<int>> g;
vector<int> used;
vector<int> topsort;

void dfs(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (used[u] == 1) {
            fail = true;
            return;
        }
        if (used[u] == 0) {
            dfs(u);
            if (fail) return;
        }
    }
    used[v] = 2;
    topsort.pb(v);
}

void solve() {
    fail = false;
    int n, m;
    cin >> n >> m;
    vector<edge> e(m);
    vector<bool> on(n);
    g.assign(n, {});
    used.assign(n, 0);
    topsort.clear();
    for (auto &[v, u, c]: e) {
        cin >> v >> u >> c;
        --v;
        --u;
    }
    for (int i = 0; i < n; ++i) {
        cin >> tmp;
        on[i] = tmp;
    }
    for (auto [v, u, c]: e) {
        if (on[v] && on[u] && !c) {
            cout << "NO\n";
            return;
        }
        if (!on[v] && !on[u] && c) {
            cout << "NO\n";
            return;
        }
        if (on[v] && !on[u] && c) {
            g[v].pb(u);
        }
        if (!on[v] && on[u] && c) {
            g[u].pb(v);
        }
        if (on[v] && !on[u] && !c) {
            g[u].pb(v);
        }
        if (!on[v] && on[u] && !c) {
            g[v].pb(u);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(i);
    }
    if (fail) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        reverse(all(topsort));
        vector<pii> ans;
        for (int v: topsort) {
            if (on[v]) {
                ans.eb(v, 1);
                for (int u: g[v]) {
                    ans.eb(u, 1);
                    ans.eb(u, -1);
                }
            } else {
                for (int u: g[v]) {
                    ans.eb(u, 1);
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (on[i]) ans.eb(i, 1);
        }
        cout << sz(ans) << '\n';
        for (auto [f, s]: ans) {
            cout << f + 1 << " " << s << '\n';
        }
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
#endif
    cin >> tt;
    while (tt--) {
        solve();
        // cout << '\n';
    }
    return 0;
}
