#include <bits/stdc++.h>

using namespace std;

void dfs1(int v, int p, int rcolor, const vector<vector<pair<int, int>>> &g, vector<pair<int, int>> &ans, vector<int> &color) {
    for (auto [u, c] : g[v]) {
        if (u != p) {
            dfs1(u, v, c, g, ans, color);
            if (color[v] != c) {
                ans.push_back({v, c});
                color[v] = c;
            }
        }
    }
    if (p != -1) {
        if (color[v] != rcolor) {
            ans.push_back({v, rcolor});
            color[v] = rcolor;
        }
    }
}

void dfs2(int v, int p, const vector<vector<pair<int, int>>> &g, const vector<int> &s, vector<pair<int, int>> &ans, vector<int> &color) {
    if (color[v] != s[v]) {
        ans.push_back({v, s[v]});
        color[v] = s[v];
    }
    for (auto [u, c]:g[v]) {
        if (u != p) {
            dfs2(u, v, g, s, ans, color);
        }
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<vector<int>> colors(n, vector<int>(2, 0));
    int a, b, cc;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> cc;
        a--;
        b--;
        g[a].push_back({b, cc});
        g[b].push_back({a, cc});
        colors[a][cc]++;
        colors[b][cc]++;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [u, c] : g[i]) {
            if (c == 0 && s[u] == 1 && s[i] == 1) {
                cout << "NO\n";
                return;
            }
            if (c == 1 && s[u] == 0 && s[i] == 0) {
                cout << "NO\n";
                return;
            }
        }
    }
    int count_v = n;
    queue<int> q;
    for (int i = 0; i < n; i++) {
        if (colors[i][0] == 0 || colors[i][1] == 0) {
            q.push(i);
        }
    }
    vector<pair<int, int>> ans;
    vector<int> p;
    vector<int> used(n, 0);
    vector<int> c_now(n, 0);
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        if (used[v]) {
            continue;
        }
        used[v] = true;
        p.push_back(v);
        count_v--;
        if (colors[v][0] == 0 && colors[v][1] == 0) {
            continue;
        }
        if (colors[v][0] == 0 && c_now[v] != 1) {
            ans.push_back({v, 1});
            c_now[v] = 1;
        } else {
            if (c_now[v] != 0) {
                ans.push_back({v, 0});
            }
            c_now[v] = 0;
        }
        for (auto [u, c] : g[v]) {
            if (colors[u][c] == 1) {
                q.push(u);
            }
            colors[u][c]--;
            if (c_now[u] != c) {
                ans.push_back({u, c});
                c_now[u] = c;
            }
        }
    }
    if (count_v == 0) {
        cout << "YES\n";
        for (int i = n - 1; i >= 0; i--) {
            if (c_now[p[i]] != s[p[i]]) {
                ans.push_back({p[i], s[p[i]]});
            }
        }
        cout << (int)ans.size() << "\n";
        for (auto [u, c] : ans) {
            cout << u + 1 << " " << c << "\n";
        }
        cout << -1 << "\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}