def count_equal(a, b):
    ans = 0
    for i in range(len(a)):
        if a[i] == b[i]:
            ans += 1
    return ans


def find_only(n, x, p):
    only = [0] * n
    for i in range(n - 1):
        x1, p1 = x[i], p[i]
        x2, p2 = x[i + 1], p[i + 1]
        dist = x2 - x1
        if dist > p1:  # левый не доходит направо
            if dist > p2:  # правый не доходит налево
                if dist > p1 + p2:  # оба не доходят друг к другу
                    return -1
                else:  # <=
                    if only[i] == -1:
                        return -1
                    only[i] = 1
                    only[i + 1] = -1
            else:  # правый доходит налево
                only[i + 1] = -1
        else:  # левый доходит направо
            if dist > p2:  # правый не доходит налево
                if only[i] == -1:
                    return -1
                only[i] = 1
            else:  # оба доходят друг к другу
                pass
    return only


def find_lr(n, only):
    now = 1
    l = -1
    r = n
    for i in range(n):
        if only[i] >= 0 and now == 1:
            if only[i] > 0:
                l = i
            continue
        elif only[i] >= 0 and now == -1:
            return -1
        elif only[i] < 0 and now == 1:
            r = i
            now = -1
        elif only[i] <= 0 and now == -1:
            continue
    return l, r


def solve(n, x, p, d):
    only = find_only(n, x, p)  # 0 если без разницы, -1 если налево, 1 если направо
    if only == -1:
        return -1

    a = find_lr(n, only)
    if a == -1:
        return -1
    l, r = a

    now_d = [1] * (l + 1) + [-1] * (n - l - 1)
    now_ans = n - count_equal(now_d, d)
    min_ans = now_ans
    for i in range(l + 1, r):
        now_d[i] = 1
        if now_d[i] == d[i]:
            now_ans -= 1
        else:
            now_ans += 1
        min_ans = min(min_ans, now_ans)

    return min_ans


if __name__ == '__main__':
    sn = int(input())
    sx, sp, sd = [-1] * sn, [0] * sn, [0] * sn
    for i in range(sn):
        sx[i], sp[i], sd[i] = map(int, input().split())
    print(solve(sn, sx, sp, sd))
