#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n; cin >> n;
	vector<ll> x(n + 2), p(n + 2), d(n + 2);
	for (ll i = 0; i < n; i++) cin >> x[i + 1] >> p[i + 1] >> d[i + 1];
	x[0] = x[1], p[0] = 0, d[0] = 1;
	x[n + 1] = x[n], p[n + 1] = 0, d[n + 1] = -1;
	n += 2;
	vector<bool> canr(n, true), canl(n, true);
	for (ll i = 1; i < n; i++) {
		if (x[i] - x[i - 1] > p[i]) canl[i] = false;
	}
	for (ll i = 0; i < n - 1; i++) {
		if (x[i + 1] - x[i] > p[i]) canr[i] = false;
	}
	for (ll i = 1; i < n; i++) canr[i] = canr[i] && canr[i - 1];
	for (ll i = n - 2; i >= 0; i--) canl[i] = canl[i] && canl[i + 1];
	vector<ll> dp1(n), dp2(n);
	for (ll i = 0; i < n; i++) {
		if (i > 0) dp1[i] = dp1[i - 1];
		if (d[i] == -1) dp1[i]++;
	}
	for (ll i = n - 1; i >= 0; i--) {
		if (i < n - 1) dp2[i] = dp2[i + 1];
		if (d[i] == 1) dp2[i]++;
	}

	ll ans = INF;
	for (ll i = 0; i < n - 1; i++) {
		ll lans = 0;
		if (i > 0 && !canr[i - 1]) continue;
		if (i < n - 2 && !canl[i + 2]) continue;
		lans = dp1[i] + dp2[i + 1];
		ll len = x[i + 1] - x[i];
		if (len > p[i] + p[i + 1]) continue;
		ans = min(ans, lans);
	}
	if (ans == INF) ans = -1;
	cout << ans << endl;
}