#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

vector<vector<ll>> graph;
vector<vector<ll>> graph2;

vector<bool> used;

bool get(ll i) {
	used[i] = true;
	for (auto p : graph2[i]) {
		if (used[p]) return true;
		if (get(p)) return true;
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t; cin >> t;

	while (t--) {
		ll n, m; cin >> n >> m;
		vector<pair<ll, ll>> per(m);
		vector<bool> lightPer(m);
		graph.assign(n, vector<ll>(0));
		vector<bool> light(n);
		for (ll i = 0; i < m; i++) {
			ll a, b, c; cin >> a >> b >> c; a--, b--;
			per[i] = { a, b };
			lightPer[i] = c;
			graph[a].push_back(b);
			graph[b].push_back(a);
		}
		for (ll i = 0; i < n; i++) {
			ll h; cin >> h;
			light[i] = h;
		}
		ll n1 = 0, n2 = 0;
		for (ll i = 0; i < n; i++) {
			if (light[i]) n1++;
			else n2++;
		}
		bool can = true;
		for (ll i = 0; i < m; i++) {
			ll a = per[i].first, b = per[i].second, c = lightPer[i];
			if (light[a] == light[b]) {
				if (light[a] != c) can = false;
			}
		}
		graph2.assign(n, vector<ll>(0));
		for (ll i = 0; i < m; i++) {
			ll a = per[i].first, b = per[i].second, c = lightPer[i];
			if (light[a] == light[b]) continue;
			if (light[b]) swap(a, b);
			if (c) graph2[a].push_back(b);
			else graph2[b].push_back(a);
		}
		used.assign(n, 0);
		for (ll i = 0; i < n; i++) {
			if (!used[i]) if (get(i)) can = false;
		}
		if (can) {
			cout << "YES" << endl;
			cout << -1 << endl;
		}
		else {
			cout << "NO" << endl;
		}
	}
}