#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

struct segmentTree {
	vector<ll> segTree;

	segmentTree(ll n) {
		segTree.resize(4 * n);
	}

	ll get(ll i, ll l, ll r, ll ql, ll qr) {
		if (l >= ql && r <= qr) return segTree[i];
		if (l >= qr || r <= ql) return 0;
		ll m = (l + r) / 2;
		return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
	}

	void add(ll i, ll l, ll r, ll id, ll x) {
		if (r - l == 1) {
			segTree[i] += x;
			return;
		}
		ll m = (l + r) / 2;
		if (id < m) add(i * 2 + 1, l, m, id, x);
		else add(i * 2 + 2, m, r, id, x);
		segTree[i] = segTree[i * 2 + 1] + segTree[i * 2 + 2];
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m; cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++) cin >> t[i];
	for (ll i = 0; i < m; i++) {
		cin >> s[i];
	}
	for (ll i = m - 1; i > 0; i--) {
		s[i] -= s[i - 1];
	}

	vector<ll> pos;
	ll cur = 0;
	for (ll i = 0; i < n; i++) {
		if (s[i] > s[cur]) {
			pos.push_back(cur);
			cur = i;
		}
	}
	pos.push_back(cur);
	pos.push_back(m);

	//pos.assign(m + 1, 0);
	//iota(pos.begin(), pos.end(), 0);
	vector<pair<ll, ll>> por;
	set<pair<ll, pair<ll, ll>>> st;
	segmentTree seg(n);
	segmentTree seg2(n);
	for (ll i = 0; i < n; i++) {
		st.insert({ s[0] * t[i], {i, 0} });
	}
	cur = 0;
	ll alr = 0;
	vector<ll> cl2;
	vector<vector<ll>> ids(n);
	while (!st.empty()) {
		pair<ll, pair<ll, ll>> p = *st.begin();
		st.erase(st.begin());
		ll cnt = pos[p.second.second + 1] - pos[p.second.second];
		por.push_back({ p.second.first, cnt });
		ids[p.second.first].push_back(por.size() - 1);
		alr += cnt;
		//if (cnt != 1) assert(false);
		if (pos[p.second.second + 1] == m) {
			seg2.add(0, 0, n, p.second.first, cnt);
			cur += (n * m) - alr;
		}
		else {
			p.second.second++;
			p.first = s[pos[p.second.second]] * t[p.second.first];
			st.insert(p);
		}
		cl2.push_back(seg2.get(0, 0, n, 0, p.second.first) * cnt);
	}
	vector<ll> cl(por.size());
	for (ll i = por.size() - 1; i >= 0; i--) {
		cl[i] = seg.get(0, 0, n, 0, por[i].first);
		seg.add(0, 0, n, por[i].first, por[i].second);
	}

	vector<ll> ans(n);
	for (ll i = n - 1; i >= 0; i--) {
		ll lans = 0;
		lans = (i + 1) * m * i;
		lans -= cur;
		ans[i] = lans;
		cur -= cl[ids[i].back()];
		for (auto p : ids[i]) cur -= cl2[p];
	}
	for (auto p : ans) cout << p << endl;
}