#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

struct segmentTree {
	vector<ll> segTree;

	segmentTree(ll n) {
		segTree.resize(4 * n);
	}

	ll get(ll i, ll l, ll r, ll ql, ll qr) {
		if (l >= ql && r <= qr) return segTree[i];
		if (l >= qr || r <= ql) return 0;
		ll m = (l + r) / 2;
		return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
	}

	void add(ll i, ll l, ll r, ll id, ll x) {
		if (r - l == 1) {
			segTree[i] += x;
			return;
		}
		ll m = (l + r) / 2;
		if (id < m) add(i * 2 + 1, l, m, id, x);
		else add(i * 2 + 2, m, r, id, x);
		segTree[i] = segTree[i * 2 + 1] + segTree[i * 2 + 2];
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	ll n, m; cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++) cin >> t[i];
	for (ll i = 0; i < m; i++) {
		cin >> s[i];
	}
	for (ll i = m - 1; i > 0; i--) {
		s[i] -= s[i - 1];
	}

	vector<ll> por;
	vector<ll> cl;
	vector<ll> cl2;
	set<pair<ll, pair<ll, ll>>> st;
	vector<bool> end;
	vector<ll> ids(n);
	vector<vector<ll>> ids2(n);
	for (ll i = 0; i < n; i++) {
		st.insert({ s[0] * t[i], {i, 0} });
	}
	ll cur = 0;
	segmentTree seg(n);
	segmentTree seg2(n);
	ll mans = 0;
	while (!st.empty()) {
		pair<ll, pair<ll, ll>> p = *st.begin();
		st.erase(st.begin());
		mans += st.size();
		por.push_back(p.second.first);
		ids[p.second.first] = por.size() - 1;
		ids2[p.second.first].push_back(por.size() - 1);
		if (p.second.second + 1 < m){
			p.second.second++;
			p.first = s[p.second.second] * t[p.second.first];
			st.insert(p);
		} else {
			seg2.add(0, 0, n, p.second.first, 1);
			cur += (n * m) - por.size();
		}
		cl2.push_back(seg2.get(0, 0, n, 0, p.second.first));
	}
	cl.resize(por.size());
	for (ll i = por.size() - 1; i >= 0; i--) {
		cl[i] = seg.get(0, 0, n, 0, por[i]);
		seg.add(0, 0, n, por[i], 1);
	}

	vector<ll> ans(n);
	for (ll i = n - 1; i >= 0; i--) {
		ll lans = 0;
		lans = (i + 1) * m * i;
		lans -= cur;
		ans[i] = lans;
		cur -= cl[ids[i]];
		for (auto p : ids2[i]) cur -= cl2[p];
	}
	for (auto p : ans) cout << p << endl;
}