#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

struct segmentTree {
	vector<ll> segTree;

	segmentTree(ll n) {
		segTree.resize(4 * n);
	}

	ll get(ll i, ll l, ll r, ll ql, ll qr) {
		if (l >= ql && r <= qr) return segTree[i];
		if (l >= qr || r <= ql) return 0;
		ll m = (l + r) / 2;
		return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
	}

	void add(ll i, ll l, ll r, ll id, ll x) {
		if (r - l == 1) {
			segTree[i] += x;
			return;
		}
		ll m = (l + r) / 2;
		if (id < m) add(i * 2 + 1, l, m, id, x);
		else add(i * 2 + 2, m, r, id, x);
		segTree[i] = segTree[i * 2 + 1] + segTree[i * 2 + 2];
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	ll n, m; cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++) cin >> t[i];
	for (ll i = 0; i < m; i++) {
		cin >> s[i];
	}
	for (ll i = m - 1; i > 0; i--) {
		s[i] -= s[i - 1];
	}

	vector<ll> jumps(n);
	ll prev = 0;
	ll cur = 0;
	for (ll i = 0; i < m; i++) {
		if (s[i] > prev) {
			if (cur < i) jumps.push_back(i - cur);
			cur = i;
			prev = s[i];
		}
	}
	jumps.push_back(m - cur);
	ll j1 = cur;
	ll j2 = m - cur;
	for (ll i = 0; i < n; i++) {
		ll ans = (i + 1) * i * j1;
		ans += j2 * (i + 1) * i / 2;
		cout << ans << endl;
	}
}