#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

struct segmentTree {
	vector<ll> segTree;

	segmentTree(ll n) {
		segTree.resize(4 * n);
	}

	ll get(ll i, ll l, ll r, ll ql, ll qr) {
		if (l >= ql && r <= qr) return segTree[i];
		if (l >= qr || r <= ql) return 0;
		ll m = (l + r) / 2;
		return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
	}

	void add(ll i, ll l, ll r, ll id, ll x) {
		if (r - l == 1) {
			segTree[i] += x;
			return;
		}
		ll m = (l + r) / 2;
		if (id < m) add(i * 2 + 1, l, m, id, x);
		else add(i * 2 + 2, m, r, id, x);
		segTree[i] = segTree[i * 2 + 1] + segTree[i * 2 + 2];
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, m; cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++) cin >> t[i];
	for (ll i = 0; i < m; i++) {
		cin >> s[i];
	}
	for (ll i = m - 1; i > 0; i--) {
		s[i] -= s[i - 1];
	}

	vector<ll> por;
	vector<ll> cl;
	vector<ll> cl2;
	set<pair<ll, pair<ll, ll>>> st;
	vector<bool> end;
	vector<ll> ids(n);
	vector<vector<ll>> ids2(n);
	st.insert({ s[0], {1, 0} });
	st.insert({ s[0] * 2, {2, 0} });
	ll cur = 0;
	segmentTree seg(n);
	segmentTree seg2(n);
	dl c1 = 0, c2 = 0, c0 = 0;
	dl c1j2 = 0, c2j1 = 0;
	dl c1j1 = 0, c2j2 = 0;
	dl j1j2 = 0;
	dl j1j1 = 0, j2j2 = 0;
	dl j1 = 0, j2 = 0;
	dl ost1 = 1, ost2 = 1;
	while (!st.empty()) {
		pair<ll, pair<ll, ll>> p = *st.begin();
		st.erase(st.begin());
		if (p.second.second + 1 < m) {
			if (p.second.first == 1) {
				j1j2 += ost2;
				j1j1++;
				j1--;
			}
			else {
				j1j2 += ost1;
				j2j2++;
				j2--;
			}
			p.second.second++;
			p.first = s[p.second.second] * p.second.first;
			st.insert(p);
		}
		else {
			seg2.add(0, 0, n, p.second.first, 1);
			if (p.second.first == 1) ost1 = false;
			else ost2 = false;

			if (p.second.first == 1) {
				j1j2 += ost2;
				j1j1 += 0.5, j1 -= 0.5;
			}
			else {
				j1j2 += ost1;
				j2j2 += 0.5, j2 -= 0.5;
			}
		}
	}

	ll R1 = 0, R2 = 0;
	for (ll i = 0; i < n; i++) {
		if (t[i] == 1) R1++;
		else R2++;
		dl ans = 0;
		ans += j1j1 * (R1 * R1);
		ans += j2j2 * (R2 * R2);
		ans += j1j2 * R1 * R2;
		ans += j1 * R1;
		ans += j2 * R2;
		ans += 0.1;
		ll a = (ll)ans;
		cout << a << endl;
	}
}