#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

struct segmentTree {
	vector<ll> segTree;

	segmentTree(ll n) {
		segTree.resize(4 * n);
	}

	ll get(ll i, ll l, ll r, ll ql, ll qr) {
		if (l >= ql && r <= qr) return segTree[i];
		if (l >= qr || r <= ql) return 0;
		ll m = (l + r) / 2;
		return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
	}

	void add(ll i, ll l, ll r, ll id, ll x) {
		if (r - l == 1) {
			segTree[i] += x;
			return;
		}
		ll m = (l + r) / 2;
		if (id < m) add(i * 2 + 1, l, m, id, x);
		else add(i * 2 + 2, m, r, id, x);
		segTree[i] = segTree[i * 2 + 1] + segTree[i * 2 + 2];
	}
};

ll get(vector<ll>& vec) {
	ll n = vec.size();
	vector<ll> per(n, -1);
	ll maxr = -1;
	for (ll i = 0; i < n; i++) {
		per[max(0ll, i - vec[i])] = max(per[max(0ll, i - vec[i])], i + vec[i] + 1);
	}
	vector<ll> cnt(n, 1);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		if(i > 0) per[i] = max(per[i], per[i - 1]);
		ans += cnt[i] * (n - i);
		if (per[i] < n) cnt[per[i]] += cnt[i];
	}
	ans -= (n * (n - 1)) / 2;
	ans -= n;
	return ans;
	return 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, x; cin >> n >> x;
	vector<ll> vec(n);
	for (ll i = 0; i < n; i++) cin >> vec[i];

	ll ans = get(vec);

	vector<ll> per(n, -1);
	ll maxr = -1;
	for (ll i = 0; i < n; i++) {
		per[max(0ll, i - vec[i])] = max(per[max(0ll, i - vec[i])], i + vec[i] + 1);
	}
	for (ll i = 0; i < n; i++) {
		if (i > 0) per[i] = max(per[i], per[i - 1]);
	}
	segmentTree st(n);
	vector<pair<ll, ll>> vp;
	for (ll i = 0; i < n; i++) st.add(0, 0, n, i, per[i]);
	for (ll i = 0; i < n; i++) {
		ll n1 = st.get(0, 0, n, i - x, i + x);
		ll n2 = (min(n, i + x) - max(0ll, i - x)) * (i + x + 1);
		vp.push_back({ n1 - n2 + abs(i - n / 2), i });
	}
	sort(vp.begin(), vp.end());
	for (ll id = 0; id < min(400ll, n); id++) {
		ll i = vp[id].second;
		if (x <= vec[i]) continue;
		ll p = vec[i];
		vec[i] = x;
		ans = min(ans, get(vec));
		vec[i] = p;
	}

	cout << ans << endl;
}