#include <set>
#include <vector>
#include <algorithm>
#include <map>
#include <iostream>
#include <iomanip>
using namespace std;
#define ll long long
#define int long long
#define debug(x) cerr << (#x) << ": "<<x<< endl;
const int INF = 1e9 + 7;
//#pragma GCC optimize("avx2")
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
struct node {
	int to, c;
};
struct edge {
	int u, v, col;
};
struct to_ans {
	int u, x;
};
int n, m;
vector<to_ans> out;
vector<edge> edges;
vector<vector<node> > gr;
vector<int> color, used;
void solve() {
	cin >> n >> m;
	out.clear();
	edges.clear();
	color = vector<int>(n);
	gr = vector<vector<node> >(n);
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c; u--; v--;
		gr[u].push_back({ v, c });
		gr[v].push_back({ u, c });
		edges.push_back({ u, v, c });
	}
	for (int i = 0; i < n; i++) cin >> color[i];
	for (auto c : edges) {
		int u = c.u, v = c.v, col = c.col;
		if (color[u] != col && color[v] != col) {
			cout << "NO" << endl;
			return;
		}
	}
	used = vector<int>(n, 0);
	for (auto c : edges) {
		int u = c.u, v = c.v, col = c.col;
		if (col == 1) {
			if (used[u] == 0) out.push_back({ u, 1 });
			if (used[v] == 0) out.push_back({ v, 1 });
			used[u] = 1;
			used[v] = 1;
		}
	}
	for (auto c : edges) {
		int u = c.u, v = c.v, col = c.col;
		if (col == 0) {
			if (used[u] == 0 || used[v] == 0) continue;
			if (used[u] == 1) out.push_back({ u, 0 });
			if (used[v] == 1) out.push_back({ v, 0 });
			used[u] = 0;
			used[v] = 0;
		}
	}
	for (int i = 0; i < n; i++) {
		if (used[i] == 1 && color[i] == 0) {
			out.push_back({ i, 0 });
			used[i] = 0;
		}
	}
	for (int i = 0; i < n; i++) {
		if (used[i] == 0 && color[i] == 1) {
			out.push_back({ i, 1 });
			used[i] = 1;
		}
	}
	cout << "YES" << endl;
	cout << out.size() << endl;
	for (auto c : out) cout << c.u + 1 << " " << c.x << endl;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}
/*
1
4 3
1 2 0
2 3 1
3 4 1
0 1 0 1
*/