#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

const ll inf = 1e15;

struct rob {
    ll x, p, d;
};

void solve() {
    ll n;
    cin >> n;

    vector<rob> a(n);
    for (auto &[x, p, d]: a) {
        cin >> x >> p >> d;
    }

    vector<bool> p_cover(n), s_cover(n); // incl
    vector<ll> p_cost(n), s_cost(n);

    p_cover[0] = true;
    p_cost[0] = a[0].d == -1;
    for (ll i = 1; i < n; i++) {
        p_cover[i] = p_cover[i-1] && (a[i-1].x + a[i-1].p >= a[i].x);
        p_cost[i] = p_cost[i-1] + (a[i].d == -1);
    }

    s_cover[n-1] = true;
    s_cost[n-1] = a[n-1].d == 1;
    for (ll i = n - 2; i >= 0; i--) {
        s_cover[i] = s_cover[i+1] && (a[i+1].x - a[i+1].p <= a[i].x);
        s_cost[i] = s_cost[i+1] + (a[i].d == 1);
    }

    ll ans = inf;

    if (p_cover[n-1]) ans = min(ans, p_cost[n-1]);
    if (s_cover[0]) ans = min(ans, s_cost[0]);

    for (ll i = 0; i < n - 1; i++) {
        if (p_cover[i] && s_cover[i+1] && a[i].x + a[i].p + a[i+1].p >= a[i+1].x) {
            ans = min(ans, p_cost[i] + s_cost[i+1]);
        }
    }

    if (ans == inf) cout << -1 << endl;
    else cout << ans << endl;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}
