#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using fl = long double;

const ll inf = 1e15; // sus

ll calc(vector<ll> &a) {
    const ll n = a.size();

    vector<ll> dp(n);

    vector<pll> segs;
    for (ll i = 0; i < n; i++) {
        segs.push_back({max(0ll, i - a[i]), min(n-1, i+a[i])});
    }

    std::sort(segs.begin(), segs.end());
    std::reverse(segs.begin(), segs.end());

    vector<ll> b(n);
    ll rmax = a[0];
    for (ll i = 0; i < n; i++) {
        while (!segs.empty() && segs.back().first <= i) {
            rmax = max(rmax, segs.back().second);
            segs.pop_back();
        }

        b[i] = rmax;
    }

    for (ll i = n - 1; i >= 0; i--) {
        if (b[i] >= n - 1) {
            dp[i] = 0;
        } else {
            dp[i] = dp[b[i] + 1] + (n - b[i] - 1);
        }
    }

    return accumulate(dp.begin(), dp.end(), 0ll);
}

void solve() {
    ll t0 = clock();
    ll n, x;
    cin >> n >> x;

    vector<ll> a(n);
    for (ll &i: a) cin >> i;

    ll ans = calc(a);

    swap(a[n/2], x);
    ans = min(ans, calc(a));
    swap(a[n/2], x);

    mt19937 mt(0xab0ba);

    for (ll it = 0;; it++) {
        if (it % 10 == 0 && clock() - t0 >= ll(fl(CLOCKS_PER_SEC) * 2.9)) break;

        ll ix = uniform_int_distribution<ll>(0, n - 1)(mt);

        if (a[ix] < x) {
            swap(a[ix], x);
            ans = min(ans, calc(a));
            swap(a[ix], x);
        }
    }

    cout << ans << endl;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}
