#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

struct Edge {
	int to, w;
};

vector<vector<Edge>> g;
vector<int> a, tout, used;
vector<vector<int>> g1;
int timer = 0;
void dfs(int v) {
	used[v] = 1;
	for (int to : g1[v]) {
		if (used[to] == 0) {
			dfs(to);
		}
	}
	tout[v] = ++timer;
}

void solve() {
	int n, m;
	cin >> n >> m;
	g.assign(n, {});
	g1.assign(n, {});
	a.assign(n, 0);
	tout.assign(n, 0);
	used.assign(n, 0);
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}
	for (auto& i : a) {
		cin >> i;
	}
	for (int v = 0; v < n; v++) {
		for (Edge e : g[v]) {
			if (a[v] == a[e.to]) {
				if (a[v] != e.w) {
					cout << "NO\n";
					return;
				}
			}
			else {
				if (a[v] == e.w) {
					g1[v].push_back(e.to);
				}
				else {
					g1[e.to].push_back(v);
				}
			}
		}
	}
	for (int v = 0; v < n; v++) {
		if (used[v] == 0) {
			dfs(v);
		}
	}
	for (int v = 0; v < n; v++) {
		for (int to : g1[v]) {
			if (tout[v] < tout[to]) {
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n-1\n";
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
