#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;



struct Segtree {
	int n;
	vector<int> t;
	Segtree(int _n) {
		n = _n;
		t.resize(4 * n);
	}
	void add(int i, int x, int l, int r) {
		if (r - l == 0) {
			t[i] = 1;
			return;
		}
		int m = (l + r) / 2;
		if (i < m) {
			add(i, 2 * x, l, m);
		}
		else {
			add(i, 2 * x + 1, m, r);
		}
	}
	int get(int l, int r, int x, int lx, int rx) {
		if (l >= rx || lx >= r) {
			return 0;
		}
		if (lx >= l && rx <= r) {
			return t[x];
		}
		int mx = (lx + rx) / 2;
		return get(l, r, 2 * x, lx, mx) + get(l, r, 2 * x + 1, mx, rx);
	}
};


vector<int> t, s, x;
int m;
void solve(int n) {
	vector<int> d_x(n);
	set<pair<ll, int>> b;
	for (int i = 0; i < n; i++) {
		b.insert({ (ll)x[0] * t[i], i });
		
	}
	
	vector<ll> ans(n);
	vector<int> cnt(n);
	for (int i = 0; i < n; i++) {
		cnt[i] = i + 1;
	}
	int timer = 0;
	vector<int> last_upd(n);
	while (!b.empty()) {
		int win = (*b.begin()).second;
		d_x[win]++;
		//ans += ll(b.size()) - 1;
		timer++;
		b.erase(b.begin());
		if (d_x[win] != m) {
			b.insert({ (ll)x[d_x[win]] * t[win], win });
		}
		else {
			for (int i = win; i < n; i++) {
				cnt[i]--;
				ans[i] += (ll)(timer - last_upd[i]) * cnt[i];
				last_upd[i] = timer;
			}
		}
	}
	for (ll i : ans) {
		cout << i << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n;
	cin >> n >> m;
	t.resize(n);
	s.resize(m);
	x.resize(m);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> s[i];
	}
	x[0] = s[0];
	for (int i = 0; i < m - 1; i++) {
		x[i + 1] = s[i + 1] - s[i];
	}
	solve(n);
}