#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 4e18;

int n;
ll solve(vector<int>& a) {
	vector<ll> dp(n);
	vector<vector<int>> L(n), R(n);
	for (int i = 0; i < n; i++) {
		L[max(0, i - a[i])].push_back(i);
		R[min(n - 1, i + a[i])].push_back(i);
	}
	vector<int> maxr(n);
	set<pair<int, int>> open;
	for (int i = n - 1; i >= 0; i--) {
		for (int idx : R[i]) {
			open.insert({ i, idx });
		}
		maxr[i] = (*(--open.end())).first;
		for (int idx : L[i]) {
			open.erase({ min(n - 1, idx + a[idx]), idx });
		}
	}
	vector<int> cnt(n);
	cnt[maxr[0]]++;
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		dp[i + 1] = dp[i] + cnt[i];
		ans += dp[i + 1];
		cnt[maxr[i + 1]] += cnt[i] + 1;
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> a1 = a;
	ll ans = solve(a);
	for (int i = 0; i < n; i++) {
		if (x > a[i]) {
			a1[i] = x;
			ans = min(ans, solve(a1));
			a1[i] = a[i];
		}
	}
	cout << ans;
}