#include <bits/stdc++.h>

using namespace std;

bool bad = false;

vector<vector<pair<int, int>>> g;
vector<int> col;

void dfs(int v) {
    col[v] = 1;
    for (auto [to, _] : g[v]) {
        if (col[to] == 1) {
            bad = true;
            return;
        } else if (col[to] == 0) {
            dfs(to);
        }
    }
    col[v] = 2;
}

vector<int> ord, used;

void dfs2(int v) {
    used[v] = 1;
    for (auto [u, _] : g[v]) {
        if (!used[u]) {
            dfs2(u);
        }
    }
    ord.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    col.assign(n, 0);
    vector<tuple<int, int, int>> e;
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c, v--, u--;
        if (v > u) {
            swap(v, u);
        }
        e.emplace_back(v, u, c);
    }
    vector<int> want(n);
    for (int i = 0; i < n; i++) {
        cin >> want[i];
    }
    for (auto &[v, u, c] : e) {
        if (want[v] == 1 - c && want[u] == 1 - c) {
            cout << "NO\n";
            return;
        }
        if (want[v] != want[u]) {
            if (want[v] == 0) {
                swap(v, u);
            }
            if (c == 1) {
                g[v].emplace_back(u, c);
            } else {
                g[u].emplace_back(v, c);
            }
        }
    }
    bad = false;
    for (int v = 0; v < n; v++) {
        dfs(v);
        if (bad) {
            cout << "NO\n";
            return;
        }
    }
    ord.clear();
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs2(i);
        }
    }
    vector<pair<int, int>> ans;

    vector<int> cur(n);
    auto apply = [&](int v, int x) {
        if (cur[v] != x) {
            cur[v] = x;
            ans.emplace_back(v, x);
        }
    };

    for (int i = 0; i < n; i++) {
        apply(i, want[i]);
    }

    for (auto [v, u, c] : e) {
        if (want[v] != want[u]) {
            if (c == 0) {
                apply(v, 0);
                apply(v, 1);
            } else {
                apply(u, 1);
                apply(u, 0);
            }
        }
    }
    reverse(ord.begin(), ord.end());
    for (int v : ord) {
        for (auto [u, c] : g[v]) {
            if (c == 0) {
                if (want[u] == 1) {
                    apply(u, 0);
                    apply(u, 1);
                } else {
                    apply(v, 0);
                    apply(v, 1);
                }
            } else {
                if (want[u] == 0) {
                    apply(u, 1);
                    apply(u, 0);
                } else {
                    apply(v, 1);
                    apply(v, 0);
                }
            }
        }
    }

    cout << "YES\n" << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*

5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

 */