#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
 
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(x) (int)(x).size()
#define ff first 
#define sc second
 
struct segtree{
    int n; 
    vector<int> t, x;
    segtree() = default;
    segtree(vector<int> x_) {
        x=x_;
        n = x.size();
        t.assign(4 * n, 0);
        build(1, 0, n);
    }
 
    void build(int v, int tl, int tr) {
        if (tl + 1 == tr) {
            t[v] = x[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v* 2, tl, tm);
        build(v*2+1,tm,tr);
        t[v] = t[v*2]+t[v*2+1];
    }
 
    void upd(int v,int tl,int tr,int p,int vl) {
        if (tl+1==tr){
            t[v]=vl;
            return;
        }
        int tm = (tl + tr) / 2;
        if(p<tm)upd(v*2,tl,tm,p,vl);
        else upd(v*2+1,tm,tr,p,vl);
        t[v]=t[v*2]+t[v*2+1];
    }
 
    int getl(int v,int tl,int tr,int l,int r) {
        if (tr <= l || tl >= r) return -1;
        if(tl+1==tr){
            return (t[v]==1?tl:-1);
        }
        int tm = (tl+tr)/2;
        int rs=getl(v*2+1,tm,tr,l,r);
        if(rs==-1)return getl(v*2,tl,tm,l,r);
        else return rs;
    }   
 
    int sum(int v, int tl, int tr, int l, int r) {
        if(tr<=l||tl>=r)return 0;
        if (l<=tl&&tr<=r)return t[v];
        int tm = (tl+tr)/2;
        return sum(v*2,tl,tm,l,r)+sum(v*2+1,tm,tr,l,r);
    }
};  

struct node {
    int mn, cnt, push;
    node() = default;
    node(int mn_, int cntmn_) {
        mn = mn_;
        cnt=  cntmn_;
        push=0;
    }
};  

node operator+(node a, node b) {
    if (a.mn < b.mn) return a;
    if (b.mn < a.mn) return b;
    return node(a.mn, a.cnt+b.cnt);
}

struct segtree2 {
    int n;
    vector<node> t;
    vector<int> TL, TR;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.resize(4 * n);
        TL.assign(4 * n, 0);
        TR.assign(4 * n, 0);
        build(1, 0, n);
    }
    void build(int v, int tl, int tr) {
        TL[v] = tl;
        TR[v] = tr;
        t[v] = node(0, tr - tl);
        if (tl + 1 == tr) return;
        int tm = (tl + tr) / 2;
        build(v*2,tl,tm);
        build(v * 2 + 1, tm, tr);
    }
    void push(int v) {
        if(t[v].push > 0) {
            t[v].mn += t[v].push;
            if (TL[v] + 1 < TR[v]) {
                t[v * 2].push += t[v].push;
                t[v * 2 + 1].push += t[v].push;
            }
            t[v].push = 0;
            return;
        }
        if (TL[v] + 1 == TR[v]) return;
        int mnl = t[v*2].mn+t[v*2].push,ccl = t[v*2].cnt;
        int mnr = t[v*2+1].mn+t[v*2+1].push,ccr = t[v*2+1].cnt;
        if(mnl<mnr){
            t[v]=node(mnl,ccl);
        } else if (mnr<mnl){
            t[v]=node(mnr, ccr);
        } else {
            t[v] = node(mnr,ccl+ccr);
        }
    }

    void upd(int v, int tl, int tr, int l, int r, int val) {
        push(v);
        if (l <= tl && tr <= r) {
            t[v].push += val;
            return;
        }
        if (tr <= l || tl >= r) return;
        int tm = (tl + tr) / 2;
        upd(v * 2, tl, tm, l, r, val);
        upd(v * 2 + 1, tm, tr, l, r, val);
        push(v);
    }

    pair<int, int> comp(pair<int, int> x, pair<int, int> y) {
        return (x.ff < y.ff ? x : make_pair(y.ff, y.sc+(x.ff==y.ff)*x.sc));
    }   

    pair<int, int> get(int v, int tl, int tr, int l, int r) {
        push(v);
        if (l <= tl && tr <= r) {
            return {t[v].mn,t[v].cnt};
        }
        if (tr <= l || tl >= r) return {1e9, 0};
        int tm = (tl + tr)/ 2;
        return comp(get(v*2,tl,tm,l,r),get(v*2+1,tm,tr,l,r));
    }
};
 
void solve() {
    int n, x; cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
 
    vector<int> nxt(n);
    vector<vector<pair<int, int>>> ev(n + 1);
    for (int i = 0; i < n; i++) {
        ev[max(0, i - a[i])].pb({min(n - 1, i + a[i]), 1});
        ev[min(n - 1, i + a[i]) + 1].pb({-1,-1});
    }
    vector<pair<int, int>> nx(n);
    multiset<int> R;
    for (int i = 0; i < n; i++) {
        for (auto &u : ev[i]) {
            if (u.first == -1) R.erase(R.find(i - 1));
            else R.insert(u.first);
        }
 
        nxt[i] = (*R.rbegin()) + 1;
        nx[i]={nxt[i],i};
    }
    sort(all(nx));
    segtree sg(vector<int>(n, 1));
    int ind=n-1;
 
    vector<vector<int>> segs;
    for (int i = n - 1; i >= 0;i--){
        int lf = max(0, i - x), rg = min(n - 1, i + x);
        while(ind>=0&&nx[ind].first==rg+1){
            sg.upd(1,0,n,nx[ind].second,0);
            ind--;   
        }
        if (sg.sum(1,0,n,lf,rg+1)){
            segs.pb({lf, sg.getl(1, 0, n, lf, rg + 1), rg + 1});
        }
    }
    reverse(all(segs));
 
    ll ans = 0;
    vector<int> siz(n + 1, 1);
    for (int j = 0; j < n; j++) {
        ans += (siz[j]-1) * 1ll * (n - j);
        siz[nxt[j]] += siz[j];
    }
    ll A = ans;

    vector<vector<int>> g(n+1);
    for (int i = 0; i < n; i++) {
        //cout<<nxt[i]<<' ';
        g[nxt[i]].pb(i);
    }
    //cout<<'\n';
    vector<ll> pref(n+1,0);
    vector<int> ord;
    auto dfs = [&](int v, auto&&dfs) -> void {
        ord.pb(v);
        for (auto &u : g[v]) {
            pref[u] = pref[v] + n - v;
            dfs(u, dfs);
        }
        ord.pb(v);
    };  
    dfs(n, dfs);
    vector<pair<int, int>> pos(n +1,{-1,-1});
    for (int i = 0; i < 2 * (n+1); i++) {
        if(pos[ord[i]].first==-1)pos[ord[i]].first=i;
        else pos[ord[i]].second = i;
    }   
    segtree2 sg2(2*(n+1));

    auto add = [&](int v) {
        //cout << "add " << v << '\n';
        auto rs = sg2.get(1,0,2*(n+1), pos[v].first,pos[v].second+1);
        if(rs.first>0){
            sg2.upd(1,0,2*(n+1), pos[v].ff, pos[v].sc+1,1);
            return;
        }
        ans -= pref[v] * 1ll * rs.second / 2;
        //cout << "minuss " << ' ' << pref[v] * 1ll * rs.second / 2 << '\n';
        sg2.upd(1,0,2*(n+1), pos[v].ff, pos[v].sc+1,1);
    };

    auto del = [&](int v) {
        //cout << "del " << v << '\n';
        sg2.upd(1,0,2*(n+1), pos[v].ff, pos[v].sc+1,-1);
        auto rs = sg2.get(1,0,2*(n+1), pos[v].first,pos[v].second+1);
            ans += pref[v] * 1ll * rs.second / 2;
            //cout << "pluss " << pref[v] * 1ll * rs.second / 2;
    };

    int curl = 0, curr = -1;
    for (auto &u : segs) {
        // vector<int> neww=nxt;
        // for (int j = u[0];j<=u[1];j++)neww[j]=u[2];
        // int aa=0;
        // siz.assign(n + 1, 1);
        // for (int j = 0; j < n; j++) {
        //     aa += (siz[j]-1) * (n - j);
        //     siz[neww[j]] += siz[j];
        // }
        //cout << u[0] << ' ' << u[1] << ' ' << u[2] << " seg\n";
        //cout<<aa<<' ';
        for (int j = curl; j <= min(u[0] - 1, curr); j++) del(j);
        for(int j = max(curr + 1, u[0]); j <= u[1]; j++) add(j);
        curl = u[0];
        curr = u[1];
        auto rs = sg2.get(1, 0, 2 * n, 0, 2 * n);
        int cntt = (rs.first == 0 ? n + 1 - rs.second / 2: n + 1);
        //cout << ans <<' '<<cntt<<' '<<(pref[u[2]] + (n - u[2])) * 1ll * cntt << '\n';
        A = min(A, ans + (pref[u[2]] + (n - u[2])) * 1ll * cntt);
        //cout<<ans + (pref[u[2]] + (n - u[2])) * 1ll * cntt<<'\n';
    }
 
    cout << A << '\n';
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
 
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}