#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
using db = double;
using pii = pair<int, int>;
using vint = vector<int>;
using vll = vector<ll>;

const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;

struct DO {
	int n;
	vint tree, lazy;
	DO(int n_) {
		n = n_;
		tree.resize(4 * n);
		lazy.resize(4 * n, -1);
	}
	void push(int v, int vl, int vr) {
		tree[v] = max(tree[v], lazy[v]);
		if (vl != vr) {
			lazy[v * 2 + 1] = max(lazy[v * 2 + 1], lazy[v]);
			lazy[v * 2 + 2] = max(lazy[v * 2 + 2], lazy[v]);
		}
		lazy[v] = -1;
	}
	int query(int v, int vl, int vr, int pos) {
		push(v, vl, vr);
		if (vl == vr)
			return tree[v];
		int vm = (vl + vr) / 2;
		if (pos <= vm)
			return query(v * 2 + 1, vl, vm, pos);
		return query(v * 2 + 2, vm + 1, vr, pos);
	}
	int query(int pos) {
		return query(0, 0, n - 1, pos);
	}
	void update(int v, int vl, int vr, int l, int r, int val) {
		push(v, vl, vr);
		if (l <= vl && vr <= r) {
			lazy[v] = val;
			push(v, vl, vr);
			return;
		}
		if (r < vl || vr < l)
			return;
		int vm = (vl + vr) / 2;
		update(v * 2 + 1, vl, vm, l, r, val);
		update(v * 2 + 2, vm + 1, vr, l, r, val);
	}
	void update(int l, int r, int val) {
		update(0, 0, n - 1, l, r, val);
	}
};
int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cout << fixed; cout.precision(8);
	int n, x;
	ll ans = 0;
	cin >> n >> x;
	vint a(n), r(n), sm(n + 1);
	DO do_(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		int lg = max(0, i - a[i]), rg = min(n - 1, i + a[i]);
		do_.update(lg, rg, rg);
	}
	vint k;
	for (int i = 0; i < n; ++i)
		r[i] = do_.query(i);
	int i = 0;
	while (i < n) {
		k.push_back(r[i] - i + 1);
		i = r[i] + 1;
	}
	for (int i = n - 1; i >= 0; --i) {
		sm[i] = sm[r[i] + 1] + n - (r[i] + 1);
		ans += sm[i];
	}
	cout << ans;
}