#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e12;

ll nxt2deg(ll n) {
    ll x = 1;
    while (x < n) x <<= 1;
    return x;
}

struct ST {
    ll n;
    vector<ll> lazy;
    vector<ll> t;

    ST(ll n_): n(nxt2deg(n_)), t(2 * n - 1, inf), lazy(2 * n - 1, inf) {}

    void push(ll i, ll il, ll ir) {
        if (lazy[i] >= inf) return;

        if (ir - il > 1) {
            lazy[2 * i + 1] = min(lazy[2 * i + 1], lazy[i]);
            t[2 * i + 1] = min(t[2 * i + 1], lazy[i]);
            lazy[2 * i + 2] = min(lazy[2 * i + 2], lazy[i]);
            t[2 * i + 2] = min(t[2 * i + 2], lazy[i]);
        }

        lazy[i] = inf;
    }

    ll get(ll l, ll r, ll i = 0, ll il = 0, ll ir = -1) {
        if (ir == -1) ir = n;
        push(i, il, ir);
//        cout << l << " " << r << " / " << t[i] << " " << il << " " << ir << endl;
        if (ir <= l || r <= il) return inf;
        if (l <= il && ir <= r) {
            return t[i];
        }

        ll im = (ir + il) / 2;
        return min(get(l, r, 2 * i + 1, il, im), get(l, r, 2 * i + 2, im, ir));
    }

    ll put(ll l, ll r, ll x, ll i = 0, ll il = 0, ll ir = -1) {
        if (ir == -1) ir = n;
        push(i, il, ir);
        if (ir <= l || r <= il) return inf;
        if (l <= il && ir <= r) {
            lazy[i] = min(lazy[i], x);
            return t[i] = min(t[i], x);
        }

        ll im = (ir + il) / 2;
        put(l, r, x, 2 * i + 1, il, im);
        put(l, r, x, 2 * i + 2, im, ir);
        return t[i] = min(t[2 * i + 1], t[2 * i + 2]);
    }
};

ll lastpos(ll x0, vector<pair<ll, ll>>& pts) {
    ll l = 0;
    ll r = pts.size();
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (pts[m].first <= x0) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}
ll firstpos(ll x0, vector<pair<ll, ll>>& pts) {
    ll l = -1;
    ll r = pts.size() - 1;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (pts[m].first < x0) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int main() {
    ll n;
    cin >> n;
    vector<ll> x(n);
    vector<ll> p(n);
    vector<ll> d(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }
    ll xmax = x.back();

    vector<pair<ll, ll>> pts;
    for (ll i = 0; i < n; ++i) {
        pts.push_back({x[i], i});
        pts.push_back({max(0ll, min(xmax, x[i] + p[i] * d[i])), inf});
        pts.push_back({max(0ll, min(xmax, x[i] - p[i] * d[i])), inf});
    }
    sort(pts.begin(), pts.end());
    n = pts.size();

    ST q0(n);
    ST q1(n);
    q0.put(0, 1, 0);
    q1.put(0, 1, 0);
    q0.put(0, lastpos(x[0] + abs(d[0] * p[0]), pts) + 1, (d[0] != 1));

    for (ll i = 1; i < n; ++i) {
        q1.put(i, i + 1, q0.get(i, i + 1));
        if (pts[i].second < inf) {
            ll ind = pts[i].second;
            q1.put(firstpos(x[ind] - abs(d[ind] * p[ind]), pts), i, q0.get(i, i + 1) + (d[ind] != -1));

            ll i0 = firstpos(x[ind] - abs(d[ind] * p[ind]), pts);
            q1.put(i, i + 1, q1.get(i0, i) + (d[ind] != -1));

            q0.put(i + 1, lastpos(x[ind] + abs(d[ind] * p[ind]), pts) + 1, q0.get(i, i + 1) + (d[ind] != 1));
        }
//        for (ll i = 0; i < n; ++i) {
//            cout << q0.get(i, i + 1) << " ";
//        }
//        cout << endl;
//        for (ll i = 0; i < n; ++i) {
//            cout << q1.get(i, i + 1) << " ";
//        }
//        cout << endl;
//        cout << "~~~~~~~~~~~~~~\n";
//        cout << i << " : " << pts[i].first << " " << pts[i].second << " / " << q0.get(i, i + 1) << " " << q1.get(i, i + 1) << endl;
    }

//    cout << "!" << firstpos(x.back(), pts) << ">" << n << endl;
//    for (auto i : q1.t) {
//        cout << i << " ";
//    }
//    cout << endl;
    q1.get(firstpos(x.back(), pts), n);
//    cout <<
    cout << ((q1.get(firstpos(x.back(), pts), n) < inf) ? q1.get(firstpos(x.back(), pts), n) : -1) << endl;
    return 0;
}
