#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e12;

bool dfs(ll v, vector<bool>& used, vector<vector<ll>>& adj, vector<ll>& tops) {
    if (used[v]) return false;
    used[v] = true;
    bool ok = true;
    for (ll u : adj[v]) {
        ok = ok && dfs(u, used, adj, tops);
    }
    tops.push_back(v);
    return ok;
}

void solve() {
    ll n, m;
    cin >> n >> m;
//    adj.resize(n, {});

    vector<pair<ll, ll>> edges(m);
    vector<int> c(m);
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e].first;
        ll& b = edges[e].second;
        cin >> a >> b >> c[e];
        --a;
        --b;
    }

    vector<int> d(n);
    for (ll v = 0; v < n; ++v) {
        cin >> d[v];
    }

    vector<bool> strict(m, false);
    bool ok = true;
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e].first;
        ll& b = edges[e].second;
        strict[e] = (d[a] == d[b]);
        if (strict[e] && c[e] != d[a]) {
            cout << "NO\n";
            return;
        }
    }

    vector<vector<ll>> toggle_after(n);
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e].first;
        ll& b = edges[e].second;
        if (!strict[e]) {
            if (c[e] == d[a]) {
                toggle_after[a].push_back(b);
            } else {
                toggle_after[b].push_back(a);
            }
        }
    }

    vector<ll> tops;
    vector<bool> used(n, false);
    for (ll v = 0; v < n; ++v) {
        if (used[v]) continue;
        if (!dfs(v, used, toggle_after, tops)) {
            cout << "NO\n";
            return;
        }
    }
//    for (auto v : tops) cout << v << " ";
//    cout << endl;
    vector<pair<ll, ll>> ans;
    for (ll v = 0; v < n; ++v) {
        ans.push_back({v + 1, 1 - d[v]});
    }
    for (ll i = tops.size() - 1; i >= 0; --i) {
        ans.push_back({tops[i] + 1, d[tops[i]]});
    }

    cout << "YES\n";
    cout << ans.size() << endl;
    for (auto act : ans) {
        cout << act.first << " " << act.second << endl;
    }
}

int main() {
    ll t;
    cin >> t;
    while (t--) solve();
    return 0;
}
