#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e12;

bool dfs(ll v, vector<bool>& used, vector<vector<ll>>& adj, vector<ll>& tops) {
    if (used[v]) return false;
    used[v] = true;

    for (ll u : adj[v]) {
        if (dfs(u, used, adj, tops) == false) return false;
    }
    tops.push_back(v);
    return true;
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<vector<ll>> edges(m, vector<ll>(3));
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e][0];
        ll& b = edges[e][1];
        ll& c = edges[e][2];
        cin >> a >> b >> c;
        --a;
        --b;
    }

    vector<int> d(n);
    for (ll v = 0; v < n; ++v) {
        cin >> d[v];
    }

    vector<bool> strict(m, false);
    bool ok = true;
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e][0];
        ll& b = edges[e][1];
        ll& c = edges[e][2];
        strict[e] = (d[a] == d[b]);
        if (strict[e] && c != d[a]) {
            cout << "NO\n";
            return;
        }
    }

    vector<bool> evert(n);
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e][0];
        ll& b = edges[e][1];
        ll& c = edges[e][2];
        if (c) {
            evert[a] = evert[b] = true;
        }
    }
    for (ll v = 0; v < n; ++v) {
        if (d[v]) evert[v] = true;
    }

    vector<vector<ll>> toggle_after(n);
    for (ll e = 0; e < m; ++e) {
        ll& a = edges[e][0];
        ll& b = edges[e][1];
        ll& c = edges[e][2];
        if (!strict[e] && evert[a] && evert[b]) {
            if (c == d[a]) {
                toggle_after[a].push_back(b);
            } else {
                toggle_after[b].push_back(a);
            }
        }
    }

    vector<ll> tops;
    vector<bool> used(n, false);
    for (ll v = 0; v < n; ++v) {
        if (evert[v] == false) continue;
        if (used[v]) continue;
        if (dfs(v, used, toggle_after, tops) == false) {
            cout << "NO\n";
            return;
        }
    }

    vector<pair<ll, ll>> ans;
    for (ll v = 0; v < n; ++v) {
        if (evert[v] == false) continue;
        ans.push_back({v + 1, 1 - d[v]});
    }
    for (ll i = tops.size() - 1; i >= 0; --i) {
        ll v = tops[i];
        ans.push_back({v + 1, d[v]});
    }

    cout << "YES\n";
    cout << ans.size() << endl;
    for (auto act : ans) {
        cout << act.first << " " << act.second << endl;
    }
}

int main() {
    ll t;
    cin >> t;
    while (t--) solve();
    return 0;
}
