#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

vector<int> pref;

int getleft(int l, int r) {
	int len = r - l + 1;
	return len - (pref[r + 1] - pref[l]);
}

int getright(int l, int r) {
	return pref[r + 1] - pref[l];
}

inline void solve() {
	int n;
	cin >> n;
	vector<int> x(n), p(n), d(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> p[i] >> d[i];
	int ans = n + 1;
	{
		int cnt = 0;
		bool ok = true;
		for (int i = 1; i < n; i++) {
			if (p[i] < x[i] - x[i - 1])
				ok = false;
			if (d[i] == 1)
				cnt++;
		}
		if (ok)
			ans = min(ans, cnt);
	}
	{
		int cnt = 0;
		bool ok = true;
		for (int i = 0; i < n - 1; i++) {
			if (p[i] < x[i + 1] - x[i])
				ok = false;
			if (d[i] == -1)
				cnt++;
		}
		if (ok)
			ans = min(ans, cnt);
	}
	vector<int> badri(n), badle(n);
	badri[0] = p[0] < x[1] - x[0];
	for (int i = 1; i < n; i++) {
		badri[i] = badri[i - 1];
		if (i < n - 1)
			badri[i] += p[i] < x[i + 1] - x[i];
	}
	badle[n - 1] = p[n - 1] < x[n - 1] - x[n - 2];
	for (int i = n - 2; i > -1; i--) {
		badle[i] = badle[i + 1];
		if (i)
			badle[i] += p[i] < x[i] - x[i - 1];
	}
	pref.resize(n + 1);
	for (int i = 0; i < n; i++)
		pref[i + 1] = pref[i] + (d[i] == 1);
	for (int i = 0; i < n - 1; i++) {
		if (i && badri[i - 1])
			continue;
		if (i < n - 2 && badle[i + 2])
			continue;
		if (x[i + 1] - x[i] > p[i] + p[i + 1])
			continue;
		ans = min(ans, getleft(0, i) + getright(i + 1, n - 1));
	}
	if (ans == n + 1)
		ans = -1;
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
