#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const int N = 1e5;
const int M = 2e5;
int c[M], d[N];
vector<pii> g[N];
bool used[N];
int cur[N];
int curEdge[M];

bool check(int n, int m, vector<int>& seq) {
	for (int i = 0; i < n; i++)
		cur[i] = 0;
	for (int i = 0; i < m; i++)
		curEdge[i] = 0;
	for (int v : seq) {
		cur[v] ^= 1;
		for (pii e : g[v]) {
			int u = e.first, i = e.second;
			if (cur[v] == cur[u])
				curEdge[i] = cur[v];
		}
	}
	for (int i = 0; i < n; i++)
		if (d[i] ^ cur[i])
			return false;
	for (int i = 0; i < m; i++)
		if (c[i] ^ curEdge[i])
			return false;
	return true;
}

void print(int n, vector<int> &seq) {
	for (int i = 0; i < n; i++)
		cur[i] = 0;
	vector<int> col(n);
	for (int i = 0; i < n; i++)
		g[i].clear();
	cout << "YES\n";
	cout << -1 << '\n';
	return;
	cout << seq.size() << '\n';
	for (int v : seq) {
		cout << v + 1 << ' ' << (col[v] ^ 1) << '\n';
		col[v] ^= 1;
	}
}

vector<int> seq, ord;

void dfs(int v, int pr = -1) {
	used[v] = true;
	vector<pii> ch;
	for (pii e : g[v])
		if (!used[e.first] && pr != e.first) {
			dfs(e.first, v);
			ch.push_back(e);
		}
	seq.push_back(v);
	cur[v] = 1;
	for (pii e : ch) {
		int u = e.first, i = e.second;
		if (c[i]) {
			seq.push_back(u);
			cur[u] = 1;
		}
	}
	seq.push_back(v);
	cur[v] = 0;
	ord.push_back(v);
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u >> c[i];
		v--;
		u--;
		g[v].push_back({ u, i });
		g[u].push_back({ v, i });
	}
	for (int i = 0; i < n; i++)
		cin >> d[i];
	for (int v = 0; v < n; v++)
		for (pii e : g[v]) {
			int u = e.first, i = e.second;
			if (d[v] && d[u] && !c[i]) {
				cout << "NO\n";
				for (i = 0; i < n; i++)
					g[i].clear();
				return;
			}
			if (!d[v] && !d[u] && c[i]) {
				cout << "NO\n";
				for (i = 0; i < n; i++)
					g[i].clear();
				return;
			}
		}
	for (int v = 0; v < n; v++)
		if (!used[v])
			dfs(v);
	for (int i = 0; i < n; i++)
		used[i] = false;
	reverse(all(ord));
	for (int v : ord)
		if (d[v] ^ cur[v]) {
			cur[v] = d[v];
			seq.push_back(v);
		}
	if (!check(n, m, seq)) {
		cout << "NO\n";
		seq.clear();
		ord.clear();
		for (int i = 0; i < n; i++)
			cur[i] = 0;
		for (int i = 0; i < n; i++)
			g[i].clear();
		for (int i = 0; i < m; i++)
			curEdge[i] = 0;
		return;
	}
	print(n, seq);
	seq.clear();
	ord.clear();
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
