#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const int N = 1e5;
const int M = 2e5;
vector<pii> g[N];
int c[M], d[N];
int cur[N];

vector<int> seq;
vector<int> ord;

void clear(int n) {
	seq.clear();
	ord.clear();
	for (int i = 0; i < n; i++)
		g[i].clear();
	for (int i = 0; i < n; i++)
		cur[i] = 0;
}

void add(int v) {
	seq.push_back(v);
	cur[v] ^= 1;
}

void dfs(int v, int pr = -1) {
	for (pii e : g[v]) {
		int u = e.first, i = e.second;
		if (u == pr)
			continue;
		dfs(u, v);
	}
	add(v);
	for (pii e : g[v]) {
		int u = e.first, i = e.second;
		if (u == pr)
			continue;
		if (c[i])
			add(u);
	}
	ord.push_back(v);
	add(v);
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u >> c[i];
		v--;
		u--;
		g[v].push_back({ u, i });
		g[u].push_back({ v, i });
	}
	for (int i = 0; i < n; i++)
		cin >> d[i];
	for (int v = 0; v < n; v++)
		for (pii e : g[v]) {
			int u = e.first;
			int i = e.second;
			if (d[v] && d[u] && !c[i]) {
				cout << "NO\n";
				clear(n);
				return;
			}
			if (!d[v] && !d[u] && c[i]) {
				cout << "NO\n";
				clear(n);
				return;
			}
		}
	dfs(0);
	for (int v : ord)
		if (cur[v] ^ d[v])
			add(v);
	for (int i = 0; i < n; i++)
		cur[i] = 0;
	cout << "YES\n";
	cout << seq.size() << '\n';
	for (int v : seq) {
		cout << v + 1 << ' ';
		cout << (cur[v] ^ 1) << '\n';
		cur[v] ^= 1;
	}
	cout << '\n';
	clear(n);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
