#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

mt19937 rnd(238);

struct node {
	int x, y;
	int sz = 1;
	node* l = nullptr;
	node* r = nullptr;

	node() {}

	node(int v) {
		x = v;
		y = rnd();
		sz = 1;
		l = nullptr;
		r = nullptr;
	}
};

int getSz(node* t) {
	return t ? t->sz : 0;
}

void upd(node* t) {
	t->sz = 1 + getSz(t->l) + getSz(t->r);
}

pair<node*, node*> split(node* t, int x) {
	if (!t)
		return { nullptr, nullptr };
	if (t->x <= x) {
		auto p = split(t->r, x);
		t->r = p.first;
		upd(t);
		return { t, p.second };
	}
	auto p = split(t->l, x);
	t->l = p.second;
	upd(t);
	return { p.first, t };
}

node* merge(node* l, node* r) {
	if (!l)
		return r;
	if (!r)
		return l;
	if (l->y > r->y) {
		l->r = merge(l->r, r);
		upd(l);
		return l;
	}
	r->l = merge(l, r->l);
	upd(r);
	return r;
}

node* insert(node* t, int x) {
	node* nn = new node(x);
	auto p = split(t, x);
	return merge(merge(p.first, nn), p.second);
}

int order_of_key(node* t, int x) {
	if (!t)
		return 0;
	if (t->x > x)
		return order_of_key(t->l, x);
	if (t->x == x)
		return 1 + getSz(t->l);
	if (t->x < x)
		return 1 + getSz(t->l) + order_of_key(t->r, x);
}

const int N = 1e5;
vector<int> buc[N];
const int NM = 1e7 + 1;
int f[NM];

void add(int i, int v) {
	i++;
	for (; i < NM; i += i & -i)
		f[i] += v;
}

int get(int i) {
	i++;
	int res = 0;
	for (; i; i -= i & -i)
		res += f[i];
	return res;
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> t(n);
	for (int i = 0; i < n; i++)
		cin >> t[i];
	vector<int> s(m + 1);
	for (int i = 1; i <= m; i++)
		cin >> s[i];
	vector<int> d(m);
	for (int i = 0; i < m; i++)
		d[i] = s[i + 1] - s[i];
	vector<int> cur(n);
	priority_queue<pli, vector<pli>, greater<pli>> q;
	for (int i = 0; i < n; i++)
		q.push({ 1ll * t[i] * d[i], i });
	vector<int> ord;
	while (!q.empty()) {
		int i = q.top().second;
		q.pop();
		ord.push_back(i);
		cur[i]++;
		if (cur[i] < m)
			q.push({ 1ll * t[i] * d[cur[i]], i });
	}
	for (int i = 0; i < (int)ord.size(); i++)
		buc[ord[i]].push_back(i);
	vector<ll> ans(n);
	node* oset = nullptr;
	for (int i = 0; i < n; i++) {
		if (i)
			ans[i] += ans[i - 1];
		ans[i] += get(buc[i].back());
		for (int pos : buc[i])
			ans[i] += i - order_of_key(oset, pos);
		for (int pos : buc[i])
			add(pos, 1);
		oset = insert(oset, buc[i].back());
	}
	for (int i = 0; i < n; i++)
		cout << ans[i] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
