#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

struct segtree {
	int sz;
	vector<int> tree;

	segtree() {}

	segtree(int n) {
		sz = 1;
		while (sz < n)
			sz *= 2;
		tree.resize(2 * sz);
	}

	void push(int x, int tl, int tr) {
		if (tr - tl == 1 || !tree[x])
			return;
		tree[2 * x + 1] = max(tree[2 * x + 1], tree[x]);
		tree[2 * x + 2] = max(tree[2 * x + 2], tree[x]);
	}

	void set(int l, int r, int v, int x, int tl, int tr) {
		push(x, tl, tr);
		if (l <= tl && tr <= r) {
			tree[x] = max(tree[x], v);
			return;
		}
		if (l >= tr || r <= tl)
			return;
		int m = (tl + tr) / 2;
		set(l, r, v, 2 * x + 1, tl, m);
		set(l, r, v, 2 * x + 2, m, tr);
	}

	void set(int l, int r, int v) {
		set(l, r, v, 0, 0, sz);
	}

	int get(int i, int x, int tl, int tr) {
		push(x, tl, tr);
		if (tr - tl == 1)
			return tree[x];
		int m = (tl + tr) / 2;
		if (i < m)
			return get(i, 2 * x + 1, tl, m);
		else
			return get(i, 2 * x + 2, m, tr);
	}

	int get(int i) {
		return get(i, 0, 0, sz);
	}
};

const int N = 5001;
vector<int> g[N];
int sz[N];

void dfs(int v) {
	sz[v] = 1;
	for (int u : g[v]) {
		dfs(u);
		sz[v] += sz[u];
	}
}

ll calc(vector<int>& a) {
	int n = a.size();
	segtree st(n);
	for (int i = 0; i < n; i++)
		st.set(max(0, i - a[i]), min(n - 1, i + a[i]) + 1, min(n - 1, i + a[i]));
	vector<int> to(n);
	vector<int> cnt(n + 1);
	for (int i = 0; i < n; i++) {
		to[i] = st.get(i);
		g[to[i] + 1].push_back(i);
		cnt[to[i] + 1]++;
	}
	dfs(n);
	for (int i = 0; i <= n; i++)
		g[i].clear();
	ll ans = 0;
	for (int i = 0; i < n; i++)
		if (cnt[i])
			ans += 1ll * (sz[i] - 1) * (n - i);
	return ans;
}

inline void solve() {
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	ll ans = calc(a);
	for (int i = 0; i < n; i++) {
		int v = a[i];
		a[i] = x;
		ans = min(ans, calc(a));
		a[i] = v;
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
