#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

void smax(int& a, int b) {
	a = max(a, b);
}

void smin(int& a, int b) {
	a = min(a, b);
}

void smax(ll& a, ll b) {
	a = max(a, b);
}

void smin(ll& a, ll b) {
	a = min(a, b);
}

const int N = 500;
int cost[N][N];
int mx[N];

ll calc(int n, vector<int> &a) {
	for (int i = 0; i < n; i++)
		for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); j++)
			smax(mx[j], min(n - 1, i + a[i]));
	for (int l = n - 1; l > -1; l--)
		cost[l][l] = 0;
	for (int l = n - 2; l > -1; l--)
		for (int r = l + 1; r < n; r++) {
			if (r <= mx[l])
				cost[l][r] = 0;
			else
				cost[l][r] = 1 + cost[mx[l] + 1][r];
		}
	ll sum = 0;
	for (int l = 0; l < n; l++)
		for (int r = l; r < n; r++)
			sum += cost[l][r];
	return sum;
}

inline void solve() {
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	ll ans = calc(n, a);
	for (int i = 0; i < n; i++) {
		int v = a[i];
		a[i] = x;
		smin(ans, calc(n, a));
		a[i] = v;
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
