#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

void smax(int& a, int b) {
	a = max(a, b);
}

void smin(int& a, int b) {
	a = min(a, b);
}

const int N = 500;
int cost[N][N];
int mx[N];

int rec(int l, int r) {
	if (mx[l] >= r)
		cost[l][r] = 0;
	if (cost[l][r] > -1)
		return cost[l][r];
	return cost[l][r] = (1 + rec(mx[l] + 1, r));
}

int calc(vector<int>& a) {
	int n = a.size();
	for (int i = 0; i < n; i++)
		for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); j++)
			mx[j] = max(mx[j], min(n - 1, i + a[i]));
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			cost[i][j] = -1;
	int ans = 0;
	for (int s = 0; s < n; s++)
		for (int t = s + 1; t < n; t++)
			ans += rec(s, t);
	return ans;
}

inline void solve() {
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int ans = calc(a);
	for (int i = 0; i < n; i++) {
		int v = a[i];
		a[i] = x;
		smin(ans, calc(a));
		a[i] = v;
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
