#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct tree {
	vector<pair<long long, long long>> z;
	long long n;

	tree(long long _n) {
		n = _n;
		z.resize(n * 4, { -1e9, -1 });
	}
	long long poz;
	pair<long long, long long> val;
	void upd0(long long l, long long r, long long x) {
		if (l + 1 == r) {
			z[x] = val;
			return;
		}
		long long m = (l + r) / 2;
		if (m > poz) {
			upd0(l, m, x * 2);
		}
		else upd0(m, r, x * 2 + 1);
		z[x] = max(z[x * 2 + 1], z[x * 2]);
	}
	void upd(long long _poz, pair<long long, long long> _val) {
		poz = _poz;
		val = _val;
		upd0(0, n, 1);
	}

	long long lq, rq;
	void get0(long long l, long long r, long long x) {
		if (l >= lq && r <= rq) {
			z[0] = max(z[0], z[x]);
			return;
		}
		long long m = (l + r) / 2;
		if (m > lq) {
			get0(l, m, x * 2);
		}
		if (m < rq) {
			get0(m, r, x * 2 + 1);
		}
	}
	pair<long long, long long> get(long long _lq, long long _rq) {
		lq = _lq;
		rq = _rq;
		z[0] = { -1e9, -1 };
		get0(0, n, 1);
		return z[0];
	}
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	long long n, x;
	cin >> n >> x;
	vector<long long> z(n);
	for (auto& i : z) cin >> i;
	long long ans = 1e18;
	vector<pair<pair<long long, long long>, long long>> pr(n);
	for (long long i = 0; i < n; i++) {
		pr[i] = { {max(0ll, i - z[i]), min(n - 1, i + z[i])}, i };
	}
	sort(pr.begin(), pr.end());
	tree T(n);
	for (long long i = 0; i < n; i++) {
		T.upd(i, { pr[i].first.second, pr[i].second });
	}
	vector<long long> next0(n);
	for (long long i = 0; i < n; i++) {
		long long l = 0, r = n;
		while (l + 1 < r) {
			long long m = (l + r) / 2;
			if (pr[m].first.first <= i) l = m;
			else r = m;
		}
		next0[i] = T.get(0, l + 1).second;
	}
	/*for (long long i = 0; i < n; i++) {
		for (long long j = 0; j < n; j++) {
			if (min(n - 1, j + z[j]) > min(n - 1, next0[i] + z[next0[i]]) && i >= max(0ll, j - z[j])) {
				next0[i] = j;
			}
		}
	}*/


	vector<long long> z0 = z;
	for (long long ii = max(n-1,x); ii < 2*n + 1; ii+=1e9) {
		if (ii < n && x <= z[ii]) continue;
		long long ans0 = 0;
		if (ii < n) z0[ii] = x;
		vector<long long> next = next0;
		if (ii < n) {
			for (long long i = 0; i < n; i++) {
				if (min(n - 1, ii + z0[ii]) > min(n - 1, next[i] + z0[next[i]]) && i >= max(0ll, ii - z0[ii])) {
					next[i] = ii;
				}
			}
		}
		vector<long long> dp(n + 1);
		for (long long i = n - 1; i >= 0; i--) {
			long long t = min(n - 1, next[i] + z0[next[i]]);
			if (t != n) dp[i] = dp[t + 1] + n - 1 - t;


			/*long long k = 0;
			for (long long j = t+1; j < n; j++) {
				if (t < j) {
					k++;
					t = min(n - 1, next[j] + z0[next[j]]);
					ans0 += k * (t - j + 1);
					j = t;
				}
			}*/
		}
		for (auto& i : dp) ans0 += i;
		ans = min(ans, ans0);
		if (ii < n) z0[ii] = z[ii];
	}
	cout << ans;
}