#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

int n, m, ban = -1;
vector<vector<pair<int, int>>> gr;
vector<pair<int, int>> ans;
vector<vector<int>> edge;
vector<int> upd, cur;

void dfs(int v, int p, int c){
    if (v == ban){
        return;
    }
    for (auto e: gr[v]){
        int u = e.first, t = e.second;
        if (u != p)
            dfs(u, v, t);
    }
    ans.push_back({v, 1});
    cur[v] = 1;
    if (c == 0) {
        ans.push_back({v, 0});
        cur[v] = 0;
    }
}

void dfs1(int v, int p){
    if (ban == v){
        return;
    }
    if (cur[v] != upd[v]){
        ans.push_back({v, upd[v]});
        cur[v] = upd[v];
    }
    for (auto e: gr[v]){
        int u = e.first;
        if (u != p){
            dfs1(u, v);
        }
    }
}

void solve(){
    cin >> n >> m;
    gr.clear();
    ans.clear();
    edge.clear();
    upd.clear();
    cur.resize(n);
    gr.resize(n);
    edge.resize(m);
    upd.resize(n);
    for (int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].push_back({b, c});
        gr[b].push_back({a, c});
        edge[i] = {a, b, c};
    }
    for (int i = 0; i < n; i++){
        cin >> upd[i];
    }
    for (int i = 0; i < m; i++){
        if (upd[edge[i][0]] != edge[i][2] and upd[edge[i][1]] != edge[i][2]){
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < n; i++){
        if (gr[i].size() >= 2) {
            if (upd[i] == upd[gr[i][0].first] and upd[i] == upd[gr[i][1].first]) {
                if (upd[i] == 1) {
                    ans.push_back({i, 1});
                    ans.push_back({upd[gr[i][0].first], 1});
                    ans.push_back({upd[gr[i][1].first], 1});
                    ans.push_back({upd[gr[i][0].first], 0});
                    ans.push_back({upd[gr[i][1].first], 0});
                }
                ban = i;
            }
        }
    }
    if (ban == -1){
        cout << "NO";
        return;
    }
    dfs(0, -1, -1);
    dfs1(0, -1);
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto e: ans){
        cout << e.first + 1 << ' ' << e.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; _++){
        solve();
    }
}