#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi2,popcnt,lzcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

const int N = 5000;
int tree[N] = {0}, p[4 * N] = {0};
    void push(int v, int l, int r){
        if (l == r - 1){
            tree[l] = max(tree[l], p[v]);
            return;
        }
        if (p[v * 2 + 1] < p[v]){
            p[v * 2 + 1] = p[v];
        }
        if (p[v * 2 + 2] < p[v]){
            p[v * 2 + 2] = p[v];
        }
    }

    void get(int v, int l, int r, vector<int>&val){
        push(v, l, r);
        if (l == r - 1){
            val[l] = tree[l];
            return;
        }
        int mid = (r + l) / 2;
        get(v * 2 + 1, l, mid, val);
        get(v * 2 + 2, mid, r, val);
    }

    void upd(int v, int l, int r, int ql, int qr, int x){
        push(v, l, r);
        if (qr <= l or r <= ql){
            return;
        }
        if (ql <= l and r <= qr){
            p[v] = x;
            push(v, l, r);
            return;
        }
        int mid = (r + l) / 2;
        upd(v * 2 + 1, l, mid, ql, qr, x);
        upd(v * 2 + 2, mid, r, ql, qr, x);
    }

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, x;
    cin >> n >> x;
    vector<int> A(n);
    for (int i = 0; i < n; i++){
        cin >> A[i];
    }
    long long res = 1e18;
    for (int ind = 0; ind < n; ind++){
        int t = A[ind];
        A[ind] = x;
        vector<int> R(n);
        for (int i = 0; i < n; i++){
            upd(0, 0, n, max((int)0, i - A[i]), min(n, i + A[i] + 1), i + A[i]);
        }
        get(0, 0, n, R);
        vector<int> sd(n);
        long long ans = 0;
        for (int i = 0; i < n; i++){
            if (R[i] + 1 < n){
                ans += (long long)(n - R[i] - 1) * (sd[i] + 1);
                sd[R[i] + 1] += sd[i] + 1;
            }
        }
        res = min(res, ans);
        A[ind] = t;
    }
    cout << res;
}