#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

#define int long long

struct ST{
    vector<int> tree, p;

    ST(int n){
        tree.resize(n);
        p.resize(4 * n);
    }

    void push(int v, int l, int r){
        if (l == r - 1){
            tree[l] = max(tree[l], p[v]);
            p[v] = 0;
            return;
        }
        p[v * 2 + 1] = max(p[v * 2 + 1], p[v]);
        p[v * 2 + 2] = max(p[v * 2 + 2], p[v]);
        p[v] = 0;
    }

    int get(int v, int l, int r, int pos){
        push(v,l, r);
        if (pos < l or pos >= r){
            return 0;
        }
        if (l == pos and l == r - 1){
            return tree[l];
        }
        int mid = (r + l) / 2;
        return max(get(v * 2 + 1, l, mid, pos), get(v * 2 + 2, mid, r, pos));
    }

    void upd(int v, int l, int r, int ql, int qr, int x){
        push(v, l, r);
        if (qr <= l or r <= ql){
            return;
        }
        if (ql <= l and r <= qr){
            p[v] = x;
            push(v, l, r);
            return;
        }
        int mid = (r + l) / 2;
        upd(v * 2 + 1, l, mid, ql, qr, x);
        upd(v * 2 + 2, mid, r, ql, qr, x);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, x;
    cin >> n >> x;
    vector<int> A(n);
    for (int i = 0; i < n; i++){
        cin >> A[i];
    }
    int res = 1e18;
    for (int ind = 0; ind < n; ind++){
        int t = A[ind];
        A[ind] = x;
        vector<int> R(n);
        ST st(n);
        for (int i = 0; i < n; i++){
            st.upd(0, 0, n, max((int)0, i - A[i]), min(n, i - A[i] + 1), i - A[i]);
        }
        for (int i = 0; i < n; i++){
            R[i] = st.get(0, 0, n, i);
        }
        vector<int> sd(n);
        int ans = 0;
        for (int i = 0; i < n; i++){
            if (R[i] + 1 < n){
                ans += (n - R[i] - 1) * (sd[i] + 1);
                sd[R[i] + 1] += sd[i] + 1;
            }
        }
        res = min(res, ans);
        A[ind] = t;
    }
    cout << res;
}