#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

vector<int> one;
vector<int> on;
vector<pair<int, int>> g[MAXN];
vector<pair<int, int>> ans;
vector<pair<pair<int, int>, int>> edges;
vector<int> d;

void upd(int v) {
    on[v] = 1 - on[v];
    ans.emplace_back(v, on[v]);
    for (auto [u, ind] : g[v]) {
        if (on[u] == on[v]) one[ind] = on[u];
    }
}

void init(int n, int m) {
    d.resize(n), edges.resize(m);
    on.resize(n), one.resize(m);
    for (int i = 0; i < n; ++i) {
        on[i] = 0;
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        one[i] = 0;
    }
    ans.clear();
}

void dfs(int v = 0, int p = -1) {
    if (d[v] == 0) {
        for (auto [u, ind] : g[v]) {
            if (u != p && edges[ind].second == 1) {
                dfs(u, v);
            }
        }
        upd(v);
        upd(v);
        for (auto [u, ind] : g[v]) {
            if (u != p && edges[ind].second == 0) {
                dfs(u, v);
            }
        }
    } else {
        for (auto [u, ind] : g[v]) {
            if (u != p && edges[ind].second == 0) {
                dfs(u, v);
            }
        }
        upd(v);
        for (auto [u, ind] : g[v]) {
            if (u != p && edges[ind].second == 1) {
                if (d[u] == 0) upd(u), upd(u);
                dfs(u);
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    init(n, m);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {{a, b}, c};
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    dfs();
    bool ok = true;
    for (int i = 0; i < m; ++i) {
        int u = edges[i].first.first, v = edges[i].first.second;
        int t = edges[i].second;
        if (t) {
            if (!d[u] && !d[v]) ok = false;
        } else {
            if (d[u] && d[v]) ok = false;
        }
    }
    if (ok) {
        cout << "YES" << '\n' << -1 << '\n';
    } else {
        cout << "NO" << '\n';
    }
    if (ok) {
        cout << "YES" << '\n';
        cout << (int)ans.size() << '\n';
        for (auto [u, t] : ans) {
            cout << u + 1 << ' ' << t << '\n';
        }
    } else {
        cout << "NO" << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}