#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

vector<int> one;
vector<int> on;
vector<pair<int, int>> g[MAXN];
vector<pair<int, int>> ans;

void upd(int v) {
    on[v] = 1 - on[v];
    ans.emplace_back(v, on[v]);
    for (auto [u, ind] : g[v]) {
        if (on[u] == on[v]) one[ind] = on[u];
    }
}

void init(int n, int m) {
    on.resize(n), one.resize(m);
    for (int i = 0; i < n; ++i) {
        on[i] = 0;
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        one[i] = 0;
    }
    ans.clear();
}

void solve() {
    int n, m;
    cin >> n >> m;
    init(n, m);
    on.resize(n), one.resize(m);
    pair<pair<int, int>, int> edges[m];
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {{a, b}, c};
    }
    int d[n];
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        int u = edges[i].first.first, v = edges[i].first.second;
        if (edges[i].second == 1 && one[i] == 0 && d[u] + d[v] == 1) {
            if (!on[u]) upd(u);
            if (!on[v]) upd(v);
            if (!d[u]) upd(u);
            if (!d[v]) upd(v);
        }
    }
    for (int i = 0; i < m; ++i) {
        int u = edges[i].first.first, v = edges[i].first.second;
        if (edges[i].second == 1 && one[i] == 0) {
            if (!on[u]) upd(u);
            if (!on[v]) upd(v);
        }
    }
    for (int i = 0; i < m; ++i) {
        int u = edges[i].first.first, v = edges[i].first.second;
        if (edges[i].second == 0 && one[i] == 1) {
            if (on[u]) upd(u);
            if (on[v]) upd(v);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (d[i] != on[i]) upd(i);
    }
    bool ok = true;
    for (int i = 0; i < m; ++i) {
        if (edges[i].second != one[i]) {
            ok = false;
        }
    }
    if (ok) {
        cout << "YES" << '\n';
        cout << (int)ans.size() << '\n';
        for (auto [u, t] : ans) {
            cout << u + 1 << ' ' << t << '\n';
        }
    } else {
        cout << "NO" << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}