#include <bits/stdc++.h>

#pragma GCC optimaze("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt")

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e18 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

ll t[4 * MAXN];
ll add[4 * MAXN];

void build(ll v, ll l, ll r) {
    if (l + 1 == r) {
        t[v] = add[v] = 0;
    } else {
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = 0, add[v] = 0;
    }
}

void push(ll v, ll l, ll r) {
    t[v] = max(t[v], add[v]);
    if (l + 1 != r) {
        add[2 * v + 1] = max(add[2 * v + 1], add[v]);
        add[2 * v + 2] = max(add[2 * v + 2], add[v]);
    }
    add[v] = 0;
}

void upd(ll v, ll l, ll r, ll ql, ll qr, ll val) {
    push(v, l, r);
    if (r <= ql || l >= qr) {
        return;
    } else if (ql <= l && r <= qr) {
        add[v] = val;
    } else {
        ll m = (l + r) / 2;
        upd(2 * v + 1, l, m, ql, qr, val);
        upd(2 * v + 2, m, r, ql, qr, val);
    }
}

ll get(ll v, ll l, ll r, ll pos) {
    push(v, l, r);
    if (l + 1 == r) {
        return t[v];
    } else {
        ll m = (l + r) / 2;
        if (pos < m) {
            return get(2 * v + 1, l, m, pos);
        } else {
            return get(2 * v + 2, m, r, pos);
        }
    }
}

void solve() {
    ll n, x;
    cin >> n >> x;
    ll a[n];
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> to(n);
    ll ans = 0;
    build(0, 0, n);
    for (ll i = 0; i < n; ++i) {
        upd(0, 0, n, i - a[i], i + a[i] + 1, i + a[i]);
    }
    for (ll i = 0; i < n; ++i) {
        to[i] = get(0, 0, n, i);
    }
    vector<ll> dp(n);
    for (ll i = n - 1; i > -1; --i) {
        if (to[i] + 1 >= n) dp[i] = 0;
        else dp[i] = dp[to[i] + 1] + (n - to[i] - 1);
    }
    for (ll i = 0; i < n; ++i) ans += dp[i];
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}