#include <bits/stdc++.h>
#define int long long

using namespace std;

struct segtree{
    int sz;
    vector<pair<int, int>> t;

    void init(int n) {
        sz = 1;
        while (sz < n) sz *= 2;
        t.assign(2 * sz - 1, {0, 0});
    }

    void set(int i, int v, int l, int r, int x) {
        if (r - l == 1) {
            t[x] = {v, i};
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            set(i, v, l, m, 2 * x + 1);
        } else {
            set(i, v, m, r, 2 * x + 2);
        }
        t[x] = max(t[2 * x + 1], t[2 * x + 2]);
    }

    void set(int i, int v) {
        set(i, v, 0, sz, 0);
    }

    pair<int, int> mx(int ql, int qr, int l, int r, int x) {
        if (ql <= l && r <= qr) {
            return t[x];
        }
        if (ql >= r || l >= qr) {
            return {-1, 0};
        }
        int m = (l + r) / 2;
        return max(mx(ql, qr, l, m, 2 * x + 1), mx(ql, qr, m, r, 2 * x + 2));
    }

    pair<int, int> mx(int l, int r) {
        return mx(l, r, 0, sz, 0);
    }
};

int n;
vector<int> l, r;

int cnt(vector<int>& a, int ll) {
    int res = 0;
    int pos = ll;
    int curr = -1;
    segtree sg;
    sg.init(n);
    for (int i = 0; i < n; ++i) {
        sg.set(l[i], r[i]);
    }
    int cur = -1;
    for (int i = pos; i < n; ++i) {
        if (curr < i) {
            curr = sg.mx(0, i + 1).first;
            ++cur;
        }
        res += cur;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int x;
    cin >> n >> x;
    vector<int> a(n);
    l.assign(n, 0);
    r.assign(n, 0);
    for (int i = 0 ; i < n; ++i) {
        cin >> a[i];
        l[i] = max(0ll, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
    }
    int mn = 1e18;
    for (int s = 0; s < n; ++s) {
        swap(x, a[s]);
        for (int i = 0 ; i < n; ++i) {
            l[i] = max(0ll, i - a[i]);
            r[i] = min(n - 1, i + a[i]);
        }
//        for (int i = 0; i < n; ++i) {
//            cout << l[i] << " " << r[i] << "\n";
//        }
        int rs = 0;
        for (int i = 0; i < n; ++i) {
            rs += cnt(a, i);
        }
        mn = min(mn, rs);
        swap(x, a[s]);
    }
    cout << mn << "\n";
}