#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<vector<ll>> a1;
    vector<vector<ll>> a2;
    map<pair<ll, ll>, ll> mapa;
    vector<vector<ll>> v;
    for(int i = 0; i < n; i++) {
        ll x, p, d; cin >> x >> p >> d;
        v.push_back({x, p, d});
    }
    for(int i = 0; i < n; i++) {
        ll x = v[i][0], p = v[i][1], d = v[i][3];
        if (d == -1) {
            a1.push_back({max(0LL, x - p), x, 2 * i});
            a2.push_back({x, min(v[n - 1][0], x + p), 2 * i + 1});
        } else {
            a2.push_back({max(0LL, x - p), x, 2 * i});
            a1.push_back({x, min(v[n - 1][0], x + p), 2 * i + 1});
        }
        mapa[{2 * i, 2 * i + 1}] = 1;
    }
    vector<vector<vector<ll>>> g(a1.size() + a2.size());
    vector<ll> d(ll(a1.size() + a2.size()), inf);
    for(int i = 0; i < a1.size(); i++) {
        for(int j = 0; j < a2.size(); j++) {
            ll ok1 = a1[i][0] >= a2[j][0] && a1[i][0] <= a2[j][1];
            ll ok2 = a1[i][1] >= a2[j][0] && a1[i][1] <= a2[j][1];
            ll ok3 = a2[j][0] >= a1[i][0] && a2[j][0] <= a1[i][1];
            ll ok4 = a2[j][1] >= a1[i][0] && a2[j][1] <= a1[i][1];
            if (ok1 || ok2 || ok3 || ok4) {
                if (mapa[{a1[i][2], a2[j][2]}] == 0) {
                    g[i].push_back({j + ll(a1.size()), 1});
                    g[j + ll(a1.size())].push_back({i, 0});
                }
            }
        }
    }
    for(int i = 0; i < a1.size(); i++) {
        for(int j = 0; j < a1.size(); j++) {
            ll ok1 = a1[i][0] >= a1[j][0] && a1[i][0] <= a1[j][1];
            ll ok2 = a1[i][1] >= a1[j][0] && a1[i][1] <= a1[j][1];
            ll ok3 = a1[j][0] >= a1[i][0] && a1[j][0] <= a1[i][1];
            ll ok4 = a1[j][1] >= a1[i][0] && a1[j][1] <= a1[i][1];
            if (ok1 || ok2 || ok3 || ok4) {
                if (mapa[{a1[i][2], a1[j][2]}] == 0) {
                    g[i].push_back({j, 0});
                    g[j].push_back({i, 0});
                }
            }
        }
    }
    for(int i = 0; i < a2.size(); i++) {
        for(int j = 0; j < a2.size(); j++) {
            ll ok1 = a2[i][0] >= a2[j][0] && a2[i][0] <= a2[j][1];
            ll ok2 = a2[i][1] >= a2[j][0] && a2[i][1] <= a2[j][1];
            ll ok3 = a2[j][0] >= a2[i][0] && a2[j][0] <= a2[i][1];
            ll ok4 = a2[j][1] >= a2[i][0] && a2[j][1] <= a2[i][1];
            if (ok1 || ok2 || ok3 || ok4) {
                if (mapa[{a2[i][2], a2[j][2]}] == 0) {
                    g[i + ll(a1.size())].push_back({j + ll(a1.size()), 1});
                    g[j + ll(a1.size())].push_back({i + ll(a1.size()), 1});
                }
            }
        }
    }
    set<pair<ll, ll>> s;
    s.insert({0, 0});
    s.insert({1, a1.size()});
    d[0] = 0;
    d[a1.size()] = 1;
    while(!s.empty()) {
        pair<ll, ll> el = *s.begin();
        s.erase(s.begin());
        ll u = el.second, c = el.first;
        if (d[u] != c) continue;
        for(int i = 0; i < g[u].size(); i++) {
            ll to = g[u][i][0];
            if (mapa[{u, to}] == 1 || mapa[{to, u}] == 1) continue;
            if (d[to] > d[u] + g[u][i][1]) {
                d[to] = d[u] + g[u][i][1];
                s.insert({d[to], to});
            }
        }
    }
    ll res = min(d[ll(a1.size()) - 1], d[ll(a1.size() + a2.size()) - 1]);
    if (res != inf) {
        cout << res;
    } else {
        cout << -1;
    }
    return 0;
}
