#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

struct Rob {
    ll x;
    ll can;
    ll d;
};

ll checkAllRight(const vector<Rob> &src) {
    ll res = 0;
    bool good = true;
    ll n = ll(src.size());
    ll lst = 0;
    for (ll i = 0; i < n; ++i) {
        if (src[i].x > lst) {
            good = false;
            break;
        }

        if (src[i].d == -1) {
            ++res;
        }

        if (i < n - 1) {
            lst = min(src[i + 1].x, src[i].x + src[i].can);
        }
    }

    if (good) {
        return res;
    } else {
        return n + 1;
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<Rob> src(n);
    for (auto &item: src) {
        cin >> item.x >> item.can >> item.d;
    }

    ll res = checkAllRight(src);

    ll canAllLeft = n;
    vector<ll> costSuf(n + 1);
    ll cur = src[n - 1].x;
    for (ll i = n - 1; i >= 0; --i) {
        if (src[i].x < cur) {
            canAllLeft = i + 1;
            break;
        }
        if (i == 0) {
            canAllLeft = 0;
        }

        costSuf[i] = costSuf[i + 1] + (src[i].d == 1);
        if (i) {
            cur = min(src[i - 1].x, src[i].x - src[i].can);
        }
    }

    ll lst = 0;
    ll needRight = 0;
    for (ll i = 0; i < canAllLeft; ++i) {
        if (src[i].x > lst) {
            cout << "-1\n";
            return;
        }

        if (src[i].d == -1) {
            ++needRight;
        }
        if (i < n - 1) {
            lst = min(src[i].x + src[i].can, src[i + 1].x);
        } else {
            lst = src[i].x + src[i].can;
        }
    }

    for (ll toL = canAllLeft; toL < n; ++toL) {
        if (src[toL].x - src[toL].can > lst) {
            break;
        }

        ll tmp = needRight + costSuf[toL];
        res = min(res, tmp);
        if (lst < src[toL].x) {
            break;
        }
        if (src[toL].d == -1) {
            ++needRight;
        }
        if (toL < n - 1) {
            lst = min(src[toL + 1].x, src[toL].x + src[toL].can);
        }
    }

    if (res == n + 1) {
        cout << "-1\n";
    } else {
        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
