#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u;
    bool on;
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<Edge> edges(m);
    for (auto &item: edges) {
        cin >> item.v >> item.u >> item.on;
        --item.v;
        --item.u;
    }

    vector<ll> want(n);
    for (ll i = 0; i < n; ++i) {
        cin >> want[i];
    }

    vector<ll> cur(n);
    for (const auto &e: edges) {
        if (want[e.v] == want[e.u]) {
            if (e.on != want[e.v]) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector<pair<ll, ll>> act;
    for (int i = 0; i < n; ++i) {
        act.emplace_back(i, 0);
    }

    act.emplace_back(0, 1);
    cur[0] = 1;
    for (ll i = 0; i < n - 1; ++i) {
        if (edges[i].on) {
            act.emplace_back(i + 1, 1);
            cur[i] = 1;
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (!want[i]) {
            act.emplace_back(i, 0);
        }
    }

    cout << "YES\n";
    cout << act.size() << '\n';
    for (const auto &item: act) {
        cout << item.first + 1 << ' ' << item.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}