#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u;
    bool on;
};

vector<pair<ll, ll>> act;

vector<ll> state;

Edge eLast;

bool bad = false;
ll finit;
ll CNT = 0;

void dfs(ll from, const vector<vector<ll>> &g0, const vector<vector<ll>> &g1, const vector<ll> &want, ll p = -1) {
    if (from == finit) {
        if (CNT == 0) {
            CNT = 1;
        } else {
            if (eLast.on && (!state[0] || !state.back())) {
                bad = true;
            }
            if (!eLast.on && state[0] && state.back()) {
                bad = true;
            }
        }

        return;
    }

    if (want[from]) {
        for (const auto &to: g0[from]) {
            if (to == p) {
                continue;
            }
            dfs(to, g0, g1, want, from);
        }

        act.emplace_back(from, 1);
        state[from] = 1;
        for (const auto &to: g1[from]) {
            if (to == p) {
                continue;
            }

            act.emplace_back(to, 1);
            act.emplace_back(to, 0);
            dfs(to, g0, g1, want, from);
        }
    } else {
        act.emplace_back(from, 1);
        state[from] = 1;
        for (const auto &to: g1[from]) {
            if (to == p) {
                continue;
            }

            act.emplace_back(to, 1);
            act.emplace_back(to, 0);
            dfs(to, g0, g1, want, from);
        }
        act.emplace_back(from, 0);
        state[from] = 0;

        for (const auto &to: g0[from]) {
            if (to == p) {
                continue;
            }

            dfs(to, g0, g1, want, from);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<Edge> edges(m);

    vector<vector<ll>> g0(n);
    vector<vector<ll>> g1(n);

    for (auto &e: edges) {
        cin >> e.v >> e.u >> e.on;
        --e.v;
        --e.u;
        if (e.on) {
            g1[e.v].push_back(e.u);
            g1[e.u].push_back(e.v);
        } else {
            g0[e.v].push_back(e.u);
            g0[e.u].push_back(e.v);
        }
    }

    eLast = edges.back();

    vector<ll> want(n);
    for (ll i = 0; i < n; ++i) {
        cin >> want[i];
    }

    for (const auto &e: edges) {
        if (want[e.v] == want[e.u]) {
            if (e.on != want[e.v]) {
                cout << "NO\n";
                return;
            }
        }
    }


    for (int i = 0; i < 10; ++i) {
        ll from = rand() % n;
        state.clear();
        state.resize(n);

        act.clear();
        finit = from;
        CNT = 0;
        dfs(from, g0, g1, want, (from - 1 + n) % n);

        if (!bad) {
            cout << "YES\n";
            cout << act.size() << '\n';
            for (const auto &item: act) {
                cout << item.first + 1 << ' ' << item.second << '\n';
            }
            return;
        }
    }

    cout << "NO\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}