#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u;
    bool on;
};

vector<pair<ll, ll>> act;

void dfs(
        ll from, const vector<vector<ll>> &g0, const vector<vector<ll>> &g1, const vector<ll> &want,
        vector<bool> &used, vector<bool> &used1) {

    used[from] = true;
    if (want[from]) {
        for (const auto &to: g0[from]) {
            if (used[to]) {
                continue;
            }
            dfs(to, g0, g1, want, used, used1);
        }

        used1[from] = true;
        act.emplace_back(from, 1);
        for (const auto &to: g1[from]) {
            if (used1[to]) {
                continue;
            }

            act.emplace_back(to, 1);
            act.emplace_back(to, 0);
        }

        for (const auto &to: g1[from]) {
            if (used[to]) {
                continue;
            }

            dfs(to, g0, g1, want, used, used1);
        }
    } else {
        act.emplace_back(from, 1);
        used1[from] = true;
        for (const auto &to: g1[from]) {
            if (used1[to]) {
                continue;
            }

            act.emplace_back(to, 1);
            act.emplace_back(to, 0);
        }

        for (const auto &to: g1[from]) {
            if (used[to]) {
                continue;
            }

            dfs(to, g0, g1, want, used, used1);
        }
        act.emplace_back(from, 0);


        for (const auto &to: g0[from]) {
            if (used[to]) {
                continue;
            }

            dfs(to, g0, g1, want, used, used1);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<Edge> edges(m);

    vector<vector<ll>> g0(n);
    vector<vector<ll>> g1(n);

    for (auto &e: edges) {
        cin >> e.v >> e.u >> e.on;
        --e.v;
        --e.u;
        if (e.on) {
            g1[e.v].push_back(e.u);
            g1[e.u].push_back(e.v);
        } else {
            g0[e.v].push_back(e.u);
            g0[e.u].push_back(e.v);
        }
    }

    vector<ll> want(n);
    for (ll i = 0; i < n; ++i) {
        cin >> want[i];
    }

    for (const auto &e: edges) {
        if (want[e.v] == want[e.u]) {
            if (e.on != want[e.v]) {
                cout << "NO\n";
                return;
            }
        }
    }

    act.clear();
    vector<bool> used(n);
    vector<bool> used1(n);
    dfs(0, g0, g1, want, used, used1);

    cout << "YES\n";
    cout << act.size() << '\n';
    for (const auto &item: act) {
        cout << item.first + 1 << ' ' << item.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}