#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u;
    bool on;
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<Edge> edges(m);
    for (auto &item: edges) {
        cin >> item.v >> item.u >> item.on;
        --item.v;
        --item.u;
    }

    vector<ll> want(n);
    ll cnt = 0;
    for (ll i = 0; i < n; ++i) {
        cin >> want[i];
        cnt += !want[i];
    }

    for (const auto &e: edges) {
        if (want[e.v] == want[e.u]) {
            if (e.on != want[e.v]) {
                cout << "NO\n";
                return;
            }
        }
    }


    cout << "YES\n";
    cout << cnt << '\n';
    for (ll i = 0; i < n; ++i) {
        if (!want[i]) {
            cout << i + 1 << ' ' << '0' << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}