#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u;
    bool on;
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<Edge> edges(m);
    map<pair<ll, ll>, ll> forE;
    for (auto &item: edges) {
        cin >> item.v >> item.u >> item.on;
        --item.v;
        --item.u;
        forE[{min(item.v, item.u), max(item.v, item.u)}] = item.on;
    }

    vector<ll> want(n);
    for (ll i = 0; i < n; ++i) {
        cin >> want[i];
    }

    vector<ll> cur(n);
    vector<pair<ll, ll>> act;
    vector<ll> curE(m);
    for (int iter = 0; iter < 10000; ++iter) {
        ll u = rand() % n;
        ll st = rand() % 2;
        cur[u] = st;
        act.emplace_back(u, st);

        for (ll eI = 0; eI < m; ++eI) {
            Edge &e = edges[eI];
            if (cur[e.v] && cur[e.u]) {
                curE[eI] = 1;
            } else if (!cur[e.v] && !cur[e.u]) {
                curE[eI] = 0;
            }
        }

        bool good = true;
        for (int j = 0; j < n; ++j) {
            if (want[j] != cur[j]) {
                good = false;
            }
        }

        for (int j = 0; j < m; ++j) {
            if (curE[j] != edges[j].on) {
                good = false;
            }
        }

        if (good) {
            cout << "YES\n";
            cout << act.size() << '\n';
            for (const auto &item: act) {
                cout << item.first + 1 << ' ' << item.second << '\n';
            }
            return;
        }
    }

    cout << "NO\n";
    return;

    for (const auto &e: edges) {
        if (want[e.v] == want[e.u]) {
            if (e.on != want[e.v]) {
                cout << "NO\n";
                return;
            }
        }
    }

    for (ll i = 0; i < n - 1; ++i) {
        if (forE[{i, i + 1}]) {
            cur[i] = 1;
            cur[i + 1] = 1;
            act.emplace_back(i, 1);
            act.emplace_back(i + 1, 1);
        } else {
            cur[i] = 0;
            cur[i + 1] = 0;
            act.emplace_back(i, 0);
            act.emplace_back(i + 1, 0);
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (cur[i] != want[i]) {
            act.emplace_back(i, want[i]);
        }
    }

    cout << "YES\n";
    cout << act.size() << '\n';
    for (const auto &item: act) {
        cout << item.first + 1 << ' ' << item.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}