#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

struct Edge {
    ll v, u;
    bool on;
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<Edge> edges(m);
    vector<ll> wantE;
    vector<ll> curE;
    for (auto &item: edges) {
        cin >> item.v >> item.u >> item.on;
        --item.v;
        --item.u;
        wantE.push_back(item.on);
        curE.push_back(0);
    }

    vector<ll> want(n);
    for (ll i = 0; i < n; ++i) {
        cin >> want[i];
    }

    vector<ll> cur(n);
    for (const auto &e: edges) {
        if (want[e.v] == want[e.u]) {
            if (e.on != want[e.v]) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector<pair<ll, ll>> act;
    for (ll i = 0; i < n - 1; ++i) {
        if (wantE[i]) {
            if (!cur[i]) {
                cur[i] = 1;
                act.emplace_back(i, 1);
            }

            if (!cur[i + 1]) {
                cur[i + 1] = 1;
                act.emplace_back(i + 1, 1);
            }
            curE[i] = 1;
        } else {
            if (cur[i]) {
                cur[i] = 0;
                act.emplace_back(i, 0);
            }

            if (cur[i + 1]) {
                cur[i + 1] = 0;
                act.emplace_back(i + 1, 0);
            }
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (cur[i] != want[i]) {
            bool can = true;
            if (i) {
                if (want[i] == cur[i - 1] && want[i] != wantE[i - 1]) {
                    can = false;
                }
            }

            if (i < n - 1) {
                if (want[i] == cur[i + 1] && want[i] != wantE[i]) {
                    can = false;
                }
            }

            if (can) {
                cur[i] = want[i];
                act.emplace_back(i, want[i]);
            }
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (cur[i] != want[i]) {
            act.emplace_back(i, want[i]);
        }
    }

    cout << "YES\n";
    cout << act.size() << '\n';
    for (const auto &item: act) {
        cout << item.first + 1 << ' ' << item.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}