#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

ll calc(const vector<ll> &src) {
    ll n = ll(src.size());
    vector<ll> maxFrom(n);
    for (ll i = 0; i < n; ++i) {
        ll to = i + src[i];
        for (ll j = max(0LL, i - src[i]); j <= min(n - 1, i + src[i]); ++j) {
            maxFrom[j] = max(maxFrom[j], to);
        }
    }

    ll res = 0;
    for (ll s = 0; s < n - 1; ++s) {
        ll cur = maxFrom[s];
        for (ll t = s + 1; t < n; ++t) {
            if (t > cur) {
                res += n - t;
                cur = maxFrom[t];
            }
        }
    }

    return res;
}

void solve() {
    ll n, x;
    cin >> n >> x;
    vector<ll> src(n);
    for (auto &item: src) {
        cin >> item;
    }

    ll res = calc(src);
    for (auto &item: src) {
        ll old = item;
        item = x;
        res = min(res, calc(src));
        item = old;
    }

    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
