#pragma gcc optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define all(a) a.begin(), a.end()
#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define debug(a) cerr << a << '\n';

void solve() {
    int n; cin >> n;
    vector <int> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector <int> pref(n, mxn), suff(n, mxn);
    pref[0] = (d[0] == -1);
    for (int i = 1; i < n; ++i) {
        if (x[i - 1] + p[i - 1] < x[i]) break;
        pref[i] = pref[i - 1] + (d[i] == -1);
    }
    suff[n - 1] = (d[n - 1] == 1);
    for (int i = n - 2; i >= 0; --i) {
        if (x[i + 1] - p[i + 1] > x[i]) break;
        suff[i] = suff[i + 1] + (d[i] == 1);
    }
    int ans = pref[n - 1];
    for (int i = 0; i < n - 1; ++i) {
        if (x[i] + p[i] >= x[i + 1] - p[i + 1]) ans = min(ans, pref[i] + suff[i + 1]);
    }
    cout << (ans == mxn ? -1 : ans) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}