#pragma gcc optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define all(a) a.begin(), a.end()
#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define debug(a) cerr << a << '\n';

const int N = 1e5 + 1;
int n, m, a[N], b[N], c[N], d[N];
vector <pii> g[N], ans;

void dfs (int k, int p) {
    if (d[k] == 1) {
        for (auto i : g[k]) {
            if (i.first == p) continue;
            if (!c[i.second]) {
                dfs(i.first, k);
            }
        }
        ans.push_back({k, 1});
        for (auto i : g[k]) {
            if (i.first == p) continue;
            if (c[i.second]) {
                ans.push_back({i.first, 1});
                ans.push_back({i.first, 0});
                dfs(i.first, k);
            }
        }
    }
    else {
        for (auto i : g[k]) {
            if (i.first == p) continue;
            if (c[i.second]) {
                dfs(i.first, k);
            }
        }
        ans.push_back({k, 1});
        ans.push_back({k, 0});
        for (auto i : g[k]) {
            if (i.first == p) continue;
            if (!c[i.second]) {
                dfs(i.first, k);
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i]; --a[i]; --b[i];
        g[a[i]].emplace_back(make_pair(b[i], i));
        g[b[i]].emplace_back(make_pair(a[i], i));
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] && !d[a[i]] && !d[b[i]]) {
            cout << "NO" << '\n'; return;
        }
        if (!c[i] && d[a[i]] && d[b[i]]) {
            cout << "NO" << '\n'; return;
        }
    }
    cout << "YES" << '\n';
    ans.clear();
    dfs(0, -1);
    for (auto i : ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}