#pragma gcc optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define all(a) a.begin(), a.end()
#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define debug(a) cerr << a << '\n';

const int N = 1e5 + 1;
int n, m, a[N], b[N], c[N], d[N];
vector <pii> g[N], ans;

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    ans.clear(); ans.assign(10 * (n + m), {-1, -1});
    int L = 0, R = ans.size() - 1;
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i]; --a[i]; --b[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] != c[i]) exit(1);
        
        if (c[i] && !d[a[i]] && !d[b[i]]) {
            cout << "NO" << '\n'; return;
        }
        if (!c[i] && d[a[i]] && d[b[i]]) {
            cout << "NO" << '\n'; return;
        }
    }
    cout << "YES" << ' ' << -1 << endl; return;
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] != d[b[i]]) {
            g[a[i]].emplace_back(make_pair(b[i], i));
            g[b[i]].emplace_back(make_pair(a[i], i));
        }
    }
    vector <ll> z(n, 0), o(n, 0);
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (!c[j.second]) ++z[i];
            else ++o[i];
        }
    }
    set <pll> q;
    for (int i = 0; i < n; ++i) {
        q.insert(make_pair(o[i] * z[i], i));
    }
    vector <bool> used(n, false);
    cout << "YES" << ' ' << -1 << endl; return;
    while (!q.empty()) {
        auto [useless, v] = *q.begin(); q.erase(q.begin());
        if (z[v] * o[v] != useless) exit(1);
        used[v] = true;
        if (useless) {
            cout << "NO" << '\n';
            return;
        }
        if (d[v]) {
            if (o[v]) {
                ans[L++] = {v, 1};
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    ans[L++] = {i.first, 1};
                    ans[L++] = {i.first, 0};
                }
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --o[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
            else if (z[v]) {
                ans[R--] = {v, 1};
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --z[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
            else {
                ans[L++] = {v, 1};
            }
        }
        else {
            if (o[v]) {
                ans[R--] = {v, 0};
                ans[R--] = {v, 1};
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --o[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
            else if (z[v]) {
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --z[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
        }
    }
    cout << "YES" << ' ' << -1 << endl; return;
    cout << "YES" << '\n';
    vector <pll> ans1;
    for (auto i : ans) {
        if (i.first != -1) ans1.pb(i);
    }
    if (ans1.size() > 1e6) exit(1);
    cout << ans1.size() << '\n';
    for (auto i : ans1) {
        cout << i.first + 1 << ' ' << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}