#pragma gcc optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define all(a) a.begin(), a.end()
#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define debug(a) cerr << a << '\n';

const int N = 1e5 + 1;
int n, m, a[N], b[N], c[N], d[N];
vector <pii> g[N], ans, ans1;

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    ans.clear(); ans1.clear();
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i]; --a[i]; --b[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] && !d[a[i]] && !d[b[i]]) {
            cout << "NO" << '\n'; return;
        }
        if (!c[i] && d[a[i]] && d[b[i]]) {
            cout << "NO" << '\n'; return;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] != d[b[i]]) {
            g[a[i]].emplace_back(make_pair(b[i], i));
            g[b[i]].emplace_back(make_pair(a[i], i));
        }
    }
    vector <ll> z(n, 0), o(n, 0);
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (!c[j.second]) ++z[i];
            else ++o[i];
        }
    }
    set <pll> q;
    for (int i = 0; i < n; ++i) {
        q.insert(make_pair(o[i] * z[i], i));
    }
    vector <bool> used(n, false);
    while (!q.empty()) {
        auto [useless, v] = *q.begin(); q.erase(q.begin());
        used[v] = true;
        if (useless) {
            cout << "NO" << '\n';
            return;
        }
        if (d[v]) {
            if (o[v]) {
                ans.push_back({v, 1});
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    ans.push_back({i.first, 1});
                    ans.push_back({i.first, 0});
                }
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --o[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
            else if (z[v]) {
                ans1.push_back({v, 1});
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --z[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
            else {
                ans1.push_back({v, 1});
            }
        }
        else {
            if (o[v]) {
                ans.push_back({v, 1});
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    ans.push_back({i.first, 1});
                    ans.push_back({i.first, 0});
                }
                ans1.push_back({v, 0});
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --o[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
            else if (z[v]) {
                for (auto i : g[v]) {
                    if (used[i.first]) continue;
                    q.erase(make_pair(o[i.first] * z[i.first], i.first));
                    --z[i.first];
                    q.insert(make_pair(o[i.first] * z[i.first], i.first));
                }
            }
        }
    }
    // reverse(all(ans1));
    cout << "YES" << '\n';
    cout << ans.size() + ans1.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second << '\n';
    }
    for (auto i : ans1) {
        cout << i.first + 1 << ' ' << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}