#pragma gcc optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define all(a) a.begin(), a.end()
#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define debug(a) cerr << a << '\n';

const int T = 1.5e5 + 1;

ll t[T];
int nn;

inline void init (int n0) {
    // for (int i = 0; i < T; ++i) t[i] = 0;
    nn = n0;
}

inline void update (int i) {
    ++i;
    for (; i <= nn; i += i & -i) {
        ++t[i];
    }
}

inline ll pref (int i) {
    ll res = 0;
    for (; i > 0; i -= i & -i) {
        res += t[i];
    }
    return res;
}

inline ll get (int l, int r) {
    return pref(r) - pref(l);
}

const int M = 1.5e5 + 1, L = 1e7;
int pos[M];
int pr[L];

void solve() {
    int n, m; cin >> n >> m;
    vector <ll> t(n), s(m), d(m);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    if (*max_element(all(t)) <= L) {
        for (int i = 0; i < n; ++i) {
            ++pr[t[i]];
        }
        for (int i = 1; i < M; ++i) pr[i] += pr[i - 1];

        for (int i = 0; i < m; ++i) {
            cin >> s[i];
        }
        d[0] = s[0];
        for (int i = 1; i < m; ++i) {
            d[i] = s[i] - s[i - 1];
        }
        ll ma = *max_element(all(d));
        for (int i = m - 1; i >= 0; --i) {
            pos[d[i]] = i;
        }

        vector <ll> lal;
        for (auto i : d) {
            if (lal.empty() || i > lal.back()) lal.push_back(i);
        }

        vector <ll> val(n);
        for (int i = 0; i < n; ++i) {
            val[i] = ma * t[i];
        }

        vector <int> order(n); iota(all(order), 0);
        auto cmp = [&] (int i, int j) {
            return t[i] < t[j] || (t[i] == t[j] && i > j);
        };

        sort(all(order), cmp);

        vector <int> ind(n);
        for (int i = 0; i < n; ++i) {
            ind[order[i]] = i;
        }

        vector <ll> A;
        for (ll i = 0; i < n; ++i) {
            A.emplace_back(t[i]);
        }
        sort(all(A));

        ll ans = 0;
        init(n);

        int k = lal.size();
        // vector<vector<int>> up(n, vector<int>(k)), down(n, vector<int>(k));
        for (ll i = 0; i < n; ++i) {
            ans += i * m;

            int pref = n, pref1 = 0;
            for (auto x : lal) {
                ll y = (val[i] + x - 1) / x;
                int index = 0;

                if (y >= M) {
                    index = n;
                }
                else {
                    if (x * y == val[i]) index = pr[y];
                    else if (y - 1 >= 0) index = pr[y - 1];
                }

                if (index != pref) {
                    ans += get(index, pref) * pos[x];
                    pref = index;
                }

                ll y1 = t[i] * x / ma;
                int index1 = pr[y1];
                if (index1 != pref1) {
                    ans += get(pref1, index1) * pos[x];
                    pref1 = index1;
                }
            }

            update(ind[i]);
            cout << ans << '\n';
        }
    }
    else {
        for (int i = 0; i < m; ++i) {
            cin >> s[i];
        }
        d[0] = s[0];
        for (int i = 1; i < m; ++i) {
            d[i] = s[i] - s[i - 1];
        }
        ll ma = *max_element(all(d));
        for (int i = m - 1; i >= 0; --i) {
            pos[d[i]] = i;
        }

        vector <ll> lal;
        for (auto i : d) {
            if (lal.empty() || i > lal.back()) lal.push_back(i);
        }

        vector <ll> val(n);
        for (int i = 0; i < n; ++i) {
            val[i] = ma * t[i];
        }

        vector <int> order(n); iota(all(order), 0);
        auto cmp = [&] (int i, int j) {
            return t[i] < t[j] || (t[i] == t[j] && i > j);
        };

        sort(all(order), cmp);

        vector <int> ind(n);
        for (int i = 0; i < n; ++i) {
            ind[order[i]] = i;
        }

        vector <ll> A;
        for (ll i = 0; i < n; ++i) {
            A.emplace_back(t[i]);
        }
        sort(all(A));

        ll ans = 0;
        init(n);

        int k = lal.size();
        // vector<vector<int>> up(n, vector<int>(k)), down(n, vector<int>(k));
        for (ll i = 0; i < n; ++i) {
            ans += i * m;

            int pref = n, pref1 = 0;
            for (auto x : lal) {
                ll y = (val[i] + x - 1) / x;
                int index;

                auto up = [&] (ll val) {
                    int l = -1, r = n;
                    while (r - l > 1) {
                        int mid = (l + r) >> 1;
                        if (A[mid] <= val) l = mid;
                        else r = mid;
                    }
                    return l + 1;
                };
                auto low = [&] (ll val) {
                    int l = -1, r = n;
                    while (r - l > 1) {
                        int mid = (l + r) >> 1;
                        if (A[mid] >= val) r = mid;
                        else l = mid;
                    }
                    return r;
                };

                if (x * y == val[i]) {
                    index = up(y);
                }
                else {
                    index = low(y);
                }

                if (index != pref) {
                    ans += get(index, pref) * pos[x];
                    pref = index;
                }

                ll y1 = t[i] * x / ma;
                int index1 = up(y1);
                if (index1 != pref1) {
                    ans += get(pref1, index1) * pos[x];
                    pref1 = index1;
                }
            }

            update(ind[i]);
            cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}