#pragma gcc optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define all(a) a.begin(), a.end()
#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define debug(a) cerr << a << '\n';

vector <int> suff, cost1;
int cnt (vector <int> a) {
    int n = a.size();
    vector <int> upd(n + 1);
    for (int i = 0; i < n; ++i) {
        upd[max(0ll, i - a[i])] = max(upd[max(0ll, i - a[i])], min(n, i + a[i] + 1));
    }
    vector <int> jump(n, 0);
    int ma = 0;
    for (int i = 0; i < n; ++i) {
        ma = max(ma, upd[i]);
        jump[i] = ma;
    }
    vector <int> dp(n, 0);
    cost1.assign(n, 0);
    for (int i = n - 2; i >= 0; --i) {
        if (jump[i] >= n) continue;
        dp[i] = (n - jump[i]) + dp[jump[i]];
    }
    suff = dp;
    cost1 = dp;
    suff[n - 1] = dp[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        suff[i] = suff[i + 1] + dp[i];
    }
    int res = 0;
    for (auto i : dp) res += i;
    return res;
}

void solve() {
    int n, x; cin >> n >> x;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = cnt(a);
    // debug(ans);
    // a[i] <= 1
    vector <int> pref(n, 0), cost(n, 0);
    vector <int> dp1(n, 0), dp2(n, 0);

    for (int i = 1; i < n; ++i) {
        if (a[i - 1]) {
            dp2[i] = min(dp2[i] + i, dp1[i]);
            dp1[i] = cost[i - 1] + i;
        }
        else {
            dp1[i] = cost[i - 1] + i;
            dp2[i] = cost[i - 1] + i;
        }
        cost[i] = min(dp1[i], dp2[i]);
    }
    for (int i = 0; i < n; ++i) {
        pref[i] = cost[i];
        if (i) pref[i] += pref[i - 1];
    }
    // vout(suff); vout(cost1);
    for (int i = 0; i < n; ++i) {
        int l = max(0ll, i - x), r = min(n, i + x + 1);
        if (l == 0 && r == n) {
            cout << 0 << '\n'; return;
        }
        else if (l == 0) {
            ans = min(ans, suff[r] + r * (cost1[r] + (n - r)));
        }
        else if (r == n) {
            ans = min(ans, pref[l] + (cost[l] + l) * (n - l - 1));
        }
        else {
            ans = min(ans, pref[l] + suff[r] + (r - l) * (cost1[r] + (n - r)) + (cost[l] + l) * (r - l - 1) + l * (n - r) + l * cost1[r] + cost[l] * (n - r));
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}