#include <iostream>
#include <vector>
#include <cmath>
#include <queue>
#include <algorithm>
#include <string>

#define res(a, n) a.clear(); a.resize(n);
#define ress(a, n, b) a.clear(); a.resize(n, b);
#define int long long
#define endl '\n'

using namespace std;


int n, m;

vector<vector<pair<int, int>>> graf;

vector<int> ans;
bool ok = true;

vector<int> d;

void pp(int a, int b) {
	ans.push_back(a + 1); ans.push_back(b);
}

void dfs(int v, int pr) {
	if (graf[v].size() == 0) {if (d[v] == 1) pp(v, 1); return; }
	if (graf[v].size() == 1 && graf[v][0].second == pr) {
		if (d[v] == 1) { pp(v, 1); }
		return;
	}
	bool f = false;
	if (d[v] == 1) {
		for (int i = 0; i < graf[v].size(); i++) {
			int u = graf[v][i].second, c = graf[v][i].first;
			if (u == pr) continue;
			if (c == 1 && d[u] == 0) {
				if (!f) {
					pp(v, 1);
					f = true;
				}
				pp(u, 1);
				pp(u, 0);
			}
			dfs(u, v);
		}
		if (!f) pp(v, 1);
	}
	else {
		for (int i = graf[v].size() - 1; i >= 0; i--) {
			int u = graf[v][i].second, c = graf[v][i].first;
			if (u == pr) continue;
			if (c == 1 && d[u] == 1) {
				if (!f) {
					pp(v, 1);
					f = true;
				}
				pp(u, 1);
				pp(u, 0);
			}
			else if (f) {
				pp(v, 0); f = false;
			}
			dfs(u, v);
		}
		if (f) pp(v, 0);
	}
}

vector<vector<int>> g;

vector<int> cc;
vector<bool> c1;

void solve() {
	cin >> n >> m;
	ans.clear();

	res(graf, n); res(d, n); ress(c1, n, false);
	for (int i = 0; i < m; i++) {
		int a, b, c; cin >> a >> b >> c;
		--a; --b;
		graf[a].push_back({ c, b });
		graf[b].push_back({ c, a });
		if (c == 1) {
			c1[a] = true; c1[b] = true;
		}
	}

	for (int i = 0; i < n; i++) cin >> d[i];
	for (int i = 0; i < n; i++) sort(graf[i].begin(), graf[i].end());

	ok = true;
	for (int i = 0; i < n; i++) {
		for (auto u : graf[i]) {
			if (d[u.second] == d[i] && u.first != d[i]) ok = false;
		}
	}
	if (!ok) {
		cout << "NO\n"; return;
	}


	res(g, n); res(cc, n);
	for (int i = 0; i < n; i++) {
		for (auto x : graf[i]) {
			int u = x.second, c = x.first;
			if (d[u] == d[i]) continue;
			if ((d[i] ^ c) == 0) {
				g[i].push_back(u);
				cc[u]++;
			}
		}
	}
	queue<int> q;
	for (int i = 0; i < n; i++) {
		if (cc[i] == 0) q.push(i);
	}
	vector<int> st;
	while (!q.empty()) {
		int v = q.front(); q.pop();
		st.push_back(v);
		for (auto x : g[v]) {
			int u = x;
			cc[u]--;
			if (cc[u] == 0) q.push(u);
		}
	}
	for (int i = 0; i < n; i++) {
		if (cc[i] != 0) ok = false;
	}
	if (!ok) {
		cout << "NO\n"; return;
	}

	//reverse(st.begin(), st.end());
	for (int i = 0; i < n; i++) {
		if (d[st[i]] == 1) { pp(st[i], 1); }
		else if (c1[st[i]]) {
			pp(st[i], 1); pp(st[i], 0);
		}
	}

	cout << "YES" << endl;;
	cout << ans.size() / 2 << endl;
	for (auto x : ans) cout << x << ' ';
	cout << endl;
}

/*


5
4 3 
1 2 1
1 3 0
1 4 0
0 1 1 0



5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4 
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0


*/

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}