#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <queue>

using namespace std;

using ll = long long;
using dlle = long double;
using pl = pair<long long, long long>;
using vl = vector<long long>;
using vpl = vector <pl>;
using vb = vector <bool>;
using vvl = vector <vl>;

unsigned const long long INF = 1e9;

struct thing {
	ll u, color;
};

bool OK1(vector <vector <thing>>& mas, vl& colortab) {
	for (int v = 0; v < mas.size(); v++) {
		for (auto& u : mas[v]) {
			if (u.color != colortab[v] && u.color != colortab[u.u]) return false;
		}
	}

	return true;
}

void dfs(ll v, ll p, vector <vector <thing>>& mas, vector <vector <thing>>& cumas) {
	for (auto& u : mas[v]) {
		if (u.u != p) {
			cumas[u.u].push_back(thing{v, u.color});
			dfs(u.u, v, mas, cumas);
		}
	}
}

vector <vector <thing>> condec(vector <vector <thing>>& mas) {
	vector <vector <thing>> cumas(mas.size());

	dfs(0, 0, mas, cumas);

	return cumas;
}

void F() {
	ll n, m;

	cin >> n >> m;

	vector <vector <thing>> mas(n);
	vl colortab(n);

	for (int i = 0; i < m; i++) {
		ll v, u, color;

		cin >> v >> u >> color;
		--v; --u;

		mas[v].push_back(thing{ u, color });
		mas[u].push_back(thing{ v, color });
	}

	for (int i = 0; i < n; i++) cin >> colortab[i];

	if (!OK1(mas, colortab)) {
		cout << "NO\n"; return;
	}

	vl mark(n);
	vl cucolor(n);
	queue<ll> qu;

	vector <vector <thing>> nmas = condec(mas);

	for (int i = 0; i < n; i++) {
		if (mas[i].size() <= 1 && i != 0) {
			qu.push(i);
			mark[i] = 1;
		}

		mark[i] = mas.size();
	}

	//if (qu.size() == 0) qu.push(0);

	mas = nmas;

	vpl st;
	vl row;

	while (qu.size()) {
		ll v = qu.front(); qu.pop();
		row.push_back(v);

		for (auto& u : mas[v]) {
			if (mark[u.u] == 1) {
				st.push_back({ v, u.color });
				st.push_back({ u.u, u.color });

				cucolor[v] = u.color;
				cucolor[u.u] = u.color;

				qu.push(u.u);
				mark[u.u] = 0;
			}
			else if (mark[u.u] > 1) {
				--mark[u.u];
				st.push_back({ v, u.color });
				st.push_back({ u.u, u.color });

				cucolor[v] = u.color;
				cucolor[u.u] = u.color;
			}
		}
	}

	reverse(row.begin(), row.end());

	for (int i = 0; i < row.size(); i++) {
		st.push_back({ row[i], colortab[row[i]] });
	}

	cout << "YES\n";
	cout << st.size() << "\n";
	for (int i = 0; i < st.size(); i++) {
		cout << st[i].first + 1 << " " << st[i].second << "\n";
	}
	cout << "\n";
}

int main() {
	ll t;

	cin >> t;

	while (t--) F();
}
