#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e9;
using pp = pair<int, int>;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pp>> graph(n);
    vector<tuple<int, int, int>> edges(m);
    vector<int> edge_col(m), edge_desired(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        edges[i] = {a, b, i};
        edge_desired[i] = c;
    }
    vector<int> col_node(n);
    for (int i = 0; i < n; i++) {
        cin >> col_node[i];
    }
    for (auto [a, b, id]: edges) {
        if (col_node[a] == col_node[b]) {
            continue;
        }
        graph[a].emplace_back(b, id);
        graph[b].emplace_back(a, id);
    }
    vector<pp> ans;
    for (int i = 0; i < n; i++) {
        if (col_node[i] == 1) {
            ans.emplace_back(i + 1, 1);
        }
    }
    for (int i = 0; i < n; i++) {
        if (col_node[i] == 0) {
            bool need = false;
            for (auto [to, id]: graph[i]) {
                if (edge_desired[id] == 1 && edge_col[id] == 0) {
                    need = true;
                    break;
                }
            }
            if (need) {
                for (auto [to, id]: graph[i]) {
                    edge_col[id] = 1;
                }
                ans.emplace_back(i + 1, 1);
                ans.emplace_back(i + 1, 0);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (col_node[i] == 1) {
            bool need = false;
            for (auto [to, id]: graph[i]) {
                if (edge_desired[id] == 0 && edge_col[id] == 1) {
                    need = true;
                    break;
                }
            }
            if (need) {
                for (auto [to, id]: graph[i]) {
                    edge_col[id] = 0;
                }
                ans.emplace_back(i + 1, 0);
                ans.emplace_back(i + 1, 1);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (col_node[i] == 0) {
            bool need = false;
            for (auto [to, id]: graph[i]) {
                if (edge_desired[id] == 1 && edge_col[id] == 0) {
                    need = true;
                    break;
                }
            }
            if (need) {
                for (auto [to, id]: graph[i]) {
                    edge_col[id] = 1;
                }
                ans.emplace_back(i + 1, 1);
                ans.emplace_back(i + 1, 0);
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (edge_col[i] != edge_desired[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n" << ans.size() << '\n';
    for (auto [node, type]: ans) {
        cout << node << ' ' << type << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}