#include<bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<array<int, 3>> ar(m);
    for (int i = 0; i < m; i++) {
        cin >> ar[i][0] >> ar[i][1] >> ar[i][2];
        ar[i][0]--;
        ar[i][1]--;
    }
    
    vector<int> d(n);
    for (auto &i : d) {
        cin >> i;
    }

    vector<vector<int>> g(2 * n);
    for (int i = 0; i < n; i++) {
        if (d[i]) {
            g[2 * i + 1].push_back(2 * i);
        } else {
            g[2 * i].push_back(2 * i + 1);
        }
    }

    for (int i = 0; i < m; i++) {
        if (ar[i][2]) {
            if (!d[ar[i][0]]) {
                g[2 * ar[i][0]].push_back(2 * ar[i][1] + 1);
            }

            if (!d[ar[i][1]]) {
                g[2 * ar[i][1]].push_back(2 * ar[i][0] + 1);
            }
        } else {
            if (d[ar[i][0]]) {
                g[2 * ar[i][0] + 1].push_back(2 * ar[i][1]);
            }

            if (d[ar[i][1]]) {
                g[2 * ar[i][1] + 1].push_back(2 * ar[i][0]);
            }
        }
    }
    
    vector<int> topsort, used(2 * n);
    auto dfs = [&](auto dfs, int i) -> void {
        used[i] = 1;
        for (auto &j : g[i]) {
            if (!used[j]) {
                dfs(dfs, j);
            }
        }

        topsort.push_back(i);
    };

    for (int i = 0; i < 2 * n; i++) {
        if (!used[i]) {
            dfs(dfs, i);
        }
    }

    vector<vector<pair<int, int>>> pablo(n);
    vector<int> cur(m);
    int ind = 0;
    for (auto [a, b, c] : ar) {
        pablo[a].push_back({b, ind});
        pablo[b].push_back({a, ind});

        ind++;
    }

    vector<int> v(n);
    for (auto &i : topsort) {
        int type = i % 2;
        int ind = i / 2;

        v[ind] = type;
        for (auto &[j, wtf] : pablo[ind]) {
            if (v[ind] == v[j]) {
                cur[wtf] = v[ind];
            }
        }
    }

    bool ok = 1;
    for (int i = 0; i < m; i++) {
        ok &= (cur[i] == ar[i][2]);
    }

    if (ok) {
        cout << "YES\n" << 2 * n << endl;
        for (auto &i : topsort) {
            cout << i / 2 + 1 << ' ' << i % 2 << "\n";
        }
    } else {
        cout << "NO\n";
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}