#include <iostream>
#include <vector>
#include <tuple>
#include <cstdlib>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(2e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n;
vector <tuple <ll, ll, ll>> ax;

vector <ll> dp;
vector <ll> torev;

ll d[MAXN * 4];
void buildtree(ll v, ll l, ll r) {
    if (l + 1 != r) {
        d[v] = INF;
        ll m = l + (r - l) / 2;
        buildtree(2 * v + 1, l, m);
        buildtree(2 * v + 2, m, r);
    }
}
void treefix(ll v, ll l, ll r, ll i, ll e) {
    if (i < l || i >= r) {
        return;
    }
    if (l + 1 == r) {
        d[v] = e;
        return;
    }
    ll m = l + (r - l) / 2;
    treefix(2 * v + 1, l, m, i, e);
    treefix(2 * v + 2, m, r, i, e);
    d[v] = min(d[2 * v + 1], d[2 * v + 2]);
}
ll getseg(ll v, ll l, ll r, ll Ql, ll Qr) {
    if (Qr <= l || Ql >= r) {
        return INF;
    }
    if (Ql <= l && r <= Qr) {
        return d[v];
    }
    ll m = l + (r - l) / 2;
    return min(getseg(2 * v + 1, l, m, Ql, Qr), getseg(2 * v + 2, m, r, Ql, Qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    ax.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> get<0>(ax[i]) >> get<1>(ax[i]) >> get<2>(ax[i]);
        torev.push_back(get<0>(ax[i]));
        torev.push_back(get<0>(ax[i]) - get<1>(ax[i]));
    }
    torev.push_back(0);
    sort(torev.begin(), torev.end());
    unique(torev.begin(), torev.end());

    sort(ax.begin(), ax.end());
    
    dp.resize(*lower_bound(torev.begin(), torev.end(), get<0>(*max_element(ax.begin(), ax.end()))) + 1, INF);
    buildtree(0, 0, dp.size());
    dp[0] = 0;
    treefix(0, 0, dp.size(), 0, 0);
    for (int i = 0; i < n; ++i) {
        ll left = max(*lower_bound(torev.begin(), torev.end(), get<0>(ax[i]) - get<1>(ax[i])), 0ll);
        ll right = *lower_bound(torev.begin(), torev.end(), get<0>(ax[i]));
        ll nowind = *lower_bound(torev.begin(), torev.end(), get<0>(ax[i]));
        if (get<2>(ax[i]) == -1) {
            // for (int j = left; j <= right; ++j) {
            //     dp[nowind] = min(dp[nowind], dp[j]);
            //     cout << "-- " << j << " " << dp[j] << " " << getseg(0, 0, dp.size(), j, j + 1) << "\n";
            // }
            dp[nowind] = min(dp[nowind], getseg(0, 0, dp.size(), left, right));
        } else {
            // for (int j = left; j <= right; ++j) {
            //     dp[nowind] = min(dp[nowind], dp[j]);
            //     cout << "-- " << j << " " << dp[j] << " " << getseg(0, 0, dp.size(), j, j + 1) << "\n";
            // }
            dp[nowind] = min(dp[nowind], getseg(0, 0, dp.size(), left, right));
            if (dp[nowind] != INF) {
                ++dp[nowind];
            }
        }
        treefix(0, 0, dp.size(), nowind, dp[nowind]);
    }
    if (dp.back() == INF) {
        cout << "-1\n";
        return 0;
    }
    cout << dp.back() << "\n";
}
