#include <iostream>
#include <vector>
#include <tuple>
#include <cstdlib>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n;
vector <tuple <ll, ll, ll>> ax;

ll d[MAXN * 4];
void buildtree(ll v, ll l, ll r) {
    if (l + 1 != r) {
        d[v] = INF;
        ll m = l + (r - l) / 2;
        buildtree(2 * v + 1, l, m);
        buildtree(2 * v + 2, m, r);
    }
}
void treefix(ll v, ll l, ll r, ll i, ll e) {
    if (i < l || i >= r) {
        return;
    }
    if (l + 1 == r) {
        d[v] = e;
        return;
    }
    ll m = l + (r - l) / 2;
    treefix(2 * v + 1, l, m, i, e);
    treefix(2 * v + 2, m, r, i, e);
    d[v] = min(d[2 * v + 1], d[2 * v + 2]);
}
ll getseg(ll v, ll l, ll r, ll Ql, ll Qr) {
    if (Qr <= l || Ql >= r) {
        return INF;
    }
    if (Ql <= l && r <= Qr) {
        return d[v];
    }
    ll m = l + (r - l) / 2;
    return min(getseg(2 * v + 1, l, m, Ql, Qr), getseg(2 * v + 2, m, r, Ql, Qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    ax.resize(n);
    ll maxax = 0;
    for (int i = 0; i < n; ++i) {
        cin >> get<0>(ax[i]) >> get<1>(ax[i]) >> get<2>(ax[i]);
        maxax = max(maxax, get<0>(ax[i]));
    }
    sort(ax.begin(), ax.end());
    ll ans1 = 0, ans2 = 0;
    vector <pair<ll, ll>> sgs1, sgs2;
    for (auto i : ax) {
        if (get<2>(i) == -1) {
            ++ans2;
        } else {
            ++ans1;
        }
        sgs1.push_back({max(get<0>(i) - get<1>(i), 0ll), -1});
        sgs1.push_back({get<0>(i), 1});
        sgs2.push_back({get<0>(i), -1});
        sgs2.push_back({get<0>(i) + get<1>(i), 1});
    }
    sort(sgs1.begin(), sgs1.end());
    sort(sgs2.begin(), sgs2.end());
    int t1 = true, t2 = true;
    int s1 = 0, s2 = 0;
    for (auto [i, y] : sgs1) {
        s1 -= y;
        if (s1 == 0 && i < maxax) {
            t1 = false;
        }
    }
    for (auto [i, y] : sgs2) {
        s2 -= y;
        if (s2 == 0 && i < maxax) {
            t2 = false;
        }
    }
    if (t1 || t2) {
        cout << min(ans1, ans2) << "\n";
    } else if (!t1) {
        if (t2) {
            cout << ans2 << "\n";
        } else {
            cout << "-1" << "\n";
        }
    } else {
        if (t1) {
            cout << ans1 << "\n";
        } else {
            cout << "-1" << "\n";
        }
    }
}
