#include <iostream>
#include <vector>
#include <tuple>
#include <cstdlib>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(2e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n;
vector <tuple <ll, ll, ll>> ax;

vector <ll> dp;

ll d[MAXN * 4];
void buildtree(ll v, ll l, ll r) {
    if (l + 1 != r) {
        d[v] = INF;
        ll m = l + (r - l) / 2;
        buildtree(2 * v + 1, l, m);
        buildtree(2 * v + 2, m, r);
    }
}
void treefix(ll v, ll l, ll r, ll i, ll e) {
    if (i < l || i >= r) {
        return;
    }
    if (l + 1 == r) {
        d[v] = e;
        return;
    }
    ll m = l + (r - l) / 2;
    treefix(2 * v + 1, l, m, i, e);
    treefix(2 * v + 2, m, r, i, e);
    d[v] = min(d[2 * v + 1], d[2 * v + 2]);
}
ll getseg(ll v, ll l, ll r, ll Ql, ll Qr) {
    if (Qr <= l || Ql >= r) {
        return INF;
    }
    if (Ql <= l && r <= Qr) {
        return d[v];
    }
    ll m = l + (r - l) / 2;
    return min(getseg(2 * v + 1, l, m, Ql, Qr), getseg(2 * v + 2, m, r, Ql, Qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    ax.resize(n);
    vector <ll> indx;
    ll MAXI = 0;
    for (int i = 0; i < n; ++i) {
        cin >> get<0>(ax[i]) >> get<1>(ax[i]) >> get<2>(ax[i]);
        indx.push_back(i);
        MAXI = max(MAXI, get<0>(ax[i]));
    }

    sort(indx.begin(), indx.end(), [](int i, int j) {
        return max(get<0>(ax[i]) - get<1>(ax[i]), 0ll) < max(get<0>(ax[j]) - get<1>(ax[j]), 0ll);
    });
    ll leftgr = 0;
    ll ans = 0;
    for (int i : indx) {
        if (get<0>(ax[i]) < leftgr) {
            if (get<2>(ax[i]) == -1) {
                leftgr = get<0>(ax[i]);
            } else {
                leftgr = get<0>(ax[i]) + get<1>(ax[i]);
            }
        } else if (get<0>(ax[i]) > leftgr){
            if (get<0>(ax[i]) - get<1>(ax[i]) <= leftgr) {
                if (get<2>(ax[i]) == 1) {
                    ++ans;
                }
                leftgr = get<0>(ax[i]);
            } else {
                cout << "-1\n";
                return 0;
            }
        } else if (get<0>(ax[i]) < MAXI) {
            leftgr = get<0>(ax[i]) + get<1>(ax[i]);
            if (get<2>(ax[i]) == -1) {
                ++ans;
            }
        }
    }
    cout << ans << "\n";
}
