#include <iostream>
#include <vector>
#include <set>
#include <random>
#include <tuple>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;

int n, m;
vector <pair<int, int>> g[MAXN];
vector <tuple<int, int, int>> rebr;

vector <pair<int, int>> ans;
vector <bool> light;
void lightvert(int v, bool tol) {
    light[v] = tol;
    ans.push_back({v, tol});
    for (int i = 0; i < g[v].size(); ++i) {
        if (light[g[v][i].first] && tol) {
            g[v][i].second = true;
            for (int j = 0; j < g[g[v][i].first].size(); ++j) {
                if (g[g[v][i].first][j].first == v) {
                    g[g[v][i].first][j].second = true;
                }
            }
        } else if ((!light[g[v][i].first]) && (!tol)) {
            g[v][i].second = false;
            for (int j = 0; j < g[g[v][i].first].size(); ++j) {
                if (g[g[v][i].first][j].first == v) {
                    g[g[v][i].first][j].second = false;
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int _;
    cin >> _;
    mt19937 gen(128739);
    for (int __ = 0; __ < _; ++__) {
        cin >> n >> m;
        ans.clear();
        light.assign(n, false);
        rebr.clear();
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            g[--a].push_back({--b, 0});
            g[b].push_back({a, 0});
            rebr.push_back({a, b, c});
        }
        vector <int> e(n);
        for (int i = 0; i < n; ++i) {
            cin >> e[i];
            if (e[i]) {
                lightvert(i, 1);
            }
        }
        bool t = false;
        for (int _ = 0; _ < 1; ++_) {
            vector <pair<ll, ll>> f;
            vector <tuple<ll, ll, ll>> freb;
            for (int j = 0; j < n; ++j) {
                if (e[j] != light[j]) {
                    f.push_back({j, e[j]});
                }
            }
            for (auto [a, b, c] : rebr) {
                pair<int, int> pp = {b, c};
                if (find(g[a].begin(), g[a].end(), pp) == g[a].end()) {
                    freb.push_back({a, b, c});
                }
            }
            if (f.size() > 0) {
                ll g = 0;
                lightvert(f[g].first, f[g].second);
            } else if (freb.size() > 0) {
                ll g = 0;
                lightvert(get<0>(freb[g]), get<2>(freb[g]));
                lightvert(get<1>(freb[g]), get<2>(freb[g]));
            } else {
                t = true;
                break;
            }
        }
        if (t) {
            cout << "YES\n";
            cout << ans.size() << "\n";
            for (auto i : ans) {
                cout << i.first + 1 << " " << i.second << "\n";
            }
        } else {
            cout << "NO\n";
        }
    }
}
