#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;

int n, m;
vector <pair<int, int>> g[MAXN];
set <pair<int, int>> gcopy[MAXN];
vector <tuple<int, int, int>> rebr;

vector <bool> light;

vector <pair<int, int>> ans;
void lightvert(int v, bool tol) {
    light[v] = tol;
    ans.push_back({v, tol});
}
void fulllight() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            if (light[g[i][j].first] && light[i]) {
                g[i][j].second = true;
            } else if ((!light[g[i][j].first]) && (!light[i])) {
                g[i][j].second = false;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int _;
    cin >> _;
    for (int __ = 0; __ < _; ++__) {
        cin >> n >> m;
        ans.clear();
        light.assign(n, false);
        rebr.clear();
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            g[--a].push_back({--b, 0});
            g[b].push_back({a, 0});
            rebr.push_back({a, b, c});
        }
        for (auto [a, b, c] : rebr) {
            if (c == 1) {
                lightvert(a, true);
                lightvert(b, true);
            }
        }
        vector <int> e(n);
        fulllight();
        for (int i = 0; i < n; ++i) {
            cin >> e[i];
            if (e[i] == 0 && light[i]) {
                lightvert(i, false);
            }
            if (e[i] == 1 && (!light[i])) {
                lightvert(i, true);
            }
        }
        fulllight();
        bool t = true;
        for (int i = 0; i < n; ++i) {
            gcopy[i].clear();
            for (auto j : g[i]) {
                gcopy[i].insert(j);
            }
        }
        for (auto i : rebr) {
            if (gcopy[get<0>(i)].find({get<1>(i), get<2>(i)}) == gcopy[get<0>(i)].end()) {
                t = false;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (light[i] != e[i]) {
                t = false;
            }
        }
        if (t) {
            cout << "YES\n";
            cout << ans.size() << "\n";
            for (auto i : ans) {
                cout << i.first + 1 << " " << i.second << "\n";
            }
        } else {
            for (auto [a, b, c] : rebr) {
                if (c == 1) {
                    lightvert(a, true);
                    lightvert(b, true);
                }
            }
            fulllight();
            for (int i = 0; i < n; ++i) {
                if (e[i] == 0 && light[i]) {
                    lightvert(i, false);
                }
                if (e[i] == 1 && (!light[i])) {
                    lightvert(i, true);
                }
            }
            fulllight();
            bool t = true;
            for (int i = 0; i < n; ++i) {
                gcopy[i].clear();
                for (auto j : g[i]) {
                    gcopy[i].insert(j);
                }
            }
            for (auto i : rebr) {
                if (gcopy[get<0>(i)].find({get<1>(i), get<2>(i)}) == gcopy[get<0>(i)].end()) {
                    t = false;
                }
            }
            for (int i = 0; i < n; ++i) {
                if (light[i] != e[i]) {
                    t = false;
                }
            }
            cout << "NO\n";
        }
    }
}
