#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

vector<vector<int>> g;
vector<int> state;
bool has_cycle = 0;

void check_cycle(int v) {
    state[v] = 1;
    for (auto to : g[v]) {
        if (state[to] == 2)
            continue;
        if (state[to] == 1) {
            has_cycle = true;
            return;
        }
        check_cycle(to);
        if (has_cycle)
            return;
    }
    state[v] = 2;
}

vector<int> order;

void topsort(int v) {
    state[v] = 1;
    for (auto to : g[v]) {
        if (state[to])
            continue;
        topsort(to);
    }
    order.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> preg(n);
    int desmask = 0;
    for (int i = 0; i < m; ++i) {
        int ai, bi, ci;
        cin >> ai >> bi >> ci;
        --ai, --bi;
        preg[ai].push_back({ bi, ci });
        preg[bi].push_back({ ai, ci });
    }
    vector<int> di(n);
    for (auto& el : di)
        cin >> el;
    for (int i = 0; i < n; ++i) {
        for (auto [to, ci] : preg[i]) {
            if (di[to] == di[i] && ci != di[i]) {
                cout << "NO\n";
                return;
            }
        }
    }
    g.assign(n, {});
    for (int v = 0; v < n; ++v) {
        if (di[v] == 0)
            continue;
        for (auto [to, ci] : preg[v]) {
            if (di[v] == di[to])
                continue;
            if (ci)
                g[v].push_back(to);
            else
                g[to].push_back(v);
        }
    }
    has_cycle = false;
    state.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (state[i] == 0)
            check_cycle(i);
    }
    if (has_cycle) {
        cout << "NO\n";
        return;
    }
    state.assign(n, 0);
    order.clear();
    for (int i = 0; i < n;++i) {
        if (!state[i])
            topsort(i);
    }
    reverse(order.begin(), order.end());
    vector<pair<int, int>> ops;
    for (int i = 0; i < n; ++i) {
        if (di[i] == 0) {
            ops.push_back({ i, 1 });
        }
    }
    for (auto el : order) {
        ops.push_back({ el, di[el] });
    }
    cout << "YES\n" << ops.size() << "\n";
    for (auto [a, b] : ops)
        cout << a + 1 << ' ' << b << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--) {
        solve();
    }
}