#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

struct MergeSortTree {
    vector<vector<int>> t;
    int h = 0;

    MergeSortTree(const vector<int>& in) {
        int n = in.size();
        while ((1 << h) < n)
            h += 1;
        t.resize(1 << (h + 1));
        for (int i = 0; i < n; ++i)
            t[(1 << h) + i] = { in[i] };
        for (int i = (1 << h) - 1; i > 0; --i) {
            merge(t[2 * i].begin(), t[2 * i].end(), t[2 * i + 1].begin(), t[2 * i + 1].end(), back_inserter(t[i]));
        }
    }

    int get(int v, int vl, int vr, int l, int r, int x) {
        if (vl >= r || vr <= l)
            return 0;
        if (l <= vl && vr <= r)
            return lower_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
        int vm = (vl + vr) / 2;
        return get(2 * v, vl, vm, l, r, x) + get(2 * v + 1, vm, vr, l, r, x);
    }

    int get(int l, int r, int x) {
        return get(1, 0, (1 << h), l, r, x);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (auto& el : a)
        cin >> el;
    vector<vector<int>> rs(n), ls(n);
    for (int i = 0; i < n; ++i) {
        int l = max((int)0, i - a[i]);
        int r = min(n - 1, i + a[i]);
        rs[r].push_back(l);
        ls[l].push_back(r);
    }
    vector<int> maxr(n);
    multiset<int> curr;
    for (int i = n - 1; i >= 0; --i) {
        for (auto el : rs[i])
            curr.insert(i);
        maxr[i] = *curr.rbegin();
        for (auto el : ls[i])
            curr.extract(el);
    }
    auto solve = [&]() {
        long long ans = 0;
        vector<int> dp(n);
        for (int i = n - 2; i >= 0; --i) {
            if (maxr[i] < n - 1)
                dp[i] = 1ll * dp[maxr[i] + 1] + (n - maxr[i] - 1);
            ans += dp[i];
        }
        return ans;
        };
    MergeSortTree mst(maxr);
    long long ans = solve();
    int mxmv = 0;
    for (int i = 0; i < n; ++i) {
        int l = max((int)0, i - x);
        int r = min(n - 1, i + x);
        int cnt = mst.get(l, r + 1, r);
        mxmv = max(mxmv, cnt);
    }
    if (mxmv) {
        for (int i = 0; i < n; ++i) {
            int pi = a[i];
            int l1 = max((int)0, i - x);
            int r1 = min(n - 1, i + x);
            int cnt = mst.get(l1, r1 + 1, r1);
            if (cnt != mxmv)
                continue;
            if (x > a[i]) {
                a[i] = x;
                auto pastmaxr = maxr;
                int l = max((int)0, i - a[i]);
                int r = min(n - 1, i + a[i]);
                int cnt = mst.get(l, r + 1, x);
                mxmv = max(mxmv, cnt);
                for (int j = l; j <= r; ++j) {
                    if (maxr[j] > r)
                        break;
                    maxr[j] = r;
                }
                ans = min(ans, solve());
                a[i] = pi;
                maxr = pastmaxr;
            }
        }
    }
    cout << ans;
}