#include <bits/stdc++.h>
using namespace std;

vector<vector<pair<int, int>>> edges; 
vector<int> colors;
vector<pair<int, int>> actions;

void dfs1(int v, int p = -1) {
	for (auto [u, c]: edges[v]) {
		if (u == p) continue;
		dfs1(u, v);
		if (c == 1) actions.emplace_back(u+1, 1);
		else actions.emplace_back(u+1, 0);
	}
	actions.emplace_back(v+1, 1);
}

void dfs2(int v, int p=-1) {
	actions.emplace_back(v+1, colors[v]);
	for (auto [u, c]: edges[v]) {
		if (u != p) dfs2(u, v);
	}
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<tuple<int, int, int>> edge_list(m);
		edges.resize(n);
		bool is_a_cycle = true;
		int indexer = 0;
		for (auto &[u, v, c]: edge_list) {
			cin >> u >> v >> c;
			u--, v--;
			if (u != indexer || v != (indexer+1) % n) {
				is_a_cycle = false;
			}
			indexer++;
			edges[u].emplace_back(v, c);
			edges[v].emplace_back(u, c);
		}
		colors.resize(n);
		for (int &i: colors) {
			cin >> i;
		}
		bool possible = true;
		for (auto [u, v, c]: edge_list) {
			if (colors[u] == colors[v] && colors[u] != c) {
				possible = false;
				break;
			}
		}
		if (possible) {
			if (is_a_cycle) {
				if (n % 2) {
					cout << "YES\n-1\n";
				}
				else {
					bool alternating = true;
					for (int i = 1; i < n; i++) {
						if (colors[i] == colors[i-1]) alternating = false;
					}
					if (!alternating) cout << "YES\n-1\n";
					else {
						for (int i = 1; i < m; i++) {
							auto [u1, v1, c1] = edge_list[i];
							auto [u0, v0, c0] = edge_list[i-1];
							if (c0 == c1) alternating = false;
						}
						if (alternating) cout << "NO\n";
						else cout << "YES\n-1\n";
					}
				}
			}
			else {
				cout << "YES\n";
				dfs1(0);
				dfs2(0);
				cout << actions.size() << "\n";
				for (auto [v, c]: actions) {
					cout << v << " " << c << "\n";
				}
				actions.clear();
			}
		}
		else {
			cout << "NO\n";
		}
		edges.clear();
		colors.clear();
	}
}