#include <bits/stdc++.h>
using namespace std;

vector<vector<pair<int, int>>> edges; 
vector<int> colors;
vector<pair<int, int>> actions;

void dfs1(int v, int p = -1) {
	for (auto [u, c]: edges[v]) {
		if (u == p) continue;
		dfs1(u, v);
		if (c == 1) actions.emplace_back(u+1, 1);
		else actions.emplace_back(u+1, 0);
	}
	actions.emplace_back(v+1, 1);
}

void dfs2(int v, int p=-1) {
	actions.emplace_back(v+1, colors[v]);
	for (auto [u, c]: edges[v]) {
		if (u != p) dfs2(u, v);
	}
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<tuple<int, int, int>> edge_list(m);
		for (auto &[u, v, c]: edge_list) {
			cin >> u >> v >> c;
			u--, v--;
			if (v < u) swap(u, v);
		}
		colors.resize(n);
		for (int &i: colors) {
			cin >> i;
		}
		bool possible = true;
		for (auto [u, v, c]: edge_list) {
			if (colors[u] == colors[v] && colors[u] != c) {
				possible = false;
				break;
			}
		}
		sort(edge_list.begin(), edge_list.end());
		if (possible) {
			for (auto [u, v, c]: edge_list) {
				actions.emplace_back(u+1, c);
				actions.emplace_back(v+1, c);
			}
			for (int i = 0; i < n; i++) {
				actions.emplace_back(i+1, colors[i]);
			}
			cout << "YES\n";
			cout << actions.size() << "\n";
			for (auto [v, c]: actions) {
				cout << v << " " <<  c << "\n";
			}
			actions.clear();
		}
		else {
			cout << "NO\n";
		}
		colors.clear();
	}
}