#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, x;
vector<int> a;
vector<int> max_coverage;

ll rate() {
	max_coverage.resize(n);
	for (int i = 0; i < n; i++) {
		max_coverage[i] = i;
	}
	for (int i = 0; i < n; i++) {
		int l = max(0, i - a[i]);
		int r = min(n-1, i + a[i]);
		max_coverage[l] = max(max_coverage[l], r);
	}
	for (int i = 1; i < n; i++) {
		max_coverage[i] = max(max_coverage[i-1], max_coverage[i]);
	}
	vector<ll> stability(n);
	ll answer = 0;
	for (int i = n-1; i >= 0; i--) {
		if (max_coverage[i] == n-1) stability[i] = 0;
		else {
			int nxt = max_coverage[i] + 1;
			stability[i] = stability[nxt] + n - nxt;
		} 
		answer += stability[i];
	}
	ll answer2 = 0;
	vector<ll> dependencies(n, 1);
	for (int i = 0; i < n; i++) {
		int nxt = max_coverage[i] + 1;
		if (nxt != n) {
			dependencies[nxt] += dependencies[i];
		}
		answer2 += (dependencies[i]) * (n - nxt);
	}
	assert(answer == answer2);
	return answer;
}

int main() {
	cin >> n >> x;
	a.resize(n);
	bool is_a_eq_0 = true;
	bool is_a_leq_1 = true;
	bool is_a_geq_20 = true;
	for (int &e: a) {
		cin >> e;
		if (e != 0) is_a_eq_0 = false;
		if (e > 1) is_a_leq_1 = false;
		if (e < n/20) is_a_geq_20 = false;
	}
	if (x == 0) {
		cout << rate();
	}
	else if (is_a_eq_0) {
		a[n/2] = x;
		cout << rate();
	}
	else if (n <= 5000) {
		ll ans = rate();
		for (int i = 0; i < n; i++) {
			if (x <= a[i]) continue;
			swap(a[i], x);
			ans = min(ans, rate());
			swap(a[i], x);
		}
		cout << ans;
	}
	else {
		ll best = rate();
		mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
		for (int attempt = 0; attempt < 10; attempt++) {
			int pos = uniform_int_distribution(0, n-1)(rnd);
			swap(a[pos], x);
			ll cur = rate();
			swap(a[pos], x);
			for (int step = (1 << 10); step > 0; step >>= 1) {
				int side = 1;
				if (rnd() % 2) side = -1;
				int nxt = pos + step * side;
				if (0 <= nxt && nxt < n) {
					swap(a[nxt], x);
					ll nw = rate();
					swap(a[nxt], x);
					if (nw < cur) {
						pos = nxt;
						cur = nw;
						continue;
					}
				}
				nxt = pos - step*side;
				if (0 <= nxt && nxt < n) {
					swap(a[nxt], x);
					ll nw = rate();
					swap(a[nxt], x);
					if (nw < cur) {
						pos = nxt;
						cur = nw;
						continue;
					}
				}
			}
			best = min(best, cur);
		}
		cout << best << "\n";
	}
}